/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(J){for(var e=[],P=0,O=J.length;P<O;P++)e[P]=te[J[P]];return e};define(te[133],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function P(w,d,g){const o=O(w,d);if(o!==-1)return w[o]}e.$db=P;function O(w,d,g=w.length-1){for(let o=g;o>=0;o--){const $=w[o];if(d($))return o}return-1}e.$eb=O;function s(w,d){const g=M(w,d);return g===-1?void 0:w[g]}e.$fb=s;function M(w,d,g=0,o=w.length){let $=g,E=o;for(;$<E;){const u=Math.floor(($+E)/2);d(w[u])?$=u+1:E=u}return $-1}e.$gb=M;function D(w,d){const g=S(w,d);return g===w.length?void 0:w[g]}e.$hb=D;function S(w,d,g=0,o=w.length){let $=g,E=o;for(;$<E;){const u=Math.floor(($+E)/2);d(w[u])?E=u:$=u+1}return $}e.$ib=S;function h(w,d,g=0,o=w.length){const $=S(w,d,g,o);return $===w.length?-1:$}e.$jb=h;class l{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(l.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!d(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const g=M(this.e,d,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$kb=l;function m(w,d){if(w.length===0)return;let g=w[0];for(let o=1;o<w.length;o++){const $=w[o];d($,g)>0&&(g=$)}return g}e.$lb=m;function b(w,d){if(w.length===0)return;let g=w[0];for(let o=1;o<w.length;o++){const $=w[o];d($,g)>=0&&(g=$)}return g}e.$mb=b;function p(w,d){return m(w,(g,o)=>-d(g,o))}e.$nb=p;function f(w,d){if(w.length===0)return-1;let g=0;for(let o=1;o<w.length;o++){const $=w[o];d($,w[g])>0&&(g=o)}return g}e.$ob=f;function y(w,d){for(const g of w){const o=d(g);if(o!==void 0)return o}}e.$pb=y}),define(te[134],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function P(D,S){const h=Object.create(null);for(const l of D){const m=S(l);let b=h[m];b||(b=h[m]=[]),b.push(l)}return h}e.$I=P;function O(D,S){const h=[],l=[];for(const m of D)S.has(m)||h.push(m);for(const m of S)D.has(m)||l.push(m);return{removed:h,added:l}}e.$J=O;function s(D,S){const h=[],l=[];for(const[m,b]of D)S.has(m)||h.push(b);for(const[m,b]of S)D.has(m)||l.push(b);return{removed:h,added:l}}e.$K=s;class M{constructor(){this.a=new Map}add(S,h){let l=this.a.get(S);l||(l=new Set,this.a.set(S,l)),l.add(h)}delete(S,h){const l=this.a.get(S);l&&(l.delete(h),l.size===0&&this.a.delete(S))}forEach(S,h){const l=this.a.get(S);l&&l.forEach(h)}get(S){const h=this.a.get(S);return h||new Set}}e.$L=M}),define(te[135],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=e.$Ms=e.$Ls=void 0;function P(S,h){const l=Math.pow(10,h);return Math.round(S*l)/l}class O{constructor(h,l,m,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=P(Math.max(Math.min(1,b),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.$Ls=O;class s{constructor(h,l,m,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,m=h.g/255,b=h.b/255,p=h.a,f=Math.max(l,m,b),y=Math.min(l,m,b);let w=0,d=0;const g=(y+f)/2,o=f-y;if(o>0){switch(d=Math.min(g<=.5?o/(2*g):o/(2-2*g),1),f){case l:w=(m-b)/o+(m<b?6:0);break;case m:w=(b-l)/o+2;break;case b:w=(l-m)/o+4;break}w*=60,w=Math.round(w)}return new s(w,d,g,p)}static i(h,l,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?h+(l-h)*6*m:m<1/2?l:m<2/3?h+(l-h)*(2/3-m)*6:h}static toRGBA(h){const l=h.h/360,{s:m,l:b,a:p}=h;let f,y,w;if(m===0)f=y=w=b;else{const d=b<.5?b*(1+m):b+m-b*m,g=2*b-d;f=s.i(g,d,l+1/3),y=s.i(g,d,l),w=s.i(g,d,l-1/3)}return new O(Math.round(f*255),Math.round(y*255),Math.round(w*255),p)}}e.$Ms=s;class M{constructor(h,l,m,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,m=h.g/255,b=h.b/255,p=Math.max(l,m,b),f=Math.min(l,m,b),y=p-f,w=p===0?0:y/p;let d;return y===0?d=0:p===l?d=((m-b)/y%6+6)%6:p===m?d=(b-l)/y+2:d=(l-m)/y+4,new M(Math.round(d*60),w,p,h.a)}static toRGBA(h){const{h:l,s:m,v:b,a:p}=h,f=b*m,y=f*(1-Math.abs(l/60%2-1)),w=b-f;let[d,g,o]=[0,0,0];return l<60?(d=f,g=y):l<120?(d=y,g=f):l<180?(g=f,o=y):l<240?(g=y,o=f):l<300?(d=y,o=f):l<=360&&(d=f,o=y),d=Math.round((d+w)*255),g=Math.round((g+w)*255),o=Math.round((o+w)*255),new O(d,g,o,p)}}e.$Ns=M;class D{static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof O)this.rgba=h;else if(h instanceof s)this.i=h,this.rgba=s.toRGBA(h);else if(h instanceof M)this.j=h,this.rgba=M.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&O.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&M.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D.k(this.rgba.r),l=D.k(this.rgba.g),m=D.k(this.rgba.b),b=.2126*h+.7152*l+.0722*m;return P(b,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),m=h.getRelativeLuminance();return l>m?(l+.05)/(m+.05):(m+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),m=h.getRelativeLuminance();return l>m}isDarkerThan(h){const l=this.getRelativeLuminance(),m=h.getRelativeLuminance();return l<m}lighten(h){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:m,b,a:p}=this.rgba;return new D(new O(l,m,b,p*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,m=this.rgba.a,b=l.a,p=m+b*(1-m);if(p<1e-6)return D.transparent;const f=this.rgba.r*m/p+l.r*b*(1-m)/p,y=this.rgba.g*m/p+l.g*b*(1-m)/p,w=this.rgba.b*m/p+l.b*b*(1-m)/p;return new D(new O(f,y,w,p))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:m,b,a:p}=this.rgba;return new D(new O(h.rgba.r-p*(h.rgba.r-l),h.rgba.g-p*(h.rgba.g-m),h.rgba.b-p*(h.rgba.b-b),1))}flatten(...h){const l=h.reduceRight((m,b)=>D.o(b,m));return D.o(this,l)}static o(h,l){const m=1-h.rgba.a;return new D(new O(m*l.rgba.r+h.rgba.a*h.rgba.r,m*l.rgba.g+h.rgba.a*h.rgba.g,m*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(h,l,m){if(h.isLighterThan(l))return h;m=m||.5;const b=h.getRelativeLuminance(),p=l.getRelativeLuminance();return m=m*(p-b)/p,h.lighten(m)}static getDarkerColor(h,l,m){if(h.isDarkerThan(l))return h;m=m||.5;const b=h.getRelativeLuminance(),p=l.getRelativeLuminance();return m=m*(b-p)/b,h.darken(m)}static{this.white=new D(new O(255,255,255,1))}static{this.black=new D(new O(0,0,0,1))}static{this.red=new D(new O(255,0,0,1))}static{this.blue=new D(new O(0,0,255,1))}static{this.green=new D(new O(0,255,0,1))}static{this.cyan=new D(new O(0,255,255,1))}static{this.lightgrey=new D(new O(211,211,211,1))}static{this.transparent=new D(new O(0,0,0,0))}}e.$Os=D,function(S){let h;(function(l){let m;(function(b){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}b.formatRGB=p;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=f;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}b.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=w;function d(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function g(t){return`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}`}b.formatHex=g;function o(t,c=!1){return c&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}${d(Math.round(t.rgba.a*255))}`}b.formatHexA=o;function $(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}b.format=$;function E(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new S(new O(r,i,n,1))}if(c===9){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),a=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new S(new O(r,i,n,a/255))}if(c===4){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new S(new O(16*r+r,16*i+i,16*n+n))}if(c===5){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),a=u(t.charCodeAt(4));return new S(new O(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}b.parseHex=E;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=l.CSS||(l.CSS={}))})(h=S.Format||(S.Format={}))}(D||(e.$Os=D={}))}),define(te[55],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function P(D){return(S,h,l)=>{let m=null,b=null;if(typeof l.value=="function"?(m="value",b=l.value):typeof l.get=="function"&&(m="get",b=l.get),!b)throw new Error("not supported");l[m]=D(b,h)}}function O(D,S,h){let l=null,m=null;if(typeof h.value=="function"?(l="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",m=h.get),!m)throw new Error("not supported");const b=`$memoize$${S}`;h[l]=function(...p){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[b]}}e.$6g=O;function s(D,S,h){return P((l,m)=>{const b=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...f){this[p]||(this[p]=h?h():void 0),clearTimeout(this[b]),S&&(this[p]=S(this[p],...f),f=[this[p]]),this[b]=setTimeout(()=>{l.apply(this,f),this[p]=h?h():void 0},D)}})}e.$7g=s;function M(D,S,h){return P((l,m)=>{const b=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,f=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...w){if(this[p]||(this[p]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...w)),this[y])return;const d=this[f]+D;d<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=h?h():void 0):(this[y]=!0,this[b]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=h?h():void 0},d-Date.now()))}})}e.$8g=M}),define(te[14],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=P,e.$V=new P;function O(u){e.$V.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=O;function s(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(u){l(u)||e.$V.onUnexpectedError(u)}e.$Y=M;function D(u){l(u)||e.$V.onUnexpectedExternalError(u)}e.$Z=D;function S(u){if(u instanceof Error){const{name:t,message:c}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:c,stack:r,noTelemetry:$.isErrorNoTelemetry(u)}}return u}e.$1=S;const h="Canceled";function l(u){return u instanceof m?!0:u instanceof Error&&u.name===h&&u.message===h}e.$2=l;class m extends Error{constructor(){super(h),this.name=this.message}}e.$3=m;function b(){const u=new Error(h);return u.name=u.message,u}e.$4=b;function p(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$5=p;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$6=f;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=y;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$8=w;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=d;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=g;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=o;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const c=new $;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=$;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(te[23],ie([0,1,14,133]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(T,H=0){return T[T.length-(1+H)]}e.$qb=s;function M(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$rb=M;function D(T,H,z=(ne,fe)=>ne===fe){if(T===H)return!0;if(!T||!H||T.length!==H.length)return!1;for(let ne=0,fe=T.length;ne<fe;ne++)if(!z(T[ne],H[ne]))return!1;return!0}e.$sb=D;function S(T,H){const z=T.length-1;H<z&&(T[H]=T[z]),T.pop()}e.$tb=S;function h(T,H,z){return l(T.length,ne=>z(T[ne],H))}e.$ub=h;function l(T,H){let z=0,ne=T-1;for(;z<=ne;){const fe=(z+ne)/2|0,ge=H(fe);if(ge<0)z=fe+1;else if(ge>0)ne=fe-1;else return fe}return-(z+1)}e.$vb=l;function m(T,H,z){if(T=T|0,T>=H.length)throw new TypeError("invalid index");const ne=H[Math.floor(H.length*Math.random())],fe=[],ge=[],ue=[];for(const we of H){const me=z(we,ne);me<0?fe.push(we):me>0?ge.push(we):ue.push(we)}return T<fe.length?m(T,fe,z):T<fe.length+ue.length?ue[0]:m(T-(fe.length+ue.length),ge,z)}e.$wb=m;function b(T,H){const z=[];let ne;for(const fe of T.slice(0).sort(H))!ne||H(ne[0],fe)!==0?(ne=[fe],z.push(ne)):ne.push(fe);return z}e.$xb=b;function*p(T,H){let z,ne;for(const fe of T)ne!==void 0&&H(ne,fe)?z.push(fe):(z&&(yield z),z=[fe]),ne=fe;z&&(yield z)}e.$yb=p;function f(T,H){for(let z=0;z<=T.length;z++)H(z===0?void 0:T[z-1],z===T.length?void 0:T[z])}e.$zb=f;function y(T,H){for(let z=0;z<T.length;z++)H(z===0?void 0:T[z-1],T[z],z+1===T.length?void 0:T[z+1])}e.$Ab=y;function w(T,H,z){const ne=[];function fe(we,me,Se){if(me===0&&Se.length===0)return;const Ie=ne[ne.length-1];Ie&&Ie.start+Ie.deleteCount===we?(Ie.deleteCount+=me,Ie.toInsert.push(...Se)):ne.push({start:we,deleteCount:me,toInsert:Se})}let ge=0,ue=0;for(;;){if(ge===T.length){fe(ge,0,H.slice(ue));break}if(ue===H.length){fe(ge,T.length-ge,[]);break}const we=T[ge],me=H[ue],Se=z(we,me);Se===0?(ge+=1,ue+=1):Se<0?(fe(ge,1,[]),ge+=1):Se>0&&(fe(ge,0,[me]),ue+=1)}return ne}e.$Bb=w;function d(T,H,z){const ne=w(T,H,z),fe=[],ge=[];for(const ue of ne)fe.push(...T.slice(ue.start,ue.start+ue.deleteCount)),ge.push(...ue.toInsert);return{removed:fe,added:ge}}e.$Cb=d;function g(T,H,z){if(z===0)return[];const ne=T.slice(0,z).sort(H);return $(T,H,ne,z,T.length),ne}e.top=g;function o(T,H,z,ne,fe){return z===0?Promise.resolve([]):new Promise((ge,ue)=>{(async()=>{const we=T.length,me=T.slice(0,z).sort(H);for(let Se=z,Ie=Math.min(z+ne,we);Se<we;Se=Ie,Ie=Math.min(Ie+ne,we)){if(Se>z&&await new Promise(je=>setTimeout(je)),fe&&fe.isCancellationRequested)throw new P.$3;$(T,H,me,Se,Ie)}return me})().then(ge,ue)})}e.$Eb=o;function $(T,H,z,ne,fe){for(const ge=z.length;ne<fe;ne++){const ue=T[ne];if(H(ue,z[ge-1])<0){z.pop();const we=(0,O.$ib)(z,me=>H(ue,me)<0);z.splice(we,0,ue)}}}function E(T){return T.filter(H=>!!H)}e.$Fb=E;function u(T){let H=0;for(let z=0;z<T.length;z++)T[z]&&(T[H]=T[z],H+=1);T.length=H}e.$Gb=u;function t(T,H,z){T.splice(z,0,T.splice(H,1)[0])}e.$Hb=t;function c(T){return!Array.isArray(T)||T.length===0}e.$Ib=c;function r(T){return Array.isArray(T)&&T.length>0}e.$Jb=r;function i(T,H=z=>z){const z=new Set;return T.filter(ne=>{const fe=H(ne);return z.has(fe)?!1:(z.add(fe),!0)})}e.$Kb=i;function n(T){const H=new Set;return z=>{const ne=T(z);return H.has(ne)?!1:(H.add(ne),!0)}}e.$Lb=n;function a(T,H){return T.length>0?T[0]:H}e.$Mb=a;function k(T,H){return T.length>0?T[T.length-1]:H}e.$Nb=k;function I(T,H,z=(ne,fe)=>ne===fe){let ne=0;for(let fe=0,ge=Math.min(T.length,H.length);fe<ge&&z(T[fe],H[fe]);fe++)ne++;return ne}e.$Ob=I;function A(T){return[].concat(...T)}e.$Pb=A;function v(T,H){let z=typeof H=="number"?T:0;typeof H=="number"?z=T:(z=0,H=T);const ne=[];if(z<=H)for(let fe=z;fe<H;fe++)ne.push(fe);else for(let fe=z;fe>H;fe--)ne.push(fe);return ne}e.$Qb=v;function C(T,H,z){return T.reduce((ne,fe)=>(ne[H(fe)]=z?z(fe):fe,ne),Object.create(null))}e.$Rb=C;function L(T,H){return T.push(H),()=>U(T,H)}e.$Sb=L;function U(T,H){const z=T.indexOf(H);if(z>-1)return T.splice(z,1),H}e.$Tb=U;function B(T,H,z){const ne=T.slice(0,H),fe=T.slice(H);return ne.concat(z,fe)}e.$Ub=B;function re(T,H){let z;if(typeof H=="number"){let ne=H;z=()=>{const fe=Math.sin(ne++)*179426549;return fe-Math.floor(fe)}}else z=Math.random;for(let ne=T.length-1;ne>0;ne-=1){const fe=Math.floor(z()*(ne+1)),ge=T[ne];T[ne]=T[fe],T[fe]=ge}}e.$Vb=re;function ee(T,H){const z=T.indexOf(H);z>-1&&(T.splice(z,1),T.unshift(H))}e.$Wb=ee;function ae(T,H){const z=T.indexOf(H);z>-1&&(T.splice(z,1),T.push(H))}e.$Xb=ae;function se(T,H){for(const z of H)T.push(z)}e.$Yb=se;function oe(T,H){return Array.isArray(T)?T.map(H):H(T)}e.$Zb=oe;function G(T){return Array.isArray(T)?T:[T]}e.$1b=G;function K(T){return T[Math.floor(Math.random()*T.length)]}e.$2b=K;function q(T,H,z){const ne=N(T,H),fe=T.length,ge=z.length;T.length=fe+ge;for(let ue=fe-1;ue>=ne;ue--)T[ue+ge]=T[ue];for(let ue=0;ue<ge;ue++)T[ue+ne]=z[ue]}e.$3b=q;function F(T,H,z,ne){const fe=N(T,H);let ge=T.splice(fe,z);return ge===void 0&&(ge=[]),q(T,fe,ne),ge}e.$4b=F;function N(T,H){return H<0?Math.max(H+T.length,0):Math.min(H,T.length)}var V;(function(T){function H(ge){return ge<0}T.isLessThan=H;function z(ge){return ge<=0}T.isLessThanOrEqual=z;function ne(ge){return ge>0}T.isGreaterThan=ne;function fe(ge){return ge===0}T.isNeitherLessOrGreaterThan=fe,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function X(T,H){return(z,ne)=>H(T(z),T(ne))}e.$5b=X;function x(...T){return(H,z)=>{for(const ne of T){const fe=ne(H,z);if(!V.isNeitherLessOrGreaterThan(fe))return fe}return V.neitherLessOrGreaterThan}}e.$6b=x;const ce=(T,H)=>T-H;e.$7b=ce;const Y=(T,H)=>(0,e.$7b)(T?1:0,H?1:0);e.$8b=Y;function R(T){return(H,z)=>-T(H,z)}e.$9b=R;class j{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let z=this.c;for(;z<this.g.length&&H(this.g[z]);)z++;const ne=z===this.c?null:this.g.slice(this.c,z);return this.c=z,ne}takeFromEndWhile(H){let z=this.d;for(;z>=0&&H(this.g[z]);)z--;const ne=z===this.d?null:this.g.slice(z+1,this.d+1);return this.d=z,ne}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const z=this.g.slice(this.c,this.c+H);return this.c+=H,z}}e.$0b=j;class W{static{this.empty=new W(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(z=>(H(z),!0))}toArray(){const H=[];return this.iterate(z=>(H.push(z),!0)),H}filter(H){return new W(z=>this.iterate(ne=>H(ne)?z(ne):!0))}map(H){return new W(z=>this.iterate(ne=>z(H(ne))))}some(H){let z=!1;return this.iterate(ne=>(z=H(ne),!z)),z}findFirst(H){let z;return this.iterate(ne=>H(ne)?(z=ne,!1):!0),z}findLast(H){let z;return this.iterate(ne=>(H(ne)&&(z=ne),!0)),z}findLastMaxBy(H){let z,ne=!0;return this.iterate(fe=>((ne||V.isGreaterThan(H(fe,z)))&&(ne=!1,z=fe),!0)),z}}e.$$b=W}),define(te[136],ie([0,1,14]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function O(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function s(h,l="Unreachable"){throw new Error(l)}e.$vc=s;function M(h){if(!h)throw new P.$ab("Assertion Failed")}e.$wc=M;function D(h){if(!h()){debugger;h(),(0,P.$Y)(new P.$ab("Assertion Failed"))}}e.$xc=D;function S(h,l){let m=0;for(;m<h.length-1;){const b=h[m],p=h[m+1];if(!l(b,p))return!1;m++}return!0}e.$yc=S}),define(te[49],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function P(O){const s=this;let M=!1,D;return function(){return M||(M=!0,D=O.apply(s,arguments)),D}}e.$bb=P}),define(te[68],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(O){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}O.is=s;const M=Object.freeze([]);function D(){return M}O.empty=D;function*S(u){yield u}O.single=S;function h(u){return s(u)?u:S(u)}O.wrap=h;function l(u){return u||M}O.from=l;function*m(u){for(let t=u.length-1;t>=0;t--)yield u[t]}O.reverse=m;function b(u){return!u||u[Symbol.iterator]().next().done===!0}O.isEmpty=b;function p(u){return u[Symbol.iterator]().next().value}O.first=p;function f(u,t){for(const c of u)if(t(c))return!0;return!1}O.some=f;function y(u,t){for(const c of u)if(t(c))return c}O.find=y;function*w(u,t){for(const c of u)t(c)&&(yield c)}O.filter=w;function*d(u,t){let c=0;for(const r of u)yield t(r,c++)}O.map=d;function*g(...u){for(const t of u)for(const c of t)yield c}O.concat=g;function o(u,t,c){let r=c;for(const i of u)r=t(r,i);return r}O.reduce=o;function*$(u,t,c=u.length){for(t<0&&(t+=u.length),c<0?c+=u.length:c>u.length&&(c=u.length);t<c;t++)yield u[t]}O.slice=$;function E(u,t=Number.POSITIVE_INFINITY){const c=[];if(t===0)return[c,u];const r=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=r.next();if(n.done)return[c,O.empty()];c.push(n.value)}return[c,{[Symbol.iterator](){return r}}]}O.consume=E})(P||(e.Iterable=P={}))}),define(te[44],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,c=!1){let r=0;const i=t.length;let n="",a=0,k=16,I=0;function A(ee){let ae=0,se=0;for(;ae<ee;){const oe=t.charCodeAt(r);if(oe>=48&&oe<=57)se=se*16+oe-48;else if(oe>=65&&oe<=70)se=se*16+oe-65+10;else if(oe>=97&&oe<=102)se=se*16+oe-97+10;else break;r++,ae++}return ae<ee&&(se=-1),se}function v(ee){r=ee,n="",a=0,k=16,I=0}function C(){const ee=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return I=3,t.substring(ee,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;ae=r}else I=3;return t.substring(ee,ae)}function L(){let ee="",ae=r;for(;;){if(r>=i){ee+=t.substring(ae,r),I=2;break}const se=t.charCodeAt(r);if(se===34){ee+=t.substring(ae,r),r++;break}if(se===92){if(ee+=t.substring(ae,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const G=A(4);G>=0?ee+=String.fromCharCode(G):I=4;break}default:I=5}ae=r;continue}if(se>=0&&se<=31)if(h(se)){ee+=t.substring(ae,r),I=2;break}else I=6;r++}return ee}function U(){if(n="",I=0,a=r,r>=i)return a=i,k=17;let ee=t.charCodeAt(r);if(S(ee)){do r++,n+=String.fromCharCode(ee),ee=t.charCodeAt(r);while(S(ee));return k=15}if(h(ee))return r++,n+=String.fromCharCode(ee),ee===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),k=14;switch(ee){case 123:return r++,k=1;case 125:return r++,k=2;case 91:return r++,k=3;case 93:return r++,k=4;case 58:return r++,k=6;case 44:return r++,k=5;case 34:return r++,n=L(),k=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return n=t.substring(ae,r),k=12}if(t.charCodeAt(r+1)===42){r+=2;const se=i-1;let oe=!1;for(;r<se;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,oe=!0;break}r++}return oe||(r++,I=1),n=t.substring(ae,r),k=13}return n+=String.fromCharCode(ee),r++,k=16}case 45:if(n+=String.fromCharCode(ee),r++,r===i||!l(t.charCodeAt(r)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),k=11;default:for(;r<i&&B(ee);)r++,ee=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return n+=String.fromCharCode(ee),r++,k=16}}function B(ee){if(S(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ee;do ee=U();while(ee>=12&&ee<=15);return ee}return{setPosition:v,getPosition:()=>r,scan:c?re:U,getToken:()=>k,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>I}}e.$Jm=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function b(t,c){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(A,v,C,L){a.value=A,a.offset=v,a.length=C,a.type=L,a.colonOffset=void 0,n=a}try{$(t,{onObjectBegin:(A,v)=>{if(c<=A)throw i;n=void 0,k=c>A,r.push("")},onObjectProperty:(A,v,C)=>{if(c<v||(I(A,v,C,"property"),r[r.length-1]=A,c<=v+C))throw i},onObjectEnd:(A,v)=>{if(c<=A)throw i;n=void 0,r.pop()},onArrayBegin:(A,v)=>{if(c<=A)throw i;n=void 0,r.push(0)},onArrayEnd:(A,v)=>{if(c<=A)throw i;n=void 0,r.pop()},onLiteralValue:(A,v,C)=>{if(c<v||(I(A,v,C,u(A)),c<=v+C))throw i},onSeparator:(A,v,C)=>{if(c<=v)throw i;if(A===":"&&n&&n.type==="property")n.colonOffset=v,k=!1,n=void 0;else if(A===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(k=!0,r[r.length-1]=""),n=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:n,isAtPropertyKey:k,matches:A=>{let v=0;for(let C=0;v<A.length&&C<r.length;C++)if(A[v]===r[C]||A[v]==="*")v++;else if(A[v]!=="**")return!1;return v===A.length}}}e.$Km=b;function p(t,c=[],r=M.DEFAULT){let i=null,n=[];const a=[];function k(A){Array.isArray(n)?n.push(A):i!==null&&(n[i]=A)}return $(t,{onObjectBegin:()=>{const A={};k(A),a.push(n),n=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const A=[];k(A),a.push(n),n=A,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:k,onError:(A,v,C)=>{c.push({error:A,offset:v,length:C})}},r),n[0]}e.$Lm=p;function f(t,c=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function a(A){return i.children.push(A),A}$(t,{onObjectBegin:A=>{i=a({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,v,C)=>{i=a({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:v,length:C,parent:i})},onObjectEnd:(A,v)=>{i.length=A+v-i.offset,i=i.parent,n(A+v)},onArrayBegin:(A,v)=>{i=a({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,v)=>{i.length=A+v-i.offset,i=i.parent,n(A+v)},onLiteralValue:(A,v,C)=>{a({type:u(A),offset:v,length:C,parent:i,value:A}),n(v+C)},onSeparator:(A,v,C)=>{i.type==="property"&&(A===":"?i.colonOffset=v:A===","&&n(v))},onError:(A,v,C)=>{c.push({error:A,offset:v,length:C})}},r);const I=i.children[0];return I&&delete I.parent,I}e.$Mm=f;function y(t,c){if(!t)return;let r=t;for(const i of c)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Nm=y;function w(t){if(!t.parent||!t.parent.children)return[];const c=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;c.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&c.push(r)}return c}e.$Om=w;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const c=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(c[r.children[0].value]=d(i))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=d;function g(t,c,r=!1){return c>=t.offset&&c<t.offset+t.length||r&&c===t.offset+t.length}e.$Qm=g;function o(t,c,r=!1){if(g(t,c,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=c;n++){const a=o(i[n],c,r);if(a)return a}return t}}e.$Rm=o;function $(t,c,r=M.DEFAULT){const i=D(t,!1);function n(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(X){return X?x=>X(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=n(c.onObjectBegin),I=a(c.onObjectProperty),A=n(c.onObjectEnd),v=n(c.onArrayBegin),C=n(c.onArrayEnd),L=a(c.onLiteralValue),U=a(c.onSeparator),B=n(c.onComment),re=a(c.onError),ee=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function se(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ee||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(X){case 12:case 13:ee?oe(10):B();break;case 16:oe(1);break;case 15:case 14:break;default:return X}}}function oe(X,x=[],ce=[]){if(re(X),x.length+ce.length>0){let Y=i.getToken();for(;Y!==17;){if(x.indexOf(Y)!==-1){se();break}else if(ce.indexOf(Y)!==-1)break;Y=se()}}}function G(X){const x=i.getTokenValue();return X?L(x):I(x),se(),!0}function K(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(oe(2),X=0)}catch{oe(2)}L(X);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return se(),!0}function q(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(U(":"),se(),V()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function F(){k(),se();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||oe(4,[],[]),U(","),se(),i.getToken()===2&&ae)break}else X&&oe(6,[],[]);q()||oe(4,[],[2,5]),X=!0}return A(),i.getToken()!==2?oe(7,[2],[]):se(),!0}function N(){v(),se();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||oe(4,[],[]),U(","),se(),i.getToken()===4&&ae)break}else X&&oe(6,[],[]);V()||oe(4,[],[4,5]),X=!0}return C(),i.getToken()!==4?oe(8,[4],[]):se(),!0}function V(){switch(i.getToken()){case 3:return N();case 1:return F();case 10:return G(!0);default:return K()}}return se(),i.getToken()===17?r.allowEmptyContent?!0:(oe(4,[],[]),!1):V()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$Sm=$;function E(t,c){const r=D(t),i=[];let n,a=0,k;do switch(k=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==k&&i.push(t.substring(a,k)),c!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,c)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$Tm=E;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=u}),define(te[137],ie([0,1,44]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zS=e.$yS=e.$xS=e.$wS=void 0;function O(l,m,b){let p,f,y,w,d;if(m){for(w=m.offset,d=w+m.length,y=w;y>0&&!h(l,y-1);)y--;let k=d;for(;k<l.length&&!h(l,k);)k++;f=l.substring(y,k),p=D(f,b)}else f=l,p=0,y=0,w=0,d=l.length;const g=S(b,l);let o=!1,$=0,E;b.insertSpaces?E=M(" ",b.tabSize||4):E="	";const u=(0,P.$Jm)(f,!1);let t=!1;function c(){return g+M(E,p+$)}function r(){let k=u.scan();for(o=!1;k===15||k===14;)o=o||k===14,k=u.scan();return t=k===16||u.getTokenError()!==0,k}const i=[];function n(k,I,A){!t&&I<d&&A>w&&l.substring(I,A)!==k&&i.push({offset:I,length:A-I,content:k})}let a=r();if(a!==17){const k=u.getTokenOffset()+y,I=M(E,p);n(I,y,k)}for(;a!==17;){let k=u.getTokenOffset()+u.getTokenLength()+y,I=r(),A="";for(;!o&&(I===12||I===13);){const C=u.getTokenOffset()+y;n(" ",k,C),k=u.getTokenOffset()+u.getTokenLength()+y,A=I===12?c():"",I=r()}if(I===2)a!==1&&($--,A=c());else if(I===4)a!==3&&($--,A=c());else{switch(a){case 3:case 1:$++,A=c();break;case 5:case 12:A=c();break;case 13:o?A=c():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}o&&(I===12||I===13)&&(A=c())}const v=u.getTokenOffset()+y;n(A,k,v),a=I}return i}e.$wS=O;function s(l,m){const b=JSON.stringify(l,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?b.replace(/\r\n|\r|\n/g,m.eol):b}e.$xS=s;function M(l,m){let b="";for(let p=0;p<m;p++)b+=l;return b}function D(l,m){let b=0,p=0;const f=m.tabSize||4;for(;b<l.length;){const y=l.charAt(b);if(y===" ")p++;else if(y==="	")p+=f;else break;b++}return Math.floor(p/f)}function S(l,m){for(let b=0;b<m.length;b++){const p=m.charAt(b);if(p==="\r")return b+1<m.length&&m.charAt(b+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return l&&l.eol||`
`}e.$yS=S;function h(l,m){return`\r
`.indexOf(l.charAt(m))!==-1}e.$zS=h}),define(te[138],ie([0,1,44,137]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ES=e.$DS=e.$CS=e.$BS=e.$AS=void 0;function s(l,m,b){return M(l,m,void 0,b)}e.$AS=s;function M(l,m,b,p,f){const y=m.slice(),w=[],d=(0,P.$Mm)(l,w);let g,o;for(;y.length>0&&(o=y.pop(),g=(0,P.$Nm)(d,y),g===void 0&&b!==void 0);)typeof o=="string"?b={[o]:b}:b=[b];if(g)if(g.type==="object"&&typeof o=="string"&&Array.isArray(g.children)){const $=(0,P.$Nm)(g,[o]);if($!==void 0)if(b===void 0){if(!$.parent)throw new Error("Malformed AST");const E=g.children.indexOf($.parent);let u,t=$.parent.offset+$.parent.length;if(E>0){const c=g.children[E-1];u=c.offset+c.length}else u=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return D(l,{offset:u,length:t-u,content:""},p)}else return D(l,{offset:$.offset,length:$.length,content:JSON.stringify(b)},p);else{if(b===void 0)return[];const E=`${JSON.stringify(o)}: ${JSON.stringify(b)}`,u=f?f(g.children.map(c=>c.children[0].value)):g.children.length;let t;if(u>0){const c=g.children[u-1];t={offset:c.offset+c.length,length:0,content:","+E}}else g.children.length===0?t={offset:g.offset+1,length:0,content:E}:t={offset:g.offset+1,length:0,content:E+","};return D(l,t,p)}}else if(g.type==="array"&&typeof o=="number"&&Array.isArray(g.children))if(b!==void 0){const $=`${JSON.stringify(b)}`;let E;if(g.children.length===0||o===0)E={offset:g.offset+1,length:0,content:g.children.length===0?$:$+","};else{const u=o===-1||o>g.children.length?g.children.length:o,t=g.children[u-1];E={offset:t.offset+t.length,length:0,content:","+$}}return D(l,E,p)}else{const $=o,E=g.children[$];let u;if(g.children.length===1)u={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===$){const t=g.children[$-1],c=t.offset+t.length,r=g.offset+g.length;u={offset:c,length:r-2-c,content:""}}else u={offset:E.offset,length:g.children[$+1].offset-E.offset,content:""};return D(l,u,p)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${g.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return D(l,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(b)},p)}}e.$BS=M;function D(l,m,b){let p=S(l,m),f=m.offset,y=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;f>0&&!(0,O.$zS)(p,f-1);)f--;for(;y<p.length&&!(0,O.$zS)(p,y);)y++}const w=(0,O.$wS)(p,{offset:f,length:y-f},b);for(let g=w.length-1;g>=0;g--){const o=w[g];p=S(p,o),f=Math.min(f,o.offset),y=Math.max(y,o.offset+o.length),y+=o.content.length-o.length}const d=l.length-(p.length-y)-f;return[{offset:f,length:d,content:p.substring(f,y)}]}e.$CS=D;function S(l,m){return l.substring(0,m.offset)+m.content+l.substring(m.offset+m.length)}e.$DS=S;function h(l,m){const b=m.slice(0).sort((f,y)=>{const w=f.offset-y.offset;return w===0?f.length-y.length:w});let p=l.length;for(let f=b.length-1;f>=0;f--){const y=b[f];if(y.offset+y.length<=p)l=S(l,y);else throw new Error("Overlapping edit");p=y.offset}return l}e.$ES=h}),define(te[84],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=P}),define(te[2],ie([0,1,23,134,49,68]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const D=!1;let S=null;class h{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:h.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const L=this.c(v);L.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const L=C.get(v);if(L)return L;const U=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,U),U}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,v).isSingleton).map(([L])=>L).flat()}computeLeakingDisposables(v=10,C){let L;if(C)L=C;else{const ae=new Map,se=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,ae).isSingleton);if(se.length===0)return;const oe=new Set(se.map(G=>G.value));if(L=se.filter(G=>!(G.parent&&oe.has(G.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function U(ae){function se(G,K){for(;G.length>0&&K.some(q=>typeof q=="string"?q===G[0]:G[0].match(q));)G.shift()}const oe=ae.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return se(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const B=new O.$L;for(const ae of L){const se=U(ae);for(let oe=0;oe<=se.length;oe++)B.add(se.slice(0,oe).join(`
`),ae)}L.sort((0,P.$5b)(ae=>ae.idx,P.$7b));let re="",ee=0;for(const ae of L.slice(0,v)){ee++;const se=U(ae),oe=[];for(let G=0;G<se.length;G++){let K=se[G];K=`(shared with ${B.get(se.slice(0,G+1).join(`
`)).size}/${L.length} leaks) at ${K}`;const F=B.get(se.slice(0,G).join(`
`)),N=(0,O.$I)([...F].map(V=>U(V)[G]),V=>V);delete N[se[G]];for(const[V,X]of Object.entries(N))oe.unshift(`    - stacktraces of ${X.length} other leaks continue with ${V}`);oe.unshift(K)}re+=`


==================== Leaking disposable ${ee}/${L.length}: ${ae.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return L.length>v&&(re+=`


... and ${L.length-v} more leaking disposables

`),{leaks:L,details:re}}}e.$_b=h;function l(A){S=A}if(e.$ac=l,D){const A="__is_disposable_tracked__";l(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[A]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==u.None)try{v[A]=!0}catch{}}markAsDisposed(v){if(v&&v!==u.None)try{v[A]=!0}catch{}}markAsSingleton(v){}})}function m(A){return S?.trackDisposable(A),A}e.$bc=m;function b(A){S?.markAsDisposed(A)}e.$cc=b;function p(A,v){S?.setParent(A,v)}function f(A,v){if(S)for(const C of A)S.setParent(C,v)}function y(A){return S?.markAsSingleton(A),A}e.$dc=y;function w(A){return typeof A.dispose=="function"&&A.dispose.length===0}e.$ec=w;function d(A){if(M.Iterable.is(A)){const v=[];for(const C of A)if(C)try{C.dispose()}catch(L){v.push(L)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}e.$fc=d;function g(A){for(const v of A)w(v)&&v.dispose();return[]}e.$gc=g;function o(...A){const v=$(()=>d(A));return f(A,v),v}e.$hc=o;function $(A){const v=m({dispose:(0,s.$bb)(()=>{b(v),A()})});return v}e.$ic=$;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return p(v,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}}e.$jc=E;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,m(this),p(this.q,this)}dispose(){b(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$kc=u;class t{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&p(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&p(v,null),v}}e.$lc=t;class c{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=c;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,b(this))},this}}e.$nc=r;class i{constructor(){this.a=new Map}acquire(v,...C){let L=this.a.get(v);L||(L={counter:0,object:this.b(v,...C)},this.a.set(v,L));const{object:U}=L,B=(0,s.$bb)(()=>{--L.counter===0&&(this.c(v,L.object),this.a.delete(v))});return L.counter++,{object:U,dispose:B}}}e.$oc=i;class n{constructor(v){this.a=v}async acquire(v,...C){const L=this.a.acquire(v,...C);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(U){throw L.dispose(),U}}}e.$pc=n;class a{constructor(v){this.object=v}dispose(){}}e.$qc=a;function k(A){const v=new E;try{A(v)}finally{v.dispose()}}e.$rc=k;class I{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=I}),define(te[101],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class O{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const D=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const l=this.b;this.b=S,S.prev=l,l.next=S}else{const l=this.a;this.a=S,S.next=l,l.prev=S}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$tc=O}),define(te[33],ie([0,1]),function(J,e){"use strict";var P,O,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function M(g,o,$){let E=g.get(o);return E===void 0&&(E=$,g.set(o,E)),E}e.$wi=M;function D(g){const o=[];return g.forEach(($,E)=>{o.push(`${E} => ${$}`)}),`Map(${g.size}) {${o.join(", ")}}`}e.$xi=D;function S(g){const o=[];return g.forEach($=>{o.push($)}),`Set(${g.size}) {${o.join(", ")}}`}e.$yi=S;class h{constructor(o,$){this.uri=o,this.value=$}}function l(g){return Array.isArray(g)}class m{static{this.a=o=>o.toString()}constructor(o,$){if(this[P]="ResourceMap",o instanceof m)this.b=new Map(o.b),this.c=$??m.a;else if(l(o)){this.b=new Map,this.c=$??m.a;for(const[E,u]of o)this.set(E,u)}else this.b=new Map,this.c=o??m.a}set(o,$){return this.b.set(this.c(o),new h(o,$)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,$){typeof $<"u"&&(o=o.bind($));for(const[E,u]of this.b)o(u.value,u.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$zi=m;class b{constructor(o,$){this[O]="ResourceSet",!o||typeof o=="function"?this.a=new m(o):(this.a=new m($),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,$){this.a.forEach((E,u)=>o.call($,u,u,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=b;var p;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,$=0){const E=this.a.get(o);if(E)return $!==0&&this.j(E,$),E.value}set(o,$,E=0){let u=this.a.get(o);if(u)u.value=$,E!==0&&this.j(u,E);else{switch(u={key:o,value:$,next:void 0,previous:void 0},E){case 0:this.h(u);break;case 1:this.g(u);break;case 2:this.h(u);break;default:this.h(u);break}this.a.set(o,u),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const $=this.a.get(o);if($)return this.a.delete(o),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,$){const E=this.e;let u=this.b;for(;u;){if($?o.bind($)(u.value,u.key,this):o(u.value,u.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const o=this,$=this.e;let E=this.b;const u={[Symbol.iterator](){return u},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(E){const t={value:E.key,done:!1};return E=E.next,t}else return{value:void 0,done:!0}}};return u}values(){const o=this,$=this.e;let E=this.b;const u={[Symbol.iterator](){return u},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(E){const t={value:E.value,done:!1};return E=E.next,t}else return{value:void 0,done:!0}}};return u}entries(){const o=this,$=this.e;let E=this.b;const u={[Symbol.iterator](){return u},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(E){const t={value:[E.key,E.value],done:!1};return E=E.next,t}else return{value:void 0,done:!0}}};return u}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let $=this.b,E=this.size;for(;$&&E>o;)this.a.delete($.key),$=$.next,E--;this.b=$,this.d=E,$&&($.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const $=o.next,E=o.previous;if(!$||!E)throw new Error("Invalid list");$.previous=E,E.next=$}o.next=void 0,o.previous=void 0,this.e++}j(o,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(o===this.b)return;const E=o.next,u=o.previous;o===this.c?(u.next=void 0,this.c=u):(E.previous=u,u.next=E),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if($===2){if(o===this.c)return;const E=o.next,u=o.previous;o===this.b?(E.previous=void 0,this.b=E):(E.previous=u,u.next=E),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach(($,E)=>{o.push([E,$])}),o}fromJSON(o){this.clear();for(const[$,E]of o)this.set($,E)}}e.$Bi=f;class y extends f{constructor(o,$=1){super(),this.k=o,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,$=2){return super.get(o,$)}peek(o){return super.get(o,0)}set(o,$){return super.set(o,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=y;class w{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let $=this.a.get(o)||0;return $===0?!1:($--,$===0?this.a.delete(o):this.a.set(o,$),!0)}has(o){return this.a.has(o)}}e.$Di=w;class d{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[$,E]of o)this.set($,E)}clear(){this.a.clear(),this.b.clear()}set(o,$){this.a.set(o,$),this.b.set($,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const $=this.a.get(o);return $===void 0?!1:(this.a.delete(o),this.b.delete($),!0)}forEach(o,$){this.a.forEach((E,u)=>{o.call($,E,u,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=d}),define(te[85],ie([0,1,33]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const O=new P.$Ci(1e4);function s(l){return h(l,"NFC",O)}e.$hl=s;const M=new P.$Ci(1e4);function D(l){return h(l,"NFD",M)}e.$il=D;const S=/[^\u0000-\u0080]/;function h(l,m,b){if(!l)return l;const p=b.get(l);if(p)return p;let f;return S.test(l)?f=l.normalize(m):f=l,b.set(l,f),f}e.$jl=function(){const l=/[\u0300-\u036f]/g;return function(m){return D(m).replace(l,"")}}()}),define(te[139],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function P(S,h,l){return Math.min(Math.max(S,h),l)}e.$Hl=P;function O(S,h){return(h+S%h)%h}e.rot=O;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=s;class M{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=M;class D{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=D}),function(){function J(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(h){M.push(h,Date.now())}function S(){const h=[];for(let l=0;l<M.length;l+=2)h.push({name:M[l],startTime:M[l+1]});return h}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var O in P)(typeof exports=="object"?exports:J)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function P(O){if(e[O])return e[O].exports;var s=e[O]={i:O,l:!1,exports:{}};return J[O].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=J,P.c=e,P.d=function(O,s,M){P.o(O,s)||Object.defineProperty(O,s,{enumerable:!0,get:M})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,s){if(1&s&&(O=P(O)),8&s||4&s&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&s&&typeof O!="string")for(var D in O)P.d(M,D,function(S){return O[S]}.bind(null,D));return M},P.n=function(O){var s=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(s,"a",s),s},P.o=function(O,s){return Object.prototype.hasOwnProperty.call(O,s)},P.p="",P(P.s=0)}([function(J,e,P){(function(O){var s;e=J.exports=ce,s=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],h=e.src=[],l=0,m=l++;h[m]="0|[1-9]\\d*";var b=l++;h[b]="[0-9]+";var p=l++;h[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;h[f]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var y=l++;h[y]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var w=l++;h[w]="(?:"+h[m]+"|"+h[p]+")";var d=l++;h[d]="(?:"+h[b]+"|"+h[p]+")";var g=l++;h[g]="(?:-("+h[w]+"(?:\\."+h[w]+")*))";var o=l++;h[o]="(?:-?("+h[d]+"(?:\\."+h[d]+")*))";var $=l++;h[$]="[0-9A-Za-z-]+";var E=l++;h[E]="(?:\\+("+h[$]+"(?:\\."+h[$]+")*))";var u=l++,t="v?"+h[f]+h[g]+"?"+h[E]+"?";h[u]="^"+t+"$";var c="[v=\\s]*"+h[y]+h[o]+"?"+h[E]+"?",r=l++;h[r]="^"+c+"$";var i=l++;h[i]="((?:<|>)?=?)";var n=l++;h[n]=h[b]+"|x|X|\\*";var a=l++;h[a]=h[m]+"|x|X|\\*";var k=l++;h[k]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[g]+")?"+h[E]+"?)?)?";var I=l++;h[I]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[o]+")?"+h[E]+"?)?)?";var A=l++;h[A]="^"+h[i]+"\\s*"+h[k]+"$";var v=l++;h[v]="^"+h[i]+"\\s*"+h[I]+"$";var C=l++;h[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=l++;h[L]="(?:~>?)";var U=l++;h[U]="(\\s*)"+h[L]+"\\s+",S[U]=new RegExp(h[U],"g");var B=l++;h[B]="^"+h[L]+h[k]+"$";var re=l++;h[re]="^"+h[L]+h[I]+"$";var ee=l++;h[ee]="(?:\\^)";var ae=l++;h[ae]="(\\s*)"+h[ee]+"\\s+",S[ae]=new RegExp(h[ae],"g");var se=l++;h[se]="^"+h[ee]+h[k]+"$";var oe=l++;h[oe]="^"+h[ee]+h[I]+"$";var G=l++;h[G]="^"+h[i]+"\\s*("+c+")$|^$";var K=l++;h[K]="^"+h[i]+"\\s*("+t+")$|^$";var q=l++;h[q]="(\\s*)"+h[i]+"\\s*("+c+"|"+h[k]+")",S[q]=new RegExp(h[q],"g");var F=l++;h[F]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var N=l++;h[N]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var V=l++;h[V]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)s(X,h[X]),S[X]||(S[X]=new RegExp(h[X]));function x(Q,le){if(Q instanceof ce)return Q;if(typeof Q!="string"||Q.length>M||!(le?S[r]:S[u]).test(Q))return null;try{return new ce(Q,le)}catch{return null}}function ce(Q,le){if(Q instanceof ce){if(Q.loose===le)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(Q,le);s("SemVer",Q,le),this.loose=le;var de=Q.trim().match(le?S[r]:S[u]);if(!de)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Re=+Ee;if(Re>=0&&Re<D)return Re}return Ee}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=x,e.valid=function(Q,le){var de=x(Q,le);return de?de.version:null},e.clean=function(Q,le){var de=x(Q.trim().replace(/^[=v]+/,""),le);return de?de.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(Q){return s("SemVer.compare",this.version,this.loose,Q),Q instanceof ce||(Q=new ce(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ce.prototype.compareMain=function(Q){return Q instanceof ce||(Q=new ce(Q,this.loose)),R(this.major,Q.major)||R(this.minor,Q.minor)||R(this.patch,Q.patch)},ce.prototype.comparePre=function(Q){if(Q instanceof ce||(Q=new ce(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var le=0;do{var de=this.prerelease[le],Ee=Q.prerelease[le];if(s("prerelease compare",le,de,Ee),de===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(de===void 0)return-1;if(de!==Ee)return R(de,Ee)}while(++le)},ce.prototype.inc=function(Q,le){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,le,de,Ee){typeof de=="string"&&(Ee=de,de=void 0);try{return new ce(Q,de).inc(le,Ee).version}catch{return null}},e.diff=function(Q,le){if(H(Q,le))return null;var de=x(Q),Ee=x(le);if(de.prerelease.length||Ee.prerelease.length){for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Ee[Re])return"pre"+Re;return"prerelease"}for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Ee[Re])return Re},e.compareIdentifiers=R;var Y=/^[0-9]+$/;function R(Q,le){var de=Y.test(Q),Ee=Y.test(le);return de&&Ee&&(Q=+Q,le=+le),de&&!Ee?-1:Ee&&!de?1:Q<le?-1:Q>le?1:0}function j(Q,le,de){return new ce(Q,de).compare(new ce(le,de))}function W(Q,le,de){return j(Q,le,de)>0}function T(Q,le,de){return j(Q,le,de)<0}function H(Q,le,de){return j(Q,le,de)===0}function z(Q,le,de){return j(Q,le,de)!==0}function ne(Q,le,de){return j(Q,le,de)>=0}function fe(Q,le,de){return j(Q,le,de)<=0}function ge(Q,le,de,Ee){var Re;switch(le){case"===":typeof Q=="object"&&(Q=Q.version),typeof de=="object"&&(de=de.version),Re=Q===de;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof de=="object"&&(de=de.version),Re=Q!==de;break;case"":case"=":case"==":Re=H(Q,de,Ee);break;case"!=":Re=z(Q,de,Ee);break;case">":Re=W(Q,de,Ee);break;case">=":Re=ne(Q,de,Ee);break;case"<":Re=T(Q,de,Ee);break;case"<=":Re=fe(Q,de,Ee);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function ue(Q,le){if(Q instanceof ue){if(Q.loose===le)return Q;Q=Q.value}if(!(this instanceof ue))return new ue(Q,le);s("comparator",Q,le),this.loose=le,this.parse(Q),this.semver===we?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Q,le){return R(le,Q)},e.major=function(Q,le){return new ce(Q,le).major},e.minor=function(Q,le){return new ce(Q,le).minor},e.patch=function(Q,le){return new ce(Q,le).patch},e.compare=j,e.compareLoose=function(Q,le){return j(Q,le,!0)},e.rcompare=function(Q,le,de){return j(le,Q,de)},e.sort=function(Q,le){return Q.sort(function(de,Ee){return e.compare(de,Ee,le)})},e.rsort=function(Q,le){return Q.sort(function(de,Ee){return e.rcompare(de,Ee,le)})},e.gt=W,e.lt=T,e.eq=H,e.neq=z,e.gte=ne,e.lte=fe,e.cmp=ge,e.Comparator=ue;var we={};function me(Q,le){if(Q instanceof me)return Q.loose===le?Q:new me(Q.raw,le);if(Q instanceof ue)return new me(Q.value,le);if(!(this instanceof me))return new me(Q,le);if(this.loose=le,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Se(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ie(Q,le,de,Ee,Re,Ue,Oe,ze,We,Z,he,$e,ye){return((le=Se(de)?"":Se(Ee)?">="+de+".0.0":Se(Re)?">="+de+"."+Ee+".0":">="+le)+" "+(ze=Se(We)?"":Se(Z)?"<"+(+We+1)+".0.0":Se(he)?"<"+We+"."+(+Z+1)+".0":$e?"<="+We+"."+Z+"."+he+"-"+$e:"<="+ze)).trim()}function je(Q,le){for(var de=0;de<Q.length;de++)if(!Q[de].test(le))return!1;if(le.prerelease.length){for(de=0;de<Q.length;de++)if(s(Q[de].semver),Q[de].semver!==we&&Q[de].semver.prerelease.length>0){var Ee=Q[de].semver;if(Ee.major===le.major&&Ee.minor===le.minor&&Ee.patch===le.patch)return!0}return!1}return!0}function ve(Q,le,de){try{le=new me(le,de)}catch{return!1}return le.test(Q)}function be(Q,le,de,Ee){var Re,Ue,Oe,ze,We;switch(Q=new ce(Q,Ee),le=new me(le,Ee),de){case">":Re=W,Ue=fe,Oe=T,ze=">",We=">=";break;case"<":Re=T,Ue=ne,Oe=W,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(Q,le,Ee))return!1;for(var Z=0;Z<le.set.length;++Z){var he=le.set[Z],$e=null,ye=null;if(he.forEach(function(Ce){Ce.semver===we&&(Ce=new ue(">=0.0.0")),$e=$e||Ce,ye=ye||Ce,Re(Ce.semver,$e.semver,Ee)?$e=Ce:Oe(Ce.semver,ye.semver,Ee)&&(ye=Ce)}),$e.operator===ze||$e.operator===We||(!ye.operator||ye.operator===ze)&&Ue(Q,ye.semver)||ye.operator===We&&Oe(Q,ye.semver))return!1}return!0}ue.prototype.parse=function(Q){var le=this.loose?S[G]:S[K],de=Q.match(le);if(!de)throw new TypeError("Invalid comparator: "+Q);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new ce(de[2],this.loose):this.semver=we},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(Q){return s("Comparator.test",Q,this.loose),this.semver===we||(typeof Q=="string"&&(Q=new ce(Q,this.loose)),ge(Q,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(Q,le){if(!(Q instanceof ue))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new me(Q.value,le),ve(this.value,de,le);if(Q.operator==="")return de=new me(this.value,le),ve(Q.semver,de,le);var Ee=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ue=this.semver.version===Q.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),ze=ge(this.semver,"<",Q.semver,le)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),We=ge(this.semver,">",Q.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Ee||Re||Ue&&Oe||ze||We},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(Q){var le=this.loose;Q=Q.trim(),s("range",Q,le);var de=le?S[N]:S[F];Q=Q.replace(de,Ie),s("hyphen replace",Q),Q=Q.replace(S[q],"$1$2$3"),s("comparator trim",Q,S[q]),Q=(Q=(Q=Q.replace(S[U],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var Ee=le?S[G]:S[K],Re=Q.split(" ").map(function(Ue){return function(Oe,ze){return s("comp",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function($e,ye){s("caret",$e,ye);var Ce=ye?S[oe]:S[se];return $e.replace(Ce,function(Fe,Le,Ne,Be,qe){var He;return s("caret",$e,Fe,Le,Ne,Be,qe),Se(Le)?He="":Se(Ne)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":Se(Be)?He=Le==="0"?">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+".0 <"+(+Le+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+Be+qe+" <"+Le+"."+Ne+"."+(+Be+1):">="+Le+"."+Ne+"."+Be+qe+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+Be+qe+" <"+(+Le+1)+".0.0"):(s("no pr"),He=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+Be+" <"+Le+"."+Ne+"."+(+Be+1):">="+Le+"."+Ne+"."+Be+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+Be+" <"+(+Le+1)+".0.0"),s("caret return",He),He})}(he,Z)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function($e,ye){var Ce=ye?S[re]:S[B];return $e.replace(Ce,function(Fe,Le,Ne,Be,qe){var He;return s("tilde",$e,Fe,Le,Ne,Be,qe),Se(Le)?He="":Se(Ne)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":Se(Be)?He=">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+Le+"."+Ne+"."+Be+qe+" <"+Le+"."+(+Ne+1)+".0"):He=">="+Le+"."+Ne+"."+Be+" <"+Le+"."+(+Ne+1)+".0",s("tilde return",He),He})}(he,Z)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,Z){return s("replaceXRanges",We,Z),We.split(/\s+/).map(function(he){return function($e,ye){$e=$e.trim();var Ce=ye?S[v]:S[A];return $e.replace(Ce,function(Fe,Le,Ne,Be,qe,He){s("xRange",$e,Fe,Le,Ne,Be,qe,He);var xe=Se(Ne),Xe=xe||Se(Be),tt=Xe||Se(qe);return Le==="="&&tt&&(Le=""),xe?Fe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&tt?(Xe&&(Be=0),tt&&(qe=0),Le===">"?(Le=">=",Xe?(Ne=+Ne+1,Be=0,qe=0):tt&&(Be=+Be+1,qe=0)):Le==="<="&&(Le="<",Xe?Ne=+Ne+1:Be=+Be+1),Fe=Le+Ne+"."+Be+"."+qe):Xe?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":tt&&(Fe=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0"),s("xRange return",Fe),Fe})}(he,Z)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,Z){return s("replaceStars",We,Z),We.trim().replace(S[V],"")}(Oe,ze),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ue){return!!Ue.match(Ee)})),Re=Re.map(function(Ue){return new ue(Ue,le)})},me.prototype.intersects=function(Q,le){if(!(Q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ee){return Q.set.some(function(Re){return Re.every(function(Ue){return Ee.intersects(Ue,le)})})})})},e.toComparators=function(Q,le){return new me(Q,le).set.map(function(de){return de.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},me.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ce(Q,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],Q))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(Q,le,de){var Ee=null,Re=null;try{var Ue=new me(le,de)}catch{return null}return Q.forEach(function(Oe){Ue.test(Oe)&&(Ee&&Re.compare(Oe)!==-1||(Re=new ce(Ee=Oe,de)))}),Ee},e.minSatisfying=function(Q,le,de){var Ee=null,Re=null;try{var Ue=new me(le,de)}catch{return null}return Q.forEach(function(Oe){Ue.test(Oe)&&(Ee&&Re.compare(Oe)!==1||(Re=new ce(Ee=Oe,de)))}),Ee},e.validRange=function(Q,le){try{return new me(Q,le).range||"*"}catch{return null}},e.ltr=function(Q,le,de){return be(Q,le,"<",de)},e.gtr=function(Q,le,de){return be(Q,le,">",de)},e.outside=be,e.prerelease=function(Q,le){var de=x(Q,le);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Q,le,de){return Q=new me(Q,de),le=new me(le,de),Q.intersects(le)},e.coerce=function(Q){if(Q instanceof ce)return Q;if(typeof Q!="string")return null;var le=Q.match(S[C]);return le==null?null:x((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(J,e){var P,O,s=J.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(d){if(P===setTimeout)return setTimeout(d,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout(d,0);try{return P(d,0)}catch{try{return P.call(null,d,0)}catch{return P.call(this,d,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{O=typeof clearTimeout=="function"?clearTimeout:D}catch{O=D}})();var h,l=[],m=!1,b=-1;function p(){m&&h&&(m=!1,h.length?l=h.concat(l):b=-1,l.length&&f())}function f(){if(!m){var d=S(p);m=!0;for(var g=l.length;g;){for(h=l,l=[];++b<g;)h&&h[b].run();b=-1,g=l.length}h=null,m=!1,function(o){if(O===clearTimeout)return clearTimeout(o);if((O===D||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(o);try{O(o)}catch{try{return O.call(null,o)}catch{return O.call(this,o)}}}(d)}}function y(d,g){this.fun=d,this.array=g}function w(){}s.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var o=1;o<arguments.length;o++)g[o-1]=arguments[o];l.push(new y(d,g)),l.length!==1||m||S(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(d){return[]},s.binding=function(d){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(d){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[140],ie([0,1]),function(J,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class O{constructor(S,h,l){this.level=S,this.key=h,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(S,h=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,s,s)}get size(){return this.f}clear(){this.e=new O(this.c,s,s)}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,h){return M.h(this,S,h,this.comparator)&&(this.f+=1),this}delete(S){const h=M.k(this,S,this.comparator);return h&&(this.f-=1),h}forEach(S,h){let l=this.e.forward[0];for(;l;)S.call(h,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",h=this.e.forward[0];for(;h;)S+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return S}static g(S,h,l){let m=S.e;for(let b=S.d-1;b>=0;b--)for(;m.forward[b]&&l(m.forward[b].key,h)<0;)m=m.forward[b];if(m=m.forward[0],m&&l(m.key,h)===0)return m}static h(S,h,l,m){const b=[];let p=S.e;for(let f=S.d-1;f>=0;f--){for(;p.forward[f]&&m(p.forward[f].key,h)<0;)p=p.forward[f];b[f]=p}if(p=p.forward[0],p&&m(p.key,h)===0)return p.value=l,!1;{const f=M.j(S);if(f>S.d){for(let y=S.d;y<f;y++)b[y]=S.e;S.d=f}p=new O(f,h,l);for(let y=0;y<f;y++)p.forward[y]=b[y].forward[y],b[y].forward[y]=p;return!0}}static j(S,h=.5){let l=1;for(;Math.random()<h&&l<S.c;)l+=1;return l}static k(S,h,l){const m=[];let b=S.e;for(let p=S.d-1;p>=0;p--){for(;b.forward[p]&&l(b.forward[p].key,h)<0;)b=b.forward[p];m[p]=b}if(b=b.forward[0],!b||l(b.key,h)!==0)return!1;for(let p=0;p<S.d&&m[p].forward[p]===b;p++)m[p].forward[p]=b.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$or=M}),define(te[69],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(M){return new O(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=O}),define(te[3],ie([0,1,14,49,2,101,69]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const S=!1,h=!1;var l;(function(A){A.None=()=>s.$kc.None;function v(ge){if(h){const{onDidAddListener:ue}=ge,we=y.create();let me=0;ge.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),ue?.()}}}function C(ge,ue){return K(ge,()=>{},0,void 0,!0,void 0,ue)}A.defer=C;function L(ge){return(ue,we=null,me)=>{let Se=!1,Ie;return Ie=ge(je=>{if(!Se)return Ie?Ie.dispose():Se=!0,ue.call(we,je)},null,me),Se&&Ie.dispose(),Ie}}A.once=L;function U(ge,ue,we){return oe((me,Se=null,Ie)=>ge(je=>me.call(Se,ue(je)),null,Ie),we)}A.map=U;function B(ge,ue,we){return oe((me,Se=null,Ie)=>ge(je=>{ue(je),me.call(Se,je)},null,Ie),we)}A.forEach=B;function re(ge,ue,we){return oe((me,Se=null,Ie)=>ge(je=>ue(je)&&me.call(Se,je),null,Ie),we)}A.filter=re;function ee(ge){return ge}A.signal=ee;function ae(...ge){return(ue,we=null,me)=>{const Se=(0,s.$hc)(...ge.map(Ie=>Ie(je=>ue.call(we,je))));return G(Se,me)}}A.any=ae;function se(ge,ue,we,me){let Se=we;return U(ge,Ie=>(Se=ue(Se,Ie),Se),me)}A.reduce=se;function oe(ge,ue){let we;const me={onWillAddFirstListener(){we=ge(Se.fire,Se)},onDidRemoveLastListener(){we?.dispose()}};ue||v(me);const Se=new $(me);return ue?.add(Se),Se.event}function G(ge,ue){return ue instanceof Array?ue.push(ge):ue&&ue.add(ge),ge}function K(ge,ue,we=100,me=!1,Se=!1,Ie,je){let ve,be,Q,le=0,de;const Ee={leakWarningThreshold:Ie,onWillAddFirstListener(){ve=ge(Ue=>{le++,be=ue(be,Ue),me&&!Q&&(Re.fire(be),be=void 0),de=()=>{const Oe=be;be=void 0,Q=void 0,(!me||le>1)&&Re.fire(Oe),le=0},typeof we=="number"?(clearTimeout(Q),Q=setTimeout(de,we)):Q===void 0&&(Q=0,queueMicrotask(de))})},onWillRemoveListener(){Se&&le>0&&de?.()},onDidRemoveLastListener(){de=void 0,ve.dispose()}};je||v(Ee);const Re=new $(Ee);return je?.add(Re),Re.event}A.debounce=K;function q(ge,ue=0,we){return A.debounce(ge,(me,Se)=>me?(me.push(Se),me):[Se],ue,void 0,!0,void 0,we)}A.accumulate=q;function F(ge,ue=(me,Se)=>me===Se,we){let me=!0,Se;return re(ge,Ie=>{const je=me||!ue(Ie,Se);return me=!1,Se=Ie,je},we)}A.latch=F;function N(ge,ue,we){return[A.filter(ge,ue,we),A.filter(ge,me=>!ue(me),we)]}A.split=N;function V(ge,ue=!1,we=[],me){let Se=we.slice(),Ie=ge(be=>{Se?Se.push(be):ve.fire(be)});me&&me.add(Ie);const je=()=>{Se?.forEach(be=>ve.fire(be)),Se=null},ve=new $({onWillAddFirstListener(){Ie||(Ie=ge(be=>ve.fire(be)),me&&me.add(Ie))},onDidAddFirstListener(){Se&&(ue?setTimeout(je):je())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return me&&me.add(ve),ve.event}A.buffer=V;function X(ge,ue){return(me,Se,Ie)=>{const je=ue(new ce);return ge(function(ve){const be=je.evaluate(ve);be!==x&&me.call(Se,be)},void 0,Ie)}}A.chain=X;const x=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(we=>(ue(we),we)),this}filter(ue){return this.f.push(we=>ue(we)?we:x),this}reduce(ue,we){let me=we;return this.f.push(Se=>(me=ue(me,Se),me)),this}latch(ue=(we,me)=>we===me){let we=!0,me;return this.f.push(Se=>{const Ie=we||!ue(Se,me);return we=!1,me=Se,Ie?Se:x}),this}evaluate(ue){for(const we of this.f)if(ue=we(ue),ue===x)break;return ue}}function Y(ge,ue,we=me=>me){const me=(...ve)=>je.fire(we(...ve)),Se=()=>ge.on(ue,me),Ie=()=>ge.removeListener(ue,me),je=new $({onWillAddFirstListener:Se,onDidRemoveLastListener:Ie});return je.event}A.fromNodeEventEmitter=Y;function R(ge,ue,we=me=>me){const me=(...ve)=>je.fire(we(...ve)),Se=()=>ge.addEventListener(ue,me),Ie=()=>ge.removeEventListener(ue,me),je=new $({onWillAddFirstListener:Se,onDidRemoveLastListener:Ie});return je.event}A.fromDOMEventEmitter=R;function j(ge){return new Promise(ue=>L(ge)(ue))}A.toPromise=j;function W(ge){const ue=new $;return ge.then(we=>{ue.fire(we)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}A.fromPromise=W;function T(ge,ue){return ue(void 0),ge(we=>ue(we))}A.runAndSubscribe=T;function H(ge,ue){let we=null;function me(Ie){we?.dispose(),we=new s.$jc,ue(Ie,we)}me(void 0);const Se=ge(Ie=>me(Ie));return(0,s.$ic)(()=>{Se.dispose(),we?.dispose()})}A.runAndSubscribeWithStore=H;class z{constructor(ue,we){this._observable=ue,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};we||v(me),this.emitter=new $(me),we&&we.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,we){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ne(ge,ue){return new z(ge,ue).emitter.event}A.fromObservable=ne;function fe(ge){return ue=>{let we=0,me=!1;const Se={beginUpdate(){we++},endUpdate(){we--,we===0&&(ge.reportChanges(),me&&(me=!1,ue()))},handlePossibleChange(){},handleChange(){me=!0}};return ge.addObserver(Se),ge.reportChanges(),{dispose(){ge.removeObserver(Se)}}}}A.fromObservableLight=fe})(l||(e.Event=l={}));class m{static{this.all=new Set}static{this.f=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${m.f++}`,m.all.add(this)}start(v){this.g=new D.$bd,this.listenerCount=v}stop(){if(this.g){const v=this.g.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.g=void 0}}}e.$dd=m;let b=-1;function p(A){const v=b;return b=A,{dispose(){b=v}}}e.$ed=p;class f{constructor(v,C=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=C,this.g=0}dispose(){this.f?.clear()}check(v,C){const L=this.threshold;if(L<=0||C<L)return;this.f||(this.f=new Map);const U=this.f.get(v.value)||0;if(this.f.set(v.value,U+1),this.g-=1,this.g<=0){this.g=L*.5;let B,re=0;for(const[ee,ae]of this.f)(!B||re<ae)&&(B=ee,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${re}):`),console.warn(B)}return()=>{const B=this.f.get(v.value)||0;this.f.set(v.value,B-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class d{constructor(v){this.value=v,this.id=w++}}const g=2,o=(A,v)=>{if(A instanceof d)v(A);else for(let C=0;C<A.length;C++){const L=A[C];L&&v(L)}};class ${constructor(v){this.x=0,this.f=v,this.g=b>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const v=this.t;queueMicrotask(()=>{o(v,C=>C.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(v,C,L)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$kc.None;if(this.m)return s.$kc.None;C&&(v=v.bind(C));const U=new d(v);let B,re;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(U.stack=y.create(),B=this.g.check(U.stack,this.x+1)),S&&(U.stack=re??y.create()),this.t?this.t instanceof d?(this.u??=new u,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.x++;const ee=(0,s.$ic)(()=>{B?.(),this.y(U)});return L instanceof s.$jc?L.add(ee):Array.isArray(L)&&L.push(ee),ee},this.q}y(v){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const C=this.t,L=C.indexOf(v);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,C[L]=void 0;const U=this.u.current===this;if(this.x*g<=C.length){let B=0;for(let re=0;re<C.length;re++)C[re]?C[B++]=C[re]:U&&(this.u.end--,B<this.u.i&&this.u.i--);C.length=B}}z(v,C){if(!v)return;const L=this.f?.onListenerError||P.$Y;if(!L){v.value(C);return}try{v.value(C)}catch(U){L(U)}}A(v){const C=v.current.t;for(;v.i<v.end;)this.z(C[v.i++],v.value);v.reset()}fire(v){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof d)this.z(this.t,v);else{const C=this.u;C.enqueue(this,v,this.t.length),this.A(C)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=$;const E=()=>new u;e.$gd=E;class u{constructor(){this.i=-1,this.end=0}enqueue(v,C,L){this.i=0,this.end=L,this.current=v,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends ${async fireAsync(v,C,L){if(this.t)for(this.h||(this.h=new M.$tc),o(this.t,U=>this.h.push([U.value,v]));this.h.size>0&&!C.isCancellationRequested;){const[U,B]=this.h.shift(),re=[],ee={...B,token:C,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,U)),re.push(ae)}};try{U(ee)}catch(ae){(0,P.$Y)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const se of ae)se.status==="rejected"&&(0,P.$Y)(se.reason)})}}}e.$hd=t;class c extends ${get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new M.$tc,this.w=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.w(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.x&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$id=c;class r extends c{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$jd=r;class i extends ${constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$kd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(v){const C={event:v,listener:null};this.h.push(C),this.g&&this.m(C);const L=()=>{this.g&&this.o(C);const U=this.h.indexOf(C);this.h.splice(U,1)};return(0,s.$ic)((0,O.$bb)(L))}j(){this.g=!0,this.h.forEach(v=>this.m(v))}k(){this.g=!1,this.h.forEach(v=>this.o(v))}m(v){v.listener=v.event(C=>this.f.fire(C))}o(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.f.dispose()}}e.$ld=n;class a{constructor(v,C,L,U){this.f=new s.$jc;const B=this.f.add(new n),re=this.f.add(new s.$sc);function ee(ae){re.set(ae,B.add(U(ae)))}for(const ae of v)ee(ae);this.f.add(C(ae=>{ee(ae)})),this.f.add(L(ae=>{re.deleteAndDispose(ae)})),this.event=B.event}dispose(){this.f.dispose()}}e.$md=a;class k{constructor(){this.f=[]}wrapEvent(v){return(C,L,U)=>v(B=>{const re=this.f[this.f.length-1];re?re.push(()=>C.call(L,B)):C.call(L,B)},void 0,U)}bufferEvents(v){const C=[];this.f.push(C);const L=v();return this.f.pop(),C.forEach(U=>U()),L}}e.$nd=k;class I{constructor(){this.f=!1,this.g=l.None,this.h=s.$kc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(v){this.g=v,this.f&&(this.h.dispose(),this.h=v(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=I}),define(te[22],ie([0,1,3]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const O=Object.freeze(function(S,h){const l=setTimeout(S.bind(h),0);return{dispose(){clearTimeout(l)}}});var s;(function(S){function h(l){return l===S.None||l===S.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}S.isCancellationToken=h,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new P.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$pd=D}),define(te[141],ie([0,1,22]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class O{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$pd,h=this.b(S.token);return this.a={promise:h,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$he=O;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const h=JSON.stringify(S);return this.b!==h&&(this.b=h,this.a=this.c(S)),this.a}}e.$ie=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const h=this.b(S);return this.a.set(S,h),h}}e.$je=M}),define(te[56],ie([0,1,14,2]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function s(E){const u=E;return u?typeof u.read=="function":!1}e.$qd=s;function M(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$rd=M;function D(E){const u=E;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$sd=D;function S(E,u){return new h(E,u)}e.$td=S;class h{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$Y)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let c;switch(u){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const r=c.indexOf(t);r>=0&&c.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(E,u){const t=[];let c;for(;(c=E.read())!==null;)t.push(c);return u(t)}e.$ud=l;function m(E,u,t){const c=[];let r;for(;(r=E.read())!==null&&c.length<t;)c.push(r);return r===null&&c.length>0?u(c):{read:()=>{if(c.length>0)return c.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}e.$vd=m;function b(E,u){return new Promise((t,c)=>{const r=[];p(E,{onData:i=>{u&&r.push(i)},onError:i=>{u?c(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.$wd=b;function p(E,u,t){E.on("error",c=>{t?.isCancellationRequested||u.onError(c)}),E.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),E.on("data",c=>{t?.isCancellationRequested||u.onData(c)})}e.$xd=p;function f(E,u){return new Promise((t,c)=>{const r=new O.$jc,i=[],n=I=>{if(i.push(I),i.length>u)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},a=I=>(r.dispose(),c(I)),k=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,O.$ic)(()=>E.removeListener("error",a))),E.on("error",a),r.add((0,O.$ic)(()=>E.removeListener("end",k))),E.on("end",k),r.add((0,O.$ic)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$yd=f;function y(E,u){const t=S(u);return t.end(E),t}e.$zd=y;function w(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$Ad=w;function d(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}e.$Bd=d;function g(E,u,t){const c=S(t);return p(E,{onData:r=>c.write(u.data(r)),onError:r=>c.error(u.error?u.error(r):r),onEnd:()=>c.end()}),c}e.$Cd=g;function o(E,u,t){let c=!1;return{read:()=>{const r=u.read();return c?r:(c=!0,r!==null?t([E,r]):E)}}}e.$Dd=o;function $(E,u,t){let c=!1;const r=S(t);return p(u,{onData:i=>c?r.write(i):(c=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{c||(c=!0,r.write(E)),r.end()}}),r}e.$Ed=$}),define(te[17],ie([0,1,84,56]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const s=typeof Buffer<"u",M=new P.$T(()=>new Uint8Array(256));let D,S;class h{static alloc(C){return s?new h(Buffer.allocUnsafe(C)):new h(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new h(C)}static fromString(C,L){return!(L?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(C)):(D||(D=new TextEncoder),new h(D.encode(C)))}static fromByteArray(C){const L=h.alloc(C.length);for(let U=0,B=C.length;U<B;U++)L.buffer[U]=C[U];return L}static concat(C,L){if(typeof L>"u"){L=0;for(let re=0,ee=C.length;re<ee;re++)L+=C[re].byteLength}const U=h.alloc(L);let B=0;for(let re=0,ee=C.length;re<ee;re++){const ae=C[re];U.set(ae,B),B+=ae.byteLength}return U}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=h.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(C,L){return new h(this.buffer.subarray(C,L))}set(C,L){if(C instanceof h)this.buffer.set(C.buffer,L);else if(C instanceof Uint8Array)this.buffer.set(C,L);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),L);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,L){f(this.buffer,C,L)}readUInt32LE(C){return y(this.buffer,C)}writeUInt32LE(C,L){w(this.buffer,C,L)}readUInt8(C){return d(this.buffer,C)}writeUInt8(C,L){g(this.buffer,C,L)}indexOf(C,L=0){return l(this.buffer,C instanceof h?C.buffer:C,L)}}e.$Fd=h;function l(v,C,L=0){const U=C.byteLength,B=v.byteLength;if(U===0)return 0;if(U===1)return v.indexOf(C[0]);if(U>B-L)return-1;const re=M.value;re.fill(C.length);for(let oe=0;oe<C.length;oe++)re[C[oe]]=C.length-oe-1;let ee=L+C.length-1,ae=ee,se=-1;for(;ee<B;)if(v[ee]===C[ae]){if(ae===0){se=ee;break}ee--,ae--}else ee+=Math.max(C.length-ae,re[v[ee]]),ae=C.length-1;return se}e.$Gd=l;function m(v,C){return v[C+0]<<0>>>0|v[C+1]<<8>>>0}e.$Hd=m;function b(v,C,L){v[L+0]=C&255,C=C>>>8,v[L+1]=C&255}e.$Id=b;function p(v,C){return v[C]*2**24+v[C+1]*2**16+v[C+2]*2**8+v[C+3]}e.$Jd=p;function f(v,C,L){v[L+3]=C,C=C>>>8,v[L+2]=C,C=C>>>8,v[L+1]=C,C=C>>>8,v[L]=C}e.$Kd=f;function y(v,C){return v[C+0]<<0>>>0|v[C+1]<<8>>>0|v[C+2]<<16>>>0|v[C+3]<<24>>>0}e.$Ld=y;function w(v,C,L){v[L+0]=C&255,C=C>>>8,v[L+1]=C&255,C=C>>>8,v[L+2]=C&255,C=C>>>8,v[L+3]=C&255}e.$Md=w;function d(v,C){return v[C]}e.$Nd=d;function g(v,C,L){v[L]=C}e.$Od=g;function o(v){return O.$ud(v,C=>h.concat(C))}e.$Pd=o;function $(v){return O.$Bd(v)}e.$Qd=$;function E(v){return O.$wd(v,C=>h.concat(C))}e.$Rd=E;async function u(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await E(v.stream)])}e.$Sd=u;function t(v){return O.$zd(v,C=>h.concat(C))}e.$Td=t;function c(v){return O.$Cd(v,{data:C=>typeof C=="string"?h.fromString(C):h.wrap(C)},C=>h.concat(C))}e.$Ud=c;function r(v){return O.$td(C=>h.concat(C),v)}e.$Vd=r;function i(v,C){return O.$Dd(v,C,L=>h.concat(L))}e.$Wd=i;function n(v,C){return O.$Ed(v,C,L=>h.concat(L))}e.$Xd=n;function a(v){let C=0,L=0,U=0;const B=new Uint8Array(Math.floor(v.length/4*3)),re=ae=>{switch(L){case 3:B[U++]=C|ae,L=0;break;case 2:B[U++]=C|ae>>>2,C=ae<<6,L=3;break;case 1:B[U++]=C|ae>>>4,C=ae<<4,L=2;break;default:C=ae<<2,L=1}};for(let ae=0;ae<v.length;ae++){const se=v.charCodeAt(ae);if(se>=65&&se<=90)re(se-65);else if(se>=97&&se<=122)re(se-97+26);else if(se>=48&&se<=57)re(se-48+52);else if(se===43||se===45)re(62);else if(se===47||se===95)re(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ae]}`)}}const ee=U;for(;L>0;)re(0);return h.wrap(B).slice(0,ee)}e.$Yd=a;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:v},C=!0,L=!1){const U=L?I:k;let B="";const re=v.byteLength%3;let ee=0;for(;ee<v.byteLength-re;ee+=3){const ae=v[ee+0],se=v[ee+1],oe=v[ee+2];B+=U[ae>>>2],B+=U[(ae<<4|se>>>4)&63],B+=U[(se<<2|oe>>>6)&63],B+=U[oe&63]}if(re===1){const ae=v[ee+0];B+=U[ae>>>2],B+=U[ae<<4&63],C&&(B+="==")}else if(re===2){const ae=v[ee+0],se=v[ee+1];B+=U[ae>>>2],B+=U[(ae<<4|se>>>4)&63],B+=U[se<<2&63],C&&(B+="=")}return B}e.$Zd=A}),define(te[26],ie([0,1,141,84]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function s(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$me=s;const M=/{(\d+)}/g;function D(Z,...he){return he.length===0?Z:Z.replace(M,function($e,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=he.length?$e:he[Ce]})}e.$ne=D;const S=/{([^}]+)}/g;function h(Z,he){return Z.replace(S,($e,ye)=>he[ye]??$e)}e.$oe=h;function l(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$pe=l;function m(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=m;function b(Z,he){let $e=0;const ye=he.charCodeAt(0);for(let Ce=Z.length-1;Ce>=0;Ce--)Z.charCodeAt(Ce)===ye&&$e++;return $e}e.$re=b;function p(Z,he,$e="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${$e}`}e.$se=p;function f(Z,he=" "){const $e=y(Z,he);return w($e,he)}e.$te=f;function y(Z,he){if(!Z||!he)return Z;const $e=he.length;if($e===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(he,ye)===ye;)ye=ye+$e;return Z.substring(ye)}e.$ue=y;function w(Z,he){if(!Z||!he)return Z;const $e=he.length,ye=Z.length;if($e===0||ye===0)return Z;let Ce=ye,Fe=-1;for(;Fe=Z.lastIndexOf(he,Ce-1),!(Fe===-1||Fe+$e!==Ce);){if(Fe===0)return"";Ce=Fe}return Z.substring(0,Ce)}e.$ve=w;function d(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=d;function g(Z){return Z.replace(/\*/g,"")}e.$xe=g;function o(Z,he,$e={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=m(Z)),$e.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(Z,ye)}e.$ye=o;function $(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$ze=$;function E(Z){return Z.split(/\r\n|\r|\n/)}e.$Ae=E;function u(Z){for(let he=0,$e=Z.length;he<$e;he++){const ye=Z.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.$Be=u;function t(Z,he=0,$e=Z.length){for(let ye=he;ye<$e;ye++){const Ce=Z.charCodeAt(ye);if(Ce!==32&&Ce!==9)return Z.substring(he,ye)}return Z.substring(he,$e)}e.$Ce=t;function c(Z,he=Z.length-1){for(let $e=he;$e>=0;$e--){const ye=Z.charCodeAt($e);if(ye!==32&&ye!==9)return $e}return-1}e.$De=c;function r(Z,he,$e){const ye=[];let Ce=0;for(const Fe of Z.matchAll(he)){if(ye.push(Z.slice(Ce,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Ce=Fe.index+Fe[0].length,ye.push($e(Fe[0],...Fe.slice(1),Fe.index,Z,Fe.groups))}return ye.push(Z.slice(Ce)),Promise.all(ye).then(Fe=>Fe.join(""))}e.$Ee=r;function i(Z,he){return Z<he?-1:Z>he?1:0}e.$Fe=i;function n(Z,he,$e=0,ye=Z.length,Ce=0,Fe=he.length){for(;$e<ye&&Ce<Fe;$e++,Ce++){const Be=Z.charCodeAt($e),qe=he.charCodeAt(Ce);if(Be<qe)return-1;if(Be>qe)return 1}const Le=ye-$e,Ne=Fe-Ce;return Le<Ne?-1:Le>Ne?1:0}e.$Ge=n;function a(Z,he){return k(Z,he,0,Z.length,0,he.length)}e.$He=a;function k(Z,he,$e=0,ye=Z.length,Ce=0,Fe=he.length){for(;$e<ye&&Ce<Fe;$e++,Ce++){let Be=Z.charCodeAt($e),qe=he.charCodeAt(Ce);if(Be===qe)continue;if(Be>=128||qe>=128)return n(Z.toLowerCase(),he.toLowerCase(),$e,ye,Ce,Fe);A(Be)&&(Be-=32),A(qe)&&(qe-=32);const He=Be-qe;if(He!==0)return He}const Le=ye-$e,Ne=Fe-Ce;return Le<Ne?-1:Le>Ne?1:0}e.$Ie=k;function I(Z){return Z>=48&&Z<=57}e.$Je=I;function A(Z){return Z>=97&&Z<=122}e.$Ke=A;function v(Z){return Z>=65&&Z<=90}e.$Le=v;function C(Z,he){return Z.length===he.length&&k(Z,he)===0}e.$Me=C;function L(Z,he){const $e=he.length;return he.length>Z.length?!1:k(Z,he,0,$e)===0}e.$Ne=L;function U(Z,he){const $e=Math.min(Z.length,he.length);let ye;for(ye=0;ye<$e;ye++)if(Z.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return $e}e.$Oe=U;function B(Z,he){const $e=Math.min(Z.length,he.length);let ye;const Ce=Z.length-1,Fe=he.length-1;for(ye=0;ye<$e;ye++)if(Z.charCodeAt(Ce-ye)!==he.charCodeAt(Fe-ye))return ye;return $e}e.$Pe=B;function re(Z){return 55296<=Z&&Z<=56319}e.$Qe=re;function ee(Z){return 56320<=Z&&Z<=57343}e.$Re=ee;function ae(Z,he){return(Z-55296<<10)+(he-56320)+65536}e.$Se=ae;function se(Z,he,$e){const ye=Z.charCodeAt($e);if(re(ye)&&$e+1<he){const Ce=Z.charCodeAt($e+1);if(ee(Ce))return ae(ye,Ce)}return ye}e.$Te=se;function oe(Z,he){const $e=Z.charCodeAt(he-1);if(ee($e)&&he>1){const ye=Z.charCodeAt(he-2);if(re(ye))return ae(ye,$e)}return $e}class G{get offset(){return this.e}constructor(he,$e=0){this.c=he,this.d=he.length,this.e=$e}setOffset(he){this.e=he}prevCodePoint(){const he=oe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=se(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$Ue=G;class K{get offset(){return this.c.offset}constructor(he,$e=0){this.c=new G(he,$e)}nextGraphemeLength(){const he=le.getInstance(),$e=this.c,ye=$e.offset;let Ce=he.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Fe=$e.offset,Le=he.getGraphemeBreakType($e.nextCodePoint());if(be(Ce,Le)){$e.setOffset(Fe);break}Ce=Le}return $e.offset-ye}prevGraphemeLength(){const he=le.getInstance(),$e=this.c,ye=$e.offset;let Ce=he.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Fe=$e.offset,Le=he.getGraphemeBreakType($e.prevCodePoint());if(be(Le,Ce)){$e.setOffset(Fe);break}Ce=Le}return ye-$e.offset}eol(){return this.c.eol()}}e.$Ve=K;function q(Z,he){return new K(Z,he).nextGraphemeLength()}e.$We=q;function F(Z,he){return new K(Z,he).prevGraphemeLength()}e.$Xe=F;function N(Z,he){he>0&&ee(Z.charCodeAt(he))&&he--;const $e=he+q(Z,he);return[$e-F(Z,$e),$e]}e.$Ye=N;function V(Z){const he=new K(Z);let $e=0;for(;!he.eol();)$e++,he.nextGraphemeLength();return $e}e.$Ze=V;let X;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(Z){return X||(X=x()),X.test(Z)}e.$1e=ce;const Y=/^[\t\n\r\x20-\x7E]*$/;function R(Z){return Y.test(Z)}e.$2e=R,e.$3e=/[\u2028\u2029]/;function j(Z){return e.$3e.test(Z)}e.$4e=j;function W(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$5e=W;function T(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$6e=T;function H(Z,he){if(Z.length<he)return Z;const $e=/\b/g;let ye=0;for(;$e.test(Z)&&!(Z.length-$e.lastIndex<he);)ye=$e.lastIndex,$e.lastIndex+=1;return Z.substring(ye).replace(/^\s/,"")}e.$7e=H;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function fe(Z){return Z&&(Z=Z.replace(z,"").replace(ne,"")),Z}e.$8e=fe,e.$9e=String.fromCharCode(65279);function ge(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$0e=ge;function ue(Z){return ge(Z)?Z.substr(1):Z}e.$$e=ue;function we(Z,he){if(!Z||!he||Z.length<he.length)return!1;const $e=he.length,ye=Z.toLowerCase();let Ce=0,Fe=-1;for(;Ce<$e;){const Le=ye.indexOf(he[Ce],Fe+1);if(Le<0)return!1;Fe=Le,Ce++}return!0}e.$_e=we;function me(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$af=me;function Se(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$bf=Se;function Ie(Z,he=1){if(he===0)return"";let $e=-1;do $e=Z.indexOf(`
`,$e+1),he--;while(he>0&&$e>=0);return $e===-1?Z:(Z[$e-1]==="\r"&&$e--,Z.substr(0,$e))}e.$cf=Ie;function je(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$df=je;function ve(Z){return le.getInstance().getGraphemeBreakType(Z)}e.$ef=ve;function be(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var Q;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Q||(e.GraphemeBreakType=Q={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=de()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const $e=this.d,ye=$e.length/3;let Ce=1;for(;Ce<=ye;)if(he<$e[3*Ce])Ce=2*Ce;else if(he>$e[3*Ce+1])Ce=2*Ce+1;else return $e[3*Ce+2];return 0}}function de(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Z,he){if(Z===0)return 0;const $e=Re(Z,he);if($e!==void 0)return $e;const ye=new G(he,Z);return ye.prevCodePoint(),ye.offset}e.$ff=Ee;function Re(Z,he){const $e=new G(he,Z);let ye=$e.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!T(ye))return;let Ce=$e.offset;return Ce>0&&$e.prevCodePoint()===8205&&(Ce=$e.offset),Ce}function Ue(Z){return 127995<=Z&&Z<=127999}var Oe;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$gf="\xA0";class ze{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$ie(he=>{function $e(He){const xe=new Map;for(let Xe=0;Xe<He.length;Xe+=2)xe.set(He[Xe],He[Xe+1]);return xe}function ye(He,xe){const Xe=new Map(He);for(const[tt,nt]of xe)Xe.set(tt,nt);return Xe}function Ce(He,xe){if(!He)return xe;const Xe=new Map;for(const[tt,nt]of He)xe.has(tt)&&Xe.set(tt,nt);return Xe}const Fe=this.c.value;let Le=he.filter(He=>!He.startsWith("_")&&He in Fe);Le.length===0&&(Le=["_default"]);let Ne;for(const He of Le){const xe=$e(Fe[He]);Ne=Ce(Ne,xe)}const Be=$e(Fe._common),qe=ye(Be,Ne);return new ze(qe)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new O.$T(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$if=We}),define(te[57],ie([0,1,26]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function O(g){return s(g,0)}e.$pi=O;function s(g,o){switch(typeof g){case"object":return g===null?M(349,o):Array.isArray(g)?h(g,o):l(g,o);case"string":return S(g,o);case"boolean":return D(g,o);case"number":return M(g,o);case"undefined":return M(937,o);default:return M(617,o)}}e.$qi=s;function M(g,o){return(o<<5)-o+g|0}e.$ri=M;function D(g,o){return M(g?433:863,o)}function S(g,o){o=M(149417,o);for(let $=0,E=g.length;$<E;$++)o=M(g.charCodeAt($),o);return o}e.$si=S;function h(g,o){return o=M(104579,o),g.reduce(($,E)=>s(E,$),o)}function l(g,o){return o=M(181387,o),Object.keys(g).sort().reduce(($,E)=>($=S(E,$),s(g[E],$)),o)}class m{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=s(o,this.g),this.g}}e.$ti=m;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function p(g,o,$=32){const E=$-o,u=~((1<<E)-1);return(g<<o|(u&g)>>>E)>>>0}function f(g,o=0,$=g.byteLength,E=0){for(let u=0;u<$;u++)g[o+u]=E}function y(g,o,$="0"){for(;g.length<o;)g=$+g;return g}function w(g,o=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map($=>$.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),o/4)}e.$ui=w;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const $=o.length;if($===0)return;const E=this.p;let u=this.r,t=this.u,c,r;for(t!==0?(c=t,r=-1,t=0):(c=o.charCodeAt(0),r=0);;){let i=c;if(P.$Qe(c))if(r+1<$){const n=o.charCodeAt(r+1);P.$Re(n)?(r++,i=P.$Se(c,n)):i=65533}else{t=c;break}else P.$Re(c)&&(i=65533);if(u=this.w(E,u,i),r++,r<$)c=o.charCodeAt(r);else break}this.r=u,this.u=t}w(o,$,E){return E<128?o[$++]=E:E<2048?(o[$++]=192|(E&1984)>>>6,o[$++]=128|(E&63)>>>0):E<65536?(o[$++]=224|(E&61440)>>>12,o[$++]=128|(E&4032)>>>6,o[$++]=128|(E&63)>>>0):(o[$++]=240|(E&1835008)>>>18,o[$++]=128|(E&258048)>>>12,o[$++]=128|(E&4032)>>>6,o[$++]=128|(E&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=d.g,$=this.q;for(let k=0;k<64;k+=4)o.setUint32(k,$.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)o.setUint32(k,p(o.getUint32(k-12,!1)^o.getUint32(k-32,!1)^o.getUint32(k-56,!1)^o.getUint32(k-64,!1),1),!1);let E=this.h,u=this.l,t=this.m,c=this.n,r=this.o,i,n,a;for(let k=0;k<80;k++)k<20?(i=u&t|~u&c,n=1518500249):k<40?(i=u^t^c,n=1859775393):k<60?(i=u&t|u&c|t&c,n=2400959708):(i=u^t^c,n=3395469782),a=p(E,5)+i+r+n+o.getUint32(k*4,!1)&4294967295,r=c,c=t,t=p(u,30),u=E,E=a;this.h=this.h+E&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+r&4294967295}}e.$vi=d}),define(te[70],ie([0,1,26]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(O||(O={})),function(s){const M="error",D="warning",S="warn",h="info",l="ignore";function m(p){return p?P.$Me(M,p)?s.Error:P.$Me(D,p)||P.$Me(S,p)?s.Warning:P.$Me(h,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function b(p){switch(p){case s.Error:return M;case s.Warning:return D;case s.Info:return h;default:return l}}s.toString=b}(O||(O={})),e.default=O}),define(te[142],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,23,26]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const y=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.$Dh=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,O.$Ge)(f,this.b,0,f.length,this.c,this.d):(0,O.$Ie)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=M;class D{constructor(f=!0,y=!0){this.f=f,this.g=y}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let y=f.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,O.$Ge)(f,this.b,0,f.length,this.d,this.e):(0,O.$Ie)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=D;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(f,y){this.f=f,this.g=y,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,O.$He)(f,this.c.scheme);if(this.d[this.e]===2)return(0,O.$He)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,O.$Fe)(f,this.c.query);if(this.d[this.e]===5)return(0,O.$Fe)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(m||(m={}));class b{static forUris(f=()=>!1,y=()=>!1){return new b(new h(f,y))}static forPaths(f=!1){return new b(new D(void 0,!f))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,y){if(y){const w=y.slice(0);(0,P.$Vb)(w);for(const d of w)this.set(d,f)}else{const w=f.slice(0);(0,P.$Vb)(w);for(const d of w)this.set(d[0],d[1])}}set(f,y){const w=this.b.reset(f);let d;this.c||(this.c=new l,this.c.segment=w.value());const g=[];for(d=this.c;;){const $=w.cmp(d.segment);if($>0)d.left||(d.left=new l,d.left.segment=w.value()),g.push([-1,d]),d=d.left;else if($<0)d.right||(d.right=new l,d.right.segment=w.value()),g.push([1,d]),d=d.right;else if(w.hasNext())w.next(),d.mid||(d.mid=new l,d.mid.segment=w.value()),g.push([0,d]),d=d.mid;else break}const o=d.value;d.value=y,d.key=f;for(let $=g.length-1;$>=0;$--){const E=g[$][1];E.updateHeight();const u=E.balanceFactor();if(u<-1||u>1){const t=g[$][0],c=g[$+1][0];if(t===1&&c===1)g[$][1]=E.rotateLeft();else if(t===-1&&c===-1)g[$][1]=E.rotateRight();else if(t===1&&c===-1)E.right=g[$+1][1]=g[$+1][1].rotateRight(),g[$][1]=E.rotateLeft();else if(t===-1&&c===1)E.left=g[$+1][1]=g[$+1][1].rotateLeft(),g[$][1]=E.rotateRight();else throw new Error;if($>0)switch(g[$-1][0]){case-1:g[$-1][1].left=g[$][1];break;case 1:g[$-1][1].right=g[$][1];break;case 0:g[$-1][1].mid=g[$][1];break}else this.c=g[0][1]}}return o}get(f){return this.d(f)?.value}d(f){const y=this.b.reset(f);let w=this.c;for(;w;){const d=y.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(f){const y=this.d(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,y){const w=this.b.reset(f),d=[];let g=this.c;for(;g;){const o=w.cmp(g.segment);if(o>0)d.push([-1,g]),g=g.left;else if(o<0)d.push([1,g]),g=g.right;else if(w.hasNext())w.next(),d.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const o=this.f(g.right);if(o.key){const{key:$,value:E,segment:u}=o;this.e(o.key,!1),g.key=$,g.value=E,g.segment=u}}else{const o=g.left??g.right;if(d.length>0){const[$,E]=d[d.length-1];switch($){case-1:E.left=o;break;case 0:E.mid=o;break;case 1:E.right=o;break}}else this.c=o}for(let o=d.length-1;o>=0;o--){const $=d[o][1];$.updateHeight();const E=$.balanceFactor();if(E>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),d[o][1]=$.rotateLeft()):E<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),d[o][1]=$.rotateRight()),o>0)switch(d[o-1][0]){case-1:d[o-1][1].left=d[o][1];break;case 1:d[o-1][1].right=d[o][1];break;case 0:d[o-1][1].mid=d[o][1];break}else this.c=d[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this.b.reset(f);let w=this.c,d;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),d=w.value||d,w=w.mid;else break}return w&&w.value||d}findSuperstr(f){return this.g(f,!1)}g(f,y){const w=this.b.reset(f);let d=this.c;for(;d;){const g=w.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else return d.mid?this.h(d.mid):y?d.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[y,w]of this)f(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const y=[];return this.j(f,y),y[Symbol.iterator]()}j(f,y){f&&(f.left&&this.j(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this.j(f.mid,y),f.right&&this.j(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:f(y.left)&&f(y.right)};return f(this.c)}}e.$Hh=b}),define(te[12],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function P(u){return typeof u=="string"}e.$jf=P;function O(u){return Array.isArray(u)&&u.every(t=>P(t))}e.$kf=O;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$lf=s;function M(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$mf=M;function D(u){return typeof u=="number"&&!isNaN(u)}e.$nf=D;function S(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$of=S;function h(u){return u===!0||u===!1}e.$pf=h;function l(u){return typeof u>"u"}e.$qf=l;function m(u){return!b(u)}e.$rf=m;function b(u){return l(u)||u===null}e.$sf=b;function p(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$tf=p;function f(u){if(b(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$uf=f;function y(...u){const t=[];for(let c=0;c<u.length;c++){const r=u[c];if(b(r))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(r)}return t}e.$vf=y;const w=Object.prototype.hasOwnProperty;function d(u){if(!s(u))return!1;for(const t in u)if(w.call(u,t))return!1;return!0}e.$wf=d;function g(u){return typeof u=="function"}e.$xf=g;function o(...u){return u.length>0&&u.every(g)}e.$yf=o;function $(u,t){const c=Math.min(u.length,t.length);for(let r=0;r<c;r++)E(u[r],t[r])}e.$zf=$;function E(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(u instanceof t)return}catch{}if(!b(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=E}),define(te[71],ie([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=void 0;const O=Object.create(null);function s(S,h){if((0,P.$jf)(h)){const l=O[h];if(l===void 0)throw new Error(`${S} references an unknown codicon: ${h}`);h=l}return O[S]=h,{id:S}}function M(){return O}e.$Nj=M;function D(){return Object.values(e.$Pj)}e.$Oj=D,e.$Pj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function O(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const o=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([$,E])=>{o[$]=E&&typeof E=="object"?O(E):E}),o}e.$Vm=O;function s(g){if(!g||typeof g!="object")return g;const o=[g];for(;o.length>0;){const $=o.shift();Object.freeze($);for(const E in $)if(M.call($,E)){const u=$[E];typeof u=="object"&&!Object.isFrozen(u)&&!(0,P.$mf)(u)&&o.push(u)}}return g}e.$Wm=s;const M=Object.prototype.hasOwnProperty;function D(g,o){return S(g,o,new Set)}e.$Xm=D;function S(g,o,$){if((0,P.$sf)(g))return g;const E=o(g);if(typeof E<"u")return E;if(Array.isArray(g)){const u=[];for(const t of g)u.push(S(t,o,$));return u}if((0,P.$lf)(g)){if($.has(g))throw new Error("Cannot clone recursive data-structure");$.add(g);const u={};for(const t in g)M.call(g,t)&&(u[t]=S(g[t],o,$));return $.delete(g),u}return g}function h(g,o,$=!0){return(0,P.$lf)(g)?((0,P.$lf)(o)&&Object.keys(o).forEach(E=>{E in g?$&&((0,P.$lf)(g[E])&&(0,P.$lf)(o[E])?h(g[E],o[E],$):g[E]=o[E]):g[E]=o[E]}),g):o}e.$Ym=h;function l(g,o){if(g===o)return!0;if(g==null||o===null||o===void 0||typeof g!=typeof o||typeof g!="object"||Array.isArray(g)!==Array.isArray(o))return!1;let $,E;if(Array.isArray(g)){if(g.length!==o.length)return!1;for($=0;$<g.length;$++)if(!l(g[$],o[$]))return!1}else{const u=[];for(E in g)u.push(E);u.sort();const t=[];for(E in o)t.push(E);if(t.sort(),!l(u,t))return!1;for($=0;$<u.length;$++)if(!l(g[u[$]],o[u[$]]))return!1}return!0}e.$Zm=l;function m(g){const o=new Set;return JSON.stringify(g,($,E)=>{if((0,P.$lf)(E)||Array.isArray(E)){if(o.has(E))return"[Circular]";o.add(E)}return E})}e.$1m=m;function b(g,o){const $=Object.create(null);return!g||!o||Object.keys(o).forEach(u=>{const t=g[u],c=o[u];l(t,c)||($[u]=c)}),$}e.$2m=b;function p(g,o){const $=o.toLowerCase(),E=Object.keys(g).find(u=>u.toLowerCase()===$);return E?g[E]:g[o]}e.$3m=p;function f(g,o){const $=Object.create(null);for(const[E,u]of Object.entries(g))o(E,u)&&($[E]=u);return $}e.$4m=f;function y(g){let o=[];for(;Object.prototype!==g;)o=o.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return o}e.$5m=y;function w(g){const o=[];for(const $ of y(g))typeof g[$]=="function"&&o.push($);return o}e.$6m=w;function d(g,o){const $=u=>function(){const t=Array.prototype.slice.call(arguments,0);return o(u,t)},E={};for(const u of g)E[u]=$(u);return E}e.$7m=d}),define(te[102],ie([0,1,71]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var O;(function(D){function S(h){return h&&typeof h=="object"&&typeof h.id=="string"}D.isThemeColor=S})(O||(e.ThemeColor=O={}));function s(D){return{id:D}}e.$Qj=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(o){const $=S.exec(o.id);if(!$)return h(P.$Pj.error);const[,E,u]=$,t=["codicon","codicon-"+E];return u&&t.push("codicon-modifier-"+u.substring(1)),t}D.asClassNameArray=h;function l(o){return h(o).join(" ")}D.asClassName=l;function m(o){return"."+h(o).join(".")}D.asCSSSelector=m;function b(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||O.isThemeColor(o.color))}D.isThemeIcon=b;const p=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(o){const $=p.exec(o);if(!$)return;const[,E]=$;return{id:E}}D.fromString=f;function y(o){return{id:o}}D.fromId=y;function w(o,$){let E=o.id;const u=E.lastIndexOf("~");return u!==-1&&(E=E.substring(0,u)),$&&(E=`${E}~${$}`),{id:E}}D.modify=w;function d(o){const $=o.id.lastIndexOf("~");if($!==-1)return o.id.substring($+1)}D.getModifier=d;function g(o,$){return o.id===$.id&&o.color?.id===$.color?.id}D.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(s){return P.test(s)}e.$3f=O,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let h=0;h<S.length;h++)S[h]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,l="";return l+=D[M[h++]],l+=D[M[h++]],l+=D[M[h++]],l+=D[M[h++]],l+="-",l+=D[M[h++]],l+=D[M[h++]],l+="-",l+=D[M[h++]],l+=D[M[h++]],l+="-",l+=D[M[h++]],l+=D[M[h++]],l+="-",l+=D[M[h++]],l+=D[M[h++]],l+=D[M[h++]],l+=D[M[h++]],l+=D[M[h++]],l+=D[M[h++]],l}}()}),define(te[143],ie([0,1,72,45,49]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NS=void 0;async function M(D,S){if(await new Promise((m,b)=>{const p=O.createReadStream(D),f=P.createHash("sha1");p.pipe(f);const y=(0,s.$bb)((w,d)=>{p.removeAllListeners(),f.removeAllListeners(),w?b(w):m(d)});p.once("error",y),p.once("end",y),f.once("error",y),f.once("data",w=>y(void 0,w.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$NS=M}),define(te[144],ie([0,1,27]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!O.has(S)}function M(){const D=(0,P.networkInterfaces)();for(const S in D){const h=D[S];if(h){for(const{mac:l}of h)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=M}),define(te[86],ie([0,1,27,58,31,144]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(l){return this.a||(this.a=O.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,m=0;const b=(0,P.networkInterfaces)();for(const p in b){const f=b[p];if(f)for(const{mac:y,internal:w}of f)w||(m+=1,this.c(y.toUpperCase())&&(l+=1))}this.b=m>0?l/m:0}return this.b}};let D;async function S(l){return D||(D=(async()=>await h(l)||s.$4f())()),D}e.$Im=S;async function h(l){try{const m=await new Promise((p,f)=>{J(["crypto"],p,f)}),b=(0,M.$Gm)();return m.createHash("sha256").update(b,"utf8").digest("hex")}catch(m){l(m);return}}}),define(te[103],ie([0,1,87]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function O(S,h,l,m=1){let b=!1;return new Promise(p=>{const f=setTimeout(()=>{if(!b)return b=!0,p(0)},l);s(S,h,m,y=>{if(!b)return b=!0,clearTimeout(f),p(y)})})}e.$6f=O;function s(S,h,l,m){if(h===0)return m(0);const b=new P.Socket;b.once("connect",()=>(D(b),s(S+l,h-1,l,m))),b.once("data",()=>{}),b.once("error",p=>(D(b),p.code!=="ECONNREFUSED"?s(S+l,h-1,l,m):m(S))),b.connect(S,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,h,l,m="127.0.0.1"){let b=!1,p,f=1;const y=P.createServer({pauseOnConnect:!0});function w(d,g){b||(b=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),g(d))}return new Promise(d=>{p=setTimeout(()=>{w(0,d)},l),y.on("listening",()=>{w(S,d)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<h?(S++,f++,y.listen(S,m)):w(0,d)}),y.on("close",()=>{w(0,d)}),y.listen(S,m)})}e.$8f=M;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(h){console.error(h)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function P(h){const l=new Set;if(Array.isArray(h))for(const m of h)typeof m=="string"&&l.add(m);return Array.from(l)}function O(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const m of P(h))s(m)}function M(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const b of l){if(h.indexOf(b)!==0)continue;const f=h.indexOf("\\",b.length);if(f===-1)continue;const y=h.substring(b.length,f);if(y){m=y;break}}return m}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[145],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RS=e.$QS=void 0,e.$QS="vscode:contextmenu",e.$RS="vscode:onCloseContextMenu"}),define(te[146],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YS=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$YS=P}),define(te[38],ie([0,1,15,14]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SS=void 0;class s{constructor(){this.a=new WeakMap}on(D,S){const h=(l,...m)=>{this.b(D,l)&&S(l,...m)};return this.a.set(S,h),P.ipcMain.on(D,h),this}once(D,S){return P.ipcMain.once(D,(h,...l)=>{this.b(D,h)&&S(h,...l)}),this}handle(D,S){return P.ipcMain.handle(D,(h,...l)=>this.b(D,h)?S(h,...l):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return P.ipcMain.removeHandler(D),this}removeListener(D,S){const h=this.a.get(S);return h&&(P.ipcMain.removeListener(D,h),this.a.delete(S)),this}b(D,S){if(!D||!D.startsWith("vscode:"))return(0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=S.senderFrame,l=h.url;if(!l||l==="about:blank")return!0;let m="unknown";try{m=new URL(l).host}catch{return(0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${l}'.`),!1}return m!=="vscode-app"?((0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${m}'.`),!1):h.parent!==null?((0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.$SS=new s}),define(te[147],ie([0,1,15,38,145]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TS=void 0;function M(){O.$SS.on(s.$QS,(S,h,l,m,b)=>{const p=D(S,m,l);p.popup({window:P.BrowserWindow.fromWebContents(S.sender)??void 0,x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{p&&S.sender.send(s.$RS,h)}})})}e.$TS=M;function D(S,h,l){const m=new P.Menu;return l.forEach(b=>{let p;b.type==="separator"?p=new P.MenuItem({type:b.type}):Array.isArray(b.submenu)?p=new P.MenuItem({submenu:D(S,h,b.submenu),label:b.label}):p=new P.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(f,y,w)=>S.sender.send(h,b.id,w)}),m.append(p)}),m}}),define(te[148],ie([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[149],ie([0,1,148]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const O=60,s=O*60,M=s*24,D=M*7,S=M*30,h=M*365;function l(b,p,f,y){typeof b!="number"&&(b=b.getTime());const w=Math.round((new Date().getTime()-b)/1e3);if(w<-30)return(0,P.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,P.localize)(1,null);let d;return w<O?(d=w,p?d===1?f?(0,P.localize)(2,null,d):(0,P.localize)(3,null,d):f?(0,P.localize)(4,null,d):(0,P.localize)(5,null,d):d===1?f?(0,P.localize)(6,null,d):(0,P.localize)(7,null,d):f?(0,P.localize)(8,null,d):(0,P.localize)(9,null,d)):w<s?(d=Math.floor(w/O),p?d===1?f?(0,P.localize)(10,null,d):(0,P.localize)(11,null,d):f?(0,P.localize)(12,null,d):(0,P.localize)(13,null,d):d===1?f?(0,P.localize)(14,null,d):(0,P.localize)(15,null,d):f?(0,P.localize)(16,null,d):(0,P.localize)(17,null,d)):w<M?(d=Math.floor(w/s),p?d===1?f?(0,P.localize)(18,null,d):(0,P.localize)(19,null,d):f?(0,P.localize)(20,null,d):(0,P.localize)(21,null,d):d===1?f?(0,P.localize)(22,null,d):(0,P.localize)(23,null,d):f?(0,P.localize)(24,null,d):(0,P.localize)(25,null,d)):w<D?(d=Math.floor(w/M),p?d===1?(0,P.localize)(26,null,d):(0,P.localize)(27,null,d):d===1?(0,P.localize)(28,null,d):(0,P.localize)(29,null,d)):w<S?(d=Math.floor(w/D),p?d===1?f?(0,P.localize)(30,null,d):(0,P.localize)(31,null,d):f?(0,P.localize)(32,null,d):(0,P.localize)(33,null,d):d===1?f?(0,P.localize)(34,null,d):(0,P.localize)(35,null,d):f?(0,P.localize)(36,null,d):(0,P.localize)(37,null,d)):w<h?(d=Math.floor(w/S),p?d===1?f?(0,P.localize)(38,null,d):(0,P.localize)(39,null,d):f?(0,P.localize)(40,null,d):(0,P.localize)(41,null,d):d===1?f?(0,P.localize)(42,null,d):(0,P.localize)(43,null,d):f?(0,P.localize)(44,null,d):(0,P.localize)(45,null,d)):(d=Math.floor(w/h),p?d===1?f?(0,P.localize)(46,null,d):(0,P.localize)(47,null,d):f?(0,P.localize)(48,null,d):(0,P.localize)(49,null,d):d===1?f?(0,P.localize)(50,null,d):(0,P.localize)(51,null,d):f?(0,P.localize)(52,null,d):(0,P.localize)(53,null,d))}e.$6l=l;function m(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=m}),define(te[150],ie([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,23,12,150]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function M(b,p){return p&&(b.stack||b.stacktrace)?s.localize(0,null,S(b),D(b.stack)||D(b.stacktrace)):S(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function S(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function h(b=null,p=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const f=P.$Fb(b),y=h(f[0],p);return f.length>1?s.localize(4,null,y,f.length):y}if(O.$jf(b))return b;if(b.detail){const f=b.detail;if(f.error)return M(f.error,p);if(f.exception)return M(f.exception,p)}return b.stack?M(b,p):b.message?b.message:s.localize(5,null)}e.$mi=h;function l(b){const p=b;return p instanceof Error&&Array.isArray(p.actions)}e.$ni=l;function m(b,p){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=p,f}e.$oi=m}),define(te[151],ie([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[152],ie([0,1,151]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function O(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$mp=O}),define(te[153],ie([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,153]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,s=!1,M=!1,D=!1,S=!1,h=!1,l=!1,m=!1,b=!1,p=!1,f,y=e.$f,w=e.$f,d,g;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?o=e.$g.vscode.process:typeof process<"u"&&(o=process);const $=typeof o?.versions?.electron=="string",E=$&&o?.type==="renderer";if(typeof navigator=="object"&&!E)g=navigator.userAgent,O=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,h=!0,f=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$f,y=f,w=navigator.language;else if(typeof o=="object"){O=o.platform==="win32",s=o.platform==="darwin",M=o.platform==="linux",D=M&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,l=$,b=!!o.env.CI||!!o.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$f,y=e.$f;const I=o.env.VSCODE_NLS_CONFIG;if(I)try{const A=JSON.parse(I),v=A.availableLanguages["*"];f=A.locale,w=A.osLocale,y=v||e.$f,d=A._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var u;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let c=0;s?c=1:O?c=3:M&&(c=2),e.$i=O,e.$j=s,e.$k=M,e.$l=D,e.$m=S,e.$n=l,e.$o=h,e.$p=h&&typeof e.$g.importScripts=="function",e.$q=m,e.$r=p,e.$s=b,e.$t=c,e.$u=g,e.$v=y;var r;(function(I){function A(){return e.$v}I.value=A;function v(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}I.isDefaultVariant=v;function C(){return e.$v==="en"}I.isDefault=C})(r||(e.Language=r={})),e.$w=f,e.$x=w,e.$y=d,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const I=[];e.$g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,L=I.length;C<L;C++){const U=I[C];if(U.id===v.data.vscodeScheduleAsyncWork){I.splice(C,1),U.callback();return}}});let A=0;return v=>{const C=++A;I.push({id:C,callback:v}),e.$g.postMessage({vscodeScheduleAsyncWork:C},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||m?2:O?1:3;let n=!0,a=!1;function k(){if(!a){a=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,n=new Uint16Array(I.buffer)[0]===(2<<8)+1}return n}e.$C=k,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let O;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.process<"u"){const s=P.$g.vscode.process;O={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$3d=O.platform,e.$4d=O.arch}),define(te[9],ie([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const O=65,s=97,M=90,D=122,S=46,h=47,l=92,m=58,b=63;class p extends Error{constructor(c,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=c.indexOf(".")!==-1?"property":"argument";let k=`The "${c}" ${a} ${n} of type ${r}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,c){if(t===null||typeof t!="object")throw new p(c,"Object",t)}function y(t,c){if(typeof t!="string")throw new p(c,"string",t)}const w=P.$3d==="win32";function d(t){return t===h||t===l}function g(t){return t===h}function o(t){return t>=O&&t<=M||t>=s&&t<=D}function $(t,c,r,i){let n="",a=0,k=-1,I=0,A=0;for(let v=0;v<=t.length;++v){if(v<t.length)A=t.charCodeAt(v);else{if(i(A))break;A=h}if(i(A)){if(!(k===v-1||I===1))if(I===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",a=0):(n=n.slice(0,C),a=n.length-1-n.lastIndexOf(r)),k=v,I=0;continue}else if(n.length!==0){n="",a=0,k=v,I=0;continue}}c&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(k+1,v)}`:n=t.slice(k+1,v),a=v-k-1;k=v,I=0}else A===S&&I!==-1?++I:I=-1}return n}function E(t,c){f(c,"pathObject");const r=c.dir||c.root,i=c.base||`${c.name||""}${c.ext||""}`;return r?r===c.root?`${r}${i}`:`${r}${t}${i}`:i}e.$5d={resolve(...t){let c="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],y(a,"path"),a.length===0)continue}else c.length===0?a=P.cwd():(a=P.env[`=${c}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==c.toLowerCase()&&a.charCodeAt(2)===l)&&(a=`${c}\\`));const k=a.length;let I=0,A="",v=!1;const C=a.charCodeAt(0);if(k===1)d(C)&&(I=1,v=!0);else if(d(C))if(v=!0,d(a.charCodeAt(1))){let L=2,U=L;for(;L<k&&!d(a.charCodeAt(L));)L++;if(L<k&&L!==U){const B=a.slice(U,L);for(U=L;L<k&&d(a.charCodeAt(L));)L++;if(L<k&&L!==U){for(U=L;L<k&&!d(a.charCodeAt(L));)L++;(L===k||L!==U)&&(A=`\\\\${B}\\${a.slice(U,L)}`,I=L)}}}else I=1;else o(C)&&a.charCodeAt(1)===m&&(A=a.slice(0,2),I=2,k>2&&d(a.charCodeAt(2))&&(v=!0,I=3));if(A.length>0)if(c.length>0){if(A.toLowerCase()!==c.toLowerCase())continue}else c=A;if(i){if(c.length>0)break}else if(r=`${a.slice(I)}\\${r}`,i=v,v&&c.length>0)break}return r=$(r,!i,"\\",d),i?`${c}\\${r}`:`${c}${r}`||"."},normalize(t){y(t,"path");const c=t.length;if(c===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(c===1)return g(a)?"\\":t;if(d(a))if(n=!0,d(t.charCodeAt(1))){let I=2,A=I;for(;I<c&&!d(t.charCodeAt(I));)I++;if(I<c&&I!==A){const v=t.slice(A,I);for(A=I;I<c&&d(t.charCodeAt(I));)I++;if(I<c&&I!==A){for(A=I;I<c&&!d(t.charCodeAt(I));)I++;if(I===c)return`\\\\${v}\\${t.slice(A)}\\`;I!==A&&(i=`\\\\${v}\\${t.slice(A,I)}`,r=I)}}}else r=1;else o(a)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),r=2,c>2&&d(t.charCodeAt(2))&&(n=!0,r=3));let k=r<c?$(t.slice(r),!n,"\\",d):"";return k.length===0&&!n&&(k="."),k.length>0&&d(t.charCodeAt(c-1))&&(k+="\\"),i===void 0?n?`\\${k}`:k:n?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){y(t,"path");const c=t.length;if(c===0)return!1;const r=t.charCodeAt(0);return d(r)||c>2&&o(r)&&t.charCodeAt(1)===m&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,r;for(let a=0;a<t.length;++a){const k=t[a];y(k,"path"),k.length>0&&(c===void 0?c=r=k:c+=`\\${k}`)}if(c===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++n;const a=r.length;a>1&&d(r.charCodeAt(1))&&(++n,a>2&&(d(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<c.length&&d(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.$5d.normalize(c)},relative(t,c){if(y(t,"from"),y(c,"to"),t===c)return"";const r=e.$5d.resolve(t),i=e.$5d.resolve(c);if(r===i||(t=r.toLowerCase(),c=i.toLowerCase(),t===c))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===l;)a--;const k=a-n;let I=0;for(;I<c.length&&c.charCodeAt(I)===l;)I++;let A=c.length;for(;A-1>I&&c.charCodeAt(A-1)===l;)A--;const v=A-I,C=k<v?k:v;let L=-1,U=0;for(;U<C;U++){const re=t.charCodeAt(n+U);if(re!==c.charCodeAt(I+U))break;re===l&&(L=U)}if(U!==C){if(L===-1)return i}else{if(v>C){if(c.charCodeAt(I+U)===l)return i.slice(I+U+1);if(U===2)return i.slice(I+U)}k>C&&(t.charCodeAt(n+U)===l?L=U:U===2&&(L=3)),L===-1&&(L=0)}let B="";for(U=n+L+1;U<=a;++U)(U===a||t.charCodeAt(U)===l)&&(B+=B.length===0?"..":"\\..");return I+=L,B.length>0?`${B}${i.slice(I,A)}`:(i.charCodeAt(I)===l&&++I,i.slice(I,A))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$5d.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===l){if(c.charCodeAt(1)===l){const r=c.charCodeAt(2);if(r!==b&&r!==S)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(o(c.charCodeAt(0))&&c.charCodeAt(1)===m&&c.charCodeAt(2)===l)return`\\\\?\\${c}`;return t},dirname(t){y(t,"path");const c=t.length;if(c===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(c===1)return d(n)?t:".";if(d(n)){if(r=i=1,d(t.charCodeAt(1))){let I=2,A=I;for(;I<c&&!d(t.charCodeAt(I));)I++;if(I<c&&I!==A){for(A=I;I<c&&d(t.charCodeAt(I));)I++;if(I<c&&I!==A){for(A=I;I<c&&!d(t.charCodeAt(I));)I++;if(I===c)return t;I!==A&&(r=i=I+1)}}}}else o(n)&&t.charCodeAt(1)===m&&(r=c>2&&d(t.charCodeAt(2))?3:2,i=r);let a=-1,k=!0;for(let I=c-1;I>=i;--I)if(d(t.charCodeAt(I))){if(!k){a=I;break}}else k=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,c){c!==void 0&&y(c,"ext"),y(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&o(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(r=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let k=c.length-1,I=-1;for(a=t.length-1;a>=r;--a){const A=t.charCodeAt(a);if(d(A)){if(!n){r=a+1;break}}else I===-1&&(n=!1,I=a+1),k>=0&&(A===c.charCodeAt(k)?--k===-1&&(i=a):(k=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if(d(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let c=0,r=-1,i=0,n=-1,a=!0,k=0;t.length>=2&&t.charCodeAt(1)===m&&o(t.charCodeAt(0))&&(c=i=2);for(let I=t.length-1;I>=c;--I){const A=t.charCodeAt(I);if(d(A)){if(!a){i=I+1;break}continue}n===-1&&(a=!1,n=I+1),A===S?r===-1?r=I:k!==1&&(k=1):r!==-1&&(k=-1)}return r===-1||n===-1||k===0||k===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){y(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return d(n)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(d(n)){if(i=1,d(t.charCodeAt(1))){let L=2,U=L;for(;L<r&&!d(t.charCodeAt(L));)L++;if(L<r&&L!==U){for(U=L;L<r&&d(t.charCodeAt(L));)L++;if(L<r&&L!==U){for(U=L;L<r&&!d(t.charCodeAt(L));)L++;L===r?i=L:L!==U&&(i=L+1)}}}}else if(o(n)&&t.charCodeAt(1)===m){if(r<=2)return c.root=c.dir=t,c;if(i=2,d(t.charCodeAt(2))){if(r===3)return c.root=c.dir=t,c;i=3}}i>0&&(c.root=t.slice(0,i));let a=-1,k=i,I=-1,A=!0,v=t.length-1,C=0;for(;v>=i;--v){if(n=t.charCodeAt(v),d(n)){if(!A){k=v+1;break}continue}I===-1&&(A=!1,I=v+1),n===S?a===-1?a=v:C!==1&&(C=1):a!==-1&&(C=-1)}return I!==-1&&(a===-1||C===0||C===1&&a===I-1&&a===k+1?c.base=c.name=t.slice(k,I):(c.name=t.slice(k,a),c.base=t.slice(k,I),c.ext=t.slice(a,I))),k>0&&k!==i?c.dir=t.slice(0,k-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const t=/\\/g;return()=>{const c=P.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>P.cwd()})();e.$6d={resolve(...t){let c="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();y(n,"path"),n.length!==0&&(c=`${n}/${c}`,r=n.charCodeAt(0)===h)}return c=$(c,!r,"/",g),r?`/${c}`:c.length>0?c:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=$(t,!c,"/",g),t.length===0?c?"/":r?"./":".":(r&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let c;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(c===void 0?c=i:c+=`/${i}`)}return c===void 0?".":e.$6d.normalize(c)},relative(t,c){if(y(t,"from"),y(c,"to"),t===c||(t=e.$6d.resolve(t),c=e.$6d.resolve(c),t===c))return"";const r=1,i=t.length,n=i-r,a=1,k=c.length-a,I=n<k?n:k;let A=-1,v=0;for(;v<I;v++){const L=t.charCodeAt(r+v);if(L!==c.charCodeAt(a+v))break;L===h&&(A=v)}if(v===I)if(k>I){if(c.charCodeAt(a+v)===h)return c.slice(a+v+1);if(v===0)return c.slice(a+v)}else n>I&&(t.charCodeAt(r+v)===h?A=v:v===0&&(A=0));let C="";for(v=r+A+1;v<=i;++v)(v===i||t.charCodeAt(v)===h)&&(C+=C.length===0?"..":"/..");return`${C}${c.slice(a+A)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===h;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===h){if(!i){r=n;break}}else i=!1;return r===-1?c?"/":".":c&&r===1?"//":t.slice(0,r)},basename(t,c){c!==void 0&&y(c,"ext"),y(t,"path");let r=0,i=-1,n=!0,a;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let k=c.length-1,I=-1;for(a=t.length-1;a>=0;--a){const A=t.charCodeAt(a);if(A===h){if(!n){r=a+1;break}}else I===-1&&(n=!1,I=a+1),k>=0&&(A===c.charCodeAt(k)?--k===-1&&(i=a):(k=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===h){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let c=-1,r=0,i=-1,n=!0,a=0;for(let k=t.length-1;k>=0;--k){const I=t.charCodeAt(k);if(I===h){if(!n){r=k+1;break}continue}i===-1&&(n=!1,i=k+1),I===S?c===-1?c=k:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||i===-1||a===0||a===1&&c===i-1&&c===r+1?"":t.slice(c,i)},format:E.bind(null,"/"),parse(t){y(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const r=t.charCodeAt(0)===h;let i;r?(c.root="/",i=1):i=0;let n=-1,a=0,k=-1,I=!0,A=t.length-1,v=0;for(;A>=i;--A){const C=t.charCodeAt(A);if(C===h){if(!I){a=A+1;break}continue}k===-1&&(I=!1,k=A+1),C===S?n===-1?n=A:v!==1&&(v=1):n!==-1&&(v=-1)}if(k!==-1){const C=a===0&&r?1:a;n===-1||v===0||v===1&&n===k-1&&n===a+1?c.base=c.name=t.slice(C,k):(c.name=t.slice(C,n),c.base=t.slice(C,k),c.ext=t.slice(n,k))}return a>0?c.dir=t.slice(0,a-1):r&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=w?e.$5d.normalize:e.$6d.normalize,e.$8d=w?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=w?e.$5d.join:e.$6d.join,e.$0d=w?e.$5d.resolve:e.$6d.resolve,e.$$d=w?e.$5d.relative:e.$6d.relative,e.$_d=w?e.$5d.dirname:e.$6d.dirname,e.$ae=w?e.$5d.basename:e.$6d.basename,e.$be=w?e.$5d.extname:e.$6d.extname,e.$ce=w?e.$5d.format:e.$6d.format,e.$de=w?e.$5d.parse:e.$6d.parse,e.$ee=w?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=w?e.$5d.sep:e.$6d.sep,e.$ge=w?e.$5d.delimiter:e.$6d.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function D(a){return a===47||a===92}e.$Bf=D;function S(a){return a.replace(/[\\/]/g,P.$6d.sep)}e.$Cf=S;function h(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Df=h;function l(a,k=P.$6d.sep){if(!a)return"";const I=a.length,A=a.charCodeAt(0);if(D(A)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let C=3;const L=C;for(;C<I&&!D(a.charCodeAt(C));C++);if(L!==C&&!D(a.charCodeAt(C+1))){for(C+=1;C<I;C++)if(D(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,k)}}return k}else if(g(A)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+k:a.slice(0,2);let v=a.indexOf("://");if(v!==-1){for(v+=3;v<I;v++)if(D(a.charCodeAt(v)))return a.slice(0,v+1)}return""}e.$Ef=l;function m(a){if(!O.$i||!a||a.length<5)return!1;let k=a.charCodeAt(0);if(k!==92||(k=a.charCodeAt(1),k!==92))return!1;let I=2;const A=I;for(;I<a.length&&(k=a.charCodeAt(I),k!==92);I++);return!(A===I||(k=a.charCodeAt(I+1),isNaN(k)||k===92))}e.$Ff=m;const b=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(a,k=O.$i){const I=k?b:p;return!(!a||a.length===0||/^\s+$/.test(a)||(I.lastIndex=0,I.test(a))||k&&f.test(a)||a==="."||a===".."||k&&a[a.length-1]==="."||k&&a.length!==a.trim().length||a.length>255)}e.$Gf=y;function w(a,k,I){const A=a===k;return!I||A?A:!a||!k?!1:(0,s.$Me)(a,k)}e.$Hf=w;function d(a,k,I,A=P.sep){if(a===k)return!0;if(!a||!k||k.length>a.length)return!1;if(I){if(!(0,s.$Ne)(a,k))return!1;if(k.length===a.length)return!0;let C=k.length;return k.charAt(k.length-1)===A&&C--,a.charAt(C)===A}return k.charAt(k.length-1)!==A&&(k+=A),a.indexOf(k)===0}e.$If=d;function g(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Jf=g;function o(a,k){return O.$i&&a.endsWith(":")&&(a+=P.sep),(0,P.$8d)(a)||(a=(0,P.$9d)(k,a)),a=(0,P.$7d)(a),O.$i?(a=(0,s.$ve)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.$ve)(a,P.sep),a||(a=P.sep)),a}e.$Kf=o;function $(a){const k=(0,P.$7d)(a);return O.$i?a.length>3?!1:E(k)&&(a.length===2||k.charCodeAt(2)===92):k===P.$6d.sep}e.$Lf=$;function E(a,k=O.$i){return k?g(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Mf=E;function u(a,k=O.$i){return E(a,k)?a[0]:void 0}e.$Nf=u;function t(a,k,I){return k.length>a.length?-1:a===k?0:(I&&(a=a.toLowerCase(),k=k.toLowerCase()),a.indexOf(k))}e.$Of=t;function c(a){const k=a.split(":");let I,A,v;for(const C of k){const L=Number(C);(0,M.$nf)(L)?A===void 0?A=L:v===void 0&&(v=L):I=I?[I,C].join(":"):C}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:A!==void 0?A:void 0,column:v!==void 0?v:A!==void 0?1:void 0}}e.$Pf=c;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,k,I=8){let A="";for(let C=0;C<I;C++){let L;C===0&&O.$i&&!k&&(I===3||I===4)?L=i:L=r,A+=L.charAt(Math.floor(Math.random()*L.length))}let v;return k?v=`${k}-${A}`:v=A,a?(0,P.$9d)(a,v):v}e.$Qf=n}),define(te[73],ie([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var O;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(O||(e.Source=O={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...h){const l=h.reduce((p,f)=>(p[f]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!l[p]).forEach(p=>{for(let f=0;f<m.length;f++)if(p.search(m[f])!==-1){delete S[p];break}})}e.$sl=M;function D(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$tl=D}),define(te[7],ie([0,1,9,4]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const m="",b="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,k,I,A,v=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=h(n,v),this.authority=a||m,this.path=l(this.scheme,k||m),this.query=I||m,this.fragment=A||m,S(this,v))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:k,path:I,query:A,fragment:v}=n;return a===void 0?a=this.scheme:a===null&&(a=m),k===void 0?k=this.authority:k===null&&(k=m),I===void 0?I=this.path:I===null&&(I=m),A===void 0?A=this.query:A===null&&(A=m),v===void 0?v=this.fragment:v===null&&(v=m),a===this.scheme&&k===this.authority&&I===this.path&&A===this.query&&v===this.fragment?this:new d(a,k,I,A,v)}static parse(n,a=!1){const k=p.exec(n);return k?new d(k[2]||m,r(k[4]||m),r(k[5]||m),r(k[7]||m),r(k[9]||m),a):new d(m,m,m,m,m)}static file(n){let a=m;if(O.$i&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const k=n.indexOf(b,2);k===-1?(a=n.substring(2),n=b):(a=n.substring(2,k),n=n.substring(k)||b)}return new d("file",a,n,m,m)}static from(n,a){return new d(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.$i&&n.scheme==="file"?k=f.file(P.$5d.join(E(n,!0),...a)).path:k=P.$6d.join(n.path,...a),n.with({path:k})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const a=new d(n);return a._formatted=n.external??null,a._fsPath=n._sep===w?n.fsPath??null:null,a}}else return n}}e.URI=f;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Sf=y;const w=O.$i?1:void 0;class d extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(i,n,a){let k,I=-1;for(let A=0;A<i.length;A++){const v=i.charCodeAt(A);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||n&&v===47||a&&v===91||a&&v===93||a&&v===58)I!==-1&&(k+=encodeURIComponent(i.substring(I,A)),I=-1),k!==void 0&&(k+=i.charAt(A));else{k===void 0&&(k=i.substr(0,A));const C=g[v];C!==void 0?(I!==-1&&(k+=encodeURIComponent(i.substring(I,A)),I=-1),k+=C):I===-1&&(I=A)}}return I!==-1&&(k+=encodeURIComponent(i.substring(I))),k!==void 0?k:i}function $(i){let n;for(let a=0;a<i.length;a++){const k=i.charCodeAt(a);k===35||k===63?(n===void 0&&(n=i.substr(0,a)),n+=g[k]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function E(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,O.$i&&(a=a.replace(/\//g,"\\")),a}e.$Tf=E;function u(i,n){const a=n?$:o;let k="",{scheme:I,authority:A,path:v,query:C,fragment:L}=i;if(I&&(k+=I,k+=":"),(A||I==="file")&&(k+=b,k+=b),A){let U=A.indexOf("@");if(U!==-1){const B=A.substr(0,U);A=A.substr(U+1),U=B.lastIndexOf(":"),U===-1?k+=a(B,!1,!1):(k+=a(B.substr(0,U),!1,!1),k+=":",k+=a(B.substr(U+1),!1,!0)),k+="@"}A=A.toLowerCase(),U=A.lastIndexOf(":"),U===-1?k+=a(A,!1,!0):(k+=a(A.substr(0,U),!1,!0),k+=A.substr(U))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const U=v.charCodeAt(1);U>=65&&U<=90&&(v=`/${String.fromCharCode(U+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const U=v.charCodeAt(0);U>=65&&U<=90&&(v=`${String.fromCharCode(U+32)}:${v.substr(2)}`)}k+=a(v,!0,!1)}return C&&(k+="?",k+=a(C,!1,!1)),L&&(k+="#",k+=n?L:o(L,!1,!1)),k}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(c)?i.replace(c,n=>t(n)):i}}),define(te[154],ie([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function O(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.$Np=O;function s(l){const m=[];let b;try{const p=JSON.parse(l.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),b=f.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:b}}e.$Op=s;function M(l){if(typeof l!="string")return M(s(l).stack);const m=l;if(m){const b=D(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(p&&p.length===4)return{uri:P.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Pp=M;function D(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function S(l,m){const{args:b,stack:p}=s(l),f=typeof b[0]=="string"&&b.length===1;let y=D(p);y&&(y=`(${y.trim()})`);let w=[];if(typeof b[0]=="string"?y&&f?w=[`%c[${m}] %c${b[0]} %c${y}`,h("blue"),h(""),h("grey")]:w=[`%c[${m}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:w=[`%c[${m}]%`,h("blue"),...b],y&&!f&&w.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=S;function h(l){return`color: ${l}`}}),define(te[74],ie([0,1,17,7]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function s(h){return JSON.stringify(h,D)}e.$9g=s;function M(h){let l=JSON.parse(h);return l=S(l),l}e.$0g=M;function D(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function S(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return O.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof P.$Fd||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let m=0;m<h.length;++m)h[m]=S(h[m],l+1);else for(const m in h)Object.hasOwnProperty.call(h,m)&&(h[m]=S(h[m],l+1))}return h}e.$$g=S}),define(te[13],ie([0,1,14,4,7]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var M;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${M.vscodeRemoteResource}`}set(m,b,p){this.a[m]=b,this.b[m]=p}setConnectionToken(m,b){this.c[m]=b}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(d){return P.$Y(d),m}const b=m.authority;let p=this.a[b];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const f=this.b[b],y=this.c[b];let w=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(w+=`&${e.$Vf}=${encodeURIComponent(y)}`),s.URI.from({scheme:O.$o?this.d:M.vscodeRemoteResource,authority:`${p}:${f}`,path:this.f,query:w})}}e.$Wf=new D,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri(m){const b=this.b(m,J);return this.uriToBrowserUri(b)}uriToBrowserUri(m){return m.scheme===M.vscodeRemote?e.$Wf.rewrite(m):m.scheme===M.file&&(O.$m||O.$p&&O.$g.origin===`${M.vscodeFileResource}://${S.a}`)?m.with({scheme:M.vscodeFileResource,authority:m.authority||S.a,query:null,fragment:null}):m}asFileUri(m){const b=this.b(m,J);return this.uriToFileUri(b)}uriToFileUri(m){return m.scheme===M.vscodeFileResource?m.with({scheme:M.file,authority:m.authority!==S.a?m.authority:null,query:null,fragment:null}):m}b(m,b){return s.URI.isUri(m)?m:s.URI.parse(b.toUrl(m))}}e.$2f=new S;var h;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const b="vscode-coi";function p(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:s.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const d=w?.get(b);if(d)return m.get(d)}l.getHeadersFromQuery=p;function f(y,w,d){if(!globalThis.crossOriginIsolated)return;const g=w&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(b,g):y[b]=g}l.addSearchParam=f})(h||(e.COI=h={}))}),define(te[19],ie([0,1,32,13,9,4,26,7]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function h(f){return(0,S.$Tf)(f,!0)}e.$9f=h;class l{constructor(y){this.a=y}compare(y,w,d=!1){return y===w?0:(0,D.$Fe)(this.getComparisonKey(y,d),this.getComparisonKey(w,d))}isEqual(y,w,d=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,d)===this.getComparisonKey(w,d)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,d=!1){if(y.scheme===w.scheme){if(y.scheme===O.Schemas.file)return P.$If(h(y),h(w),this.a(y))&&y.query===w.query&&(d||y.fragment===w.fragment);if((0,e.$ng)(y.authority,w.authority))return P.$If(y.path,w.path,this.a(y),"/")&&y.query===w.query&&(d||y.fragment===w.fragment)}return!1}joinPath(y,...w){return S.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.$fg)(y)||y.authority}basename(y){return s.$6d.basename(y.path)}extname(y){return s.$6d.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===O.Schemas.file?w=S.URI.file(s.$_d(h(y))).path:(w=s.$6d.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===O.Schemas.file?w=S.URI.file(s.$7d(h(y))).path:w=s.$6d.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.$ng)(y.authority,w.authority))return;if(y.scheme===O.Schemas.file){const o=s.$$d(h(y),h(w));return M.$i?P.$Cf(o):o}let d=y.path||"/";const g=w.path||"/";if(this.a(y)){let o=0;for(const $=Math.min(d.length,g.length);o<$&&!(d.charCodeAt(o)!==g.charCodeAt(o)&&d.charAt(o).toLowerCase()!==g.charAt(o).toLowerCase());o++);d=g.substr(0,o)+d.substr(o)}return s.$6d.relative(d,g)}resolvePath(y,w){if(y.scheme===O.Schemas.file){const d=S.URI.file(s.$0d(h(y),w));return y.with({authority:d.authority,path:d.path})}return w=P.$Df(w),y.with({path:s.$6d.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,D.$Me)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===O.Schemas.file){const d=h(y);return d.length>P.$Ef(d).length&&d[d.length-1]===w}else{const d=y.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.$og)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let d=!1;if(y.scheme===O.Schemas.file){const g=h(y);d=g!==void 0&&g.length===P.$Ef(g).length&&g[g.length-1]===w}else{w="/";const g=y.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.$og)(y,w)?y.with({path:y.path+"/"}):y}}e.$0f=l,e.$$f=new l(()=>!1),e.$_f=new l(f=>f.scheme===O.Schemas.file?!M.$k:!0),e.$ag=new l(f=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function m(f,y){const w=[];for(let d=0;d<f.length;d++){const g=y(f[d]);f.some((o,$)=>$===d?!1:(0,e.$cg)(g,y(o)))||w.push(f[d])}return w}e.$rg=m;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(w){const d=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach($=>{const[E,u]=$.split(":");E&&u&&d.set(E,u)});const o=w.path.substring(0,w.path.indexOf(";"));return o&&d.set(f.META_DATA_MIME,o),d}f.parseMetaData=y})(b||(e.DataUri=b={}));function p(f,y,w){if(y){let d=f.path;return d&&d[0]!==s.$6d.sep&&(d=s.$6d.sep+d),f.with({scheme:w,authority:y,path:d})}return f.with({scheme:w})}e.$sg=p}),define(te[8],ie([0,1,22,14,3,2,19,4,142]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function l(R){return!!R&&typeof R.then=="function"}e.$tg=l;function m(R){const j=new P.$pd,W=R(j.token),T=new Promise((H,z)=>{const ne=j.token.onCancellationRequested(()=>{ne.dispose(),j.dispose(),z(new O.$3)});Promise.resolve(W).then(fe=>{ne.dispose(),j.dispose(),H(fe)},fe=>{ne.dispose(),j.dispose(),z(fe)})});return new class{cancel(){j.cancel()}then(H,z){return T.then(H,z)}catch(H){return this.then(void 0,H)}finally(H){return T.finally(H)}}}e.$ug=m;function b(R,j,W){return new Promise((T,H)=>{const z=j.onCancellationRequested(()=>{z.dispose(),T(W)});R.then(T,H).finally(()=>z.dispose())})}e.$vg=b;function p(R,j){return new Promise((W,T)=>{const H=j.onCancellationRequested(()=>{H.dispose(),T(new O.$3)});R.then(W,T).finally(()=>H.dispose())})}e.$wg=p;async function f(R){let j=-1;const W=R.map((T,H)=>T.then(z=>(j=H,z)));try{return await Promise.race(W)}finally{R.forEach((T,H)=>{H!==j&&T.cancel()})}}e.$xg=f;function y(R,j,W){let T;const H=setTimeout(()=>{T?.(void 0),W?.()},j);return Promise.race([R.finally(()=>clearTimeout(H)),new Promise(z=>T=z)])}e.$yg=y;function w(R){return new Promise((j,W)=>{const T=R();l(T)?T.then(j,W):j(T)})}e.$zg=w;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const W=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(W,W).then(T)})}return new Promise((W,T)=>{this.b.then(W,T)})}return this.a=j(),new Promise((W,T)=>{this.a.then(H=>{this.a=null,W(H)},H=>{this.a=null,T(H)})})}dispose(){this.f=!0}}e.$Ag=d;class g{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Bg=g;class o{constructor(){this.a=new Map}queue(j,W){const H=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(j)===H&&this.a.delete(j)});return this.a.set(j,H),H}}e.$Cg=o;const $=(R,j)=>{let W=!0;const T=setTimeout(()=>{W=!1,j()},R);return{isTriggered:()=>W,dispose:()=>{clearTimeout(T),W=!1}}},E=R=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,R())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class u{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,W=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((H,z)=>{this.d=H,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const H=this.g;return this.g=null,H()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=W===h.$cd?E(T):$(W,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=u;class t{constructor(j){this.a=new u(j),this.b=new d}trigger(j,W){return this.a.trigger(()=>this.b.queue(j),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=t;class c{constructor(){this.a=!1,this.b=new Promise((j,W)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=c;class r extends c{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Gg=r;function i(R,j){return j?new Promise((W,T)=>{const H=setTimeout(()=>{z.dispose(),W()},R),z=j.onCancellationRequested(()=>{clearTimeout(H),z.dispose(),T(new O.$3)})}):m(W=>i(R,W))}e.$Hg=i;function n(R,j=0){const W=setTimeout(R,j);return(0,M.$ic)(()=>clearTimeout(W))}e.$Ig=n;function a(R){const j=[];let W=0;const T=R.length;function H(){return W<T?R[W++]():null}function z(ne){ne!=null&&j.push(ne);const fe=H();return fe?fe.then(z):Promise.resolve(j)}return Promise.resolve(null).then(z)}e.$Jg=a;function k(R,j=T=>!!T,W=null){let T=0;const H=R.length,z=()=>{if(T>=H)return Promise.resolve(W);const ne=R[T++];return Promise.resolve(ne()).then(ge=>j(ge)?Promise.resolve(ge):z())};return z()}e.$Kg=k;function I(R,j=T=>!!T,W=null){if(R.length===0)return Promise.resolve(W);let T=R.length;const H=()=>{T=-1;for(const z of R)z.cancel?.()};return new Promise((z,ne)=>{for(const fe of R)fe.then(ge=>{--T>=0&&j(ge)?(H(),z(ge)):T===0&&z(W)}).catch(ge=>{--T>=0&&(H(),ne(ge))})})}e.$Lg=I;class A{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((W,T)=>{this.f.push({factory:j,c:W,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const W=j.factory();W.then(j.c,j.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=A;class v extends A{constructor(){super(1)}}e.$Ng=v;class C{constructor(){this.a=new K,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Og=C;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new N;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,W=D.$$f){const T=W.getComparisonKey(j);let H=this.a.get(T);if(!H){H=new v;const z=this.f++,ne=s.Event.once(H.onDrained)(()=>{H?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$sc),this.d.set(z,ne),this.a.set(T,H)}return H}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=L;class U{constructor(j,W){this.a=-1,typeof j=="function"&&typeof W=="number"&&this.setIfNotSet(j,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},W)}setIfNotSet(j,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},W))}}e.$Qg=U;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,W){this.cancel(),this.a=setInterval(()=>{j()},W)}}e.$Rg=B;class re{constructor(j,W){this.b=-1,this.a=j,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=re;class ee{constructor(j,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=j,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=ee;class ae extends re{constructor(j,W){super(j,W),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$Ug=ae;class se extends M.$kc{constructor(j,W){super(),this.g=j,this.h=W,this.a=[],this.b=this.B(new M.$lc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of j)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=R=>{(0,S.$A)(()=>{if(j)return;const W=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$Wg=(R,j)=>{const W=requestIdleCallback(R,typeof j=="number"?{timeout:j}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(W))}}}}();class oe{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=oe;async function G(R,j,W){let T;for(let H=0;H<W;H++)try{return await R()}catch(z){T=z,await i(j)}throw T}e.$Yg=G;class K{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,W,T){return this.a={taskId:j,cancel:()=>T?.(),promise:W},W.then(()=>this.d(j),()=>this.d(j)),W}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let W,T;const H=new Promise((z,ne)=>{W=z,T=ne});this.b={run:j,promise:H,promiseResolve:W,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=K;class q{constructor(j,W=()=>Date.now()){this.d=j,this.f=W,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$1g=q;var F;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,W)=>{this.a=j,this.b=W})}complete(j){return new Promise(W=>{this.a(j),this.d={outcome:0,value:j},W()})}error(j){return new Promise(W=>{this.b(j),this.d={outcome:1,value:j},W()})}cancel(){return this.error(new O.$3)}}e.$2g=N;var V;(function(R){async function j(T){let H;const z=await Promise.all(T.map(ne=>ne.then(fe=>fe,fe=>{H||(H=fe)})));if(typeof H<"u")throw H;return z}R.settled=j;function W(T){return new Promise(async(H,z)=>{try{await T(H,z)}catch(ne){z(ne)}})}R.withAsyncBody=W})(V||(e.Promises=V={}));var X;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(X||(X={}));class x{static fromArray(j){return new x(W=>{W.emitMany(j)})}static fromPromise(j){return new x(async W=>{W.emitMany(await j)})}static fromPromises(j){return new x(async W=>{await Promise.all(j.map(async T=>W.emitOne(await T)))})}static merge(j){return new x(async W=>{await Promise.all(j.map(async T=>{for await(const H of T)W.emitOne(H)}))})}static{this.EMPTY=x.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$fd,queueMicrotask(async()=>{const W={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(j(W)),this.j()}catch(T){this.k(T)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,W){return new x(async T=>{for await(const H of j)T.emitOne(W(H))})}map(j){return x.map(this,j)}static filter(j,W){return new x(async T=>{for await(const H of j)W(H)&&T.emitOne(H)})}filter(j){return x.filter(this,j)}static coalesce(j){return x.filter(j,W=>!!W)}coalesce(){return x.coalesce(this)}static async toPromise(j){const W=[];for await(const T of j)W.push(T);return W}toPromise(){return x.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$3g=x;class ce extends x{constructor(j,W){super(W),this.l=j}cancel(){this.l.cancel()}}e.$4g=ce;function Y(R){const j=new P.$pd,W=R(j.token);return new ce(j,async T=>{const H=j.token.onCancellationRequested(()=>{H.dispose(),j.dispose(),T.reject(new O.$3)});try{for await(const z of W){if(j.token.isCancellationRequested)return;T.emitOne(z)}H.dispose(),j.dispose()}catch(z){H.dispose(),j.dispose(),T.reject(z)}})}e.$5g=Y}),define(te[104],ie([0,1,23,8,32,33,9,4,26]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function l(){return Object.create(null)}e.$mj=l,e.$nj="**",e.$oj="/";const m="[/\\\\]",b="[^/\\\\]",p=/\//g;function f(K,q){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${m}|${b}+${m}${q?`|${m}${b}+`:""})*?`}}function y(K,q){if(!K)return[];const F=[];let N=!1,V=!1,X="";for(const x of K){switch(x){case q:if(!N&&!V){F.push(X),X="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":V=!0;break;case"]":V=!1;break}X+=x}return X&&F.push(X),F}e.$pj=y;function w(K){if(!K)return"";let q="";const F=y(K,e.$oj);if(F.every(N=>N===e.$nj))q=".*";else{let N=!1;F.forEach((V,X)=>{if(V===e.$nj){if(N)return;q+=f(2,X===F.length-1)}else{let x=!1,ce="",Y=!1,R="";for(const j of V){if(j!=="}"&&x){ce+=j;continue}if(Y&&(j!=="]"||!R)){let W;j==="-"?W=j:(j==="^"||j==="!")&&!R?W="^":j===e.$oj?W="":W=(0,h.$qe)(j),R+=W;continue}switch(j){case"{":x=!0;continue;case"[":Y=!0;continue;case"}":{const T=`(?:${y(ce,",").map(H=>w(H)).join("|")})`;q+=T,x=!1,ce="";break}case"]":{q+="["+R+"]",Y=!1,R="";break}case"?":q+=b;continue;case"*":q+=f(1);continue;default:q+=(0,h.$qe)(j)}}X<F.length-1&&(F[X+1]!==e.$nj||X+2<F.length)&&(q+=m)}N=V===e.$nj})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ci(1e4),c=function(){return!1},r=function(){return null};function i(K,q){if(!K)return r;let F;typeof K!="string"?F=K.pattern:F=K,F=F.trim();const N=`${F}_${!!q.trimForExclusions}`;let V=t.get(N);if(V)return n(V,K);let X;return d.test(F)?V=k(F.substr(4),F):(X=g.exec(a(F,q)))?V=I(X[1],F):(q.trimForExclusions?$:o).test(F)?V=A(F,q):(X=E.exec(a(F,q)))?V=v(X[1].substr(1),F,!0):(X=u.exec(a(F,q)))?V=v(X[1],F,!1):V=C(F),t.set(N,V),n(V,K)}function n(K,q){if(typeof q=="string")return K;const F=function(N,V){return(0,s.$If)(N,q.base,!S.$k)?K((0,h.$ue)(N.substr(q.base.length),D.sep),V):null};return F.allBasenames=K.allBasenames,F.allPaths=K.allPaths,F.basenames=K.basenames,F.patterns=K.patterns,F}function a(K,q){return q.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function k(K,q){return function(F,N){return typeof F=="string"&&F.endsWith(K)?q:null}}function I(K,q){const F=`/${K}`,N=`\\${K}`,V=function(x,ce){return typeof x!="string"?null:ce?ce===K?q:null:x===K||x.endsWith(F)||x.endsWith(N)?q:null},X=[K];return V.basenames=X,V.patterns=[q],V.allBasenames=X,V}function A(K,q){const F=oe(K.slice(1,-1).split(",").map(ce=>i(ce,q)).filter(ce=>ce!==r),K),N=F.length;if(!N)return r;if(N===1)return F[0];const V=function(ce,Y){for(let R=0,j=F.length;R<j;R++)if(F[R](ce,Y))return K;return null},X=F.find(ce=>!!ce.allBasenames);X&&(V.allBasenames=X.allBasenames);const x=F.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(V.allPaths=x),V}function v(K,q,F){const N=D.sep===D.$6d.sep,V=N?K:K.replace(p,D.sep),X=D.sep+V,x=D.$6d.sep+K;let ce;return F?ce=function(Y,R){return typeof Y=="string"&&(Y===V||Y.endsWith(X)||!N&&(Y===K||Y.endsWith(x)))?q:null}:ce=function(Y,R){return typeof Y=="string"&&(Y===V||!N&&Y===K)?q:null},ce.allPaths=[(F?"*/":"./")+K],ce}function C(K){try{const q=new RegExp(`^${w(K)}$`);return function(F){return q.lastIndex=0,typeof F=="string"&&q.test(F)?K:null}}catch{return r}}function L(K,q,F){return!K||typeof q!="string"?!1:U(K)(q,void 0,F)}e.$qj=L;function U(K,q={}){if(!K)return c;if(typeof K=="string"||B(K)){const F=i(K,q);if(F===r)return c;const N=function(V,X){return!!F(V,X)};return F.allBasenames&&(N.allBasenames=F.allBasenames),F.allPaths&&(N.allPaths=F.allPaths),N}return ae(K,q)}e.$rj=U;function B(K){const q=K;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.$sj=B;function re(K){return K.allBasenames||[]}e.$tj=re;function ee(K){return K.allPaths||[]}e.$uj=ee;function ae(K,q){const F=oe(Object.getOwnPropertyNames(K).map(ce=>se(ce,K[ce],q)).filter(ce=>ce!==r)),N=F.length;if(!N)return r;if(!F.some(ce=>!!ce.requiresSiblings)){if(N===1)return F[0];const ce=function(j,W){let T;for(let H=0,z=F.length;H<z;H++){const ne=F[H](j,W);if(typeof ne=="string")return ne;(0,O.$tg)(ne)&&(T||(T=[]),T.push(ne))}return T?(async()=>{for(const H of T){const z=await H;if(typeof z=="string")return z}return null})():null},Y=F.find(j=>!!j.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const R=F.reduce((j,W)=>W.allPaths?j.concat(W.allPaths):j,[]);return R.length&&(ce.allPaths=R),ce}const V=function(ce,Y,R){let j,W;for(let T=0,H=F.length;T<H;T++){const z=F[T];z.requiresSiblings&&R&&(Y||(Y=(0,D.$ae)(ce)),j||(j=Y.substr(0,Y.length-(0,D.$be)(ce).length)));const ne=z(ce,Y,j,R);if(typeof ne=="string")return ne;(0,O.$tg)(ne)&&(W||(W=[]),W.push(ne))}return W?(async()=>{for(const T of W){const H=await T;if(typeof H=="string")return H}return null})():null},X=F.find(ce=>!!ce.allBasenames);X&&(V.allBasenames=X.allBasenames);const x=F.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(V.allPaths=x),V}function se(K,q,F){if(q===!1)return r;const N=i(K,F);if(N===r)return r;if(typeof q=="boolean")return N;if(q){const V=q.when;if(typeof V=="string"){const X=(x,ce,Y,R)=>{if(!R||!N(x,ce))return null;const j=V.replace("$(basename)",()=>Y),W=R(j);return(0,O.$tg)(W)?W.then(T=>T?K:null):W?K:null};return X.requiresSiblings=!0,X}}return N}function oe(K,q){const F=K.filter(ce=>!!ce.basenames);if(F.length<2)return K;const N=F.reduce((ce,Y)=>{const R=Y.basenames;return R?ce.concat(R):ce},[]);let V;if(q){V=[];for(let ce=0,Y=N.length;ce<Y;ce++)V.push(q)}else V=F.reduce((ce,Y)=>{const R=Y.patterns;return R?ce.concat(R):ce},[]);const X=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let j;for(j=ce.length;j>0;j--){const W=ce.charCodeAt(j-1);if(W===47||W===92)break}Y=ce.substr(j)}const R=N.indexOf(Y);return R!==-1?V[R]:null};X.basenames=N,X.patterns=V,X.allBasenames=N;const x=K.filter(ce=>!ce.basenames);return x.push(X),x}function G(K,q){return(0,P.$sb)(K,q,(F,N)=>typeof F=="string"&&typeof N=="string"?F===N:typeof F!="string"&&typeof N!="string"?F.base===N.base&&F.pattern===N.pattern:!1)}e.$vj=G}),define(te[46],ie([0,1,23,32,9,4,19,26]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nA=e.$mA=e.$lA=e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=void 0;function h(i,n){const{os:a,tildify:k,relative:I}=n;if(I){const C=l(i,I,a);if(typeof C=="string")return C}let A=i.fsPath;if(a===1&&!M.$i?A=A.replace(/\//g,"\\"):a!==1&&M.$i&&(A=A.replace(/\\/g,"/")),a!==1&&k?.userHome){const C=k.userHome.fsPath;let L;i.scheme!==k.userHome.scheme&&i.path.startsWith(s.$6d.sep)?L=k.userHome.with({path:i.path}).fsPath:L=i.fsPath,A=p(L,C,a)}return(a===1?s.$5d:s.$6d).normalize(m(A,a===1))}e.$eA=h;function l(i,n,a){const k=a===1?s.$5d:s.$6d,I=a===3?D.$$f:D.$ag,A=n.getWorkspace(),v=(0,P.$Mb)(A.folders);if(!v)return;i.scheme!==v.uri.scheme&&i.path.startsWith(s.$6d.sep)&&(i=v.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let L;if(I.isEqual(C.uri,i)?L="":L=I.relativePath(C.uri,i)??"",L&&(L=k.normalize(L)),A.folders.length>1&&!n.noPrefix){const U=C.name?C.name:I.basenameOrAuthority(C.uri);L=L?`${U} \u2022 ${L}`:U}return L}function m(i,n=M.$i){return(0,O.$Mf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$fA=m;let b=Object.create(null);function p(i,n,a=M.OS){if(a===1||!i||!n)return i;let k=b.original===n?b.normalized:void 0;k||(k=n,M.$i&&(k=(0,O.$Cf)(k)),k=`${(0,S.$ve)(k,s.$6d.sep)}${s.$6d.sep}`,b={original:n,normalized:k});let I=i;return M.$i&&(I=(0,O.$Cf)(I)),(a===3?I.startsWith(k):(0,S.$Ne)(I,k))?`~/${I.substr(k.length)}`:i}e.$gA=p;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$hA=f;const y="\u2026",w="\\\\",d="~";function g(i,n=s.sep){const a=new Array(i.length);let k=!1;for(let I=0;I<i.length;I++){const A=i[I];if(A===""){a[I]=`.${n}`;continue}if(!A){a[I]=A;continue}k=!0;let v="",C=A;C.indexOf(w)===0?(v=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(n)===0?(v=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(d)===0&&(v=C.substr(0,C.indexOf(d)+d.length),C=C.substr(C.indexOf(d)+d.length));const L=C.split(n);for(let U=1;k&&U<=L.length;U++)for(let B=L.length-U;k&&B>=0;B--){k=!1;let re=L.slice(B,B+U).join(n);for(let ee=0;!k&&ee<i.length;ee++)if(ee!==I&&i[ee]&&i[ee].indexOf(re)>-1){const ae=B+U===L.length,se=B>0&&i[ee].indexOf(n)>-1?n+re:re,oe=i[ee].endsWith(se);k=!ae||oe}if(!k){let ee="";(L[0].endsWith(":")||v!=="")&&(B===1&&(B=0,U++,re=L[0]+n+re),B>0&&(ee=L[0]+n),ee=v+ee),B>0&&(ee=ee+y+n),ee=ee+re,B+U<L.length&&(ee=ee+n+y),a[I]=ee}}k&&(a[I]=A)}return a}e.$iA=g;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function $(i,n=Object.create(null)){const a=[];let k=!1,I="";for(const A of i)if(A==="$"||k&&A==="{")I&&a.push({value:I,type:o.TEXT}),I="",k=!0;else if(A==="}"&&k){const v=n[I];if(typeof v=="string")v.length&&a.push({value:v,type:o.VARIABLE});else if(v){const C=a[a.length-1];(!C||C.type!==o.SEPARATOR)&&a.push({value:v.label,type:o.SEPARATOR})}I="",k=!1}else I+=A;return I&&!k&&a.push({value:I,type:o.TEXT}),a.filter((A,v)=>{if(A.type===o.SEPARATOR){const C=a[v-1],L=a[v+1];return[C,L].every(U=>U&&(U.type===o.VARIABLE||U.type===o.TEXT)&&U.value.length>0)}return!0}).map(A=>A.value).join("")}e.$jA=$;function E(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$kA=E;function u(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$lA=u;function t(i){return i.replace(/&/g,"&&")}e.$mA=t;function c(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n));return{name:a.name,parentPath:a.parentPath+i.substring(n)}}}return r(i)}e.$nA=c;function r(i){const n=i.indexOf("/")!==-1?s.$6d:s.$5d,a=n.basename(i),k=n.dirname(i);return a.length?{name:a,parentPath:k}:{name:k,parentPath:""}}}),define(te[155],ie([0,1,17,7]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function s(b){return b.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const f=this.a.transformIncoming(p);return f===p?p:s(O.URI.from(f))}transformOutgoing(p){const f=this.a.transformOutgoing(p);return f===p?p:s(O.URI.from(f))}transformOutgoingURI(p){const f=this.a.transformOutgoing(p);return f===p?p:O.URI.from(f)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Bm=M,e.$Cm=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function D(b,p,f){if(!b||f>200)return null;if(typeof b=="object"){if(b instanceof O.URI)return p.transformOutgoing(b);for(const y in b)if(Object.hasOwnProperty.call(b,y)){const w=D(b[y],p,f+1);w!==null&&(b[y]=w)}}return null}function S(b,p){const f=D(b,p,0);return f===null?b:f}e.$Dm=S;function h(b,p,f,y){if(!b||y>200)return null;if(typeof b=="object"){if(b.$mid===1)return f?O.URI.revive(p.transformIncoming(b)):p.transformIncoming(b);if(b instanceof P.$Fd)return null;for(const w in b)if(Object.hasOwnProperty.call(b,w)){const d=h(b[w],p,f,y+1);d!==null&&(b[w]=d)}}return null}function l(b,p){const f=h(b,p,!1,0);return f===null?b:f}e.$Em=l;function m(b,p){const f=h(b,p,!0,0);return f===null?b:f}e.$Fm=m}),define(te[21],ie([0,1,45,27,156,8,32,85,9,4,19,7]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function f(se,oe=p.UNLINK,G){if((0,D.$Lf)(se))throw new Error("rimraf - will refuse to recursively delete root");return oe===p.UNLINK?w(se):y(se,G)}async function y(se,oe=(0,D.$Qf)((0,O.tmpdir)())){try{try{await P.promises.rename(se,oe)}catch(G){return G.code==="ENOENT"?void 0:w(se)}w(oe).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function w(se){return(0,s.promisify)(P.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function d(se){if((0,D.$Lf)(se))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function g(se,oe){return E(await(oe?o(se):(0,s.promisify)(P.readdir)(se)))}async function o(se){try{return await(0,s.promisify)(P.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const oe=[],G=await g(se);for(const K of G){let q=!1,F=!1,N=!1;try{const V=await e.Promises.lstat((0,h.$9d)(se,K));q=V.isFile(),F=V.isDirectory(),N=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}oe.push({name:K,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>N})}return oe}function $(se){return E(P.readdirSync(se))}e.readdirSync=$;function E(se){return se.map(oe=>typeof oe=="string"?l.$j?(0,S.$hl)(oe):oe:(oe.name=l.$j?(0,S.$hl)(oe.name):oe.name,oe))}async function u(se){const oe=await g(se),G=[];for(const K of oe)await c.existsDirectory((0,h.$9d)(se,K))&&G.push(K);return G}function t(se,oe=1e3){return new Promise(G=>{let K=!1;const q=setInterval(()=>{K||(K=!0,P.access(se,F=>{K=!1,F&&(clearInterval(q),G(void 0))}))},oe)})}e.whenDeleted=t;var c;(function(se){async function oe(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(l.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw V}throw N}}se.stat=oe;async function G(q){try{const{stat:F,symbolicLink:N}=await se.stat(q);return F.isFile()&&N?.dangling!==!0}catch{}return!1}se.existsFile=G;async function K(q){try{const{stat:F,symbolicLink:N}=await se.stat(q);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(c||(e.SymlinkSupport=c={}));const r=new M.$Pg;function i(se,oe,G){return r.queueFor(b.URI.file(se),m.$_f).queue(()=>{const K=A(G);return new Promise((q,F)=>k(se,oe,K,N=>N?F(N):q()))})}let n=!0;function a(se){n=se}e.configureFlushOnWrite=a;function k(se,oe,G,K){if(!n)return P.writeFile(se,oe,{mode:G.mode,flag:G.flag},K);P.open(se,G.flag,G.mode,(q,F)=>{if(q)return K(q);P.writeFile(F,oe,N=>{if(N)return P.close(F,()=>K(N));P.fdatasync(F,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a(!1)),P.close(F,X=>K(X))))})})}function I(se,oe,G){const K=A(G);if(!n)return P.writeFileSync(se,oe,{mode:K.mode,flag:K.flag});const q=P.openSync(se,K.flag,K.mode);try{P.writeFileSync(q,oe);try{P.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),a(!1)}}finally{P.closeSync(q)}}e.writeFileSync=I;function A(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function v(se,oe,G=6e4){if(se!==oe)try{l.$i&&typeof G=="number"?await C(se,oe,Date.now(),G):await(0,s.promisify)(P.rename)(se,oe)}catch(K){if(se.toLowerCase()!==oe.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await L(se,oe,{preserveSymlinks:!1}),await f(se,p.MOVE);else throw K}}async function C(se,oe,G,K,q=0){try{return await(0,s.promisify)(P.rename)(se,oe)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-G>=K)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${F}`),F;if(q===0){let N=!1;try{const{stat:V}=await c.stat(oe);V.isFile()||(N=!0)}catch{}if(N)throw F}return await(0,M.$Hg)(Math.min(100,q*10)),C(se,oe,G,K,q+1)}}async function L(se,oe,G){return B(se,oe,{root:{source:se,target:oe},options:G,handledSourcePaths:new Set})}const U=511;async function B(se,oe,G){if(G.handledSourcePaths.has(se))return;G.handledSourcePaths.add(se);const{stat:K,symbolicLink:q}=await c.stat(se);if(q){if(G.options.preserveSymlinks)try{return await ae(se,oe,G)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return K.isDirectory()?re(se,oe,K.mode&U,G):ee(se,oe,K.mode&U)}async function re(se,oe,G,K){await e.Promises.mkdir(oe,{recursive:!0,mode:G});const q=await g(se);for(const F of q)await B((0,h.$9d)(se,F),(0,h.$9d)(oe,F),K)}async function ee(se,oe,G){await e.Promises.copyFile(se,oe),await e.Promises.chmod(oe,G)}async function ae(se,oe,G){let K=await e.Promises.readlink(se);(0,D.$If)(K,G.root.source,!l.$k)&&(K=(0,h.$9d)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,oe)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(se,oe,G,K,q)=>new Promise((F,N)=>{P.read(se,oe,G,K,q,(V,X,x)=>V?N(V):F({bytesRead:X,buffer:x}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(se,oe,G,K,q)=>new Promise((F,N)=>{P.write(se,oe,G,K,q,(V,X,x)=>V?N(V):F({bytesWritten:X,buffer:x}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return f}get rename(){return v}get copy(){return L}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function S(p){if(s.$k)return p;const f=(0,O.$_d)(p);if(p===f)return p;const y=((0,O.$ae)(p)||p).toLowerCase();try{const d=(0,D.readdirSync)(f).filter(g=>g.toLowerCase()===y);if(d.length===1){const g=S(f);if(g)return(0,O.$9d)(g,d[0])}else if(d.length>1){const g=d.indexOf(y);if(g>=0){const o=S(f);if(o)return(0,O.$9d)(o,d[g])}}}catch{}return null}e.$Up=S;async function h(p){if(s.$k)return p;const f=(0,O.$_d)(p);if(p===f)return p;const y=((0,O.$ae)(p)||p).toLowerCase();try{const d=(await D.Promises.readdir(f)).filter(g=>g.toLowerCase()===y);if(d.length===1){const g=await h(f);if(g)return(0,O.$9d)(g,d[0])}else if(d.length>1){const g=d.indexOf(y);if(g>=0){const o=await h(f);if(o)return(0,O.$9d)(o,d[g])}}}catch{}return null}e.$Vp=h;async function l(p){try{return await D.Promises.realpath(p)}catch{const y=b(p);return await D.Promises.access(y,P.constants.R_OK),y}}e.$Wp=l;function m(p){try{return P.realpathSync(p)}catch{const y=b(p);return P.accessSync(y,P.constants.R_OK),y}}e.$Xp=m;function b(p){return(0,M.$ve)((0,O.$7d)(p),O.sep)}}),define(te[106],ie([0,1,27,9,21]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class b{constructor(u,t,c){this.exePath=u,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:E=!1}={}){return E?l===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:u=!1}={}){const t=p({useAlternateBitness:E});if(!t)return null;const c=O.$9d(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(c))return null;let r=-1,i=null;for(const k of await s.Promises.readdir(c)){let I=-1;if(u){const v=k.indexOf("-");if(v<0)continue;const C=k.substring(0,v);if(!M.test(C)||k.substring(v+1)!=="preview")continue;I=parseInt(C,10)}else{if(!M.test(k))continue;I=parseInt(k,10)}if(I<=r)continue;const A=O.$9d(c,k,"pwsh.exe");await s.SymlinkSupport.existsFile(A)&&(i=A,r=I)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=u?" Preview":"";return new b(i,`PowerShell${a}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=O.$9d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(u))if(t.test(r)){const i=O.$9d(u,r,"pwsh.exe");return new b(i,c)}return null}function w(){const E=O.$9d(P.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function d(){const E=O.$9d(process.env.windir,l===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*g(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=w(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=d(),E&&(yield E)}async function*o(){for await(const E of g())await E.exists()&&(yield E)}e.$ql=o;async function $(){for await(const E of o())return E;return null}e.$rl=$}),define(te[88],ie([0,1,9,4,35,73,12,21]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h(b=s.env){return b.comspec||"cmd.exe"}e.$ul=h;function l(b){let p=[],f=!1;const y=function(w){if(f){p.push(w);return}(!b.send(w,g=>{if(g&&console.error(g),f=!1,p.length>0){const o=p.slice(0);p=[],o.forEach($=>y($))}})||O.$i)&&(f=!0)};return{send:y}}e.$vl=l;var m;(function(b){async function p(f,y,w){if(P.$8d(f))return f;if(y===void 0&&(y=s.cwd()),P.$_d(f)!=="."||(w===void 0&&D.$jf(s.env.PATH)&&(w=s.env.PATH.split(P.$ge)),w===void 0||w.length===0))return P.$9d(y,f);async function g(o){if(await S.Promises.exists(o)){let $;try{$=await S.Promises.stat(o)}catch(E){E.message.startsWith("EACCES")&&($=await S.Promises.lstat(o))}return $?!$.isDirectory():!1}return!1}for(const o of w){let $;if(P.$8d(o)?$=P.$9d(o,f):$=P.$9d(y,o,f),await g($))return $;let E=$+".com";if(await g(E)||(E=$+".exe",await g(E)))return E}return P.$9d(y,f)}b.findExecutable=p})(m||(e.win32=m={}))}),define(te[107],ie([0,1,47,13]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function s(D){return new Promise((S,h)=>{let l;const m=new Map;function b(f,y,w,d,g){const o=m.get(y);if(f===D||o){const $={name:p(w),cmd:w,pid:f,ppid:y,load:d,mem:g};m.set(f,$),f===D&&(l=$),o&&(o.children||(o.children=[]),o.children.push($),o.children.length>1&&(o.children=o.children.sort((E,u)=>E.pid-u.pid)))}}function p(f){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,o=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-agent";if(o.exec(f))return"conpty-agent";let E=$.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let t="";do E=u.exec(f),E&&(t+=E+" ");while(E);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{J(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(D,w=>{if(!w){h(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(w,d=>{const g=new Map;d.forEach(o=>{const $=f(o.commandLine||"");g.set(o.pid,{name:p($),cmd:$,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),l=g.get(D),l?(g.forEach(o=>{const $=g.get(o.ppid);$&&($.children||($.children=[]),$.children.push(o))}),g.forEach(o=>{o.children&&(o.children=o.children.sort(($,E)=>$.pid-E.pid))}),S(l)):h(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[l];const w=[];for(;y.length;){const g=y.shift();g&&(w.push(g.pid),g.children&&(y=y.concat(g.children)))}let d=JSON.stringify(O.$2f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+w.join(" "),(0,P.exec)(d,{},(g,o,$)=>{if(g||$)h(g||new Error($.toString()));else{const E=o.toString().split(`
`);for(let u=0;u<w.length;u++){const t=m.get(w[u]);t.load=parseFloat(E[u])}if(!l){h(new Error(`Root process ${D} not found`));return}S(l)}})};(0,P.exec)("which ps",{},(y,w,d)=>{if(y||d)if(process.platform!=="linux")h(y||new Error(d.toString()));else{const g=JSON.stringify(O.$2f.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(o,$,E)=>{o||E?h(o||new Error(E.toString())):(M($,b),f())})}else{const g=w.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${g} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,E,u)=>{$||u&&!u.includes("screen size is bogus")?h($||new Error(u.toString())):(M(E,b),process.platform==="linux"?f():l?S(l):h(new Error(`Root process ${D} not found`)))})}})}})}e.$sr=s;function M(D,S){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=D.toString().split(`
`);for(const m of l){const b=h.exec(m.trim());b&&b.length===6&&S(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;async function D(b,p){return b===1?O.$i?m():M.$ul(p):h(b,p)}e.$wl=D;let S=null;function h(b,p){if(O.$k&&b===2||O.$j&&b===3)return"/bin/bash";if(!S){let f;if(O.$i)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let l=null;async function m(){return l||(l=(await(0,s.$rl)()).exePath),l}});var ke=this&&this.__decorate||function(J,e,P,O){var s=arguments.length,M=s<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,P):O,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,e,P,O);else for(var S=J.length-1;S>=0;S--)(D=J[S])&&(M=(s<3?D(M):s>3?D(e,P,M):D(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(te[42],ie([0,1,23,8,17,22,55,14,3,2,74,26,12]),function(J,e,P,O,s,M,D,S,h,l,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var f;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(f||(f={}));function y(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(w||(w={}));function d(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));function o(q){let F=0;for(let N=0;;N+=7){const V=q.read(1);if(F|=(V.buffer[0]&127)<<N,!(V.buffer[0]&128))return F}}const $=r(0);function E(q,F){if(F===0){q.write($);return}let N=0;for(let X=F;X!==0;X=X>>>7)N++;const V=s.$Fd.alloc(N);for(let X=0;F!==0;X++)V.buffer[X]=F&127,F=F>>>7,F>0&&(V.buffer[X]|=128);q.write(V)}class u{constructor(F){this.b=F,this.a=0}read(F){const N=this.b.slice(this.a,this.a+F);return this.a+=N.byteLength,N}}e.$_g=u;class t{constructor(){this.a=[]}get buffer(){return s.$Fd.concat(this.a)}write(F){this.a.push(F)}}e.$ah=t;var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(c||(c={}));function r(q){const F=s.$Fd.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object),Uint:r(c.Int)},n=typeof Buffer<"u";function a(q,F){if(typeof F>"u")q.write(i.Undefined);else if(typeof F=="string"){const N=s.$Fd.fromString(F);q.write(i.String),E(q,N.byteLength),q.write(N)}else if(n&&Buffer.isBuffer(F)){const N=s.$Fd.wrap(F);q.write(i.Buffer),E(q,N.byteLength),q.write(N)}else if(F instanceof s.$Fd)q.write(i.VSBuffer),E(q,F.byteLength),q.write(F);else if(Array.isArray(F)){q.write(i.Array),E(q,F.length);for(const N of F)a(q,N)}else if(typeof F=="number"&&(F|0)===F)q.write(i.Uint),E(q,F);else{const N=s.$Fd.fromString(JSON.stringify(F));q.write(i.Object),E(q,N.byteLength),q.write(N)}}e.$bh=a;function k(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(o(q)).toString();case c.Buffer:return q.read(o(q)).buffer;case c.VSBuffer:return q.read(o(q));case c.Array:{const N=o(q),V=[];for(let X=0;X<N;X++)V.push(k(q));return V}case c.Object:return JSON.parse(q.read(o(q)).toString());case c.Int:return o(q)}}e.$ch=k;class I{constructor(F,N,V=null,X=1e3){this.h=F,this.j=N,this.k=V,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(F,N){this.b.set(F,N),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const N=this.o([F.type]);this.k?.logOutgoing(N,0,1,d(F.type));return}case 201:case 202:case 204:case 203:{const N=this.o([F.type,F.id],F.data);this.k?.logOutgoing(N,F.id,1,d(F.type),F.data);return}}}o(F,N=void 0){const V=new t;return a(V,F),a(V,N),this.p(V.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const N=new u(F),V=k(N),X=k(N),x=V[0];switch(x){case 100:return this.k?.logIncoming(F.byteLength,V[1],1,`${y(x)}: ${V[2]}.${V[3]}`,X),this.s({type:x,id:V[1],channelName:V[2],name:V[3],arg:X});case 102:return this.k?.logIncoming(F.byteLength,V[1],1,`${y(x)}: ${V[2]}.${V[3]}`,X),this.t({type:x,id:V[1],channelName:V[2],name:V[3],arg:X});case 101:return this.k?.logIncoming(F.byteLength,V[1],1,`${y(x)}`),this.u({type:x,id:V[1]});case 103:return this.k?.logIncoming(F.byteLength,V[1],1,`${y(x)}`),this.u({type:x,id:V[1]})}}s(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const V=new M.$pd;let X;try{X=N.call(this.j,F.name,F.arg,V.token)}catch(Y){X=Promise.reject(Y)}const x=F.id;X.then(Y=>{this.m({id:x,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:x,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:x,data:Y,type:203})}).finally(()=>{ce.dispose(),this.d.delete(F.id)});const ce=(0,l.$ic)(()=>V.cancel());this.d.set(F.id,ce)}t(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const V=F.id,x=N.listen(this.j,F.name,F.arg)(ce=>this.m({id:V,data:ce,type:204}));this.d.set(F.id,x)}u(F){const N=this.d.get(F.id);N&&(N.dispose(),this.d.delete(F.id))}v(F){let N=this.g.get(F.channelName);N||(N=[],this.g.set(F.channelName,N));const V=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:F,timeoutTimer:V})}w(F){const N=this.g.get(F);if(N){for(const V of N)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$fc)(this.d.values()),this.d.clear()}}e.$dh=I;var A;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class v{constructor(F,N=null){this.l=F,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=N}getChannel(F){const N=this;return{call(V,X,x){return N.a?Promise.reject(new S.$3):N.m(F,V,X,x)},listen(V,X){return N.a?h.Event.None:N.o(F,V,X)}}}m(F,N,V,X=M.CancellationToken.None){const x=this.g++,Y={id:x,type:100,channelName:F,name:N,arg:V};if(X.isCancellationRequested)return Promise.reject(new S.$3);let R;return new Promise((W,T)=>{if(X.isCancellationRequested)return T(new S.$3);const H=()=>{const ge=ue=>{switch(ue.type){case 201:this.f.delete(x),W(ue.data);break;case 202:{this.f.delete(x);const we=new Error(ue.data.message);we.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,we.name=ue.data.name,T(we);break}case 203:this.f.delete(x),T(ue.data);break}};this.f.set(x,ge),this.p(Y)};let z=null;this.b===g.Idle?H():(z=(0,O.$ug)(ge=>this.u()),z.then(()=>{z=null,H()}));const ne=()=>{z?(z.cancel(),z=null):this.p({id:x,type:101}),T(new S.$3)},fe=X.onCancellationRequested(ne);R=(0,l.$hc)((0,l.$ic)(ne),fe),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(F,N,V){const X=this.g++,ce={id:X,type:102,channelName:F,name:N,arg:V};let Y=null;const R=new h.$fd({onWillAddFirstListener:()=>{Y=(0,O.$ug)(W=>this.u()),Y.then(()=>{Y=null,this.d.add(R),this.p(ce)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(R),this.p({id:X,type:103}))}}),j=W=>R.fire(W.data);return this.f.set(X,j),R.event}p(F){switch(F.type){case 100:case 102:{const N=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(N,F.id,0,`${y(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.q([F.type,F.id]);this.j?.logOutgoing(N,F.id,0,y(F.type));return}}}q(F,N=void 0){const V=new t;return a(V,F),a(V,N),this.r(V.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const N=new u(F),V=k(N),X=k(N),x=V[0];switch(x){case 200:return this.j?.logIncoming(F.byteLength,0,0,d(x)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,V[1],0,d(x),X),this.t({type:V[0],id:V[1],data:X})}}t(F){if(F.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$fc)(this.d.values()),this.d.clear()}}e.$eh=v,ke([D.$6g],v.prototype,"onDidInitializePromise",null);class C{get connections(){const F=[];return this.f.forEach(N=>F.push(N)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new h.$fd,this.onDidAddConnection=this.g.event,this.h=new h.$fd,this.onDidRemoveConnection=this.h.event,this.j=new l.$jc,this.j.add(F(({protocol:N,onDidClientDisconnect:V})=>{const X=h.Event.once(N.onMessage);this.j.add(X(x=>{const ce=new u(x),Y=k(ce),R=new I(N,Y),j=new v(N);this.a.forEach((T,H)=>R.registerChannel(H,T));const W={channelServer:R,channelClient:j,ctx:Y};this.f.add(W),this.g.fire(W),this.j.add(V(()=>{R.dispose(),j.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(F,N){const V=this;return{call(X,x,ce){let Y;if((0,p.$xf)(N)){const j=(0,P.$2b)(V.connections.filter(N));Y=j?Promise.resolve(j):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,N))}else Y=N.routeCall(V,X,x);const R=Y.then(j=>j.channelClient.getChannel(F));return U(R).call(X,x,ce)},listen(X,x){if((0,p.$xf)(N))return V.k(F,N,X,x);const ce=N.routeEvent(V,X,x).then(Y=>Y.channelClient.getChannel(F));return U(ce).listen(X,x)}}}k(F,N,V,X){const x=this;let ce;const Y=new h.$fd({onWillAddFirstListener:()=>{ce=new l.$jc;const R=new h.$ld,j=new Map,W=H=>{const ne=H.channelClient.getChannel(F).listen(V,X),fe=R.add(ne);j.set(H,fe)},T=H=>{const z=j.get(H);z&&(z.dispose(),j.delete(H))};x.connections.filter(N).forEach(W),h.Event.filter(x.onDidAddConnection,N)(W,void 0,ce),x.onDidRemoveConnection(T,void 0,ce),R.event(Y.fire,Y,ce),ce.add(R)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return Y.event}registerChannel(F,N){this.a.set(F,N);for(const V of this.f)V.channelServer.registerChannel(F,N)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=C;class L{constructor(F,N,V=null){const X=new t;a(X,N),F.send(X.buffer),this.a=new v(F,V),this.d=new I(F,N,V)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,N){this.d.registerChannel(F,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=L;function U(q){return{call(F,N,V){return q.then(X=>X.call(F,N,V))},listen(F,N){const V=new h.$od;return q.then(X=>V.input=X.listen(F,N)),V.event}}}e.$hh=U;function B(q){let F=!1;return{call(N,V,X){return F?q.call(N,V,X):(0,O.$Hg)(0).then(()=>F=!0).then(()=>q.call(N,V,X))},listen(N,V){if(F)return q.listen(N,V);const X=new h.$od;return(0,O.$Hg)(0).then(()=>F=!0).then(()=>X.input=q.listen(N,V)),X.event}}}e.$ih=B;class re{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const N of F.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await h.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$jh=re;var ee;(function(q){function F(x,ce,Y){const R=x,j=Y&&Y.disableMarshalling,W=new Map;for(const T in R)V(T)&&W.set(T,h.Event.buffer(R[T],!0,void 0,ce));return new class{listen(T,H,z){const ne=W.get(H);if(ne)return ne;if(X(H)){const fe=R[H];if(typeof fe=="function")return fe.call(R,z)}throw new S.$_(`Event not found: ${H}`)}call(T,H,z){const ne=R[H];if(typeof ne=="function"){if(!j&&Array.isArray(z))for(let fe=0;fe<z.length;fe++)z[fe]=(0,m.$$g)(z[fe]);return ne.apply(R,z)}throw new S.$_(`Method not found: ${H}`)}}}q.fromService=F;function N(x,ce){const Y=ce&&ce.disableMarshalling;return new Proxy({},{get(R,j){if(typeof j=="string")return ce?.properties?.has(j)?ce.properties.get(j):X(j)?function(W){return x.listen(j,W)}:V(j)?x.listen(j):async function(...W){let T;ce&&!(0,p.$sf)(ce.context)?T=[ce.context,...W]:T=W;const H=await x.call(j,T);return Y?H:(0,m.$$g)(H)};throw new S.$_(`Property not found: ${String(j)}`)}})}q.toService=N;function V(x){return x[0]==="o"&&x[1]==="n"&&b.$Le(x.charCodeAt(2))}function X(x){return/^onDynamic/.test(x)&&b.$Le(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const F=q.toString();if(F!=="[object Object]")return F}return q}function oe(q){return Array.isArray(q)?q.map(se):se(q)}function G(q,F,N,V,X,x,ce){ce=oe(ce);const Y=ae[X],R=Y[V%Y.length];let j=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(x)?(j=j.concat(ce),j.push(")")):j.push(ce),console.log.apply(console,j)}class K{constructor(F,N){this.d=F,this.f=N,this.a=0,this.b=0}logOutgoing(F,N,V,X,x){this.b+=F,G(this.d,this.b,F,N,V,X,x)}logIncoming(F,N,V,X,x){this.a+=F,G(this.f,this.a,F,N,V,X,x)}}e.$kh=K}),define(te[157],ie([0,1,17,3,42]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WS=e.$VS=void 0;class M{constructor(h){this.a=h,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",l=>P.$Fd.wrap(l.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$VS=M;class D extends s.$gh{constructor(h,l){const m=new M(h);super(m,l),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$WS=D}),define(te[109],ie([0,1,17,3,2,42]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function k(A,v){if(!n.has(A)){const C=String(++a);n.set(A,C)}return n.get(A)}function I(A,v,C,L){if(!i.enableDiagnostics)return;const U=k(A,v);if(L instanceof P.$Fd||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const B=P.$Fd.alloc(L.byteLength);B.set(L),i.records.push({timestamp:Date.now(),id:U,label:v,type:C,buff:B})}else i.records.push({timestamp:Date.now(),id:U,label:v,type:C,data:L})}i.traceSocketEvent=I})(S||(e.SocketDiagnostics=S={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function m(){return l||(l=P.$Fd.alloc(0)),l}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return m();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const v=this.a[0];return a&&(this.a.shift(),this.b-=n),v}if(this.a[0].byteLength>n){const v=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),v}const k=P.$Fd.alloc(n);let I=0,A=0;for(;n>0;){const v=this.a[A];if(v.byteLength>n){const C=v.slice(0,n);k.set(C,I),I+=n,a&&(this.a[A]=v.slice(n),this.b-=n),n-=n}else k.set(v,I),I+=v.byteLength,a?(this.a.shift(),this.b-=v.byteLength):A++,n-=v.byteLength}return k}}e.$lh=b;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,a,k,I){this.type=n,this.id=a,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends s.$kc{constructor(n){super(),this.f=this.B(new O.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new w(k,I,A,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.$Fd.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const k=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,k}h(){const n=P.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class o extends s.$kc{constructor(n){super(),this.f=new O.$fd,this.onMessage=this.f.event,this.g=new O.$fd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$mh=o;class $ extends M.$gh{static fromSocket(n,a){return new $(new o(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,k=null){super(n,a,k),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$nh=$;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$oh=E;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,k=this.a;for(;k;)n[a++]=k.data,k=k.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new u(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<c.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=c.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+c.a)*1e3;let k=0;for(let I=0;I<c.a;I++)n-this.c[I]<=a&&k++;return 1-k/c.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??c.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$jc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,m());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,m());this.p.write(n)}sendResume(){const n=new w(8,0,0,m());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,m());this.p.write(n);const a=this.b.toArray();for(let k=0,I=a.length;k<I;k++)this.p.write(a[k]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new w(6,0,0,m())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let k=0,I=a.length;k<I;k++)this.p.write(a[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const k=new w(1,a,this.h,n);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(n){const a=new w(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,k=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(a>=2e4&&k>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:k});return}const A=Math.max(2e4-a,2e4-k,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},A)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,m());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,m());this.p.write(n)}}e.$ph=r}),define(te[158],ie([0,1,38,17,3,2,42,146]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZS=void 0;function h(m,b){const p=s.Event.fromNodeEventEmitter(P.$SS,b,(y,w)=>({event:y,message:w})),f=s.Event.filter(p,({event:y})=>y.sender.id===m);return s.Event.map(f,({message:y})=>y&&O.$Fd.wrap(y))}class l extends D.$fh{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(P.$SS,"vscode:hello",({sender:p})=>p);return s.Event.map(b,p=>{const f=p.id;l.b.get(f)?.dispose();const w=new s.$fd;l.b.set(f,(0,M.$ic)(()=>w.fire()));const d=h(f,"vscode:message"),g=s.Event.any(s.Event.signal(h(f,"vscode:disconnect")),w.event);return{protocol:new S.$YS(p,d),onDidClientDisconnect:g}})}constructor(){super(l.d())}}e.$ZS=l}),define(te[110],ie([0,1,38,3,31,157]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=e.$1S=void 0;class D extends M.$WS{constructor(l,m){super({addEventListener:(b,p)=>l.addListener(b,p),removeEventListener:(b,p)=>l.removeListener(b,p),postMessage:b=>l.postMessage(b),start:()=>l.start(),close:()=>l.close()},m)}}e.$1S=D;async function S(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$4f)();h.webContents.send("vscode:createMessageChannel",l);const m=O.Event.fromNodeEventEmitter(P.$SS,"vscode:createMessageChannelResult",(p,f)=>({nonce:f,port:p.ports[0]})),{port:b}=await O.Event.toPromise(O.Event.once(O.Event.filter(m,p=>p.nonce===l)));return b}e.$2S=S}),define(te[159],ie([0,1,47,8,17,22,154,14,3,2,37,88,73,42]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class y extends f.$dh{constructor(g){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",o=>s.$Fd.wrap(Buffer.from(o,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Rp=y;class w{constructor(g,o){this.i=g,this.j=o,this.c=new Set,this.g=new Map,this.h=new h.$fd,this.onDidProcessExit=this.h.event;const $=o&&o.timeout?o.timeout:6e4;this.b=new O.$Dg($),this.d=null,this.f=null}getChannel(g){const o=this;return{call($,E,u){return o.k(g,$,E,u)},listen($,E){return o.l(g,$,E)}}}k(g,o,$,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const u=this.n(g),t=(0,O.$ug)(i=>u.call(o,$,i)),c=E.onCancellationRequested(()=>t.cancel()),r=(0,l.$ic)(()=>t.cancel());return this.c.add(r),t.finally(()=>{c.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,o,$){if(!this.b)return h.Event.None;this.b.cancel();let E;const u=new h.$fd({onWillAddFirstListener:()=>{E=this.n(g).listen(o,$)(u.fire,u),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],o=Object.create(null);o.env={...(0,m.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(o.env={...o.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(o.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$tl)(o.env),this.d=(0,P.fork)(this.i,g,o);const $=new h.$fd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Np)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}$.fire(s.$Fd.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,b.$vl)(this.d):this.d,t=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),c=$.event,r={send:t,onMessage:c};this.f=new f.$eh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(k=>(0,l.$fc)(k)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(g){let o=this.g.get(g);return o||(o=this.m.getChannel(g),this.g.set(g,o)),o}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=w}),define(te[111],ie([0,1,8,3,2,74,12]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function h(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$Qo=h;var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class m extends s.$kc{static{this.a=100}constructor(f,y=Object.create(null)){super(),this.r=f,this.s=y,this.b=this.B(new O.$id),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$Eg(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((y,w)=>this.w(w,y)),f.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(f,y){if(this.c===l.Closed)return;let w=!1;(0,D.$sf)(y)?w=this.f.delete(f):this.f.get(f)!==y&&(this.f.set(f,y),w=!0),w&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,y){const w=this.f.get(f);return(0,D.$sf)(w)?y:w}getBoolean(f,y){const w=this.get(f);return(0,D.$sf)(w)?y:w==="true"}getNumber(f,y){const w=this.get(f);return(0,D.$sf)(w)?y:parseInt(w,10)}getObject(f,y){const w=this.get(f);return(0,D.$sf)(w)?y:(0,M.$0g)(w)}async set(f,y,w=!1){if(this.c===l.Closed)return;if((0,D.$sf)(y))return this.delete(f,w);const d=(0,D.$lf)(y)||Array.isArray(y)?(0,M.$9g)(y):String(y);if(this.f.get(f)!==d)return this.f.set(f,d),this.j.set(f,d),this.h.delete(f),this.b.fire({key:f,external:w}),this.D()}async delete(f,y=!1){if(!(this.c===l.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:y}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Ro=m;class b{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((y,w)=>this.a.set(w,y)),f.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$So=b}),define(te[160],ie([0,1,8,3,33,9,21]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lT=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return O.Event.None}static{this.a=2e3}static{this.b=256}constructor(m,b=Object.create(null)){this.g=m,this.h=b,this.c=(0,M.$ae)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,b=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(f=>b.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(m){const b=await this.f;return this.j(b,m)}j(m,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$xi)(b.insert):"0"}), delete(${b.delete?(0,s.$yi)(b.delete):"0"})`),this.t(m,()=>{const p=b.insert,f=b.delete;if(p&&p.size>0){const y=[];y.push([]);let w=0;p.forEach((d,g)=>{let o=y[w];o.length>S.b&&(w++,o=[],y.push(o)),o.push(g,d)}),y.forEach(d=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array(d.length/2).fill("(?,?)").join(",")}`,g=>g.run(d),()=>{const g=[];let o=0;return p.forEach(($,E)=>{g.push(E),o+=$.length}),`Keys: ${g.join(", ")} Length: ${o}`})})}if(f&&f.size){const y=[];y.push([]);let w=0;f.forEach(d=>{let g=y[w];g.length>S.b&&(w++,g=[],y.push(g)),g.push(d)}),y.forEach(d=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array(d.length).fill("?").join(",")})`,g=>g.run(d),()=>{const g=[];return f.forEach(o=>{g.push(o)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const m=await this.f;return this.q(m,"VACUUM")}async close(m){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,m)}k(m,b){return new Promise((p,f)=>{m.db.close(y=>(y&&this.o(m,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?p():!m.isErroneous&&!m.isInMemory?this.l().then(p,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),p())):typeof b=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const d=()=>this.k(w,void 0);return this.j(w,{insert:b()}).then(()=>d(),g=>(d(),Promise.reject(g)))})).then(p,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return D.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const b=await this.f,p=await this.r(b,m?"PRAGMA integrity_check":"PRAGMA quick_check"),f=m?p.integrity_check:p.quick_check;return b.isErroneous?`${f} (last error: ${b.lastError})`:b.isInMemory?`${f} (in-memory!)`:f}async n(m,b=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${b})`);try{return await this.p(m)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&b)return await(0,P.$Hg)(S.a),this.n(m,!1);try{await D.Promises.unlink(m);try{await D.Promises.rename(this.m(m),m,!1)}catch{}return await this.p(m)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(S.IN_MEMORY_PATH)}}}o(m,b){m.isErroneous=!0,m.lastError=b,this.d.error(b)}p(m){return new Promise((b,p)=>{new Promise((f,y)=>{J(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.d.isTracing?f.verbose().Database:f.Database)(m,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(w)):p(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(y),d=>y.db.close(()=>p(d)))),isInMemory:m===S.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},p)})}q(m,b){return new Promise((p,f)=>{m.db.exec(b,y=>y?(this.o(m,`[storage ${this.c}] exec(): ${y}`),f(y)):p())})}r(m,b){return new Promise((p,f)=>{m.db.get(b,(y,w)=>y?(this.o(m,`[storage ${this.c}] get(): ${y}`),f(y)):p(w))})}s(m,b){return new Promise((p,f)=>{m.db.all(b,(y,w)=>y?(this.o(m,`[storage ${this.c}] all(): ${y}`),f(y)):p(w))})}t(m,b){return new Promise((p,f)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),b(),m.db.run("END TRANSACTION",y=>y?(this.o(m,`[storage ${this.c}] transaction(): ${y}`),f(y)):p())})})}u(m,b,p,f){const y=m.db.prepare(b),w=d=>{this.o(m,`[storage ${this.c}] prepare(): ${d} (${b}). Details: ${f()}`)};y.on("error",w),p(y),y.finalize(d=>{d&&w(d),y.removeListener("error",w)})}}e.$lT=S;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[h.a]&&(this.b=m.logTrace),m&&typeof m.logError=="function"&&(this.c=m.logError)}get isTracing(){return!!this.b}trace(m){this.b?.(m)}error(m){this.c?.(m)}}}),define(te[161],ie([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(te[162],ie([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[163],ie([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[164],ie([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[165],ie([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(te[166],ie([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[167],ie([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[168],ie([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[169],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[170],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[171],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[172],ie([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[173],ie([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[174],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[175],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[176],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[177],ie([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[178],ie([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[179],ie([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[180],ie([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[181],ie([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[182],ie([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[183],ie([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[184],ie([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[185],ie([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[186],ie([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[187],ie([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(te[188],ie([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[189],ie([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[190],ie([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[191],ie([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[192],ie([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[193],ie([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[194],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cU=e.$bU=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$bU=P;function O(s){return s&&s.hasOwnProperty("workspace")}e.$cU=O}),define(te[195],ie([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5b=e.$z5b=e.$y5b=void 0;function O(D){return typeof D?.backupFolder=="string"}e.$y5b=O;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(h=>({workspace:{id:h.id,configPath:P.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$z5b=s;function M(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(h=>({folderUri:P.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$A5b=M}),define(te[196],ie([0,1,14,164]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const D=(0,O.localize)(3,null),S=(0,O.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,P.$6)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const b=this.d,p=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:p};this.g.push({offset:b,lexeme:p,additionalInfo:m}),this.f.push(f)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const b=this.c.substring(this.d,this.e),p=h.b.get(b);p?this.k(p):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,b=!1,p=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(S);return}const y=this.c.charCodeAt(m);if(b)b=!1;else if(y===47&&!p){m++;break}else y===91?p=!0:y===92?b=!0:y===93&&(p=!1);m++}for(;m<this.c.length&&h.a.has(this.c.charCodeAt(m));)m++;this.e=m;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=h}),define(te[197],ie([0,1,3,2]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=void 0;class s{constructor(){this.a=new P.$fd,this.b=new P.$fd,this.c=new P.$fd,this.d=new P.$fd}static{this.ChannelName="extensionhostdebugservice"}call(S,h,l){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(S,h,l){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Bn=s;class M extends O.$kc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,h,l){this.b.call("attach",[S,h,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,h){this.b.call("terminate",[S,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,h){return this.b.call("openExtensionDevelopmentHostWindow",[S,h])}}e.$Cn=M}),define(te[198],ie([0,1,149,55,13,9,35,19,7]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,M.$_d)(s.$2f.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$9d)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,S.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$9d)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$ig)(h.URI.file((0,M.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$9d)(f,"argv.json")):(0,S.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$0d)(f):(0,M.$7d)((0,M.$9d)(s.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,M.$0d)(f)):h.URI.file((0,M.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$0d)(f);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const w=D.env.VSCODE_PORTABLE;return w?(0,M.$9d)(w,"extensions"):(0,S.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,M.$7d)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,M.$7d)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$8l.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const w=e.$8l.exec(y);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$ig)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$9d)(f,"policy.json")):(0,S.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,w){this.a=f,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$9l=l,ke([O.$6g],l.prototype,"appRoot",null),ke([O.$6g],l.prototype,"userHome",null),ke([O.$6g],l.prototype,"userDataPath",null),ke([O.$6g],l.prototype,"appSettingsHome",null),ke([O.$6g],l.prototype,"tmpDir",null),ke([O.$6g],l.prototype,"cacheHome",null),ke([O.$6g],l.prototype,"stateResource",null),ke([O.$6g],l.prototype,"userRoamingDataHome",null),ke([O.$6g],l.prototype,"userDataSyncHome",null),ke([O.$6g],l.prototype,"sync",null),ke([O.$6g],l.prototype,"machineSettingsResource",null),ke([O.$6g],l.prototype,"workspaceStorageHome",null),ke([O.$6g],l.prototype,"localHistoryHome",null),ke([O.$6g],l.prototype,"keyboardLayoutResource",null),ke([O.$6g],l.prototype,"argvResource",null),ke([O.$6g],l.prototype,"isExtensionDevelopment",null),ke([O.$6g],l.prototype,"untitledWorkspacesHome",null),ke([O.$6g],l.prototype,"builtinExtensionsPath",null),ke([O.$6g],l.prototype,"extensionsPath",null),ke([O.$6g],l.prototype,"extensionDevelopmentLocationURI",null),ke([O.$6g],l.prototype,"extensionDevelopmentKind",null),ke([O.$6g],l.prototype,"extensionTestsLocationURI",null),ke([O.$6g],l.prototype,"debugExtensionHost",null),ke([O.$6g],l.prototype,"logLevel",null),ke([O.$6g],l.prototype,"extensionLogLevel",null),ke([O.$6g],l.prototype,"serviceMachineIdResource",null),ke([O.$6g],l.prototype,"disableTelemetry",null),ke([O.$6g],l.prototype,"disableWorkspaceTrust",null),ke([O.$6g],l.prototype,"useInMemorySecretStorage",null),ke([O.$6g],l.prototype,"policyFile",null);function m(p,f){return b(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}e.$0l=m;function b(p,f,y,w,d,g){const $=Number(f||p)||(w?null:y),E=$?!!f:!1;let u;if(g)try{u=JSON.parse(g)}catch{}return{port:$,break:E,debugId:d,env:u}}e.$$l=b}),define(te[112],ie([0,1,307,4,167]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$xl=["tunnel","serve-web"],e.$yl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(w,d,g=D){const o=w.find(a=>a.length>0&&a[0]!=="-"),$={},E=["_"],u=[],t={};let c;for(const a in d){const k=d[a];k.type==="subcommand"?a===o&&(c=k):(k.alias&&($[a]=k.alias),k.type==="string"||k.type==="string[]"?(E.push(a),k.deprecates&&E.push(...k.deprecates)):k.type==="boolean"&&(u.push(a),k.deprecates&&u.push(...k.deprecates)),k.global&&(t[a]=k))}if(c&&o){const a=t;for(const v in c.options)a[v]=c.options[v];const k=w.filter(v=>v!==o),I=g.getSubcommandReporter?g.getSubcommandReporter(o):void 0,A=S(k,a,I);return{[o]:A,_:[]}}const r=P(w,{string:E,boolean:u,alias:$}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in d){const k=d[a];if(k.type==="subcommand")continue;k.alias&&delete n[k.alias];let I=n[a];if(k.deprecates)for(const A of k.deprecates)n.hasOwnProperty(A)&&(I||(I=n[A],I&&g.onDeprecatedOption(A,k.deprecationMessage||(0,s.localize)(37,null,a))),delete n[A]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const A=I.filter(v=>v.length>0);A.length!==I.length&&(g.onEmptyValue(a),I=A.length>0?A:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(a,I)):!I&&!k.allowEmptyValue&&(g.onEmptyValue(a),I=void 0));i[a]=I,k.deprecationMessage&&g.onDeprecatedOption(a,k.deprecationMessage)}delete n[a]}for(const a in n)g.onUnknownOption(a);return i}e.$zl=S;function h(w,d){let g="";return d.args&&(Array.isArray(d.args)?g=` <${d.args.join("> <")}>`:g=` <${d.args}>`),d.alias?`-${d.alias} --${w}${g}`:`--${w}${g}`}function l(w,d){const g=[];for(const o in w){const $=w[o],E=h(o,$);g.push([E,$.description])}return m(g,d)}e.$Al=l;function m(w,d){const o=w.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if(d-o<25)return w.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const $=d-o-1,E=[];for(const u of w){const t=u[0],c=p(u[1],$),r=b(o-t.length-2);E.push("  "+t+r+c[0]);for(let i=1;i<c.length;i++)E.push(b(o)+c[i])}return E}function b(w){return" ".repeat(w)}function p(w,d){const g=[];for(;w.length;){const o=w.length<d?w.length:w.lastIndexOf(" ",d),$=w.slice(0,o).trim();w=w.slice(o),g.push($)}return g}function f(w,d,g,o,$){const E=process.stdout.isTTY&&process.stdout.columns||80,u=$?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${w} ${g}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${d} [${(0,s.localize)(40,null)}]${u}`),t.push(""),$?.noPipe!==!0&&(O.$i?t.push((0,s.localize)(41,null,d)):t.push((0,s.localize)(42,null,d)),t.push(""));const c={},r=[];for(const i in o){const n=o[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=c[n.cat];a||(c[n.cat]=a={}),a[i]=n}}for(const i in c){const n=i,a=c[n];a&&(t.push(M[n]),t.push(...l(a,E)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...m(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.$Bl=f;function y(w,d){return`${w||(0,s.localize)(44,null)}
${d||(0,s.localize)(45,null)}
${process.arch}`}e.$Cl=y}),define(te[199],ie([0,1,87,197,112]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H5b=void 0;class M extends O.$Bn{constructor(S){super(),this.f=S}call(S,h,l){return h==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(S,h,l)}async g(S,h){const l=(0,s.$zl)(S,s.$yl);l.debugRenderer=h;const m=l.extensionDevelopmentPath;if(!m)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const p=b.win;if(!p)return{success:!0};const f=p.webContents.debugger;let y=f.isAttached()?1/0:0;const w=(0,P.createServer)(d=>{y++===0&&f.attach();let g=!1;const o=u=>{g||d.write(JSON.stringify(u)+"\0")},$=(u,t,c,r)=>o({method:t,params:c,sessionId:r});p.on("close",()=>{f.removeListener("message",$),d.end(),g=!0}),f.addListener("message",$);let E=Buffer.alloc(0);d.on("data",u=>{E=Buffer.concat([E,u]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let c;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),c=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(c.method,c.params,c.sessionId).then(r=>o({id:c.id,sessionId:c.sessionId,result:r})).catch(r=>o({id:c.id,sessionId:c.sessionId,error:{code:0,message:r.message}}))}}),d.on("error",u=>{console.error("error on cdp pipe:",u)}),d.on("close",()=>{g=!0,--y===0&&f.detach()})});return await new Promise(d=>w.listen(0,d)),p.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$H5b=M}),define(te[63],ie([0,1,308,168,112]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$El=e.$Dl=void 0;function M(b,p){const f=($,E)=>{console.warn((0,O.localize)(0,null,$,E))},y=$=>{console.warn((0,O.localize)(1,null,$))},w=($,E)=>{console.warn((0,O.localize)(2,null,$,E))},d=$=>({onUnknownOption:E=>{s.$xl.includes($)||console.warn((0,O.localize)(3,null,E,$))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:s.$xl.includes($)?d:void 0}),g={onUnknownOption:$=>{console.warn((0,O.localize)(4,null,$))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:d},o=(0,s.$zl)(b,s.$yl,p?g:void 0);return o.goto&&o._.forEach($=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test($),(0,O.localize)(5,null))),o}function D(b){const p=b.findIndex(f=>!/^-/.test(f));if(p>-1)return[...b.slice(0,p),...b.slice(p+1)]}function S(b){let[,...p]=b;process.env.VSCODE_DEV&&(p=D(p)||[]);const f=!m(process.env);return M(p,f)}e.$Dl=S;function h(b){let[,,...p]=b;return process.env.VSCODE_DEV&&(p=D(p)||[]),M(p,!0)}e.$El=h;function l(b,...p){const f=b.indexOf("--");return f===-1?b.push(...p):b.splice(f,0,...p),b}e.$Fl=l;function m(b){return b.VSCODE_CLI==="1"}e.$Gl=m}),function(){"use strict";function J(e,P,O){function s(D,S){const h=M(D,S),l=[h];return e.isAbsolute(h)||l.unshift(O),e.resolve(...l)}function M(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,S);const m=D["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(b,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,S)}return{getUserDataPath:s}}if(typeof define=="function")define(te[200],ie([113,27,35]),function(e,P,O){return J(e,P,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=J(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,198,200]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class M extends O.$9l{constructor(l,m){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,m.nameShort)},m)}}e.$_l=M;function D(h,l){return(0,O.$$l)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}e.$am=D;function S(h,l){return(0,O.$$l)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}e.$bm=S}),define(te[201],ie([0,1,45,27,32]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=void 0;function M(D){const S=(0,s.$Qf)((0,O.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.$06b=M}),define(te[202],ie([0,1,12,170]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function s(D,S,h,l){try{M(D,S,h,l)}catch(m){D.error(m?.message??m)}return S}e.$np=s;function M(D,S,h,l){const m=(b,p,f)=>{const y=b[p];if((0,P.$jf)(y)){const w=y,d=w.length;if(d>1&&w[0]==="%"&&w[d-1]==="%"){const g=w.substr(1,d-2);let o=h[g];o===void 0&&l&&(o=l[g]);const $=typeof o=="string"?o:o?.message,E=l?.[g],u=typeof E=="string"?E:E?.message;if(!$){u||D.warn(`[${S.name}]: ${(0,O.localize)(0,null,g)}`);return}if(f&&(p==="title"||p==="category")&&u&&u!==$){const t={value:$,original:u};b[p]=t}else b[p]=$}}else if((0,P.$lf)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?m(y,w,!0):m(y,w,f));else if(Array.isArray(y))for(let w=0;w<y.length;w++)m(y,w,f)};for(const b in S)S.hasOwnProperty(b)&&m(S,b)}}),define(te[203],ie([0,1,19,70,172,204]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||D.test(g)}e.$Bo=h;function l(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=g.match(D);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}e.$Co=l;function m(g){if(!g)return null;const o=g.majorBase,$=g.majorMustEqual,E=g.minorBase;let u=g.minorMustEqual;const t=g.patchBase;let c=g.patchMustEqual;g.hasCaret&&(o===0||(u=!1),c=!1);let r=0;if(g.preRelease){const i=S.exec(g.preRelease);if(i){const[,n,a,k]=i;r=Date.UTC(Number(n),Number(a)-1,Number(k))}}return{majorBase:o,majorMustEqual:$,minorBase:E,minorMustEqual:u,patchBase:t,patchMustEqual:c,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$Do=m;function b(g,o,$){let E;typeof g=="string"?E=m(l(g)):E=g;let u;o instanceof Date?u=o.getTime():typeof o=="string"&&(u=new Date(o).getTime());let t;if(typeof $=="string"?t=m(l($)):t=$,!E||!t)return!1;const c=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,a=t.minorBase,k=t.patchBase;const I=t.notBefore;let A=t.majorMustEqual,v=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?c>n?!0:c<n?!1:r>a?!0:r<a||u&&u<I?!1:i>=k:(c===1&&n===0&&(!A||!v||!C)&&(n=1,a=0,k=0,A=!0,v=!1,C=!1),c<n?!1:c>n?!A:r<a?!1:r>a?!v:i<k?!1:i>k?!C:!(u&&u<I))}e.$Eo=b;function p(g,o,$,E,u){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([O.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([O.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([O.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([O.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([O.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!d(E.extensionDependencies))return t.push([O.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!d(E.activationEvents))return t.push([O.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([O.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([O.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([O.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$ig)($,E.main);(0,P.$cg)(i,$)||t.push([O.default.Warning,s.localize(10,null,i.path,$.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([O.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$ig)($,E.browser);(0,P.$cg)(i,$)||t.push([O.default.Warning,s.localize(12,null,i.path,$.path)])}}if(!M.valid(E.version))return t.push([O.default.Error,s.localize(13,null)]),t;const c=[];if(!f(g,o,E,u,c))for(const i of c)t.push([O.default.Error,i]);return t}e.$Fo=p;function f(g,o,$,E,u){return E||typeof $.main>"u"&&typeof $.browser>"u"?!0:w(g,o,$.engines.vscode,u)}e.$Go=f;function y(g,o,$){return g==="*"||w(o,$,g)}e.$Ho=y;function w(g,o,$,E=[]){const u=m(l($));if(!u)return E.push(s.localize(14,null,$)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(s.localize(15,null,$)),!1}else if(!u.majorMustEqual)return E.push(s.localize(16,null,$)),!1;return b(g,o,u)?!0:(E.push(s.localize(17,null,g,$)),!1)}function d(g){if(!Array.isArray(g))return!1;for(let o=0,$=g.length;o<$;o++)if(typeof g[o]!="string")return!1;return!0}}),define(te[205],ie([0,1,17,31]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function s(M,D,S){let h=S&&S.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await D.readFile(M.serviceMachineIdResource)).value.toString();h=(0,O.$3f)(m)?m:null}catch{h=null}if(!h){h=(0,O.$4f)();try{await D.writeFile(M.serviceMachineIdResource,P.$Fd.fromString(h))}catch{}}return S?.store("storage.serviceMachineId",h,-1,1),h}e.$2o=s}),define(te[75],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class P{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$yh=P}),define(te[206],ie([0,1,75]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const O=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,h,l){h instanceof P.$yh||(h=new P.$yh(h,[],!!l)),O.push([S,h])}e.$mr=M;function D(){return O}e.$nr=D}),define(te[207],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class P{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$4p=P;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const S=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(D);S.outgoing.set(h.key,h),h.incoming.set(S.key,S)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let S=this.a.get(D);return S||(S=new P(D,M),this.a.set(D,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,S]of this.a)M.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const S=new Set([M]),h=this.c(D,S);if(h)return h}}c(M,D){for(const[S,h]of M.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const l=this.c(h,D);if(l)return l;D.delete(S)}}}e.$5p=O}),define(te[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$Ah=s("instantiationService");function O(D,S,h){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:h}):(S[P.DI_DEPENDENCIES]=[{id:D,index:h}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(h,l,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(S,h,m)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$Bh=s;function M(D){return D}e.$Ch=M}),define(te[64],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B5b=void 0,e.$B5b=(0,P.$Bh)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,s.$Bh)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof O.URI)}e.$9h=M;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof O.URI)}e.$0h=D;var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function h(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=h;function l(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$_h=l;function m(g,o){const $=Object.create(null);for(const E in g)b($,E,g[E],o);return $}e.$ai=m;function b(g,o,$,E){const u=o.split("."),t=u.pop();let c=g;for(let r=0;r<u.length;r++){const i=u[r];let n=c[i];switch(typeof n){case"undefined":n=c[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${o} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}c=n}if(typeof c=="object"&&c!==null)try{c[t]=$}catch{E(`Ignoring ${o} as ${u.join(".")} is ${JSON.stringify(c)}`)}else E(`Ignoring ${o} as ${u.join(".")} is ${JSON.stringify(c)}`)}e.$bi=b;function p(g,o){const $=o.split(".");f(g,$)}e.$ci=p;function f(g,o){const $=o.shift();if(o.length===0){delete g[$];return}if(Object.keys(g).indexOf($)!==-1){const E=g[$];typeof E=="object"&&!Array.isArray(E)&&(f(E,o),Object.keys(E).length===0&&delete g[$])}}function y(g,o,$){function E(c,r){let i=c;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=o.split("."),t=E(g,u);return typeof t>"u"?$:t}e.$di=y;function w(g,o,$){Object.keys(o).forEach(E=>{E!=="__proto__"&&(E in g?P.$lf(g[E])&&P.$lf(o[E])?w(g[E],o[E],$):$&&(g[E]=o[E]):g[E]=o[E])})}e.$ei=w;function d(g){return g.replace(/[\[\]]/g,"")}e.$fi=d}),define(te[114],ie([0,1,4,26,196,6,163,14]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",P.$j),h.set("isLinux",P.$k),h.set("isWindows",P.$i),h.set("isWeb",P.$o),h.set("isMacNative",P.$j&&!P.$o),h.set("isEdge",P.$G),h.set("isFirefox",P.$E),h.set("isChrome",P.$D),h.set("isSafari",P.$F);function l(Y,R){if(h.get(Y)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Y,R)}e.$Gi=l;const m=Object.prototype.hasOwnProperty;var b;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const p={regexParsingWithErrorRecovery:!0},f=(0,D.localize)(0,null),y=(0,D.localize)(1,null),w=(0,D.localize)(2,null),d=(0,D.localize)(3,null),g=(0,D.localize)(4,null),o=(0,D.localize)(5,null),$=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=p){this.k=R,this.d=new s.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const W=this.D(),T=W.type===17?o:void 0;throw this.h.push({message:g,offset:W.offset,lexeme:s.$Fi.getLexeme(W),additionalInfo:T}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const j=this.o();R.push(j)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const j=this.s();R.push(j)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,d),j?.negate()}case 17:return this.z(),L.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,d),j}case 17:{const j=R.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const H=T.lexeme,z=H.lastIndexOf("/"),ne=z===H.length-1?void 0:this.w(H.substring(z+1));let fe;try{fe=new RegExp(H.substring(1,z),ne)}catch{throw this.B("REGEX",T)}return se.create(j,fe)}switch(T.type){case 10:case 19:{const H=[T.lexeme];this.z();let z=this.D(),ne=0;for(let me=0;me<T.lexeme.length;me++)T.lexeme.charCodeAt(me)===40?ne++:T.lexeme.charCodeAt(me)===41&&ne--;for(;!this.E()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?ne++:T.lexeme.charCodeAt(me)===41&&ne--}if(ne<0)break;H.push(s.$Fi.getLexeme(z)),this.z(),z=this.D()}const fe=H.join(""),ge=fe.lastIndexOf("/"),ue=ge===fe.length-1?void 0:this.w(fe.substring(ge+1));let we;try{we=new RegExp(fe.substring(1,ge),ue)}catch{throw this.B("REGEX",T)}return t.regex(j,we)}case 18:{const H=T.lexeme;this.z();let z=null;if(!(0,O.$me)(H)){const ne=H.indexOf("/"),fe=H.lastIndexOf("/");if(ne!==fe&&ne>=0){const ge=H.slice(ne+1,fe),ue=H[fe+1]==="i"?"i":"";try{z=new RegExp(ge,ue)}catch{throw this.B("REGEX",T)}}}if(z===null)throw this.B("REGEX",T);return se.create(j,z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const T=this.u();return t.notIn(j,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(j,T);switch(T){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(j,T);switch(T){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,T)}}case 5:return this.z(),ee.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),B.create(j,this.u());case 8:return this.z(),re.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:$,offset:R.offset,lexeme:"",additionalInfo:E}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,j){if(this.C(R))return this.z();throw this.B(j,this.D())}B(R,j,W){const T=(0,D.localize)(8,null,R,s.$Fi.getLexeme(j)),H=j.offset,z=s.$Fi.getLexeme(j);return this.h.push({message:T,offset:H,lexeme:z,additionalInfo:W}),u.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=u;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(R){return k.create(R)}static equals(R,j){return I.create(R,j)}static notEquals(R,j){return C.create(R,j)}static regex(R,j){return se.create(R,j)}static in(R,j){return A.create(R,j)}static notIn(R,j){return v.create(R,j)}static not(R){return L.create(R)}static and(...R){return K.create(R,null,!0)}static or(...R){return q.create(R,null,!0)}static greater(R,j){return B.create(R,j)}static greaterEquals(R,j){return re.create(R,j)}static smaller(R,j){return ee.create(R,j)}static smallerEquals(R,j){return ae.create(R,j)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$Ii=t;function c(Y){const R=new u({regexParsingWithErrorRecovery:!1});return Y.map(j=>(R.parse(j),R.lexingErrors.length>0?R.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,D.localize)(9,null,W.additionalInfo):(0,D.localize)(10,null),offset:W.offset,length:W.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.$Ji=c;function r(Y,R){const j=Y?Y.substituteConstants():void 0,W=R?R.substituteConstants():void 0;return!j&&!W?!0:!j||!W?!1:j.equals(W)}e.$Ki=r;function i(Y,R){return Y.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.$Li=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$Mi=a;class k{static create(R,j=null){const W=h.get(R);return typeof W=="boolean"?W?a.INSTANCE:n.INSTANCE:new k(R,j)}constructor(R,j){this.key=R,this.c=j,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:N(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ni=k;class I{static create(R,j,W=null){if(typeof j=="boolean")return j?k.create(R,W):L.create(R,W);const T=h.get(R);return typeof T=="boolean"?j===(T?"true":"false")?a.INSTANCE:n.INSTANCE:new I(R,j,W)}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=h.get(this.c);if(typeof R=="boolean"){const j=R?"true":"false";return this.d===j?a.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Oi=I;class A{static create(R,j){return new A(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:V(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const j=R.getValue(this.f),W=R.getValue(this.d);return Array.isArray(j)?j.includes(W):typeof W=="string"&&typeof j=="object"&&j!==null?m.call(j,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Pi=A;class v{static create(R,j){return new v(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=11,this.c=A.create(R,j)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=v;class C{static create(R,j,W=null){if(typeof j=="boolean")return j?L.create(R,W):k.create(R,W);const T=h.get(R);return typeof T=="boolean"?j===(T?"true":"false")?n.INSTANCE:a.INSTANCE:new C(R,j,W)}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=h.get(this.c);if(typeof R=="boolean"){const j=R?"true":"false";return this.d===j?n.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ri=C;class L{static create(R,j=null){const W=h.get(R);return typeof W=="boolean"?W?n.INSTANCE:a.INSTANCE:new L(R,j)}constructor(R,j){this.c=R,this.d=j,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:N(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=h.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:a.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Si=L;function U(Y,R){if(typeof Y=="string"){const j=parseFloat(Y);isNaN(j)||(Y=j)}return typeof Y=="string"||typeof Y=="number"?R(Y):n.INSTANCE}class B{static create(R,j,W=null){return U(j,T=>new B(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ti=B;class re{static create(R,j,W=null){return U(j,T=>new re(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Ui=re;class ee{static create(R,j,W=null){return U(j,T=>new ee(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Vi=ee;class ae{static create(R,j,W=null){return U(j,T=>new ae(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Wi=ae;class se{static create(R,j){return new se(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const j=this.f?this.f.source:"",W=R.f?R.f.source:"";return j<W?-1:j>W?1:0}equals(R){if(R.type===this.type){const j=this.f?this.f.source:"",W=R.f?R.f.source:"";return this.d===R.d&&j===W}return!1}substituteConstants(){return this}evaluate(R){const j=R.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$Xi=se;class oe{static create(R){return new oe(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new oe(this.c.map(R))}negate(){return this.c}}e.$Yi=oe;function G(Y){let R=null;for(let j=0,W=Y.length;j<W;j++){const T=Y[j].substituteConstants();if(Y[j]!==T&&R===null){R=[];for(let H=0;H<j;H++)R[H]=Y[H]}R!==null&&(R[j]=T)}return R===null?Y:R}class K{static create(R,j,W){return K.d(R,j,W)}constructor(R,j){this.expr=R,this.c=j,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let j=0,W=this.expr.length;j<W;j++){const T=i(this.expr[j],R.expr[j]);if(T!==0)return T}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let j=0,W=this.expr.length;j<W;j++)if(!this.expr[j].equals(R.expr[j]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:K.create(R,this.c,!1)}evaluate(R){for(let j=0,W=this.expr.length;j<W;j++)if(!this.expr[j].evaluate(R))return!1;return!0}static d(R,j,W){const T=[];let H=!1;for(const z of R)if(z){if(z.type===1){H=!0;continue}if(z.type===0)return n.INSTANCE;if(z.type===6){T.push(...z.expr);continue}T.push(z)}if(T.length===0&&H)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(i);for(let z=1;z<T.length;z++)T[z-1].equals(T[z])&&(T.splice(z,1),z--);if(T.length===1)return T[0];for(;T.length>1;){const z=T[T.length-1];if(z.type!==9)break;T.pop();const ne=T.pop(),fe=T.length===0,ge=q.create(z.expr.map(ue=>K.create([ue,ne],null,W)),null,fe);ge&&(T.push(ge),T.sort(i))}if(T.length===1)return T[0];if(W){for(let z=0;z<T.length;z++)for(let ne=z+1;ne<T.length;ne++)if(T[z].negate().equals(T[ne]))return n.INSTANCE;if(T.length===1)return T[0]}return new K(T,j)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const j of this.expr)R.push(...j.keys());return R}map(R){return new K(this.expr.map(j=>j.map(R)),null)}negate(){if(!this.c){const R=[];for(const j of this.expr)R.push(j.negate());this.c=q.create(R,this,!0)}return this.c}}e.$Zi=K;class q{static create(R,j,W){return q.d(R,j,W)}constructor(R,j){this.expr=R,this.c=j,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let j=0,W=this.expr.length;j<W;j++){const T=i(this.expr[j],R.expr[j]);if(T!==0)return T}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let j=0,W=this.expr.length;j<W;j++)if(!this.expr[j].equals(R.expr[j]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:q.create(R,this.c,!1)}evaluate(R){for(let j=0,W=this.expr.length;j<W;j++)if(this.expr[j].evaluate(R))return!0;return!1}static d(R,j,W){let T=[],H=!1;if(R){for(let z=0,ne=R.length;z<ne;z++){const fe=R[z];if(fe){if(fe.type===0){H=!0;continue}if(fe.type===1)return a.INSTANCE;if(fe.type===9){T=T.concat(fe.expr);continue}T.push(fe)}}if(T.length===0&&H)return n.INSTANCE;T.sort(i)}if(T.length!==0){if(T.length===1)return T[0];for(let z=1;z<T.length;z++)T[z-1].equals(T[z])&&(T.splice(z,1),z--);if(T.length===1)return T[0];if(W){for(let z=0;z<T.length;z++)for(let ne=z+1;ne<T.length;ne++)if(T[z].negate().equals(T[ne]))return a.INSTANCE;if(T.length===1)return T[0]}return new q(T,j)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const j of this.expr)R.push(...j.keys());return R}map(R){return new q(this.expr.map(j=>j.map(R)),null)}negate(){if(!this.c){const R=[];for(const j of this.expr)R.push(j.negate());for(;R.length>1;){const j=R.shift(),W=R.shift(),T=[];for(const H of ce(j))for(const z of ce(W))T.push(K.create([H,z],null,!1));R.unshift(q.create(T,null,!1))}this.c=q.create(R,this,!0)}return this.c}}e.$1i=q;class F extends k{static{this.d=[]}static all(){return F.d.values()}constructor(R,j,W){super(R,null),this.f=j,typeof W=="object"?F.d.push({...W,key:R}):W!==!0&&F.d.push({key:R,description:W,type:j!=null?typeof j:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return I.create(this.key,R)}notEqualsTo(R){return C.create(this.key,R)}}e.$2i=F,e.$3i=(0,M.$Bh)("contextKeyService");function N(Y,R){return Y<R?-1:Y>R?1:0}function V(Y,R,j,W){return Y<j?-1:Y>j?1:R<W?-1:R>W?1:0}function X(Y,R){if(Y.type===0||R.type===1)return!0;if(Y.type===9)return R.type===9?x(Y.expr,R.expr):!1;if(R.type===9){for(const j of R.expr)if(X(Y,j))return!0;return!1}if(Y.type===6){if(R.type===6)return x(R.expr,Y.expr);for(const j of Y.expr)if(X(j,R))return!0;return!1}return Y.equals(R)}e.$4i=X;function x(Y,R){let j=0,W=0;for(;j<Y.length&&W<R.length;){const T=Y[j].cmp(R[W]);if(T<0)return!1;T===0&&j++,W++}return j===Y.length}function ce(Y){return Y.type===9?Y.expr:[Y]}}),define(te[90],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.ID=void 0,e.ID="diagnosticsService",e.$gm=(0,P.$Bh)(e.ID);function O(M){return!!M.hostName&&!!M.errorMessage}e.$hm=O;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$im=s}),define(te[91],ie([0,1,19,70,165,6,46,4,37]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sA=e.$rA=e.ConfirmResult=e.$qA=e.$pA=e.$oA=void 0,e.$oA=(0,M.$Bh)("dialogService");var l;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(l||(l={}));class m{a(d){return this.d(d,l.Confirmation)}b(d){return this.d(d,l.Prompt)}c(d){return this.d(d,l.Input)}d(d,g){const o=[];switch(g){case l.Confirmation:{const $=d;$.primaryButton?o.push($.primaryButton):o.push((0,s.localize)(0,null)),$.cancelButton?o.push($.cancelButton):o.push((0,s.localize)(1,null));break}case l.Prompt:{const $=d;Array.isArray($.buttons)&&$.buttons.length>0&&o.push(...$.buttons.map(E=>E.label)),$.cancelButton&&($.cancelButton===!0?o.push((0,s.localize)(2,null)):typeof $.cancelButton=="string"?o.push($.cancelButton):$.cancelButton.label?o.push($.cancelButton.label):o.push((0,s.localize)(3,null))),o.length===0&&o.push((0,s.localize)(4,null));break}case l.Input:{const $=d;$.primaryButton?o.push($.primaryButton):o.push((0,s.localize)(5,null)),$.cancelButton?o.push($.cancelButton):o.push((0,s.localize)(6,null));break}}return o}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===O.default.Info?"info":d===O.default.Error?"error":d===O.default.Warning?"warning":"none"}async f(d,g,o){const $=[...d.buttons??[]];return d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&$.push(d.cancelButton),{result:await $[g]?.run({checkboxChecked:o}),checkboxChecked:o}}}e.$pA=m,e.$qA=(0,M.$Bh)("fileDialogService");var b;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const p=10;function f(w){const d=[];return d.push(...w.slice(0,p).map(g=>typeof g=="string"?g:(0,P.$fg)(g))),w.length>p&&(w.length-p===1?d.push((0,s.localize)(7,null)):d.push((0,s.localize)(8,null,w.length-p))),d.push(""),d.join(`
`)}e.$rA=f;function y(w,d){const g=(0,h.$Vm)(w);let o=(g.buttons??[]).map(t=>(0,D.$lA)(t)),$=(w.buttons||[]).map((t,c)=>c),E=0,u=g.cancelId??o.length-1;if(o.length>1){const t=typeof u=="number"?o[u]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&o.length>1&&u!==1){o.splice(u,1),o.splice(1,0,t);const c=$[u];$.splice(u,1),$.splice(1,0,c),u=1}S.$k&&o.length>1&&(o=o.reverse(),$=$.reverse(),E=o.length-1,typeof t=="string"&&(u=E-1))}else if(S.$i&&typeof t=="string"&&o.length>1&&u!==o.length-1){o.splice(u,1),o.push(t);const c=$[u];$.splice(u,1),$.push(c),u=o.length-1}}return g.buttons=o,g.defaultId=E,g.cancelId=u,g.noLink=!0,g.title=g.title||d.nameLong,{options:g,buttonIndeces:$}}e.$sA=y}),define(te[115],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CT=e.$BT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$AT=e.$zT=void 0,e.$zT=(0,P.$Bh)("encryptionService"),e.$AT=(0,P.$Bh)("encryptionMainService");var O;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(O||(e.PasswordStoreCLIOption=O={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$BT=M;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$CT=D}),define(te[36],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,P.$Bh)("environmentService"),e.$Jh=(0,P.$Ch)(e.$Ih)}),define(te[116],ie([0,1,169,6]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function s(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=s;function M(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=M;function D(o,$){switch(o){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=D;function S(o,$){return $==="web"&&!o.includes("web")}e.$Vn=S;function h(o,$,E){return S($,E)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===E?!0:l(E).includes(o)}e.$Wn=h;function l(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=l;function m(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Yn=m;var b;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var p;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var f;(function(o){o.Install="install",o.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Zn=(0,O.$Bh)("extensionGalleryService");var w;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var d;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class g extends Error{constructor($,E){super($),this.code=E,this.name=E}}e.$1n=g,e.$2n=(0,O.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,O.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,O.$Bh)("IExtensionTipsService"),e.$7n=(0,P.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,P.localize)(1,null),original:"Preferences"}}),define(te[208],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kb=void 0,e.$7kb=(0,P.$Bh)("extensionUrlTrustService")}),define(te[209],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X5b=e.$W5b=void 0,e.$W5b=(0,P.$Bh)("extensionHostStarter"),e.$X5b="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fXb=e.$eXb=e.$dXb=void 0,e.$dXb=(0,P.$Bh)("externalTerminal"),e.$eXb="Terminal.app",e.$fXb=(0,P.$Bh)("externalTerminal")}),define(te[210],ie([0,1,47,13,9,4,73,21,88,173,117]),function(J,e,P,O,s,M,D,S,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=e.$Z5b=void 0;const b=l.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends p{static{this.b="cmd.exe"}openTerminal(E,u){return this.spawnTerminal(P,E,h.$ul(),u)}spawnTerminal(E,u,t,c){const r=u.windowsExec||f.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const i=s.$ae(r,".exe").toLowerCase();if(i==="cmder")return E.spawn(r,c?[c]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((a,k)=>{const I=d(process),A=E.spawn(t,n,{cwd:c,env:I});A.on("error",k),A.on("exit",()=>a())})}runInTerminal(E,u,t,c,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,a)=>{const k=`"${u} - ${b}"`,I=`""${t.join('" "')}" & pause"`,A=Object.assign({},d(process),c);Object.keys(A).filter(B=>A[B]===null).forEach(B=>delete A[B]);const v={cwd:u,env:A,windowsVerbatimArguments:!0};let C,L;s.$ae(i,".exe")==="wt"?(C=i,L=["-d",".",f.b,"/c",I]):(C=f.b,L=["/c","start",k,"/wait",i,"/c",I]),P.spawn(C,L,v).on("error",B=>{a(g(B))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$Z5b=f;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(E,u){return this.spawnTerminal(P,E,u)}runInTerminal(E,u,t,c,r){const i=r.osxExec||m.$eXb;return new Promise((n,a)=>{if(i===m.$eXb||i==="iTerm.app"){const k=i===m.$eXb?"TerminalHelper":"iTermHelper",A=[O.$2f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",E||b,"-w",u];for(const L of t)A.push("-a"),A.push(L);if(c){const L=Object.assign({},d(process),c);for(const U in L){const B=L[U];B===null?(A.push("-u"),A.push(U)):(A.push("-e"),A.push(`${U}=${B}`))}}let v="";const C=P.spawn(y.b,A);C.on("error",L=>{a(g(L))}),C.stderr.on("data",L=>{v+=L.toString()}),C.on("exit",L=>{if(L===0)n(void 0);else if(v){const U=v.split(`
`,1);a(new Error(U[0]))}else a(new Error(l.localize(1,null,k,L)))})}else a(new Error(l.localize(2,null,i)))})}spawnTerminal(E,u,t){const c=u.osxExec||m.$eXb;return new Promise((r,i)=>{const n=["-a",c];t&&n.push(t);const a=d(process),k=E.spawn("/usr/bin/open",n,{cwd:t,env:a});k.on("error",i),k.on("exit",()=>r())})}}e.$15b=y;class w extends p{static{this.b=l.localize(3,null)}openTerminal(E,u){return this.spawnTerminal(P,E,u)}runInTerminal(E,u,t,c,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,a)=>{const k=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const A=`${o(t)}; echo; read -p "${w.b}" -n1;`;k.push(`''${A}''`);const v=Object.assign({},d(process),c);Object.keys(v).filter(B=>v[B]===null).forEach(B=>delete v[B]);const C={cwd:u,env:v};let L="";const U=P.spawn(I,k,C);U.on("error",B=>{a(g(B))}),U.stderr.on("data",B=>{L+=B.toString()}),U.on("exit",B=>{if(B===0)n(void 0);else if(L){const re=L.split(`
`,1);a(new Error(re[0]))}else a(new Error(l.localize(4,null,I,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!M.$k)w.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");w.d=new Promise(u=>{E?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w.d}spawnTerminal(E,u,t){const c=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{c.then(n=>{const a=d(process),k=E.spawn(n,[],{cwd:t,env:a});k.on("error",i),k.on("exit",()=>r())})})}}e.$25b=w;function d($){const E={...$.env};return(0,D.$sl)(E),E}function g($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(l.localize(5,null,$.path)):$}function o($){let E="";for(const u of $)u.indexOf(" ")>=0?E+='"'+u+'"':E+=u,E+=" ";return E}}),define(te[16],ie([0,1,58,9,26,12,7,175,6,4,13]),function(J,e,P,O,s,M,D,S,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,h.$Bh)("fileService");function b(N){return N.create===!0}e.$7j=b;var p;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var f;(function(N){N[N.Readonly=1]="Readonly",N[N.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileAtomicWrite=32768]="FileAtomicWrite",N[N.FileAtomicDelete=65536]="FileAtomicDelete",N[N.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function w(N){return!!(N.capabilities&2)}e.$8j=w;function d(N){return!!(N.capabilities&8)}e.$9j=d;function g(N){return!!(N.capabilities&131072)}e.$0j=g;function o(N){return!!(N.capabilities&4)}e.$$j=o;function $(N){return!!(N.capabilities&16)}e.$_j=$;function E(N){return w(N)?!!(N.capabilities&16384):!1}e.$ak=E;function u(N){return w(N)?!!(N.capabilities&32768):!1}e.$bk=u;function t(N){return!!(N.capabilities&65536)}e.$ck=t;function c(N){return!!(N.capabilities&2048)}e.$dk=c;var r;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsStorageQuota="EntryExceedsStorageQuota",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(V,X){const x=new i(V.toString(),X);return k(x,X),x}constructor(V,X){super(V),this.code=X}}e.$ek=i;function n(N,V){return i.create(N,V)}e.$fk=n;function a(N){return N||n((0,S.localize)(0,null),r.Unknown)}e.$gk=a;function k(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.$hk=k;function I(N){if(!N)return r.Unknown;if(N instanceof i)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return r.Unknown;switch(V[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$ik=I;function A(N){if(N instanceof re)return N.fileOperationResult;switch(I(N)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$jk=A;var v;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(v||(e.FileOperation=v={}));class C{constructor(V,X,x){this.resource=V,this.operation=X,this.target=x}isOperation(V){return this.operation===V}}e.$kk=C;var L;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class U{constructor(V,X){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const x=new Map;for(const ce of V){const Y=x.get(ce.type);switch(Y?Y.push([ce.resource,ce]):x.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,Y]of x)switch(ce){case 1:this.a=P.$Hh.forUris(()=>X),this.a.fill(Y);break;case 0:this.b=P.$Hh.forUris(()=>X),this.b.fill(Y);break;case 2:this.c=P.$Hh.forUris(()=>X),this.c.fill(Y);break}}contains(V,...X){return this.d(V,{includeChildren:!1},...X)}affects(V,...X){return this.d(V,{includeChildren:!0},...X)}d(V,X,...x){if(!V)return!1;const ce=x.length>0;return!!((!ce||x.includes(1))&&(this.a?.get(V)||X.includeChildren&&this.a?.findSuperstr(V))||(!ce||x.includes(0))&&(this.b?.get(V)||X.includeChildren&&this.b?.findSuperstr(V))||(!ce||x.includes(2))&&(this.c?.findSubstr(V)||X.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=U;function B(N,V,X){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==O.sep&&(V+=O.sep),X?(0,s.$Ne)(N,V):N.indexOf(V)===0)}e.$mk=B;class re extends Error{constructor(V,X,x){super(V),this.fileOperationResult=X,this.options=x}}e.$nk=re;class ee extends re{constructor(V,X,x,ce){super(V,X,ce),this.fileOperationResult=X,this.size=x}}e.$ok=ee;class ae extends re{constructor(V,X,x){super(V,2,x),this.stat=X}}e.$pk=ae;var se;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var oe;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe||(e.FileKind=oe={})),e.$xk="";function G(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.$yk=G;async function K(N,V){if(!V.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(X=>{const x=V.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===N.scheme&&ce.added&&(x.dispose(),X())})})}e.$zk=K;class q{static{this.KB=1024}static{this.MB=q.KB*q.KB}static{this.GB=q.MB*q.KB}static{this.TB=q.GB*q.KB}static formatSize(V){return(0,M.$nf)(V)||(V=0),V<q.KB?(0,S.localize)(1,null,V.toFixed(0)):V<q.MB?(0,S.localize)(2,null,(V/q.KB).toFixed(2)):V<q.GB?(0,S.localize)(3,null,(V/q.MB).toFixed(2)):V<q.TB?(0,S.localize)(4,null,(V/q.GB).toFixed(2)):(0,S.localize)(5,null,(V/q.TB).toFixed(2))}}e.$Ak=q;function F(N){const V=typeof N=="string"||N?.scheme===m.Schemas.vscodeRemote;return typeof N!="string"&&N?.scheme===m.Schemas.file?1024*q.MB:V?10*q.MB:l.$o?50*q.MB:1024*q.MB}e.$Bk=F}),define(te[211],ie([0,1,17,50,14,3,2,56,7,31,16]),function(J,e,P,O,s,M,D,S,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M="localFilesystem";class b extends D.$kc{constructor(f,y){super(),this.a=f,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$fd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$fd),this.onDidWatchError=this.g.event,this.h=(0,l.$4f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,y){const{buffer:w}=await this.a.call("readFile",[f,y]);return w}readFileStream(f,y,w){const d=(0,S.$td)(o=>P.$Fd.concat(o.map($=>P.$Fd.wrap($))).buffer),g=new D.$jc;return g.add(this.a.listen("readFileStream",[f,y])(o=>{if(o instanceof P.$Fd)d.write(o.buffer);else{if(o==="end")d.end();else{let $;if(o instanceof Error)$=o;else{const E=o;$=(0,m.$fk)(E.message??(0,O.$mi)(E),E.code??m.FileSystemProviderErrorCode.Unknown)}d.error($),d.end()}g.dispose()}})),g.add(w.onCancellationRequested(()=>{d.error((0,s.$4)()),d.end(),g.dispose()})),d}writeFile(f,y,w){return this.a.call("writeFile",[f,P.$Fd.wrap(y),w])}open(f,y){return this.a.call("open",[f,y])}close(f){return this.a.call("close",[f])}async read(f,y,w,d,g){const[o,$]=await this.a.call("read",[f,y,g]);return w.set(o.buffer.slice(0,$),d),$}write(f,y,w,d,g){return this.a.call("write",[f,y,P.$Fd.wrap(w),d,g])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,y){return this.a.call("delete",[f,y])}rename(f,y,w){return this.a.call("rename",[f,y,w])}copy(f,y,w){return this.a.call("copy",[f,y,w])}cloneFile(f,y){return this.a.call("cloneFile",[f,y])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const y=f;this.f.fire(y.map(w=>({resource:h.URI.revive(w.resource),type:w.type})))}else{const y=f;this.g.fire(y)}}))}watch(f,y){const w=(0,l.$4f)();return this.a.call("watch",[this.h,w,f,y]),(0,D.$ic)(()=>this.a.call("unwatch",[this.h,w]))}}e.$8M=b}),define(te[118],ie([0,1,17,14,176,16]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function D(m,b,p,f,y,w){let d;try{await S(m,b,p,f,y,w)}catch(g){d=g}finally{d&&y.errorTransformer&&(d=y.errorTransformer(d)),typeof d<"u"&&p.error(d),p.end()}}e.$Cp=D;async function S(m,b,p,f,y,w){h(w);const d=await m.open(b,{create:!1});try{h(w);let g=0,o=0,$=y&&typeof y.length=="number"?y.length:void 0,E=P.$Fd.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,t=0;do o=await m.read(d,u,E.buffer,t,E.byteLength-t),u+=o,t+=o,g+=o,typeof $=="number"&&($-=o),t===E.byteLength&&(await p.write(f(E)),E=P.$Fd.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),t=0);while(o>0&&(typeof $!="number"||$>0)&&h(w)&&l(g,y));if(t>0){let c=t;typeof $=="number"&&(c=Math.min(t,$)),p.write(f(E.slice(0,c)))}}catch(g){throw(0,M.$gk)(g)}finally{await m.close(d)}}function h(m){if(m.isCancellationRequested)throw(0,O.$4)();return!0}function l(m,b){if(typeof b?.limits?.size=="number"&&m>b.limits.size)throw(0,M.$fk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,4,7,16]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function h(g){return g.recursive===!0}e.$Ep=h;class l extends O.$kc{static{this.a=5}constructor(o,$,E,u){super(),this.h=o,this.j=$,this.m=E,this.n=u,this.c=this.B(new O.$lc),this.f=void 0,this.g=0}s(){const o=new O.$jc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile($=>this.h($))),o.add(this.b.onDidLogMessage($=>this.j($))),o.add(this.b.onDidError($=>this.t($)))}t(o){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=l;class m extends l{constructor(o,$,E){super(o,$,E,{type:"node.js",restartOnError:!1})}}e.$Gp=m;class b extends l{constructor(o,$,E){super(o,$,E,{type:"universal",restartOnError:!0})}}e.$Hp=b;function p(g){return g.map(o=>({type:o.type,resource:D.URI.file(o.path)}))}e.$Ip=p;function f(g){const o=new d;for(const $ of g)o.processEvent($);return o.coalesce()}e.$Jp=f;function y(g,o){return typeof o=="string"&&!o.startsWith(P.$nj)&&!(0,s.$8d)(o)?{base:g,pattern:o}:o}e.$Kp=y;function w(g,o){const $=[];for(const E of o)$.push((0,P.$rj)(y(g,E)));return $}e.$Lp=w;class d{constructor(){this.a=new Set,this.b=new Map}c(o){return M.$k?o.path:o.path.toLowerCase()}processEvent(o){const $=this.b.get(this.c(o));let E=!1;if($){const u=$.type,t=o.type;$.path!==o.path&&(o.type===2||o.type===1)?E=!0:u===1&&t===2?(this.b.delete(this.c(o)),this.a.delete($)):u===2&&t===1?$.type=0:u===1&&t===0||($.type=t)}else E=!0;E&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],$=[];return Array.from(this.a).filter(E=>E.type!==2?(o.push(E),!1):!0).sort((E,u)=>E.path.length-u.path.length).filter(E=>$.some(u=>(0,S.$mk)(E.path,u,!M.$k))?!1:($.push(E.path),!0)).concat(o)}}}),define(te[212],ie([0,1,45,8,22,32,2,85,9,4,105,21,76]),function(J,e,P,O,s,M,D,S,h,l,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class f extends D.$kc{static{this.a=100}static{this.b=75}constructor(d,g,o,$){super(),this.m=d,this.n=g,this.r=o,this.s=$,this.c=this.B(new O.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.n(E))),this.f=this.B(new O.$Ug(E=>this.z(E),f.b)),this.g=(0,p.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$Lp)(this.m.path,this.m.includes):void 0,this.j=new s.$pd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const g=await b.Promises.stat(d);this.B(await this.w(d,g.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let g=d.path;try{g=await b.Promises.realpath(d.path),d.path===g&&(g=await(0,m.$Vp)(d.path)??d.path),d.path!==g&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${g})`)}catch{}return g}async w(d,g){if(l.$j&&(0,M.$If)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$kc.None;const o=new s.$pd(this.j.token),$=new D.$jc;try{const E=(0,h.$ae)(d),u=(0,P.watch)(d);$.add((0,D.$ic)(()=>{u.removeAllListeners(),u.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(g)try{for(const r of await b.Promises.readdir(d))t.add(r)}catch(r){this.D(r)}const c=new Map;$.add((0,D.$ic)(()=>{for(const[,r]of c)r.dispose();c.clear()})),u.on("error",(r,i)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),u.on("change",(r,i)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),l.$j&&(n=(0,S.$hl)(n))),!(!n||r!=="change"&&r!=="rename"))if(g)if(r==="rename"){c.get(n)?.dispose();const a=setTimeout(async()=>{if(c.delete(n),n===E&&!await b.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,h.$9d)(d,n));if(o.token.isCancellationRequested)return;let I;k?t.has(n)?I=0:(I=1,t.add(n)):(t.delete(n),I=2),this.y({path:(0,h.$9d)(this.m.path,n),type:I})},f.a);c.set(n,(0,D.$ic)(()=>clearTimeout(a)))}else{let a;t.has(n)?a=0:(a=1,t.add(n)),this.y({path:(0,h.$9d)(this.m.path,n),type:a})}else if(r==="rename"||n!==E){const a=setTimeout(async()=>{const k=await b.Promises.exists(d);o.token.isCancellationRequested||(k?(this.y({path:this.m.path,type:0},!0),$.add(await this.w(d,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);$.clear(),$.add((0,D.$ic)(()=>clearTimeout(a)))}else this.y({path:this.m.path,type:0},!0)})}catch(E){await b.Promises.exists(d)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${E.toString()})`)}return(0,D.$ic)(()=>{o.dispose(!0),$.dispose()})}y(d,g=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!g&&this.g.some(o=>o(d.path))?this.s&&this.G(` >> ignored (excluded) ${d.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(o=>o(d.path))?this.s&&this.G(` >> ignored (not included) ${d.path}`):this.f.work(d))}z(d){const g=(0,p.$Jp)(d);if(g.length>0){if(this.s)for(const $ of g)this.G(`>> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.path}`);this.c.work(g)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(l.$k)return b.Promises.exists(d);try{const g=(0,h.$ae)(d);return(await b.Promises.readdir((0,h.$_d)(d))).some($=>$===g)}catch(g){return this.G(g),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=f;async function y(w,d,g,o,$=512){const E=await b.Promises.open(w,"r"),u=Buffer.allocUnsafe($),t=new s.$pd(o);let c,r=!1;const i={path:w,excludes:[],recursive:!1},n=new f(i,a=>{(async()=>{for(const{type:k}of a)if(k===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await b.Promises.read(E,u,0,$,null);if(!I||t.token.isCancellationRequested)break;d(u.slice(0,I))}}catch(I){c=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,g(),new Promise((a,k)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await b.Promises.close(E)}catch(I){c=new Error(I)}c?k(c):a()})})}e.$Zp=y}),define(te[213],ie([0,1,3,104,2,4,212]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class S extends s.$kc{constructor(){super(...arguments),this.a=this.B(new P.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$fd),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(l){const m=this.j(l),b=m.filter(f=>{const y=this.c.get(f.path);return y?!(0,O.$vj)(y.request.excludes,f.excludes)||!(0,O.$vj)(y.request.includes,f.includes):!0}),p=Array.from(this.c.values()).filter(({request:f})=>!m.find(y=>y.path===f.path&&(0,O.$vj)(y.excludes,f.excludes)&&(0,O.$vj)(y.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.m(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const f of p)this.h(f);for(const f of b)this.g(f)}g(l){const m=new D.$Yp(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),b={request:l,instance:m};this.c.set(l.path,b)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const m=this.c.get(l);m&&(this.c.delete(l),m.instance.dispose())}j(l){const m=new Map;for(const b of l){const p=M.$k?b.path:b.path.toLowerCase();m.set(p,b)}return Array.from(m.values())}async setVerboseLogging(l){this.f=l;for(const[,m]of this.c)m.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,m){return m?`[File Watcher (node.js)] ${l} (path: ${m.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$1p=S}),define(te[214],ie([0,1,76,213]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class s extends P.$Gp{constructor(D,S,h){super(D,S,h),this.s()}r(D){return D.add(new O.$1p)}}e.$2p=s}),define(te[215],ie([0,1,13,42,159,76]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class D extends M.$Hp{constructor(h,l,m){super(h,l,m),this.s()}r(h){const l=h.add(new s.$Sp(P.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:m,signal:b})=>this.t(`terminated by itself with code ${m}, signal: ${b}`))),O.ProxyChannel.toService((0,O.$ih)(l.getChannel("watcher")))}}e.$Tp=D}),define(te[92],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$zh=P}),define(te[216],ie([0,1,8,14,2,75,207,6,92,101]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const m=!1;class b extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class p{constructor(d=new h.$zh,g=!1,o,$=m){this.f=d,this.g=g,this.h=o,this.i=$,this.o=new Set,this.f.set(S.$Ah,this),this._globalGraph=$?o?._globalGraph??new D.$5p(E=>E):void 0}createChild(d){return new p(d,this.g,this,this.i)}invokeFunction(d,...g){const o=y.traceInvocation(this.i,d);let $=!1;try{return d({get:u=>{if($)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(u,o);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...g)}finally{$=!0,o.stop()}}createInstance(d,...g){let o,$;return d instanceof M.$yh?(o=y.traceCreation(this.i,d.ctor),$=this.j(d.ctor,d.staticArguments.concat(g),o)):(o=y.traceCreation(this.i,d),$=this.j(d,g,o)),o.stop(),$}j(d,g=[],o){const $=S._util.getServiceDependencies(d).sort((t,c)=>t.index-c.index),E=[];for(const t of $){const c=this.m(t.id,o);c||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(c)}const u=$.length>0?$[0].index:g.length;if(g.length!==u){console.trace(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${g.length} static arguments`);const t=u-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,u)}return Reflect.construct(d,g.concat(E))}k(d,g){if(this.f.get(d)instanceof M.$yh)this.f.set(d,g);else if(this.h)this.h.k(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const g=this.f.get(d);return!g&&this.h?this.h.l(d):g}m(d,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const o=this.l(d);return o instanceof M.$yh?this.q(d,o,g.branch(d,!0)):(g.branch(d,!1),o)}q(d,g,o){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,g,o)}finally{this.o.delete(d)}}r(d,g,o){const $=new D.$5p(t=>t.id.toString());let E=0;const u=[{id:d,desc:g,_trace:o}];for(;u.length;){const t=u.pop();if($.lookupOrInsertNode(t),E++>1e3)throw new b($);for(const c of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(c.id);if(r||this.u(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),r instanceof M.$yh){const i={id:c.id,desc:r,_trace:t._trace.branch(c.id,!0)};$.insertEdge(t,i),u.push(i)}}}for(;;){const t=$.roots();if(t.length===0){if(!$.isEmpty())throw new b($);break}for(const{data:c}of t){if(this.l(c.id)instanceof M.$yh){const i=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,i)}$.removeNode(c)}}return this.l(d)}s(d,g,o=[],$,E){if(this.f.get(d)instanceof M.$yh)return this.t(d,g,o,$,E);if(this.h)return this.h.s(d,g,o,$,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(d,g,o=[],$,E){if($){const u=new p(void 0,this.g,this,this.i);u.c=String(d);const t=new Map,c=new P.$Xg(()=>{const r=u.j(g,o,E);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const k of n)a.apply(r,k)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!c.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let k=t.get(i);return k||(k=new l.$tc,t.set(i,k)),(A,v,C)=>{const L=k.push([A,v,C]);return(0,s.$ic)(L)}}if(i in r)return r[i];const n=c.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return c.value[i]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,o,E)}u(d,g){if(g&&console.warn(d),this.g)throw new Error(d)}}e.$6p=p;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,g){return d?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(d,g){return d?new y(1,g.name):y.c}static{this.f=0}constructor(d,g){this.type=d,this.name=g,this.g=Date.now(),this.h=[]}branch(d,g){const o=new y(3,d.toString());return this.h.push([d,g,o]),o}stop(){const d=Date.now()-this.g;y.f+=d;let g=!1;function o(E,u){const t=[],c=new Array(E+1).join("	");for(const[r,i,n]of u.h)if(i&&n){g=!0,t.push(`${c}CREATES -> ${r}`);const a=o(E+1,n);a&&t.push(a)}else t.push(`${c}uses -> ${r}`);return t.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${o(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(d>2||g)&&y.all.add($.join(`
`))}}e.$7p=y}),define(te[217],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtb=e.IssueType=void 0;var O;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(O||(e.IssueType=O={})),e.$qtb=(0,P.$Bh)("issueService")}),define(te[5],ie([0,1,50,3,57,2,33,4,19,12,7,114,6]),function(J,e,P,O,s,M,D,S,h,l,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,p.$Bh)("logService"),e.$6i=(0,p.$Bh)("loggerService");function f(){return new Date().toISOString()}function y(A){return(0,l.$nf)(A)}e.$7i=y;var w;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8i=w.Info;function d(A,v,C){switch(v){case w.Trace:A.trace(C);break;case w.Debug:A.debug(C);break;case w.Info:A.info(C);break;case w.Warning:A.warn(C);break;case w.Error:A.error(C);break;case w.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=d;function g(A,v=!1){let C="";for(let L=0;L<A.length;L++){let U=A[L];if(U instanceof Error&&(U=(0,P.$mi)(U,v)),typeof U=="object")try{U=JSON.stringify(U)}catch{}C+=(L>0?" ":"")+U}return C}class o extends M.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new O.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==w.Off&&this.b<=v}}e.$0i=o;class $ extends o{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...C){this.f(w.Trace)&&this.g(w.Trace,g([v,...C],!0))}debug(v,...C){this.f(w.Debug)&&this.g(w.Debug,g([v,...C]))}info(v,...C){this.f(w.Info)&&this.g(w.Info,g([v,...C]))}warn(v,...C){this.f(w.Warning)&&this.g(w.Warning,g([v,...C]))}error(v,...C){if(this.f(w.Error))if(v instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=v.stack,this.g(w.Error,g(L))}else this.g(w.Error,g([v,...C]))}flush(){}}e.$$i=$;class E extends o{constructor(v=e.$8i){super(),this.setLevel(v),this.g=!S.$i}trace(v,...C){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...C):console.log(`[main ${f()}]`,v,...C))}debug(v,...C){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...C):console.log(`[main ${f()}]`,v,...C))}info(v,...C){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...C):console.log(`[main ${f()}]`,v,...C))}warn(v,...C){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,v,...C):console.warn(`[main ${f()}]`,v,...C))}error(v,...C){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,v,...C):console.error(`[main ${f()}]`,v,...C))}dispose(){}flush(){}}e.$_i=E;class u extends o{constructor(v=e.$8i,C=!0){super(),this.g=C,this.setLevel(v)}trace(v,...C){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...C):console.log(v,...C))}debug(v,...C){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...C):console.log(v,...C))}info(v,...C){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...C):console.log(v,...C))}warn(v,...C){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...C):console.log(v,...C))}error(v,...C){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...C):console.error(v,...C))}dispose(){}flush(){}}e.$aj=u;class t extends o{constructor(v,C=e.$8i){super(),this.g=v,this.setLevel(C)}trace(v,...C){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(v),...C])}debug(v,...C){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(v),...C])}info(v,...C){this.f(w.Info)&&this.g.log(w.Info,[this.h(v),...C])}warn(v,...C){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(v),...C])}error(v,...C){this.f(w.Error)&&this.g.log(w.Error,[this.h(v),...C])}h(v){return typeof v=="string"?v:(0,P.$mi)(v,this.f(w.Trace))}dispose(){}flush(){}}e.$bj=t;class c extends o{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const C of this.g)C.setLevel(v);super.setLevel(v)}trace(v,...C){for(const L of this.g)L.trace(v,...C)}debug(v,...C){for(const L of this.g)L.debug(v,...C)}info(v,...C){for(const L of this.g)L.info(v,...C)}warn(v,...C){for(const L of this.g)L.warn(v,...C)}error(v,...C){for(const L of this.g)L.error(v,...C)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose()}}e.$cj=c;class r extends M.$kc{constructor(v,C,L){if(super(),this.h=v,this.j=C,this.b=new D.$zi,this.c=this.B(new O.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$fd),this.onDidChangeVisibility=this.g.event,L)for(const U of L)this.b.set(U.resource,{logger:void 0,info:U})}m(v){return(0,l.$jf)(v)?[...this.b.values()].find(C=>C.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,C){const L=this.n(v),U=(0,l.$jf)(v)?v:C?.id??(0,s.$pi)(L.toString()).toString(16);let B=this.b.get(L)?.logger;const re=C?.logLevel==="always"?w.Trace:C?.logLevel;B||(B=this.s(L,re??this.getLogLevel(L)??this.h,{...C,id:U}));const ee={logger:B,info:{resource:L,id:U,logLevel:re,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(ee.info),this.b.set(L,ee),B}n(v){return(0,l.$jf)(v)?(0,h.$ig)(this.j,`${v}.log`):v}setLogLevel(v,C){if(m.URI.isUri(v)){const L=v,U=C,B=this.b.get(L);B&&U!==B.info.logLevel&&(B.info.logLevel=U===this.h?void 0:U,B.logger?.setLevel(U),this.b.set(B.info.resource,B),this.f.fire([L,U]))}else{this.h=v;for(const[L,U]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,C){const L=this.m(v);L&&C!==!L.info.hidden&&(L.info.hidden=!C,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,C]))}getLogLevel(v){let C;return v&&(C=this.b.get(v)?.info.logLevel),C??this.h}registerLogger(v){const C=this.b.get(v.resource);C?C.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const C=this.b.get(v);C&&(C.logger&&C.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=r;class i{constructor(){this.onDidChangeLogLevel=new O.$fd().event}setLevel(v){}getLevel(){return w.Info}trace(v,...C){}debug(v,...C){}info(v,...C){}warn(v,...C){}error(v,...C){}critical(v,...C){}dispose(){}flush(){}}e.$ej=i;class n extends i{}e.$fj=n;function a(A){if(A.verbose)return w.Trace;if(typeof A.logLevel=="string"){const v=I(A.logLevel.toLowerCase());if(v!==void 0)return v}return e.$8i}e.$gj=a;function k(A){switch(A){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$hj=k;function I(A){switch(A){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$ij=I,e.$jj=new b.$2i("logLevel",k(w.Info))});var _=this&&this.__param||function(J,e){return function(P,O){e(P,O,J)}};define(te[218],ie([0,1,15,4,5]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;const M=P.safeStorage;let D=class{constructor(h){this.a=h,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const m=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=M.decryptString(m);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(m){throw this.a.error(m),m}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(O.$i)return Promise.resolve("dpapi");if(O.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const h=M.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(O.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(O.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$U5b=D,e.$U5b=D=ke([_(0,s.$5i)],D)}),define(te[219],ie([0,1,23,8,14,3,2,9,76,5]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class m extends D.$kc{constructor(p,f){super(),this.a=p,this.b=f,this.c=this.B(new M.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Eg(0)),this.w=[],this.y=this.B(new O.$Eg(0))}watch(p,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(p,f):this.z(p,f)}n(p,f){const y={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,P.$Sb)(this.j,y);return this.r(),(0,D.$ic)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Y)(p))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Ip)(f)),f=>this.G(f),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const f of this.j)(0,h.$Ep)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const f of this.j)(0,h.$Ep)(f)&&p.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,f){const y={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,P.$Sb)(this.w,y);return this.C(),(0,D.$ic)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,h.$Ip)(p)),p=>this.G(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,S.$7d)(p.fsPath)}}e.$Mp=m}),define(te[220],ie([0,1,23,8,17,22,3,57,68,2,58,13,65,19,56,174,16,118,5,14]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let E=class extends l.$kc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new D.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new O.$Pg)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new l.$jc;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),r.add(c.onDidChangeFile(i=>this.X.fire(new d.$lk(i,!this.S(c))))),typeof c.onDidWatchError=="function"&&r.add(c.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,l.$ic)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,l.$fc)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(r){c.push(r)}}),!this.h.has(t)&&await O.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&c)}listCapabilities(){return h.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,f.$mg)(t))throw new d.$nk((0,w.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const r=new $.$_;throw r.message=(0,w.localize)(1,null,t.toString()),r}return c}async m(t){const c=await this.j(t);if((0,d.$$j)(c)||(0,d.$8j)(c)||(0,d.$_j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const c=await this.j(t);if((0,d.$$j)(c)||(0,d.$8j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.s(t,c)}catch(r){throw(0,d.$ik)(r)===d.FileSystemProviderErrorCode.FileNotFound?new d.$nk((0,w.localize)(2,null,this.rb(t)),1):(0,d.$gk)(r)}}async s(t,c){const r=await this.j(t),i=this.S(r),n=c?.resolveTo,a=c?.resolveSingleChildDescendants,k=c?.resolveMetadata,I=await r.stat(t);let A;return this.t(r,t,I,void 0,!!k,(v,C)=>(A||(A=m.$Hh.forUris(()=>!i),A.set(t,!0),n&&A.fill(!0,n)),A.get(v.resource)||A.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&a?C===1:!1))}async t(t,c,r,i,n,a){const{providerExtUri:k}=this.R(t),I={resource:c,name:k.basename(c),isFile:(r.type&d.FileType.File)!==0,isDirectory:(r.type&d.FileType.Directory)!==0,isSymbolicLink:(r.type&d.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&d.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&d.FilePermission.Locked),etag:(0,d.$yk)({mtime:r.mtime,size:r.size}),children:void 0};if(I.isDirectory&&a(I,i)){try{const A=await t.readdir(c),v=await O.Promises.settled(A.map(async([C,L])=>{try{const U=k.joinPath(c,C),B=n?await t.stat(U):{type:L};return await this.t(t,U,B,A.length,n,a)}catch(U){return this.b.trace(U),null}}));I.children=(0,P.$Fb)(v)}catch(A){this.b.trace(A),I.children=[]}return I}return I}async resolveAll(t){return O.Promises.settled(t.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),r=await c.stat(t);return this.t(c,t,r,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.u(t,c)}catch(r){return r}return!0}async u(t,c){if(!c?.overwrite&&await this.exists(t))throw new d.$nk((0,w.localize)(3,null,this.rb(t)),3,c)}async createFile(t,c=s.$Fd.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,c);return this.r.fire(new d.$kk(t,0,i)),i}async writeFile(t,c,r){const i=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(i);try{await this.w(i,t,r)||await this.U(i,n.dirname(t));let k;if((0,d.$8j)(i)&&!(c instanceof s.$Fd))if((0,y.$rd)(c)){const I=await(0,y.$yd)(c,3);I.ended?k=s.$Fd.concat(I.buffer):k=I}else k=(0,y.$vd)(c,I=>s.$Fd.concat(I),3);else k=c;if(!(0,d.$$j)(i)||(0,d.$8j)(i)&&k instanceof s.$Fd)await this.gb(i,t,r,k);else{const I=k instanceof s.$Fd?(0,s.$Qd)(k):k;r?.atomic!==!1&&r?.atomic?.postfix?await this.bb(i,t,(0,f.$ig)((0,f.$hg)(t),`${(0,f.$fg)(t)}${r.atomic.postfix}`),r,I):await this.cb(i,t,r,I)}this.r.fire(new d.$kk(t,4))}catch(a){throw new d.$nk((0,w.localize)(4,null,this.rb(t),(0,d.$gk)(a).toString()),(0,d.$jk)(a),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,c,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(c)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(c)));if(i)throw new Error((0,w.localize)(7,null,this.rb(c)))}let a;try{a=await t.stat(c)}catch{return}if(a.type&d.FileType.Directory)throw new d.$nk((0,w.localize)(8,null,this.rb(c)),0,r);if(this.qb(c,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==d.$xk&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,d.$yk)({mtime:r.mtime,size:a.size}))throw new d.$nk((0,w.localize)(9,null),3,r);return a}async readFile(t,c,r){const i=await this.m(t);return c?.atomic?this.z(i,t,c,r):this.C(i,t,c,r)}async z(t,c,r,i){return new Promise((n,a)=>{this.ab.queueFor(c,this.R(t).providerExtUri).queue(async()=>{try{const k=await this.C(t,c,r,i);n(k)}catch(k){a(k)}})})}async C(t,c,r,i){const n=await this.D(t,c,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Rd)(n.value)}}async readFileStream(t,c,r){const i=await this.m(t);return this.D(i,t,c,r)}async D(t,c,r,i){const n=new M.$pd(i),a=this.J(c,r).then(I=>I,I=>{throw n.dispose(!0),I});let k;try{return typeof r?.etag=="string"&&r.etag!==d.$xk&&await a,r?.atomic&&(0,d.$ak)(t)||!((0,d.$$j)(t)||(0,d.$_j)(t))||(0,d.$8j)(t)&&r?.preferUnbuffered?k=this.I(t,c,r):(0,d.$_j)(t)?k=this.G(t,c,n.token,r):k=this.H(t,c,n.token,r),k.on("end",()=>n.dispose()),k.on("error",()=>n.dispose()),{...await a,value:k}}catch(I){throw k&&await(0,y.$wd)(k),this.F(I,c,r)}}F(t,c,r){const i=(0,w.localize)(10,null,this.rb(c),(0,d.$gk)(t).toString());return t instanceof d.$pk?new d.$pk(i,t.stat,r):t instanceof d.$ok?new d.$ok(i,t.fileOperationResult,t.size,t.options):new d.$nk(i,(0,d.$jk)(t),r)}G(t,c,r,i=Object.create(null)){const n=t.readFileStream(c,i,r);return(0,y.$Cd)(n,{data:a=>a instanceof s.$Fd?a:s.$Fd.wrap(a),error:a=>this.F(a,c,i)},a=>s.$Fd.concat(a))}H(t,c,r,i=Object.create(null)){const n=(0,s.$Vd)();return(0,g.$Cp)(t,c,n,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,c,i)},r),n}I(t,c,r){const i=(0,y.$td)(n=>s.$Fd.concat(n));return(async()=>{try{let n;r?.atomic&&(0,d.$ak)(t)?n=await t.readFile(c,{atomic:!0}):n=await t.readFile(c),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(c,n.byteLength,r),i.end(s.$Fd.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,c){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new d.$nk((0,w.localize)(11,null,this.rb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==d.$xk&&c.etag===r.etag)throw new d.$pk((0,w.localize)(12,null),r,c);return this.L(t,r.size,c),r}L(t,c,r){if(typeof r?.limits?.size=="number"&&c>r.limits.size)throw new d.$ok((0,w.localize)(13,null,this.rb(t)),7,c,r)}async canMove(t,c,r){return this.M(t,c,"move",r)}async canCopy(t,c,r){return this.M(t,c,"copy",r)}async M(t,c,r,i){if(t.toString()!==c.toString())try{const n=r==="move"?this.pb(await this.n(t),t):await this.m(t),a=this.pb(await this.n(c),c);await this.Q(n,t,a,c,r,i)}catch(n){return n}return!0}async move(t,c,r){const i=this.pb(await this.n(t),t),n=this.pb(await this.n(c),c),a=await this.N(i,t,n,c,"move",!!r),k=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,a==="move"?2:3,k)),k}async copy(t,c,r){const i=await this.m(t),n=this.pb(await this.n(c),c),a=await this.N(i,t,n,c,"copy",!!r),k=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,a==="copy"?3:2,k)),k}async N(t,c,r,i,n,a){if(c.toString()===i.toString())return n;const{exists:k,isSameResourceWithDifferentPathCase:I}=await this.Q(t,c,r,i,n,a);if(k&&!I&&a&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,d.$9j)(t))await t.copy(c,i,{overwrite:a});else{const A=await this.resolve(c);A.isDirectory?await this.P(t,A,r,i):await this.O(t,c,r,i)}return n}else return t===r?(await t.rename(c,i,{overwrite:a}),n):(await this.N(t,c,r,i,"copy",a),await this.del(c,{recursive:!0}),"copy")}async O(t,c,r,i){if((0,d.$$j)(t)&&(0,d.$$j)(r))return this.ib(t,c,r,i);if((0,d.$$j)(t)&&(0,d.$8j)(r))return this.ob(t,c,r,i);if((0,d.$8j)(t)&&(0,d.$$j)(r))return this.mb(t,c,r,i);if((0,d.$8j)(t)&&(0,d.$8j)(r))return this.kb(t,c,r,i)}async P(t,c,r,i){await r.mkdir(i),Array.isArray(c.children)&&await O.Promises.settled(c.children.map(async n=>{const a=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,a):this.O(t,n.resource,r,a)}))}async Q(t,c,r,i,n,a){let k=!1;if(t===r){const{providerExtUri:A,isPathCaseSensitive:v}=this.R(t);if(v||(k=A.isEqual(c,i)),k&&n==="copy")throw new Error((0,w.localize)(14,null,this.rb(c),this.rb(i)));if(!k&&A.isEqualOrParent(i,c))throw new Error((0,w.localize)(15,null,this.rb(c),this.rb(i)))}const I=await this.exists(i);if(I&&!k){if(!a)throw new d.$nk((0,w.localize)(16,null,this.rb(c),this.rb(i)),4);if(t===r){const{providerExtUri:A}=this.R(t);if(A.isEqualOrParent(c,i))throw new Error((0,w.localize)(17,null,this.rb(c),this.rb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:k}}R(t){const c=this.S(t);return{providerExtUri:c?f.$$f:f.$ag,isPathCaseSensitive:c}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.pb(await this.j(t),t);await this.U(c,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,0,r)),r}async U(t,c){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&d.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(c)));break}catch(n){if((0,d.$ik)(n)!==d.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(c)),c=i.dirname(c)}for(let n=r.length-1;n>=0;n--){c=i.joinPath(c,r[n]);try{await t.mkdir(c)}catch(a){if((0,d.$ik)(a)!==d.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,c){try{await this.W(t,c)}catch(r){return r}return!0}async W(t,c){const r=this.pb(await this.j(t),t),i=!!c?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(t)));const n=c?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(t)));if(i&&n)throw new Error((0,w.localize)(21,null,this.rb(t)));let a;try{a=await r.stat(t)}catch{}if(a)this.qb(t,a);else throw new d.$nk((0,w.localize)(22,null,this.rb(t)),1);if(!!!c?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(t)))}return r}async del(t,c){const r=await this.W(t,c),i=!!c?.useTrash,n=!!c?.recursive,a=c?.atomic??!1;await r.delete(t,{recursive:n,useTrash:i,atomic:a}),this.r.fire(new d.$kk(t,1))}async cloneFile(t,c){const r=await this.j(t),i=this.pb(await this.n(c),c);if(r===i&&this.R(r).providerExtUri.isEqual(t,c))return;if(r===i&&(0,d.$0j)(r))return r.cloneFile(t,c);await this.U(i,this.R(i).providerExtUri.dirname(c));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,d.$9j)(r)?n.queue(()=>r.copy(t,c,{overwrite:!0})):n.queue(()=>this.O(r,t,i,c))}watch(t,c={recursive:!1,excludes:[]}){const r=new l.$jc;let i=!1,n=()=>{i=!0};return r.add((0,l.$ic)(()=>n())),(async()=>{try{const a=await this.$(t,c);i?(0,l.$fc)(a):n=()=>(0,l.$fc)(a)}catch(a){this.b.error(a)}})(),r}async $(t,c){const r=await this.j(t),i=(0,S.$pi)([this.R(r).providerExtUri.getComparisonKey(t),c]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,c)},this.Z.set(i,n)),n.count+=1,(0,l.$ic)(()=>{n&&(n.count--,n.count===0&&((0,l.$fc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,l.$fc)(t.disposable);this.Z.clear()}async bb(t,c,r,i,n){await this.cb(t,r,i,n);try{await t.rename(r,c,{overwrite:!0})}catch(a){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async cb(t,c,r,i){return this.ab.queueFor(c,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(c,{create:!0,unlock:r?.unlock??!1});try{(0,y.$rd)(i)||(0,y.$sd)(i)?await this.db(t,n,i):await this.eb(t,n,i)}catch(a){throw(0,d.$gk)(a)}finally{await t.close(n)}})}async db(t,c,r){let i=0,n;if((0,y.$sd)(r)){if(r.buffer.length>0){const a=s.$Fd.concat(r.buffer);await this.fb(t,c,a,a.byteLength,i,0),i+=a.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((a,k)=>{(0,y.$xd)(n,{onData:async I=>{n.pause();try{await this.fb(t,c,I,I.byteLength,i,0)}catch(A){return k(A)}i+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>k(I),onEnd:()=>a()})})}async eb(t,c,r){let i=0,n;for(;(n=r.read())!==null;)await this.fb(t,c,n,n.byteLength,i,0),i+=n.byteLength}async fb(t,c,r,i,n,a){let k=0;for(;k<i;){const I=await t.write(c,n+k,r.buffer,a+k,i-k);k+=I}}async gb(t,c,r,i){return this.ab.queueFor(c,this.R(t).providerExtUri).queue(()=>this.hb(t,c,r,i))}async hb(t,c,r,i){let n;i instanceof s.$Fd?n=i:(0,y.$rd)(i)?n=await(0,s.$Rd)(i):(0,y.$sd)(i)?n=await(0,s.$Sd)(i):n=(0,s.$Pd)(i),await t.writeFile(c,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async ib(t,c,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.jb(t,c,r,i))}async jb(t,c,r,i){let n,a;try{n=await t.open(c,{create:!1}),a=await r.open(i,{create:!0,unlock:!1});const k=s.$Fd.alloc(this.a);let I=0,A=0,v=0;do v=await t.read(n,I,k.buffer,A,k.byteLength-A),await this.fb(r,a,k,v,I,A),I+=v,A+=v,A===k.byteLength&&(A=0);while(v>0)}catch(k){throw(0,d.$gk)(k)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async kb(t,c,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.lb(t,c,r,i))}async lb(t,c,r,i){return r.writeFile(i,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,c,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.nb(t,c,r,i))}async nb(t,c,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(c);await this.fb(r,n,s.$Fd.wrap(a),a.byteLength,0,0)}catch(a){throw(0,d.$gk)(a)}finally{await r.close(n)}}async ob(t,c,r,i){const n=await(0,s.$Rd)(this.H(t,c,M.CancellationToken.None));await this.gb(r,i,void 0,n)}pb(t,c){if(t.capabilities&2048)throw new d.$nk((0,w.localize)(24,null,this.rb(c)),6);return t}qb(t,c){if((c.permissions??0)&d.FilePermission.Readonly)throw new d.$nk((0,w.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===b.Schemas.file?t.fsPath:t.toString(!0)}};e.$Dp=E,e.$Dp=E=ke([_(0,o.$5i)],E)}),define(te[93],ie([0,1,45,309,8,33,17,3,32,2,9,4,19,56,21,178,16,118,219,50,215,214]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,O.gracefulify)(P)}catch(c){console.error(`Error enabling graceful-fs: ${(0,$.$mi)(c)}`)}})();class t extends o.$Mp{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$zi(n=>p.$_f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,b.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let k;a.isSymbolicLink()?k=(await this.stat((0,p.$ig)(r,a.name))).type:k=this.M(a),n.push([a.name,k])}catch(k){this.a.trace(k)}})),n}catch(i){throw this.eb(i)}}M(r,i){let n;return i?.dangling?n=d.FileType.Unknown:r.isFile()?n=d.FileType.File:r.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$Fg;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await y.Promises.readFile(a)}catch(a){throw this.eb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,f.$td)(k=>D.$Fd.concat(k.map(I=>D.$Fd.wrap(I))).buffer);return(0,g.$Cp)(this,r,a,k=>k.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(r,(0,p.$ig)((0,p.$hg)(r),`${(0,p.$fg)(r)}${n.atomic.postfix}`),i,n):this.R(r,i,n)}async Q(r,i,n,a){await this.R(i,n,a);try{await this.rename(i,r,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}async R(r,i,n){let a;try{const k=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(k)){if(!n.overwrite)throw(0,d.$fk)((0,w.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$fk)((0,w.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(k){throw await this.fb(r,k)}finally{typeof a=="number"&&await this.close(a)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i){const n=this.H(r);let a;(0,d.$7j)(i)&&(a=await this.O(r));let k;try{if((0,d.$7j)(i)&&i.unlock)try{const{stat:A}=await y.SymlinkSupport.stat(n);A.mode&128||await y.Promises.chmod(n,A.mode|128)}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}let I;if((0,d.$7j)(i)){if(b.$i)try{await y.Promises.truncate(n,0),I="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}I||(I="w")}else I="r";k=await y.Promises.open(n,I)}catch(I){throw a?.dispose(),(0,d.$7j)(i)?await this.fb(r,I):this.eb(I)}if(this.S.set(k,0),(0,d.$7j)(i)&&this.W.set(k,r),a){const I=this.U.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${n})`),this.U.set(k,a),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${n})`),I.dispose())}return k}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,k){const I=this.Y(r,i);let A=null;try{A=(await y.Promises.read(r,n,a,k,I)).bytesRead}catch(v){throw this.eb(v)}finally{this.Z(r,I,A)}return A}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,n){const a=this.S.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(r,a+n):this.S.delete(r)))}async write(r,i,n,a,k){return(0,s.$Yg)(()=>this.$(r,i,n,a,k),100,3)}async $(r,i,n,a,k){const I=this.Y(r,i);let A=null;try{A=(await y.Promises.write(r,n,a,k,I)).bytesWritten}catch(v){throw await this.fb(this.W.get(r),v)}finally{this.Z(r,I,A)}return A}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,m.$9d)((0,m.$_d)(n),`${(0,m.$ae)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,a)}else try{await y.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let k=!1;try{const{stat:I,symbolicLink:A}=await y.SymlinkSupport.stat(n);k=I.isDirectory()&&!A}catch{}if(k)await y.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.eb(n)}}async rename(r,i,n){const a=this.H(r),k=this.H(i);if(a!==k)try{await this.ab(r,i,"move",n.overwrite),await y.Promises.rename(a,k)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,m.$ae)(a),(0,m.$ae)((0,m.$_d)(k)),I.toString()))),this.eb(I)}}async copy(r,i,n){const a=this.H(r),k=this.H(i);if(a!==k)try{await this.ab(r,i,"copy",n.overwrite),await y.Promises.copy(a,k,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,m.$ae)(a),(0,m.$ae)((0,m.$_d)(k)),I.toString()))),this.eb(I)}}async ab(r,i,n,a){const k=this.H(r),I=this.H(i);let A=!1;if(!!(this.capabilities&1024)||(A=(0,h.$Hf)(k,I,!0)),A){if(n==="copy")throw(0,d.$fk)((0,w.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,d.$fk)((0,w.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(i);if(L){if(!a)throw(0,d.$fk)((0,w.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);C.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,n){const a=this.H(r),k=this.H(i),I=!!(this.capabilities&1024);if((0,h.$Hf)(a,k,!I))return;const A=new l.$jc;try{const[v,C]=await Promise.all([this.O(r),this.O(i)]);A.add(v),A.add(C),n&&await y.Promises.mkdir((0,m.$_d)(k),{recursive:!0}),await y.Promises.copyFile(a,k)}catch(v){if(v.code==="ENOENT"&&!n)return this.bb(r,i,!0);throw this.eb(v)}finally{A.dispose()}}t(r,i,n){return new E.$Tp(a=>r(a),a=>i(a),n)}F(r,i,n){return new u.$2p(a=>r(a),a=>i(a),n)}eb(r){if(r instanceof d.$ek)return r;let i=r,n;switch(r.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fk)(i,n)}async fb(r,i){let n=this.eb(i);if(r&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await y.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,d.$fk)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$3p=t}),define(te[221],ie([0,1,3,93,2,17,56,22]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=void 0;class h extends s.$kc{constructor(b,p){super(),this.a=b,this.b=p,this.F=new Map,this.G=new Map}call(b,p,f){const y=this.c(b);switch(p){case"stat":return this.g(y,f[0]);case"readdir":return this.h(y,f[0]);case"open":return this.r(y,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(y,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(y,f[0],f[1],f[2]);case"rename":return this.z(y,f[0],f[1],f[2]);case"copy":return this.C(y,f[0],f[1],f[2]);case"cloneFile":return this.D(y,f[0],f[1]);case"mkdir":return this.w(y,f[0]);case"delete":return this.y(y,f[0],f[1]);case"watch":return this.I(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${p} not found`)}listen(b,p,f){const y=this.c(b);switch(p){case"fileChange":return this.H(y,f[0]);case"readFileStream":return this.m(y,f[0],f[1])}throw new Error(`Unknown event ${p}`)}g(b,p){const f=this.f(b,p,!0);return this.a.stat(f)}h(b,p){const f=this.f(b,p);return this.a.readdir(f)}async j(b,p,f){const y=this.f(b,p,!0),w=await this.a.readFile(y,f);return M.$Fd.wrap(w)}m(b,p,f){const y=this.f(b,p,!0),w=new S.$pd,d=new P.$fd({onDidRemoveLastListener:()=>{w.cancel()}}),g=this.a.readFileStream(y,f,w.token);return(0,D.$xd)(g,{onData:o=>d.fire(M.$Fd.wrap(o)),onError:o=>d.fire(o),onEnd:()=>{d.fire("end"),d.dispose(),w.dispose()}}),d.event}n(b,p,f,y){const w=this.f(b,p);return this.a.writeFile(w,f.buffer,y)}r(b,p,f){const y=this.f(b,p,!0);return this.a.open(y,f)}s(b){return this.a.close(b)}async t(b,p,f){const y=M.$Fd.alloc(f),w=0,d=await this.a.read(b,p,y.buffer,w,f);return[y,d]}u(b,p,f,y,w){return this.a.write(b,p,f.buffer,y,w)}w(b,p){const f=this.f(b,p);return this.a.mkdir(f)}y(b,p,f){const y=this.f(b,p);return this.a.delete(y,f)}z(b,p,f,y){const w=this.f(b,p),d=this.f(b,f);return this.a.rename(w,d,y)}C(b,p,f,y){const w=this.f(b,p),d=this.f(b,f);return this.a.copy(w,d,y)}D(b,p,f){const y=this.f(b,p),w=this.f(b,f);return this.a.cloneFile(y,w)}H(b,p){const f=new P.$fd({onWillAddFirstListener:()=>{this.F.set(p,this.L(b,f))},onDidRemoveLastListener:()=>{(0,s.$fc)(this.F.get(p)),this.F.delete(p)}});return f.event}async I(b,p,f,y,w){const d=this.F.get(p);if(d){const g=this.f(b,y),o=d.watch(f,g,w);this.G.set(p+f,o)}}async J(b,p){const f=b+p,y=this.G.get(f);y&&((0,s.$fc)(y),this.G.delete(f))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$yr=h;class l extends s.$kc{constructor(b,p,f,y){super(),this.c=b,this.f=f,this.g=y,this.a=new Map,this.b=this.B(new O.$3p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(b){const p=this.B(new P.$fd);this.B(p.event(f=>{b.fire(f.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(f=>p.fire(f))),this.B(this.b.onDidWatchError(f=>b.fire(f)))}j(b){}m(b){}watch(b,p,f){const y=this.m(this.g);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.a.set(b,this.b.watch(p,f)),(0,s.$ic)(()=>{(0,s.$fc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$zr=l}),define(te[222],ie([0,1,15,177,4,7,16,9,221,155]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=void 0;class m extends h.$yr{constructor(f,y,w){super(f,y),this.M=w}c(f){return l.$Cm}f(f,y){return M.URI.revive(y)}async y(f,y,w){if(!w.useTrash)return super.y(f,y,w);const d=this.f(f,y),g=(0,S.$7d)(d.fsPath);try{await P.shell.trashItem(g)}catch{throw(0,D.$fk)(s.$i?(0,O.localize)(0,null,(0,S.$ae)(g)):(0,O.localize)(1,null,(0,S.$ae)(g)),D.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new b(f,y,this.b,this.M)}}e.$35b=m;class b extends h.$zr{watch(f,y,w){if(w.recursive)throw(0,D.$fk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(te[223],ie([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42b=void 0;class O extends P.$$i{constructor(M=P.$8i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:S}of this.m)(0,P.log)(M,D,S);this.m=[]}g(M,D){this.n?(0,P.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$42b=O}),define(te[224],ie([0,1,7,3,5,2]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=void 0;class D extends s.$dj{constructor(b,p,f,y,w){super(p,f,y),this.r=b,this.t=w,this.B(w.listen("onDidChangeLogLevel",b)(d=>{(0,s.$7i)(d)?super.setLogLevel(d):super.setLogLevel(P.URI.revive(d[0]),d[1])})),this.B(w.listen("onDidChangeVisibility",b)(([d,g])=>super.setVisibility(P.URI.revive(d),g))),this.B(w.listen("onDidChangeLoggers",b)(({added:d,removed:g})=>{for(const o of d)super.registerLogger({...o,resource:P.URI.revive(o.resource)});for(const o of g)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new s.$bj({log:(b,p)=>{this.t.call("consoleLog",[b,p])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,p){super.setLogLevel(b,p),this.t.call("setLogLevel",[b,p])}setVisibility(b,p){super.setVisibility(b,p),this.t.call("setVisibility",[this.n(b),p])}s(b,p,f){return new S(this.t,b,p,f,this.r)}static setLogLevel(b,p,f){return b.call("setLogLevel",[p,f])}}e.$1q=D;class S extends s.$$i{constructor(b,p,f,y,w){super(y?.logLevel==="always"),this.r=b,this.s=p,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[p,y,w]).then(()=>{this.u(this.n),this.m=!0})}g(b,p){const f=[[b,p]];this.m?this.u(f):this.n.push(...f)}u(b){this.r.call("log",[this.s,b])}}class h{constructor(b,p){this.a=b,this.b=p}listen(b,p){const f=this.b(b);switch(p){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.c(w,f)),removed:[...y.removed].map(w=>this.c(w,f))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$7i)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(b,p,f){const y=this.b(b);switch(p){case"setLogLevel":return(0,s.$7i)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,y)))}throw new Error(`Call not found: ${p}`)}c(b,p){return{...b,resource:p.transformOutgoingURI(b.resource)}}}e.$2q=h;class l extends M.$kc{constructor(b,p){super(),p.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(f=>p.call("setLogLevel",[f]))),p.call("getRegisteredLoggers").then(f=>{for(const y of f)b.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([f,y])=>b.setVisibility(P.URI.revive(f),y))),this.B(p.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const w of f)b.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of y)b.deregisterLogger(w.resource)}))}}e.$3q=l}),define(te[225],ie([0,1,2,5]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class s extends P.$kc{constructor(D,S=[]){super(),this.a=new O.$cj([D,...S]),this.B(D.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$mN=s}),define(te[226],ie([0,1,33,7,5]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=void 0;class M{constructor(S){this.b=S,this.a=new P.$zi}listen(S,h,l){switch(h){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(S,h,l){switch(h){case"createLogger":this.c(O.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(O.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$7i)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(O.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(O.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:O.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(O.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}c(S,h,l){this.a.set(S,this.b.createLogger(S,h,l))}d(S,h){let l=console.log;switch(S){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...h)}e(S,h){const l=this.a.get(S);if(!l)throw new Error("Create the logger before logging");for(const[m,b]of h)(0,s.log)(l,m,b)}}e.$16b=M}),define(te[227],ie([0,1,16,5]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,m,b,p,f){try{const y=await new Promise((d,g)=>{J(["@vscode/spdlog"],d,g)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(l,m,b,p);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function D(l,m,b){switch(m){case O.LogLevel.Trace:l.trace(b);break;case O.LogLevel.Debug:l.debug(b);break;case O.LogLevel.Info:l.info(b);break;case O.LogLevel.Warning:l.warn(b);break;case O.LogLevel.Error:l.error(b);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function S(l,m){switch(m){case O.LogLevel.Trace:l.setLevel(s.Trace);break;case O.LogLevel.Debug:l.setLevel(s.Debug);break;case O.LogLevel.Info:l.setLevel(s.Info);break;case O.LogLevel.Warning:l.setLevel(s.Warning);break;case O.LogLevel.Error:l.setLevel(s.Error);break;case O.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class h extends O.$$i{constructor(m,b,p,f,y){super(),this.m=[],this.setLevel(y),this.n=this.s(m,b,p,f),this.B(this.onDidChangeLogLevel(w=>{this.r&&S(this.r,w)}))}async s(m,b,p,f){const y=p?6:1,w=30/y*P.$Ak.MB,d=await M(m,b,w,y,f);if(d){this.r=d,S(this.r,this.getLevel());for(const{level:g,message:o}of this.m)D(this.r,g,o);this.m=[]}}g(m,b){this.r?D(this.r,m,b):this.getLevel()<=m&&this.m.push({level:m,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bN=h}),define(te[228],ie([0,1,31,5,227]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;class M extends O.$dj{s(S,h,l){return new s.$bN((0,P.$4f)(),S.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.$cN=M}),define(te[66],ie([0,1,33,3,6,5,228]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=e.$o6b=void 0,e.$o6b=(0,s.$Ch)(M.$6i);class S extends D.$cN{constructor(){super(...arguments),this.u=new P.$zi}createLogger(l,m,b){b!==void 0&&this.u.set(this.n(l),b);try{return super.createLogger(l,m)}catch(p){throw this.u.delete(this.n(l)),p}}registerLogger(l,m){m!==void 0&&this.u.set(l.resource,m),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const m=[];for(const b of super.getRegisteredLoggers())l===this.u.get(b.resource)&&m.push(b);return m}getOnDidChangeLogLevelEvent(l){return O.Event.filter(this.onDidChangeLogLevel,m=>(0,M.$7i)(m)||this.w(m[0],l))}getOnDidChangeVisibilityEvent(l){return O.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,l))}getOnDidChangeLoggersEvent(l){return O.Event.filter(O.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(p=>this.w(p.resource,l)),removed:[...m.removed].filter(p=>this.w(p.resource,l))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(l){for(const[m,b]of this.u)b===l&&this.deregisterLogger(m)}w(l,m){const b=this.u.get(l);return b===void 0||b===m}dispose(){super.dispose(),this.u.clear()}}e.$p6b=S}),define(te[229],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=e.$h6b=e.$g6b=e.$f6b=void 0;function P(D){return D.submenu!==void 0}e.$f6b=P;function O(D){return D.id==="vscode.menubar.separator"}e.$g6b=O;function s(D){return D.uri!==void 0}e.$h6b=s;function M(D){return!P(D)&&!O(D)&&!s(D)}e.$i6b=M}),define(te[39],ie([0,1,3,68,2,6]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,M.$Bh)("policy");class D extends s.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const m=Object.keys(this.f).length;return this.f={...l,...this.f},m!==Object.keys(this.f).length&&await this.j(l),O.Iterable.reduce(this.g.entries(),(b,[p,f])=>({...b,[p]:f}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(l,[m,b])=>({...l,[m]:{definition:b,value:this.g.get(m)}}),{})}}e.$$m=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=S}),define(te[230],ie([0,1,8,3,68,12,16,5,39]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;function l(b,p){const f=[];for(const y of new Set(s.Iterable.concat(b.keys(),p.keys())))b.get(y)!==p.get(y)&&f.push(y);return f}let m=class extends h.$$m{constructor(p,f,y){super(),this.m=p,this.n=f,this.s=y,this.c=this.B(new P.$Eg(500));const w=O.Event.filter(f.onDidFilesChange,d=>d.affects(p));this.B(f.watch(p)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const f=await this.n.readFile(this.m),y=JSON.parse(f.value.toString());if(!(0,M.$lf)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&p.set(w,y[w])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return p}async w(){const p=await this.u(),f=l(this.g,p);this.g=p,f.length>0&&this.h.fire(f)}};e.$g7b=m,e.$g7b=m=ke([_(1,D.$6j),_(2,S.$5i)],m)}),define(te[231],ie([0,1,3,2,39]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=void 0;class M{constructor(h){this.b=h,this.a=new O.$jc}listen(h,l){switch(l){case"onDidChange":return P.Event.map(this.b.onDidChange,m=>m.reduce((b,p)=>({...b,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(h,l,m){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$T6b=M;class D extends s.$$m{constructor(h,l){super(),this.a=l;for(const m in h){const{definition:b,value:p}=h[m];this.f[m]=b,p!==void 0&&this.g.set(m,p)}this.a.listen("onDidChange")(m=>{for(const b in m){const p=m[b];p===null?this.g.delete(b):this.g.set(b,p)}this.h.fire(Object.keys(m))})}async j(h){const l=await this.a.call("updatePolicyDefinitions",h);for(const m in l)this.g.set(m,l[m])}}e.$U6b=D}),define(te[232],ie([0,1,39,8,310,2,5]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let S=class extends P.$$m{constructor(l,m){super(),this.m=l,this.n=m,this.a=new O.$Ag,this.b=this.B(new M.$lc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((m,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,l,p=>{this.t(p),m()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),b(p)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const m in l){const b=l[m];b===void 0?this.g.delete(m):this.g.set(m,b)}this.h.fire(Object.keys(l))}};e.$f7b=S,e.$f7b=S=ke([_(0,D.$5i)],S)}),define(te[77],ie([0,1,4,35]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.context<"u"){const M=P.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,P.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,24]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=void 0;let M=class{constructor(S,h){this.b=S,this.c=h,this.a=new Map}async isExtensionUrlTrusted(S,h){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(h);if(!l)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,m,b]=l;let p=this.a.get(S);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[S],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...p])}const f=Buffer.from(decodeURIComponent(b),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=f.slice(0,6),w=f.readUIntBE(0,6),d=Date.now()-w;if(d<0||d>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const g=f.slice(6),o=P.createVerify("SHA256");o.write(y),o.write(Buffer.from(m)),o.end();for(let $=0;$<p.length;$++){let E=p[$];if(E!==null){if(typeof E=="string")try{E=P.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),p[$]=E}catch(u){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${$+1} for ${S}:`,u),p[$]=null;continue}if(o.verify(E,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.$V5b=M,e.$V5b=M=ke([_(0,s.$kj),_(1,O.$5i)],M)}),define(te[234],ie([0,1,8,5]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$85b=void 0;let s=class{constructor(D,S,h){this.a=D,this.b=S,this.c=h}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Hg)(D);const h=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$85b=s,e.$85b=s=ke([_(2,O.$5i)],s)}),define(te[78],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=void 0,e.$$5b=(0,P.$Bh)("protocolMainService")}),define(te[43],ie([0,1,136,12]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(O.$jf(D)),P.ok(O.$lf(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$8m=new s}),define(te[235],ie([0,1,3,43]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[s(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;O.$8m.add(e.$9m.JSONContribution,D)}),define(te[59],ie([0,1,23,3,12,162,18,235,43]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var l;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$an={Configuration:"base.contributions.configuration"};var m;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const b=h.$8m.as(S.$9m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$fd,this.onDidSchemaChange=this.i.event,this.j=new O.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const r=new Set;this.n(t,c,r),b.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const c=new Set;this.o(t,c),b.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const r=new Set;this.o(c,r),this.n(t,!1,r),b.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(c.add(a),e.$kn.test(a)){const k=this.a.get(a),I=k?.valuesSources??new Map;if(n)for(const L of Object.keys(i[a]))I.set(L,n);const A={...k?.value||{},...i[a]};this.a.set(a,{source:n,value:A,valuesSources:I});const v=(0,D.$fi)(a),C={type:"object",default:A,description:M.localize(1,null,v),$ref:e.$hn,defaultDefaultValue:A,source:s.$jf(n)?void 0:n,defaultValueSource:n};r.push(...w(a)),this.d[a]=C,this.b.properties[a]=C}else{this.a.set(a,{value:i[a],source:n});const k=this.d[a];k&&(this.w(a,k),this.r(a,k))}this.m(r)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),k=s.$jf(i)?i:i?.id,I=s.$jf(a?.source)?a?.source:a?.source?.id;if(k===I)if(c.add(n),this.a.delete(n),e.$kn.test(n))delete this.d[n],delete this.b.properties[n];else{const A=this.d[n];A&&(this.w(n,A),this.r(n,A))}}this.u()}deltaConfiguration(t){let c=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,r){t.forEach(i=>{this.p(i,c,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,c){const r=i=>{if(i.properties)for(const n in i.properties){c.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,c=!0,r,i,n=3,a){n=s.$sf(t.scope)?n:t.scope;const k=t.properties;if(k)for(const A in k){const v=k[A];if(c&&$(A,v)){delete k[A];continue}if(v.source=r,v.defaultDefaultValue=k[A].default,this.w(A,v),e.$kn.test(A)?v.scope=void 0:(v.scope=s.$sf(v.scope)?n:v.scope,v.restricted=s.$sf(v.restricted)?!!i?.includes(A):v.restricted),k[A].hasOwnProperty("included")&&!k[A].included){this.f[A]=k[A],delete k[A];continue}else this.d[A]=k[A],k[A].policy?.name&&this.e.set(k[A].policy.name,A);!k[A].deprecationMessage&&k[A].markdownDeprecationMessage&&(k[A].deprecationMessage=k[A].markdownDeprecationMessage),a.add(A)}const I=t.allOf;if(I)for(const A of I)this.p(A,c,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$bn.properties[t]=c,c.scope){case 1:e.$cn.properties[t]=c;break;case 2:e.$dn.properties[t]=c;break;case 6:e.$en.properties[t]=c;break;case 3:e.$fn.properties[t]=c;break;case 4:e.$gn.properties[t]=c;break;case 5:e.$gn.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$bn.properties[t],c.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$hn};this.w(c,r),e.$bn.properties[c]=r,e.$cn.properties[c]=r,e.$dn.properties[c]=r,e.$en.properties[c]=r,e.$fn.properties[c]=r,e.$gn.properties[c]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,c){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$qf(i)&&(i=c.defaultDefaultValue,n=void 0),s.$qf(i)&&(i=g(c.type)),c.default=i,c.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.$jn=`^(${f})+$`,e.$kn=new RegExp(e.$jn);function w(u){const t=[];if(e.$kn.test(u)){let c=y.exec(u);for(;c?.length;){const r=c[1].trim();r&&t.push(r),c=y.exec(u)}}return(0,P.$Kb)(t)}e.$ln=w;function d(u){return u.reduce((t,c)=>`${t}[${c}]`,"")}e.$mn=d;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=g;const o=new p;h.$8m.add(e.$an.Configuration,o);function $(u,t){return u.trim()?e.$kn.test(u)?M.localize(7,null,u):o.getConfigurationProperties()[u]!==void 0?M.localize(8,null,u):t.policy?.name&&o.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,u,t.policy?.name,o.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$on=$;function E(){const u=[],t=o.getConfigurationProperties();for(const c of Object.keys(t))u.push([c,t[c].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$pn=E}),define(te[119],ie([0,1,23,3,44,2,33,37,12,7,18,59,43]),function(J,e,P,O,s,M,D,S,h,l,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function f(c){return Object.isFrozen(c)?c:S.$Wm(c)}class y{constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,m.$di)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),a=i?this.rawConfiguration.getOverrideValue(r,i):void 0,k=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:a,merged:k}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,m.$di)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Kb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Kb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$Vm(this.contents),n=S.$Vm(this.overrides),a=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const I of r)if(k.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const A of I.overrides){const[v]=n.filter(C=>P.$sb(C.identifiers,A.identifiers));v?(this.h(v.contents,A.contents),v.keys.push(...A.keys),v.keys=P.$Kb(v.keys)):n.push(S.$Vm(A))}for(const A of I.keys)a.indexOf(A)===-1&&a.push(A)}return new y(i,a,n,k.every(I=>I instanceof y)?void 0:k)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of P.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let k=this.contents[a];const I=i[a];I&&(typeof k=="object"&&typeof I=="object"?(k=S.$Vm(k),this.h(k,I)):k=I),n[a]=k}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&h.$lf(r[n])&&h.$lf(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$Vm(i[n])}}i(r){let i=null,n=null;const a=k=>{k&&(n?this.h(n,k):n=S.$Vm(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===r?i=k.contents:k.identifiers.includes(r)&&a(k.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,m.$ci)(this.contents,r),b.$kn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$sb(n.identifiers,(0,b.$ln)(r))),1))}j(r,i,n){(0,m.$bi)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),b.$kn.test(r)&&this.overrides.push({identifiers:(0,b.$ln)(r),keys:Object.keys(this.contents[r]),contents:(0,m.$ai)(this.contents[r],a=>console.error(a))})}}e.$qn=y;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.$sf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:k,restricted:I,hasExcludedProperties:A}=this.h(r,i);this.b=new y(n,a,k,A?[r]:void 0),this.c=I||[]}g(r){let i={},n=null,a=[];const k=[],I=[];function A(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}const v={onObjectBegin:()=>{const C={};A(C),k.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=k.pop()},onArrayBegin:()=>{const C=[];A(C),k.push(a),a=C,n=null},onArrayEnd:()=>{a=k.pop()},onLiteralValue:A,onError:(C,L,U)=>{I.push({error:C,offset:L,length:U})}};if(r)try{s.$Sm(r,v),i=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=p.$8m.as(b.$an.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const k=(0,m.$ai)(r,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),I=Object.keys(r),A=this.j(r,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:k,keys:I,overrides:A,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let k=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:k};const I={},A=[];for(const v in r)if(b.$kn.test(v)&&n){const C=this.i(r[v],i,!1,a);I[v]=C.raw,k=k||C.hasExcludedProperties,A.push(...C.restricted)}else{const C=i[v],L=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&A.push(v),!a.exclude?.includes(v)&&(a.include?.includes(v)||(L===void 0||a.scopes===void 0||a.scopes.includes(L))&&!(a.skipRestricted&&C?.restricted))?I[v]=r[v]:k=!0}return{raw:I,restricted:A,hasExcludedProperties:k}}j(r,i){const n=[];for(const a of Object.keys(r))if(b.$kn.test(a)){const k={};for(const I in r[a])k[I]=r[a][I];n.push({identifiers:(0,b.$ln)(a),keys:Object.keys(k),contents:(0,m.$ai)(k,i)})}return n}}e.$rn=w;class d extends M.$kc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new O.$fd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&n.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=d;class g{constructor(r,i,n,a,k,I,A,v,C,L,U,B,re){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=k,this.f=I,this.g=A,this.h=v,this.i=C,this.j=L,this.k=U,this.l=B,this.m=re}get value(){return f(this.c)}n(r,i,n){const a=r.inspect(i,n);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class o{constructor(r,i,n,a,k=new y,I=new y,A=new D.$zi,v=new y,C=new D.$zi){this.c=r,this.d=i,this.f=n,this.g=a,this.h=k,this.i=I,this.j=A,this.l=v,this.m=C,this.a=null,this.b=new D.$zi,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new y,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.q(r,i,n),k=this.u(i.resource,n),I=i.resource?this.m.get(i.resource)||this.l:this.l,A=new Set;for(const v of a.overrides)for(const C of v.identifiers)a.getOverrideValue(r,C)!==void 0&&A.add(C);return new g(r,i,a.getValue(r),A.size?[...A]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,k||void 0,I)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:k,removed:I}=u(this.c,r);i=[...a,...k,...I]}for(const a of i)for(const k of(0,b.$ln)(a)){const I=this.c.getKeysForOverrideIdentifier(k),A=r.getKeysForOverrideIdentifier(k),v=[...A.filter(C=>I.indexOf(C)===-1),...I.filter(C=>A.indexOf(C)===-1),...I.filter(C=>!S.$Zm(this.c.override(k).getValue(C),r.override(k).getValue(C)))];n.push([k,v])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=u(this.d,r),k=[...i,...n,...a];return k.length&&this.updatePolicyConfiguration(r),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=u(this.applicationConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:k}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=u(this.localUserConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:k}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=u(this.remoteUserConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:k}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=u(this.workspaceConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:k}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:a,updated:k,removed:I,overrides:A}=u(n,i),v=[...a,...k,...I];return(v.length||!n)&&this.updateFolderConfiguration(r,i),{keys:v,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:k,overrides:I}=u(i,void 0);return{keys:[...n,...a,...k],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let a=this.r(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}r({resource:r},i){let n=this.s();if(i&&r){const a=i.getFolder(r);a&&(n=this.t(a.uri)||n);const k=this.m.get(r);k&&(n=n.merge(k))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:k}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:k}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),a=this.x(r.application),k=this.x(r.user),I=this.x(r.workspace),A=r.folders.reduce((v,C)=>(v.set(l.URI.revive(C[0]),this.x(C[1])),v),new D.$zi);return new o(i,n,a,k,new y,I,A,new y,new D.$zi)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$tn=o;function $(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,i=new Map;for(const a of c)a.keys.forEach(k=>r.add(k)),a.overrides.forEach(([k,I])=>{const A=(0,D.$wi)(i,k,new Set);I.forEach(v=>A.add(v))});const n=[];return i.forEach((a,k)=>n.push([k,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$un=$;class E{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const I of k)this.affectedKeys.add(I);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=o.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const k=a+n.length;if(k>=this.d.length)return!1;const I=this.d.charCodeAt(k);if(I!==this.b&&I!==this.c)return!1;if(i){const A=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,v=this.g.getValue(r,i,this.h);return!S.$Zm(A,v)}return!0}}e.$vn=E;function u(c,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,c?.rawConfiguration),k=[],I=c?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const v=A.filter(C=>!I.includes(C));for(const C of v)k.push([C,r.getKeysForOverrideIdentifier(C)])}if(c){const v=I.filter(C=>!A.includes(C));for(const C of v)k.push([C,c.getKeysForOverrideIdentifier(C)])}if(r&&c){for(const v of I)if(A.includes(v)){const C=t({contents:c.getOverrideValue(void 0,v)||{},keys:c.getKeysForOverrideIdentifier(v)},{contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)});k.push([v,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:a,overrides:k}}function t(c,r){const i=c?r?c.keys.filter(k=>r.keys.indexOf(k)===-1):[...c.keys]:[],n=r?c?r.keys.filter(k=>c.keys.indexOf(k)===-1):[...r.keys]:[],a=[];if(c&&r){for(const k of r.keys)if(c.keys.indexOf(k)!==-1){const I=(0,m.$di)(r.contents,k),A=(0,m.$di)(c.contents,k);S.$Zm(I,A)||a.push(k)}}return{added:i,removed:n,updated:a}}}),define(te[236],ie([0,1,23,3,2,37,12,119,59,5,39,43]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class p extends s.$kc{constructor(){super(...arguments),this.a=this.B(new O.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$8m.as(h.$an.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:g})=>this.c(Array.from(d),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,g){this.h(d,b.$8m.as(h.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new S.$qn;const d=b.$8m.as(h.$an.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,g){const o=this.f();for(const $ of d){const E=o[$],u=g[$];E!==void 0?this.b.addValue($,E):u?this.b.addValue($,u.default):this.b.removeValue($)}}}e.$wn=p;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new S.$qn}async initialize(){return this.configurationModel}}e.$xn=f;let y=class extends s.$kc{get configurationModel(){return this.b}constructor(d,g,o){super(),this.c=d,this.f=g,this.g=o,this.a=this.B(new O.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const g={},o=[],$=b.$8m.as(h.$an.Configuration).getConfigurationProperties();for(const E of d){const u=$[E];if(!u){o.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}o.push(E),g[u.policy.name]={type:u.type}}}return(0,D.$wf)(g)||await this.f.updatePolicyDefinitions(g),o}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const g=b.$8m.as(h.$an.Configuration).getPolicyConfigurations(),o=(0,P.$Fb)(d.map($=>g.get($)));this.m(o,!0)}m(d,g){this.g.trace("PolicyConfiguration#update",d);const o=b.$8m.as(h.$an.Configuration).getConfigurationProperties(),$=[],E=this.b.isEmpty();for(const u of d){const t=o[u]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(E?c!==void 0:!(0,M.$Zm)(this.b.getValue(u),c))&&$.push([u,c])}else this.b.getValue(u)!==void 0&&$.push([u,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const u=this.b;this.b=new S.$qn;for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,c]of $)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);g&&this.a.fire(this.b)}}};e.$yn=y,e.$yn=y=ke([_(1,m.$0m),_(2,l.$5i)],y)}),define(te[237],ie([0,1,8,3,2,19,18,119,236,39]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class m extends s.$kc{constructor(p,f,y,w){super(),this.j=p,this.h=this.B(new O.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$wn),this.c=y instanceof l.$_m?new h.$xn:this.B(new h.$yn(this.b,y,w)),this.f=this.B(new S.$sn(this.j,{},M.$_f,f)),this.a=new S.$tn(this.b.configurationModel,this.c.configurationModel,new S.$qn,new S.$qn),this.g=this.B(new P.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:g})=>this.n(d,g))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,f,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$tn(p,f,new S.$qn,y)}getConfigurationData(){return this.a.toData()}getValue(p,f){const y=typeof p=="string"?p:void 0,w=(0,D.$9h)(p)?p:(0,D.$9h)(f)?f:{};return this.a.getValue(y,w,void 0)}updateValue(p,f,y,w){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const f=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(y,f,2)}n(p,f){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(p,f);this.s(w,y,7)}r(p){const f=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.s(y,f,7)}s(p,f,y){const w=new S.$vn(p,{data:f},this.a);w.source=y,w.sourceConfig=this.t(y),this.h.fire(w)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=m}),define(te[238],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=e.$76b=e.$66b=void 0,e.$66b="request",e.$76b="remoteResourceHandler";class P{async routeCall(s,M,D){if(M!==e.$66b)throw new Error(`Call not found: ${M}`);const S=D[0];if(S?.authority){const h=s.connections.find(l=>l.ctx===S.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$86b=P}),define(te[239],ie([0,1,14,6]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,O.$Bh)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=M;class D{constructor(b,p){this.host=b,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=D;var S;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class h extends P.$_{static isNotAvailable(b){return b instanceof h&&b._code===S.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof h&&b._code===S.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof h&&b._code===S.NoResolverFound}static isInvalidAuthority(b){return b instanceof h&&b._code===S.InvalidAuthority}static isHandled(b){return b instanceof h&&b.isHandled}constructor(b,p=S.Unknown,f){super(b),this._message=b,this._code=p,this._detail=f,this.isHandled=p===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Mk=h;function l(m){const b=m.indexOf("+");return b===-1?m:m.substring(0,b)}e.$Nk=l}),define(te[60],ie([0,1,13]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function O(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.$Ok=O;function s(l){if(!l)return;const m=l.indexOf("+");return m<0?l:l.substr(0,m)}e.$Pk=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Qk=M;function D(l){const{host:m,port:b}=h(l);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:b}}e.$Rk=D;function S(l,m){let{host:b,port:p}=h(l);return typeof p>"u"&&(p=m),{host:b,port:p}}e.$Sk=S;function h(l){const m=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const b=l.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(te[120],ie([0,1,26,6,60]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Tl=M,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class h{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const o=typeof d=="string"?d:d.value,$=typeof g=="string"?g:g.value;return P.$Me(o,$)}return d._lower===g._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Vl=h;class l{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const g of d)this.add(g)}add(d){this.c.add(h.toKey(d))}delete(d){return this.c.delete(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}}e.$Wl=l;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(h.toKey(d))}get(d){return this.c.get(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}set(d,g){this.c.set(h.toKey(d),g)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=m;function b(w){return p(w)}e.$Yl=b;function p(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Zl=p;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$1l=f;function y(w,d){if(d){const g=`onResolveRemoteAuthority:${(0,s.$Pk)(d)}`;return!!w.activationEvents?.includes(g)}return!1}e.$2l=y,e.$3l=(0,O.$Bh)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,22,14,3,2,65,69,31,109,239,60]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const y=30*1e3;var w;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function d(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(Y){const R=new s.$pd;return setTimeout(()=>R.cancel(),Y),R.token}function o(Y,R){if(Y.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$pd;return Y.onCancellationRequested(()=>j.cancel()),R.onCancellationRequested(()=>j.cancel()),j.token}class ${get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new S.$jc,this.promise=new Promise((j,W)=>{this.f=j,this.g=W}),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function E(Y,R){const j=new $(R);return j.registerDisposable(Y.onControlMessage(W=>{const T=JSON.parse(W.toString()),H=F(T);H?j.reject(H):j.resolve(T)})),j.promise}function u(Y,R,j,W,T,H,z,ne){const fe=new $(ne),ge=l.$bd.create(!1);return Y.info(`Creating a socket (${z})...`),h.mark(`code/willCreateSocket/${H}`),R.connect(j,W,T,z).then(ue=>{fe.didTimeout?(h.mark(`code/didCreateSocketError/${H}`),Y.info(`Creating a socket (${z}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(h.mark(`code/didCreateSocketOK/${H}`),Y.info(`Creating a socket (${z}) was successful after ${ge.elapsed()} ms.`),fe.resolve(ue))},ue=>{h.mark(`code/didCreateSocketError/${H}`),Y.info(`Creating a socket (${z}) returned an error after ${ge.elapsed()} ms.`),Y.error(ue),fe.reject(ue)}),fe.promise}function t(Y,R){const j=new $(R);return Y.then(W=>{j.didTimeout||j.resolve(W)},W=>{j.didTimeout||j.reject(W)}),j.promise}async function c(Y,R,j,W){const T=x(Y,R);Y.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let H;try{H=await u(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,(0,f.$Qk)(Y),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,d(R),`renderer-${d(R)}-${Y.reconnectionToken}`,W)}catch(ue){throw Y.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(ue),ue}Y.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let z,ne;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(H,null),z=Y.reconnectionProtocol,ne=!1):(z=new b.$ph({socket:H}),ne=!0),Y.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const fe=await t(Y.signService.createNewMessage((0,m.$4f)()),W),ge={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:fe.data};z.sendControl(O.$Fd.fromString(JSON.stringify(ge)));try{const ue=await E(z,o(W,g(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(Y.logService.trace(`${T} 4/6. received SignRequest control message.`),!await t(Y.signService.validate(fe,ue.signedData),W)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const me=await t(Y.signService.sign(ue.data),W),Se={type:"connectionType",commit:Y.commit,signedData:me,desiredConnectionType:R};return j&&(Se.args=j),Y.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(O.$Fd.fromString(JSON.stringify(Se))),{protocol:z,ownsProtocol:ne}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(Y.logService.error(`${T} the handshake timed out. Error:`),Y.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${T} received error control message when negotiating connection. Error:`),Y.logService.error(ue)),ne&&q(z),ue}}async function r(Y,R,j,W){const T=Date.now(),H=x(Y,R),{protocol:z,ownsProtocol:ne}=await c(Y,R,j,W),fe=new $(W);return fe.registerDisposable(z.onControlMessage(ge=>{const ue=JSON.parse(ge.toString()),we=F(ue);we?(Y.logService.error(`${H} received error control message when negotiating connection. Error:`),Y.logService.error(we),ne&&q(z),fe.reject(we)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${ce(T)}!`),fe.resolve({protocol:z,firstMessage:ue}))})),fe.promise}async function i(Y,R){const{protocol:j}=await r(Y,1,void 0,R);return{protocol:j}}async function n(Y,R,j){const{protocol:W,firstMessage:T}=await r(Y,2,R,j),H=T&&T.debugPort;return{protocol:W,debugPort:H}}async function a(Y,R,j){const W=Date.now(),T=x(Y,3),{protocol:H}=await c(Y,3,R,j);return Y.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${ce(W)}!`),H}async function k(Y,R,j){const{connectTo:W,connectionToken:T}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:W,connectionToken:T,reconnectionToken:R,reconnectionProtocol:j,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function I(Y,R,j){return v(Y,async W=>{const{protocol:T}=await i(W,s.CancellationToken.None);return new G(Y,R,j,W.reconnectionToken,T)})}e.$Xk=I;async function A(Y,R){return v(Y,async j=>{const{protocol:W,debugPort:T}=await n(j,R,s.CancellationToken.None);return new K(Y,R,j.reconnectionToken,W,T)})}e.$Yk=A;async function v(Y,R){for(let W=1;;W++)try{const T=(0,m.$4f)(),H=await k(Y,T,null);return await R(H)}catch(T){if(W<5)Y.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(T);else throw Y.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(T),oe.triggerPermanentFailure(0,0,p.$Mk.isHandled(T)),T}}async function C(Y,R,j){const W=await k(Y,(0,m.$4f)(),null);return await a(W,{host:R,port:j},s.CancellationToken.None)}e.$Zk=C;function L(Y){return(0,P.$ug)(R=>new Promise((j,W)=>{const T=setTimeout(j,Y*1e3);R.onCancellationRequested(()=>{clearTimeout(T),j()})}))}var U;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class B{constructor(R,j){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.type=0}}e.$1k=B;class re{constructor(R,j,W,T){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.durationSeconds=W,this.c=T,this.type=1}skipWait(){this.c.cancel()}}e.$2k=re;class ee{constructor(R,j,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=W,this.type=2}}e.$3k=ee;class ae{constructor(R,j,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=W,this.type=4}}e.$4k=ae;class se{constructor(R,j,W,T){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=W,this.handled=T,this.type=3}}e.$5k=se;class oe extends S.$kc{static triggerPermanentFailure(R,j,W){this._permanentFailure=!0,this.f=R,this.g=j,this.h=W,this.j.forEach(T=>T.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(R=>R.y())}static debugPauseSocketWriting(){this.j.forEach(R=>R.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(R,j,W,T,H){super(),this.t=R,this.u=j,this.reconnectionToken=W,this.protocol=T,this.w=H,this.m=this.B(new D.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(T.onSocketClose(z=>{const ne=X(this.t,this.reconnectionToken,!0);z?z.type===0?(this.u.logService.info(`${ne} received socket close event (hadError: ${z.hadError}).`),z.error&&this.u.logService.error(z.error)):(this.u.logService.info(`${ne} received socket close event (wasClean: ${z.wasClean}, code: ${z.code}, reason: ${z.reason}).`),z.event&&this.u.logService.error(z.event)):this.u.logService.info(`${ne} received socket close event.`),this.y()})),this.B(T.onSocketTimeout(z=>{const ne=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${z.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,S.$ic)(()=>{const z=oe.j.indexOf(this);z>=0&&oe.j.splice(z,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const R=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const T=W<j.length?j[W]:j[j.length-1];try{if(T>0){const z=L(T);this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,z)),this.u.logService.info(`${R} waiting for ${T} seconds before reconnecting...`);try{await z}catch{}}if(this.n){this.u.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this.u.logService.info(`${R} resolving connection...`);const H=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${R} connecting to ${H.connectTo}...`),await this.G(H,g(y)),this.u.logService.info(`${R} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this.u.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(p.$Mk.isTemporarilyNotAvailable(H)){this.u.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,M.$2)(H)){this.u.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof p.$Mk){this.u.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,p.$Mk.isHandled(H));break}this.u.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this.n&&!this.s)}C(R,j,W){this.w?oe.triggerPermanentFailure(R,j,W):this.D(R,j,W)}D(R,j,W){this.m.fire(new se(this.reconnectionToken,R,j,W)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=oe;class G extends oe{constructor(R,j,W,T,H){super(1,R,T,H,!0),this.client=this.B(new b.$nh(H,{remoteAuthority:j,clientId:W},R.ipcLogger))}async G(R,j){await i(R,j)}}e.$7k=G;class K extends oe{constructor(R,j,W,T,H){super(2,R,W,T,!1),this.H=j,this.debugPort=H}async G(R,j){await n(R,this.H,j)}}e.$8k=K;function q(Y){try{Y.acceptDisconnect();const R=Y.getSocket();Y.dispose(),R.dispose()}catch(R){(0,M.$Y)(R)}}function F(Y){if(Y&&Y.type==="error"){const R=new Error(`Connection error: ${Y.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function N(Y,R){for(;Y.length<R;)Y+=" ";return Y}function V(Y,R){return`[remote-connection][${N(d(Y),13)}][${R.substr(0,5)}\u2026]`}function X(Y,R,j){return`${V(Y,R)}[${j?"reconnect":"initial"}]`}function x(Y,R){return`${X(R,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function ce(Y){return`${Date.now()-Y} ms`}}),define(te[241],ie([0,1,2,6]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,O.$Bh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$ic)(()=>{const h=this.a[D]?.indexOf(S);typeof h=="number"&&h>=0&&this.a[D]?.splice(h,1)})}b(D){return(this.a[D.type]||[]).find(h=>h.supports(D))}connect(D,S,h,l){const m=this.b(D);if(!m)throw new Error(`No socket factory found for ${D}`);return m.connect(D,S,h,l)}}e.$Uk=s}),define(te[242],ie([0,1,27,47,21,113]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;let D;async function S(f=!1){return(D===void 0||f)&&(D=h()),D}e.$75b=S;async function h(){const f=l();if(f===void 0)return!1;if(f>=22e3){const y=b();if(y)return new Promise(w=>{O.execFile(y,["--status"],d=>w(!d))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(f)return parseInt(f[3])}function m(f){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,w?"Sysnative":"System32",f)}}function b(){return m("wsl.exe")}function p(){return m("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,14,2,182,59,6,5,43]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,S.$Bh)("requestService");class m{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class b extends s.$kc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,M.localize)(0,null),when:h.$jj.isEqualTo((0,h.$hj)(h.LogLevel.Trace)).serialize()})}async c(u,t,c){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new m(t.headers??{}));try{const i=await c();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,O.$8)(i)),i}}}e.$Jo=b;function p(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Ko=p;function f(E){return E.res.statusCode===204}e.$Lo=f;async function y(E){return f(E)?null:(await(0,P.$Rd)(E.stream)).toString()}e.$Mo=y;async function w(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$No=w;async function d(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const t=(await(0,P.$Rd)(E.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}e.$Oo=d;function g(E){$(E)}e.$Po=g;let o;function $(E){const u=l.$8m.as(D.$an.Configuration),t=o;o={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},u.updateConfigurations({add:[o],remove:t?[t]:[]})}$(1)}),define(te[243],ie([0,1,17,22]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class s{constructor(S){this.a=S}listen(S,h){throw new Error("Invalid listen")}call(S,h,l,m=O.CancellationToken.None){switch(h){case"request":return this.a.request(l[0],m).then(async({res:b,stream:p})=>{const f=await(0,P.$Rd)(p);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.a.resolveProxy(l[0])}throw new Error("Invalid call")}}e.$Lq=s;class M{constructor(S){this.a=S}async request(S,h){const[l,m]=await this.a.call("request",[S],h);return{res:l,stream:(0,P.$Td)(m)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Mq=M}),define(te[244],ie([0,1,245,12]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(D,S,h={}){const l=(0,P.parse)(D),m=h.proxyUrl||s(l,S);if(!m)return null;const b=(0,P.parse)(m);if(!/^https?:$/.test(b.protocol||""))return null;const p={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,O.$pf)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((f,y)=>{J(["http-proxy-agent"],f,y)}))(p):new(await new Promise((f,y)=>{J(["https-proxy-agent"],f,y)}))(p)}e.$Nq=M}),define(te[246],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=e.$r6b=e.$q6b=void 0,e.$q6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$r6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$s6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,183,22,50,14,4,31,108,63,8,139]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=void 0;let y;async function w(g,o,$,E){return $["force-disable-user-env"]?(o.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(o.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Gl)(E)&&!$["force-user-env"]?(o.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Gl)(E)?o.trace("resolveShellEnv(): running (--force-user-env)"):o.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(u,t)=>{const c=new M.$pd;let r=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,f.$Hl)(i,1,120)*1e3);const n=setTimeout(()=>{c.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{u(await d(o,c.token))}catch(a){!(0,S.$2)(a)&&!c.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$mi)(a)))):u({})}finally{clearTimeout(n),c.dispose()}})),y)}e.$Ml=w;async function d(g,o){const $=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",$);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const u=(0,l.$4f)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",c);const r=await(0,m.$wl)(h.OS,c);return g.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(o.isCancellationRequested)return n(new S.$3);const a=(0,O.$ae)(r);let k,I;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(k=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,I=["-Login","-Command"]):a==="nu"?(k=`^'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,a==="tcsh"||a==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const v=(0,P.spawn)(r,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});o.onCancellationRequested(()=>(v.kill(),n(new S.$3))),v.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,D.$mi)(U)),n(U)});const C=[];v.stdout.on("data",U=>C.push(U));const L=[];v.stderr.on("data",U=>L.push(U)),v.on("close",(U,B)=>{const re=Buffer.concat(C).toString("utf8");g.trace("getUnixShellEnvironment#raw",re);const ee=Buffer.concat(L).toString("utf8");if(ee.trim()&&g.trace("getUnixShellEnvironment#stderr",ee),U||B)return n(new Error((0,s.localize)(2,null,U,B)));const ae=t.exec(re),se=ae?ae[1]:"{}";try{const oe=JSON.parse(se);$?oe.ELECTRON_RUN_AS_NODE=$:delete oe.ELECTRON_RUN_AS_NODE,E?oe.ELECTRON_NO_ATTACH_CONSOLE=E:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){g.error("getUnixShellEnvironment#errorCaught",(0,D.$mi)(oe)),n(oe)}})})}}),define(te[247],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s2b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(P.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$s2b=P}),define(te[95],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,P.$Bh)(e.$Vk)}),define(te[248],ie([0,1,247]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=void 0;class O extends P.$s2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>J(["vsda"],M,D))}}e.$e7b=O}),define(te[34],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0,e.$dN=(0,P.$Bh)("stateReadService"),e.$eN=(0,P.$Bh)("stateService")}),define(te[121],ie([0,1,8,17,2,12,36,16,5]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=e.$fN=e.SaveStrategy=void 0;var l;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class m extends s.$kc{constructor(y,w,d,g){super(),this.h=y,this.j=d,this.m=g,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new P.$Eg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,w){const d=this.a[y];return(0,M.$sf)(d)?w:d}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:d,data:g}of y)this.a[d]!==g&&((0,M.$sf)(g)?(0,M.$qf)(this.a[d])||(this.a[d]=void 0,w=!0):(this.a[d]=g,w=!0));w&&this.r()}removeItem(y){(0,M.$qf)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,O.$Fd.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$fN=m;let b=class extends s.$kc{constructor(y,w,d,g){super(),this.a=this.B(new m(w.stateResource,y,d,g))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$gN=b,e.$gN=b=ke([_(1,D.$Ih),_(2,h.$5i),_(3,S.$6j)],b);class p extends b{setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$hN=p}),define(te[122],ie([0,1,4,35,31]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function M(h){if(P.$t===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function D(h,l,m,b,p,f,y,w){const d=Object.create(null);d["common.machineId"]=f,d.sessionID=(0,s.$4f)()+Date.now(),d.commitHash=b,d.version=p,d["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,P.$h)(P.$t),d["common.nodePlatform"]=O.$3d,d["common.nodeArch"]=m,d["common.product"]=w||"desktop",y&&(d["common.msftInternal"]=y);let g=0;const o=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),P.$l&&(d["common.snap"]="true");const $=M(l);return $&&(d["common.platformDetail"]=$),d}e.$0n=D;function S(h){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const m=l.toLowerCase();return h.some(b=>m===b)}e.$$n=S}),define(te[25],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,P.$Bh)("telemetryService"),e.$0k=(0,P.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[249],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0;const d=new Map;async function g(t,c){const r=`${t}::${c.join(":")}`,i=d.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,k=new Map,I=2e4;function A(C,L,U,B){const re=L.substring(C.length+1);return O.Promises.withAsyncBody(async ee=>{let ae;try{ae=await m.Promises.readdir(L,{withFileTypes:!0})}catch{ee();return}if(B.count>=I){B.count+=ae.length,B.maxReached=!0,ee();return}let se=ae.length;if(se===0){ee();return}let oe=ae;B.count+ae.length>I&&(B.maxReached=!0,se=I-B.count,oe=ae.slice(0,se)),B.count+=ae.length;for(const G of oe)if(G.isDirectory()){if(U.includes(G.name)||await A(C,(0,D.$9d)(L,G.name),U,B),--se===0){ee();return}}else{const K=G.name.lastIndexOf(".");if(K>=0){const q=G.name.substring(K+1);q&&a.set(q,(a.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(re)!==!1&&q.filePattern.test(G.name)&&k.set(q.tag,(k.get(q.tag)??0)+1);if(--se===0){ee();return}}})}const v=O.Promises.withAsyncBody(async C=>{const L={count:0,maxReached:!1};await A(t,t,c,L);const U=await E(t);C({configFiles:o(k),fileTypes:o(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:U})});return d.set(r,v),v}e.$tr=g;function o(t){return Array.from(t.entries(),([c,r])=>({name:c,count:r})).sort((c,r)=>r.count-c.count)}function $(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/f.$Ak.GB).toFixed(2)}GB (${(P.freemem()/f.$Ak.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$Hm.value()*100)}%`},c=P.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.$ur=$;async function E(t){try{const c=new Map,r=(0,D.$9d)(t,".vscode","launch.json"),i=await m.Promises.readFile(r),n=[],a=(0,s.$Lm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Um)(a)==="object"&&a.configurations)for(const k of a.configurations){const I=k.type;I&&(c.has(I)?c.set(I,c.get(I)+1):c.set(I,1))}return o(c)}catch{return[]}}e.$vr=E;let u=class{constructor(c,r){this.c=c,this.d=r}f(c){const r=[];return r.push(`OS Version:       ${c.os}`),r.push(`CPUs:             ${c.cpus}`),r.push(`Memory (System):  ${c.memory}`),r.push(`VM:               ${c.vmHint}`),r.join(`
`)}g(c){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/f.$Ak.GB).toFixed(2)}GB (${(P.freemem()/f.$Ak.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$Hm.value()*100)}%`),r.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${c.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(c,r){return Promise.all([(0,b.$sr)(c.mainPID),this.k(c)]).then(async i=>{let[n,a]=i,k=this.m(c,n);return r.forEach(I=>{if((0,p.$hm)(I))k+=`
${I.errorMessage}`,a+=`
${I.errorMessage}`;else if(k+=`

Remote: ${I.hostName}`,I.processes&&(k+=`
${this.m(c,I.processes)}`),I.workspaceMetadata){a+=`
|  Remote: ${I.hostName}`;for(const A of Object.keys(I.workspaceMetadata)){const v=I.workspaceMetadata[A];let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),a+=`|    Folder (${A}): ${C}`,a+=this.h(v)}}}),{processInfo:k,workspaceInfo:a}})}async getSystemInfo(c,r){const{memory:i,vmHint:n,os:a,cpus:k}=$(),I={os:a,memory:i,cpus:k,vmHint:n,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(I.load=`${P.loadavg().map(A=>Math.round(A)).join(", ")}`),S.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(c,r){const i=[];return(0,b.$sr)(c.mainPID).then(async n=>(i.push(""),i.push(this.g(c)),i.push(""),i.push(this.m(c,n)),c.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(c))),r.forEach(a=>{if((0,p.$hm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(c,a.processes)),a.workspaceMetadata)for(const k of Object.keys(a.workspaceMetadata)){const I=a.workspaceMetadata[k];let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${k}): ${A}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(c){const r=[];let n=0;const a=(v,C)=>{const L=` ${v}(${C})`;n+L.length>60?(r.push(k),k="|                 ",n=k.length):n+=L.length,k+=L};let k="|      File types:";const I=10,A=c.fileTypes.length>I?I:c.fileTypes.length;for(let v=0;v<A;v++){const C=c.fileTypes[v];a(C.name,C.count)}if(r.push(k),c.configFiles.length>=0&&(k="|      Conf files:",n=0,c.configFiles.forEach(v=>{a(v.name,v.count)}),r.push(k)),c.launchConfigFiles.length>0){let v="|      Launch Configs:";c.launchConfigFiles.forEach(C=>{const L=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;v+=L}),r.push(v)}return r.join(`
`)}j(c){const r=Math.max(...Object.keys(c).map(i=>i.length));return Object.keys(c).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${c[i]}`).join(`
                  `)}k(c){const r=[],i=[];return c.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const k=h.URI.revive(a);if(k.scheme===M.Schemas.file){const I=k.fsPath;i.push(g(I,["node_modules",".git"]).then(A=>{let v=`${A.fileCount} files`;A.maxFilesReached&&(v=`more than ${v}`),r.push(`|    Folder (${(0,D.$ae)(I)}): ${v}`),r.push(this.h(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${A.toString()})`)}))}else r.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(c,r){const i=new Map;c.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),c.pidToNames.forEach(({pid:a,name:k})=>i.set(a,k));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(c.mainPID,i,n,r,0),n.join(`
`)}n(c,r,i,n,a){const k=a===0;let I;k?I=n.pid===c?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?I=r.get(n.pid):I=`${"  ".repeat(a)} ${n.name}`;const A=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(A/f.$Ak.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(n.children)&&n.children.forEach(v=>this.n(c,r,i,v,a+1))}async getWorkspaceFileExtensions(c){const r=new Set;for(const{uri:i}of c.folders){const n=h.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const a=n.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(c){for(const{uri:r}of c.folders){const i=h.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const a=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),a.fileTypes.forEach(k=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:k.name,count:k.count})}),a.launchConfigFiles.forEach(k=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:k.name,count:k.count})}),a.configFiles.forEach(k=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:k.name,count:k.count})})}catch{}}}};e.$wr=u,e.$wr=u=ke([_(0,w.$9k),_(1,y.$kj)],u)}),define(te[250],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=void 0;class P{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:S,data:h}){return this.b.forEach(l=>l.log(S,h)),Promise.resolve(null)}}e.$v6b=P;class O{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$w6b=O}),define(te[52],ie([0,1,37,12,3,18,60,122,25]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$_n=l;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=m,e.$bo=new m;class b{async publicLog(n,a,k){}async publicLogError(n,a,k){}}e.$co=b,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(k,I)=>{const A=k?new Set([...k.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:A}},1e3,!0)(k=>{k.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$$h)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$go=p;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$ho=f;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$io=y;function w(i){const n=i.getValue(h.$dl),a=i.getValue(h.$el);if(i.getValue(h.$fl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=w;function d(i){const n={},a={},k={};$(i,k);for(let I in k){I=I.length>150?I.substr(I.length-149):I;const A=k[I];typeof A=="number"?a[I]=A:typeof A=="boolean"?a[I]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${A.length}`),n[I]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(n[I]=A)}return{properties:n,measurements:a}}e.$ko=d;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(i){if(!i)return"none";const n=(0,D.$Pk)(i);return g.has(n)?n:"other"}e.$lo=o;function $(i,n,a=0,k){if(i)for(const I of Object.getOwnPropertyNames(i)){const A=i[I],v=k?k+I:I;Array.isArray(A)?n[v]=(0,P.$1m)(A):A instanceof Date?n[v]=A.toISOString():(0,O.$lf)(A)?a<2?$(A,n,a+1,v+"."):n[v]=(0,P.$1m)(A):n[v]=A}}function E(i,n){const a=i.msftInternalDomains||[],k=n.getValue("telemetry.internalTesting");return(0,S.$$n)(a)||k}e.$mo=E;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$no=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const k=[];for(const C of n)for(;;){const L=C.exec(i);if(!L)break;k.push([L.index,C.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const C=A.exec(i);if(!C)break;const L=k.some(([U,B])=>C.index<B&&U<A.lastIndex);!I.test(C[0])&&!L&&(a+=i.substring(v,C.index)+"<REDACTED: user-file-path>",v=A.lastIndex)}return v<i.length&&(a+=i.substr(v)),a}function c(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function r(i,n){return(0,P.$Xm)(i,a=>{if(a instanceof l||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let k=a.replaceAll("%20"," ");k=t(k,n);for(const I of n)k=k.replace(I,"");return k=c(k),k}})}e.$oo=r}),define(te[123],ie([0,1,26,116,120,4,7,14,35,52]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function m(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$He)(r.id,i.id)===0}e.$po=m;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,a)}static parse(i){const n=b.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$qo=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=f.exec(r);return i&&i[1]?[d(i[1]),i[2]]:[d(r),void 0]}e.$ro=y;function w(r,i){return`${r}.${i}`}e.$so=w;function d(r){return r.toLowerCase()}e.$to=d;function g(r,i){return d(w(r??s.$Rl,i))}e.$uo=g;function o(r,i){const n=[],a=k=>{for(const I of n)if(I.some(A=>m(i(A),i(k))))return I;return null};for(const k of r){const I=a(k);I?I.push(k):n.push([k])}return n}e.$vo=o;function $(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$wo=$;function E(r){return{id:new l.$_n(r.identifier.id),name:new l.$_n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$xo=E,e.$yo=new s.$Vl("pprice.better-merge");function u(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const k=a.shift();if(k&&n.every(I=>!m(I.identifier,{id:k}))){const I=r.filter(A=>m(A.identifier,{id:k}));I.length===1&&(n.push(I[0]),a.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$zo=u;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,S.$8)(k))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(r,i){const n=await t(r,i),a=(0,O.$Un)(n?"alpine":M.$t,h.$4d);return i.debug("ComputeTargetPlatform:",a),a}e.$Ao=c}),define(te[251],ie([0,1,205,52]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function s(M,D,S,h,l,m,b){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,O.$ho)(D,S)&&(0,O.$jo)(h)===3){const f=await(0,P.$2o)(S,l,m);p["X-Market-User-Id"]=f,p["VSCode-SessionId"]=b.machineId||f}return p}e.$3o=s}),define(te[252],ie([0,1,2,37,4,26,184,18,59,77,24,43,25,52]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,o,$){this.k=o,this.l=$,this.d={},this.i=new P.$jc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$qe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$qe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(p.$dl)||E.affectsConfiguration(p.$fl)||E.affectsConfiguration(p.$el))&&this.m()}))}setExperimentProperty(g,o){this.d[g]=o}m(){let g=(0,f.$jo)(this.k);const o=this.l.enabledTelemetryLevels;if(o){this.h=this.sendErrorTelemetry?o.error:!1;const $=o.usage?3:o.error?2:0;g=Math.min(g,$)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,o,$){this.g<o||($=(0,O.$Ym)($,this.d),$=(0,f.$oo)($,this.j),$=(0,O.$Ym)($,this.c),this.b.forEach(E=>E.log(g,$)))}publicLog(g,o){this.n(g,3,o)}publicLog2(g,o){this.publicLog(g,o)}publicLogError(g,o){this.h&&this.n(g,2,o)}publicLogError2(g,o){this.publicLogError(g,o)}};e.$Qq=y,e.$Qq=y=ke([_(1,S.$8h),_(2,m.$kj)],y);function w(){const d=(0,D.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),o=s.$o?"":(0,D.localize)(3,null),$=(0,D.localize)(4,null),E=(0,D.localize)(5,null),u=(0,D.localize)(6,null),t=(0,D.localize)(7,null),c=`
|       | ${$} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${d} ${g} ${o}

&nbsp;

${t}
${c}

&nbsp;

${r}
`}b.$8m.as(h.$an.Configuration).registerConfiguration({id:p.$cl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[p.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$8m.as(h.$an.Configuration).registerConfiguration({id:p.$cl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[p.$fl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,D.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,D.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${p.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[253],ie([0,1,4,86,25]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;async function M(D,S){let h=D.getItem(s.$bl);return(typeof h!="string"||P.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,O.$Im)(S.error.bind(S))),h}e.$Y6b=M}),define(te[254],ie([0,1,25,253]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;async function s(M,D){const S=await(0,O.$Y6b)(M,D);return M.setItem(P.$bl,S),S}e.$Z6b=s}),define(te[124],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(te[255],ie([0,1,4,124]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;const s=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((b,p)=>{this.d(b,p);const f=b.map.entries();let y=f.next();for(;!y.done;){const w=y.value[1],d=y.value[0];let g=this.a.get(d);if(g||(g=[],this.a.set(d,g)),g.length>0&&g[0].type===O.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const o={extensionIdentifier:p,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};o.scope||delete o.scope,g.unshift(o),y=f.next()}})}async applyToProcessEnvironment(m,b,p){let f;P.$i&&(f={},Object.keys(m).forEach(y=>f[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap(b)){const d=P.$i&&f[y.toLowerCase()]||y;for(const g of w){const o=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case O.EnvironmentVariableMutatorType.Append:m[d]=(m[d]||"")+o;break;case O.EnvironmentVariableMutatorType.Prepend:m[d]=o+(m[d]||"");break;case O.EnvironmentVariableMutatorType.Replace:m[d]=o;break}if(g.options?.applyAtShellIntegration??!1){const $=`VSCODE_ENV_${s.get(g.type)}`;m[$]=(m[$]?m[$]+":":"")+y+"="+this.c(o)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,b){const p=new Map,f=new Map,y=new Map;if(m.getVariableMap(b).forEach((w,d)=>{const g=this.getVariableMap(b).get(d),o=S(w,g);o&&p.set(d,o)}),this.getVariableMap(b).forEach((w,d)=>{const g=m.getVariableMap(b).get(d),o=S(w,g);o&&y.set(d,o)}),this.getVariableMap(b).forEach((w,d)=>{const g=m.getVariableMap(b).get(d),o=h(w,g);o&&f.set(d,o)}),!(p.size===0&&f.size===0&&y.size===0))return{added:p,changed:f,removed:y}}getVariableMap(m){const b=new Map;for(const p of this.a.values()){const f=p.filter(y=>D(y,m));f.length>0&&b.set(f[0].variable,f)}return b}getDescriptionMap(m){const b=new Map;for(const p of this.b.values()){const f=p.filter(y=>D(y,m,!0));for(const y of f)b.set(y.extensionIdentifier,y.description)}return b}d(m,b){if(!m.descriptionMap)return;const p=m.descriptionMap.entries();let f=p.next();for(;!f.done;){const y=f.value[1],w=f.value[0];let d=this.b.get(w);d||(d=[],this.b.set(w,d));const g={extensionIdentifier:b,scope:y.scope,description:y.description};g.scope||delete g.scope,d.push(g),f=p.next()}}}e.$gr=M;function D(l,m,b=!1){return l.scope?!!(l.scope.workspaceFolder&&m?.workspaceFolder&&l.scope.workspaceFolder.index===m.workspaceFolder.index):b?m===l.scope:!0}function S(l,m){if(!m)return l;const b=new Set;m.forEach(f=>b.add(f.extensionIdentifier));const p=[];return l.forEach(f=>{b.has(f.extensionIdentifier)||p.push(f)}),p.length===0?void 0:p}function h(l,m){if(!m)return;const b=new Map;m.forEach(f=>b.set(f.extensionIdentifier,f));const p=[];return l.forEach(f=>{const y=b.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(te[256],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function P(h){return[...h.entries()]}e.$ar=P;function O(h){return h?[...h.entries()]:[]}e.$br=O;function s(h){return new Map(h)}e.$cr=s;function M(h){return new Map(h??[])}e.$dr=M;function D(h){return Array.from(h.entries()).map(l=>[l[0],P(l[1].map),O(l[1].descriptionMap)])}e.$er=D;function S(h){return new Map(h.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$fr=S}),define(te[257],ie([0,1,8,22,3,2,5]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let S=class extends M.$kc{constructor(l,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$fd),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$ic)(()=>{for(const b of this.f.values())(0,M.$fc)(b)}))}createRequest(l){return new Promise((m,b)=>{const p=++this.a;this.c.set(p,m),this.g.fire({requestId:p,...l});const f=new O.$pd;(0,P.$Hg)(this.b,f.token).then(()=>b(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$ic)(()=>f.cancel())])})}acceptReply(l,m){const b=this.c.get(l);b?(this.c.delete(l),(0,M.$fc)(this.f.get(l)||[]),this.f.delete(l),b(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$4q=S,e.$4q=S=ke([_(1,D.$5i)],S)}),define(te[125],ie([0,1,6,114,43]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Wq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Vq=void 0,e.$Vq=new O.$2i("terminalTabFocusMode",!1,!0);var M;(function(u){u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(S||(e.PosixShellType=S={}));var h;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var l;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var m;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var b;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$Wq=(0,P.$Bh)("ptyService");var p;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var f;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var d;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var g;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var o;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(o||(e.ShellIntegrationStatus=o={}));var $;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})($||(e.TerminalExitReason=$={})),e.$Xq={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const c=this.b(t.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$8m.add(e.$Xq.Backend,new E),e.$Yq=(0,P.$Bh)("localPtyService"),e.$Zq=(0,P.$Bh)("terminalLogService")}),define(te[258],ie([0,1,71,7,186,102]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=e.$5q=void 0;function D(p,f){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(w=>({name:w.profileName,description:S(w)}))),f&&y.push(...f.map(w=>({name:w.title,description:h(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.$5q=D;function S(p){let f=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Pj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?f+=`
- args: "${p.args}"`:f+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(f+=`
- overrideName: ${p.overrideName}`),p.color&&(f+=`
- color: ${p.color}`),p.env&&(f+=`
- env: ${JSON.stringify(p.env)}`),f}function h(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Pj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function l(p,f){if(!p&&!f)return!0;if(typeof p=="string"&&typeof f=="string")return p===f;if(Array.isArray(p)&&Array.isArray(f)){if(p.length!==f.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==f[y])return!1;return!0}return!1}e.$6q=l;function m(p,f){if(!p&&!f)return!0;if(!p||!f)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(f))return p.id===f.id&&p.color===f.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof f=="object"&&"light"in f&&"dark"in f){const y=p,w=f;if((O.URI.isUri(y.light)||b(y.light))&&(O.URI.isUri(y.dark)||b(y.dark))&&(O.URI.isUri(w.light)||b(w.light))&&(O.URI.isUri(w.dark)||b(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(O.URI.isUri(p)&&O.URI.isUri(f)||b(p)||b(f)){const y=p,w=f;return y.path===w.path&&y.scheme===w.scheme}return!1}e.$7q=m;function b(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$8q=b}),define(te[259],ie([0,1,71,4,185,59,43,258]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=e.$0q=e.$9q=void 0,e.$9q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$0q={type:"string",enum:Array.from((0,P.$Oj)(),d=>d.id),markdownEnumDescriptions:Array.from((0,P.$Oj)(),d=>`$(${d.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$0q},color:{description:(0,s.localize)(3,null),...e.$9q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function b(d){const g=d===2?"linux":d===1?"osx":"windows";return(0,s.localize)(7,null,(0,O.$h)(d),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){D.$8m.as(M.$an.Configuration).registerConfiguration(p),w()}e.$$q=f;let y;function w(d,g){const o=D.$8m.as(M.$an.Configuration);let $;d&&($=(0,S.$5q)(d?.profiles,g));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:d?.os===3?$?.values:void 0,markdownEnumDescriptions:d?.os===3?$?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:d?.os===2?$?.values:void 0,markdownEnumDescriptions:d?.os===2?$?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:d?.os===1?$?.values:void 0,markdownEnumDescriptions:d?.os===1?$?.markdownDescriptions:void 0}}},o.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$_q=w}),define(te[260],ie([0,1,27,13,37,9,4,35,26,12,21,124,256,255]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$hr=y;async function w(i,n,a,k=S.env,I=m.Promises.exists){if(M.$8d(i))return await I(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$_d(i)!=="."){const L=M.$9d(n,i);return await I(L)?L:void 0}const v=(0,s.$3m)(k,"PATH");if(a===void 0&&(0,l.$jf)(v)&&(a=v.split(M.$ge)),a===void 0||a.length===0){const L=M.$9d(n,i);return await I(L)?L:void 0}for(const L of a){let U;if(M.$8d(L)?U=M.$9d(L,i):U=M.$9d(n,L,i),await I(U))return U;if(D.$i){let B=U+".com";if(await I(B)||(B=U+".exe",await I(B)))return B}}const C=M.$9d(n,i);return await I(C)?C:void 0}e.$ir=w;function d(i,n,a,k,I){const A=D.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||A)return;const v=i.args,C=S.$3d==="win32"?M.$ae(i.executable).toLowerCase():M.$ae(i.executable),L=M.$_d(O.$2f.asFileUri("").fsPath);let U;const B={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(B.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!v||c(v)?U=$.get(o.WindowsPwsh):t(v)&&(U=$.get(o.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L,""),{newArgs:U,envMixin:B}):void 0;k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!v||v.length===0?U=$.get(o.Bash):r(v)&&(B.VSCODE_SHELL_LOGIN="1",g(n,B),U=$.get(o.Bash)),U?(U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L),{newArgs:U,envMixin:B}):void 0;case"fish":{const re=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${re}:${ee}`,g(n,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!v||c(v)?U=$.get(o.Pwsh):t(v)&&(U=$.get(o.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L,""),{newArgs:U,envMixin:B}):void 0;case"zsh":{if(!v||v.length===0?U=$.get(o.Zsh):r(v)?(U=$.get(o.ZshLogin),g(n,B)):(v===$.get(o.Zsh)||v===$.get(o.ZshLogin))&&(U=v),!U)return;U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L);let re;try{re=P.userInfo().username}catch{re="unknown"}const ee=M.$9d(P.tmpdir(),`${re}-${I.applicationName}-zsh`);B.ZDOTDIR=ee;const ae=a?.ZDOTDIR??P.homedir()??"~";B.USER_ZDOTDIR=ae;const se=[];return se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$9d(ee,".zshrc")}),se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$9d(ee,".zprofile")}),se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$9d(ee,".zshenv")}),se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$9d(ee,".zlogin")}),{newArgs:U,envMixin:B,filesToCopy:se}}}k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$jr=d;function g(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,p.$fr)(i.environmentVariableCollections),I=new f.$gr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),A=[];if(I)for(const v of I)v.type===b.EnvironmentVariableMutatorType.Prepend&&A.push(v.value);A.length>0&&(n.VSCODE_PATH_PREFIX=A.join(""))}}var o;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(o||(o={}));const $=new Map;$.set(o.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(o.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(o.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),$.set(o.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),$.set(o.Zsh,["-i"]),$.set(o.ZshLogin,["-il"]),$.set(o.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function c(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function r(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(te[261],ie([0,1,47,71,9,4,12,21,106,260,113]),function(J,e,P,O,s,M,D,S,h,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;let b,p=!0;function f(n,a,k,I,A=process.env,v,C,L,U){return v=v||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?y(k,v,A,C,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:I.getValue("terminal.integrated.defaultProfile.windows"),U,L):c(v,C,k,n&&typeof n=="object"?{...n}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,L,A)}e.$kr=f;async function y(n,a,k,I,A,v,C,L,U){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let ee=!1;(0,l.$hr)()>=16299&&(ee=!0),await o(L);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:O.$Pj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Pj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:O.$Pj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Pj.terminalBash,isAutoDetected:!0});const oe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",oe],requiresPath:process.env.CMDER_ROOT?oe:{path:oe,isUnsafe:!0},isAutoDetected:!0})}r(v,ae);const se=await w(ae.entries(),C,a,k,I,U);if(n&&A)try{const oe=await u(`${re}\\${ee?"wsl":"bash"}.exe`,C);for(const G of oe)(!v||!(G.profileName in v))&&se.push(G)}catch{p&&(I?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return se}async function w(n,a,k,I=process.env,A,v){const C=[];for(const[L,U]of n)C.push(d(L,U,a,k,I,A,v));return(await Promise.all(C)).filter(L=>!!L)}async function d(n,a,k,I,A=process.env,v,C){if(a===null)return;let L,U,B;if("source"in a&&!("path"in a)){const se=b?.get(a.source);if(!se)return;L=se.paths,U=a.args||se.args,a.icon?B=g(a.icon):se.icon&&(B=se.icon)}else L=Array.isArray(a.path)?a.path:[a.path],U=M.$i||Array.isArray(a.args)?a.args:void 0,B=g(a.icon);let re;if(C){const se=L.map(G=>typeof G=="string"?G:G.path),oe=await C(se);re=new Array(L.length);for(let G=0;G<L.length;G++)typeof L[G]=="string"?re[G]=oe[G]:re[G]={path:oe[G],isUnsafe:!0}}else re=L.slice();let ee;if(a.requiresPath){let se;if((0,D.$jf)(a.requiresPath)?se=a.requiresPath:(se=a.requiresPath.path,a.requiresPath.isUnsafe&&(ee=se)),!await I.existsFile(se))return}const ae=await i(n,k,re,I,A,U,a.env,a.overrideName,a.isAutoDetected,ee);if(!ae){v?.debug("Terminal profile not validated",n,L);return}return ae.isAutoDetected=a.isAutoDetected,ae.icon=B,ae.color=a.color,ae}function g(n){return typeof n=="string"?{id:n}:n}async function o(n){if(b&&!n)return;const[a,k]=await Promise.all([$(),n||E()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:k,icon:O.$Pj.terminalPowershell})}async function $(){const n=new Set,a=await(0,l.$ir)("git.exe");if(a){const A=(0,m.dirname)(a);n.add((0,m.resolve)(A,"../.."))}function k(A,v){v&&A.add(v)}k(n,process.env.ProgramW6432),k(n,process.env.ProgramFiles),k(n,process.env["ProgramFiles(X86)"]),k(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const A of n)I.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function E(){const n=[];for await(const a of(0,h.$ql)())n.push(a.exePath);return n}async function u(n,a){const k=[],I=await new Promise((C,L)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,B)=>{if(U)return L("Problem occurred when getting wsl distros");C(B)})});if(!I)return[];const A=new RegExp(/[\r?\n]/),v=I.split(A).filter(C=>C.trim().length>0&&C!=="");for(const C of v){if(C===""||C.startsWith("docker-desktop"))continue;const L=`${C} (WSL)`,U={profileName:L,path:n,args:["-d",`${C}`],isDefault:L===a,icon:t(C),isAutoDetected:!1};k.push(U)}return k}function t(n){return n.includes("Ubuntu")?O.$Pj.terminalUbuntu:n.includes("Debian")?O.$Pj.terminalDebian:O.$Pj.terminalLinux}async function c(n,a,k,I,A,v,C,L){const U=new Map;if(k){const B=(await n.readFile("/etc/shells")).toString(),re=(v||B.split(`
`)).map(ae=>{const se=ae.indexOf("#");return se===-1?ae:ae.substring(0,se)}).filter(ae=>ae.trim().length>0),ee=new Map;for(const ae of re){let se=(0,s.$ae)(ae),oe=ee.get(se)||0;oe++,oe>1&&(se=`${se} (${oe})`),ee.set(se,oe),U.set(se,{path:ae,isAutoDetected:!0})}}return r(I,U),await w(U.entries(),A,n,L,a,C)}function r(n,a){if(n)for(const[k,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?a.delete(k):(I.icon=I.icon||a.get(k)?.icon,a.set(k,I))}async function i(n,a,k,I,A,v,C,L,U,B){if(k.length===0)return Promise.resolve(void 0);const re=k.shift();if(re==="")return i(n,a,k,I,A,v,C,L,U);const ee=typeof re!="string"&&re.isUnsafe,ae=typeof re=="string"?re:re.path,se={profileName:n,path:ae,args:v,env:C,overrideName:L,isAutoDetected:U,isDefault:n===a,isUnsafePath:ee,requiresUnsafePath:B};if((0,s.$ae)(ae)===ae){const G=A.PATH?A.PATH.split(s.$ge):void 0,K=await(0,l.$ir)(ae,void 0,G,void 0,I.existsFile);return K?(se.path=K,se.isFromPath=!0,se):i(n,a,k,I,A,v)}return await I.existsFile((0,s.$7d)(ae))?se:i(n,a,k,I,A,v,C,L,U)}}),define(te[262],ie([0,1,3,2,4,42,18,5,224,94,257,125,259,261,108,69]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;var d;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let g=class extends O.$kc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor($,E,u,t){super(),this.M=$,this.N=E,this.O=u,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$fd),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$fd),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$fd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$fd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$fd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$fd),this.onProcessData=this.D.event,this.F=this.B(new P.$fd),this.onProcessReady=this.F.event,this.G=this.B(new P.$fd),this.onProcessReplay=this.G.event,this.H=this.B(new P.$fd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$fd),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$fd),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$fd),this.onProcessExit=this.L.event,(0,p.$$q)(),this.B(this.M),this.B((0,O.$ic)(()=>this.W())),this.j=this.B(new m.$4q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$Ml)(this.N,this.O,{_:[]},process.env)}catch($){return this.O.error("ptyHost was unable to resolve shell environment",$),{}}}U(){const $=this.M.start(),E=$.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B($.onDidProcessExit(c=>{this.u.fire(c.code),!this.m&&!this.q.isDisposed&&(this.n<=d.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const t=M.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(c=>this.D.fire(c))),this.B(t.onProcessReady(c=>this.F.fire(c))),this.B(t.onProcessExit(c=>this.L.fire(c))),this.B(t.onDidChangeProperty(c=>this.J.fire(c))),this.B(t.onProcessReplay(c=>this.G.fire(c))),this.B(t.onProcessOrphanQuestion(c=>this.H.fire(c))),this.B(t.onDidRequestDetach(c=>this.I.fire(c))),this.B(new h.$3q(this.P,E.getChannel(b.TerminalIpcChannels.Logger))),this.a=$,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[$,t]}async createProcess($,E,u,t,c,r,i,n,a,k,I){const A=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),v=await this.f.createProcess($,E,u,t,c,r,i,n,a,k,I);return clearTimeout(A),v}updateTitle($,E,u){return this.f.updateTitle($,E,u)}updateIcon($,E,u,t){return this.f.updateIcon($,E,u,t)}attachToProcess($){return this.f.attachToProcess($)}detachFromProcess($,E){return this.f.detachFromProcess($,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start($){return this.f.start($)}shutdown($,E){return this.f.shutdown($,E)}input($,E){return this.f.input($,E)}processBinary($,E){return this.f.processBinary($,E)}resize($,E,u){return this.f.resize($,E,u)}clearBuffer($){return this.f.clearBuffer($)}acknowledgeDataEvent($,E){return this.f.acknowledgeDataEvent($,E)}setUnicodeVersion($,E){return this.f.setUnicodeVersion($,E)}getInitialCwd($){return this.f.getInitialCwd($)}getCwd($){return this.f.getCwd($)}async getLatency(){const $=new w.$bd,E=await this.f.getLatency();return $.stop(),[{label:"ptyhostservice<->ptyhost",latency:$.elapsed()},...E]}orphanQuestionReply($){return this.f.orphanQuestionReply($)}installAutoReply($,E){return this.f.installAutoReply($,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply($){return this.f.uninstallAutoReply($)}getDefaultSystemShell($){return this.g?.getDefaultSystemShell($)??(0,y.$wl)($??s.OS,process.env)}async getProfiles($,E,u,t=!1){const c=await this.S();return(0,f.$kr)(E,u,t,this.N,c,void 0,this.O,this.bb.bind(this,$))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath($,E){return this.f.getWslPath($,E)}getRevivedPtyNewId($,E){return this.f.getRevivedPtyNewId($,E)}setTerminalLayoutInfo($){return this.f.setTerminalLayoutInfo($)}async getTerminalLayoutInfo($){return this.g?.getTerminalLayoutInfo($)}async requestDetachInstance($,E){return this.f.requestDetachInstance($,E)}async acceptDetachInstanceReply($,E){return this.f.acceptDetachInstanceReply($,E)}async freePortKillProcess($){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess($)}async serializeTerminalState($){return this.f.serializeTerminalState($)}async reviveTerminalProcesses($,E,u){return this.f.reviveTerminalProcesses($,E,u)}async refreshProperty($,E){return this.f.refreshProperty($,E)}async updateProperty($,E,u){return this.f.updateProperty($,E,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X($){this.ab(),this.s=setTimeout(()=>this.Y(),$?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb($,E){return this.j.createRequest({workspaceId:$,originalText:E})}async acceptPtyHostResolvedVariables($,E){this.j.acceptReply($,E)}};e.$lr=g,e.$lr=g=ke([_(1,D.$8h),_(2,S.$5i),_(3,S.$6i)],g)}),define(te[79],ie([0,1,15,3,2,4,18,6,34]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=e.$55b=void 0;const l="#FFFFFF",m="#1E1E1E",b="#000000",p="#FFFFFF",f="theme",y="themeBackground",w="windowSplash";e.$55b=(0,S.$Bh)("themeMainService");let d=class extends s.$kc{constructor(o,$){super(),this.b=o,this.c=$,this.a=this.B(new O.$fd),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const o=this.getColorScheme();if(o.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return o.dark?b:p;let $=this.b.getItem(y,null);if(!$)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":$=l;break;case"hc-black":$=b;break;case"hc-light":$=p;break;default:$=m}return M.$j&&$.toUpperCase()===m&&($="#171717"),$}saveWindowSplash(o,$){this.b.setItems([{key:f,data:$.baseTheme},{key:y,data:$.colorInfo.background},{key:w,data:$}]),typeof o=="number"&&this.f(o,$)}f(o,$){for(const E of P.BrowserWindow.getAllWindows())if(E.id===o){E.setBackgroundColor($.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$65b=d,e.$65b=d=ke([_(0,h.$eN),_(1,D.$8h)],d)}),define(te[126],ie([0,1,3,18,6,5]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.ProvidedOnAutoForward=e.$Yz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xz=e.$Wz=void 0,e.$Wz=(0,s.$Bh)("tunnelService"),e.$Xz=(0,s.$Bh)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(S||(e.TunnelPrivacyId=S={}));function h(d){return!!d.forwardPort}e.$Yz=h;var l;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function m(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(g)return{address:g[1],port:+g[2]}}e.$Zz=m,e.$1z=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(d){return e.$1z.indexOf(d)>=0}e.$2z=b,e.$3z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(d){return e.$3z.indexOf(d)>=0}e.$4z=p;function f(d,g,o,$){if(o===1)return!1;if(o===2&&p(g)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(E?.length===4&&parseInt(E[1])>=18)return!1}return d<1024}e.$5z=f;class y{constructor(g,o,$){this.remoteAddress=g,this.localAddress=o,this.b=$,this.a=new P.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6z=y;let w=class{constructor(g,o){this.j=g,this.k=o,this.a=new P.$fd,this.onTunnelOpened=this.a.event,this.b=new P.$fd,this.onTunnelClosed=this.b.event,this.c=new P.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],o=Array.from(this.e.values());for(const $ of o){const E=Array.from($.values());for(const u of E){const t=await u.value;t&&typeof t!="string"&&g.push(t)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:o}of g.values())await o.then($=>typeof $!="string"?$?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,o,$,E,u){this.p(g,o,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:o,localAddress:$,privacy:E,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,o){(p(g)||b(g))&&(g=e.$1z[0]);const $=this.r(g,o);if($)return++$.refcount,$.value}openTunnel(g,o,$,E,u,t=!1,c,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${$} on local port ${u}.`);const i=this.f??g;if(!i)return;if(o||(o="localhost"),E||(E=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,o,$,E,u,t,c,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(o,$),a}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(o,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(a);return(a.tunnelRemoteHost!==o||a.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&a.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const o=this.e.get(g.tunnelRemoteHost);if(o){const $=o.get(g.tunnelRemotePort);$&&($.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,$))}}}}async o(g,o,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${o}.`);const E=$.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(o),E}}async closeTunnel(g,o){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${o} `);const $=this.e.get(g);if($&&$.has(o)){const E=$.get(o);E.refcount=0,await this.o(g,o,E)}}p(g,o,$){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(o,{refcount:1,value:$})}async q(g,o){const $=this.e.get(g);if($){const E=$.get(o),u=E?await E.value:void 0;(!u||typeof u=="string")&&$.delete(o),$.size===0&&this.e.delete(g)}}r(g,o){const $=[g];b(g)?($.push(...e.$1z),$.push(...e.$3z)):p(g)&&$.push(...e.$3z);const E=$.map(u=>this.e.get(u));for(const u of E){const t=u?.get(o);if(t)return t}}canTunnel(g){return!!m(g)}t(g,o,$,E,u,t,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${$} on local port ${E}.`);const r=$;this.i.add(r);const i=E===void 0?$:E,n={elevationRequired:u?this.isPortPrivileged(i):!1},a={remoteAddress:{host:o,port:$},localAddressPort:E,privacy:t,public:t?t!==S.Private:void 0,protocol:c},k=g.forwardPort(a,n);return k?(this.p(o,$,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),k}};e.$7z=w,e.$7z=w=ke([_(0,M.$5i),_(1,O.$8h)],w)}),define(te[48],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ST=e.$RT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var O;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(O||(e.StateType=O={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$RT={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$ST=(0,P.$Bh)("updateService")}),define(te[263],ie([0,1,4,187,59,43]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$8m.as(s.$an.Configuration).registerConfiguration({id:"update",order:15,title:(0,O.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,O.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,O.localize)(2,null),(0,O.localize)(3,null),(0,O.localize)(4,null),(0,O.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,O.localize)(6,null),deprecationMessage:(0,O.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,O.localize)(8,null),description:(0,O.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,O.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=void 0;class s{constructor(S){this.a=S}listen(S,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(S,h,l){switch(h){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.$x6b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$fd,this.onStateChange=this.a.event,this.b=O.$RT.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$y6b=M}),define(te[40],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,P.$Bh)("IUriIdentityService")}),define(te[265],ie([0,1,40,206,16,19,140,3,2]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class l{static{this._clock=0}constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let m=class{constructor(p){this.g=p,this.c=new h.$jc,this.f=2**16;const f=new Map,y=w=>{let d=f.get(w.scheme);return d===void 0&&(d=p.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,d)),d};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new M.$0f(y),this.d=new D.$or((w,d)=>this.extUri.compare(w,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$jg)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const f=this.f*.5;for(let y=0;y<f;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$pr=m,e.$pr=m=ke([_(0,s.$6j)],m),(0,O.$mr)(P.$Ck,m,1)}),define(te[127],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GT=void 0,e.$GT=(0,P.$Bh)("urlService")}),define(te[266],ie([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=e.$G6b=e.$F6b=void 0;class O{constructor(S){this.a=S}listen(S,h){throw new Error(`Event not found: ${h}`)}call(S,h,l){switch(h){case"handleURL":return this.a.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.$F6b=O;class s{constructor(S){this.a=S}handleURL(S,h){return this.a.call("handleURL",[S.toJSON(),h])}}e.$G6b=s;class M{constructor(S,h){this.a=S,this.b=h}async routeCall(S,h,l,m){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const b=P.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const p=/\bwindowId=(\d+)/.exec(b.query);if(p){const f=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,b.toString(!0));const y=new RegExp(`window:${f}`),w=S.connections.find(d=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",d.ctx),y.test(d.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,h,l,m)}routeEvent(S,h){throw new Error(`Event not found: ${h}`)}}e.$H6b=M}),define(te[267],ie([0,1,8,2,7,24]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IT=e.$HT=void 0;class D extends O.$kc{constructor(){super(...arguments),this.a=new Set}open(l,m){const b=[...this.a.values()];return(0,P.$Kg)(b.map(p=>()=>p.handleURL(l,m)),void 0,!1).then(p=>p||!1)}registerHandler(l){return this.a.add(l),(0,O.$ic)(()=>this.a.delete(l))}}e.$HT=D;let S=class extends D{constructor(l){super(),this.b=l}create(l){let{authority:m,path:b,query:p,fragment:f}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:m,path:b,query:p,fragment:f})}};e.$IT=S,e.$IT=S=ke([_(0,M.$kj)],S)}),define(te[268],ie([0,1,15,8,3,2,4,7]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0;class h{constructor(m,b,p,f,y,w){if(this.f=b,this.g=w,this.a=[],this.b=0,this.c=M.$kc.None,this.d=new M.$jc,m&&(w.trace("ElectronURLListener initialUrisToHandle:",m.map(o=>o.originalUrl)),this.a=m),D.$i){const o=f.isBuilt?[]:[`"${f.appRoot}"`];o.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,o)}const d=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(o,$)=>({event:o,url:$})),({event:o,url:$})=>(o.preventDefault(),$));this.d.add(d(o=>{const $=this.h(o);$&&this.f.open($,{originalUrl:o})})),p.getWindows().filter(o=>o.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h(m){try{return S.URI.parse(m)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const b of this.a)await this.f.open(b.uri,{originalUrl:b.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),m.push(b));m.length!==0&&(this.a=m,this.c=(0,O.$Ig)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$I6b=h}),define(te[269],ie([0,1,3,2,16,56,58,17,12,33]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class m extends O.$kc{get capabilities(){return this.g.capabilities&-5}constructor(p,f,y,w,d,g){super(),this.f=p,this.g=f,this.h=y,this.j=w,this.m=g,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$fd),this.onDidChangeFile=this.a.event,this.b=D.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new l.$Ai(o=>d.extUri.getComparisonKey(this.s(o))),this.n(),this.B(w.onDidChangeProfiles(()=>this.n())),this.B(this.g.onDidChangeFile(o=>this.r(o)))}n(){this.c.clear();for(const p of this.j.profiles)this.c.add(p.settingsResource),this.c.add(p.keybindingsResource),this.c.add(p.tasksResource),this.c.add(p.extensionsResource)}watch(p,f){this.b.set(p,p);const y=this.g.watch(this.s(p),f);return(0,O.$ic)(()=>{this.b.delete(p),y.dispose()})}stat(p){return this.g.stat(this.s(p))}mkdir(p){return this.g.mkdir(this.s(p))}rename(p,f,y){return this.g.rename(this.s(p),this.s(f),y)}readFile(p){return this.g.readFile(this.s(p),{atomic:!0})}readFileStream(p,f,y){const w=(0,M.$td)(d=>S.$Fd.concat(d.map(g=>S.$Fd.wrap(g))).buffer);return(async()=>{try{const d=await this.readFile(p);w.end(d)}catch(d){w.error(d),w.end()}})(),w}readdir(p){return this.g.readdir(this.s(p))}writeFile(p,f,y){return this.c.has(p)&&!(0,h.$lf)(y.atomic)&&(0,s.$bk)(this.g)&&(y={...y,atomic:{postfix:".vsctmp"}}),this.g.writeFile(this.s(p),f,y)}delete(p,f){return this.g.delete(this.s(p),f)}copy(p,f,y){if((0,s.$9j)(this.g))return this.g.copy(this.s(p),this.s(f),y);throw new Error("copy not supported")}r(p){const f=[];for(const y of p){if(y.resource.scheme!==this.f)continue;const w=this.t(y.resource);this.b.findSubstr(w)&&f.push({resource:w,type:y.type})}f.length&&(this.m.debug("User data changed"),this.a.fire(f))}s(p){return p.with({scheme:this.f})}t(p){return p.with({scheme:this.h})}}e.$h7b=m}),define(te[270],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=void 0,e.$26b="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0,e.$J6b=(0,P.$Bh)("webviewManagerService")}),define(te[272],ie([0,1,15,2,13,7]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;class D extends O.$kc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}b(h,l){try{const m=M.URI.parse(h.url),b=D.a.get(m.path);if(typeof b=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${b}`,f=s.$2f.asFileUri(p);return l({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$K6b=D}),define(te[80],ie([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=void 0,e.$PD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(m){return!!m.workspaceUri}e.$QD=O;function s(m){return!!m.folderUri}e.$RD=s;function M(m){return!!m.fileUri}e.$SD=M;function D(m){const b=S(m),p=m.getValue("window.menuBarVisibility");return p==="default"||b==="native"&&p==="compact"||P.$j&&P.$m?"classic":p}e.$TD=D;function S(m){if(P.$o)return"custom";const b=m.getValue("window");if(b){if(P.$j&&b.nativeTabs===!0||P.$j&&b.nativeFullScreen===!1)return"native";const y=b.titleBarStyle;if(y==="native"||y==="custom")return y}return P.$k?"native":"custom"}e.$UD=S;function h(m){return!(!P.$i||P.$o||S(m)==="native")}e.$VD=h;function l(m=0){return Math.pow(1.2,m)}e.$WD=l}),define(te[128],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$h5b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var O;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(O||(e.UnloadReason=O={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$h5b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[30],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$w5b=void 0,e.$w5b=(0,P.$Bh)("windowsMainService");var O;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(O||(e.OpenContext=O={}))}),define(te[273],ie([0,1,15,23,4,7,21,18,63,6,5,127,30]),function(J,e,P,O,s,M,D,S,h,l,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=e.$d6b=e.ID=void 0,e.ID="launchMainService",e.$d6b=(0,l.$Bh)(e.ID);let f=class{constructor(w,d,g,o){this.a=w,this.b=d,this.c=g,this.d=o}async start(w,d){this.a.trace("Received data from other instance: ",w,d),s.$j&&P.app.focus({steal:!0});const g=this.e(w);if(g.length){let o=Promise.resolve();if(this.b.getWindowCount()===0){const $=(0,O.$Mb)(await this.b.openEmptyWindow({context:4}));$&&(o=$.ready())}o.then(()=>{for(const{uri:$,originalUrl:E}of g)this.c.open($,{originalUrl:E})})}else return this.f(w,d)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,O.$Fb)(w._urls.map(d=>{try{return{uri:M.URI.parse(d),originalUrl:d}}catch{return null}})):[]}async f(w,d){const g=(0,h.$Gl)(d)?0:4;let o=[];const $=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,u={context:g,cli:w,userEnv:d,waitMarkerFileURI:$,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,u);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)o=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,u),o=[c]):o=await this.b.open({...u,forceEmpty:!0})}}else o=await this.b.open({...u,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if($&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,D.whenDeleted)($.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$e6b=f,e.$e6b=f=ke([_(0,m.$5i),_(1,p.$w5b),_(2,b.$GT),_(3,S.$8h)],f)}),define(te[274],ie([0,1,15,3,2,272,30]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=void 0;let S=class extends s.$kc{constructor(l){super(),this.b=l,this.a=this.B(new O.$fd),this.onFoundInFrame=this.a.event,this.B(new M.$K6b)}async setIgnoreMenuShortcuts(l,m){let b;if(typeof l.windowId=="number"){const{windowId:p}=l,f=this.b.getWindowById(p);if(!f?.win)throw new Error(`Invalid windowId: ${p}`);b=f.win.webContents}else{const{webContentsId:p}=l;if(b=P.webContents.fromId(p),!b)throw new Error(`Invalid webContentsId: ${p}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(m)}async findInFrame(l,m,b,p){const y=this.c(l,m);if(typeof y.findInFrame=="function"){y.findInFrame(b,{findNext:p.findNext,forward:p.forward});const w=(d,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(l,m,b){const f=this.c(l,m);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(l,m){const b=this.b.getWindowById(l.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${l}`);const p=b.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===m);if(!p)throw new Error(`Unknown frame: ${m}`);return p}};e.$L6b=S,e.$L6b=S=ke([_(0,D.$w5b)],S)}),define(te[275],ie([0,1,8,3,2]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=void 0;class M extends s.$kc{constructor({onDidOpenWindow:S,onDidFocusWindow:h,getActiveWindowId:l}){super(),this.a=this.B(new s.$jc),O.Event.latch(O.Event.any(S,h))(this.f,this,this.a),this.b=(0,P.$ug)(()=>l()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$R6b=M}),define(te[29],ie([0,1,191,9,58,19,7,6,13]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,S.$Bh)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Lh=l;function m(i){return typeof i?.id=="string"&&!l(i)&&!p(i)}e.$Mh=m,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function b(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$ae)(i)}:n?e.$Nh:e.$Oh;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Ph=b;function p(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$Qh=p;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$Rh=f;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Sh=w;function d(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Th=d;class g{constructor(n,a,k,I,A){this.h=n,this.j=k,this.k=I,this.l=A,this.c=s.$Hh.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Hh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=g;class o{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=o;function $(i){return new o({uri:i,index:0,name:(0,M.$eg)(i)},{uri:i.toString()})}e.$Wh=$,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,P.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function E(i,n){return M.$_f.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$2h=E;function u(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$3h=u,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$4h}e.$5h=t;function c(i,n){return!E(i,n)&&!u(i)}e.$6h=c;function r(i){return(typeof i=="string"?(0,O.$be)(i):(0,M.$gg)(i))===e.$Yh}e.$7h=r}),define(te[61],ie([0,1,15,8,57,46,2,85,4,21,166,91,6,5,24,29]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J5b=e.$I5b=void 0,e.$I5b=(0,p.$Bh)("dialogMainService");let d=class{constructor(o,$){this.d=o,this.e=$,this.a=new Map,this.b=new Map,this.c=new O.$Ng}pickFileFolder(o,$){return this.f({...o,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},$)}pickFolder(o,$){return this.f({...o,pickFolders:!0,title:(0,m.localize)(1,null)},$)}pickFile(o,$){return this.f({...o,pickFiles:!0,title:(0,m.localize)(2,null)},$)}pickWorkspace(o,$){const E=(0,m.localize)(3,null),u=(0,M.$lA)((0,m.localize)(4,null)),t=w.$Zh;return this.f({...o,pickFiles:!0,title:E,filters:t,buttonLabel:u},$)}async f(o,$){const E={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters,defaultPath:o.defaultPath};(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(E.properties=void 0,o.pickFiles&&o.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&E.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(E,($||P.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(o){if(o){let $=this.b.get(o.id);return $||($=new O.$Ng,this.b.set(o.id,$)),$}else return this.c}showMessageBox(o,$){return this.g($).queue(async()=>{const{options:E,buttonIndeces:u}=(0,b.$sA)(o,this.e);let t;return $?t=await P.dialog.showMessageBox($,E):t=await P.dialog.showMessageBox(E),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(o,$){const E=this.j(o,$);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g($).queue(async()=>{let u;return $?u=await P.dialog.showSaveDialog($,o):u=await P.dialog.showSaveDialog(o),u.filePath=this.h(u.filePath),u})}finally{(0,D.$fc)(E)}}h(o){return o&&h.$j&&(o=(0,S.$hl)(o)),o}i(o){return o.map($=>this.h($))}async showOpenDialog(o,$){o.defaultPath&&(await l.Promises.exists(o.defaultPath)||(o.defaultPath=void 0));const E=this.j(o,$);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g($).queue(async()=>{let u;return $?u=await P.dialog.showOpenDialog($,o):u=await P.dialog.showOpenDialog(o),u.filePaths=this.i(u.filePaths),u})}finally{(0,D.$fc)(E)}}j(o,$){if(!$)return D.$kc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",o);let E=this.a.get($.id);E||(E=new Set,this.a.set($.id,E));const u=(0,s.$pi)(o);if(!E.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",o),E.add(u),(0,D.$ic)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",o),E?.delete(u),E?.size===0&&this.a.delete($.id)})}};e.$J5b=d,e.$J5b=d=ke([_(0,f.$5i),_(1,y.$kj)],d)}),define(te[276],ie([0,1,3,2,74,29]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=void 0;class D extends O.$kc{static{this.a=100}constructor(h,l){super(),this.f=h,this.g=l,this.b=this.B(new P.$fd),this.c=new Map,this.h(l.applicationStorage,this.b)}h(h,l){this.B(P.Event.debounce(h.onDidChangeStorage,(m,b)=>(m?m.push(b):m=[b],m),D.a)(m=>{m.length&&l.fire(this.j(m,h))}))}j(h,l){const m=new Map,b=new Set;return h.forEach(p=>{const f=l.get(p.key);typeof f=="string"?m.set(p.key,f):b.add(p.key)}),{changed:Array.from(m.entries()),deleted:Array.from(b.values())}}listen(h,l,m){switch(l){case"onDidChangeStorage":{const b=m.profile?(0,s.$$g)(m.profile):void 0;if(!b)return this.b.event;let p=this.c.get(b.id);return p||(p=this.B(new P.$fd),this.h(this.g.profileStorage(b),p),this.c.set(b.id,p)),p.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,m){const b=m.profile?(0,s.$$g)(m.profile):void 0,p=(0,M.$Rh)(m.workspace),f=await this.m(b,p);switch(l){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=m;if(y.insert)for(const[w,d]of y.insert)f.set(w,d);y.delete?.forEach(w=>f.delete(w));break}case"optimize":return f.optimize();case"isUsed":{const y=m.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async m(h,l){let m;l?m=this.g.workspaceStorage(l):h?m=this.g.profileStorage(h):m=this.g.applicationStorage;try{await m.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${b}`)}return m}}e.$u6b=D}),define(te[41],ie([0,1,57,3,2,19,7,188,36,16,6,5,29,33,40,8,31,26,12]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var $;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Dk=E,e.$Ek=(0,m.$Bh)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Fk=u;function t(i,n,a,k,I,A){return{id:i,name:n,location:a,isDefault:!1,shortName:I?.shortName,globalStorageHome:A&&I?.useDefaultFlags?.globalState?A.globalStorageHome:(0,M.$ig)(a,"globalStorage"),settingsResource:A&&I?.useDefaultFlags?.settings?A.settingsResource:(0,M.$ig)(a,"settings.json"),keybindingsResource:A&&I?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,M.$ig)(a,"keybindings.json"),tasksResource:A&&I?.useDefaultFlags?.tasks?A.tasksResource:(0,M.$ig)(a,"tasks.json"),snippetsHome:A&&I?.useDefaultFlags?.snippets?A.snippetsHome:(0,M.$ig)(a,"snippets"),extensionsResource:A&&I?.useDefaultFlags?.extensions?A.extensionsResource:(0,M.$ig)(a,"extensions.json"),cacheHome:(0,M.$ig)(k,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Gk=t;let c=class extends s.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,k,I){super(),this.t=n,this.u=a,this.w=k,this.y=I,this.f=!0,this.h=this.B(new O.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zi,emptyWindows:new Map},this.profilesHome=(0,M.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,o.$jf)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}a.push(t((0,M.$fg)(A.location),A.name,A.location,this.g,{shortName:A.shortName,useDefaultFlags:A.useDefaultFlags},n))}}catch(A){this.y.error(A)}const k=new f.$zi,I=new Map;if(a.length)try{const A=this.Q();if(A.workspaces)for(const[v,C]of Object.entries(A.workspaces)){const L=D.URI.parse(v),U=a.find(B=>B.id===C);U&&k.set(L,U)}if(A.emptyWindows)for(const[v,C]of Object.entries(A.emptyWindows)){const L=a.find(U=>U.id===C);L&&I.set(v,L)}}catch(A){this.y.error(A)}this.z={profiles:a,workspaces:k,emptyWindows:I}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",k=new RegExp(`${(0,g.$qe)(a)}\\s(\\d+)`);let I=0;for(const v of this.profiles){const C=k.exec(v.name),L=C?parseInt(C[1]):0;I=L>I?L:I}const A=`${a} ${I+1}`;return this.createProfile((0,P.$pi)((0,d.$4f)()).toString(16),A,{transient:!0},n)}async createNamedProfile(n,a,k){return this.createProfile((0,P.$pi)((0,d.$4f)()).toString(16),n,a,k)}async createProfile(n,a,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(n,a,k);return I&&await this.setProfileForWorkspace(I,A),A}async F(n,a,k){if(!(0,o.$jf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(a);return I||(I=(async()=>{try{const A=this.profiles.find(L=>L.name===a||L.id===n);if(A)return A;const v=t(n,a,(0,M.$ig)(this.profilesHome,n),this.g,k,this.defaultProfile);await this.u.createFolder(v.location);const C=[];return this.j.fire({profile:v,join(L){C.push(L)}}),await w.Promises.settled(C),this.I([v],[],[]),v}finally{this.r.delete(a)}})(),this.r.set(a,I)),I}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===n.id);if(!k)throw new Error(`Profile '${n.name}' does not exist`);return k=t(k.id,a.name??k.name,k.location,this.g,{shortName:a.shortName??k.shortName,transient:a.transient??k.isTransient,useDefaultFlags:a.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(I=>I.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const k=[];this.m.fire({profile:a,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(I){(0,l.$jk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,k)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,p.$Lh)(n)?n.uri:(0,p.$Qh)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,k){const I=[...this.profiles,...n],A=[];this.s.profiles=[];for(let v of I)v.isDefault||a.some(C=>v.id===C.id)||(v=k.find(C=>v.id===C.id)??v,v.isTransient?this.s.profiles.push(v):A.push({location:v.location,name:v.name,shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}));this.P(A),this.z=void 0,this.J(n,a,k)}J(n,a,k){this.h.fire({added:n,removed:a,updated:k,all:this.profiles})}L(n,a,k){k=a?.isTransient?!0:k,k||this.L(n,void 0,!0);const I=this.G(n),A=k?this.s:this.C;D.URI.isUri(I)?(A.workspaces.delete(I),a&&A.workspaces.set(I,a)):(A.emptyWindows.delete(I),a&&A.emptyWindows.set(I,a)),k||this.M()}M(){const n={};for(const[k,I]of this.C.workspaces.entries())n[k.toString()]=I.id;const a={};for(const[k,I]of this.C.emptyWindows.entries())a[k.toString()]=I.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},k=this.D();if(n.workspaces)for(const[A,v]of Object.entries(n.workspaces)){const C=D.URI.parse(v);a[A]=this.w.extUri.isEqual(C,k.location)?k.id:this.w.extUri.basename(C)}const I={};if(n.emptyWindows)for(const[A,v]of Object.entries(n.emptyWindows)){const C=D.URI.parse(v);I[A]=this.w.extUri.isEqual(C,k.location)?k.id:this.w.extUri.basename(C)}return{workspaces:a,emptyWindows:I}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Hk=c,e.$Hk=c=ke([_(0,h.$Ih),_(1,l.$6j),_(2,y.$Ck),_(3,b.$5i)],c);class r extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ik=r}),define(te[81],ie([0,1,8,17,2,3,33,7,116,123,16,6,5,41,40,12,14,25]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var o;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(o||(e.ExtensionsProfileScanningErrorCode=o={}));class $ extends Error{constructor(r,i){super(r),this.code=i}}e.$jp=$,e.$kp=(0,b.$Bh)("IExtensionsProfileScannerService");let E=class extends s.$kc{constructor(r,i,n,a,k,I){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=k,this.t=I,this.b=this.B(new M.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$zi}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,k=>{const I=[];for(const A of k)r.some(([v])=>(0,l.$po)(v.identifier,A.identifier)&&v.manifest.version!==A.version)?n.push(A):I.push(A);for(const[A,v]of r){const C=I.findIndex(U=>(0,l.$po)(U.identifier,A.identifier)&&U.version===A.manifest.version),L={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:v};C===-1?(a.push(L),I.push(L)):I.splice(C,1,L)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),I}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(k){throw a.length&&this.c.fire({extensions:a,error:k,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:k,profileLocation:i}),k}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const k=[];for(const I of a){const A=r.find(([v])=>(0,l.$po)(v.identifier,I.identifier)&&v.manifest.version===I.version);A&&(I.metadata={...I.metadata,...A[1]},n.push(I)),k.push(I)}return k}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const k=[];for(const I of a)(0,l.$po)(I.identifier,r.identifier)?n.push(I):k.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],k;try{const I=await this.m.readFile(r);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,m.$jk)(I)!==1)throw I;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&n?.bailOutWhenFileNotFound)throw new $((0,d.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(k){Array.isArray(k)||this.w(r);let I=!1;for(const A of k){u(A)||this.w(r);let v;if((0,w.$jf)(A.relativeLocation)&&A.relativeLocation)v=this.z(A.relativeLocation);else if((0,w.$jf)(A.location))v=this.z(A.location),I=!0,A.relativeLocation=A.location,A.location=v.toJSON();else{v=S.URI.revive(A.location);const C=this.y(v);C&&(I=!0,A.relativeLocation=C)}a.push({identifier:A.identifier,location:v,version:A.version,metadata:A.metadata})}I&&await this.m.writeFile(r,O.$Fd.fromString(JSON.stringify(k)))}if(i){a=i(a);const I=a.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,O.$Fd.fromString(JSON.stringify(I)))}return a})}w(r){const i=new $(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(k){if((0,m.$jk)(k)===1)return;throw k}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const k=JSON.parse(n);Array.isArray(k)&&k.every(I=>u(I))?a=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$Fd.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,m.$jk)(k)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(r)}catch(k){(0,m.$jk)(k)!==1&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,m.$jk)(k)!==1&&this.t.error(k)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Ng,this.h.set(r,i)),i}};e.$lp=E,e.$lp=E=ke([_(1,m.$6j),_(2,f.$Ek),_(3,y.$Ck),_(4,g.$9k),_(5,p.$5i)],E);function u(c){return(0,w.$lf)(c)&&(0,h.$Yn)(c.identifier)&&(t(c.location)||(0,w.$jf)(c.location)&&c.location)&&((0,w.$qf)(c.relativeLocation)||(0,w.$jf)(c.relativeLocation))&&c.version&&(0,w.$jf)(c.version)}function t(c){return c?(0,w.$jf)(c.path)&&(0,w.$jf)(c.scheme):!1}}),define(te[129],ie([0,1,23,8,37,17,14,44,152,2,13,9,4,19,204,70,12,7,171,36,123,120,203,16,6,5,24,3,74,81,41,40,202]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n,a,k,I,A,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var L;(function(oe){function G(K,q){if(K===q)return!0;const F=Object.keys(K),N=new Set;for(const V of Object.keys(q))N.add(V);if(F.length!==N.size)return!1;for(const V of F){if(K[V]!==q[V])return!1;N.delete(V)}return N.size===0}oe.equals=G})(L||(e.Translations=L={})),e.$op=(0,r.$Bh)("IExtensionsScannerService");let U=class extends l.$kc{constructor(G,K,q,F,N,V,X,x,ce,Y,R,j){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=K,this.r=q,this.s=F,this.t=N,this.u=V,this.w=X,this.y=x,this.z=ce,this.C=Y,this.D=R,this.F=j,this.g=this.B(new a.$fd),this.onDidChangeCache=this.g.event,this.h=(0,f.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ee,this.s,this.h)),this.m=this.B(this.F.createInstance(ee,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(G,K,q){const[F,N]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(K)]),V=q?await this.scanExtensionsUnderDevelopment(G,[...F,...N]):[];return this.L(F,N,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const K=[];K.push(this.M(!!G.useCache,G.language)),K.push(this.N(G.language,!!G.checkControlFile));const[q,F]=await Promise.all(K);return this.J([...q,...F],0,G,!1)}async scanUserExtensions(G){const K=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const q=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(K,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,q),N=G.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let V;try{V=await N.scanExtensions(F)}catch(X){if(X instanceof I.$jp&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await N.scanExtensions(F);else throw X}return V=await this.J(V,1,G,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(G,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===m.Schemas.file).map(async F=>{const N=await this.P(F,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(X=>(X.type=K.find(x=>(0,E.$po)(x.identifier,X.identifier))?.type??X.type,this.n.validate(X,N)))}))).flat();return this.J(q,"development",G,!0)}return[]}async scanExistingExtension(G,K,q){const F=await this.P(G,!1,K,!0,q.language,!0,void 0),N=await this.n.scanExtension(F);return!N||!q.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(G,K,q){const F=await this.P(G,!1,K,!0,q.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(F);return this.J(N,K,q,!0)}async scanMetadata(G){const K=(0,f.$ig)(G,"package.json"),q=(await this.w.readFile(K)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(G,K){const q=(0,f.$ig)(G,"package.json"),F=(await this.w.readFile(q)).value.toString(),N=JSON.parse(F);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,N.__metadata={...N.__metadata,...K},await this.w.writeFile((0,f.$ig)(G,"package.json"),M.$Fd.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof I.$jp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$Fd.fromString(JSON.stringify([])))}catch(K){(0,c.$jk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$8)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,K,q,F){return q.includeAllVersions||(G=this.L(K===0?G:void 0,K===1?G:void 0,K==="development"?G:void 0,await this.getTargetPlatform(),F)),q.includeInvalid||(G=G.filter(N=>N.isValid)),G.sort((N,V)=>{const X=b.$ae(N.location.fsPath),x=b.$ae(V.location.fsPath);return X<x?-1:X>x?1:0})}L(G,K,q,F,N){const V=(x,ce,Y)=>{if(x.isValid&&!ce.isValid)return!1;if(x.isValid===ce.isValid){if(N&&y.gt(x.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(y.eq(x.manifest.version,ce.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===F)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`),!0},X=new u.$Xl;return G?.forEach(x=>{const ce=X.get(x.identifier.id);(!ce||V(ce,x,!1))&&X.set(x.identifier.id,x)}),K?.forEach(x=>{const ce=X.get(x.identifier.id);if(!ce&&G&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!ce||V(ce,x,!1))&&X.set(x.identifier.id,x)}),q?.forEach(x=>{const ce=X.get(x.identifier.id);(!ce||V(ce,x,!0))&&X.set(x.identifier.id,x),X.set(x.identifier.id,x)}),[...X.values()]}async M(G,K){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),N=await(G&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",N.length),N}async N(G,K){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const F=K?await this.O():{},N=[],V=g.URI.file(b.$7d(b.$9d(m.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of q){const ce=F[x.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":N.push((0,f.$ig)(V,x.name));break;default:N.push(g.URI.file(ce));break}}const X=await Promise.all(N.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",X.length),(0,P.$Fb)(X)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,K,q,F,N,V,X){const x=await this.f(N??p.$v),ce=await this.Q(G),Y=K&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=Y?await this.Q(Y):void 0;return new B(G,ce,Y,R,K,X,q,F,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,x)}async Q(G){try{const K=await this.w.stat(G);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$pp=U,e.$pp=U=ke([_(4,A.$Ek),_(5,I.$kp),_(6,c.$6j),_(7,i.$5i),_(8,$.$Ih),_(9,n.$kj),_(10,v.$Ck),_(11,r.$Ah)],U);class B{constructor(G,K,q,F,N,V,X,x,ce,Y,R,j,W,T,H){this.location=G,this.mtime=K,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=F,this.profile=N,this.profileScanOptions=V,this.type=X,this.excludeObsolete=x,this.validate=ce,this.productVersion=Y,this.productDate=R,this.productCommit=j,this.devMode=W,this.language=T,this.translations=H}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,K){return(0,f.$bg)(G.location,K.location)&&G.mtime===K.mtime&&(0,f.$bg)(G.applicationExtensionslocation,K.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&G.profile===K.profile&&s.$Zm(G.profileScanOptions,K.profileScanOptions)&&G.type===K.type&&G.excludeObsolete===K.excludeObsolete&&G.validate===K.validate&&G.productVersion===K.productVersion&&G.productDate===K.productDate&&G.productCommit===K.productCommit&&G.devMode===K.devMode&&G.language===K.language&&L.equals(G.translations,K.translations)}}e.$qp=B;let re=class extends l.$kc{constructor(G,K,q,F,N){super(),this.f=G,this.g=K,this.h=q,this.j=F,this.m=N}async scanExtensions(G){const K=G.profile?await this.r(G):await this.n(G);let q={};if(G.excludeObsolete&&G.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(F)}catch{}return(0,d.$wf)(q)?K:K.filter(F=>!q[E.$qo.create(F).toString()])}async n(G){const K=await this.j.resolve(G.location);if(!K.children?.length)return[];const q=await Promise.all(K.children.map(async F=>{if(!F.isDirectory||G.type===1&&(0,f.$fg)(F.resource).indexOf(".")===0)return null;const N=new B(F.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(N)}));return(0,P.$Fb)(q).sort((F,N)=>F.location.path<N.location.path?-1:1)}async r(G){let K=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){K=K.filter(F=>!F.metadata?.isApplicationScoped);const q=await this.s(G.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,G);K.push(...q)}return K}async s(G,K,q){const F=await this.g.scanProfileExtensions(G,q.profileScanOptions);if(!F.length)return[];const N=await Promise.all(F.map(async V=>{if(K(V)){const X=new B(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(X,V.metadata)}return null}));return(0,P.$Fb)(N)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,f.$ig)(G.location,"package.json"))){const K=await this.scanExtension(G);return K?[K]:[]}else return await this.scanExtensions(G)}catch(K){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,D.$8)(K)),[]}}async scanExtension(G,K){try{let q=await this.scanExtensionManifest(G.location);if(q){q.publisher||(q.publisher=u.$Rl),K=K??q.__metadata,delete q.__metadata;const F=(0,E.$uo)(q.publisher,q.name),N=K?.id?{id:F,uuid:K.id}:{id:F},V=K?.isSystem?0:G.type,X=V===0||!!K?.isBuiltin;q=await this.t(G.location,q,B.createNlsConfiguration(G));const x={type:V,identifier:N,manifest:q,location:G.location,isBuiltin:X,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return G.validate?this.validate(x,G):x}}catch(q){G.type!==0&&this.m.error(q)}return null}validate(G,K){let q=!0;const F=(0,t.$Fo)(K.productVersion,K.productDate,K.location,G.manifest,G.isBuiltin);for(const[N,V]of F)N===w.default.Error&&(q=!1,this.m.error(this.z(K.location,V)));return G.isValid=q,G.validations=F,G}async scanExtensionManifest(G){const K=(0,f.$ig)(G,"package.json");let q;try{q=(await this.j.readFile(K)).value.toString()}catch(N){return(0,c.$jk)(N)!==1&&this.m.error(this.z(G,(0,o.localize)(0,null,K.path,N.message))),null}let F;try{F=JSON.parse(q)}catch{const V=[];(0,S.$Lm)(q,V);for(const X of V)this.m.error(this.z(G,(0,o.localize)(1,null,K.path,X.offset,X.length,(0,h.$mp)(X.error))));return null}return(0,S.$Um)(F)!=="object"?(this.m.error(this.z(G,(0,o.localize)(2,null,K.path))),null):F}async t(G,K,q){const F=await this.u(G,K,q);if(F)try{const N=[],V=await this.w(F.default,N);if(N.length>0)return N.forEach(x=>{this.m.error(this.z(G,(0,o.localize)(3,null,F.default?.path,(0,h.$mp)(x.error))))}),K;if((0,S.$Um)(F)!=="object")return this.m.error(this.z(G,(0,o.localize)(4,null,F.default?.path))),K;const X=F.values||Object.create(null);return(0,C.$np)(this.m,K,X,V)}catch{}return K}async u(G,K,q){const F=(0,f.$ig)(G,"package.nls.json"),N=(ce,Y)=>{Y.forEach(R=>{this.m.error(this.z(G,(0,o.localize)(5,null,ce?.path,(0,h.$mp)(R.error))))})},V=ce=>{this.m.error(this.z(G,(0,o.localize)(6,null,ce?.path)))},X=`${K.publisher}.${K.name}`,x=q.translations[X];if(x)try{const ce=g.URI.file(x),Y=(await this.j.readFile(ce)).value.toString(),R=[],j=(0,S.$Lm)(Y,R);return R.length>0?(N(ce,R),{values:void 0,default:F}):(0,S.$Um)(j)!=="object"?(V(ce),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let Y;try{Y=await this.y(G,q)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const R=(await this.j.readFile(Y.localized)).value.toString(),j=[],W=(0,S.$Lm)(R,j);return j.length>0?(N(Y.localized,j),{values:void 0,default:Y.original}):(0,S.$Um)(W)!=="object"?(V(Y.localized),{values:void 0,default:Y.original}):{values:W,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(G,K){if(G)try{const q=(await this.j.readFile(G)).value.toString();return(0,S.$Lm)(q,K)}catch{}}y(G,K){return new Promise((q,F)=>{const N=V=>{const X=(0,f.$ig)(G,`package.nls.${V}.json`);this.j.exists(X).then(x=>{x&&q({localized:X,original:(0,f.$ig)(G,"package.nls.json")});const ce=V.lastIndexOf("-");ce===-1?q({localized:(0,f.$ig)(G,"package.nls.json"),original:null}):(V=V.substring(0,ce),N(V))})};if(K.devMode||K.pseudo||!K.language)return q({localized:(0,f.$ig)(G,"package.nls.json"),original:null});N(K.language)})}z(G,K){return`[${G.path}]: ${K}`}};re=ke([_(1,I.$kp),_(2,v.$Ck),_(3,c.$6j),_(4,i.$5i)],re);let ee=class extends re{constructor(G,K,q,F,N,V,X){super(K,F,N,V,X),this.G=G,this.H=q,this.D=this.B(new O.$Eg(3e3)),this.F=this.B(new a.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(G){const K=this.M(G),q=await this.I(K);if(this.C=G,q&&q.input&&B.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),q.result.map(N=>(N.location=g.URI.revive(N.location),N));const F=await super.scanExtensions(G);return await this.J(K,{input:G,result:F}),F}async I(G){try{const K=await this.j.readFile(G),q=JSON.parse(K.value.toString());return{result:q.result,input:(0,k.$$g)(q.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",G.path,(0,D.$8)(K))}return null}async J(G,K){try{await this.j.writeFile(G,M.$Fd.fromString(JSON.stringify(K)))}catch(q){this.m.debug("Error while writing the extension cache file:",G.path,(0,D.$8)(q))}}async L(){if(!this.C)return;const G=this.M(this.C),K=await this.I(G);if(!K)return;const q=K.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Zm(F,q))try{this.m.info("Invalidating Cache",q,F),await this.j.del(G),this.F.fire()}catch(N){this.m.error(N)}}M(G){const K=this.N(G);return this.h.extUri.joinPath(K.cacheHome,G.type===0?u.$Ql:u.$Pl)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(G.location,K.extensionsResource))??this.G:this.H.defaultProfile}};ee=ke([_(2,A.$Ek),_(3,I.$kp),_(4,v.$Ck),_(5,c.$6j),_(6,i.$5i)],ee);function ae(oe,G){const K=(0,E.$so)(oe.manifest.publisher,oe.manifest.name);return{id:K,identifier:new u.$Vl(K),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:G,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$rp=ae;class se extends U{constructor(G,K,q,F,N,V,X,x,ce,Y,R,j){super(G,K,(0,f.$ig)(q,".vscode-oss-dev","extensions","control.json"),F,N,V,X,x,ce,Y,R,j),this.R=(async()=>{if(p.$y)try{const W=await this.w.readFile(g.URI.file(p.$y));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$sp=se}),define(te[277],ie([0,1,5,41,40,25,81,16,36,7]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let m=class extends D.$lp{constructor(p,f,y,w,d,g){super(l.URI.file(p.extensionsPath),f,y,w,d,g)}};e.$lN=m,e.$lN=m=ke([_(0,h.$Jh),_(1,S.$6j),_(2,O.$Ek),_(3,s.$Ck),_(4,M.$9k),_(5,P.$5i)],m)}),define(te[278],ie([0,1,7,36,81,129,16,6,5,24,40,41]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0;let p=class extends M.$sp{constructor(y,w,d,g,o,$,E,u){super(P.URI.file(o.builtinExtensionsPath),P.URI.file(o.extensionsPath),o.userHome,y.defaultProfile,y,w,d,g,o,$,E,u)}};e.$V6b=p,e.$V6b=p=ke([_(0,b.$Ek),_(1,s.$kp),_(2,D.$6j),_(3,h.$5i),_(4,O.$Jh),_(5,l.$kj),_(6,m.$Ck),_(7,S.$Ah)],p)}),define(te[279],ie([0,1,15,2,13,9,4,58,7,31,38,36,5,41]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=void 0;let y=class extends O.$kc{constructor(d,g,o){super(),this.c=d,this.f=o,this.a=S.$Hh.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(d.appRoot),this.addValidFileRoot(d.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(d.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:d}=P.session;d.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,o)=>this.j(g,o)),d.protocol.interceptFileProtocol(s.Schemas.file,(g,o)=>this.h(g,o)),this.B((0,O.$ic)(()=>{d.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(d){const g=(0,M.$7d)(d);return this.a.get(g)?O.$kc.None:(this.a.set(g,!0),(0,O.$ic)(()=>this.a.delete(g)))}h(d,g){const o=h.URI.parse(d.url);return this.f.error(`Refused to load resource ${o.fsPath} from ${s.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}j(d,g){const o=this.m(d);let $;return this.c.crossOriginIsolated&&((0,M.$ae)(o)==="workbench.html"||(0,M.$ae)(o)==="workbench-dev.html"?$=s.COI.CoopAndCoep:$=s.COI.getHeadersFromQuery(d.url)),this.a.findSubstr(o)?g({path:o,headers:$}):this.b.has((0,M.$be)(o).toLowerCase())?g({path:o}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${o} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}m(d){const g=h.URI.parse(d.url),o=s.$2f.uriToFileUri(g);return(0,M.$7d)(o.fsPath)}createIPCObjectUrl(){let d;const g=h.URI.from({scheme:"vscode",path:(0,l.$4f)()}),o=g.toString(),$=async()=>d;return m.$SS.handle(o,$),this.f.trace(`IPC Object URL: Registered new channel ${o}.`),{resource:g,update:E=>d=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${o}.`),m.$SS.removeHandler(o)}}}};e.$$6b=y,e.$$6b=y=ke([_(0,b.$Jh),_(1,f.$Ek),_(2,p.$5i)],y)}),define(te[96],ie([0,1,8,3,2,65,12,111,6,41]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,h.$Bh)("storageService");var m;(function(o){o[o.NONE=0]="NONE",o[o.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var b;(function(o){o[o.APPLICATION=-1]="APPLICATION",o[o.PROFILE=0]="PROFILE",o[o.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var p;(function(o){o[o.USER=0]="USER",o[o.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f(o){const $=o.get(e.$Uo);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Wo=f;class y extends s.$kc{static{this.a=60*1e3}constructor($={flushInterval:y.a}){super(),this.m=$,this.b=this.B(new O.$id),this.c=this.B(new O.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,E,u){return O.Event.filter(this.b.event,t=>t.scope===$&&(E===void 0||t.key===E),u)}n(){this.j.value=(0,P.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,E){const{key:u,external:t}=E;if(u===e.$Uo){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:u,target:this.J($)[u],external:t})}w($){this.f.fire({reason:$})}get($,E,u){return this.P(E)?.get($,u)}getBoolean($,E,u){return this.P(E)?.getBoolean($,u)}getNumber($,E,u){return this.P(E)?.getNumber($,u)}getObject($,E,u){return this.P(E)?.getObject($,u)}storeAll($,E){this.y(()=>{for(const u of $)this.store(u.key,u.value,u.scope,u.target,E)})}store($,E,u,t,c=!1){if((0,D.$sf)(E)){this.remove($,u,c);return}this.y(()=>{this.z($,u,t),this.P(u)?.set($,E,c)})}remove($,E,u=!1){this.y(()=>{this.z($,E,void 0),this.P(E)?.delete($,u)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,E){const u=[],t=this.J($);for(const c of Object.keys(t))t[c]===E&&u.push(c);return u}z($,E,u,t=!1){const c=this.J(E);typeof u=="number"?c[$]!==u&&(c[$]=u,this.P(E)?.set(e.$Uo,JSON.stringify(c),t)):typeof c[$]=="number"&&(delete c[$],this.P(E)?.set(e.$Uo,JSON.stringify(c),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const E=this.P($);return E?f(E):Object.create(null)}isNew($){return this.getBoolean(e.$To,$)===!0}async flush($=m.NONE){this.f.fire({reason:$});const E=this.P(-1),u=this.P(0),t=this.P(1);switch($){case m.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return g($,E,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,E){return this.w(m.NONE),(0,l.$Dk)($)?this.R($,E):this.S($,E)}M($,E){return!($.id===E.id||w(E)&&w($))}N($,E,u){this.y(()=>{const t=new Set;for(const[c,r]of $)t.add(c),E.get(c)!==r&&this.u(u,{key:c,external:!0});for(const[c]of E.items)t.has(c)||this.u(u,{key:c,external:!0})})}}e.$Xo=y;function w(o){return o.isDefault||!!o.useDefaultFlags?.globalState}e.$Yo=w;class d extends y{constructor(){super(),this.U=this.B(new S.$Ro(new S.$So,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Ro(new S.$So,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Ro(new S.$So,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Zo=d;async function g(o,$,E,u,t,c){const r=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,n=new Map;o.forEach((L,U)=>{i.set(U,L),n.set(U,r(L))});const a=new Map,k=new Map;$.forEach((L,U)=>{a.set(U,L),k.set(U,r(L))});const I=new Map,A=new Map;E.forEach((L,U)=>{I.set(U,L),A.set(U,r(L))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const v=[];if(i.forEach((L,U)=>{v.push({key:U,value:L})}),console.table(v),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];a.forEach((U,B)=>{L.push({key:B,value:U})}),console.table(L),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${c})`);const C=[];I.forEach((L,U)=>{C.push({key:U,value:L})}),console.table(C),console.groupEnd(),console.log(A)}e.$1o=g}),define(te[280],ie([0,1,23,8,3,2,9,69,7,21,111,160,5,96,25,29,13]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p5b=e.$o5b=e.$n5b=e.$m5b=void 0;class g extends M.$kc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$fd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$fd),this.onDidCloseStorage=this.c.event,this.f=this.B(new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new O.$2g,this.whenInit=this.h.p,this.j=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===m.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(f.$To);i===void 0?r.set(f.$To,!0):i&&r.set(f.$To,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=m.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$bd(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([a,k])=>({key:a,length:k.length})),(a,k)=>k.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=m.StorageState.Closed,await this.f.close()}}class o extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$9d)(this.z.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,o.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new m.$Ro(new b.$lT(this.path??b.$lT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class $ extends o{constructor(r,i,n,a){super(r,i,n,a)}}e.$m5b=$;class E extends o{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$_k,void 0)===void 0&&r.set(y.$_k,new Date().toUTCString());const n=r.get(y.$$k,void 0),a=new Date().toUTCString();r.set(y.$al,typeof n>"u"?null:n),r.set(y.$$k,a)}}e.$n5b=E;class u extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$9d)(this.F.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.C.id,u.y)}constructor(r,i,n,a,k){super(n,k),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new m.$Ro(new b.$lT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:i?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$lT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$9d)(this.F.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.C.id),i=(0,D.$9d)(r,u.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$Lh)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$Qh)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$9d)(r,u.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$o5b=u;class t extends g{get path(){}async t(){return new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.$p5b=t}),define(te[281],ie([0,1,3,2,96]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;class M extends O.$kc{constructor(S,h,l){super(),this.b=S,this.c=h,this.f=l;const m=this.B(new O.$lc);this.a=this.B(new P.$fd({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new O.$jc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.h(h))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let m=h.get(l.profile.id);return m||h.set(l.profile.id,m={profile:l.profile,keys:[],storage:l.storage}),m.keys.push(l.key),h},100)(h=>this.j(h))),S}h(S){const h=S.includes(s.$Uo)?[this.c.defaultProfile]:[],l=[];if(S=S.filter(m=>m!==s.$Uo),S.length){const m=(0,s.$Wo)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:S.map(b=>({key:b,scope:0,target:m[b]}))})}this.m(h,l)}j(S){const h=[],l=new Map;for(const[m,b]of S.entries()){b.keys.includes(s.$Uo)&&h.push(b.profile);const p=b.keys.filter(f=>f!==s.$Uo);if(p.length){const f=(0,s.$Wo)(b.storage.storage);l.set(m,{profile:b.profile,changes:p.map(y=>({key:y,scope:0,target:f[y]}))})}}this.m(h,[...l.values()])}m(S,h){(S.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:S})}listen(S,h,l){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(S,h){throw new Error(`Call not found: ${h}`)}}e.$X6b=M}),define(te[282],ie([0,1,7,36,16,5,34,40,41,12,121]),function(J,e,P,O,s,M,D,S,h,l,m){"use strict";var b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;let f=class extends h.$Hk{static{b=this}static{this.a="profileAssociationsMigration"}constructor(g,o,$,E,u){super($,E,o,u),this.U=g,this.W=$}O(){return this.U.getItem(b.b,[]).map(o=>({...o,location:(0,l.$jf)(o.location)?this.w.extUri.joinPath(this.profilesHome,o.location):P.URI.revive(o.location)}))}Q(){const g=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$iN=f,e.$iN=f=b=ke([_(0,D.$dN),_(1,S.$Ck),_(2,O.$Jh),_(3,s.$6j),_(4,M.$5i)],f);let y=p=class extends f{constructor(g,o,$,E,u){super(g,o,$,E,u),this.$=g}P(g){g.length?this.$.setItem(p.b,g.map(o=>({...o,location:this.w.extUri.basename(o.location)}))):this.$.removeItem(p.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(p.c,g):this.$.removeItem(p.c)}Q(){const g="workspaceAndProfileInfo",o=this.$.getItem(g,void 0);if(o){this.$.removeItem(g);const E=o.reduce((u,{workspace:t,profile:c})=>(u[P.URI.revive(t).toString()]=P.URI.revive(c).toString(),u),{});this.$.setItem(p.c,{workspaces:E})}const $=super.Q();return this.$.getItem(p.a,!1)||(this.R($),this.$.setItem(p.a,!0)),$}};e.$jN=y,e.$jN=y=p=ke([_(0,D.$eN),_(1,S.$Ck),_(2,O.$Jh),_(3,s.$6j),_(4,M.$5i)],y);let w=class extends y{constructor(g,o,$,E){super(new m.$hN(0,o,E,$),g,o,$,E)}async init(){return await this.$.init(),super.init()}};e.$kN=w,e.$kN=w=ke([_(0,S.$Ck),_(1,O.$Jh),_(2,s.$6j),_(3,M.$5i)],w)}),define(te[53],ie([0,1,36,16,6,5,40,41,282,34]),function(J,e,P,O,s,M,D,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r5b=e.$q5b=void 0,e.$q5b=(0,s.$Ch)(S.$Ek);let m=class extends h.$jN{constructor(p,f,y,w,d){super(p,f,y,w,d)}getAssociatedEmptyWindows(){const p=[];for(const f of this.C.emptyWindows.keys())p.push({id:f});return p}};e.$r5b=m,e.$r5b=m=ke([_(0,l.$eN),_(1,D.$Ck),_(2,P.$Jh),_(3,O.$6j),_(4,M.$5i)],m)}),define(te[130],ie([0,1,19,7,29]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=e.$L5b=e.$K5b=void 0;async function M(h,l,m){for(const p of h){const f=p.openedWorkspace;if((0,s.$Qh)(f)){const y=await m(f);if(y){if(y.folders.some(w=>P.$_f.isEqualOrParent(l,w.uri)))return p}else if(P.$_f.isEqualOrParent(l,f.configPath))return p}}const b=h.filter(p=>(0,s.$Lh)(p.openedWorkspace)&&P.$_f.isEqualOrParent(l,p.openedWorkspace.uri));if(b.length)return b.sort((p,f)=>-(p.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$K5b=M;function D(h,l){for(const m of h)if((0,s.$Qh)(m.openedWorkspace)&&P.$_f.isEqual(m.openedWorkspace.configPath,l)||(0,s.$Lh)(m.openedWorkspace)&&P.$_f.isEqual(m.openedWorkspace.uri,l))return m}e.$L5b=D;function S(h,l){const m=b=>l.some(p=>P.$_f.isEqual(O.URI.file(p),O.URI.file(b)));for(const b of h)if(b.config?.extensionDevelopmentPath?.some(p=>m(p)))return b}e.$M5b=S}),define(te[97],ie([0,1,32,44,138,46,13,9,4,19,7,6,60,29]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mU=e.$lU=e.$kU=e.$jU=e.$iU=e.$hU=e.$gU=e.$fU=e.$eU=e.$dU=void 0,e.$dU=(0,b.$Bh)("workspacesService");function y(A){return A.hasOwnProperty("workspace")}e.$eU=y;function w(A){return A.hasOwnProperty("folderUri")}e.$fU=w;function d(A){return A.hasOwnProperty("fileUri")}e.$gU=d;function g(A){return o(A)||$(A)}e.$hU=g;function o(A){const v=A;return typeof v?.path=="string"&&(!v.name||typeof v.name=="string")}function $(A){const v=A;return typeof v?.uri=="string"&&(!v.name||typeof v.name=="string")}function E(A,v,C,L,U){if(A.scheme!==L.scheme)return{name:C,uri:A.toString(!0)};let B=v?void 0:U.relativePath(L,A);if(B!==void 0)B.length===0?B=".":h.$i&&(B=u(B));else if(A.scheme===D.Schemas.file)B=A.fsPath,h.$i&&(B=u(B));else if(U.isEqualAuthority(A.authority,L.authority))B=A.path;else return{name:C,uri:A.toString(!0)};return{name:C,path:B}}e.$iU=E;function u(A){return A=(0,M.$fA)(A),(0,P.$Ff)(A)||(A=(0,P.$Cf)(A)),A}function t(A,v,C){const L=[],U=new Set,B=C.dirname(v);for(const re of A){let ee;if(o(re))re.path&&(ee=C.resolvePath(B,re.path));else if($(re))try{ee=m.URI.parse(re.uri),ee.path[0]!==S.$6d.sep&&(ee=ee.with({path:S.$6d.sep+ee.path}))}catch(ae){console.warn(ae)}if(ee){const ae=C.getComparisonKey(ee);if(!U.has(ae)){U.add(ae);const se=re.name||C.basenameOrAuthority(ee);L.push(new f.$Vh({uri:ee,name:se,index:L.length},re))}}}return L}e.$jU=t;function c(A,v,C,L,U){const B=r(v,A),re=U.dirname(v),ee=U.dirname(L),ae=[];for(const K of B.folders){const q=o(K)?U.resolvePath(re,K.path):m.URI.parse(K.uri);let F;C?F=!1:F=!o(K)||(0,S.$8d)(K.path),ae.push(E(q,F,K.name,ee,U))}const se={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},oe=s.$BS(A,["folders"],ae,se);let G=s.$ES(A,oe);return(0,l.$ng)(B.remoteAuthority,(0,p.$Ok)(L))&&(G=s.$ES(G,s.$AS(G,["remoteAuthority"],se))),G}e.$kU=c;function r(A,v){const C=O.$Lm(v);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(L=>g(L));else throw new Error(`${A} looks like an invalid workspace file.`);return C}function i(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function n(A){return typeof A.folderUri=="string"}function a(A){return typeof A.fileUri=="string"}function k(A,v){const C={workspaces:[],files:[]};if(A){const L=function(B,re){for(let ee=0;ee<B.length;ee++)try{re(B[ee],ee)}catch(ae){v.warn(`Error restoring recent entry ${JSON.stringify(B[ee])}: ${ae.toString()}. Skip entry.`)}},U=A;Array.isArray(U.entries)&&L(U.entries,B=>{const re=B.label,ee=B.remoteAuthority;i(B)?C.workspaces.push({label:re,remoteAuthority:ee,workspace:{id:B.workspace.id,configPath:m.URI.parse(B.workspace.configPath)}}):n(B)?C.workspaces.push({label:re,remoteAuthority:ee,folderUri:m.URI.parse(B.folderUri)}):a(B)&&C.files.push({label:re,remoteAuthority:ee,fileUri:m.URI.parse(B.fileUri)})})}return C}e.$lU=k;function I(A){const v={entries:[]};for(const C of A.workspaces)w(C)?v.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):v.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of A.files)v.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return v}e.$mU=I}),define(te[98],ie([0,1,72,13,4,19]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F5b=e.$E5b=e.$D5b=e.$C5b=void 0,e.$C5b=128/4;function D(l){function m(){let b=l.scheme===O.Schemas.file?(0,M.$9f)(l):l.toString();return s.$k||(b=b.toLowerCase()),(0,P.createHash)("md5").update(b).digest("hex")}return{id:m(),configPath:l}}e.$D5b=D;function S(l,m){function b(){if(l.scheme!==O.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!m)return;let f;return s.$k?f=m.ino:s.$j?f=m.birthtime.getTime():s.$i&&(typeof m.birthtimeMs=="number"?f=Math.floor(m.birthtimeMs):f=m.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(f?String(f):"").digest("hex")}const p=b();if(typeof p=="string")return{id:p,uri:l}}e.$E5b=S;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$F5b=h}),define(te[99],ie([0,1,72,87,27,283,17,14,3,2,9,4,31,42,109]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class w{traceSocketEvent(v,C){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,C)}constructor(v,C=""){this.f=!0,this.debugLabel=C,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const C=L=>{this.traceSocketEvent("read",L),v(D.$Fd.wrap(L))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(v){const C=L=>{v({type:0,hadError:L,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(v){const C=()=>{v()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,S.$Y)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,S.$Y)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$qh=w;var d;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var g;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(g||(g={}));class o extends l.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,C){this.socket.traceSocketEvent(v,C)}constructor(v,C,L,U){super(),this.f=this.B(new h.$fd),this.g=this.B(new h.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:L?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new $(this,C,L,U,this.f,(B,re)=>this.m(B,re))),this.B(this.a.onError(B=>{console.error(B),(0,S.$Y)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new y.$lh,this.B(this.socket.onData(B=>this.n(B))),this.B(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let C=0;for(;C<v.byteLength;)this.a.writeMessage(v.slice(C,Math.min(C+262144,v.byteLength))),C+=262144}m(v,C){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let L=2;v.byteLength<126?L+=0:v.byteLength<2**16?L+=2:L+=8;const U=D.$Fd.alloc(L);if(C?U.writeUInt8(194,0):U.writeUInt8(130,0),v.byteLength<126)U.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){U.writeUInt8(126,1);let B=1;U.writeUInt8(v.byteLength>>>8&255,++B),U.writeUInt8(v.byteLength>>>0&255,++B)}else{U.writeUInt8(127,1);let B=1;U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(v.byteLength>>>24&255,++B),U.writeUInt8(v.byteLength>>>16&255,++B),U.writeUInt8(v.byteLength>>>8&255,++B),U.writeUInt8(v.byteLength>>>0&255,++B)}this.socket.write(D.$Fd.concat([U,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),L=C.readUInt8(0),U=(L&128)>>>7,B=(L&64)>>>6,re=C.readUInt8(1),ee=(re&128)>>>7,ae=re&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!B),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),L=C.readUInt8(1),U=(L&128)>>>7;let B=L&127,re=1;B===126?B=C.readUInt8(++re)*2**8+C.readUInt8(++re):B===127&&(B=C.readUInt8(++re)*0+C.readUInt8(++re)*0+C.readUInt8(++re)*0+C.readUInt8(++re)*0+C.readUInt8(++re)*2**24+C.readUInt8(++re)*2**16+C.readUInt8(++re)*2**8+C.readUInt8(++re));let ee=0;U&&(ee=C.readUInt8(++re)*2**24+C.readUInt8(++re)*2**16+C.readUInt8(++re)*2**8+C.readUInt8(++re)),this.j.state=3,this.j.readLen=B,this.j.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(C,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=o;class $ extends l.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Fd.alloc(0)}constructor(v,C,L,U,B,re){super(),this.n=v,this.r=B,this.s=re,this.a=this.B(new h.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new E(this.n,U,L,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(v){this.g.push(v),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const v=this.g.shift();if(this.f){const C=await this.w(this.f,v);this.s(C,!0)}else this.s(v,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,C){return new Promise((L,U)=>{v.write(C),v.flush(B=>L(B))})}acceptFrame(v,C,L){this.h.push({data:v,isCompressed:C,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const C=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,C,L){return new Promise((U,B)=>{v.write(C),L&&v.write(D.$Fd.fromByteArray([0,0,255,255])),v.flush(re=>U(re))})}}class E extends l.$kc{get recordedInflateBytes(){return this.j?D.$Fd.concat(this.f):D.$Fd.alloc(0)}constructor(v,C,L,U){super(),this.h=v,this.j=C,this.a=this.B(new h.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(D.$Fd.wrap(B))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$Fd.concat(this.g);this.g.length=0,v(C)})}}class u extends l.$kc{constructor(v,C){super(),this.g=v,this.a=this.B(new h.$fd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(D.$Fd.wrap(L))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$Fd.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),v(C)})}}function t(A,v){if(v===0)return;const C=A.byteLength>>>2;for(let ae=0;ae<C;ae++){const se=A.readUInt32BE(ae*4);A.writeUInt32BE(se^v,ae*4)}const L=C*4,U=A.byteLength-L,B=v>>>24&255,re=v>>>16&255,ee=v>>>8&255;U>=1&&A.writeUInt8(A.readUInt8(L)^B,L),U>=2&&A.writeUInt8(A.readUInt8(L+1)^re,L+1),U>=3&&A.writeUInt8(A.readUInt8(L+2)^ee,L+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function r(){const A=(0,p.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const v=process.platform!=="darwin"&&e.$sh?e.$sh:(0,s.tmpdir)(),C=(0,m.$9d)(v,`vscode-ipc-${A}.sock`);return n(C),C}e.$th=r;function i(A,v,C){const L=(0,P.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${C}-${v}-sock`;const U=C.substr(0,4),B=v.substr(0,6),re=L.substr(0,8);let ee;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?ee=(0,m.$9d)(e.$sh,`vscode-${re}-${U}-${B}.sock`):ee=(0,m.$9d)(A,`${U}-${B}.sock`),n(ee),ee}e.$uh=i;function n(A){const v=c[b.$t];typeof v=="number"&&A.length>=v&&console.warn(`WARNING: IPC handle "${A}" is longer than ${v} chars, try a shorter --user-data-dir`)}class a extends f.$fh{static b(v){const C=h.Event.fromNodeEventEmitter(v,"connection");return h.Event.map(C,L=>({protocol:new y.$mh(new w(L,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(L,"close"))}))}constructor(v){super(a.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=a;function k(A){return new Promise((v,C)=>{const L=(0,O.createServer)();L.on("error",C),L.listen(A,()=>{L.removeListener("error",C),v(new a(L))})})}e.$wh=k;function I(A,v){return new Promise((C,L)=>{const U=(0,O.createConnection)(A,()=>{U.removeListener("error",L),C(y.$nh.fromSocket(new w(U,`ipc-client${v}`),v))});U.once("error",L)})}e.$xh=I}),define(te[28],ie([0,1,55,9,4,99,36,89,6]),function(J,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=e.$i5b=void 0,e.$i5b=(0,h.$Ch)(D.$Ih);class l extends S.$_l{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,O.$9d)(this.userDataPath,"clp")}get backupHome(){return(0,O.$9d)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$uh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,O.$9d)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const p=b.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[b]?process.env[p]=process.env[b]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$j5b=l,ke([P.$6g],l.prototype,"cachedLanguagesPath",null),ke([P.$6g],l.prototype,"backupHome",null),ke([P.$6g],l.prototype,"mainIPCHandle",null),ke([P.$6g],l.prototype,"mainLockfile",null),ke([P.$6g],l.prototype,"disableUpdates",null),ke([P.$6g],l.prototype,"crossOriginIsolated",null),ke([P.$6g],l.prototype,"codeCachePath",null),ke([P.$6g],l.prototype,"useCodeCache",null)}),define(te[284],ie([0,1,72,32,13,9,4,19,21,195,18,28,34,16,5,194,29,98]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=void 0;let $=class{static{o=this}static{this.a="backupWorkspaces"}constructor(u,t,c,r){this.j=u,this.k=t,this.l=c,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$_f,this.i={isEqual:(i,n)=>(0,O.$Hf)(i,n,!D.$k)}}async initialize(){const u=this.m.getItem(o.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,l.$z5b)(u)),this.e=await this.v((0,l.$A5b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$rk.OFF}q(){return this.s()===f.$rk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$rk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,t){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const c=(0,M.$9d)(this.c,u.workspace.id);return t?this.t(c,t).then(()=>c):c}async t(u,t){if(await h.Promises.exists(u)&&await this.z(u),await h.Promises.exists(t))try{await h.Promises.rename(t,u,!1)}catch(c){this.l.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}registerFolderBackup(u){return this.e.some(t=>this.h.isEqual(u.folderUri,t.folderUri))||(this.e.push(u),this.C()),(0,M.$9d)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,M.$9d)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const t=new Set,c=[];for(const r of u){const i=r.workspace;if(!(0,d.$Qh)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$9d)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?c.push(r):await this.z(n):await this.x(n)}}return c}async v(u){if(!Array.isArray(u))return[];const t=[],c=new Set;for(const r of u){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!c.has(n)){c.add(n);const a=(0,M.$9d)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(u){if(!Array.isArray(u))return[];const t=[],c=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!c.has(i)){c.add(i);const n=(0,M.$9d)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(u){try{await h.Promises.rm(u,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let u=(0,g.$F5b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.id));)u=(0,g.$F5b)();return{backupFolder:u.id}}async z(u){const t=this.y(),c=(0,M.$9d)(this.c,t.backupFolder);try{await h.Promises.rename(u,c,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.d)await this.A(t)&&u.push(t);for(const t of this.e)await this.A(t)&&u.push(t);return u}A(u){let t;return(0,l.$y5b)(u)?t=(0,M.$9d)(this.c,u.backupFolder):(0,w.$bU)(u)?t=(0,M.$9d)(this.c,this.D(u)):t=(0,M.$9d)(this.c,u.workspace.id),this.B(t)}async B(u){try{const t=await h.Promises.readdir(u);for(const c of t)try{if((await h.Promises.readdir((0,M.$9d)(u,c))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:t,remoteAuthority:c})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return c&&(r.remoteAuthority=c),r}),folders:this.e.map(({folderUri:t,remoteAuthority:c})=>{const r={folderUri:t.toString()};return c&&(r.remoteAuthority=c),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:c})=>{const r={backupFolder:t};return c&&(r.remoteAuthority=c),r})};this.m.setItem(o.a,u)}D(u){const t=u.folderUri;let c;return t.scheme===s.Schemas.file?c=D.$k?t.fsPath:t.fsPath.toLowerCase():c=t.toString().toLowerCase(),(0,P.createHash)("md5").update(c).digest("hex")}};e.$G5b=$,e.$G5b=$=o=ke([_(0,b.$i5b),_(1,m.$8h),_(2,y.$5i),_(3,p.$eN)],$)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,28]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$l5b=e.LifecycleMainPhase=e.ShutdownReason=e.$k5b=void 0,e.$k5b=(0,m.$Bh)("lifecycleMainService");var w;(function(o){o[o.QUIT=1]="QUIT",o[o.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var d;(function(o){o[o.Starting=1]="Starting",o[o.Ready=2]="Ready",o[o.AfterWindowOpen=3]="AfterWindowOpen",o[o.Eventually=4]="Eventually"})(d||(e.LifecycleMainPhase=d={}));let g=class extends D.$kc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor($,E,u){super(),this.F=$,this.G=E,this.H=u,this.c=this.B(new M.$fd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$fd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$fd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$fd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const $=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",$);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",$),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L($){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:$,join(t,c){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(c.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase($){if($<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===$)return;this.S(`lifecycle (main): phase changed (value: ${$})`),this.n=$;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when($){if($<=this.n)return;let E=this.C.get($);E||(E=new s.$Fg,this.C.set($,E)),await E.wait()}registerWindow($){const E=new D.$jc;this.t++,E.add($.onWillLoad(t=>this.g.fire({window:$,workspace:t.workspace,reason:t.reason})));const u=(0,l.$uf)($.win);u.on("close",t=>{const c=$.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${$.id}`),t.preventDefault(),this.unload($,1).then(r=>{if(r){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire($),$.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${$.id}`),this.t--,E.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}async reload($,E){await this.unload($,3)||$.reload(E)}unload($,E){const u=this.z.get($.id);if(u)return u;const t=this.M($,E).finally(()=>{this.z.delete($.id)});return this.z.set($.id,t),t}async M($,E){if(!$.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${$.id}`);const u=this.j?2:E,t=await this.P($,u);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${$.id})`),this.N(t)):(await this.Q($,u),!1)}N($){return $?(this.O(!0),this.j=!1,!0):!1}O($){this.w&&(this.w($),this.w=void 0,this.u=void 0)}P($,E){return new Promise(u=>{const t=this.s++,c=`vscode:ok${t}`,r=`vscode:cancel${t}`;O.$SS.once(c,()=>{u(!1)}),O.$SS.once(r,()=>{u(!0)}),$.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:r,reason:E})})}Q($,E){return new Promise(u=>{const c=`vscode:reply${this.s++}`;O.$SS.once(c,()=>u()),$.send("vscode:onWillUnload",{replyChannel:c,reason:E})})}quit($){return this.R($).then(E=>{if(!E&&$)try{if(S.$i){const u=(0,h.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return E})}R($){return this.S(`Lifecycle#quit() - begin (willRestart: ${$})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):($&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S($){this.H.args["enable-smoke-test-driver"]?this.F.info($):this.F.trace($)}setRelaunchHandler($){this.D=$}async relaunch($){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if($?.addArgs&&E.push(...$.addArgs),$?.removeArgs)for(const c of $.removeArgs){const r=E.indexOf(c);r>=0&&E.splice(r,1)}const u=()=>{this.D?.handleRelaunch($)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",u),await this.quit(!0)&&P.app.removeListener("quit",u)}async kill($){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Hg)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let u;E.webContents&&!E.webContents.isDestroyed()?u=new Promise(t=>E.once("closed",t)):u=Promise.resolve(),E.destroy(),await u}})()]),P.app.exit($)}};e.$l5b=g,e.$l5b=g=y=ke([_(0,b.$5i),_(1,p.$eN),_(2,f.$i5b)],g)}),define(te[285],ie([0,1,4,3,2,6,20]),function(J,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=e.$a6b=void 0,e.$a6b=(0,M.$Bh)("keyboardLayoutMainService");let S=class extends s.$kc{constructor(m){super(),this.a=this.B(new O.$fd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((b,p)=>{J(["native-keymap"],b,p)});this.c=h(m),P.$s||m.onDidChangeKeyboardLayout(()=>{this.c=h(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$b6b=S,e.$b6b=S=ke([_(0,D.$k5b)],S);function h(l){const m=l.getKeyMap(),b=l.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:b}}}),define(te[286],ie([0,1,245,8,17,14,12,18,36,94,5,51,244,283]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;let y=class extends b.$Jo{constructor(o,$,E,u){super(u),this.m=o,this.n=$,this.r=E,this.s(),this.B(o.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const o=this.m.getValue("http");this.f=o?.proxy,this.g=!!o?.proxyStrictSSL,this.h=o?.proxyAuthorization}async request(o,$){const{f:E,g:u}=this;let t;try{t=await(0,l.$Ml)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$8)(i)))}const c={...process.env,...t},r=o.agent?o.agent:await(0,p.$Nq)(o.url||"",c,{proxyUrl:E,strictSSL:u});return o.agent=r,o.strictSSL=u,this.h&&(o.headers={...o.headers||{},"Proxy-Authorization":this.h}),this.c(o.isChromiumNetwork?"electron":"node",o,()=>d(o,$))}async resolveProxy(o){}};e.$Oq=y,e.$Oq=y=ke([_(0,S.$8h),_(1,h.$Jh),_(2,m.$5i),_(3,m.$6i)],y);async function w(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((E,u)=>{J(["https"],E,u)}):await new Promise((E,u)=>{J(["http"],E,u)})).request}async function d(g,o){return O.Promises.withAsyncBody(async($,E)=>{const u=(0,P.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await w(g),c={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,D.$pf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(c.auth=g.user+":"+g.password);const r=t(c,i=>{const n=(0,D.$nf)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)d({...g,url:i.headers.location,followRedirects:n-1},o).then($,E);else{let a=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,f.createGunzip)())),$({res:i,stream:(0,s.$Ud)(a)})}});r.on("error",E),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),o.onCancellationRequested(()=>{r.abort(),E(new M.$3)})})}e.$Pq=d}),define(te[287],ie([0,1,15,286]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=void 0;function s(D){return P.net.request}class M extends O.$Oq{request(S,h){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.$d7b=M}),define(te[82],ie([0,1,7,49,3,2,36,16,6,20,5,96,280,41,53,40,13]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=e.$u5b=e.$t5b=e.$s5b=void 0,e.$s5b=(0,h.$Bh)("storageMainService");let g=class extends M.$kc{constructor(E,u,t,c,r,i){super(),this.c=E,this.f=u,this.g=t,this.h=c,this.j=r,this.m=i,this.a=void 0,this.b=this.B(new s.$fd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,u]of this.t)E.join("profileStorage",u.close());for(const[,u]of this.w)E.join("workspaceStorage",u.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const u=this.t.get(E.profile.id);u&&E.join(u.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new p.$n5b(this.n(),this.g,this.c,this.j);return this.B((0,O.$bb)(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,b.$Yo)(E))return this.applicationStorage;let u=this.t.get(E.id);if(!u){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),u=this.B(this.u(E)),this.t.set(E.id,u);const t=this.B(u.onDidChangeStorage(c=>this.b.fire({...c,storage:u,profile:E})));this.B((0,O.$bb)(u.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),t.dispose()}))}return u}u(E){return this.a===2?new p.$p5b(this.c,this.j):new p.$m5b(E,this.n(),this.c,this.j)}workspaceStorage(E){let u=this.w.get(E.id);return u||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),u=this.B(this.y(E)),this.w.set(E.id,u),this.B((0,O.$bb)(u.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),u}y(E){return this.a===2?new p.$p5b(this.c,this.j):new p.$o5b(E,this.n(),this.c,this.f,this.j)}isUsed(E){const u=P.URI.file(E);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(P.URI.file(t.path),u))return!0;return!1}};e.$t5b=g,e.$t5b=g=ke([_(0,m.$5i),_(1,D.$Ih),_(2,y.$q5b),_(3,l.$k5b),_(4,S.$6j),_(5,w.$Ck)],g),e.$u5b=(0,h.$Bh)("applicationStorageMainService");let o=class extends b.$Xo{constructor(E,u){super(),this.s=E,this.U=u,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===-1)return this.U.applicationStorage.storage}Q(E){if(E===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$v5b=o,e.$v5b=o=ke([_(0,f.$Ek),_(1,e.$s5b)],o)}),define(te[288],ie([0,1,15,22,3,57,2,31,115,5,82,30]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;var p;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let f=class extends D.$kc{constructor(w,d,g,o){super(),this.g=w,this.h=d,this.j=g,this.m=o,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(P.app,"login",(d,g,o,$,E)=>({event:d,webContents:g,req:o,authInfo:$,callback:E}));this.B(w(this.r,this))}async r({event:w,authInfo:d,req:g,callback:o}){if(!d.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let $;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),$=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(d);try{$=await this.b}finally{this.b=void 0}}o($?.username,$?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.t(w);if(d)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const d=String((0,M.$pi)({scheme:w.scheme,host:w.host,port:w.port}));let g,o;try{const t=this.m.get(this.a+d,-1);if(t){const c=JSON.parse(await this.j.decrypt(t));g=c.username,o=c.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof g=="string"&&typeof o=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:g,password:o};const $=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!$){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${$.id} to handle proxy login`);const E={authInfo:w,username:this.f?.username??g,password:this.f?.password??o,replyChannel:`vscode:proxyAuthResponse:${(0,S.$4f)()}`};$.sendWhenReady("vscode:openProxyAuthenticationDialog",O.CancellationToken.None,E),this.c=p.LoginDialogShown;const u=await new Promise(t=>{const c=async(r,i,n)=>{if(i===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${$.id}`),$.win?.webContents.off("ipc-message",c),n){const a={username:n.username,password:n.password};try{if(n.remember){const k=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+d,k,-1,1)}else this.m.remove(this.a+d,-1)}catch(k){this.g.error(k)}t({username:a.username,password:a.password})}else t(void 0)};$.win?.webContents.on("ipc-message",c)});return this.f=u,u}};e.$x5b=f,e.$x5b=f=ke([_(0,l.$5i),_(1,b.$w5b),_(2,h.$AT),_(3,m.$u5b)],f)}),define(te[289],ie([0,1,87,27,103,99,8,2,4,18,5,24,240,241,95,126,17]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=e.$a7b=e.$_6b=void 0;async function g(t,c,r,i,n){let a;for(let k=3;k&&(a?.dispose(),a=await new o(t,c,r,i,n).waitForReady(),!(n&&s.$7f[n]||!s.$7f[a.tunnelLocalPort]));k--);return a}class o extends S.$kc{constructor(c,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=P.createServer(),this.c=new D.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,r=(0,w.$4z)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$8f)(c,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(c){c.pause();const r=(0,w.$2z)(this.tunnelRemoteHost)||(0,w.$4z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$Zk)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&c.write(a.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),n.end()}),c.on("close",()=>n.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),n instanceof M.$qh?n.socket.destroy():n.end()}),n instanceof M.$qh?this.t(c,n):this.s(c,n),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),n.end()})}s(c,r){r.onClose(()=>c.destroy()),r.onEnd(()=>c.end()),r.onData(i=>c.write(i.buffer)),c.on("data",i=>r.write(d.$Fd.wrap(i))),c.resume()}t(c,r){const i=r.socket;i.on("end",()=>c.end()),i.on("close",()=>c.end()),i.on("error",()=>{c.destroy()}),i.pipe(c),c.pipe(i)}}e.$_6b=o;let $=class extends w.$7z{constructor(c,r,i,n,a){super(r,a),this.u=c,this.v=i,this.w=n}isPortPrivileged(c){return(0,w.$5z)(c,this.l,h.OS,O.release())}s(c,r,i,n,a,k,I,A){const v=this.r(r,i);if(v)return++v.refcount,v.value;if((0,w.$Yz)(c))return this.t(c,r,i,a,k,I,A);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const C={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=g(C,n,r,i,a);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,L),L}}};e.$a7b=$,e.$a7b=$=ke([_(0,f.$Tk),_(1,m.$5i),_(2,y.$Wk),_(3,b.$kj),_(4,l.$8h)],$);let E=class extends ${constructor(c,r,i,n,a){super(c,r,i,n,a)}};e.$b7b=E,e.$b7b=E=ke([_(0,f.$Tk),_(1,m.$5i),_(2,y.$Wk),_(3,b.$kj),_(4,l.$8h)],E);let u=class extends S.$kc{constructor(c,r,i,n,a){super(),this.b=c,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(c,r,i,n,a,k,I,A,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${k}.`),!this.a.has(c)){const C=new E(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(c,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(r,i,n,a,k,I,A,v)}};e.$c7b=u,e.$c7b=u=ke([_(0,f.$Tk),_(1,m.$5i),_(2,b.$kj),_(3,y.$Wk),_(4,l.$8h)],u)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,24,51,48]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=void 0;function p(y,w,d){return`${d.updateUrl}/api/update/${y}/${w}/${d.commit}`}e.$z6b=p;let f=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,d,g,o,$,E){this.f=w,this.g=d,this.h=g,this.i=o,this.j=$,this.k=E,this.b=b.$RT.Uninitialized,this.c=new s.$fd,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$RT.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$RT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$RT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),d=this.m(w);if(!d){this.d(b.$RT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(d),!this.a){this.d(b.$RT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$RT.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,P.$Hg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},O.CancellationToken.None)).res.statusCode===204}catch(d){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(d);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$A6b=f,e.$A6b=f=ke([_(0,S.$k5b),_(1,M.$8h),_(2,D.$i5b),_(3,m.$Io),_(4,h.$5i),_(5,l.$kj)],f)}),define(te[290],ie([0,1,15,55,3,2,18,28,20,5,24,51,25,48,100]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;let w=class extends y.$A6b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(g,o)=>o)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(g,o,$)=>({url:o,version:$,productVersion:$}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(g,o,$,E)=>({releaseNotes:o,version:$,productVersion:$,date:E}))}constructor(g,o,$,E,u,t,c){super(g,o,E,u,t,c),this.z=$,this.u=new M.$jc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const o=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(f.$RT.Idle(1,o))}s(g){let o;this.k.darwinUniversalAssetId?o=this.k.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,y.$z6b)(o,g,this.k);try{P.autoUpdater.setFeedURL({url:$})}catch(E){this.j.error("Failed to set update feed URL",E);return}return $}t(g){this.d(f.$RT.CheckingForUpdates(g)),P.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(f.$RT.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(f.$RT.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$RT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$B6b=w,ke([O.$6g],w.prototype,"v",null),ke([O.$6g],w.prototype,"w",null),ke([O.$6g],w.prototype,"x",null),ke([O.$6g],w.prototype,"y",null),e.$B6b=w=ke([_(0,h.$k5b),_(1,D.$8h),_(2,p.$9k),_(3,S.$i5b),_(4,b.$Io),_(5,l.$5i),_(6,m.$kj)],w)}),define(te[291],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=void 0;let p=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,d,g){if(this.f=w,this.g=g,this.a=b.$RT.Uninitialized,this.b=new M.$fd,this.onStateChange=this.b.event,d.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$RT.Idle(this.k())),this.h(30*1e3).then(void 0,o=>this.g.error(o))}h(w=60*60*1e3){return(0,s.$Hg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};p=ke([_(0,h.$k5b),_(1,S.$i5b),_(2,l.$5i)],p);let f=class extends p{constructor(w,d,g,o,$,E){super(g,o,$),this.o=w,this.p=d,this.q=E;const u=(0,O.watch)(D.$_d(this.o)),t=M.Event.fromNodeEventEmitter(u,"change",(n,a)=>a),c=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(c,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),u.close()})}m(){this.d(b.$RT.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(b.$RT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$RT.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$RT.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$ae(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((g,o)=>(0,O.realpath)(`${D.$_d(this.o)}/current`,($,E)=>$?o($):g(E))),d=D.$ae(w);return this.p!==d}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$D6b=f,e.$D6b=f=ke([_(2,h.$k5b),_(3,S.$i5b),_(4,l.$5i),_(5,m.$9k)],f)}),define(te[292],ie([0,1,2,20,53,29,8,30]),function(J,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=void 0;let h=class extends P.$kc{constructor(m,b,p){super(),this.a=b,this.b=p,this.B(m.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(m.onBeforeCloseWindow(f=>this.c(f))),this.B(new D.$Sg(()=>this.g(),30*1e3)).schedule()}async c(m){const b=this.f(m),p=this.a.getProfileForWorkspace(b);p?.isTransient&&(this.a.unsetWorkspace(b,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,M.$Ph)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const b=this.b.getWindows().map(p=>this.f(p));for(const p of m)b.some(f=>f.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$W6b=h,e.$W6b=h=ke([_(0,O.$k5b),_(1,s.$q5b),_(2,S.$w5b)],h)}),define(te[62],ie([0,1,15,2,3,5,311,8,13,30,70,25,20,73,37,4,131]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=e.$P5b=void 0;function o(u){return typeof u.responseWindowId=="number"}let $=class extends O.$kc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,c,r){super(),this.t=t,this.u=c,this.w=r,this.c=String(++g.a),this.f=this.B(new s.$fd),this.onStdout=this.f.event,this.g=this.B(new s.$fd),this.onStderr=this.g.event,this.h=this.B(new s.$fd),this.onMessage=this.h.event,this.j=this.B(new s.$fd),this.onExit=this.j.event,this.m=this.B(new s.$fd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,c){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,c){case m.default.Error:this.t.error(r);break;case m.default.Warning:this.t.warn(r);break;case m.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const c=this.C(t);return c&&t.payload&&this.postMessage(t.payload),c}C(t){if(!this.z())return!1;this.s=t;const c=`${this.s.type}-${this.c}`,r=h.$2f.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],a=this.s.allowLoadingUnsignedLibraries,k=this.s.forceAllocationsToV8Sandbox,I="pipe",A=this.D(t);return this.y("creating new...",m.default.Info),this.n=P.utilityProcess.fork(r,i,{serviceName:c,env:A,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:k,stdio:I}),this.F(this.n,this.s,c),!0}D(t){const c=t.env?{...t.env}:{...(0,y.$Vm)(process.env)};c.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(c.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),c.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,d.isUNCAccessRestrictionsDisabled)()?c.NODE_DISABLE_UNC_ACCESS_CHECKS="1":c.NODE_UNC_HOST_ALLOWLIST=(0,d.getUNCHostAllowlist)().join("\\")),(0,f.$tl)(c);for(const r of Object.keys(c))c[r]=String(c[r]);return c}F(t,c,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:o(c)?`${c.type} [${c.responseWindowId}]`:c.type}),this.y("successfully created",m.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,m.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,m.default.Error),this.u.publicLog2("utilityprocesscrash",{type:c.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,c){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),c())}))}postMessage(t,c){this.n&&this.n.postMessage(t,c)}connect(t){const{port1:c,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),c}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",m.default.Info),this.n.kill()?(this.y("successfully killed the process",m.default.Info),this.G()):this.y("unable to kill the process",m.default.Warning)}G(){typeof this.r=="number"&&g.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Hg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$P5b=$,e.$P5b=$=g=ke([_(0,M.$5i),_(1,b.$9k),_(2,p.$k5b)],$);let E=class extends ${constructor(t,c,r,i){super(t,r,i),this.H=c}start(t){const c=this.H.getWindowById(t.responseWindowId);if(!c?.win||c.win.isDestroyed()||c.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.C(t))return!1;this.I(c.win,t);const i=this.connect(t.payload);return c.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,c){c.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Q5b=E,e.$Q5b=E=ke([_(0,M.$5i),_(1,l.$w5b),_(2,b.$9k),_(3,p.$k5b)],E)}),define(te[293],ie([0,1,14,5,20,8,62,30,25]),function(J,e,P,O,s,M,D,S,h){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=void 0;let m=class{static{l=this}static{this.a=0}constructor(p,f,y,w){this.d=p,this.f=f,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(d=>{this.c=!0,d.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const f=this.b.get(p);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,P.$4)();const p=String(++l.a),f=new D.$Q5b(this.d,this.g,this.h,this.f);return this.b.set(p,f),f.onExit(({pid:y,code:w,signal:d})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${d}.`),setTimeout(()=>{f.dispose(),this.b.delete(p)})}),{id:p}}async start(p,f){if(this.c)throw(0,P.$4)();this.i(p).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,P.$4)();const f=this.b.get(p);return f?f.enableInspectPort():!1}async kill(p){if(this.c)throw(0,P.$4)();const f=this.b.get(p);f&&f.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(p));return M.Promises.settled(f).then(()=>{})}};e.$Y5b=m,e.$Y5b=m=l=ke([_(0,O.$5i),_(1,s.$k5b),_(2,S.$w5b),_(3,h.$9k)],m)}),define(te[294],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,89,12,246,24]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=void 0;let g=class extends s.$kc{constructor($,E,u,t,c,r,i,n){super(),this.c=$,this.f=E,this.g=u,this.h=t,this.j=c,this.m=r,this.n=i,this.r=n,this.a=new O.$Fg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$SS.on(w.$r6b.request,($,E)=>this.t($,E,w.$r6b.response)),P.$SS.on(w.$s6b.request,($,E)=>this.t($,E,w.$s6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t($,E,u){this.j.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(u);if($.sender.isDestroyed())return t.close();$.sender.postMessage(u,E,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$q6b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const $=new O.$2g;this.b?this.b.once(w.$q6b.initDone,()=>$.complete()):P.$SS.once(w.$q6b.initDone,()=>$.complete()),await $.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const $=new O.$2g;this.b?this.b.once(w.$q6b.ipcReady,()=>$.complete()):P.$SS.once(w.$q6b.ipcReady,()=>$.complete()),await $.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$P5b(this.j,p.$bo,this.h));const $=(0,f.$bm)(this.f.args,this.f.isBuilt);let E;$.port&&(E=["--nolazy"],$.break?E.push(`--inspect-brk=${$.port}`):E.push(`--inspect=${$.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect($){return await this.z,(0,y.$uf)(this.b).connect($)}};e.$t6b=g,e.$t6b=g=ke([_(1,M.$i5b),_(2,h.$Ek),_(3,D.$k5b),_(4,S.$5i),_(5,m.$o6b),_(6,l.$0m),_(7,d.$kj)],g)}),define(te[295],ie([0,1,28,89,20,5,52,62,110,38,2,3,37,18,13]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;let w=class extends m.$kc{constructor(g,o,$,E,u){super(),this.f=g,this.g=o,this.h=$,this.j=E,this.m=u,this.a=void 0,this.b=new b.$fd,this.onRequestConnection=this.b.event,this.c=new b.$fd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$SS.on("vscode:createPtyHostMessageChannel",(t,c)=>this.r(t,c)),this.B((0,m.$ic)(()=>{l.$SS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$P5b(this.m,D.$bo,this.j);const g=(0,O.$am)(this.h.args,this.h.isBuilt),o=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:o,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const $=this.a.connect(),E=new h.$1S($,"ptyHost"),u=new m.$jc;return u.add(E),u.add((0,m.$ic)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,p.$Vm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},o=this.g.getValue("terminal.integrated.developer.ptyHost.latency");o&&typeof o=="number"&&(g.VSCODE_LATENCY=String(o));const $=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return $&&typeof $=="number"&&(g.VSCODE_STARTUP_DELAY=String($)),this.h.restoreSnapExportedVariables(),g}r(g,o){this.b.fire();const $=this.a.connect();if(g.sender.isDestroyed()){$.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",o,[$])}};e.$56b=w,e.$56b=w=ke([_(1,f.$8h),_(2,P.$i5b),_(3,s.$k5b),_(4,M.$5i)],w)}),define(te[296],ie([0,1,2,6,5,30,62,25,57,3,8,20]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=e.$36b=void 0,e.$36b=(0,O.$Bh)("utilityProcessWorker");let p=class extends P.$kc{constructor(w,d,g,o){super(),this.b=w,this.c=d,this.f=g,this.g=o,this.a=new Map}async createWorker(w){const d=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${d})`);const g=this.h(w);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${d})`),this.disposeWorker(w));const o=new f(this.b,this.c,this.f,this.g,w);if(!o.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,o);const $=new m.$2g;return l.Event.once(o.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(g),$.complete({reason:E})}),$.p}h(w){return(0,h.$pi)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const d=this.h(w),g=this.a.get(d);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),g.kill(),this.a.delete(d))}};e.$46b=p,e.$46b=p=ke([_(0,s.$5i),_(1,M.$w5b),_(2,S.$9k),_(3,b.$k5b)],p);let f=class extends P.$kc{constructor(w,d,g,o,$){super(),this.c=w,this.f=d,this.g=g,this.h=o,this.j=$,this.a=this.B(new l.$fd),this.onDidTerminate=this.a.event,this.b=new D.$Q5b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const d=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:d,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ke([_(0,s.$5i),_(1,M.$w5b),_(2,S.$9k),_(3,b.$k5b)],f)}),define(te[297],ie([0,1,15,2,4,19,7,18,20,5,34,30,128,29]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=e.$O6b=e.$N6b=void 0;let w=class extends O.$kc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,t,c,r,i){super(),this.g=u,this.h=t,this.j=c,this.m=r,this.n=i,this.b=d(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const c=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);c&&(t.lastPluginDevelopmentHostWindow=this.w(c),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!c.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const r=o(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(u){if(this.j.quitRequested)return;const t=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(c=>{const r=(0,f.$Qh)(u.openedWorkspace)&&c.workspace?.id===u.openedWorkspace.id,i=(0,f.$Lh)(u.openedWorkspace)&&c.folderUri&&M.$_f.isEqual(c.folderUri,u.openedWorkspace.uri);(r||i)&&(c.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(u){return{windowId:u.id,workspace:(0,f.$Qh)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.$Lh)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.z(u),c=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||c?.restoreFullscreen),r||(t.mode=1)}return t}z(u){const t=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=u.workspace;if((0,f.$Qh)(k)){const A=this.state.openedWindows.filter(v=>v.workspace&&v.workspace.id===k.id).map(v=>v.uiState);if(A.length)return A[0]}if((0,f.$Lh)(k)){const A=this.state.openedWindows.filter(v=>v.folderUri&&M.$_f.isEqual(v.folderUri,k.uri)).map(v=>v.uiState);if(A.length)return A[0]}else if(u.backupPath){const A=this.state.openedWindows.filter(v=>v.backupPath===u.backupPath).map(v=>v.uiState);if(A.length)return A[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let c;const r=P.screen.getAllDisplays();if(r.length===1)c=r[0];else{if(s.$j){const k=P.screen.getCursorScreenPoint();c=P.screen.getDisplayNearestPoint(k)}!c&&t&&(c=P.screen.getDisplayMatching(t.getBounds())),c||(c=P.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$h5b)();i.x=Math.round(c.bounds.x+c.bounds.width/2-i.width/2),i.y=Math.round(c.bounds.y+c.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const k=t.serializeWindowState();k.mode===3?i.mode=3:i=k,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.g.getWindows().map(c=>c.getBounds());for(;t.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};e.$N6b=w,e.$N6b=w=y=ke([_(0,b.$w5b),_(1,m.$eN),_(2,h.$k5b),_(3,l.$5i),_(4,S.$8h)],w);function d(E){const u={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(c=>g(c))),u}e.$O6b=d;function g(E){const u={uiState:E.uiState};return E.backupPath&&(u.backupPath=E.backupPath),E.remoteAuthority&&(u.remoteAuthority=E.remoteAuthority),E.folder&&(u.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(u.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),u}function o(E){return{lastActiveWindow:E.lastActiveWindow&&$(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&$(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(u=>$(u))}}e.$P6b=o;function $(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[54],ie([0,1,15,3,44,2,13,9,19,21,193,64,61,28,6,5,53,130,29,97,98]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O5b=e.$N5b=void 0,e.$N5b=(0,y.$Bh)("workspacesManagementMainService");let u=class extends M.$kc{constructor(c,r,i,n,a){super(),this.g=c,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new O.$fd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new O.$fd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const c=(await l.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,h.$ig)(this.c,r,o.$1h));for(const r of c){const i=(0,E.$D5b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(c){c.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${c}).`)}}resolveLocalWorkspace(c){return this.r(c,r=>l.Promises.readFile(r,"utf8"))}r(c,r){if(this.s(c)&&c.scheme===D.Schemas.file)try{const i=r(c.fsPath);return i instanceof Promise?i.then(n=>this.t(c,n),n=>{}):this.t(c,i)}catch{return}}s(c){return(0,o.$2h)(c,this.g)||(0,o.$7h)(c)}t(c,r){try{const i=this.u(c,r),n=(0,E.$D5b)(c);return{id:n.id,configPath:n.configPath,folders:(0,$.$jU)(i.folders,n.configPath,h.$_f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(c,r){const i=(0,s.$Lm)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,$.$hU)(n));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(c,r){const{workspace:i,storedWorkspace:n}=this.w(c,r),a=i.configPath.fsPath;return await l.Promises.mkdir((0,S.$_d)(a),{recursive:!0}),await l.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(c=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,h.$ig)(this.c,i),a=(0,h.$ig)(n,o.$1h),k=[];for(const I of c)k.push((0,$.$iU)(I.uri,!0,I.name,n,h.$_f));return{workspace:(0,E.$D5b)(a),storedWorkspace:{folders:k,remoteAuthority:r}}}async getWorkspaceIdentifier(c){return(0,E.$D5b)(c)}isUntitledWorkspace(c){return(0,o.$2h)(c.configPath,this.g)}async deleteUntitledWorkspace(c){this.isUntitledWorkspace(c)&&(await this.y(c),this.j.isEnabled()&&this.j.unsetWorkspace(c),this.a.fire(c))}async y(c){const r=(0,h.$9f)(c.configPath);try{await l.Promises.rm((0,S.$_d)(r));const i=(0,S.$9d)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,c.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,S.$9d)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==c.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(c,r,i){if(!c||!c.win||!c.isReady||!await this.z(c,r,i))return;const a=await this.C(c,(0,E.$D5b)(i));if(a)return this.b.fire({window:c,workspace:a.workspace}),a}async z(c,r,i){return i?(0,o.$Qh)(c.openedWorkspace)&&h.$_f.isEqual(c.openedWorkspace.configPath,i)?!1:(0,g.$L5b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,h.$fg)(i)),detail:(0,m.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(c,r){if(!c.config)return;c.focus();let i;return c.config.extensionDevelopmentPath||(c.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:c.remoteAuthority},c.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:c.remoteAuthority})),(0,o.$Qh)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&await this.deleteUntitledWorkspace(c.openedWorkspace),c.config.workspace=r,c.config.backupPath=i,{workspace:r,backupPath:i}}};e.$O5b=u,e.$O5b=u=ke([_(0,f.$i5b),_(1,w.$5i),_(2,d.$q5b),_(3,b.$B5b),_(4,p.$I5b)],u)}),define(te[132],ie([0,1,15,38,22,6,30,29,54,12,5,62]),function(J,e,P,O,s,M,D,S,h,l,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=e.$S5b=e.ID=void 0,e.ID="diagnosticsMainService",e.$S5b=(0,M.$Bh)(e.ID);let p=class{constructor(y,w,d){this.a=y,this.b=w,this.c=d}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async g=>{const o=g.remoteAuthority;if(!o)return;const $=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(u=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:$,args:E}),O.$SS.once($,(t,c)=>{c||u({hostName:o,errorMessage:`Unable to resolve connection to '${o}'.`}),u(c)}),setTimeout(()=>{u({hostName:o,errorMessage:`Connection to '${o}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const d of P.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(d.id);g?y.push(await this.d(g)):y.push(this.e(d))}const w=[];for(const{pid:d,name:g}of b.$P5b.getAll())w.push({pid:d,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),d=(0,l.$uf)(y.win);return this.e(d,w,y.remoteAuthority)}e(y,w=[],d){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:d}}async f(y){const w=[],d=y.openedWorkspace;if((0,S.$Lh)(d))w.push(d.uri);else if((0,S.$Qh)(d)){const g=await this.b.resolveLocalWorkspace(d.configPath);g&&g.folders.forEach($=>{w.push($.uri)})}return w}};e.$T5b=p,e.$T5b=p=ke([_(0,D.$w5b),_(1,h.$N5b),_(2,m.$5i)],p)}),define(te[67],ie([0,1,47,15,27,156,55,3,2,13,9,4,7,105,86,21,103,181,61,28,6,20,5,24,79,30,29,54,17,242,234]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n,a,k,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=void 0,e.$95b=(0,E.$Bh)("nativeHostMainService");let v=class extends h.$kc{constructor(L,U,B,re,ee,ae,se,oe){super(),this.a=L,this.b=U,this.c=B,this.f=re,this.g=ee,this.h=ae,this.j=se,this.m=oe,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:G,x:K,y:q})=>({windowId:G.id,x:K,y:q})),({windowId:G})=>!!this.a.getWindowById(G)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-maximize",(G,K)=>K.id),G=>!!this.a.getWindowById(G)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-unmaximize",(G,K)=>K.id),G=>!!this.a.getWindowById(G)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(G,K)=>K.id),G=>!!this.a.getWindowById(G)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),G=>!!G),G=>G.id),S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(G,K)=>K.id),G=>!!this.a.getWindowById(G))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(O.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new S.$fd),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(O.screen,"display-metrics-changed",(G,K,q)=>q),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),S.Event.fromNodeEventEmitter(O.screen,"display-added"),S.Event.fromNodeEventEmitter(O.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$Ph)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const U=O.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(L,U,B){return Array.isArray(U)?this.r(L,U,B):this.s(L,U)}async r(L,U,B=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:U,cli:this.f.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async s(L,U){await this.a.openEmptyWindow({context:5,contextWindowId:L},U)}async toggleFullScreen(L){this.C(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.C(L)?.handleTitleDoubleClick()}async isMaximized(L){const U=this.C(L);return U?.win?U.win.isMaximized():!1}async maximizeWindow(L){const U=this.C(L);U?.win&&U.win.maximize()}async unmaximizeWindow(L){const U=this.C(L);U?.win&&U.win.unmaximize()}async minimizeWindow(L){const U=this.C(L);U?.win&&U.win.minimize()}async updateWindowControls(L,U){const B=this.C(L);B&&B.updateWindowControls(U)}async focusWindow(L,U){U&&typeof U.windowId=="number"&&(L=U.windowId),this.C(L)?.focus({force:U?.force??!1})}async setMinimumSize(L,U,B){const re=this.C(L);if(re?.win){const[ee,ae]=re.win.getSize(),[se,oe]=re.win.getMinimumSize(),[G,K]=[U??se,B??oe],[q,F]=[Math.max(ee,G),Math.max(ae,K)];(se!==G||oe!==K)&&re.win.setMinimumSize(G,K),(ee!==q||ae!==F)&&re.win.setSize(q,F)}}async saveWindowSplash(L,U){this.j.saveWindowSplash(L,U)}async installShellCommand(L){const{source:U,target:B}=await this.t();try{const{symbolicLink:re}=await w.SymlinkSupport.stat(U);if(re&&!re.dangling){const ee=await(0,f.$Wp)(U);if(B===ee)return}await w.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await w.Promises.symlink(B,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ee}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ee===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ae)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(L){const{source:U}=await this.t();try{await w.Promises.unlink(U)}catch(B){switch(B.code){case"EACCES":{const{response:re}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(re===0)try{const ee=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ee)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw B}}}async t(){const L=(0,m.$0d)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await w.Promises.exists(L))throw new Error((0,g.localize)(8,null,L));return{source:U,target:L}}async showMessageBox(L,U){return this.b.showMessageBox(U,this.u(L))}async showSaveDialog(L,U){return this.b.showSaveDialog(U,this.u(L))}async showOpenDialog(L,U){return this.b.showOpenDialog(U,this.u(L))}u(L){const U=this.C(L);if(U?.win)return U.win}async pickFileFolderAndOpen(L,U){const B=await this.b.pickFileFolder(U);B&&await this.w(await Promise.all(B.map(async re=>await w.SymlinkSupport.existsDirectory(re)?{folderUri:p.URI.file(re)}:{fileUri:p.URI.file(re)})),U,L)}async pickFolderAndOpen(L,U){const B=await this.b.pickFolder(U);B&&await this.w(B.map(re=>({folderUri:p.URI.file(re)})),U,L)}async pickFileAndOpen(L,U){const B=await this.b.pickFile(U);B&&await this.w(B.map(re=>({fileUri:p.URI.file(re)})),U,L)}async pickWorkspaceAndOpen(L,U){const B=await this.b.pickWorkspace(U);B&&await this.w(B.map(re=>({workspaceUri:p.URI.file(re)})),U,L)}async w(L,U,B){await this.a.open({context:3,contextWindowId:B,cli:this.f.args,urisToOpen:L,forceNewWindow:U.forceNewWindow})}async showItemInFolder(L,U){O.shell.showItemInFolder(U)}async setRepresentedFilename(L,U){this.C(L)?.setRepresentedFilename(U)}async setDocumentEdited(L,U){this.C(L)?.setDocumentEdited(U)}async openExternal(L,U){return this.f.unsetSnapExportedVariables(),O.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,U){return O.shell.trashItem(U)}async isAdmin(){let L;return b.$i?L=(await new Promise((U,B)=>{J(["native-is-elevated"],U,B)}))():L=process.getuid?.()===0,L}async writeElevated(L,U,B,re){const ee=await new Promise((ae,se)=>{J(["@vscode/sudo-prompt"],ae,se)});return new Promise((ae,se)=>{const oe=[`"${this.z}"`];re?.unlock&&oe.push("--file-chmod"),oe.push("--file-write",`"${U.fsPath}"`,`"${B.fsPath}"`);const G={name:this.h.nameLong.replace("-",""),icns:b.$j&&this.f.isBuilt?(0,m.$9d)((0,m.$_d)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ee.exec(oe.join(" "),G,(K,q,F)=>{q&&this.g.trace(`[sudo-prompt] received stdout: ${q}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),K?se(K):ae(void 0)})})}async isRunningUnderARM64Translation(){return b.$k||b.$i?!1:O.app.runningUnderARM64Translation}get z(){return b.$i?this.f.isBuilt?(0,m.$9d)((0,m.$_d)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.bat"):b.$k?this.f.isBuilt?(0,m.$9d)((0,m.$_d)(process.execPath),"bin",`${this.h.applicationName}`):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,m.$9d)(this.f.appRoot,"bin","code"):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Hm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.$i&&(0,I.$75b)()}async killProcess(L,U,B){process.kill(U,B)}async readClipboardText(L,U){return O.clipboard.readText(U)}async writeClipboardText(L,U,B){return O.clipboard.writeText(U,B)}async readClipboardFindText(L){return O.clipboard.readFindText()}async writeClipboardFindText(L,U){return O.clipboard.writeFindText(U)}async writeClipboardBuffer(L,U,B,re){return O.clipboard.writeBuffer(U,Buffer.from(B.buffer),re)}async readClipboardBuffer(L,U){return k.$Fd.wrap(O.clipboard.readBuffer(U))}async hasClipboard(L,U,B){return O.clipboard.has(U,B)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){O.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){O.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){O.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){O.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){O.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,U){this.C(L)?.updateTouchBar(U)}async notifyReady(L){this.C(L)?.setReady()}async relaunch(L,U){return this.c.relaunch(U)}async reload(L,U){const B=this.C(L);if(B){if((0,n.$Qh)(B.openedWorkspace)){const re=B.openedWorkspace.configPath;if(re.scheme===l.Schemas.file&&(await this.m.resolveLocalWorkspace(re))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.c.reload(B,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,U){const B=this.C(U);if(B?.win)return B.win.close()}async quit(L){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(L,U){await this.c.kill(U)}async resolveProxy(L,U){return this.C(L)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(L,U,B,re,ee=1){return(0,d.$6f)(U,B,re,ee)}async openDevTools(L,U){const B=this.C(L);B?.win&&B.win.webContents.openDevTools(U)}async toggleDevTools(L){const U=this.C(L);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(L,U){const B=this.C(L);B?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&B.win.webContents.sendInputEvent(U)}async profileRenderer(L,U,B){const re=this.C(L);if(!re||!re.win)throw new Error;return await new A.$85b(re.win,U,this.g).inspect(B)}async windowsGetStringRegKey(L,U,B,re){if(!b.$i)return;const ee=await new Promise((ae,se)=>{J(["@vscode/windows-registry"],ae,se)});try{return ee.GetStringRegKey(U,B,re)}catch{return}}C(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$05b=v,ke([D.$6g],v.prototype,"z",null),e.$05b=v=ke([_(0,i.$w5b),_(1,o.$I5b),_(2,u.$k5b),_(3,$.$i5b),_(4,t.$5i),_(5,c.$kj),_(6,r.$55b),_(7,a.$N5b)],v)}),define(te[298],ie([0,1,15,38,27,2,13,4,107,179,90,132,61,28,5,67,77,24,78,80,32,34,62,22,7,30,8]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=void 0;const k="issue.processExplorerWindowState";let I=class{static{a=this}static{this.a="#1E1E1E"}constructor(C,L,U,B,re,ee,ae,se,oe,G,K){this.g=C,this.h=L,this.i=U,this.j=B,this.k=re,this.l=ee,this.m=ae,this.n=se,this.o=oe,this.p=G,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){O.$SS.on("vscode:listProcesses",async C=>{const L=[];try{L.push({name:(0,l.localize)(0,null),rootProcess:await(0,h.$sr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(B=>{(0,m.$hm)(B)?L.push({name:B.hostName,rootProcess:B}):B.processes&&L.push({name:B.hostName,rootProcess:B.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(C,"vscode:listProcessesResponse",L)}),O.$SS.on("vscode:workbenchCommand",(C,L)=>{const{id:U,from:B,args:re}=L;let ee;switch(B){case"processExplorer":ee=this.f;break;default:throw new Error(`Unexpected command source: ${B}`)}ee?.webContents.send("vscode:runAction",{id:U,from:B,args:re})}),O.$SS.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),O.$SS.on("vscode:pidToNameRequest",async C=>{const L=await this.k.getMainDiagnostics(),U=[];for(const B of L.windows)U.push([B.pid,`window [${B.id}] (${B.title})`]);for(const{pid:B,name:re}of t.$P5b.getAll())U.push([B,re]);this.t(C,"vscode:pidToNameResponse",U)})}async openReporter(C){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$jc,U=L.add(this.n.createIPCObjectUrl()),B=this.v(this.c,700,800);this.b=this.u(B,U,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:d.default}),this.b.loadURL(D.$2f.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$jc,U=L.add(this.n.createIPCObjectUrl()),B=this.p.getItem(k,void 0),re=A(B)?B:this.v(this.f,800,500);this.d=this.u(re,U,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:d.default}),this.d.loadURL(D.$2f.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const ee=()=>{if(!this.d)return;const ae=this.d.getSize(),se=this.d.getPosition();if(!ae||!se)return;const oe={width:ae[0],height:ae[1],x:se[0],y:se[1]};this.p.setItem(k,oe)};this.d.on("moved",ee),this.d.on("resized",ee)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await P.contentTracing.stopRecording(`${(0,E.$Qf)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,C),buttons:[(0,l.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,L)}async $getSystemInfo(){const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,L)}async $getPerformanceInfo(){try{const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,L)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return C===0}return!1}async $getIssueReporterUri(C){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return n.Promises.withAsyncBody(async(B,re)=>{const ee=new c.$pd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",ee.token,{replyChannel:U,extensionId:C}),O.$SS.once(U,(ae,se)=>{B(r.URI.parse(se))});try{await(0,n.$Hg)(5e3),ee.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{O.$SS.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,L,...U){C.sender.isDestroyed()||C.sender.send(L,...U)}u(C,L,U,B){const re=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:U.title,backgroundColor:U.backgroundColor||a.a,webPreferences:{preload:D.$2f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,$.$WD)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(C,L,U){let B;const re=P.screen.getAllDisplays();if(re.length===1)B=re[0];else{if(S.$j){const se=P.screen.getCursorScreenPoint();B=P.screen.getDisplayNearestPoint(se)}!B&&C&&(B=P.screen.getDisplayMatching(C.getBounds())),B||(B=P.screen.getPrimaryDisplay()||re[0])}const ee=B.bounds,ae={width:L,height:U,x:ee.x+ee.width/2-L/2,y:ee.y+ee.height/2-U/2};return ee.width>0&&ee.height>0&&(ae.x<ee.x&&(ae.x=ee.x),ae.y<ee.y&&(ae.y=ee.y),ae.x>ee.x+ee.width&&(ae.x=ee.x),ae.y>ee.y+ee.height&&(ae.y=ee.y),ae.width>ee.width&&(ae.width=ee.width),ae.height>ee.height&&(ae.height=ee.height)),ae}};e.$_5b=I,e.$_5b=I=a=ke([_(1,f.$i5b),_(2,y.$5i),_(3,m.$gm),_(4,b.$S5b),_(5,p.$I5b),_(6,w.$95b),_(7,o.$$5b),_(8,g.$kj),_(9,u.$eN),_(10,i.$w5b)],I);function A(v){return typeof v!="object"||v===null?!1:"x"in v&&"y"in v&&"width"in v&&"height"in v}}),define(te[299],ie([0,1,22,18,28,20,5,67,24,51,25,48,100]),function(J,e,P,O,s,M,D,S,h,l,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=void 0;let f=class extends p.$A6b{constructor(w,d,g,o,$,E,u,t){super(w,d,o,$,E,t),this.e=g,this.u=u}s(w){return(0,p.$z6b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(b.$RT.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(l.$Oo).then(d=>{!d||!d.url||!d.version||!d.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(b.$RT.Idle(1))):this.d(b.$RT.AvailableForDownload(d))}).then(void 0,d=>{this.j.error(d),this.e.publicLog2("update:notAvailable",{explicit:!!w});const g=w?d.message||d:void 0;this.d(b.$RT.Idle(1,g))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(b.$RT.Idle(1))}};e.$C6b=f,e.$C6b=f=ke([_(0,M.$k5b),_(1,O.$8h),_(2,m.$9k),_(3,s.$i5b),_(4,l.$Io),_(5,D.$5i),_(6,S.$95b),_(7,h.$kj)],f)}),define(te[300],ie([0,1,47,45,27,8,22,55,9,7,143,21,18,28,16,20,5,67,24,51,25,48,100]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0;async function c(a,k=1e3){for(;!a();)await(0,M.$Hg)(k)}let r;function i(){return typeof r>"u"&&(r=O.existsSync(h.$9d(h.$_d(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$A6b{get cachePath(){const k=h.$9d((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(k,{recursive:!0}).then(()=>k)}constructor(k,I,A,v,C,L,U,B,re){super(k,I,v,C,L,re),this.u=A,this.v=U,this.w=B,k.setRelaunchHandler(this)}handleRelaunch(k){return k?.addArgs||k?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$RT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(k){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.$z6b)(I,k,this.k)}t(k){this.a&&(this.d(u.$RT.CheckingForUpdates(k)),this.i.request({url:this.a},D.CancellationToken.None).then($.$Oo).then(I=>{const A=i();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!k}),this.d(u.$RT.Idle(A)),Promise.resolve(null)):A===1?(this.d(u.$RT.AvailableForDownload(I)),Promise.resolve(null)):(this.d(u.$RT.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(v=>b.Promises.exists(v).then(C=>{if(C)return Promise.resolve(v);const L=I.url,U=I.hash,B=`${v}.tmp`;return this.i.request({url:L},D.CancellationToken.None).then(re=>this.v.writeFile(l.URI.file(B),re.stream)).then(U?()=>(0,m.$NS)(B,I.hash):()=>{}).then(()=>b.Promises.rename(B,v,!1)).then(()=>v)})).then(v=>{const C=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:v},C?this.k.target==="user"?this.p():this.d(u.$RT.Downloaded(I)):this.d(u.$RT.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!k});const A=k?I.message||I:void 0;this.d(u.$RT.Idle(i(),A))}))}async o(k){k.update.url&&this.w.openExternal(void 0,k.update.url),this.d(u.$RT.Idle(i()))}async B(k){const I=await this.cachePath;return h.$9d(I,`CodeSetup-${this.k.quality}-${k}.exe`)}async C(k=null){const I=k?L=>!new RegExp(`${this.k.quality}-${k}\\.exe$`).test(L):()=>!0,A=await this.cachePath,C=(await b.Promises.readdir(A)).filter(I).map(async L=>{try{await b.Promises.unlink(h.$9d(A,L))}catch{}});await Promise.all(C)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const k=this.state.update;this.d(u.$RT.Updating(k));const I=await this.cachePath;this.e.updateFilePath=h.$9d(I,`CodeSetup-${this.k.quality}-${k.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$RT.Idle(i()))});const v=`${this.k.win32MutexName}-ready`,C=await new Promise((L,U)=>{J(["@vscode/windows-mutex"],L,U)});c(()=>C.isActive(v)).then(()=>this.d(u.$RT.Ready(k)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?O.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(k){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),A={version:"unknown",productVersion:"unknown"};this.d(u.$RT.Downloading(A)),this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(u.$RT.Downloaded(A)):this.d(u.$RT.Ready(A))}};e.$E6b=n,ke([S.$6g],n.prototype,"cachePath",null),e.$E6b=n=ke([_(0,w.$k5b),_(1,p.$8h),_(2,E.$9k),_(3,f.$i5b),_(4,$.$Io),_(5,d.$5i),_(6,y.$6j),_(7,g.$95b),_(8,o.$kj)],n)}),define(te[301],ie([0,1,15,8,22,50,3,2,13,9,65,4,7,189,64,18,61,28,63,16,20,5,24,78,251,82,25,102,79,80,30,29,54,128,135,39,34,53,66,23]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n,a,k,I,A,v,C,L,U,B,re,ee,ae,se){"use strict";var oe;Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=void 0;var G;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(G||(G={}));let K=class extends S.$kc{static{oe=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const F=this.R.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.R.getProfileForWorkspace(this.config.workspace??(0,v.$Ph)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(F,N,V,X,x,ce,Y,R,j,W,T,H,z,ne,fe,ge,ue,we,me,Se){super(),this.N=N,this.O=V,this.P=X,this.Q=x,this.R=ce,this.S=Y,this.U=R,this.W=j,this.X=W,this.Y=T,this.Z=H,this.$=z,this.ab=ne,this.bb=fe,this.db=ge,this.eb=ue,this.fb=we,this.gb=me,this.hb=Se,this.b=this.B(new D.$fd),this.onWillLoad=this.b.event,this.c=this.B(new D.$fd),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$fd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$fd),this.onDidClose=this.g.event,this.h=this.B(new D.$fd),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Ie,je]=this.sb(F.state);this.s=Ie,this.N.trace("window#ctor: using window state",Ie);const ve=this.s.mode===0||this.s.mode===3,be=this.X.getValue("window"),Q={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.Y.getBackgroundColor(),minWidth:I.$PD.WIDTH,minHeight:I.$PD.HEIGHT,show:!ve,title:this.eb.nameLong,webPreferences:{preload:h.$2f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.$WD)(be?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};b.$k?Q.icon=(0,l.$9d)(this.P.appRoot,"resources/linux/code.png"):b.$i&&!this.P.isBuilt&&(Q.icon=(0,l.$9d)(this.P.appRoot,"resources/win32/code_150x150.png")),b.$j&&!this.zb()&&(Q.fullscreenable=!1),b.$j&&(Q.acceptFirstMouse=!0,be?.clickThroughInactive===!1&&(Q.acceptFirstMouse=!1));const le=b.$j&&be?.nativeTabs===!0;le&&(Q.tabbingIdentifier=this.eb.nameShort);const de=(0,I.$UD)(this.X)==="custom";if(de&&(Q.titleBarStyle="hidden",b.$j||(Q.frame=!1),(0,I.$VD)(this.X))){const Ee=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Re=U.$Os.fromHex(Ee).isDarker()?"#FFFFFF":"#000000";Q.titleBarOverlay={height:29,color:Ee,symbolColor:Re},this.D=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(Q),(0,m.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,b.$j&&de&&this.m.setSheetOffset(22),de&&(b.$i&&(0,I.$VD)(this.X)||b.$j)){const Ee=this.hb.getItem(oe.a);Ee&&this.updateWindowControls({height:Ee})}b.$i&&de&&this.m.hookWindowMessage(278,()=>{const[Re,Ue]=this.m.getPosition(),Oe=P.screen.getCursorScreenPoint(),ze=Oe.x-Re,We=Oe.y-Ue;return(()=>!(ze>30&&We>=0&&We<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:ze,y:We})),0}),(b.$j||b.$i)&&je&&(!le||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ee=>typeof Ee=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),ve&&((0,m.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(F){b.$j?this.m.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return b.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(F){b.$j&&this.m.setDocumentEdited(F),this.C=F}isDocumentEdited(){return b.$j?this.m.isDocumentEdited():!!this.C}focus(F){b.$j&&F?.force&&P.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.F.push(F)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){V.dispose(),X.dispose(),F()}const V=this.onDidClose(()=>N()),X=this.onWillLoad(()=>N())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(N,V)=>this.mb(2,{...V})),this.m.webContents.on("did-fail-load",(N,V,X)=>this.mb(3,{reason:X,exitCode:V})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",N=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",N,this.m)}),this.m.on("unmaximize",N=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",N,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(N=>this.pb(N))),this.B(this.Z.onDidDeleteUntitledWorkspace(N=>this.ob(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,V)=>{const X=await this.lb();V({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,X)})})}lb(){return this.kb||(this.kb=(0,r.$3o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(F,N){switch(F){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:X}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.m);if(V!==2){const x=V===0;await this.nb(x,X)}}else if(F===2){let V;N?V=(0,f.localize)(7,null,N.reason,N.exitCode??"<unknown>"):V=(0,f.localize)(6,null);const{response:X,checkboxChecked:x}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:V,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.m),ce=X===0;await this.nb(ce,x)}break}}async nb(F,N){const V=this.r?.workspace;if(N&&V)try{const X=this.W.workspaceStorage(V);await X.init(),X.delete("memento/workbench.parts.editor"),await X.close()}catch(X){this.N.error(X)}if(this.h.fire(),this.m?.destroy(),F&&this.r){let X,x;(0,v.$Lh)(V)?X={folderUri:V.uri}:(0,v.$Qh)(V)?X={workspaceUri:V.configPath}:x=!0,(0,se.$Mb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(F){this.r?.workspace?.id===F.id&&(this.r.workspace=void 0)}pb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.Ab();N!==this.t&&(this.t=N,this.Bb(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.H||V!==this.I)){this.H=N,this.I=V;const X=N||"",x=V?`${V},<local>`:"<local>";this.N.trace(`Setting proxy to '${X}', bypassing '${x}'`),this.m.webContents.session.setProxy({proxyRules:X,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(F){b.$j&&F.win&&this.m.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!N.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(F,N),this.ib===0?this.r=F:this.L=F,this.ib=1,this.m.loadURL(h.$2f.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new O.$Sg(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:N.isReload?3:V?2:1})}qb(F,N){const V=(this.r??this.L)?.userEnv;if(V){const X=(0,o.$Gl)(V)&&!(0,o.$Gl)(F.userEnv),x=this.isExtensionDevelopmentHost;(X||x)&&(F.userEnv={...V,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.Y.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),F.perfMarks=(0,m.getMarks)(),this.J.update(F)}async reload(F){const N=Object.assign({},this.r);N.workspace=await this.rb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.Q.serialize(),N.continueOn=this.P.continueOn,N.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},N.logLevel=this.O.getLogLevel(),N.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async rb(F){if((0,v.$Qh)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===h.Schemas.file&&!await this.S.exists(N))return}else if((0,v.$Lh)(F.workspace)){const N=F.workspace.uri;if(N.scheme===h.Schemas.file&&!await this.S.exists(N))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,L.$h5b)();if(this.isFullScreen){let V;try{V=P.screen.getDisplayMatching(this.getBounds())}catch{}const X=(0,L.$h5b)();return{mode:3,display:V?V.id:void 0,width:this.s.width||X.width,height:this.s.height||X.height,x:this.s.x||0,y:this.s.y||0}}const F=Object.create(null);let N;if(!b.$j&&this.m.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let V;N===1?V=this.getBounds():V=this.m.getNormalBounds(),F.x=V.x,F.y=V.y,F.width=V.width,F.height=V.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(oe.a,F.height),b.$i&&this.D)this.m.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(b.$j&&F.height!==void 0){const N=(F.height-15)/2;N?this.m.setWindowButtonPosition({x:N,y:N}):this.m.setWindowButtonPosition(null)}}sb(F){(0,m.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const V=P.screen.getAllDisplays();N=V.length>1,F=this.tb(F,V)}catch(V){this.N.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[F||(0,L.$h5b)(),N]}tb(F,N){if(this.N.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const x=this.ub(N[0]);if(x){let ce=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!x||(F.x<x.x&&(F.x=x.x),F.y<x.y&&(F.y=x.y))};this.N.trace("window#validateWindowState: 1 monitor working area",x),ce(),F.width>x.width&&(F.width=x.width),F.height>x.height&&(F.height=x.height),F.x>x.x+x.width-128&&(F.x=x.x+x.width-F.width),F.y>x.y+x.height-128&&(F.y=x.y+x.height-F.height),ce()}return F}if(F.display&&F.mode===3){const x=N.find(ce=>ce.id===F.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,L.$h5b)(3);return ce.x=x.bounds.x,ce.y=x.bounds.y,ce}}let V,X;try{V=P.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),X=this.ub(V)}catch{}if(V&&X&&F.x+F.width>X.x&&F.y+F.height>X.y&&F.x<X.x+X.width&&F.y<X.y+X.height)return this.N.trace("window#validateWindowState: multi-monitor working area",X),F}ub(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this.m.getPosition(),[V,X]=this.m.getSize();return{x:F,y:N,width:V,height:X}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(F){this.zb()?this.wb(F):this.yb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return b.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(F){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(F)}xb(F){b.$j&&(this.u=F,this.w=new O.$2g,Promise.race([this.w.p,(0,O.$Hg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(F)}yb(F){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(F),this.m.webContents.focus()}zb(){const F=this.X.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let F=(0,I.$TD)(this.X);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Bb(F,N=!0){b.$j||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,f.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.Cb(F)}):this.Cb(F))}Cb(F){const N=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(F,N,...V){this.isReady?this.send(F,...V):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...V)})}send(F,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...N)}catch(V){this.N.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,M.$mi)(V)}`)}}}updateTouchBar(F){b.$j&&this.G.forEach((N,V)=>{const X=F[V];N.segments=this.Fb(X)})}Db(){if(b.$j){for(let F=0;F<10;F++){const N=this.Eb();this.G.push(N)}this.m.setTouchBar(new P.TouchBar({items:this.G}))}}Eb(F=[]){const N=this.Fb(F),V=new P.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:X=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:V.segments[X].id,from:"touchbar"})}});return V}Fb(F=[]){return F.map(V=>{let X;V.icon&&!a.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===h.Schemas.file&&(X=P.nativeImage.createFromPath(p.URI.revive(V.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let x;return typeof V.title=="string"?x=V.title:x=V.title.value,{id:V.id,label:X?void 0:x,icon:X}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$M6b=K,e.$M6b=K=oe=ke([_(1,u.$5i),_(2,ae.$o6b),_(3,g.$i5b),_(4,B.$0m),_(5,ee.$q5b),_(6,$.$6j),_(7,i.$u5b),_(8,i.$s5b),_(9,w.$8h),_(10,k.$55b),_(11,C.$N5b),_(12,y.$B5b),_(13,n.$9k),_(14,d.$I5b),_(15,E.$k5b),_(16,t.$kj),_(17,c.$$5b),_(18,A.$w5b),_(19,re.$eN)],K)}),define(te[83],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,192,6,20,5,82,97,29,54,33]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=e.$j6b=void 0,e.$j6b=(0,y.$Bh)("workspacesHistoryMainService");let c=class extends S.$kc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,a,k){super(),this.f=i,this.g=n,this.h=a,this.j=k,this.c=this.B(new M.$fd),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Eg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],a=[];for(const I of i)if((0,o.$eU)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.u(n,I.workspace)&&n.push(I);else if((0,o.$fU)(I))this.w(n,I.folderUri)||n.push(I);else{const A=this.y(a,I.fileUri),v=I.fileUri.scheme===h.Schemas.file&&t.F.indexOf((0,m.$fg)(I.fileUri))>=0;!A&&!v&&(a.push(I),l.$i&&I.fileUri.scheme===h.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const k=await this.n({workspaces:n,files:a});n=k.workspaces,a=k.files,n.length>t.a&&(n.length=t.a),a.length>t.a&&(a.length=t.a),await this.s({workspaces:n,files:a}),this.c.fire(),l.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=A=>{const v=this.t(A);for(const C of i)if(m.$_f.isEqual(C,v))return!1;return!0},a=await this.getRecentlyOpened(),k=a.workspaces.filter(n),I=a.files.filter(n);(k.length!==a.workspaces.length||I.length!==a.files.length)&&(await this.s({files:I,workspaces:k}),this.c.fire(),l.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new u.$zi(I=>m.$_f.getComparisonKey(I));if(i?.workspaces)for(const I of i.workspaces)n.set(this.t(I),I);const a=new u.$zi(I=>m.$_f.getComparisonKey(I));if(i?.files)for(const I of i.files)a.set(this.t(I),I);const k=await this.r();for(const I of k.workspaces){const A=n.get(this.t(I));A?A.label=A.label??I.label:n.set(this.t(I),I)}for(const I of k.files){const A=a.get(this.t(I));A?A.label=A.label??I.label:a.set(this.t(I),I)}return{workspaces:[...n.values()],files:[...a.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,o.$lU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,o.$mU)(i)),-1,1)}t(i){return(0,o.$fU)(i)?i.folderUri:(0,o.$gU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(a=>(0,o.$eU)(a)&&a.workspace.id===n.id)}w(i,n){return!!i.find(a=>(0,o.$fU)(a)&&m.$_f.isEqual(a.folderUri,n))}y(i,n){return!!i.find(a=>m.$_f.isEqual(a.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){l.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!l.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const I of P.app.getJumpListSettings().removedItems){const A=I.args;if(A){const v=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);v&&n.push(b.URI.parse(v[2]))}}await this.removeRecentlyOpened(n);let a=!1;const k=(0,O.$Fb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(I=>{const A=(0,o.$eU)(I)?I.workspace:I.folderUri,{title:v,description:C}=this.J(A,I.label);let L;return b.URI.isUri(A)?L=`--folder-uri "${A.toString()}"`:(a=!0,L=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:v.substr(0,255),description:C.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&i.push({type:"custom",name:a?(0,f.localize)(2,null):(0,f.localize)(3,null),items:k})}i.push({type:"recent"});try{const n=P.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,D.$nA)(n).name,description:n};if(b.URI.isUri(i))return{title:(0,m.$fg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let a=(0,m.$fg)(i.configPath);return a.endsWith($.$Xh)&&(a=a.substr(0,a.length-$.$Xh.length-1)),{title:(0,f.localize)(5,null,a),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,D.$fA)(i.fsPath):i.toString()}async M(){if(!l.$j)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let a=0;for(let I=0;I<i.workspaces.length&&a<t.z;I++){const A=this.t(i.workspaces[I]);if(A.scheme===h.Schemas.file){const v=(0,m.$9f)(A);await p.Promises.exists(v)&&(n.push(v),a++)}}const k=[];for(let I=0;I<i.files.length&&a<t.C;I++){const A=this.t(i.files[I]);if(A.scheme===h.Schemas.file){const v=(0,m.$9f)(A);if(t.F.includes((0,m.$fg)(A))||n.includes(v))continue;await p.Promises.exists(v)&&(k.push(v),a++)}}k.reverse().forEach(I=>P.app.addRecentDocument(I)),n.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$k6b=c,e.$k6b=c=t=ke([_(0,d.$5i),_(1,E.$N5b),_(2,w.$k5b),_(3,g.$u5b)],c)}),define(te[302],ie([0,1,15,8,22,46,4,7,180,18,28,20,5,229,67,24,34,25,48,80,30,83]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;const c="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(a,k,I,A,v,C,L,U,B,re,ee){this.n=a,this.o=k,this.p=I,this.q=A,this.r=v,this.s=C,this.t=L,this.u=U,this.v=B,this.w=re,this.x=ee,this.m=Object.create(null),this.g=new O.$Sg(()=>this.E(),0),this.h=new O.$Sg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,$.$UD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(t.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(C,L,U)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(C,L,U)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(C,L,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:c}}),this.m["workbench.action.files.openFolder"]=(C,L,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:c}}),this.m["workbench.action.openWorkspace"]=(C,L,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:c}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.youTubeUrl;a&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(a,"openYouTubeUrl"));const k=this.x.requestFeatureUrl;k&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(k,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(I,"openReportIssues"));const A=this.x.licenseUrl;A&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$v){const C=A.indexOf("?")>0?"&":"?";this.Z(`${A}${C}lang=${D.$v}`,"openLicenseUrl")}else this.Z(A,"openLicenseUrl")});const v=this.x.privacyStatementUrl;v&&A&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(v,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!D.$j)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,k){this.k=a.menus,this.l=a.keybindings,this.t.setItem(t.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){D.$j&&(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){D.$j&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=P.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(D.$j?new P.Menu:null);return}const k=new P.Menu;let I;if(D.$j){const v=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:v}),this.I(v),k.append(I)}if(D.$j&&!this.c){this.c=!0;const v=new P.Menu;v.append(new P.MenuItem({label:this.ab(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(v)}if(this.K("File")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(1,null)),submenu:v});this.M(v,"File"),k.append(C)}if(this.K("Edit")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(2,null)),submenu:v});this.M(v,"Edit"),k.append(C)}if(this.K("Selection")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(3,null)),submenu:v});this.M(v,"Selection"),k.append(C)}if(this.K("View")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(4,null)),submenu:v});this.M(v,"View"),k.append(C)}if(this.K("Go")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(5,null)),submenu:v});this.M(v,"Go"),k.append(C)}if(this.K("Run")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(6,null)),submenu:v});this.M(v,"Run"),k.append(C)}if(this.K("Terminal")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(7,null)),submenu:v});this.M(v,"Terminal"),k.append(C)}let A;if(this.K("Window")){const v=new P.Menu;A=new P.MenuItem({label:this.ab(h.localize(8,null)),submenu:v,role:"window"}),this.S(v)}if(A&&k.append(A),this.K("Help")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(9,null)),submenu:v,role:"help"});this.M(v,"Help"),k.append(C)}k.items&&k.items.length>0?P.Menu.setApplicationMenu(k):P.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const k=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.T();let A;if(this.K("Preferences")){const ae=new P.Menu;this.M(ae,"Preferences"),A=new P.MenuItem({label:this.ab(h.localize(11,null)),submenu:ae})}const v=new P.Menu,C=new P.MenuItem({label:h.localize(12,null),role:"services",submenu:v}),L=new P.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new P.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new P.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new P.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ae,se,oe)=>{const G=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.J(oe)&&this.w.quit(void 0)}})),ee=[k];ee.push(...I),A&&ee.push(i(),A),ee.push(i(),C,i(),L,U,B,i(),re),ee.forEach(ae=>a.append(ae))}async J(a){if(this.p.getWindowCount()===0)return!0;const k=this.o.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.Q(a)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return I===0}return!0}K(a){if(!D.$j&&(0,$.$UD)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,k){k.forEach(I=>{if((0,f.$g6b)(I))a.append(i());else if((0,f.$f6b)(I)){const A=new P.Menu,v=new P.MenuItem({label:this.ab(I.label),submenu:A});this.L(A,I.submenu.items),a.append(v)}else(0,f.$h6b)(I)?a.append(this.O(I)):(0,f.$i6b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.N(a),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?a.append(new P.MenuItem(this.Y(I.id,{label:this.ab(I.label),click:this.m[I.id]}))):a.append(this.U(I.label,I.id,!1,I.checked)):a.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)):a.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)))})}M(a,k){this.k&&this.k[k]&&this.L(a,this.k[k].items)}N(a){const k=this.T();k.length&&(k.forEach(I=>a.append(I)),a.append(i()))}O(a){const k=S.URI.revive(a.uri),I=a.id,A=I==="openRecentFile"?{fileUri:k}:I==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new P.MenuItem(this.Y(I,{label:a.label,click:async(v,C,L)=>{const U=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[A],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([k])}},!1))}P(a){return!!(a&&(!D.$j&&(a.ctrlKey||a.shiftKey)||D.$j&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,k,I){const A={label:this.ab(a),role:I,enabled:!0};return new P.MenuItem(this.X(k,A))}S(a){const k=new P.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),A=new P.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),v=this.U(h.localize(23,null),"workbench.action.switchWindow"),C=[];this.C&&(C.push(i()),C.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),C.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,I,i(),v,...C,i(),A].forEach(L=>a.append(L))}T(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.ab(h.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.ab(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.ab(h.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.ab(h.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(a,k,I,A){const v=this.ab(a),C=typeof k=="function"?k:(ee,ae,se)=>{const oe=ee?ee.userSettingsLabel:null;let G=k;Array.isArray(k)&&(G=this.P(se)?k[1]:k[0]),oe&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:oe}):this.W({type:"commandId",commandId:G})},L=typeof I=="boolean"?I:this.p.getWindowCount()>0,U=typeof A=="boolean"?A:!1,B={label:v,click:C,enabled:L};U&&(B.type="checkbox",B.checked=U);let re;return typeof k=="string"?re=k:Array.isArray(k)&&(re=k[0]),D.$j&&(re==="editor.action.clipboardCutAction"?B.role="cut":re==="editor.action.clipboardCopyAction"?B.role="copy":re==="editor.action.clipboardPasteAction"&&(B.role="paste"),re==="undo"?B.click=this.V(C,{inDevTools:ee=>ee.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?B.click=this.V(C,{inDevTools:ee=>ee.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(B.click=this.V(C,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(re,B))}V(a,k){return(I,A,v)=>{const C=P.BrowserWindow.getFocusedWindow();if(!C)return k.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return k.inDevTools(C.webContents.devToolsWebContents);a(I,A||C,v)}}W(a){let k=P.BrowserWindow.getFocusedWindow();if(!k){const A=this.p.getLastActiveWindow();A?.isMinimized()&&(k=A.win)}const I=k?this.p.getWindowById(k.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",a),D.$j&&!this.q.isBuilt&&!I.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const A={id:a.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:a.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,k){const I=typeof a=="string"?this.l[a]:void 0;if(I?.label){if(I.isNative!==!1)k.accelerator=I.label,k.userSettingsLabel=I.userSettingsLabel;else if(typeof k.label=="string"){const A=k.label.indexOf("[");A>=0?k.label=`${k.label.substr(0,A)} [${I.label}]`:k.label=`${k.label} [${I.label}]`}}else k.accelerator=void 0;return k}Y(a,k,I=!k.accelerator){I&&(k=this.X(a,k));const A=k.click;return k.click=(v,C,L)=>{this.$(a),A?.(v,C,L)},k}Z(a,k){this.w.openExternal(void 0,a),this.$(k)}$(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:c})}ab(a){return(0,M.$kA)(a,!this.B)}};e.$l6b=r,e.$l6b=r=t=ke([_(0,o.$ST),_(1,l.$8h),_(2,E.$w5b),_(3,m.$i5b),_(4,g.$9k),_(5,u.$j6b),_(6,d.$eN),_(7,b.$k5b),_(8,p.$5i),_(9,y.$95b),_(10,w.$kj)],r);function i(){return new P.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=e.$m6b=void 0,e.$m6b=(0,P.$Bh)("menubarMainService");let D=class{constructor(h,l,m){this.b=h,this.c=l,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$l6b)}async updateMenubar(h,l){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(l,h)}};e.$n6b=D,e.$n6b=D=ke([_(0,P.$Ah),_(1,O.$k5b),_(2,s.$5i)],D)}),define(te[304],ie([0,1,15,21,131,27,23,22,3,32,49,46,2,13,9,65,4,35,19,12,7,190,64,18,61,28,16,6,20,5,77,78,60,34,80,301,130,297,29,98,83,54,79,39,53,66]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n,a,k,I,A,v,C,L,U,B,re,ee,ae,se,oe,G,K,q,F,N){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=void 0;function X(Y){return(0,ae.$Qh)(Y?.workspace)}function x(Y){return(0,ae.$Lh)(Y?.workspace)}let ce=class extends p.$kc{static{V=this}static{this.a=[]}constructor(R,j,W,T,H,z,ne,fe,ge,ue,we,me,Se,Ie,je,ve,be,Q){super(),this.m=R,this.n=j,this.r=W,this.s=T,this.t=H,this.u=z,this.w=ne,this.z=fe,this.C=ge,this.D=ue,this.F=we,this.G=me,this.H=Se,this.I=Ie,this.J=je,this.L=ve,this.M=be,this.N=Q,this.b=this.B(new h.$fd),this.onDidOpenWindow=this.b.event,this.c=this.B(new h.$fd),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new h.$fd),this.onDidDestroyWindow=this.f.event,this.g=this.B(new h.$fd),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new h.$fd),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ee.$N6b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const j=new p.$jc;if(j.add(h.Event.any(R.onDidClose,R.onDidDestroy)(()=>j.dispose())),R.config.extensionDevelopmentPath)for(const W of R.config.extensionDevelopmentPath)j.add(this.M.addValidFileRoot(W));R.config.extensionTestsPath&&j.add(this.M.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,j){const W=this.w.args,T=j?.remoteAuthority||void 0,H=!0,z=j?.forceReuseWindow,ne=!z;return this.open({...R,cli:W,forceEmpty:H,forceNewWindow:ne,forceReuseWindow:z,remoteAuthority:T})}openExistingWindow(R,j){R.focus(),this.P(j,[R])}async open(R){this.r.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const j=[],W=[],T=[],H=[],z=[];let ne,fe=0;const ge=await this.X(R);this.r.trace("windowsManager#open pathsToOpen",ge);for(const Ie of ge)x(Ie)?R.addMode?j.push(Ie):W.push(Ie):X(Ie)?T.push(Ie):Ie.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ie.remoteAuthority}),ne.filesToOpenOrCreate.push(Ie)):Ie.backupPath?z.push({backupFolder:(0,y.$ae)(Ie.backupPath),remoteAuthority:Ie.remoteAuthority}):fe++;R.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),R.mergeMode&&ne&&ne.filesToOpenOrCreate.length===4&&(ne.filesToMerge=ne.filesToOpenOrCreate.slice(0,4),ne.filesToOpenOrCreate=[],ne.filesToDiff=[]),ne&&R.waitMarkerFileURI&&(ne.filesToWait={paths:(0,D.$Fb)([...ne.filesToDiff,ne.filesToMerge[3],...ne.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(H.push(...this.H.getUntitledWorkspaces()),T.push(...H),z.push(...this.D.getEmptyWindowBackups())):z.length=0;const{windows:ue,filesOpenedInWindow:we}=await this.Q(R,T,W,z,fe,ne,j);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${W.length}, emptyToRestore: ${z.length}, emptyToOpen: ${fe})`),ue.length>1)if(we)we.focus();else{const Ie=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let je=!0,ve=!0;if(Ie){const be=ue.filter(Q=>this.j.state.lastActiveWindow&&Q.backupPath===this.j.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),je=!1,ve=!1)}if(je)for(let be=ue.length-1;be>=0;be--){const Q=ue[be];if(!(Q.openedWorkspace&&H.some(le=>Q.openedWorkspace&&le.workspace.id===Q.openedWorkspace.id)||Q.backupPath&&z.some(le=>Q.backupPath&&le.backupFolder===(0,y.$ae)(Q.backupPath)))){Q.focus(),ve=!1;break}}ve&&ue[ue.length-1].focus()}const me=ne&&ne.filesToDiff.length>0,Se=ne&&ne.filesToMerge.length>0;if(!ue.some(Ie=>Ie.isExtensionDevelopmentHost)&&!me&&!Se&&!R.noRecentEntry){const Ie=[];for(const je of ge)X(je)&&!je.transient?Ie.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):x(je)?Ie.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&Ie.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.G.addRecentlyOpened(Ie)}return this.P(R,ue),ue}P(R,j){const W=R.waitMarkerFileURI;R.context===0&&W&&j.length===1&&j[0]&&(async()=>{await j[0].whenClosedOrLoaded;try{await this.L.del(W)}catch{}})()}async Q(R,j,W,T,H,z,ne){const fe=[];let ge;function ue(be,Q){fe.push(be),Q&&(ge=be,z=void 0)}let{openFolderInNewWindow:we,openFilesInNewWindow:me}=this.ib(R);if(!R.initialStartup&&ne.length>0){const be=ne[0].remoteAuthority,Q=this.nb(be);Q&&ue(this.S(Q,ne.map(le=>le.workspace.uri)))}const Se=W.length+j.length+T.length;if(z&&Se===0){const be=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],Q=this.getWindows().filter(de=>z&&(0,o.$ng)(de.remoteAuthority,z.remoteAuthority));let le;be?.fileUri&&!me&&((R.context===4||R.context===0||R.context===1)&&(le=await(0,re.$K5b)(Q,be.fileUri,async de=>de.configPath.scheme===f.Schemas.file?this.H.resolveLocalWorkspace(de.configPath):void 0)),le||(le=this.ob(Q))),le?(0,ae.$Qh)(le.openedWorkspace)?j.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):(0,ae.$Lh)(le.openedWorkspace)?W.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):ue(this.R(R,le,z),!0):ue(await this.jb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const Ie=(0,D.$Kb)(j,be=>be.workspace.id);if(Ie.length>0){const be=(0,D.$Fb)(Ie.map(Q=>(0,re.$L5b)(this.getWindows(),Q.workspace.configPath)));if(be.length>0){const Q=be[0],le=(0,o.$ng)(z?.remoteAuthority,Q.remoteAuthority)?z:void 0;ue(this.R(R,Q,le),!!le),we=!0}for(const Q of Ie){if(be.some(Ee=>Ee.openedWorkspace&&Ee.openedWorkspace.id===Q.workspace.id))continue;const le=Q.remoteAuthority,de=(0,o.$ng)(z?.remoteAuthority,le)?z:void 0;ue(await this.W(R,Q,we,de),!!de),we=!0}}const je=(0,D.$Kb)(W,be=>o.$_f.getComparisonKey(be.workspace.uri));if(je.length>0){const be=(0,D.$Fb)(je.map(Q=>(0,re.$L5b)(this.getWindows(),Q.workspace.uri)));if(be.length>0){const Q=be[0],le=(0,o.$ng)(z?.remoteAuthority,Q.remoteAuthority)?z:void 0;ue(this.R(R,Q,le),!!le),we=!0}for(const Q of je){if(be.some(Ee=>(0,ae.$Lh)(Ee.openedWorkspace)&&o.$_f.isEqual(Ee.openedWorkspace.uri,Q.workspace.uri)))continue;const le=Q.remoteAuthority,de=(0,o.$ng)(z?.remoteAuthority,le)?z:void 0;ue(await this.W(R,Q,we,de),!!de),we=!0}}const ve=(0,D.$Kb)(T,be=>be.backupFolder);if(ve.length>0)for(const be of ve){const Q=be.remoteAuthority,le=(0,o.$ng)(z?.remoteAuthority,Q)?z:void 0;ue(await this.U(R,!0,Q,le,be),!!le),we=!0}if(fe.length===0||z){z&&!H&&H++;const be=z?z.remoteAuthority:R.remoteAuthority;for(let Q=0;Q<H;Q++)ue(await this.U(R,we,be,z),!!z),we=!0}return{windows:(0,D.$Kb)(fe),filesOpenedInWindow:ge}}R(R,j,W){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),j.focus();const T={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return j.sendWhenReady("vscode:openFiles",S.CancellationToken.None,T),j}S(R,j){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:j}),R.focus();const W={foldersToAdd:j};return R.sendWhenReady("vscode:addFolders",S.CancellationToken.None,W),R}U(R,j,W,T,H){this.r.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:W,filesToOpen:T,forceNewWindow:j});let z;return!j&&typeof R.contextWindowId=="number"&&(z=this.getWindowById(R.contextWindowId)),this.jb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:W,forceNewWindow:j,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:T,windowToUse:z,emptyWindowBackupInfo:H,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}W(R,j,W,T,H){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:j,filesToOpen:T}),!W&&!H&&typeof R.contextWindowId=="number"&&(H=this.getWindowById(R.contextWindowId)),this.jb({workspace:j.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:j.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:T,windowToUse:H,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async X(R){let j,W=!1,T=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(j=await this.Y(R),W=!0):R.forceEmpty?j=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(j=await this.Z(R.cli),j.length===0&&j.push(Object.create(null)),W=!0):(j=await this.ab(),j.length===0&&j.push(Object.create(null)),T=!0),!R.addMode&&W){const H=j.filter(z=>x(z));if(H.length>1){const z=H[0].remoteAuthority;if(H.every(ne=>(0,o.$ng)(ne.remoteAuthority,z))){const ne=await this.H.createUntitledWorkspace(H.map(fe=>({uri:fe.workspace.uri})));j.push({workspace:ne,remoteAuthority:z}),j=j.filter(fe=>!x(fe))}}}if(R.initialStartup&&!T&&this.F.getValue("window")?.restoreWindows==="preserve"){const H=await this.ab();j.unshift(...H.filter(z=>X(z)||x(z)||z.backupPath))}return j}async Y(R){const j={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},W=await Promise.all((0,D.$Fb)(R.urisToOpen||[]).map(async T=>{const H=await this.cb(T,j);if(H)return H.label=T.label,H;const z=this.eb(T);this.J.showMessageBox({type:"info",buttons:[(0,u.localize)(0,null)],message:z.scheme===f.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:z.scheme===f.Schemas.file?(0,u.localize)(3,null,(0,b.$eA)(z,{os:d.OS,tildify:this.w})):(0,u.localize)(4,null,z.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Fb)(W)}async Z(R){const j=[],W={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},T=R["folder-uri"];if(T){const ne=await Promise.all(T.map(fe=>{const ge=this.$(fe);if(ge)return this.cb({folderUri:ge},W)}));j.push(...(0,D.$Fb)(ne))}const H=R["file-uri"];if(H){const ne=await Promise.all(H.map(fe=>{const ge=this.$(fe);if(ge)return this.cb((0,ae.$7h)(fe)?{workspaceUri:ge}:{fileUri:ge},W)}));j.push(...(0,D.$Fb)(ne))}const z=await Promise.all(R._.map(ne=>W.remoteAuthority?this.hb(ne,W):this.fb(ne,W)));return j.push(...(0,D.$Fb)(z)),j}$(R){try{const j=E.URI.parse(R);if(!j.scheme){this.r.error(`Invalid URI input string, scheme missing: ${R}`);return}return j.path?j:j.with({path:"/"})}catch(j){this.r.error(`Invalid URI input string: ${R}, ${j.message}`)}}async ab(){const R=this.bb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const j=[];R!=="one"&&j.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&j.push(this.j.state.lastActiveWindow);const W=await Promise.all(j.map(async T=>{if(T.workspace){const H=await this.cb({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});if(X(H))return H}else if(T.folderUri){const H=await this.cb({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});if(x(H))return H}else if(R!=="folders"&&T.backupPath)return{backupPath:T.backupPath,remoteAuthority:T.remoteAuthority}}));return(0,D.$Fb)(W)}}}bb(){let R;return this.C.wasRestarted?R="all":(R=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async cb(R,j=Object.create(null)){const W=this.eb(R);return W.scheme===f.Schemas.file?((0,U.$SD)(R)&&(j={...j,forceOpenWorkspaceAsFile:!0}),this.fb(W.fsPath,j)):this.db(R,j)}db(R,j){let W=this.eb(R);const T=(0,C.$Ok)(W)||j.remoteAuthority;if(W=(0,o.$pg)((0,o.$jg)(W)),(0,U.$SD)(R)){if(j.gotoLineMode){const{path:H,line:z,column:ne}=(0,l.$Pf)(W.path);return{fileUri:W.with({path:H}),options:{selection:z?{startLineNumber:z,startColumn:ne||1}:void 0},remoteAuthority:T}}return{fileUri:W,remoteAuthority:T}}else if((0,U.$QD)(R))return{workspace:(0,se.$D5b)(W),remoteAuthority:T};return{workspace:(0,se.$E5b)(W),remoteAuthority:T}}eb(R){return(0,U.$QD)(R)?R.workspaceUri:(0,U.$RD)(R)?R.folderUri:R.fileUri}async fb(R,j,W){let T,H;j.gotoLineMode&&({path:R,line:T,column:H}=(0,l.$Pf)(R)),R=(0,l.$Kf)((0,y.$7d)(R),(0,g.cwd)());try{const z=await O.Promises.stat(R);if(z.isFile()){if(!j.forceOpenWorkspaceAsFile){const ne=await this.H.resolveLocalWorkspace(E.URI.file(R));if(ne)return ne.transient&&j.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:E.URI.file(R),type:n.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:H||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,se.$E5b)(E.URI.file(R),z),type:n.FileType.Directory,exists:!0};if(!d.$i&&R==="/dev/null")return{fileUri:E.URI.file(R),type:n.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!W)return this.gb(R,j);const ne=E.URI.file(R);if(this.G.removeRecentlyOpened([ne]),j.ignoreFileNotFound)return{fileUri:ne,type:n.FileType.File,exists:!1}}}async gb(R,j){const W=E.URI.file(R),{response:T,checkboxChecked:H}=await this.J.showMessageBox({type:"warning",buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null),(0,u.localize)(7,null)],message:(0,u.localize)(8,null,W.authority),detail:(0,u.localize)(9,null,(0,b.$eA)(W,{os:d.OS,tildify:this.w})),checkboxLabel:(0,u.localize)(10,null,W.authority),cancelId:1});if(T===0)return(0,s.addUNCHostToAllowlist)(W.authority),H&&this.B(h.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,W.authority)})),this.fb(R,j,!0);if(T===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(R,j)}hb(R,j){const W=R.charCodeAt(0),T=j.remoteAuthority;let H,z;j.gotoLineMode&&({path:R,line:H,column:z}=(0,l.$Pf)(R)),W!==47&&((0,l.$Jf)(W)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,l.$Cf)(R)),R=`/${R}`);const ne=E.URI.from({scheme:f.Schemas.vscodeRemote,authority:T,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,ae.$7h)(R))return j.forceOpenWorkspaceAsFile?{fileUri:ne,options:{selection:H?{startLineNumber:H,startColumn:z||1}:void 0},remoteAuthority:j.remoteAuthority}:{workspace:(0,se.$D5b)(ne),remoteAuthority:T};if(j.gotoLineMode||y.$6d.basename(R).indexOf(".")!==-1)return{fileUri:ne,options:{selection:H?{startLineNumber:H,startColumn:z||1}:void 0},remoteAuthority:T}}return{workspace:(0,se.$E5b)(ne),remoteAuthority:T}}ib(R){const j=this.F.getValue("window"),W=j?.openFoldersInNewWindow||"default",T=j?.openFilesInNewWindow||"off";let H=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(W==="on"||W==="off")&&(H=W==="on");let z=!1;return R.forceNewWindow||R.forceReuseWindow?z=!!R.forceNewWindow&&!R.forceReuseWindow:(d.$j?R.context===1&&(z=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!R.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(z=T==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(R,j){const W=(0,re.$M5b)(this.getWindows(),R);if(W)return this.C.reload(W,j.cli),W.focus(),[W];let T=j.cli["folder-uri"]||[],H=j.cli["file-uri"]||[],z=j.cli._;if(!z.length&&!T.length&&!H.length&&!j.cli.extensionTestsPath){const ge=this.j.state.lastPluginDevelopmentHostWindow,ue=ge?.workspace??ge?.folderUri;ue&&(E.URI.isUri(ue)?ue.scheme===f.Schemas.file?z=[ue.fsPath]:T=[ue.toString()]:ue.configPath.scheme===f.Schemas.file?z=[(0,o.$9f)(ue.configPath)]:H=[ue.configPath.toString()])}let ne=j.remoteAuthority;for(const ge of R)if(ge.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=E.URI.parse(ge),we=(0,C.$Ok)(ue);we&&(ne?(0,o.$ng)(we,ne)||this.r.error("more than one extension development path authority"):ne=we)}z=z.filter(ge=>{const ue=E.URI.file(ge);return(0,re.$L5b)(this.getWindows(),ue)?!1:(0,o.$ng)((0,C.$Ok)(ue),ne)}),T=T.filter(ge=>{const ue=this.$(ge);return ue&&(0,re.$L5b)(this.getWindows(),ue)?!1:ue?(0,o.$ng)((0,C.$Ok)(ue),ne):!1}),H=H.filter(ge=>{const ue=this.$(ge);return ue&&(0,re.$L5b)(this.getWindows(),ue)?!1:ue?(0,o.$ng)((0,C.$Ok)(ue),ne):!1}),j.cli._=z,j.cli["folder-uri"]=T,j.cli["file-uri"]=H;const fe={context:j.context,cli:j.cli,forceNewWindow:!0,forceEmpty:!z.length&&!T.length&&!H.length,userEnv:j.userEnv,noRecentEntry:!0,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:ne,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile};return this.open(fe)}async jb(R){const j=this.F.getValue("window"),W=this.getLastActiveWindow(),T=W?.profile??this.z.defaultProfile;let H;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(H=R.windowToUse||W,H&&H.focus());const z={...this.w.args,...R.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,y.$9d)(this.w.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:T},homeDir:this.w.userHome.with({scheme:f.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:f.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.n,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:f.Schemas.file}).fsPath,product:A.default,isInitialStartup:R.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof j?.zoomLevel=="number"?j.zoomLevel:void 0,autoDetectHighContrast:j?.autoDetectHighContrast??!0,autoDetectColorScheme:j?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(H){const ne=H.config;!z.extensionDevelopmentPath&&ne?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=ne.extensionDevelopmentPath,z.extensionDevelopmentKind=ne.extensionDevelopmentKind,z["enable-proposed-api"]=ne["enable-proposed-api"],z.verbose=ne.verbose,z["inspect-extensions"]=ne["inspect-extensions"],z["inspect-brk-extensions"]=ne["inspect-brk-extensions"],z.debugId=ne.debugId,z.extensionEnvironment=ne.extensionEnvironment,z["extensions-dir"]=ne["extensions-dir"],z["disable-extensions"]=ne["disable-extensions"]),z.loggers={global:z.loggers.global,window:ne?.loggers.window??z.loggers.window}}else{const ne=this.j.getNewWindowState(z);(0,w.mark)("code/willCreateCodeWindow");const fe=H=this.I.createInstance(B.$M6b,{state:ne,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(fe),V.a.push(fe),this.b.fire(fe),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.$bb)(fe.onDidSignalReady)(()=>this.c.fire(fe)),(0,m.$bb)(fe.onDidClose)(()=>this.mb(fe)),(0,m.$bb)(fe.onDidDestroy)(()=>this.f.fire(fe)),fe.onDidTriggerSystemContextMenu(({x:ue,y:we})=>this.h.fire({window:fe,x:ue,y:we}));const ge=(0,$.$uf)(fe.win?.webContents);ge.removeAllListeners("devtools-reload-page"),ge.on("devtools-reload-page",()=>this.C.reload(fe)),this.C.registerWindow(fe)}return z.windowId=H.id,H.isReady?this.C.unload(H,4).then(async ne=>{ne||await this.kb(H,z,R,T)}):await this.kb(H,z,R,T),H}async kb(R,j,W,T){if(j.extensionDevelopmentPath||((0,ae.$Qh)(j.workspace)?j.backupPath=this.D.registerWorkspaceBackup({workspace:j.workspace,remoteAuthority:j.remoteAuthority}):(0,ae.$Lh)(j.workspace)?j.backupPath=this.D.registerFolderBackup({folderUri:j.workspace.uri,remoteAuthority:j.remoteAuthority}):j.backupPath=this.D.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,se.$F5b)().id,remoteAuthority:j.remoteAuthority})),this.z.isEnabled()){const H=j.workspace??(0,ae.$Ph)(j.backupPath,!1),z=this.lb(W,H,T),ne=z instanceof Promise?await z:z;j.profiles.profile=ne,j.extensionDevelopmentPath||await this.z.setProfileForWorkspace(H,ne)}R.load(j)}lb(R,j,W){return R.forceProfile?this.z.profiles.find(T=>T.name===R.forceProfile)??this.z.createNamedProfile(R.forceProfile):R.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(j)??W}mb(R){const j=V.a.indexOf(R);V.a.splice(j,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=P.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(R){return this.ob(this.getWindows().filter(j=>(0,o.$ng)(j.remoteAuthority,R)))}ob(R){const j=Math.max.apply(Math,R.map(W=>W.lastFocusTime));return R.find(W=>W.lastFocusTime===j)}sendToFocused(R,...j){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,S.CancellationToken.None,...j)}sendToAll(R,j,W){for(const T of this.getWindows())W&&W.indexOf(T.id)>=0||T.sendWhenReady(R,S.CancellationToken.None,j)}getWindows(){return V.a}getWindowCount(){return V.a.length}getWindowById(R){const j=this.getWindows().filter(W=>W.id===R);return(0,D.$Mb)(j)}getWindowByWebContents(R){const j=P.BrowserWindow.fromWebContents(R);if(j)return this.getWindowById(j.id)}};e.$Q6b=ce,e.$Q6b=ce=V=ke([_(2,I.$5i),_(3,N.$o6b),_(4,L.$eN),_(5,q.$0m),_(6,i.$i5b),_(7,F.$q5b),_(8,k.$k5b),_(9,t.$B5b),_(10,c.$8h),_(11,oe.$j6b),_(12,G.$N5b),_(13,a.$Ah),_(14,r.$I5b),_(15,n.$6j),_(16,v.$$5b),_(17,K.$55b)],ce)}),define(te[305],ie([0,1,64,30,83,54]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=void 0;let D=class{constructor(h,l,m,b){this.a=h,this.b=l,this.c=m,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const m=this.b.getWindowById(h);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),l)}createUntitledWorkspace(h,l,m){return this.a.createUntitledWorkspace(l,m)}deleteUntitledWorkspace(h,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$S6b=D,e.$S6b=D=ke([_(0,M.$N5b),_(1,O.$w5b),_(2,s.$j6b),_(3,P.$B5b)],D)}),define(te[306],ie([0,1,15,131,38,27,17,50,14,32,49,44,46,2,13,9,4,12,7,31,147,42,158,110,288,161,64,284,18,199,90,132,61,115,218,28,63,94,208,233,209,293,117,210,211,16,222,93,75,6,92,217,298,285,273,20,5,303,67,24,60,294,95,34,276,82,122,25,250,252,52,48,264,290,299,291,300,127,266,267,268,271,274,30,304,275,29,97,83,305,54,39,231,53,243,51,81,129,278,292,281,8,254,277,226,66,91,296,270,23,125,295,262,238,84]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n,a,k,I,A,v,C,L,U,B,re,ee,ae,se,oe,G,K,q,F,N,V,X,x,ce,Y,R,j,W,T,H,z,ne,fe,ge,ue,we,me,Se,Ie,je,ve,be,Q,le,de,Ee,Re,Ue,Oe,ze,We,Z,he,$e,ye,Ce,Fe,Le,Ne,Be,qe,He,xe,Xe,tt,nt,$t,rt,mt,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,It,Dt,at,At,ht,ct,Ct,Rt,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;let ut=class extends f.$kc{constructor(De,Pe,pe,Me,Ae,Te,Ke,Ze,Qe,Ge,Ve,Je){super(),this.c=De,this.f=Pe,this.g=pe,this.h=Me,this.j=Ae,this.m=Te,this.n=Ke,this.s=Ze,this.t=Qe,this.u=Ge,this.w=Ve,this.y=Je,this.z(),this.C()}z(){const De=Ge=>Ge?.startsWith(`${y.Schemas.vscodeWebview}://`),Pe=new Set(this.w.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Je,Ye)=>De(Ye.requestingUrl)?Je(pe.has(Ve)):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Je(Pe.has(Ve)):Je(!1)),P.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Je,Ye)=>De(Ye.requestingUrl)?pe.has(Ve):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Pe.has(Ve):!1);const Me=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),Ae=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Te=Ge=>Ge.resourceType==="xhr"||Ae(Ge.frame),Ke=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Je=P.BrowserWindow.getAllWindows();for(const Ye of Je)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ze=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Je=Ve.frame;if(!Je||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Je=o.URI.parse(Ge.url);return Je.scheme===y.Schemas.vscodeWebview&&!Ze(Je,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Je.scheme===y.Schemas.vscodeFileResource&&!Ke(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Je.path.endsWith(".svg")&&!Me.has(Je.scheme)?Ve({cancel:!Te(Ge)}):Ve({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Je=Ge.responseHeaders,Ye=Je["content-type"]||Je["Content-Type"];if(Ye&&Array.isArray(Ye)){const it=o.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Me.has(it.scheme))return Je["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Je});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Te(Ge)})}return Ve({cancel:!1})});const Qe=P.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.m.codeCachePath&&Qe.setCodeCachePath((0,w.$9d)(this.m.codeCachePath,"chrome")),d.$i&&(this.s.getValue("security.restrictUNCAccess")===!1?(0,O.disableUNCAccessRestrictions)():(0,O.addUNCHostToAllowlist)(this.s.getValue("security.allowedUNCHosts")))}C(){(0,h.setUnexpectedErrorHandler)(pe=>this.F(pe)),process.on("uncaughtException",pe=>{(0,h.$X)(pe)||(0,h.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,h.$Y)(pe)),this.n.onWillShutdown(()=>this.dispose()),(0,E.$TS)(),P.app.on("accessibility-support-changed",(pe,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),P.app.on("activate",async(pe,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(pe,Me)=>{Me.on("will-navigate",Ae=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),Me.setWindowOpenHandler(({url:Ae})=>(this.b?.openExternal(void 0,Ae),{action:"deny"}))});let De=[],Pe;P.app.on("open-file",(pe,Me)=>{this.h.trace("app#open-file: ",Me),pe.preventDefault(),De.push((0,qe.$7h)(Me)?{workspaceUri:o.URI.file(Me)}:{fileUri:o.URI.file(Me)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.m.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$SS.handle("vscode:fetchShellEnv",pe=>{const Me=this.a?.getWindowByWebContents(pe.sender);let Ae,Te;return Me?.config?(Ae=Me.config,Te={...process.env,...Me.config.userEnv}):(Ae=this.m.args,Te=process.env),this.U(Ae,Te,!1)}),s.$SS.handle("vscode:writeNlsFile",(pe,Me,Ae)=>{const Te=this.D([Me]);if(!Te||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.u.writeFile(Te,D.$Fd.fromString(Ae))}),s.$SS.handle("vscode:readNlsFile",async(pe,...Me)=>{const Ae=this.D(Me);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.u.readFile(Ae)).value.toString()}),s.$SS.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$SS.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$SS.on("vscode:reloadWindow",pe=>pe.sender.reload())}D(De){let Pe;for(const pe of De)typeof pe=="string"&&(typeof Pe!="string"?Pe=pe:Pe=(0,w.$9d)(Pe,pe));if(!(typeof Pe!="string"||!(0,w.$8d)(Pe)||!(0,l.$If)(Pe,this.m.cachedLanguagesPath,!d.$k)))return o.URI.file(Pe)}F(De){if(De){const Pe={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${De}`),De.stack&&this.h.error(De.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.m.appRoot}`),this.h.debug("args:",this.m.args);const De=this.w.win32AppUserModelId;d.$i&&De&&P.app.setAppUserModelId(De);try{d.$j&&this.s.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Qe){this.h.error(Qe)}const Pe=new t.$ZS;this.n.onWillShutdown(Qe=>{Qe.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Et.$Z6b)(this.t,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Me,sharedProcessClient:Ae}=this.N(pe),Te=await this.O(pe,Me);this.B(Te.createInstance(r.$x5b)),this.B(Te.createInstance(vt.$W6b)),Te.invokeFunction(Qe=>this.P(Qe,Pe,Ae));const Ke=Te.invokeFunction(Qe=>this.G(Qe,Pe));this.H(Pe),this.n.phase=2,await Te.invokeFunction(Qe=>this.Q(Qe,Ke)),this.n.phase=3,this.R(),this.B(new ot.$Sg(()=>{this.B((0,ot.$Wg)(()=>this.n.phase=4,2500))},2500)).schedule()}G(De,Pe){const pe=this.a=De.get(Le.$w5b),Me=De.get(Z.$GT),Ae=this.b=De.get(fe.$95b),Te=this;Me.registerHandler({async handleURL(Je,Ye){return Te.M(pe,Me,Je,Ye)}});const Ke=this.B(new Be.$R6b({onDidOpenWindow:Ae.onDidOpenWindow,onDidFocusWindow:Ae.onDidFocusWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Ze=new u.$jh(Je=>Ke.getActiveClientId().then(Ye=>Je===Ye)),Qe=new he.$H6b(Ze,this.h),Ge=Pe.getChannel("urlHandler",Qe);Me.registerHandler(new he.$G6b(Ge));const Ve=this.I();return this.B(new ye.$I6b(Ve?.urls,Me,pe,this.m,this.w,this.h)),Ve}H(De){const Pe=()=>({statusCode:404,data:"Not found"}),pe=new Ot.$T(()=>De.getChannel(lt.$76b,new lt.$86b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Me,Ae)=>{const Te=o.URI.parse(Me.url);if(!Te.authority.startsWith("window:"))return Ae(Pe());pe.value.call(lt.$66b,[Te]).then(Ke=>Ae({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.h.warn("error dispatching remote resource call",Ke),Ae({statusCode:500,data:String(Ke)})})})}I(){const De=this.m.args["open-url"]?this.m.args._urls||[]:[];De.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),De.length+Pe.length===0)return;const pe=[];return{urls:[...De,...Pe].map(Ae=>{try{return{uri:o.URI.parse(Ae),originalUrl:Ae}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ae);return}}).filter(Ae=>{if(!Ae)return!1;if(this.J(Ae.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ae.uri.toString(!0)),!1;const Te=this.L(Ae.uri);return Te?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ae.uri.toString(!0),Te),pe.push(Te),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ae.uri.toString(!0)),!0)}),openables:pe}}J(De){if(De.authority===y.Schemas.file&&d.$i){const{options:Pe,buttonIndeces:pe}=(0,Dt.$sA)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.$eA)(De,{os:d.OS,tildify:this.m}),this.w.nameShort),detail:(0,i.localize)(3,null)},this.w);if(pe[P.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}L(De){if(De.path){if(De.authority===y.Schemas.file){const Pe=o.URI.file(De.fsPath);return(0,qe.$7h)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(De.authority===y.Schemas.vscodeRemote){const Pe=De.path.indexOf(w.$6d.sep,1);if(Pe!==-1){const pe=De.path.substring(1,Pe),Me=De.path.substring(Pe);let Ae=De.query;const Te=new URLSearchParams(De.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),Ae=Te.toString());const Ke=o.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Me,query:Ae,fragment:De.fragment});return(0,qe.$7h)(Me)?{workspaceUri:Ke}:/:[\d]+$/.test(Me)?{fileUri:Ke}:{folderUri:Ke}}}}}async M(De,Pe,pe,Me){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.w.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:o.URI.parse(pe.query).path,query:""})),this.J(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Ae=!1;const Te=new URLSearchParams(pe.query);Te.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Te.delete("windowId"),pe=pe.with({query:Te.toString()}),Ae=!0):d.$j&&De.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ae=!0);const Ke=Te.get("continueOn");Ke!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Te.delete("continueOn"),pe=pe.with({query:Te.toString()}),this.m.continueOn=Ke??void 0);const Ze=this.L(pe);return Ze?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,pe.toString(!0)),(0,ht.$Mb)(await De.open({context:5,cli:{...this.m.args},urisToOpen:[Ze],forceNewWindow:Ae,gotoLineMode:!0}))?.focus(),!0):Ae?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$Mb)(await De.open({context:5,cli:{...this.m.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.$Ok)(pe)}))?.ready(),Pe.open(pe,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}N(De){const Pe=this.B(this.g.createInstance(we.$t6b,De)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const Ae=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new c.$1S(Ae,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),pe))(),sharedProcessClient:pe}}async O(De,Pe){const pe=new Y.$zh;switch(process.platform){case"win32":pe.set(Ee.$ST,new x.$yh(We.$E6b));break;case"linux":d.$l?pe.set(Ee.$ST,new x.$yh(ze.$D6b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ee.$ST,new x.$yh(Oe.$C6b));break;case"darwin":pe.set(Ee.$ST,new x.$yh(Ue.$B6b));break}pe.set(Le.$w5b,new x.$yh(Ne.$Q6b,[De,this.f],!1));const Me=new C.$J5b(this.h,this.w);pe.set(C.$I5b,Me),pe.set(T.$d6b,new x.$yh(T.$e6b,void 0,!1)),pe.set(v.$S5b,new x.$yh(v.$T5b,void 0,!1)),pe.set(A.$gm,u.ProxyChannel.toService((0,u.$hh)(Pe.then(Qe=>Qe.getChannel("diagnostics"))))),pe.set(R.$qtb,new x.$yh(j.$_5b,[this.f])),pe.set(L.$AT,new x.$yh(U.$U5b)),pe.set(W.$a6b,new x.$yh(W.$b6b)),pe.set(fe.$95b,new x.$yh(fe.$05b,void 0,!1)),pe.set(Ce.$J6b,new x.$yh(Fe.$L6b)),pe.set(ne.$m6b,new x.$yh(ne.$n6b)),pe.set(ae.$7kb,new x.$yh(se.$V5b)),pe.set(oe.$W5b,new x.$yh(G.$Y5b)),pe.set(je.$s5b,new x.$yh(je.$t5b)),pe.set(je.$u5b,new x.$yh(je.$v5b));const Ae=new Ct.$56b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.s.getValue("terminal.integrated.persistentSessionScrollback")??100},this.s,this.m,this.n,this.h),Te=new Rt.$lr(Ae,this.s,this.h,this.j);pe.set(ct.$Yq,Te),d.$i?pe.set(K.$fXb,new x.$yh(q.$Z5b)):d.$j?pe.set(K.$fXb,new x.$yh(q.$15b)):d.$k&&pe.set(K.$fXb,new x.$yh(q.$25b));const Ke=new a.$G5b(this.m,this.s,this.h,this.t);pe.set(n.$B5b,Ke);const Ze=new tt.$O5b(this.m,this.h,this.y,Ke,Me);if(pe.set(tt.$N5b,Ze),pe.set(He.$dU,new x.$yh(Xe.$S6b,void 0,!1)),pe.set(xe.$j6b,new x.$yh(xe.$k6b,void 0,!1)),pe.set(Z.$GT,new x.$yh($e.$IT,void 0,!1)),(0,de.$ho)(this.w,this.m)){const Qe=(0,de.$mo)(this.w,this.s),Ge=(0,u.$hh)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new Q.$w6b(Ge),Je=(0,ve.$0n)((0,M.release)(),(0,M.hostname)(),process.arch,this.w.commit,this.w.version,De,Qe),Ye=(0,de.$no)(this.m),it={appenders:[Ve],commonProperties:Je,piiPaths:Ye,sendErrorTelemetry:!0};pe.set(be.$9k,new x.$yh(le.$Qq,[it],!1))}else pe.set(be.$9k,de.$bo);return pe.set(bt.$kp,new x.$yh(St.$lN,void 0,!0)),pe.set(pt.$op,new x.$yh(yt.$V6b,void 0,!0)),pe.set(at.$36b,new x.$yh(at.$46b,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Ze.initialize()]),this.g.createChild(pe)}P(De,Pe,pe){const Me=this.B(new f.$jc),Ae=u.ProxyChannel.fromService(De.get(T.$d6b),Me,{disableMarshalling:!0});this.c.registerChannel("launch",Ae);const Te=u.ProxyChannel.fromService(De.get(v.$S5b),Me,{disableMarshalling:!0});this.c.registerChannel("diagnostics",Te);const Ke=new $t.$T6b(De.get(nt.$0m));Pe.registerChannel("policy",Ke),pe.then(et=>et.registerChannel("policy",Ke));const Ze=this.u.getProvider(y.Schemas.file);(0,g.$tf)(Ze instanceof X.$3p);const Qe=new V.$35b(Ze,this.h,this.m);Pe.registerChannel(F.$7M,Qe),pe.then(et=>et.registerChannel(F.$7M,Qe));const Ge=u.ProxyChannel.fromService(De.get(rt.$q5b),Me);Pe.registerChannel("userDataProfiles",Ge),pe.then(et=>et.registerChannel("userDataProfiles",Ge));const Ve=new mt.$Lq(De.get(wt.$Io));pe.then(et=>et.registerChannel("request",Ve));const Je=new Re.$x6b(De.get(Ee.$ST));Pe.registerChannel("update",Je);const Ye=u.ProxyChannel.fromService(De.get(R.$qtb),Me);Pe.registerChannel("issue",Ye);const it=u.ProxyChannel.fromService(De.get(L.$AT),Me);Pe.registerChannel("encryption",it);const _e=u.ProxyChannel.fromService(De.get(me.$Wk),Me);Pe.registerChannel("sign",_e);const st=u.ProxyChannel.fromService(De.get(W.$a6b),Me);Pe.registerChannel("keyboardLayout",st),this.b=De.get(fe.$95b);const ft=u.ProxyChannel.fromService(this.b,Me);Pe.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const Mt=u.ProxyChannel.fromService(De.get(He.$dU),Me);Pe.registerChannel("workspaces",Mt);const Lt=u.ProxyChannel.fromService(De.get(ne.$m6b),Me);Pe.registerChannel("menubar",Lt);const jt=u.ProxyChannel.fromService(De.get(Z.$GT),Me);Pe.registerChannel("url",jt);const Ft=u.ProxyChannel.fromService(De.get(ae.$7kb),Me);Pe.registerChannel("extensionUrlTrust",Ft);const Ut=u.ProxyChannel.fromService(De.get(Ce.$J6b),Me);Pe.registerChannel("webview",Ut);const dt=this.B(new Ie.$u6b(this.h,De.get(je.$s5b)));Pe.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Nt=this.B(new kt.$X6b(De.get(je.$s5b),De.get(rt.$q5b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=u.ProxyChannel.fromService(De.get(ct.$Yq),Me);Pe.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Wt=u.ProxyChannel.fromService(De.get(K.$fXb),Me);Pe.registerChannel("externalTerminal",Wt);const gt=new Pt.$16b(De.get(It.$o6b));Pe.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const zt=new I.$H5b(De.get(Le.$w5b));Pe.registerChannel("extensionhostdebugservice",zt);const Bt=u.ProxyChannel.fromService(De.get(oe.$W5b),Me);Pe.registerChannel(oe.$X5b,Bt);const qt=u.ProxyChannel.fromService(De.get(at.$36b),Me);Pe.registerChannel(At.$26b,qt)}async Q(De,Pe){const pe=this.a=De.get(Le.$w5b),Me=(0,re.$Gl)(process.env)?0:4,Ae=this.m.args;if(Pe){if(Pe.openables.length>0)return pe.open({context:Me,cli:Ae,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const _e of Pe.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Me,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,Ke=Ae._.length,Ze=!!Ae["folder-uri"],Qe=!!Ae["file-uri"],Ge=Ae["skip-add-to-recently-opened"]===!0,Ve=Ae.wait&&Ae.waitMarkerFilePath?o.URI.file(Ae.waitMarkerFilePath):void 0,Je=Ae.remote||void 0,Ye=Ae.profile,it=Ae["profile-temp"];if(!Ke&&!Ze&&!Qe){if(Ae["new-window"]||Ye||it)return pe.open({context:Me,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:Ye,forceTempProfile:it});if(Te.length)return pe.open({context:1,cli:Ae,urisToOpen:Te.map(_e=>(0,qe.$7h)(_e)?{workspaceUri:o.URI.file(_e)}:{fileUri:o.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Me,cli:Ae,forceNewWindow:Ae["new-window"]||!Ke&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Ye,forceTempProfile:it})}R(){this.S(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(De,Pe)=>{Pe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),this.U(this.m.args,process.env,!0),this.W(),d.$j&&P.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async S(){const De=this.w.win32MutexName;if(d.$i&&De)try{const Pe=await new Promise((Me,Ae)=>{J(["@vscode/windows-mutex"],Me,Ae)}),pe=new Pe.Mutex(De);(0,m.$bb)(this.n.onWillShutdown)(()=>pe.release())}catch(Pe){this.h.error(Pe)}}async U(De,Pe,pe){try{return await(0,ee.$Ml)(this.s,this.h,De,Pe)}catch(Me){const Ae=(0,S.$mi)(Me);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.h.error(Ae)}return{}}async W(){try{const Pe=(await this.u.readFile(this.m.argvResource)).value.toString(),pe=JSON.parse((0,b.$Tm)(Pe)),Ae=(0,de.$jo)(this.s)>=1;if(pe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$4f)()}"`,"}"],Ke=Pe.substring(0,Pe.length-2).concat(`,
`,Te.join(`
`));await this.u.writeFile(this.m.argvResource,D.$Fd.fromString(Ke))}else{const Te=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Te!==Pe&&await this.u.writeFile(this.m.argvResource,D.$Fd.fromString(Te))}}catch(De){this.h.error(De)}}};e.$96b=ut,e.$96b=ut=ke([_(2,ce.$Ah),_(3,z.$5i),_(4,z.$6i),_(5,B.$i5b),_(6,H.$k5b),_(7,k.$8h),_(8,Se.$eN),_(9,N.$6j),_(10,ge.$kj),_(11,rt.$q5b)],ut)}),define(te[312],ie([0,1,15,45,7,23,8,50,14,32,49,46,13,9,65,4,35,26,21,42,99,306,10,18,237,249,28,63,201,16,220,93,75,216,92,20,223,5,77,24,78,279,126,289,51,287,95,248,34,52,79,53,39,232,230,2,40,265,66,225,91,121,269,263]),function(J,e,P,O,s,M,D,S,h,l,m,b,p,f,y,w,d,g,o,$,E,u,t,c,r,i,n,a,k,I,A,v,C,L,U,B,re,ee,ae,se,oe,G,K,q,F,N,V,X,x,ce,Y,R,j,W,T,H,z,ne,fe,ge,ue,we,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ve){console.error(ve.message),P.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ve,be,Q,le,de,Ee,Re,Ue]=this.b();try{try{await this.d(Q,Ue,le,de,Re)}catch(Oe){throw this.f(Q,Re,Oe),Oe}await ve.invokeFunction(async Oe=>{const ze=Oe.get(ee.$5i),We=Oe.get(B.$k5b),Z=Oe.get(I.$6j),he=Oe.get(ee.$6i),$e=await this.e(ze,Q,We,ve,Re,!0);return o.Promises.writeFile(Q.mainLockfile,String(process.pid)).catch(ye=>{ze.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Ee.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.$bb)(We.onWillShutdown)(ye=>{Z.dispose(),le.dispose(),ye.join("instanceLockfile",o.Promises.unlink(Q.mainLockfile).catch(()=>{}))}),ve.createInstance(u.$96b,$e,be).startup()})}catch(Oe){ve.invokeFunction(this.i,Oe)}}b(){const ve=new U.$zh,be=new H.$jc;process.once("exit",()=>be.dispose());const Q={_serviceBrand:void 0,...ae.default};ve.set(se.$kj,Q);const le=new n.$j5b(this.j(),Q),de=this.c(le);ve.set(n.$i5b,le);const Ee=new fe.$p6b((0,ee.$gj)(le),le.logsHome);ve.set(fe.$o6b,Ee);const Re=new re.$42b(Ee.getLogLevel()),Ue=be.add(new ge.$mN(Re,[new ee.$_i(Ee.getLogLevel())]));ve.set(ee.$5i,Ue);const Oe=new A.$Dp(Ue);ve.set(I.$6j,Oe);const ze=new v.$3p(Ue);Oe.registerProvider(p.Schemas.file,ze);const We=new ne.$pr(Oe);ve.set(z.$Ck,We);const Z=new we.$hN(1,le,Ue,Oe);ve.set(x.$dN,Z),ve.set(x.$eN,Z);const he=new R.$r5b(Z,We,le,Oe,Ue);ve.set(R.$q5b,he),Oe.registerProvider(p.Schemas.vscodeUserData,new me.$h7b(p.Schemas.file,ze,p.Schemas.vscodeUserData,he,We,Ue));const $e=w.$i&&Q.win32RegValueName?be.add(new W.$f7b(Ue,Q.win32RegValueName)):le.policyFile?be.add(new T.$g7b(le.policyFile,Oe,Ue)):new j.$_m;ve.set(j.$0m,$e);const ye=new r.$zn(he.defaultProfile.settingsResource,Oe,$e,Ue);return ve.set(c.$8h,ye),ve.set(B.$k5b,new C.$yh(B.$l5b,void 0,!1)),ve.set(F.$Io,new C.$yh(N.$d7b,void 0,!0)),ve.set(Y.$55b,new C.$yh(Y.$65b)),ve.set(V.$Wk,new C.$yh(X.$e7b,void 0,!1)),ve.set(K.$Wz,new C.$yh(q.$b7b)),ve.set(oe.$$5b,new G.$$6b(le,he,Ue)),[new L.$6p(ve,!0),de,le,ye,Z,Re,Q,he]}c(ve){const be={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Q=>{const le=process.env[Q];typeof le=="string"&&(be[Q]=le)}),Object.assign(process.env,be),be}async d(ve,be,Q,le,de){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.with({scheme:p.Schemas.file}).fsPath,be.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,ve.backupHome].map(Ee=>Ee?o.Promises.mkdir(Ee,{recursive:!0}):void 0)),le.init(),Q.initialize()]),be.init()}async e(ve,be,Q,le,de,Ee){let Re;try{(0,y.mark)("code/willStartMainServer"),Re=await(0,E.$wh)(be.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.$bb)(Q.onWillShutdown)(()=>Re.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(be,de,Ue),Ue;let Oe;try{Oe=await(0,E.$xh)(be.mainIPCHandle,"main")}catch(he){if(!Ee||w.$i||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,de.nameShort),(0,t.localize)(2,null),de),he;try{(0,O.unlinkSync)(be.mainIPCHandle)}catch($e){throw ve.warn("Could not delete obsolete instance handle",$e),$e}return this.e(ve,be,Q,le,de,!1)}if(be.extensionTestsLocationURI&&!be.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${de.nameShort} is running.`;throw ve.error(he),Oe.dispose(),new Error(he)}let ze;!be.args.wait&&!be.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,de.nameShort),(0,t.localize)(4,null),de)},1e4));const We=$.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Z=$.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(be.args.status)return le.invokeFunction(async()=>{const he=new i.$wr(ce.$bo,de),$e=await Z.getMainDiagnostics(),ye=await Z.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ce=await he.getDiagnostics($e,ye);throw console.log(Ce),new h.$$});throw w.$i&&await this.h(We,ve),ve.trace("Sending env to running instance..."),await We.start(be.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new h.$$("Sent env to running instance. Terminating...")}if(be.args.status)throw console.log((0,t.localize)(5,null,de.nameShort)),new h.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}f(ve,be,Q){if(Q.code==="EACCES"||Q.code==="EPERM"){const le=(0,M.$Fb)([ve.userDataPath,ve.extensionsPath,E.$sh]).map(de=>(0,b.$eA)(s.URI.file(de),{os:w.OS,tildify:ve}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$mi)(Q),le.join(`
`)),be)}}g(ve,be,Q){P.dialog.showMessageBoxSync((0,ue.$sA)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ve,detail:be},Q).options)}async h(ve,be){if(w.$i){const Q=await ve.getMainProcessId();be.trace("Sending some foreground love to the running instance:",Q);try{(await new Promise((le,de)=>{J(["windows-foreground-love"],le,de)})).allowSetForegroundWindow(Q)}catch(le){be.error(le)}}}i(ve,be){const Q=ve.get(ee.$5i),le=ve.get(B.$k5b);let de=0;be&&(be.isExpected?be.message&&Q.trace(be.message):(de=1,be.stack?Q.error(be.stack):Q.error(`Startup error: ${be.toString()}`))),le.kill(de)}j(){const ve=this.k((0,a.$Dl)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const be=(0,k.$06b)(ve.verbose);be&&((0,a.$Fl)(process.argv,"--waitMarkerFilePath",be),ve.waitMarkerFilePath=be)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const be=this.l(ve._,ve.goto);ve._=be}return ve}l(ve,be){const Q=(0,d.cwd)(),le=ve.map(Re=>{let Ue=String(Re),Oe;be&&(Oe=(0,l.$Pf)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(Q,Ue));const ze=(0,l.$Kf)(Ue,Q),We=(0,f.$ae)(ze);return We&&!(0,l.$Gf)(We)?null:be&&Oe?(Oe.path=ze,this.n(Oe)):ze}),de=w.$i||w.$j,Ee=(0,M.$Kb)(le,Re=>Re&&de?Re.toLowerCase():Re||"");return(0,M.$Fb)(Ee)}m(ve,be){return w.$i&&(be=(0,g.$ve)(be,'"')),be=(0,g.$te)((0,g.$te)(be," "),"	"),w.$i&&(be=(0,f.$0d)(ve,be),be=(0,g.$ve)(be,".")),be}n(ve){const be=[ve.path];return typeof ve.line=="number"&&be.push(String(ve.line)),typeof ve.column=="number"&&be.push(String(ve.column)),be.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10765021158cf51eaf6785361598e1668f53e06e/core/vs/code/electron-main/main.js.map
