/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const R=new Map,A=new Map,N=new Map,v=new Map;function u(g,y){g.has(y.detail)||g.set(y.detail,-y.timestamp)}function l(g,y){const w=g.get(y.detail);w&&(w>=0||g.set(y.detail,w+y.timestamp))}let I=[];typeof J=="function"&&typeof J.getStats=="function"&&(I=J.getStats().slice(0).sort((g,y)=>g.timestamp-y.timestamp));for(const g of I)switch(g.type){case 10:u(R,g);break;case 11:case 12:l(R,g);break;case 21:u(A,g);break;case 22:l(A,g);break;case 33:u(N,g);break;case 34:l(N,g);break;case 31:u(v,g);break;case 32:l(v,g);break}let O=0;N.forEach(g=>O+=g);function d(g){const y=[];return g.forEach((w,$)=>y.push([$,w])),y}return{amdLoad:d(R),amdInvoke:d(A),nodeRequire:d(N),nodeEval:d(v),nodeRequireTotal:O}}static toMarkdownTable(R,A){let N="";const v=[];return R.forEach((u,l)=>{v[l]=u.length}),A.forEach(u=>{u.forEach((l,I)=>{typeof l>"u"&&(l=u[I]="-");const O=l.toString().length;v[I]=Math.max(O,v[I])})}),R.forEach((u,l)=>{N+=`| ${u+" ".repeat(v[l]-u.toString().length)} `}),N+=`|
`,R.forEach((u,l)=>{N+=`| ${"-".repeat(v[l])} `}),N+=`|
`,A.forEach(u=>{u.forEach((l,I)=>{typeof l<"u"&&(N+=`| ${l+" ".repeat(v[I]-l.toString().length)} `)}),N+=`|
`}),N}}e.$S=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function L(N){return(v,u,l)=>{let I=null,O=null;if(typeof l.value=="function"?(I="value",O=l.value):typeof l.get=="function"&&(I="get",O=l.get),!O)throw new Error("not supported");l[I]=N(O,u)}}function D(N,v,u){let l=null,I=null;if(typeof u.value=="function"?(l="value",I=u.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",I=u.get),!I)throw new Error("not supported");const O=`$memoize$${v}`;u[l]=function(...d){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[O]}}e.$6g=D;function R(N,v,u){return L((l,I)=>{const O=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...g){this[d]||(this[d]=u?u():void 0),clearTimeout(this[O]),v&&(this[d]=v(this[d],...g),g=[this[d]]),this[O]=setTimeout(()=>{l.apply(this,g),this[d]=u?u():void 0},N)}})}e.$7g=R;function A(N,v,u){return L((l,I)=>{const O=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,g=`$throttle$lastRun$${I}`,y=`$throttle$pending$${I}`;return function(...w){if(this[d]||(this[d]=u?u():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),v&&(this[d]=v(this[d],...w)),this[y])return;const $=this[g]+N;$<=Date.now()?(this[g]=Date.now(),l.apply(this,[this[d]]),this[d]=u?u():void 0):(this[y]=!0,this[O]=setTimeout(()=>{this[y]=!1,this[g]=Date.now(),l.apply(this,[this[d]]),this[d]=u?u():void 0},$-Date.now()))}})}e.$8g=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function D(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=D;function R(u,l="Unreachable"){throw new Error(l)}e.$vc=R;function A(u){if(!u)throw new L.$ab("Assertion Failed")}e.$wc=A;function N(u){if(!u()){debugger;u(),(0,L.$Y)(new L.$ab("Assertion Failed"))}}e.$xc=N;function v(u,l){let I=0;for(;I<u.length-1;){const O=u[I],d=u[I+1];if(!l(O,d))return!1;I++}return!0}e.$yc=v}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(t,a=!1){let i=0;const s=t.length;let n="",r=0,c=16,P=0;function S(te){let ae=0,le=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,ae++}return ae<te&&(le=-1),le}function E(te){i=te,n="",r=0,c=16,P=0}function j(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return P=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ae=i}else P=3;return t.substring(te,ae)}function H(){let te="",ae=i;for(;;){if(i>=s){te+=t.substring(ae,i),P=2;break}const le=t.charCodeAt(i);if(le===34){te+=t.substring(ae,i),i++;break}if(le===92){if(te+=t.substring(ae,i),i++,i>=s){P=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const B=S(4);B>=0?te+=String.fromCharCode(B):P=4;break}default:P=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){te+=t.substring(ae,i),P=2;break}else P=6;i++}return te}function x(){if(n="",P=0,r=i,i>=s)return r=s,c=17;let te=t.charCodeAt(i);if(v(te)){do i++,n+=String.fromCharCode(te),te=t.charCodeAt(i);while(v(te));return c=15}if(u(te))return i++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),c=14;switch(te){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=H(),c=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!u(t.charCodeAt(i));)i++;return n=t.substring(ae,i),c=12}if(t.charCodeAt(i+1)===42){i+=2;const le=s-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,P=1),n=t.substring(ae,i),c=13}return n+=String.fromCharCode(te),i++,c=16}case 45:if(n+=String.fromCharCode(te),i++,i===s||!l(t.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),c=11;default:for(;i<s&&_(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(n=t.substring(r,i),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(te),i++,c=16}}function _(te){if(v(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:E,getPosition:()=>i,scan:a?ue:x,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>P}}e.$Jm=N;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function O(t,a){const i=[],s=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function P(S,E,j,H){r.value=S,r.offset=E,r.length=j,r.type=H,r.colonOffset=void 0,n=r}try{k(t,{onObjectBegin:(S,E)=>{if(a<=S)throw s;n=void 0,c=a>S,i.push("")},onObjectProperty:(S,E,j)=>{if(a<E||(P(S,E,j,"property"),i[i.length-1]=S,a<=E+j))throw s},onObjectEnd:(S,E)=>{if(a<=S)throw s;n=void 0,i.pop()},onArrayBegin:(S,E)=>{if(a<=S)throw s;n=void 0,i.push(0)},onArrayEnd:(S,E)=>{if(a<=S)throw s;n=void 0,i.pop()},onLiteralValue:(S,E,j)=>{if(a<E||(P(S,E,j,b(S)),a<=E+j))throw s},onSeparator:(S,E,j)=>{if(a<=E)throw s;if(S===":"&&n&&n.type==="property")n.colonOffset=E,c=!1,n=void 0;else if(S===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(c=!0,i[i.length-1]=""),n=void 0}}})}catch(S){if(S!==s)throw S}return{path:i,previousNode:n,isAtPropertyKey:c,matches:S=>{let E=0;for(let j=0;E<S.length&&j<i.length;j++)if(S[E]===i[j]||S[E]==="*")E++;else if(S[E]!=="**")return!1;return E===S.length}}}e.$Km=O;function d(t,a=[],i=A.DEFAULT){let s=null,n=[];const r=[];function c(S){Array.isArray(n)?n.push(S):s!==null&&(n[s]=S)}return k(t,{onObjectBegin:()=>{const S={};c(S),r.push(n),n=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const S=[];c(S),r.push(n),n=S,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(S,E,j)=>{a.push({error:S,offset:E,length:j})}},i),n[0]}e.$Lm=d;function g(t,a=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function r(S){return s.children.push(S),S}k(t,{onObjectBegin:S=>{s=r({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,E,j)=>{s=r({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:E,length:j,parent:s})},onObjectEnd:(S,E)=>{s.length=S+E-s.offset,s=s.parent,n(S+E)},onArrayBegin:(S,E)=>{s=r({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,E)=>{s.length=S+E-s.offset,s=s.parent,n(S+E)},onLiteralValue:(S,E,j)=>{r({type:b(S),offset:E,length:j,parent:s,value:S}),n(E+j)},onSeparator:(S,E,j)=>{s.type==="property"&&(S===":"?s.colonOffset=E:S===","&&n(E))},onError:(S,E,j)=>{a.push({error:S,offset:E,length:j})}},i);const P=s.children[0];return P&&delete P.parent,P}e.$Mm=g;function y(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===s){i=r.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.$Nm=y;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Om=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=$(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=$;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Qm=h;function f(t,a,i=!1){if(h(t,a,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=a;n++){const r=f(s[n],a,i);if(r)return r}return t}}e.$Rm=f;function k(t,a,i=A.DEFAULT){const s=N(t,!1);function n(Z){return Z?()=>Z(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(Z){return Z?K=>Z(K,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(a.onObjectBegin),P=r(a.onObjectProperty),S=n(a.onObjectEnd),E=n(a.onArrayBegin),j=n(a.onArrayEnd),H=r(a.onLiteralValue),x=r(a.onSeparator),_=n(a.onComment),ue=r(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const Z=s.scan();switch(s.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Z){case 12:case 13:te?ie(10):_();break;case 16:ie(1);break;case 15:case 14:break;default:return Z}}}function ie(Z,K=[],U=[]){if(ue(Z),K.length+U.length>0){let z=s.getToken();for(;z!==17;){if(K.indexOf(z)!==-1){le();break}else if(U.indexOf(z)!==-1)break;z=le()}}}function B(Z){const K=s.getTokenValue();return Z?H(K):P(K),le(),!0}function G(){switch(s.getToken()){case 11:{let Z=0;try{Z=JSON.parse(s.getTokenValue()),typeof Z!="number"&&(ie(2),Z=0)}catch{ie(2)}H(Z);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function T(){return s.getToken()!==10?(ie(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(x(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function M(){c(),le();let Z=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Z||ie(4,[],[]),x(","),le(),s.getToken()===2&&ae)break}else Z&&ie(6,[],[]);T()||ie(4,[],[2,5]),Z=!0}return S(),s.getToken()!==2?ie(7,[2],[]):le(),!0}function q(){E(),le();let Z=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Z||ie(4,[],[]),x(","),le(),s.getToken()===4&&ae)break}else Z&&ie(6,[],[]);X()||ie(4,[],[4,5]),Z=!0}return j(),s.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(s.getToken()){case 3:return q();case 1:return M();case 10:return B(!0);default:return G()}}return le(),s.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(s.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Sm=k;function p(t,a){const i=N(t),s=[];let n,r=0,c;do switch(c=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:r!==c&&s.push(t.substring(r,c)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),r=i.getPosition();break}while(n!==17);return s.join("")}e.$Tm=p;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=b}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function L(v,u,l){return Math.min(Math.max(v,u),l)}e.$Hl=L;function D(v,u){return(u+v%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=A;class N{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const l=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=N}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function N(u){A.push(u,Date.now())}function v(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:N,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(R+N.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,A){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var N in D)L.d(A,N,function(v){return D[v]}.bind(null,N));return A},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=U,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],u=e.src=[],l=0,I=l++;u[I]="0|[1-9]\\d*";var O=l++;u[O]="[0-9]+";var d=l++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=l++;u[g]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var y=l++;u[y]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var w=l++;u[w]="(?:"+u[I]+"|"+u[d]+")";var $=l++;u[$]="(?:"+u[O]+"|"+u[d]+")";var h=l++;u[h]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var f=l++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var k=l++;u[k]="[0-9A-Za-z-]+";var p=l++;u[p]="(?:\\+("+u[k]+"(?:\\."+u[k]+")*))";var b=l++,t="v?"+u[g]+u[h]+"?"+u[p]+"?";u[b]="^"+t+"$";var a="[v=\\s]*"+u[y]+u[f]+"?"+u[p]+"?",i=l++;u[i]="^"+a+"$";var s=l++;u[s]="((?:<|>)?=?)";var n=l++;u[n]=u[O]+"|x|X|\\*";var r=l++;u[r]=u[I]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=l++;u[P]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var S=l++;u[S]="^"+u[s]+"\\s*"+u[c]+"$";var E=l++;u[E]="^"+u[s]+"\\s*"+u[P]+"$";var j=l++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=l++;u[H]="(?:~>?)";var x=l++;u[x]="(\\s*)"+u[H]+"\\s+",v[x]=new RegExp(u[x],"g");var _=l++;u[_]="^"+u[H]+u[c]+"$";var ue=l++;u[ue]="^"+u[H]+u[P]+"$";var te=l++;u[te]="(?:\\^)";var ae=l++;u[ae]="(\\s*)"+u[te]+"\\s+",v[ae]=new RegExp(u[ae],"g");var le=l++;u[le]="^"+u[te]+u[c]+"$";var ie=l++;u[ie]="^"+u[te]+u[P]+"$";var B=l++;u[B]="^"+u[s]+"\\s*("+a+")$|^$";var G=l++;u[G]="^"+u[s]+"\\s*("+t+")$|^$";var T=l++;u[T]="(\\s*)"+u[s]+"\\s*("+a+"|"+u[c]+")",v[T]=new RegExp(u[T],"g");var M=l++;u[M]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var q=l++;u[q]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var X=l++;u[X]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)R(Z,u[Z]),v[Z]||(v[Z]=new RegExp(u[Z]));function K(V,Q){if(V instanceof U)return V;if(typeof V!="string"||V.length>A||!(Q?v[i]:v[b]).test(V))return null;try{return new U(V,Q)}catch{return null}}function U(V,Q){if(V instanceof U){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(V,Q);R("SemVer",V,Q),this.loose=Q;var ee=V.trim().match(Q?v[i]:v[b]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<N)return ye}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Q){var ee=K(V,Q);return ee?ee.version:null},e.clean=function(V,Q){var ee=K(V.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),o(this.major,V.major)||o(this.minor,V.minor)||o(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],me=V.prerelease[Q];if(R("prerelease compare",Q,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return o(ee,me)}while(++Q)},U.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new U(V,ee).inc(Q,me).version}catch{return null}},e.diff=function(V,Q){if(Y(V,Q))return null;var ee=K(V),me=K(Q);if(ee.prerelease.length||me.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return ye},e.compareIdentifiers=o;var z=/^[0-9]+$/;function o(V,Q){var ee=z.test(V),me=z.test(Q);return ee&&me&&(V=+V,Q=+Q),ee&&!me?-1:me&&!ee?1:V<Q?-1:V>Q?1:0}function m(V,Q,ee){return new U(V,ee).compare(new U(Q,ee))}function F(V,Q,ee){return m(V,Q,ee)>0}function C(V,Q,ee){return m(V,Q,ee)<0}function Y(V,Q,ee){return m(V,Q,ee)===0}function W(V,Q,ee){return m(V,Q,ee)!==0}function ce(V,Q,ee){return m(V,Q,ee)>=0}function oe(V,Q,ee){return m(V,Q,ee)<=0}function pe(V,Q,ee,me){var ye;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Y(V,ee,me);break;case"!=":ye=W(V,ee,me);break;case">":ye=F(V,ee,me);break;case">=":ye=ce(V,ee,me);break;case"<":ye=C(V,ee,me);break;case"<=":ye=oe(V,ee,me);break;default:throw new TypeError("Invalid operator: "+Q)}return ye}function de(V,Q){if(V instanceof de){if(V.loose===Q)return V;V=V.value}if(!(this instanceof de))return new de(V,Q);R("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Q){return o(Q,V)},e.major=function(V,Q){return new U(V,Q).major},e.minor=function(V,Q){return new U(V,Q).minor},e.patch=function(V,Q){return new U(V,Q).patch},e.compare=m,e.compareLoose=function(V,Q){return m(V,Q,!0)},e.rcompare=function(V,Q,ee){return m(Q,V,ee)},e.sort=function(V,Q){return V.sort(function(ee,me){return e.compare(ee,me,Q)})},e.rsort=function(V,Q){return V.sort(function(ee,me){return e.rcompare(ee,me,Q)})},e.gt=F,e.lt=C,e.eq=Y,e.neq=W,e.gte=ce,e.lte=oe,e.cmp=pe,e.Comparator=de;var ge={};function fe(V,Q){if(V instanceof fe)return V.loose===Q?V:new fe(V.raw,Q);if(V instanceof de)return new fe(V.value,Q);if(!(this instanceof fe))return new fe(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Q,ee,me,ye,je,ke,Le,Ie,Ae,Ue,Oe,Ne){return((Q=he(ee)?"":he(me)?">="+ee+".0.0":he(ye)?">="+ee+"."+me+".0":">="+Q)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Ue+"-"+Oe:"<="+Le)).trim()}function be(V,Q){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var me=V[ee].semver;if(me.major===Q.major&&me.minor===Q.minor&&me.patch===Q.patch)return!0}return!1}return!0}function Se(V,Q,ee){try{Q=new fe(Q,ee)}catch{return!1}return Q.test(V)}function Fe(V,Q,ee,me){var ye,je,ke,Le,Ie;switch(V=new U(V,me),Q=new fe(Q,me),ee){case">":ye=F,je=oe,ke=C,Le=">",Ie=">=";break;case"<":ye=C,je=ce,ke=F,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,Q,me))return!1;for(var Ae=0;Ae<Q.set.length;++Ae){var Ue=Q.set[Ae],Oe=null,Ne=null;if(Ue.forEach(function(De){De.semver===ge&&(De=new de(">=0.0.0")),Oe=Oe||De,Ne=Ne||De,ye(De.semver,Oe.semver,me)?Oe=De:ke(De.semver,Ne.semver,me)&&(Ne=De)}),Oe.operator===Le||Oe.operator===Ie||(!Ne.operator||Ne.operator===Le)&&je(V,Ne.semver)||Ne.operator===Ie&&ke(V,Ne.semver))return!1}return!0}de.prototype.parse=function(V){var Q=this.loose?v[B]:v[G],ee=V.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new U(V,this.loose)),pe(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Q){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Q),Se(this.value,ee,Q);if(V.operator==="")return ee=new fe(this.value,Q),Se(V.semver,ee,Q);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),je=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=pe(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=pe(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||je&&ke||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),R("range",V,Q);var ee=Q?v[q]:v[M];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(v[T],"$1$2$3"),R("comparator trim",V,v[T]),V=(V=(V=V.replace(v[x],"$1~")).replace(v[ae],"$1^")).split(/\s+/).join(" ");var me=Q?v[B]:v[G],ye=V.split(" ").map(function(je){return function(ke,Le){return R("comp",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){R("caret",Oe,Ne);var De=Ne?v[ie]:v[le];return Oe.replace(De,function(Me,ve,Ee,Pe,Re){var ze;return R("caret",Oe,Me,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Ue,Ae)}).join(" ")}(ke,Le),R("caret",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){var De=Ne?v[ue]:v[_];return Oe.replace(De,function(Me,ve,Ee,Pe,Re){var ze;return R("tilde",Oe,Me,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Ue,Ae)}).join(" ")}(ke,Le),R("tildes",ke),ke=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ue){return function(Oe,Ne){Oe=Oe.trim();var De=Ne?v[E]:v[S];return Oe.replace(De,function(Me,ve,Ee,Pe,Re,ze){R("xRange",Oe,Me,ve,Ee,Pe,Re,ze);var Be=he(Ee),Ce=Be||he(Pe),Te=Ce||he(Re);return ve==="="&&Te&&(ve=""),Be?Me=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(Pe=0),Te&&(Re=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,Pe=0,Re=0):Te&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:Pe=+Pe+1),Me=ve+Ee+"."+Pe+"."+Re):Ce?Me=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Me=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Me),Me})}(Ue,Ae)}).join(" ")}(ke,Le),R("xrange",ke),ke=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(v[X],"")}(ke,Le),R("stars",ke),ke}(je,Q)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(je){return!!je.match(me)})),ye=ye.map(function(je){return new de(je,Q)})},fe.prototype.intersects=function(V,Q){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return V.set.some(function(ye){return ye.every(function(je){return me.intersects(je,Q)})})})})},e.toComparators=function(V,Q){return new fe(V,Q).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(be(this.set[Q],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,Q,ee){var me=null,ye=null;try{var je=new fe(Q,ee)}catch{return null}return V.forEach(function(ke){je.test(ke)&&(me&&ye.compare(ke)!==-1||(ye=new U(me=ke,ee)))}),me},e.minSatisfying=function(V,Q,ee){var me=null,ye=null;try{var je=new fe(Q,ee)}catch{return null}return V.forEach(function(ke){je.test(ke)&&(me&&ye.compare(ke)!==1||(ye=new U(me=ke,ee)))}),me},e.validRange=function(V,Q){try{return new fe(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,ee){return Fe(V,Q,"<",ee)},e.gtr=function(V,Q,ee){return Fe(V,Q,">",ee)},e.outside=Fe,e.prerelease=function(V,Q){var ee=K(V,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Q,ee){return V=new fe(V,ee),Q=new fe(Q,ee),V.intersects(Q)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var Q=V.match(v[j]);return Q==null?null:K((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function v($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:N}catch{D=N}})();var u,l=[],I=!1,O=-1;function d(){I&&u&&(I=!1,u.length?l=u.concat(l):O=-1,l.length&&g())}function g(){if(!I){var $=v(d);I=!0;for(var h=l.length;h;){for(u=l,l=[];++O<h;)u&&u[O].run();O=-1,h=l.length}u=null,I=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===N||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}($)}}function y($,h){this.fun=$,this.array=h}function w(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];l.push(new y($,h)),l.length!==1||I||v(g)},y.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=w,R.addListener=w,R.once=w,R.off=w,R.removeListener=w,R.removeAllListeners=w,R.emit=w,R.prependListener=w,R.prependOnceListener=w,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class D{constructor(v,u,l){this.level=v,this.key=u,this.value=l,this.forward=[]}}const R=void 0;class A{constructor(v,u=2**16){this.comparator=v,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R)}has(v){return!!A.g(this,v,this.comparator)}get(v){return A.g(this,v,this.comparator)?.value}set(v,u){return A.h(this,v,u,this.comparator)&&(this.f+=1),this}delete(v){const u=A.k(this,v,this.comparator);return u&&(this.f-=1),u}forEach(v,u){let l=this.e.forward[0];for(;l;)v.call(u,l.value,l.key,this),l=l.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",u=this.e.forward[0];for(;u;)v+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return v}static g(v,u,l){let I=v.e;for(let O=v.d-1;O>=0;O--)for(;I.forward[O]&&l(I.forward[O].key,u)<0;)I=I.forward[O];if(I=I.forward[0],I&&l(I.key,u)===0)return I}static h(v,u,l,I){const O=[];let d=v.e;for(let g=v.d-1;g>=0;g--){for(;d.forward[g]&&I(d.forward[g].key,u)<0;)d=d.forward[g];O[g]=d}if(d=d.forward[0],d&&I(d.key,u)===0)return d.value=l,!1;{const g=A.j(v);if(g>v.d){for(let y=v.d;y<g;y++)O[y]=v.e;v.d=g}d=new D(g,u,l);for(let y=0;y<g;y++)d.forward[y]=O[y].forward[y],O[y].forward[y]=d;return!0}}static j(v,u=.5){let l=1;for(;Math.random()<u&&l<v.c;)l+=1;return l}static k(v,u,l){const I=[];let O=v.e;for(let d=v.d-1;d>=0;d--){for(;O.forward[d]&&l(O.forward[d].key,u)<0;)O=O.forward[d];I[d]=O}if(O=O.forward[0],!O||l(O.key,u)!==0)return!1;for(let d=0;d<v.d&&I[d].forward[d]===O;d++)I[d].forward[d]=O.forward[d];for(;v.d>0&&v.e.forward[v.d-1]===R;)v.d-=1;return!0}}e.$or=A}),define(ne[41],re([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function R(p){const b=p;return b?typeof b.read=="function":!1}e.$qd=R;function A(p){const b=p;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.$rd=A;function N(p){const b=p;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$sd=N;function v(p,b){return new u(p,b)}e.$td=v;class u{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,L.$Y)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(p,b){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return b(t)}e.$ud=l;function I(p,b,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return p.read()}}}e.$vd=I;function O(p,b){return new Promise((t,a)=>{const i=[];d(p,{onData:s=>{b&&i.push(s)},onError:s=>{b?a(s):t(void 0)},onEnd:()=>{t(b?b(i):void 0)}})})}e.$wd=O;function d(p,b,t){p.on("error",a=>{t?.isCancellationRequested||b.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||b.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||b.onData(a)})}e.$xd=d;function g(p,b){return new Promise((t,a)=>{const i=new D.$jc,s=[],n=P=>{if(s.push(P),s.length>b)return i.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=P=>(i.dispose(),a(P)),c=()=>(i.dispose(),t({stream:p,buffer:s,ended:!0}));i.add((0,D.$ic)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,D.$ic)(()=>p.removeListener("end",c))),p.on("end",c),i.add((0,D.$ic)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$yd=g;function y(p,b){const t=v(b);return t.end(p),t}e.$zd=y;function w(){const p=v(()=>{throw new Error("not supported")});return p.end(),p}e.$Ad=w;function $(p){let b=!1;return{read:()=>b?null:(b=!0,p)}}e.$Bd=$;function h(p,b,t){const a=v(t);return d(p,{onData:i=>a.write(b.data(i)),onError:i=>a.error(b.error?b.error(i):i),onEnd:()=>a.end()}),a}e.$Cd=h;function f(p,b,t){let a=!1;return{read:()=>{const i=b.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.$Dd=f;function k(p,b,t){let a=!1;const i=v(t);return d(b,{onData:s=>a?i.write(s):(a=!0,i.write(t([p,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.$Ed=k}),define(ne[14],re([0,1,164,41]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const R=typeof Buffer<"u",A=new L.$T(()=>new Uint8Array(256));let N,v;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,H){return!(H?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(N||(N=new TextEncoder),new u(N.encode(j)))}static fromByteArray(j){const H=u.alloc(j.length);for(let x=0,_=j.length;x<_;x++)H.buffer[x]=j[x];return H}static concat(j,H){if(typeof H>"u"){H=0;for(let ue=0,te=j.length;ue<te;ue++)H+=j[ue].byteLength}const x=u.alloc(H);let _=0;for(let ue=0,te=j.length;ue<te;ue++){const ae=j[ue];x.set(ae,_),_+=ae.byteLength}return x}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(j,H){return new u(this.buffer.subarray(j,H))}set(j,H){if(j instanceof u)this.buffer.set(j.buffer,H);else if(j instanceof Uint8Array)this.buffer.set(j,H);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),H);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,H){g(this.buffer,j,H)}readUInt32LE(j){return y(this.buffer,j)}writeUInt32LE(j,H){w(this.buffer,j,H)}readUInt8(j){return $(this.buffer,j)}writeUInt8(j,H){h(this.buffer,j,H)}indexOf(j,H=0){return l(this.buffer,j instanceof u?j.buffer:j,H)}}e.$Fd=u;function l(E,j,H=0){const x=j.byteLength,_=E.byteLength;if(x===0)return 0;if(x===1)return E.indexOf(j[0]);if(x>_-H)return-1;const ue=A.value;ue.fill(j.length);for(let ie=0;ie<j.length;ie++)ue[j[ie]]=j.length-ie-1;let te=H+j.length-1,ae=te,le=-1;for(;te<_;)if(E[te]===j[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(j.length-ae,ue[E[te]]),ae=j.length-1;return le}e.$Gd=l;function I(E,j){return E[j+0]<<0>>>0|E[j+1]<<8>>>0}e.$Hd=I;function O(E,j,H){E[H+0]=j&255,j=j>>>8,E[H+1]=j&255}e.$Id=O;function d(E,j){return E[j]*2**24+E[j+1]*2**16+E[j+2]*2**8+E[j+3]}e.$Jd=d;function g(E,j,H){E[H+3]=j,j=j>>>8,E[H+2]=j,j=j>>>8,E[H+1]=j,j=j>>>8,E[H]=j}e.$Kd=g;function y(E,j){return E[j+0]<<0>>>0|E[j+1]<<8>>>0|E[j+2]<<16>>>0|E[j+3]<<24>>>0}e.$Ld=y;function w(E,j,H){E[H+0]=j&255,j=j>>>8,E[H+1]=j&255,j=j>>>8,E[H+2]=j&255,j=j>>>8,E[H+3]=j&255}e.$Md=w;function $(E,j){return E[j]}e.$Nd=$;function h(E,j,H){E[H]=j}e.$Od=h;function f(E){return D.$ud(E,j=>u.concat(j))}e.$Pd=f;function k(E){return D.$Bd(E)}e.$Qd=k;function p(E){return D.$wd(E,j=>u.concat(j))}e.$Rd=p;async function b(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await p(E.stream)])}e.$Sd=b;function t(E){return D.$zd(E,j=>u.concat(j))}e.$Td=t;function a(E){return D.$Cd(E,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$Ud=a;function i(E){return D.$td(j=>u.concat(j),E)}e.$Vd=i;function s(E,j){return D.$Dd(E,j,H=>u.concat(H))}e.$Wd=s;function n(E,j){return D.$Ed(E,j,H=>u.concat(H))}e.$Xd=n;function r(E){let j=0,H=0,x=0;const _=new Uint8Array(Math.floor(E.length/4*3)),ue=ae=>{switch(H){case 3:_[x++]=j|ae,H=0;break;case 2:_[x++]=j|ae>>>2,j=ae<<6,H=3;break;case 1:_[x++]=j|ae>>>4,j=ae<<4,H=2;break;default:j=ae<<2,H=1}};for(let ae=0;ae<E.length;ae++){const le=E.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const te=x;for(;H>0;)ue(0);return u.wrap(_).slice(0,te)}e.$Yd=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:E},j=!0,H=!1){const x=H?P:c;let _="";const ue=E.byteLength%3;let te=0;for(;te<E.byteLength-ue;te+=3){const ae=E[te+0],le=E[te+1],ie=E[te+2];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[(le<<2|ie>>>6)&63],_+=x[ie&63]}if(ue===1){const ae=E[te+0];_+=x[ae>>>2],_+=x[ae<<4&63],j&&(_+="==")}else if(ue===2){const ae=E[te+0],le=E[te+1];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[le<<2&63],j&&(_+="=")}return _}e.$Zd=S}),define(ne[42],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function D(h){return R(h,0)}e.$pi=D;function R(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):l(h,f);case"string":return v(h,f);case"boolean":return N(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$qi=R;function A(h,f){return(f<<5)-f+h|0}e.$ri=A;function N(h,f){return A(h?433:863,f)}function v(h,f){f=A(149417,f);for(let k=0,p=h.length;k<p;k++)f=A(h.charCodeAt(k),f);return f}e.$si=v;function u(h,f){return f=A(104579,f),h.reduce((k,p)=>R(p,k),f)}function l(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((k,p)=>(k=v(p,k),R(h[p],k)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$ti=I;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function d(h,f,k=32){const p=k-f,b=~((1<<p)-1);return(h<<f|(b&h)>>>p)>>>0}function g(h,f=0,k=h.byteLength,p=0){for(let b=0;b<k;b++)h[f+b]=p}function y(h,f,k="0"){for(;h.length<f;)h=k+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(k=>k.toString(16).padStart(2,"0")).join(""):y((h>>>0).toString(16),f/4)}e.$ui=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const k=f.length;if(k===0)return;const p=this.p;let b=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let s=a;if(L.$Qe(a))if(i+1<k){const n=f.charCodeAt(i+1);L.$Re(n)?(i++,s=L.$Se(a,n)):s=65533}else{t=a;break}else L.$Re(a)&&(s=65533);if(b=this.w(p,b,s),i++,i<k)a=f.charCodeAt(i);else break}this.r=b,this.u=t}w(f,k,p){return p<128?f[k++]=p:p<2048?(f[k++]=192|(p&1984)>>>6,f[k++]=128|(p&63)>>>0):p<65536?(f[k++]=224|(p&61440)>>>12,f[k++]=128|(p&4032)>>>6,f[k++]=128|(p&63)>>>0):(f[k++]=240|(p&1835008)>>>18,f[k++]=128|(p&258048)>>>12,f[k++]=128|(p&4032)>>>6,f[k++]=128|(p&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,k=this.q;for(let c=0;c<64;c+=4)f.setUint32(c,k.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)f.setUint32(c,d(f.getUint32(c-12,!1)^f.getUint32(c-32,!1)^f.getUint32(c-56,!1)^f.getUint32(c-64,!1),1),!1);let p=this.h,b=this.l,t=this.m,a=this.n,i=this.o,s,n,r;for(let c=0;c<80;c++)c<20?(s=b&t|~b&a,n=1518500249):c<40?(s=b^t^a,n=1859775393):c<60?(s=b&t|b&a|t&a,n=2400959708):(s=b^t^a,n=3395469782),r=d(p,5)+s+i+n+f.getUint32(c*4,!1)&4294967295,i=a,a=t,t=d(b,30),b=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$vi=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const A="error",N="warning",v="warn",u="info",l="ignore";function I(d){return d?L.$Me(A,d)?R.Error:L.$Me(N,d)||L.$Me(v,d)?R.Warning:L.$Me(u,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=I;function O(d){switch(d){case R.Error:return A;case R.Warning:return N;case R.Info:return u;default:return l}}R.toString=O}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([k,p])=>{f[k]=p&&typeof p=="object"?D(p):p}),f}e.$Vm=D;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const k=f.shift();Object.freeze(k);for(const p in k)if(A.call(k,p)){const b=k[p];typeof b=="object"&&!Object.isFrozen(b)&&!(0,L.$mf)(b)&&f.push(b)}}return h}e.$Wm=R;const A=Object.prototype.hasOwnProperty;function N(h,f){return v(h,f,new Set)}e.$Xm=N;function v(h,f,k){if((0,L.$sf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const b=[];for(const t of h)b.push(v(t,f,k));return b}if((0,L.$lf)(h)){if(k.has(h))throw new Error("Cannot clone recursive data-structure");k.add(h);const b={};for(const t in h)A.call(h,t)&&(b[t]=v(h[t],f,k));return k.delete(h),b}return h}function u(h,f,k=!0){return(0,L.$lf)(h)?((0,L.$lf)(f)&&Object.keys(f).forEach(p=>{p in h?k&&((0,L.$lf)(h[p])&&(0,L.$lf)(f[p])?u(h[p],f[p],k):h[p]=f[p]):h[p]=f[p]}),h):f}e.$Ym=u;function l(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let k,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(k=0;k<h.length;k++)if(!l(h[k],f[k]))return!1}else{const b=[];for(p in h)b.push(p);b.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!l(b,t))return!1;for(k=0;k<b.length;k++)if(!l(h[b[k]],f[b[k]]))return!1}return!0}e.$Zm=l;function I(h){const f=new Set;return JSON.stringify(h,(k,p)=>{if((0,L.$lf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$1m=I;function O(h,f){const k=Object.create(null);return!h||!f||Object.keys(f).forEach(b=>{const t=h[b],a=f[b];l(t,a)||(k[b]=a)}),k}e.$2m=O;function d(h,f){const k=f.toLowerCase(),p=Object.keys(h).find(b=>b.toLowerCase()===k);return p?h[p]:h[f]}e.$3m=d;function g(h,f){const k=Object.create(null);for(const[p,b]of Object.entries(h))f(p,b)&&(k[p]=b);return k}e.$4m=g;function y(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$5m=y;function w(h){const f=[];for(const k of y(h))typeof h[k]=="function"&&f.push(k);return f}e.$6m=w;function $(h,f){const k=b=>function(){const t=Array.prototype.slice.call(arguments,0);return f(b,t)},p={};for(const b of h)p[b]=k(b);return p}e.$7m=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$3f=D,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(v){for(let u=0;u<v.length;u++)v[u]=Math.floor(Math.random()*256);return v};const A=new Uint8Array(16),N=[];for(let v=0;v<256;v++)N.push(v.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l}}()}),define(ne[74],re([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const v=N.replace(/\-/g,":").toLowerCase();return!D.has(v)}function A(){const N=(0,L.networkInterfaces)();for(const v in N){const u=N[v];if(u){for(const{mac:l}of u)if(R(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=A}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(l){return this.a||(this.a=D.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,I=0;const O=(0,L.networkInterfaces)();for(const d in O){const g=O[d];if(g)for(const{mac:y,internal:w}of g)w||(I+=1,this.c(y.toUpperCase())&&(l+=1))}this.b=I>0?l/I:0}return this.b}};let N;async function v(l){return N||(N=(async()=>await u(l)||R.$4f())()),N}e.$Im=v;async function u(l){try{const I=await new Promise((d,g)=>{J(["crypto"],d,g)}),O=(0,A.$Gm)();return I.createHash("sha256").update(O,"utf8").digest("hex")}catch(I){l(I);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const D=60,R=D*60,A=R*24,N=A*7,v=A*30,u=A*365;function l(O,d,g,y){typeof O!="number"&&(O=O.getTime());const w=Math.round((new Date().getTime()-O)/1e3);if(w<-30)return(0,L.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,L.localize)(1,null);let $;return w<D?($=w,d?$===1?g?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):g?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?g?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):g?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):w<R?($=Math.floor(w/D),d?$===1?g?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):g?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?g?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):g?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):w<A?($=Math.floor(w/R),d?$===1?g?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):g?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?g?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):g?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):w<N?($=Math.floor(w/A),d?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):w<v?($=Math.floor(w/N),d?$===1?g?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):g?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?g?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):g?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):w<u?($=Math.floor(w/v),d?$===1?g?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):g?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?g?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):g?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(w/u),d?$===1?g?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):g?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?g?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):g?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$6l=l;function I(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=I}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function A(O,d){return d&&(O.stack||O.stacktrace)?R.localize(0,null,v(O),N(O.stack)||N(O.stacktrace)):v(O)}function N(O){return Array.isArray(O)?O.join(`
`):O}function v(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?R.localize(1,null,O.message):O.message||R.localize(2,null)}function u(O=null,d=!1){if(!O)return R.localize(3,null);if(Array.isArray(O)){const g=L.$Fb(O),y=u(g[0],d);return g.length>1?R.localize(4,null,y,g.length):y}if(D.$jf(O))return O;if(O.detail){const g=O.detail;if(g.error)return A(g.error,d);if(g.exception)return A(g.exception,d)}return O.stack?A(O,d):O.message?O.message:R.localize(5,null)}e.$mi=u;function l(O){const d=O;return d instanceof Error&&Array.isArray(d.actions)}e.$ni=l;function I(O,d){let g;return typeof O=="string"?g=new Error(O):g=O,g.actions=d,g}e.$oi=I}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$mp=D}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var D;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(v,...u){const l=u.reduce((d,g)=>(d[g]=!0,d),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(d=>!l[d]).forEach(d=>{for(let g=0;g<I.length;g++)if(d.search(I[g])!==-1){delete v[d];break}})}e.$sl=A;function N(v){v&&(delete v.DEBUG,L.$j&&delete v.DYLD_LIBRARY_PATH,L.$k&&delete v.LD_PRELOAD)}e.$tl=N}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function D(l){const I=l;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.$Np=D;function R(l){const I=[];let O;try{const d=JSON.parse(l.arguments),g=d[d.length-1];g&&g.__$stack&&(d.pop(),O=g.__$stack),I.push(...d)}catch{I.push("Unable to log remote console arguments",l.arguments)}return{args:I,stack:O}}e.$Op=R;function A(l){if(typeof l!="string")return A(R(l).stack);const I=l;if(I){const O=N(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$Pp=A;function N(l){if(!l)return l;const I=l.indexOf(`
`);return I===-1?l:l.substring(0,I)}function v(l,I){const{args:O,stack:d}=R(l),g=typeof O[0]=="string"&&O.length===1;let y=N(d);y&&(y=`(${y.trim()})`);let w=[];if(typeof O[0]=="string"?y&&g?w=[`%c[${I}] %c${O[0]} %c${y}`,u("blue"),u(""),u("grey")]:w=[`%c[${I}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:w=[`%c[${I}]%`,u("blue"),...O],y&&!g&&w.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=v;function u(l){return`color: ${l}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function R(u){return JSON.stringify(u,N)}e.$9g=R;function A(u){let l=JSON.parse(u);return l=v(l),l}e.$0g=A;function N(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function v(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$Fd||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let I=0;I<u.length;++I)u[I]=v(u[I],l+1);else for(const I in u)Object.hasOwnProperty.call(u,I)&&(u[I]=v(u[I],l+1))}return u}e.$$g=v}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class N{constructor(d,g,y){this.id=d,this.dependencies=g,this.callback=y}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,g,y)=>{typeof d!="string"&&(y=g,g=d,d=null),(typeof g!="object"||!Array.isArray(g))&&(y=g,g=null),this.c.push(new N(d,g,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const g=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!g)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(g.dependencies)&&g.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${g.dependencies.join(", ")}`);return typeof g.callback=="function"?g.callback([]):g.callback}h(d){return new Promise((g,y)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",h),w.removeEventListener("error",f)},h=k=>{$(),g(this.c.pop())},f=k=>{$(),y(k)};w.addEventListener("load",h),w.addEventListener("error",f),this.f&&(d=this.f.createScriptURL(d)),w.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(w)})}i(d){return new Promise((g,y)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),g(this.c.pop())}catch(w){y(w)}})}async j(d){try{const g=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(d).fsPath,h=g.readFileSync($).toString(),f=w.wrap(h.replace(/^#!.*/,""));return new y.Script(f).runInThisContext().apply(),this.c.pop()}catch(g){throw g}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function I(O,d,g){if(L.$R){g===void 0&&(g=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[O]&&(O=l[O]);const y=`${O}/${d}`;if(u.has(y))return u.get(y);let w;if(/^\w[\w\d+.-]*:\/\//.test(y))w=y;else{const k=`${g&&!R.$o?D.$Zf:D.$Yf}/${y}`;w=D.$2f.asBrowserUri(k).toString(!0)}const $=v.INSTANCE.load(w);return u.set(y,$),$}else return await new Promise((y,w)=>{J([O],y,w)})}e.$aD=I}),define(ne[83],re([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class O{constructor(b,t,a){this.exePath=b,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:p=!1,findPreview:b=!1}={}){const t=d({useAlternateBitness:p});if(!t)return null;const a=D.$9d(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const c of await R.Promises.readdir(a)){let P=-1;if(b){const E=c.indexOf("-");if(E<0)continue;const j=c.substring(0,E);if(!A.test(j)||c.substring(E+1)!=="preview")continue;P=parseInt(j,10)}else{if(!A.test(c))continue;P=parseInt(c,10)}if(P<=i)continue;const S=D.$9d(a,c,"pwsh.exe");await R.SymlinkSupport.existsFile(S)&&(s=S,i=P)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",r=b?" Preview":"";return new O(s,`PowerShell${r}${n}`,!0)}async function y({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const b=D.$9d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(b))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(b))if(t.test(i)){const s=D.$9d(b,i,"pwsh.exe");return new O(s,a)}return null}function w(){const p=D.$9d(L.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=D.$9d(process.env.windir,l===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*h(){let p=await g();p&&(yield p),p=await g({useAlternateBitness:!0}),p&&(yield p),p=await y(),p&&(yield p),p=w(),p&&(yield p),p=await g({findPreview:!0}),p&&(yield p),p=await y({findPreview:!0}),p&&(yield p),p=await g({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$ql=f;async function k(){for await(const p of f())return p;return null}e.$rl=k}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,L,D,R,A,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=R.env){return O.comspec||"cmd.exe"}e.$ul=u;function l(O){let d=[],g=!1;const y=function(w){if(g){d.push(w);return}(!O.send(w,h=>{if(h&&console.error(h),g=!1,d.length>0){const f=d.slice(0);d=[],f.forEach(k=>y(k))}})||D.$i)&&(g=!0)};return{send:y}}e.$vl=l;var I;(function(O){async function d(g,y,w){if(L.$8d(g))return g;if(y===void 0&&(y=R.cwd()),L.$_d(g)!=="."||(w===void 0&&N.$jf(R.env.PATH)&&(w=R.env.PATH.split(L.$ge)),w===void 0||w.length===0))return L.$9d(y,g);async function h(f){if(await v.Promises.exists(f)){let k;try{k=await v.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(k=await v.Promises.lstat(f))}return k?!k.isDirectory():!1}return!1}for(const f of w){let k;if(L.$8d(f)?k=L.$9d(f,g):k=L.$9d(y,f,g),await h(k))return k;let p=k+".com";if(await h(p)||(p=k+".exe",await h(p)))return p}return L.$9d(y,g)}O.findExecutable=d})(I||(e.win32=I={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;async function N(O,d){return O===1?D.$i?I():A.$ul(d):u(O,d)}e.$wl=N;let v=null;function u(O,d){if(D.$k&&O===2||D.$j&&O===3)return"/bin/bash";if(!v){let g;if(D.$i)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,L.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}v=g}return v}let l=null;async function I(){return l||(l=(await(0,R.$rl)()).exePath),l}});var $e=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,A=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var v=J.length-1;v>=0;v--)(N=J[v])&&(A=(R<3?N(A):R>3?N(e,L,A):N(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,D,R,A,N,v,u,l,I,O,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var g;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(g||(g={}));function y(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w||(w={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let M=0;for(let q=0;;q+=7){const X=T.read(1);if(M|=(X.buffer[0]&127)<<q,!(X.buffer[0]&128))return M}}const k=i(0);function p(T,M){if(M===0){T.write(k);return}let q=0;for(let Z=M;Z!==0;Z=Z>>>7)q++;const X=R.$Fd.alloc(q);for(let Z=0;M!==0;Z++)X.buffer[Z]=M&127,M=M>>>7,M>0&&(X.buffer[Z]|=128);T.write(X)}class b{constructor(M){this.b=M,this.a=0}read(M){const q=this.b.slice(this.a,this.a+M);return this.a+=q.byteLength,q}}e.$_g=b;class t{constructor(){this.a=[]}get buffer(){return R.$Fd.concat(this.a)}write(M){this.a.push(M)}}e.$ah=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const M=R.$Fd.alloc(1);return M.writeUInt8(T,0),M}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},n=typeof Buffer<"u";function r(T,M){if(typeof M>"u")T.write(s.Undefined);else if(typeof M=="string"){const q=R.$Fd.fromString(M);T.write(s.String),p(T,q.byteLength),T.write(q)}else if(n&&Buffer.isBuffer(M)){const q=R.$Fd.wrap(M);T.write(s.Buffer),p(T,q.byteLength),T.write(q)}else if(M instanceof R.$Fd)T.write(s.VSBuffer),p(T,M.byteLength),T.write(M);else if(Array.isArray(M)){T.write(s.Array),p(T,M.length);for(const q of M)r(T,q)}else if(typeof M=="number"&&(M|0)===M)T.write(s.Uint),p(T,M);else{const q=R.$Fd.fromString(JSON.stringify(M));T.write(s.Object),p(T,q.byteLength),T.write(q)}}e.$bh=r;function c(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const q=f(T),X=[];for(let Z=0;Z<q;Z++)X.push(c(T));return X}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$ch=c;class P{constructor(M,q,X=null,Z=1e3){this.h=M,this.j=q,this.k=X,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(M,q){this.b.set(M,q),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const q=this.o([M.type]);this.k?.logOutgoing(q,0,1,$(M.type));return}case 201:case 202:case 204:case 203:{const q=this.o([M.type,M.id],M.data);this.k?.logOutgoing(q,M.id,1,$(M.type),M.data);return}}}o(M,q=void 0){const X=new t;return r(X,M),r(X,q),this.p(X.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const q=new b(M),X=c(q),Z=c(q),K=X[0];switch(K){case 100:return this.k?.logIncoming(M.byteLength,X[1],1,`${y(K)}: ${X[2]}.${X[3]}`,Z),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:Z});case 102:return this.k?.logIncoming(M.byteLength,X[1],1,`${y(K)}: ${X[2]}.${X[3]}`,Z),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:Z});case 101:return this.k?.logIncoming(M.byteLength,X[1],1,`${y(K)}`),this.u({type:K,id:X[1]});case 103:return this.k?.logIncoming(M.byteLength,X[1],1,`${y(K)}`),this.u({type:K,id:X[1]})}}s(M){const q=this.b.get(M.channelName);if(!q){this.v(M);return}const X=new A.$pd;let Z;try{Z=q.call(this.j,M.name,M.arg,X.token)}catch(z){Z=Promise.reject(z)}const K=M.id;Z.then(z=>{this.m({id:K,data:z,type:201})},z=>{z instanceof Error?this.m({id:K,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:K,data:z,type:203})}).finally(()=>{U.dispose(),this.d.delete(M.id)});const U=(0,l.$ic)(()=>X.cancel());this.d.set(M.id,U)}t(M){const q=this.b.get(M.channelName);if(!q){this.v(M);return}const X=M.id,K=q.listen(this.j,M.name,M.arg)(U=>this.m({id:X,data:U,type:204}));this.d.set(M.id,K)}u(M){const q=this.d.get(M.id);q&&(q.dispose(),this.d.delete(M.id))}v(M){let q=this.g.get(M.channelName);q||(q=[],this.g.set(M.channelName,q));const X=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:M,timeoutTimer:X})}w(M){const q=this.g.get(M);if(q){for(const X of q)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$fc)(this.d.values()),this.d.clear()}}e.$dh=P;var S;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class E{constructor(M,q=null){this.l=M,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=q}getChannel(M){const q=this;return{call(X,Z,K){return q.a?Promise.reject(new v.$3):q.m(M,X,Z,K)},listen(X,Z){return q.a?u.Event.None:q.o(M,X,Z)}}}m(M,q,X,Z=A.CancellationToken.None){const K=this.g++,z={id:K,type:100,channelName:M,name:q,arg:X};if(Z.isCancellationRequested)return Promise.reject(new v.$3);let o;return new Promise((F,C)=>{if(Z.isCancellationRequested)return C(new v.$3);const Y=()=>{const pe=de=>{switch(de.type){case 201:this.f.delete(K),F(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(K),C(de.data);break}};this.f.set(K,pe),this.p(z)};let W=null;this.b===h.Idle?Y():(W=(0,D.$ug)(pe=>this.u()),W.then(()=>{W=null,Y()}));const ce=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),C(new v.$3)},oe=Z.onCancellationRequested(ce);o=(0,l.$hc)((0,l.$ic)(ce),oe),this.d.add(o)}).finally(()=>{o.dispose(),this.d.delete(o)})}o(M,q,X){const Z=this.g++,U={id:Z,type:102,channelName:M,name:q,arg:X};let z=null;const o=new u.$fd({onWillAddFirstListener:()=>{z=(0,D.$ug)(F=>this.u()),z.then(()=>{z=null,this.d.add(o),this.p(U)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(o),this.p({id:Z,type:103}))}}),m=F=>o.fire(F.data);return this.f.set(Z,m),o.event}p(M){switch(M.type){case 100:case 102:{const q=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(q,M.id,0,`${y(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const q=this.q([M.type,M.id]);this.j?.logOutgoing(q,M.id,0,y(M.type));return}}}q(M,q=void 0){const X=new t;return r(X,M),r(X,q),this.r(X.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const q=new b(M),X=c(q),Z=c(q),K=X[0];switch(K){case 200:return this.j?.logIncoming(M.byteLength,0,0,$(K)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,X[1],0,$(K),Z),this.t({type:X[0],id:X[1],data:Z})}}t(M){if(M.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$fc)(this.d.values()),this.d.clear()}}e.$eh=E,$e([N.$6g],E.prototype,"onDidInitializePromise",null);class j{get connections(){const M=[];return this.f.forEach(q=>M.push(q)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new u.$fd,this.onDidAddConnection=this.g.event,this.h=new u.$fd,this.onDidRemoveConnection=this.h.event,this.j=new l.$jc,this.j.add(M(({protocol:q,onDidClientDisconnect:X})=>{const Z=u.Event.once(q.onMessage);this.j.add(Z(K=>{const U=new b(K),z=c(U),o=new P(q,z),m=new E(q);this.a.forEach((C,Y)=>o.registerChannel(Y,C));const F={channelServer:o,channelClient:m,ctx:z};this.f.add(F),this.g.fire(F),this.j.add(X(()=>{o.dispose(),m.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(M,q){const X=this;return{call(Z,K,U){let z;if((0,d.$xf)(q)){const m=(0,L.$2b)(X.connections.filter(q));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,q))}else z=q.routeCall(X,Z,K);const o=z.then(m=>m.channelClient.getChannel(M));return x(o).call(Z,K,U)},listen(Z,K){if((0,d.$xf)(q))return X.k(M,q,Z,K);const U=q.routeEvent(X,Z,K).then(z=>z.channelClient.getChannel(M));return x(U).listen(Z,K)}}}k(M,q,X,Z){const K=this;let U;const z=new u.$fd({onWillAddFirstListener:()=>{U=new l.$jc;const o=new u.$ld,m=new Map,F=Y=>{const ce=Y.channelClient.getChannel(M).listen(X,Z),oe=o.add(ce);m.set(Y,oe)},C=Y=>{const W=m.get(Y);W&&(W.dispose(),m.delete(Y))};K.connections.filter(q).forEach(F),u.Event.filter(K.onDidAddConnection,q)(F,void 0,U),K.onDidRemoveConnection(C,void 0,U),o.event(z.fire,z,U),U.add(o)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return z.event}registerChannel(M,q){this.a.set(M,q);for(const X of this.f)X.channelServer.registerChannel(M,q)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=j;class H{constructor(M,q,X=null){const Z=new t;r(Z,q),M.send(Z.buffer),this.a=new E(M,X),this.d=new P(M,q,X)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,q){this.d.registerChannel(M,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=H;function x(T){return{call(M,q,X){return T.then(Z=>Z.call(M,q,X))},listen(M,q){const X=new u.$od;return T.then(Z=>X.input=Z.listen(M,q)),X.event}}}e.$hh=x;function _(T){let M=!1;return{call(q,X,Z){return M?T.call(q,X,Z):(0,D.$Hg)(0).then(()=>M=!0).then(()=>T.call(q,X,Z))},listen(q,X){if(M)return T.listen(q,X);const Z=new u.$od;return(0,D.$Hg)(0).then(()=>M=!0).then(()=>Z.input=T.listen(q,X)),Z.event}}}e.$ih=_;class ue{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const q of M.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$jh=ue;var te;(function(T){function M(K,U,z){const o=K,m=z&&z.disableMarshalling,F=new Map;for(const C in o)X(C)&&F.set(C,u.Event.buffer(o[C],!0,void 0,U));return new class{listen(C,Y,W){const ce=F.get(Y);if(ce)return ce;if(Z(Y)){const oe=o[Y];if(typeof oe=="function")return oe.call(o,W)}throw new v.$_(`Event not found: ${Y}`)}call(C,Y,W){const ce=o[Y];if(typeof ce=="function"){if(!m&&Array.isArray(W))for(let oe=0;oe<W.length;oe++)W[oe]=(0,I.$$g)(W[oe]);return ce.apply(o,W)}throw new v.$_(`Method not found: ${Y}`)}}}T.fromService=M;function q(K,U){const z=U&&U.disableMarshalling;return new Proxy({},{get(o,m){if(typeof m=="string")return U?.properties?.has(m)?U.properties.get(m):Z(m)?function(F){return K.listen(m,F)}:X(m)?K.listen(m):async function(...F){let C;U&&!(0,d.$sf)(U.context)?C=[U.context,...F]:C=F;const Y=await K.call(m,C);return z?Y:(0,I.$$g)(Y)};throw new v.$_(`Property not found: ${String(m)}`)}})}T.toService=q;function X(K){return K[0]==="o"&&K[1]==="n"&&O.$Le(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&O.$Le(K.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const M=T.toString();if(M!=="[object Object]")return M}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function B(T,M,q,X,Z,K,U){U=ie(U);const z=ae[Z],o=z[X%z.length];let m=[`%c[${T}]%c[${String(M).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(K)?(m=m.concat(U),m.push(")")):m.push(U),console.log.apply(console,m)}class G{constructor(M,q){this.d=M,this.f=q,this.a=0,this.b=0}logOutgoing(M,q,X,Z,K){this.b+=M,B(this.d,this.b,M,q,X,Z,K)}logIncoming(M,q,X,Z,K){this.a+=M,B(this.f,this.a,M,q,X,Z,K)}}e.$kh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class y extends g.$dh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$Fd.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Rp=y;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$fd,this.onDidProcessExit=this.h.event;const k=f&&f.timeout?f.timeout:6e4;this.b=new D.$Dg(k),this.d=null,this.f=null}getChannel(h){const f=this;return{call(k,p,b){return f.k(h,k,p,b)},listen(k,p){return f.l(h,k,p)}}}k(h,f,k,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(v.$4());this.b.cancel();const b=this.n(h),t=(0,D.$ug)(s=>b.call(f,k,s)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,l.$ic)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,k){if(!this.b)return u.Event.None;this.b.cancel();let p;const b=new u.$fd({onWillAddFirstListener:()=>{p=this.n(h).listen(f,k)(b.fire,b),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return b.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$tl)(f.env),this.d=(0,L.fork)(this.i,h,f);const k=new u.$fd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$Np)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}k.fire(R.$Fd.wrap(Buffer.from(n,"base64")))});const b=this.j.useQueue?(0,O.$vl)(this.d):this.d,t=n=>this.d&&this.d.connected&&b.send(n.buffer.toString("base64")),a=k.event,i={send:t,onMessage:a};this.f=new g.$eh(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",s),this.c.forEach(c=>(0,l.$fc)(c)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=w}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var v;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function u(d){const g=d;return g?.changed instanceof Map||g?.deleted instanceof Set}e.$Qo=u;var l;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(l||(e.StorageState=l={}));class I extends R.$kc{static{this.a=100}constructor(g,y=Object.create(null)){super(),this.r=g,this.s=y,this.b=this.B(new D.$id),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new L.$Eg(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((y,w)=>this.w(w,y)),g.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(g,y){if(this.c===l.Closed)return;let w=!1;(0,N.$sf)(y)?w=this.f.delete(g):this.f.get(g)!==y&&(this.f.set(g,y),w=!0),w&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,y){const w=this.f.get(g);return(0,N.$sf)(w)?y:w}getBoolean(g,y){const w=this.get(g);return(0,N.$sf)(w)?y:w==="true"}getNumber(g,y){const w=this.get(g);return(0,N.$sf)(w)?y:parseInt(w,10)}getObject(g,y){const w=this.get(g);return(0,N.$sf)(w)?y:(0,A.$0g)(w)}async set(g,y,w=!1){if(this.c===l.Closed)return;if((0,N.$sf)(y))return this.delete(g,w);const $=(0,N.$lf)(y)||Array.isArray(y)?(0,A.$9g)(y):String(y);if(this.f.get(g)!==$)return this.f.set(g,$),this.j.set(g,$),this.h.delete(g),this.b.fire({key:g,external:w}),this.D()}async delete(g,y=!1){if(!(this.c===l.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:y}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(this.z)return this.D(g)}async D(g){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$Ro=I;class O{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((y,w)=>this.a.set(w,y)),g.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$So=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var R;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const N=(0,D.localize)(3,null),v=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const O=this.d,d=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:d};this.g.push({offset:O,lexeme:d,additionalInfo:I}),this.f.push(g)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const O=this.c.substring(this.d,this.e),d=u.b.get(O);d?this.k(d):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,O=!1,d=!1;for(;;){if(I>=this.c.length){this.e=I,this.l(v);return}const y=this.c.charCodeAt(I);if(O)O=!1;else if(y===47&&!d){I++;break}else y===91?d=!0:y===92?O=!0:y===93&&(d=!1);I++}for(;I<this.c.length&&u.a.has(this.c.charCodeAt(I));)I++;this.e=I;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.$_d)(R.$2f.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$9d)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,v.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,L.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$9d)(this.userDataPath,"logs",g)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$ig)(u.URI.file((0,A.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=N.env.VSCODE_PORTABLE;return g?u.URI.file((0,A.$9d)(g,"argv.json")):(0,v.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.$0d)(g):(0,A.$7d)((0,A.$9d)(R.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?u.URI.file((0,A.$0d)(g)):u.URI.file((0,A.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.$0d)(g);const y=N.env.VSCODE_EXTENSIONS;if(y)return y;const w=N.env.VSCODE_PORTABLE;return w?(0,A.$9d)(w,"extensions"):(0,v.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(y=>/^[^:/?#]+?:\/\//.test(y)?u.URI.parse(y):u.URI.file((0,A.$7d)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?u.URI.parse(g):u.URI.file((0,A.$7d)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$8l.test(g))}get extensionLogLevel(){const g=[];for(const y of this.args.log||[]){const w=e.$8l.exec(y);w&&w[1]&&w[2]&&g.push([w[1],w[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,v.$ig)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=N.env.VSCODE_PORTABLE;return g?u.URI.file((0,A.$9d)(g,"policy.json")):(0,v.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,y,w){this.a=g,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$9l=l,$e([D.$6g],l.prototype,"appRoot",null),$e([D.$6g],l.prototype,"userHome",null),$e([D.$6g],l.prototype,"userDataPath",null),$e([D.$6g],l.prototype,"appSettingsHome",null),$e([D.$6g],l.prototype,"tmpDir",null),$e([D.$6g],l.prototype,"cacheHome",null),$e([D.$6g],l.prototype,"stateResource",null),$e([D.$6g],l.prototype,"userRoamingDataHome",null),$e([D.$6g],l.prototype,"userDataSyncHome",null),$e([D.$6g],l.prototype,"sync",null),$e([D.$6g],l.prototype,"machineSettingsResource",null),$e([D.$6g],l.prototype,"workspaceStorageHome",null),$e([D.$6g],l.prototype,"localHistoryHome",null),$e([D.$6g],l.prototype,"keyboardLayoutResource",null),$e([D.$6g],l.prototype,"argvResource",null),$e([D.$6g],l.prototype,"isExtensionDevelopment",null),$e([D.$6g],l.prototype,"untitledWorkspacesHome",null),$e([D.$6g],l.prototype,"builtinExtensionsPath",null),$e([D.$6g],l.prototype,"extensionsPath",null),$e([D.$6g],l.prototype,"extensionDevelopmentLocationURI",null),$e([D.$6g],l.prototype,"extensionDevelopmentKind",null),$e([D.$6g],l.prototype,"extensionTestsLocationURI",null),$e([D.$6g],l.prototype,"debugExtensionHost",null),$e([D.$6g],l.prototype,"logLevel",null),$e([D.$6g],l.prototype,"extensionLogLevel",null),$e([D.$6g],l.prototype,"serviceMachineIdResource",null),$e([D.$6g],l.prototype,"disableTelemetry",null),$e([D.$6g],l.prototype,"disableWorkspaceTrust",null),$e([D.$6g],l.prototype,"useInMemorySecretStorage",null),$e([D.$6g],l.prototype,"policyFile",null);function I(d,g){return O(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}e.$0l=I;function O(d,g,y,w,$,h){const k=Number(g||d)||(w?null:y),p=k?!!g:!1;let b;if(h)try{b=JSON.parse(h)}catch{}return{port:k,break:p,debugId:$,env:b}}e.$$l=O}),function(){"use strict";function J(e,L,D){function R(N,v){const u=A(N,v),l=[u];return e.isAbsolute(u)||l.unshift(D),e.resolve(...l)}function A(N,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,v);const I=N["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(O,"AppData","Roaming")}break;case"darwin":l=e.join(L.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,v)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class A extends D.$9l{constructor(l,I){super(l,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(l,I.nameShort)},I)}}e.$_l=A;function N(u,l){return(0,D.$$l)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.$am=N;function v(u,l){return(0,D.$$l)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.$bm=v}),define(ne[112],re([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function R(N,v,u,l){try{A(N,v,u,l)}catch(I){N.error(I?.message??I)}return v}e.$np=R;function A(N,v,u,l){const I=(O,d,g)=>{const y=O[d];if((0,L.$jf)(y)){const w=y,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const h=w.substr(1,$-2);let f=u[h];f===void 0&&l&&(f=l[h]);const k=typeof f=="string"?f:f?.message,p=l?.[h],b=typeof p=="string"?p:p?.message;if(!k){b||N.warn(`[${v.name}]: ${(0,D.localize)(0,null,h)}`);return}if(g&&(d==="title"||d==="category")&&b&&b!==k){const t={value:k,original:b};O[d]=t}else O[d]=k}}else if((0,L.$lf)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?I(y,w,!0):I(y,w,g));else if(Array.isArray(y))for(let w=0;w<y.length;w++)I(y,w,g)};for(const O in v)v.hasOwnProperty(O)&&I(v,O)}}),define(ne[48],re([0,1,17,54,98,43]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||N.test(h)}e.$Bo=u;function l(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(N);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Co=l;function I(h){if(!h)return null;const f=h.majorBase,k=h.majorMustEqual,p=h.minorBase;let b=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(f===0||(b=!1),a=!1);let i=0;if(h.preRelease){const s=v.exec(h.preRelease);if(s){const[,n,r,c]=s;i=Date.UTC(Number(n),Number(r)-1,Number(c))}}return{majorBase:f,majorMustEqual:k,minorBase:p,minorMustEqual:b,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Do=I;function O(h,f,k){let p;typeof h=="string"?p=I(l(h)):p=h;let b;f instanceof Date?b=f.getTime():typeof f=="string"&&(b=new Date(f).getTime());let t;if(typeof k=="string"?t=I(l(k)):t=k,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,s=p.patchBase;let n=t.majorBase,r=t.minorBase,c=t.patchBase;const P=t.notBefore;let S=t.majorMustEqual,E=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:i>r?!0:i<r||b&&b<P?!1:s>=c:(a===1&&n===0&&(!S||!E||!j)&&(n=1,r=0,c=0,S=!0,E=!1,j=!1),a<n?!1:a>n?!S:i<r?!1:i>r?!E:s<c?!1:s>c?!j:!(b&&b<P))}e.$Eo=O;function d(h,f,k,p,b){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([D.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([D.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([D.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([D.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([D.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([D.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([D.default.Error,R.localize(9,null,"main")]),t;{const s=(0,L.$ig)(k,p.main);(0,L.$cg)(s,k)||t.push([D.default.Warning,R.localize(10,null,s.path,k.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([D.default.Error,R.localize(11,null,"browser")]),t;{const s=(0,L.$ig)(k,p.browser);(0,L.$cg)(s,k)||t.push([D.default.Warning,R.localize(12,null,s.path,k.path)])}}if(!A.valid(p.version))return t.push([D.default.Error,R.localize(13,null)]),t;const a=[];if(!g(h,f,p,b,a))for(const s of a)t.push([D.default.Error,s]);return t}e.$Fo=d;function g(h,f,k,p,b){return p||typeof k.main>"u"&&typeof k.browser>"u"?!0:w(h,f,k.engines.vscode,b)}e.$Go=g;function y(h,f,k){return h==="*"||w(f,k,h)}e.$Ho=y;function w(h,f,k,p=[]){const b=I(l(k));if(!b)return p.push(R.localize(14,null,k)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return p.push(R.localize(15,null,k)),!1}else if(!b.majorMustEqual)return p.push(R.localize(16,null,k)),!1;return O(h,f,b)?!0:(p.push(R.localize(17,null,h,k)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,k=h.length;f<k;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function R(A,N,v){let u=v&&v.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const I=(await N.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$3f)(I)?I:null}catch{u=null}if(!u){u=(0,D.$4f)();try{await N.writeFile(A.serviceMachineIdResource,L.$Fd.fromString(u))}catch{}}return v?.store("storage.serviceMachineId",u,-1,1),u}e.$2o=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class L{constructor(R,A=[],N=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$yh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const D=[];var R;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(v,u,l){u instanceof L.$yh||(u=new L.$yh(u,[],!!l)),D.push([v,u])}e.$mr=A;function N(){return D}e.$nr=N}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$4p=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const v=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(N);v.outgoing.set(u.key,u),u.incoming.set(v.key,v)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const v of this.a.values())v.outgoing.delete(N),v.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let v=this.a.get(N);return v||(v=new L(N,A),this.a.set(N,v)),v}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,v]of this.a)A.push(`${N}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const v=new Set([A]),u=this.c(N,v);if(u)return u}}c(A,N){for(const[v,u]of A.outgoing){if(N.has(v))return[...N,v].join(" -> ");N.add(v);const l=this.c(u,N);if(l)return l;N.delete(v)}}}e.$5p=D}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,R.$Bh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$9h=A;function N(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$0h=N;var v;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=u;function l(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$_h=l;function I(h,f){const k=Object.create(null);for(const p in h)O(k,p,h[p],f);return k}e.$ai=I;function O(h,f,k,p){const b=f.split("."),t=b.pop();let a=h;for(let i=0;i<b.length;i++){const s=b[i];let n=a[s];switch(typeof n){case"undefined":n=a[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${b.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[t]=k}catch{p(`Ignoring ${f} as ${b.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${f} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.$bi=O;function d(h,f){const k=f.split(".");g(h,k)}e.$ci=d;function g(h,f){const k=f.shift();if(f.length===0){delete h[k];return}if(Object.keys(h).indexOf(k)!==-1){const p=h[k];typeof p=="object"&&!Array.isArray(p)&&(g(p,f),Object.keys(p).length===0&&delete h[k])}}function y(h,f,k){function p(a,i){let s=a;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const b=f.split("."),t=p(h,b);return typeof t>"u"?k:t}e.$di=y;function w(h,f,k){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$lf(h[p])&&L.$lf(f[p])?w(h[p],f[p],k):k&&(h[p]=f[p]):h[p]=f[p])})}e.$ei=w;function $(h){return h.replace(/[\[\]]/g,"")}e.$fi=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,D,R,A,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$G),u.set("isFirefox",L.$E),u.set("isChrome",L.$D),u.set("isSafari",L.$F);function l(z,o){if(u.get(z)!==void 0)throw(0,v.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,o)}e.$Gi=l;const I=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const d={regexParsingWithErrorRecovery:!0},g=(0,N.localize)(0,null),y=(0,N.localize)(1,null),w=(0,N.localize)(2,null),$=(0,N.localize)(3,null),h=(0,N.localize)(4,null),f=(0,N.localize)(5,null),k=(0,N.localize)(6,null),p=(0,N.localize)(7,null);class b{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(o=d){this.k=o,this.d=new R.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(o){if(o===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(o).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const F=this.D(),C=F.type===17?f:void 0;throw this.h.push({message:h,offset:F.offset,lexeme:R.$Fi.getLexeme(F),additionalInfo:C}),b.c}return m}catch(m){if(m!==b.c)throw m;return}}l(){return this.m()}m(){const o=[this.o()];for(;this.y(16);){const m=this.o();o.push(m)}return o.length===1?o[0]:t.or(...o)}o(){const o=[this.s()];for(;this.y(15);){const m=this.s();o.push(m)}return o.length===1?o[0]:t.and(...o)}s(){if(this.y(2)){const o=this.D();switch(o.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(o.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",o)}}return this.t()}t(){const o=this.D();switch(o.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=o.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Y=C.lexeme,W=Y.lastIndexOf("/"),ce=W===Y.length-1?void 0:this.w(Y.substring(W+1));let oe;try{oe=new RegExp(Y.substring(1,W),ce)}catch{throw this.B("REGEX",C)}return le.create(m,oe)}switch(C.type){case 10:case 19:{const Y=[C.lexeme];this.z();let W=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Y.push(R.$Fi.getLexeme(W)),this.z(),W=this.D()}const oe=Y.join(""),pe=oe.lastIndexOf("/"),de=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let ge;try{ge=new RegExp(oe.substring(1,pe),de)}catch{throw this.B("REGEX",C)}return t.regex(m,ge)}case 18:{const Y=C.lexeme;this.z();let W=null;if(!(0,D.$me)(Y)){const ce=Y.indexOf("/"),oe=Y.lastIndexOf("/");if(ce!==oe&&ce>=0){const pe=Y.slice(ce+1,oe),de=Y[oe+1]==="i"?"i":"";try{W=new RegExp(pe,de)}catch{throw this.B("REGEX",C)}}}if(W===null)throw this.B("REGEX",C);return le.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const C=this.u();return t.notIn(m,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return t.equals(m,C);switch(C){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return t.notEquals(m,C);switch(C){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,C)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ae.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),ue.create(m,this.u());case 13:return this.z(),t.in(m,this.u());default:return t.has(m)}}case 20:throw this.h.push({message:k,offset:o.offset,lexeme:"",additionalInfo:p}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const o=this.D();switch(o.type){case 17:case 18:return this.z(),o.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(o){return o.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(o){return this.C(o)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(o,m){if(this.C(o))return this.z();throw this.B(m,this.D())}B(o,m,F){const C=(0,N.localize)(8,null,o,R.$Fi.getLexeme(m)),Y=m.offset,W=R.$Fi.getLexeme(m);return this.h.push({message:C,offset:Y,lexeme:W,additionalInfo:F}),b.c}C(o){return this.D().type===o}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=b;class t{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(o){return c.create(o)}static equals(o,m){return P.create(o,m)}static notEquals(o,m){return j.create(o,m)}static regex(o,m){return le.create(o,m)}static in(o,m){return S.create(o,m)}static notIn(o,m){return E.create(o,m)}static not(o){return H.create(o)}static and(...o){return G.create(o,null,!0)}static or(...o){return T.create(o,null,!0)}static greater(o,m){return _.create(o,m)}static greaterEquals(o,m){return ue.create(o,m)}static smaller(o,m){return te.create(o,m)}static smallerEquals(o,m){return ae.create(o,m)}static{this.c=new b({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this.c.parse(o)}}e.$Ii=t;function a(z){const o=new b({regexParsingWithErrorRecovery:!1});return z.map(m=>(o.parse(m),o.lexingErrors.length>0?o.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,N.localize)(9,null,F.additionalInfo):(0,N.localize)(10,null),offset:F.offset,length:F.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Ji=a;function i(z,o){const m=z?z.substituteConstants():void 0,F=o?o.substituteConstants():void 0;return!m&&!F?!0:!m||!F?!1:m.equals(F)}e.$Ki=i;function s(z,o){return z.cmp(o)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.$Li=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return n.INSTANCE}}e.$Mi=r;class c{static create(o,m=null){const F=u.get(o);return typeof F=="boolean"?F?r.INSTANCE:n.INSTANCE:new c(o,m)}constructor(o,m){this.key=o,this.c=m,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:q(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:n.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Ni=c;class P{static create(o,m,F=null){if(typeof m=="boolean")return m?c.create(o,F):H.create(o,F);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?r.INSTANCE:n.INSTANCE:new P(o,m,F)}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(o){return o.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(o){return o.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Oi=P;class S{static create(o,m){return new S(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=10,this.c=null}cmp(o){return o.type!==this.type?this.type-o.type:X(this.d,this.f,o.d,o.f)}equals(o){return o.type===this.type?this.d===o.d&&this.f===o.f:!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.f),F=o.getValue(this.d);return Array.isArray(m)?m.includes(F):typeof F=="string"&&typeof m=="object"&&m!==null?I.call(m,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(o){return o.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Pi=S;class E{static create(o,m){return new E(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=11,this.c=S.create(o,m)}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(o){return o.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=E;class j{static create(o,m,F=null){if(typeof m=="boolean")return m?H.create(o,F):c.create(o,F);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?n.INSTANCE:r.INSTANCE:new j(o,m,F)}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(o){return o.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ri=j;class H{static create(o,m=null){const F=u.get(o);return typeof F=="boolean"?F?n.INSTANCE:r.INSTANCE:new H(o,m)}constructor(o,m){this.c=o,this.d=m,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:q(this.c,o.c)}equals(o){return o.type===this.type?this.c===o.c:!1}substituteConstants(){const o=u.get(this.c);return typeof o=="boolean"?o?n.INSTANCE:r.INSTANCE:this}evaluate(o){return!o.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(o){return o.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$Si=H;function x(z,o){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?o(z):n.INSTANCE}class _{static create(o,m,F=null){return x(m,C=>new _(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ti=_;class ue{static create(o,m,F=null){return x(m,C=>new ue(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Ui=ue;class te{static create(o,m,F=null){return x(m,C=>new te(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Vi=te;class ae{static create(o,m,F=null){return x(m,C=>new ae(o,C,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Wi=ae;class le{static create(o,m){return new le(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=7,this.c=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.d<o.d)return-1;if(this.d>o.d)return 1;const m=this.f?this.f.source:"",F=o.f?o.f.source:"";return m<F?-1:m>F?1:0}equals(o){if(o.type===this.type){const m=this.f?this.f.source:"",F=o.f?o.f.source:"";return this.d===o.d&&m===F}return!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const o=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${o}`}keys(){return[this.d]}map(o){return o.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Xi=le;class ie{static create(o){return new ie(o)}constructor(o){this.c=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(o){return new ie(this.c.map(o))}negate(){return this.c}}e.$Yi=ie;function B(z){let o=null;for(let m=0,F=z.length;m<F;m++){const C=z[m].substituteConstants();if(z[m]!==C&&o===null){o=[];for(let Y=0;Y<m;Y++)o[Y]=z[Y]}o!==null&&(o[m]=C)}return o===null?z:o}class G{static create(o,m,F){return G.d(o,m,F)}constructor(o,m){this.expr=o,this.c=m,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const C=s(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=B(this.expr);return o===this.expr?this:G.create(o,this.c,!1)}evaluate(o){for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].evaluate(o))return!1;return!0}static d(o,m,F){const C=[];let Y=!1;for(const W of o)if(W){if(W.type===1){Y=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){C.push(...W.expr);continue}C.push(W)}if(C.length===0&&Y)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];for(;C.length>1;){const W=C[C.length-1];if(W.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,pe=T.create(W.expr.map(de=>G.create([de,ce],null,F)),null,oe);pe&&(C.push(pe),C.sort(s))}if(C.length===1)return C[0];if(F){for(let W=0;W<C.length;W++)for(let ce=W+1;ce<C.length;ce++)if(C[W].negate().equals(C[ce]))return n.INSTANCE;if(C.length===1)return C[0]}return new G(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new G(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());this.c=T.create(o,this,!0)}return this.c}}e.$Zi=G;class T{static create(o,m,F){return T.d(o,m,F)}constructor(o,m){this.expr=o,this.c=m,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const C=s(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=B(this.expr);return o===this.expr?this:T.create(o,this.c,!1)}evaluate(o){for(let m=0,F=this.expr.length;m<F;m++)if(this.expr[m].evaluate(o))return!0;return!1}static d(o,m,F){let C=[],Y=!1;if(o){for(let W=0,ce=o.length;W<ce;W++){const oe=o[W];if(oe){if(oe.type===0){Y=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Y)return n.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];if(F){for(let W=0;W<C.length;W++)for(let ce=W+1;ce<C.length;ce++)if(C[W].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new T(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());for(;o.length>1;){const m=o.shift(),F=o.shift(),C=[];for(const Y of U(m))for(const W of U(F))C.push(G.create([Y,W],null,!1));o.unshift(T.create(C,null,!1))}this.c=T.create(o,this,!0)}return this.c}}e.$1i=T;class M extends c{static{this.d=[]}static all(){return M.d.values()}constructor(o,m,F){super(o,null),this.f=m,typeof F=="object"?M.d.push({...F,key:o}):F!==!0&&M.d.push({key:o,description:F,type:m!=null?typeof m:void 0})}bindTo(o){return o.createKey(this.key,this.f)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return P.create(this.key,o)}notEqualsTo(o){return j.create(this.key,o)}}e.$2i=M,e.$3i=(0,A.$Bh)("contextKeyService");function q(z,o){return z<o?-1:z>o?1:0}function X(z,o,m,F){return z<m?-1:z>m?1:o<F?-1:o>F?1:0}function Z(z,o){if(z.type===0||o.type===1)return!0;if(z.type===9)return o.type===9?K(z.expr,o.expr):!1;if(o.type===9){for(const m of o.expr)if(Z(z,m))return!0;return!1}if(z.type===6){if(o.type===6)return K(o.expr,z.expr);for(const m of z.expr)if(Z(m,o))return!0;return!1}return z.equals(o)}e.$4i=Z;function K(z,o){let m=0,F=0;for(;m<z.length&&F<o.length;){const C=z[m].cmp(o[F]);if(C<0)return!1;C===0&&m++,F++}return m===z.length}function U(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=void 0,e.$Dn=(0,L.$Bh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,L.$Bh)("environmentService"),e.$Jh=(0,L.$Ch)(e.$Ih)}),define(ne[21],re([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=R;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=A;function N(f,k){switch(f){case 3:return k==="x64"?"win32-x64":k==="ia32"?"win32-ia32":k==="arm64"?"win32-arm64":"unknown";case 2:return k==="x64"?"linux-x64":k==="arm64"?"linux-arm64":k==="arm"?"linux-armhf":"unknown";case"alpine":return k==="x64"?"alpine-x64":k==="arm64"?"alpine-arm64":"unknown";case 1:return k==="x64"?"darwin-x64":k==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=N;function v(f,k){return k==="web"&&!f.includes("web")}e.$Vn=v;function u(f,k,p){return v(k,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:l(p).includes(f)}e.$Wn=u;function l(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=l;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Yn=I;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var g;(function(f){f.Install="install",f.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var y;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Zn=(0,D.$Bh)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(k,p){super(k),this.code=p,this.name=p}}e.$1n=h,e.$2n=(0,D.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,D.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,D.$Bh)("IExtensionTipsService"),e.$7n=(0,L.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=void 0,e.$7o=(0,L.$Bh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,N)=>J(["node-vsce-sign"],async v=>A(v),N))),this.a}async verify(A,N,v){let u;try{u=await this.b()}catch{return!1}return u.verify(A,N,v)}}e.$8o=D}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function N(I,O,d,g,y,w){let $;try{await v(I,O,d,g,y,w)}catch(h){$=h}finally{$&&y.errorTransformer&&($=y.errorTransformer($)),typeof $<"u"&&d.error($),d.end()}}e.$Cp=N;async function v(I,O,d,g,y,w){u(w);const $=await I.open(O,{create:!1});try{u(w);let h=0,f=0,k=y&&typeof y.length=="number"?y.length:void 0,p=L.$Fd.alloc(Math.min(y.bufferSize,typeof k=="number"?k:y.bufferSize)),b=y&&typeof y.position=="number"?y.position:0,t=0;do f=await I.read($,b,p.buffer,t,p.byteLength-t),b+=f,t+=f,h+=f,typeof k=="number"&&(k-=f),t===p.byteLength&&(await d.write(g(p)),p=L.$Fd.alloc(Math.min(y.bufferSize,typeof k=="number"?k:y.bufferSize)),t=0);while(f>0&&(typeof k!="number"||k>0)&&u(w)&&l(h,y));if(t>0){let a=t;typeof k=="number"&&(a=Math.min(t,k)),d.write(g(p.slice(0,a)))}}catch(h){throw(0,A.$gk)(h)}finally{await I.close($)}}function u(I){if(I.isCancellationRequested)throw(0,D.$4)();return!0}function l(I,O){if(typeof O?.limits?.size=="number"&&I>O.limits.size)throw(0,A.$fk)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class v extends R.$kc{constructor(){super(...arguments),this.a=this.B(new L.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$fd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(l){const I=this.j(l),O=I.filter(g=>{const y=this.c.get(g.path);return y?!(0,D.$vj)(y.request.excludes,g.excludes)||!(0,D.$vj)(y.request.includes,g.includes):!0}),d=Array.from(this.c.values()).filter(({request:g})=>!I.find(y=>y.path===g.path&&(0,D.$vj)(y.excludes,g.excludes)&&(0,D.$vj)(y.includes,g.includes))).map(({request:g})=>g.path);O.length&&this.m(`Request to start watching: ${O.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const g of d)this.h(g);for(const g of O)this.g(g)}g(l){const I=new N.$Yp(l,d=>this.a.fire(d),d=>this.b.fire(d),this.f),O={request:l,instance:I};this.c.set(l.path,O)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const I=this.c.get(l);I&&(this.c.delete(l),I.instance.dispose())}j(l){const I=new Map;for(const O of l){const d=A.$k?O.path:O.path.toLowerCase();I.set(d,O)}return Array.from(I.values())}async setVerboseLogging(l){this.f=l;for(const[,I]of this.c)I.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,I){return I?`[File Watcher (node.js)] ${l} (path: ${I.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$1p=v}),define(ne[118],re([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class R extends L.$Gp{constructor(N,v,u){super(N,v,u),this.s()}r(N){return N.add(new D.$1p)}}e.$2p=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class N extends A.$Hp{constructor(u,l,I){super(u,l,I),this.s()}r(u){const l=u.add(new R.$Sp(L.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:I,signal:O})=>this.t(`terminated by itself with code ${I}, signal: ${O}`))),D.ProxyChannel.toService((0,D.$ih)(l.getChannel("watcher")))}}e.$Tp=N}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,N]of R)this.set(A,N)}set(R,A){const N=this.a.get(R);return this.a.set(R,A),N}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$zh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const I=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class d{constructor($=new u.$zh,h=!1,f,k=I){this.f=$,this.g=h,this.h=f,this.i=k,this.o=new Set,this.f.set(v.$Ah,this),this._globalGraph=k?f?._globalGraph??new N.$5p(p=>p):void 0}createChild($){return new d($,this.g,this,this.i)}invokeFunction($,...h){const f=y.traceInvocation(this.i,$);let k=!1;try{return $({get:b=>{if(k)throw(0,D.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(b,f);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...h)}finally{k=!0,f.stop()}}createInstance($,...h){let f,k;return $ instanceof A.$yh?(f=y.traceCreation(this.i,$.ctor),k=this.j($.ctor,$.staticArguments.concat(h),f)):(f=y.traceCreation(this.i,$),k=this.j($,h,f)),f.stop(),k}j($,h=[],f){const k=v._util.getServiceDependencies($).sort((t,a)=>t.index-a.index),p=[];for(const t of k){const a=this.m(t.id,f);a||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const b=k.length>0?k[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${$.name} at position ${b+1} conflicts with ${h.length} static arguments`);const t=b-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,b)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$yh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$yh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const k=new N.$5p(t=>t.id.toString());let p=0;const b=[{id:$,desc:h,_trace:f}];for(;b.length;){const t=b.pop();if(k.lookupOrInsertNode(t),p++>1e3)throw new O(k);for(const a of v._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${$} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.$yh){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};k.insertEdge(t,s),b.push(s)}}}for(;;){const t=k.roots();if(t.length===0){if(!k.isEmpty())throw new O(k);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$yh){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}k.removeNode(a)}}return this.l($)}s($,h,f=[],k,p){if(this.f.get($)instanceof A.$yh)return this.t($,h,f,k,p);if(this.h)return this.h.s($,h,f,k,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],k,p){if(k){const b=new d(void 0,this.g,this,this.i);b.c=String($);const t=new Map,a=new L.$Xg(()=>{const i=b.j(h,f,p);for(const[s,n]of t){const r=i[s];if(typeof r=="function")for(const c of n)r.apply(i,c)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let c=t.get(s);return c||(c=new l.$tc,t.set(s,c)),(S,E,j)=>{const H=c.push([S,E,j]);return(0,R.$ic)(H)}}if(s in i)return i[s];const n=a.value;let r=n[s];return typeof r!="function"||(r=r.bind(n),i[s]=r),r},set(i,s,n){return a.value[s]=n,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$6p=d;var g;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(g||(g={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new y(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation($,h){return $?new y(1,h.name):y.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new y(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;y.f+=$;let h=!1;function f(p,b){const t=[],a=new Array(p+1).join("	");for(const[i,s,n]of b.h)if(s&&n){h=!0,t.push(`${a}CREATES -> ${i}`);const r=f(p+1,n);r&&t.push(r)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];($>2||h)&&y.all.add(k.join(`
`))}}e.$7p=y});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,D,R,A,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=void 0;function u(I){return I.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$Hq=u,e.$Iq=(0,v.$Bh)("languagePackService");let l=class extends D.$kc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$pd;setTimeout(()=>O.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const y=d.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],h=u(w);return{...this.f(h,$,w),extensionId:w.identifier.id,galleryExtension:w}});return y.push(this.f("en","English")),y}f(O,d,g){const y=d??O;let w;if(y!==O&&(w=`(${O})`),O.toLowerCase()===R.$v.toLowerCase()&&(w??="",w+=(0,A.localize)(0,null)),g?.installCount){w??="";const $=g.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),w+=` $(cloud-download) ${h}`}return{id:O,label:y,description:w}}};e.$Jq=l,e.$Jq=l=$e([se(0,N.$Zn)],l)}),define(ne[6],re([0,1,34,4,42,2,31,13,17,3,11,116,10]),function(J,e,L,D,R,A,N,v,u,l,I,O,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,d.$Bh)("logService"),e.$6i=(0,d.$Bh)("loggerService");function g(){return new Date().toISOString()}function y(S){return(0,l.$nf)(S)}e.$7i=y;var w;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8i=w.Info;function $(S,E,j){switch(E){case w.Trace:S.trace(j);break;case w.Debug:S.debug(j);break;case w.Info:S.info(j);break;case w.Warning:S.warn(j);break;case w.Error:S.error(j);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function h(S,E=!1){let j="";for(let H=0;H<S.length;H++){let x=S[H];if(x instanceof Error&&(x=(0,L.$mi)(x,E)),typeof x=="object")try{x=JSON.stringify(x)}catch{}j+=(H>0?" ":"")+x}return j}class f extends A.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new D.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$0i=f;class k extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...j){this.f(w.Trace)&&this.g(w.Trace,h([E,...j],!0))}debug(E,...j){this.f(w.Debug)&&this.g(w.Debug,h([E,...j]))}info(E,...j){this.f(w.Info)&&this.g(w.Info,h([E,...j]))}warn(E,...j){this.f(w.Warning)&&this.g(w.Warning,h([E,...j]))}error(E,...j){if(this.f(w.Error))if(E instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=E.stack,this.g(w.Error,h(H))}else this.g(w.Error,h([E,...j]))}flush(){}}e.$$i=k;class p extends f{constructor(E=e.$8i){super(),this.setLevel(E),this.g=!v.$i}trace(E,...j){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,E,...j):console.log(`[main ${g()}]`,E,...j))}debug(E,...j){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,E,...j):console.log(`[main ${g()}]`,E,...j))}info(E,...j){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,E,...j):console.log(`[main ${g()}]`,E,...j))}warn(E,...j){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,E,...j):console.warn(`[main ${g()}]`,E,...j))}error(E,...j){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,E,...j):console.error(`[main ${g()}]`,E,...j))}dispose(){}flush(){}}e.$_i=p;class b extends f{constructor(E=e.$8i,j=!0){super(),this.g=j,this.setLevel(E)}trace(E,...j){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...j):console.log(E,...j))}debug(E,...j){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...j):console.log(E,...j))}info(E,...j){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...j):console.log(E,...j))}warn(E,...j){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...j):console.log(E,...j))}error(E,...j){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...j):console.error(E,...j))}dispose(){}flush(){}}e.$aj=b;class t extends f{constructor(E,j=e.$8i){super(),this.g=E,this.setLevel(j)}trace(E,...j){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...j])}debug(E,...j){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...j])}info(E,...j){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...j])}warn(E,...j){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...j])}error(E,...j){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...j])}h(E){return typeof E=="string"?E:(0,L.$mi)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$bj=t;class a extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const j of this.g)j.setLevel(E);super.setLevel(E)}trace(E,...j){for(const H of this.g)H.trace(E,...j)}debug(E,...j){for(const H of this.g)H.debug(E,...j)}info(E,...j){for(const H of this.g)H.info(E,...j)}warn(E,...j){for(const H of this.g)H.warn(E,...j)}error(E,...j){for(const H of this.g)H.error(E,...j)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$cj=a;class i extends A.$kc{constructor(E,j,H){if(super(),this.h=E,this.j=j,this.b=new N.$zi,this.c=this.B(new D.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeVisibility=this.g.event,H)for(const x of H)this.b.set(x.resource,{logger:void 0,info:x})}m(E){return(0,l.$jf)(E)?[...this.b.values()].find(j=>j.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,j){const H=this.n(E),x=(0,l.$jf)(E)?E:j?.id??(0,R.$pi)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const ue=j?.logLevel==="always"?w.Trace:j?.logLevel;_||(_=this.s(H,ue??this.getLogLevel(H)??this.h,{...j,id:x}));const te={logger:_,info:{resource:H,id:x,logLevel:ue,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(te.info),this.b.set(H,te),_}n(E){return(0,l.$jf)(E)?(0,u.$ig)(this.j,`${E}.log`):E}setLogLevel(E,j){if(I.URI.isUri(E)){const H=E,x=j,_=this.b.get(H);_&&x!==_.info.logLevel&&(_.info.logLevel=x===this.h?void 0:x,_.logger?.setLevel(x),this.b.set(_.info.resource,_),this.f.fire([H,x]))}else{this.h=E;for(const[H,x]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,j){const H=this.m(E);H&&j!==!H.info.hidden&&(H.info.hidden=!j,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,j]))}getLogLevel(E){let j;return E&&(j=this.b.get(E)?.info.logLevel),j??this.h}registerLogger(E){const j=this.b.get(E.resource);j?j.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const j=this.b.get(E);j&&(j.logger&&j.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=i;class s{constructor(){this.onDidChangeLogLevel=new D.$fd().event}setLevel(E){}getLevel(){return w.Info}trace(E,...j){}debug(E,...j){}info(E,...j){}warn(E,...j){}error(E,...j){}critical(E,...j){}dispose(){}flush(){}}e.$ej=s;class n extends s{}e.$fj=n;function r(S){if(S.verbose)return w.Trace;if(typeof S.logLevel=="string"){const E=P(S.logLevel.toLowerCase());if(E!==void 0)return E}return e.$8i}e.$gj=r;function c(S){switch(S){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$hj=c;function P(S){switch(S){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$ij=P,e.$jj=new O.$2i("logLevel",c(w.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class I extends N.$kc{constructor(d,g){super(),this.a=d,this.b=g,this.c=this.B(new A.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Eg(0)),this.w=[],this.y=this.B(new D.$Eg(0))}watch(d,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(d,g):this.z(d,g)}n(d,g){const y={path:this.H(d),excludes:g.excludes,includes:g.includes,recursive:g.recursive},w=(0,L.$Sb)(this.j,y);return this.r(),(0,N.$ic)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$Y)(d))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,u.$Ip)(g)),g=>this.G(g),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const g of this.j)(0,u.$Ep)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const g of this.j)(0,u.$Ep)(g)&&d.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,g){const y={path:this.H(d),excludes:g.excludes,includes:g.includes,recursive:!1},w=(0,L.$Sb)(this.w,y);return this.C(),(0,N.$ic)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$Y)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$Ip)(d)),d=>this.G(d),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,v.$7d)(d.fsPath)}}e.$Mp=I}),define(ne[122],re([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,12,61,6,9]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let p=class extends l.$kc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new N.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$Pg)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new l.$jc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.X.fire(new $.$lk(s,!this.S(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.Y.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,l.$ic)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,l.$fc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await D.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,g.$mg)(t))throw new $.$nk((0,w.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new k.$_;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,$.$$j)(a)||(0,$.$8j)(a)||(0,$.$_j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,$.$$j)(a)||(0,$.$8j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,$.$ik)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$nk((0,w.localize)(2,null,this.rb(t)),1):(0,$.$gk)(i)}}async s(t,a){const i=await this.j(t),s=this.S(i),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,P=await i.stat(t);let S;return this.t(i,t,P,void 0,!!c,(E,j)=>(S||(S=I.$Hh.forUris(()=>!s),S.set(t,!0),n&&S.fill(!0,n)),S.get(E.resource)||S.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&r?j===1:!1))}async t(t,a,i,s,n,r){const{providerExtUri:c}=this.R(t),P={resource:a,name:c.basename(a),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$yk)({mtime:i.mtime,size:i.size}),children:void 0};if(P.isDirectory&&r(P,s)){try{const S=await t.readdir(a),E=await D.Promises.settled(S.map(async([j,H])=>{try{const x=c.joinPath(a,j),_=n?await t.stat(x):{type:H};return await this.t(t,x,_,S.length,n,r)}catch(x){return this.b.trace(x),null}}));P.children=(0,L.$Fb)(E)}catch(S){this.b.trace(S),P.children=[]}return P}return P}async resolveAll(t){return D.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new $.$nk((0,w.localize)(3,null,this.rb(t)),3,a)}async createFile(t,a=R.$Fd.fromString(""),i){await this.u(t,i);const s=await this.writeFile(t,a);return this.r.fire(new $.$kk(t,0,s)),s}async writeFile(t,a,i){const s=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(s);try{await this.w(s,t,i)||await this.U(s,n.dirname(t));let c;if((0,$.$8j)(s)&&!(a instanceof R.$Fd))if((0,y.$rd)(a)){const P=await(0,y.$yd)(a,3);P.ended?c=R.$Fd.concat(P.buffer):c=P}else c=(0,y.$vd)(a,P=>R.$Fd.concat(P),3);else c=a;if(!(0,$.$$j)(s)||(0,$.$8j)(s)&&c instanceof R.$Fd)await this.gb(s,t,i,c);else{const P=c instanceof R.$Fd?(0,R.$Qd)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.bb(s,t,(0,g.$ig)((0,g.$hg)(t),`${(0,g.$fg)(t)}${i.atomic.postfix}`),i,P):await this.cb(s,t,i,P)}this.r.fire(new $.$kk(t,4))}catch(r){throw new $.$nk((0,w.localize)(4,null,this.rb(t),(0,$.$gk)(r).toString()),(0,$.$jk)(r),i)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const s=!!i?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(a)));if(s)throw new Error((0,w.localize)(7,null,this.rb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&$.FileType.Directory)throw new $.$nk((0,w.localize)(8,null,this.rb(a)),0,i);if(this.qb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$xk&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$yk)({mtime:i.mtime,size:r.size}))throw new $.$nk((0,w.localize)(9,null),3,i);return r}async readFile(t,a,i){const s=await this.m(t);return a?.atomic?this.z(s,t,a,i):this.C(s,t,a,i)}async z(t,a,i,s){return new Promise((n,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const c=await this.C(t,a,i,s);n(c)}catch(c){r(c)}})})}async C(t,a,i,s){const n=await this.D(t,a,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,R.$Rd)(n.value)}}async readFileStream(t,a,i){const s=await this.m(t);return this.D(s,t,a,i)}async D(t,a,i,s){const n=new A.$pd(s),r=this.J(a,i).then(P=>P,P=>{throw n.dispose(!0),P});let c;try{return typeof i?.etag=="string"&&i.etag!==$.$xk&&await r,i?.atomic&&(0,$.$ak)(t)||!((0,$.$$j)(t)||(0,$.$_j)(t))||(0,$.$8j)(t)&&i?.preferUnbuffered?c=this.I(t,a,i):(0,$.$_j)(t)?c=this.G(t,a,n.token,i):c=this.H(t,a,n.token,i),c.on("end",()=>n.dispose()),c.on("error",()=>n.dispose()),{...await r,value:c}}catch(P){throw c&&await(0,y.$wd)(c),this.F(P,a,i)}}F(t,a,i){const s=(0,w.localize)(10,null,this.rb(a),(0,$.$gk)(t).toString());return t instanceof $.$pk?new $.$pk(s,t.stat,i):t instanceof $.$ok?new $.$ok(s,t.fileOperationResult,t.size,t.options):new $.$nk(s,(0,$.$jk)(t),i)}G(t,a,i,s=Object.create(null)){const n=t.readFileStream(a,s,i);return(0,y.$Cd)(n,{data:r=>r instanceof R.$Fd?r:R.$Fd.wrap(r),error:r=>this.F(r,a,s)},r=>R.$Fd.concat(r))}H(t,a,i,s=Object.create(null)){const n=(0,R.$Vd)();return(0,h.$Cp)(t,a,n,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.F(r,a,s)},i),n}I(t,a,i){const s=(0,y.$td)(n=>R.$Fd.concat(n));return(async()=>{try{let n;i?.atomic&&(0,$.$ak)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.L(a,n.byteLength,i),s.end(R.$Fd.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$nk((0,w.localize)(11,null,this.rb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==$.$xk&&a.etag===i.etag)throw new $.$pk((0,w.localize)(12,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new $.$ok((0,w.localize)(13,null,this.rb(t)),7,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,s){if(t.toString()!==a.toString())try{const n=i==="move"?this.pb(await this.n(t),t):await this.m(t),r=this.pb(await this.n(a),a);await this.Q(n,t,r,a,i,s)}catch(n){return n}return!0}async move(t,a,i){const s=this.pb(await this.n(t),t),n=this.pb(await this.n(a),a),r=await this.N(s,t,n,a,"move",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$kk(t,r==="move"?2:3,c)),c}async copy(t,a,i){const s=await this.m(t),n=this.pb(await this.n(a),a),r=await this.N(s,t,n,a,"copy",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$kk(t,r==="copy"?3:2,c)),c}async N(t,a,i,s,n,r){if(a.toString()===s.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:P}=await this.Q(t,a,i,s,n,r);if(c&&!P&&r&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,$.$9j)(t))await t.copy(a,s,{overwrite:r});else{const S=await this.resolve(a);S.isDirectory?await this.P(t,S,i,s):await this.O(t,a,i,s)}return n}else return t===i?(await t.rename(a,s,{overwrite:r}),n):(await this.N(t,a,i,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,s){if((0,$.$$j)(t)&&(0,$.$$j)(i))return this.ib(t,a,i,s);if((0,$.$$j)(t)&&(0,$.$8j)(i))return this.ob(t,a,i,s);if((0,$.$8j)(t)&&(0,$.$$j)(i))return this.mb(t,a,i,s);if((0,$.$8j)(t)&&(0,$.$8j)(i))return this.kb(t,a,i,s)}async P(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async n=>{const r=this.R(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),i,r):this.O(t,n.resource,i,r)}))}async Q(t,a,i,s,n,r){let c=!1;if(t===i){const{providerExtUri:S,isPathCaseSensitive:E}=this.R(t);if(E||(c=S.isEqual(a,s)),c&&n==="copy")throw new Error((0,w.localize)(14,null,this.rb(a),this.rb(s)));if(!c&&S.isEqualOrParent(s,a))throw new Error((0,w.localize)(15,null,this.rb(a),this.rb(s)))}const P=await this.exists(s);if(P&&!c){if(!r)throw new $.$nk((0,w.localize)(16,null,this.rb(a),this.rb(s)),4);if(t===i){const{providerExtUri:S}=this.R(t);if(S.isEqualOrParent(a,s))throw new Error((0,w.localize)(17,null,this.rb(a),this.rb(s)))}}return{exists:P,isSameResourceWithDifferentPathCase:c}}R(t){const a=this.S(t);return{providerExtUri:a?g.$$f:g.$ag,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.pb(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$kk(t,0,i)),i}async U(t,a){const i=[],{providerExtUri:s}=this.R(t);for(;!s.isEqual(a,s.dirname(a));)try{if(!((await t.stat(a)).type&$.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(a)));break}catch(n){if((0,$.$ik)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(a)),a=s.dirname(a)}for(let n=i.length-1;n>=0;n--){a=s.joinPath(a,i[n]);try{await t.mkdir(a)}catch(r){if((0,$.$ik)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.pb(await this.j(t),t),s=!!a?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(t)));const n=a?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(t)));if(s&&n)throw new Error((0,w.localize)(21,null,this.rb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.qb(t,r);else throw new $.$nk((0,w.localize)(22,null,this.rb(t)),1);if(!!!a?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(t)))}return i}async del(t,a){const i=await this.W(t,a),s=!!a?.useTrash,n=!!a?.recursive,r=a?.atomic??!1;await i.delete(t,{recursive:n,useTrash:s,atomic:r}),this.r.fire(new $.$kk(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.pb(await this.n(a),a);if(i===s&&this.R(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,$.$0j)(i))return i.cloneFile(t,a);await this.U(s,this.R(s).providerExtUri.dirname(a));const n=this.ab.queueFor(t,this.R(i).providerExtUri);return i===s&&(0,$.$9j)(i)?n.queue(()=>i.copy(t,a,{overwrite:!0})):n.queue(()=>this.O(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.$jc;let s=!1,n=()=>{s=!0};return i.add((0,l.$ic)(()=>n())),(async()=>{try{const r=await this.$(t,a);s?(0,l.$fc)(r):n=()=>(0,l.$fc)(r)}catch(r){this.b.error(r)}})(),i}async $(t,a){const i=await this.j(t),s=(0,v.$pi)([this.R(i).providerExtUri.getComparisonKey(t),a]);let n=this.Z.get(s);return n||(n={count:0,disposable:i.watch(t,a)},this.Z.set(s,n)),n.count+=1,(0,l.$ic)(()=>{n&&(n.count--,n.count===0&&((0,l.$fc)(n.disposable),this.Z.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,l.$fc)(t.disposable);this.Z.clear()}async bb(t,a,i,s,n){await this.cb(t,i,s,n);try{await t.rename(i,a,{overwrite:!0})}catch(r){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(t,a,i,s){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,y.$rd)(s)||(0,y.$sd)(s)?await this.db(t,n,s):await this.eb(t,n,s)}catch(r){throw(0,$.$gk)(r)}finally{await t.close(n)}})}async db(t,a,i){let s=0,n;if((0,y.$sd)(i)){if(i.buffer.length>0){const r=R.$Fd.concat(i.buffer);await this.fb(t,a,r,r.byteLength,s,0),s+=r.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((r,c)=>{(0,y.$xd)(n,{onData:async P=>{n.pause();try{await this.fb(t,a,P,P.byteLength,s,0)}catch(S){return c(S)}s+=P.byteLength,setTimeout(()=>n.resume())},onError:P=>c(P),onEnd:()=>r()})})}async eb(t,a,i){let s=0,n;for(;(n=i.read())!==null;)await this.fb(t,a,n,n.byteLength,s,0),s+=n.byteLength}async fb(t,a,i,s,n,r){let c=0;for(;c<s;){const P=await t.write(a,n+c,i.buffer,r+c,s-c);c+=P}}async gb(t,a,i,s){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){let n;s instanceof R.$Fd?n=s:(0,y.$rd)(s)?n=await(0,R.$Rd)(s):(0,y.$sd)(s)?n=await(0,R.$Sd)(s):n=(0,R.$Pd)(s),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async ib(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){let n,r;try{n=await t.open(a,{create:!1}),r=await i.open(s,{create:!0,unlock:!1});const c=R.$Fd.alloc(this.a);let P=0,S=0,E=0;do E=await t.read(n,P,c.buffer,S,c.byteLength-S),await this.fb(i,r,c,E,P,S),P+=E,S+=E,S===c.byteLength&&(S=0);while(E>0)}catch(c){throw(0,$.$gk)(c)}finally{await D.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async kb(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.lb(t,a,i,s))}async lb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.nb(t,a,i,s))}async nb(t,a,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.fb(i,n,R.$Fd.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$gk)(r)}finally{await i.close(n)}}async ob(t,a,i,s){const n=await(0,R.$Rd)(this.H(t,a,A.CancellationToken.None));await this.gb(i,s,void 0,n)}pb(t,a){if(t.capabilities&2048)throw new $.$nk((0,w.localize)(24,null,this.rb(a)),6);return t}qb(t,a){if((a.permissions??0)&$.FilePermission.Readonly)throw new $.$nk((0,w.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===O.Schemas.file?t.fsPath:t.toString(!0)}};e.$Dp=p,e.$Dp=p=$e([se(0,f.$5i)],p)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,41,24,101,12,61,121,34,119,118]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,k.$mi)(a)}`)}})();class t extends f.$Mp{static{this.I=!1}constructor(i,s){super(i,s),this.onDidChangeCapabilities=v.Event.None,this.N=new A.$zi(n=>d.$_f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,O.$k&&(this.J|=1024)),this.J}async stat(i){try{const{stat:s,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(i));return{type:this.M(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.eb(s)}}async L(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const s=await y.Promises.readdir(this.H(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async r=>{try{let c;r.isSymbolicLink()?c=(await this.stat((0,d.$ig)(i,r.name))).type:c=this.M(r),n.push([r.name,c])}catch(c){this.a.trace(c)}})),n}catch(s){throw this.eb(s)}}M(i,s){let n;return s?.dangling?n=$.FileType.Unknown:i.isFile()?n=$.FileType.File:i.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,s&&(n|=$.FileType.SymbolicLink),n}async O(i){const s=this.H(i);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.N.get(i);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const r=new R.$Fg;return this.N.set(i,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,l.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(i)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(i)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(i)})`),n=await this.O(i));const r=this.H(i);return await y.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{n?.dispose()}}P(i){t.I&&this.a.trace(i)}readFileStream(i,s,n){const r=(0,g.$td)(c=>N.$Fd.concat(c.map(P=>N.$Fd.wrap(P))).buffer);return(0,h.$Cp)(this,i,r,c=>c.buffer,{...s,bufferSize:256*1024},n),r}async writeFile(i,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(i,(0,d.$ig)((0,d.$hg)(i),`${(0,d.$fg)(i)}${n.atomic.postfix}`),s,n):this.R(i,s,n)}async Q(i,s,n,r){await this.R(s,n,r);try{await this.rename(s,i,{overwrite:!0})}catch(c){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async R(i,s,n){let r;try{const c=this.H(i);if(!n.create||!n.overwrite){if(await y.Promises.exists(c)){if(!n.overwrite)throw(0,$.$fk)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$fk)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(c){throw await this.fb(i,c)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(i){t.X=i}async open(i,s){const n=this.H(i);let r;(0,$.$7j)(s)&&(r=await this.O(i));let c;try{if((0,$.$7j)(s)&&s.unlock)try{const{stat:S}=await y.SymlinkSupport.stat(n);S.mode&128||await y.Promises.chmod(n,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let P;if((0,$.$7j)(s)){if(O.$i)try{await y.Promises.truncate(n,0),P="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}P||(P="w")}else P="r";c=await y.Promises.open(n,P)}catch(P){throw r?.dispose(),(0,$.$7j)(s)?await this.fb(i,P):this.eb(P)}if(this.S.set(c,0),(0,$.$7j)(s)&&this.W.set(c,i),r){const P=this.U.get(c);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${n})`),this.U.set(c,r),P&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${n})`),P.dispose())}return c}async close(i){const s=this.U.get(i);try{if(this.S.delete(i),this.W.delete(i)&&t.X)try{await y.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(i)}catch(n){throw this.eb(n)}finally{s&&(this.U.get(i)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.U.delete(i)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,r,c){const P=this.Y(i,s);let S=null;try{S=(await y.Promises.read(i,n,r,c,P)).bytesRead}catch(E){throw this.eb(E)}finally{this.Z(i,P,S)}return S}Y(i,s){return s===this.S.get(i)?null:s}Z(i,s,n){const r=this.S.get(i);typeof r=="number"&&(typeof s=="number"||(typeof n=="number"?this.S.set(i,r+n):this.S.delete(i)))}async write(i,s,n,r,c){return(0,R.$Yg)(()=>this.$(i,s,n,r,c),100,3)}async $(i,s,n,r,c){const P=this.Y(i,s);let S=null;try{S=(await y.Promises.write(i,n,r,c,P)).bytesWritten}catch(E){throw await this.fb(this.W.get(i),E)}finally{this.Z(i,P,S)}return S}async mkdir(i){try{await y.Promises.mkdir(this.H(i))}catch(s){throw this.eb(s)}}async delete(i,s){try{const n=this.H(i);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,I.$9d)((0,I.$_d)(n),`${(0,I.$ae)(n)}${s.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,r)}else try{await y.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let c=!1;try{const{stat:P,symbolicLink:S}=await y.SymlinkSupport.stat(n);c=P.isDirectory()&&!S}catch{}if(c)await y.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.eb(n)}}async rename(i,s,n){const r=this.H(i),c=this.H(s);if(r!==c)try{await this.ab(i,s,"move",n.overwrite),await y.Promises.rename(r,c)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,w.localize)(2,null,(0,I.$ae)(r),(0,I.$ae)((0,I.$_d)(c)),P.toString()))),this.eb(P)}}async copy(i,s,n){const r=this.H(i),c=this.H(s);if(r!==c)try{await this.ab(i,s,"copy",n.overwrite),await y.Promises.copy(r,c,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,w.localize)(3,null,(0,I.$ae)(r),(0,I.$ae)((0,I.$_d)(c)),P.toString()))),this.eb(P)}}async ab(i,s,n,r){const c=this.H(i),P=this.H(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,u.$Hf)(c,P,!0)),S){if(n==="copy")throw(0,$.$fk)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const j=await this.L(i);if(!j)throw(0,$.$fk)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(s);if(H){if(!r)throw(0,$.$fk)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);j.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,s){return this.bb(i,s,!1)}async bb(i,s,n){const r=this.H(i),c=this.H(s),P=!!(this.capabilities&1024);if((0,u.$Hf)(r,c,!P))return;const S=new l.$jc;try{const[E,j]=await Promise.all([this.O(i),this.O(s)]);S.add(E),S.add(j),n&&await y.Promises.mkdir((0,I.$_d)(c),{recursive:!0}),await y.Promises.copyFile(r,c)}catch(E){if(E.code==="ENOENT"&&!n)return this.bb(i,s,!0);throw this.eb(E)}finally{S.dispose()}}t(i,s,n){return new p.$Tp(r=>i(r),r=>s(r),n)}F(i,s,n){return new b.$2p(r=>i(r),r=>s(r),n)}eb(i){if(i instanceof $.$ek)return i;let s=i,n;switch(i.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$fk)(s,n)}async fb(i,s){let n=this.eb(s);if(i&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await y.SymlinkSupport.stat(this.H(i));r.mode&128||(n=(0,$.$fk)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$3p=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class R extends L.$kc{constructor(N,v=[]){super(),this.a=new D.$cj([N,...v]),this.B(N.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...v){this.a.trace(N,...v)}debug(N,...v){this.a.debug(N,...v)}info(N,...v){this.a.info(N,...v)}warn(N,...v){this.a.warn(N,...v)}error(N,...v){this.a.error(N,...v)}flush(){this.a.flush()}}e.$mN=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;var R;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(R||(R={}));async function A(l,I,O,d,g){try{const y=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});y.setFlushOn(R.Trace);const w=await y.createAsyncRotatingLogger(l,I,O,d);return g?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function N(l,I,O){switch(I){case D.LogLevel.Trace:l.trace(O);break;case D.LogLevel.Debug:l.debug(O);break;case D.LogLevel.Info:l.info(O);break;case D.LogLevel.Warning:l.warn(O);break;case D.LogLevel.Error:l.error(O);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function v(l,I){switch(I){case D.LogLevel.Trace:l.setLevel(R.Trace);break;case D.LogLevel.Debug:l.setLevel(R.Debug);break;case D.LogLevel.Info:l.setLevel(R.Info);break;case D.LogLevel.Warning:l.setLevel(R.Warning);break;case D.LogLevel.Error:l.setLevel(R.Error);break;case D.LogLevel.Off:l.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class u extends D.$$i{constructor(I,O,d,g,y){super(),this.m=[],this.setLevel(y),this.n=this.s(I,O,d,g),this.B(this.onDidChangeLogLevel(w=>{this.r&&v(this.r,w)}))}async s(I,O,d,g){const y=d?6:1,w=30/y*L.$Ak.MB,$=await A(I,O,w,y,g);if($){this.r=$,v(this.r,this.getLevel());for(const{level:h,message:f}of this.m)N(this.r,h,f);this.m=[]}}g(I,O){this.r?N(this.r,I,O):this.getLevel()<=I&&this.m.push({level:I,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;class A extends D.$dj{s(v,u,l){return new R.$bN((0,L.$4f)(),v.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.$cN=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,A.$Bh)("policy");class N extends R.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const I=Object.keys(this.f).length;return this.f={...l,...this.f},I!==Object.keys(this.f).length&&await this.j(l),D.Iterable.reduce(this.g.entries(),(O,[d,g])=>({...O,[d]:g}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(l,[I,O])=>({...l,[I]:{definition:O,value:this.g.get(I)}}),{})}}e.$$m=N;class v{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=v}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;function l(O,d){const g=[];for(const y of new Set(R.Iterable.concat(O.keys(),d.keys())))O.get(y)!==d.get(y)&&g.push(y);return g}let I=class extends u.$$m{constructor(d,g,y){super(),this.m=d,this.n=g,this.s=y,this.c=this.B(new L.$Eg(500));const w=D.Event.filter(g.onDidFilesChange,$=>$.affects(d));this.B(g.watch(d)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const g=await this.n.readFile(this.m),y=JSON.parse(g.value.toString());if(!(0,A.$lf)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&d.set(w,y[w])}catch(g){g.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",g)}return d}async w(){const d=await this.u(),g=l(this.g,d);this.g=d,g.length>0&&this.h.fire(g)}};e.$g7b=I,e.$g7b=I=$e([se(1,N.$6j),se(2,v.$5i)],I)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let v=class extends L.$$m{constructor(l,I){super(),this.m=l,this.n=I,this.a=new D.$Ag,this.b=this.B(new A.$lc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((I,O)=>{try{this.b.value=(0,R.createWatcher)(this.n,l,d=>{this.t(d),I()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),O(d)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const I in l){const O=l[I];O===void 0?this.g.delete(I):this.g.set(I,O)}this.h.fire(Object.keys(l))}};e.$f7b=v,e.$f7b=v=$e([se(0,N.$5i)],v)}),define(ne[32],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,L.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class R{constructor(){this.a=new Map}add(N,v){L.ok(D.$jf(N)),L.ok(D.$lf(v)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,v)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$8m=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function R(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this.b=new L.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,l){this.a[R(u)]=l,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;D.$8m.add(e.$9m.JSONContribution,N)}),define(ne[44],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var l;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$an={Configuration:"base.contributions.configuration"};var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const O=u.$8m.as(v.$9m.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$fd,this.onDidSchemaChange=this.i.event,this.j=new D.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),O.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),O.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),O.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:n}of t)for(const r in s)if(a.add(r),e.$kn.test(r)){const c=this.a.get(r),P=c?.valuesSources??new Map;if(n)for(const H of Object.keys(s[r]))P.set(H,n);const S={...c?.value||{},...s[r]};this.a.set(r,{source:n,value:S,valuesSources:P});const E=(0,N.$fi)(r),j={type:"object",default:S,description:A.localize(1,null,E),$ref:e.$hn,defaultDefaultValue:S,source:R.$jf(n)?void 0:n,defaultValueSource:n};i.push(...w(r)),this.d[r]=j,this.b.properties[r]=j}else{this.a.set(r,{value:s[r],source:n});const c=this.d[r];c&&(this.w(r,c),this.r(r,c))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const n in i){const r=this.a.get(n),c=R.$jf(s)?s:s?.id,P=R.$jf(r?.source)?r?.source:r?.source?.id;if(c===P)if(a.add(n),this.a.delete(n),e.$kn.test(n))delete this.d[n],delete this.b.properties[n];else{const S=this.d[n];S&&(this.w(n,S),this.r(n,S))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const n in s.properties){a.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,a=!0,i,s,n=3,r){n=R.$sf(t.scope)?n:t.scope;const c=t.properties;if(c)for(const S in c){const E=c[S];if(a&&k(S,E)){delete c[S];continue}if(E.source=i,E.defaultDefaultValue=c[S].default,this.w(S,E),e.$kn.test(S)?E.scope=void 0:(E.scope=R.$sf(E.scope)?n:E.scope,E.restricted=R.$sf(E.restricted)?!!s?.includes(S):E.restricted),c[S].hasOwnProperty("included")&&!c[S].included){this.f[S]=c[S],delete c[S];continue}else this.d[S]=c[S],c[S].policy?.name&&this.e.set(c[S].policy.name,S);!c[S].deprecationMessage&&c[S].markdownDeprecationMessage&&(c[S].deprecationMessage=c[S].markdownDeprecationMessage),r.add(S)}const P=t.allOf;if(P)for(const S of P)this.p(S,a,i,s,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const r in s)this.r(r,s[r]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$bn.properties[t]=a,a.scope){case 1:e.$cn.properties[t]=a;break;case 2:e.$dn.properties[t]=a;break;case 6:e.$en.properties[t]=a;break;case 3:e.$fn.properties[t]=a;break;case 4:e.$gn.properties[t]=a;break;case 5:e.$gn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$bn.properties[t],a.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$hn};this.w(a,i),e.$bn.properties[a]=i,e.$cn.properties[a]=i,e.$dn.properties[a]=i,e.$en.properties[a]=i,e.$fn.properties[a]=i,e.$gn.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,n=i?.source;R.$qf(s)&&(s=a.defaultDefaultValue,n=void 0),R.$qf(s)&&(s=h(a.type)),a.default=s,a.defaultValueSource=n}}const g="\\[([^\\]]+)\\]",y=new RegExp(g,"g");e.$jn=`^(${g})+$`,e.$kn=new RegExp(e.$jn);function w(b){const t=[];if(e.$kn.test(b)){let a=y.exec(b);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=y.exec(b)}}return(0,L.$Kb)(t)}e.$ln=w;function $(b){return b.reduce((t,a)=>`${t}[${a}]`,"")}e.$mn=$;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=h;const f=new d;u.$8m.add(e.$an.Configuration,f);function k(b,t){return b.trim()?e.$kn.test(b)?A.localize(7,null,b):f.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,b,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$on=k;function p(){const b=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))b.push([a,t[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.$pn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,44,36]),function(J,e,L,D,R,A,N,v,u,l,I,O,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function g(a){return Object.isFrozen(a)?a:v.$Wm(a)}class y{constructor(i={},s=[],n=[],r){this.b=i,this.c=s,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof y)return s;const n=new w("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,I.$di)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),r=s?this.rawConfiguration.getOverrideValue(i,s):void 0,c=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:r,merged:c}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,I.$di)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return L.$Kb(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return L.$Kb(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=v.$Vm(this.contents),n=v.$Vm(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const P of i)if(c.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(s,P.contents);for(const S of P.overrides){const[E]=n.filter(j=>L.$sb(j.identifiers,S.identifiers));E?(this.h(E.contents,S.contents),E.keys.push(...S.keys),E.keys=L.$Kb(E.keys)):n.push(v.$Vm(S))}for(const S of P.keys)r.indexOf(S)===-1&&r.push(S)}return new y(s,r,n,c.every(P=>P instanceof y)?void 0:c)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const r of L.$Kb([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r];const P=s[r];P&&(typeof c=="object"&&typeof P=="object"?(c=v.$Vm(c),this.h(c,P)):c=P),n[r]=c}return new y(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&u.$lf(i[n])&&u.$lf(s[n])){this.h(i[n],s[n]);continue}i[n]=v.$Vm(s[n])}}i(i){let s=null,n=null;const r=c=>{c&&(n?this.h(n,c):n=v.$Vm(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===i?s=c.contents:c.identifiers.includes(i)&&r(c.contents);return r(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,I.$ci)(this.contents,i),O.$kn.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>L.$sb(n.identifiers,(0,O.$ln)(i))),1))}j(i,s,n){(0,I.$bi)(this.contents,i,s,r=>console.error(r)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),O.$kn.test(i)&&this.overrides.push({identifiers:(0,O.$ln)(i),keys:Object.keys(this.contents[i]),contents:(0,I.$ai)(this.contents[i],r=>console.error(r))})}}e.$qn=y;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!u.$sf(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:r,overrides:c,restricted:P,hasExcludedProperties:S}=this.h(i,s);this.b=new y(n,r,c,S?[i]:void 0),this.c=P||[]}g(i){let s={},n=null,r=[];const c=[],P=[];function S(j){Array.isArray(r)?r.push(j):n!==null&&(r[n]=j)}const E={onObjectBegin:()=>{const j={};S(j),c.push(r),r=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const j=[];S(j),c.push(r),r=j,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:S,onError:(j,H,x)=>{P.push({error:j,offset:H,length:x})}};if(i)try{R.$Sm(i,E),s=r[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return s}h(i,s){const n=d.$8m.as(O.$an.Configuration).getConfigurationProperties(),r=this.i(i,n,!0,s);i=r.raw;const c=(0,I.$ai)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),P=Object.keys(i),S=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:c,keys:P,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,s,n,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:c};const P={},S=[];for(const E in i)if(O.$kn.test(E)&&n){const j=this.i(i[E],s,!1,r);P[E]=j.raw,c=c||j.hasExcludedProperties,S.push(...j.restricted)}else{const j=s[E],H=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&S.push(E),!r.exclude?.includes(E)&&(r.include?.includes(E)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&j?.restricted))?P[E]=i[E]:c=!0}return{raw:P,restricted:S,hasExcludedProperties:c}}j(i,s){const n=[];for(const r of Object.keys(i))if(O.$kn.test(r)){const c={};for(const P in i[r])c[P]=i[r][P];n.push({identifiers:(0,O.$ln)(r),keys:Object.keys(c),contents:(0,I.$ai)(c,s)})}return n}}e.$rn=w;class $ extends A.$kc{constructor(i,s,n,r){super(),this.c=i,this.f=s,this.g=r,this.b=this.B(new D.$fd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,c=>c.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=$;class h{constructor(i,s,n,r,c,P,S,E,j,H,x,_,ue){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=r,this.d=c,this.f=P,this.g=S,this.h=E,this.i=j,this.j=H,this.k=x,this.l=_,this.m=ue}get value(){return g(this.c)}n(i,s,n){const r=i.inspect(s,n);return{get value(){return g(r.value)},get override(){return g(r.override)},get merged(){return g(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,s,n,r,c=new y,P=new y,S=new N.$zi,E=new y,j=new N.$zi){this.c=i,this.d=s,this.f=n,this.g=r,this.h=c,this.i=P,this.j=S,this.l=E,this.m=j,this.a=null,this.b=new N.$zi,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new y,this.m.set(n.resource,r))):r=this.l,s===void 0?r.removeValue(i):r.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const r=this.q(i,s,n),c=this.u(s.resource,n),P=s.resource?this.m.get(s.resource)||this.l:this.l,S=new Set;for(const E of r.overrides)for(const j of E.identifiers)r.getOverrideValue(i,j)!==void 0&&S.add(j);return new h(i,s,r.getValue(i),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,c||void 0,P)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:r,updated:c,removed:P}=b(this.c,i);s=[...r,...c,...P]}for(const r of s)for(const c of(0,O.$ln)(r)){const P=this.c.getKeysForOverrideIdentifier(c),S=i.getKeysForOverrideIdentifier(c),E=[...S.filter(j=>P.indexOf(j)===-1),...P.filter(j=>S.indexOf(j)===-1),...P.filter(j=>!v.$Zm(this.c.override(c).getValue(j),i.override(c).getValue(j)))];n.push([c,E])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:r}=b(this.d,i),c=[...s,...n,...r];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.applicationConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateApplicationConfiguration(i),{keys:P,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.localUserConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateLocalUserConfiguration(i),{keys:P,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.remoteUserConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateRemoteUserConfiguration(i),{keys:P,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.workspaceConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateWorkspaceConfiguration(i),{keys:P,overrides:c}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:r,updated:c,removed:P,overrides:S}=b(n,s),E=[...r,...c,...P];return(E.length||!n)&&this.updateFolderConfiguration(i,s),{keys:E,overrides:S}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:c,overrides:P}=b(s,void 0);return{keys:[...n,...r,...c],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let r=this.r(s,n);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},s){let n=this.s();if(s&&i){const r=s.getFolder(i);r&&(n=this.t(r.uri)||n);const c=this.m.get(i);c&&(n=n.merge(c))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),r=this.j.get(i);r?(s=n.merge(r),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:r,keys:c}=this.j.get(s);return i.push([s,{contents:n,overrides:r,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),r=this.x(i.application),c=this.x(i.user),P=this.x(i.workspace),S=i.folders.reduce((E,j)=>(E.set(l.URI.revive(j[0]),this.x(j[1])),E),new N.$zi);return new f(s,n,r,c,new y,P,S,new y,new N.$zi)}static x(i){return new y(i.contents,i.keys,i.overrides)}}e.$tn=f;function k(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const r of a)r.keys.forEach(c=>i.add(c)),r.overrides.forEach(([c,P])=>{const S=(0,N.$wi)(s,c,new Set);P.forEach(E=>S.add(E))});const n=[];return s.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.$un=k;class p{constructor(i,s,n,r){this.change=i,this.f=s,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const P of c)this.affectedKeys.add(P);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,r=this.d.indexOf(n);if(r<0)return!1;const c=r+n.length;if(c>=this.d.length)return!1;const P=this.d.charCodeAt(c);if(P!==this.b&&P!==this.c)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,E=this.g.getValue(i,s,this.h);return!v.$Zm(S,E)}return!0}}e.$vn=p;function b(a,i){const{added:s,removed:n,updated:r}=t(i?.rawConfiguration,a?.rawConfiguration),c=[],P=a?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const E=S.filter(j=>!P.includes(j));for(const j of E)c.push([j,i.getKeysForOverrideIdentifier(j)])}if(a){const E=P.filter(j=>!S.includes(j));for(const j of E)c.push([j,a.getKeysForOverrideIdentifier(j)])}if(i&&a){for(const E of P)if(S.includes(E)){const j=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});c.push([E,[...j.added,...j.removed,...j.updated]])}}return{added:s,removed:n,updated:r,overrides:c}}function t(a,i){const s=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],n=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],r=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const P=(0,I.$di)(i.contents,c),S=(0,I.$di)(a.contents,c);v.$Zm(P,S)||r.push(c)}}return{added:s,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,44,6,38,36]),function(J,e,L,D,R,A,N,v,u,l,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class d extends R.$kc{constructor(){super(...arguments),this.a=this.B(new D.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$8m.as(u.$an.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,O.$8m.as(u.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new v.$qn;const $=O.$8m.as(u.$an.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const k of $){const p=f[k],b=h[k];p!==void 0?this.b.addValue(k,p):b?this.b.addValue(k,b.default):this.b.removeValue(k)}}}e.$wn=d;class g{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new v.$qn}async initialize(){return this.configurationModel}}e.$xn=g;let y=class extends R.$kc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new D.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],k=O.$8m.as(u.$an.Configuration).getConfigurationProperties();for(const p of $){const b=k[p];if(!b){f.push(p);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.g.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}f.push(p),h[b.policy.name]={type:b.type}}}return(0,N.$wf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=O.$8m.as(u.$an.Configuration).getPolicyConfigurations(),f=(0,L.$Fb)($.map(k=>h.get(k)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=O.$8m.as(u.$an.Configuration).getConfigurationProperties(),k=[],p=this.b.isEmpty();for(const b of $){const t=f[b]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,A.$Zm)(this.b.getValue(b),a))&&k.push([b,a])}else this.b.getValue(b)!==void 0&&k.push([b,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const b=this.b;this.b=new v.$qn;for(const t of b.keys)this.b.setValue(t,b.getValue(t));for(const[t,a]of k)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$yn=y,e.$yn=y=$e([se(1,I.$0m),se(2,l.$5i)],y)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class I extends R.$kc{constructor(d,g,y,w){super(),this.j=d,this.h=this.B(new D.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$wn),this.c=y instanceof l.$_m?new u.$xn:this.B(new u.$yn(this.b,y,w)),this.f=this.B(new v.$sn(this.j,{},A.$_f,g)),this.a=new v.$tn(this.b.configurationModel,this.c.configurationModel,new v.$qn,new v.$qn),this.g=this.B(new L.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,g,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$tn(d,g,new v.$qn,y)}getConfigurationData(){return this.a.toData()}getValue(d,g){const y=typeof d=="string"?d:void 0,w=(0,N.$9h)(d)?d:(0,N.$9h)(g)?g:{};return this.a.getValue(y,w,void 0)}updateValue(d,g,y,w){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const g=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(y,g,2)}n(d,g){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(d,g);this.s(w,y,7)}r(d){const g=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(d);this.s(y,g,7)}s(d,g,y){const w=new v.$vn(d,{data:g},this.a);w.source=y,w.sourceConfig=this.t(y),this.h.fire(w)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=I}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function D(l){return l.scheme===L.Schemas.vscodeRemote?l.authority:void 0}e.$Ok=D;function R(l){if(!l)return;const I=l.indexOf("+");return I<0?l:l.substr(0,I)}e.$Pk=R;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Qk=A;function N(l){const{host:I,port:O}=u(l);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:O}}e.$Rk=N;function v(l,I){let{host:O,port:d}=u(l);return typeof d>"u"&&(d=I),{host:O,port:d}}e.$Sk=v;function u(l){const I=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const O=l.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const d=l.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Tl=A,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(N||(e.ExtensionType=N={}));var v;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,k=typeof h=="string"?h:h.value;return L.$Me(f,k)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Vl=u;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Wl=l;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=I;function O(w){return d(w)}e.$Yl=O;function d(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Zl=d;function g(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$1l=g;function y(w,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Pk)($)}`;return!!w.activationEvents?.includes(h)}return!1}e.$2l=y,e.$3l=(0,D.$Bh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;class A extends L.$kc{constructor(v,u,l,I,O){super(),this.a=v,this.b=u,this.c=l,this.f=O,this.B(I.onDidInstallExtensions(d=>this.g(d))),this.B(I.onDidUninstallExtension(d=>this.h(d)))}g(v){for(const u of v)u.local&&this.invalidate(u.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,v)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,D.$Pl))}catch(u){(0,R.$jk)(u)!==1&&this.f.error(u)}}}e.$wp=A}),define(ne[45],re([0,1,14,9,2,103,44,10,6,36]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,v.$Bh)("requestService");class I{constructor(b){this.b=b}toJSON(){if(!this.a){const b=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.b[t];this.a=b}return this.a}}class O extends R.$kc{constructor(b){super(),this.b=0,this.a=b.createLogger("network",{name:(0,A.localize)(0,null),when:u.$jj.isEqualTo((0,u.$hj)(u.LogLevel.Trace)).serialize()})}async c(b,t,a){const i=`${b} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new I(t.headers??{}));try{const s=await a();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,D.$8)(s)),s}}}e.$Jo=O;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Ko=d;function g(p){return p.res.statusCode===204}e.$Lo=g;async function y(p){return g(p)?null:(await(0,L.$Rd)(p.stream)).toString()}e.$Mo=y;async function w(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return y(p)}e.$No=w;async function $(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const t=(await(0,L.$Rd)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Oo=$;function h(p){k(p)}e.$Po=h;let f;function k(p){const b=l.$8m.as(N.$an.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},b.updateConfigurations({add:[f],remove:t?[t]:[]})}k(1)}),define(ne[135],re([0,1,20,15,12,45]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;let N=class{constructor(u,l){this.a=u,this.b=l}async download(u,l,I=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,l);return}const O={type:"GET",url:u.toString(!0)},d=await this.a.request(O,I);if(d.res.statusCode===200)await this.b.writeFile(l,d.stream);else{const g=await(0,A.$No)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${g}`)}}};e.$BN=N,e.$BN=N=$e([se(0,A.$Io),se(1,R.$6j)],N)}),define(ne[136],re([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;function R(N,v){return N.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:N.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function A(N,v,u={}){const l=(0,L.parse)(N),I=u.proxyUrl||R(l,v);if(!I)return null;const O=(0,L.parse)(I);if(!/^https?:$/.test(O.protocol||""))return null;const d={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.$pf)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((g,y)=>{J(["http-proxy-agent"],g,y)}))(d):new(await new Promise((g,y)=>{J(["https-proxy-agent"],g,y)}))(d)}e.$Nq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=void 0;let y;async function w(h,f,k,p){return k["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$Gl)(p)&&!k["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$Gl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=d.Promises.withAsyncBody(async(b,t)=>{const a=new A.$pd;let i=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,g.$Hl)(s,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{b(await $(f,a.token))}catch(r){!(0,v.$2)(r)&&!a.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.$mi)(r)))):b({})}finally{clearTimeout(n),a.dispose()}})),y)}e.$Ml=w;async function $(h,f){const k=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",k);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const b=(0,l.$4f)().replace(/-/g,"").substr(0,12),t=new RegExp(b+"({.*})"+b),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,I.$wl)(u.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(f.isCancellationRequested)return n(new v.$3);const r=(0,D.$ae)(i);let c,P;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' ${S} -p '''${b}'' + JSON.stringify(process.env) + ''${b}'''`,P=["-Login","-Command"]):r==="nu"?(c=`^'${process.execPath}' ${S} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,P=["-i","-l","-c"]):(c=`'${process.execPath}' ${S} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),c);const E=(0,L.spawn)(i,[...P,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(E.kill(),n(new v.$3))),E.on("error",x=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,N.$mi)(x)),n(x)});const j=[];E.stdout.on("data",x=>j.push(x));const H=[];E.stderr.on("data",x=>H.push(x)),E.on("close",(x,_)=>{const ue=Buffer.concat(j).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),x||_)return n(new Error((0,R.localize)(2,null,x,_)));const ae=t.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);k?ie.ELECTRON_RUN_AS_NODE=k:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),s(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,N.$mi)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0,e.$dN=(0,L.$Bh)("stateReadService"),e.$eN=(0,L.$Bh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=e.$fN=e.SaveStrategy=void 0;var l;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class I extends R.$kc{constructor(y,w,$,h){super(),this.h=y,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new L.$Eg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,w){const $=this.a[y];return(0,A.$sf)($)?w:$}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:$,data:h}of y)this.a[$]!==h&&((0,A.$sf)(h)?(0,A.$qf)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=h,w=!0));w&&this.r()}removeItem(y){(0,A.$qf)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,D.$Fd.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$fN=I;let O=class extends R.$kc{constructor(y,w,$,h){super(),this.a=this.B(new I(w.stateResource,y,$,h))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$gN=O,e.$gN=O=$e([se(1,N.$Ih),se(2,u.$5i),se(3,v.$6j)],O);class d extends O{setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$hN=d}),define(ne[69],re([0,1,13,35,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function A(u){if(L.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function N(u,l,I,O,d,g,y,w){const $=Object.create(null);$["common.machineId"]=g,$.sessionID=(0,R.$4f)()+Date.now(),$.commitHash=O,$.version=d,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$h)(L.$t),$["common.nodePlatform"]=D.$3d,$["common.nodeArch"]=I,$["common.product"]=w||"desktop",y&&($["common.msftInternal"]=y);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$l&&($["common.snap"]="true");const k=A(l);return k&&($["common.platformDetail"]=k),$}e.$0n=N;function v(u){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const I=l.toLowerCase();return u.some(O=>I===O)}e.$$n=v}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,L.$Bh)("telemetryService"),e.$0k=(0,L.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$_n=l;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=I,e.$bo=new I;class O{async publicLog(n,r,c){}async publicLogError(n,r,c){}}e.$co=O,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function d(s,n){return R.Event.debounce(n.onDidChangeConfiguration,(c,P)=>{const S=c?new Set([...c.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:S}},1e3,!0)(c=>{c.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.$$h)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$go=d;function g(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$ho=g;function y(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$io=y;function w(s){const n=s.getValue(u.$dl),r=s.getValue(u.$el);if(s.getValue(u.$fl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=w;function $(s){const n={},r={},c={};k(s,c);for(let P in c){P=P.length>150?P.substr(P.length-149):P;const S=c[P];typeof S=="number"?r[P]=S:typeof S=="boolean"?r[P]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${S.length}`),n[P]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(n[P]=S)}return{properties:n,measurements:r}}e.$ko=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(s){if(!s)return"none";const n=(0,N.$Pk)(s);return h.has(n)?n:"other"}e.$lo=f;function k(s,n,r=0,c){if(s)for(const P of Object.getOwnPropertyNames(s)){const S=s[P],E=c?c+P:P;Array.isArray(S)?n[E]=(0,L.$1m)(S):S instanceof Date?n[E]=S.toISOString():(0,D.$lf)(S)?r<2?k(S,n,r+1,E+"."):n[E]=(0,L.$1m)(S):n[E]=S}}function p(s,n){const r=s.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,v.$$n)(r)||c}e.$mo=p;function b(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$no=b;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const c=[];for(const j of n)for(;;){const H=j.exec(s);if(!H)break;c.push([H.index,j.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(r="";;){const j=S.exec(s);if(!j)break;const H=c.some(([x,_])=>j.index<_&&x<S.lastIndex);!P.test(j[0])&&!H&&(r+=s.substring(E,j.index)+"<REDACTED: user-file-path>",E=S.lastIndex)}return E<s.length&&(r+=s.substr(E)),r}function a(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function i(s,n){return(0,L.$Xm)(s,r=>{if(r instanceof l||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=t(c,n);for(const P of n)c=c.replace(P,"");return c=a(c),c}})}e.$oo=i}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function I(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,L.$He)(i.id,s.id)===0}e.$po=I;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const n=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,n,r)}static parse(s){const n=O.exec(s);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$qo=d;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const s=g.exec(i);return s&&s[1]?[$(s[1]),s[2]]:[$(i),void 0]}e.$ro=y;function w(i,s){return`${i}.${s}`}e.$so=w;function $(i){return i.toLowerCase()}e.$to=$;function h(i,s){return $(w(i??R.$Rl,s))}e.$uo=h;function f(i,s){const n=[],r=c=>{for(const P of n)if(P.some(S=>I(s(S),s(c))))return P;return null};for(const c of i){const P=r(c);P?P.push(c):n.push([c])}return n}e.$vo=f;function k(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$wo=k;function p(i){return{id:new l.$_n(i.identifier.id),name:new l.$_n(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$xo=p,e.$yo=new R.$Vl("pprice.better-merge");function b(i,s){const n=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&n.every(P=>!I(P.identifier,{id:c}))){const P=i.filter(S=>I(S.identifier,{id:c}));P.length===1&&(n.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$zo=b;async function t(i,s){if(!A.$k)return!1;let n;try{n=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,v.$8)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,s){const n=await t(i,s),r=(0,D.$Un)(n?"alpine":A.$t,u.$4d);return s.debug("ComputeTargetPlatform:",r),r}e.$Ao=a}),define(ne[140],re([0,1,20,9,15,17,43,11,93,21,27,37]),function(J,e,L,D,R,A,N,v,u,l,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;const d=$=>(0,u.localize)(0,null,$),g=(0,u.localize)(1,null,"ms-dotnettools.csharp");function y($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let w=class{constructor(h,f,k){this.a=h,this.b=f,this.d=k}get f(){}async listExtensions(h,f,k){let p=await this.b.getInstalled(1,k);const b=O.$Ul.map(a=>a.toLowerCase());if(f&&f!==""){if(b.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(s=>s.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),b.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(y(a.manifest,h)))}async installExtensions(h,f,k,p){const b=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const s=(r,c,P)=>{i.push({id:r,version:c!=="prerelease"?c:void 0,installOptions:{...k,isBuiltin:P,installPreReleaseVersion:c==="prerelease"||k.installPreReleaseVersion}})};for(const r of h)if(r instanceof v.URI)a.push({vsix:r,installOptions:k});else{const[c,P]=(0,I.$ro)(r);s(c,P,!1)}for(const r of f)if(r instanceof v.URI)a.push({vsix:r,installOptions:{...k,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,P]=(0,I.$ro)(r);s(c,P,!0)}const n=await this.b.getInstalled(1,k.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:r,installOptions:c})=>{try{const P=await this.g(r,c,p,n);P&&t.push(P)}catch(P){this.a.error(P),b.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:c})=>{const P=n.find(S=>(0,I.$po)(S.identifier,{id:r}));if(P){if(!p&&(!c||c==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,r,P.manifest.version,r)),!1;if(c&&P.manifest.version===c)return this.a.info((0,u.localize)(6,null,`${r}@${c}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async c=>{const P=r.get(c.id.toLowerCase());if(P)try{const S=await this.j(c,P,n);S&&t.push(S)}catch(S){this.a.error(S.message||S.stack||S),b.push(c.id)}else this.a.error(`${d(c.version?`${c.id}@${c.version}`:c.id)}
${g}`),b.push(c.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,D.$8)(t))),t}if(b.length)throw new Error((0,u.localize)(8,null,b.join(", ")))}async g(h,f,k,p){const b=await this.b.getManifest(h);if(!b)throw new Error("Invalid vsix");if(await this.l(b,k,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$fg)(h))),b}catch(a){if((0,D.$2)(a))return this.a.info((0,u.localize)(10,null,(0,A.$fg)(h))),null;throw a}return null}async h(h){const f=new Map,k=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),b=[];for(const t of h)l.$Nn.test(t.id)&&b.push({...t,preRelease:k});if(b.length){const t=await this.d.getExtensions(b,{targetPlatform:p},L.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:h,version:f,installOptions:k},p,b){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const a=b.find(i=>(0,I.$po)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{k.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...k,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,D.$2)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,k,p){if(!f){const b={id:(0,I.$uo)(h.publisher,h.name)},t=p.find(a=>(0,I.$po)(b,a.identifier)&&(0,N.gt)(a.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,k){const p=async t=>{if(t instanceof v.URI){const a=await this.b.getManifest(t);return y(a)}return t},b=[];for(const t of h){const a=await p(t),s=(await this.b.getInstalled(void 0,k)).filter(n=>(0,I.$po)(n.identifier,{id:a}));if(!s.length)throw new Error(`${this.m(a)}
${g}`);if(s.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&s.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const n of s)await this.b.uninstall(n,{profileLocation:k}),b.push(n);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(k=>{f.forEach(p=>{if(p.identifier.id===k&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$9o=w,e.$9o=w=$e([se(1,l.$2n),se(2,l.$Zn)],w)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class v extends D.$kc{constructor(l,I,O,d,g,y,w){super(),this.f=l,this.g=I,this.h=O,this.j=d,this.m=g,this.n=y,this.r=w,this.a=this.B(new L.$fd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$sc),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(l=>this.u(l.added))),this.B(this.j.onAddExtensions(l=>this.w(l))),this.B(this.j.onDidAddExtensions(l=>this.y(l))),this.B(this.j.onRemoveExtensions(l=>this.z(l))),this.B(this.j.onDidRemoveExtensions(l=>this.C(l))),this.B(this.n.onDidFilesChange(l=>this.D(l)))}async u(l){try{l.length&&await Promise.all(l.map(I=>(this.c.set(I.id,(0,D.$hc)(this.n.watch(this.m.extUri.dirname(I.extensionsResource)),this.n.watch(I.extensionsResource))),this.G(I.extensionsResource))))}catch(I){throw this.r.error(I),I}}async w(l){for(const I of l.extensions)this.I(this.L(I.identifier,I.version),l.profileLocation)}async y(l){for(const I of l.extensions){const O=this.L(I.identifier,I.version);l.error?this.J(O,l.profileLocation):this.I(O,l.profileLocation)}}async z(l){for(const I of l.extensions)this.J(this.L(I.identifier,I.version),l.profileLocation)}async C(l){const I=[],O=[];for(const d of l.extensions){const g=this.L(d.identifier,d.version);l.error?this.I(g,l.profileLocation):(this.J(g,l.profileLocation),this.b.has(g)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),O.push(this.f.scanInstalledExtensionAtLocation(d.location).then(y=>{y?I.push(y):this.r.info("Extension not found at the location",d.location.toString())},y=>this.r.error(y)))))}try{await Promise.all(O),I.length&&await this.H(I)}catch(d){this.r.error(d)}}D(l){for(const I of this.h.profiles)l.contains(I.extensionsResource,0,1)&&this.F(I.extensionsResource)}async F(l){const I=[],O=[],d=await this.j.scanProfileExtensions(l),g=new Set,y=new Set;for(const[w,$]of this.b)$.has(l)&&y.add(w);for(const w of d){const $=this.L(w.identifier,w.version);g.add($),y.has($)||(I.push(w.identifier),this.I($,l))}for(const w of y)if(!g.has(w)){const $=this.M(w);$&&(O.push($.identifier),this.J(w,l))}(I.length||O.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:l}:void 0,removed:O.length?{extensions:O,profileLocation:l}:void 0})}async G(l){const I=await this.j.scanProfileExtensions(l);for(const O of I)this.I(this.L(O.identifier,O.version),l)}async H(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}I(l,I){let O=this.b.get(l);O||this.b.set(l,O=new R.$Ai(d=>this.m.extUri.getComparisonKey(d))),O.add(I)}J(l,I){const O=this.b.get(l);O&&O.delete(I),O?.size||this.b.delete(l)}L(l,I){return`${N.$Vl.toKey(l.id)}@${I}`}M(l){const[I,O]=(0,A.$ro)(l);return O?{identifier:{id:I},version:O}:void 0}}e.$xp=v}),define(ne[142],re([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function R(A,N,v,u,l,I,O){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,D.$ho)(N,v)&&(0,D.$jo)(u)===3){const g=await(0,L.$2o)(v,l,I);d["X-Market-User-Id"]=g,d["VSCode-SessionId"]=O.machineId||g}return d}e.$3o=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;let w=class extends g.$Jq{constructor(k,p,b,t){super(b),this.h=k,this.j=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(k,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const a=t.translations[k];return a?y.URI.file(a):void 0}async getInstalledLanguages(){const k=await this.g.getLanguagePacks(),p=Object.keys(k).map(b=>{const t=k[b];return{...this.f(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((b,t)=>b.label.localeCompare(t.label)),p}async m(k){k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",k.identifier.id),await this.update())}async n(k){const p=await this.g.getLanguagePacks();Object.keys(p).some(b=>p[b]&&p[b].extensions.some(t=>(0,O.$po)(t.extensionIdentifier,k.identifier)))&&(this.j.info("Removing language packs from the extension",k.identifier.id),await this.update())}async update(){const[k,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),b=await this.g.update(p);return!(0,D.$sb)(Object.keys(k),Object.keys(b))}};e.$Kq=w,e.$Kq=w=$e([se(0,I.$2n),se(1,l.$Jh),se(2,I.$Zn),se(3,d.$5i)],w);let $=class extends A.$kc{constructor(k,p){super(),this.j=p,this.c={},this.f=(0,v.$9d)(k.userDataPath,"languagepacks.json"),this.g=new R.$Ng}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(k){return this.s(p=>{Object.keys(p).forEach(b=>delete p[b]),this.m(p,...k)}).then(()=>this.c)}m(k,...p){for(const b of p)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.n(k,b);Object.keys(k).forEach(b=>this.r(k[b]))}n(k,p){const b=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===N.Schemas.file&&h(a)){let i=k[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},k[a.languageId]=i);const s=i.extensions.filter(n=>(0,O.$po)(n.extensionIdentifier,b))[0];s?s.version=p.manifest.version:i.extensions.push({extensionIdentifier:b,version:p.manifest.version});for(const n of a.translations)i.translations[n.id]=(0,v.$9d)(p.location.fsPath,n.path)}}r(k){if(k){const p=(0,L.createHash)("md5");for(const b of k.extensions)p.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);k.hash=p.digest("hex")}}s(k=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(p=k(b),b)).then(b=>{for(const a of Object.keys(b))b[a]||delete b[a];this.c=b,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,b=>this.j.error(b))})}};$=$e([se(0,l.$Jh),se(1,d.$5i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const k of f.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function u(I,O,d){const g=await(0,L.$aD)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,L.$aD)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new g.AppInsightsCore,$=new y.PostChannel,h={instrumentationKey:I,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(d){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:d};h.extensionConfig[$.identifier]=f}return w.initialize(h,[]),w.addTelemetryInitializer(f=>{O&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),w}class l{constructor(O,d,g,y,w){this.e=O,this.f=d,this.g=g,this.h=w,this.c=N,this.d=v,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{O(d)},d=>{(0,D.$Y)(d),console.error(d)})}}log(O,d){if(!this.a)return;d=(0,R.$Ym)(d,this.g),d=(0,A.$ko)(d);const g=this.f+"/"+O;try{this.i(y=>{y.pluginVersionString=d?.properties.version??"Unknown",y.track({name:g,baseData:{name:g,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$_M=l}),define(ne[145],re([0,1,2,30,13,29,105,25,44,146,32,36,26,39]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,k){this.k=f,this.l=k,this.d={},this.i=new L.$jc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$qe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$qe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$dl)||p.affectsConfiguration(d.$fl)||p.affectsConfiguration(d.$el))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,g.$jo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const k=f.usage?3:f.error?2:0;h=Math.min(h,k)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,k){this.g<f||(k=(0,D.$Ym)(k,this.d),k=(0,g.$oo)(k,this.j),k=(0,D.$Ym)(k,this.c),this.b.forEach(p=>p.log(h,k)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Qq=y,e.$Qq=y=$e([se(1,v.$8h),se(2,I.$kj)],y);function w(){const $=(0,N.localize)(0,null,l.default.nameLong),h=l.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$o?"":(0,N.localize)(3,null),k=(0,N.localize)(4,null),p=(0,N.localize)(5,null),b=(0,N.localize)(6,null),t=(0,N.localize)(7,null),a=`
|       | ${k} | ${p} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}O.$8m.as(u.$an.Configuration).registerConfiguration({id:d.$cl,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[d.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$8m.as(u.$an.Configuration).registerConfiguration({id:d.$cl,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[d.$fl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,N.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,N.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${d.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=void 0;async function N(I,O){const d=await O.request(I,D.CancellationToken.None),g=(await(0,L.$Rd)(d.stream)).toString(),y=d.res.statusCode??200;return{headers:d.res.headers,statusCode:y,responseData:g}}async function v(I){const O={method:I.type,headers:I.headers};return new Promise((g,y)=>{const w=R.request(I.url??"",O,$=>{$.on("data",function(h){g({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){y(h)})});w.write(I.data,$=>{$&&y($)}),w.end()})}async function u(I,O,d){const g=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),y={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:g};try{const w=I?await N(y,I):await v(y);d(w.statusCode,w.headers,w.responseData)}catch{d(0,{})}}class l extends A.$_M{constructor(O,d,g,y,w){const $={sendPOST:(h,f)=>{u(O,h,f)}};super(d,g,y,w,$)}}e.$aN=l}),define(ne[148],re([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;async function R(A,N){const v=Object.create(null),u=(I,O)=>{const d=JSON.parse(I);v[O]=d};if(N){const I=[],O=await D.Promises.readdir(N);for(const g of O)try{(await D.Promises.stat((0,L.$9d)(N,g))).isDirectory()&&I.push(g)}catch{}const d=[];for(const g of I)(await D.Promises.readdir((0,L.$9d)(N,g))).filter(w=>w==="telemetry.json").length===1&&d.push(g);for(const g of d){const y=(await D.Promises.readFile((0,L.$9d)(N,g,"telemetry.json"))).toString();u(y,g)}}let l=(await D.Promises.readFile((0,L.$9d)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await D.Promises.readFile((0,L.$9d)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(v,null,4)}e.$D7b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;async function A(N,v){let u=N.getItem(R.$bl);return(typeof u!="string"||L.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$Im)(v.error.bind(v))),u}e.$Y6b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,L.$Bh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class l{static{this._clock=0}constructor(d){this.uri=d,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let I=class{constructor(d){this.g=d,this.c=new u.$jc,this.f=2**16;const g=new Map,y=w=>{let $=g.get(w.scheme);return $===void 0&&($=d.hasProvider(w)&&!this.g.hasCapability(w,1024),g.set(w.scheme,$)),$};this.c.add(v.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(w=>{g.delete(w.scheme)})),this.extUri=new A.$0f(y),this.d=new N.$or((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$jg)(d));const g=this.d.get(d);return g?g.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new l(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const g=this.f*.5;for(let y=0;y<g;y++)this.d.set(d[y][0],d[y][1].touch())}};e.$pr=I,e.$pr=I=$e([se(0,R.$6j)],I),(0,D.$mr)(L.$Ck,I,1)}),define(ne[151],re([0,1,4,2,12,41,46,14,3,31]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class I extends D.$kc{get capabilities(){return this.g.capabilities&-5}constructor(d,g,y,w,$,h){super(),this.f=d,this.g=g,this.h=y,this.j=w,this.m=h,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$fd),this.onDidChangeFile=this.a.event,this.b=N.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new l.$Ai(f=>$.extUri.getComparisonKey(this.s(f))),this.n(),this.B(w.onDidChangeProfiles(()=>this.n())),this.B(this.g.onDidChangeFile(f=>this.r(f)))}n(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}watch(d,g){this.b.set(d,d);const y=this.g.watch(this.s(d),g);return(0,D.$ic)(()=>{this.b.delete(d),y.dispose()})}stat(d){return this.g.stat(this.s(d))}mkdir(d){return this.g.mkdir(this.s(d))}rename(d,g,y){return this.g.rename(this.s(d),this.s(g),y)}readFile(d){return this.g.readFile(this.s(d),{atomic:!0})}readFileStream(d,g,y){const w=(0,A.$td)($=>v.$Fd.concat($.map(h=>v.$Fd.wrap(h))).buffer);return(async()=>{try{const $=await this.readFile(d);w.end($)}catch($){w.error($),w.end()}})(),w}readdir(d){return this.g.readdir(this.s(d))}writeFile(d,g,y){return this.c.has(d)&&!(0,u.$lf)(y.atomic)&&(0,R.$bk)(this.g)&&(y={...y,atomic:{postfix:".vsctmp"}}),this.g.writeFile(this.s(d),g,y)}delete(d,g){return this.g.delete(this.s(d),g)}copy(d,g,y){if((0,R.$9j)(this.g))return this.g.copy(this.s(d),this.s(g),y);throw new Error("copy not supported")}r(d){const g=[];for(const y of d){if(y.resource.scheme!==this.f)continue;const w=this.t(y.resource);this.b.findSubstr(w)&&g.push({resource:w,type:y.type})}g.length&&(this.m.debug("User data changed"),this.a.fire(g))}s(d){return d.with({scheme:this.f})}t(d){return d.with({scheme:this.h})}}e.$h7b=I}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,D,R,A,N,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,v.$Bh)("contextService");function l(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$Lh=l;function I(s){return typeof s?.id=="string"&&!l(s)&&!d(s)}e.$Mh=I,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function O(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,D.$ae)(s)}:n?e.$Nh:e.$Oh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Ph=O;function d(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$Qh=d;function g(s){const n=s;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Rh=g;var y;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Sh=w;function $(s){const n=s;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Th=$;class h{constructor(n,r,c,P,S){this.h=n,this.j=c,this.k=P,this.l=S,this.c=R.$Hh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Hh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=f;function k(s){return new f({uri:s,index:0,name:(0,A.$eg)(s)},{uri:s.toString()})}e.$Wh=k,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,L.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function p(s,n){return A.$_f.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$2h=p;function b(s){let n;return N.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===u.Schemas.tmp}e.$3h=b,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$4h}e.$5h=t;function a(s,n){return!p(s,n)&&!b(s)}e.$6h=a;function i(s){return(typeof s=="string"?(0,D.$be)(s):(0,A.$gg)(s))===e.$Yh}e.$7h=i}),define(ne[23],re([0,1,42,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var k;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(k||(e.ProfileResourceType=k={}));function p(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Dk=p,e.$Ek=(0,I.$Bh)("IUserDataProfilesService");function b(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:N.URI.revive(s.location).with({scheme:n}),globalStorageHome:N.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Fk=b;function t(s,n,r,c,P,S){return{id:s,name:n,location:r,isDefault:!1,shortName:P?.shortName,globalStorageHome:S&&P?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.$ig)(r,"globalStorage"),settingsResource:S&&P?.useDefaultFlags?.settings?S.settingsResource:(0,A.$ig)(r,"settings.json"),keybindingsResource:S&&P?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.$ig)(r,"keybindings.json"),tasksResource:S&&P?.useDefaultFlags?.tasks?S.tasksResource:(0,A.$ig)(r,"tasks.json"),snippetsHome:S&&P?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.$ig)(r,"snippets"),extensionsResource:S&&P?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.$ig)(r,"extensions.json"),cacheHome:(0,A.$ig)(c,s),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Gk=t;let a=class extends R.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,c,P){super(),this.t=n,this.u=r,this.w=c,this.y=P,this.f=!0,this.h=this.B(new D.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new g.$zi,emptyWindows:new Map},this.profilesHome=(0,A.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,f.$jf)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}r.push(t((0,A.$fg)(S.location),S.name,S.location,this.g,{shortName:S.shortName,useDefaultFlags:S.useDefaultFlags},n))}}catch(S){this.y.error(S)}const c=new g.$zi,P=new Map;if(r.length)try{const S=this.Q();if(S.workspaces)for(const[E,j]of Object.entries(S.workspaces)){const H=N.URI.parse(E),x=r.find(_=>_.id===j);x&&c.set(H,x)}if(S.emptyWindows)for(const[E,j]of Object.entries(S.emptyWindows)){const H=r.find(x=>x.id===j);H&&P.set(E,H)}}catch(S){this.y.error(S)}this.z={profiles:r,workspaces:c,emptyWindows:P}}return this.z}D(){const n=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",c=new RegExp(`${(0,h.$qe)(r)}\\s(\\d+)`);let P=0;for(const E of this.profiles){const j=c.exec(E.name),H=j?parseInt(j[1]):0;P=H>P?H:P}const S=`${r} ${P+1}`;return this.createProfile((0,L.$pi)((0,$.$4f)()).toString(16),S,{transient:!0},n)}async createNamedProfile(n,r,c){return this.createProfile((0,L.$pi)((0,$.$4f)()).toString(16),n,r,c)}async createProfile(n,r,c,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(n,r,c);return P&&await this.setProfileForWorkspace(P,S),S}async F(n,r,c){if(!(0,f.$jf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(r);return P||(P=(async()=>{try{const S=this.profiles.find(H=>H.name===r||H.id===n);if(S)return S;const E=t(n,r,(0,A.$ig)(this.profilesHome,n),this.g,c,this.defaultProfile);await this.u.createFolder(E.location);const j=[];return this.j.fire({profile:E,join(H){j.push(H)}}),await w.Promises.settled(j),this.I([E],[],[]),E}finally{this.r.delete(r)}})(),this.r.set(r,P)),P}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(P=>P.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=t(c.id,r.name??c.name,c.location,this.g,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.m.fire({profile:r,join(P){c.push(P)}});try{await Promise.allSettled(c)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(P){(0,l.$jk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(P=>P.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,c)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return N.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$Lh)(n)?n.uri:(0,d.$Qh)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,c){const P=[...this.profiles,...n],S=[];this.s.profiles=[];for(let E of P)E.isDefault||r.some(j=>E.id===j.id)||(E=c.find(j=>E.id===j.id)??E,E.isTransient?this.s.profiles.push(E):S.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.P(S),this.z=void 0,this.J(n,r,c)}J(n,r,c){this.h.fire({added:n,removed:r,updated:c,all:this.profiles})}L(n,r,c){c=r?.isTransient?!0:c,c||this.L(n,void 0,!0);const P=this.G(n),S=c?this.s:this.C;N.URI.isUri(P)?(S.workspaces.delete(P),r&&S.workspaces.set(P,r)):(S.emptyWindows.delete(P),r&&S.emptyWindows.set(P,r)),c||this.M()}M(){const n={};for(const[c,P]of this.C.workspaces.entries())n[c.toString()]=P.id;const r={};for(const[c,P]of this.C.emptyWindows.entries())r[c.toString()]=P.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},c=this.D();if(n.workspaces)for(const[S,E]of Object.entries(n.workspaces)){const j=N.URI.parse(E);r[S]=this.w.extUri.isEqual(j,c.location)?c.id:this.w.extUri.basename(j)}const P={};if(n.emptyWindows)for(const[S,E]of Object.entries(n.emptyWindows)){const j=N.URI.parse(E);P[S]=this.w.extUri.isEqual(j,c.location)?c.id:this.w.extUri.basename(j)}return{workspaces:r,emptyWindows:P}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Hk=a,e.$Hk=a=$e([se(0,u.$Ih),se(1,l.$6j),se(2,y.$Ck),se(3,O.$5i)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ik=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=void 0;let p=class extends v.$kc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,c,P,S,E){super(),this.z=n,this.C=r,this.D=c,this.F=P,this.G=S,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$fd),this.s=this.B(new N.$fd),this.t=this.B(new N.$fd),this.u=this.B(new N.$fd),this.w=this.B(new N.$fd),this.y=[],this.B((0,v.$ic)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,d.$Wn)(c,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:S})=>(0,g.$po)(S,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw t(c)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$1n(O.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],c=[];await Promise.allSettled(n.map(async({extension:P,options:S})=>{try{const E=await this.O(P,!!S?.installGivenVersion,!!S?.installPreReleaseVersion);c.push({...E,options:S})}catch(E){r.push({identifier:P.identifier,operation:2,source:P,error:E})}})),c.length&&r.push(...await this.I(c));for(const P of r)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!I.URI.isUri(P.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,g.$xo)(P.source),error:P.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,y.$Yl)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(c=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const P of this.H.profiles){const S=(await this.getInstalled(1,P.extensionsResource)).find(E=>(0,g.$po)(E.identifier,n.identifier));S?this.w.fire(S):this.u.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return c}else{const c=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async c=>{try{const P=await this.J(c);r.push(...P)}catch(P){r.push({identifier:{id:(0,g.$uo)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:P})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:c}){const P=c.isApplicationScoped||c.isBuiltin||(0,y.$Yl)(n),S={...c,installOnlyNewlyAddedFromExtensionPack:I.URI.isUri(r)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.H.defaultProfile.extensionsResource:c.profileLocation??this.Y()},E=te=>`${g.$qo.create(te).toString()}${S.profileLocation?`-${S.profileLocation.toString()}`:""}`;if(!I.URI.isUri(r)){const te=this.j.get(E(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const j=[],H=[],x=[],_=this.Z(n,r,S);I.URI.isUri(r)||this.j.set(E(r),{task:_,waitingTasks:[]}),this.n.fire({identifier:_.identifier,source:r,profileLocation:S.profileLocation}),this.F.info("Installing extension:",_.identifier.id),j.push({task:_,manifest:n});let ue=!1;try{if(S.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const ae=await this.N(_.identifier,n,!!S.installOnlyNewlyAddedFromExtensionPack,!!S.installPreReleaseVersion,S.profileLocation),le=await this.getInstalled(void 0,S.profileLocation),ie={...S,donotIncludePackAndDependencies:!0,context:{...S.context,[d.$Rn]:!0}};for(const{gallery:B,manifest:G}of(0,L.$Kb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(q=>(0,g.$po)({id:q},_.identifier));const T=E(B),M=this.j.get(T);if(M){if(this.L(_,M.task)){const q=M.task.identifier;this.F.info("Waiting for already requested installing extension",q.id,_.identifier.id),M.waitingTasks.push(_),H.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,X=>X.some(Z=>(0,g.$po)(Z.identifier,q)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",q.id,_.identifier.id),!X.find(K=>(0,g.$po)(K.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!le.some(({identifier:q})=>(0,g.$po)(q,B.identifier))){const q=this.Z(G,B,ie);this.j.set(T,{task:q,waitingTasks:[_]}),this.n.fire({identifier:q.identifier,source:B,profileLocation:S.profileLocation}),this.F.info("Installing extension:",q.identifier.id,_.identifier.id),j.push({task:q,manifest:G})}}}catch(ae){if(I.URI.isUri(_.source))(0,L.$Jb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",_.identifier.id,ae.message),(0,L.$Jb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",_.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),ae}const te=j.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(B=>te.has(B.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===_&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const B=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,S,R.CancellationToken.None))),!I.URI.isUri(ie.source)){const T=ie.operation===3,M=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.$xo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:M}),u.$o&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}x.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw I.URI.isUri(ie.source)||a(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.$xo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-B,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.M(H),x.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),x}catch(te){if(j.forEach(({task:ae})=>ae.cancel()),x.length)try{const ae=await Promise.allSettled(x.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:S.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:B}=x[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",B.id):this.F.warn("Rollback: Error while uninstalling extension",B.id,(0,A.$8)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$8)(ae),x.map(({identifier:le})=>le.id))}return j.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:S.context,profileLocation:S.profileLocation,error:te}))}finally{for(const{task:te}of j)te.source&&!I.URI.isUri(te.source)&&this.j.delete(E(te.source))}}L(n,r){for(const[,{task:c,waitingTasks:P}]of this.j.entries())if(c===n&&(P.includes(r)||P.some(S=>this.L(S,r)))||c===r&&P[0]&&!this.L(n,P[0]))return!1;return!0}async M(n){const r=[],c=[],P=await Promise.allSettled(n);for(const S of P)S.status==="fulfilled"?r.push(S.value):c.push(S.reason);if(c.length)throw b(c);return r}async N(n,r,c,P,S){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,S),j=[],H=[],x=async(_,ue)=>{j.push(_);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=c?E.find(ie=>(0,g.$po)(ie.identifier,_)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(B=>(0,g.$po)({id:B},{id:ie}))||ae.every(B=>!(0,g.$po)({id:B},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>j.every(B=>!(0,g.$po)(B,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(B=>({id:B,preRelease:P})),R.CancellationToken.None);for(const B of ie){if(j.find(M=>(0,g.$po)(M,B.identifier)))continue;const G=te.some(M=>(0,g.$po)({id:M},B.identifier));let T;try{T=await this.O(B,!1,P)}catch(M){if(G)throw M;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.$8)(M));continue}H.push({gallery:T.extension,manifest:T.manifest}),await x(T.extension.identifier,T.manifest)}}}};return await x(n,r),H}async O(n,r,c){let P;const S=await this.getExtensionsControlManifest();if(S.malicious.some(H=>(0,g.$po)(n.identifier,H)))throw new d.$1n(O.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const E=S.deprecated[n.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!P)throw new d.$1n(O.localize(2,null,n.identifier.id,E.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new d.$1n(O.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$Sn)(H)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.P(n,r,c),!P)throw!c&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new d.$1n(O.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$1n(O.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const j=await this.z.getManifest(P,R.CancellationToken.None);if(j===null)throw new d.$1n(`Missing manifest for extension ${P.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==P.version)throw new d.$1n(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:j}}async P(n,r,c){const P=await this.getTargetPlatform();let S=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(S=(await this.z.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:P,compatible:!0},R.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(n,c,P)&&(S=n),S||(r?S=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},R.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(n,c,P)),S}async Q(n,r){const c={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},P=_=>`${_.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,S=this.m.get(P(n.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),S.waitUntilTaskIsFinished();const E=_=>{const ue=this.$(_,c);return this.m.set(P(ue.extension.identifier),ue),c.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped}),ue},j=(_,ue)=>{ue?c.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,ue.message):c.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,g.$wo)(_),error:ue}),this.u.fire({identifier:_.identifier,error:ue?.code,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],x=[];try{H.push(E(n));const _=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,_);for(const te of ue)this.m.has(P(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):H.push(E(te))}c.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(ue=>ue.extension),_,n),await this.M(H.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,c,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}j(ue.extension)}catch(te){const ae=te instanceof d.$1n?te:new d.$1n((0,A.$8)(te),d.ExtensionManagementErrorCode.Internal);throw j(ue.extension,ae),ae}finally{x.push(ue)}}))}catch(_){const ue=_ instanceof d.$1n?_:new d.$1n((0,A.$8)(_),d.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}x.includes(te)||j(te.extension,ue)}throw ue}finally{for(const _ of H)this.m.delete(P(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,c){for(const P of n){const S=this.W(P,r);if(S.length){const E=S.filter(j=>!n.some(H=>(0,g.$po)(H.identifier,j.identifier)));if(E.length)throw new Error(this.S(P,E,c))}}}S(n,r,c){return c===n?r.length===1?O.localize(6,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const S=r.filter(j=>!j.isBuiltin&&P.some(H=>(0,g.$po)({id:H},j.identifier))),E=[];for(const j of S)E.push(...this.U(j,r,c));return[...S,...E]}return[]}W(n,r){return r.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(P=>(0,g.$po)({id:P},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$fp=p,e.$fp=p=$e([se(0,d.$Zn),se(1,h.$9k),se(2,f.$Ck),se(3,w.$5i),se(4,$.$kj),se(5,k.$Ek)],p);function b(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,c)=>new Error(`${r.message}${r.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$gp=b;function t(s){if(s instanceof d.$1n)return s;const n=new d.$1n(s.message,d.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$hp=t;function a(s,n,{extensionData:r,verificationStatus:c,duration:P,error:S,durationSinceUpdate:E}){let j,H;(0,l.$rf)(c)&&(c===!0?c="Verified":(c===!1||(j=d.ExtensionManagementErrorCode.Signature,H=c),c="Unverified")),S&&(S instanceof d.$1n?(j=S.code,S.code===d.ExtensionManagementErrorCode.Signature&&(H=S.message)):j=d.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...r,verificationStatus:c,success:!S,duration:P,errorcode:j,errorcodeDetail:H,durationSinceUpdate:E})}class i{constructor(){this.d=new D.$Fg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$ug)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$ug)(n=>new Promise((r,c)=>{const P=n.onCancellationRequested(()=>{P.dispose(),c(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$ip=i}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class k extends Error{constructor(i,s){super(i),this.code=s}}e.$jp=k,e.$kp=(0,O.$Bh)("IExtensionsProfileScannerService");let p=class extends R.$kc{constructor(i,s,n,r,c,P){super(),this.j=i,this.m=s,this.n=n,this.r=r,this.s=c,this.t=P,this.b=this.B(new A.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new N.$zi}scanProfileExtensions(i,s){return this.u(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],r=[];try{return await this.u(s,c=>{const P=[];for(const S of c)i.some(([E])=>(0,l.$po)(E.identifier,S.identifier)&&E.manifest.version!==S.version)?n.push(S):P.push(S);for(const[S,E]of i){const j=P.findIndex(x=>(0,l.$po)(x.identifier,S.identifier)&&x.version===S.manifest.version),H={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:E};j===-1?(r.push(H),P.push(H)):P.splice(j,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),P}),r.length&&this.c.fire({extensions:r,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),r}catch(c){throw r.length&&this.c.fire({extensions:r,error:c,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:c,profileLocation:s}),c}}async updateMetadata(i,s){const n=[];return await this.u(s,r=>{const c=[];for(const P of r){const S=i.find(([E])=>(0,l.$po)(E.identifier,P.identifier)&&E.manifest.version===P.version);S&&(P.metadata={...P.metadata,...S[1]},n.push(P)),c.push(P)}return c}),n}async removeExtensionFromProfile(i,s){const n=[];try{await this.u(s,r=>{const c=[];for(const P of r)(0,l.$po)(P.identifier,i.identifier)?n.push(P):c.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:s}),c}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:s}),r}}async u(i,s,n){return this.F(i).queue(async()=>{let r=[],c;try{const P=await this.m.readFile(i);c=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,I.$jk)(P)!==1)throw P;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&n?.bailOutWhenFileNotFound)throw new k((0,$.$8)(P),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.w(i);let P=!1;for(const S of c){b(S)||this.w(i);let E;if((0,w.$jf)(S.relativeLocation)&&S.relativeLocation)E=this.z(S.relativeLocation);else if((0,w.$jf)(S.location))E=this.z(S.location),P=!0,S.relativeLocation=S.location,S.location=E.toJSON();else{E=v.URI.revive(S.location);const j=this.y(E);j&&(P=!0,S.relativeLocation=j)}r.push({identifier:S.identifier,location:E,version:S.version,metadata:S.metadata})}P&&await this.m.writeFile(i,D.$Fd.fromString(JSON.stringify(c)))}if(s){r=s(r);const P=r.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(i,D.$Fd.fromString(JSON.stringify(P)))}return r})}w(i){const s=new k(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(i)).value.toString()}catch(c){if((0,I.$jk)(c)===1)return;throw c}this.t.info("Migrating extensions from old default profile location",i.toString());let r;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(P=>b(P))?r=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$Fd.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,I.$jk)(c)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(i)}catch(c){(0,I.$jk)(c)!==1&&this.t.error(c)}try{await this.m.del(s)}catch(c){(0,I.$jk)(c)!==1&&this.t.error(c)}return r})()),this.C}F(i){let s=this.h.get(i);return s||(s=new L.$Ng,this.h.set(i,s)),s}};e.$lp=p,e.$lp=p=$e([se(1,I.$6j),se(2,g.$Ek),se(3,y.$Ck),se(4,h.$9k),se(5,d.$5i)],p);function b(a){return(0,w.$lf)(a)&&(0,u.$Yn)(a.identifier)&&(t(a.location)||(0,w.$jf)(a.location)&&a.location)&&((0,w.$qf)(a.relativeLocation)||(0,w.$jf)(a.relativeLocation))&&a.version&&(0,w.$jf)(a.version)}function t(a){return a?(0,w.$jf)(a.path)&&(0,w.$jf)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,43,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k,p,b,t,a,i,s,n,r,c,P,S,E,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var H;(function(ie){function B(G,T){if(G===T)return!0;const M=Object.keys(G),q=new Set;for(const X of Object.keys(T))q.add(X);if(M.length!==q.size)return!1;for(const X of M){if(G[X]!==T[X])return!1;q.delete(X)}return q.size===0}ie.equals=B})(H||(e.Translations=H={})),e.$op=(0,i.$Bh)("IExtensionsScannerService");let x=class extends l.$kc{constructor(B,G,T,M,q,X,Z,K,U,z,o,m){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=G,this.r=T,this.s=M,this.t=q,this.u=X,this.w=Z,this.y=K,this.z=U,this.C=z,this.D=o,this.F=m,this.g=this.B(new r.$fd),this.onDidChangeCache=this.g.event,this.h=(0,g.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(B,G,T){const[M,q]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(G)]),X=T?await this.scanExtensionsUnderDevelopment(B,[...M,...q]):[];return this.L(M,q,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const G=[];G.push(this.M(!!B.useCache,B.language)),G.push(this.N(B.language,!!B.checkControlFile));const[T,M]=await Promise.all(G);return this.J([...T,...M],0,B,!1)}async scanUserExtensions(B){const G=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(G,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,T),q=B.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let X;try{X=await q.scanExtensions(M)}catch(Z){if(Z instanceof P.$jp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await q.scanExtensions(M);else throw Z}return X=await this.J(X,1,B,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(B,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===I.Schemas.file).map(async M=>{const q=await this.P(M,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(q)).map(Z=>(Z.type=G.find(K=>(0,p.$po)(K.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,q)))}))).flat();return this.J(T,"development",B,!0)}return[]}async scanExistingExtension(B,G,T){const M=await this.P(B,!1,G,!0,T.language,!0,void 0),q=await this.n.scanExtension(M);return!q||!T.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(B,G,T){const M=await this.P(B,!1,G,!0,T.language,!0,void 0),q=await this.n.scanOneOrMultipleExtensions(M);return this.J(q,G,T,!0)}async scanMetadata(B){const G=(0,g.$ig)(B,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(B,G){const T=(0,g.$ig)(B,"package.json"),M=(await this.w.readFile(T)).value.toString(),q=JSON.parse(M);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,q.__metadata={...q.__metadata,...G},await this.w.writeFile((0,g.$ig)(B,"package.json"),A.$Fd.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof P.$jp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Fd.fromString(JSON.stringify([])))}catch(G){(0,a.$jk)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$8)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,G,T,M){return T.includeAllVersions||(B=this.L(G===0?B:void 0,G===1?B:void 0,G==="development"?B:void 0,await this.getTargetPlatform(),M)),T.includeInvalid||(B=B.filter(q=>q.isValid)),B.sort((q,X)=>{const Z=O.$ae(q.location.fsPath),K=O.$ae(X.location.fsPath);return Z<K?-1:Z>K?1:0})}L(B,G,T,M,q){const X=(K,U,z)=>{if(K.isValid&&!U.isValid)return!1;if(K.isValid===U.isValid){if(q&&y.gt(K.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(y.eq(K.manifest.version,U.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===M)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${K.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${U.location.path}.`),!0},Z=new b.$Xl;return B?.forEach(K=>{const U=Z.get(K.identifier.id);(!U||X(U,K,!1))&&Z.set(K.identifier.id,K)}),G?.forEach(K=>{const U=Z.get(K.identifier.id);if(!U&&B&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!U||X(U,K,!1))&&Z.set(K.identifier.id,K)}),T?.forEach(K=>{const U=Z.get(K.identifier.id);(!U||X(U,K,!0))&&Z.set(K.identifier.id,K),Z.set(K.identifier.id,K)}),[...Z.values()]}async M(B,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),q=await(B&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",q.length),q}async N(B,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const M=G?await this.O():{},q=[],X=h.URI.file(O.$7d(O.$9d(I.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const U=M[K.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":q.push((0,g.$ig)(X,K.name));break;default:q.push(h.URI.file(U));break}}const Z=await Promise.all(q.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,L.$Fb)(Z)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,G,T,M,q,X,Z){const K=await this.f(q??d.$v),U=await this.Q(B),z=G&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,o=z?await this.Q(z):void 0;return new _(B,U,z,o,G,Z,T,M,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,q,K)}async Q(B){try{const G=await this.w.stat(B);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$pp=x,e.$pp=x=$e([se(4,S.$Ek),se(5,P.$kp),se(6,a.$6j),se(7,s.$5i),se(8,k.$Ih),se(9,n.$kj),se(10,E.$Ck),se(11,i.$Ah)],x);class _{constructor(B,G,T,M,q,X,Z,K,U,z,o,m,F,C,Y){this.location=B,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=M,this.profile=q,this.profileScanOptions=X,this.type=Z,this.excludeObsolete=K,this.validate=U,this.productVersion=z,this.productDate=o,this.productCommit=m,this.devMode=F,this.language=C,this.translations=Y}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,G){return(0,g.$bg)(B.location,G.location)&&B.mtime===G.mtime&&(0,g.$bg)(B.applicationExtensionslocation,G.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&B.profile===G.profile&&R.$Zm(B.profileScanOptions,G.profileScanOptions)&&B.type===G.type&&B.excludeObsolete===G.excludeObsolete&&B.validate===G.validate&&B.productVersion===G.productVersion&&B.productDate===G.productDate&&B.productCommit===G.productCommit&&B.devMode===G.devMode&&B.language===G.language&&H.equals(B.translations,G.translations)}}e.$qp=_;let ue=class extends l.$kc{constructor(B,G,T,M,q){super(),this.f=B,this.g=G,this.h=T,this.j=M,this.m=q}async scanExtensions(B){const G=B.profile?await this.r(B):await this.n(B);let T={};if(B.excludeObsolete&&B.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(M)}catch{}return(0,$.$wf)(T)?G:G.filter(M=>!T[p.$qo.create(M).toString()])}async n(B){const G=await this.j.resolve(B.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async M=>{if(!M.isDirectory||B.type===1&&(0,g.$fg)(M.resource).indexOf(".")===0)return null;const q=new _(M.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(q)}));return(0,L.$Fb)(T).sort((M,q)=>M.location.path<q.location.path?-1:1)}async r(B){let G=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){G=G.filter(M=>!M.metadata?.isApplicationScoped);const T=await this.s(B.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,B);G.push(...T)}return G}async s(B,G,T){const M=await this.g.scanProfileExtensions(B,T.profileScanOptions);if(!M.length)return[];const q=await Promise.all(M.map(async X=>{if(G(X)){const Z=new _(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Z,X.metadata)}return null}));return(0,L.$Fb)(q)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,g.$ig)(B.location,"package.json"))){const G=await this.scanExtension(B);return G?[G]:[]}else return await this.scanExtensions(B)}catch(G){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,N.$8)(G)),[]}}async scanExtension(B,G){try{let T=await this.scanExtensionManifest(B.location);if(T){T.publisher||(T.publisher=b.$Rl),G=G??T.__metadata,delete T.__metadata;const M=(0,p.$uo)(T.publisher,T.name),q=G?.id?{id:M,uuid:G.id}:{id:M},X=G?.isSystem?0:B.type,Z=X===0||!!G?.isBuiltin;T=await this.t(B.location,T,_.createNlsConfiguration(B));const K={type:X,identifier:q,manifest:T,location:B.location,isBuiltin:Z,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return B.validate?this.validate(K,B):K}}catch(T){B.type!==0&&this.m.error(T)}return null}validate(B,G){let T=!0;const M=(0,t.$Fo)(G.productVersion,G.productDate,G.location,B.manifest,B.isBuiltin);for(const[q,X]of M)q===w.default.Error&&(T=!1,this.m.error(this.z(G.location,X)));return B.isValid=T,B.validations=M,B}async scanExtensionManifest(B){const G=(0,g.$ig)(B,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(q){return(0,a.$jk)(q)!==1&&this.m.error(this.z(B,(0,f.localize)(0,null,G.path,q.message))),null}let M;try{M=JSON.parse(T)}catch{const X=[];(0,v.$Lm)(T,X);for(const Z of X)this.m.error(this.z(B,(0,f.localize)(1,null,G.path,Z.offset,Z.length,(0,u.$mp)(Z.error))));return null}return(0,v.$Um)(M)!=="object"?(this.m.error(this.z(B,(0,f.localize)(2,null,G.path))),null):M}async t(B,G,T){const M=await this.u(B,G,T);if(M)try{const q=[],X=await this.w(M.default,q);if(q.length>0)return q.forEach(K=>{this.m.error(this.z(B,(0,f.localize)(3,null,M.default?.path,(0,u.$mp)(K.error))))}),G;if((0,v.$Um)(M)!=="object")return this.m.error(this.z(B,(0,f.localize)(4,null,M.default?.path))),G;const Z=M.values||Object.create(null);return(0,j.$np)(this.m,G,Z,X)}catch{}return G}async u(B,G,T){const M=(0,g.$ig)(B,"package.nls.json"),q=(U,z)=>{z.forEach(o=>{this.m.error(this.z(B,(0,f.localize)(5,null,U?.path,(0,u.$mp)(o.error))))})},X=U=>{this.m.error(this.z(B,(0,f.localize)(6,null,U?.path)))},Z=`${G.publisher}.${G.name}`,K=T.translations[Z];if(K)try{const U=h.URI.file(K),z=(await this.j.readFile(U)).value.toString(),o=[],m=(0,v.$Lm)(z,o);return o.length>0?(q(U,o),{values:void 0,default:M}):(0,v.$Um)(m)!=="object"?(X(U),{values:void 0,default:M}):{values:m.contents?m.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let z;try{z=await this.y(B,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const o=(await this.j.readFile(z.localized)).value.toString(),m=[],F=(0,v.$Lm)(o,m);return m.length>0?(q(z.localized,m),{values:void 0,default:z.original}):(0,v.$Um)(F)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:F,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(B,G){if(B)try{const T=(await this.j.readFile(B)).value.toString();return(0,v.$Lm)(T,G)}catch{}}y(B,G){return new Promise((T,M)=>{const q=X=>{const Z=(0,g.$ig)(B,`package.nls.${X}.json`);this.j.exists(Z).then(K=>{K&&T({localized:Z,original:(0,g.$ig)(B,"package.nls.json")});const U=X.lastIndexOf("-");U===-1?T({localized:(0,g.$ig)(B,"package.nls.json"),original:null}):(X=X.substring(0,U),q(X))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,g.$ig)(B,"package.nls.json"),original:null});q(G.language)})}z(B,G){return`[${B.path}]: ${G}`}};ue=$e([se(1,P.$kp),se(2,E.$Ck),se(3,a.$6j),se(4,s.$5i)],ue);let te=class extends ue{constructor(B,G,T,M,q,X,Z){super(G,M,q,X,Z),this.G=B,this.H=T,this.D=this.B(new D.$Eg(3e3)),this.F=this.B(new r.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(B){const G=this.M(B),T=await this.I(G);if(this.C=B,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),T.result.map(q=>(q.location=h.URI.revive(q.location),q));const M=await super.scanExtensions(B);return await this.J(G,{input:B,result:M}),M}async I(B){try{const G=await this.j.readFile(B),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,c.$$g)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",B.path,(0,N.$8)(G))}return null}async J(B,G){try{await this.j.writeFile(B,A.$Fd.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",B.path,(0,N.$8)(T))}}async L(){if(!this.C)return;const B=this.M(this.C),G=await this.I(B);if(!G)return;const T=G.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$Zm(M,T))try{this.m.info("Invalidating Cache",T,M),await this.j.del(B),this.F.fire()}catch(q){this.m.error(q)}}M(B){const G=this.N(B);return this.h.extUri.joinPath(G.cacheHome,B.type===0?b.$Ql:b.$Pl)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(B.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=$e([se(2,S.$Ek),se(3,P.$kp),se(4,E.$Ck),se(5,a.$6j),se(6,s.$5i)],te);function ae(ie,B){const G=(0,p.$so)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new b.$Vl(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:B,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$rp=ae;class le extends x{constructor(B,G,T,M,q,X,Z,K,U,z,o,m){super(B,G,(0,g.$ig)(T,".vscode-oss-dev","extensions","control.json"),M,q,X,Z,K,U,z,o,m),this.R=(async()=>{if(d.$y)try{const F=await this.w.readFile(h.URI.file(d.$y));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$sp=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,R,A,N,v,u,l,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let d=class extends N.$kc{constructor(y,w){super(),this.b=y,this.f=w,this.a=new D.$Mg(5)}async postUninstall(y){const w=this.g(y,"uninstall");w&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error($)}}));try{await l.Promises.rm(this.m(y))}catch($){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error($)}}g(y,w){const $=`vscode:${w}`;if(y.location.scheme===v.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[$]=="string"){const h=y.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${$} should be a node script`),null):{script:(0,u.$9d)(y.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(y,w,$,h,f){return new Promise((k,p)=>{const b=this.j(y,w,$,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):k(void 0)};b.on("error",i=>{a((0,R.$mi)(i)||"Unknown")}),b.on("exit",(i,s)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,b.kill(),p("timed out")},5e3))})}j(y,w,$,h){const f={silent:!0,execArgv:void 0},k=(0,L.fork)(y,[`--type=extension-post-${w}`,...$],f);k.stdout.setEncoding("utf8"),k.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(k.stdout,"data"),b=A.Event.fromNodeEventEmitter(k.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,i)),b(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(b,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),k}m(y){return(0,u.$9d)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};e.$up=d,e.$up=d=$e([se(0,O.$Ek),se(1,I.$5i)],d)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let I=class extends N.$lp{constructor(d,g,y,w,$,h){super(l.URI.file(d.extensionsPath),g,y,w,$,h)}};e.$lN=I,e.$lN=I=$e([se(0,u.$Jh),se(1,v.$6j),se(2,D.$Ek),se(3,R.$Ck),se(4,A.$9k),se(5,L.$5i)],I)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,R,A,N,v,u,l,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0;let d=class extends A.$sp{constructor(y,w,$,h,f,k,p,b){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,y.defaultProfile,y,w,$,h,f,k,p,b)}};e.$V6b=d,e.$V6b=d=$e([se(0,O.$Ek),se(1,R.$kp),se(2,N.$6j),se(3,u.$5i),se(4,D.$Jh),se(5,l.$kj),se(6,I.$Ck),se(7,v.$Ah)],d)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,u.$Bh)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var d;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function g(f){const k=f.get(e.$Uo);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.$Wo=g;class y extends R.$kc{static{this.a=60*1e3}constructor(k={flushInterval:y.a}){super(),this.m=k,this.b=this.B(new D.$id),this.c=this.B(new D.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,p,b){return D.Event.filter(this.b.event,t=>t.scope===k&&(p===void 0||t.key===p),b)}n(){this.j.value=(0,L.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,p){const{key:b,external:t}=p;if(b===e.$Uo){switch(k){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:b,target:this.J(k)[b],external:t})}w(k){this.f.fire({reason:k})}get(k,p,b){return this.P(p)?.get(k,b)}getBoolean(k,p,b){return this.P(p)?.getBoolean(k,b)}getNumber(k,p,b){return this.P(p)?.getNumber(k,b)}getObject(k,p,b){return this.P(p)?.getObject(k,b)}storeAll(k,p){this.y(()=>{for(const b of k)this.store(b.key,b.value,b.scope,b.target,p)})}store(k,p,b,t,a=!1){if((0,N.$sf)(p)){this.remove(k,b,a);return}this.y(()=>{this.z(k,b,t),this.P(b)?.set(k,p,a)})}remove(k,p,b=!1){this.y(()=>{this.z(k,p,void 0),this.P(p)?.delete(k,b)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,p){const b=[],t=this.J(k);for(const a of Object.keys(t))t[a]===p&&b.push(a);return b}z(k,p,b,t=!1){const a=this.J(p);typeof b=="number"?a[k]!==b&&(a[k]=b,this.P(p)?.set(e.$Uo,JSON.stringify(a),t)):typeof a[k]=="number"&&(delete a[k],this.P(p)?.set(e.$Uo,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(k){switch(k){case-1:return this.I;case 0:return this.G;default:return this.D}}L(k){const p=this.P(k);return p?g(p):Object.create(null)}isNew(k){return this.getBoolean(e.$To,k)===!0}async flush(k=I.NONE){this.f.fire({reason:k});const p=this.P(-1),b=this.P(0),t=this.P(1);switch(k){case I.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,b=this.P(1)?.items??new Map;return h(k,p,b,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,p){return this.w(I.NONE),(0,l.$Dk)(k)?this.R(k,p):this.S(k,p)}M(k,p){return!(k.id===p.id||w(p)&&w(k))}N(k,p,b){this.y(()=>{const t=new Set;for(const[a,i]of k)t.add(a),p.get(a)!==i&&this.u(b,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.u(b,{key:a,external:!0})})}}e.$Xo=y;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Yo=w;class $ extends y{constructor(){super(),this.U=this.B(new v.$Ro(new v.$So,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$Ro(new v.$So,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$Ro(new v.$So,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(1,k))),this.B(this.W.onDidChangeStorage(k=>this.u(0,k))),this.B(this.U.onDidChangeStorage(k=>this.u(-1,k)))}P(k){switch(k){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}e.$Zo=$;async function h(f,k,p,b,t,a){const i=H=>{try{return JSON.parse(H)}catch{return H}},s=new Map,n=new Map;f.forEach((H,x)=>{s.set(x,H),n.set(x,i(H))});const r=new Map,c=new Map;k.forEach((H,x)=>{r.set(x,H),c.set(x,i(H))});const P=new Map,S=new Map;p.forEach((H,x)=>{P.set(x,H),S.set(x,i(H))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const E=[];if(s.forEach((H,x)=>{E.push({key:x,value:H})}),console.table(E),console.groupEnd(),console.log(n),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const H=[];r.forEach((x,_)=>{H.push({key:_,value:x})}),console.table(H),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${a})`);const j=[];P.forEach((H,x)=>{j.push({key:x,value:H})}),console.table(j),console.groupEnd(),console.log(S)}e.$1o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,45,142,157,26,175]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=void 0;const t=A.$o?"web":(0,O.$Un)(A.$t,N.$4d),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...o){return String(o.reduce((m,F)=>m|F,0))}var n;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(m=S){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,F=this.d.pageSize){return new E({...this.d,pageNumber:m,pageSize:F})}withFilter(m,...F){const C=[...this.d.criteria,...F.length?F.map(Y=>({filterType:m,value:Y})):[{filterType:m}]];return new E({...this.d,criteria:C})}withSortBy(m){return new E({...this.d,sortBy:m})}withSortOrder(m){return new E({...this.d,sortOrder:m})}withFlags(...m){return new E({...this.d,flags:m.reduce((F,C)=>F|C,0)})}withAssetTypes(...m){return new E({...this.d,assetTypes:m})}withSource(m){return new E({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:F,pageSize:C,sortBy:Y,sortOrder:W,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:m,pageNumber:F,pageSize:C,sortBy:Y,sortOrder:W}],assetTypes:oe,flags:ce}}get searchText(){const m=this.d.criteria.filter(F=>F.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(o,m){const F=(o||[]).filter(C=>C.statisticName===m)[0];return F?F.value:0}function H(o){const m="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(C=>C.assetType.indexOf(m)===0).reduce((C,Y)=>{const W=ue(o,Y.assetType);return W&&C.push([Y.assetType.substring(m.length),W]),C},[])}function x(o){if(o.properties){const m=o.properties.filter(Y=>Y.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=m.filter(Y=>F.test(Y.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(o,r.Repository)}function _(o){return{uri:`${o.fallbackAssetUri}/${r.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${r.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,m){return o.files.filter(C=>C.assetType===m)[0]?{uri:`${o.assetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,m){const F=o.properties?o.properties.filter(Y=>Y.key===m):[],C=F.length>0&&F[0].value;return C?C.split(",").map(Y=>(0,d.$to)(Y)):[]}function ae(o){const m=o.properties?o.properties.filter(F=>F.key===c.Engine):[];return m.length>0&&m[0].value||""}function le(o){const m=o.properties?o.properties.filter(F=>F.key===c.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(o){const m=o.properties?o.properties.filter(C=>C.key===c.LocalizedLanguages):[],F=m.length>0&&m[0].value||"";return F?F.split(","):[]}function B(o){return o.properties?.find(m=>m.key===c.SponsorLink)?.value}function G(o){return o.indexOf("preview")!==-1}function T(o){return o.targetPlatform?(0,O.$Tn)(o.targetPlatform):"undefined"}function M(o){const m=(0,L.$Kb)(o.versions.map(T)),F=!!o.tags?.includes(O.$On),C=m.indexOf("web");return F?C===-1&&m.push("web"):C!==-1&&m.splice(C,1),m}function q(o,m){const F=(0,O.$Xn)(m);for(let C=0;C<o.length;C++){const Y=o[C];if(Y.version===o[C-1]?.version){let W=C;const ce=T(Y);if(ce===m)for(;W>0&&o[W-1].version===Y.version;)W--;else if(F.includes(ce))for(;W>0&&o[W-1].version===Y.version&&T(o[W-1])!==m;)W--;W!==C&&(o.splice(C,1),o.splice(W,0,Y))}}return o}e.$4o=q;function X(o,m,F){o.telemetryData={index:m,querySource:F,queryActivityId:o.queryContext?.[a]}}function Z(o,m,F,C){const Y=o.versions[0],W={manifest:ue(m,r.Manifest),readme:ue(m,r.Details),changelog:ue(m,r.Changelog),license:ue(m,r.License),repository:x(m),download:_(m),icon:ue(m,r.Icon),signature:ue(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,d.$uo)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:m.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(Y),description:o.shortDescription||"",installCount:j(o.statistics,"install"),rating:j(o.statistics,"averagerating"),ratingCount:j(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:F,assets:W,properties:{dependencies:te(m,c.Dependency),extensionPack:te(m,c.ExtensionPack),engine:ae(m),localizedLanguages:ie(m),targetPlatform:T(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(Y),hasReleaseVersion:!0,preview:G(o.flags),isSigned:!!W.signature,queryContext:C}}let K=class{constructor(m,F,C,Y,W,ce,oe,pe){this.k=F,this.l=C,this.n=Y,this.o=W,this.q=ce,this.u=oe,this.w=pe;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$3o)(oe.version,oe,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,F,C){const Y=D.CancellationToken.isCancellationToken(F)?{}:F,W=D.CancellationToken.isCancellationToken(F)?F:C,ce=[],oe=[],pe=[],de=[];let ge=!0;for(const we of m){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new E().withPage(1,m.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(n.ExtensionName,...ce)),(Y.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Y.source&&(fe=fe.withSource(Y.source));const{extensions:he}=await this.z(fe,{targetPlatform:Y.targetPlatform??t,includePreRelease:pe,versions:de,compatible:!!Y.compatible},W);return Y.source&&he.forEach((we,be)=>X(we,be,Y.source)),he}async getCompatibleExtension(m,F,C){if((0,O.$Vn)(m.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(m,F,C))return m;const Y=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Y,{targetPlatform:C,compatible:!0,includePreRelease:F},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,F,C){if(!(0,O.$Wn)(m.properties.targetPlatform,m.allTargetPlatforms,C)||!F&&m.properties.isPreReleaseVersion)return!1;let Y=m.properties.engine;if(!Y){const W=await this.getManifest(m,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Y=W.engines.vscode}return(0,g.$Ho)(Y,this.u.version,this.u.date)}async y(m,F,C,Y,W){if(!(0,O.$Wn)(T(m),Y,W)||F!=="any"&&le(m)!==(F==="prerelease"))return!1;if(C)try{const ce=await this.E(m);if(!(0,g.$Ho)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$8)(ce)),!1}return!0}async query(m,F){let C=m.text||"";const Y=m.pageSize??50;let W=new E().withPage(1,Y);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),W=W.withFilter(n.SearchText,C)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,Se)=>X(be,(ge.pageNumber-1)*ge.pageSize+Se,m.source)),{extensions:he,total:we}},{extensions:oe,total:pe}=await ce(W,F),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$3;const{extensions:he}=await ce(W.withPage(ge+1),fe);return he};return{firstPage:oe,total:pe,pageSize:W.pageSize,getPage:de}}async z(m,F,C){const Y=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),F.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:W,total:ce,context:oe}=await this.B(m,C);if(!(m.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,F,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$uo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$pf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,d.$po)(Fe,we))?.includePreRelease;if(F.compatible&&(0,O.$Vn)(M(he),F.targetPlatform))continue;const Se=await this.A(he,F,oe);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==F.targetPlatform&&Se.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Se])}if(ge.size){const fe=new b.$bd,he=new E().withFlags(Y&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,F,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Se=ge.get(be.identifier.uuid);de.push([Se,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(m,F,C){const Y={id:(0,d.$uo)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=F.versions?.find(de=>(0,d.$po)(de,Y))?.version,ce=(0,v.$pf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,d.$po)(de,Y))?.includePreRelease,oe=M(m),pe=q(m.versions,F.targetPlatform);if(F.compatible&&(0,O.$Vn)(oe,F.targetPlatform))return null;for(let de=0;de<pe.length;de++){const ge=pe[de];if(!(W&&ge.version!==W)){if(await this.y(ge,ce?"any":"release",F.compatible,oe,F.targetPlatform))return Z(m,ge,oe,C);if(W&&ge.version===W)return null}}return W||F.compatible?null:Z(m,m.versions[0],oe)}async B(m,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(i.Unpublished));const C=await this.j,Y=JSON.stringify(m.raw),W={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},ce=new b.$bd;let oe,pe,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Y,headers:W},F),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Oo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw pe=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Y.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Ko)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:pe?(0,R.$2)(pe)?"canceled":(0,R.$8)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,F,C,Y){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${m}.${F}/version/${C}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${F}/${C}/stats?statType=${Y}`),ce=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:W,headers:pe},D.CancellationToken.None)}catch{}}async download(m,F,C){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Y=(0,d.$xo)(m),W=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Y,duration:fe}),oe=C===2?"install":C===3?"update":"",pe=oe?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:m.assets.download,de=m.queryContext?.[a]?{[a]:m.queryContext[a]}:void 0,ge=await this.D(pe,de?{headers:de}:void 0);await this.q.writeFile(F,ge.stream),ce(new Date().getTime()-W)}async downloadSignatureArchive(m,F){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const C=await this.D(m.assets.signature);await this.q.writeFile(F,C.stream)}async getReadme(m,F){if(m.assets.readme){const C=await this.D(m.assets.readme,{},F);return await(0,h.$No)(C)||""}return""}async getManifest(m,F){if(m.assets.manifest){const C=await this.D(m.assets.manifest,{},F),Y=await(0,h.$No)(C);return Y?JSON.parse(Y):null}return null}async C(m,F){const C=ue(m,r.Manifest);if(!C)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},W=await this.D(C,{headers:Y});return await(0,h.$Oo)(W)}async getCoreTranslation(m,F){const C=m.assets.coreTranslations.filter(Y=>Y[0]===F.toUpperCase())[0];if(C){const Y=await this.D(C[1]),W=await(0,h.$No)(Y);return W?JSON.parse(W):null}return null}async getChangelog(m,F){if(m.assets.changelog){const C=await this.D(m.assets.changelog,{},F);return await(0,h.$No)(C)||""}return""}async getAllCompatibleVersions(m,F,C){let Y=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Y=Y.withFilter(n.ExtensionId,m.identifier.uuid):Y=Y.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Y,D.CancellationToken.None);if(!W.length)return[];const ce=M(W[0]);if((0,O.$Vn)(ce,C))return[];const oe=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,F?"any":"release",!0,ce,C)&&oe.push(ge)}catch{}}));const pe=[],de=new Set;for(const ge of q(oe,C))de.has(ge.version)||(de.add(ge.version),pe.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return pe}async D(m,F={},C=D.CancellationToken.None){const Y=await this.j,W={type:"GET"},ce={...Y,...F.headers||{}};F={...F,...W,headers:ce};const oe=m.uri,pe=m.fallbackUri,de={...F,url:oe};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$No)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$2)(ge))throw ge;const fe=(0,R.$8)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...F,url:pe};return this.k.request(he,C)}}async E(m){let F=ae(m);if(!F){const C=await this.C(m,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");F=C.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,h.$Oo)(m),C=[],Y={},W=[];if(F){for(const ce of F.malicious)C.push({id:ce});if(F.migrateToPreRelease)for(const[ce,oe]of Object.entries(F.migrateToPreRelease))(!oe.engine||(0,g.$Ho)(oe.engine,this.u.version,this.u.date))&&(Y[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,oe]of Object.entries(F.deprecated))oe&&(Y[ce.toLowerCase()]=(0,v.$pf)(oe)?{}:oe);if(F.search)for(const ce of F.search)W.push(ce)}return{malicious:C,deprecated:Y,search:W}}};K=$e([se(1,h.$Io),se(2,w.$5i),se(3,I.$Ih),se(4,p.$9k),se(5,y.$6j),se(6,$.$kj),se(7,l.$8h)],K);let U=class extends K{constructor(m,F,C,Y,W,ce,oe,pe){super(m,F,C,Y,W,ce,oe,pe)}};e.$5o=U,e.$5o=U=$e([se(0,k.$Vo),se(1,h.$Io),se(2,w.$5i),se(3,I.$Ih),se(4,p.$9k),se(5,y.$6j),se(6,$.$kj),se(7,l.$8h)],U);let z=class extends K{constructor(m,F,C,Y,W,ce,oe){super(void 0,m,F,C,Y,W,ce,oe)}};e.$6o=z,e.$6o=z=$e([se(0,h.$Io),se(1,w.$5i),se(2,I.$Ih),se(3,p.$9k),se(4,y.$6j),se(5,$.$kj),se(6,l.$8h)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,R,A,N,v,u,l,I){"use strict";var O,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;let g=class extends u.$Hk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(h,f,k,p,b){super(k,p,f,b),this.U=h,this.W=k}O(){return this.U.getItem(O.b,[]).map(f=>({...f,location:(0,l.$jf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$iN=g,e.$iN=g=O=$e([se(0,N.$dN),se(1,v.$Ck),se(2,D.$Jh),se(3,R.$6j),se(4,A.$5i)],g);let y=d=class extends g{constructor(h,f,k,p,b){super(h,f,k,p,b),this.$=h}P(h){h.length?this.$.setItem(d.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(d.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(d.c,h):this.$.removeItem(d.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((b,{workspace:t,profile:a})=>(b[L.URI.revive(t).toString()]=L.URI.revive(a).toString(),b),{});this.$.setItem(d.c,{workspaces:p})}const k=super.Q();return this.$.getItem(d.a,!1)||(this.R(k),this.$.setItem(d.a,!0)),k}};e.$jN=y,e.$jN=y=d=$e([se(0,N.$eN),se(1,v.$Ck),se(2,D.$Jh),se(3,R.$6j),se(4,A.$5i)],y);let w=class extends y{constructor(h,f,k,p){super(new I.$hN(0,f,p,k),h,f,k,p)}async init(){return await this.$.init(),super.init()}};e.$kN=w,e.$kN=w=$e([se(0,v.$Ck),se(1,D.$Jh),se(2,R.$6j),se(3,A.$5i)],w)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,R,A,N,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.zip=e.$bp=e.$ap=void 0,e.$ap="end of central directory record signature not found";const I=new RegExp(e.$ap);class O extends Error{constructor(a,i){let s=i.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=i}}e.$bp=O;function d(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,s)=>i+s,a&61440)}function g(t){if(t instanceof O)return t;let a;return I.test(t.message)&&(a="CorruptZip"),new O(a,t)}function y(t,a,i,s,n,r){const c=R.$_d(a),P=R.$9d(s,c);if(!P.startsWith(s))return Promise.reject(new Error(v.localize(0,null,a)));const S=R.$9d(s,a);let E;return r.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(N.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((j,H)=>{if(!r.isCancellationRequested)try{E=(0,L.createWriteStream)(S,{mode:i}),E.once("close",()=>j()),E.once("error",H),t.once("error",H),t.pipe(E)}catch(x){H(x)}}))}function w(t,a,i,s){let n=(0,D.$ug)(()=>Promise.resolve()),r=0;const c=s.onCancellationRequested(()=>{n.cancel(),t.close()});return new Promise((P,S)=>{const E=new D.$Bg,j=H=>{H.isCancellationRequested||(r++,t.readEntry())};t.once("error",S),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===r?P():S(new O("Incomplete",new Error(v.localize(1,null,r,t.entryCount))))},S)),t.readEntry(),t.on("entry",H=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(H.fileName)){j(s);return}const x=H.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const te=R.$9d(a,x);n=(0,D.$ug)(ae=>N.Promises.mkdir(te,{recursive:!0}).then(()=>j(ae)).then(void 0,S));return}const _=h(t,H),ue=d(H);n=(0,D.$ug)(te=>E.queue(()=>_.then(ae=>y(ae,x,ue,a,i,te).then(()=>j(te)))).then(null,S))})}).finally(()=>c.dispose())}function $(t,a=!1){return new Promise((i,s)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(n,r)=>{n?s(g(n)):i((0,A.$uf)(r))})})}function h(t,a){return new Promise((i,s)=>{t.openReadStream(a,(n,r)=>{n?s(g(n)):i((0,A.$uf)(r))})})}function f(t,a){return new Promise((i,s)=>{const n=new l.ZipFile;a.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const r=(0,L.createWriteStream)(t);n.outputStream.pipe(r),n.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>i(t))})}e.zip=f;function k(t,a,i={},s){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(c=>N.Promises.rm(a).then(()=>c))),r.then(c=>w(c,a,{sourcePathRegex:n},s))}e.$dp=k;function p(t,a){return $(t).then(i=>new Promise((s,n)=>{i.on("entry",r=>{r.fileName===a&&h(i,r).then(c=>s(c),c=>n(c))}),i.once("close",()=>n(new Error(v.localize(2,null,a))))}))}function b(t,a){return p(t,a).then(i=>new Promise((s,n)=>{const r=[];i.once("error",n),i.on("data",c=>r.push(c)),i.on("end",()=>s(Buffer.concat(r)))}))}e.$ep=b}),define(ne[160],re([0,1,8,9,2,15,17,43,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;let p=class extends R.$kc{static{k=this}static{this.c=".sigzip"}constructor(t,a,i,s,n,r){super(),this.h=a,this.j=i,this.m=s,this.n=n,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,i){await this.g;const s=(0,N.$ig)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,r=>this.j.download(t,r,a))}catch(r){throw new y.$1n(r.message,y.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.t(t)){const r=await this.u(t);try{n=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(c){const P=c;if(n=P.code,P.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${P.output}`),n===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new y.$1n(O.$ap,y.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(c){this.r.error(c)}}}return n===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,u.$pf)(a)?a:!0}async u(t){await this.g;const a=(0,N.$ig)(this.extensionsDownloadDir,`${this.z(t)}${k.c}`);return await this.w(t,a,i=>this.j.downloadSignatureArchive(t,i)),a}async w(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await i(a);return}const s=(0,N.$ig)(this.extensionsDownloadDir,`.${(0,l.$4f)()}`);await this.h.exists(s)||await i(s);try{await I.Promises.rename(s.fsPath,a.fsPath,2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,D.$8)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],s=[];for(const c of t.children)if(c.name.endsWith(k.c))s.push(c.resource);else{const P=w.$qo.parse(c.name);P&&i.push([P,c])}const n=(0,w.$vo)(i,([c])=>c),r=[];for(const c of n)c.sort((P,S)=>v.rcompare(P[0].version,S[0].version)),a.push(...c.slice(1).map(P=>P[1].resource)),r.push(c[0][1]);r.sort((c,P)=>c.mtime-P.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(c=>c.resource)),a.push(...s),await L.Promises.settled(a.map(c=>(this.r.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$qo.create(t).toString().toLowerCase():(0,l.$4f)()}};e.$tp=p,e.$tp=p=k=$e([se(0,g.$Jh),se(1,h.$6j),se(2,y.$Zn),se(3,d.$8h),se(4,$.$7o),se(5,f.$5i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;function R(A){return(0,L.$ep)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$vp=R}),define(ne[162],re([0,1,8,14,20,34,9,4,42,2,31,15,16,17,43,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k,p,b,t,a,i,s,n,r,c,P,S,E,j,H,x,_,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$yp=(0,_.$Ch)(i.$2n);const B=".vsctmp";let G=class extends a.$fp{constructor(U,z,o,m,F,C,Y,W,ce,oe,pe,de){super(U,z,pe,o,oe,de),this.fb=F,this.gb=C,this.hb=Y,this.ib=ce,this.eb=new Map,this.rb=new I.$Ai;const ge=this.B(W.createInstance(P.$up));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new E.$wp(de,ce,pe,this,this.F)),this.db=this.B(W.createInstance(c.$tp));const fe=this.B(new j.$xp(this,this.fb,de,C,pe,ce,o));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Ao)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const z=await this.pb(U),o=await(0,k.zip)((0,g.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)()).fsPath,z);return $.URI.file(o)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:z,cleanup:o}=await this.lb(U),m=d.$0d(z.fsPath);try{return await(0,S.$vp)(m)}finally{await o()}}getInstalled(U,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(U??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.bb.scanUserExtensionAtLocation(U)}async install(U,z={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:o,cleanup:m}=await this.lb(U);try{const F=await(0,S.$vp)(d.$0d(o.fsPath)),C=(0,s.$uo)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,H.$Ho)(F.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const W=(await this.I([{manifest:F,extension:o,options:z}])).find(({identifier:ce})=>(0,s.$po)(ce,{id:C}));if(W?.local)return W.local;throw W?.error?W.error:(0,a.$hp)(new Error(`Unknown error while installing extension ${C}`))}finally{await m()}}async installFromLocation(U,z){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const o=await this.bb.scanUserExtensionAtLocation(U);if(!o)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ub([[o,void 0]],z),this.F.info("Successfully installed extension",o.identifier.id,z.toString()),o}async installExtensionsFromProfile(U,z,o){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,z.toString(),o.toString());const m=(await this.bb.scanExtensions(1,z)).filter(F=>U.some(C=>(0,s.$po)(C,F.identifier)));if(m.length){const F=await Promise.all(m.map(C=>this.bb.scanMetadata(C,z)));await this.ub(m.map((C,Y)=>[C,F[Y]]),o),this.F.info("Successfully installed extensions",m.map(C=>C.identifier.id),o.toString())}return m}async updateMetadata(U,z,o=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,U=await this.bb.updateMetadata(U,z,o),this.cb.invalidate(o),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[o]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!o)throw new Error(p.localize(2,null));await this.bb.setUninstalled(U);try{await this.bb.removeUninstalledExtension(U)}catch(m){throw new Error(p.localize(3,null,(0,A.$mi)(m)))}return this.installFromGallery(o)}ab(U,z,o,m){return this.bb.copyExtension(U,z,o,m)}copyExtensions(U,z){return this.bb.copyExtensions(U,z)}markAsUninstalled(...U){return this.bb.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(U){this.F.error(U)}}async download(U,z,o){const{location:m}=await this.db.download(U,z,!o);return m}async lb(U){if(U.scheme===O.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const z=(0,g.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)());return await this.hb.download(U,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(U,z,o){if($.URI.isUri(z))return new X(U,z,o,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=s.$qo.create(z).toString();let F=this.eb.get(m);return F||(this.eb.set(m,F=new q(U,z,o,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),F}$(U,z){return new Z(U,z.profileLocation,this.gb)}async pb(U){const z=async m=>{let F=await f.Promises.readdir(m);F=F.map(W=>d.$9d(m,W));const C=await Promise.all(F.map(W=>f.Promises.stat(W)));let Y=Promise.resolve([]);return C.forEach((W,ce)=>{const oe=F[ce];W.isFile()&&(Y=Y.then(pe=>[...pe,oe])),W.isDirectory()&&(Y=Y.then(pe=>z(oe).then(de=>[...pe,...de])))}),Y};return(await z(U.location.fsPath)).map(m=>({path:`extension/${d.$$d(U.location.fsPath,m)}`,localPath:m}))}async qb({added:U,removed:z}){if(z)for(const o of z.extensions)this.F.info("Extensions removed from another source",o.id,z.profileLocation.toString()),this.u.fire({identifier:o,profileLocation:z.profileLocation});if(U){const m=(await this.bb.scanExtensions(1,U.profileLocation)).filter(F=>U.extensions.some(C=>(0,s.$po)(C,F.identifier)));this.s.fire(m.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,U.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:U.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const U=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of U.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(U){if(!U.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const o of U.rawAdded){if(this.rb.has(o)||!this.D.extUri.isEqual(this.D.extUri.dirname(o),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(o,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(o).startsWith(".")||!(await this.ib.stat(o)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(o);m&&m.installedTimestamp===void 0&&(this.rb.add(o),z.push(m))}z.length&&(await this.ub(z.map(o=>[o,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(o=>o.identifier.id)))}async ub(U,z){const o=U.map(m=>m[0]);await this.vb(o),await this.gb.addExtensionsToProfile(U,z),this.s.fire(o.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async vb(U){const z=await this.bb.getUninstalledExtensions();for(const o of U){const m=s.$qo.create(o);z[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$zp=G,e.$zp=G=$e([se(0,i.$Zn),se(1,ae.$9k),se(2,ue.$5i),se(3,t.$Jh),se(4,r.$op),se(5,n.$kp),se(6,b.$Dn),se(7,_.$Ah),se(8,x.$6j),se(9,te.$kj),se(10,le.$Ck),se(11,ie.$Ek)],G);let T=class extends l.$kc{constructor(U,z,o,m,F,C){super(),this.j=U,this.m=z,this.n=o,this.s=m,this.t=F,this.u=C,this.h=this.B(new v.$fd),this.onExtract=this.h.event,this.c=(0,g.$ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$Ng}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,z){const o={includeInvalid:!0,profileLocation:z};let m=[];return U===null||U===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},o,!1)):U===1&&m.push(...await this.n.scanUserExtensions(o)),m=U!==null?m.filter(F=>F.type===U):m,Promise.all(m.map(F=>this.F(F)))}async scanAllUserExtensions(U){const z=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(z.map(o=>this.F(o)))}async scanUserExtensionAtLocation(U){try{const z=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(U,z,o,m,F){const C=U.toString(),Y=$.URI.file(d.$9d(this.n.userExtensionsLocation.fsPath,`.${(0,h.$4f)()}`)),W=$.URI.file(d.$9d(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(W);if(ce&&m){try{await this.y(U.id,W,"removeExisting")}catch{throw new i.$1n(p.localize(4,null,W.fsPath,U.id),i.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,k.$dp)(z,Y.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${W}:`,U.id)}catch(oe){let pe=i.ExtensionManagementErrorCode.Extract;throw oe instanceof k.$bp&&(oe.type==="CorruptZip"?pe=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(pe=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$1n(oe.message,pe)}await this.n.updateMetadata(Y,o);try{this.u.trace(`Started renaming the extension from ${Y.fsPath} to ${W.fsPath}`),await this.C(Y.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,N.$8)(oe)}. Deleted from extracted location`,Y),oe}this.h.fire(W)}catch(oe){try{await this.m.del(Y,{recursive:!0})}catch{}throw oe}return this.D(W,1)}async scanMetadata(U,z){return z?(await this.w(U,z))?.metadata:this.n.scanMetadata(U.location)}async w(U,z){return(await this.s.scanProfileExtensions(z)).find(m=>(0,s.$po)(m.identifier,U.identifier))}async updateMetadata(U,z,o){return o?await this.s.updateMetadata([[U,z]],o):await this.n.updateMetadata(U.location,z),this.D(U.location,U.type,o)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const z=U.map(o=>s.$qo.create(o));await this.z(o=>z.forEach(m=>{o[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(U){await this.z(z=>delete z[U.toString()])}async removeExtension(U,z){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,z)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(z=>delete z[s.$qo.create(U).toString()])}async copyExtension(U,z,o,m){const F=await this.w(U,z),C=await this.w(U,o);return m={...F?.metadata,...m},C?await this.s.updateMetadata([[U,{...C.metadata,...m}]],o):await this.s.addExtensionsToProfile([[U,m]],o),this.D(U.location,U.type,o)}async copyExtensions(U,z){const o=await this.scanExtensions(1,U),m=await Promise.all(o.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,U)]));await this.s.addExtensionsToProfile(m,z)}async y(U,z,o){this.u.trace(`Deleting ${o} extension from disk`,U,z.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$pi)((0,h.$4f)()).toString(16)}${B}`);await this.C(z.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${o} extension from disk`,U,z.fsPath)}async z(U){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,x.$jk)(m)!==1)throw m}let o={};if(z)try{o=JSON.parse(z)}catch{}return U&&(U(o),Object.keys(o).length?await this.m.writeFile(this.c,D.$Fd.fromString(JSON.stringify(o))):await this.m.del(this.c)),o})}async C(U,z){try{await f.Promises.rename(U,z,2*60*1e3)}catch(o){throw new i.$1n(o.message||p.localize(5,null,U,z),o.code||i.ExtensionManagementErrorCode.Rename)}}async D(U,z,o){if(o){const F=(await this.n.scanUserExtensions({profileLocation:o})).find(C=>this.t.extUri.isEqual(C.location,U));if(F)return this.F(F)}else{const m=await this.n.scanExistingExtension(U,z,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(p.localize(6,null,U.path))}async F(U){const z=await this.m.resolve(U.location);let o,m;return z.children&&(o=z.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,m=z.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:o,changelogUrl:m,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const F of z)U[s.$qo.create(F).toString()]||o.add(F.identifier.id.toLowerCase());try{const F=(0,s.$vo)(z,C=>C.identifier);await L.Promises.settled(F.map(async C=>{const Y=C.sort((W,ce)=>y.rcompare(W.manifest.version,ce.manifest.version))[0];o.has(Y.identifier.id.toLowerCase())||await this.j(await this.F(Y))}))}catch(F){this.u.error(F)}const m=z.filter(F=>F.metadata&&U[s.$qo.create(F).toString()]);await Promise.allSettled(m.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,x.$jk)(z)!==1&&this.u.error(z);return}if(U?.children)try{await Promise.allSettled(U.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(o){(0,x.$jk)(o)!==1&&this.u.error(o)}}}))}catch{}}};e.$Ap=T,e.$Ap=T=$e([se(1,x.$6j),se(2,r.$op),se(3,n.$kp),se(4,le.$Ck),se(5,ue.$5i)],T);class M extends a.$ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$qf)(this.options.operation)?this.l:this.options.operation}constructor(U,z,o,m,F,C,Y,W,ce){super(),this.identifier=U,this.source=z,this.options=o,this.m=m,this.n=F,this.o=C,this.p=Y,this.q=W,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[z,o]=await this.x(U);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,o]],this.j),z}async u({zipPath:U,key:z,metadata:o},m,F){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,U,o,m,F),this.s.info("Extracting extension completed.",z.id)),C}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(m=>s.$qo.create(m).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class q extends M{constructor(U,z,o,m,F,C,Y,W,ce,oe){super(z.identifier,z,o,F,C,Y,W,ce,oe),this.y=z,this.z=m}async x(U){const o=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Y=>(0,s.$po)(Y.identifier,this.y.identifier));o&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$pf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.y.version)return[await this.m.updateMetadata(o,m),m];const{location:F,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:s.$qo.create(this.y),metadata:m},!1,U),m]}catch(Y){try{await this.z.delete(F)}catch(W){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,N.$8)(W))}throw Y}}async B(U){try{await(0,S.$vp)(U)}catch(z){throw new i.$1n((0,a.$gp)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$Bp=q;class X extends M{constructor(U,z,o,m,F,C,Y,W,ce,oe){super({id:(0,s.$uo)(U.publisher,U.name)},z,o,F,C,Y,W,ce,oe),this.y=U,this.z=z,this.A=m}async h(U){const z=await super.h(U);return this.D(z,U),z}async x(U){const z=new s.$qo(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Y=>(0,s.$po)(this.identifier,Y.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new s.$qo(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&y.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Y=await this.v(z);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$0d(this.z.fsPath),key:z,metadata:F},!0,U),F]}async D(U,z){try{let[o]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],z);if(o||([o]=await this.A.getExtensions([{id:U.identifier.id}],z)),o){const m={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,m,this.options.profileLocation)}}catch{}}}class Z extends a.$ip{constructor(U,z,o){super(),this.extension=U,this.j=z,this.k=o}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,45,136,178]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;let y=class extends O.$Jo{constructor(f,k,p,b){super(b),this.m=f,this.n=k,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,k){const{f:p,g:b}=this;let t;try{t=await(0,l.$Ml)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$8)(s)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,d.$Nq)(f.url||"",a,{proxyUrl:p,strictSSL:b});return f.agent=i,f.strictSSL=b,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,k))}async resolveProxy(f){}};e.$Oq=y,e.$Oq=y=$e([se(0,v.$8h),se(1,u.$Jh),se(2,I.$5i),se(3,I.$6i)],y);async function w(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,b)=>{J(["https"],p,b)}):await new Promise((p,b)=>{J(["http"],p,b)})).request}async function $(h,f){return D.Promises.withAsyncBody(async(k,p)=>{const b=(0,L.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),a={hostname:b.hostname,port:b.port?parseInt(b.port):b.protocol==="https:"?443:80,protocol:b.protocol,path:b.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,N.$pf)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(a.auth=h.user+":"+h.password);const i=t(a,s=>{const n=(0,N.$nf)(h.followRedirects)?h.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)$({...h,url:s.headers.location,followRedirects:n-1},f).then(k,p);else{let r=s;!h.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,g.createGunzip)())),k({res:s,stream:(0,R.$Ud)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new A.$3)})})}e.$Pq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,R,A,N,v,u,l,I,O,d,g,y,w,$,h,f,k,p,b,t,a,i,s,n,r,c,P,S,E,j,H,x,_,ue,te,ae,le,ie,B,G,T,M,q,X,Z,K,U,z,o,m,F,C,Y,W,ce,oe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends N.$kc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(_.$5i),Fe=be.get(r.$6j),V=be.get(h.$Jh),Q=be.get(m.$Ek);Se.info("CLI main",this.b),this.g(Se),await this.h(V,Fe,Q,he),await Promise.all(we.map(ee=>{(0,D.$yg)(ee.flush(),1e3)}))})}async f(){const he=new j.$zh,we={_serviceBrand:void 0,...le.default};he.set(ie.$kj,we);const be=new f.$_l(this.b,we);he.set(h.$Jh,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(De=>De?d.Promises.mkdir(De,{recursive:!0}):void 0));const Se=new ce.$cN((0,_.$gj)(be),be.logsHome);he.set(_.$6i,Se);const Fe=this.B(Se.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];Se.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$aj(Se.getLogLevel()));const Q=this.B(new W.$mN(Fe,V));he.set(_.$5i,Q);const ee=this.B(new c.$Dp(Q));he.set(r.$6j,ee);const me=this.B(new P.$3p(Q));ee.registerProvider(v.Schemas.file,me);const ye=new o.$pr(ee);he.set(z.$Ck,ye);const je=new T.$gN(1,be,Q,ee),ke=new F.$iN(je,ye,be,ee,Q);he.set(m.$Ek,ke),ee.registerProvider(v.Schemas.vscodeUserData,new pe.$h7b(v.Schemas.file,me,v.Schemas.vscodeUserData,ke,ye,Q));const Le=l.$i&&we.win32RegValueName?this.B(new ae.$f7b(Q,we.win32RegValueName)):be.policyFile?this.B(new ue.$g7b(be.policyFile,ee,Q)):new te.$_m;he.set(te.$0m,Le);const Ie=this.B(new y.$zn(ke.defaultProfile.settingsResource,ee,Le,Q));he.set(g.$8h,Ie),await Promise.all([je.init(),Ie.initialize()]);let Ae;try{Ae=await(0,C.$Y6b)(je,Q)}catch(De){De.code!=="ENOENT"&&Q.error(De)}ke.init(),he.set(z.$Ck,new o.$pr(ee));const Ue=new G.$Oq(Ie,be,Q,Se);he.set(B.$Io,Ue),he.set(w.$Dn,new S.$yh($.$BN,void 0,!0)),he.set(a.$kp,new S.$yh(Y.$lN,void 0,!0)),he.set(i.$op,new S.$yh(n.$V6b,void 0,!0)),he.set(b.$7o,new S.$yh(b.$8o,void 0,!0)),he.set(s.$yp,new S.$yh(s.$zp,void 0,!0)),he.set(p.$Zn,new S.$yh(k.$6o,void 0,!0)),he.set(H.$Iq,new S.$yh(x.$Kq,void 0,!1));const Oe=[],Ne=(0,Z.$mo)(we,Ie);if((0,Z.$ho)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new K.$aN(Ue,Ne,"monacoworkbench",null,we.aiConfig.ariaKey));const De={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,M.$0n)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Ne),piiPaths:(0,Z.$no)(be)};he.set(q.$9k,new S.$yh(X.$Qq,[De],!1))}else he.set(q.$9k,Z.$bo);return[new E.$6p(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$mi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$X)(we)||(0,A.$Y)(we)}),process.on("unhandledRejection",we=>(0,A.$Y)(we))}async h(he,we,be,Se){let Fe;if(he.args.profile&&(Fe=be.profiles.find(Q=>Q.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Q,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$D7b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$8d)(we)?we:(0,u.$9d)((0,I.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10765021158cf51eaf6785361598e1668f53e06e/core/vs/code/node/cliProcessMain.js.map
