/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],O=0,N=te.length;O<N;O++)e[O]=oe[te[O]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class O{static get(){const A=new Map,L=new Map,D=new Map,I=new Map;function S(l,f){l.has(f.detail)||l.set(f.detail,-f.timestamp)}function m(l,f){const w=l.get(f.detail);w&&(w>=0||l.set(f.detail,w+f.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((l,f)=>l.timestamp-f.timestamp));for(const l of P)switch(l.type){case 10:S(A,l);break;case 11:case 12:m(A,l);break;case 21:S(L,l);break;case 22:m(L,l);break;case 33:S(D,l);break;case 34:m(D,l);break;case 31:S(I,l);break;case 32:m(I,l);break}let E=0;D.forEach(l=>E+=l);function g(l){const f=[];return l.forEach((w,d)=>f.push([d,w])),f}return{amdLoad:g(A),amdInvoke:g(L),nodeRequire:g(D),nodeEval:g(I),nodeRequireTotal:E}}static toMarkdownTable(A,L){let D="";const I=[];return A.forEach((S,m)=>{I[m]=S.length}),L.forEach(S=>{S.forEach((m,P)=>{typeof m>"u"&&(m=S[P]="-");const E=m.toString().length;I[P]=Math.max(E,I[P])})}),A.forEach((S,m)=>{D+=`| ${S+" ".repeat(I[m]-S.toString().length)} `}),D+=`|
`,A.forEach((S,m)=>{D+=`| ${"-".repeat(I[m])} `}),D+=`|
`,L.forEach(S=>{S.forEach((m,P)=>{typeof m<"u"&&(D+=`| ${m+" ".repeat(I[P]-m.toString().length)} `)}),D+=`|
`}),D}}e.$S=O}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function O(w,d,h){const o=N(w,d);if(o!==-1)return w[o]}e.$db=O;function N(w,d,h=w.length-1){for(let o=h;o>=0;o--){const $=w[o];if(d($))return o}return-1}e.$eb=N;function A(w,d){const h=L(w,d);return h===-1?void 0:w[h]}e.$fb=A;function L(w,d,h=0,o=w.length){let $=h,y=o;for(;$<y;){const C=Math.floor(($+y)/2);d(w[C])?$=C+1:y=C}return $-1}e.$gb=L;function D(w,d){const h=I(w,d);return h===w.length?void 0:w[h]}e.$hb=D;function I(w,d,h=0,o=w.length){let $=h,y=o;for(;$<y;){const C=Math.floor(($+y)/2);d(w[C])?y=C:$=C+1}return $}e.$ib=I;function S(w,d,h=0,o=w.length){const $=I(w,d,h,o);return $===w.length?-1:$}e.$jb=S;class m{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(m.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!d(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const h=L(this.e,d,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$kb=m;function P(w,d){if(w.length===0)return;let h=w[0];for(let o=1;o<w.length;o++){const $=w[o];d($,h)>0&&(h=$)}return h}e.$lb=P;function E(w,d){if(w.length===0)return;let h=w[0];for(let o=1;o<w.length;o++){const $=w[o];d($,h)>=0&&(h=$)}return h}e.$mb=E;function g(w,d){return P(w,(h,o)=>-d(h,o))}e.$nb=g;function l(w,d){if(w.length===0)return-1;let h=0;for(let o=1;o<w.length;o++){const $=w[o];d($,w[h])>0&&(h=o)}return h}e.$ob=l;function f(w,d){for(const h of w){const o=d(h);if(o!==void 0)return o}}e.$pb=f}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function O(D,I){const S=Object.create(null);for(const m of D){const P=I(m);let E=S[P];E||(E=S[P]=[]),E.push(m)}return S}e.$I=O;function N(D,I){const S=[],m=[];for(const P of D)I.has(P)||S.push(P);for(const P of I)D.has(P)||m.push(P);return{removed:S,added:m}}e.$J=N;function A(D,I){const S=[],m=[];for(const[P,E]of D)I.has(P)||S.push(E);for(const[P,E]of I)D.has(P)||m.push(E);return{removed:S,added:m}}e.$K=A;class L{constructor(){this.a=new Map}add(I,S){let m=this.a.get(I);m||(m=new Set,this.a.set(I,m)),m.add(S)}delete(I,S){const m=this.a.get(I);m&&(m.delete(S),m.size===0&&this.a.delete(I))}forEach(I,S){const m=this.a.get(I);m&&m.forEach(S)}get(I){const S=this.a.get(I);return S||new Set}}e.$L=L}),define(oe[83],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function O(D){return(I,S,m)=>{let P=null,E=null;if(typeof m.value=="function"?(P="value",E=m.value):typeof m.get=="function"&&(P="get",E=m.get),!E)throw new Error("not supported");m[P]=D(E,S)}}function N(D,I,S){let m=null,P=null;if(typeof S.value=="function"?(m="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(m="get",P=S.get),!P)throw new Error("not supported");const E=`$memoize$${I}`;S[m]=function(...g){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[E]}}e.$6g=N;function A(D,I,S){return O((m,P)=>{const E=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...l){this[g]||(this[g]=S?S():void 0),clearTimeout(this[E]),I&&(this[g]=I(this[g],...l),l=[this[g]]),this[E]=setTimeout(()=>{m.apply(this,l),this[g]=S?S():void 0},D)}})}e.$7g=A;function L(D,I,S){return O((m,P)=>{const E=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,f=`$throttle$pending$${P}`;return function(...w){if(this[g]||(this[g]=S?S():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),I&&(this[g]=I(this[g],...w)),this[f])return;const d=this[l]+D;d<=Date.now()?(this[l]=Date.now(),m.apply(this,[this[g]]),this[g]=S?S():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[l]=Date.now(),m.apply(this,[this[g]]),this[g]=S?S():void 0},d-Date.now()))}})}e.$8g=L}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?$.isErrorNoTelemetry(i)?new $(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=O,e.$V=new O;function N(C){e.$V.setUnexpectedErrorHandler(C)}e.setUnexpectedErrorHandler=N;function A(C){if(!C||typeof C!="object")return!1;const i=C;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$X=A;function L(C){m(C)||e.$V.onUnexpectedError(C)}e.$Y=L;function D(C){m(C)||e.$V.onUnexpectedExternalError(C)}e.$Z=D;function I(C){if(C instanceof Error){const{name:i,message:c}=C,n=C.stacktrace||C.stack;return{$isError:!0,name:i,message:c,stack:n,noTelemetry:$.isErrorNoTelemetry(C)}}return C}e.$1=I;const S="Canceled";function m(C){return C instanceof P?!0:C instanceof Error&&C.name===S&&C.message===S}e.$2=m;class P extends Error{constructor(){super(S),this.name=this.message}}e.$3=P;function E(){const C=new Error(S);return C.name=C.message,C}e.$4=E;function g(C){return C?new Error(`Illegal argument: ${C}`):new Error("Illegal argument")}e.$5=g;function l(C){return C?new Error(`Illegal state: ${C}`):new Error("Illegal state")}e.$6=l;class f extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=f;function w(C){return C?C.message?C.message:C.stack?C.stack.split(`
`)[0]:String(C):"Error"}e.$8=w;class d extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$9=d;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$0=h;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=o;class $ extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof $)return i;const c=new $;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$_=$;class y extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,y.prototype)}}e.$ab=y}),define(oe[18],ae([0,1,8,125]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function A(M,K=0){return M[M.length-(1+K)]}e.$qb=A;function L(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.$rb=L;function D(M,K,Y=(se,le)=>se===le){if(M===K)return!0;if(!M||!K||M.length!==K.length)return!1;for(let se=0,le=M.length;se<le;se++)if(!Y(M[se],K[se]))return!1;return!0}e.$sb=D;function I(M,K){const Y=M.length-1;K<Y&&(M[K]=M[Y]),M.pop()}e.$tb=I;function S(M,K,Y){return m(M.length,se=>Y(M[se],K))}e.$ub=S;function m(M,K){let Y=0,se=M-1;for(;Y<=se;){const le=(Y+se)/2|0,ue=K(le);if(ue<0)Y=le+1;else if(ue>0)se=le-1;else return le}return-(Y+1)}e.$vb=m;function P(M,K,Y){if(M=M|0,M>=K.length)throw new TypeError("invalid index");const se=K[Math.floor(K.length*Math.random())],le=[],ue=[],he=[];for(const $e of K){const de=Y($e,se);de<0?le.push($e):de>0?ue.push($e):he.push($e)}return M<le.length?P(M,le,Y):M<le.length+he.length?he[0]:P(M-(le.length+he.length),ue,Y)}e.$wb=P;function E(M,K){const Y=[];let se;for(const le of M.slice(0).sort(K))!se||K(se[0],le)!==0?(se=[le],Y.push(se)):se.push(le);return Y}e.$xb=E;function*g(M,K){let Y,se;for(const le of M)se!==void 0&&K(se,le)?Y.push(le):(Y&&(yield Y),Y=[le]),se=le;Y&&(yield Y)}e.$yb=g;function l(M,K){for(let Y=0;Y<=M.length;Y++)K(Y===0?void 0:M[Y-1],Y===M.length?void 0:M[Y])}e.$zb=l;function f(M,K){for(let Y=0;Y<M.length;Y++)K(Y===0?void 0:M[Y-1],M[Y],Y+1===M.length?void 0:M[Y+1])}e.$Ab=f;function w(M,K,Y){const se=[];function le($e,de,we){if(de===0&&we.length===0)return;const ve=se[se.length-1];ve&&ve.start+ve.deleteCount===$e?(ve.deleteCount+=de,ve.toInsert.push(...we)):se.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===M.length){le(ue,0,K.slice(he));break}if(he===K.length){le(ue,M.length-ue,[]);break}const $e=M[ue],de=K[he],we=Y($e,de);we===0?(ue+=1,he+=1):we<0?(le(ue,1,[]),ue+=1):we>0&&(le(ue,0,[de]),he+=1)}return se}e.$Bb=w;function d(M,K,Y){const se=w(M,K,Y),le=[],ue=[];for(const he of se)le.push(...M.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:le,added:ue}}e.$Cb=d;function h(M,K,Y){if(Y===0)return[];const se=M.slice(0,Y).sort(K);return $(M,K,se,Y,M.length),se}e.top=h;function o(M,K,Y,se,le){return Y===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=M.length,de=M.slice(0,Y).sort(K);for(let we=Y,ve=Math.min(Y+se,$e);we<$e;we=ve,ve=Math.min(ve+se,$e)){if(we>Y&&await new Promise(Ie=>setTimeout(Ie)),le&&le.isCancellationRequested)throw new O.$3;$(M,K,de,we,ve)}return de})().then(ue,he)})}e.$Eb=o;function $(M,K,Y,se,le){for(const ue=Y.length;se<le;se++){const he=M[se];if(K(he,Y[ue-1])<0){Y.pop();const $e=(0,N.$ib)(Y,de=>K(he,de)<0);Y.splice($e,0,he)}}}function y(M){return M.filter(K=>!!K)}e.$Fb=y;function C(M){let K=0;for(let Y=0;Y<M.length;Y++)M[Y]&&(M[K]=M[Y],K+=1);M.length=K}e.$Gb=C;function i(M,K,Y){M.splice(Y,0,M.splice(K,1)[0])}e.$Hb=i;function c(M){return!Array.isArray(M)||M.length===0}e.$Ib=c;function n(M){return Array.isArray(M)&&M.length>0}e.$Jb=n;function s(M,K=Y=>Y){const Y=new Set;return M.filter(se=>{const le=K(se);return Y.has(le)?!1:(Y.add(le),!0)})}e.$Kb=s;function t(M){const K=new Set;return Y=>{const se=M(Y);return K.has(se)?!1:(K.add(se),!0)}}e.$Lb=t;function r(M,K){return M.length>0?M[0]:K}e.$Mb=r;function a(M,K){return M.length>0?M[M.length-1]:K}e.$Nb=a;function v(M,K,Y=(se,le)=>se===le){let se=0;for(let le=0,ue=Math.min(M.length,K.length);le<ue&&Y(M[le],K[le]);le++)se++;return se}e.$Ob=v;function b(M){return[].concat(...M)}e.$Pb=b;function u(M,K){let Y=typeof K=="number"?M:0;typeof K=="number"?Y=M:(Y=0,K=M);const se=[];if(Y<=K)for(let le=Y;le<K;le++)se.push(le);else for(let le=Y;le>K;le--)se.push(le);return se}e.$Qb=u;function p(M,K,Y){return M.reduce((se,le)=>(se[K(le)]=Y?Y(le):le,se),Object.create(null))}e.$Rb=p;function j(M,K){return M.push(K),()=>F(M,K)}e.$Sb=j;function F(M,K){const Y=M.indexOf(K);if(Y>-1)return M.splice(Y,1),K}e.$Tb=F;function T(M,K,Y){const se=M.slice(0,K),le=M.slice(K);return se.concat(Y,le)}e.$Ub=T;function z(M,K){let Y;if(typeof K=="number"){let se=K;Y=()=>{const le=Math.sin(se++)*179426549;return le-Math.floor(le)}}else Y=Math.random;for(let se=M.length-1;se>0;se-=1){const le=Math.floor(Y()*(se+1)),ue=M[se];M[se]=M[le],M[le]=ue}}e.$Vb=z;function B(M,K){const Y=M.indexOf(K);Y>-1&&(M.splice(Y,1),M.unshift(K))}e.$Wb=B;function _(M,K){const Y=M.indexOf(K);Y>-1&&(M.splice(Y,1),M.push(K))}e.$Xb=_;function J(M,K){for(const Y of K)M.push(Y)}e.$Yb=J;function Q(M,K){return Array.isArray(M)?M.map(K):K(M)}e.$Zb=Q;function H(M){return Array.isArray(M)?M:[M]}e.$1b=H;function x(M){return M[Math.floor(Math.random()*M.length)]}e.$2b=x;function G(M,K,Y){const se=W(M,K),le=M.length,ue=Y.length;M.length=le+ue;for(let he=le-1;he>=se;he--)M[he+ue]=M[he];for(let he=0;he<ue;he++)M[he+se]=Y[he]}e.$3b=G;function V(M,K,Y,se){const le=W(M,K);let ue=M.splice(le,Y);return ue===void 0&&(ue=[]),G(M,le,se),ue}e.$4b=V;function W(M,K){return K<0?Math.max(K+M.length,0):Math.min(K,M.length)}var ee;(function(M){function K(ue){return ue<0}M.isLessThan=K;function Y(ue){return ue<=0}M.isLessThanOrEqual=Y;function se(ue){return ue>0}M.isGreaterThan=se;function le(ue){return ue===0}M.isNeitherLessOrGreaterThan=le,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(M,K){return(Y,se)=>K(M(Y),M(se))}e.$5b=ne;function re(...M){return(K,Y)=>{for(const se of M){const le=se(K,Y);if(!ee.isNeitherLessOrGreaterThan(le))return le}return ee.neitherLessOrGreaterThan}}e.$6b=re;const X=(M,K)=>M-K;e.$7b=X;const q=(M,K)=>(0,e.$7b)(M?1:0,K?1:0);e.$8b=q;function k(M){return(K,Y)=>-M(K,Y)}e.$9b=k;class R{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let Y=this.c;for(;Y<this.g.length&&K(this.g[Y]);)Y++;const se=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,se}takeFromEndWhile(K){let Y=this.d;for(;Y>=0&&K(this.g[Y]);)Y--;const se=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,se}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const Y=this.g.slice(this.c,this.c+K);return this.c+=K,Y}}e.$0b=R;class U{static{this.empty=new U(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(Y=>(K(Y),!0))}toArray(){const K=[];return this.iterate(Y=>(K.push(Y),!0)),K}filter(K){return new U(Y=>this.iterate(se=>K(se)?Y(se):!0))}map(K){return new U(Y=>this.iterate(se=>Y(K(se))))}some(K){let Y=!1;return this.iterate(se=>(Y=K(se),!Y)),Y}findFirst(K){let Y;return this.iterate(se=>K(se)?(Y=se,!1):!0),Y}findLast(K){let Y;return this.iterate(se=>(K(se)&&(Y=se),!0)),Y}findLastMaxBy(K){let Y,se=!0;return this.iterate(le=>((se||ee.isGreaterThan(K(le,Y)))&&(se=!1,Y=le),!0)),Y}}e.$$b=U}),define(oe[127],ae([0,1,8]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function N(S,m){if(!S)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=N;function A(S,m="Unreachable"){throw new Error(m)}e.$vc=A;function L(S){if(!S)throw new O.$ab("Assertion Failed")}e.$wc=L;function D(S){if(!S()){debugger;S(),(0,O.$Y)(new O.$ab("Assertion Failed"))}}e.$xc=D;function I(S,m){let P=0;for(;P<S.length-1;){const E=S[P],g=S[P+1];if(!m(E,g))return!1;P++}return!0}e.$yc=I}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function O(N){const A=this;let L=!1,D;return function(){return L||(L=!0,D=N.apply(A,arguments)),D}}e.$bb=O}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(N){function A(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}N.is=A;const L=Object.freeze([]);function D(){return L}N.empty=D;function*I(C){yield C}N.single=I;function S(C){return A(C)?C:I(C)}N.wrap=S;function m(C){return C||L}N.from=m;function*P(C){for(let i=C.length-1;i>=0;i--)yield C[i]}N.reverse=P;function E(C){return!C||C[Symbol.iterator]().next().done===!0}N.isEmpty=E;function g(C){return C[Symbol.iterator]().next().value}N.first=g;function l(C,i){for(const c of C)if(i(c))return!0;return!1}N.some=l;function f(C,i){for(const c of C)if(i(c))return c}N.find=f;function*w(C,i){for(const c of C)i(c)&&(yield c)}N.filter=w;function*d(C,i){let c=0;for(const n of C)yield i(n,c++)}N.map=d;function*h(...C){for(const i of C)for(const c of i)yield c}N.concat=h;function o(C,i,c){let n=c;for(const s of C)n=i(n,s);return n}N.reduce=o;function*$(C,i,c=C.length){for(i<0&&(i+=C.length),c<0?c+=C.length:c>C.length&&(c=C.length);i<c;i++)yield C[i]}N.slice=$;function y(C,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,C];const n=C[Symbol.iterator]();for(let s=0;s<i;s++){const t=n.next();if(t.done)return[c,N.empty()];c.push(t.value)}return[c,{[Symbol.iterator](){return n}}]}N.consume=y})(O||(e.Iterable=O={}))}),define(oe[34],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function D(i,c=!1){let n=0;const s=i.length;let t="",r=0,a=16,v=0;function b(B){let _=0,J=0;for(;_<B;){const Q=i.charCodeAt(n);if(Q>=48&&Q<=57)J=J*16+Q-48;else if(Q>=65&&Q<=70)J=J*16+Q-65+10;else if(Q>=97&&Q<=102)J=J*16+Q-97+10;else break;n++,_++}return _<B&&(J=-1),J}function u(B){n=B,t="",r=0,a=16,v=0}function p(){const B=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return v=3,i.substring(B,n);let _=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;_=n}else v=3;return i.substring(B,_)}function j(){let B="",_=n;for(;;){if(n>=s){B+=i.substring(_,n),v=2;break}const J=i.charCodeAt(n);if(J===34){B+=i.substring(_,n),n++;break}if(J===92){if(B+=i.substring(_,n),n++,n>=s){v=2;break}switch(i.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const H=b(4);H>=0?B+=String.fromCharCode(H):v=4;break}default:v=5}_=n;continue}if(J>=0&&J<=31)if(S(J)){B+=i.substring(_,n),v=2;break}else v=6;n++}return B}function F(){if(t="",v=0,r=n,n>=s)return r=s,a=17;let B=i.charCodeAt(n);if(I(B)){do n++,t+=String.fromCharCode(B),B=i.charCodeAt(n);while(I(B));return a=15}if(S(B))return n++,t+=String.fromCharCode(B),B===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(B){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=j(),a=10;case 47:{const _=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!S(i.charCodeAt(n));)n++;return t=i.substring(_,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const J=s-1;let Q=!1;for(;n<J;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,v=1),t=i.substring(_,n),a=13}return t+=String.fromCharCode(B),n++,a=16}case 45:if(t+=String.fromCharCode(B),n++,n===s||!m(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;n<s&&T(B);)n++,B=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(B),n++,a=16}}function T(B){if(I(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let B;do B=F();while(B>=12&&B<=15);return B}return{setPosition:u,getPosition:()=>n,scan:c?z:F,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Jm=D;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function E(i,c){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(b,u,p,j){r.value=b,r.offset=u,r.length=p,r.type=j,r.colonOffset=void 0,t=r}try{$(i,{onObjectBegin:(b,u)=>{if(c<=b)throw s;t=void 0,a=c>b,n.push("")},onObjectProperty:(b,u,p)=>{if(c<u||(v(b,u,p,"property"),n[n.length-1]=b,c<=u+p))throw s},onObjectEnd:(b,u)=>{if(c<=b)throw s;t=void 0,n.pop()},onArrayBegin:(b,u)=>{if(c<=b)throw s;t=void 0,n.push(0)},onArrayEnd:(b,u)=>{if(c<=b)throw s;t=void 0,n.pop()},onLiteralValue:(b,u,p)=>{if(c<u||(v(b,u,p,C(b)),c<=u+p))throw s},onSeparator:(b,u,p)=>{if(c<=u)throw s;if(b===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(b===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(b){if(b!==s)throw b}return{path:n,previousNode:t,isAtPropertyKey:a,matches:b=>{let u=0;for(let p=0;u<b.length&&p<n.length;p++)if(b[u]===n[p]||b[u]==="*")u++;else if(b[u]!=="**")return!1;return u===b.length}}}e.$Km=E;function g(i,c=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(b){Array.isArray(t)?t.push(b):s!==null&&(t[s]=b)}return $(i,{onObjectBegin:()=>{const b={};a(b),r.push(t),t=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const b=[];a(b),r.push(t),t=b,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(b,u,p)=>{c.push({error:b,offset:u,length:p})}},n),t[0]}e.$Lm=g;function l(i,c=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function r(b){return s.children.push(b),b}$(i,{onObjectBegin:b=>{s=r({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,u,p)=>{s=r({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:u,length:p,parent:s})},onObjectEnd:(b,u)=>{s.length=b+u-s.offset,s=s.parent,t(b+u)},onArrayBegin:(b,u)=>{s=r({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,u)=>{s.length=b+u-s.offset,s=s.parent,t(b+u)},onLiteralValue:(b,u,p)=>{r({type:C(b),offset:u,length:p,parent:s,value:b}),t(u+p)},onSeparator:(b,u,p)=>{s.type==="property"&&(b===":"?s.colonOffset=u:b===","&&t(u))},onError:(b,u,p)=>{c.push({error:b,offset:u,length:p})}},n);const v=s.children[0];return v&&delete v.parent,v}e.$Mm=l;function f(i,c){if(!i)return;let n=i;for(const s of c)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Nm=f;function w(i){if(!i.parent||!i.parent.children)return[];const c=w(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;c.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&c.push(n)}return c}e.$Om=w;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const c=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(c[n.children[0].value]=d(s))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$Pm=d;function h(i,c,n=!1){return c>=i.offset&&c<i.offset+i.length||n&&c===i.offset+i.length}e.$Qm=h;function o(i,c,n=!1){if(h(i,c,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=c;t++){const r=o(s[t],c,n);if(r)return r}return i}}e.$Rm=o;function $(i,c,n=L.DEFAULT){const s=D(i,!1);function t(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ne){return ne?re=>ne(re,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(c.onObjectBegin),v=r(c.onObjectProperty),b=t(c.onObjectEnd),u=t(c.onArrayBegin),p=t(c.onArrayEnd),j=r(c.onLiteralValue),F=r(c.onSeparator),T=t(c.onComment),z=r(c.onError),B=n&&n.disallowComments,_=n&&n.allowTrailingComma;function J(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:B||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(ne){case 12:case 13:B?Q(10):T();break;case 16:Q(1);break;case 15:case 14:break;default:return ne}}}function Q(ne,re=[],X=[]){if(z(ne),re.length+X.length>0){let q=s.getToken();for(;q!==17;){if(re.indexOf(q)!==-1){J();break}else if(X.indexOf(q)!==-1)break;q=J()}}}function H(ne){const re=s.getTokenValue();return ne?j(re):v(re),J(),!0}function x(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(Q(2),ne=0)}catch{Q(2)}j(ne);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return J(),!0}function G(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(F(":"),J(),ee()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function V(){a(),J();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Q(4,[],[]),F(","),J(),s.getToken()===2&&_)break}else ne&&Q(6,[],[]);G()||Q(4,[],[2,5]),ne=!0}return b(),s.getToken()!==2?Q(7,[2],[]):J(),!0}function W(){u(),J();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Q(4,[],[]),F(","),J(),s.getToken()===4&&_)break}else ne&&Q(6,[],[]);ee()||Q(4,[],[4,5]),ne=!0}return p(),s.getToken()!==4?Q(8,[4],[]):J(),!0}function ee(){switch(s.getToken()){case 3:return W();case 1:return V();case 10:return H(!0);default:return x()}}return J(),s.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):ee()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.$Sm=$;function y(i,c){const n=D(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),c!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,c)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$Tm=y;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=C}),define(oe[41],ae([0,1,34]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zS=e.$yS=e.$xS=e.$wS=void 0;function N(m,P,E){let g,l,f,w,d;if(P){for(w=P.offset,d=w+P.length,f=w;f>0&&!S(m,f-1);)f--;let a=d;for(;a<m.length&&!S(m,a);)a++;l=m.substring(f,a),g=D(l,E)}else l=m,g=0,f=0,w=0,d=m.length;const h=I(E,m);let o=!1,$=0,y;E.insertSpaces?y=L(" ",E.tabSize||4):y="	";const C=(0,O.$Jm)(l,!1);let i=!1;function c(){return h+L(y,g+$)}function n(){let a=C.scan();for(o=!1;a===15||a===14;)o=o||a===14,a=C.scan();return i=a===16||C.getTokenError()!==0,a}const s=[];function t(a,v,b){!i&&v<d&&b>w&&m.substring(v,b)!==a&&s.push({offset:v,length:b-v,content:a})}let r=n();if(r!==17){const a=C.getTokenOffset()+f,v=L(y,g);t(v,f,a)}for(;r!==17;){let a=C.getTokenOffset()+C.getTokenLength()+f,v=n(),b="";for(;!o&&(v===12||v===13);){const p=C.getTokenOffset()+f;t(" ",a,p),a=C.getTokenOffset()+C.getTokenLength()+f,b=v===12?c():"",v=n()}if(v===2)r!==1&&($--,b=c());else if(v===4)r!==3&&($--,b=c());else{switch(r){case 3:case 1:$++,b=c();break;case 5:case 12:b=c();break;case 13:o?b=c():b=" ";break;case 6:b=" ";break;case 10:if(v===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?b=" ":v!==5&&v!==17&&(i=!0);break;case 16:i=!0;break}o&&(v===12||v===13)&&(b=c())}const u=C.getTokenOffset()+f;t(b,a,u),r=v}return s}e.$wS=N;function A(m,P){const E=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$xS=A;function L(m,P){let E="";for(let g=0;g<P;g++)E+=m;return E}function D(m,P){let E=0,g=0;const l=P.tabSize||4;for(;E<m.length;){const f=m.charAt(E);if(f===" ")g++;else if(f==="	")g+=l;else break;E++}return Math.floor(g/l)}function I(m,P){for(let E=0;E<P.length;E++){const g=P.charAt(E);if(g==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return m&&m.eol||`
`}e.$yS=I;function S(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.$zS=S}),define(oe[85],ae([0,1,34,41]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ES=e.$DS=e.$CS=e.$BS=e.$AS=void 0;function A(m,P,E){return L(m,P,void 0,E)}e.$AS=A;function L(m,P,E,g,l){const f=P.slice(),w=[],d=(0,O.$Mm)(m,w);let h,o;for(;f.length>0&&(o=f.pop(),h=(0,O.$Nm)(d,f),h===void 0&&E!==void 0);)typeof o=="string"?E={[o]:E}:E=[E];if(h)if(h.type==="object"&&typeof o=="string"&&Array.isArray(h.children)){const $=(0,O.$Nm)(h,[o]);if($!==void 0)if(E===void 0){if(!$.parent)throw new Error("Malformed AST");const y=h.children.indexOf($.parent);let C,i=$.parent.offset+$.parent.length;if(y>0){const c=h.children[y-1];C=c.offset+c.length}else C=h.offset+1,h.children.length>1&&(i=h.children[1].offset);return D(m,{offset:C,length:i-C,content:""},g)}else return D(m,{offset:$.offset,length:$.length,content:JSON.stringify(E)},g);else{if(E===void 0)return[];const y=`${JSON.stringify(o)}: ${JSON.stringify(E)}`,C=l?l(h.children.map(c=>c.children[0].value)):h.children.length;let i;if(C>0){const c=h.children[C-1];i={offset:c.offset+c.length,length:0,content:","+y}}else h.children.length===0?i={offset:h.offset+1,length:0,content:y}:i={offset:h.offset+1,length:0,content:y+","};return D(m,i,g)}}else if(h.type==="array"&&typeof o=="number"&&Array.isArray(h.children))if(E!==void 0){const $=`${JSON.stringify(E)}`;let y;if(h.children.length===0||o===0)y={offset:h.offset+1,length:0,content:h.children.length===0?$:$+","};else{const C=o===-1||o>h.children.length?h.children.length:o,i=h.children[C-1];y={offset:i.offset+i.length,length:0,content:","+$}}return D(m,y,g)}else{const $=o,y=h.children[$];let C;if(h.children.length===1)C={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===$){const i=h.children[$-1],c=i.offset+i.length,n=h.offset+h.length;C={offset:c,length:n-2-c,content:""}}else C={offset:y.offset,length:h.children[$+1].offset-y.offset,content:""};return D(m,C,g)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(m,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(E)},g)}}e.$BS=L;function D(m,P,E){let g=I(m,P),l=P.offset,f=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,N.$zS)(g,l-1);)l--;for(;f<g.length&&!(0,N.$zS)(g,f);)f++}const w=(0,N.$wS)(g,{offset:l,length:f-l},E);for(let h=w.length-1;h>=0;h--){const o=w[h];g=I(g,o),l=Math.min(l,o.offset),f=Math.max(f,o.offset+o.length),f+=o.content.length-o.length}const d=m.length-(g.length-f)-l;return[{offset:l,length:d,content:g.substring(l,f)}]}e.$CS=D;function I(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.$DS=I;function S(m,P){const E=P.slice(0).sort((l,f)=>{const w=l.offset-f.offset;return w===0?l.length-f.length:w});let g=m.length;for(let l=E.length-1;l>=0;l--){const f=E[l];if(f.offset+f.length<=g)m=I(m,f);else throw new Error("Overlapping edit");g=f.offset}return m}e.$ES=S}),define(oe[86],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class O{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=O}),define(oe[2],ae([0,1,18,126,84,59]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const D=!1;let I=null;class S{constructor(){this.b=new Map}static{this.a=0}c(u){let p=this.b.get(u);return p||(p={parent:null,source:null,isSingleton:!1,value:u,idx:S.a++},this.b.set(u,p)),p}trackDisposable(u){const p=this.c(u);p.source||(p.source=new Error().stack)}setParent(u,p){const j=this.c(u);j.parent=p}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,p){const j=p.get(u);if(j)return j;const F=u.parent?this.f(this.c(u.parent),p):u;return p.set(u,F),F}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,u).isSingleton).map(([j])=>j).flat()}computeLeakingDisposables(u=10,p){let j;if(p)j=p;else{const _=new Map,J=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,_).isSingleton);if(J.length===0)return;const Q=new Set(J.map(H=>H.value));if(j=J.filter(H=>!(H.parent&&Q.has(H.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function F(_){function J(H,x){for(;H.length>0&&x.some(G=>typeof G=="string"?G===H[0]:H[0].match(G));)H.shift()}const Q=_.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return J(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const T=new N.$L;for(const _ of j){const J=F(_);for(let Q=0;Q<=J.length;Q++)T.add(J.slice(0,Q).join(`
`),_)}j.sort((0,O.$5b)(_=>_.idx,O.$7b));let z="",B=0;for(const _ of j.slice(0,u)){B++;const J=F(_),Q=[];for(let H=0;H<J.length;H++){let x=J[H];x=`(shared with ${T.get(J.slice(0,H+1).join(`
`)).size}/${j.length} leaks) at ${x}`;const V=T.get(J.slice(0,H).join(`
`)),W=(0,N.$I)([...V].map(ee=>F(ee)[H]),ee=>ee);delete W[J[H]];for(const[ee,ne]of Object.entries(W))Q.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${ee}`);Q.unshift(x)}z+=`


==================== Leaking disposable ${B}/${j.length}: ${_.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return j.length>u&&(z+=`


... and ${j.length-u} more leaking disposables

`),{leaks:j,details:z}}}e.$_b=S;function m(b){I=b}if(e.$ac=m,D){const b="__is_disposable_tracked__";m(new class{trackDisposable(u){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[b]||console.log(p)},3e3)}setParent(u,p){if(u&&u!==C.None)try{u[b]=!0}catch{}}markAsDisposed(u){if(u&&u!==C.None)try{u[b]=!0}catch{}}markAsSingleton(u){}})}function P(b){return I?.trackDisposable(b),b}e.$bc=P;function E(b){I?.markAsDisposed(b)}e.$cc=E;function g(b,u){I?.setParent(b,u)}function l(b,u){if(I)for(const p of b)I.setParent(p,u)}function f(b){return I?.markAsSingleton(b),b}e.$dc=f;function w(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$ec=w;function d(b){if(L.Iterable.is(b)){const u=[];for(const p of b)if(p)try{p.dispose()}catch(j){u.push(j)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$fc=d;function h(b){for(const u of b)w(u)&&u.dispose();return[]}e.$gc=h;function o(...b){const u=$(()=>d(b));return l(b,u),u}e.$hc=o;function $(b){const u=P({dispose:(0,A.$bb)(()=>{E(u),b()})});return u}e.$ic=$;class y{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return g(u,this),this.g?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}}e.$jc=y;class C{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new y,P(this),g(this.q,this)}dispose(){E(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$kc=C;class i{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&g(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&g(u,null),u}}e.$lc=i;class c{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=c;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(u){let p=u;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,E(this))},this}}e.$nc=n;class s{constructor(){this.a=new Map}acquire(u,...p){let j=this.a.get(u);j||(j={counter:0,object:this.b(u,...p)},this.a.set(u,j));const{object:F}=j,T=(0,A.$bb)(()=>{--j.counter===0&&(this.c(u,j.object),this.a.delete(u))});return j.counter++,{object:F,dispose:T}}}e.$oc=s;class t{constructor(u){this.a=u}async acquire(u,...p){const j=this.a.acquire(u,...p);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(F){throw j.dispose(),F}}}e.$pc=t;class r{constructor(u){this.object=u}dispose(){}}e.$qc=r;function a(b){const u=new y;try{b(u)}finally{u.dispose()}}e.$rc=a;class v{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,p,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(u)?.dispose(),this.a.set(u,p)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=v}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class O{static{this.Undefined=new O(void 0)}constructor(L){this.element=L,this.next=O.Undefined,this.prev=O.Undefined}}class N{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let L=this.a;for(;L!==O.Undefined;){const D=L.next;L.prev=O.Undefined,L.next=O.Undefined,L=D}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,D){const I=new O(L);if(this.a===O.Undefined)this.a=I,this.b=I;else if(D){const m=this.b;this.b=I,I.prev=m,m.next=I}else{const m=this.a;this.a=I,I.next=m,m.prev=I}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(I))}}shift(){if(this.a!==O.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==O.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==O.Undefined&&L.next!==O.Undefined){const D=L.prev;D.next=L.next,L.next.prev=D}else L.prev===O.Undefined&&L.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):L.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):L.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==O.Undefined;)yield L.element,L=L.next}}e.$tc=N}),define(oe[35],ae([0,1]),function(te,e){"use strict";var O,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function L(h,o,$){let y=h.get(o);return y===void 0&&(y=$,h.set(o,y)),y}e.$wi=L;function D(h){const o=[];return h.forEach(($,y)=>{o.push(`${y} => ${$}`)}),`Map(${h.size}) {${o.join(", ")}}`}e.$xi=D;function I(h){const o=[];return h.forEach($=>{o.push($)}),`Set(${h.size}) {${o.join(", ")}}`}e.$yi=I;class S{constructor(o,$){this.uri=o,this.value=$}}function m(h){return Array.isArray(h)}class P{static{this.a=o=>o.toString()}constructor(o,$){if(this[O]="ResourceMap",o instanceof P)this.b=new Map(o.b),this.c=$??P.a;else if(m(o)){this.b=new Map,this.c=$??P.a;for(const[y,C]of o)this.set(y,C)}else this.b=new Map,this.c=o??P.a}set(o,$){return this.b.set(this.c(o),new S(o,$)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,$){typeof $<"u"&&(o=o.bind($));for(const[y,C]of this.b)o(C.value,C.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$zi=P;class E{constructor(o,$){this[N]="ResourceSet",!o||typeof o=="function"?this.a=new P(o):(this.a=new P($),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,$){this.a.forEach((y,C)=>o.call($,C,C,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=E;var g;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class l{constructor(){this[A]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,$=0){const y=this.a.get(o);if(y)return $!==0&&this.j(y,$),y.value}set(o,$,y=0){let C=this.a.get(o);if(C)C.value=$,y!==0&&this.j(C,y);else{switch(C={key:o,value:$,next:void 0,previous:void 0},y){case 0:this.h(C);break;case 1:this.g(C);break;case 2:this.h(C);break;default:this.h(C);break}this.a.set(o,C),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const $=this.a.get(o);if($)return this.a.delete(o),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,$){const y=this.e;let C=this.b;for(;C;){if($?o.bind($)(C.value,C.key,this):o(C.value,C.key,this),this.e!==y)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const o=this,$=this.e;let y=this.b;const C={[Symbol.iterator](){return C},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(y){const i={value:y.key,done:!1};return y=y.next,i}else return{value:void 0,done:!0}}};return C}values(){const o=this,$=this.e;let y=this.b;const C={[Symbol.iterator](){return C},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(y){const i={value:y.value,done:!1};return y=y.next,i}else return{value:void 0,done:!0}}};return C}entries(){const o=this,$=this.e;let y=this.b;const C={[Symbol.iterator](){return C},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(y){const i={value:[y.key,y.value],done:!1};return y=y.next,i}else return{value:void 0,done:!0}}};return C}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let $=this.b,y=this.size;for(;$&&y>o;)this.a.delete($.key),$=$.next,y--;this.b=$,this.d=y,$&&($.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const $=o.next,y=o.previous;if(!$||!y)throw new Error("Invalid list");$.previous=y,y.next=$}o.next=void 0,o.previous=void 0,this.e++}j(o,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(o===this.b)return;const y=o.next,C=o.previous;o===this.c?(C.next=void 0,this.c=C):(y.previous=C,C.next=y),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if($===2){if(o===this.c)return;const y=o.next,C=o.previous;o===this.b?(y.previous=void 0,this.b=y):(y.previous=C,C.next=y),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach(($,y)=>{o.push([y,$])}),o}fromJSON(o){this.clear();for(const[$,y]of o)this.set($,y)}}e.$Bi=l;class f extends l{constructor(o,$=1){super(),this.k=o,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,$=2){return super.get(o,$)}peek(o){return super.get(o,0)}set(o,$){return super.set(o,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=f;class w{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let $=this.a.get(o)||0;return $===0?!1:($--,$===0?this.a.delete(o):this.a.set(o,$),!0)}has(o){return this.a.has(o)}}e.$Di=w;class d{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[$,y]of o)this.set($,y)}clear(){this.a.clear(),this.b.clear()}set(o,$){this.a.set(o,$),this.b.set($,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const $=this.a.get(o);return $===void 0?!1:(this.a.delete(o),this.b.delete($),!0)}forEach(o,$){this.a.forEach((y,C)=>{o.call($,y,C,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=d}),define(oe[88],ae([0,1,35]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const N=new O.$Ci(1e4);function A(m){return S(m,"NFC",N)}e.$hl=A;const L=new O.$Ci(1e4);function D(m){return S(m,"NFD",L)}e.$il=D;const I=/[^\u0000-\u0080]/;function S(m,P,E){if(!m)return m;const g=E.get(m);if(g)return g;let l;return I.test(m)?l=m.normalize(P):l=m,E.set(m,l),l}e.$jl=function(){const m=/[\u0300-\u036f]/g;return function(P){return D(P).replace(m,"")}}()}),function(){function te(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function D(S){L.push(S,Date.now())}function I(){const S=[];for(let m=0;m<L.length;m+=2)S.push({name:L[m],startTime:L[m+1]});return S}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(A+D.startTime)});return L}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function O(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=O(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var N in O)(typeof exports=="object"?exports:te)[N]=O[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function O(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return te[N].call(A.exports,A,A.exports,O),A.l=!0,A.exports}return O.m=te,O.c=e,O.d=function(N,A,L){O.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:L})},O.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},O.t=function(N,A){if(1&A&&(N=O(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var D in N)O.d(L,D,function(I){return N[I]}.bind(null,D));return L},O.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return O.d(A,"a",A),A},O.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},O.p="",O(O.s=0)}([function(te,e,O){(function(N){var A;e=te.exports=X,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],S=e.src=[],m=0,P=m++;S[P]="0|[1-9]\\d*";var E=m++;S[E]="[0-9]+";var g=m++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=m++;S[l]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var f=m++;S[f]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var w=m++;S[w]="(?:"+S[P]+"|"+S[g]+")";var d=m++;S[d]="(?:"+S[E]+"|"+S[g]+")";var h=m++;S[h]="(?:-("+S[w]+"(?:\\."+S[w]+")*))";var o=m++;S[o]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var $=m++;S[$]="[0-9A-Za-z-]+";var y=m++;S[y]="(?:\\+("+S[$]+"(?:\\."+S[$]+")*))";var C=m++,i="v?"+S[l]+S[h]+"?"+S[y]+"?";S[C]="^"+i+"$";var c="[v=\\s]*"+S[f]+S[o]+"?"+S[y]+"?",n=m++;S[n]="^"+c+"$";var s=m++;S[s]="((?:<|>)?=?)";var t=m++;S[t]=S[E]+"|x|X|\\*";var r=m++;S[r]=S[P]+"|x|X|\\*";var a=m++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[h]+")?"+S[y]+"?)?)?";var v=m++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[o]+")?"+S[y]+"?)?)?";var b=m++;S[b]="^"+S[s]+"\\s*"+S[a]+"$";var u=m++;S[u]="^"+S[s]+"\\s*"+S[v]+"$";var p=m++;S[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=m++;S[j]="(?:~>?)";var F=m++;S[F]="(\\s*)"+S[j]+"\\s+",I[F]=new RegExp(S[F],"g");var T=m++;S[T]="^"+S[j]+S[a]+"$";var z=m++;S[z]="^"+S[j]+S[v]+"$";var B=m++;S[B]="(?:\\^)";var _=m++;S[_]="(\\s*)"+S[B]+"\\s+",I[_]=new RegExp(S[_],"g");var J=m++;S[J]="^"+S[B]+S[a]+"$";var Q=m++;S[Q]="^"+S[B]+S[v]+"$";var H=m++;S[H]="^"+S[s]+"\\s*("+c+")$|^$";var x=m++;S[x]="^"+S[s]+"\\s*("+i+")$|^$";var G=m++;S[G]="(\\s*)"+S[s]+"\\s*("+c+"|"+S[a]+")",I[G]=new RegExp(S[G],"g");var V=m++;S[V]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var W=m++;S[W]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ee=m++;S[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)A(ne,S[ne]),I[ne]||(I[ne]=new RegExp(S[ne]));function re(ce,ge){if(ce instanceof X)return ce;if(typeof ce!="string"||ce.length>L||!(ge?I[n]:I[C]).test(ce))return null;try{return new X(ce,ge)}catch{return null}}function X(ce,ge){if(ce instanceof X){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof X))return new X(ce,ge);A("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?I[n]:I[C]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<D)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=re,e.valid=function(ce,ge){var be=re(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=re(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(ce){return A("SemVer.compare",this.version,this.loose,ce),ce instanceof X||(ce=new X(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},X.prototype.compareMain=function(ce){return ce instanceof X||(ce=new X(ce,this.loose)),k(this.major,ce.major)||k(this.minor,ce.minor)||k(this.patch,ce.patch)},X.prototype.comparePre=function(ce){if(ce instanceof X||(ce=new X(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=ce.prerelease[ge];if(A("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return k(be,Se)}while(++ge)},X.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new X(ce,be).inc(ge,Se).version}catch{return null}},e.diff=function(ce,ge){if(K(ce,ge))return null;var be=re(ce),Se=re(ge);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=k;var q=/^[0-9]+$/;function k(ce,ge){var be=q.test(ce),Se=q.test(ge);return be&&Se&&(ce=+ce,ge=+ge),be&&!Se?-1:Se&&!be?1:ce<ge?-1:ce>ge?1:0}function R(ce,ge,be){return new X(ce,be).compare(new X(ge,be))}function U(ce,ge,be){return R(ce,ge,be)>0}function M(ce,ge,be){return R(ce,ge,be)<0}function K(ce,ge,be){return R(ce,ge,be)===0}function Y(ce,ge,be){return R(ce,ge,be)!==0}function se(ce,ge,be){return R(ce,ge,be)>=0}function le(ce,ge,be){return R(ce,ge,be)<=0}function ue(ce,ge,be,Se){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=K(ce,be,Se);break;case"!=":Pe=Y(ce,be,Se);break;case">":Pe=U(ce,be,Se);break;case">=":Pe=se(ce,be,Se);break;case"<":Pe=M(ce,be,Se);break;case"<=":Pe=le(ce,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(ce,ge){if(ce instanceof he){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof he))return new he(ce,ge);A("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ce,ge){return k(ge,ce)},e.major=function(ce,ge){return new X(ce,ge).major},e.minor=function(ce,ge){return new X(ce,ge).minor},e.patch=function(ce,ge){return new X(ce,ge).patch},e.compare=R,e.compareLoose=function(ce,ge){return R(ce,ge,!0)},e.rcompare=function(ce,ge,be){return R(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=U,e.lt=M,e.eq=K,e.neq=Y,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=he;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof he)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function ve(ce,ge,be,Se,Pe,ze,De,Ue,Me,ie,fe,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+ge)+" "+(Ue=we(Me)?"":we(ie)?"<"+(+Me+1)+".0.0":we(fe)?"<"+Me+"."+(+ie+1)+".0":me?"<="+Me+"."+ie+"."+fe+"-"+me:"<="+Ue)).trim()}function Ie(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(A(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var Se=ce[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Le(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Te(ce,ge,be,Se){var Pe,ze,De,Ue,Me;switch(ce=new X(ce,Se),ge=new de(ge,Se),be){case">":Pe=U,ze=le,De=M,Ue=">",Me=">=";break;case"<":Pe=M,ze=se,De=U,Ue="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(ce,ge,Se))return!1;for(var ie=0;ie<ge.set.length;++ie){var fe=ge.set[ie],me=null,pe=null;if(fe.forEach(function(ke){ke.semver===$e&&(ke=new he(">=0.0.0")),me=me||ke,pe=pe||ke,Pe(ke.semver,me.semver,Se)?me=ke:De(ke.semver,pe.semver,Se)&&(pe=ke)}),me.operator===Ue||me.operator===Me||(!pe.operator||pe.operator===Ue)&&ze(ce,pe.semver)||pe.operator===Me&&De(ce,pe.semver))return!1}return!0}he.prototype.parse=function(ce){var ge=this.loose?I[H]:I[x],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new X(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(ce){return A("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new X(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ce,ge){if(!(ce instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Le(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Le(ce.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),ze=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ue=ue(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=ue(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Se||Pe||ze&&De||Ue||Me},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),A("range",ce,ge);var be=ge?I[W]:I[V];ce=ce.replace(be,ve),A("hyphen replace",ce),ce=ce.replace(I[G],"$1$2$3"),A("comparator trim",ce,I[G]),ce=(ce=(ce=ce.replace(I[F],"$1~")).replace(I[_],"$1^")).split(/\s+/).join(" ");var Se=ge?I[H]:I[x],Pe=ce.split(" ").map(function(ze){return function(De,Ue){return A("comp",De),De=function(Me,ie){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){A("caret",me,pe);var ke=pe?I[Q]:I[J];return me.replace(ke,function(Re,Ce,Oe,je,Ae){var Ne;return A("caret",me,Re,Ce,Oe,je,Ae),we(Ce)?Ne="":we(Oe)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(je)?Ne=Ce==="0"?">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+".0 <"+(+Ce+1)+".0.0":Ae?(A("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=Ce==="0"?Oe==="0"?">="+Ce+"."+Oe+"."+je+Ae+" <"+Ce+"."+Oe+"."+(+je+1):">="+Ce+"."+Oe+"."+je+Ae+" <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+"."+je+Ae+" <"+(+Ce+1)+".0.0"):(A("no pr"),Ne=Ce==="0"?Oe==="0"?">="+Ce+"."+Oe+"."+je+" <"+Ce+"."+Oe+"."+(+je+1):">="+Ce+"."+Oe+"."+je+" <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+"."+je+" <"+(+Ce+1)+".0.0"),A("caret return",Ne),Ne})}(fe,ie)}).join(" ")}(De,Ue),A("caret",De),De=function(Me,ie){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){var ke=pe?I[z]:I[T];return me.replace(ke,function(Re,Ce,Oe,je,Ae){var Ne;return A("tilde",me,Re,Ce,Oe,je,Ae),we(Ce)?Ne="":we(Oe)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(je)?Ne=">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0":Ae?(A("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=">="+Ce+"."+Oe+"."+je+Ae+" <"+Ce+"."+(+Oe+1)+".0"):Ne=">="+Ce+"."+Oe+"."+je+" <"+Ce+"."+(+Oe+1)+".0",A("tilde return",Ne),Ne})}(fe,ie)}).join(" ")}(De,Ue),A("tildes",De),De=function(Me,ie){return A("replaceXRanges",Me,ie),Me.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var ke=pe?I[u]:I[b];return me.replace(ke,function(Re,Ce,Oe,je,Ae,Ne){A("xRange",me,Re,Ce,Oe,je,Ae,Ne);var qe=we(Oe),Be=qe||we(je),Ve=Be||we(Ae);return Ce==="="&&Ve&&(Ce=""),qe?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(Be&&(je=0),Ve&&(Ae=0),Ce===">"?(Ce=">=",Be?(Oe=+Oe+1,je=0,Ae=0):Ve&&(je=+je+1,Ae=0)):Ce==="<="&&(Ce="<",Be?Oe=+Oe+1:je=+je+1),Re=Ce+Oe+"."+je+"."+Ae):Be?Re=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Ve&&(Re=">="+Oe+"."+je+".0 <"+Oe+"."+(+je+1)+".0"),A("xRange return",Re),Re})}(fe,ie)}).join(" ")}(De,Ue),A("xrange",De),De=function(Me,ie){return A("replaceStars",Me,ie),Me.trim().replace(I[ee],"")}(De,Ue),A("stars",De),De}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(Se)})),Pe=Pe.map(function(ze){return new he(ze,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return ce.set.some(function(Pe){return Pe.every(function(ze){return Se.intersects(ze,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new X(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ce))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(De){ze.test(De)&&(Se&&Pe.compare(De)!==-1||(Pe=new X(Se=De,be)))}),Se},e.minSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(De){ze.test(De)&&(Se&&Pe.compare(De)!==1||(Pe=new X(Se=De,be)))}),Se},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Te(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Te(ce,ge,">",be)},e.outside=Te,e.prerelease=function(ce,ge){var be=re(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof X)return ce;if(typeof ce!="string")return null;var ge=ce.match(I[p]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(te,e){var O,N,A=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(d){if(O===setTimeout)return setTimeout(d,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(d,0);try{return O(d,0)}catch{try{return O.call(null,d,0)}catch{return O.call(this,d,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch{O=L}try{N=typeof clearTimeout=="function"?clearTimeout:D}catch{N=D}})();var S,m=[],P=!1,E=-1;function g(){P&&S&&(P=!1,S.length?m=S.concat(m):E=-1,m.length&&l())}function l(){if(!P){var d=I(g);P=!0;for(var h=m.length;h;){for(S=m,m=[];++E<h;)S&&S[E].run();E=-1,h=m.length}S=null,P=!1,function(o){if(N===clearTimeout)return clearTimeout(o);if((N===D||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(o);try{N(o)}catch{try{return N.call(null,o)}catch{return N.call(this,o)}}}(d)}}function f(d,h){this.fun=d,this.array=h}function w(){}A.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var o=1;o<arguments.length;o++)h[o-1]=arguments[o];m.push(new f(d,h)),m.length!==1||P||I(l)},f.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=w,A.addListener=w,A.once=w,A.off=w,A.removeListener=w,A.removeAllListeners=w,A.emit=w,A.prependListener=w,A.prependOnceListener=w,A.listeners=function(d){return[]},A.binding=function(d){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(d){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class N{constructor(I,S,m){this.level=I,this.key=S,this.value=m,this.forward=[]}}const A=void 0;class L{constructor(I,S=2**16){this.comparator=I,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new N(this.c,A,A)}get size(){return this.f}clear(){this.e=new N(this.c,A,A)}has(I){return!!L.g(this,I,this.comparator)}get(I){return L.g(this,I,this.comparator)?.value}set(I,S){return L.h(this,I,S,this.comparator)&&(this.f+=1),this}delete(I){const S=L.k(this,I,this.comparator);return S&&(this.f-=1),S}forEach(I,S){let m=this.e.forward[0];for(;m;)I.call(S,m.value,m.key,this),m=m.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",S=this.e.forward[0];for(;S;)I+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return I}static g(I,S,m){let P=I.e;for(let E=I.d-1;E>=0;E--)for(;P.forward[E]&&m(P.forward[E].key,S)<0;)P=P.forward[E];if(P=P.forward[0],P&&m(P.key,S)===0)return P}static h(I,S,m,P){const E=[];let g=I.e;for(let l=I.d-1;l>=0;l--){for(;g.forward[l]&&P(g.forward[l].key,S)<0;)g=g.forward[l];E[l]=g}if(g=g.forward[0],g&&P(g.key,S)===0)return g.value=m,!1;{const l=L.j(I);if(l>I.d){for(let f=I.d;f<l;f++)E[f]=I.e;I.d=l}g=new N(l,S,m);for(let f=0;f<l;f++)g.forward[f]=E[f].forward[f],E[f].forward[f]=g;return!0}}static j(I,S=.5){let m=1;for(;Math.random()<S&&m<I.c;)m+=1;return m}static k(I,S,m){const P=[];let E=I.e;for(let g=I.d-1;g>=0;g--){for(;E.forward[g]&&m(E.forward[g].key,S)<0;)E=E.forward[g];P[g]=E}if(E=E.forward[0],!E||m(E.key,S)!==0)return!1;for(let g=0;g<I.d&&P[g].forward[g]===E;g++)P[g].forward[g]=E.forward[g];for(;I.d>0&&I.e.forward[I.d-1]===A;)I.d-=1;return!0}}e.$or=L}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(L){return new N(L)}constructor(L){this.c=O&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=N}),define(oe[3],ae([0,1,8,84,2,87,60]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const I=!1,S=!1;var m;(function(b){b.None=()=>A.$kc.None;function u(ue){if(S){const{onDidAddListener:he}=ue,$e=f.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function p(ue,he){return x(ue,()=>{},0,void 0,!0,void 0,he)}b.defer=p;function j(ue){return(he,$e=null,de)=>{let we=!1,ve;return ve=ue(Ie=>{if(!we)return ve?ve.dispose():we=!0,he.call($e,Ie)},null,de),we&&ve.dispose(),ve}}b.once=j;function F(ue,he,$e){return Q((de,we=null,ve)=>ue(Ie=>de.call(we,he(Ie)),null,ve),$e)}b.map=F;function T(ue,he,$e){return Q((de,we=null,ve)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,ve),$e)}b.forEach=T;function z(ue,he,$e){return Q((de,we=null,ve)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,ve),$e)}b.filter=z;function B(ue){return ue}b.signal=B;function _(...ue){return(he,$e=null,de)=>{const we=(0,A.$hc)(...ue.map(ve=>ve(Ie=>he.call($e,Ie))));return H(we,de)}}b.any=_;function J(ue,he,$e,de){let we=$e;return F(ue,ve=>(we=he(we,ve),we),de)}b.reduce=J;function Q(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||u(de);const we=new $(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function x(ue,he,$e=100,de=!1,we=!1,ve,Ie){let Le,Te,ce,ge=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Le=ue(ze=>{ge++,Te=he(Te,ze),de&&!ce&&(Pe.fire(Te),Te=void 0),be=()=>{const De=Te;Te=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(De),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Ie||u(Se);const Pe=new $(Se);return Ie?.add(Pe),Pe.event}b.debounce=x;function G(ue,he=0,$e){return b.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}b.accumulate=G;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return z(ue,ve=>{const Ie=de||!he(ve,we);return de=!1,we=ve,Ie},$e)}b.latch=V;function W(ue,he,$e){return[b.filter(ue,he,$e),b.filter(ue,de=>!he(de),$e)]}b.split=W;function ee(ue,he=!1,$e=[],de){let we=$e.slice(),ve=ue(Te=>{we?we.push(Te):Le.fire(Te)});de&&de.add(ve);const Ie=()=>{we?.forEach(Te=>Le.fire(Te)),we=null},Le=new $({onWillAddFirstListener(){ve||(ve=ue(Te=>Le.fire(Te)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Le),Le.event}b.buffer=ee;function ne(ue,he){return(de,we,ve)=>{const Ie=he(new X);return ue(function(Le){const Te=Ie.evaluate(Le);Te!==re&&de.call(we,Te)},void 0,ve)}}b.chain=ne;const re=Symbol("HaltChainable");class X{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:re),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ve=$e||!he(we,de);return $e=!1,de=we,ve?we:re}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===re)break;return he}}function q(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Ie=new $({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}b.fromNodeEventEmitter=q;function k(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Ie=new $({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}b.fromDOMEventEmitter=k;function R(ue){return new Promise(he=>j(ue)(he))}b.toPromise=R;function U(ue){const he=new $;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}b.fromPromise=U;function M(ue,he){return he(void 0),ue($e=>he($e))}b.runAndSubscribe=M;function K(ue,he){let $e=null;function de(ve){$e?.dispose(),$e=new A.$jc,he(ve,$e)}de(void 0);const we=ue(ve=>de(ve));return(0,A.$ic)(()=>{we.dispose(),$e?.dispose()})}b.runAndSubscribeWithStore=K;class Y{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||u(de),this.emitter=new $(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function se(ue,he){return new Y(ue,he).emitter.event}b.fromObservable=se;function le(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}b.fromObservableLight=le})(m||(e.Event=m={}));class P{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${P.f++}`,P.all.add(this)}start(u){this.g=new D.$bd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$dd=P;let E=-1;function g(b){const u=E;return E=b,{dispose(){E=u}}}e.$ed=g;class l{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const j=this.threshold;if(j<=0||p<j)return;this.f||(this.f=new Map);const F=this.f.get(u.value)||0;if(this.f.set(u.value,F+1),this.g-=1,this.g<=0){this.g=j*.5;let T,z=0;for(const[B,_]of this.f)(!T||z<_)&&(T=B,z=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${z}):`),console.warn(T)}return()=>{const T=this.f.get(u.value)||0;this.f.set(u.value,T-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class d{constructor(u){this.value=u,this.id=w++}}const h=2,o=(b,u)=>{if(b instanceof d)u(b);else for(let p=0;p<b.length;p++){const j=b[p];j&&u(j)}};class ${constructor(u){this.x=0,this.f=u,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(I){const u=this.t;queueMicrotask(()=>{o(u,p=>p.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,j)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$kc.None;if(this.m)return A.$kc.None;p&&(u=u.bind(p));const F=new d(u);let T,z;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(F.stack=f.create(),T=this.g.check(F.stack,this.x+1)),I&&(F.stack=z??f.create()),this.t?this.t instanceof d?(this.u??=new C,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.x++;const B=(0,A.$ic)(()=>{T?.(),this.y(F)});return j instanceof A.$jc?j.add(B):Array.isArray(j)&&j.push(B),B},this.q}y(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const p=this.t,j=p.indexOf(u);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,p[j]=void 0;const F=this.u.current===this;if(this.x*h<=p.length){let T=0;for(let z=0;z<p.length;z++)p[z]?p[T++]=p[z]:F&&(this.u.end--,T<this.u.i&&this.u.i--);p.length=T}}z(u,p){if(!u)return;const j=this.f?.onListenerError||O.$Y;if(!j){u.value(p);return}try{u.value(p)}catch(F){j(F)}}A(u){const p=u.current.t;for(;u.i<u.end;)this.z(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof d)this.z(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.A(p)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=$;const y=()=>new C;e.$gd=y;class C{constructor(){this.i=-1,this.end=0}enqueue(u,p,j){this.i=0,this.end=j,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends ${async fireAsync(u,p,j){if(this.t)for(this.h||(this.h=new L.$tc),o(this.t,F=>this.h.push([F.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[F,T]=this.h.shift(),z=[],B={...T,token:p,waitUntil:_=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");j&&(_=j(_,F)),z.push(_)}};try{F(B)}catch(_){(0,O.$Y)(_);continue}Object.freeze(z),await Promise.allSettled(z).then(_=>{for(const J of _)J.status==="rejected"&&(0,O.$Y)(J.reason)})}}}e.$hd=i;class c extends ${get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new L.$tc,this.w=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.w(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.x&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$id=c;class n extends c{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$jd=n;class s extends ${constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$kd=s;class t{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const j=()=>{this.g&&this.o(p);const F=this.h.indexOf(p);this.h.splice(F,1)};return(0,A.$ic)((0,N.$bb)(j))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$ld=t;class r{constructor(u,p,j,F){this.f=new A.$jc;const T=this.f.add(new t),z=this.f.add(new A.$sc);function B(_){z.set(_,T.add(F(_)))}for(const _ of u)B(_);this.f.add(p(_=>{B(_)})),this.f.add(j(_=>{z.deleteAndDispose(_)})),this.event=T.event}dispose(){this.f.dispose()}}e.$md=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,j,F)=>u(T=>{const z=this.f[this.f.length-1];z?z.push(()=>p.call(j,T)):p.call(j,T)},void 0,F)}bufferEvents(u){const p=[];this.f.push(p);const j=u();return this.f.pop(),p.forEach(F=>F()),j}}e.$nd=a;class v{constructor(){this.f=!1,this.g=m.None,this.h=A.$kc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=v}),define(oe[26],ae([0,1,3]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const N=Object.freeze(function(I,S){const m=setTimeout(I.bind(S),0);return{dispose(){clearTimeout(m)}}});var A;(function(I){function S(m){return m===I.None||m===I.Cancelled||m instanceof L?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}I.isCancellationToken=S,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new O.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=A.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=A.None}}e.$pd=D}),define(oe[129],ae([0,1,26]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class N{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new O.$pd,S=this.b(I.token);return this.a={promise:S,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$he=N;class A{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const S=JSON.stringify(I);return this.b!==S&&(this.b=S,this.a=this.c(I)),this.a}}e.$ie=A;class L{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const S=this.b(I);return this.a.set(I,S),S}}e.$je=L}),define(oe[42],ae([0,1,8,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function A(y){const C=y;return C?typeof C.read=="function":!1}e.$qd=A;function L(y){const C=y;return C?[C.on,C.pause,C.resume,C.destroy].every(i=>typeof i=="function"):!1}e.$rd=L;function D(y){const C=y;return C?L(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$sd=D;function I(y,C){return new S(y,C)}e.$td=I;class S{constructor(C,i){this.e=C,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(i=>i(C))}h(C){this.c.error.length===0?(0,O.$Y)(C):this.c.error.slice(0).forEach(i=>i(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,i){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(C,i){if(this.a.destroyed)return;let c;switch(C){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const n=c.indexOf(i);n>=0&&c.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(y,C){const i=[];let c;for(;(c=y.read())!==null;)i.push(c);return C(i)}e.$ud=m;function P(y,C,i){const c=[];let n;for(;(n=y.read())!==null&&c.length<i;)c.push(n);return n===null&&c.length>0?C(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return y.read()}}}e.$vd=P;function E(y,C){return new Promise((i,c)=>{const n=[];g(y,{onData:s=>{C&&n.push(s)},onError:s=>{C?c(s):i(void 0)},onEnd:()=>{i(C?C(n):void 0)}})})}e.$wd=E;function g(y,C,i){y.on("error",c=>{i?.isCancellationRequested||C.onError(c)}),y.on("end",()=>{i?.isCancellationRequested||C.onEnd()}),y.on("data",c=>{i?.isCancellationRequested||C.onData(c)})}e.$xd=g;function l(y,C){return new Promise((i,c)=>{const n=new N.$jc,s=[],t=v=>{if(s.push(v),s.length>C)return n.dispose(),y.pause(),i({stream:y,buffer:s,ended:!1})},r=v=>(n.dispose(),c(v)),a=()=>(n.dispose(),i({stream:y,buffer:s,ended:!0}));n.add((0,N.$ic)(()=>y.removeListener("error",r))),y.on("error",r),n.add((0,N.$ic)(()=>y.removeListener("end",a))),y.on("end",a),n.add((0,N.$ic)(()=>y.removeListener("data",t))),y.on("data",t)})}e.$yd=l;function f(y,C){const i=I(C);return i.end(y),i}e.$zd=f;function w(){const y=I(()=>{throw new Error("not supported")});return y.end(),y}e.$Ad=w;function d(y){let C=!1;return{read:()=>C?null:(C=!0,y)}}e.$Bd=d;function h(y,C,i){const c=I(i);return g(y,{onData:n=>c.write(C.data(n)),onError:n=>c.error(C.error?C.error(n):n),onEnd:()=>c.end()}),c}e.$Cd=h;function o(y,C,i){let c=!1;return{read:()=>{const n=C.read();return c?n:(c=!0,n!==null?i([y,n]):y)}}}e.$Dd=o;function $(y,C,i){let c=!1;const n=I(i);return g(C,{onData:s=>c?n.write(s):(c=!0,n.write(i([y,s]))),onError:s=>n.error(s),onEnd:()=>{c||(c=!0,n.write(y)),n.end()}}),n}e.$Ed=$}),define(oe[14],ae([0,1,86,42]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const A=typeof Buffer<"u",L=new O.$T(()=>new Uint8Array(256));let D,I;class S{static alloc(p){return A?new S(Buffer.allocUnsafe(p)):new S(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new S(p)}static fromString(p,j){return!(j?.dontUseNodeBuffer||!1)&&A?new S(Buffer.from(p)):(D||(D=new TextEncoder),new S(D.encode(p)))}static fromByteArray(p){const j=S.alloc(p.length);for(let F=0,T=p.length;F<T;F++)j.buffer[F]=p[F];return j}static concat(p,j){if(typeof j>"u"){j=0;for(let z=0,B=p.length;z<B;z++)j+=p[z].byteLength}const F=S.alloc(j);let T=0;for(let z=0,B=p.length;z<B;z++){const _=p[z];F.set(_,T),T+=_.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=S.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(p,j){return new S(this.buffer.subarray(p,j))}set(p,j){if(p instanceof S)this.buffer.set(p.buffer,j);else if(p instanceof Uint8Array)this.buffer.set(p,j);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),j);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return g(this.buffer,p)}writeUInt32BE(p,j){l(this.buffer,p,j)}readUInt32LE(p){return f(this.buffer,p)}writeUInt32LE(p,j){w(this.buffer,p,j)}readUInt8(p){return d(this.buffer,p)}writeUInt8(p,j){h(this.buffer,p,j)}indexOf(p,j=0){return m(this.buffer,p instanceof S?p.buffer:p,j)}}e.$Fd=S;function m(u,p,j=0){const F=p.byteLength,T=u.byteLength;if(F===0)return 0;if(F===1)return u.indexOf(p[0]);if(F>T-j)return-1;const z=L.value;z.fill(p.length);for(let Q=0;Q<p.length;Q++)z[p[Q]]=p.length-Q-1;let B=j+p.length-1,_=B,J=-1;for(;B<T;)if(u[B]===p[_]){if(_===0){J=B;break}B--,_--}else B+=Math.max(p.length-_,z[u[B]]),_=p.length-1;return J}e.$Gd=m;function P(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$Hd=P;function E(u,p,j){u[j+0]=p&255,p=p>>>8,u[j+1]=p&255}e.$Id=E;function g(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$Jd=g;function l(u,p,j){u[j+3]=p,p=p>>>8,u[j+2]=p,p=p>>>8,u[j+1]=p,p=p>>>8,u[j]=p}e.$Kd=l;function f(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$Ld=f;function w(u,p,j){u[j+0]=p&255,p=p>>>8,u[j+1]=p&255,p=p>>>8,u[j+2]=p&255,p=p>>>8,u[j+3]=p&255}e.$Md=w;function d(u,p){return u[p]}e.$Nd=d;function h(u,p,j){u[j]=p}e.$Od=h;function o(u){return N.$ud(u,p=>S.concat(p))}e.$Pd=o;function $(u){return N.$Bd(u)}e.$Qd=$;function y(u){return N.$wd(u,p=>S.concat(p))}e.$Rd=y;async function C(u){return u.ended?S.concat(u.buffer):S.concat([...u.buffer,await y(u.stream)])}e.$Sd=C;function i(u){return N.$zd(u,p=>S.concat(p))}e.$Td=i;function c(u){return N.$Cd(u,{data:p=>typeof p=="string"?S.fromString(p):S.wrap(p)},p=>S.concat(p))}e.$Ud=c;function n(u){return N.$td(p=>S.concat(p),u)}e.$Vd=n;function s(u,p){return N.$Dd(u,p,j=>S.concat(j))}e.$Wd=s;function t(u,p){return N.$Ed(u,p,j=>S.concat(j))}e.$Xd=t;function r(u){let p=0,j=0,F=0;const T=new Uint8Array(Math.floor(u.length/4*3)),z=_=>{switch(j){case 3:T[F++]=p|_,j=0;break;case 2:T[F++]=p|_>>>2,p=_<<6,j=3;break;case 1:T[F++]=p|_>>>4,p=_<<4,j=2;break;default:p=_<<2,j=1}};for(let _=0;_<u.length;_++){const J=u.charCodeAt(_);if(J>=65&&J<=90)z(J-65);else if(J>=97&&J<=122)z(J-97+26);else if(J>=48&&J<=57)z(J-48+52);else if(J===43||J===45)z(62);else if(J===47||J===95)z(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${u[_]}`)}}const B=F;for(;j>0;)z(0);return S.wrap(T).slice(0,B)}e.$Yd=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:u},p=!0,j=!1){const F=j?v:a;let T="";const z=u.byteLength%3;let B=0;for(;B<u.byteLength-z;B+=3){const _=u[B+0],J=u[B+1],Q=u[B+2];T+=F[_>>>2],T+=F[(_<<4|J>>>4)&63],T+=F[(J<<2|Q>>>6)&63],T+=F[Q&63]}if(z===1){const _=u[B+0];T+=F[_>>>2],T+=F[_<<4&63],p&&(T+="==")}else if(z===2){const _=u[B+0],J=u[B+1];T+=F[_>>>2],T+=F[(_<<4|J>>>4)&63],T+=F[J<<2&63],p&&(T+="=")}return T}e.$Zd=b}),define(oe[27],ae([0,1,129,86]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$me=A;const L=/{(\d+)}/g;function D(ie,...fe){return fe.length===0?ie:ie.replace(L,function(me,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$ne=D;const I=/{([^}]+)}/g;function S(ie,fe){return ie.replace(I,(me,pe)=>fe[pe]??me)}e.$oe=S;function m(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$pe=m;function P(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=P;function E(ie,fe){let me=0;const pe=fe.charCodeAt(0);for(let ke=ie.length-1;ke>=0;ke--)ie.charCodeAt(ke)===pe&&me++;return me}e.$re=E;function g(ie,fe,me="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${me}`}e.$se=g;function l(ie,fe=" "){const me=f(ie,fe);return w(me,fe)}e.$te=l;function f(ie,fe){if(!ie||!fe)return ie;const me=fe.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(fe,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$ue=f;function w(ie,fe){if(!ie||!fe)return ie;const me=fe.length,pe=ie.length;if(me===0||pe===0)return ie;let ke=pe,Re=-1;for(;Re=ie.lastIndexOf(fe,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return ie.substring(0,ke)}e.$ve=w;function d(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=d;function h(ie){return ie.replace(/\*/g,"")}e.$xe=h;function o(ie,fe,me={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=P(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$ye=o;function $(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$ze=$;function y(ie){return ie.split(/\r\n|\r|\n/)}e.$Ae=y;function C(ie){for(let fe=0,me=ie.length;fe<me;fe++){const pe=ie.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Be=C;function i(ie,fe=0,me=ie.length){for(let pe=fe;pe<me;pe++){const ke=ie.charCodeAt(pe);if(ke!==32&&ke!==9)return ie.substring(fe,pe)}return ie.substring(fe,me)}e.$Ce=i;function c(ie,fe=ie.length-1){for(let me=fe;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$De=c;function n(ie,fe,me){const pe=[];let ke=0;for(const Re of ie.matchAll(fe)){if(pe.push(ie.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(ke)),Promise.all(pe).then(Re=>Re.join(""))}e.$Ee=n;function s(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Fe=s;function t(ie,fe,me=0,pe=ie.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){const je=ie.charCodeAt(me),Ae=fe.charCodeAt(ke);if(je<Ae)return-1;if(je>Ae)return 1}const Ce=pe-me,Oe=Re-ke;return Ce<Oe?-1:Ce>Oe?1:0}e.$Ge=t;function r(ie,fe){return a(ie,fe,0,ie.length,0,fe.length)}e.$He=r;function a(ie,fe,me=0,pe=ie.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){let je=ie.charCodeAt(me),Ae=fe.charCodeAt(ke);if(je===Ae)continue;if(je>=128||Ae>=128)return t(ie.toLowerCase(),fe.toLowerCase(),me,pe,ke,Re);b(je)&&(je-=32),b(Ae)&&(Ae-=32);const Ne=je-Ae;if(Ne!==0)return Ne}const Ce=pe-me,Oe=Re-ke;return Ce<Oe?-1:Ce>Oe?1:0}e.$Ie=a;function v(ie){return ie>=48&&ie<=57}e.$Je=v;function b(ie){return ie>=97&&ie<=122}e.$Ke=b;function u(ie){return ie>=65&&ie<=90}e.$Le=u;function p(ie,fe){return ie.length===fe.length&&a(ie,fe)===0}e.$Me=p;function j(ie,fe){const me=fe.length;return fe.length>ie.length?!1:a(ie,fe,0,me)===0}e.$Ne=j;function F(ie,fe){const me=Math.min(ie.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$Oe=F;function T(ie,fe){const me=Math.min(ie.length,fe.length);let pe;const ke=ie.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(ke-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$Pe=T;function z(ie){return 55296<=ie&&ie<=56319}e.$Qe=z;function B(ie){return 56320<=ie&&ie<=57343}e.$Re=B;function _(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$Se=_;function J(ie,fe,me){const pe=ie.charCodeAt(me);if(z(pe)&&me+1<fe){const ke=ie.charCodeAt(me+1);if(B(ke))return _(pe,ke)}return pe}e.$Te=J;function Q(ie,fe){const me=ie.charCodeAt(fe-1);if(B(me)&&fe>1){const pe=ie.charCodeAt(fe-2);if(z(pe))return _(pe,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=Q(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=J(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Ue=H;class x{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(ke,Ce)){me.setOffset(Re);break}ke=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,ke)){me.setOffset(Re);break}ke=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$Ve=x;function G(ie,fe){return new x(ie,fe).nextGraphemeLength()}e.$We=G;function V(ie,fe){return new x(ie,fe).prevGraphemeLength()}e.$Xe=V;function W(ie,fe){fe>0&&B(ie.charCodeAt(fe))&&fe--;const me=fe+G(ie,fe);return[me-V(ie,me),me]}e.$Ye=W;function ee(ie){const fe=new x(ie);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$Ze=ee;let ne;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(ie){return ne||(ne=re()),ne.test(ie)}e.$1e=X;const q=/^[\t\n\r\x20-\x7E]*$/;function k(ie){return q.test(ie)}e.$2e=k,e.$3e=/[\u2028\u2029]/;function R(ie){return e.$3e.test(ie)}e.$4e=R;function U(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$5e=U;function M(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$6e=M;function K(ie,fe){if(ie.length<fe)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$7e=K;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(Y,"").replace(se,"")),ie}e.$8e=le,e.$9e=String.fromCharCode(65279);function ue(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$0e=ue;function he(ie){return ue(ie)?ie.substr(1):ie}e.$$e=he;function $e(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const me=fe.length,pe=ie.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Ce=pe.indexOf(fe[ke],Re+1);if(Ce<0)return!1;Re=Ce,ke++}return!0}e.$_e=$e;function de(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$af=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$bf=we;function ve(ie,fe=1){if(fe===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$cf=ve;function Ie(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$df=Ie;function Le(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$ef=Le;function Te(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let ke=1;for(;ke<=pe;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(ie,fe){if(ie===0)return 0;const me=Pe(ie,fe);if(me!==void 0)return me;const pe=new H(fe,ie);return pe.prevCodePoint(),pe.offset}e.$ff=Se;function Pe(ie,fe){const me=new H(fe,ie);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!M(pe))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function ze(ie){return 127995<=ie&&ie<=127999}var De;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={})),e.$gf="\xA0";class Ue{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$ie(fe=>{function me(Ne){const qe=new Map;for(let Be=0;Be<Ne.length;Be+=2)qe.set(Ne[Be],Ne[Be+1]);return qe}function pe(Ne,qe){const Be=new Map(Ne);for(const[Ve,xe]of qe)Be.set(Ve,xe);return Be}function ke(Ne,qe){if(!Ne)return qe;const Be=new Map;for(const[Ve,xe]of Ne)qe.has(Ve)&&Be.set(Ve,xe);return Be}const Re=this.c.value;let Ce=fe.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ce.length===0&&(Ce=["_default"]);let Oe;for(const Ne of Ce){const qe=me(Re[Ne]);Oe=ke(Oe,qe)}const je=me(Re._common),Ae=pe(je,Oe);return new Ue(Ae)})}static getInstance(fe){return Ue.d.get(Array.from(fe))}static{this.e=new N.$T(()=>Object.keys(Ue.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=Ue;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(fe){return Me.e().has(fe)}static get codePoints(){return Me.e()}}e.$if=Me}),define(oe[51],ae([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function N(h){return A(h,0)}e.$pi=N;function A(h,o){switch(typeof h){case"object":return h===null?L(349,o):Array.isArray(h)?S(h,o):m(h,o);case"string":return I(h,o);case"boolean":return D(h,o);case"number":return L(h,o);case"undefined":return L(937,o);default:return L(617,o)}}e.$qi=A;function L(h,o){return(o<<5)-o+h|0}e.$ri=L;function D(h,o){return L(h?433:863,o)}function I(h,o){o=L(149417,o);for(let $=0,y=h.length;$<y;$++)o=L(h.charCodeAt($),o);return o}e.$si=I;function S(h,o){return o=L(104579,o),h.reduce(($,y)=>A(y,$),o)}function m(h,o){return o=L(181387,o),Object.keys(h).sort().reduce(($,y)=>($=I(y,$),A(h[y],$)),o)}class P{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=A(o,this.g),this.g}}e.$ti=P;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function g(h,o,$=32){const y=$-o,C=~((1<<y)-1);return(h<<o|(C&h)>>>y)>>>0}function l(h,o=0,$=h.byteLength,y=0){for(let C=0;C<$;C++)h[o+C]=y}function f(h,o,$="0"){for(;h.length<o;)h=$+h;return h}function w(h,o=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map($=>$.toString(16).padStart(2,"0")).join(""):f((h>>>0).toString(16),o/4)}e.$ui=w;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const $=o.length;if($===0)return;const y=this.p;let C=this.r,i=this.u,c,n;for(i!==0?(c=i,n=-1,i=0):(c=o.charCodeAt(0),n=0);;){let s=c;if(O.$Qe(c))if(n+1<$){const t=o.charCodeAt(n+1);O.$Re(t)?(n++,s=O.$Se(c,t)):s=65533}else{i=c;break}else O.$Re(c)&&(s=65533);if(C=this.w(y,C,s),n++,n<$)c=o.charCodeAt(n);else break}this.r=C,this.u=i}w(o,$,y){return y<128?o[$++]=y:y<2048?(o[$++]=192|(y&1984)>>>6,o[$++]=128|(y&63)>>>0):y<65536?(o[$++]=224|(y&61440)>>>12,o[$++]=128|(y&4032)>>>6,o[$++]=128|(y&63)>>>0):(o[$++]=240|(y&1835008)>>>18,o[$++]=128|(y&258048)>>>12,o[$++]=128|(y&4032)>>>6,o[$++]=128|(y&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=d.g,$=this.q;for(let a=0;a<64;a+=4)o.setUint32(a,$.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)o.setUint32(a,g(o.getUint32(a-12,!1)^o.getUint32(a-32,!1)^o.getUint32(a-56,!1)^o.getUint32(a-64,!1),1),!1);let y=this.h,C=this.l,i=this.m,c=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=C&i|~C&c,t=1518500249):a<40?(s=C^i^c,t=1859775393):a<60?(s=C&i|C&c|i&c,t=2400959708):(s=C^i^c,t=3395469782),r=g(y,5)+s+n+t+o.getUint32(a*4,!1)&4294967295,n=c,c=i,i=g(C,30),C=y,y=r;this.h=this.h+y&4294967295,this.l=this.l+C&4294967295,this.m=this.m+i&4294967295,this.n=this.n+c&4294967295,this.o=this.o+n&4294967295}}e.$vi=d}),define(oe[89],ae([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const L="error",D="warning",I="warn",S="info",m="ignore";function P(g){return g?O.$Me(L,g)?A.Error:O.$Me(D,g)||O.$Me(I,g)?A.Warning:O.$Me(S,g)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function E(g){switch(g){case A.Error:return L;case A.Warning:return D;case A.Info:return S;default:return m}}A.toString=E}(N||(N={})),e.default=N}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const f=l.charCodeAt(0),w=this.b.charCodeAt(this.c);return f-w}value(){return this.b[this.c]}}e.$Dh=A;class L{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Ge)(l,this.b,0,l.length,this.c,this.d):(0,N.$Ie)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=L;class D{constructor(l=!0,f=!0){this.f=l,this.g=f}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let f=l.length-1;f>=0;f--,this.c--){const w=this.b.charCodeAt(f);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Ge)(l,this.b,0,l.length,this.d,this.e):(0,N.$Ie)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=D;var I;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(I||(I={}));class S{constructor(l,f){this.f=l,this.g=f,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,N.$He)(l,this.c.scheme);if(this.d[this.e]===2)return(0,N.$He)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,N.$Fe)(l,this.c.query);if(this.d[this.e]===5)return(0,N.$Fe)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=S;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(P||(P={}));class E{static forUris(l=()=>!1,f=()=>!1){return new E(new S(l,f))}static forPaths(l=!1){return new E(new D(void 0,!l))}static forStrings(){return new E(new A)}static forConfigKeys(){return new E(new L)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,f){if(f){const w=f.slice(0);(0,O.$Vb)(w);for(const d of w)this.set(d,l)}else{const w=l.slice(0);(0,O.$Vb)(w);for(const d of w)this.set(d[0],d[1])}}set(l,f){const w=this.b.reset(l);let d;this.c||(this.c=new m,this.c.segment=w.value());const h=[];for(d=this.c;;){const $=w.cmp(d.segment);if($>0)d.left||(d.left=new m,d.left.segment=w.value()),h.push([-1,d]),d=d.left;else if($<0)d.right||(d.right=new m,d.right.segment=w.value()),h.push([1,d]),d=d.right;else if(w.hasNext())w.next(),d.mid||(d.mid=new m,d.mid.segment=w.value()),h.push([0,d]),d=d.mid;else break}const o=d.value;d.value=f,d.key=l;for(let $=h.length-1;$>=0;$--){const y=h[$][1];y.updateHeight();const C=y.balanceFactor();if(C<-1||C>1){const i=h[$][0],c=h[$+1][0];if(i===1&&c===1)h[$][1]=y.rotateLeft();else if(i===-1&&c===-1)h[$][1]=y.rotateRight();else if(i===1&&c===-1)y.right=h[$+1][1]=h[$+1][1].rotateRight(),h[$][1]=y.rotateLeft();else if(i===-1&&c===1)y.left=h[$+1][1]=h[$+1][1].rotateLeft(),h[$][1]=y.rotateRight();else throw new Error;if($>0)switch(h[$-1][0]){case-1:h[$-1][1].left=h[$][1];break;case 1:h[$-1][1].right=h[$][1];break;case 0:h[$-1][1].mid=h[$][1];break}else this.c=h[0][1]}}return o}get(l){return this.d(l)?.value}d(l){const f=this.b.reset(l);let w=this.c;for(;w;){const d=f.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(f.hasNext())f.next(),w=w.mid;else break}return w}has(l){const f=this.d(l);return!(f?.value===void 0&&f?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,f){const w=this.b.reset(l),d=[];let h=this.c;for(;h;){const o=w.cmp(h.segment);if(o>0)d.push([-1,h]),h=h.left;else if(o<0)d.push([1,h]),h=h.right;else if(w.hasNext())w.next(),d.push([0,h]),h=h.mid;else break}if(h){if(f?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const o=this.f(h.right);if(o.key){const{key:$,value:y,segment:C}=o;this.e(o.key,!1),h.key=$,h.value=y,h.segment=C}}else{const o=h.left??h.right;if(d.length>0){const[$,y]=d[d.length-1];switch($){case-1:y.left=o;break;case 0:y.mid=o;break;case 1:y.right=o;break}}else this.c=o}for(let o=d.length-1;o>=0;o--){const $=d[o][1];$.updateHeight();const y=$.balanceFactor();if(y>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),d[o][1]=$.rotateLeft()):y<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),d[o][1]=$.rotateRight()),o>0)switch(d[o-1][0]){case-1:d[o-1][1].left=d[o][1];break;case 1:d[o-1][1].right=d[o][1];break;case 0:d[o-1][1].mid=d[o][1];break}else this.c=d[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const f=this.b.reset(l);let w=this.c,d;for(;w;){const h=f.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(f.hasNext())f.next(),d=w.value||d,w=w.mid;else break}return w&&w.value||d}findSuperstr(l){return this.g(l,!1)}g(l,f){const w=this.b.reset(l);let d=this.c;for(;d;){const h=w.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else return d.mid?this.h(d.mid):f?d.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[f,w]of this)l(w,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const f=[];return this.j(l,f),f[Symbol.iterator]()}j(l,f){l&&(l.left&&this.j(l.left,f),l.value&&f.push([l.key,l.value]),l.mid&&this.j(l.mid,f),l.right&&this.j(l.right,f))}_isBalanced(){const l=f=>{if(!f)return!0;const w=f.balanceFactor();return w<-1||w>1?!1:l(f.left)&&l(f.right)};return l(this.c)}}e.$Hh=E}),define(oe[9],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function O(C){return typeof C=="string"}e.$jf=O;function N(C){return Array.isArray(C)&&C.every(i=>O(i))}e.$kf=N;function A(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}e.$lf=A;function L(C){const i=Object.getPrototypeOf(Uint8Array);return typeof C=="object"&&C instanceof i}e.$mf=L;function D(C){return typeof C=="number"&&!isNaN(C)}e.$nf=D;function I(C){return!!C&&typeof C[Symbol.iterator]=="function"}e.$of=I;function S(C){return C===!0||C===!1}e.$pf=S;function m(C){return typeof C>"u"}e.$qf=m;function P(C){return!E(C)}e.$rf=P;function E(C){return m(C)||C===null}e.$sf=E;function g(C,i){if(!C)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$tf=g;function l(C){if(E(C))throw new Error("Assertion Failed: argument is undefined or null");return C}e.$uf=l;function f(...C){const i=[];for(let c=0;c<C.length;c++){const n=C[c];if(E(n))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);i.push(n)}return i}e.$vf=f;const w=Object.prototype.hasOwnProperty;function d(C){if(!A(C))return!1;for(const i in C)if(w.call(C,i))return!1;return!0}e.$wf=d;function h(C){return typeof C=="function"}e.$xf=h;function o(...C){return C.length>0&&C.every(h)}e.$yf=o;function $(C,i){const c=Math.min(C.length,i.length);for(let n=0;n<c;n++)y(C[n],i[n])}e.$zf=$;function y(C,i){if(O(i)){if(typeof C!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(C instanceof i)return}catch{}if(!E(C)&&C.constructor===i||i.length===1&&i.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=y}),define(oe[30],ae([0,1,9]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const o=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([$,y])=>{o[$]=y&&typeof y=="object"?N(y):y}),o}e.$Vm=N;function A(h){if(!h||typeof h!="object")return h;const o=[h];for(;o.length>0;){const $=o.shift();Object.freeze($);for(const y in $)if(L.call($,y)){const C=$[y];typeof C=="object"&&!Object.isFrozen(C)&&!(0,O.$mf)(C)&&o.push(C)}}return h}e.$Wm=A;const L=Object.prototype.hasOwnProperty;function D(h,o){return I(h,o,new Set)}e.$Xm=D;function I(h,o,$){if((0,O.$sf)(h))return h;const y=o(h);if(typeof y<"u")return y;if(Array.isArray(h)){const C=[];for(const i of h)C.push(I(i,o,$));return C}if((0,O.$lf)(h)){if($.has(h))throw new Error("Cannot clone recursive data-structure");$.add(h);const C={};for(const i in h)L.call(h,i)&&(C[i]=I(h[i],o,$));return $.delete(h),C}return h}function S(h,o,$=!0){return(0,O.$lf)(h)?((0,O.$lf)(o)&&Object.keys(o).forEach(y=>{y in h?$&&((0,O.$lf)(h[y])&&(0,O.$lf)(o[y])?S(h[y],o[y],$):h[y]=o[y]):h[y]=o[y]}),h):o}e.$Ym=S;function m(h,o){if(h===o)return!0;if(h==null||o===null||o===void 0||typeof h!=typeof o||typeof h!="object"||Array.isArray(h)!==Array.isArray(o))return!1;let $,y;if(Array.isArray(h)){if(h.length!==o.length)return!1;for($=0;$<h.length;$++)if(!m(h[$],o[$]))return!1}else{const C=[];for(y in h)C.push(y);C.sort();const i=[];for(y in o)i.push(y);if(i.sort(),!m(C,i))return!1;for($=0;$<C.length;$++)if(!m(h[C[$]],o[C[$]]))return!1}return!0}e.$Zm=m;function P(h){const o=new Set;return JSON.stringify(h,($,y)=>{if((0,O.$lf)(y)||Array.isArray(y)){if(o.has(y))return"[Circular]";o.add(y)}return y})}e.$1m=P;function E(h,o){const $=Object.create(null);return!h||!o||Object.keys(o).forEach(C=>{const i=h[C],c=o[C];m(i,c)||($[C]=c)}),$}e.$2m=E;function g(h,o){const $=o.toLowerCase(),y=Object.keys(h).find(C=>C.toLowerCase()===$);return y?h[y]:h[o]}e.$3m=g;function l(h,o){const $=Object.create(null);for(const[y,C]of Object.entries(h))o(y,C)&&($[y]=C);return $}e.$4m=l;function f(h){let o=[];for(;Object.prototype!==h;)o=o.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return o}e.$5m=f;function w(h){const o=[];for(const $ of f(h))typeof h[$]=="function"&&o.push($);return o}e.$6m=w;function d(h,o){const $=C=>function(){const i=Array.prototype.slice.call(arguments,0);return o(C,i)},y={};for(const C of h)y[C]=$(C);return y}e.$7m=d}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return O.test(A)}e.$3f=N,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(I){for(let S=0;S<I.length;S++)I[S]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,m="";return m+=D[L[S++]],m+=D[L[S++]],m+=D[L[S++]],m+=D[L[S++]],m+="-",m+=D[L[S++]],m+=D[L[S++]],m+="-",m+=D[L[S++]],m+=D[L[S++]],m+="-",m+=D[L[S++]],m+=D[L[S++]],m+="-",m+=D[L[S++]],m+=D[L[S++]],m+=D[L[S++]],m+=D[L[S++]],m+=D[L[S++]],m+=D[L[S++]],m}}()}),define(oe[131],ae([0,1,36]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(D){const I=D.replace(/\-/g,":").toLowerCase();return!N.has(I)}function L(){const D=(0,O.networkInterfaces)();for(const I in D){const S=D[I];if(S){for(const{mac:m}of S)if(A(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=L}),define(oe[132],ae([0,1,36,47,32,131]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(m){return this.a||(this.a=N.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,P=0;const E=(0,O.networkInterfaces)();for(const g in E){const l=E[g];if(l)for(const{mac:f,internal:w}of l)w||(P+=1,this.c(f.toUpperCase())&&(m+=1))}this.b=P>0?m/P:0}return this.b}};let D;async function I(m){return D||(D=(async()=>await S(m)||A.$4f())()),D}e.$Im=I;async function S(m){try{const P=await new Promise((g,l)=>{te(["crypto"],g,l)}),E=(0,L.$Gm)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){m(P);return}}}),define(oe[133],ae([0,1,268,14]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OS=void 0;class A extends O.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const I=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(D,I,S){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let m=0;for(;m<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,m):(0,N.$Gd)(this.a,this.b,m);if(P===-1)break;this.push(this.a.slice(m,P+this.c)),m=P+this.c}this.a=m===this.a.length?void 0:this.a.slice(m),S()}_flush(D){this.a&&this.push(this.a),D()}}e.$OS=A}),define(oe[134],ae([0,1,61]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function N(I,S,m,P=1){let E=!1;return new Promise(g=>{const l=setTimeout(()=>{if(!E)return E=!0,g(0)},m);A(I,S,P,f=>{if(!E)return E=!0,clearTimeout(l),g(f)})})}e.$6f=N;function A(I,S,m,P){if(S===0)return P(0);const E=new O.Socket;E.once("connect",()=>(D(E),A(I+m,S-1,m,P))),E.once("data",()=>{}),E.once("error",g=>(D(E),g.code!=="ECONNREFUSED"?A(I+m,S-1,m,P):P(I))),E.connect(I,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,S,m,P="127.0.0.1"){let E=!1,g,l=1;const f=O.createServer({pauseOnConnect:!0});function w(d,h){E||(E=!0,f.removeAllListeners(),f.close(),g&&clearTimeout(g),h(d))}return new Promise(d=>{g=setTimeout(()=>{w(0,d)},m),f.on("listening",()=>{w(I,d)}),f.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&l<S?(I++,l++,f.listen(I,P)):w(0,d)}),f.on("close",()=>{w(0,d)}),f.listen(I,P)})}e.$8f=L;function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(S){console.error(S)}}}),define(oe[135],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5S=void 0;function O(N){return!!N.parentPort}e.$5S=O}),define(oe[136],ae([13,10]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,136]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const N=60,A=N*60,L=A*24,D=L*7,I=L*30,S=L*365;function m(E,g,l,f){typeof E!="number"&&(E=E.getTime());const w=Math.round((new Date().getTime()-E)/1e3);if(w<-30)return(0,O.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!f&&w<30)return(0,O.localize)(1,null);let d;return w<N?(d=w,g?d===1?l?(0,O.localize)(2,null,d):(0,O.localize)(3,null,d):l?(0,O.localize)(4,null,d):(0,O.localize)(5,null,d):d===1?l?(0,O.localize)(6,null,d):(0,O.localize)(7,null,d):l?(0,O.localize)(8,null,d):(0,O.localize)(9,null,d)):w<A?(d=Math.floor(w/N),g?d===1?l?(0,O.localize)(10,null,d):(0,O.localize)(11,null,d):l?(0,O.localize)(12,null,d):(0,O.localize)(13,null,d):d===1?l?(0,O.localize)(14,null,d):(0,O.localize)(15,null,d):l?(0,O.localize)(16,null,d):(0,O.localize)(17,null,d)):w<L?(d=Math.floor(w/A),g?d===1?l?(0,O.localize)(18,null,d):(0,O.localize)(19,null,d):l?(0,O.localize)(20,null,d):(0,O.localize)(21,null,d):d===1?l?(0,O.localize)(22,null,d):(0,O.localize)(23,null,d):l?(0,O.localize)(24,null,d):(0,O.localize)(25,null,d)):w<D?(d=Math.floor(w/L),g?d===1?(0,O.localize)(26,null,d):(0,O.localize)(27,null,d):d===1?(0,O.localize)(28,null,d):(0,O.localize)(29,null,d)):w<I?(d=Math.floor(w/D),g?d===1?l?(0,O.localize)(30,null,d):(0,O.localize)(31,null,d):l?(0,O.localize)(32,null,d):(0,O.localize)(33,null,d):d===1?l?(0,O.localize)(34,null,d):(0,O.localize)(35,null,d):l?(0,O.localize)(36,null,d):(0,O.localize)(37,null,d)):w<S?(d=Math.floor(w/I),g?d===1?l?(0,O.localize)(38,null,d):(0,O.localize)(39,null,d):l?(0,O.localize)(40,null,d):(0,O.localize)(41,null,d):d===1?l?(0,O.localize)(42,null,d):(0,O.localize)(43,null,d):l?(0,O.localize)(44,null,d):(0,O.localize)(45,null,d)):(d=Math.floor(w/S),g?d===1?l?(0,O.localize)(46,null,d):(0,O.localize)(47,null,d):l?(0,O.localize)(48,null,d):(0,O.localize)(49,null,d):d===1?l?(0,O.localize)(50,null,d):(0,O.localize)(51,null,d):l?(0,O.localize)(52,null,d):(0,O.localize)(53,null,d))}e.$6l=m;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=P}),define(oe[137],ae([13,10]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,9,137]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function L(E,g){return g&&(E.stack||E.stacktrace)?A.localize(0,null,I(E),D(E.stack)||D(E.stacktrace)):I(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function S(E=null,g=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const l=O.$Fb(E),f=S(l[0],g);return l.length>1?A.localize(4,null,f,l.length):f}if(N.$jf(E))return E;if(E.detail){const l=E.detail;if(l.error)return L(l.error,g);if(l.exception)return L(l.exception,g)}return E.stack?L(E,g):E.message?E.message:A.localize(5,null)}e.$mi=S;function m(E){const g=E;return g instanceof Error&&Array.isArray(g.actions)}e.$ni=m;function P(E,g){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=g,l}e.$oi=P}),define(oe[138],ae([13,10]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function N(A){switch(A){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$mp=N}),define(oe[140],ae([13,10]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[6],ae([0,1,140]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,A=!1,L=!1,D=!1,I=!1,S=!1,m=!1,P=!1,E=!1,g=!1,l,f=e.$f,w=e.$f,d,h;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?o=e.$g.vscode.process:typeof process<"u"&&(o=process);const $=typeof o?.versions?.electron=="string",y=$&&o?.type==="renderer";if(typeof navigator=="object"&&!y)h=navigator.userAgent,N=h.indexOf("Windows")>=0,A=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,g=h?.indexOf("Mobi")>=0,S=!0,l=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$f,f=l,w=navigator.language;else if(typeof o=="object"){N=o.platform==="win32",A=o.platform==="darwin",L=o.platform==="linux",D=L&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,m=$,E=!!o.env.CI||!!o.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$f,f=e.$f;const v=o.env.VSCODE_NLS_CONFIG;if(v)try{const b=JSON.parse(v),u=b.availableLanguages["*"];l=b.locale,w=b.osLocale,f=u||e.$f,d=b._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var C;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(C||(e.Platform=C={}));function i(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=i;let c=0;A?c=1:N?c=3:L&&(c=2),e.$i=N,e.$j=A,e.$k=L,e.$l=D,e.$m=I,e.$n=m,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=g,e.$s=E,e.$t=c,e.$u=h,e.$v=f;var n;(function(v){function b(){return e.$v}v.value=b;function u(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}v.isDefaultVariant=u;function p(){return e.$v==="en"}v.isDefault=p})(n||(e.Language=n={})),e.$w=l,e.$x=w,e.$y=d,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const v=[];e.$g.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let p=0,j=v.length;p<j;p++){const F=v[p];if(F.id===u.data.vscodeScheduleAsyncWork){v.splice(p,1),F.callback();return}}});let b=0;return u=>{const p=++b;v.push({id:p,callback:u}),e.$g.postMessage({vscodeScheduleAsyncWork:p},"*")}}return v=>setTimeout(v)})();var s;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=A||P?2:N?1:3;let t=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(oe[37],ae([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let N;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.process<"u"){const A=O.$g.vscode.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$3d=N.platform,e.$4d=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const N=65,A=97,L=90,D=122,I=46,S=47,m=92,P=58,E=63;class g extends Error{constructor(c,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,c){if(i===null||typeof i!="object")throw new g(c,"Object",i)}function f(i,c){if(typeof i!="string")throw new g(c,"string",i)}const w=O.$3d==="win32";function d(i){return i===S||i===m}function h(i){return i===S}function o(i){return i>=N&&i<=L||i>=A&&i<=D}function $(i,c,n,s){let t="",r=0,a=-1,v=0,b=0;for(let u=0;u<=i.length;++u){if(u<i.length)b=i.charCodeAt(u);else{if(s(b))break;b=S}if(s(b)){if(!(a===u-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==I||t.charCodeAt(t.length-2)!==I){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),a=u,v=0;continue}else if(t.length!==0){t="",r=0,a=u,v=0;continue}}c&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,u)}`:t=i.slice(a+1,u),r=u-a-1;a=u,v=0}else b===I&&v!==-1?++v:v=-1}return t}function y(i,c){l(c,"pathObject");const n=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return n?n===c.root?`${n}${s}`:`${n}${i}${s}`:s}e.$5d={resolve(...i){let c="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],f(r,"path"),r.length===0)continue}else c.length===0?r=O.cwd():(r=O.env[`=${c}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${c}\\`));const a=r.length;let v=0,b="",u=!1;const p=r.charCodeAt(0);if(a===1)d(p)&&(v=1,u=!0);else if(d(p))if(u=!0,d(r.charCodeAt(1))){let j=2,F=j;for(;j<a&&!d(r.charCodeAt(j));)j++;if(j<a&&j!==F){const T=r.slice(F,j);for(F=j;j<a&&d(r.charCodeAt(j));)j++;if(j<a&&j!==F){for(F=j;j<a&&!d(r.charCodeAt(j));)j++;(j===a||j!==F)&&(b=`\\\\${T}\\${r.slice(F,j)}`,v=j)}}}else v=1;else o(p)&&r.charCodeAt(1)===P&&(b=r.slice(0,2),v=2,a>2&&d(r.charCodeAt(2))&&(u=!0,v=3));if(b.length>0)if(c.length>0){if(b.toLowerCase()!==c.toLowerCase())continue}else c=b;if(s){if(c.length>0)break}else if(n=`${r.slice(v)}\\${n}`,s=u,u&&c.length>0)break}return n=$(n,!s,"\\",d),s?`${c}\\${n}`:`${c}${n}`||"."},normalize(i){f(i,"path");const c=i.length;if(c===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(c===1)return h(r)?"\\":i;if(d(r))if(t=!0,d(i.charCodeAt(1))){let v=2,b=v;for(;v<c&&!d(i.charCodeAt(v));)v++;if(v<c&&v!==b){const u=i.slice(b,v);for(b=v;v<c&&d(i.charCodeAt(v));)v++;if(v<c&&v!==b){for(b=v;v<c&&!d(i.charCodeAt(v));)v++;if(v===c)return`\\\\${u}\\${i.slice(b)}\\`;v!==b&&(s=`\\\\${u}\\${i.slice(b,v)}`,n=v)}}}else n=1;else o(r)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),n=2,c>2&&d(i.charCodeAt(2))&&(t=!0,n=3));let a=n<c?$(i.slice(n),!t,"\\",d):"";return a.length===0&&!t&&(a="."),a.length>0&&d(i.charCodeAt(c-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){f(i,"path");const c=i.length;if(c===0)return!1;const n=i.charCodeAt(0);return d(n)||c>2&&o(n)&&i.charCodeAt(1)===P&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let c,n;for(let r=0;r<i.length;++r){const a=i[r];f(a,"path"),a.length>0&&(c===void 0?c=n=a:c+=`\\${a}`)}if(c===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&d(n.charCodeAt(0))){++t;const r=n.length;r>1&&d(n.charCodeAt(1))&&(++t,r>2&&(d(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<c.length&&d(c.charCodeAt(t));)t++;t>=2&&(c=`\\${c.slice(t)}`)}return e.$5d.normalize(c)},relative(i,c){if(f(i,"from"),f(c,"to"),i===c)return"";const n=e.$5d.resolve(i),s=e.$5d.resolve(c);if(n===s||(i=n.toLowerCase(),c=s.toLowerCase(),i===c))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===m;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===m;)r--;const a=r-t;let v=0;for(;v<c.length&&c.charCodeAt(v)===m;)v++;let b=c.length;for(;b-1>v&&c.charCodeAt(b-1)===m;)b--;const u=b-v,p=a<u?a:u;let j=-1,F=0;for(;F<p;F++){const z=i.charCodeAt(t+F);if(z!==c.charCodeAt(v+F))break;z===m&&(j=F)}if(F!==p){if(j===-1)return s}else{if(u>p){if(c.charCodeAt(v+F)===m)return s.slice(v+F+1);if(F===2)return s.slice(v+F)}a>p&&(i.charCodeAt(t+F)===m?j=F:F===2&&(j=3)),j===-1&&(j=0)}let T="";for(F=t+j+1;F<=r;++F)(F===r||i.charCodeAt(F)===m)&&(T+=T.length===0?"..":"\\..");return v+=j,T.length>0?`${T}${s.slice(v,b)}`:(s.charCodeAt(v)===m&&++v,s.slice(v,b))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const c=e.$5d.resolve(i);if(c.length<=2)return i;if(c.charCodeAt(0)===m){if(c.charCodeAt(1)===m){const n=c.charCodeAt(2);if(n!==E&&n!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(o(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===m)return`\\\\?\\${c}`;return i},dirname(i){f(i,"path");const c=i.length;if(c===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(c===1)return d(t)?i:".";if(d(t)){if(n=s=1,d(i.charCodeAt(1))){let v=2,b=v;for(;v<c&&!d(i.charCodeAt(v));)v++;if(v<c&&v!==b){for(b=v;v<c&&d(i.charCodeAt(v));)v++;if(v<c&&v!==b){for(b=v;v<c&&!d(i.charCodeAt(v));)v++;if(v===c)return i;v!==b&&(n=s=v+1)}}}}else o(t)&&i.charCodeAt(1)===P&&(n=c>2&&d(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let v=c-1;v>=s;--v)if(d(i.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,c){c!==void 0&&f(c,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&o(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(n=2),c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let a=c.length-1,v=-1;for(r=i.length-1;r>=n;--r){const b=i.charCodeAt(r);if(d(b)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(b===c.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(d(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let c=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===P&&o(i.charCodeAt(0))&&(c=s=2);for(let v=i.length-1;v>=c;--v){const b=i.charCodeAt(v);if(d(b)){if(!r){s=v+1;break}continue}t===-1&&(r=!1,t=v+1),b===I?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:y.bind(null,"\\"),parse(i){f(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return d(t)?(c.root=c.dir=i,c):(c.base=c.name=i,c);if(d(t)){if(s=1,d(i.charCodeAt(1))){let j=2,F=j;for(;j<n&&!d(i.charCodeAt(j));)j++;if(j<n&&j!==F){for(F=j;j<n&&d(i.charCodeAt(j));)j++;if(j<n&&j!==F){for(F=j;j<n&&!d(i.charCodeAt(j));)j++;j===n?s=j:j!==F&&(s=j+1)}}}}else if(o(t)&&i.charCodeAt(1)===P){if(n<=2)return c.root=c.dir=i,c;if(s=2,d(i.charCodeAt(2))){if(n===3)return c.root=c.dir=i,c;s=3}}s>0&&(c.root=i.slice(0,s));let r=-1,a=s,v=-1,b=!0,u=i.length-1,p=0;for(;u>=s;--u){if(t=i.charCodeAt(u),d(t)){if(!b){a=u+1;break}continue}v===-1&&(b=!1,v=u+1),t===I?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return v!==-1&&(r===-1||p===0||p===1&&r===v-1&&r===a+1?c.base=c.name=i.slice(a,v):(c.name=i.slice(a,r),c.base=i.slice(a,v),c.ext=i.slice(r,v))),a>0&&a!==s?c.dir=i.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(w){const i=/\\/g;return()=>{const c=O.cwd().replace(i,"/");return c.slice(c.indexOf("/"))}}return()=>O.cwd()})();e.$6d={resolve(...i){let c="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:C();f(t,"path"),t.length!==0&&(c=`${t}/${c}`,n=t.charCodeAt(0)===S)}return c=$(c,!n,"/",h),n?`/${c}`:c.length>0?c:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===S,n=i.charCodeAt(i.length-1)===S;return i=$(i,!c,"/",h),i.length===0?c?"/":n?"./":".":(n&&(i+="/"),c?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let c;for(let n=0;n<i.length;++n){const s=i[n];f(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.$6d.normalize(c)},relative(i,c){if(f(i,"from"),f(c,"to"),i===c||(i=e.$6d.resolve(i),c=e.$6d.resolve(c),i===c))return"";const n=1,s=i.length,t=s-n,r=1,a=c.length-r,v=t<a?t:a;let b=-1,u=0;for(;u<v;u++){const j=i.charCodeAt(n+u);if(j!==c.charCodeAt(r+u))break;j===S&&(b=u)}if(u===v)if(a>v){if(c.charCodeAt(r+u)===S)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else t>v&&(i.charCodeAt(n+u)===S?b=u:u===0&&(b=0));let p="";for(u=n+b+1;u<=s;++u)(u===s||i.charCodeAt(u)===S)&&(p+=p.length===0?"..":"/..");return`${p}${c.slice(r+b)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===S;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===S){if(!s){n=t;break}}else s=!1;return n===-1?c?"/":".":c&&n===1?"//":i.slice(0,n)},basename(i,c){c!==void 0&&f(c,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let a=c.length-1,v=-1;for(r=i.length-1;r>=0;--r){const b=i.charCodeAt(r);if(b===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(b===c.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===S){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let c=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const v=i.charCodeAt(a);if(v===S){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),v===I?c===-1?c=a:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||s===-1||r===0||r===1&&c===s-1&&c===n+1?"":i.slice(c,s)},format:y.bind(null,"/"),parse(i){f(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const n=i.charCodeAt(0)===S;let s;n?(c.root="/",s=1):s=0;let t=-1,r=0,a=-1,v=!0,b=i.length-1,u=0;for(;b>=s;--b){const p=i.charCodeAt(b);if(p===S){if(!v){r=b+1;break}continue}a===-1&&(v=!1,a=b+1),p===I?t===-1?t=b:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&n?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?c.base=c.name=i.slice(p,a):(c.name=i.slice(p,t),c.base=i.slice(p,a),c.ext=i.slice(t,a))}return r>0?c.dir=i.slice(0,r-1):n&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=w?e.$5d.normalize:e.$6d.normalize,e.$8d=w?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=w?e.$5d.join:e.$6d.join,e.$0d=w?e.$5d.resolve:e.$6d.resolve,e.$$d=w?e.$5d.relative:e.$6d.relative,e.$_d=w?e.$5d.dirname:e.$6d.dirname,e.$ae=w?e.$5d.basename:e.$6d.basename,e.$be=w?e.$5d.extname:e.$6d.extname,e.$ce=w?e.$5d.format:e.$6d.format,e.$de=w?e.$5d.parse:e.$6d.parse,e.$ee=w?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=w?e.$5d.sep:e.$6d.sep,e.$ge=w?e.$5d.delimiter:e.$6d.delimiter}),define(oe[48],ae([0,1,16,6,27,9]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function D(r){return r===47||r===92}e.$Bf=D;function I(r){return r.replace(/[\\/]/g,O.$6d.sep)}e.$Cf=I;function S(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Df=S;function m(r,a=O.$6d.sep){if(!r)return"";const v=r.length,b=r.charCodeAt(0);if(D(b)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let p=3;const j=p;for(;p<v&&!D(r.charCodeAt(p));p++);if(j!==p&&!D(r.charCodeAt(p+1))){for(p+=1;p<v;p++)if(D(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(h(b)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<v;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$Ef=m;function P(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const b=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(b===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Ff=P;const E=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=N.$i){const v=a?E:g;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&l.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Gf=f;function w(r,a,v){const b=r===a;return!v||b?b:!r||!a?!1:(0,A.$Me)(r,a)}e.$Hf=w;function d(r,a,v,b=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,A.$Ne)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===b&&p--,r.charAt(p)===b}return a.charAt(a.length-1)!==b&&(a+=b),r.indexOf(a)===0}e.$If=d;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Jf=h;function o(r,a){return N.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$8d)(r)||(r=(0,O.$9d)(a,r)),r=(0,O.$7d)(r),N.$i?(r=(0,A.$ve)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,A.$ve)(r,O.sep),r||(r=O.sep)),r}e.$Kf=o;function $(r){const a=(0,O.$7d)(r);return N.$i?r.length>3?!1:y(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$6d.sep}e.$Lf=$;function y(r,a=N.$i){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Mf=y;function C(r,a=N.$i){return y(r,a)?r[0]:void 0}e.$Nf=C;function i(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Of=i;function c(r){const a=r.split(":");let v,b,u;for(const p of a){const j=Number(p);(0,L.$nf)(j)?b===void 0?b=j:u===void 0&&(u=j):v=v?[v,p].join(":"):p}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:b!==void 0?b:void 0,column:u!==void 0?u:b!==void 0?1:void 0}}e.$Pf=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let b="";for(let p=0;p<v;p++){let j;p===0&&N.$i&&!a&&(v===3||v===4)?j=s:j=n,b+=j.charAt(Math.floor(Math.random()*j.length))}let u;return a?u=`${a}-${b}`:u=b,r?(0,O.$9d)(r,u):u}e.$Qf=t}),define(oe[141],ae([0,1,16]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const E=(0,O.$be)(P),g=N[E.toLowerCase()];return g!==void 0?g:D(P)}e.$Ir=L;function D(P){const E=(0,O.$be)(P);return A[E.toLowerCase()]}e.$Jr=D;function I(P){for(const E in A)if(A[E]===P)return E}e.$Kr=I;const S=/^(.+)\/(.+?)(;.+)?$/;function m(P,E){const g=S.exec(P);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:E?void 0:P}e.$Lr=m}),define(oe[90],ae([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function L(I,...S){const m=S.reduce((g,l)=>(g[l]=!0,g),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(g=>!m[g]).forEach(g=>{for(let l=0;l<P.length;l++)if(g.search(P[l])!==-1){delete I[g];break}})}e.$sl=L;function D(I){I&&(delete I.DEBUG,O.$j&&delete I.DYLD_LIBRARY_PATH,O.$k&&delete I.LD_PRELOAD)}e.$tl=D}),define(oe[11],ae([0,1,16,6]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,D=/^\/\//;function I(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,t){return!s&&!t?"file":s}function m(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,b,u=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=S(t,u),this.authority=r||P,this.path=m(this.scheme,a||P),this.query=v||P,this.fragment=b||P,I(this,u))}get fsPath(){return y(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:b,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),v===void 0?v=this.path:v===null&&(v=P),b===void 0?b=this.query:b===null&&(b=P),u===void 0?u=this.fragment:u===null&&(u=P),r===this.scheme&&a===this.authority&&v===this.path&&b===this.query&&u===this.fragment?this:new d(r,a,v,b,u)}static parse(t,r=!1){const a=g.exec(t);return a?new d(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new d(P,P,P,P,P)}static file(t){let r=P;if(N.$i&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const a=t.indexOf(E,2);a===-1?(r=t.substring(2),t=E):(r=t.substring(2,a),t=t.substring(a)||E)}return new d("file",r,t,P,P)}static from(t,r){return new d(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=l.file(O.$5d.join(y(t,!0),...r)).path:a=O.$6d.join(t.path,...r),t.with({path:a})}toString(t=!1){return C(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new d(t);return r._formatted=t.external??null,r._fsPath=t._sep===w?t.fsPath??null:null,r}}else return t}}e.URI=l;function f(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$Sf=f;const w=N.$i?1:void 0;class d extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(t=!1){return t?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=w),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(s,t,r){let a,v=-1;for(let b=0;b<s.length;b++){const u=s.charCodeAt(b);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)v!==-1&&(a+=encodeURIComponent(s.substring(v,b)),v=-1),a!==void 0&&(a+=s.charAt(b));else{a===void 0&&(a=s.substr(0,b));const p=h[u];p!==void 0?(v!==-1&&(a+=encodeURIComponent(s.substring(v,b)),v=-1),a+=p):v===-1&&(v=b)}}return v!==-1&&(a+=encodeURIComponent(s.substring(v))),a!==void 0?a:s}function $(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=h[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function y(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$Tf=y;function C(s,t){const r=t?$:o;let a="",{scheme:v,authority:b,path:u,query:p,fragment:j}=s;if(v&&(a+=v,a+=":"),(b||v==="file")&&(a+=E,a+=E),b){let F=b.indexOf("@");if(F!==-1){const T=b.substr(0,F);b=b.substr(F+1),F=T.lastIndexOf(":"),F===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,F),!1,!1),a+=":",a+=r(T.substr(F+1),!1,!0)),a+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?a+=r(b,!1,!0):(a+=r(b.substr(0,F),!1,!0),a+=b.substr(F))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const F=u.charCodeAt(1);F>=65&&F<=90&&(u=`/${String.fromCharCode(F+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const F=u.charCodeAt(0);F>=65&&F<=90&&(u=`${String.fromCharCode(F+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),j&&(a+="#",a+=t?j:o(j,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(c)?s.replace(c,t=>i(t)):s}}),define(oe[142],ae([0,1,11]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function N(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Np=N;function A(m){const P=[];let E;try{const g=JSON.parse(m.arguments),l=g[g.length-1];l&&l.__$stack&&(g.pop(),E=l.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:E}}e.$Op=A;function L(m){if(typeof m!="string")return L(A(m).stack);const P=m;if(P){const E=D(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(g&&g.length===4)return{uri:O.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Pp=L;function D(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function I(m,P){const{args:E,stack:g}=A(m),l=typeof E[0]=="string"&&E.length===1;let f=D(g);f&&(f=`(${f.trim()})`);let w=[];if(typeof E[0]=="string"?f&&l?w=[`%c[${P}] %c${E[0]} %c${f}`,S("blue"),S(""),S("grey")]:w=[`%c[${P}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:w=[`%c[${P}]%`,S("blue"),...E],f&&!l&&w.push(f),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=I;function S(m){return`color: ${m}`}}),define(oe[63],ae([0,1,14,11]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function A(S){return JSON.stringify(S,D)}e.$9g=A;function L(S){let m=JSON.parse(S);return m=I(m),m}e.$0g=L;function D(S,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function I(S,m=0){if(!S||m>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return N.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof O.$Fd||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=I(S[P],m+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=I(S[P],m+1))}return S}e.$$g=I}),define(oe[23],ae([0,1,8,6,11]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,E,g){this.a[P]=E,this.b[P]=g}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(d){return O.$Y(d),P}const E=P.authority;let g=this.a[E];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const l=this.b[E],f=this.c[E];let w=`path=${encodeURIComponent(P.path)}`;return typeof f=="string"&&(w+=`&${e.$Vf}=${encodeURIComponent(f)}`),A.URI.from({scheme:N.$o?this.d:L.vscodeRemoteResource,authority:`${g}:${l}`,path:this.f,query:w})}}e.$Wf=new D,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class I{static{this.a="vscode-app"}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Wf.rewrite(P):P.scheme===L.file&&(N.$m||N.$p&&N.$g.origin===`${L.vscodeFileResource}://${I.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||I.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==I.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return A.URI.isUri(P)?P:A.URI.parse(E.toUrl(P))}}e.$2f=new I;var S;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function g(f){let w;typeof f=="string"?w=new URL(f).searchParams:f instanceof URL?w=f.searchParams:A.URI.isUri(f)&&(w=new URL(f.toString(!0)).searchParams);const d=w?.get(E);if(d)return P.get(d)}m.getHeadersFromQuery=g;function l(f,w,d){if(!globalThis.crossOriginIsolated)return;const h=w&&d?"3":d?"2":"1";f instanceof URLSearchParams?f.set(E,h):f[E]=h}m.addSearchParam=l})(S||(e.COI=S={}))}),define(oe[143],ae([0,1,124,23,6,11]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class D{constructor(g,l,f){this.id=g,this.dependencies=l,this.callback=f}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,l,f)=>{typeof g!="string"&&(f=l,l=g,g=null),(typeof l!="object"||!Array.isArray(l))&&(f=l,l=null),this.c.push(new D(g,l,f))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const l=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!l)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(g){return new Promise((l,f)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const d=()=>{w.removeEventListener("load",h),w.removeEventListener("error",o)},h=$=>{d(),l(this.c.pop())},o=$=>{d(),f($)};w.addEventListener("load",h),w.addEventListener("error",o),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((l,f)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),l(this.c.pop())}catch(w){f(w)}})}async j(g){try{const l=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,d=L.URI.parse(g).fsPath,h=l.readFileSync(d).toString(),o=w.wrap(h.replace(/^#!.*/,""));return new f.Script(o).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const S=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function P(E,g,l){if(O.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[E]&&(E=m[E]);const f=`${E}/${g}`;if(S.has(f))return S.get(f);let w;if(/^\w[\w\d+.-]*:\/\//.test(f))w=f;else{const $=`${l&&!A.$o?N.$Zf:N.$Yf}/${f}`;w=N.$2f.asBrowserUri($).toString(!0)}const d=I.INSTANCE.load(w);return S.set(f,d),d}else return await new Promise((f,w)=>{te([E],f,w)})}e.$aD=P}),define(oe[21],ae([0,1,48,23,16,6,27,11]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function S(l){return(0,I.$Tf)(l,!0)}e.$9f=S;class m{constructor(f){this.a=f}compare(f,w,d=!1){return f===w?0:(0,D.$Fe)(this.getComparisonKey(f,d),this.getComparisonKey(w,d))}isEqual(f,w,d=!1){return f===w?!0:!f||!w?!1:this.getComparisonKey(f,d)===this.getComparisonKey(w,d)}getComparisonKey(f,w=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,w,d=!1){if(f.scheme===w.scheme){if(f.scheme===N.Schemas.file)return O.$If(S(f),S(w),this.a(f))&&f.query===w.query&&(d||f.fragment===w.fragment);if((0,e.$ng)(f.authority,w.authority))return O.$If(f.path,w.path,this.a(f),"/")&&f.query===w.query&&(d||f.fragment===w.fragment)}return!1}joinPath(f,...w){return I.URI.joinPath(f,...w)}basenameOrAuthority(f){return(0,e.$fg)(f)||f.authority}basename(f){return A.$6d.basename(f.path)}extname(f){return A.$6d.extname(f.path)}dirname(f){if(f.path.length===0)return f;let w;return f.scheme===N.Schemas.file?w=I.URI.file(A.$_d(S(f))).path:(w=A.$6d.dirname(f.path),f.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),w="/")),f.with({path:w})}normalizePath(f){if(!f.path.length)return f;let w;return f.scheme===N.Schemas.file?w=I.URI.file(A.$7d(S(f))).path:w=A.$6d.normalize(f.path),f.with({path:w})}relativePath(f,w){if(f.scheme!==w.scheme||!(0,e.$ng)(f.authority,w.authority))return;if(f.scheme===N.Schemas.file){const o=A.$$d(S(f),S(w));return L.$i?O.$Cf(o):o}let d=f.path||"/";const h=w.path||"/";if(this.a(f)){let o=0;for(const $=Math.min(d.length,h.length);o<$&&!(d.charCodeAt(o)!==h.charCodeAt(o)&&d.charAt(o).toLowerCase()!==h.charAt(o).toLowerCase());o++);d=h.substr(0,o)+d.substr(o)}return A.$6d.relative(d,h)}resolvePath(f,w){if(f.scheme===N.Schemas.file){const d=I.URI.file(A.$0d(S(f),w));return f.with({authority:d.authority,path:d.path})}return w=O.$Df(w),f.with({path:A.$6d.resolve(f.path,w)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,w){return f===w||f!==void 0&&w!==void 0&&(0,D.$Me)(f,w)}hasTrailingPathSeparator(f,w=A.sep){if(f.scheme===N.Schemas.file){const d=S(f);return d.length>O.$Ef(d).length&&d[d.length-1]===w}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,w=A.sep){return(0,e.$og)(f,w)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,w=A.sep){let d=!1;if(f.scheme===N.Schemas.file){const h=S(f);d=h!==void 0&&h.length===O.$Ef(h).length&&h[h.length-1]===w}else{w="/";const h=f.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.$og)(f,w)?f.with({path:f.path+"/"}):f}}e.$0f=m,e.$$f=new m(()=>!1),e.$_f=new m(l=>l.scheme===N.Schemas.file?!L.$k:!0),e.$ag=new m(l=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function P(l,f){const w=[];for(let d=0;d<l.length;d++){const h=f(l[d]);l.some((o,$)=>$===d?!1:(0,e.$cg)(h,f(o)))||w.push(l[d])}return w}e.$rg=P;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function f(w){const d=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach($=>{const[y,C]=$.split(":");y&&C&&d.set(y,C)});const o=w.path.substring(0,w.path.indexOf(";"));return o&&d.set(l.META_DATA_MIME,o),d}l.parseMetaData=f})(E||(e.DataUri=E={}));function g(l,f,w){if(f){let d=l.path;return d&&d[0]!==A.$6d.sep&&(d=A.$6d.sep+d),l.with({scheme:w,authority:f,path:d})}return l.with({scheme:w})}e.$sg=g}),define(oe[5],ae([0,1,26,8,3,2,21,6,130]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function m(k){return!!k&&typeof k.then=="function"}e.$tg=m;function P(k){const R=new O.$pd,U=k(R.token),M=new Promise((K,Y)=>{const se=R.token.onCancellationRequested(()=>{se.dispose(),R.dispose(),Y(new N.$3)});Promise.resolve(U).then(le=>{se.dispose(),R.dispose(),K(le)},le=>{se.dispose(),R.dispose(),Y(le)})});return new class{cancel(){R.cancel()}then(K,Y){return M.then(K,Y)}catch(K){return this.then(void 0,K)}finally(K){return M.finally(K)}}}e.$ug=P;function E(k,R,U){return new Promise((M,K)=>{const Y=R.onCancellationRequested(()=>{Y.dispose(),M(U)});k.then(M,K).finally(()=>Y.dispose())})}e.$vg=E;function g(k,R){return new Promise((U,M)=>{const K=R.onCancellationRequested(()=>{K.dispose(),M(new N.$3)});k.then(U,M).finally(()=>K.dispose())})}e.$wg=g;async function l(k){let R=-1;const U=k.map((M,K)=>M.then(Y=>(R=K,Y)));try{return await Promise.race(U)}finally{k.forEach((M,K)=>{K!==R&&M.cancel()})}}e.$xg=l;function f(k,R,U){let M;const K=setTimeout(()=>{M?.(void 0),U?.()},R);return Promise.race([k.finally(()=>clearTimeout(K)),new Promise(Y=>M=Y)])}e.$yg=f;function w(k){return new Promise((R,U)=>{const M=k();m(M)?M.then(R,U):R(M)})}e.$zg=w;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const U=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(U,U).then(M)})}return new Promise((U,M)=>{this.b.then(U,M)})}return this.a=R(),new Promise((U,M)=>{this.a.then(K=>{this.a=null,U(K)},K=>{this.a=null,M(K)})})}dispose(){this.f=!0}}e.$Ag=d;class h{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$Bg=h;class o{constructor(){this.a=new Map}queue(R,U){const K=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(R)===K&&this.a.delete(R)});return this.a.set(R,K),K}}e.$Cg=o;const $=(k,R)=>{let U=!0;const M=setTimeout(()=>{U=!1,R()},k);return{isTriggered:()=>U,dispose:()=>{clearTimeout(M),U=!1}}},y=k=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,k())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class C{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,U=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((K,Y)=>{this.d=K,this.f=Y}).then(()=>{if(this.b=null,this.d=null,this.g){const K=this.g;return this.g=null,K()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=U===S.$cd?y(M):$(U,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=C;class i{constructor(R){this.a=new C(R),this.b=new d}trigger(R,U){return this.a.trigger(()=>this.b.queue(R),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=i;class c{constructor(){this.a=!1,this.b=new Promise((R,U)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=c;class n extends c{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$Gg=n;function s(k,R){return R?new Promise((U,M)=>{const K=setTimeout(()=>{Y.dispose(),U()},k),Y=R.onCancellationRequested(()=>{clearTimeout(K),Y.dispose(),M(new N.$3)})}):P(U=>s(k,U))}e.$Hg=s;function t(k,R=0){const U=setTimeout(k,R);return(0,L.$ic)(()=>clearTimeout(U))}e.$Ig=t;function r(k){const R=[];let U=0;const M=k.length;function K(){return U<M?k[U++]():null}function Y(se){se!=null&&R.push(se);const le=K();return le?le.then(Y):Promise.resolve(R)}return Promise.resolve(null).then(Y)}e.$Jg=r;function a(k,R=M=>!!M,U=null){let M=0;const K=k.length,Y=()=>{if(M>=K)return Promise.resolve(U);const se=k[M++];return Promise.resolve(se()).then(ue=>R(ue)?Promise.resolve(ue):Y())};return Y()}e.$Kg=a;function v(k,R=M=>!!M,U=null){if(k.length===0)return Promise.resolve(U);let M=k.length;const K=()=>{M=-1;for(const Y of k)Y.cancel?.()};return new Promise((Y,se)=>{for(const le of k)le.then(ue=>{--M>=0&&R(ue)?(K(),Y(ue)):M===0&&Y(U)}).catch(ue=>{--M>=0&&(K(),se(ue))})})}e.$Lg=v;class b{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new A.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((U,M)=>{this.f.push({factory:R,c:U,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const U=R.factory();U.then(R.c,R.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=b;class u extends b{constructor(){super(1)}}e.$Ng=u;class p{constructor(){this.a=new x,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$Og=p;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new W;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,U=D.$$f){const M=U.getComparisonKey(R);let K=this.a.get(M);if(!K){K=new u;const Y=this.f++,se=A.Event.once(K.onDrained)(()=>{K?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$sc),this.d.set(Y,se),this.a.set(M,K)}return K}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=j;class F{constructor(R,U){this.a=-1,typeof R=="function"&&typeof U=="number"&&this.setIfNotSet(R,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},U)}setIfNotSet(R,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},U))}}e.$Qg=F;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,U){this.cancel(),this.a=setInterval(()=>{R()},U)}}e.$Rg=T;class z{constructor(R,U){this.b=-1,this.a=R,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=z;class B{constructor(R,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=R,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=B;class _ extends z{constructor(R,U){super(R,U),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$Ug=_;class J extends L.$kc{constructor(R,U){super(),this.g=R,this.h=U,this.a=[],this.b=this.B(new L.$lc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of R)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=k=>{(0,I.$A)(()=>{if(R)return;const U=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.$Wg=(k,R)=>{const U=requestIdleCallback(k,typeof R=="number"?{timeout:R}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(U))}}}}();class Q{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=Q;async function H(k,R,U){let M;for(let K=0;K<U;K++)try{return await k()}catch(Y){M=Y,await s(R)}throw M}e.$Yg=H;class x{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,U,M){return this.a={taskId:R,cancel:()=>M?.(),promise:U},U.then(()=>this.d(R),()=>this.d(R)),U}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{let U,M;const K=new Promise((Y,se)=>{U=Y,M=se});this.b={run:R,promise:K,promiseResolve:U,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=x;class G{constructor(R,U=()=>Date.now()){this.d=R,this.f=U,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$1g=G;var V;(function(k){k[k.Resolved=0]="Resolved",k[k.Rejected=1]="Rejected"})(V||(V={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,U)=>{this.a=R,this.b=U})}complete(R){return new Promise(U=>{this.a(R),this.d={outcome:0,value:R},U()})}error(R){return new Promise(U=>{this.b(R),this.d={outcome:1,value:R},U()})}cancel(){return this.error(new N.$3)}}e.$2g=W;var ee;(function(k){async function R(M){let K;const Y=await Promise.all(M.map(se=>se.then(le=>le,le=>{K||(K=le)})));if(typeof K<"u")throw K;return Y}k.settled=R;function U(M){return new Promise(async(K,Y)=>{try{await M(K,Y)}catch(se){Y(se)}})}k.withAsyncBody=U})(ee||(e.Promises=ee={}));var ne;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(ne||(ne={}));class re{static fromArray(R){return new re(U=>{U.emitMany(R)})}static fromPromise(R){return new re(async U=>{U.emitMany(await R)})}static fromPromises(R){return new re(async U=>{await Promise.all(R.map(async M=>U.emitOne(await M)))})}static merge(R){return new re(async U=>{await Promise.all(R.map(async M=>{for await(const K of M)U.emitOne(K)}))})}static{this.EMPTY=re.fromArray([])}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new A.$fd,queueMicrotask(async()=>{const U={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(R(U)),this.j()}catch(M){this.k(M)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(R,U){return new re(async M=>{for await(const K of R)M.emitOne(U(K))})}map(R){return re.map(this,R)}static filter(R,U){return new re(async M=>{for await(const K of R)U(K)&&M.emitOne(K)})}filter(R){return re.filter(this,R)}static coalesce(R){return re.filter(R,U=>!!U)}coalesce(){return re.coalesce(this)}static async toPromise(R){const U=[];for await(const M of R)U.push(M);return U}toPromise(){return re.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.$3g=re;class X extends re{constructor(R,U){super(U),this.l=R}cancel(){this.l.cancel()}}e.$4g=X;function q(k){const R=new O.$pd,U=k(R.token);return new X(R,async M=>{const K=R.token.onCancellationRequested(()=>{K.dispose(),R.dispose(),M.reject(new N.$3)});try{for await(const Y of U){if(R.token.isCancellationRequested)return;M.emitOne(Y)}K.dispose(),R.dispose()}catch(Y){K.dispose(),R.dispose(),M.reject(Y)}})}e.$5g=q}),define(oe[91],ae([0,1,18,5,48,35,16,6,27]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function m(){return Object.create(null)}e.$mj=m,e.$nj="**",e.$oj="/";const P="[/\\\\]",E="[^/\\\\]",g=/\//g;function l(x,G){switch(x){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${G?`|${P}${E}+`:""})*?`}}function f(x,G){if(!x)return[];const V=[];let W=!1,ee=!1,ne="";for(const re of x){switch(re){case G:if(!W&&!ee){V.push(ne),ne="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=re}return ne&&V.push(ne),V}e.$pj=f;function w(x){if(!x)return"";let G="";const V=f(x,e.$oj);if(V.every(W=>W===e.$nj))G=".*";else{let W=!1;V.forEach((ee,ne)=>{if(ee===e.$nj){if(W)return;G+=l(2,ne===V.length-1)}else{let re=!1,X="",q=!1,k="";for(const R of ee){if(R!=="}"&&re){X+=R;continue}if(q&&(R!=="]"||!k)){let U;R==="-"?U=R:(R==="^"||R==="!")&&!k?U="^":R===e.$oj?U="":U=(0,S.$qe)(R),k+=U;continue}switch(R){case"{":re=!0;continue;case"[":q=!0;continue;case"}":{const M=`(?:${f(X,",").map(K=>w(K)).join("|")})`;G+=M,re=!1,X="";break}case"]":{G+="["+k+"]",q=!1,k="";break}case"?":G+=E;continue;case"*":G+=l(1);continue;default:G+=(0,S.$qe)(R)}}ne<V.length-1&&(V[ne+1]!==e.$nj||ne+2<V.length)&&(G+=P)}W=ee===e.$nj})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Ci(1e4),c=function(){return!1},n=function(){return null};function s(x,G){if(!x)return n;let V;typeof x!="string"?V=x.pattern:V=x,V=V.trim();const W=`${V}_${!!G.trimForExclusions}`;let ee=i.get(W);if(ee)return t(ee,x);let ne;return d.test(V)?ee=a(V.substr(4),V):(ne=h.exec(r(V,G)))?ee=v(ne[1],V):(G.trimForExclusions?$:o).test(V)?ee=b(V,G):(ne=y.exec(r(V,G)))?ee=u(ne[1].substr(1),V,!0):(ne=C.exec(r(V,G)))?ee=u(ne[1],V,!1):ee=p(V),i.set(W,ee),t(ee,x)}function t(x,G){if(typeof G=="string")return x;const V=function(W,ee){return(0,A.$If)(W,G.base,!I.$k)?x((0,S.$ue)(W.substr(G.base.length),D.sep),ee):null};return V.allBasenames=x.allBasenames,V.allPaths=x.allPaths,V.basenames=x.basenames,V.patterns=x.patterns,V}function r(x,G){return G.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function a(x,G){return function(V,W){return typeof V=="string"&&V.endsWith(x)?G:null}}function v(x,G){const V=`/${x}`,W=`\\${x}`,ee=function(re,X){return typeof re!="string"?null:X?X===x?G:null:re===x||re.endsWith(V)||re.endsWith(W)?G:null},ne=[x];return ee.basenames=ne,ee.patterns=[G],ee.allBasenames=ne,ee}function b(x,G){const V=Q(x.slice(1,-1).split(",").map(X=>s(X,G)).filter(X=>X!==n),x),W=V.length;if(!W)return n;if(W===1)return V[0];const ee=function(X,q){for(let k=0,R=V.length;k<R;k++)if(V[k](X,q))return x;return null},ne=V.find(X=>!!X.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((X,q)=>q.allPaths?X.concat(q.allPaths):X,[]);return re.length&&(ee.allPaths=re),ee}function u(x,G,V){const W=D.sep===D.$6d.sep,ee=W?x:x.replace(g,D.sep),ne=D.sep+ee,re=D.$6d.sep+x;let X;return V?X=function(q,k){return typeof q=="string"&&(q===ee||q.endsWith(ne)||!W&&(q===x||q.endsWith(re)))?G:null}:X=function(q,k){return typeof q=="string"&&(q===ee||!W&&q===x)?G:null},X.allPaths=[(V?"*/":"./")+x],X}function p(x){try{const G=new RegExp(`^${w(x)}$`);return function(V){return G.lastIndex=0,typeof V=="string"&&G.test(V)?x:null}}catch{return n}}function j(x,G,V){return!x||typeof G!="string"?!1:F(x)(G,void 0,V)}e.$qj=j;function F(x,G={}){if(!x)return c;if(typeof x=="string"||T(x)){const V=s(x,G);if(V===n)return c;const W=function(ee,ne){return!!V(ee,ne)};return V.allBasenames&&(W.allBasenames=V.allBasenames),V.allPaths&&(W.allPaths=V.allPaths),W}return _(x,G)}e.$rj=F;function T(x){const G=x;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$sj=T;function z(x){return x.allBasenames||[]}e.$tj=z;function B(x){return x.allPaths||[]}e.$uj=B;function _(x,G){const V=Q(Object.getOwnPropertyNames(x).map(X=>J(X,x[X],G)).filter(X=>X!==n)),W=V.length;if(!W)return n;if(!V.some(X=>!!X.requiresSiblings)){if(W===1)return V[0];const X=function(R,U){let M;for(let K=0,Y=V.length;K<Y;K++){const se=V[K](R,U);if(typeof se=="string")return se;(0,N.$tg)(se)&&(M||(M=[]),M.push(se))}return M?(async()=>{for(const K of M){const Y=await K;if(typeof Y=="string")return Y}return null})():null},q=V.find(R=>!!R.allBasenames);q&&(X.allBasenames=q.allBasenames);const k=V.reduce((R,U)=>U.allPaths?R.concat(U.allPaths):R,[]);return k.length&&(X.allPaths=k),X}const ee=function(X,q,k){let R,U;for(let M=0,K=V.length;M<K;M++){const Y=V[M];Y.requiresSiblings&&k&&(q||(q=(0,D.$ae)(X)),R||(R=q.substr(0,q.length-(0,D.$be)(X).length)));const se=Y(X,q,R,k);if(typeof se=="string")return se;(0,N.$tg)(se)&&(U||(U=[]),U.push(se))}return U?(async()=>{for(const M of U){const K=await M;if(typeof K=="string")return K}return null})():null},ne=V.find(X=>!!X.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((X,q)=>q.allPaths?X.concat(q.allPaths):X,[]);return re.length&&(ee.allPaths=re),ee}function J(x,G,V){if(G===!1)return n;const W=s(x,V);if(W===n)return n;if(typeof G=="boolean")return W;if(G){const ee=G.when;if(typeof ee=="string"){const ne=(re,X,q,k)=>{if(!k||!W(re,X))return null;const R=ee.replace("$(basename)",()=>q),U=k(R);return(0,N.$tg)(U)?U.then(M=>M?x:null):U?x:null};return ne.requiresSiblings=!0,ne}}return W}function Q(x,G){const V=x.filter(X=>!!X.basenames);if(V.length<2)return x;const W=V.reduce((X,q)=>{const k=q.basenames;return k?X.concat(k):X},[]);let ee;if(G){ee=[];for(let X=0,q=W.length;X<q;X++)ee.push(G)}else ee=V.reduce((X,q)=>{const k=q.patterns;return k?X.concat(k):X},[]);const ne=function(X,q){if(typeof X!="string")return null;if(!q){let R;for(R=X.length;R>0;R--){const U=X.charCodeAt(R-1);if(U===47||U===92)break}q=X.substr(R)}const k=W.indexOf(q);return k!==-1?ee[k]:null};ne.basenames=W,ne.patterns=ee,ne.allBasenames=W;const re=x.filter(X=>!X.basenames);return re.push(ne),re}function H(x,G){return(0,O.$sb)(x,G,(V,W)=>typeof V=="string"&&typeof W=="string"?V===W:typeof V!="string"&&typeof W!="string"?V.base===W.base&&V.pattern===W.pattern:!1)}e.$vj=H}),define(oe[92],ae([0,1,14,11]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function A(E){return E.toJSON()}class L{constructor(g){this.a=g}transformIncoming(g){const l=this.a.transformIncoming(g);return l===g?g:A(N.URI.from(l))}transformOutgoing(g){const l=this.a.transformOutgoing(g);return l===g?g:A(N.URI.from(l))}transformOutgoingURI(g){const l=this.a.transformOutgoing(g);return l===g?g:N.URI.from(l)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Bm=L,e.$Cm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function D(E,g,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return g.transformOutgoing(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const w=D(E[f],g,l+1);w!==null&&(E[f]=w)}}return null}function I(E,g){const l=D(E,g,0);return l===null?E:l}e.$Dm=I;function S(E,g,l,f){if(!E||f>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?N.URI.revive(g.transformIncoming(E)):g.transformIncoming(E);if(E instanceof O.$Fd)return null;for(const w in E)if(Object.hasOwnProperty.call(E,w)){const d=S(E[w],g,l,f+1);d!==null&&(E[w]=d)}}return null}function m(E,g){const l=S(E,g,!1,0);return l===null?E:l}e.$Em=m;function P(E,g){const l=S(E,g,!0,0);return l===null?E:l}e.$Fm=P}),define(oe[31],ae([0,1,52,36,269,5,48,88,16,6,21,11]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function l(J,Q=g.UNLINK,H){if((0,D.$Lf)(J))throw new Error("rimraf - will refuse to recursively delete root");return Q===g.UNLINK?w(J):f(J,H)}async function f(J,Q=(0,D.$Qf)((0,N.tmpdir)())){try{try{await O.promises.rename(J,Q)}catch(H){return H.code==="ENOENT"?void 0:w(J)}w(Q).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function w(J){return(0,A.promisify)(O.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function d(J){if((0,D.$Lf)(J))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(J,Q){return y(await(Q?o(J):(0,A.promisify)(O.readdir)(J)))}async function o(J){try{return await(0,A.promisify)(O.readdir)(J,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const Q=[],H=await h(J);for(const x of H){let G=!1,V=!1,W=!1;try{const ee=await e.Promises.lstat((0,S.$9d)(J,x));G=ee.isFile(),V=ee.isDirectory(),W=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Q.push({name:x,isFile:()=>G,isDirectory:()=>V,isSymbolicLink:()=>W})}return Q}function $(J){return y(O.readdirSync(J))}e.readdirSync=$;function y(J){return J.map(Q=>typeof Q=="string"?m.$j?(0,I.$hl)(Q):Q:(Q.name=m.$j?(0,I.$hl)(Q.name):Q.name,Q))}async function C(J){const Q=await h(J),H=[];for(const x of Q)await c.existsDirectory((0,S.$9d)(J,x))&&H.push(x);return H}function i(J,Q=1e3){return new Promise(H=>{let x=!1;const G=setInterval(()=>{x||(x=!0,O.access(J,V=>{x=!1,V&&(clearInterval(G),H(void 0))}))},Q)})}e.whenDeleted=i;var c;(function(J){async function Q(G){let V;try{if(V=await e.Promises.lstat(G),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(m.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ee}throw W}}J.stat=Q;async function H(G){try{const{stat:V,symbolicLink:W}=await J.stat(G);return V.isFile()&&W?.dangling!==!0}catch{}return!1}J.existsFile=H;async function x(G){try{const{stat:V,symbolicLink:W}=await J.stat(G);return V.isDirectory()&&W?.dangling!==!0}catch{}return!1}J.existsDirectory=x})(c||(e.SymlinkSupport=c={}));const n=new L.$Pg;function s(J,Q,H){return n.queueFor(E.URI.file(J),P.$_f).queue(()=>{const x=b(H);return new Promise((G,V)=>a(J,Q,x,W=>W?V(W):G()))})}let t=!0;function r(J){t=J}e.configureFlushOnWrite=r;function a(J,Q,H,x){if(!t)return O.writeFile(J,Q,{mode:H.mode,flag:H.flag},x);O.open(J,H.flag,H.mode,(G,V)=>{if(G)return x(G);O.writeFile(V,Q,W=>{if(W)return O.close(V,()=>x(W));O.fdatasync(V,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),O.close(V,ne=>x(ne))))})})}function v(J,Q,H){const x=b(H);if(!t)return O.writeFileSync(J,Q,{mode:x.mode,flag:x.flag});const G=O.openSync(J,x.flag,x.mode);try{O.writeFileSync(G,Q);try{O.fdatasyncSync(G)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{O.closeSync(G)}}e.writeFileSync=v;function b(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function u(J,Q,H=6e4){if(J!==Q)try{m.$i&&typeof H=="number"?await p(J,Q,Date.now(),H):await(0,A.promisify)(O.rename)(J,Q)}catch(x){if(J.toLowerCase()!==Q.toLowerCase()&&x.code==="EXDEV"||J.endsWith("."))await j(J,Q,{preserveSymlinks:!1}),await l(J,g.MOVE);else throw x}}async function p(J,Q,H,x,G=0){try{return await(0,A.promisify)(O.rename)(J,Q)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-H>=x)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${V}`),V;if(G===0){let W=!1;try{const{stat:ee}=await c.stat(Q);ee.isFile()||(W=!0)}catch{}if(W)throw V}return await(0,L.$Hg)(Math.min(100,G*10)),p(J,Q,H,x,G+1)}}async function j(J,Q,H){return T(J,Q,{root:{source:J,target:Q},options:H,handledSourcePaths:new Set})}const F=511;async function T(J,Q,H){if(H.handledSourcePaths.has(J))return;H.handledSourcePaths.add(J);const{stat:x,symbolicLink:G}=await c.stat(J);if(G){if(H.options.preserveSymlinks)try{return await _(J,Q,H)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(G.dangling)return}return x.isDirectory()?z(J,Q,x.mode&F,H):B(J,Q,x.mode&F)}async function z(J,Q,H,x){await e.Promises.mkdir(Q,{recursive:!0,mode:H});const G=await h(J);for(const V of G)await T((0,S.$9d)(J,V),(0,S.$9d)(Q,V),x)}async function B(J,Q,H){await e.Promises.copyFile(J,Q),await e.Promises.chmod(Q,H)}async function _(J,Q,H){let x=await e.Promises.readlink(J);(0,D.$If)(x,H.root.source,!m.$k)&&(x=(0,S.$9d)(H.root.target,x.substr(H.root.source.length+1))),await e.Promises.symlink(x,Q)}e.Promises=new class{get access(){return(0,A.promisify)(O.access)}get stat(){return(0,A.promisify)(O.stat)}get lstat(){return(0,A.promisify)(O.lstat)}get utimes(){return(0,A.promisify)(O.utimes)}get read(){return(J,Q,H,x,G)=>new Promise((V,W)=>{O.read(J,Q,H,x,G,(ee,ne,re)=>ee?W(ee):V({bytesRead:ne,buffer:re}))})}get readFile(){return(0,A.promisify)(O.readFile)}get write(){return(J,Q,H,x,G)=>new Promise((V,W)=>{O.write(J,Q,H,x,G,(ee,ne,re)=>ee?W(ee):V({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,A.promisify)(O.appendFile)}get fdatasync(){return(0,A.promisify)(O.fdatasync)}get truncate(){return(0,A.promisify)(O.truncate)}get copyFile(){return(0,A.promisify)(O.copyFile)}get open(){return(0,A.promisify)(O.open)}get close(){return(0,A.promisify)(O.close)}get symlink(){return(0,A.promisify)(O.symlink)}get readlink(){return(0,A.promisify)(O.readlink)}get chmod(){return(0,A.promisify)(O.chmod)}get mkdir(){return(0,A.promisify)(O.mkdir)}get unlink(){return(0,A.promisify)(O.unlink)}get rmdir(){return(0,A.promisify)(O.rmdir)}get realpath(){return(0,A.promisify)(O.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return C}get writeFile(){return s}get rm(){return l}get rename(){return u}get copy(){return j}}}),define(oe[144],ae([0,1,52,16,6,27,31]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function I(g){if(A.$k)return g;const l=(0,N.$_d)(g);if(g===l)return g;const f=((0,N.$ae)(g)||g).toLowerCase();try{const d=(0,D.readdirSync)(l).filter(h=>h.toLowerCase()===f);if(d.length===1){const h=I(l);if(h)return(0,N.$9d)(h,d[0])}else if(d.length>1){const h=d.indexOf(f);if(h>=0){const o=I(l);if(o)return(0,N.$9d)(o,d[h])}}}catch{}return null}e.$Up=I;async function S(g){if(A.$k)return g;const l=(0,N.$_d)(g);if(g===l)return g;const f=((0,N.$ae)(g)||g).toLowerCase();try{const d=(await D.Promises.readdir(l)).filter(h=>h.toLowerCase()===f);if(d.length===1){const h=await S(l);if(h)return(0,N.$9d)(h,d[0])}else if(d.length>1){const h=d.indexOf(f);if(h>=0){const o=await S(l);if(o)return(0,N.$9d)(o,d[h])}}}catch{}return null}e.$Vp=S;async function m(g){try{return await D.Promises.realpath(g)}catch{const f=E(g);return await D.Promises.access(f,O.constants.R_OK),f}}e.$Wp=m;function P(g){try{return O.realpathSync(g)}catch{const f=E(g);return O.accessSync(f,O.constants.R_OK),f}}e.$Xp=P;function E(g){return(0,L.$ve)((0,N.$7d)(g),N.sep)}}),define(oe[145],ae([0,1,16,6,37,90,9,31]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(E=A.env){return E.comspec||"cmd.exe"}e.$ul=S;function m(E){let g=[],l=!1;const f=function(w){if(l){g.push(w);return}(!E.send(w,h=>{if(h&&console.error(h),l=!1,g.length>0){const o=g.slice(0);g=[],o.forEach($=>f($))}})||N.$i)&&(l=!0)};return{send:f}}e.$vl=m;var P;(function(E){async function g(l,f,w){if(O.$8d(l))return l;if(f===void 0&&(f=A.cwd()),O.$_d(l)!=="."||(w===void 0&&D.$jf(A.env.PATH)&&(w=A.env.PATH.split(O.$ge)),w===void 0||w.length===0))return O.$9d(f,l);async function h(o){if(await I.Promises.exists(o)){let $;try{$=await I.Promises.stat(o)}catch(y){y.message.startsWith("EACCES")&&($=await I.Promises.lstat(o))}return $?!$.isDirectory():!1}return!1}for(const o of w){let $;if(O.$8d(o)?$=O.$9d(o,l):$=O.$9d(f,o,l),await h($))return $;let y=$+".com";if(await h(y)||(y=$+".exe",await h(y)))return y}return O.$9d(f,l)}E.findExecutable=g})(P||(e.win32=P={}))}),define(oe[146],ae([0,1,64,23]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function A(D){return new Promise((I,S)=>{let m;const P=new Map;function E(l,f,w,d,h){const o=P.get(f);if(l===D||o){const $={name:g(w),cmd:w,pid:l,ppid:f,load:d,mem:h};P.set(l,$),l===D&&(m=$),o&&(o.children||(o.children=[]),o.children.push($),o.children.length>1&&(o.children=o.children.sort((y,C)=>y.pid-C.pid)))}}function g(l){const f=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,o=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(l))return"electron-crash-reporter";if(h.exec(l))return"winpty-agent";if(o.exec(l))return"conpty-agent";let y=$.exec(l);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?f.exec(l)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const C=/[a-zA-Z-]+\.js/g;let i="";do y=C.exec(l),y&&(i+=y+" ");while(y);return i&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${i})`:w.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,w)=>{te(["@vscode/windows-process-tree"],f,w)}).then(f=>{f.getProcessList(D,w=>{if(!w){S(new Error(`Root process ${D} not found`));return}f.getProcessCpuUsage(w,d=>{const h=new Map;d.forEach(o=>{const $=l(o.commandLine||"");h.set(o.pid,{name:g($),cmd:$,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),m=h.get(D),m?(h.forEach(o=>{const $=h.get(o.ppid);$&&($.children||($.children=[]),$.children.push(o))}),h.forEach(o=>{o.children&&(o.children=o.children.sort(($,y)=>$.pid-y.pid))}),I(m)):S(new Error(`Root process ${D} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let l=function(){let f=[m];const w=[];for(;f.length;){const h=f.shift();h&&(w.push(h.pid),h.children&&(f=f.concat(h.children)))}let d=JSON.stringify(N.$2f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+w.join(" "),(0,O.exec)(d,{},(h,o,$)=>{if(h||$)S(h||new Error($.toString()));else{const y=o.toString().split(`
`);for(let C=0;C<w.length;C++){const i=P.get(w[C]);i.load=parseFloat(y[C])}if(!m){S(new Error(`Root process ${D} not found`));return}I(m)}})};(0,O.exec)("which ps",{},(f,w,d)=>{if(f||d)if(process.platform!=="linux")S(f||new Error(d.toString()));else{const h=JSON.stringify(N.$2f.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(h,{},(o,$,y)=>{o||y?S(o||new Error(y.toString())):(L($,E),l())})}else{const h=w.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${h} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,y,C)=>{$||C&&!C.includes("screen size is bogus")?S($||new Error(C.toString())):(L(y,E),process.platform==="linux"?l():m?I(m):S(new Error(`Root process ${D} not found`)))})}})}})}e.$sr=A;function L(D,I){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=D.toString().split(`
`);for(const P of m){const E=S.exec(P.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,O,N){var A=arguments.length,L=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,O):N,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,O,N);else for(var I=te.length-1;I>=0;I--)(D=te[I])&&(L=(A<3?D(L):A>3?D(e,O,L):D(e,O))||L);return A>3&&L&&Object.defineProperty(e,O,L),L};define(oe[43],ae([0,1,18,5,14,26,83,8,3,2,63,27,9]),function(te,e,O,N,A,L,D,I,S,m,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var l;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(l||(l={}));function f(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w||(w={}));function d(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(h||(h={}));function o(G){let V=0;for(let W=0;;W+=7){const ee=G.read(1);if(V|=(ee.buffer[0]&127)<<W,!(ee.buffer[0]&128))return V}}const $=n(0);function y(G,V){if(V===0){G.write($);return}let W=0;for(let ne=V;ne!==0;ne=ne>>>7)W++;const ee=A.$Fd.alloc(W);for(let ne=0;V!==0;ne++)ee.buffer[ne]=V&127,V=V>>>7,V>0&&(ee.buffer[ne]|=128);G.write(ee)}class C{constructor(V){this.b=V,this.a=0}read(V){const W=this.b.slice(this.a,this.a+V);return this.a+=W.byteLength,W}}e.$_g=C;class i{constructor(){this.a=[]}get buffer(){return A.$Fd.concat(this.a)}write(V){this.a.push(V)}}e.$ah=i;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function n(G){const V=A.$Fd.alloc(1);return V.writeUInt8(G,0),V}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object),Uint:n(c.Int)},t=typeof Buffer<"u";function r(G,V){if(typeof V>"u")G.write(s.Undefined);else if(typeof V=="string"){const W=A.$Fd.fromString(V);G.write(s.String),y(G,W.byteLength),G.write(W)}else if(t&&Buffer.isBuffer(V)){const W=A.$Fd.wrap(V);G.write(s.Buffer),y(G,W.byteLength),G.write(W)}else if(V instanceof A.$Fd)G.write(s.VSBuffer),y(G,V.byteLength),G.write(V);else if(Array.isArray(V)){G.write(s.Array),y(G,V.length);for(const W of V)r(G,W)}else if(typeof V=="number"&&(V|0)===V)G.write(s.Uint),y(G,V);else{const W=A.$Fd.fromString(JSON.stringify(V));G.write(s.Object),y(G,W.byteLength),G.write(W)}}e.$bh=r;function a(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(o(G)).toString();case c.Buffer:return G.read(o(G)).buffer;case c.VSBuffer:return G.read(o(G));case c.Array:{const W=o(G),ee=[];for(let ne=0;ne<W;ne++)ee.push(a(G));return ee}case c.Object:return JSON.parse(G.read(o(G)).toString());case c.Int:return o(G)}}e.$ch=a;class v{constructor(V,W,ee=null,ne=1e3){this.h=V,this.j=W,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(V,W){this.b.set(V,W),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const W=this.o([V.type]);this.k?.logOutgoing(W,0,1,d(V.type));return}case 201:case 202:case 204:case 203:{const W=this.o([V.type,V.id],V.data);this.k?.logOutgoing(W,V.id,1,d(V.type),V.data);return}}}o(V,W=void 0){const ee=new i;return r(ee,V),r(ee,W),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const W=new C(V),ee=a(W),ne=a(W),re=ee[0];switch(re){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(re)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(re)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(re)}`),this.u({type:re,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${f(re)}`),this.u({type:re,id:ee[1]})}}s(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=new L.$pd;let ne;try{ne=W.call(this.j,V.name,V.arg,ee.token)}catch(q){ne=Promise.reject(q)}const re=V.id;ne.then(q=>{this.m({id:re,data:q,type:201})},q=>{q instanceof Error?this.m({id:re,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:re,data:q,type:203})}).finally(()=>{X.dispose(),this.d.delete(V.id)});const X=(0,m.$ic)(()=>ee.cancel());this.d.set(V.id,X)}t(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=V.id,re=W.listen(this.j,V.name,V.arg)(X=>this.m({id:ee,data:X,type:204}));this.d.set(V.id,re)}u(V){const W=this.d.get(V.id);W&&(W.dispose(),this.d.delete(V.id))}v(V){let W=this.g.get(V.channelName);W||(W=[],this.g.set(V.channelName,W));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:V,timeoutTimer:ee})}w(V){const W=this.g.get(V);if(W){for(const ee of W)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$fc)(this.d.values()),this.d.clear()}}e.$dh=v;var b;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class u{constructor(V,W=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=W}getChannel(V){const W=this;return{call(ee,ne,re){return W.a?Promise.reject(new I.$3):W.m(V,ee,ne,re)},listen(ee,ne){return W.a?S.Event.None:W.o(V,ee,ne)}}}m(V,W,ee,ne=L.CancellationToken.None){const re=this.g++,q={id:re,type:100,channelName:V,name:W,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new I.$3);let k;return new Promise((U,M)=>{if(ne.isCancellationRequested)return M(new I.$3);const K=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(re),U(he.data);break;case 202:{this.f.delete(re);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,M($e);break}case 203:this.f.delete(re),M(he.data);break}};this.f.set(re,ue),this.p(q)};let Y=null;this.b===h.Idle?K():(Y=(0,N.$ug)(ue=>this.u()),Y.then(()=>{Y=null,K()}));const se=()=>{Y?(Y.cancel(),Y=null):this.p({id:re,type:101}),M(new I.$3)},le=ne.onCancellationRequested(se);k=(0,m.$hc)((0,m.$ic)(se),le),this.d.add(k)}).finally(()=>{k.dispose(),this.d.delete(k)})}o(V,W,ee){const ne=this.g++,X={id:ne,type:102,channelName:V,name:W,arg:ee};let q=null;const k=new S.$fd({onWillAddFirstListener:()=>{q=(0,N.$ug)(U=>this.u()),q.then(()=>{q=null,this.d.add(k),this.p(X)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(k),this.p({id:ne,type:103}))}}),R=U=>k.fire(U.data);return this.f.set(ne,R),k.event}p(V){switch(V.type){case 100:case 102:{const W=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(W,V.id,0,`${f(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const W=this.q([V.type,V.id]);this.j?.logOutgoing(W,V.id,0,f(V.type));return}}}q(V,W=void 0){const ee=new i;return r(ee,V),r(ee,W),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const W=new C(V),ee=a(W),ne=a(W),re=ee[0];switch(re){case 200:return this.j?.logIncoming(V.byteLength,0,0,d(re)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,d(re),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$fc)(this.d.values()),this.d.clear()}}e.$eh=u,ye([D.$6g],u.prototype,"onDidInitializePromise",null);class p{get connections(){const V=[];return this.f.forEach(W=>V.push(W)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new S.$fd,this.onDidAddConnection=this.g.event,this.h=new S.$fd,this.onDidRemoveConnection=this.h.event,this.j=new m.$jc,this.j.add(V(({protocol:W,onDidClientDisconnect:ee})=>{const ne=S.Event.once(W.onMessage);this.j.add(ne(re=>{const X=new C(re),q=a(X),k=new v(W,q),R=new u(W);this.a.forEach((M,K)=>k.registerChannel(K,M));const U={channelServer:k,channelClient:R,ctx:q};this.f.add(U),this.g.fire(U),this.j.add(ee(()=>{k.dispose(),R.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(V,W){const ee=this;return{call(ne,re,X){let q;if((0,g.$xf)(W)){const R=(0,O.$2b)(ee.connections.filter(W));q=R?Promise.resolve(R):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,W))}else q=W.routeCall(ee,ne,re);const k=q.then(R=>R.channelClient.getChannel(V));return F(k).call(ne,re,X)},listen(ne,re){if((0,g.$xf)(W))return ee.k(V,W,ne,re);const X=W.routeEvent(ee,ne,re).then(q=>q.channelClient.getChannel(V));return F(X).listen(ne,re)}}}k(V,W,ee,ne){const re=this;let X;const q=new S.$fd({onWillAddFirstListener:()=>{X=new m.$jc;const k=new S.$ld,R=new Map,U=K=>{const se=K.channelClient.getChannel(V).listen(ee,ne),le=k.add(se);R.set(K,le)},M=K=>{const Y=R.get(K);Y&&(Y.dispose(),R.delete(K))};re.connections.filter(W).forEach(U),S.Event.filter(re.onDidAddConnection,W)(U,void 0,X),re.onDidRemoveConnection(M,void 0,X),k.event(q.fire,q,X),X.add(k)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return q.event}registerChannel(V,W){this.a.set(V,W);for(const ee of this.f)ee.channelServer.registerChannel(V,W)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=p;class j{constructor(V,W,ee=null){const ne=new i;r(ne,W),V.send(ne.buffer),this.a=new u(V,ee),this.d=new v(V,W,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,W){this.d.registerChannel(V,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=j;function F(G){return{call(V,W,ee){return G.then(ne=>ne.call(V,W,ee))},listen(V,W){const ee=new S.$od;return G.then(ne=>ee.input=ne.listen(V,W)),ee.event}}}e.$hh=F;function T(G){let V=!1;return{call(W,ee,ne){return V?G.call(W,ee,ne):(0,N.$Hg)(0).then(()=>V=!0).then(()=>G.call(W,ee,ne))},listen(W,ee){if(V)return G.listen(W,ee);const ne=new S.$od;return(0,N.$Hg)(0).then(()=>V=!0).then(()=>ne.input=G.listen(W,ee)),ne.event}}}e.$ih=T;class z{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const W of V.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await S.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$jh=z;var B;(function(G){function V(re,X,q){const k=re,R=q&&q.disableMarshalling,U=new Map;for(const M in k)ee(M)&&U.set(M,S.Event.buffer(k[M],!0,void 0,X));return new class{listen(M,K,Y){const se=U.get(K);if(se)return se;if(ne(K)){const le=k[K];if(typeof le=="function")return le.call(k,Y)}throw new I.$_(`Event not found: ${K}`)}call(M,K,Y){const se=k[K];if(typeof se=="function"){if(!R&&Array.isArray(Y))for(let le=0;le<Y.length;le++)Y[le]=(0,P.$$g)(Y[le]);return se.apply(k,Y)}throw new I.$_(`Method not found: ${K}`)}}}G.fromService=V;function W(re,X){const q=X&&X.disableMarshalling;return new Proxy({},{get(k,R){if(typeof R=="string")return X?.properties?.has(R)?X.properties.get(R):ne(R)?function(U){return re.listen(R,U)}:ee(R)?re.listen(R):async function(...U){let M;X&&!(0,g.$sf)(X.context)?M=[X.context,...U]:M=U;const K=await re.call(R,M);return q?K:(0,P.$$g)(K)};throw new I.$_(`Property not found: ${String(R)}`)}})}G.toService=W;function ee(re){return re[0]==="o"&&re[1]==="n"&&E.$Le(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&E.$Le(re.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const V=G.toString();if(V!=="[object Object]")return V}return G}function Q(G){return Array.isArray(G)?G.map(J):J(G)}function H(G,V,W,ee,ne,re,X){X=Q(X);const q=_[ne],k=q[ee%q.length];let R=[`%c[${G}]%c[${String(V).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(re)?(R=R.concat(X),R.push(")")):R.push(X),console.log.apply(console,R)}class x{constructor(V,W){this.d=V,this.f=W,this.a=0,this.b=0}logOutgoing(V,W,ee,ne,re){this.b+=V,H(this.d,this.b,V,W,ee,ne,re)}logIncoming(V,W,ee,ne,re){this.a+=V,H(this.f,this.a,V,W,ee,ne,re)}}e.$kh=x}),define(oe[65],ae([0,1,14,3,2,43]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(b,u){if(!t.has(b)){const p=String(++r);t.set(b,p)}return t.get(b)}function v(b,u,p,j){if(!s.enableDiagnostics)return;const F=a(b,u);if(j instanceof O.$Fd||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const T=O.$Fd.alloc(j.byteLength);T.set(j),s.records.push({timestamp:Date.now(),id:F,label:u,type:p,buff:T})}else s.records.push({timestamp:Date.now(),id:F,label:u,type:p,data:j})}s.traceSocketEvent=v})(I||(e.SocketDiagnostics=I={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let m=null;function P(){return m||(m=O.$Fd.alloc(0)),m}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return P();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=O.$Fd.alloc(t);let v=0,b=0;for(;t>0;){const u=this.a[b];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,v),v+=t,r&&(this.a[b]=u.slice(t),this.b-=t),t-=t}else a.set(u,v),v+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):b++,t-=u.byteLength}return a}}e.$lh=E;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(g||(g={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class w{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends A.$kc{constructor(t){super(),this.f=this.B(new N.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new w(a,v,b,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$Fd.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class o extends A.$kc{constructor(t){super(),this.f=new N.$fd,this.onMessage=this.f.event,this.g=new N.$fd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new w(1,0,0,t))}}e.$mh=o;class $ extends L.$gh{static fromSocket(t,r){return new $(new o(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$nh=$;class y{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$oh=y;class C{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new C(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<c.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+c.a)*1e3;let a=0;for(let v=0;v<c.a;v++)t-this.c[v]<=r&&a++;return 1-a/c.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new y,this.onControlMessage=this.u.event,this.v=new y,this.onMessage=this.v.event,this.w=new y,this.onDidDispose=this.w.event,this.x=new y,this.onSocketClose=this.x.event,this.y=new y,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??c.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$jc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new w(5,0,0,P());this.p.write(t),this.p.flush()}sendPause(){const t=new w(7,0,0,P());this.p.write(t)}sendResume(){const t=new w(8,0,0,P());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new w(3,0,this.h,P());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new w(6,0,0,P())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new w(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new w(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const b=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new w(3,0,this.h,P());this.p.write(t)}D(){this.h=this.g;const t=new w(9,0,this.h,P());this.p.write(t)}}e.$ph=n}),define(oe[93],ae([0,1,64,5,14,26,142,8,3,2,30,145,90,43]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class f extends l.$dh{constructor(h){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",o=>A.$Fd.wrap(Buffer.from(o,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Rp=f;class w{constructor(h,o){this.i=h,this.j=o,this.c=new Set,this.g=new Map,this.h=new S.$fd,this.onDidProcessExit=this.h.event;const $=o&&o.timeout?o.timeout:6e4;this.b=new N.$Dg($),this.d=null,this.f=null}getChannel(h){const o=this;return{call($,y,C){return o.k(h,$,y,C)},listen($,y){return o.l(h,$,y)}}}k(h,o,$,y=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.$4());this.b.cancel();const C=this.n(h),i=(0,N.$ug)(s=>C.call(o,$,s)),c=y.onCancellationRequested(()=>i.cancel()),n=(0,m.$ic)(()=>i.cancel());return this.c.add(n),i.finally(()=>{c.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(h,o,$){if(!this.b)return S.Event.None;this.b.cancel();let y;const C=new S.$fd({onWillAddFirstListener:()=>{y=this.n(h).listen(o,$)(C.fire,C),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],o=Object.create(null);o.env={...(0,P.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(o.env={...o.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(o.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,g.$tl)(o.env),this.d=(0,O.fork)(this.i,h,o);const $=new S.$fd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,D.$Np)(t)){(0,D.log)(t,`IPC Library: ${this.j.serverName}`);return}$.fire(A.$Fd.wrap(Buffer.from(t,"base64")))});const C=this.j.useQueue?(0,E.$vl)(this.d):this.d,i=t=>this.d&&this.d.connected&&C.send(t.buffer.toString("base64")),c=$.event,n={send:i,onMessage:c};this.f=new l.$eh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,m.$fc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(h){let o=this.g.get(h);return o||(o=this.m.getChannel(h),this.g.set(h,o)),o}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=w}),define(oe[147],ae([0,1,135,14,43,3,9,18]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=e.$6S=void 0;class S{constructor(g){this.a=g,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",l=>N.$Fd.wrap(l.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}class m extends A.$fh{static b(g){(0,D.$tf)((0,O.$5S)(process),"Electron Utility Process");const l=new L.$fd;return process.parentPort.on("message",f=>{if(g?.handledClientConnection(f))return;const w=(0,I.$Mb)(f.ports);w&&l.fire(w)}),L.Event.map(l.event,f=>({protocol:new S(f),onDidClientDisconnect:L.Event.fromNodeEventEmitter(f,"close")}))}constructor(g){super(m.b(g))}}e.$6S=m;function P(E,g,l){const f=w=>{w.data===g&&(E.removeListener("message",f),l())};E.on("message",f)}e.$7S=P}),define(oe[66],ae([0,1,5,3,2,63,9]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var I;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function S(g){const l=g;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$Qo=S;var m;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(m||(e.StorageState=m={}));class P extends A.$kc{static{this.a=100}constructor(l,f=Object.create(null)){super(),this.r=l,this.s=f,this.b=this.B(new N.$id),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new O.$Eg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((f,w)=>this.w(w,f)),l.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(l,f){if(this.c===m.Closed)return;let w=!1;(0,D.$sf)(f)?w=this.f.delete(l):this.f.get(l)!==f&&(this.f.set(l,f),w=!0),w&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,f){const w=this.f.get(l);return(0,D.$sf)(w)?f:w}getBoolean(l,f){const w=this.get(l);return(0,D.$sf)(w)?f:w==="true"}getNumber(l,f){const w=this.get(l);return(0,D.$sf)(w)?f:parseInt(w,10)}getObject(l,f){const w=this.get(l);return(0,D.$sf)(w)?f:(0,L.$0g)(w)}async set(l,f,w=!1){if(this.c===m.Closed)return;if((0,D.$sf)(f))return this.delete(l,w);const d=(0,D.$lf)(f)||Array.isArray(f)?(0,L.$9g)(f):String(f);if(this.f.get(l)!==d)return this.f.set(l,d),this.j.set(l,d),this.h.delete(l),this.b.fire({key:l,external:w}),this.D()}async delete(l,f=!1){if(!(this.c===m.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:f}),this.D()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=m.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Ro=P;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((f,w)=>this.a.set(w,f)),l.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$So=E}),define(oe[148],ae([13,10]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,10]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,10]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,10]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,10]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,10]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,10]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,10]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,10]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var A;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(A||(e.TokenType=A={}));function L(...m){switch(m.length){case 1:return(0,N.localize)(0,null,m[0]);case 2:return(0,N.localize)(1,null,m[0],m[1]);case 3:return(0,N.localize)(2,null,m[0],m[1],m[2]);default:return}}const D=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,O.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,g=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:g};this.g.push({offset:E,lexeme:g,additionalInfo:P}),this.f.push(l)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),g=S.b.get(E);g?this.k(g):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,g=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(I);return}const f=this.c.charCodeAt(P);if(E)E=!1;else if(f===47&&!g){P++;break}else f===91?g=!0:f===92?E=!0:f===93&&(g=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=S}),define(oe[180],ae([0,1,62,83,23,16,37,21,11]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,L.$_d)(A.$2f.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,L.$9d)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,I.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,O.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$9d)(this.userDataPath,"logs",l)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$ig)(S.URI.file((0,L.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?S.URI.file((0,L.$9d)(l,"argv.json")):(0,I.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,L.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,L.$0d)(l):(0,L.$7d)((0,L.$9d)(A.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?S.URI.file((0,L.$0d)(l)):S.URI.file((0,L.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,L.$0d)(l);const f=D.env.VSCODE_EXTENSIONS;if(f)return f;const w=D.env.VSCODE_PORTABLE;return w?(0,L.$9d)(w,"extensions"):(0,I.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(f=>/^[^:/?#]+?:\/\//.test(f)?S.URI.parse(f):S.URI.file((0,L.$7d)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?S.URI.parse(l):S.URI.file((0,L.$7d)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$8l.test(l))}get extensionLogLevel(){const l=[];for(const f of this.args.log||[]){const w=e.$8l.exec(f);w&&w[1]&&w[2]&&l.push([w[1],w[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,I.$ig)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?S.URI.file((0,L.$9d)(l,"policy.json")):(0,I.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,f,w){this.a=l,this.b=f,this.c=w,this.editSessionId=this.args.editSessionId}}e.$9l=m,ye([N.$6g],m.prototype,"appRoot",null),ye([N.$6g],m.prototype,"userHome",null),ye([N.$6g],m.prototype,"userDataPath",null),ye([N.$6g],m.prototype,"appSettingsHome",null),ye([N.$6g],m.prototype,"tmpDir",null),ye([N.$6g],m.prototype,"cacheHome",null),ye([N.$6g],m.prototype,"stateResource",null),ye([N.$6g],m.prototype,"userRoamingDataHome",null),ye([N.$6g],m.prototype,"userDataSyncHome",null),ye([N.$6g],m.prototype,"sync",null),ye([N.$6g],m.prototype,"machineSettingsResource",null),ye([N.$6g],m.prototype,"workspaceStorageHome",null),ye([N.$6g],m.prototype,"localHistoryHome",null),ye([N.$6g],m.prototype,"keyboardLayoutResource",null),ye([N.$6g],m.prototype,"argvResource",null),ye([N.$6g],m.prototype,"isExtensionDevelopment",null),ye([N.$6g],m.prototype,"untitledWorkspacesHome",null),ye([N.$6g],m.prototype,"builtinExtensionsPath",null),ye([N.$6g],m.prototype,"extensionsPath",null),ye([N.$6g],m.prototype,"extensionDevelopmentLocationURI",null),ye([N.$6g],m.prototype,"extensionDevelopmentKind",null),ye([N.$6g],m.prototype,"extensionTestsLocationURI",null),ye([N.$6g],m.prototype,"debugExtensionHost",null),ye([N.$6g],m.prototype,"logLevel",null),ye([N.$6g],m.prototype,"extensionLogLevel",null),ye([N.$6g],m.prototype,"serviceMachineIdResource",null),ye([N.$6g],m.prototype,"disableTelemetry",null),ye([N.$6g],m.prototype,"disableWorkspaceTrust",null),ye([N.$6g],m.prototype,"useInMemorySecretStorage",null),ye([N.$6g],m.prototype,"policyFile",null);function P(g,l){return E(g["inspect-extensions"],g["inspect-brk-extensions"],5870,l,g.debugId,g.extensionEnvironment)}e.$0l=P;function E(g,l,f,w,d,h){const $=Number(l||g)||(w?null:f),y=$?!!l:!1;let C;if(h)try{C=JSON.parse(h)}catch{}return{port:$,break:y,debugId:d,env:C}}e.$$l=E}),function(){"use strict";function te(e,O,N){function A(D,I){const S=L(D,I),m=[S];return e.isAbsolute(S)||m.unshift(N),e.resolve(...m)}function L(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,I);const P=D["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(E,"AppData","Roaming")}break;case"darwin":m=e.join(O.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,I)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,O,N){return te(e,O,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=te(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class L extends N.$9l{constructor(m,P){super(m,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,A.getUserDataPath)(m,P.nameShort)},P)}}e.$_l=L;function D(S,m){return(0,N.$$l)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,m,S.extensionEnvironment)}e.$am=D;function I(S,m){return(0,N.$$l)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,m,S.extensionEnvironment)}e.$bm=I}),define(oe[183],ae([0,1,9,154]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function A(D,I,S,m){try{L(D,I,S,m)}catch(P){D.error(P?.message??P)}return I}e.$np=A;function L(D,I,S,m){const P=(E,g,l)=>{const f=E[g];if((0,O.$jf)(f)){const w=f,d=w.length;if(d>1&&w[0]==="%"&&w[d-1]==="%"){const h=w.substr(1,d-2);let o=S[h];o===void 0&&m&&(o=m[h]);const $=typeof o=="string"?o:o?.message,y=m?.[h],C=typeof y=="string"?y:y?.message;if(!$){C||D.warn(`[${I.name}]: ${(0,N.localize)(0,null,h)}`);return}if(l&&(g==="title"||g==="category")&&C&&C!==$){const i={value:$,original:C};E[g]=i}else E[g]=$}}else if((0,O.$lf)(f))for(const w in f)f.hasOwnProperty(w)&&(w==="commands"?P(f,w,!0):P(f,w,l));else if(Array.isArray(f))for(let w=0;w<f.length;w++)P(f,w,l)};for(const E in I)I.hasOwnProperty(E)&&P(I,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=e.$b8b=void 0;class O{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$b8b=O;class N{constructor(L){this.a=L}listen(L,D){throw new Error(`Event not found: ${D}`)}call(L,D,I){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${D}`)}}e.$c8b=N}),define(oe[67],ae([0,1,21,89,158,53]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||D.test(h)}e.$Bo=S;function m(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=h.match(D);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}e.$Co=m;function P(h){if(!h)return null;const o=h.majorBase,$=h.majorMustEqual,y=h.minorBase;let C=h.minorMustEqual;const i=h.patchBase;let c=h.patchMustEqual;h.hasCaret&&(o===0||(C=!1),c=!1);let n=0;if(h.preRelease){const s=I.exec(h.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:o,majorMustEqual:$,minorBase:y,minorMustEqual:C,patchBase:i,patchMustEqual:c,isMinimum:h.hasGreaterEquals,notBefore:n}}e.$Do=P;function E(h,o,$){let y;typeof h=="string"?y=P(m(h)):y=h;let C;o instanceof Date?C=o.getTime():typeof o=="string"&&(C=new Date(o).getTime());let i;if(typeof $=="string"?i=P(m($)):i=$,!y||!i)return!1;const c=y.majorBase,n=y.minorBase,s=y.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const v=i.notBefore;let b=i.majorMustEqual,u=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?c>t?!0:c<t?!1:n>r?!0:n<r||C&&C<v?!1:s>=a:(c===1&&t===0&&(!b||!u||!p)&&(t=1,r=0,a=0,b=!0,u=!1,p=!1),c<t?!1:c>t?!b:n<r?!1:n>r?!u:s<a?!1:s>a?!p:!(C&&C<v))}e.$Eo=E;function g(h,o,$,y,C){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([N.default.Error,A.localize(0,null)]),i;if(typeof y.name!="string")return i.push([N.default.Error,A.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([N.default.Error,A.localize(2,null,"version")]),i;if(!y.engines)return i.push([N.default.Error,A.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([N.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!d(y.extensionDependencies))return i.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!d(y.activationEvents))return i.push([N.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([N.default.Error,A.localize(9,null,"main")]),i;{const s=(0,O.$ig)($,y.main);(0,O.$cg)(s,$)||i.push([N.default.Warning,A.localize(10,null,s.path,$.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([N.default.Error,A.localize(11,null,"browser")]),i;{const s=(0,O.$ig)($,y.browser);(0,O.$cg)(s,$)||i.push([N.default.Warning,A.localize(12,null,s.path,$.path)])}}if(!L.valid(y.version))return i.push([N.default.Error,A.localize(13,null)]),i;const c=[];if(!l(h,o,y,C,c))for(const s of c)i.push([N.default.Error,s]);return i}e.$Fo=g;function l(h,o,$,y,C){return y||typeof $.main>"u"&&typeof $.browser>"u"?!0:w(h,o,$.engines.vscode,C)}e.$Go=l;function f(h,o,$){return h==="*"||w(o,$,h)}e.$Ho=f;function w(h,o,$,y=[]){const C=P(m($));if(!C)return y.push(A.localize(14,null,$)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return y.push(A.localize(15,null,$)),!1}else if(!C.majorMustEqual)return y.push(A.localize(16,null,$)),!1;return E(h,o,C)?!0:(y.push(A.localize(17,null,h,$)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let o=0,$=h.length;o<$;o++)if(typeof h[o]!="string")return!1;return!0}}),define(oe[44],ae([0,1,14,32]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function A(L,D,I){let S=I&&I.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const P=(await D.readFile(L.serviceMachineIdResource)).value.toString();S=(0,N.$3f)(P)?P:null}catch{S=null}if(!S){S=(0,N.$4f)();try{await D.writeFile(L.serviceMachineIdResource,O.$Fd.fromString(S))}catch{}}return I?.store("storage.serviceMachineId",S,-1,1),S}e.$2o=A}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class O{constructor(A,L=[],D=!1){this.ctor=A,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.$yh=O}),define(oe[185],ae([0,1,68]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const N=[];var A;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function L(I,S,m){S instanceof O.$yh||(S=new O.$yh(S,[],!!m)),N.push([I,S])}e.$mr=L;function D(){return N}e.$nr=D}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class O{constructor(L,D){this.key=L,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$4p=O;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const D of this.a.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const I=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(D);I.outgoing.set(S.key,S),S.incoming.set(I.key,I)}removeNode(L){const D=this.b(L);this.a.delete(D);for(const I of this.a.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(L){const D=this.b(L);let I=this.a.get(D);return I||(I=new O(D,L),this.a.set(D,I)),I}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[D,I]of this.a)L.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this.a){const I=new Set([L]),S=this.c(D,I);if(S)return S}}c(L,D){for(const[I,S]of L.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const m=this.c(S,D);if(m)return m;D.delete(I)}}}e.$5p=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var O;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(O||(e._util=O={})),e.$Ah=A("instantiationService");function N(D,I,S){I[O.DI_TARGET]===I?I[O.DI_DEPENDENCIES].push({id:D,index:S}):(I[O.DI_DEPENDENCIES]=[{id:D,index:S}],I[O.DI_TARGET]=I)}function A(D){if(O.serviceIds.has(D))return O.serviceIds.get(D);const I=function(S,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,S,P)};return I.toString=()=>D,O.serviceIds.set(D,I),I}e.$Bh=A;function L(D){return D}e.$Ch=L}),define(oe[187],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=void 0,e.$K7b=(0,O.$Bh)("checksumService")}),define(oe[19],ae([0,1,9,11,4]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,A.$Bh)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$9h=L;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$0h=D;var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=S;function m(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$_h=m;function P(h,o){const $=Object.create(null);for(const y in h)E($,y,h[y],o);return $}e.$ai=P;function E(h,o,$,y){const C=o.split("."),i=C.pop();let c=h;for(let n=0;n<C.length;n++){const s=C[n];let t=c[s];switch(typeof t){case"undefined":t=c[s]=Object.create(null);break;case"object":break;default:y(`Ignoring ${o} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}c=t}if(typeof c=="object"&&c!==null)try{c[i]=$}catch{y(`Ignoring ${o} as ${C.join(".")} is ${JSON.stringify(c)}`)}else y(`Ignoring ${o} as ${C.join(".")} is ${JSON.stringify(c)}`)}e.$bi=E;function g(h,o){const $=o.split(".");l(h,$)}e.$ci=g;function l(h,o){const $=o.shift();if(o.length===0){delete h[$];return}if(Object.keys(h).indexOf($)!==-1){const y=h[$];typeof y=="object"&&!Array.isArray(y)&&(l(y,o),Object.keys(y).length===0&&delete h[$])}}function f(h,o,$){function y(c,n){let s=c;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const C=o.split("."),i=y(h,C);return typeof i>"u"?$:i}e.$di=f;function w(h,o,$){Object.keys(o).forEach(y=>{y!=="__proto__"&&(y in h?O.$lf(h[y])&&O.$lf(o[y])?w(h[y],o[y],$):$&&(h[y]=o[y]):h[y]=o[y])})}e.$ei=w;function d(h){return h.replace(/[\[\]]/g,"")}e.$fi=d}),define(oe[94],ae([0,1,6,27,179,4,150,8]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",O.$j),S.set("isLinux",O.$k),S.set("isWindows",O.$i),S.set("isWeb",O.$o),S.set("isMacNative",O.$j&&!O.$o),S.set("isEdge",O.$G),S.set("isFirefox",O.$E),S.set("isChrome",O.$D),S.set("isSafari",O.$F);function m(q,k){if(S.get(q)!==void 0)throw(0,I.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,k)}e.$Gi=m;const P=Object.prototype.hasOwnProperty;var E;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const g={regexParsingWithErrorRecovery:!0},l=(0,D.localize)(0,null),f=(0,D.localize)(1,null),w=(0,D.localize)(2,null),d=(0,D.localize)(3,null),h=(0,D.localize)(4,null),o=(0,D.localize)(5,null),$=(0,D.localize)(6,null),y=(0,D.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=g){this.k=k,this.d=new A.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const R=this.l();if(!this.E()){const U=this.D(),M=U.type===17?o:void 0;throw this.h.push({message:h,offset:U.offset,lexeme:A.$Fi.getLexeme(U),additionalInfo:M}),C.c}return R}catch(R){if(R!==C.c)throw R;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const R=this.o();k.push(R)}return k.length===1?k[0]:i.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const R=this.s();k.push(R)}return k.length===1?k[0]:i.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const R=this.l();return this.A(1,d),R?.negate()}case 17:return this.z(),j.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const R=this.l();return this.A(1,d),R}case 17:{const R=k.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const K=M.lexeme,Y=K.lastIndexOf("/"),se=Y===K.length-1?void 0:this.w(K.substring(Y+1));let le;try{le=new RegExp(K.substring(1,Y),se)}catch{throw this.B("REGEX",M)}return J.create(R,le)}switch(M.type){case 10:case 19:{const K=[M.lexeme];this.z();let Y=this.D(),se=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?se++:M.lexeme.charCodeAt(de)===41&&se--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let de=0;de<Y.lexeme.length;de++)Y.lexeme.charCodeAt(de)===40?se++:M.lexeme.charCodeAt(de)===41&&se--}if(se<0)break;K.push(A.$Fi.getLexeme(Y)),this.z(),Y=this.D()}const le=K.join(""),ue=le.lastIndexOf("/"),he=ue===le.length-1?void 0:this.w(le.substring(ue+1));let $e;try{$e=new RegExp(le.substring(1,ue),he)}catch{throw this.B("REGEX",M)}return i.regex(R,$e)}case 18:{const K=M.lexeme;this.z();let Y=null;if(!(0,N.$me)(K)){const se=K.indexOf("/"),le=K.lastIndexOf("/");if(se!==le&&se>=0){const ue=K.slice(se+1,le),he=K[le+1]==="i"?"i":"";try{Y=new RegExp(ue,he)}catch{throw this.B("REGEX",M)}}}if(Y===null)throw this.B("REGEX",M);return J.create(R,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const M=this.u();return i.notIn(R,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return i.equals(R,M);switch(M){case"true":return i.has(R);case"false":return i.not(R);default:return i.equals(R,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return i.notEquals(R,M);switch(M){case"true":return i.not(R);case"false":return i.has(R);default:return i.notEquals(R,M)}}case 5:return this.z(),B.create(R,this.u());case 6:return this.z(),_.create(R,this.u());case 7:return this.z(),T.create(R,this.u());case 8:return this.z(),z.create(R,this.u());case 13:return this.z(),i.in(R,this.u());default:return i.has(R)}}case 20:throw this.h.push({message:$,offset:k.offset,lexeme:"",additionalInfo:y}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,R){if(this.C(k))return this.z();throw this.B(R,this.D())}B(k,R,U){const M=(0,D.localize)(8,null,k,A.$Fi.getLexeme(R)),K=R.offset,Y=A.$Fi.getLexeme(R);return this.h.push({message:M,offset:K,lexeme:Y,additionalInfo:U}),C.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=C;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(k){return a.create(k)}static equals(k,R){return v.create(k,R)}static notEquals(k,R){return p.create(k,R)}static regex(k,R){return J.create(k,R)}static in(k,R){return b.create(k,R)}static notIn(k,R){return u.create(k,R)}static not(k){return j.create(k)}static and(...k){return x.create(k,null,!0)}static or(...k){return G.create(k,null,!0)}static greater(k,R){return T.create(k,R)}static greaterEquals(k,R){return z.create(k,R)}static smaller(k,R){return B.create(k,R)}static smallerEquals(k,R){return _.create(k,R)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.$Ii=i;function c(q){const k=new C({regexParsingWithErrorRecovery:!1});return q.map(R=>(k.parse(R),k.lexingErrors.length>0?k.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,D.localize)(9,null,U.additionalInfo):(0,D.localize)(10,null),offset:U.offset,length:U.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.$Ji=c;function n(q,k){const R=q?q.substituteConstants():void 0,U=k?k.substituteConstants():void 0;return!R&&!U?!0:!R||!U?!1:R.equals(U)}e.$Ki=n;function s(q,k){return q.cmp(k)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.$Li=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return t.INSTANCE}}e.$Mi=r;class a{static create(k,R=null){const U=S.get(k);return typeof U=="boolean"?U?r.INSTANCE:t.INSTANCE:new a(k,R)}constructor(k,R){this.key=k,this.c=R,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:W(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=S.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:t.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ni=a;class v{static create(k,R,U=null){if(typeof R=="boolean")return R?a.create(k,U):j.create(k,U);const M=S.get(k);return typeof M=="boolean"?R===(M?"true":"false")?r.INSTANCE:t.INSTANCE:new v(k,R,U)}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?r.INSTANCE:t.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Oi=v;class b{static create(k,R){return new b(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.f),U=k.getValue(this.d);return Array.isArray(R)?R.includes(U):typeof U=="string"&&typeof R=="object"&&R!==null?P.call(R,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Pi=b;class u{static create(k,R){return new u(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=11,this.c=b.create(k,R)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=u;class p{static create(k,R,U=null){if(typeof R=="boolean")return R?j.create(k,U):a.create(k,U);const M=S.get(k);return typeof M=="boolean"?R===(M?"true":"false")?t.INSTANCE:r.INSTANCE:new p(k,R,U)}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?t.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ri=p;class j{static create(k,R=null){const U=S.get(k);return typeof U=="boolean"?U?t.INSTANCE:r.INSTANCE:new j(k,R)}constructor(k,R){this.c=k,this.d=R,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:W(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=S.get(this.c);return typeof k=="boolean"?k?t.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Si=j;function F(q,k){if(typeof q=="string"){const R=parseFloat(q);isNaN(R)||(q=R)}return typeof q=="string"||typeof q=="number"?k(q):t.INSTANCE}class T{static create(k,R,U=null){return F(R,M=>new T(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Ti=T;class z{static create(k,R,U=null){return F(R,M=>new z(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ui=z;class B{static create(k,R,U=null){return F(R,M=>new B(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vi=B;class _{static create(k,R,U=null){return F(R,M=>new _(k,M,U))}constructor(k,R,U){this.c=k,this.d=R,this.f=U,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Wi=_;class J{static create(k,R){return new J(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const R=this.f?this.f.source:"",U=k.f?k.f.source:"";return R<U?-1:R>U?1:0}equals(k){if(k.type===this.type){const R=this.f?this.f.source:"",U=k.f?k.f.source:"";return this.d===k.d&&R===U}return!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.d);return this.f?this.f.test(R):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Xi=J;class Q{static create(k){return new Q(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new Q(this.c.map(k))}negate(){return this.c}}e.$Yi=Q;function H(q){let k=null;for(let R=0,U=q.length;R<U;R++){const M=q[R].substituteConstants();if(q[R]!==M&&k===null){k=[];for(let K=0;K<R;K++)k[K]=q[K]}k!==null&&(k[R]=M)}return k===null?q:k}class x{static create(k,R,U){return x.d(k,R,U)}constructor(k,R){this.expr=k,this.c=R,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,U=this.expr.length;R<U;R++){const M=s(this.expr[R],k.expr[R]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=H(this.expr);return k===this.expr?this:x.create(k,this.c,!1)}evaluate(k){for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].evaluate(k))return!1;return!0}static d(k,R,U){const M=[];let K=!1;for(const Y of k)if(Y){if(Y.type===1){K=!0;continue}if(Y.type===0)return t.INSTANCE;if(Y.type===6){M.push(...Y.expr);continue}M.push(Y)}if(M.length===0&&K)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(s);for(let Y=1;Y<M.length;Y++)M[Y-1].equals(M[Y])&&(M.splice(Y,1),Y--);if(M.length===1)return M[0];for(;M.length>1;){const Y=M[M.length-1];if(Y.type!==9)break;M.pop();const se=M.pop(),le=M.length===0,ue=G.create(Y.expr.map(he=>x.create([he,se],null,U)),null,le);ue&&(M.push(ue),M.sort(s))}if(M.length===1)return M[0];if(U){for(let Y=0;Y<M.length;Y++)for(let se=Y+1;se<M.length;se++)if(M[Y].negate().equals(M[se]))return t.INSTANCE;if(M.length===1)return M[0]}return new x(M,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new x(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());this.c=G.create(k,this,!0)}return this.c}}e.$Zi=x;class G{static create(k,R,U){return G.d(k,R,U)}constructor(k,R){this.expr=k,this.c=R,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,U=this.expr.length;R<U;R++){const M=s(this.expr[R],k.expr[R]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=H(this.expr);return k===this.expr?this:G.create(k,this.c,!1)}evaluate(k){for(let R=0,U=this.expr.length;R<U;R++)if(this.expr[R].evaluate(k))return!0;return!1}static d(k,R,U){let M=[],K=!1;if(k){for(let Y=0,se=k.length;Y<se;Y++){const le=k[Y];if(le){if(le.type===0){K=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){M=M.concat(le.expr);continue}M.push(le)}}if(M.length===0&&K)return t.INSTANCE;M.sort(s)}if(M.length!==0){if(M.length===1)return M[0];for(let Y=1;Y<M.length;Y++)M[Y-1].equals(M[Y])&&(M.splice(Y,1),Y--);if(M.length===1)return M[0];if(U){for(let Y=0;Y<M.length;Y++)for(let se=Y+1;se<M.length;se++)if(M[Y].negate().equals(M[se]))return r.INSTANCE;if(M.length===1)return M[0]}return new G(M,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new G(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());for(;k.length>1;){const R=k.shift(),U=k.shift(),M=[];for(const K of X(R))for(const Y of X(U))M.push(x.create([K,Y],null,!1));k.unshift(G.create(M,null,!1))}this.c=G.create(k,this,!0)}return this.c}}e.$1i=G;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(k,R,U){super(k,null),this.f=R,typeof U=="object"?V.d.push({...U,key:k}):U!==!0&&V.d.push({key:k,description:U,type:R!=null?typeof R:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return v.create(this.key,k)}notEqualsTo(k){return p.create(this.key,k)}}e.$2i=V,e.$3i=(0,L.$Bh)("contextKeyService");function W(q,k){return q<k?-1:q>k?1:0}function ee(q,k,R,U){return q<R?-1:q>R?1:k<U?-1:k>U?1:0}function ne(q,k){if(q.type===0||k.type===1)return!0;if(q.type===9)return k.type===9?re(q.expr,k.expr):!1;if(k.type===9){for(const R of k.expr)if(ne(q,R))return!0;return!1}if(q.type===6){if(k.type===6)return re(k.expr,q.expr);for(const R of q.expr)if(ne(R,k))return!0;return!1}return q.equals(k)}e.$4i=ne;function re(q,k){let R=0,U=0;for(;R<q.length&&U<k.length;){const M=q[R].cmp(k[U]);if(M<0)return!1;M===0&&R++,U++}return R===q.length}function X(q){return q.type===9?q.expr:[q]}}),define(oe[95],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.ID=void 0,e.ID="diagnosticsService",e.$gm=(0,O.$Bh)(e.ID);function N(L){return!!L.hostName&&!!L.errorMessage}e.$hm=N;class A{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$im=A}),define(oe[96],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=void 0,e.$Dn=(0,O.$Bh)("downloadService")}),define(oe[15],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,O.$Bh)("environmentService"),e.$Jh=(0,O.$Ch)(e.$Ih)}),define(oe[29],ae([0,1,153,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function A(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=A;function L(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=L;function D(o,$){switch(o){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=D;function I(o,$){return $==="web"&&!o.includes("web")}e.$Vn=I;function S(o,$,y){return I($,y)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===y?!0:m(y).includes(o)}e.$Wn=S;function m(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=m;function P(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Yn=P;var E;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var g;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var f;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$Zn=(0,N.$Bh)("extensionGalleryService");var w;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var d;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class h extends Error{constructor($,y){super($),this.code=y,this.name=y}}e.$1n=h,e.$2n=(0,N.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,N.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,N.$Bh)("IExtensionTipsService"),e.$7n=(0,O.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,O.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,11,92,29]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=void 0;function S(d,h){return d?L.URI.revive(h?h.transformIncoming(d):d):void 0}function m(d,h){return h?h.transformOutgoingURI(d):d}function P(d,h){h=h||D.$Cm;const o=d.manifest;return{...(0,D.$Fm)({...d,manifest:void 0},h),manifest:o}}function E(d,h){return d?.profileLocation?(0,D.$Fm)(d,h??D.$Cm):d}function g(d,h){return h?(0,A.$Xm)(d,o=>o instanceof L.URI?h.transformOutgoingURI(o):void 0):d}class l{constructor(h,o){this.a=h,this.b=o,this.onInstallExtension=O.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,o){const $=this.b(h);switch(o){case"onInstallExtension":return O.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?m(y.profileLocation,$):y.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,y=>y.map(C=>({...C,local:C.local?g(C.local,$):C.local,profileLocation:C.profileLocation?m(C.profileLocation,$):C.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?m(y.profileLocation,$):y.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?m(y.profileLocation,$):y.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,y=>g(y,$))}throw new Error("Invalid listen")}async call(h,o,$){const y=this.b(h);switch(o){case"zip":{const C=P($[0],y),i=await this.a.zip(C);return m(i,y)}case"unzip":return this.a.unzip(S($[0],y));case"install":return this.a.install(S($[0],y),E($[1],y));case"installFromLocation":return this.a.installFromLocation(S($[0],y),S($[1],y));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile($[0],S($[1],y),S($[2],y));case"getManifest":return this.a.getManifest(S($[0],y));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall($[0]);case"installFromGallery":return this.a.installFromGallery($[0],E($[1],y));case"installGalleryExtensions":{const C=$[0];return this.a.installGalleryExtensions(C.map(({extension:i,options:c})=>({extension:i,options:E(c,y)??{}})))}case"uninstall":return this.a.uninstall(P($[0],y),E($[1],y));case"reinstallFromGallery":return this.a.reinstallFromGallery(P($[0],y));case"getInstalled":return(await this.a.getInstalled($[0],S($[1],y))).map(i=>g(i,y));case"toggleAppliationScope":{const C=await this.a.toggleAppliationScope(P($[0],y),S($[1],y));return g(C,y)}case"copyExtensions":return this.a.copyExtensions(S($[0],y),S($[1],y));case"updateMetadata":{const C=await this.a.updateMetadata(P($[0],y),$[1],S($[2],y));return g(C,y)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download($[0],$[1],$[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$0o=l;class f extends N.$kc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new O.$fd),this.f=this.B(new O.$fd),this.g=this.B(new O.$fd),this.h=this.B(new O.$fd),this.j=this.B(new O.$fd),this.B(this.m.listen("onInstallExtension")(o=>this.n(this.c,{...o,source:this.r(o.source)?L.URI.revive(o.source):o.source,profileLocation:L.URI.revive(o.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(o=>this.n(this.f,o.map($=>({...$,local:$.local?P($.local,null):$.local,source:this.r($.source)?L.URI.revive($.source):$.source,profileLocation:L.URI.revive($.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(o=>this.n(this.g,{...o,profileLocation:L.URI.revive(o.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(o=>this.n(this.h,{...o,profileLocation:L.URI.revive(o.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(o=>this.j.fire(P(o,null))))}n(h,o){h.fire(o)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const o=await this.getTargetPlatform();return h.allTargetPlatforms.some($=>(0,I.$Wn)($,h.allTargetPlatforms,o))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(o=>L.URI.revive(o)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,o){return Promise.resolve(this.m.call("install",[h,o])).then($=>P($,null))}installFromLocation(h,o){return Promise.resolve(this.m.call("installFromLocation",[h,o])).then($=>P($,null))}async installExtensionsFromProfile(h,o,$){return(await this.m.call("installExtensionsFromProfile",[h,o,$])).map(C=>P(C,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,o){return Promise.resolve(this.m.call("installFromGallery",[h,o])).then($=>P($,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map($=>({...$,local:$.local?P($.local,null):$.local,source:this.r($.source)?L.URI.revive($.source):$.source,profileLocation:L.URI.revive($.profileLocation)}))}uninstall(h,o){return Promise.resolve(this.m.call("uninstall",[h,o]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(o=>P(o,null))}getInstalled(h=null,o){return Promise.resolve(this.m.call("getInstalled",[h,o])).then($=>$.map(y=>P(y,null)))}updateMetadata(h,o,$){return Promise.resolve(this.m.call("updateMetadata",[h,o,$])).then(y=>P(y,null))}toggleAppliationScope(h,o){return this.m.call("toggleAppliationScope",[h,o]).then($=>P($,null))}copyExtensions(h,o){return this.m.call("copyExtensions",[h,o])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,o,$){const y=await this.m.call("download",[h,o,$]);return L.URI.revive(y)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$$o=f;class w{constructor(h){this.a=h}listen(h,o){throw new Error("Invalid listen")}call(h,o,$){switch(o){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive($[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$_o=w}),define(oe[97],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=void 0,e.$7o=(0,O.$Bh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((L,D)=>te(["node-vsce-sign"],async I=>L(I),D))),this.a}async verify(L,D,I){let S;try{S=await this.b()}catch{return!1}return S.verify(L,D,I)}}e.$8o=N}),define(oe[98],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NUb=e.RecommendationsNotificationResult=e.$MUb=e.RecommendationSource=void 0;var N;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function A(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$MUb=A;var L;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$NUb=(0,O.$Bh)("IExtensionRecommendationNotificationService")}),define(oe[12],ae([0,1,47,16,27,9,11,160,4,6,23]),function(te,e,O,N,A,L,D,I,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,S.$Bh)("fileService");function E(W){return W.create===!0}e.$7j=E;var g;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var l;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var f;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function w(W){return!!(W.capabilities&2)}e.$8j=w;function d(W){return!!(W.capabilities&8)}e.$9j=d;function h(W){return!!(W.capabilities&131072)}e.$0j=h;function o(W){return!!(W.capabilities&4)}e.$$j=o;function $(W){return!!(W.capabilities&16)}e.$_j=$;function y(W){return w(W)?!!(W.capabilities&16384):!1}e.$ak=y;function C(W){return w(W)?!!(W.capabilities&32768):!1}e.$bk=C;function i(W){return!!(W.capabilities&65536)}e.$ck=i;function c(W){return!!(W.capabilities&2048)}e.$dk=c;var n;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ee,ne){const re=new s(ee.toString(),ne);return a(re,ne),re}constructor(ee,ne){super(ee),this.code=ne}}e.$ek=s;function t(W,ee){return s.create(W,ee)}e.$fk=t;function r(W){return W||t((0,I.localize)(0,null),n.Unknown)}e.$gk=r;function a(W,ee){return W.name=ee?`${ee} (FileSystemError)`:"FileSystemError",W}e.$hk=a;function v(W){if(!W)return n.Unknown;if(W instanceof s)return W.code;const ee=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ik=v;function b(W){if(W instanceof z)return W.fileOperationResult;switch(v(W)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$jk=b;var u;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class p{constructor(ee,ne,re){this.resource=ee,this.operation=ne,this.target=re}isOperation(ee){return this.operation===ee}}e.$kk=p;var j;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const X of ee){const q=re.get(X.type);switch(q?q.push([X.resource,X]):re.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,q]of re)switch(X){case 1:this.a=O.$Hh.forUris(()=>ne),this.a.fill(q);break;case 0:this.b=O.$Hh.forUris(()=>ne),this.b.fill(q);break;case 2:this.c=O.$Hh.forUris(()=>ne),this.c.fill(q);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...re){if(!ee)return!1;const X=re.length>0;return!!((!X||re.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!X||re.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!X||re.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=F;function T(W,ee,ne){return!W||!ee||W===ee||ee.length>W.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,A.$Ne)(W,ee):W.indexOf(ee)===0)}e.$mk=T;class z extends Error{constructor(ee,ne,re){super(ee),this.fileOperationResult=ne,this.options=re}}e.$nk=z;class B extends z{constructor(ee,ne,re,X){super(ee,ne,X),this.fileOperationResult=ne,this.size=re}}e.$ok=B;class _ extends z{constructor(ee,ne,re){super(ee,2,re),this.stat=ne}}e.$pk=_;var J;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var Q;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$xk="";function H(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.$yk=H;async function x(W,ee){if(!ee.hasProvider(D.URI.from({scheme:W.scheme})))return new Promise(ne=>{const re=ee.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===W.scheme&&X.added&&(re.dispose(),ne())})})}e.$zk=x;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(ee){return(0,L.$nf)(ee)||(ee=0),ee<G.KB?(0,I.localize)(1,null,ee.toFixed(0)):ee<G.MB?(0,I.localize)(2,null,(ee/G.KB).toFixed(2)):ee<G.GB?(0,I.localize)(3,null,(ee/G.MB).toFixed(2)):ee<G.TB?(0,I.localize)(4,null,(ee/G.GB).toFixed(2)):(0,I.localize)(5,null,(ee/G.TB).toFixed(2))}}e.$Ak=G;function V(W){const ee=typeof W=="string"||W?.scheme===P.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===P.Schemas.file?1024*G.MB:ee?10*G.MB:m.$o?50*G.MB:1024*G.MB}e.$Bk=V});var Z=this&&this.__param||function(te,e){return function(O,N){e(O,N,te)}};define(oe[189],ae([0,1,69,42,12]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;let L=class{constructor(I){this.a=I}async checksum(I){const S=(await this.a.readFileStream(I)).value;return new Promise((m,P)=>{const E=(0,O.createHash)("md5");(0,N.$xd)(S,{onData:g=>E.update(g.buffer),onError:g=>P(g),onEnd:()=>m(E.digest("base64").replace(/=+$/,""))})})}};e.$L7b=L,e.$L7b=L=ye([Z(0,A.$6j)],L)}),define(oe[190],ae([0,1,14,38,8,3,2,42,11,32,12]),function(te,e,O,N,A,L,D,I,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M="localFilesystem";class E extends D.$kc{constructor(l,f){super(),this.a=l,this.b=f,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$fd),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$fd),this.onDidWatchError=this.g.event,this.h=(0,m.$4f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,f){const{buffer:w}=await this.a.call("readFile",[l,f]);return w}readFileStream(l,f,w){const d=(0,I.$td)(o=>O.$Fd.concat(o.map($=>O.$Fd.wrap($))).buffer),h=new D.$jc;return h.add(this.a.listen("readFileStream",[l,f])(o=>{if(o instanceof O.$Fd)d.write(o.buffer);else{if(o==="end")d.end();else{let $;if(o instanceof Error)$=o;else{const y=o;$=(0,P.$fk)(y.message??(0,N.$mi)(y),y.code??P.FileSystemProviderErrorCode.Unknown)}d.error($),d.end()}h.dispose()}})),h.add(w.onCancellationRequested(()=>{d.error((0,A.$4)()),d.end(),h.dispose()})),d}writeFile(l,f,w){return this.a.call("writeFile",[l,O.$Fd.wrap(f),w])}open(l,f){return this.a.call("open",[l,f])}close(l){return this.a.call("close",[l])}async read(l,f,w,d,h){const[o,$]=await this.a.call("read",[l,f,h]);return w.set(o.buffer.slice(0,$),d),$}write(l,f,w,d,h){return this.a.call("write",[l,f,O.$Fd.wrap(w),d,h])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,f){return this.a.call("delete",[l,f])}rename(l,f,w){return this.a.call("rename",[l,f,w])}copy(l,f,w){return this.a.call("copy",[l,f,w])}cloneFile(l,f){return this.a.call("cloneFile",[l,f])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const f=l;this.f.fire(f.map(w=>({resource:S.URI.revive(w.resource),type:w.type})))}else{const f=l;this.g.fire(f)}}))}watch(l,f){const w=(0,m.$4f)();return this.a.call("watch",[this.h,w,l,f]),(0,D.$ic)(()=>this.a.call("unwatch",[this.h,w]))}}e.$8M=E}),define(oe[99],ae([0,1,14,8,161,12]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function D(P,E,g,l,f,w){let d;try{await I(P,E,g,l,f,w)}catch(h){d=h}finally{d&&f.errorTransformer&&(d=f.errorTransformer(d)),typeof d<"u"&&g.error(d),g.end()}}e.$Cp=D;async function I(P,E,g,l,f,w){S(w);const d=await P.open(E,{create:!1});try{S(w);let h=0,o=0,$=f&&typeof f.length=="number"?f.length:void 0,y=O.$Fd.alloc(Math.min(f.bufferSize,typeof $=="number"?$:f.bufferSize)),C=f&&typeof f.position=="number"?f.position:0,i=0;do o=await P.read(d,C,y.buffer,i,y.byteLength-i),C+=o,i+=o,h+=o,typeof $=="number"&&($-=o),i===y.byteLength&&(await g.write(l(y)),y=O.$Fd.alloc(Math.min(f.bufferSize,typeof $=="number"?$:f.bufferSize)),i=0);while(o>0&&(typeof $!="number"||$>0)&&S(w)&&m(h,f));if(i>0){let c=i;typeof $=="number"&&(c=Math.min(i,$)),g.write(l(y.slice(0,c)))}}catch(h){throw(0,L.$gk)(h)}finally{await P.close(d)}}function S(P){if(P.isCancellationRequested)throw(0,N.$4)();return!0}function m(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,L.$fk)((0,A.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,91,2,16,6,11,12]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function S(h){return h.recursive===!0}e.$Ep=S;class m extends N.$kc{static{this.a=5}constructor(o,$,y,C){super(),this.h=o,this.j=$,this.m=y,this.n=C,this.c=this.B(new N.$lc),this.f=void 0,this.g=0}s(){const o=new N.$jc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile($=>this.h($))),o.add(this.b.onDidLogMessage($=>this.j($))),o.add(this.b.onDidError($=>this.t($)))}t(o){this.n.restartOnError?this.g<m.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=m;class P extends m{constructor(o,$,y){super(o,$,y,{type:"node.js",restartOnError:!1})}}e.$Gp=P;class E extends m{constructor(o,$,y){super(o,$,y,{type:"universal",restartOnError:!0})}}e.$Hp=E;function g(h){return h.map(o=>({type:o.type,resource:D.URI.file(o.path)}))}e.$Ip=g;function l(h){const o=new d;for(const $ of h)o.processEvent($);return o.coalesce()}e.$Jp=l;function f(h,o){return typeof o=="string"&&!o.startsWith(O.$nj)&&!(0,A.$8d)(o)?{base:h,pattern:o}:o}e.$Kp=f;function w(h,o){const $=[];for(const y of o)$.push((0,O.$rj)(f(h,y)));return $}e.$Lp=w;class d{constructor(){this.a=new Set,this.b=new Map}c(o){return L.$k?o.path:o.path.toLowerCase()}processEvent(o){const $=this.b.get(this.c(o));let y=!1;if($){const C=$.type,i=o.type;$.path!==o.path&&(o.type===2||o.type===1)?y=!0:C===1&&i===2?(this.b.delete(this.c(o)),this.a.delete($)):C===2&&i===1?$.type=0:C===1&&i===0||($.type=i)}else y=!0;y&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],$=[];return Array.from(this.a).filter(y=>y.type!==2?(o.push(y),!1):!0).sort((y,C)=>y.path.length-C.path.length).filter(y=>$.some(C=>(0,I.$mk)(y.path,C,!L.$k))?!1:($.push(y.path),!0)).concat(o)}}}),define(oe[191],ae([0,1,52,5,26,48,2,88,16,6,144,31,54]),function(te,e,O,N,A,L,D,I,S,m,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class l extends D.$kc{static{this.a=100}static{this.b=75}constructor(d,h,o,$){super(),this.m=d,this.n=h,this.r=o,this.s=$,this.c=this.B(new N.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.n(y))),this.f=this.B(new N.$Ug(y=>this.z(y),l.b)),this.g=(0,g.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$Lp)(this.m.path,this.m.includes):void 0,this.j=new A.$pd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await E.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await E.Promises.realpath(d.path),d.path===h&&(h=await(0,P.$Vp)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(m.$j&&(0,L.$If)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$kc.None;const o=new A.$pd(this.j.token),$=new D.$jc;try{const y=(0,S.$ae)(d),C=(0,O.watch)(d);$.add((0,D.$ic)(()=>{C.removeAllListeners(),C.close()})),this.G(`Started watching: '${d}'`);const i=new Set;if(h)try{for(const n of await E.Promises.readdir(d))i.add(n)}catch(n){this.D(n)}const c=new Map;$.add((0,D.$ic)(()=>{for(const[,n]of c)n.dispose();c.clear()})),C.on("error",(n,s)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),C.on("change",(n,s)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${n}"] ${s}`);let t="";if(s&&(t=s.toString(),m.$j&&(t=(0,I.$hl)(t))),!(!t||n!=="change"&&n!=="rename"))if(h)if(n==="rename"){c.get(t)?.dispose();const r=setTimeout(async()=>{if(c.delete(t),t===y&&!await E.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.C((0,S.$9d)(d,t));if(o.token.isCancellationRequested)return;let v;a?i.has(t)?v=0:(v=1,i.add(t)):(i.delete(t),v=2),this.y({path:(0,S.$9d)(this.m.path,t),type:v})},l.a);c.set(t,(0,D.$ic)(()=>clearTimeout(r)))}else{let r;i.has(t)?r=0:(r=1,i.add(t)),this.y({path:(0,S.$9d)(this.m.path,t),type:r})}else if(n==="rename"||t!==y){const r=setTimeout(async()=>{const a=await E.Promises.exists(d);o.token.isCancellationRequested||(a?(this.y({path:this.m.path,type:0},!0),$.add(await this.w(d,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},l.a);$.clear(),$.add((0,D.$ic)(()=>clearTimeout(r)))}else this.y({path:this.m.path,type:0},!0)})}catch(y){await E.Promises.exists(d)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${y.toString()})`)}return(0,D.$ic)(()=>{o.dispose(!0),$.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!h&&this.g.some(o=>o(d.path))?this.s&&this.G(` >> ignored (excluded) ${d.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(o=>o(d.path))?this.s&&this.G(` >> ignored (not included) ${d.path}`):this.f.work(d))}z(d){const h=(0,g.$Jp)(d);if(h.length>0){if(this.s)for(const $ of h)this.G(`>> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.path}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(m.$k)return E.Promises.exists(d);try{const h=(0,S.$ae)(d);return(await E.Promises.readdir((0,S.$_d)(d))).some($=>$===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=l;async function f(w,d,h,o,$=512){const y=await E.Promises.open(w,"r"),C=Buffer.allocUnsafe($),i=new A.$pd(o);let c,n=!1;const s={path:w,excludes:[],recursive:!1},t=new l(s,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:v}=await E.Promises.read(y,C,0,$,null);if(!v||i.token.isCancellationRequested)break;d(C.slice(0,v))}}catch(v){c=new Error(v),i.dispose(!0)}finally{n=!1}}})()});return await t.ready,h(),new Promise((r,a)=>{i.token.onCancellationRequested(async()=>{t.dispose();try{await E.Promises.close(y)}catch(v){c=new Error(v)}c?a(c):r()})})}e.$Zp=f}),define(oe[192],ae([0,1,3,91,2,6,191]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class I extends A.$kc{constructor(){super(...arguments),this.a=this.B(new O.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$fd),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(m){const P=this.j(m),E=P.filter(l=>{const f=this.c.get(l.path);return f?!(0,N.$vj)(f.request.excludes,l.excludes)||!(0,N.$vj)(f.request.includes,l.includes):!0}),g=Array.from(this.c.values()).filter(({request:l})=>!P.find(f=>f.path===l.path&&(0,N.$vj)(f.excludes,l.excludes)&&(0,N.$vj)(f.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const l of g)this.h(l);for(const l of E)this.g(l)}g(m){const P=new D.$Yp(m,g=>this.a.fire(g),g=>this.b.fire(g),this.f),E={request:m,instance:P};this.c.set(m.path,E)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const P=this.c.get(m);P&&(this.c.delete(m),P.instance.dispose())}j(m){const P=new Map;for(const E of m){const g=L.$k?E.path:E.path.toLowerCase();P.set(g,E)}return Array.from(P.values())}async setVerboseLogging(m){this.f=m;for(const[,P]of this.c)P.instance.setVerboseLogging(m)}m(m){this.f&&this.b.fire({type:"trace",message:this.n(m)})}n(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$1p=I}),define(oe[193],ae([0,1,54,192]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class A extends O.$Gp{constructor(D,I,S){super(D,I,S),this.s()}r(D){return D.add(new N.$1p)}}e.$2p=A}),define(oe[194],ae([0,1,23,43,93,54]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class D extends L.$Hp{constructor(S,m,P){super(S,m,P),this.s()}r(S){const m=S.add(new A.$Sp(O.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(m.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$ih)(m.getChannel("watcher")))}}e.$Tp=D}),define(oe[70],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class O{constructor(...A){this.a=new Map;for(const[L,D]of A)this.set(L,D)}set(A,L){const D=this.a.get(A);return this.a.set(A,L),D}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$zh=O}),define(oe[195],ae([0,1,5,8,2,68,186,4,70,87]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const P=!1;class E extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class g{constructor(d=new S.$zh,h=!1,o,$=P){this.f=d,this.g=h,this.h=o,this.i=$,this.o=new Set,this.f.set(I.$Ah,this),this._globalGraph=$?o?._globalGraph??new D.$5p(y=>y):void 0}createChild(d){return new g(d,this.g,this,this.i)}invokeFunction(d,...h){const o=f.traceInvocation(this.i,d);let $=!1;try{return d({get:C=>{if($)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const i=this.m(C,o);if(!i)throw new Error(`[invokeFunction] unknown service '${C}'`);return i}},...h)}finally{$=!0,o.stop()}}createInstance(d,...h){let o,$;return d instanceof L.$yh?(o=f.traceCreation(this.i,d.ctor),$=this.j(d.ctor,d.staticArguments.concat(h),o)):(o=f.traceCreation(this.i,d),$=this.j(d,h,o)),o.stop(),$}j(d,h=[],o){const $=I._util.getServiceDependencies(d).sort((i,c)=>i.index-c.index),y=[];for(const i of $){const c=this.m(i.id,o);c||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(c)}const C=$.length>0?$[0].index:h.length;if(h.length!==C){console.trace(`[createInstance] First service dependency of ${d.name} at position ${C+1} conflicts with ${h.length} static arguments`);const i=C-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,C)}return Reflect.construct(d,h.concat(y))}k(d,h){if(this.f.get(d)instanceof L.$yh)this.f.set(d,h);else if(this.h)this.h.k(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const h=this.f.get(d);return!h&&this.h?this.h.l(d):h}m(d,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const o=this.l(d);return o instanceof L.$yh?this.q(d,o,h.branch(d,!0)):(h.branch(d,!1),o)}q(d,h,o){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,h,o)}finally{this.o.delete(d)}}r(d,h,o){const $=new D.$5p(i=>i.id.toString());let y=0;const C=[{id:d,desc:h,_trace:o}];for(;C.length;){const i=C.pop();if($.lookupOrInsertNode(i),y++>1e3)throw new E($);for(const c of I._util.getServiceDependencies(i.desc.ctor)){const n=this.l(c.id);if(n||this.u(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(c.id)),n instanceof L.$yh){const s={id:c.id,desc:n,_trace:i._trace.branch(c.id,!0)};$.insertEdge(i,s),C.push(s)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new E($);break}for(const{data:c}of i){if(this.l(c.id)instanceof L.$yh){const s=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,s)}$.removeNode(c)}}return this.l(d)}s(d,h,o=[],$,y){if(this.f.get(d)instanceof L.$yh)return this.t(d,h,o,$,y);if(this.h)return this.h.s(d,h,o,$,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(d,h,o=[],$,y){if($){const C=new g(void 0,this.g,this,this.i);C.c=String(d);const i=new Map,c=new O.$Xg(()=>{const n=C.j(h,o,y);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)r.apply(n,a)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!c.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new m.$tc,i.set(s,a)),(b,u,p)=>{const j=a.push([b,u,p]);return(0,A.$ic)(j)}}if(s in n)return n[s];const t=c.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return c.value[s]=t,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,o,y)}u(d,h){if(h&&console.warn(d),this.g)throw new Error(d)}}e.$6p=g;var l;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(l||(l={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,h){return d?new f(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(d,h){return d?new f(1,h.name):f.c}static{this.f=0}constructor(d,h){this.type=d,this.name=h,this.g=Date.now(),this.h=[]}branch(d,h){const o=new f(3,d.toString());return this.h.push([d,h,o]),o}stop(){const d=Date.now()-this.g;f.f+=d;let h=!1;function o(y,C){const i=[],c=new Array(y+1).join("	");for(const[n,s,t]of C.h)if(s&&t){h=!0,i.push(`${c}CREATES -> ${n}`);const r=o(y+1,t);r&&i.push(r)}else i.push(`${c}uses -> ${n}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${o(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(d>2||h)&&f.all.add($.join(`
`))}}e.$7p=f}),define(oe[71],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=e.$i7b=void 0,e.$i7b=(0,O.$Bh)("mainProcessService");class N{constructor(L,D){this.a=L,this.b=D}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,D){this.a.registerChannel(L,D)}}e.$j7b=N}),define(oe[72],ae([0,1,26,2,6,163,29,4]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=void 0;function S(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Hq=S,e.$Iq=(0,I.$Bh)("languagePackService");let m=class extends N.$kc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new O.$pd;setTimeout(()=>E.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const f=g.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(d=>d.startsWith("lp-"))).map(w=>{const d=w.properties.localizedLanguages?.[0],h=S(w);return{...this.f(h,d,w),extensionId:w.identifier.id,galleryExtension:w}});return f.push(this.f("en","English")),f}f(E,g,l){const f=g??E;let w;if(f!==E&&(w=`(${E})`),E.toLowerCase()===A.$v.toLowerCase()&&(w??="",w+=(0,L.localize)(0,null)),l?.installCount){w??="";const d=l.installCount;let h;d>1e6?h=`${Math.floor(d/1e5)/10}M`:d>1e3?h=`${Math.floor(d/1e3)}K`:h=String(d),w+=` $(cloud-download) ${h}`}return{id:E,label:f,description:w}}};e.$Jq=m,e.$Jq=m=ye([Z(0,D.$Zn)],m)}),define(oe[196],ae([0,1,2,72]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;let A=class extends O.$kc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$H7b=A,e.$H7b=A=ye([Z(0,N.$Iq)],A)}),define(oe[7],ae([0,1,38,3,51,2,35,6,21,9,11,94,4]),function(te,e,O,N,A,L,D,I,S,m,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,g.$Bh)("logService"),e.$6i=(0,g.$Bh)("loggerService");function l(){return new Date().toISOString()}function f(b){return(0,m.$nf)(b)}e.$7i=f;var w;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8i=w.Info;function d(b,u,p){switch(u){case w.Trace:b.trace(p);break;case w.Debug:b.debug(p);break;case w.Info:b.info(p);break;case w.Warning:b.warn(p);break;case w.Error:b.error(p);break;case w.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=d;function h(b,u=!1){let p="";for(let j=0;j<b.length;j++){let F=b[j];if(F instanceof Error&&(F=(0,O.$mi)(F,u)),typeof F=="object")try{F=JSON.stringify(F)}catch{}p+=(j>0?" ":"")+F}return p}class o extends L.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new N.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==w.Off&&this.b<=u}}e.$0i=o;class $ extends o{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(w.Trace)&&this.g(w.Trace,h([u,...p],!0))}debug(u,...p){this.f(w.Debug)&&this.g(w.Debug,h([u,...p]))}info(u,...p){this.f(w.Info)&&this.g(w.Info,h([u,...p]))}warn(u,...p){this.f(w.Warning)&&this.g(w.Warning,h([u,...p]))}error(u,...p){if(this.f(w.Error))if(u instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=u.stack,this.g(w.Error,h(j))}else this.g(w.Error,h([u,...p]))}flush(){}}e.$$i=$;class y extends o{constructor(u=e.$8i){super(),this.setLevel(u),this.g=!I.$i}trace(u,...p){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}debug(u,...p){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}info(u,...p){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}warn(u,...p){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,u,...p):console.warn(`[main ${l()}]`,u,...p))}error(u,...p){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,u,...p):console.error(`[main ${l()}]`,u,...p))}dispose(){}flush(){}}e.$_i=y;class C extends o{constructor(u=e.$8i,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}dispose(){}flush(){}}e.$aj=C;class i extends o{constructor(u,p=e.$8i){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(u),...p])}debug(u,...p){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(u),...p])}info(u,...p){this.f(w.Info)&&this.g.log(w.Info,[this.h(u),...p])}warn(u,...p){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(u),...p])}error(u,...p){this.f(w.Error)&&this.g.log(w.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,O.$mi)(u,this.f(w.Trace))}dispose(){}flush(){}}e.$bj=i;class c extends o{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const j of this.g)j.trace(u,...p)}debug(u,...p){for(const j of this.g)j.debug(u,...p)}info(u,...p){for(const j of this.g)j.info(u,...p)}warn(u,...p){for(const j of this.g)j.warn(u,...p)}error(u,...p){for(const j of this.g)j.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$cj=c;class n extends L.$kc{constructor(u,p,j){if(super(),this.h=u,this.j=p,this.b=new D.$zi,this.c=this.B(new N.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$fd),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}m(u){return(0,m.$jf)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const j=this.n(u),F=(0,m.$jf)(u)?u:p?.id??(0,A.$pi)(j.toString()).toString(16);let T=this.b.get(j)?.logger;const z=p?.logLevel==="always"?w.Trace:p?.logLevel;T||(T=this.s(j,z??this.getLogLevel(j)??this.h,{...p,id:F}));const B={logger:T,info:{resource:j,id:F,logLevel:z,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(B.info),this.b.set(j,B),T}n(u){return(0,m.$jf)(u)?(0,S.$ig)(this.j,`${u}.log`):u}setLogLevel(u,p){if(P.URI.isUri(u)){const j=u,F=p,T=this.b.get(j);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([j,F]))}else{this.h=u;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const j=this.m(u);j&&p!==!j.info.hidden&&(j.info.hidden=!p,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=n;class s{constructor(){this.onDidChangeLogLevel=new N.$fd().event}setLevel(u){}getLevel(){return w.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$ej=s;class t extends s{}e.$fj=t;function r(b){if(b.verbose)return w.Trace;if(typeof b.logLevel=="string"){const u=v(b.logLevel.toLowerCase());if(u!==void 0)return u}return e.$8i}e.$gj=r;function a(b){switch(b){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$hj=a;function v(b){switch(b){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$ij=v,e.$jj=new E.$2i("logLevel",a(w.Info))}),define(oe[197],ae([0,1,5,8,2,23,16,21,31,15,7]),function(te,e,O,N,A,L,D,I,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;let E=class extends A.$kc{constructor(l,f){super(),this.a=l,this.b=f,this.B(new O.$Sg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,I.$fg)(this.a.logsHome),f=(0,I.$hg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,h=(await S.Promises.readdir(f)).filter($=>/^\d{8}T\d{6}$/.test($)).sort().filter($=>$!==l),o=h.slice(0,Math.max(0,h.length-9));o.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${o.join(", ")}'`),await Promise.all(o.map($=>S.Promises.rm((0,D.$9d)(f,$)))))}catch(l){(0,N.$Y)(l)}}};e.$I7b=E,e.$I7b=E=ye([Z(0,m.$Ih),Z(1,P.$5i)],E)}),define(oe[198],ae([0,1,18,5,8,3,2,16,54,7]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class P extends D.$kc{constructor(g,l){super(),this.a=g,this.b=l,this.c=this.B(new L.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Eg(0)),this.w=[],this.y=this.B(new N.$Eg(0))}watch(g,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(g,l):this.z(g,l)}n(g,l){const f={path:this.H(g),excludes:l.excludes,includes:l.includes,recursive:l.recursive},w=(0,O.$Sb)(this.j,f);return this.r(),(0,D.$ic)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,A.$Y)(g))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,S.$Ip)(l)),l=>this.G(l),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const l of this.j)(0,S.$Ep)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const l of this.j)(0,S.$Ep)(l)&&g.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,l){const f={path:this.H(g),excludes:l.excludes,includes:l.includes,recursive:!1},w=(0,O.$Sb)(this.w,f);return this.C(),(0,D.$ic)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,A.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,S.$Ip)(g)),g=>this.G(g),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,I.$7d)(g.fsPath)}}e.$Mp=P}),define(oe[199],ae([0,1,18,5,14,26,3,51,59,2,47,23,100,21,42,159,12,99,7,8]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let y=class extends m.$kc{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new D.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new D.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$Pg)}registerProvider(i,c){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const n=new m.$jc;return this.h.set(i,c),this.c.fire({added:!0,scheme:i,provider:c}),n.add(c.onDidChangeFile(s=>this.X.fire(new d.$lk(s,!this.S(c))))),typeof c.onDidWatchError=="function"&&n.add(c.onDidWatchError(s=>this.Y.fire(new Error(s)))),n.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:i}))),(0,m.$ic)(()=>{this.c.fire({added:!1,scheme:i,provider:c}),this.h.delete(i),(0,m.$fc)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const c=[];this.f.fire({scheme:i,join(n){c.push(n)}}),!this.h.has(i)&&await N.Promises.settled(c)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,c){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return S.Iterable.map(this.h,([i,c])=>({scheme:i,capabilities:c.capabilities}))}async j(i){if(!(0,l.$mg)(i))throw new d.$nk((0,w.localize)(0,null,this.rb(i)),8);await this.activateProvider(i.scheme);const c=this.h.get(i.scheme);if(!c){const n=new $.$_;throw n.message=(0,w.localize)(1,null,i.toString()),n}return c}async m(i){const c=await this.j(i);if((0,d.$$j)(c)||(0,d.$8j)(c)||(0,d.$_j)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const c=await this.j(i);if((0,d.$$j)(c)||(0,d.$8j)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,c){try{return await this.s(i,c)}catch(n){throw(0,d.$ik)(n)===d.FileSystemProviderErrorCode.FileNotFound?new d.$nk((0,w.localize)(2,null,this.rb(i)),1):(0,d.$gk)(n)}}async s(i,c){const n=await this.j(i),s=this.S(n),t=c?.resolveTo,r=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,v=await n.stat(i);let b;return this.t(n,i,v,void 0,!!a,(u,p)=>(b||(b=P.$Hh.forUris(()=>!s),b.set(i,!0),t&&b.fill(!0,t)),b.get(u.resource)||b.findSuperstr(u.resource.with({query:null,fragment:null}))?!0:u.isDirectory&&r?p===1:!1))}async t(i,c,n,s,t,r){const{providerExtUri:a}=this.R(i),v={resource:c,name:a.basename(c),isFile:(n.type&d.FileType.File)!==0,isDirectory:(n.type&d.FileType.Directory)!==0,isSymbolicLink:(n.type&d.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&d.FilePermission.Readonly)||!!(i.capabilities&2048),locked:!!((n.permissions??0)&d.FilePermission.Locked),etag:(0,d.$yk)({mtime:n.mtime,size:n.size}),children:void 0};if(v.isDirectory&&r(v,s)){try{const b=await i.readdir(c),u=await N.Promises.settled(b.map(async([p,j])=>{try{const F=a.joinPath(c,p),T=t?await i.stat(F):{type:j};return await this.t(i,F,T,b.length,t,r)}catch(F){return this.b.trace(F),null}}));v.children=(0,O.$Fb)(u)}catch(b){this.b.trace(b),v.children=[]}return v}return v}async resolveAll(i){return N.Promises.settled(i.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const c=await this.j(i),n=await c.stat(i);return this.t(c,i,n,void 0,!0,()=>!1)}async exists(i){const c=await this.j(i);try{return!!await c.stat(i)}catch{return!1}}async canCreateFile(i,c){try{await this.u(i,c)}catch(n){return n}return!0}async u(i,c){if(!c?.overwrite&&await this.exists(i))throw new d.$nk((0,w.localize)(3,null,this.rb(i)),3,c)}async createFile(i,c=A.$Fd.fromString(""),n){await this.u(i,n);const s=await this.writeFile(i,c);return this.r.fire(new d.$kk(i,0,s)),s}async writeFile(i,c,n){const s=this.pb(await this.n(i),i),{providerExtUri:t}=this.R(s);try{await this.w(s,i,n)||await this.U(s,t.dirname(i));let a;if((0,d.$8j)(s)&&!(c instanceof A.$Fd))if((0,f.$rd)(c)){const v=await(0,f.$yd)(c,3);v.ended?a=A.$Fd.concat(v.buffer):a=v}else a=(0,f.$vd)(c,v=>A.$Fd.concat(v),3);else a=c;if(!(0,d.$$j)(s)||(0,d.$8j)(s)&&a instanceof A.$Fd)await this.gb(s,i,n,a);else{const v=a instanceof A.$Fd?(0,A.$Qd)(a):a;n?.atomic!==!1&&n?.atomic?.postfix?await this.bb(s,i,(0,l.$ig)((0,l.$hg)(i),`${(0,l.$fg)(i)}${n.atomic.postfix}`),n,v):await this.cb(s,i,n,v)}this.r.fire(new d.$kk(i,4))}catch(r){throw new d.$nk((0,w.localize)(4,null,this.rb(i),(0,d.$gk)(r).toString()),(0,d.$jk)(r),n)}return this.resolve(i,{resolveMetadata:!0})}async w(i,c,n){const s=!!n?.unlock;if(s&&!(i.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(c)));if(!!n?.atomic){if(!(i.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(c)));if(s)throw new Error((0,w.localize)(7,null,this.rb(c)))}let r;try{r=await i.stat(c)}catch{return}if(r.type&d.FileType.Directory)throw new d.$nk((0,w.localize)(8,null,this.rb(c)),0,n);if(this.qb(c,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==d.$xk&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,d.$yk)({mtime:n.mtime,size:r.size}))throw new d.$nk((0,w.localize)(9,null),3,n);return r}async readFile(i,c,n){const s=await this.m(i);return c?.atomic?this.z(s,i,c,n):this.C(s,i,c,n)}async z(i,c,n,s){return new Promise((t,r)=>{this.ab.queueFor(c,this.R(i).providerExtUri).queue(async()=>{try{const a=await this.C(i,c,n,s);t(a)}catch(a){r(a)}})})}async C(i,c,n,s){const t=await this.D(i,c,{...n,preferUnbuffered:!0},s);return{...t,value:await(0,A.$Rd)(t.value)}}async readFileStream(i,c,n){const s=await this.m(i);return this.D(s,i,c,n)}async D(i,c,n,s){const t=new L.$pd(s),r=this.J(c,n).then(v=>v,v=>{throw t.dispose(!0),v});let a;try{return typeof n?.etag=="string"&&n.etag!==d.$xk&&await r,n?.atomic&&(0,d.$ak)(i)||!((0,d.$$j)(i)||(0,d.$_j)(i))||(0,d.$8j)(i)&&n?.preferUnbuffered?a=this.I(i,c,n):(0,d.$_j)(i)?a=this.G(i,c,t.token,n):a=this.H(i,c,t.token,n),a.on("end",()=>t.dispose()),a.on("error",()=>t.dispose()),{...await r,value:a}}catch(v){throw a&&await(0,f.$wd)(a),this.F(v,c,n)}}F(i,c,n){const s=(0,w.localize)(10,null,this.rb(c),(0,d.$gk)(i).toString());return i instanceof d.$pk?new d.$pk(s,i.stat,n):i instanceof d.$ok?new d.$ok(s,i.fileOperationResult,i.size,i.options):new d.$nk(s,(0,d.$jk)(i),n)}G(i,c,n,s=Object.create(null)){const t=i.readFileStream(c,s,n);return(0,f.$Cd)(t,{data:r=>r instanceof A.$Fd?r:A.$Fd.wrap(r),error:r=>this.F(r,c,s)},r=>A.$Fd.concat(r))}H(i,c,n,s=Object.create(null)){const t=(0,A.$Vd)();return(0,h.$Cp)(i,c,t,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.F(r,c,s)},n),t}I(i,c,n){const s=(0,f.$td)(t=>A.$Fd.concat(t));return(async()=>{try{let t;n?.atomic&&(0,d.$ak)(i)?t=await i.readFile(c,{atomic:!0}):t=await i.readFile(c),typeof n?.position=="number"&&(t=t.slice(n.position)),typeof n?.length=="number"&&(t=t.slice(0,n.length)),this.L(c,t.byteLength,n),s.end(A.$Fd.wrap(t))}catch(t){s.error(t),s.end()}})(),s}async J(i,c){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new d.$nk((0,w.localize)(11,null,this.rb(i)),0,c);if(typeof c?.etag=="string"&&c.etag!==d.$xk&&c.etag===n.etag)throw new d.$pk((0,w.localize)(12,null),n,c);return this.L(i,n.size,c),n}L(i,c,n){if(typeof n?.limits?.size=="number"&&c>n.limits.size)throw new d.$ok((0,w.localize)(13,null,this.rb(i)),7,c,n)}async canMove(i,c,n){return this.M(i,c,"move",n)}async canCopy(i,c,n){return this.M(i,c,"copy",n)}async M(i,c,n,s){if(i.toString()!==c.toString())try{const t=n==="move"?this.pb(await this.n(i),i):await this.m(i),r=this.pb(await this.n(c),c);await this.Q(t,i,r,c,n,s)}catch(t){return t}return!0}async move(i,c,n){const s=this.pb(await this.n(i),i),t=this.pb(await this.n(c),c),r=await this.N(s,i,t,c,"move",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new d.$kk(i,r==="move"?2:3,a)),a}async copy(i,c,n){const s=await this.m(i),t=this.pb(await this.n(c),c),r=await this.N(s,i,t,c,"copy",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new d.$kk(i,r==="copy"?3:2,a)),a}async N(i,c,n,s,t,r){if(c.toString()===s.toString())return t;const{exists:a,isSameResourceWithDifferentPathCase:v}=await this.Q(i,c,n,s,t,r);if(a&&!v&&r&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),t==="copy"){if(i===n&&(0,d.$9j)(i))await i.copy(c,s,{overwrite:r});else{const b=await this.resolve(c);b.isDirectory?await this.P(i,b,n,s):await this.O(i,c,n,s)}return t}else return i===n?(await i.rename(c,s,{overwrite:r}),t):(await this.N(i,c,n,s,"copy",r),await this.del(c,{recursive:!0}),"copy")}async O(i,c,n,s){if((0,d.$$j)(i)&&(0,d.$$j)(n))return this.ib(i,c,n,s);if((0,d.$$j)(i)&&(0,d.$8j)(n))return this.ob(i,c,n,s);if((0,d.$8j)(i)&&(0,d.$$j)(n))return this.mb(i,c,n,s);if((0,d.$8j)(i)&&(0,d.$8j)(n))return this.kb(i,c,n,s)}async P(i,c,n,s){await n.mkdir(s),Array.isArray(c.children)&&await N.Promises.settled(c.children.map(async t=>{const r=this.R(n).providerExtUri.joinPath(s,t.name);return t.isDirectory?this.P(i,await this.resolve(t.resource),n,r):this.O(i,t.resource,n,r)}))}async Q(i,c,n,s,t,r){let a=!1;if(i===n){const{providerExtUri:b,isPathCaseSensitive:u}=this.R(i);if(u||(a=b.isEqual(c,s)),a&&t==="copy")throw new Error((0,w.localize)(14,null,this.rb(c),this.rb(s)));if(!a&&b.isEqualOrParent(s,c))throw new Error((0,w.localize)(15,null,this.rb(c),this.rb(s)))}const v=await this.exists(s);if(v&&!a){if(!r)throw new d.$nk((0,w.localize)(16,null,this.rb(c),this.rb(s)),4);if(i===n){const{providerExtUri:b}=this.R(i);if(b.isEqualOrParent(c,s))throw new Error((0,w.localize)(17,null,this.rb(c),this.rb(s)))}}return{exists:v,isSameResourceWithDifferentPathCase:a}}R(i){const c=this.S(i);return{providerExtUri:c?l.$$f:l.$ag,isPathCaseSensitive:c}}S(i){return!!(i.capabilities&1024)}async createFolder(i){const c=this.pb(await this.j(i),i);await this.U(c,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new d.$kk(i,0,n)),n}async U(i,c){const n=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(c,s.dirname(c));)try{if(!((await i.stat(c)).type&d.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(c)));break}catch(t){if((0,d.$ik)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;n.push(s.basename(c)),c=s.dirname(c)}for(let t=n.length-1;t>=0;t--){c=s.joinPath(c,n[t]);try{await i.mkdir(c)}catch(r){if((0,d.$ik)(r)!==d.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(i,c){try{await this.W(i,c)}catch(n){return n}return!0}async W(i,c){const n=this.pb(await this.j(i),i),s=!!c?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(i)));const t=c?.atomic;if(t&&!(n.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(i)));if(s&&t)throw new Error((0,w.localize)(21,null,this.rb(i)));let r;try{r=await n.stat(i)}catch{}if(r)this.qb(i,r);else throw new d.$nk((0,w.localize)(22,null,this.rb(i)),1);if(!!!c?.recursive){const v=await this.resolve(i);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(i)))}return n}async del(i,c){const n=await this.W(i,c),s=!!c?.useTrash,t=!!c?.recursive,r=c?.atomic??!1;await n.delete(i,{recursive:t,useTrash:s,atomic:r}),this.r.fire(new d.$kk(i,1))}async cloneFile(i,c){const n=await this.j(i),s=this.pb(await this.n(c),c);if(n===s&&this.R(n).providerExtUri.isEqual(i,c))return;if(n===s&&(0,d.$0j)(n))return n.cloneFile(i,c);await this.U(s,this.R(s).providerExtUri.dirname(c));const t=this.ab.queueFor(i,this.R(n).providerExtUri);return n===s&&(0,d.$9j)(n)?t.queue(()=>n.copy(i,c,{overwrite:!0})):t.queue(()=>this.O(n,i,s,c))}watch(i,c={recursive:!1,excludes:[]}){const n=new m.$jc;let s=!1,t=()=>{s=!0};return n.add((0,m.$ic)(()=>t())),(async()=>{try{const r=await this.$(i,c);s?(0,m.$fc)(r):t=()=>(0,m.$fc)(r)}catch(r){this.b.error(r)}})(),n}async $(i,c){const n=await this.j(i),s=(0,I.$pi)([this.R(n).providerExtUri.getComparisonKey(i),c]);let t=this.Z.get(s);return t||(t={count:0,disposable:n.watch(i,c)},this.Z.set(s,t)),t.count+=1,(0,m.$ic)(()=>{t&&(t.count--,t.count===0&&((0,m.$fc)(t.disposable),this.Z.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.Z)(0,m.$fc)(i.disposable);this.Z.clear()}async bb(i,c,n,s,t){await this.cb(i,n,s,t);try{await i.rename(n,c,{overwrite:!0})}catch(r){try{await i.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(i,c,n,s){return this.ab.queueFor(c,this.R(i).providerExtUri).queue(async()=>{const t=await i.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,f.$rd)(s)||(0,f.$sd)(s)?await this.db(i,t,s):await this.eb(i,t,s)}catch(r){throw(0,d.$gk)(r)}finally{await i.close(t)}})}async db(i,c,n){let s=0,t;if((0,f.$sd)(n)){if(n.buffer.length>0){const r=A.$Fd.concat(n.buffer);await this.fb(i,c,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;t=n.stream}else t=n;return new Promise((r,a)=>{(0,f.$xd)(t,{onData:async v=>{t.pause();try{await this.fb(i,c,v,v.byteLength,s,0)}catch(b){return a(b)}s+=v.byteLength,setTimeout(()=>t.resume())},onError:v=>a(v),onEnd:()=>r()})})}async eb(i,c,n){let s=0,t;for(;(t=n.read())!==null;)await this.fb(i,c,t,t.byteLength,s,0),s+=t.byteLength}async fb(i,c,n,s,t,r){let a=0;for(;a<s;){const v=await i.write(c,t+a,n.buffer,r+a,s-a);a+=v}}async gb(i,c,n,s){return this.ab.queueFor(c,this.R(i).providerExtUri).queue(()=>this.hb(i,c,n,s))}async hb(i,c,n,s){let t;s instanceof A.$Fd?t=s:(0,f.$rd)(s)?t=await(0,A.$Rd)(s):(0,f.$sd)(s)?t=await(0,A.$Sd)(s):t=(0,A.$Pd)(s),await i.writeFile(c,t.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async ib(i,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.jb(i,c,n,s))}async jb(i,c,n,s){let t,r;try{t=await i.open(c,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const a=A.$Fd.alloc(this.a);let v=0,b=0,u=0;do u=await i.read(t,v,a.buffer,b,a.byteLength-b),await this.fb(n,r,a,u,v,b),v+=u,b+=u,b===a.byteLength&&(b=0);while(u>0)}catch(a){throw(0,d.$gk)(a)}finally{await N.Promises.settled([typeof t=="number"?i.close(t):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async kb(i,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.lb(i,c,n,s))}async lb(i,c,n,s){return n.writeFile(s,await i.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(i,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.nb(i,c,n,s))}async nb(i,c,n,s){const t=await n.open(s,{create:!0,unlock:!1});try{const r=await i.readFile(c);await this.fb(n,t,A.$Fd.wrap(r),r.byteLength,0,0)}catch(r){throw(0,d.$gk)(r)}finally{await n.close(t)}}async ob(i,c,n,s){const t=await(0,A.$Rd)(this.H(i,c,L.CancellationToken.None));await this.gb(n,s,void 0,t)}pb(i,c){if(i.capabilities&2048)throw new d.$nk((0,w.localize)(24,null,this.rb(c)),6);return i}qb(i,c){if((c.permissions??0)&d.FilePermission.Readonly)throw new d.$nk((0,w.localize)(25,null,this.rb(i)),6)}rb(i){return i.scheme===E.Schemas.file?i.fsPath:i.toString(!0)}};e.$Dp=y,e.$Dp=y=ye([Z(0,o.$5i)],y)}),define(oe[200],ae([0,1,52,271,5,35,14,3,48,2,16,6,21,42,31,162,12,99,198,38,194,193]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,N.gracefulify)(O)}catch(c){console.error(`Error enabling graceful-fs: ${(0,$.$mi)(c)}`)}})();class i extends o.$Mp{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.N=new L.$zi(t=>g.$_f.getComparisonKey(t)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await f.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:d.FilePermission.Locked}}catch(s){throw this.eb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await f.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,g.$ig)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.eb(s)}}M(n,s){let t;return s?.dangling?t=d.FileType.Unknown:n.isFile()?t=d.FileType.File:n.isDirectory()?t=d.FileType.Directory:t=d.FileType.Unknown,s&&(t|=d.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new A.$Fg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,m.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await f.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,l.$td)(a=>D.$Fd.concat(a.map(v=>D.$Fd.wrap(v))).buffer);return(0,h.$Cp)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix?this.Q(n,(0,g.$ig)((0,g.$hg)(n),`${(0,g.$fg)(n)}${t.atomic.postfix}`),s,t):this.R(n,s,t)}async Q(n,s,t,r){await this.R(s,t,r);try{await this.rename(s,n,{overwrite:!0})}catch(a){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async R(n,s,t){let r;try{const a=this.H(n);if(!t.create||!t.overwrite){if(await f.Promises.exists(a)){if(!t.overwrite)throw(0,d.$fk)((0,w.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,d.$fk)((0,w.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:t.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(a){throw await this.fb(n,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(n){i.X=n}async open(n,s){const t=this.H(n);let r;(0,d.$7j)(s)&&(r=await this.O(n));let a;try{if((0,d.$7j)(s)&&s.unlock)try{const{stat:b}=await f.SymlinkSupport.stat(t);b.mode&128||await f.Promises.chmod(t,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let v;if((0,d.$7j)(s)){if(E.$i)try{await f.Promises.truncate(t,0),v="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}v||(v="w")}else v="r";a=await f.Promises.open(t,v)}catch(v){throw r?.dispose(),(0,d.$7j)(s)?await this.fb(n,v):this.eb(v)}if(this.S.set(a,0),(0,d.$7j)(s)&&this.W.set(a,n),r){const v=this.U.get(a);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${t})`),this.U.set(a,r),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${t})`),v.dispose())}return a}async close(n){const s=this.U.get(n);try{if(this.S.delete(n),this.W.delete(n)&&i.X)try{await f.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await f.Promises.close(n)}catch(t){throw this.eb(t)}finally{s&&(this.U.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.U.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const v=this.Y(n,s);let b=null;try{b=(await f.Promises.read(n,t,r,a,v)).bytesRead}catch(u){throw this.eb(u)}finally{this.Z(n,v,b)}return b}Y(n,s){return s===this.S.get(n)?null:s}Z(n,s,t){const r=this.S.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.S.set(n,r+t):this.S.delete(n)))}async write(n,s,t,r,a){return(0,A.$Yg)(()=>this.$(n,s,t,r,a),100,3)}async $(n,s,t,r,a){const v=this.Y(n,s);let b=null;try{b=(await f.Promises.write(n,t,r,a,v)).bytesWritten}catch(u){throw await this.fb(this.W.get(n),u)}finally{this.Z(n,v,b)}return b}async mkdir(n){try{await f.Promises.mkdir(this.H(n))}catch(s){throw this.eb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,P.$9d)((0,P.$_d)(t),`${(0,P.$ae)(t)}${s.atomic.postfix}`)),await f.Promises.rm(t,f.RimRafMode.MOVE,r)}else try{await f.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:b}=await f.SymlinkSupport.stat(t);a=v.isDirectory()&&!b}catch{}if(a)await f.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.eb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.ab(n,s,"move",t.overwrite),await f.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(2,null,(0,P.$ae)(r),(0,P.$ae)((0,P.$_d)(a)),v.toString()))),this.eb(v)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.ab(n,s,"copy",t.overwrite),await f.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(3,null,(0,P.$ae)(r),(0,P.$ae)((0,P.$_d)(a)),v.toString()))),this.eb(v)}}async ab(n,s,t,r){const a=this.H(n),v=this.H(s);let b=!1;if(!!(this.capabilities&1024)||(b=(0,S.$Hf)(a,v,!0)),b){if(t==="copy")throw(0,d.$fk)((0,w.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,d.$fk)((0,w.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(s);if(j){if(!r)throw(0,d.$fk)((0,w.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);p.type&d.FileType.File&&j.type&d.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.bb(n,s,!1)}async bb(n,s,t){const r=this.H(n),a=this.H(s),v=!!(this.capabilities&1024);if((0,S.$Hf)(r,a,!v))return;const b=new m.$jc;try{const[u,p]=await Promise.all([this.O(n),this.O(s)]);b.add(u),b.add(p),t&&await f.Promises.mkdir((0,P.$_d)(a),{recursive:!0}),await f.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.bb(n,s,!0);throw this.eb(u)}finally{b.dispose()}}t(n,s,t){return new y.$Tp(r=>n(r),r=>s(r),t)}F(n,s,t){return new C.$2p(r=>n(r),r=>s(r),t)}eb(n){if(n instanceof d.$ek)return n;let s=n,t;switch(n.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=d.FileSystemProviderErrorCode.Unknown;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fk)(s,t)}async fb(n,s){let t=this.eb(s);if(n&&t.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await f.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,d.$fk)(s,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$3p=i}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.$$7b=void 0,e.$$7b=(0,A.$Bh)("sharedProcessLifecycleService");let D=class extends N.$kc{constructor(S){super(),this.b=S,this.a=this.B(new O.$fd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$_7b=D,e.$_7b=D=ye([Z(0,L.$5i)],D)}),define(oe[201],ae([0,1,11,3,7,2]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=void 0;class D extends A.$dj{constructor(E,g,l,f,w){super(g,l,f),this.r=E,this.t=w,this.B(w.listen("onDidChangeLogLevel",E)(d=>{(0,A.$7i)(d)?super.setLogLevel(d):super.setLogLevel(O.URI.revive(d[0]),d[1])})),this.B(w.listen("onDidChangeVisibility",E)(([d,h])=>super.setVisibility(O.URI.revive(d),h))),this.B(w.listen("onDidChangeLoggers",E)(({added:d,removed:h})=>{for(const o of d)super.registerLogger({...o,resource:O.URI.revive(o.resource)});for(const o of h)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new A.$bj({log:(E,g)=>{this.t.call("consoleLog",[E,g])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,g){super.setLogLevel(E,g),this.t.call("setLogLevel",[E,g])}setVisibility(E,g){super.setVisibility(E,g),this.t.call("setVisibility",[this.n(E),g])}s(E,g,l){return new I(this.t,E,g,l,this.r)}static setLogLevel(E,g,l){return E.call("setLogLevel",[g,l])}}e.$1q=D;class I extends A.$$i{constructor(E,g,l,f,w){super(f?.logLevel==="always"),this.r=E,this.s=g,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[g,f,w]).then(()=>{this.u(this.n),this.m=!0})}g(E,g){const l=[[E,g]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class S{constructor(E,g){this.a=E,this.b=g}listen(E,g){const l=this.b(E);switch(g){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(w=>this.c(w,l)),removed:[...f.removed].map(w=>this.c(w,l))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,f=>[l.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,f=>(0,A.$7i)(f)?f:[l.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${g}`)}async call(E,g,l){const f=this.b(E);switch(g){case"setLogLevel":return(0,A.$7i)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(O.URI.revive(f.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,f)))}throw new Error(`Call not found: ${g}`)}c(E,g){return{...E,resource:g.transformOutgoingURI(E.resource)}}}e.$2q=S;class m extends L.$kc{constructor(E,g){super(),g.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>g.call("setLogLevel",[l]))),g.call("getRegisteredLoggers").then(l=>{for(const f of l)E.registerLogger({...f,resource:O.URI.revive(f.resource)})}),this.B(g.listen("onDidChangeVisibility")(([l,f])=>E.setVisibility(O.URI.revive(l),f))),this.B(g.listen("onDidChangeLoggers")(({added:l,removed:f})=>{for(const w of l)E.registerLogger({...w,resource:O.URI.revive(w.resource)});for(const w of f)E.deregisterLogger(w.resource)}))}}e.$3q=m}),define(oe[202],ae([0,1,2,7]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class A extends O.$kc{constructor(D,I=[]){super(),this.a=new N.$cj([D,...I]),this.B(D.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...I){this.a.trace(D,...I)}debug(D,...I){this.a.debug(D,...I)}info(D,...I){this.a.info(D,...I)}warn(D,...I){this.a.warn(D,...I)}error(D,...I){this.a.error(D,...I)}flush(){this.a.flush()}}e.$mN=A}),define(oe[55],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=void 0,e.$45b=(0,O.$Bh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,L.$Bh)("policy");class D extends A.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const P=Object.keys(this.f).length;return this.f={...m,...this.f},P!==Object.keys(this.f).length&&await this.j(m),N.Iterable.reduce(this.g.entries(),(E,[g,l])=>({...E,[g]:l}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(m,[P,E])=>({...m,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$$m=D;class I{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=I}),define(oe[203],ae([0,1,3,2,56]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=void 0;class L{constructor(S){this.b=S,this.a=new N.$jc}listen(S,m){switch(m){case"onDidChange":return O.Event.map(this.b.onDidChange,P=>P.reduce((E,g)=>({...E,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(S,m,P){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.$T6b=L;class D extends A.$$m{constructor(S,m){super(),this.a=m;for(const P in S){const{definition:E,value:g}=S[P];this.f[P]=E,g!==void 0&&this.g.set(P,g)}this.a.listen("onDidChange")(P=>{for(const E in P){const g=P[E];g===null?this.g.delete(E):this.g.set(E,g)}this.h.fire(Object.keys(P))})}async j(S){const m=await this.a.call("updatePolicyDefinitions",S);for(const P in m)this.g.set(P,m[P])}}e.$U6b=D}),define(oe[102],ae([0,1,6,37]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.context<"u"){const L=O.$g.vscode.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[24],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,O.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,5,8,2,16,31,7,24]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;let m=class extends A.$kc{constructor(E,g,l){super(),this.b=g,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new O.$Sg(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),l=(0,L.$_d)(E),f=(0,L.$ae)(E),w=await D.Promises.readdir(l);await Promise.all(w.map(async d=>{if(d===f)return;const h=(0,L.$9d)(l,d),o=await D.Promises.stat(h);if(o.isDirectory()&&g-o.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),D.Promises.rm(h)}))}catch(g){(0,N.$Y)(g)}}};e.$F7b=m,e.$F7b=m=ye([Z(1,S.$kj),Z(2,I.$5i)],m)}),define(oe[205],ae([0,1,5,8,2,16,31,15,7,24]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;let P=class extends A.$kc{constructor(g,l,f){super(),this.b=g,this.c=l,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$Sg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),l=JSON.parse(await D.Promises.readFile((0,L.$9d)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const o of Object.keys(l)){const $=l[o];g[`${$.hash}.${o}`]=!0}const f=(0,L.$9d)(this.b.userDataPath,"clp");if(!await D.Promises.exists(f))return;const d=await D.Promises.readdir(f);for(const o of d){if(g[o]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${o}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${o}`),await D.Promises.rm((0,L.$9d)(f,o))}const h=Date.now();for(const o of Object.keys(g)){const $=(0,L.$9d)(f,o),y=await D.Promises.readdir($);for(const C of y){if(C==="tcf.json")continue;const i=(0,L.$9d)($,C),c=await D.Promises.stat(i);c.isDirectory()&&h-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$9d)(o,C)}`),await D.Promises.rm(i))}}}catch(g){(0,N.$Y)(g)}}};e.$G7b=P,e.$G7b=P=ye([Z(0,I.$Jh),Z(1,S.$5i),Z(2,m.$kj)],P)}),define(oe[206],ae([0,1,16,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$CF=void 0,e.$CF=(0,N.$Bh)("IV8InspectProfilingService");var A;(function(L){function D(S){return!!(S.samples&&S.timeDeltas)}L.isValidProfile=D;function I(S,m="noAbsolutePaths"){for(const P of S.nodes)P.callFrame&&P.callFrame.url&&((0,O.$8d)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,O.$9d)(m,(0,O.$ae)(P.callFrame.url)));return S}L.rewriteAbsolutePaths=I})(A||(e.Utils=A={}))}),define(oe[207],ae([0,1,32]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=void 0;class N{constructor(){this.a=new Map}async startProfiling(L){const I=await(await new Promise((m,P)=>{te(["v8-inspect-profiler"],m,P)})).startProfiling({port:L.port,checkForPaused:!0}),S=(0,O.$4f)();return this.a.set(S,I),S}async stopProfiling(L){const D=this.a.get(L);if(!D)throw new Error(`UNKNOWN session '${L}'`);const I=await D.stop();return this.a.delete(L),I.profile}}e.$17b=N}),define(oe[40],ae([0,1,127,9]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class A{constructor(){this.a=new Map}add(D,I){O.ok(N.$jf(D)),O.ok(N.$lf(I)),O.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,I)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$8m=new A}),define(oe[103],ae([0,1,3,40]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this.b=new O.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,m){this.a[A(S)]=m,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new L;N.$8m.add(e.$9m.JSONContribution,D)}),define(oe[49],ae([0,1,18,3,9,149,19,103,40]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var m;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$an={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const E=S.$8m.as(I.$9m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new N.$fd,this.onDidSchemaChange=this.i.event,this.j=new N.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(i,c=!0){this.registerConfigurations([i],c)}registerConfigurations(i,c=!0){const n=new Set;this.n(i,c,n),E.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const c=new Set;this.o(i,c),E.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:i,remove:c}){const n=new Set;this.o(c,n),this.n(i,!1,n),E.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const c=new Set;this.k(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(i,c){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(c.add(r),e.$kn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const j of Object.keys(s[r]))v.set(j,t);const b={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:b,valuesSources:v});const u=(0,D.$fi)(r),p={type:"object",default:b,description:L.localize(1,null,u),$ref:e.$hn,defaultDefaultValue:b,source:A.$jf(t)?void 0:t,defaultValueSource:t};n.push(...w(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const c=new Set;this.l(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(i,c){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=A.$jf(s)?s:s?.id,v=A.$jf(r?.source)?r?.source:r?.source?.id;if(a===v)if(c.add(t),this.a.delete(t),e.$kn.test(t))delete this.d[t],delete this.b.properties[t];else{const b=this.d[t];b&&(this.w(t,b),this.r(t,b))}}this.u()}deltaConfiguration(i){let c=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),c=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),c=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const c of i)this.h.add(c);this.u()}n(i,c,n){i.forEach(s=>{this.p(s,c,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,c){const n=s=>{if(s.properties)for(const t in s.properties){c.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,c=!0,n,s,t=3,r){t=A.$sf(i.scope)?t:i.scope;const a=i.properties;if(a)for(const b in a){const u=a[b];if(c&&$(b,u)){delete a[b];continue}if(u.source=n,u.defaultDefaultValue=a[b].default,this.w(b,u),e.$kn.test(b)?u.scope=void 0:(u.scope=A.$sf(u.scope)?t:u.scope,u.restricted=A.$sf(u.restricted)?!!s?.includes(b):u.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),r.add(b)}const v=i.allOf;if(v)for(const b of v)this.p(b,c,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const c=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(c)};c(i)}r(i,c){switch(e.$bn.properties[i]=c,c.scope){case 1:e.$cn.properties[i]=c;break;case 2:e.$dn.properties[i]=c;break;case 6:e.$en.properties[i]=c;break;case 3:e.$fn.properties[i]=c;break;case 4:e.$gn.properties[i]=c;break;case 5:e.$gn.properties[i]=c,this.g.properties[i]=c;break}}s(i,c){switch(delete e.$bn.properties[i],c.scope){case 1:delete e.$cn.properties[i];break;case 2:delete e.$dn.properties[i];break;case 6:delete e.$en.properties[i];break;case 3:delete e.$fn.properties[i];break;case 4:case 5:delete e.$gn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const c=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$hn};this.w(c,n),e.$bn.properties[c]=n,e.$cn.properties[c]=n,e.$dn.properties[c]=n,e.$en.properties[c]=n,e.$fn.properties[c]=n,e.$gn.properties[c]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=i,e.$cn.patternProperties[e.$jn]=i,e.$dn.patternProperties[e.$jn]=i,e.$en.patternProperties[e.$jn]=i,e.$fn.patternProperties[e.$jn]=i,e.$gn.patternProperties[e.$jn]=i,this.i.fire()}w(i,c){const n=this.a.get(i);let s=n?.value,t=n?.source;A.$qf(s)&&(s=c.defaultDefaultValue,t=void 0),A.$qf(s)&&(s=h(c.type)),c.default=s,c.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",f=new RegExp(l,"g");e.$jn=`^(${l})+$`,e.$kn=new RegExp(e.$jn);function w(C){const i=[];if(e.$kn.test(C)){let c=f.exec(C);for(;c?.length;){const n=c[1].trim();n&&i.push(n),c=f.exec(C)}}return(0,O.$Kb)(i)}e.$ln=w;function d(C){return C.reduce((i,c)=>`${i}[${c}]`,"")}e.$mn=d;function h(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=h;const o=new g;S.$8m.add(e.$an.Configuration,o);function $(C,i){return C.trim()?e.$kn.test(C)?L.localize(7,null,C):o.getConfigurationProperties()[C]!==void 0?L.localize(8,null,C):i.policy?.name&&o.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,C,i.policy?.name,o.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$on=$;function y(){const C=[],i=o.getConfigurationProperties();for(const c of Object.keys(i))C.push([c,i[c].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$pn=y}),define(oe[73],ae([0,1,18,3,34,2,35,30,9,11,19,49,40]),function(te,e,O,N,A,L,D,I,S,m,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function l(c){return Object.isFrozen(c)?c:I.$Wm(c)}class f{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof f)return s;const t=new w("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$di)(this.contents,n):this.contents}inspect(n,s){const t=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,P.$di)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return O.$Kb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Kb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=I.$Vm(this.contents),t=I.$Vm(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(s,v.contents);for(const b of v.overrides){const[u]=t.filter(p=>O.$sb(p.identifiers,b.identifiers));u?(this.h(u.contents,b.contents),u.keys.push(...b.keys),u.keys=O.$Kb(u.keys)):t.push(I.$Vm(b))}for(const b of v.keys)r.indexOf(b)===-1&&r.push(b)}return new f(s,r,t,a.every(v=>v instanceof f)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of O.$Kb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const v=s[r];v&&(typeof a=="object"&&typeof v=="object"?(a=I.$Vm(a),this.h(a,v)):a=v),t[r]=a}return new f(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&S.$lf(n[t])&&S.$lf(s[t])){this.h(n[t],s[t]);continue}n[t]=I.$Vm(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=I.$Vm(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,P.$ci)(this.contents,n),E.$kn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>O.$sb(t.identifiers,(0,E.$ln)(n))),1))}j(n,s,t){(0,P.$bi)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$kn.test(n)&&this.overrides.push({identifiers:(0,E.$ln)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$ai)(this.contents[n],r=>console.error(r))})}}e.$qn=f;class w{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!S.$sf(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:b}=this.h(n,s);this.b=new f(t,r,a,b?[n]:void 0),this.c=v||[]}g(n){let s={},t=null,r=[];const a=[],v=[];function b(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};b(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];b(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:b,onError:(p,j,F)=>{v.push({error:p,offset:j,length:F})}};if(n)try{A.$Sm(n,u),s=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return s}h(n,s){const t=g.$8m.as(E.$an.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,P.$ai)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),v=Object.keys(n),b=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:v,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},b=[];for(const u in n)if(E.$kn.test(u)&&t){const p=this.i(n[u],s,!1,r);v[u]=p.raw,a=a||p.hasExcludedProperties,b.push(...p.restricted)}else{const p=s[u],j=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&b.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&p?.restricted))?v[u]=n[u]:a=!0}return{raw:v,restricted:b,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(E.$kn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,E.$ln)(r),keys:Object.keys(a),contents:(0,P.$ai)(a,s)})}return t}}e.$rn=w;class d extends L.$kc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new N.$fd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new f}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=d;class h{constructor(n,s,t,r,a,v,b,u,p,j,F,T,z){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=b,this.h=u,this.i=p,this.j=j,this.k=F,this.l=T,this.m=z}get value(){return l(this.c)}n(n,s,t){const r=n.inspect(s,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class o{constructor(n,s,t,r,a=new f,v=new f,b=new D.$zi,u=new f,p=new D.$zi){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=v,this.j=b,this.l=u,this.m=p,this.a=null,this.b=new D.$zi,this.n=null}getValue(n,s,t){return this.q(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new f,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.q(n,s,t),a=this.u(s.resource,t),v=s.resource?this.m.get(s.resource)||this.l:this.l,b=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(n,p)!==void 0&&b.add(p);return new h(n,s,r.getValue(n),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:v}=C(this.c,n);s=[...r,...a,...v]}for(const r of s)for(const a of(0,E.$ln)(r)){const v=this.c.getKeysForOverrideIdentifier(a),b=n.getKeysForOverrideIdentifier(a),u=[...b.filter(p=>v.indexOf(p)===-1),...v.filter(p=>b.indexOf(p)===-1),...v.filter(p=>!I.$Zm(this.c.override(a).getValue(p),n.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=C(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=C(this.applicationConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=C(this.localUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=C(this.remoteUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=C(this.workspaceConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.p.get(n),{added:r,updated:a,removed:v,overrides:b}=C(t,s),u=[...r,...a,...v];return(u.length||!t)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:b}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=C(s,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,t){let r=this.r(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},s){let t=this.s();if(s&&n){const r=s.getFolder(n);r&&(t=this.t(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const t=this.s(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}u(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),v=this.x(n.workspace),b=n.folders.reduce((u,p)=>(u.set(m.URI.revive(p[0]),this.x(p[1])),u),new D.$zi);return new o(s,t,r,a,new f,v,b,new f,new D.$zi)}static x(n){return new f(n.contents,n.keys,n.overrides)}}e.$tn=o;function $(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,s=new Map;for(const r of c)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const b=(0,D.$wi)(s,a,new Set);v.forEach(u=>b.add(u))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$un=$;class y{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=o.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!I.$Zm(b,u)}return!0}}e.$vn=y;function C(c,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,c?.rawConfiguration),a=[],v=c?.getAllOverrideIdentifiers()||[],b=n?.getAllOverrideIdentifiers()||[];if(n){const u=b.filter(p=>!v.includes(p));for(const p of u)a.push([p,n.getKeysForOverrideIdentifier(p)])}if(c){const u=v.filter(p=>!b.includes(p));for(const p of u)a.push([p,c.getKeysForOverrideIdentifier(p)])}if(n&&c){for(const u of v)if(b.includes(u)){const p=i({contents:c.getOverrideValue(void 0,u)||{},keys:c.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(c,n){const s=c?n?c.keys.filter(a=>n.keys.indexOf(a)===-1):[...c.keys]:[],t=n?c?n.keys.filter(a=>c.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(c&&n){for(const a of n.keys)if(c.keys.indexOf(a)!==-1){const v=(0,P.$di)(n.contents,a),b=(0,P.$di)(c.contents,a);I.$Zm(v,b)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,9,73,49,7,56,40]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class g extends A.$kc{constructor(){super(...arguments),this.a=this.B(new N.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new I.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$8m.as(S.$an.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:h})=>this.c(Array.from(d),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,h){this.h(d,E.$8m.as(S.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new I.$qn;const d=E.$8m.as(S.$an.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,h){const o=this.f();for(const $ of d){const y=o[$],C=h[$];y!==void 0?this.b.addValue($,y):C?this.b.addValue($,C.default):this.b.removeValue($)}}}e.$wn=g;class l{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new I.$qn}async initialize(){return this.configurationModel}}e.$xn=l;let f=class extends A.$kc{get configurationModel(){return this.b}constructor(d,h,o){super(),this.c=d,this.f=h,this.g=o,this.a=this.B(new N.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new I.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const h={},o=[],$=E.$8m.as(S.$an.Configuration).getConfigurationProperties();for(const y of d){const C=$[y];if(!C){o.push(y);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}o.push(y),h[C.policy.name]={type:C.type}}}return(0,D.$wf)(h)||await this.f.updatePolicyDefinitions(h),o}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const h=E.$8m.as(S.$an.Configuration).getPolicyConfigurations(),o=(0,O.$Fb)(d.map($=>h.get($)));this.m(o,!0)}m(d,h){this.g.trace("PolicyConfiguration#update",d);const o=E.$8m.as(S.$an.Configuration).getConfigurationProperties(),$=[],y=this.b.isEmpty();for(const C of d){const i=o[C]?.policy?.name;if(i){const c=this.f.getPolicyValue(i);(y?c!==void 0:!(0,L.$Zm)(this.b.getValue(C),c))&&$.push([C,c])}else this.b.getValue(C)!==void 0&&$.push([C,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const C=this.b;this.b=new I.$qn;for(const i of C.keys)this.b.setValue(i,C.getValue(i));for(const[i,c]of $)c===void 0?this.b.removeValue(i):this.b.setValue(i,c);h&&this.a.fire(this.b)}}};e.$yn=f,e.$yn=f=ye([Z(1,P.$0m),Z(2,m.$5i)],f)}),define(oe[209],ae([0,1,5,3,2,21,19,73,208,56]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class P extends A.$kc{constructor(g,l,f,w){super(),this.j=g,this.h=this.B(new N.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$wn),this.c=f instanceof m.$_m?new S.$xn:this.B(new S.$yn(this.b,f,w)),this.f=this.B(new I.$sn(this.j,{},L.$_f,l)),this.a=new I.$tn(this.b.configurationModel,this.c.configurationModel,new I.$qn,new I.$qn),this.g=this.B(new O.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:h})=>this.n(d,h))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,l,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.$tn(g,l,new I.$qn,f)}getConfigurationData(){return this.a.toData()}getValue(g,l){const f=typeof g=="string"?g:void 0,w=(0,D.$9h)(g)?g:(0,D.$9h)(l)?l:{};return this.a.getValue(f,w,void 0)}updateValue(g,l,f,w){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const l=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(f,l,2)}n(g,l){const f=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(g,l);this.s(w,f,7)}r(g){const l=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(g);this.s(f,l,7)}s(g,l,f){const w=new I.$vn(g,{data:l},this.a);w.source=f,w.sourceConfig=this.t(f),this.h.fire(w)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=P}),define(oe[210],ae([0,1,14,3,2,65]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akb=e.$zkb=e.$ykb=e.$xkb=void 0;const D=(m,P,E)=>{const g=new Uint8Array(16);for(let w=0;w<16;w++)g[w]=Math.round(Math.random()*256);const l=(0,O.$Zd)(O.$Fd.wrap(g));return[`GET ws://localhost${m}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$xkb=D,e.$ykb=O.$Fd.fromString(`\r
\r
`);async function I(m,P,E,g,l){m.write(O.$Fd.fromString((0,e.$xkb)(P,E,g)));const f=new A.$jc;try{return await new Promise((w,d)=>{let h;f.add(m.onData(o=>{h?h=O.$Fd.concat([h,o],h.byteLength+o.byteLength):h=o;const $=h.indexOf(e.$ykb);if($===-1)return;w(m),m.pauseData();const y=h.slice($+e.$ykb.byteLength);y.byteLength&&l.onData.fire(y)})),f.add(m.onClose(o=>d(o??new Error("socket closed")))),f.add(m.onEnd(()=>d(new Error("socket ended"))))})}catch(w){throw m.dispose(),w}finally{f.dispose()}}e.$zkb=I;class S extends A.$kc{constructor(P,E){super(),this.g=P,this.a=this.B(new N.$id),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new N.$fd),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(g=>this.a.fire(g))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Akb=S}),define(oe[211],ae([0,1,8,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,N.$Bh)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class L{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=L;class D{constructor(E,g){this.host=E,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=D;var I;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class S extends O.$_{static isNotAvailable(E){return E instanceof S&&E._code===I.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===I.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===I.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===I.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,g=I.Unknown,l){super(E),this._message=E,this._code=g,this._detail=l,this.isHandled=g===I.NotAvailable&&l===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Mk=S;function m(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Nk=m}),define(oe[74],ae([0,1,23]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function N(m){return m.scheme===O.Schemas.vscodeRemote?m.authority:void 0}e.$Ok=N;function A(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.$Pk=A;function L(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$Qk=L;function D(m){const{host:P,port:E}=S(m);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Rk=D;function I(m,P){let{host:E,port:g}=S(m);return typeof g>"u"&&(g=P),{host:E,port:g}}e.$Sk=I;function S(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=m.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const g=m.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:m,port:void 0}}}),define(oe[45],ae([0,1,27,4,74]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Tl=L,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D||(e.ExtensionType=D={}));var I;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class S{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,h){if(typeof d>"u"||d===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof d=="string"||typeof h=="string"){const o=typeof d=="string"?d:d.value,$=typeof h=="string"?h:h.value;return O.$Me(o,$)}return d._lower===h._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Vl=S;class m{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const h of d)this.add(h)}add(d){this.c.add(S.toKey(d))}delete(d){return this.c.delete(S.toKey(d))}has(d){return this.c.has(S.toKey(d))}}e.$Wl=m;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(S.toKey(d))}get(d){return this.c.get(S.toKey(d))}has(d){return this.c.has(S.toKey(d))}set(d,h){this.c.set(S.toKey(d),h)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=P;function E(w){return g(w)}e.$Yl=E;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Zl=g;function l(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$1l=l;function f(w,d){if(d){const h=`onResolveRemoteAuthority:${(0,A.$Pk)(d)}`;return!!w.activationEvents?.includes(h)}return!1}e.$2l=f,e.$3l=(0,N.$Bh)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,45,12]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;class L extends O.$kc{constructor(I,S,m,P,E){super(),this.a=I,this.b=S,this.c=m,this.f=E,this.B(P.onDidInstallExtensions(g=>this.g(g))),this.B(P.onDidUninstallExtension(g=>this.h(g)))}g(I){for(const S of I)S.local&&this.invalidate(S.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,I)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Pl))}catch(S){(0,A.$jk)(S)!==1&&this.f.error(S)}}}e.$wp=L}),define(oe[213],ae([0,1,5,14,26,8,3,2,100,60,32,65,211,74]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const f=30*1e3;var w;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function d(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const k=new A.$pd;return setTimeout(()=>k.cancel(),q),k.token}function o(q,k){if(q.isCancellationRequested||k.isCancellationRequested)return A.CancellationToken.Cancelled;const R=new A.$pd;return q.onCancellationRequested(()=>R.cancel()),k.onCancellationRequested(()=>R.cancel()),R.token}class ${get didTimeout(){return this.c==="timedout"}constructor(k){this.c="pending",this.d=new I.$jc,this.promise=new Promise((R,U)=>{this.f=R,this.g=U}),k.isCancellationRequested?this.h():this.d.add(k.onCancellationRequested(()=>this.h()))}registerDisposable(k){this.c==="pending"?this.d.add(k):k.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(k))}reject(k){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(k))}}function y(q,k){const R=new $(k);return R.registerDisposable(q.onControlMessage(U=>{const M=JSON.parse(U.toString()),K=V(M);K?R.reject(K):R.resolve(M)})),R.promise}function C(q,k,R,U,M,K,Y,se){const le=new $(se),ue=m.$bd.create(!1);return q.info(`Creating a socket (${Y})...`),S.mark(`code/willCreateSocket/${K}`),k.connect(R,U,M,Y).then(he=>{le.didTimeout?(S.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${Y}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${K}`),q.info(`Creating a socket (${Y}) was successful after ${ue.elapsed()} ms.`),le.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${Y}) returned an error after ${ue.elapsed()} ms.`),q.error(he),le.reject(he)}),le.promise}function i(q,k){const R=new $(k);return q.then(U=>{R.didTimeout||R.resolve(U)},U=>{R.didTimeout||R.reject(U)}),R.promise}async function c(q,k,R,U){const M=re(q,k);q.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let K;try{K=await C(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,l.$Qk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,d(k),`renderer-${d(k)}-${q.reconnectionToken}`,U)}catch(he){throw q.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),q.logService.error(he),he}q.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let Y,se;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(K,null),Y=q.reconnectionProtocol,se=!1):(Y=new E.$ph({socket:K}),se=!0),q.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const le=await i(q.signService.createNewMessage((0,P.$4f)()),U),ue={type:"auth",auth:q.connectionToken||"00000000000000000000",data:le.data};Y.sendControl(N.$Fd.fromString(JSON.stringify(ue)));try{const he=await y(Y,o(U,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(q.logService.trace(`${M} 4/6. received SignRequest control message.`),!await i(q.signService.validate(le,he.signedData),U)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await i(q.signService.sign(he.data),U),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:k};return R&&(we.args=R),q.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(N.$Fd.fromString(JSON.stringify(we))),{protocol:Y,ownsProtocol:se}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(q.logService.error(`${M} the handshake timed out. Error:`),q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${M} received error control message when negotiating connection. Error:`),q.logService.error(he)),se&&G(Y),he}}async function n(q,k,R,U){const M=Date.now(),K=re(q,k),{protocol:Y,ownsProtocol:se}=await c(q,k,R,U),le=new $(U);return le.registerDisposable(Y.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(q.logService.error(`${K} received error control message when negotiating connection. Error:`),q.logService.error($e),se&&G(Y),le.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${X(M)}!`),le.resolve({protocol:Y,firstMessage:he}))})),le.promise}async function s(q,k){const{protocol:R}=await n(q,1,void 0,k);return{protocol:R}}async function t(q,k,R){const{protocol:U,firstMessage:M}=await n(q,2,k,R),K=M&&M.debugPort;return{protocol:U,debugPort:K}}async function r(q,k,R){const U=Date.now(),M=re(q,3),{protocol:K}=await c(q,3,k,R);return q.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${X(U)}!`),K}async function a(q,k,R){const{connectTo:U,connectionToken:M}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:U,connectionToken:M,reconnectionToken:k,reconnectionProtocol:R,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,k,R){return u(q,async U=>{const{protocol:M}=await s(U,A.CancellationToken.None);return new H(q,k,R,U.reconnectionToken,M)})}e.$Xk=v;async function b(q,k){return u(q,async R=>{const{protocol:U,debugPort:M}=await t(R,k,A.CancellationToken.None);return new x(q,k,R.reconnectionToken,U,M)})}e.$Yk=b;async function u(q,k){for(let U=1;;U++)try{const M=(0,P.$4f)(),K=await a(q,M,null);return await k(K)}catch(M){if(U<5)q.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(M);else throw q.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(M),Q.triggerPermanentFailure(0,0,g.$Mk.isHandled(M)),M}}async function p(q,k,R){const U=await a(q,(0,P.$4f)(),null);return await r(U,{host:k,port:R},A.CancellationToken.None)}e.$Zk=p;function j(q){return(0,O.$ug)(k=>new Promise((R,U)=>{const M=setTimeout(R,q*1e3);k.onCancellationRequested(()=>{clearTimeout(M),R()})}))}var F;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class T{constructor(k,R){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.type=0}}e.$1k=T;class z{constructor(k,R,U,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.durationSeconds=U,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$2k=z;class B{constructor(k,R,U){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=U,this.type=2}}e.$3k=B;class _{constructor(k,R,U){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=U,this.type=4}}e.$4k=_;class J{constructor(k,R,U,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=U,this.handled=M,this.type=3}}e.$5k=J;class Q extends I.$kc{static triggerPermanentFailure(k,R,U){this._permanentFailure=!0,this.f=k,this.g=R,this.h=U,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(k=>k.y())}static debugPauseSocketWriting(){this.j.forEach(k=>k.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(k,R,U,M,K){super(),this.t=k,this.u=R,this.reconnectionToken=U,this.protocol=M,this.w=K,this.m=this.B(new D.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new _(this.reconnectionToken,0,0)),this.B(M.onSocketClose(Y=>{const se=ne(this.t,this.reconnectionToken,!0);Y?Y.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(Y=>{const se=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,I.$ic)(()=>{const Y=Q.j.indexOf(this);Y>=0&&Q.j.splice(Y,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const k=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const M=U<R.length?R[U]:R[R.length-1];try{if(M>0){const Y=j(M);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,Y)),this.u.logService.info(`${k} waiting for ${M} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.u.logService.info(`${k} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${k} connecting to ${K.connectTo}...`),await this.G(K,h(f)),this.u.logService.info(`${k} reconnected!`),this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.u.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(g.$Mk.isTemporarilyNotAvailable(K)){this.u.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,L.$2)(K)){this.u.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof g.$Mk){this.u.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,g.$Mk.isHandled(K));break}this.u.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.n&&!this.s)}C(k,R,U){this.w?Q.triggerPermanentFailure(k,R,U):this.D(k,R,U)}D(k,R,U){this.m.fire(new J(this.reconnectionToken,k,R,U)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=Q;class H extends Q{constructor(k,R,U,M,K){super(1,k,M,K,!0),this.client=this.B(new E.$nh(K,{remoteAuthority:R,clientId:U},k.ipcLogger))}async G(k,R){await s(k,R)}}e.$7k=H;class x extends Q{constructor(k,R,U,M,K){super(2,k,U,M,!1),this.H=R,this.debugPort=K}async G(k,R){await t(k,this.H,R)}}e.$8k=x;function G(q){try{q.acceptDisconnect();const k=q.getSocket();q.dispose(),k.dispose()}catch(k){(0,L.$Y)(k)}}function V(q){if(q&&q.type==="error"){const k=new Error(`Connection error: ${q.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function W(q,k){for(;q.length<k;)q+=" ";return q}function ee(q,k){return`[remote-connection][${W(d(q),13)}][${k.substr(0,5)}\u2026]`}function ne(q,k,R){return`${ee(q,k)}[${R?"reconnect":"initial"}]`}function re(q,k){return`${ne(k,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function X(q){return`${Date.now()-q} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,N.$Bh)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(D,I){return this.a[D]??=[],this.a[D].push(I),(0,O.$ic)(()=>{const S=this.a[D]?.indexOf(I);typeof S=="number"&&S>=0&&this.a[D]?.splice(S,1)})}b(D){return(this.a[D.type]||[]).find(S=>S.supports(D))}connect(D,I,S,m){const P=this.b(D);if(!P)throw new Error(`No socket factory found for ${D}`);return P.connect(D,I,S,m)}}e.$Uk=A}),define(oe[214],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=e.$X7b=void 0,e.$X7b=(0,O.$Bh)("sharedProcessTunnelService"),e.$Y7b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=e.$87b=e.$77b=e.$67b=e.$57b=e.TunnelStates=e.$47b=e.$37b=void 0,e.$37b=(0,O.$Bh)("IRemoteTunnelService"),e.$47b={active:!1};var A;(function(L){L.disconnected=D=>({type:"disconnected",onTokenFailed:D}),L.connected=(D,I)=>({type:"connected",info:D,serviceInstallFailed:I}),L.connecting=D=>({type:"connecting",progress:D}),L.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$57b="remote.tunnels.access",e.$67b=e.$57b+".hostNameOverride",e.$77b=e.$57b+".preventSleep",e.$87b="remoteTunnelService",e.$97b=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,14,8,2,166,49,4,7,40]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,I.$Bh)("requestService");class P{constructor(C){this.b=C}toJSON(){if(!this.a){const C=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?C[i]="*****":C[i]=this.b[i];this.a=C}return this.a}}class E extends A.$kc{constructor(C){super(),this.b=0,this.a=C.createLogger("network",{name:(0,L.localize)(0,null),when:S.$jj.isEqualTo((0,S.$hj)(S.LogLevel.Trace)).serialize()})}async c(C,i,c){const n=`${C} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new P(i.headers??{}));try{const s=await c();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$8)(s)),s}}}e.$Jo=E;function g(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.$Ko=g;function l(y){return y.res.statusCode===204}e.$Lo=l;async function f(y){return l(y)?null:(await(0,O.$Rd)(y.stream)).toString()}e.$Mo=f;async function w(y){if(!g(y))throw new Error("Server returned "+y.res.statusCode);return f(y)}e.$No=w;async function d(y){if(!g(y))throw new Error("Server returned "+y.res.statusCode);if(l(y))return null;const i=(await(0,O.$Rd)(y.stream)).toString();try{return JSON.parse(i)}catch(c){throw c.message+=`:
`+i,c}}e.$Oo=d;function h(y){$(y)}e.$Po=h;let o;function $(y){const C=m.$8m.as(D.$an.Configuration),i=o;o={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},C.updateConfigurations({add:[o],remove:i?[i]:[]})}$(1)}),define(oe[215],ae([0,1,26,23,12,57]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;let D=class{constructor(S,m){this.a=S,this.b=m}async download(S,m,P=O.CancellationToken.None){if(S.scheme===N.Schemas.file||S.scheme===N.Schemas.vscodeRemote){await this.b.copy(S,m);return}const E={type:"GET",url:S.toString(!0)},g=await this.a.request(E,P);if(g.res.statusCode===200)await this.b.writeFile(m,g.stream);else{const l=await(0,L.$No)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${l}`)}}};e.$BN=D,e.$BN=D=ye([Z(0,L.$Io),Z(1,A.$6j)],D)}),define(oe[216],ae([0,1,14,26]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class A{constructor(I){this.a=I}listen(I,S){throw new Error("Invalid listen")}call(I,S,m,P=N.CancellationToken.None){switch(S){case"request":return this.a.request(m[0],P).then(async({res:E,stream:g})=>{const l=await(0,O.$Rd)(g);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.$Lq=A;class L{constructor(I){this.a=I}async request(I,S){const[m,P]=await this.a.call("request",[I],S);return{res:m,stream:(0,O.$Td)(P)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.$Mq=L}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=e.$r6b=e.$q6b=void 0,e.$q6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$r6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$s6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s2b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const L=await this.c();if(L){const D=String(O.a++);return this.b.set(D,L),{id:D,data:L.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,L){if(!A.id)return!0;const D=this.b.get(A.id);if(!D)return!1;this.b.delete(A.id);try{return D.validate(L)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$s2b=O}),define(oe[106],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,O.$Bh)(e.$Vk)}),define(oe[219],ae([0,1,218]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=void 0;class N extends O.$s2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(D=>new D.signer().sign(L))}h(){return new Promise((L,D)=>te(["vsda"],L,D))}}e.$e7b=N}),define(oe[75],ae([0,1,3,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bAb=e.$aAb=e.$_zb=e.$$zb=void 0;class A extends N.$kc{constructor(E,g,l){super(),this.a=E,this.b=g,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},g=await this.a.call("getItems",E);return new Map(g)}updateItems(E){const g={profile:this.b,workspace:this.c};return E.insert&&(g.insert=Array.from(E.insert.entries())),E.delete&&(g.delete=Array.from(E.delete.values())),this.a.call("updateItems",g)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class L extends A{constructor(E,g){super(E,g,void 0),this.f=this.B(new O.$fd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class D extends L{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$$zb=D;class I extends L{constructor(E,g){super(E,g)}async close(){this.dispose()}}e.$_zb=I;class S extends A{constructor(E,g){super(E,void 0,g),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$aAb=S;class m{constructor(E){this.a=E}isUsed(E){const g={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.$bAb=m}),define(oe[107],ae([0,1,6,37,32]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function L(S){if(O.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function D(S,m,P,E,g,l,f,w){const d=Object.create(null);d["common.machineId"]=l,d.sessionID=(0,A.$4f)()+Date.now(),d.commitHash=E,d.version=g,d["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,O.$h)(O.$t),d["common.nodePlatform"]=N.$3d,d["common.nodeArch"]=P,d["common.product"]=w||"desktop",f&&(d["common.msftInternal"]=f);let h=0;const o=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),O.$l&&(d["common.snap"]="true");const $=L(m);return $&&(d["common.platformDetail"]=$),d}e.$0n=D;function I(S){const m=N.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return S.some(E=>P===E)}e.$$n=I}),define(oe[22],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,O.$Bh)("telemetryService"),e.$0k=(0,O.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[220],ae([0,1,36,5,34,23,16,6,11,132,31,146,95,12,24,22]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0;const d=new Map;async function h(i,c){const n=`${i}::${c.join(":")}`,s=d.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function b(p,j,F,T){const z=j.substring(p.length+1);return N.Promises.withAsyncBody(async B=>{let _;try{_=await P.Promises.readdir(j,{withFileTypes:!0})}catch{B();return}if(T.count>=v){T.count+=_.length,T.maxReached=!0,B();return}let J=_.length;if(J===0){B();return}let Q=_;T.count+_.length>v&&(T.maxReached=!0,J=v-T.count,Q=_.slice(0,J)),T.count+=_.length;for(const H of Q)if(H.isDirectory()){if(F.includes(H.name)||await b(p,(0,D.$9d)(j,H.name),F,T),--J===0){B();return}}else{const x=H.name.lastIndexOf(".");if(x>=0){const G=H.name.substring(x+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of t)G.relativePathPattern?.test(z)!==!1&&G.filePattern.test(H.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--J===0){B();return}}})}const u=N.Promises.withAsyncBody(async p=>{const j={count:0,maxReached:!1};await b(i,i,c,j);const F=await y(i);p({configFiles:o(a),fileTypes:o(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F})});return d.set(n,u),u}e.$tr=h;function o(i){return Array.from(i.entries(),([c,n])=>({name:c,count:n})).sort((c,n)=>n.count-c.count)}function $(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/l.$Ak.GB).toFixed(2)}GB (${(O.freemem()/l.$Ak.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.$Hm.value()*100)}%`},c=O.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}e.$ur=$;async function y(i){try{const c=new Map,n=(0,D.$9d)(i,".vscode","launch.json"),s=await P.Promises.readFile(n),t=[],r=(0,A.$Lm)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$Um)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(c.has(v)?c.set(v,c.get(v)+1):c.set(v,1))}return o(c)}catch{return[]}}e.$vr=y;let C=class{constructor(c,n){this.c=c,this.d=n}f(c){const n=[];return n.push(`OS Version:       ${c.os}`),n.push(`CPUs:             ${c.cpus}`),n.push(`Memory (System):  ${c.memory}`),n.push(`VM:               ${c.vmHint}`),n.join(`
`)}g(c){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/l.$Ak.GB).toFixed(2)}GB (${(O.freemem()/l.$Ak.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(m.$Hm.value()*100)}%`),n.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${c.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(c,n){return Promise.all([(0,E.$sr)(c.mainPID),this.k(c)]).then(async s=>{let[t,r]=s,a=this.m(c,t);return n.forEach(v=>{if((0,g.$hm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(c,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const b of Object.keys(v.workspaceMetadata)){const u=v.workspaceMetadata[b];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${b}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(c,n){const{memory:s,vmHint:t,os:r,cpus:a}=$(),v={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(v.load=`${O.loadavg().map(b=>Math.round(b)).join(", ")}`),I.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(c,n){const s=[];return(0,E.$sr)(c.mainPID).then(async t=>(s.push(""),s.push(this.g(c)),s.push(""),s.push(this.m(c,t)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(c))),n.forEach(r=>{if((0,g.$hm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(c,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let b=`${v.fileCount} files`;v.maxFilesReached&&(b=`more than ${b}`),s.push(`Folder (${a}): ${b}`),s.push(this.h(v))}}),s.push(""),s.push(""),s.join(`
`)))}h(c){const n=[];let t=0;const r=(u,p)=>{const j=` ${u}(${p})`;t+j.length>60?(n.push(a),a="|                 ",t=a.length):t+=j.length,a+=j};let a="|      File types:";const v=10,b=c.fileTypes.length>v?v:c.fileTypes.length;for(let u=0;u<b;u++){const p=c.fileTypes[u];r(p.name,p.count)}if(n.push(a),c.configFiles.length>=0&&(a="|      Conf files:",t=0,c.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(a)),c.launchConfigFiles.length>0){let u="|      Launch Configs:";c.launchConfigFiles.forEach(p=>{const j=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=j}),n.push(u)}return n.join(`
`)}j(c){const n=Math.max(...Object.keys(c).map(s=>s.length));return Object.keys(c).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${c[s]}`).join(`
                  `)}k(c){const n=[],s=[];return c.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===L.Schemas.file){const v=a.fsPath;s.push(h(v,["node_modules",".git"]).then(b=>{let u=`${b.fileCount} files`;b.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,D.$ae)(v)}): ${u}`),n.push(this.h(b))}).catch(b=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${b.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(c,n){const s=new Map;c.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(c.mainPID,s,t,n,0),t.join(`
`)}n(c,n,s,t,r){const a=r===0;let v;a?v=t.pid===c?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const b=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(b/l.$Ak.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(c,n,s,u,r+1))}async getWorkspaceFileExtensions(c){const n=new Set;for(const{uri:s}of c.folders){const t=S.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(c){for(const{uri:n}of c.folders){const s=S.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$wr=C,e.$wr=C=ye([Z(0,w.$9k),Z(1,f.$kj)],C)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=void 0;class O{constructor(L){this.b=L}listen(L,D){throw new Error(`Event not found: ${D}`)}call(L,D,{eventName:I,data:S}){return this.b.forEach(m=>m.log(I,S)),Promise.resolve(null)}}e.$v6b=O;class N{constructor(L){this.b=L}log(L,D){return this.b.call("log",{eventName:L,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$w6b=N}),define(oe[46],ae([0,1,30,9,3,19,74,107,22]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class m{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$_n=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=P,e.$bo=new P;class E{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$co=E,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function g(s,t){return A.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const b=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:b}},1e3,!0)(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.$$h)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$go=g;function l(s,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!s.enableTelemetry||t.extensionTestsLocationURI)}e.$ho=l;function f(s,t){return!(t.isBuilt||t.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$io=f;function w(s){const t=s.getValue(S.$dl),r=s.getValue(S.$el);if(s.getValue(S.$fl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=w;function d(s){const t={},r={},a={};$(s,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const b=a[v];typeof b=="number"?r[v]=b:typeof b=="boolean"?r[v]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${b.length}`),t[v]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(t[v]=b)}return{properties:t,measurements:r}}e.$ko=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(s){if(!s)return"none";const t=(0,D.$Pk)(s);return h.has(t)?t:"other"}e.$lo=o;function $(s,t,r=0,a){if(s)for(const v of Object.getOwnPropertyNames(s)){const b=s[v],u=a?a+v:v;Array.isArray(b)?t[u]=(0,O.$1m)(b):b instanceof Date?t[u]=b.toISOString():(0,N.$lf)(b)?r<2?$(b,t,r+1,u+"."):t[u]=(0,O.$1m)(b):t[u]=b}}function y(s,t){const r=s.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,I.$$n)(r)||a}e.$mo=y;function C(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$no=C;function i(s,t){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const a=[];for(const p of t)for(;;){const j=p.exec(s);if(!j)break;a.push([j.index,p.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const p=b.exec(s);if(!p)break;const j=a.some(([F,T])=>p.index<T&&F<b.lastIndex);!v.test(p[0])&&!j&&(r+=s.substring(u,p.index)+"<REDACTED: user-file-path>",u=b.lastIndex)}return u<s.length&&(r+=s.substr(u)),r}function c(s){if(!s)return s;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,t){return(0,O.$Xm)(s,r=>{if(r instanceof m||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=i(a,t);for(const v of t)a=a.replace(v,"");return a=c(a),a}})}e.$oo=n}),define(oe[33],ae([0,1,27,29,45,6,11,8,37,46]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function P(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$He)(n.id,s.id)===0}e.$po=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,t,r)}static parse(s){const t=E.exec(s);return t&&t[1]&&t[2]?new g({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$qo=g;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const s=l.exec(n);return s&&s[1]?[d(s[1]),s[2]]:[d(n),void 0]}e.$ro=f;function w(n,s){return`${n}.${s}`}e.$so=w;function d(n){return n.toLowerCase()}e.$to=d;function h(n,s){return d(w(n??A.$Rl,s))}e.$uo=h;function o(n,s){const t=[],r=a=>{for(const v of t)if(v.some(b=>P(s(b),s(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$vo=o;function $(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$wo=$;function y(n){return{id:new m.$_n(n.identifier.id),name:new m.$_n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$xo=y,e.$yo=new A.$Vl("pprice.better-merge");function C(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!P(v.identifier,{id:a}))){const v=n.filter(b=>P(b.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$zo=C;async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$8)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(n,s){const t=await i(n,s),r=(0,N.$Un)(t?"alpine":L.$t,S.$4d);return s.debug("ComputeTargetPlatform:",r),r}e.$Ao=c}),define(oe[221],ae([0,1,18,2,21,11,12,24,5,3,16,6,37,33]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y4b=e.$x4b=void 0;let f=class extends N.$kc{constructor($,y){super(),this.b=$,this.c=y,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,C])=>this.a.set(C.configPath,C))}getConfigBasedTips($){return this.f($)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f($){const y=[];for(const[C,i]of this.a)if(!(i.configScheme&&i.configScheme!==$.scheme))try{const c=(await this.b.readFile((0,A.$ig)($,C))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(c))&&y.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return y}};e.$x4b=f,e.$x4b=f=ye([Z(0,D.$6j),Z(1,I.$kj)],f);const w="extensionTips/promptedExecutableTips",d="extensionTips/lastPromptedMediumImpExeTime";class h extends f{constructor($,y,C,i,c,n,s,t){super(s,t),this.r=$,this.s=y,this.t=C,this.u=i,this.w=c,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],b=[],u=[];Object.entries(a.recommendations).forEach(([p,j])=>{j.important?a.important?v.push({extensionId:p,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):b.push({extensionId:p,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):u.push({extensionId:p,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),b.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),this.B((0,S.$Ig)(async()=>{await this.C(),this.F(),this.G()},3e3))}async getImportantExecutableBasedTips(){const $=await this.O(this.g),y=await this.O(this.h);return[...$,...y]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const $=await this.O(this.g),y=await this.O(this.h),C=await this.u.getInstalled();this.m=this.D($,C),this.n=this.D(y,C)}D($,y){const C=new Map;$.forEach(t=>C.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:c}=this.N([...C.keys()],y);for(const t of i){const r=C.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of c){const r=C.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of c){const r=C.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[$,y]=[...this.m.entries()][0];this.H(y).then(C=>{switch(C){case"reacted":this.M(y[0].exeName,y);break;case"ignored":this.m.delete($);break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B((0,S.$Ig)(()=>{i.dispose(),this.F()},36e5));break}}})}G(){if(this.n.size===0)return;const $=this.I(),y=Date.now()-$,C=7*24*60*60*1e3;if(y<C){const n=this.B((0,S.$Ig)(()=>{n.dispose(),this.G()},C-y));return}const[i,c]=[...this.n.entries()][0];this.H(c).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(c[0].exeName,c);const s=this.B((0,S.$Ig)(()=>{s.dispose(),this.G()},C));break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=m.Event.once(m.Event.latch(m.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B((0,S.$Ig)(()=>{s.dispose(),this.G()},36e5));break}}})}async H($){const y=await this.u.getInstalled(1),C=$.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(c=>y.every(n=>!(0,l.$po)(n.identifier,{id:c})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:C,source:3,name:$[0].exeFriendlyName,searchValue:`@exe:"${$[0].exeName}"`})}I(){let $=this.w.getNumber(d,-1);return $||($=Date.now(),this.J($)),$}J($){this.w.store(d,$,-1,1)}L(){return JSON.parse(this.w.get(w,-1,"{}"))}M($,y){const C=this.L();C[$]=y.map(({extensionId:i})=>i.toLowerCase()),this.w.store(w,JSON.stringify(C),-1,0)}N($,y){const C=[],i=[],c=y.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return $.forEach(n=>{c.has(n.toLowerCase())?C.push(n):i.push(n)}),{installed:C,uninstalled:i}}async O($){const y=[],C=new Map;for(const i of $.keys()){const c=$.get(i);if(!c||!(0,O.$Jb)(c.recommendations))continue;const n=[];E.$i?c.windowsPath&&n.push(c.windowsPath.replace("%USERPROFILE%",()=>g.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>g.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>g.env.ProgramFiles).replace("%APPDATA%",()=>g.env.APPDATA).replace("%WINDIR%",()=>g.env.WINDIR)):(n.push((0,P.$9d)("/usr/local/bin",i)),n.push((0,P.$9d)("/usr/bin",i)),n.push((0,P.$9d)(this.r.fsPath,i)));for(const s of n){let t=C.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),C.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:b}of c.recommendations)y.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:i,exeFriendlyName:c.exeFriendlyName,windowsPath:c.windowsPath,whenNotInstalled:b})}}return y}}e.$y4b=h}),define(oe[222],ae([0,1,26,33]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Ub=void 0;async function A(L,D,I,S,m){try{const P=await L.getExtensionsControlManifest();if(!P.deprecated)return;const E=await L.getInstalled(1);for(const[g,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:f,autoMigrate:w,preRelease:d}=l.extension;if(!w)continue;const h=E.find($=>(0,N.$po)($.identifier,{id:g}));if(!h)continue;const o=(await D.getExtensions([{id:f,preRelease:d}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!o){m.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{m.info(`Migrating '${h.identifier.id}' extension to '${f}' extension...`);const $=!S.getDisabledExtensions().some(C=>(0,N.$po)(C,h.identifier));await L.uninstall(h),m.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let y=E.find(C=>(0,N.$po)(C.identifier,{id:f}));(!y||!y.isPreReleaseVersion&&$)&&(y=await L.installFromGallery(o,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${y.identifier.id}'`),$||(await S.disableExtension(y.identifier),m.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),w.storage&&(I.addToMigrationList((0,N.$so)(h.manifest.publisher,h.manifest.name),(0,N.$so)(y.manifest.publisher,y.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${h.identifier.id}' extension to '${f}' extension.`)}catch($){m.error($)}}}catch(P){m.error(P)}}e.$4Ub=A}),define(oe[223],ae([0,1,3,2,35,33,45]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class I extends N.$kc{constructor(m,P,E,g,l,f,w){super(),this.f=m,this.g=P,this.h=E,this.j=g,this.m=l,this.n=f,this.r=w,this.a=this.B(new O.$fd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$sc),this.s().then(null,d=>w.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(m=>this.u(m.added))),this.B(this.j.onAddExtensions(m=>this.w(m))),this.B(this.j.onDidAddExtensions(m=>this.y(m))),this.B(this.j.onRemoveExtensions(m=>this.z(m))),this.B(this.j.onDidRemoveExtensions(m=>this.C(m))),this.B(this.n.onDidFilesChange(m=>this.D(m)))}async u(m){try{m.length&&await Promise.all(m.map(P=>(this.c.set(P.id,(0,N.$hc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(m){for(const P of m.extensions)this.I(this.L(P.identifier,P.version),m.profileLocation)}async y(m){for(const P of m.extensions){const E=this.L(P.identifier,P.version);m.error?this.J(E,m.profileLocation):this.I(E,m.profileLocation)}}async z(m){for(const P of m.extensions)this.J(this.L(P.identifier,P.version),m.profileLocation)}async C(m){const P=[],E=[];for(const g of m.extensions){const l=this.L(g.identifier,g.version);m.error?this.I(l,m.profileLocation):(this.J(l,m.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),E.push(this.f.scanInstalledExtensionAtLocation(g.location).then(f=>{f?P.push(f):this.r.info("Extension not found at the location",g.location.toString())},f=>this.r.error(f)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch(g){this.r.error(g)}}D(m){for(const P of this.h.profiles)m.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(m){const P=[],E=[],g=await this.j.scanProfileExtensions(m),l=new Set,f=new Set;for(const[w,d]of this.b)d.has(m)&&f.add(w);for(const w of g){const d=this.L(w.identifier,w.version);l.add(d),f.has(d)||(P.push(w.identifier),this.I(d,m))}for(const w of f)if(!l.has(w)){const d=this.M(w);d&&(E.push(d.identifier),this.J(w,m))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:m}:void 0,removed:E.length?{extensions:E,profileLocation:m}:void 0})}async G(m){const P=await this.j.scanProfileExtensions(m);for(const E of P)this.I(this.L(E.identifier,E.version),m)}async H(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}I(m,P){let E=this.b.get(m);E||this.b.set(m,E=new A.$Ai(g=>this.m.extUri.getComparisonKey(g))),E.add(P)}J(m,P){const E=this.b.get(m);E&&E.delete(P),E?.size||this.b.delete(m)}L(m,P){return`${D.$Vl.toKey(m.id)}@${P}`}M(m){const[P,E]=(0,L.$ro)(m);return E?{identifier:{id:P},version:E}:void 0}}e.$xp=I}),define(oe[224],ae([0,1,44,46]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function A(L,D,I,S,m,P,E){const g={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${D.nameShort})`};if((0,N.$ho)(D,I)&&(0,N.$jo)(S)===3){const l=await(0,O.$2o)(I,m,P);g["X-Market-User-Id"]=l,g["VSCode-SessionId"]=E.machineId||l}return g}e.$3o=A}),define(oe[225],ae([0,1,69,18,5,2,23,16,31,15,29,33,7,72,11]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;let w=class extends l.$Jq{constructor($,y,C,i){super(C),this.h=$,this.j=i,this.g=this.B(new d(y,i)),this.h.registerParticipant({postInstall:async c=>this.m(c),postUninstall:async c=>this.n(c)})}async getBuiltInExtensionTranslationsUri($,y){const i=(await this.g.getLanguagePacks())[y];if(!i){this.j.warn(`No language pack found for ${y}`);return}const c=i.translations[$];return c?f.URI.file(c):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),y=Object.keys($).map(C=>{const i=$[C];return{...this.f(C,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((C,i)=>C.label.localeCompare(i.label)),y}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const y=await this.g.getLanguagePacks();Object.keys(y).some(C=>y[C]&&y[C].extensions.some(i=>(0,E.$po)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),C=await this.g.update(y);return!(0,N.$sb)(Object.keys($),Object.keys(C))}};e.$Kq=w,e.$Kq=w=ye([Z(0,P.$2n),Z(1,m.$Jh),Z(2,P.$Zn),Z(3,g.$5i)],w);let d=class extends L.$kc{constructor($,y){super(),this.j=y,this.c={},this.f=(0,I.$9d)($.userDataPath,"languagepacks.json"),this.g=new A.$Ng}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(y=>{Object.keys(y).forEach(C=>delete y[C]),this.m(y,...$)}).then(()=>this.c)}m($,...y){for(const C of y)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.n($,C);Object.keys($).forEach(C=>this.r($[C]))}n($,y){const C=y.identifier,i=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const c of i)if(y.location.scheme===D.Schemas.file&&h(c)){let n=$[c.languageId];n||(n={hash:"",extensions:[],translations:{},label:c.localizedLanguageName??c.languageName},$[c.languageId]=n);const s=n.extensions.filter(t=>(0,E.$po)(t.extensionIdentifier,C))[0];s?s.version=y.manifest.version:n.extensions.push({extensionIdentifier:C,version:y.manifest.version});for(const t of c.translations)n.translations[t.id]=(0,I.$9d)(y.location.fsPath,t.path)}}r($){if($){const y=(0,O.createHash)("md5");for(const C of $.extensions)y.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);$.hash=y.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let y=null;return S.Promises.readFile(this.f,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(y=$(C),C)).then(C=>{for(const c of Object.keys(C))C[c]||delete C[c];this.c=C,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),S.Promises.writeFile(this.f,i)}).then(()=>y,C=>this.j.error(C))})}};d=ye([Z(0,m.$Jh),Z(1,g.$5i)],d);function h(o){if(typeof o.languageId!="string"||!Array.isArray(o.translations)||o.translations.length===0)return!1;for(const $ of o.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(o.languageName&&typeof o.languageName!="string"||o.localizedLanguageName&&typeof o.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,143,8,30,46]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function S(P,E,g){const l=await(0,O.$aD)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,O.$aD)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new l.AppInsightsCore,d=new f.PostChannel,h={instrumentationKey:P,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(g){h.extensionConfig={};const o={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[d.identifier]=o}return w.initialize(h,[]),w.addTelemetryInitializer(o=>{E&&(o.ext=o.ext??{},o.ext.utc=o.ext.utc??{},o.ext.utc.flags=8462029)}),w}class m{constructor(E,g,l,f,w){this.e=E,this.f=g,this.g=l,this.h=w,this.c=D,this.d=I,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(g=>{E(g)},g=>{(0,N.$Y)(g),console.error(g)})}}log(E,g){if(!this.a)return;g=(0,A.$Ym)(g,this.g),g=(0,L.$ko)(g);const l=this.f+"/"+E;try{this.i(f=>{f.pluginVersionString=g?.properties.version??"Unknown",f.track({name:l,baseData:{name:l,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$_M=m}),define(oe[109],ae([0,1,2,167,15,7,24,46]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y3b=void 0;let S=class extends O.$kc{constructor(P,E,g,l,f=""){super(),this.b=f;const w=E.getLogger(I.$do);if(w)this.a=this.B(w);else{const h=(0,I.$io)(l,g)?" (Not Sent)":"",o=()=>(0,I.$ho)(l,g)&&P.getLevel()===L.LogLevel.Trace;this.a=this.B(E.createLogger(I.$do,{name:(0,N.localize)(0,null,h),hidden:!o()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(I.$do,o()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,I.$ko)(E))}};e.$Y3b=S,e.$Y3b=S=ye([Z(0,L.$5i),Z(1,L.$6i),Z(2,A.$Ih),Z(3,D.$kj)],S)}),define(oe[110],ae([0,1,2,30,6,27,168,19,49,102,24,40,22,46]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,o,$){this.k=o,this.l=$,this.d={},this.i=new O.$jc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,L.$qe)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$qe)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(g.$dl)||y.affectsConfiguration(g.$fl)||y.affectsConfiguration(g.$el))&&this.m()}))}setExperimentProperty(h,o){this.d[h]=o}m(){let h=(0,l.$jo)(this.k);const o=this.l.enabledTelemetryLevels;if(o){this.h=this.sendErrorTelemetry?o.error:!1;const $=o.usage?3:o.error?2:0;h=Math.min(h,$)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,o,$){this.g<o||($=(0,N.$Ym)($,this.d),$=(0,l.$oo)($,this.j),$=(0,N.$Ym)($,this.c),this.b.forEach(y=>y.log(h,$)))}publicLog(h,o){this.n(h,3,o)}publicLog2(h,o){this.publicLog(h,o)}publicLogError(h,o){this.h&&this.n(h,2,o)}publicLogError2(h,o){this.publicLogError(h,o)}};e.$Qq=f,e.$Qq=f=ye([Z(1,I.$8h),Z(2,P.$kj)],f);function w(){const d=(0,D.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),o=A.$o?"":(0,D.localize)(3,null),$=(0,D.localize)(4,null),y=(0,D.localize)(5,null),C=(0,D.localize)(6,null),i=(0,D.localize)(7,null),c=`
|       | ${$} | ${y} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${d} ${h} ${o}

&nbsp;

${i}
${c}

&nbsp;

${n}
`}E.$8m.as(S.$an.Configuration).registerConfiguration({id:g.$cl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[g.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$8m.as(S.$an.Configuration).registerConfiguration({id:g.$cl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[g.$fl]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,D.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,D.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${g.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,14,26,272,226]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=void 0;async function D(P,E){const g=await E.request(P,N.CancellationToken.None),l=(await(0,O.$Rd)(g.stream)).toString(),f=g.res.statusCode??200;return{headers:g.res.headers,statusCode:f,responseData:l}}async function I(P){const E={method:P.type,headers:P.headers};return new Promise((l,f)=>{const w=A.request(P.url??"",E,d=>{d.on("data",function(h){l({headers:d.headers,statusCode:d.statusCode??200,responseData:h.toString()})}),d.on("error",function(h){f(h)})});w.write(P.data,d=>{d&&f(d)}),w.end()})}async function S(P,E,g){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),f={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const w=P?await D(f,P):await I(f);g(w.statusCode,w.headers,w.responseData)}catch{g(0,{})}}class m extends L.$_M{constructor(E,g,l,f,w){const d={sendPOST:(h,o)=>{S(E,h,o)}};super(g,l,f,w,d)}}e.$aN=m}),define(oe[228],ae([0,1,23,93,19,15,7,24,22,108,109,110]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0;let g=class{constructor(f,w,d,h,o,$){this.b=f,this.c=w,this.d=d,this.e=h,this.f=o,this.g=$,this.a=new Map}h(f){if(!this.a.has(f.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.c.machineId,w["common.vscodesessionid"]=this.c.sessionId;const d=[f.id,JSON.stringify(w),f.aiKey],o=new N.$Sp(O.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),$=[new m.$w6b(o),new P.$Y3b(this.d,this.e,this.f,this.g,`[${f.id}] `)];this.a.set(f.id,new E.$Qq({appenders:$,sendErrorTelemetry:f.sendErrorTelemetry},this.b,this.g))}return this.a.get(f.id)}publicLog(f,w,d){this.h(f).publicLog(w,d)}publicLogError(f,w,d){this.h(f).publicLogError(w,d)}};e.$M7b=g,e.$M7b=g=ye([Z(0,A.$8h),Z(1,S.$9k),Z(2,D.$5i),Z(3,D.$6i),Z(4,L.$Ih),Z(5,I.$kj)],g)}),define(oe[76],ae([0,1,3,19,4,7]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.ProvidedOnAutoForward=e.$Yz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xz=e.$Wz=void 0,e.$Wz=(0,A.$Bh)("tunnelService"),e.$Xz=(0,A.$Bh)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D||(e.TunnelProtocol=D={}));var I;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(I||(e.TunnelPrivacyId=I={}));function S(d){return!!d.forwardPort}e.$Yz=S;var m;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(h)return{address:h[1],port:+h[2]}}e.$Zz=P,e.$1z=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(d){return e.$1z.indexOf(d)>=0}e.$2z=E,e.$3z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(d){return e.$3z.indexOf(d)>=0}e.$4z=g;function l(d,h,o,$){if(o===1)return!1;if(o===2&&g(h)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(y?.length===4&&parseInt(y[1])>=18)return!1}return d<1024}e.$5z=l;class f{constructor(h,o,$){this.remoteAddress=h,this.localAddress=o,this.b=$,this.a=new O.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6z=f;let w=class{constructor(h,o){this.j=h,this.k=o,this.a=new O.$fd,this.onTunnelOpened=this.a.event,this.b=new O.$fd,this.onTunnelClosed=this.b.event,this.c=new O.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],o=Array.from(this.e.values());for(const $ of o){const y=Array.from($.values());for(const C of y){const i=await C.value;i&&typeof i!="string"&&h.push(i)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:o}of h.values())await o.then($=>typeof $!="string"?$?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,o,$,y,C){this.p(h,o,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:o,localAddress:$,privacy:y,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,o){(g(h)||E(h))&&(h=e.$1z[0]);const $=this.r(h,o);if($)return++$.refcount,$.value}openTunnel(h,o,$,y,C,i=!1,c,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${$} on local port ${C}.`);const s=this.f??h;if(!s)return;if(o||(o="localhost"),y||(y=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(s,o,$,y,C,i,c,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(o,$),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(o,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==o||r.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const o=this.e.get(h.tunnelRemoteHost);if(o){const $=o.get(h.tunnelRemotePort);$&&($.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,$))}}}}async o(h,o,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${o}.`);const y=$.value.then(async C=>{C&&typeof C!="string"&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(o),y}}async closeTunnel(h,o){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${o} `);const $=this.e.get(h);if($&&$.has(o)){const y=$.get(o);y.refcount=0,await this.o(h,o,y)}}p(h,o,$){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(o,{refcount:1,value:$})}async q(h,o){const $=this.e.get(h);if($){const y=$.get(o),C=y?await y.value:void 0;(!C||typeof C=="string")&&$.delete(o),$.size===0&&this.e.delete(h)}}r(h,o){const $=[h];E(h)?($.push(...e.$1z),$.push(...e.$3z)):g(h)&&$.push(...e.$3z);const y=$.map(C=>this.e.get(C));for(const C of y){const i=C?.get(o);if(i)return i}}canTunnel(h){return!!P(h)}t(h,o,$,y,C,i,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${$} on local port ${y}.`);const n=$;this.i.add(n);const s=y===void 0?$:y,t={elevationRequired:C?this.isPortPrivileged(s):!1},r={remoteAddress:{host:o,port:$},localAddressPort:y,privacy:i,public:i?i!==I.Private:void 0,protocol:c},a=h.forwardPort(r,t);return a?(this.p(o,$,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$7z=w,e.$7z=w=ye([Z(0,L.$5i),Z(1,N.$8h)],w)}),define(oe[229],ae([0,1,7,76,2,8,5]),function(te,e,O,N,A,L,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;class S extends A.$kc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$2g),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let m=class extends A.$kc{static{I=this}static{this.a=0}constructor(E,g){super(),this.f=E,this.g=g,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(E,g,l,f,w,d,h){const o=new S,$=await Promise.resolve(this.f.openTunnel(E,o,l,f,w,d,h));if(!$||typeof $=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${f} (remote).`),o.dispose(),new Error("Could not create tunnel");if(this.c.has(g))throw this.c.delete(g),o.dispose(),await $.dispose(),(0,L.$4)();return o.setTunnel($),this.b.set(g,o),this.g.info(`[SharedProcessTunnelService] Created tunnel ${g}: ${$.localAddress} (local) to ${l}:${f} (remote).`),{tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress}}async setAddress(E,g){const l=this.b.get(E);l&&l.setAddress(g)}async destroyTunnel(E){const g=this.b.get(E);if(g){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await g.dispose();return}this.c.add(E)}};e.$Z7b=m,e.$Z7b=m=I=ye([Z(0,N.$Xz),Z(1,O.$5i)],m)}),define(oe[28],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,O.$Bh)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,12,21,128,3,2]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class m{static{this._clock=0}constructor(g){this.uri=g,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let P=class{constructor(g){this.g=g,this.c=new S.$jc,this.f=2**16;const l=new Map,f=w=>{let d=l.get(w.scheme);return d===void 0&&(d=g.hasProvider(w)&&!this.g.hasCapability(w,1024),l.set(w.scheme,d)),d};this.c.add(I.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(w=>{l.delete(w.scheme)})),this.extUri=new L.$0f(f),this.d=new D.$or((w,d)=>this.extUri.compare(w,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,L.$jg)(g));const l=this.d.get(g);return l?l.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new m(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((f,w)=>f[1].time<w[1].time?1:f[1].time>w[1].time?-1:0);m._clock=0,this.d.clear();const l=this.f*.5;for(let f=0;f<l;f++)this.d.set(g[f][0],g[f][1].touch())}};e.$pr=P,e.$pr=P=ye([Z(0,A.$6j)],P),(0,N.$mr)(O.$Ck,P,1)}),define(oe[231],ae([0,1,3,2,12,42,47,14,9,35]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class P extends N.$kc{get capabilities(){return this.g.capabilities&-5}constructor(g,l,f,w,d,h){super(),this.f=g,this.g=l,this.h=f,this.j=w,this.m=h,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$fd),this.onDidChangeFile=this.a.event,this.b=D.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new m.$Ai(o=>d.extUri.getComparisonKey(this.s(o))),this.n(),this.B(w.onDidChangeProfiles(()=>this.n())),this.B(this.g.onDidChangeFile(o=>this.r(o)))}n(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}watch(g,l){this.b.set(g,g);const f=this.g.watch(this.s(g),l);return(0,N.$ic)(()=>{this.b.delete(g),f.dispose()})}stat(g){return this.g.stat(this.s(g))}mkdir(g){return this.g.mkdir(this.s(g))}rename(g,l,f){return this.g.rename(this.s(g),this.s(l),f)}readFile(g){return this.g.readFile(this.s(g),{atomic:!0})}readFileStream(g,l,f){const w=(0,L.$td)(d=>I.$Fd.concat(d.map(h=>I.$Fd.wrap(h))).buffer);return(async()=>{try{const d=await this.readFile(g);w.end(d)}catch(d){w.error(d),w.end()}})(),w}readdir(g){return this.g.readdir(this.s(g))}writeFile(g,l,f){return this.c.has(g)&&!(0,S.$lf)(f.atomic)&&(0,A.$bk)(this.g)&&(f={...f,atomic:{postfix:".vsctmp"}}),this.g.writeFile(this.s(g),l,f)}delete(g,l){return this.g.delete(this.s(g),l)}copy(g,l,f){if((0,A.$9j)(this.g))return this.g.copy(this.s(g),this.s(l),f);throw new Error("copy not supported")}r(g){const l=[];for(const f of g){if(f.resource.scheme!==this.f)continue;const w=this.t(f.resource);this.b.findSubstr(w)&&l.push({resource:w,type:f.type})}l.length&&(this.m.debug("User data changed"),this.a.fire(l))}s(g){return g.with({scheme:this.f})}t(g){return g.with({scheme:this.h})}}e.$h7b=P}),define(oe[77],ae([0,1,85]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rzb=e.$Qzb=e.edit=void 0;function N(D,I,S,m){const P=(0,O.$BS)(D,I,S,m)[0];return P&&(D=D.substring(0,P.offset)+P.content+D.substring(P.offset+P.length)),D}e.edit=N;function A(D,I,S){let m=S;for(;m>=0;){if(D.charAt(m)===I.charAt(I.length-1)&&I.length===1)return m+1;if(m--,I.length===2&&m>=0&&D.charAt(m)===I.charAt(0))return m+2}return 0}e.$Qzb=A;function L(D,I,S){let m=S;for(;m>=0;)if(D.charAt(m)===I.charAt(I.length-1)&&I.length===1||(m++,I.length===2&&m>=0&&D.charAt(m)===I.charAt(1)))return m;return D.length-1}e.$Rzb=L}),define(oe[232],ae([0,1,30,53,9]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G2b=void 0;function L(l,f,w,d,h,o){const $=[],y=[],C=[];if(!f){const B=l.filter(({identifier:_})=>h.every(J=>J.toLowerCase()!==_.id.toLowerCase()));return{local:{added:$,removed:y,updated:C},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}l=l.map(E),f=f.map(E),w=w?w.map(E):null;const i=new Map,c=B=>{B.uuid&&i.set(B.id.toLowerCase(),B.uuid)};l.forEach(({identifier:B})=>c(B)),f.forEach(({identifier:B})=>c(B)),w?.forEach(({identifier:B})=>c(B));const n=B=>{const _=B.identifier.uuid||i.get(B.identifier.id.toLowerCase());return _?`uuid:${_}`:`id:${B.identifier.id.toLowerCase()}`},s=(B,_)=>(B.set(n(_),_),B),t=l.reduce(s,new Map),r=f.reduce(s,new Map),a=f.reduce((B,_)=>s(B,(0,O.$Vm)(_)),new Map),v=w?w.reduce(s,new Map):null,b=d.reduce(s,new Map),u=h.reduce((B,_)=>{const J=i.get(_.toLowerCase());return B.add(J?`uuid:${J}`:`id:${_.toLowerCase()}`)},new Set),p=o?o.reduce((B,{id:_,uuid:J})=>(J=J??i.get(_.toLowerCase()),B.add(J?`uuid:${J}`:`id:${_.toLowerCase()}`)),new Set):null,j=D(t,r,u,!1);if(j.added.size>0||j.removed.size>0||j.updated.size>0){const B=D(v,t,u,!1),_=D(v,r,u,!0),J=(Q,H,x,G)=>{let V,W,ee;return H.installed?(V=G.pinned,ee=G.preRelease,V&&(W=G.version)):(V=x.pinned,ee=x.preRelease,V&&(W=x.version)),V===void 0&&(V=H.pinned,V&&(W=H.version)),ee===void 0&&(ee=H.preRelease),{...G,installed:H.installed||x.installed,pinned:V,preRelease:ee,version:W??(x.version&&(!H.installed||N.gt(x.version,H.version))?x.version:H.version),state:S(H,x,v?.get(Q))}};for(const Q of _.removed.values()){const H=t.get(Q);if(!H)continue;const x=(0,A.$uf)(v?.get(Q)),G=p&&!p.has(Q)&&x.installed;H.installed&&G?y.push(H.identifier):a.set(Q,H)}for(const Q of _.added.values()){const H=(0,A.$uf)(r.get(Q)),x=t.get(Q);if(x){if(j.updated.has(Q)){const G=J(Q,x,H,H);I(x,H,!1,!1)||C.push(g(G,Q)),a.set(Q,G)}}else H.installed&&$.push(g(H,Q))}for(const Q of _.updated.values()){const H=(0,A.$uf)(r.get(Q)),x=(0,A.$uf)(v?.get(Q)),G=t.get(Q);if(G)if(p&&!p.has(Q)&&x.installed&&G.installed&&!H.installed)y.push(G.identifier);else{const W=J(Q,G,H,H);C.push(g(W,Q)),a.set(Q,W)}else H.installed&&$.push(g(H,Q))}for(const Q of B.added.values())_.added.has(Q)||a.set(Q,(0,A.$uf)(t.get(Q)));for(const Q of B.updated.values()){if(_.removed.has(Q)||_.updated.has(Q))continue;const H=(0,A.$uf)(t.get(Q)),x=(0,A.$uf)(r.get(Q));a.set(Q,J(Q,H,x,H))}for(const Q of B.removed.values())_.updated.has(Q)||_.removed.has(Q)||b.has(Q)||(0,A.$uf)(r.get(Q)).installed&&p&&(p.has(Q)||!(0,A.$uf)(v?.get(Q)).installed||a.delete(Q))}const F=[],T=D(r,a,new Set,!0),z=T.added.size>0||T.updated.size>0||T.removed.size>0;return z&&a.forEach((B,_)=>F.push(g(B,_))),{local:{added:$,removed:y,updated:C},remote:z?{added:[...T.added].map(B=>a.get(B)),updated:[...T.updated].map(B=>a.get(B)),removed:[...T.removed].map(B=>r.get(B)),all:F}:null}}e.$G2b=L;function D(l,f,w,d){const h=l?[...l.keys()].filter(i=>!w.has(i)):[],o=[...f.keys()].filter(i=>!w.has(i)),$=o.filter(i=>!h.includes(i)).reduce((i,c)=>(i.add(c),i),new Set),y=h.filter(i=>!o.includes(i)).reduce((i,c)=>(i.add(c),i),new Set),C=new Set;for(const i of h){if(y.has(i))continue;const c=l.get(i),n=f.get(i);(!n||!I(c,n,d,!0))&&C.add(i)}return{added:$,removed:y,updated:C}}function I(l,f,w,d){return!(l.disabled!==f.disabled||!!l.isApplicationScoped!=!!f.isApplicationScoped||d&&l.installed!==f.installed||l.installed&&f.installed&&(l.preRelease!==f.preRelease||l.pinned!==f.pinned||f.pinned&&l.version!==f.version)||!P(l.state,f.state)||w&&l.version!==f.version)}function S(l,f,w){const d=l.state,h=f.state,o=w?.state;if(!f.version||d&&N.gt(l.version,f.version))return d;if(h&&N.gt(f.version,l.version)||!d)return h;if(!h)return d;const $=(0,O.$Vm)(d),y=o?m(o,h):{added:Object.keys(h).reduce((i,c)=>(i.add(c),i),new Set),removed:new Set,updated:new Set},C=o?m(o,d):{added:Object.keys(d).reduce((i,c)=>(i.add(c),i),new Set),removed:new Set,updated:new Set};for(const i of[...y.added.values(),...y.updated.values()])$[i]=h[i];for(const i of y.removed.values())C.updated.has(i)||delete $[i];return $}function m(l,f){const w=Object.keys(l),d=Object.keys(f),h=d.filter(y=>!w.includes(y)).reduce((y,C)=>(y.add(C),y),new Set),o=w.filter(y=>!d.includes(y)).reduce((y,C)=>(y.add(C),y),new Set),$=new Set;for(const y of w){if(o.has(y))continue;const C=l[y],i=f[y];(0,O.$Zm)(C,i)||$.add(y)}return{added:h,removed:o,updated:$}}function P(l={},f={}){const{added:w,removed:d,updated:h}=m(l,f);return w.size===0&&d.size===0&&h.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function g(l,f){const w={...l,identifier:{id:l.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete w.disabled,l.installed||delete w.installed,l.state||delete w.state,l.isApplicationScoped||delete w.isApplicationScoped,w}}),define(oe[111],ae([0,1,18,19,4]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OBb=e.$NBb=void 0,e.$NBb=(0,A.$Bh)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,S){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==I&&P!==`-${I}`),S&&m.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(I,S){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==I&&P!==`-${I}`),S&&m.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(I){const S=I.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),m=this.b().map(g=>g.toLowerCase()),P=[],E=[];if(Array.isArray(m))for(const g of m)g.startsWith("-")?E.push(g.substring(1)):P.push(g);return(0,O.$Kb)([...S,...P].filter(g=>!E.includes(g)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$OBb=L,e.$OBb=L=ye([Z(0,N.$8h)],L)}),define(oe[233],ae([0,1,18,34,30,94,77]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M2b=void 0;function I(y){return(0,N.$Lm)(y)||[]}async function S(y,C,i,c,n){const s=I(y),t=I(C),r=i?I(i):null,a=[...s,...t,...r||[]].map(J=>J.key),v=await n.resolveUserBindings(a),b=P(s,t,r,v);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:y,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};const u=g(s),p=g(t),j=r?g(r):null,F=f(u,p,v),T=j?f(j,u,v):{added:[...u.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},z=j?f(j,p,v):{added:[...p.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},B=m(F,T,z);let _=y;for(const J of B.removed.values())B.conflicts.has(J)||(_=o(_,J,c));for(const J of B.added.values()){if(B.conflicts.has(J))continue;const Q=p.get(J);if(Q.some(H=>H.command!==`-${J}`&&b.conflicts.has(v[H.key]))){B.conflicts.add(J);continue}_=h(_,Q,c)}for(const J of B.updated.values()){if(B.conflicts.has(J))continue;const Q=p.get(J);if(Q.some(H=>H.command!==`-${J}`&&b.conflicts.has(v[H.key]))){B.conflicts.add(J);continue}_=$(_,J,Q,c)}return{mergeContent:_,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$M2b=S;function m(y,C,i){const c=new Set,n=new Set,s=new Set,t=new Set;for(const r of C.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(C.updated.has(r)?t.add(r):n.add(r));for(const r of C.added.values())t.has(r)||i.added.has(r)&&y.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(C.added.has(r)?y.updated.has(r)&&t.add(r):c.add(r));for(const r of C.updated.values())t.has(r)||i.updated.has(r)&&y.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(C.updated.has(r)?y.updated.has(r)&&t.add(r):s.add(r));return{added:c,removed:n,updated:s,conflicts:t}}function P(y,C,i,c){const n=new Set,s=E(y,c),t=E(C,c),r=i?E(i,c):null,a=l(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,s):{added:[...s.keys()].reduce((T,z)=>(T.add(z),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const b=r?l(r,t):{added:[...t.keys()].reduce((T,z)=>(T.add(z),T),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:p,updated:j,conflicts:F}=m(a,v,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:j,conflicts:F}}function E(y,C){const i=new Map;for(const c of y){const n=C[c.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(c)}return i}function g(y){const C=new Map;for(const i of y){const c=i.command[0]==="-"?i.command.substring(1):i.command;let n=C.get(c);n||(n=[],C.set(c,n)),n.push(i)}return C}function l(y,C){const i=[...y.keys()],c=[...C.keys()],n=c.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!c.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=y.get(r).map(b=>({...b,key:r})),v=C.get(r).map(b=>({...b,key:r}));(0,O.$sb)(a,v,(b,u)=>d(b,u))||t.add(r)}return{added:n,removed:s,updated:t}}function f(y,C,i){const c=[...y.keys()],n=[...C.keys()],s=n.filter(a=>!c.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=c.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of c){if(t.has(a))continue;const v=y.get(a).map(u=>({...u,key:i[u.key]})),b=C.get(a).map(u=>({...u,key:i[u.key]}));w(v,b)||r.add(a)}return{added:s,removed:t,updated:r}}function w(y,C){return!(!(0,O.$sb)(y.filter(({command:i})=>i[0]!=="-"),C.filter(({command:i})=>i[0]!=="-"),(i,c)=>d(i,c))||!(0,O.$sb)(y.filter(({command:i})=>i[0]==="-"),C.filter(({command:i})=>i[0]==="-"),(i,c)=>d(i,c)))}function d(y,C){if(y.command!==C.command||y.key!==C.key)return!1;const i=L.$Ii.deserialize(y.when),c=L.$Ii.deserialize(C.when);return!(i&&!c||!i&&c||i&&c&&!i.equals(c)||!A.$Zm(y.args,C.args))}function h(y,C,i){for(const c of C)y=D.edit(y,[-1],c,i);return y}function o(y,C,i){const c=I(y);for(let n=c.length-1;n>=0;n--)(c[n].command===C||c[n].command===`-${C}`)&&(y=D.edit(y,[n],void 0,i));return y}function $(y,C,i,c){const n=I(y),s=n.findIndex(t=>t.command===C||t.command===`-${C}`);for(let t=n.length-1;t>=0;t--)(n[t].command===C||n[t].command===`-${C}`)&&(y=D.edit(y,[t],void 0,c));for(let t=i.length-1;t>=0;t--)y=D.edit(y,[s],i[t],c);return y}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U2b=e.$T2b=void 0;function O(L,D,I){const S={},m={},P=new Set;if(!D)return{local:{added:S,updated:m,removed:[...P.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=N(L,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:m,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=N(I,L),l=N(I,D),f={},w={},d=new Set,h=new Set;for(const o of g.removed.values())l.updated.has(o)?S[o]=D[o]:d.add(o);for(const o of l.removed.values())h.has(o)||(g.updated.has(o)?h.add(o):P.add(o));for(const o of g.updated.values())h.has(o)||(l.updated.has(o)?E.updated.has(o)&&h.add(o):w[o]=L[o]);for(const o of l.updated.values())h.has(o)||(g.updated.has(o)?E.updated.has(o)&&h.add(o):L[o]!==void 0&&(m[o]=D[o]));for(const o of g.added.values())h.has(o)||(l.added.has(o)?E.updated.has(o)&&h.add(o):f[o]=L[o]);for(const o of l.added.values())h.has(o)||(g.added.has(o)?E.updated.has(o)&&h.add(o):S[o]=D[o]);return{local:{added:S,removed:[...P.values()],updated:m},remote:{added:f,removed:[...d.values()],updated:w},conflicts:[...h.values()]}}e.$T2b=O;function N(L,D){const I=L?Object.keys(L):[],S=D?Object.keys(D):[],m=S.filter(g=>!I.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),P=I.filter(g=>!S.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),E=new Set;for(const g of I){if(P.has(g))continue;const l=L[g],f=D[g];l!==f&&E.add(g)}return{added:m,removed:P,updated:E}}function A(L,D){const{added:I,removed:S,updated:m}=N(L,D);return I.size===0&&S.size===0&&m.size===0}e.$U2b=A}),define(oe[235],ae([0,1,30]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=void 0;function N(L,D,I,S){const m={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!D){const g=L.filter(({id:l})=>!S.includes(l));return g.length?P.added=g:P=null,{local:m,remote:P}}const E=A(L,D,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const g=A(I,L,S),l=A(I,D,S);for(const f of l.removed){const w=L.find(d=>d.id===f);w&&m.removed.push(w)}for(const f of l.added){const w=D.find(d=>d.id===f);g.added.includes(f)?E.updated.includes(f)&&m.updated.push(w):m.added.push(w)}for(const f of l.updated)m.updated.push(D.find(w=>w.id===f));for(const f of g.added)l.added.includes(f)||P.added.push(L.find(w=>w.id===f));for(const f of g.updated)l.removed.includes(f)||l.updated.includes(f)||P.updated.push(L.find(w=>w.id===f));for(const f of g.removed){const w=D.find(d=>d.id===f);w&&P.removed.push(w)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:m,remote:P}}e.$B4b=N;function A(L,D,I){L=L?L.filter(({id:l})=>!I.includes(l)):[],D=D.filter(({id:l})=>!I.includes(l));const S=L.map(({id:l})=>l),m=D.map(({id:l})=>l),P=m.filter(l=>!S.includes(l)),E=S.filter(l=>!m.includes(l)),g=[];for(const{id:l,name:f,shortName:w,useDefaultFlags:d}of L){if(E.includes(l))continue;const h=D.find(o=>o.id===l);(!h||h.name!==f||h.shortName!==w||!(0,O.$Zm)(h.useDefaultFlags,d))&&g.push(l)}return{added:P,removed:E,updated:g}}}),define(oe[25],ae([0,1,18,9,174,49,29,4,103,40]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.MergeState=e.Change=e.SyncStatus=e.$Kgb=e.$Jgb=e.$Igb=e.UserDataSyncErrorCode=e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.$Cgb=e.$Bgb=e.$Agb=e.$zgb=e.SyncResource=e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.$ugb=e.$tgb=void 0;function P(){const t=m.$8m.as(L.$an.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$tgb=P;function E(){const t=m.$8m.as(L.$an.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(b=>!!t[b].ignoreSync),a=Object.keys(t).filter(b=>t[b].scope===2||t[b].scope===6),v=P();return(0,O.$Kb)([...r,...a,...v])}e.$ugb=E,e.$vgb="settingsSync",e.$wgb="settingsSync.keybindingsPerPlatform";function g(){const t="vscode://schemas/ignoredSettings",r=m.$8m.as(L.$an.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$wgb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:D.$Mn,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.$8m.as(S.$9m.JSONContribution),v=()=>{const b=P(),u=E(),p=Object.keys(L.$bn.properties).filter(T=>!u.includes(T)),j=u.filter(T=>!b.includes(T)),F={items:{type:"string",enum:[...p,...j.map(T=>`-${T}`)]}};a.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$xgb=g;function l(t){return t&&(0,N.$lf)(t)&&(0,N.$jf)(t.id)&&Array.isArray(t.scopes)}e.$ygb=l;var f;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.$zgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(t,...r){return t?[t,...r]:r}e.$Agb=w;function d(t,r,a,v){return v.joinPath(a.userDataSyncHome,...w(t,r,`lastSync${r}.json`))}e.$Bgb=d,e.$Cgb=(0,I.$Bh)("IUserDataSyncStoreManagementService"),e.$Dgb=(0,I.$Bh)("IUserDataSyncStoreService"),e.$Egb=(0,I.$Bh)("IUserDataSyncLocalStoreService"),e.$Fgb="x-operation-id",e.$Ggb="X-Execution-Id";function h(t){const r={};return r[e.$Ggb]=t,r}e.$Hgb=h;var o;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(o||(e.UserDataSyncErrorCode=o={}));class $ extends Error{constructor(r,a,v,b){super(r),this.code=a,this.resource=v,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Igb=$;class y extends ${constructor(r,a,v,b,u){super(r,v,void 0,u),this.url=a,this.serverCode=b}}e.$Jgb=y;class C extends ${constructor(r,a){super(r,a)}}e.$Kgb=C,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const b=v[2]==="unknown"?void 0:v[2],u=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],b,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}($||(e.$Igb=$={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var c;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(c||(e.Change=c={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Lgb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Mgb=s,e.$Ngb=(0,I.$Bh)("IUserDataSyncEnablementService"),e.$Ogb=(0,I.$Bh)("IUserDataSyncService"),e.$Pgb=(0,I.$Bh)("IUserDataSyncResourceProviderService"),e.$Qgb=(0,I.$Bh)("IUserDataAutoSyncService"),e.$Rgb=(0,I.$Bh)("IUserDataSyncUtilService"),e.$Sgb=(0,I.$Bh)("IUserDataSyncLogService"),e.$Tgb="userDataSync",e.$Ugb="vscode-userdata-sync",e.$Vgb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ab=void 0;function A(D,I,S,m,P){if(!I)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const E=L(D,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=S?L(S,I):{added:Object.keys(I).reduce((o,$)=>(o.add($),o),new Set),removed:new Set,updated:new Set},l=S?L(S,D):{added:Object.keys(D).reduce((o,$)=>(o.add($),o),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},w=O.$Vm(I),d=!S;for(const o of l.added.values())o!==N.$Lgb&&d&&g.added.has(o)||(w[o]=D[o]);for(const o of l.updated.values())w[o]=D[o];for(const o of l.removed.values())m.unregistered.includes(o)||delete w[o];for(const o of g.added.values()){const $=I[o];if(m.machine.includes(o)){P.info(`GlobalState: Skipped adding ${o} in local storage because it is declared as machine scoped.`);continue}if(S&&l.added.has(o))continue;const y=D[o];y&&y.value===$.value||o===N.$Lgb&&d&&l.added.has(o)||(y?f.updated[o]=$:f.added[o]=$)}for(const o of g.updated.values()){const $=I[o];if(m.machine.includes(o)){P.info(`GlobalState: Skipped updating ${o} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(o)||l.removed.has(o))continue;const y=D[o];y&&y.value===$.value||(f.updated[o]=$)}for(const o of g.removed.values()){if(m.machine.includes(o)){P.trace(`GlobalState: Skipped removing ${o} in local storage because it is declared as machine scoped.`);continue}l.updated.has(o)||l.removed.has(o)||f.removed.push(o)}const h=L(I,w);return{local:f,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:w}}}e.$0Ab=A;function L(D,I){const S=Object.keys(D),m=Object.keys(I),P=m.filter(l=>!S.includes(l)).reduce((l,f)=>(l.add(f),l),new Set),E=S.filter(l=>!m.includes(l)).reduce((l,f)=>(l.add(f),l),new Set),g=new Set;for(const l of S){if(E.has(l))continue;const f=D[l],w=I[l];O.$Zm(f,w)||g.add(l)}return{added:P,removed:E,updated:g}}}),define(oe[237],ae([0,1,18,34,85,41,30,77,25]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xzb=e.$Wzb=e.$Vzb=e.$Uzb=e.$Tzb=e.$Szb=void 0;function m(a,v,b){let u=[];b?u=E(b):u=P(v);const p=[],j=[...(0,S.$tgb)()];if(Array.isArray(u))for(const F of u)F.startsWith("-")?j.push(F.substring(1)):p.push(F);return(0,O.$Kb)([...a,...p].filter(F=>!j.includes(F)))}e.$Szb=m;function P(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const v=(0,N.$Lm)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function g(a,v){const b=(0,N.$Lm)(a)||{};let u="{}";for(const p of Object.keys(b)){const j=(0,A.$BS)(u,[p],b[p],v);u=(0,A.$ES)(u,j)}return u}e.$Tzb=g;function l(a,v,b,u){if(b.length){const p=r(v),j=(0,N.$Lm)(v)||{},F=(0,N.$Lm)(a);if(!F)return a;const T=[];for(const z of b){const B=j[z],_=F[z];B===void 0?a=I.edit(a,[z],void 0,u):_!==void 0?a=I.edit(a,[z],B,u):T.push(i(z,p))}T.sort((z,B)=>z.startOffset-B.startOffset),T.forEach(z=>a=o(z.setting.key,v,a,u))}return a}e.$Uzb=l;function f(a,v,b,u,p,j){const F=l(a,v,u,j),T=b!==F,z=b!==v;if(!T&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!z)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(z&&!T)return{conflictsSettings:[],localContent:l(v,a,u,j),remoteContent:null,hasConflicts:!1};if(b===null&&d(a)){const R=w(a,v,u)?null:l(v,a,u,j);return{conflictsSettings:[],localContent:R,remoteContent:null,hasConflicts:!1}}let B=a,_=v;const J=(0,N.$Lm)(a),Q=(0,N.$Lm)(v),H=b?(0,N.$Lm)(b):null,x=u.reduce((R,U)=>(R.add(U),R),new Set),G=h(J,Q,x),V=h(H,J,x),W=h(H,Q,x),ee=new Map,ne=new Set,re=R=>{ne.add(R);const U=p.filter(({key:M})=>M===R)[0];U?(B=I.edit(B,[R],U.value,j),_=I.edit(_,[R],U.value,j)):ee.set(R,{key:R,localValue:J[R],remoteValue:Q[R]})};for(const R of V.removed.values())W.updated.has(R)?re(R):_=I.edit(_,[R],void 0,j);for(const R of W.removed.values())ne.has(R)||(V.updated.has(R)?re(R):B=I.edit(B,[R],void 0,j));for(const R of V.updated.values())ne.has(R)||(W.updated.has(R)?G.updated.has(R)&&re(R):_=I.edit(_,[R],J[R],j));for(const R of W.updated.values())ne.has(R)||(V.updated.has(R)?G.updated.has(R)&&re(R):B=I.edit(B,[R],Q[R],j));for(const R of V.added.values())ne.has(R)||(W.added.has(R)?G.updated.has(R)&&re(R):_=o(R,B,_,j));for(const R of W.added.values())ne.has(R)||(V.added.has(R)?G.updated.has(R)&&re(R):B=o(R,_,B,j));const X=ee.size>0||!w(B,_,u),q=X||!w(B,a,[]),k=X||!w(_,v,[]);return{localContent:q?B:null,remoteContent:k?_:null,conflictsSettings:[...ee.values()],hasConflicts:X}}e.$Vzb=f;function w(a,v,b){if(a===v)return!0;const u=(0,N.$Lm)(a),p=(0,N.$Lm)(v),j=b.reduce((z,B)=>(z.add(B),z),new Set),F=r(a).filter(z=>!(z.setting&&j.has(z.setting.key))),T=r(v).filter(z=>!(z.setting&&j.has(z.setting.key)));if(F.length!==T.length)return!1;for(let z=0;z<F.length;z++){const B=F[z],_=T[z];if(B.setting&&_.setting){if(B.setting.key!==_.setting.key||!D.$Zm(u[B.setting.key],p[B.setting.key]))return!1}else if(!B.setting&&!_.setting){if(B.value!==_.value)return!1}else return!1}return!0}function d(a){return a?r(a).length===0:!0}e.$Wzb=d;function h(a,v,b){const u=a?Object.keys(a).filter(z=>!b.has(z)):[],p=Object.keys(v).filter(z=>!b.has(z)),j=p.filter(z=>!u.includes(z)).reduce((z,B)=>(z.add(B),z),new Set),F=u.filter(z=>!p.includes(z)).reduce((z,B)=>(z.add(B),z),new Set),T=new Set;if(a)for(const z of u){if(F.has(z))continue;const B=a[z],_=v[z];D.$Zm(B,_)||T.add(z)}return{added:j,removed:F,updated:T}}function o(a,v,b,u){const p=(0,N.$Lm)(v),j=r(v),F=r(b),T=$(a,j,F);return y(b,a,p[a],T,F,u)}e.$Xzb=o;function $(a,v,b){const u=v.findIndex(j=>j.setting?.key===a),p=v[u-1];if(p){if(p.setting){const F=i(p.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!0}}else{const F=c(u,v);if(F){const T=i(F.setting.key,b);if(T){const z=n(b.indexOf(T),b),B=s(v,F,v[u]);if(z){const _=s(b,T,z),J=t(B,_);return J?{index:b.indexOf(J),insertAfter:!0}:{index:b.indexOf(z),insertAfter:!1}}else{const _=s(b,T,b[b.length-1]),J=t(B,_);return J?{index:b.indexOf(J),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const j=v[u+1];if(j)if(j.setting){const F=i(j.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!1}}else{const F=n(u,v);if(F){const T=i(F.setting.key,b);if(T){const z=c(b.indexOf(T),b),B=s(v,v[u],F);if(z){const _=s(b,z,T),J=t(B.reverse(),_.reverse());return J?{index:b.indexOf(J),insertAfter:!1}:{index:b.indexOf(z),insertAfter:!0}}else{const _=s(b,b[0],T),J=t(B.reverse(),_.reverse());return J?{index:b.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function y(a,v,b,u,p,j){let F;return u.index===-1?F=(0,A.$BS)(a,[v],b,j):F=C(a,v,b,u,p,j).map(T=>(0,A.$CS)(a,T,j)[0]),(0,A.$ES)(a,F)}function C(a,v,b,u,p,j){const F=`${JSON.stringify(v)}: ${JSON.stringify(b)}`,T=(0,L.$yS)(j,a),z=p[u.index];if(u.insertAfter){const B=[];if(z.setting)B.push({offset:z.endOffset,length:0,content:","+F});else{const _=n(u.index,p),J=c(u.index,p),Q=J?.setting?.commaOffset;J&&Q===void 0&&B.push({offset:J.endOffset,length:0,content:","});const H=Q!==void 0&&Q>z.endOffset;B.push({offset:H?Q+1:z.endOffset,length:0,content:_?T+F+",":T+F})}return B}else{if(z.setting)return[{offset:z.startOffset,length:0,content:F+","}];const B=(p[u.index-1]&&!p[u.index-1].setting?T:"")+F+(n(u.index,p)?",":"")+T;return[{offset:z.startOffset,length:0,content:B}]}}function i(a,v){return v.filter(b=>b.setting?.key===a)[0]}function c(a,v){for(let b=a-1;b>=0;b--)if(v[b].setting)return v[b]}function n(a,v){for(let b=a+1;b<v.length;b++)if(v[b].setting)return v[b]}function s(a,v,b){const u=a.indexOf(v),p=a.indexOf(b);return a.filter((j,F)=>u<F&&F<p)}function t(a,v){if(a.length&&v.length){let b=0;for(;b<v.length&&b<a.length;b++)if(a[b].value!==v[b].value)return v[b-1];return v[b-1]}}function r(a){const v=[];let b=-1,u,p;const j={onObjectBegin:F=>{b++},onObjectProperty:(F,T,z)=>{b===0&&(u=T,p=F)},onObjectEnd:(F,T)=>{b--,b===0&&v.push({startOffset:u,endOffset:F+T,value:a.substring(u,F+T),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(F,T)=>{b++},onArrayEnd:(F,T)=>{b--,b===0&&v.push({startOffset:u,endOffset:F+T,value:a.substring(u,F+T),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(F,T,z)=>{b===0&&v.push({startOffset:u,endOffset:T+z,value:a.substring(u,T+z),setting:{key:p,commaOffset:void 0}})},onSeparator:(F,T,z)=>{if(b===0&&F===","){let B=v.length-1;for(;B>=0&&!v[B].setting;B--);const _=v[B];_&&v.splice(B,1,{startOffset:_.startOffset,endOffset:_.endOffset,value:_.value,setting:{key:_.setting.key,commaOffset:T}})}},onComment:(F,T)=>{b===0&&v.push({startOffset:F,endOffset:F+T,value:a.substring(F,F+T)})}};return(0,N.$Sm)(a,j),v}}),define(oe[78],ae([0,1,3,2,4,25]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dzb=e.$Czb=void 0,e.$Czb=(0,A.$Bh)("IUserDataSyncAccountService");let D=class extends N.$kc{get account(){return this.a}constructor(S,m){super(),this.g=S,this.h=m,this.b=this.B(new O.$fd),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$fd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$Dzb=D,e.$Dzb=D=ye([Z(0,L.$Dgb),Z(1,L.$Sgb)],D)}),define(oe[238],ae([0,1,2,11]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=e.$S7b=e.$R7b=e.$Q7b=e.$P7b=e.$O7b=e.$N7b=void 0;class A{constructor(g){this.a=g}listen(g,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(g,l,f){switch(l){case"triggerSync":return this.a.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(f[0])}throw new Error("Invalid call")}}e.$N7b=A;class L{constructor(g){this.a=g}listen(g,l){throw new Error(`Event not found: ${l}`)}call(g,l,f){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(f[0]))}throw new Error("Invalid call")}}e.$O7b=L;class D{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.$P7b=D;class I{constructor(g){this.a=g}listen(g,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(g,l,f){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(f[0],f[1]);case"setEnablements":return this.a.setEnablements(f)}throw new Error("Invalid call")}}e.$Q7b=I;class S{constructor(g){this.a=g}listen(g,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(g,l,f){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(f)}throw new Error("Invalid call")}}e.$R7b=S;class m{constructor(g){this.a=g}listen(g,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(g,l,f){switch(l){case"switch":return this.a.switch(f[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$S7b=m;class P extends O.$kc{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:N.URI.revive(g.url),type:g.type,defaultUrl:N.URI.revive(g.defaultUrl),insidersUrl:N.URI.revive(g.insidersUrl),stableUrl:N.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.$T7b=P}),define(oe[239],ae([0,1,21,175,15,7,25]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PBb=void 0;let I=class extends L.$0i{constructor(m,P){super(),this.g=this.B(m.createLogger((0,O.$ig)(P.logsHome,`${D.$Tgb}.log`),{id:D.$Tgb,name:(0,N.localize)(0,null)}))}trace(m,...P){this.g.trace(m,...P)}debug(m,...P){this.g.debug(m,...P)}info(m,...P){this.g.info(m,...P)}warn(m,...P){this.g.warn(m,...P)}error(m,...P){this.g.error(m,...P)}flush(){this.g.flush()}};e.$PBb=I,e.$PBb=I=ye([Z(0,L.$6i),Z(1,A.$Ih)],I)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=e.$h8b=void 0,e.$h8b=(0,N.$Bh)("voiceRecognitionService");let L=class{constructor(I,S){this.a=I,this.b=S}async transcribe(I,S){const m=process.env.VSCODE_VOICE_MODULE_PATH;if(!m||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${I.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const P=Date.now();try{const E=te.__$__nodeRequire(m),g=new AbortController;S.onCancellationRequested(()=>g.abort());const l=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:I},{language:"en",signal:g.signal});return this.a.info(`[voice] transcribe(${I.length}): Text "${l}", took ${Date.now()-P}ms)`),l}catch(E){throw this.a.error(`[voice] transcribe(${I.length}): Failed width "${E}", took ${Date.now()-P}ms)`),E}}};e.$i8b=L,e.$i8b=L=ye([Z(0,O.$5i),Z(1,A.$kj)],L)}),define(oe[240],ae([0,1,2,112,7,26,5]),function(te,e,O,N,A,L,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;let S=class extends O.$kc{static{I=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(l,f,w){super(),this.b=l,this.c=f,this.f=w,this.g()}g(){this.B(this.b(l=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${I.a})`),I.a?this.B(new P(l,this.c,this.f)):this.B(new E(l,this.c,this.f))}))}};e.$j8b=S,e.$j8b=S=I=ye([Z(1,N.$h8b),Z(2,A.$5i)],S);class m extends O.$kc{static{this.a=30*16e3*16*1/8}constructor(l,f,w){super(),this.b=l,this.c=f,this.f=w,this.g()}g(){const l=new L.$pd;this.B((0,O.$ic)(()=>l.dispose(!0)));const f=d=>{d.data instanceof Float32Array&&this.h(d.data,l.token)};this.b.on("message",f),this.B((0,O.$ic)(()=>this.b.off("message",f))),this.b.start();let w=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),w=!0,this.dispose()}),this.B((0,O.$ic)(()=>{w||this.b.close()}))}j(l){const f=new Float32Array(l.reduce((d,h)=>d+h.length,0));let w=0;for(const d of l)f.set(d,w),w+=d.length;return f}}class P extends m{constructor(){super(...arguments),this.m=this.B(new D.$Ng),this.n=[],this.r=new Float32Array(0)}async h(l,f){if(l.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,l]):l;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const w=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(w,f))}}async t(l,f){if(!f.isCancellationRequested){if(l.length>m.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(l.length!==0){const w=await this.c.transcribe(l,f);w&&this.n.push(w)}f.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends m{constructor(){super(...arguments),this.m=new D.$Og,this.n=void 0,this.r=0,this.s=""}async h(l,f){const w=this.n?this.j([this.n,l]):l;if(w.length>m.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=w,this.m.queue(()=>this.u(f))}async u(l){if(l.isCancellationRequested)return;const f=this.n?.slice(0);if(!f)return;let w;f.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),w=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),w=await this.c.transcribe(f,l)),this.s=w,this.r=f.length,!l.isCancellationRequested&&this.b.postMessage(w)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,5,3,2]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=void 0;class L extends A.$kc{constructor({onDidOpenWindow:I,onDidFocusWindow:S,getActiveWindowId:m}){super(),this.a=this.B(new A.$jc),N.Event.latch(N.Event.any(I,S))(this.f,this,this.a),this.b=(0,O.$ug)(()=>m()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$R6b=L}),define(oe[113],ae([0,1,178,16,47,21,11,4,23]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,I.$Bh)("contextService");function m(s){const t=s;return typeof t?.id=="string"&&D.URI.isUri(t.uri)}e.$Lh=m;function P(s){return typeof s?.id=="string"&&!m(s)&&!g(s)}e.$Mh=P,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function E(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$ae)(s)}:t?e.$Nh:e.$Oh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Ph=E;function g(s){const t=s;return typeof t?.id=="string"&&D.URI.isUri(t.configPath)}e.$Qh=g;function l(s){const t=s;if(t?.uri)return{id:t.id,uri:D.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Rh=l;var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function w(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$Sh=w;function d(s){const t=s;return!!(t&&typeof t=="object"&&D.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$Th=d;class h{constructor(t,r,a,v,b){this.h=t,this.j=a,this.k=v,this.l=b,this.c=A.$Hh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$Hh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=h;class o{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$ig)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=o;function $(s){return new o({uri:s,index:0,name:(0,L.$eg)(s)},{uri:s.toString()})}e.$Wh=$,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,O.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function y(s,t){return L.$_f.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$2h=y;function C(s){let t;return D.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===S.Schemas.tmp}e.$3h=C,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$4h}e.$5h=i;function c(s,t){return!y(s,t)&&!C(s)}e.$6h=c;function n(s){return(typeof s=="string"?(0,N.$be)(s):(0,L.$gg)(s))===e.$Yh}e.$7h=n}),define(oe[17],ae([0,1,51,3,2,21,11,169,15,12,4,7,113,35,28,5,32,27,9]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var $;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function y(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&D.URI.isUri(t.location)&&D.URI.isUri(t.globalStorageHome)&&D.URI.isUri(t.settingsResource)&&D.URI.isUri(t.keybindingsResource)&&D.URI.isUri(t.tasksResource)&&D.URI.isUri(t.snippetsHome)&&D.URI.isUri(t.extensionsResource))}e.$Dk=y,e.$Ek=(0,P.$Bh)("IUserDataProfilesService");function C(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:D.URI.revive(s.location).with({scheme:t}),globalStorageHome:D.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:D.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:D.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:D.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:D.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:D.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:D.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Fk=C;function i(s,t,r,a,v,b){return{id:s,name:t,location:r,isDefault:!1,shortName:v?.shortName,globalStorageHome:b&&v?.useDefaultFlags?.globalState?b.globalStorageHome:(0,L.$ig)(r,"globalStorage"),settingsResource:b&&v?.useDefaultFlags?.settings?b.settingsResource:(0,L.$ig)(r,"settings.json"),keybindingsResource:b&&v?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,L.$ig)(r,"keybindings.json"),tasksResource:b&&v?.useDefaultFlags?.tasks?b.tasksResource:(0,L.$ig)(r,"tasks.json"),snippetsHome:b&&v?.useDefaultFlags?.snippets?b.snippetsHome:(0,L.$ig)(r,"snippets"),extensionsResource:b&&v?.useDefaultFlags?.extensions?b.extensionsResource:(0,L.$ig)(r,"extensions.json"),cacheHome:(0,L.$ig)(a,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Gk=i;let c=class extends A.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zi,emptyWindows:new Map},this.profilesHome=(0,L.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,o.$jf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(i((0,L.$fg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,useDefaultFlags:b.useDefaultFlags},t))}}catch(b){this.y.error(b)}const a=new l.$zi,v=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[u,p]of Object.entries(b.workspaces)){const j=D.URI.parse(u),F=r.find(T=>T.id===p);F&&a.set(j,F)}if(b.emptyWindows)for(const[u,p]of Object.entries(b.emptyWindows)){const j=r.find(F=>F.id===p);j&&v.set(u,j)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,h.$qe)(r)}\\s(\\d+)`);let v=0;for(const u of this.profiles){const p=a.exec(u.name),j=p?parseInt(p[1]):0;v=j>v?j:v}const b=`${r} ${v+1}`;return this.createProfile((0,O.$pi)((0,d.$4f)()).toString(16),b,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$pi)((0,d.$4f)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,b),b}async F(t,r,a){if(!(0,o.$jf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const b=this.profiles.find(j=>j.name===r||j.id===t);if(b)return b;const u=i(t,r,(0,L.$ig)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(j){p.push(j)}}),await w.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,m.$jk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,g.$Lh)(t)?t.uri:(0,g.$Qh)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],b=[];this.s.profiles=[];for(let u of v)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):b.push({location:u.location,name:u.name,shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}));this.P(b),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),b=a?this.s:this.C;D.URI.isUri(v)?(b.workspaces.delete(v),r&&b.workspaces.set(v,r)):(b.emptyWindows.delete(v),r&&b.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[b,u]of Object.entries(t.workspaces)){const p=D.URI.parse(u);r[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const v={};if(t.emptyWindows)for(const[b,u]of Object.entries(t.emptyWindows)){const p=D.URI.parse(u);v[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Hk=c,e.$Hk=c=ye([Z(0,S.$Ih),Z(1,m.$6j),Z(2,f.$Ck),Z(3,E.$5i)],c);class n extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Ik=n}),define(oe[242],ae([0,1,5,2,17]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;let L=class extends N.$kc{constructor(I){super(),this.B(new O.$Sg(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$27b=L,e.$27b=L=ye([Z(0,A.$Ek)],L)}),define(oe[243],ae([0,1,18,5,26,8,3,2,6,9,11,152,29,33,45,7,24,22,28,17]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=void 0;let y=class extends I.$kc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,b,u){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=b,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$fd),this.s=this.B(new D.$fd),this.t=this.B(new D.$fd),this.u=this.B(new D.$fd),this.w=this.B(new D.$fd),this.y=[],this.B((0,I.$ic)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,g.$Wn)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:b})=>(0,l.$po)(b,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:i(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new g.$1n(E.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:b})=>{try{const u=await this.O(v,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);a.push({...u,options:b})}catch(u){r.push({identifier:v.identifier,operation:2,source:v,error:u})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&c(this.C,"extensionGallery:install",{extensionData:(0,l.$xo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,f.$Yl)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const b=(await this.getInstalled(1,v.extensionsResource)).find(u=>(0,l.$po)(u.identifier,t.identifier));b?this.w.fire(b):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a);r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$uo)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a}){const v=a.isApplicationScoped||a.isBuiltin||(0,f.$Yl)(t),b={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},u=B=>`${l.$qo.create(B).toString()}${b.profileLocation?`-${b.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const B=this.j.get(u(r));if(B)return this.F.info("Extensions is already requested to install",r.identifier.id),await B.task.waitUntilTaskIsFinished(),[]}const p=[],j=[],F=[],T=this.Z(t,r,b);P.URI.isUri(r)||this.j.set(u(r),{task:T,waitingTasks:[]}),this.n.fire({identifier:T.identifier,source:r,profileLocation:b.profileLocation}),this.F.info("Installing extension:",T.identifier.id),p.push({task:T,manifest:t});let z=!1;try{if(b.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const _=await this.N(T.identifier,t,!!b.installOnlyNewlyAddedFromExtensionPack,!!b.installPreReleaseVersion,b.profileLocation),J=await this.getInstalled(void 0,b.profileLocation),Q={...b,donotIncludePackAndDependencies:!0,context:{...b.context,[g.$Rn]:!0}};for(const{gallery:H,manifest:x}of(0,O.$Kb)(_,({gallery:G})=>G.identifier.id)){z=z||!!x.extensionDependencies?.some(W=>(0,l.$po)({id:W},T.identifier));const G=u(H),V=this.j.get(G);if(V){if(this.L(T,V.task)){const W=V.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,T.identifier.id),V.waitingTasks.push(T),j.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,l.$po)(ne.identifier,W)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,T.identifier.id),!ee.find(re=>(0,l.$po)(re.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!J.some(({identifier:W})=>(0,l.$po)(W,H.identifier))){const W=this.Z(x,H,Q);this.j.set(G,{task:W,waitingTasks:[T]}),this.n.fire({identifier:W.identifier,source:H,profileLocation:b.profileLocation}),this.F.info("Installing extension:",W.identifier.id,T.identifier.id),p.push({task:W,manifest:x})}}}catch(_){if(P.URI.isUri(T.source))(0,O.$Jb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,_.message),(0,O.$Jb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,_.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),_}const B=p.reduce((_,{task:J,manifest:Q})=>(_.set(J.identifier.id.toLowerCase(),{task:J,manifest:Q}),_),new Map);for(;B.size;){let _;const J=[...B.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(H=>B.has(H.toLowerCase())));J.length?_=B.size===1?J:J.filter(({task:Q})=>!(Q===T&&!z)):(this.F.info("Found extensions with circular dependencies",J.map(({task:Q})=>Q.identifier.id)),_=[...B.values()]),await this.M(_.map(async({task:Q})=>{const H=new Date().getTime();try{const x=await Q.run();if(await this.M(this.y.map(G=>G.postInstall(x,Q.source,b,A.CancellationToken.None))),!P.URI.isUri(Q.source)){const G=Q.operation===3,V=G?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(c(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$xo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:V}),S.$o&&Q.operation!==3)try{await this.z.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}F.push({local:x,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw P.URI.isUri(Q.source)||c(this.C,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$xo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-H,error:x}),this.F.error("Error while installing the extension:",Q.identifier.id),x}finally{B.delete(Q.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),F.forEach(({identifier:_})=>this.F.info("Extension installed successfully:",_.id)),F}catch(B){if(p.forEach(({task:_})=>_.cancel()),F.length)try{const _=await Promise.allSettled(F.map(({local:J})=>this.$(J,{versionOnly:!0,profileLocation:b.profileLocation}).run()));for(let J=0;J<_.length;J++){const Q=_[J],{identifier:H}=F[J];Q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",H.id):this.F.warn("Rollback: Error while uninstalling extension",H.id,(0,L.$8)(Q.reason))}}catch(_){this.F.warn("Error while rolling back extensions",(0,L.$8)(_),F.map(({identifier:J})=>J.id))}return p.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:b.context,profileLocation:b.profileLocation,error:B}))}finally{for(const{task:B}of p)B.source&&!P.URI.isUri(B.source)&&this.j.delete(u(B.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(b=>this.L(b,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const b of v)b.status==="fulfilled"?r.push(b.value):a.push(b.reason);if(a.length)throw C(a);return r}async N(t,r,a,v,b){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,b),p=[],j=[],F=async(T,z)=>{p.push(T);const B=z.extensionDependencies||[],_=[...B];if(z.extensionPack){const J=a?u.find(Q=>(0,l.$po)(Q.identifier,T)):void 0;for(const Q of z.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(H=>(0,l.$po)({id:H},{id:Q}))||_.every(H=>!(0,l.$po)({id:H},{id:Q}))&&_.push(Q)}if(_.length){const J=_.filter(Q=>p.every(H=>!(0,l.$po)(H,{id:Q})));if(J.length){const Q=await this.z.getExtensions(J.map(H=>({id:H,preRelease:v})),A.CancellationToken.None);for(const H of Q){if(p.find(V=>(0,l.$po)(V,H.identifier)))continue;const x=B.some(V=>(0,l.$po)({id:V},H.identifier));let G;try{G=await this.O(H,!1,v)}catch(V){if(x)throw V;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,L.$8)(V));continue}j.push({gallery:G.extension,manifest:G.manifest}),await F(G.extension.identifier,G.manifest)}}}};return await F(t,r),j}async O(t,r,a){let v;const b=await this.getExtensionsControlManifest();if(b.malicious.some(j=>(0,l.$po)(t.identifier,j)))throw new g.$1n(E.localize(1,null,t.identifier.id),g.ExtensionManagementErrorCode.Malicious);const u=b.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!v)throw new g.$1n(E.localize(2,null,t.identifier.id,u.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const j=await this.getTargetPlatform();throw new g.$1n(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,g.$Sn)(j)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new g.$1n(E.localize(4,null,t.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$1n(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const p=await this.z.getManifest(v,A.CancellationToken.None);if(p===null)throw new g.$1n(`Missing manifest for extension ${v.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(p.version!==v.version)throw new g.$1n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:p}}async P(t,r,a){const v=await this.getTargetPlatform();let b=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(b=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(t,a,v)&&(b=t),b||(r?b=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(t,a,v)),b}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,b=this.m.get(v(t.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),b.waitUntilTaskIsFinished();const u=T=>{const z=this.$(T,a);return this.m.set(v(z.extension.identifier),z),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),z},p=(T,z)=>{z?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),z.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,z.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),c(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$wo)(T),error:z}),this.u.fire({identifier:T.identifier,error:z?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},j=[],F=[];try{j.push(u(t));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const z=this.U(t,T);for(const B of z)this.m.has(v(B.identifier))?this.F.info("Extensions is already requested to uninstall",B.identifier.id):j.push(u(B))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(j.map(z=>z.extension),T,t),await this.M(j.map(async z=>{try{if(await z.run(),await this.M(this.y.map(B=>B.postUninstall(z.extension,a,A.CancellationToken.None))),z.extension.identifier.uuid)try{await this.z.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}p(z.extension)}catch(B){const _=B instanceof g.$1n?B:new g.$1n((0,L.$8)(B),g.ExtensionManagementErrorCode.Internal);throw p(z.extension,_),_}finally{F.push(z)}}))}catch(T){const z=T instanceof g.$1n?T:new g.$1n((0,L.$8)(T),g.ExtensionManagementErrorCode.Internal);for(const B of j){try{B.cancel()}catch{}F.includes(B)||p(B.extension,z)}throw z}finally{for(const T of j)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(t,r,a){for(const v of t){const b=this.W(v,r);if(b.length){const u=b.filter(p=>!t.some(j=>(0,l.$po)(j.identifier,p.identifier)));if(u.length)throw new Error(this.S(v,u,a))}}}S(t,r,a){return a===t?r.length===1?E.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const b=r.filter(p=>!p.isBuiltin&&v.some(j=>(0,l.$po)({id:j},p.identifier))),u=[];for(const p of b)u.push(...this.U(p,r,a));return[...b,...u]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,l.$po)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$fp=y,e.$fp=y=ye([Z(0,g.$Zn),Z(1,h.$9k),Z(2,o.$Ck),Z(3,w.$5i),Z(4,d.$kj),Z(5,$.$Ek)],y);function C(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$gp=C;function i(s){if(s instanceof g.$1n)return s;const t=new g.$1n(s.message,g.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$hp=i;function c(s,t,{extensionData:r,verificationStatus:a,duration:v,error:b,durationSinceUpdate:u}){let p,j;(0,m.$rf)(a)&&(a===!0?a="Verified":(a===!1||(p=g.ExtensionManagementErrorCode.Signature,j=a),a="Unverified")),b&&(b instanceof g.$1n?(p=b.code,b.code===g.ExtensionManagementErrorCode.Signature&&(j=b.message)):p=g.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!b,duration:v,errorcode:p,errorcodeDetail:j,durationSinceUpdate:u})}class n{constructor(){this.d=new N.$Fg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$ug)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$ug)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new L.$3)})})),this.d.open()),this.g.cancel()}}e.$ip=n}),define(oe[50],ae([0,1,5,14,2,3,35,11,29,33,12,4,7,17,28,9,8,22]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var o;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(o||(e.ExtensionsProfileScanningErrorCode=o={}));class $ extends Error{constructor(n,s){super(n),this.code=s}}e.$jp=$,e.$kp=(0,E.$Bh)("IExtensionsProfileScannerService");let y=class extends A.$kc{constructor(n,s,t,r,a,v){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new L.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new L.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$zi}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const v=[];for(const b of a)n.some(([u])=>(0,m.$po)(u.identifier,b.identifier)&&u.manifest.version!==b.version)?t.push(b):v.push(b);for(const[b,u]of n){const p=v.findIndex(F=>(0,m.$po)(F.identifier,b.identifier)&&F.version===b.manifest.version),j={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:u};p===-1?(r.push(j),v.push(j)):v.splice(p,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),v}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const v of r){const b=n.find(([u])=>(0,m.$po)(u.identifier,v.identifier)&&u.manifest.version===v.version);b&&(v.metadata={...v.metadata,...b[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const v of r)(0,m.$po)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$jk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new $((0,d.$8)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const b of a){C(b)||this.w(n);let u;if((0,w.$jf)(b.relativeLocation)&&b.relativeLocation)u=this.z(b.relativeLocation);else if((0,w.$jf)(b.location))u=this.z(b.location),v=!0,b.relativeLocation=b.location,b.location=u.toJSON();else{u=I.URI.revive(b.location);const p=this.y(u);p&&(v=!0,b.relativeLocation=p)}r.push({identifier:b.identifier,location:u,version:b.version,metadata:b.metadata})}v&&await this.m.writeFile(n,N.$Fd.fromString(JSON.stringify(a)))}if(s){r=s(r);const v=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(n,N.$Fd.fromString(JSON.stringify(v)))}return r})}w(n){const s=new $(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,P.$jk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>C(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Fd.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.$jk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,P.$jk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,P.$jk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$Ng,this.h.set(n,s)),s}};e.$lp=y,e.$lp=y=ye([Z(1,P.$6j),Z(2,l.$Ek),Z(3,f.$Ck),Z(4,h.$9k),Z(5,g.$5i)],y);function C(c){return(0,w.$lf)(c)&&(0,S.$Yn)(c.identifier)&&(i(c.location)||(0,w.$jf)(c.location)&&c.location)&&((0,w.$qf)(c.relativeLocation)||(0,w.$jf)(c.relativeLocation))&&c.version&&(0,w.$jf)(c.version)}function i(c){return c?(0,w.$jf)(c.path)&&(0,w.$jf)(c.scheme):!1}}),define(oe[79],ae([0,1,18,5,30,14,8,34,139,2,23,16,6,21,53,89,9,11,155,15,33,45,67,12,4,7,24,3,63,50,17,28,183]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i,c,n,s,t,r,a,v,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var j;(function(Q){function H(x,G){if(x===G)return!0;const V=Object.keys(x),W=new Set;for(const ee of Object.keys(G))W.add(ee);if(V.length!==W.size)return!1;for(const ee of V){if(x[ee]!==G[ee])return!1;W.delete(ee)}return W.size===0}Q.equals=H})(j||(e.Translations=j={})),e.$op=(0,n.$Bh)("IExtensionsScannerService");let F=class extends m.$kc{constructor(H,x,G,V,W,ee,ne,re,X,q,k,R){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=x,this.r=G,this.s=V,this.t=W,this.u=ee,this.w=ne,this.y=re,this.z=X,this.C=q,this.D=k,this.F=R,this.g=this.B(new r.$fd),this.onDidChangeCache=this.g.event,this.h=(0,l.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(H,x,G){const[V,W]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(x)]),ee=G?await this.scanExtensionsUnderDevelopment(H,[...V,...W]):[];return this.L(V,W,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const x=[];x.push(this.M(!!H.useCache,H.language)),x.push(this.N(H.language,!!H.checkControlFile));const[G,V]=await Promise.all(x);return this.J([...G,...V],0,H,!1)}async scanUserExtensions(H){const x=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",x);const G=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(x,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G),W=H.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ee;try{ee=await W.scanExtensions(V)}catch(ne){if(ne instanceof v.$jp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ee=await W.scanExtensions(V);else throw ne}return ee=await this.J(ee,1,H,!0),this.y.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(H,x){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const W=await this.P(V,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(ne=>(ne.type=x.find(re=>(0,y.$po)(re.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,W)))}))).flat();return this.J(G,"development",H,!0)}return[]}async scanExistingExtension(H,x,G){const V=await this.P(H,!1,x,!0,G.language,!0,void 0),W=await this.n.scanExtension(V);return!W||!G.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(H,x,G){const V=await this.P(H,!1,x,!0,G.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(V);return this.J(W,x,G,!0)}async scanMetadata(H){const x=(0,l.$ig)(H,"package.json"),G=(await this.w.readFile(x)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,x){const G=(0,l.$ig)(H,"package.json"),V=(await this.w.readFile(G)).value.toString(),W=JSON.parse(V);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,W.__metadata={...W.__metadata,...x},await this.w.writeFile((0,l.$ig)(H,"package.json"),L.$Fd.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$jp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(x=>[x,x.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Fd.fromString(JSON.stringify([])))}catch(x){(0,c.$jk)(x)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$8)(x))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,x,G,V){return G.includeAllVersions||(H=this.L(x===0?H:void 0,x===1?H:void 0,x==="development"?H:void 0,await this.getTargetPlatform(),V)),G.includeInvalid||(H=H.filter(W=>W.isValid)),H.sort((W,ee)=>{const ne=E.$ae(W.location.fsPath),re=E.$ae(ee.location.fsPath);return ne<re?-1:ne>re?1:0})}L(H,x,G,V,W){const ee=(re,X,q)=>{if(re.isValid&&!X.isValid)return!1;if(re.isValid===X.isValid){if(W&&f.gt(re.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(f.eq(re.manifest.version,X.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===V)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${re.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${X.location.path}.`),!0},ne=new C.$Xl;return H?.forEach(re=>{const X=ne.get(re.identifier.id);(!X||ee(X,re,!1))&&ne.set(re.identifier.id,re)}),x?.forEach(re=>{const X=ne.get(re.identifier.id);if(!X&&H&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!X||ee(X,re,!1))&&ne.set(re.identifier.id,re)}),G?.forEach(re=>{const X=ne.get(re.identifier.id);(!X||ee(X,re,!0))&&ne.set(re.identifier.id,re),ne.set(re.identifier.id,re)}),[...ne.values()]}async M(H,x){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),W=await(H&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",W.length),W}async N(H,x){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const V=x?await this.O():{},W=[],ee=h.URI.file(E.$7d(E.$9d(P.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of G){const X=V[re.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":W.push((0,l.$ig)(ee,re.name));break;default:W.push(h.URI.file(X));break}}const ne=await Promise.all(W.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,O.$Fb)(ne)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,x,G,V,W,ee,ne){const re=await this.f(W??g.$v),X=await this.Q(H),q=x&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,k=q?await this.Q(q):void 0;return new T(H,X,q,k,x,ne,G,V,ee,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,re)}async Q(H){try{const x=await this.w.stat(H);if(typeof x.mtime=="number")return x.mtime}catch{}}};e.$pp=F,e.$pp=F=ye([Z(4,b.$Ek),Z(5,v.$kp),Z(6,c.$6j),Z(7,s.$5i),Z(8,$.$Ih),Z(9,t.$kj),Z(10,u.$Ck),Z(11,n.$Ah)],F);class T{constructor(H,x,G,V,W,ee,ne,re,X,q,k,R,U,M,K){this.location=H,this.mtime=x,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=re,this.validate=X,this.productVersion=q,this.productDate=k,this.productCommit=R,this.devMode=U,this.language=M,this.translations=K}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,x){return(0,l.$bg)(H.location,x.location)&&H.mtime===x.mtime&&(0,l.$bg)(H.applicationExtensionslocation,x.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&H.profile===x.profile&&A.$Zm(H.profileScanOptions,x.profileScanOptions)&&H.type===x.type&&H.excludeObsolete===x.excludeObsolete&&H.validate===x.validate&&H.productVersion===x.productVersion&&H.productDate===x.productDate&&H.productCommit===x.productCommit&&H.devMode===x.devMode&&H.language===x.language&&j.equals(H.translations,x.translations)}}e.$qp=T;let z=class extends m.$kc{constructor(H,x,G,V,W){super(),this.f=H,this.g=x,this.h=G,this.j=V,this.m=W}async scanExtensions(H){const x=H.profile?await this.r(H):await this.n(H);let G={};if(H.excludeObsolete&&H.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(V)}catch{}return(0,d.$wf)(G)?x:x.filter(V=>!G[y.$qo.create(V).toString()])}async n(H){const x=await this.j.resolve(H.location);if(!x.children?.length)return[];const G=await Promise.all(x.children.map(async V=>{if(!V.isDirectory||H.type===1&&(0,l.$fg)(V.resource).indexOf(".")===0)return null;const W=new T(V.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(W)}));return(0,O.$Fb)(G).sort((V,W)=>V.location.path<W.location.path?-1:1)}async r(H){let x=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){x=x.filter(V=>!V.metadata?.isApplicationScoped);const G=await this.s(H.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,H);x.push(...G)}return x}async s(H,x,G){const V=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async ee=>{if(x(ee)){const ne=new T(ee.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,O.$Fb)(W)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$ig)(H.location,"package.json"))){const x=await this.scanExtension(H);return x?[x]:[]}else return await this.scanExtensions(H)}catch(x){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,D.$8)(x)),[]}}async scanExtension(H,x){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=C.$Rl),x=x??G.__metadata,delete G.__metadata;const V=(0,y.$uo)(G.publisher,G.name),W=x?.id?{id:V,uuid:x.id}:{id:V},ee=x?.isSystem?0:H.type,ne=ee===0||!!x?.isBuiltin;G=await this.t(H.location,G,T.createNlsConfiguration(H));const re={type:ee,identifier:W,manifest:G,location:H.location,isBuiltin:ne,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return H.validate?this.validate(re,H):re}}catch(G){H.type!==0&&this.m.error(G)}return null}validate(H,x){let G=!0;const V=(0,i.$Fo)(x.productVersion,x.productDate,x.location,H.manifest,H.isBuiltin);for(const[W,ee]of V)W===w.default.Error&&(G=!1,this.m.error(this.z(x.location,ee)));return H.isValid=G,H.validations=V,H}async scanExtensionManifest(H){const x=(0,l.$ig)(H,"package.json");let G;try{G=(await this.j.readFile(x)).value.toString()}catch(W){return(0,c.$jk)(W)!==1&&this.m.error(this.z(H,(0,o.localize)(0,null,x.path,W.message))),null}let V;try{V=JSON.parse(G)}catch{const ee=[];(0,I.$Lm)(G,ee);for(const ne of ee)this.m.error(this.z(H,(0,o.localize)(1,null,x.path,ne.offset,ne.length,(0,S.$mp)(ne.error))));return null}return(0,I.$Um)(V)!=="object"?(this.m.error(this.z(H,(0,o.localize)(2,null,x.path))),null):V}async t(H,x,G){const V=await this.u(H,x,G);if(V)try{const W=[],ee=await this.w(V.default,W);if(W.length>0)return W.forEach(re=>{this.m.error(this.z(H,(0,o.localize)(3,null,V.default?.path,(0,S.$mp)(re.error))))}),x;if((0,I.$Um)(V)!=="object")return this.m.error(this.z(H,(0,o.localize)(4,null,V.default?.path))),x;const ne=V.values||Object.create(null);return(0,p.$np)(this.m,x,ne,ee)}catch{}return x}async u(H,x,G){const V=(0,l.$ig)(H,"package.nls.json"),W=(X,q)=>{q.forEach(k=>{this.m.error(this.z(H,(0,o.localize)(5,null,X?.path,(0,S.$mp)(k.error))))})},ee=X=>{this.m.error(this.z(H,(0,o.localize)(6,null,X?.path)))},ne=`${x.publisher}.${x.name}`,re=G.translations[ne];if(re)try{const X=h.URI.file(re),q=(await this.j.readFile(X)).value.toString(),k=[],R=(0,I.$Lm)(q,k);return k.length>0?(W(X,k),{values:void 0,default:V}):(0,I.$Um)(R)!=="object"?(ee(X),{values:void 0,default:V}):{values:R.contents?R.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let q;try{q=await this.y(H,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const k=(await this.j.readFile(q.localized)).value.toString(),R=[],U=(0,I.$Lm)(k,R);return R.length>0?(W(q.localized,R),{values:void 0,default:q.original}):(0,I.$Um)(U)!=="object"?(ee(q.localized),{values:void 0,default:q.original}):{values:U,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,x){if(H)try{const G=(await this.j.readFile(H)).value.toString();return(0,I.$Lm)(G,x)}catch{}}y(H,x){return new Promise((G,V)=>{const W=ee=>{const ne=(0,l.$ig)(H,`package.nls.${ee}.json`);this.j.exists(ne).then(re=>{re&&G({localized:ne,original:(0,l.$ig)(H,"package.nls.json")});const X=ee.lastIndexOf("-");X===-1?G({localized:(0,l.$ig)(H,"package.nls.json"),original:null}):(ee=ee.substring(0,X),W(ee))})};if(x.devMode||x.pseudo||!x.language)return G({localized:(0,l.$ig)(H,"package.nls.json"),original:null});W(x.language)})}z(H,x){return`[${H.path}]: ${x}`}};z=ye([Z(1,v.$kp),Z(2,u.$Ck),Z(3,c.$6j),Z(4,s.$5i)],z);let B=class extends z{constructor(H,x,G,V,W,ee,ne){super(x,V,W,ee,ne),this.G=H,this.H=G,this.D=this.B(new N.$Eg(3e3)),this.F=this.B(new r.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const x=this.M(H),G=await this.I(x);if(this.C=H,G&&G.input&&T.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),G.result.map(W=>(W.location=h.URI.revive(W.location),W));const V=await super.scanExtensions(H);return await this.J(x,{input:H,result:V}),V}async I(H){try{const x=await this.j.readFile(H),G=JSON.parse(x.value.toString());return{result:G.result,input:(0,a.$$g)(G.input)}}catch(x){this.m.debug("Error while reading the extension cache file:",H.path,(0,D.$8)(x))}return null}async J(H,x){try{await this.j.writeFile(H,L.$Fd.fromString(JSON.stringify(x)))}catch(G){this.m.debug("Error while writing the extension cache file:",H.path,(0,D.$8)(G))}}async L(){if(!this.C)return;const H=this.M(this.C),x=await this.I(H);if(!x)return;const G=x.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$Zm(V,G))try{this.m.info("Invalidating Cache",G,V),await this.j.del(H),this.F.fire()}catch(W){this.m.error(W)}}M(H){const x=this.N(H);return this.h.extUri.joinPath(x.cacheHome,H.type===0?C.$Ql:C.$Pl)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(x=>this.h.extUri.isEqual(H.location,x.extensionsResource))??this.G:this.H.defaultProfile}};B=ye([Z(2,b.$Ek),Z(3,v.$kp),Z(4,u.$Ck),Z(5,c.$6j),Z(6,s.$5i)],B);function _(Q,H){const x=(0,y.$so)(Q.manifest.publisher,Q.manifest.name);return{id:x,identifier:new C.$Vl(x),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:H,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.$rp=_;class J extends F{constructor(H,x,G,V,W,ee,ne,re,X,q,k,R){super(H,x,(0,l.$ig)(G,".vscode-oss-dev","extensions","control.json"),V,W,ee,ne,re,X,q,k,R),this.R=(async()=>{if(g.$y)try{const U=await this.w.readFile(h.URI.file(g.$y));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$sp=J}),define(oe[244],ae([0,1,64,5,38,3,2,23,16,31,7,17]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let g=class extends D.$kc{constructor(f,w){super(),this.b=f,this.f=w,this.a=new N.$Mg(5)}async postUninstall(f){const w=this.g(f,"uninstall");w&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,f),this.f.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.f.error(d)}}));try{await m.Promises.rm(this.m(f))}catch(d){this.f.error("Error while removing extension storage path",f.identifier.id),this.f.error(d)}}g(f,w){const d=`vscode:${w}`;if(f.location.scheme===I.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[d]=="string"){const h=f.manifest.scripts[d].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${d} should be a node script`),null):{script:(0,S.$9d)(f.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(f,w,d,h,o){return new Promise(($,y)=>{const C=this.j(f,w,d,o);let i;const c=n=>{i&&(clearTimeout(i),i=null),n?y(n):$(void 0)};C.on("error",n=>{c((0,A.$mi)(n)||"Unknown")}),C.on("exit",(n,s)=>{c(n?`post-${w} process exited with code ${n}`:void 0)}),h&&(i=setTimeout(()=>{i=null,C.kill(),y("timed out")},5e3))})}j(f,w,d,h){const o={silent:!0,execArgv:void 0},$=(0,O.fork)(f,[`--type=extension-post-${w}`,...d],o);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const y=L.Event.fromNodeEventEmitter($.stdout,"data"),C=L.Event.fromNodeEventEmitter($.stderr,"data");y(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,n)),C(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,n));const i=L.Event.any(L.Event.map(y,n=>({data:`%c${n}`,format:[""]})),L.Event.map(C,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),$}m(f){return(0,S.$9d)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.$up=g,e.$up=g=ye([Z(0,E.$Ek),Z(1,P.$5i)],g)}),define(oe[245],ae([0,1,7,17,28,22,50,12,15,11]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let P=class extends D.$lp{constructor(g,l,f,w,d,h){super(m.URI.file(g.extensionsPath),l,f,w,d,h)}};e.$lN=P,e.$lN=P=ye([Z(0,S.$Jh),Z(1,I.$6j),Z(2,N.$Ek),Z(3,A.$Ck),Z(4,L.$9k),Z(5,O.$5i)],P)}),define(oe[246],ae([0,1,11,15,50,79,12,4,7,24,28,17]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0;let g=class extends L.$sp{constructor(f,w,d,h,o,$,y,C){super(O.URI.file(o.builtinExtensionsPath),O.URI.file(o.extensionsPath),o.userHome,f.defaultProfile,f,w,d,h,o,$,y,C)}};e.$V6b=g,e.$V6b=g=ye([Z(0,E.$Ek),Z(1,A.$kp),Z(2,D.$6j),Z(3,S.$5i),Z(4,N.$Jh),Z(5,m.$kj),Z(6,P.$Ck),Z(7,I.$Ah)],g)}),define(oe[20],ae([0,1,5,3,2,100,9,66,4,17]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,S.$Bh)("storageService");var P;(function(o){o[o.NONE=0]="NONE",o[o.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(o){o[o.APPLICATION=-1]="APPLICATION",o[o.PROFILE=0]="PROFILE",o[o.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var g;(function(o){o[o.USER=0]="USER",o[o.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function l(o){const $=o.get(e.$Uo);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Wo=l;class f extends A.$kc{static{this.a=60*1e3}constructor($={flushInterval:f.a}){super(),this.m=$,this.b=this.B(new N.$id),this.c=this.B(new N.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new O.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,y,C){return N.Event.filter(this.b.event,i=>i.scope===$&&(y===void 0||i.key===y),C)}n(){this.j.value=(0,O.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,y){const{key:C,external:i}=y;if(C===e.$Uo){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:C,target:this.J($)[C],external:i})}w($){this.f.fire({reason:$})}get($,y,C){return this.P(y)?.get($,C)}getBoolean($,y,C){return this.P(y)?.getBoolean($,C)}getNumber($,y,C){return this.P(y)?.getNumber($,C)}getObject($,y,C){return this.P(y)?.getObject($,C)}storeAll($,y){this.y(()=>{for(const C of $)this.store(C.key,C.value,C.scope,C.target,y)})}store($,y,C,i,c=!1){if((0,D.$sf)(y)){this.remove($,C,c);return}this.y(()=>{this.z($,C,i),this.P(C)?.set($,y,c)})}remove($,y,C=!1){this.y(()=>{this.z($,y,void 0),this.P(y)?.delete($,C)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,y){const C=[],i=this.J($);for(const c of Object.keys(i))i[c]===y&&C.push(c);return C}z($,y,C,i=!1){const c=this.J(y);typeof C=="number"?c[$]!==C&&(c[$]=C,this.P(y)?.set(e.$Uo,JSON.stringify(c),i)):typeof c[$]=="number"&&(delete c[$],this.P(y)?.set(e.$Uo,JSON.stringify(c),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const y=this.P($);return y?l(y):Object.create(null)}isNew($){return this.getBoolean(e.$To,$)===!0}async flush($=P.NONE){this.f.fire({reason:$});const y=this.P(-1),C=this.P(0),i=this.P(1);switch($){case P.NONE:await O.Promises.settled([y?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await O.Promises.settled([y?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,y=this.P(0)?.items??new Map,C=this.P(1)?.items??new Map;return h($,y,C,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,y){return this.w(P.NONE),(0,m.$Dk)($)?this.R($,y):this.S($,y)}M($,y){return!($.id===y.id||w(y)&&w($))}N($,y,C){this.y(()=>{const i=new Set;for(const[c,n]of $)i.add(c),y.get(c)!==n&&this.u(C,{key:c,external:!0});for(const[c]of y.items)i.has(c)||this.u(C,{key:c,external:!0})})}}e.$Xo=f;function w(o){return o.isDefault||!!o.useDefaultFlags?.globalState}e.$Yo=w;class d extends f{constructor(){super(),this.U=this.B(new I.$Ro(new I.$So,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Ro(new I.$So,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Ro(new I.$So,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Zo=d;async function h(o,$,y,C,i,c){const n=j=>{try{return JSON.parse(j)}catch{return j}},s=new Map,t=new Map;o.forEach((j,F)=>{s.set(F,j),t.set(F,n(j))});const r=new Map,a=new Map;$.forEach((j,F)=>{r.set(F,j),a.set(F,n(j))});const v=new Map,b=new Map;y.forEach((j,F)=>{v.set(F,j),b.set(F,n(j))}),console.group(C!==i?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const u=[];if(s.forEach((j,F)=>{u.push({key:F,value:j})}),console.table(u),console.groupEnd(),console.log(t),C!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];r.forEach((F,T)=>{j.push({key:T,value:F})}),console.table(j),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const p=[];v.forEach((j,F)=>{p.push({key:F,value:j})}),console.table(p),console.groupEnd(),console.log(b)}e.$1o=h}),define(oe[114],ae([0,1,3,2,9,29,33,20]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bzb=e.$Azb=void 0;let S=class extends N.$kc{constructor(E,g){super(),this.a=new O.$fd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new m(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(g.onDidInstallExtensions(l=>l.forEach(({local:f,operation:w})=>{f&&w===4&&this.f(f.identifier)})))}async enableExtension(E,g){return this.f(E)?(this.a.fire({extensions:[E],source:g}),!0):!1}async disableExtension(E,g){return this.c(E)?(this.a.fire({extensions:[E],source:g}),!0):!1}getDisabledExtensions(){return this.h(L.$3n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const g=this.getDisabledExtensions();return g.every(l=>!(0,D.$po)(l,E))?(g.push(E),this.g(g),!0):!1}f(E){const g=this.getDisabledExtensions();for(let l=0;l<g.length;l++){const f=g[l];if((0,D.$po)(f,E))return g.splice(l,1),this.g(g),!0}return!1}g(E){this.j(L.$3n,E)}h(E){return this.b.get(E,0)}j(E,g){this.b.set(E,g,0)}};e.$Azb=S,e.$Azb=S=ye([Z(0,I.$Vo),Z(1,L.$2n)],S);class m extends N.$kc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new O.$fd),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$jc))(g=>this.f(g)))}get(E,g){let l;return g===0?((0,A.$sf)(this.a[E])&&(this.a[E]=this.g(E,g)),l=this.a[E]):l=this.g(E,g),JSON.parse(l)}set(E,g,l){const f=JSON.stringify(g.map(({id:d,uuid:h})=>({id:d,uuid:h})));this.g(E,l)!==f&&(l===0&&(g.length?this.a[E]=f:delete this.a[E]),this.h(E,g.length?f:void 0,l))}f(E){if(!(0,A.$sf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const f=this.get(E.key,E.scope),w=l.filter(h=>!f.some(o=>(0,D.$po)(h,o))),d=f.filter(h=>!l.some(o=>(0,D.$po)(o,h)));(w.length||d.length)&&this.b.fire([...w,...d])}}g(E,g){return this.c.get(E,g,"[]")}h(E,g,l){g?this.c.store(E,g,l,1):this.c.remove(E,l)}}e.$Bzb=m}),define(oe[247],ae([0,1,18,26,8,6,37,9,11,19,15,29,33,67,12,7,24,57,224,20,22,60]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=void 0;const i=L.$o?"web":(0,E.$Un)(L.$t,D.$4d),c="X-Market-Search-Activity-Id";var n;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...k){return String(k.reduce((R,U)=>R|U,0))}var t;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(R=b){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,U=this.d.pageSize){return new u({...this.d,pageNumber:R,pageSize:U})}withFilter(R,...U){const M=[...this.d.criteria,...U.length?U.map(K=>({filterType:R,value:K})):[{filterType:R}]];return new u({...this.d,criteria:M})}withSortBy(R){return new u({...this.d,sortBy:R})}withSortOrder(R){return new u({...this.d,sortOrder:R})}withFlags(...R){return new u({...this.d,flags:R.reduce((U,M)=>U|M,0)})}withAssetTypes(...R){return new u({...this.d,assetTypes:R})}withSource(R){return new u({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:U,pageSize:M,sortBy:K,sortOrder:Y,flags:se,assetTypes:le}=this.d;return{filters:[{criteria:R,pageNumber:U,pageSize:M,sortBy:K,sortOrder:Y}],assetTypes:le,flags:se}}get searchText(){const R=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(k,R){const U=(k||[]).filter(M=>M.statisticName===R)[0];return U?U.value:0}function j(k){const R="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(M=>M.assetType.indexOf(R)===0).reduce((M,K)=>{const Y=z(k,K.assetType);return Y&&M.push([K.assetType.substring(R.length),Y]),M},[])}function F(k){if(k.properties){const R=k.properties.filter(K=>K.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=R.filter(K=>U.test(K.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return z(k,r.Repository)}function T(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function z(k,R){return k.files.filter(M=>M.assetType===R)[0]?{uri:`${k.assetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function B(k,R){const U=k.properties?k.properties.filter(K=>K.key===R):[],M=U.length>0&&U[0].value;return M?M.split(",").map(K=>(0,g.$to)(K)):[]}function _(k){const R=k.properties?k.properties.filter(U=>U.key===a.Engine):[];return R.length>0&&R[0].value||""}function J(k){const R=k.properties?k.properties.filter(U=>U.key===a.PreRelease):[];return R.length>0&&R[0].value==="true"}function Q(k){const R=k.properties?k.properties.filter(M=>M.key===a.LocalizedLanguages):[],U=R.length>0&&R[0].value||"";return U?U.split(","):[]}function H(k){return k.properties?.find(R=>R.key===a.SponsorLink)?.value}function x(k){return k.indexOf("preview")!==-1}function G(k){return k.targetPlatform?(0,E.$Tn)(k.targetPlatform):"undefined"}function V(k){const R=(0,O.$Kb)(k.versions.map(G)),U=!!k.tags?.includes(E.$On),M=R.indexOf("web");return U?M===-1&&R.push("web"):M!==-1&&R.splice(M,1),R}function W(k,R){const U=(0,E.$Xn)(R);for(let M=0;M<k.length;M++){const K=k[M];if(K.version===k[M-1]?.version){let Y=M;const se=G(K);if(se===R)for(;Y>0&&k[Y-1].version===K.version;)Y--;else if(U.includes(se))for(;Y>0&&k[Y-1].version===K.version&&G(k[Y-1])!==R;)Y--;Y!==M&&(k.splice(M,1),k.splice(Y,0,K))}}return k}e.$4o=W;function ee(k,R,U){k.telemetryData={index:R,querySource:U,queryActivityId:k.queryContext?.[c]}}function ne(k,R,U,M){const K=k.versions[0],Y={manifest:z(R,r.Manifest),readme:z(R,r.Details),changelog:z(R,r.Changelog),license:z(R,r.License),repository:F(R),download:T(R),icon:z(R,r.Icon),signature:z(R,r.Signature),coreTranslations:j(R)};return{identifier:{id:(0,g.$uo)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:R.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(K),description:k.shortDescription||"",installCount:p(k.statistics,"install"),rating:p(k.statistics,"averagerating"),ratingCount:p(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:U,assets:Y,properties:{dependencies:B(R,a.Dependency),extensionPack:B(R,a.ExtensionPack),engine:_(R),localizedLanguages:Q(R),targetPlatform:G(R),isPreReleaseVersion:J(R)},hasPreReleaseVersion:J(K),hasReleaseVersion:!0,preview:x(k.flags),isSigned:!!Y.signature,queryContext:M}}let re=class{constructor(R,U,M,K,Y,se,le,ue){this.k=U,this.l=M,this.n=K,this.o=Y,this.q=se,this.u=le,this.w=ue;const he=le.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,o.$3o)(le.version,le,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,U,M){const K=N.CancellationToken.isCancellationToken(U)?{}:U,Y=N.CancellationToken.isCancellationToken(U)?U:M,se=[],le=[],ue=[],he=[];let $e=!0;for(const ve of R){ve.uuid?le.push(ve.uuid):se.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),$e=$e&&!!ve.hasPreRelease&&!Ie}if(!le.length&&!se.length)return[];let de=new u().withPage(1,R.length);le.length&&(de=de.withFilter(t.ExtensionId,...le)),se.length&&(de=de.withFilter(t.ExtensionName,...se)),(K.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:we}=await this.z(de,{targetPlatform:K.targetPlatform??i,includePreRelease:ue,versions:he,compatible:!!K.compatible},Y);return K.source&&we.forEach((ve,Ie)=>ee(ve,Ie,K.source)),we}async getCompatibleExtension(R,U,M){if((0,E.$Vn)(R.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(R,U,M))return R;const K=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,R.identifier.uuid),{extensions:Y}=await this.z(K,{targetPlatform:M,compatible:!0,includePreRelease:U},N.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(R,U,M){if(!(0,E.$Wn)(R.properties.targetPlatform,R.allTargetPlatforms,M)||!U&&R.properties.isPreReleaseVersion)return!1;let K=R.properties.engine;if(!K){const Y=await this.getManifest(R,N.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");K=Y.engines.vscode}return(0,l.$Ho)(K,this.u.version,this.u.date)}async y(R,U,M,K,Y){if(!(0,E.$Wn)(G(R),K,Y)||U!=="any"&&J(R)!==(U==="prerelease"))return!1;if(M)try{const se=await this.E(R);if(!(0,l.$Ho)(se,this.u.version,this.u.date))return!1}catch(se){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,A.$8)(se)),!1}return!0}async query(R,U){let M=R.text||"";const K=R.pageSize??50;let Y=new u().withPage(1,K);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Y=Y.withFilter(t.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Y=Y.withFilter(t.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(t.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),Y=Y.withFilter(t.SearchText,M)),Y=Y.withSortBy(0)):R.ids?Y=Y.withFilter(t.ExtensionId,...R.ids):R.names?Y=Y.withFilter(t.ExtensionName,...R.names):Y=Y.withSortBy(4),typeof R.sortBy=="number"&&(Y=Y.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(Y=Y.withSortOrder(R.sortOrder)),R.source&&(Y=Y.withSource(R.source));const se=async($e,de)=>{const{extensions:we,total:ve}=await this.z($e,{targetPlatform:i,compatible:!1,includePreRelease:!!R.includePreRelease},de);return we.forEach((Ie,Le)=>ee(Ie,($e.pageNumber-1)*$e.pageSize+Le,R.source)),{extensions:we,total:ve}},{extensions:le,total:ue}=await se(Y,U),he=async($e,de)=>{if(de.isCancellationRequested)throw new A.$3;const{extensions:we}=await se(Y.withPage($e+1),de);return we};return{firstPage:le,total:ue,pageSize:Y.pageSize,getPage:he}}async z(R,U,M){const K=R.flags;R.flags&n.IncludeLatestVersionOnly&&R.flags&n.IncludeVersions&&(R=R.withFlags(R.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(R.flags&n.IncludeLatestVersionOnly)&&!(R.flags&n.IncludeVersions)&&(R=R.withFlags(R.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(R=R.withFlags(R.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),R=R.withFlags(R.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Y,total:se,context:le}=await this.B(R,M);if(!(R.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of Y){const ve=await this.A(we,U,le);ve&&de.push(ve)}return{extensions:de,total:se}}const he=[],$e=new Map;for(let de=0;de<Y.length;de++){const we=Y[de],ve={id:(0,g.$uo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,I.$pf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Te=>(0,g.$po)(Te,ve))?.includePreRelease;if(U.compatible&&(0,E.$Vn)(V(we),U.targetPlatform))continue;const Le=await this.A(we,U,le);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==U.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Le])}if($e.size){const de=new C.$bd,we=new u().withFlags(K&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:ve}=await this.z(we,U,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of ve){const Le=$e.get(Ie.identifier.uuid);he.push([Le,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:se}}async A(R,U,M){const K={id:(0,g.$uo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},Y=U.versions?.find(he=>(0,g.$po)(he,K))?.version,se=(0,I.$pf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(he=>(0,g.$po)(he,K))?.includePreRelease,le=V(R),ue=W(R.versions,U.targetPlatform);if(U.compatible&&(0,E.$Vn)(le,U.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(Y&&$e.version!==Y)){if(await this.y($e,se?"any":"release",U.compatible,le,U.targetPlatform))return ne(R,$e,le,M);if(Y&&$e.version===Y)return null}}return Y||U.compatible?null:ne(R,R.versions[0],le)}async B(R,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const M=await this.j,K=JSON.stringify(R.raw),Y={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},se=new C.$bd;let le,ue,he=0;try{if(le=await this.k.request({type:"POST",url:this.g&&R.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:Y},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,h.$Oo)(le);if($e){const de=$e.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[c]:le.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(K.length),duration:se.elapsed(),success:!!le&&(0,h.$Ko)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ue?(0,A.$2)(ue)?"canceled":(0,A.$8)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(R,U,M,K){if(!this.isEnabled())return;const Y=L.$o?this.x(`/itemName/${R}.${U}/version/${M}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${U}/${M}/stats?statType=${K}`),se=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:se};try{await this.k.request({type:"POST",url:Y,headers:ue},N.CancellationToken.None)}catch{}}async download(R,U,M){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const K=(0,g.$xo)(R),Y=new Date().getTime(),se=de=>this.o.publicLog("galleryService:downloadVSIX",{...K,duration:de}),le=M===2?"install":M===3?"update":"",ue=le?{uri:`${R.assets.download.uri}${S.URI.parse(R.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${R.assets.download.fallbackUri}${S.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:R.assets.download,he=R.queryContext?.[c]?{[c]:R.queryContext[c]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(U,$e.stream),se(new Date().getTime()-Y)}async downloadSignatureArchive(R,U){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const M=await this.D(R.assets.signature);await this.q.writeFile(U,M.stream)}async getReadme(R,U){if(R.assets.readme){const M=await this.D(R.assets.readme,{},U);return await(0,h.$No)(M)||""}return""}async getManifest(R,U){if(R.assets.manifest){const M=await this.D(R.assets.manifest,{},U),K=await(0,h.$No)(M);return K?JSON.parse(K):null}return null}async C(R,U){const M=z(R,r.Manifest);if(!M)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Y=await this.D(M,{headers:K});return await(0,h.$Oo)(Y)}async getCoreTranslation(R,U){const M=R.assets.coreTranslations.filter(K=>K[0]===U.toUpperCase())[0];if(M){const K=await this.D(M[1]),Y=await(0,h.$No)(K);return Y?JSON.parse(Y):null}return null}async getChangelog(R,U){if(R.assets.changelog){const M=await this.D(R.assets.changelog,{},U);return await(0,h.$No)(M)||""}return""}async getAllCompatibleVersions(R,U,M){let K=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?K=K.withFilter(t.ExtensionId,R.identifier.uuid):K=K.withFilter(t.ExtensionName,R.identifier.id);const{galleryExtensions:Y}=await this.B(K,N.CancellationToken.None);if(!Y.length)return[];const se=V(Y[0]);if((0,E.$Vn)(se,M))return[];const le=[];await Promise.all(Y[0].versions.map(async $e=>{try{await this.y($e,U?"any":"release",!0,se,M)&&le.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of W(le,M))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:J($e)}));return ue}async D(R,U={},M=N.CancellationToken.None){const K=await this.j,Y={type:"GET"},se={...K,...U.headers||{}};U={...U,...Y,headers:se};const le=R.uri,ue=R.fallbackUri,he={...U,url:le};try{const $e=await this.k.request(he,M);if($e.res.statusCode===200)return $e;const de=await(0,h.$No)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,A.$2)($e))throw $e;const de=(0,A.$8)($e);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:de});const we={...U,url:ue};return this.k.request(we,M)}}async E(R){let U=_(R);if(!U){const M=await this.C(R,N.CancellationToken.None);if(!M)throw new Error("Manifest was not found");U=M.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const R=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.$Oo)(R),M=[],K={},Y=[];if(U){for(const se of U.malicious)M.push({id:se});if(U.migrateToPreRelease)for(const[se,le]of Object.entries(U.migrateToPreRelease))(!le.engine||(0,l.$Ho)(le.engine,this.u.version,this.u.date))&&(K[se.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[se,le]of Object.entries(U.deprecated))le&&(K[se.toLowerCase()]=(0,I.$pf)(le)?{}:le);if(U.search)for(const se of U.search)Y.push(se)}return{malicious:M,deprecated:K,search:Y}}};re=ye([Z(1,h.$Io),Z(2,w.$5i),Z(3,P.$Ih),Z(4,y.$9k),Z(5,f.$6j),Z(6,d.$kj),Z(7,m.$8h)],re);let X=class extends re{constructor(R,U,M,K,Y,se,le,ue){super(R,U,M,K,Y,se,le,ue)}};e.$5o=X,e.$5o=X=ye([Z(0,$.$Vo),Z(1,h.$Io),Z(2,w.$5i),Z(3,P.$Ih),Z(4,y.$9k),Z(5,f.$6j),Z(6,d.$kj),Z(7,m.$8h)],X);let q=class extends re{constructor(R,U,M,K,Y,se,le){super(void 0,R,U,M,K,Y,se,le)}};e.$6o=q,e.$6o=q=ye([Z(0,h.$Io),Z(1,w.$5i),Z(2,P.$Ih),Z(3,y.$9k),Z(4,f.$6j),Z(5,d.$kj),Z(6,m.$8h)],q)}),define(oe[80],ae([0,1,4,3,2,20,33,24,18,7,9]),function(te,e,O,N,A,L,D,I,S,m,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uz=e.$Tz=void 0,e.$Tz=(0,O.$Bh)("IExtensionStorageService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends A.$kc{static{E=this}static{this.a=512*1024}static b(w){return`extensionKeys/${(0,D.$to)(w.id)}@${w.version}`}static c(w){const d=g.exec(w);if(d&&d[1])return{id:d[1],version:d[2]}}static async removeOutdatedExtensionVersions(w,d){const h=await w.getInstalled(),o=[];for(const[$,y]of E.f(d)){const C=h.find(i=>(0,D.$po)(i.identifier,{id:$}))?.manifest.version;for(const i of y)C!==i&&o.push(E.b({id:$,version:i}))}for(const $ of o)d.remove($,0)}static f(w){const d=new Map,h=w.keys(0,1);for(const o of h){const $=E.c(o);if($){let y=d.get($.id.toLowerCase());y||d.set($.id.toLowerCase(),y=[]),y.push($.version)}}return d}constructor(w,d,h){super(),this.j=w,this.m=d,this.n=h,this.g=this.B(new N.$fd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(w),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$jc))(o=>this.r(o)))}r(w){if(this.h.has(w.key.toLowerCase())){this.g.fire();return}const d=E.c(w.key);if(d){if(this.j.get(w.key,0)===void 0)this.h.delete(d.id.toLowerCase());else{let h=this.h.get(d.id.toLowerCase());h||this.h.set(d.id.toLowerCase(),h=[]),h.push(d.version),this.g.fire()}return}}s(w){if((0,P.$jf)(w))return w;const d=w.manifest?w.manifest.publisher:w.publisher,h=w.manifest?w.manifest.name:w.name;return(0,D.$so)(d,h)}getExtensionState(w,d){const h=this.s(w),o=this.getExtensionStateRaw(w,d);if(o)try{return JSON.parse(o)}catch($){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${d}): ${$}`)}}getExtensionStateRaw(w,d){const h=this.s(w),o=this.j.get(h,d?0:1);return o&&o?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${d}): ${o.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),o}setExtensionState(w,d,h){const o=this.s(w);d===void 0?this.j.remove(o,h?0:1):this.j.store(o,JSON.stringify(d),h?0:1,1)}setKeysForSync(w,d){this.j.store(E.b(w),JSON.stringify(d),0,1)}getKeysForSync(w){const d=this.m.extensionSyncedKeys?.[w.id.toLowerCase()],h=this.j.get(E.b(w),0),o=h?JSON.parse(h):void 0;return o&&d?(0,S.$Kb)([...o,...d]):o||d}addToMigrationList(w,d){if(w!==d){const h=this.t.filter(o=>!o.includes(w)&&!o.includes(d));h.push([w,d]),this.t=h}}getSourceExtensionToMigrate(w){const d=this.t.find(([,h])=>w===h);return d?d[0]:void 0}get t(){const w=this.j.get("extensionStorage.migrationList",-1,"[]");try{const d=JSON.parse(w);if(Array.isArray(d))return d}catch{}return[]}set t(w){w.length?this.j.store("extensionStorage.migrationList",JSON.stringify(w),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Uz=l,e.$Uz=l=E=ye([Z(0,L.$Vo),Z(1,I.$kj),Z(2,m.$5i)],l)}),define(oe[248],ae([0,1,29,12,24,15,98,55,20,22,221]),function(te,e,O,N,A,L,D,I,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;let E=class extends P.$y4b{constructor(l,f,w,d,h,o,$,y){super(l.userHome,h,f,w,d,o,$,y)}};e.$e8b=E,e.$e8b=E=ye([Z(0,L.$Jh),Z(1,m.$9k),Z(2,O.$2n),Z(3,S.$Vo),Z(4,I.$45b),Z(5,D.$NUb),Z(6,N.$6j),Z(7,A.$kj)],E)}),define(oe[249],ae([0,1,105,3,22,15,2,7,16,64,24,6,5,101,19,165,36,20,9,133,21]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=void 0;const C=[O.$67b,O.$77b],i="remoteTunnelSession",c="remoteTunnelIsService";let n=class extends D.$kc{constructor(a,v,b,u,p,j,F){super(),this.y=a,this.z=v,this.C=b,this.D=j,this.F=F,this.f=new N.$fd,this.onDidTokenFailed=this.f.event,this.g=new N.$fd,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$fd,this.onDidChangeMode=this.h.event,this.n=O.$47b,this.w=!1,this.I=(T,z)=>{z?this.j.error(T):this.j.info(T)},this.j=this.B(u.createLogger((0,y.$ig)(b.logsHome,`${O.$87b}.log`),{id:O.$87b,name:O.$97b})),this.t=new g.$Dg(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,I.$hj)(T)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(j.onDidChangeConfiguration(T=>{C.some(z=>T.affectsConfiguration(z))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;E.$j?a=this.C.appRoot:a=(0,S.$_d)((0,S.$_d)(this.C.appRoot)),this.u=(0,S.$9d)(a,"bin",`${this.z.tunnelApplicationName}${E.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(O.$47b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const b=(z,B)=>{B?this.j.error(z):a+=z,!this.C.isBuilt&&z.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,w.localize)(0,null)))},u=this.O("status",["status"],b);this.r=u;try{if(await u,this.r!==u)return;const z=JSON.parse(a.trim().split(`
`).find(B=>B.startsWith("{")));if(v=z.service_installed,this.j.info(z.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!z.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(z){this.j.error(z),this.G(O.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const z=p.token;this.G(O.TunnelStates.connecting((0,w.localize)(1,null,p.accountLabel,p.providerId)));const B=(J,Q)=>{J=J.replaceAll(z,"*".repeat(4)),b(J,Q)},_=this.O("login",["user","login","--provider",p.providerId,"--access-token",z,"--log",(0,I.$hj)(this.j.getLevel())],B);this.r=_;try{if(await _,this.r!==_)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(p),this.G(O.TunnelStates.disconnected(p));return}}const j=this.Q();j?this.G(O.TunnelStates.connecting((0,w.localize)(2,null,j))):this.G(O.TunnelStates.connecting((0,w.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,I.$hj)(this.j.getLevel())];j?F.push("--name",j):F.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(F)===!1),this.N(p,F,T)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(b){this.j.error(b),v=1}if(v!==0){const b=(0,w.localize)(4,null);return this.j.warn(b),this.G(O.TunnelStates.connecting(b)),!1}return!0}async N(a,v,b){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let u=!1;const p=this.O("tunnel",v,(j,F)=>{F?this.j.error(j):this.j.info(j),j.includes("Connected to an existing tunnel process")&&(u=!0);const T=j.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const z={link:T[1],domain:T[2],tunnelName:T[4],isAttached:u};this.G(O.TunnelStates.connected(z,b))}else j.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$47b,this.G(O.TunnelStates.disconnected()))})}O(a,v,b=this.I){return(0,g.$ug)(u=>new Promise((p,j)=>{u.isCancellationRequested&&p(-1);let F;const T=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,m.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$9d)(this.C.appRoot,"cli"),stdio:T});else{b(`Running tunnel CLI
`,!1);const z=this.J();b(`${a} Spawning: ${z} tunnel ${v.join(" ")}
`,!1),F=(0,m.spawn)(z,["tunnel",...v],{cwd:(0,d.homedir)(),stdio:T})}F.stdout.pipe(new $.$OS(`
`)).on("data",z=>{if(F){const B=z.toString();b(B,!1)}}),F.stderr.pipe(new $.$OS(`
`)).on("data",z=>{if(F){const B=z.toString();b(B,!0)}}),F.on("exit",z=>{F&&(b(`${a} exit(${F.pid}): + ${z} `,!1),F=void 0,p(z||0))}),F.on("error",z=>{F&&(b(`${a} error(${F.pid}): + ${z} `,!0),F=void 0,j())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$77b)}Q(){let a=this.D.getValue(O.$67b)||(0,d.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),v=this.F.getBoolean(c,-1,!1);if(a){const b=JSON.parse(a);if(b&&(0,o.$jf)(b.accountLabel)&&(0,o.$jf)(b.sessionId)&&(0,o.$jf)(b.providerId))return{active:!0,session:b,asService:v};this.j.error("Problems restoring session from storage, invalid format",b)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$47b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(v),-1,1),this.F.store(c,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(c,-1)}};e.$a8b=n,e.$a8b=n=ye([Z(0,A.$9k),Z(1,P.$kj),Z(2,L.$Jh),Z(3,I.$6i),Z(4,l.$$7b),Z(5,f.$8h),Z(6,h.$Vo)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(oe[250],ae([0,1,5,2,23,21,66,20,75,17]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;class P extends I.$Xo{constructor(g,l,f,w){super(),this.bb=g,this.cb=l,this.db=f,this.eb=w,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$jc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$jc),this.ab=this.hb(this.bb)}fb(){const g=this.B(new S.$$zb(this.db.getChannel("storage"))),l=this.B(new D.$Ro(g));return this.B(l.onDidChangeStorage(f=>this.u(-1,f))),l}gb(g){this.X.clear(),this.W=g;let l;if((0,I.$Yo)(g))l=this.U;else{const f=this.X.add(new S.$_zb(this.db.getChannel("storage"),g));l=this.X.add(new D.$Ro(f))}return this.X.add(l.onDidChangeStorage(f=>this.u(0,f))),l}hb(g){this.$.clear(),this.Z=g?.id;let l;if(g){const f=this.$.add(new S.$aAb(this.db.getChannel("storage"),g));l=this.$.add(new D.$Ro(f)),this.$.add(l.onDidChangeStorage(w=>this.u(1,w)))}return l}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(g){switch(g){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(g){switch(g){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$ig)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(g){if(!this.M(this.W,g))return;const l=this.Y,f=l.items;l!==this.U&&await l.close(),this.Y=this.gb(g),await this.Y.init(),this.N(f,this.Y,0)}async S(g,l){const f=this.ab,w=f?.items??new Map;await f?.close(),this.ab=this.hb(g),await this.ab.init(),this.N(w,this.ab,1)}hasScope(g){return(0,m.$Dk)(g)?this.W.id===g.id:this.Z===g.id}}e.$f8b=P}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=void 0;class D{constructor(m,P){this.a=m,this.b=P}listen(m,P){const E=this.b(m);switch(P){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,g=>({all:g.all.map(l=>(0,L.$Dm)({...l},E)),added:g.added.map(l=>(0,L.$Dm)({...l},E)),removed:g.removed.map(l=>(0,L.$Dm)({...l},E)),updated:g.updated.map(l=>(0,L.$Dm)({...l},E))}))}throw new Error(`Invalid listen ${P}`)}async call(m,P,E){const g=this.b(m);switch(P){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,L.$Dm)({...l},g)}case"updateProfile":{let l=(0,A.$Fk)((0,L.$Em)(E[0],g),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,L.$Dm)({...l},g)}case"removeProfile":{const l=(0,A.$Fk)((0,L.$Em)(E[0],g),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.$sN=D;class I extends N.$kc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new O.$fd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(g=>(0,A.$Fk)(g,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(g=>{const l=g.added.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme)),f=g.removed.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme)),w=g.updated.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme));this.a=g.all.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme)),this.b.fire({added:l,removed:f,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,P,E){const g=await this.f.call("createNamedProfile",[m,P,E]);return(0,A.$Fk)(g,this.profilesHome.scheme)}async createProfile(m,P,E,g){const l=await this.f.call("createProfile",[m,P,E,g]);return(0,A.$Fk)(l,this.profilesHome.scheme)}async createTransientProfile(m){const P=await this.f.call("createTransientProfile",[m]);return(0,A.$Fk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(m,P){await this.f.call("setProfileForWorkspace",[m,P])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,P){const E=await this.f.call("updateProfile",[m,P]);return(0,A.$Fk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$tN=I}),define(oe[58],ae([0,1,2,66,4,20,3,75,17]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eAb=e.$dAb=e.$cAb=void 0,e.$cAb=(0,A.$Bh)("IUserDataProfileStorageService");let m=class extends O.$kc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async f=>this.b(f))}async updateStorageData(l,f,w){return this.withProfileScopedStorageService(l,async d=>this.c(d,f,w))}async withProfileScopedStorageService(l,f){if(this.a.hasScope(l))return f(this.a);const w=await this.g(l),d=new E(w);try{await d.initialize();const h=await f(d);return await d.flush(),h}finally{d.dispose(),await this.f(w)}}b(l){const f=new Map,w=d=>{for(const h of l.keys(0,d))f.set(h,{value:l.get(h,0),target:d})};return w(0),w(1),f}c(l,f,w){l.storeAll(Array.from(f.entries()).map(([d,h])=>({key:d,value:h,scope:0,target:w})),!0)}async f(l){try{await l.close()}finally{(0,O.$ec)(l)&&l.dispose()}}};e.$dAb=m,e.$dAb=m=ye([Z(0,L.$Vo)],m);class P extends m{constructor(l,f,w,d){super(w),this.j=l;const h=l.getChannel("profileStorageListener"),o=this.B(new O.$lc);this.h=this.B(new D.$fd({onWillAddFirstListener:()=>{o.value=h.listen("onDidChange")($=>{d.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(y=>(0,S.$Fk)(y,f.profilesHome.scheme)),valueChanges:$.valueChanges.map(y=>({...y,profile:(0,S.$Fk)(y.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>o.value=void 0})),this.onDidChange=this.h.event}async g(l){const f=this.j.getChannel("storage");return(0,L.$Yo)(l)?new I.$$zb(f):new I.$_zb(f,l)}}e.$eAb=P;class E extends L.$Xo{constructor(l){super({flushInterval:100}),this.s=this.B(new N.$Ro(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,20,7,17,71,58]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=void 0;let I=class extends D.$eAb{constructor(m,P,E,g){super(m,P,E,g)}};e.$W7b=I,e.$W7b=I=ye([Z(0,L.$i7b),Z(1,A.$Ek),Z(2,O.$Vo),Z(3,N.$5i)],I)}),define(oe[39],ae([0,1,18,5,14,26,3,34,2,27,9,170,19,15,12,7,44,20,22,28,25,17]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Ab=e.$8Ab=e.$7Ab=e.$6Ab=e.$5Ab=e.$4Ab=e.$3Ab=void 0;function i(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||c(v.syncData)))}e.$3Ab=i;function c(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$4Ab=c;function n(v,b){return`${(0,m.$bf)(v)}${b.isDefault?"":` (${b.name})`}`}e.$5Ab=n;let s=class extends S.$kc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(b,u,p,j,F,T,z,B,_,J,Q,H){super(),this.syncResource=b,this.collection=u,this.G=p,this.H=j,this.I=F,this.J=T,this.L=z,this.M=B,this.N=_,this.O=J,this.P=Q,this.c=null,this.m="idle",this.n=this.B(new D.$fd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$fd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Eg(50)),this.w=this.B(new D.$fd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(b.syncResource,b.profile),this.h=H.extUri,this.f=this.h.joinPath(j.userDataSyncHome,...(0,y.$Agb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,y.$Vgb),this.y=(0,y.$Bgb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,j,this.h),this.j=(0,d.$2o)(j,p,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const u=await this.Y(b.remoteUserData,b.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.ub(b):!0)&&this.w.fire()}}S(b){this.m!==b&&(this.m=b,this.n.fire(b))}async sync(b,u={}){await this.U(b,!0,this.ob(),u)}async preview(b,u,p={}){return this.U(b,!1,u,p)}async apply(b,u={}){try{this.F={...u};const p=await this.ab(b);return this.S(p),this.c}finally{this.F={}}}async U(b,u,p,j){try{if(this.F={...j},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const T=await this.getLastSyncUserData(),z=await this.X(b,T);return F=await this.Y(z,T,u,p),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(b){const u=this.kb(b);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),j=await this.X(null,p),F=await this.W(j),T=await this.qb({ref:j.ref,syncData:u},p,F,this.ob(),L.CancellationToken.None),z=[];for(const B of T){const _=await this.sb(B,B.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.sb(B,B.previewResource,B.remoteContent,L.CancellationToken.None);z.push([B,{..._,remoteChange:J!==0?J:2}])}await this.tb(j,p,z,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(b){const u=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===u}async X(b,u){if(u){const p=b?b[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(b,u,p,j){if(b.syncData&&b.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new y.$Igb((0,E.localize)(0,null,this.resource,this.pb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(b,u,p,j)}catch(F){if(F instanceof y.$Igb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(b,u,p,j);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(b,u,p,j)}throw F}}async Z(b,u,p,j){try{const F=await this.W(b),T=!F&&u===null&&this.gb()!==void 0,z=p&&!T;this.c||(this.c=(0,N.$ug)(_=>this.eb(b,u,F,z,j,_)));let B=await this.c;if(p&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const _ of B.resourcePreviews)B=await this.accept(_.remoteResource)||B}return this.cb(B.resourcePreviews),B.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(b){return await this.$(b,async u=>{const p=await this.rb(u,L.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$Fd.fromString(p?.content||""));const j=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,L.CancellationToken.None):void 0;return u.acceptResult=j,u.mergeState=p.hasConflicts?"conflict":j?"accepted":"preview",u.localChange=j?j.localChange:p.localChange,u.remoteChange=j?j.remoteChange:p.remoteChange,u}),this.c}async accept(b,u){return await this.$(b,async p=>{const j=await this.sb(p,b,u,L.CancellationToken.None);return p.acceptResult=j,p.mergeState="accepted",p.localChange=j.localChange,p.remoteChange=j.remoteChange,p}),this.c}async discard(b){return await this.$(b,async u=>{const p=await this.rb(u,L.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$Fd.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(b,u){if(!this.c)return;let p=await this.c;const j=p.resourcePreviews.findIndex(({localResource:F,remoteResource:T,previewResource:z})=>this.h.isEqual(F,b)||this.h.isEqual(T,b)||this.h.isEqual(z,b));j!==-1&&(this.c=(0,N.$ug)(async F=>{const T=[...p.resourcePreviews];return T[j]=await u(T[j]),{...p,resourcePreviews:T}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(b){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),b),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(b){const u=b.filter(({mergeState:p})=>p==="conflict");(0,O.$sb)(this.s,u,(p,j)=>this.h.isEqual(p.previewResource,j.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async db(b){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,b))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,b))return p.remoteContent;if(this.h.isEqual(p.localResource,b))return p.localContent;if(this.h.isEqual(p.baseResource,b))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(b){(0,f.$jk)(b)!==1&&this.O.error(b)}}async eb(b,u,p,j,F,T){const z=await this.qb(b,u,p,F,T),B=[];for(const _ of z){const J=_.previewResource.with({scheme:y.$Ugb,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)B.push({..._,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=j?await this.rb(_,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(_.previewResource,A.$Fd.fromString(Q?.content||""));const H=Q&&!Q.hasConflicts?await this.sb(_,_.previewResource,void 0,T):void 0;B.push({..._,acceptResult:H,mergeState:Q?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:Q?Q.localChange:_.localChange,remoteChange:H?H.remoteChange:Q?Q.remoteChange:_.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:u,resourcePreviews:B,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let b=this.gb();if(b||(b=await this.jb()),!b)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(b),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let j,F=1;for(;j===void 0&&F++<6;)try{const T=await this.hb();T&&(T.ref===u.ref?j=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof f.$nk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof y.$Igb)throw T;this.O.error(T,F)}}if(j===void 0)try{const T=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);j=T===null?null:this.kb(T),await this.ib({ref:u.ref,syncData:j})}catch(T){if(T instanceof y.$Igb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return j===void 0?null:{...u,syncData:j}}async fb(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),j={ref:b.ref,version:p,...u};this.I.store(this.z,JSON.stringify(j),-1,1),await this.ib(b)}gb(){return this.I.get(this.z,-1)}async hb(){const b=(await this.G.readFile(this.y)).value.toString();try{const u=b?JSON.parse(b):void 0;if(i(u))return u}catch(u){this.O.error(u)}}async ib(b){await this.G.writeFile(this.y,A.$Fd.fromString(JSON.stringify(b)))}async jb(){try{const b=await this.G.readFile(this.y),u=JSON.parse(b.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(b){b instanceof f.$nk&&b.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(b)}return this.I.get(this.z,-1)}async getRemoteUserData(b){const{ref:u,content:p}=await this.lb(b);let j=null;return p!==null&&(j=this.kb(p)),{ref:u,syncData:j}}kb(b){try{const u=JSON.parse(b);if(c(u))return u}catch(u){this.O.error(u)}throw new y.$Igb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(b){const u=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(b,u){const p=await this.j,j={version:this.pb,machineId:p,content:b};try{return u=await this.J.writeResource(this.resource,JSON.stringify(j),u,this.collection,this.F),{ref:u,syncData:j}}catch(F){throw F instanceof y.$Igb&&F.code==="TooLarge"&&(F=new y.$Igb(F.message,F.code,this.resource)),F}}async nb(b){const u={version:this.pb,content:b};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(y.$vgb)}};e.$6Ab=s,e.$6Ab=s=ye([Z(2,f.$6j),Z(3,l.$Ih),Z(4,h.$Vo),Z(5,y.$Dgb),Z(6,y.$Egb),Z(7,y.$Ngb),Z(8,o.$9k),Z(9,y.$Sgb),Z(10,g.$8h),Z(11,$.$Ck)],s);let t=class extends s{constructor(b,u,p,j,F,T,z,B,_,J,Q,H,x){super(u,p,j,F,T,z,B,_,J,Q,H,x),this.r=b,this.B(this.G.watch(this.h.dirname(b))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(b,u,p){try{u?await this.G.writeFile(this.r,A.$Fd.fromString(b),p?void 0:u):await this.G.createFile(this.r,A.$Fd.fromString(b),{overwrite:p})}catch(j){throw j instanceof f.$nk&&j.fileOperationResult===1||j instanceof f.$nk&&j.fileOperationResult===3?new y.$Igb(j.message,"LocalPreconditionFailed"):j}}async xb(){try{await this.G.del(this.r)}catch(b){if(!(b instanceof f.$nk&&b.fileOperationResult===1))throw b}}yb(b){b.contains(this.r)&&this.Q()}};e.$7Ab=t,e.$7Ab=t=ye([Z(3,f.$6j),Z(4,l.$Ih),Z(5,h.$Vo),Z(6,y.$Dgb),Z(7,y.$Egb),Z(8,y.$Ngb),Z(9,o.$9k),Z(10,y.$Sgb),Z(11,g.$8h),Z(12,$.$Ck)],t);let r=class extends t{constructor(b,u,p,j,F,T,z,B,_,J,Q,H,x,G){super(b,u,p,j,F,T,z,B,_,J,Q,x,G),this.zb=H,this.Bb=void 0}Ab(b,u){const p=[],j=(0,I.$Lm)(b,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,P.$qf)(j)&&u!==Array.isArray(j)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$8Ab=r,e.$8Ab=r=ye([Z(3,f.$6j),Z(4,l.$Ih),Z(5,h.$Vo),Z(6,y.$Dgb),Z(7,y.$Egb),Z(8,y.$Ngb),Z(9,o.$9k),Z(10,y.$Sgb),Z(11,y.$Rgb),Z(12,g.$8h),Z(13,$.$Ck)],r);let a=class{constructor(b,u,p,j,F,T,z){this.resource=b,this.g=u,this.h=p,this.j=j,this.k=F,this.l=T,this.d=z.extUri,this.f=(0,y.$Bgb)(void 0,this.resource,p,this.d)}async initialize({ref:b,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:b,syncData:p})}catch(j){this.j.error(j)}}m(b){try{const u=JSON.parse(b);if(c(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:b.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,A.$Fd.fromString(JSON.stringify(b)))}};e.$9Ab=a,e.$9Ab=a=ye([Z(1,C.$Ek),Z(2,l.$Ih),Z(3,w.$5i),Z(4,f.$6j),Z(5,h.$Vo),Z(6,$.$Ck)],a)}),define(oe[115],ae([0,1,5,26,8,3,41,2,27,19,15,114,29,33,80,45,12,4,70,7,20,22,28,17,39,232,111,25,58]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i,c,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L2b=e.$K2b=e.$J2b=e.$I2b=e.$H2b=void 0;async function v(T,z){const B=JSON.parse(T.content);if(T.version===1||T.version===2){const _=(await z.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of B)T.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),T.version===2&&_.every(Q=>!(0,l.$po)(Q.identifier,J.identifier))&&(J.installed=!0)}return B}function b(T){return JSON.parse(T.content)}e.$H2b=b;function u(T,z){return T.sort((B,_)=>!B.identifier.uuid&&_.identifier.uuid?-1:B.identifier.uuid&&!_.identifier.uuid?1:(0,S.$Fe)(B.identifier.id,_.identifier.id)),z?(0,D.$xS)(T,{}):JSON.stringify(T)}e.$I2b=u;let p=class extends n.$6Ab{constructor(z,B,_,J,Q,H,x,G,V,W,ee,ne,re,X,q,k,R){super({syncResource:"extensions",profile:z},B,J,_,Q,H,x,ne,re,W,ee,q),this.Cb=G,this.Db=V,this.Eb=R,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Ugb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Ugb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Ugb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Ugb,authority:"accepted"}),this.Bb=this.Eb.createInstance(j),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,U=>U.some(({local:M})=>!!M)),L.Event.filter(this.Cb.onDidUninstallExtension,U=>!U.error),L.Event.filter(k.onDidChange,U=>U.valueChanges.some(({profile:M,changes:K})=>this.syncResource.profile.id===M.id&&K.some(Y=>Y.key===g.$3n))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(z,B){const _=z.syncData?await v(z.syncData,this.Cb):null,J=B?.skippedExtensions??[],Q=B?.builtinExtensions??null,H=B?.syncData?await v(B.syncData,this.Cb):null,{localExtensions:x,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);_?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:W}=(0,s.$G2b)(x,_,H,J,G,Q),ee={local:V,remote:W,content:this.Hb(x,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:W!==null?2:0},ne=this.Ob(x,!1);return[{skippedExtensions:J,builtinExtensions:Q,baseResource:this.xb,baseContent:H?this.Ob(H,!1):ne,localResource:this.yb,localContent:ne,localExtensions:x,remoteResource:this.zb,remoteExtensions:_,remoteContent:_?this.Ob(_,!1):null,previewResource:this.wb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.Ab}]}async ub(z){const B=z.syncData?await v(z.syncData,this.Cb):null,{localExtensions:_,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,s.$G2b)(_,B,B,z.skippedExtensions||[],J,z.builtinExtensions||[]);return Q!==null}Hb(z,B,_,J){const Q=[...B,..._],H=new Set,x=G=>{H.add(G.id.toLowerCase()),G.uuid&&H.add(G.uuid)};Q.forEach(({identifier:G})=>x(G)),J.forEach(x);for(const G of z)H.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&H.has(G.identifier.uuid)||Q.push(G);return this.Ob(Q,!1)}async rb(z,B){return{...z.previewResult,hasConflicts:!1}}async sb(z,B,_,J){if(this.h.isEqual(B,this.yb))return this.Kb(z);if(this.h.isEqual(B,this.zb))return this.Lb(z);if(this.h.isEqual(B,this.wb))return z.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Kb(z){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(B),J=(0,s.$G2b)(z.localExtensions,null,null,z.skippedExtensions,_,z.builtinExtensions),{local:Q,remote:H}=J;return{content:z.localContent,local:Q,remote:H,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(z){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(B),J=z.remoteContent?JSON.parse(z.remoteContent):null;if(J!==null){const Q=(0,s.$G2b)(z.localExtensions,J,z.localExtensions,[],_,z.builtinExtensions),{local:H,remote:x}=Q;return{content:z.remoteContent,local:H,remote:x,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(z,B,_,J){let{skippedExtensions:Q,builtinExtensions:H,localExtensions:x}=_[0][0];const{local:G,remote:V,localChange:W,remoteChange:ee}=_[0][1];if(W===0&&ee===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),W!==0&&(await this.nb(JSON.stringify(x)),Q=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,Q,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ne=JSON.stringify(V.all);z=await this.mb(ne,J?null:z.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(re=>re.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(re=>re.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(re=>re.identifier.id))}.`:""}`)}B?.ref!==z.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(x,H),await this.fb(z,{skippedExtensions:Q,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ne=>ne.identifier.id))}.`:""}`))}Nb(z,B){const _=new Set,J=[];for(const Q of z)_.add(Q.identifier.id.toLowerCase()),Q.installed||J.push(Q.identifier);if(B)for(const Q of B)_.has(Q.id.toLowerCase())||J.push(Q);return J}async resolveContent(z){if(this.h.isEqual(this.zb,z)||this.h.isEqual(this.xb,z)||this.h.isEqual(this.yb,z)||this.h.isEqual(this.Ab,z)){const B=await this.db(z);return B&&this.Ob(JSON.parse(B),!0)}return null}Ob(z,B){return u(z,B)}async hasLocalData(){try{const{localExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(z.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$J2b=p,e.$J2b=p=ye([Z(2,P.$Ih),Z(3,d.$6j),Z(4,y.$Vo),Z(5,r.$Dgb),Z(6,r.$Egb),Z(7,g.$2n),Z(8,t.$NBb),Z(9,r.$Sgb),Z(10,m.$8h),Z(11,r.$Ngb),Z(12,C.$9k),Z(13,f.$Tz),Z(14,i.$Ck),Z(15,a.$cAb),Z(16,h.$Ah)],p);let j=class{constructor(z,B,_,J,Q,H){this.a=z,this.b=B,this.c=_,this.d=J,this.f=Q,this.g=H}async getLocalExtensions(z){const B=await this.a.getInstalled(void 0,z.extensionsResource),_=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(z,async(Q,H)=>{const x=Q.getDisabledExtensions();return B.map(G=>{const{identifier:V,isBuiltin:W,manifest:ee,preRelease:ne,pinned:re,isApplicationScoped:X}=G,q={identifier:V,preRelease:ne,version:ee.version,pinned:!!re};X&&!(0,w.$Yl)(ee)&&(q.isApplicationScoped=X),x.some(k=>(0,l.$po)(k,V))&&(q.disabled=!0),W||(q.installed=!0);try{const k=H.getKeysForSync({id:V.id,version:ee.version});if(k){const R=H.getExtensionState(G,!0)||{};q.state=Object.keys(R).reduce((U,M)=>(k.includes(M)&&(U[M]=R[M]),U),{})}}catch(k){this.g.info(`${(0,n.$5Ab)("extensions",z)}: Error while parsing extension state`,(0,A.$8)(k))}return q})}),ignoredExtensions:_}}async updateLocalExtensions(z,B,_,J,Q){const H=(0,n.$5Ab)("extensions",Q),x=[],G=new Map,V=[],W=[],ee=await this.a.getInstalled(void 0,Q.extensionsResource);if((z.length||_.length)&&await this.j(Q,async(X,q)=>{await O.Promises.settled([...z,..._].map(async k=>{const R=ee.find(K=>(0,l.$po)(K.identifier,k.identifier));if(R&&R.isBuiltin){k.state&&R.manifest.version===k.version&&this.h(k.state,R,R.manifest.version,q),X.getDisabledExtensions().some(Y=>(0,l.$po)(Y,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${H}: Disabling extension...`,k.identifier.id),await X.disableExtension(k.identifier),this.g.info(`${H}: Disabled extension`,k.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,k.identifier.id),await X.enableExtension(k.identifier),this.g.info(`${H}: Enabled extension`,k.identifier.id))),V.push(k.identifier);return}const U=k.pinned?k.version:void 0,M=(await this.c.getExtensions([{...k.identifier,version:U,preRelease:U?void 0:k.preRelease}],N.CancellationToken.None))[0];if(k.state&&(R?R.manifest.version===k.version:M)&&this.h(k.state,R||M,R?.manifest.version,q),M)try{X.getDisabledExtensions().some(Y=>(0,l.$po)(Y,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${H}: Disabling extension...`,k.identifier.id,M.version),await X.disableExtension(M.identifier),this.g.info(`${H}: Disabled extension`,k.identifier.id,M.version)):(this.g.trace(`${H}: Enabling extension...`,k.identifier.id,M.version),await X.enableExtension(M.identifier),this.g.info(`${H}: Enabled extension`,k.identifier.id,M.version))),(!R||R.preRelease!==k.preRelease||R.pinned!==k.pinned||U&&R.manifest.version!==U)&&(await this.a.canInstall(M)?(x.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[g.$Pn]:!0,[g.$Qn]:!0}}}),G.set(M.identifier.id.toLowerCase(),k)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),W.push(k)))}catch(K){W.push(k),this.g.error(K),this.g.info(`${H}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else W.push(k),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),B.length){const X=ee.filter(({identifier:q,isBuiltin:k})=>!k&&B.some(R=>(0,l.$po)(q,R)));await O.Promises.settled(X.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),V.push(q.identifier)}))}const ne=await this.a.installGalleryExtensions(x);for(const{identifier:X,local:q,error:k,source:R}of ne){const U=R;if(q)this.g.info(`${H}: Installed extension.`,X.id,U.version),V.push(X);else{const M=G.get(X.id.toLowerCase());M&&(W.push(M),this.g.info(`${H}: Skipped synchronizing extension`,U.displayName||U.identifier.id)),k instanceof g.$1n&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):k&&this.g.error(k)}}const re=[];for(const X of J)V.some(q=>(0,l.$po)(q,X.identifier))||re.push(X);for(const X of W)re.some(q=>(0,l.$po)(q.identifier,X.identifier))||re.push(X);return re}h(z,B,_,J){const Q=J.getExtensionState(B,!0)||{},H=_?J.getKeysForSync({id:B.identifier.id,version:_}):void 0;H?H.forEach(x=>{Q[x]=z[x]}):Object.keys(z).forEach(x=>Q[x]=z[x]),J.setExtensionState(B,Q,!0)}async j(z,B){return this.b.withProfileScopedStorageService(z,async _=>{const J=new I.$jc,Q=this.f.createChild(new o.$zh([y.$Vo,_])),H=J.add(Q.createInstance(E.$Azb)),x=J.add(Q.createInstance(f.$Uz));try{return await B(H,x)}finally{J.dispose()}})}};e.$K2b=j,e.$K2b=j=ye([Z(0,g.$2n),Z(1,a.$cAb),Z(2,g.$Zn),Z(3,t.$NBb),Z(4,h.$Ah),Z(5,r.$Sgb)],j);let F=class extends n.$9Ab{constructor(z,B,_,J,Q,H,x,G){super("extensions",J,Q,H,_,x,G),this.p=z,this.q=B}async t(z){return z.syncData?await v(z.syncData,this.p):null}u(z,B){const _=[],J=[],Q=[];for(const H of z){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const x=B.find(G=>(0,l.$po)(G.identifier,H.identifier));x?(_.push(x),H.disabled&&Q.push(H.identifier)):H.installed&&(J.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&Q.push(H.identifier))}return{installedExtensions:_,newExtensions:J,disabledExtensions:Q,remoteExtensions:z}}};e.$L2b=F,e.$L2b=F=ye([Z(0,g.$2n),Z(1,t.$NBb),Z(2,d.$6j),Z(3,c.$Ek),Z(4,P.$Ih),Z(5,$.$5i),Z(6,y.$Vo),Z(7,i.$Ck)],F)}),define(oe[116],ae([0,1,14,8,3,34,41,6,32,19,15,12,7,44,20,22,28,39,77,236,25,17,58,4]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cBb=e.$bBb=e.$aBb=e.$_Ab=e.$$Ab=void 0;const n="globalState.argv.",s=["locale"];function t(p,j){const F=p.storage?Object.keys(p.storage).sort():[],T={};return F.forEach(z=>T[z]=p.storage[z]),p.storage=T,j?(0,D.$xS)(p,{}):JSON.stringify(p)}e.$$Ab=t;const r=1;let a=class extends h.$6Ab{constructor(j,F,T,z,B,_,J,Q,H,x,G,V,W,ee){super({syncResource:"globalState",profile:j},F,z,Q,V,B,_,H,x,J,G,W),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:y.$Ugb,authority:"base"}),this.xb=this.vb.with({scheme:y.$Ugb,authority:"local"}),this.yb=this.vb.with({scheme:y.$Ugb,authority:"remote"}),this.zb=this.vb.with({scheme:y.$Ugb,authority:"accepted"}),this.Ab=ee.createInstance(v),this.B(z.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(z.onDidFilesChange,ne=>ne.contains(this.H.argvResource)),A.Event.filter(T.onDidChange,ne=>!!(ne.targetChanges.some(re=>this.syncResource.profile.id===re.id)||ne.valueChanges.some(({profile:re,changes:X})=>this.syncResource.profile.id===re.id&&X.some(q=>q.target===0)))))(()=>this.Q()))}async qb(j,F,T){const z=j.syncData?JSON.parse(j.syncData.content):null;F=F===null&&T?j:F;const B=F&&F.syncData?JSON.parse(F.syncData.content):null,_=await this.Ab.getLocalGlobalState(this.syncResource.profile);z?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(B),{local:Q,remote:H}=(0,$.$0Ab)(_.storage,z?z.storage:null,B?B.storage:null,J,this.O),x={content:null,local:Q,remote:H,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:H.all!==null?2:0},G=t(_,!1);return[{baseResource:this.wb,baseContent:B?t(B,!1):G,localResource:this.xb,localContent:G,localUserData:_,remoteResource:this.yb,remoteContent:z?t(z,!1):null,previewResource:this.vb,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(j){const F=j.syncData?JSON.parse(j.syncData.content):null;if(F===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),z=await this.Jb(F),{remote:B}=(0,$.$0Ab)(T.storage,F.storage,F.storage,z,this.O);return B.all!==null}async rb(j,F){return{...j.previewResult,hasConflicts:!1}}async sb(j,F,T,z){if(this.h.isEqual(F,this.xb))return this.Gb(j);if(this.h.isEqual(F,this.yb))return this.Hb(j);if(this.h.isEqual(F,this.vb))return j.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(j){return{content:j.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(j.localUserData.storage),removed:[],updated:[],all:j.localUserData.storage},localChange:0,remoteChange:2}}async Hb(j){if(j.remoteContent!==null){const F=JSON.parse(j.remoteContent),{local:T,remote:z}=(0,$.$0Ab)(j.localUserData.storage,F.storage,null,j.storageKeys,this.O);return{content:j.remoteContent,local:T,remote:z,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:j.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(j,F,T,z){const{localUserData:B}=T[0][0],{local:_,remote:J,localChange:Q,remoteChange:H}=T[0][1];if(Q===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(B)),await this.Ab.writeLocalGlobalState(_,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const x=JSON.stringify({storage:J.all});j=await this.mb(x,z?null:j.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}F?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(j),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(j){if(this.h.isEqual(this.yb,j)||this.h.isEqual(this.wb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.zb,j)){const F=await this.db(j);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:j}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(j).length>1||j[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(j){const F=await this.Bb.readStorageData(this.syncResource.profile),T=[],z=[];for(const[J,Q]of F)Q.target===0?T.push(J):Q.target===1&&z.push(J);const B=[...T,...z],_=j?.storage?Object.keys(j.storage).filter(J=>!J.startsWith(n)&&!B.includes(J)&&F.get(J)!==void 0):[];if(!I.$o){const J=[...y.$zgb.map(Q=>(0,y.$Mgb)(Q)),y.$Lgb];_.push(...J),z.push(...J)}return{user:T,machine:z,unregistered:_}}};e.$_Ab=a,e.$_Ab=a=ye([Z(2,i.$cAb),Z(3,E.$6j),Z(4,y.$Dgb),Z(5,y.$Egb),Z(6,y.$Sgb),Z(7,P.$Ih),Z(8,y.$Ngb),Z(9,w.$9k),Z(10,m.$8h),Z(11,f.$Vo),Z(12,d.$Ck),Z(13,c.$Ah)],a);let v=class{constructor(j,F,T,z){this.a=j,this.b=F,this.c=T,this.d=z}async getLocalGlobalState(j){const F={};if(j.isDefault){const z=await this.f(),B=(0,L.$Lm)(z);for(const _ of s)B[_]!==void 0&&(F[`${n}${_}`]={version:1,value:B[_]})}const T=await this.c.readStorageData(j);for(const[z,B]of T)B.value&&B.target===0&&(F[z]={version:1,value:B.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const j=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),j.value.toString()}catch(j){this.d.debug((0,N.$8)(j))}return"{}"}async writeLocalGlobalState({added:j,removed:F,updated:T},z){const B=(0,h.$5Ab)("globalState",z),_={},J=new Map,Q=await this.c.readStorageData(z),H=(x,G)=>{for(const V of x){if(V.startsWith(n)){_[V.substring(n.length)]=G?G[V].value:void 0;continue}if(G){const W=G[V];W.value!==Q.get(V)?.value&&J.set(V,W.value)}else Q.get(V)!==void 0&&J.set(V,void 0)}};if(H(Object.keys(j),j),H(Object.keys(T),T),H(F),Object.keys(_).length){this.d.trace(`${B}: Updating locale...`);const x=await this.f();let G=x;for(const V of Object.keys(_))G=(0,o.edit)(G,[V],_[V],{});x!==G&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$Fd.fromString(G)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}J.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(z,J,0),this.d.info(`${B}: Updated global state`,[...J.keys()]))}};e.$aBb=v,e.$aBb=v=ye([Z(0,E.$6j),Z(1,P.$Ih),Z(2,i.$cAb),Z(3,y.$Sgb)],v);let b=class extends h.$9Ab{constructor(j,F,T,z,B,_){super("globalState",T,z,B,F,j,_)}async o(j){const F=j.syncData?JSON.parse(j.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},z={};for(const B of Object.keys(F.storage))B.startsWith(n)?T[B.substring(n.length)]=F.storage[B].value:this.l.get(B,0)===void 0&&(z[B]=F.storage[B].value);if(Object.keys(T).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const _ of Object.keys(T))B=(0,o.edit)(B,[_],T[_],{});await this.k.writeFile(this.h.argvResource,O.$Fd.fromString(B))}if(Object.keys(z).length){const B=[];for(const _ of Object.keys(z))B.push({key:_,value:z[_],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$bBb=b,e.$bBb=b=ye([Z(0,f.$Vo),Z(1,E.$6j),Z(2,C.$Ek),Z(3,P.$Ih),Z(4,y.$Sgb),Z(5,d.$Ck)],b);let u=class{constructor(j,F,T,z,B){this.a=j,this.b=F,this.c=T,this.d=z,this.f=B}getSyncStoreType(j){return this.h(j)?.storage[y.$Lgb]?.value}async sync(j){const F=(0,y.$Hgb)((0,S.$4f)());try{return await this.g(j,F)}catch(T){if(T instanceof y.$Igb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(j,F)}throw T}}async g(j,F){const T=await this.a.readResource("globalState",null,void 0,F),z=this.h(T)||{storage:{}};z.storage[y.$Lgb]={value:j,version:r};const B=await(0,l.$2o)(this.c,this.d,this.b),_={version:r,machineId:B,content:t(z,!1)};await this.a.writeResource("globalState",JSON.stringify(_),T.ref,void 0,F)}h({content:j}){if(!j)return null;const F=JSON.parse(j);if((0,h.$4Ab)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$cBb=u,e.$cBb=u=ye([Z(1,f.$Vo),Z(2,P.$Ih),Z(3,E.$6j),Z(4,g.$5i)],u)}),define(oe[117],ae([0,1,18,14,3,34,6,9,171,19,15,12,20,22,28,17,39,233,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P2b=e.$O2b=e.$N2b=void 0;function $(i,c,n){try{const s=JSON.parse(i);if(!c)return(0,I.$qf)(s.all)?null:s.all;switch(D.OS){case 2:return(0,I.$qf)(s.mac)?null:s.mac;case 3:return(0,I.$qf)(s.linux)?null:s.linux;case 1:return(0,I.$qf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$N2b=$;let y=class extends d.$8Ab{constructor(c,n,s,t,r,a,v,b,u,p,j,F,T){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},n,b,u,p,s,t,v,F,r,j,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:o.$Ugb,authority:"base"}),this.Gb=this.Eb.with({scheme:o.$Ugb,authority:"local"}),this.Hb=this.Eb.with({scheme:o.$Ugb,authority:"remote"}),this.Ib=this.Eb.with({scheme:o.$Ugb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,z=>z.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(c,n,s,t){const r=c.syncData?$(c.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?c:n;const a=n?this.Ob(n):null,v=await this.vb(),b=await this.Cb();let u=null,p=!1,j=!1,F=!1;if(r){let B=v?v.value.toString():"[]";if(B=B||"[]",this.Ab(B,!0))throw new o.$Igb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==B||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const _=await(0,h.$M2b)(B,r,a,b,this.zb);_.hasChanges&&(u=_.mergeContent,F=_.hasConflicts,p=F||_.mergeContent!==B,j=F||_.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=v.value.toString(),j=!0);const T={content:F?a:u,localChange:p?v?2:1:0,remoteChange:j?2:0,hasConflicts:F},z=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:z,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(c){const n=this.Ob(c);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,h.$M2b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(c,n){return c.previewResult}async sb(c,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(c,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:v,remoteChange:b}=s[0][1];if(v===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new o.$Igb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),b!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",c.syncData?.content);c=await this.mb(u,t?null:c.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(c,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.vb();if(c){const n=(0,L.$Lm)(c.value.toString());if((0,O.$Jb)(n))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Hb,c)||this.h.isEqual(this.Fb,c)||this.h.isEqual(this.Gb,c)||this.h.isEqual(this.Ib,c)?this.db(c):null}Ob(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Qb()?null:$(c.syncData.content,this.Qb(),this.O)}Pb(c,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=c,D.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(o.$wgb)}};e.$O2b=y,e.$O2b=y=ye([Z(2,o.$Dgb),Z(3,o.$Egb),Z(4,o.$Sgb),Z(5,m.$8h),Z(6,o.$Ngb),Z(7,E.$6j),Z(8,P.$Ih),Z(9,g.$Vo),Z(10,o.$Rgb),Z(11,l.$9k),Z(12,f.$Ck)],y);let C=class extends d.$9Ab{constructor(c,n,s,t,r,a){super("keybindings",n,s,t,c,r,a)}async o(c){const n=c.syncData?this.p(c.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Fd.fromString(n)),await this.n(c)}async i(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$Lm)(c.value.toString());return!(0,O.$Jb)(n)}catch(c){return c.fileOperationResult===1}}p(c){try{return $(c,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$P2b=C,e.$P2b=C=ye([Z(0,E.$6j),Z(1,w.$Ek),Z(2,P.$Ih),Z(3,o.$Sgb),Z(4,g.$Vo),Z(5,f.$Ck)],C)}),define(oe[118],ae([0,1,14,3,172,19,73,15,29,12,20,22,28,17,39,237,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=e.$R2b=e.$Q2b=void 0;function h(C){return C&&C.settings&&typeof C.settings=="string"&&Object.keys(C).length===1}function o(C){const i=JSON.parse(C);return h(i)?i:{settings:C}}e.$Q2b=o;let $=class extends f.$8Ab{constructor(i,c,n,s,t,r,a,v,b,u,p,j,F,T){super(i.settingsResource,{syncResource:"settings",profile:i},c,n,s,t,r,a,p,j,v,b,u,T),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.$Ugb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$Ugb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$Ugb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$Ugb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const c=await this.getLastSyncUserData(),n=await this.X(i,c),s=this.Lb(n),t=new D.$rn(d.$vgb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(d.$vgb)||{}}async qb(i,c,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);c=c===null&&n?i:c;const a=c?this.Lb(c):null,v=await this.Pb();let b=null,u=!1,p=!1,j=!1;if(r){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Qb(B),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,w.$Vzb)(B,r.settings,a?a.settings:null,v,[],t);b=_.localContent||_.remoteContent,u=_.localContent!==null,p=_.remoteContent!==null,j=_.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),b=s.value.toString().trim()||"{}",this.Qb(b),p=!0);const F=s?s.value.toString():null,T=a?.settings??null,z={content:j?T:b,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:j};return[{fileContent:s,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:F,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async ub(i){const c=this.Lb(i);if(c===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,w.$Vzb)(s||"{}",c.settings,c.settings,t,[],r).remoteContent!==null}async rb(i,c){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,w.$Uzb)(i.previewResult.content,"{}",s,n):null}}async sb(i,c,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(c,this.localResource))return{content:i.fileContent?(0,w.$Uzb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.remoteResource))return{content:i.remoteContent!==null?(0,w.$Uzb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,w.$Uzb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(i,c,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const b=await this.Cb(),u=this.Lb(i),p=await this.Pb(r);r=(0,w.$Uzb)(r,u?u.settings:"{}",p,b),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,w.$Wzb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let c=await super.db(i);if(c){const n=await this.Cb(),s=await this.Pb();c=(0,w.$Uzb)(c,"{}",s,n)}return c}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return o(i)}catch(c){this.O.error(c)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const c=await this.Ob;return(0,w.$Szb)(c,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new d.$Igb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$R2b=$,e.$R2b=$=ye([Z(2,m.$6j),Z(3,I.$Ih),Z(4,P.$Vo),Z(5,d.$Dgb),Z(6,d.$Egb),Z(7,d.$Sgb),Z(8,d.$Rgb),Z(9,L.$8h),Z(10,d.$Ngb),Z(11,E.$9k),Z(12,S.$2n),Z(13,g.$Ck)],$);let y=class extends f.$9Ab{constructor(i,c,n,s,t,r){super("settings",c,n,s,i,t,r)}async o(i){const c=i.syncData?this.p(i.syncData.content):null;if(!c){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$Fd.fromString(c.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$Wzb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return o(i)}catch(c){this.j.error(c)}return null}};e.$S2b=y,e.$S2b=y=ye([Z(0,m.$6j),Z(1,l.$Ek),Z(2,I.$Ih),Z(3,d.$Sgb),Z(4,P.$Vo),Z(5,g.$Ck)],y)}),define(oe[119],ae([0,1,14,3,30,19,15,12,20,22,28,17,39,234,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X2b=e.$W2b=e.$V2b=void 0;function w(o){return JSON.parse(o.content)}e.$V2b=w;let d=class extends g.$6Ab{constructor($,y,C,i,c,n,s,t,r,a,v,b){super({syncResource:"snippets",profile:$},y,i,C,c,n,s,a,v,t,r,b),this.pb=1,this.vb=$.snippetsHome,this.B(this.G.watch(C.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb($,y,C){const i=await this.Hb(),c=this.Gb(i),n=$.syncData?this.Fb($.syncData):null;y=y===null&&C?$:y;const s=y&&y.syncData?this.Fb(y.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$T2b)(c,n,s);return this.Bb(t,i,n||{},s||{})}async ub($){const y=$.syncData?this.Fb($.syncData):null;if(y===null)return!0;const C=await this.Hb(),i=this.Gb(C),c=(0,l.$T2b)(i,y,y);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async rb($,y){return $.previewResult}async sb($,y,C,i){if(this.h.isEqualOrParent(y,this.g.with({scheme:f.$Ugb,authority:"local"})))return{content:$.fileContent?$.fileContent.value.toString():null,localChange:0,remoteChange:$.fileContent?$.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(y,this.g.with({scheme:f.$Ugb,authority:"remote"})))return{content:$.remoteContent,localChange:$.remoteContent!==null?$.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(y,this.g))return C===void 0?{content:$.previewResult.content,localChange:$.previewResult.localChange,remoteChange:$.previewResult.remoteChange}:{content:C,localChange:C===null?$.fileContent!==null?3:0:2,remoteChange:C===null?$.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async tb($,y,C,i){const c=C.map(([n,s])=>({...n,acceptResult:s}));c.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),c.some(({localChange:n})=>n!==0)&&(await this.Cb(c),await this.Db(c,i)),c.some(({remoteChange:n})=>n!==0)&&($=await this.Eb(c,$,i)),y?.ref!==$.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb($),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of c)try{await this.G.del(n)}catch{}}Bb($,y,C,i){const c=new Map;for(const n of Object.keys($.local.added)){const s={content:$.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of Object.keys($.local.updated)){const s={content:$.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:y[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of $.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:y[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of Object.keys($.remote.added)){const s={content:$.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:y[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of Object.keys($.remote.updated)){const s={content:$.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:y[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of $.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of $.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:y[n]?2:1,remoteChange:C[n]?2:1},t=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:y[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}for(const n of Object.keys(y))if(!c.has(n)){const s={content:y[n]?y[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"local"}),fileContent:y[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:f.$Ugb,authority:"accepted"})})}return[...c.values()]}async resolveContent($){return this.h.isEqualOrParent($,this.g.with({scheme:f.$Ugb,authority:"remote"}))||this.h.isEqualOrParent($,this.g.with({scheme:f.$Ugb,authority:"local"}))||this.h.isEqualOrParent($,this.g.with({scheme:f.$Ugb,authority:"base"}))||this.h.isEqualOrParent($,this.g.with({scheme:f.$Ugb,authority:"accepted"}))?this.db($):null}async hasLocalData(){try{const $=await this.Hb();if(Object.keys($).length)return!0}catch{}return!1}async Cb($){const y={};for(const C of $)C.fileContent&&(y[this.h.basename(C.localResource)]=C.fileContent);await this.nb(JSON.stringify(this.Gb(y)))}async Db($,y){for(const{fileContent:C,acceptResult:i,localResource:c,remoteResource:n,localChange:s}of $)if(s!==0){const t=n?this.h.basename(n):this.h.basename(c),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$Fd.fromString(i.content),{overwrite:y}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$Fd.fromString(i.content),y?void 0:C),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb($,y,C){const i=y.syncData?this.Fb(y.syncData):{},c=(0,A.$Vm)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of $)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete c[a]:c[a]=n.content}return(0,l.$U2b)(i,c)||(this.O.trace(`${this.D}: Updating remote snippets...`),y=await this.mb(JSON.stringify(c),C?null:y.ref),this.O.info(`${this.D}: Updated remote snippets`)),y}Fb($){return w($)}Gb($){const y={};for(const C of Object.keys($))y[C]=$[C].value.toString();return y}async Hb(){const $={};let y;try{y=await this.G.resolve(this.vb)}catch(C){if(C instanceof I.$nk&&C.fileOperationResult===1)return $;throw C}for(const C of y.children||[]){const i=C.resource,c=this.h.extname(i);if(c===".json"||c===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);$[n]=s}}return $}};e.$W2b=d,e.$W2b=d=ye([Z(2,D.$Ih),Z(3,I.$6j),Z(4,S.$Vo),Z(5,f.$Dgb),Z(6,f.$Egb),Z(7,f.$Sgb),Z(8,L.$8h),Z(9,f.$Ngb),Z(10,m.$9k),Z(11,P.$Ck)],d);let h=class extends g.$9Ab{constructor($,y,C,i,c,n){super("snippets",y,C,i,$,c,n)}async o($){const y=$.syncData?JSON.parse($.syncData.content):null;if(!y){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(y)){const c=y[i];if(c){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,O.$Fd.fromString(c)),this.j.info("Created snippet",this.d.basename(n))}}await this.n($)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch($){return $.fileOperationResult===1}}};e.$X2b=h,e.$X2b=h=ye([Z(0,I.$6j),Z(1,E.$Ek),Z(2,D.$Ih),Z(3,f.$Sgb),Z(4,S.$Vo),Z(5,P.$Ck)],h)}),define(oe[120],ae([0,1,14,19,15,12,20,22,28,17,39,25]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$12b=e.$Z2b=e.$Y2b=void 0;function g(d,h){try{return JSON.parse(d).tasks??null}catch(o){return h.error(o),null}}e.$Y2b=g;let l=class extends P.$7Ab{constructor(h,o,$,y,C,i,c,n,s,t,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},o,n,s,t,$,y,c,r,C,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Ugb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Ugb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Ugb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Ugb,authority:"accepted"})}async qb(h,o,$,y){const C=h.syncData?g(h.syncData.content,this.O):null;o=o===null&&$?h:o;const i=o?.syncData?g(o.syncData.content,this.O):null,c=await this.vb();let n=null,s=!1,t=!1,r=!1;if(h.syncData){const b=c?c.value.toString():null;if(!i||i!==b||i!==C){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=w(b,C,i);n=u.content,r=u.hasConflicts,s=u.hasLocalChanged,t=u.hasRemoteChanged}}else c&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=c.value.toString(),t=!0);const a={content:r?i:n,localChange:s?c?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=c?c.value.toString():null;return[{fileContent:c,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:C,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const o=h?.syncData?g(h.syncData.content,this.O):null;if(o===null)return!0;const $=await this.vb(),y=$?$.value.toString():null,C=w(y,o,o);return C.hasLocalChanged||C.hasRemoteChanged}async rb(h,o){return h.previewResult}async sb(h,o,$,y){if(this.h.isEqual(o,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.Ab))return $===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:$,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(h,o,$,y){const{fileContent:C}=$[0][0],{content:i,localChange:c,remoteChange:n}=$[0][1];if(c===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),c!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),C&&await this.nb(JSON.stringify(this.Kb(C.value.toString()))),i?await this.wb(i,C,y):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));h=await this.mb(s,y?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}o?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$Z2b=l,e.$Z2b=l=ye([Z(2,E.$Dgb),Z(3,E.$Egb),Z(4,E.$Sgb),Z(5,N.$8h),Z(6,E.$Ngb),Z(7,L.$6j),Z(8,A.$Ih),Z(9,D.$Vo),Z(10,I.$9k),Z(11,S.$Ck)],l);let f=class extends P.$9Ab{constructor(h,o,$,y,C,i){super("tasks",o,$,y,h,C,i),this.c=this.g.defaultProfile.tasksResource}async o(h){const o=h.syncData?g(h.syncData.content,this.j):null;if(!o){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$Fd.fromString(o)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$12b=f,e.$12b=f=ye([Z(0,L.$6j),Z(1,m.$Ek),Z(2,A.$Ih),Z(3,E.$Sgb),Z(4,D.$Vo),Z(5,S.$Ck)],f);function w(d,h,o){if(d===null&&h===null&&o===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(d===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const $=o!==d,y=o!==h;return!$&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:$&&!y?{content:d,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!$?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:d,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,19,15,12,20,22,28,17,39,235,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=e.$D4b=e.$C4b=void 0;let l=class extends P.$6Ab{constructor(h,o,$,y,C,i,c,n,s,t,r,a,v){super({syncResource:"profiles",profile:h},o,y,C,i,c,n,r,a,s,t,v),this.vb=$,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.$Ugb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$Ugb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$Ugb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$Ugb,authority:"accepted"}),this.B($.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?w(h.syncData):null}async getRemoteSyncedProfiles(h){const o=await this.getLastSyncUserData(),$=await this.X(h,o);return $?.syncData?w($.syncData):null}async qb(h,o,$){if(!this.vb.isEnabled())throw new g.$Igb("Cannot sync profiles because they are disabled","LocalError");const y=h.syncData?w(h.syncData):null,C=o?.syncData?w(o.syncData):null,i=this.Db(),{local:c,remote:n}=(0,E.$B4b)(i,y,C,[]),s={local:c,remote:n,content:C?this.Eb(C):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:n!==null?2:0},t=f(i,!1);return[{baseResource:this.baseResource,baseContent:C?this.Eb(C):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:y?this.Eb(y):null,remoteProfiles:y,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const o=h?.syncData?w(h.syncData):null,$=this.Db(),{remote:y}=(0,E.$B4b)($,o,o,[]);return!!y?.added.length||!!y?.removed.length||!!y?.updated.length}async rb(h,o){return{...h.previewResult,hasConflicts:!1}}async sb(h,o,$,y){if(this.h.isEqual(o,this.localResource))return this.Ab(h);if(this.h.isEqual(o,this.remoteResource))return this.Bb(h);if(this.h.isEqual(o,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${o.toString()}`)}async Ab(h){const o=this.Db(),$=(0,E.$B4b)(o,null,null,[]),{local:y,remote:C}=$;return{content:h.localContent,local:y,remote:C,localChange:y.added.length>0||y.removed.length>0||y.updated.length>0?2:0,remoteChange:C!==null?2:0}}async Bb(h){const o=h.remoteContent?JSON.parse(h.remoteContent):null,$=[],y=[];for(const C of this.Db()){const i=o?.find(c=>c.id===C.id);i&&($.push({id:C.id,name:C.name,collection:i.collection}),y.push(C))}if(o!==null){const C=(0,E.$B4b)(y,o,$,[]),{local:i,remote:c}=C;return{content:h.remoteContent,local:i,remote:c,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,o,$,y){const{local:C,remote:i,localChange:c,remoteChange:n}=$[0][1];c===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=$[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new g.$Igb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.nb(f(this.Db(),!1));const t=[];for(const r of C.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of C.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of C.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),s.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:v})=>a.id===v),1);for(const a of i?.updated||[]){const v=s.find(({id:b})=>a.id===b);v&&s.splice(s.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(s,y?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}o?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,o){return this.mb(this.Eb(h),o)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const o=await this.db(h);return o&&(0,O.$xS)(JSON.parse(o),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((o,$)=>o.name.localeCompare($.name)))}};e.$C4b=l,e.$C4b=l=ye([Z(2,m.$Ek),Z(3,L.$6j),Z(4,A.$Ih),Z(5,D.$Vo),Z(6,g.$Dgb),Z(7,g.$Egb),Z(8,g.$Sgb),Z(9,N.$8h),Z(10,g.$Ngb),Z(11,I.$9k),Z(12,S.$Ck)],l);function f(d,h){const o=[...d].sort(($,y)=>$.name.localeCompare(y.name)).map($=>({id:$.id,name:$.name}));return h?(0,O.$xS)(o,{}):JSON.stringify(o)}e.$D4b=f;function w(d){return JSON.parse(d.content)}e.$E4b=w}),define(oe[253],ae([0,1,3,2,6,15,20,22,25]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p4b=void 0;const m="sync.enable";let P=class extends N.$kc{constructor(g,l,f,w){super(),this.c=g,this.f=l,this.g=f,this.h=w,this.a=new O.$fd,this.onDidChangeEnablement=this.a.event,this.b=new O.$fd,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(-1,void 0,this.B(new N.$jc))(d=>this.m(d)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(m,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(m,{enabled:g}),this.c.store(m,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,S.$Mgb)(g),-1,!0)}setResourceEnablement(g,l){if(this.isResourceEnabled(g)!==l){const f=(0,S.$Mgb)(g);this.j(f,l)}}getResourceSyncStateVersion(g){}j(g,l){this.c.store(g,l,-1,A.$o?0:1)}m(g){if(m===g.key){this.a.fire(this.isEnabled());return}const l=S.$zgb.filter(f=>(0,S.$Mgb)(f)===g.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$p4b=P,e.$p4b=P=ye([Z(0,D.$Vo),Z(1,I.$9k),Z(2,L.$Ih),Z(3,S.$Cgb)],P)}),define(oe[254],ae([0,1,5,14,62,2,21,19,15,12,17,25]),function(te,e,O,N,A,L,D,I,S,m,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A4b=void 0;let g=class extends L.$kc{constructor(f,w,d,h,o){super(),this.a=f,this.b=w,this.c=d,this.f=h,this.g=o,this.h()}async h(){for(const w of this.g.profiles)for(const d of E.$zgb)try{await this.m(this.j(d,w.isDefault?void 0:w.id))}catch(h){this.f.error(h)}let f;try{f=await this.b.resolve(this.a.userDataSyncHome)}catch(w){(0,m.$jk)(w)!==1&&this.f.error(w);return}if(f.children){for(const w of f.children)if(w.isDirectory&&!this.g.profiles.some(d=>d.id===w.name))try{this.f.info("Deleting non existing profile from backup",w.resource.path),await this.b.del(w.resource,{recursive:!0})}catch(d){this.f.error(d)}}}async getAllResourceRefs(f,w,d){const h=this.j(f,w,d);try{const o=await this.b.resolve(h);if(o.children)return o.children.filter(y=>y.isFile&&!y.name.startsWith("lastSync")).sort().reverse().map(y=>({ref:y.name,created:this.n(y)}))}catch(o){if((0,m.$jk)(o)!==1)throw o}return[]}async resolveResourceContent(f,w,d,h){const o=this.j(f,d,h),$=(0,D.$ig)(o,w);try{return(await this.b.readFile($)).value.toString()}catch(y){return this.f.error(y),null}}async writeResource(f,w,d,h,o){const $=this.j(f,h,o),y=(0,D.$ig)($,`${(0,A.$7l)(d).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(y,N.$Fd.fromString(w))}catch(C){this.f.error(C)}}j(f,w,d=this.a.userDataSyncHome){return(0,D.$ig)(d,...w?[w,f]:[f])}async m(f){try{try{if(!await this.b.exists(f))return}catch{return}const w=await this.b.resolve(f);if(w.children){const d=w.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let o=d.filter(y=>Date.now()-this.n(y)>h);const $=d.length-o.length;$<10&&(o=o.slice(10-$)),await O.Promises.settled(o.map(async y=>{this.f.info("Deleting from backup",y.resource.path),await this.b.del(y.resource)}))}}catch(w){this.f.error(w)}}n(f){return new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.$A4b=g,e.$A4b=g=ye([Z(0,S.$Ih),Z(1,m.$6j),Z(2,I.$8h),Z(3,E.$Sgb),Z(4,P.$Ek)],g)}),define(oe[81],ae([0,1,3,2,6,27,176,15,12,4,24,44,20,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$sgb=e.$rgb=e.$qgb=void 0,e.$qgb=(0,m.$Bh)("IUserDataSyncMachinesService");const w="sync.currentMachineName",d="Safari",h="Chrome",o="Edge",$="Firefox",y="Android";function C(n){switch(n){case d:case h:case o:case $:case y:case(0,A.$h)(0):return!0}return!1}e.$rgb=C;function i(){return A.$F?d:A.$D?h:A.$G?o:A.$E?$:A.$H?y:(0,A.$h)(A.$o?0:A.$t)}let c=class extends N.$kc{static{f=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,v,b){super(),this.h=r,this.j=a,this.m=v,this.n=b,this.c=this.B(new O.$fd),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$2o)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),v=a.machines.find(({id:b})=>b===s);if(v){v.name=t,await this.t(a);const b=await this.f;s===b&&this.h.store(w,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const v=t.machines.find(b=>b.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(w,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$qe)(r)}\\s#(\\d+)`);let v=0;for(const b of s){const u=a.exec(b.name),p=u?parseInt(u[1]):0;v=p>v?p:v}return`${r} #${v+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==f.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(f.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[f.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(f.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:f.a,machines:[]}}};e.$sgb=c,e.$sgb=c=f=ye([Z(0,I.$Ih),Z(1,S.$6j),Z(2,g.$Vo),Z(3,l.$Dgb),Z(4,l.$Sgb),Z(5,P.$kj)],c)}),define(oe[255],ae([0,1,5,62,38,8,3,2,6,21,11,173,24,20,22,25,78,81]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G4b=void 0;const o="sync.disableMachineEventually",$="sync.sessionId",y="sync.storeUrl",C="sync.productQuality";let i=class extends I.$kc{get n(){const s=this.H.get(y,-1);return s?P.URI.parse(s):void 0}set n(s){s?this.H.store(y,s.toString(),-1,1):this.H.remove(y,-1)}get s(){return this.H.get(C,-1)}set s(s){s?this.H.store(C,s,-1,1):this.H.remove(C,-1)}constructor(s,t,r,a,v,b,u,p,j,F){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=b,this.D=u,this.F=p,this.G=j,this.H=F,this.a=this.B(new I.$lc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$fd),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$Eg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,m.$bg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new c(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$7l)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove($,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=w.$Igb.toUserDataSyncError(s);t instanceof w.$Kgb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(o,!0,-1,1),await(0,O.$Hg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(o,-1,!1)}R(){this.H.remove(o,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$G4b=i,e.$G4b=i=ye([Z(0,g.$kj),Z(1,w.$Cgb),Z(2,w.$Dgb),Z(3,w.$Ngb),Z(4,w.$Ogb),Z(5,w.$Sgb),Z(6,d.$Czb),Z(7,f.$9k),Z(8,h.$qgb),Z(9,l.$Vo)],i);class c extends I.$kc{static{this.a="Interval"}constructor(s,t,r,a,v,b,u,p,j){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=v,this.w=b,this.y=u,this.z=p,this.C=j,this.b=this.B(new I.$lc),this.c=this.B(new D.$fd),this.onDidStartSync=this.c.event,this.f=this.B(new D.$fd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$ic)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}D(){this.b.value=(0,O.$Ig)(()=>this.sync(c.a,!1),this.n)}sync(s,t){const r=(0,O.$ug)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$2)(v))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,m.$bg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,m.$bg)(t.defaultUrl,s.defaultUrl)||!(0,m.$bg)(t.insidersUrl,s.insidersUrl)||!(0,m.$bg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,w.$Igb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(b){this.y.error(b),a=b}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new w.$Kgb((0,E.localize)(0,null),"DefaultServiceChanged"):new w.$Kgb((0,E.localize)(1,null),"ServiceChanged"):new w.$Kgb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get($,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new w.$Kgb((0,E.localize)(3,null),"DefaultServiceChanged"):new w.$Kgb((0,E.localize)(4,null),"ServiceChanged"):new w.$Kgb((0,E.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(u=>u.isCurrent);if(v?.disabled)throw new w.$Kgb((0,E.localize)(6,null),"TurnedOff");const b=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new w.$Kgb((0,A.$mi)(u),u instanceof w.$Igb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store($,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(oe[256],ae([0,1,11,177,15,12,44,20,28,25,17,39,119,118,117,19,120,115,116,4,121,41,27]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$f5b=void 0;let n=class{static{c=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,b,u,p,j,F,T){this.e=t,this.f=r,this.g=a,this.h=b,this.i=u,this.j=p,this.k=j,this.l=F,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,y.$E4b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,y.$E4b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:b})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:b,ref:u})=>({created:b,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,D.$2o)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===c.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,b){if(t){const{content:u}=await this.M(r,v,a);return u}return this.f.resolveResourceContent(r,v,a,b)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$Q2b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,f.$N2b)(t.content,!!this.l.getValue(m.$wgb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,d.$Y2b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const b=(0,g.$V2b)(v),u=[];for(const p of Object.keys(b)){const j=this.d.joinPath(t,p),F=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,c.a);u.push({resource:j,comparableResource:F})}return u}}return[]}z(t,r){return(0,g.$V2b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,h.$I2b)((0,h.$H2b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(h.$K2b).getLocalExtensions(t);return(0,h.$I2b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,o.$$Ab)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(o.$aBb).getLocalGlobalState(t);return(0,o.$$Ab)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,C.$xS)(JSON.parse(t.content),{})}return null}async I(t){return(0,y.$D4b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?c.b:c.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$te)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),a.push(t.profile),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:m.$Ugb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==m.$Ugb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===c.b;let v,b;const u=[];let p,j,F,T,z;for(;r.length;){const B=r.shift();B.startsWith("scheme:")?v=B.substring(7):B.startsWith("authority:")?b=B.substring(10):B.startsWith("syncResource:")?p=B.substring(13):B.startsWith("profile:")?j=B.substring(8):B.startsWith("collection:")?F=B.substring(11):B.startsWith("ref:")?T=B.substring(4):p?z=B:u.push(B)}return{remote:a,syncResource:p,profile:j,collection:F,ref:T,node:z,location:v&&b!==void 0?this.d.joinPath(O.URI.from({scheme:v,authority:b,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,E.$4Ab)(a))return a}catch(a){this.g.error(a)}throw new m.$Igb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$f5b=n,e.$f5b=n=c=ye([Z(0,m.$Dgb),Z(1,m.$Egb),Z(2,m.$Sgb),Z(3,S.$Ck),Z(4,A.$Ih),Z(5,I.$Vo),Z(6,L.$6j),Z(7,P.$Ek),Z(8,w.$8h),Z(9,$.$Ah)],n)}),define(oe[257],ae([0,1,18,5,26,38,3,2,21,9,32,19,29,12,4,20,22,17,115,116,117,118,119,120,121,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i,c,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=void 0;const t="sync.lastSyncTime";let r=class extends I.$kc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,j,F,T,z,B,_,J,Q,H,x){super(),this.C=p,this.D=j,this.F=F,this.G=T,this.H=z,this.I=B,this.J=_,this.L=J,this.M=Q,this.N=H,this.O=x,this.f="uninitialized",this.g=this.B(new D.$fd),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$fd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$fd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$fd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$fd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$fd),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$fd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,I.$ic)(()=>this.bb()))}async createSyncTask(p,j){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),T=(0,P.$4f)();try{const J=(0,s.$Hgb)(T);j&&(J["Cache-Control"]="no-cache"),p=await this.D.manifest(p,J)}catch(J){const Q=s.$Igb.toUserDataSyncError(J);throw b(Q,T,this.F,this.I),Q}const z=!1,B=this;let _;return{manifest:p,async run(){if(z)throw new Error("Can run a task only once");_=(0,N.$ug)(J=>B.P(p,!1,T,J)),await _.finally(()=>_=void 0),B.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),B.$()},stop(){return _?.cancel(),B.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Igb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),j=(0,P.$4f)(),F=(0,s.$Hgb)(j);let T;try{T=await this.D.manifest(null,F)}catch(_){const J=s.$Igb.toUserDataSyncError(_);throw b(J,j,this.F,this.I),J}await this.resetLocal();const z=this,B=new A.$pd;return{id:j,async merge(){return z.P(T,!0,j,B.token)},async apply(){try{try{await z.R(T,j,B.token)}catch(_){if(s.$Igb.toUserDataSyncError(_).code==="MethodNotFound")z.H.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.H.info("Applying manual sync again..."),await z.R(T,j,B.token);else throw _}}catch(_){throw z.H.error(_),_}z.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),z.$()},async stop(){B.cancel(),await z.U(),await z.resetLocal()}}}async P(p,j,F,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(z,p,j,F,T));const B=z.enabled.find(_=>_.resource==="profiles");if(B){const _=await B.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(_,p,j,F,T)}}finally{this.r.fire(this.n)}}async Q(p,j,F,T,z){for(const B of p){if(z.isCancellationRequested)return;const _=this.M.profiles.find(Q=>Q.id===B.id);if(!_){this.H.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",B.name);const J=this.getOrCreateActiveProfileSynchronizer(_,B);this.n.push(...await this.S(J,j,F,T,z))}for(const[B,_]of this.z.entries())this.M.profiles.some(J=>J.id===_[0].profile.id)||(_[1].dispose(),this.z.delete(B))}async R(p,j,F){const T=this.ab();for(const Q of T){if(F.isCancellationRequested)return;await Q.apply(j,F)}const z=T.find(Q=>Q.profile.isDefault);if(!z)return;const B=z.enabled.find(Q=>Q.resource==="profiles");if(!B)return;const J=(await B.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(Q=>T.every(H=>H.profile.id!==Q.id));J.length&&await this.Q(J,p,!1,j,F)}async S(p,j,F,T,z){return(await p.sync(j,F,T,z)).map(([_,J])=>({profile:p.profile,syncResource:_,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const j=await this.N.resolveContent(p);if(j)return j;for(const F of this.ab())for(const T of F.enabled){const z=await T.resolveContent(p);if(z)return z}return null}async replace(p){this.cb();const j=this.N.resolveUserDataSyncResource(p);if(!j)return;const F=await this.resolveContent(p.uri);F&&await this.W(j.profile,async T=>{if(j.syncResource===T.resource)return await T.replace(F),!0})}async accept(p,j,F,T){this.cb(),await this.W(p.profile,async z=>{if(p.syncResource===z.resource)return await z.accept(j,F),T&&await z.apply((0,m.$pf)(T)?!1:T.force,(0,s.$Hgb)((0,P.$4f)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(j){this.H.error(j)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),j=p.map(B=>B.collection),F=await this.D.getAllCollections(),T=F.filter(B=>!j.includes(B));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(B=>this.D.deleteCollection(B))),this.H.info("Deleted redundant collections on server"));const z=p.filter(B=>F.includes(B.collection));if(z.length!==p.length){const B=this.G.createInstance(n.$C4b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await B.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await B.updateRemoteProfiles(z,null),this.H.info("Updated remote profiles on server")}finally{B.dispose()}}}async saveRemoteActivityData(p){this.cb();const j=await this.D.getActivityData();await this.C.writeFile(p,j)}async extractActivityData(p,j){const F=(await this.C.readFile(p)).value.toString(),T=JSON.parse(F);if(T.resources)for(const z in T.resources)for(const B of T.resources[z])await this.O.writeResource(z,B.content,new Date(B.created*1e3),void 0,j);if(T.collections)for(const z in T.collections)for(const B in T.collections[z].resources)for(const _ of T.collections[z].resources?.[B]??[])await this.O.writeResource(B,_.content,new Date(_.created*1e3),z,j)}async W(p,j){const F=new I.$jc;try{const T=this.z.get(p.id);if(T){const Q=await this.X(T[0],j,F);return(0,m.$qf)(Q)?null:Q}if(p.isDefault){const Q=F.add(this.G.createInstance(a,p,void 0)),H=await this.X(Q,j,F);return(0,m.$qf)(H)?null:H}if(this.M.isEnabled())return null;const z=F.add(this.G.createInstance(n.$C4b,p,void 0)),B=await this.D.manifest(null),J=(await z.getRemoteSyncedProfiles(B?.latest??null)||[]).find(Q=>Q.id===p.id);if(J){const Q=F.add(this.G.createInstance(a,p,J.collection)),H=await this.X(Q,j,F);return(0,m.$qf)(H)?null:H}return null}finally{F.dispose()}}async X(p,j,F){const T=[...p.enabled,...p.disabled.reduce((z,B)=>(B!=="workspaceState"&&z.push(F.add(p.createSynchronizer(B))),z),[])];for(const z of T){const B=await j(z);if(!(0,m.$qf)(B))return B}}Y(p){const j=this.f;this.f!==p&&(this.f=p,this.g.fire(p),j==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(j=>j.conflicts).flat();(0,O.$sb)(this.j,p,(j,F)=>j.profile.id===F.profile.id&&j.syncResource===F.syncResource&&(0,O.$sb)(j.conflicts,F.conflicts,(T,z)=>(0,S.$bg)(T.previewResource,z.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,j){let F=this.z.get(p.id);if(F&&F[0].collection!==j?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(p.id)),!F){const T=new I.$jc,z=T.add(this.G.createInstance(a,p,j?.collection));T.add(z.onDidChangeStatus(B=>this.Y(B))),T.add(z.onDidChangeConflicts(B=>this.Z())),T.add(z.onDidChangeLocal(B=>this.h.fire(B))),this.z.set(p.id,F=[z,T])}return F[0]}ab(){const p=[];for(const[j]of this.z.values())p.push(j);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$F4b=r,e.$F4b=r=ye([Z(0,l.$6j),Z(1,s.$Dgb),Z(2,s.$Cgb),Z(3,f.$Ah),Z(4,s.$Sgb),Z(5,d.$9k),Z(6,w.$Vo),Z(7,s.$Ngb),Z(8,h.$Ek),Z(9,s.$Pgb),Z(10,s.$Egb)],r);let a=class extends I.$kc{get enabled(){return this.f.sort((p,j)=>p[1]-j[1]).map(([p])=>p)}get disabled(){return s.$zgb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,j,F,T,z,B,_,J,Q,H){super(),this.profile=p,this.collection=j,this.r=F,this.t=T,this.u=z,this.w=B,this.y=_,this.z=J,this.C=Q,this.D=H,this.f=[],this.g="idle",this.h=this.B(new D.$fd),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$fd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$fd),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([x,G])=>this.F(x,G))),this.B((0,I.$ic)(()=>this.f.splice(0,this.f.length).forEach(([,,x])=>x.dispose())));for(const x of s.$zgb)F.isResourceEnabled(x)&&this.G(x)}F(p,j){j?this.G(p):this.H(p)}G(p){if(this.f.some(([z])=>z.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const j=new I.$jc,F=j.add(this.createSynchronizer(p));j.add(F.onDidChangeStatus(()=>this.L())),j.add(F.onDidChangeConflicts(()=>this.M())),j.add(F.onDidChangeLocal(()=>this.j.fire(p)));const T=this.N(p);this.f.push([F,T,j])}H(p){const j=this.f.findIndex(([F])=>F.resource===p);if(j!==-1){const[[F,,T]]=this.f.splice(j,1);T.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(C.$R2b,this.profile,this.collection);case"keybindings":return this.t.createInstance(y.$O2b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$W2b,this.profile,this.collection);case"tasks":return this.t.createInstance(c.$Z2b,this.profile,this.collection);case"globalState":return this.t.createInstance($.$_Ab,this.profile,this.collection);case"extensions":return this.t.createInstance(o.$J2b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$C4b,this.profile,this.collection)}}async sync(p,j,F,T){if(T.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const B=[],_=(0,s.$Hgb)(F),J=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,Q=j?await this.I(J):{};for(const H of z){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(j){const x=await H.preview(J,Q,_);if(x)for(const G of x.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await H.merge(G.previewResource)}else await H.sync(J,_)}catch(x){const G=s.$Igb.toUserDataSyncError(x);if(b(G,F,this.w,this.y),v(x))throw G;this.z.error(x),this.z.error(`${H.resource}: ${(0,L.$mi)(x)}`),B.push([H.resource,G])}}return B}finally{this.L()}}async apply(p,j){const F=(0,s.$Hgb)(p);for(const T of this.enabled){if(j.isCancellationRequested)return;try{await T.apply(!1,F)}catch(z){const B=s.$Igb.toUserDataSyncError(z);if(b(B,p,this.w,this.y),v(z))throw B;this.z.error(z),this.z.error(`${T.resource}: ${(0,L.$mi)(z)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(j){this.z.error(j)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(j){this.z.error(`${p.resource}: ${(0,L.$mi)(j)}`),this.z.error(j)}}async I(p){if(!this.profile.isDefault)return{};const j=this.D.getValue(s.$vgb),F=this.enabled.find(T=>T instanceof C.$R2b);if(F){const T=await F.getRemoteUserDataSyncConfiguration(p);return{...j,...T}}return j}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,O.$sb)(this.m,p,(j,F)=>j.syncResource===F.syncResource&&(0,O.$sb)(j.conflicts,F.conflicts,(T,z)=>(0,S.$bg)(T.previewResource,z.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Z(2,s.$Ngb),Z(3,f.$Ah),Z(4,g.$Zn),Z(5,s.$Cgb),Z(6,d.$9k),Z(7,s.$Sgb),Z(8,h.$Ek),Z(9,E.$8h)],a);function v(u){if(u instanceof s.$Igb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function b(u,p,j,F){F.publicLog2("sync/error",{code:u.code,serverCode:u instanceof s.$Jgb?String(u.serverCode):void 0,url:u instanceof s.$Jgb?u.url:void 0,resource:u.resource,executionId:p,service:j.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,11,17,25]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=e.$U7b=void 0;function I(g,l){return{...g,profile:(0,L.$Fk)(g.profile,l.profilesHome.scheme)}}function S(g){return{created:g.created,uri:A.URI.revive(g.uri)}}class m{constructor(l,f,w){this.c=l,this.d=f,this.f=w,this.a=new Map,this.b=new O.$fd}listen(l,f){switch(f){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${f}`)}async call(l,f,w){try{return await this.g(l,f,w)}catch(d){throw this.f.error(d),d}}async g(l,f,w){switch(f){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(w[0]));case"accept":return this.c.accept(I(w[0],this.d),A.URI.revive(w[1]),w[2],w[3]);case"replace":return this.c.replace(S(w[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(w[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(w[0]),A.URI.revive(w[1]));case"createManualSyncTask":return this.i()}if(f.startsWith("manualSync/")){const d=f.substring(11),h=w[0],o=this.h(h);switch(w=w.slice(1),d){case"merge":return o.merge();case"apply":return o.apply().then(()=>this.a.delete(this.j(o.id)));case"stop":return o.stop().finally(()=>this.a.delete(this.j(o.id)))}}throw new Error("Invalid call")}h(l){const f=this.a.get(this.j(l));if(!f)throw new Error(`Manual sync taks not found: ${l}`);return f}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$U7b=m;let P=class extends N.$kc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,f){super(),this.n=f,this.b="uninitialized",this.c=this.B(new O.$fd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$fd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$fd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$fd),this.onSyncErrors=this.m.event,this.a={call(w,d,h){return l.call(w,d,h).then(null,o=>{throw D.$Igb.toUserDataSyncError(o)})},listen(w,d){return l.listen(w,d)}},this.a.call("_getInitialData").then(([w,d,h])=>{this.s(w),this.t(d),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(o=>this.s(o))),this.B(this.a.listen("onDidChangeLastSyncTime")(o=>this.u(o)))}),this.B(this.a.listen("onDidChangeConflicts")(w=>this.t(w))),this.B(this.a.listen("onSyncErrors")(w=>this.m.fire(w.map(d=>({...d,error:D.$Igb.toUserDataSyncError(d.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),f=this;return new E(l,{async call(d,h,o){return f.a.call(`manualSync/${d}`,[l,...Array.isArray(h)?h:[h]],o)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,f,w,d){return this.a.call("accept",[l,f,w,d])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,f){return this.a.call("extractActivityData",[l,f])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(f=>({syncResource:f.syncResource,profile:(0,L.$Fk)(f.profile,this.n.profilesHome.scheme),conflicts:f.conflicts.map(w=>({...w,baseResource:A.URI.revive(w.baseResource),localResource:A.URI.revive(w.localResource),remoteResource:A.URI.revive(w.remoteResource),previewResource:A.URI.revive(w.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$V7b=P,e.$V7b=P=ye([Z(1,L.$Ek)],P);class E extends N.$kc{constructor(l,f){super(),this.id=l,this.a=f}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,5,26,8,3,2,141,6,21,9,11,32,19,15,12,24,57,44,20,25]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Ab=e.$1Ab=e.$ZAb=e.$YAb=e.$XAb=void 0;const C="configurationSync.store",i="sync.previous.store",c="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends D.$kc{get userDataSyncStore(){return this.b}get c(){return this.h.get(y.$Lgb,-1)}set c(F){this.h.store(y.$Lgb,F,-1,S.$o?0:1)}constructor(F,T,z){super(),this.f=F,this.g=T,this.h=z,this.a=this.B(new L.$fd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const B=this.B(new D.$jc);this.B(L.Event.filter(z.onDidChangeValue(-1,y.$Lgb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.j()))}j(){this.b=this.m(this.f[C]),this.a.fire()}m(F){if(F&&(F=S.$o&&F.web?{...F,...F.web}:F,(0,P.$jf)(F.url)&&(0,P.$lf)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(T=>Array.isArray(F.authenticationProviders[T].scopes)))){const T=F,z=!!T.canSwitch,B=T.url===T.insidersUrl?"insiders":"stable",_=(z?this.c:void 0)||B,J=_==="insiders"?T.insidersUrl:_==="stable"?T.stableUrl:T.url;return{url:E.URI.parse(J),type:_,defaultType:B,defaultUrl:E.URI.parse(T.url),stableUrl:E.URI.parse(T.stableUrl),insidersUrl:E.URI.parse(T.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(T.authenticationProviders).reduce((Q,H)=>(Q.push({id:H,scopes:T.authenticationProviders[H].scopes}),Q),[])}}}};e.$XAb=a,e.$XAb=a=ye([Z(0,d.$kj),Z(1,l.$8h),Z(2,$.$Vo)],a);let v=class extends a{constructor(F,T,z){super(F,T,z);const B=this.h.get(i,-1);B&&(this.n=JSON.parse(B));const _=this.f[C];_?this.h.store(i,JSON.stringify(_),-1,1):this.h.remove(i,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$YAb=v,e.$YAb=v=ye([Z(0,d.$kj),Z(1,l.$8h),Z(2,$.$Vo)],v);let b=class extends D.$kc{get donotMakeRequestsUntil(){return this.j}constructor(F,T,z,B,_,J,Q){super(),this.n=z,this.r=B,this.s=Q,this.g=this.B(new L.$fd),this.onTokenFailed=this.g.event,this.h=this.B(new L.$fd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$fd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,o.$2o)(_,J,Q).then(H=>{const x={"X-Client-Name":`${T.applicationName}${S.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(x["X-Client-Commit"]=T.commit),x}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,D.$ic)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,T){this.b={token:F,type:T}}t(F){this.a=F?(0,m.$ig)(F,"v1"):void 0}u(){const F=this.s.getNumber(c,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(c,this.j.getTime(),-1,1),this.w=(0,O.$ug)(T=>(0,O.$Hg)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(c,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,m.$ig)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const z=await this.D(T,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,h.$Oo)(z))?.map(({id:B})=>B)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,m.$ig)(this.a,"collection").toString();F={...F},F["Content-Type"]=I.$Hr.text;const z=await this.D(T,{type:"POST",headers:F},[],N.CancellationToken.None),B=await(0,h.$No)(z);if(!B)throw new y.$Jgb("Server did not return the collection id",T,"NoCollection",z.res.statusCode,z.res.headers[y.$Fgb]);return B}async deleteCollection(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=F?(0,m.$ig)(this.a,"collection",F).toString():(0,m.$ig)(this.a,"collection").toString();T={...T},await this.D(z,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(F,T){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.z(this.a,T,F),B={},_=await this.D(z.toString(),{type:"GET",headers:B},[],N.CancellationToken.None);return(await(0,h.$Oo)(_)||[]).map(({url:Q,created:H})=>({ref:(0,m.$kg)(z,z.with({path:Q})),created:H*1e3}))}async resolveResourceContent(F,T,z,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,m.$ig)(this.z(this.a,z,F),T).toString();B={...B},B["Cache-Control"]="no-cache";const J=await this.D(_,{type:"GET",headers:B},[],N.CancellationToken.None);return await(0,h.$No)(J)}async deleteResource(F,T,z){if(!this.a)throw new Error("No settings sync store url configured.");const B=T!==null?(0,m.$ig)(this.z(this.a,z,F),T).toString():this.z(this.a,z,F).toString(),_={};await this.D(B,{type:"DELETE",headers:_},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$ig)(this.a,"resource").toString(),T={"Content-Type":I.$Hr.text};await this.D(F,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(F,T,z,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,m.$ig)(this.z(this.a,z,F),"latest").toString();B={...B},B["Cache-Control"]="no-cache",T&&(B["If-None-Match"]=T.ref);const J=await this.D(_,{type:"GET",headers:B},[304],N.CancellationToken.None);let Q=null;if(J.res.statusCode===304&&(Q=T),Q===null){const H=J.res.headers.etag;if(!H)throw new y.$Jgb("Server did not return the ref",_,"NoRef",J.res.statusCode,J.res.headers[y.$Fgb]);const x=await(0,h.$No)(J);if(!x&&J.res.statusCode===304)throw new y.$Jgb("Empty response",_,"EmptyResponse",J.res.statusCode,J.res.headers[y.$Fgb]);Q={ref:H,content:x}}return Q}async writeResource(F,T,z,B,_={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,B,F).toString();_={..._},_["Content-Type"]=I.$Hr.text,z&&(_["If-Match"]=z);const Q=await this.D(J,{type:"POST",data:T,headers:_},[],N.CancellationToken.None),H=Q.res.headers.etag;if(!H)throw new y.$Jgb("Server did not return the ref",J,"NoRef",Q.res.statusCode,Q.res.headers[y.$Fgb]);return H}async manifest(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,m.$ig)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",F&&(T["If-None-Match"]=F.ref);const B=await this.D(z,{type:"GET",headers:T},[304],N.CancellationToken.None);let _=null;if(B.res.statusCode===304&&(_=F),!_){const Q=B.res.headers.etag;if(!Q)throw new y.$Jgb("Server did not return the ref",z,"NoRef",B.res.statusCode,B.res.headers[y.$Fgb]);const H=await(0,h.$No)(B);if(!H&&B.res.statusCode===304)throw new y.$Jgb("Empty response",z,"EmptyResponse",B.res.statusCode,B.res.headers[y.$Fgb]);H&&(_={...JSON.parse(H),ref:Q})}const J=this.s.get(n,-1);return J&&_&&J!==_.session&&this.C(),_===null&&J&&this.C(),_&&this.s.store(n,_.session,-1,1),_}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$ig)(this.a,"download").toString(),T={},z=await this.D(F,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,h.$Ko)(z))throw new y.$Jgb("Server returned "+z.res.statusCode,F,"EmptyResponse",z.res.statusCode,z.res.headers[y.$Fgb]);if((0,h.$Lo)(z))throw new y.$Jgb("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[y.$Fgb]);return z.stream}z(F,T,z){return T?(0,m.$ig)(F,"collection",T,"resource",z):(0,m.$ig)(F,"resource",z)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(F,T,z,B){if(!this.b)throw new y.$Jgb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new y.$Jgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const _=await this.c;T.headers={...T.headers||{},..._,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:F,type:T.type,headers:{...T.headers,authorization:void 0}});let J;try{J=await this.f.request(F,T,B)}catch(V){if(!(V instanceof y.$Jgb)){let W="RequestFailed";const ee=(0,A.$8)(V).toLowerCase();ee.includes("xhr timeout")?W="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?W="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?W="RequestPathNotEscaped":ee.includes("headers must be an object")?W="RequestHeadersNotObject":(0,A.$2)(V)&&(W="RequestCanceled"),V=new y.$Jgb(`Connection refused for the request '${F}'.`,F,W,void 0,void 0)}throw this.r.info("Request failed",F),V}const Q=J.res.headers[y.$Fgb],H={url:F,status:J.res.statusCode,"execution-id":T.headers[y.$Ggb],"operation-id":Q},x=(0,h.$Ko)(J)||J.res.statusCode&&z.includes(J.res.statusCode);let G="";if(x?this.r.trace("Request succeeded",H):(G=await(0,h.$Mo)(J)||"",this.r.info("Request failed",H,G)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new y.$Jgb(`${T.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",J.res.statusCode,Q);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new y.$Jgb(`${T.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",J.res.statusCode,Q)}if(this.h.fire(),J.res.statusCode===404)throw new y.$Jgb(`${T.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",J.res.statusCode,Q);if(J.res.statusCode===405)throw new y.$Jgb(`${T.type} request '${F}' failed because the requested endpoint is not found (405). ${G}`,F,"MethodNotFound",J.res.statusCode,Q);if(J.res.statusCode===409)throw new y.$Jgb(`${T.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",J.res.statusCode,Q);if(J.res.statusCode===410)throw new y.$Jgb(`${T.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",J.res.statusCode,Q);if(J.res.statusCode===412)throw new y.$Jgb(`${T.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",J.res.statusCode,Q);if(J.res.statusCode===413)throw new y.$Jgb(`${T.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",J.res.statusCode,Q);if(J.res.statusCode===426)throw new y.$Jgb(`${T.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",J.res.statusCode,Q);if(J.res.statusCode===429){const V=J.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new y.$Jgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",J.res.statusCode,Q)):new y.$Jgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",J.res.statusCode,Q)}if(!x)throw new y.$Jgb("Server returned "+J.res.statusCode,F,"Unknown",J.res.statusCode,Q);return J}F(F){let T=this.s.get(s,-1);T===void 0&&(T=(0,g.$4f)(),this.s.store(s,T,-1,1)),F["X-Machine-Session-Id"]=T;const z=this.s.get(n,-1);z!==void 0&&(F["X-User-Session-Id"]=z)}};e.$ZAb=b,e.$ZAb=b=ye([Z(1,d.$kj),Z(2,h.$Io),Z(3,y.$Sgb),Z(4,f.$Ih),Z(5,w.$6j),Z(6,$.$Vo)],b);let u=class extends b{constructor(F,T,z,B,_,J,Q){super(F.userDataSyncStore?.url,T,z,B,_,J,Q),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$1Ab=u,e.$1Ab=u=ye([Z(0,y.$Cgb),Z(1,d.$kj),Z(2,h.$Io),Z(3,y.$Sgb),Z(4,f.$Ih),Z(5,w.$6j),Z(6,$.$Vo)],u);class p{constructor(F,T,z,B){this.c=F,this.d=T,this.f=z,this.g=B,this.a=[],this.b=void 0}request(F,T,z){if(this.h()&&this.i(),T.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new y.$Jgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(T,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$2Ab=p}),define(oe[260],ae([0,1,3,55,24,20,22,255,25,78,81]),function(te,e,O,N,A,L,D,I,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=void 0;let E=class extends I.$G4b{constructor(l,f,w,d,h,o,$,y,C,i,c){super(l,f,w,d,h,$,y,C,i,c),this.B(O.Event.debounce(O.Event.any(O.Event.map(o.onDidFocusWindow,()=>"windowFocus"),O.Event.map(o.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$d8b=E,e.$d8b=E=ye([Z(0,A.$kj),Z(1,S.$Cgb),Z(2,S.$Dgb),Z(3,S.$Ngb),Z(4,S.$Ogb),Z(5,N.$45b),Z(6,S.$Sgb),Z(7,m.$Czb),Z(8,D.$9k),Z(9,P.$qgb),Z(10,L.$Vo)],E)}),define(oe[261],ae([0,1,69,23,6,21]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F5b=e.$E5b=e.$D5b=e.$C5b=void 0,e.$C5b=128/4;function D(m){function P(){let E=m.scheme===N.Schemas.file?(0,L.$9f)(m):m.toString();return A.$k||(E=E.toLowerCase()),(0,O.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:m}}e.$D5b=D;function I(m,P){function E(){if(m.scheme!==N.Schemas.file)return(0,O.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let l;return A.$k?l=P.ino:A.$j?l=P.birthtime.getTime():A.$i&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,O.createHash)("md5").update(m.fsPath).update(l?String(l):"").digest("hex")}const g=E();if(typeof g=="string")return{id:g,uri:m}}e.$E5b=I;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$F5b=S}),define(oe[262],ae([0,1,5,8,2,16,31,15,7,75,113,261,55,71,23]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0;let w=class extends A.$kc{constructor(h,o,$,y){super(),this.a=h,this.b=o,this.c=$,this.f=y,this.B(new O.$Sg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:f.Schemas.file}).fsPath,o=await D.Promises.readdir(h),$=new m.$bAb(this.f.getChannel("storage"));await Promise.all(o.map(async y=>{const C=(0,L.$9d)(h,y);y.length===E.$C5b||y===P.$Nh.id||(await this.c.getWindows()).some(n=>n.workspace?.id===y)||await $.isUsed(C)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${y} as it seems to be an unused empty workspace.`),await D.Promises.rm(C))}))}catch(h){(0,N.$Y)(h)}}};e.$J7b=w,e.$J7b=w=ye([Z(0,I.$Jh),Z(1,S.$5i),Z(2,g.$45b),Z(3,l.$i7b)],w)}),define(oe[82],ae([0,1,52,5,16,9,31,148,273,274]),function(te,e,O,N,A,L,D,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.zip=e.$bp=e.$ap=void 0,e.$ap="end of central directory record signature not found";const P=new RegExp(e.$ap);class E extends Error{constructor(c,n){let s=n.message;switch(c){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=c,this.cause=n}}e.$bp=E;function g(i){const c=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>c&n).reduce((n,s)=>n+s,c&61440)}function l(i){if(i instanceof E)return i;let c;return P.test(i.message)&&(c="CorruptZip"),new E(c,i)}function f(i,c,n,s,t,r){const a=A.$_d(c),v=A.$9d(s,a);if(!v.startsWith(s))return Promise.reject(new Error(I.localize(0,null,c)));const b=A.$9d(s,c);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(D.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((p,j)=>{if(!r.isCancellationRequested)try{u=(0,O.createWriteStream)(b,{mode:n}),u.once("close",()=>p()),u.once("error",j),i.once("error",j),i.pipe(u)}catch(F){j(F)}}))}function w(i,c,n,s){let t=(0,N.$ug)(()=>Promise.resolve()),r=0;const a=s.onCancellationRequested(()=>{t.cancel(),i.close()});return new Promise((v,b)=>{const u=new N.$Bg,p=j=>{j.isCancellationRequested||(r++,i.readEntry())};i.once("error",b),i.once("close",()=>t.then(()=>{s.isCancellationRequested||i.entryCount===r?v():b(new E("Incomplete",new Error(I.localize(1,null,r,i.entryCount))))},b)),i.readEntry(),i.on("entry",j=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){p(s);return}const F=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const B=A.$9d(c,F);t=(0,N.$ug)(_=>D.Promises.mkdir(B,{recursive:!0}).then(()=>p(_)).then(void 0,b));return}const T=h(i,j),z=g(j);t=(0,N.$ug)(B=>u.queue(()=>T.then(_=>f(_,F,z,c,n,B).then(()=>p(B)))).then(null,b))})}).finally(()=>a.dispose())}function d(i,c=!1){return new Promise((n,s)=>{(0,S.open)(i,c?{lazyEntries:!0}:void 0,(t,r)=>{t?s(l(t)):n((0,L.$uf)(r))})})}function h(i,c){return new Promise((n,s)=>{i.openReadStream(c,(t,r)=>{t?s(l(t)):n((0,L.$uf)(r))})})}function o(i,c){return new Promise((n,s)=>{const t=new m.ZipFile;c.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const r=(0,O.createWriteStream)(i);t.outputStream.pipe(r),t.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(i))})}e.zip=o;function $(i,c,n={},s){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=d(i,!0);return n.overwrite&&(r=r.then(a=>D.Promises.rm(c).then(()=>a))),r.then(a=>w(a,c,{sourcePathRegex:t},s))}e.$dp=$;function y(i,c){return d(i).then(n=>new Promise((s,t)=>{n.on("entry",r=>{r.fileName===c&&h(n,r).then(a=>s(a),a=>t(a))}),n.once("close",()=>t(new Error(I.localize(2,null,c))))}))}function C(i,c){return y(i,c).then(n=>new Promise((s,t)=>{const r=[];n.once("error",t),n.on("data",a=>r.push(a)),n.on("end",()=>s(Buffer.concat(r)))}))}e.$ep=C}),define(oe[263],ae([0,1,5,8,2,23,21,53,9,32,31,82,19,15,29,33,97,12,7]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;let y=class extends A.$kc{static{$=this}static{this.c=".sigzip"}constructor(i,c,n,s,t,r){super(),this.h=c,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,c,n){await this.g;const s=(0,D.$ig)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,c))}catch(r){throw new f.$1n(r.message,f.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===o.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${v.output}`),t===f.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===f.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new f.$1n(E.$ap,f.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return!1;const c=this.m.getValue("extensions.verifySignature");return(0,S.$pf)(c)?c:!0}async u(i){await this.g;const c=(0,D.$ig)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);return await this.w(i,c,n=>this.j.downloadSignatureArchive(i,n)),c}async w(i,c,n){if(await this.h.exists(c))return;if(c.scheme!==L.Schemas.file){await n(c);return}const s=(0,D.$ig)(this.extensionsDownloadDir,`.${(0,m.$4f)()}`);await this.h.exists(s)||await n(s);try{await P.Promises.rename(s.fsPath,c.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,c.path);else throw this.r.info(`Rename failed because of ${(0,N.$8)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const c=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith($.c))s.push(a.resource);else{const v=w.$qo.parse(a.name);v&&n.push([v,a])}const t=(0,w.$vo)(n,([a])=>a),r=[];for(const a of t)a.sort((v,b)=>I.rcompare(v[0].version,b[0].version)),c.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),c.push(...s),await O.Promises.settled(c.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?w.$qo.create(i).toString().toLowerCase():(0,m.$4f)()}};e.$tp=y,e.$tp=y=$=ye([Z(0,l.$Jh),Z(1,h.$6j),Z(2,f.$Zn),Z(3,g.$8h),Z(4,d.$7o),Z(5,o.$5i)],y)}),define(oe[264],ae([0,1,82,157]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;function A(L){return(0,O.$ep)(L,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$vp=A}),define(oe[122],ae([0,1,5,14,26,38,8,3,51,2,35,23,16,21,53,9,11,32,31,82,156,96,15,243,29,33,50,79,263,244,264,212,223,67,12,4,7,24,22,28,17]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i,c,n,s,t,r,a,v,b,u,p,j,F,T,z,B,_,J,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$yp=(0,T.$Ch)(n.$2n);const H=".vsctmp";let x=class extends c.$fp{constructor(X,q,k,R,U,M,K,Y,se,le,ue,he){super(X,q,ue,k,le,he),this.fb=U,this.gb=M,this.hb=K,this.ib=se,this.eb=new Map,this.rb=new P.$Ai;const $e=this.B(Y.createInstance(v.$up));this.bb=this.B(Y.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new u.$wp(he,se,ue,this,this.F)),this.db=this.B(Y.createInstance(a.$tp));const de=this.B(new p.$xp(this,this.fb,he,M,ue,se,k));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Ao)(this.ib,this.F)),this.jb}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const q=await this.pb(X),k=await(0,$.zip)((0,l.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)()).fsPath,q);return d.URI.file(k)}async unzip(X){return this.F.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:q,cleanup:k}=await this.lb(X),R=g.$0d(q.fsPath);try{return await(0,b.$vp)(R)}finally{await k()}}getInstalled(X,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(X??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.bb.scanUserExtensionAtLocation(X)}async install(X,q={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:k,cleanup:R}=await this.lb(X);try{const U=await(0,b.$vp)(g.$0d(k.fsPath)),M=(0,s.$uo)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,j.$Ho)(U.engines.vscode,this.G.version,this.G.date))throw new Error(y.localize(0,null,M,this.G.version));const Y=(await this.I([{manifest:U,extension:k,options:q}])).find(({identifier:se})=>(0,s.$po)(se,{id:M}));if(Y?.local)return Y.local;throw Y?.error?Y.error:(0,c.$hp)(new Error(`Unknown error while installing extension ${M}`))}finally{await R()}}async installFromLocation(X,q){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const k=await this.bb.scanUserExtensionAtLocation(X);if(!k)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.ub([[k,void 0]],q),this.F.info("Successfully installed extension",k.identifier.id,q.toString()),k}async installExtensionsFromProfile(X,q,k){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,q.toString(),k.toString());const R=(await this.bb.scanExtensions(1,q)).filter(U=>X.some(M=>(0,s.$po)(M,U.identifier)));if(R.length){const U=await Promise.all(R.map(M=>this.bb.scanMetadata(M,q)));await this.ub(R.map((M,K)=>[M,U[K]]),k),this.F.info("Successfully installed extensions",R.map(M=>M.identifier.id),k.toString())}return R}async updateMetadata(X,q,k=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.pinned=q.pinned||void 0,X=await this.bb.updateMetadata(X,q,k),this.cb.invalidate(k),this.w.fire(X),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(y.localize(1,null));const q=await this.getTargetPlatform(),[k]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:q,compatible:!0},A.CancellationToken.None);if(!k)throw new Error(y.localize(2,null));await this.bb.setUninstalled(X);try{await this.bb.removeUninstalledExtension(X)}catch(R){throw new Error(y.localize(3,null,(0,L.$mi)(R)))}return this.installFromGallery(k)}ab(X,q,k,R){return this.bb.copyExtension(X,q,k,R)}copyExtensions(X,q){return this.bb.copyExtensions(X,q)}markAsUninstalled(...X){return this.bb.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(X){this.F.error(X)}}async download(X,q,k){const{location:R}=await this.db.download(X,q,!k);return R}async lb(X){if(X.scheme===E.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const q=(0,l.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)());return await this.hb.download(X,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(R){this.F.error(R)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(X,q,k){if(d.URI.isUri(q))return new ee(X,q,k,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const R=s.$qo.create(q).toString();let U=this.eb.get(R);return U||(this.eb.set(R,U=new W(X,q,k,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),U.waitUntilTaskIsFinished().finally(()=>this.eb.delete(R))),U}$(X,q){return new ne(X,q.profileLocation,this.gb)}async pb(X){const q=async R=>{let U=await o.Promises.readdir(R);U=U.map(Y=>g.$9d(R,Y));const M=await Promise.all(U.map(Y=>o.Promises.stat(Y)));let K=Promise.resolve([]);return M.forEach((Y,se)=>{const le=U[se];Y.isFile()&&(K=K.then(ue=>[...ue,le])),Y.isDirectory()&&(K=K.then(ue=>q(le).then(he=>[...ue,...he])))}),K};return(await q(X.location.fsPath)).map(R=>({path:`extension/${g.$$d(X.location.fsPath,R)}`,localPath:R}))}async qb({added:X,removed:q}){if(q)for(const k of q.extensions)this.F.info("Extensions removed from another source",k.id,q.profileLocation.toString()),this.u.fire({identifier:k,profileLocation:q.profileLocation});if(X){const R=(await this.bb.scanExtensions(1,X.profileLocation)).filter(U=>X.extensions.some(M=>(0,s.$po)(M,U.identifier)));this.s.fire(R.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,X.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:X.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const X=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of X.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(X){if(!X.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const k of X.rawAdded){if(this.rb.has(k)||!this.D.extUri.isEqual(this.D.extUri.dirname(k),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(k,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(k).startsWith(".")||!(await this.ib.stat(k)).isDirectory)continue;const R=await this.bb.scanUserExtensionAtLocation(k);R&&R.installedTimestamp===void 0&&(this.rb.add(k),q.push(R))}q.length&&(await this.ub(q.map(k=>[k,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(k=>k.identifier.id)))}async ub(X,q){const k=X.map(R=>R[0]);await this.vb(k),await this.gb.addExtensionsToProfile(X,q),this.s.fire(k.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:q})))}async vb(X){const q=await this.bb.getUninstalledExtensions();for(const k of X){const R=s.$qo.create(k);q[R.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",R.id),await this.bb.setInstalled(R),this.F.info("Removed the extension from uninstalled list:",R.id))}}};e.$zp=x,e.$zp=x=ye([Z(0,n.$Zn),Z(1,_.$9k),Z(2,z.$5i),Z(3,i.$Jh),Z(4,r.$op),Z(5,t.$kp),Z(6,C.$Dn),Z(7,T.$Ah),Z(8,F.$6j),Z(9,B.$kj),Z(10,J.$Ck),Z(11,Q.$Ek)],x);let G=class extends m.$kc{constructor(X,q,k,R,U,M){super(),this.j=X,this.m=q,this.n=k,this.s=R,this.t=U,this.u=M,this.h=this.B(new I.$fd),this.onExtract=this.h.event,this.c=(0,l.$ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Ng}async cleanUp(){await this.H(),await this.G()}async scanExtensions(X,q){const k={includeInvalid:!0,profileLocation:q};let R=[];return X===null||X===0?R.push(...await this.n.scanAllExtensions({includeInvalid:!0},k,!1)):X===1&&R.push(...await this.n.scanUserExtensions(k)),R=X!==null?R.filter(U=>U.type===X):R,Promise.all(R.map(U=>this.F(U)))}async scanAllUserExtensions(X){const q=await this.n.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(q.map(k=>this.F(k)))}async scanUserExtensionAtLocation(X){try{const q=await this.n.scanExistingExtension(X,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(X,q,k,R,U){const M=X.toString(),K=d.URI.file(g.$9d(this.n.userExtensionsLocation.fsPath,`.${(0,h.$4f)()}`)),Y=d.URI.file(g.$9d(this.n.userExtensionsLocation.fsPath,M));let se=await this.m.exists(Y);if(se&&R){try{await this.y(X.id,Y,"removeExisting")}catch{throw new n.$1n(y.localize(4,null,Y.fsPath,X.id),n.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.u.trace(`Started extracting the extension from ${q} to ${Y.fsPath}`),await(0,$.$dp)(q,K.fsPath,{sourcePath:"extension",overwrite:!0},U),this.u.info(`Extracted extension to ${Y}:`,X.id)}catch(le){let ue=n.ExtensionManagementErrorCode.Extract;throw le instanceof $.$bp&&(le.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$1n(le.message,ue)}await this.n.updateMetadata(K,k);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${Y.fsPath}`),await this.C(K.fsPath,Y.fsPath),this.u.info("Renamed to",Y.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.u.info(`Rename failed because of ${(0,D.$8)(le)}. Deleted from extracted location`,K),le}this.h.fire(Y)}catch(le){try{await this.m.del(K,{recursive:!0})}catch{}throw le}return this.D(Y,1)}async scanMetadata(X,q){return q?(await this.w(X,q))?.metadata:this.n.scanMetadata(X.location)}async w(X,q){return(await this.s.scanProfileExtensions(q)).find(R=>(0,s.$po)(R.identifier,X.identifier))}async updateMetadata(X,q,k){return k?await this.s.updateMetadata([[X,q]],k):await this.n.updateMetadata(X.location,q),this.D(X.location,X.type,k)}getUninstalledExtensions(){return this.z()}async setUninstalled(...X){const q=X.map(k=>s.$qo.create(k));await this.z(k=>q.forEach(R=>{k[R.toString()]=!0,this.u.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(X){await this.z(q=>delete q[X.toString()])}async removeExtension(X,q){if(this.t.extUri.isEqualOrParent(X.location,this.n.userExtensionsLocation))return this.y(X.identifier.id,X.location,q)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.z(q=>delete q[s.$qo.create(X).toString()])}async copyExtension(X,q,k,R){const U=await this.w(X,q),M=await this.w(X,k);return R={...U?.metadata,...R},M?await this.s.updateMetadata([[X,{...M.metadata,...R}]],k):await this.s.addExtensionsToProfile([[X,R]],k),this.D(X.location,X.type,k)}async copyExtensions(X,q){const k=await this.scanExtensions(1,X),R=await Promise.all(k.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,X)]));await this.s.addExtensionsToProfile(R,q)}async y(X,q,k){this.u.trace(`Deleting ${k} extension from disk`,X,q.fsPath);const R=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$pi)((0,h.$4f)()).toString(16)}${H}`);await this.C(q.fsPath,R.fsPath),await this.m.del(R,{recursive:!0}),this.u.info(`Deleted ${k} extension from disk`,X,q.fsPath)}async z(X){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(R){if((0,F.$jk)(R)!==1)throw R}let k={};if(q)try{k=JSON.parse(q)}catch{}return X&&(X(k),Object.keys(k).length?await this.m.writeFile(this.c,N.$Fd.fromString(JSON.stringify(k))):await this.m.del(this.c)),k})}async C(X,q){try{await o.Promises.rename(X,q,2*60*1e3)}catch(k){throw new n.$1n(k.message||y.localize(5,null,X,q),k.code||n.ExtensionManagementErrorCode.Rename)}}async D(X,q,k){if(k){const U=(await this.n.scanUserExtensions({profileLocation:k})).find(M=>this.t.extUri.isEqual(M.location,X));if(U)return this.F(U)}else{const R=await this.n.scanExistingExtension(X,q,{includeInvalid:!0});if(R)return this.F(R)}throw new Error(y.localize(6,null,X.path))}async F(X){const q=await this.m.resolve(X.location);let k,R;return q.children&&(k=q.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,R=q.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:k,changelogUrl:R,publisherDisplayName:X.metadata?.publisherDisplayName||null,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned}}async G(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(X));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const U of q)X[s.$qo.create(U).toString()]||k.add(U.identifier.id.toLowerCase());try{const U=(0,s.$vo)(q,M=>M.identifier);await O.Promises.settled(U.map(async M=>{const K=M.sort((Y,se)=>f.rcompare(Y.manifest.version,se.manifest.version))[0];k.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(U){this.u.error(U)}const R=q.filter(U=>U.metadata&&X[s.$qo.create(U).toString()]);await Promise.allSettled(R.map(U=>this.removeUninstalledExtension(U)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,F.$jk)(q)!==1&&this.u.error(q);return}if(X?.children)try{await Promise.allSettled(X.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(k){(0,F.$jk)(k)!==1&&this.u.error(k)}}}))}catch{}}};e.$Ap=G,e.$Ap=G=ye([Z(1,F.$6j),Z(2,r.$op),Z(3,t.$kp),Z(4,J.$Ck),Z(5,z.$5i)],G);class V extends c.$ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$qf)(this.options.operation)?this.l:this.options.operation}constructor(X,q,k,R,U,M,K,Y,se){super(),this.identifier=X,this.source=q,this.options=k,this.m=R,this.n=U,this.o=M,this.p=K,this.q=Y,this.s=se,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(X){const[q,k]=await this.x(X);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,k]],this.j),q}async u({zipPath:X,key:q,metadata:k},R,U){let M=await this.v(q);return M||(this.s.trace("Extracting extension...",q.id),M=await this.m.extractUserExtension(q,X,k,R,U),this.s.info("Extracting extension completed.",q.id)),M}async v(X){return await this.w(X)?(this.s.trace("Removing the extension from uninstalled list:",X.id),await this.m.setInstalled(X),this.s.info("Removed the extension from uninstalled list:",X.id),(await this.m.scanAllUserExtensions(!0)).find(R=>s.$qo.create(R).equals(X))):void 0}async w(X){return!!(await this.m.getUninstalledExtensions())[X.toString()]}}class W extends V{constructor(X,q,k,R,U,M,K,Y,se,le){super(q.identifier,q,k,U,M,K,Y,se,le),this.y=q,this.z=R}async x(X){const k=(await this.m.scanExtensions(null,this.options.profileLocation)).find(K=>(0,s.$po)(K.identifier,this.y.identifier));k&&(this.l=3);const R={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$pf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.y.version)return[await this.m.updateMetadata(k,R),R];const{location:U,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(U.fsPath),[await this.u({zipPath:U.fsPath,key:s.$qo.create(this.y),metadata:R},!1,X),R]}catch(K){try{await this.z.delete(U)}catch(Y){this.s.warn("Error while deleting the downloaded file",U.toString(),(0,D.$8)(Y))}throw K}}async B(X){try{await(0,b.$vp)(X)}catch(q){throw new n.$1n((0,c.$gp)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Bp=W;class ee extends V{constructor(X,q,k,R,U,M,K,Y,se,le){super({id:(0,s.$uo)(X.publisher,X.name)},q,k,U,M,K,Y,se,le),this.y=X,this.z=q,this.A=R}async h(X){const q=await super.h(X);return this.D(q,X),q}async x(X){const q=new s.$qo(this.identifier,this.y.version),R=(await this.m.scanExtensions(1,this.options.profileLocation)).find(K=>(0,s.$po)(this.identifier,K.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(R)if(this.l=3,q.equals(new s.$qo(R.identifier,R.manifest.version)))try{await this.m.removeExtension(R,"existing")}catch{throw new Error(y.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&f.gt(R.manifest.version,this.y.version)&&await this.m.setUninstalled(R);else{const K=await this.v(q);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(y.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$0d(this.z.fsPath),key:q,metadata:U},!0,X),U]}async D(X,q){try{let[k]=await this.A.getExtensions([{id:X.identifier.id,version:X.manifest.version}],q);if(k||([k]=await this.A.getExtensions([{id:X.identifier.id}],q)),k){const R={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(X,R,this.options.profileLocation)}}catch{}}}class ne extends c.$ip{constructor(X,q,k){super(),this.extension=X,this.j=q,this.k=k}async h(X){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,80,222,122,7,20]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=void 0;let m=class extends O.$kc{constructor(E,g,l,f,w,d){super(),E.cleanUp(),(0,L.$4Ub)(E,g,l,f,d),A.$Uz.removeOutdatedExtensionVersions(E,w)}};e.$07b=m,e.$07b=m=ye([Z(0,D.$yp),Z(1,N.$Zn),Z(2,A.$Tz),Z(3,N.$5n),Z(4,S.$Vo),Z(5,I.$5i)],m)}),define(oe[123],ae([0,1,69,61,36,275,14,8,3,2,16,6,32,43,65]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class w{traceSocketEvent(u,p){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=j=>{this.traceSocketEvent("read",j),u(D.$Fd.wrap(j))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=j=>{u({type:0,hadError:j,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,I.$Y)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,I.$Y)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$qh=w;var d;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var h;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(h||(h={}));class o extends m.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,j,F){super(),this.f=this.B(new S.$fd),this.g=this.B(new S.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:j?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new $(this,p,j,F,this.f,(T,z)=>this.m(T,z))),this.B(this.a.onError(T=>{console.error(T),(0,I.$Y)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new f.$lh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength))),p+=262144}m(u,p){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let j=2;u.byteLength<126?j+=0:u.byteLength<2**16?j+=2:j+=8;const F=D.$Fd.alloc(j);if(p?F.writeUInt8(194,0):F.writeUInt8(130,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let T=1;F.writeUInt8(u.byteLength>>>8&255,++T),F.writeUInt8(u.byteLength>>>0&255,++T)}else{F.writeUInt8(127,1);let T=1;F.writeUInt8(0,++T),F.writeUInt8(0,++T),F.writeUInt8(0,++T),F.writeUInt8(0,++T),F.writeUInt8(u.byteLength>>>24&255,++T),F.writeUInt8(u.byteLength>>>16&255,++T),F.writeUInt8(u.byteLength>>>8&255,++T),F.writeUInt8(u.byteLength>>>0&255,++T)}this.socket.write(D.$Fd.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),j=p.readUInt8(0),F=(j&128)>>>7,T=(j&64)>>>6,z=p.readUInt8(1),B=(z&128)>>>7,_=z&127;this.j.state=2,this.j.readLen=2+(B?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),j=p.readUInt8(1),F=(j&128)>>>7;let T=j&127,z=1;T===126?T=p.readUInt8(++z)*2**8+p.readUInt8(++z):T===127&&(T=p.readUInt8(++z)*0+p.readUInt8(++z)*0+p.readUInt8(++z)*0+p.readUInt8(++z)*0+p.readUInt8(++z)*2**24+p.readUInt8(++z)*2**16+p.readUInt8(++z)*2**8+p.readUInt8(++z));let B=0;F&&(B=p.readUInt8(++z)*2**24+p.readUInt8(++z)*2**16+p.readUInt8(++z)*2**8+p.readUInt8(++z)),this.j.state=3,this.j.readLen=T,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),i(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(p,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=o;class $ extends m.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Fd.alloc(0)}constructor(u,p,j,F,T,z){super(),this.n=u,this.r=T,this.s=z,this.a=this.B(new S.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new y(this.n,F,j,{windowBits:15})),this.f=this.B(new C(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(u){this.g.push(u),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const u=this.g.shift();if(this.f){const p=await this.w(this.f,u);this.s(p,!0)}else this.s(u,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((j,F)=>{u.write(p),u.flush(T=>j(T))})}acceptFrame(u,p,j){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,j){return new Promise((F,T)=>{u.write(p),j&&u.write(D.$Fd.fromByteArray([0,0,255,255])),u.flush(z=>F(z))})}}class y extends m.$kc{get recordedInflateBytes(){return this.j?D.$Fd.concat(this.f):D.$Fd.alloc(0)}constructor(u,p,j,F){super(),this.h=u,this.j=p,this.a=this.B(new S.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(F),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(D.$Fd.wrap(T))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=D.$Fd.concat(this.g);this.g.length=0,u(p)})}}class C extends m.$kc{constructor(u,p){super(),this.g=u,this.a=this.B(new S.$fd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$Fd.wrap(j))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=D.$Fd.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function i(b,u){if(u===0)return;const p=b.byteLength>>>2;for(let _=0;_<p;_++){const J=b.readUInt32BE(_*4);b.writeUInt32BE(J^u,_*4)}const j=p*4,F=b.byteLength-j,T=u>>>24&255,z=u>>>16&255,B=u>>>8&255;F>=1&&b.writeUInt8(b.readUInt8(j)^T,j),F>=2&&b.writeUInt8(b.readUInt8(j+1)^z,j+1),F>=3&&b.writeUInt8(b.readUInt8(j+2)^B,j+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function n(){const b=(0,g.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const u=process.platform!=="darwin"&&e.$sh?e.$sh:(0,A.tmpdir)(),p=(0,P.$9d)(u,`vscode-ipc-${b}.sock`);return t(p),p}e.$th=n;function s(b,u,p){const j=(0,O.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${p}-${u}-sock`;const F=p.substr(0,4),T=u.substr(0,6),z=j.substr(0,8);let B;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?B=(0,P.$9d)(e.$sh,`vscode-${z}-${F}-${T}.sock`):B=(0,P.$9d)(b,`${F}-${T}.sock`),t(B),B}e.$uh=s;function t(b){const u=c[E.$t];typeof u=="number"&&b.length>=u&&console.warn(`WARNING: IPC handle "${b}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends l.$fh{static b(u){const p=S.Event.fromNodeEventEmitter(u,"connection");return S.Event.map(p,j=>({protocol:new f.$mh(new w(j,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(j,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=r;function a(b){return new Promise((u,p)=>{const j=(0,N.createServer)();j.on("error",p),j.listen(b,()=>{j.removeListener("error",p),u(new r(j))})})}e.$wh=a;function v(b,u){return new Promise((p,j)=>{const F=(0,N.createConnection)(b,()=>{F.removeListener("error",j),p(f.$nh.fromSocket(new w(F,`ipc-client${u}`),u))});F.once("error",j)})}e.$xh=v}),define(oe[266],ae([0,1,61,123,210]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=void 0,e.$g8b=new class{supports(L){return!0}connect({host:L,port:D},I,S,m){return new Promise((P,E)=>{const g=O.createConnection({host:L,port:D},()=>{g.removeListener("error",E),g.write((0,A.$xkb)(I,S,m));const l=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",l),P(new N.$qh(g,m)))};g.on("data",l)});g.setNoDelay(!0),g.once("error",E)})}}}),define(oe[267],ae([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,14]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=e.$a7b=e.$_6b=void 0;async function h(i,c,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new o(i,c,n,s,t).waitForReady(),!(t&&A.$7f[t]||!A.$7f[r.tunnelLocalPort]));a--);return r}class o extends I.$kc{constructor(c,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=O.createServer(),this.c=new D.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,n=(0,w.$4z)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,A.$8f)(c,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(c){c.pause();const n=(0,w.$2z)(this.tunnelRemoteHost)||(0,w.$4z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,g.$Zk)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),t.end()}),c.on("close",()=>t.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),t instanceof L.$qh?t.socket.destroy():t.end()}),t instanceof L.$qh?this.t(c,t):this.s(c,t),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),t.end()})}s(c,n){n.onClose(()=>c.destroy()),n.onEnd(()=>c.end()),n.onData(s=>c.write(s.buffer)),c.on("data",s=>n.write(d.$Fd.wrap(s))),c.resume()}t(c,n){const s=n.socket;s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),s.pipe(c),c.pipe(s)}}e.$_6b=o;let $=class extends w.$7z{constructor(c,n,s,t,r){super(n,r),this.u=c,this.v=s,this.w=t}isPortPrivileged(c){return(0,w.$5z)(c,this.l,S.OS,N.release())}s(c,n,s,t,r,a,v,b){const u=this.r(n,s);if(u)return++u.refcount,u.value;if((0,w.$Yz)(c))return this.t(c,n,s,r,a,v,b);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const p={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=h(p,t,n,s,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,s,j),j}}};e.$a7b=$,e.$a7b=$=ye([Z(0,l.$Tk),Z(1,P.$5i),Z(2,f.$Wk),Z(3,E.$kj),Z(4,m.$8h)],$);let y=class extends ${constructor(c,n,s,t,r){super(c,n,s,t,r)}};e.$b7b=y,e.$b7b=y=ye([Z(0,l.$Tk),Z(1,P.$5i),Z(2,f.$Wk),Z(3,E.$kj),Z(4,m.$8h)],y);let C=class extends I.$kc{constructor(c,n,s,t,r){super(),this.b=c,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(c,n,s,t,r,a,v,b,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(c)){const p=new y(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(c,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(n,s,t,r,a,v,b,u)}};e.$c7b=C,e.$c7b=C=ye([Z(0,l.$Tk),Z(1,P.$5i),Z(2,E.$kj),Z(3,f.$Wk),Z(4,m.$8h)],C)}),define(oe[276],ae([0,1,36,38,8,2,23,11,18,3,43,147,204,205,196,197,262,187,189,19,209,95,220,96,215,15,114,247,29,97,188,122,98,12,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,22,108,109,110,46,228,80,111,25,78,254,238,239,81,253,257,258,259,58,252,241,106,219,76,267,214,229,28,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,10,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,O,N,A,L,D,I,S,m,P,E,g,l,f,w,d,h,o,$,y,C,i,c,n,s,t,r,a,v,b,u,p,j,F,T,z,B,_,J,Q,H,x,G,V,W,ee,ne,re,X,q,k,R,U,M,K,Y,se,le,ue,he,$e,de,we,ve,Ie,Le,Te,ce,ge,be,Se,Pe,ze,De,Ue,Me,ie,fe,me,pe,ke,Re,Ce,Oe,je,Ae,Ne,qe,Be,Ve,xe,ut,vt,Et,kt,St,ft,Ct,Pt,Rt,It,Ot,Dt,jt,dt,At,gt,Lt,Nt,$t,Ft,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Mt extends L.$kc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new E.$6S(this)),this.b=void 0,this.c=this.B(new m.$fd),this.g()}g(){let Ee=!1;const Fe=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,E.$7S)(process.parentPort,tt.$q6b.exit,Fe)}async init(){const Ee=await this.h();(0,se.$xgb)(),Ee.invokeFunction(Fe=>{const Ke=Fe.get(x.$5i);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Fe),this.m(Ke)}),this.B((0,L.$hc)(Ee.createInstance(g.$F7b,this.f.codeCachePath),Ee.createInstance(l.$G7b),Ee.createInstance(d.$J7b),Ee.createInstance(w.$I7b),Ee.createInstance(f.$H7b),Ee.createInstance(Et.$07b),Ee.createInstance(xe.$27b),Ee.createInstance(Ft.$j8b,this.c.event)))}async h(){const Ee=new J.$zh,Fe={_serviceBrand:void 0,...V.default};Ee.set(W.$kj,Fe);const Ke=new P.$jh(We=>We==="main"),He=new dt.$j7b(this.a,Ke);Ee.set(dt.$i7b,He);const nt=this.f.policiesData?new Ne.$U6b(this.f.policiesData,He.getChannel("policy")):new qe.$_m;Ee.set(qe.$0m,nt);const Ge=new Nt.$_l(this.f.args,Fe);Ee.set(s.$Jh,Ge);const Qe=new G.$1q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(We=>({...We,resource:I.URI.revive(We.resource)})),He.getChannel("logger"));Ee.set(x.$6i,Qe);const st=this.B(Qe.createLogger("sharedprocess",{name:(0,kt.localize)(0,null)})),ct=this.B(new x.$aj(st.getLevel())),Je=this.B(new St.$mN(st,[ct]));Ee.set(x.$5i,Je),this.b=this.B(new ft.$_7b(Je)),Ee.set(ft.$$7b,this.b);const Ye=this.B(new F.$Dp(Je));Ee.set(j.$6j,Ye);const lt=this.B(new T.$3p(Je));Ye.registerProvider(D.Schemas.file,lt);const rt=new ie.$pr(Ye);Ee.set(Me.$Ck,rt);const Xe=this.B(new Be.$tN(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Ee.set(je.$Ek,Xe);const ht=this.B(new me.$h7b(D.Schemas.file,this.B(new pe.$8M(He.getChannel(pe.$7M),{pathCaseSensitive:fe.$k})),D.Schemas.vscodeUserData,Xe,rt,Je));Ye.registerProvider(D.Schemas.vscodeUserData,ht);const Ze=this.B(new y.$zn(Xe.defaultProfile.settingsResource,Ye,nt,Je));Ee.set($.$8h,Ze);const _e=new At.$f8b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},He,Ge);Ee.set(ne.$Vo,_e),this.B((0,L.$ic)(()=>_e.flush())),await Promise.all([Ze.initialize(),_e.initialize()]);const bt=new Rt.$Mq(He.getChannel("request"));Ee.set(ee.$Io,bt),Ee.set(h.$K7b,new z.$yh(o.$L7b,void 0,!1)),Ee.set(Re.$CF,new z.$yh(ke.$17b,void 0,!1));const wt=P.ProxyChannel.toService(He.getChannel("nativeHost"));Ee.set(Ot.$45b,wt),Ee.set(c.$Dn,new z.$yh(n.$BN,void 0,!0));const Tt=this.B(new ge.$R6b(wt)),zt=new P.$jh(We=>Tt.getActiveClientId().then(at=>We===at));Ee.set(p.$NUb,new It.$b8b(this.a.getChannel("extensionRecommendationNotification",zt)));let ot;const et=[],yt=(0,U.$mo)(Fe,Ze);if((0,U.$ho)(Fe,Ge)){const We=new k.$Y3b(Je,Qe,Ge,Fe);if(et.push(We),Fe.aiConfig?.ariaKey){const at=new Ve.$aN(bt,yt,"monacoworkbench",null,Fe.aiConfig.ariaKey);this.B((0,L.$ic)(()=>at.flush())),et.push(at)}ot=new R.$Qq({appenders:et,commonProperties:(0,re.$0n)((0,O.release)(),(0,O.hostname)(),process.arch,Fe.commit,Fe.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,U.$no)(Ge)},Ze,Fe)}else{ot=U.$bo;const We=U.$fo;et.push(We)}this.a.registerChannel("telemetryAppender",new q.$v6b(et)),Ee.set(X.$9k,ot);const Ut=new M.$M7b(Ze,ot,Je,Qe,Ge,Fe);Ee.set(X.$0k,Ut),Ee.set(Ae.$kp,new z.$yh(Pt.$lN,void 0,!0)),Ee.set(Ce.$op,new z.$yh(Oe.$V6b,void 0,!0)),Ee.set(v.$7o,new z.$yh(v.$8o,void 0,!0)),Ee.set(u.$yp,new z.$yh(u.$zp,void 0,!0)),Ee.set(a.$Zn,new z.$yh(r.$5o,void 0,!0)),Ee.set(a.$6n,new z.$yh(jt.$e8b,void 0,!1)),Ee.set(Q.$Iq,new z.$yh(H.$Kq,void 0,!1)),Ee.set(C.$gm,new z.$yh(i.$wr,void 0,!1)),Ee.set(le.$Czb,new z.$yh(le.$Dzb,void 0,!0)),Ee.set(se.$Sgb,new z.$yh($e.$PBb,void 0,!0)),Ee.set(se.$Rgb,new he.$P7b(this.a.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),Ee.set(a.$5n,new z.$yh(t.$Azb,void 0,!1)),Ee.set(Y.$NBb,new z.$yh(Y.$OBb,void 0,!0)),Ee.set(K.$Tz,new z.$yh(K.$Uz)),Ee.set(se.$Cgb,new z.$yh(Le.$YAb,void 0,!0)),Ee.set(se.$Dgb,new z.$yh(Le.$1Ab,void 0,!0)),Ee.set(de.$qgb,new z.$yh(de.$sgb,void 0,!0)),Ee.set(se.$Egb,new z.$yh(ue.$A4b,void 0,!1)),Ee.set(se.$Ngb,new z.$yh(we.$p4b,void 0,!0)),Ee.set(se.$Ogb,new z.$yh(ve.$F4b,void 0,!1)),Ee.set(Te.$cAb,new z.$yh(ce.$W7b,void 0,!0)),Ee.set(se.$Pgb,new z.$yh(vt.$f5b,void 0,!0)),Ee.set(be.$Wk,new z.$yh(Se.$e7b,void 0,!1));const pt=new gt.$Uk;return Ee.set(gt.$Tk,pt),pt.register(0,Lt.$g8b),Ee.set(Pe.$Xz,new z.$yh(ze.$c7b)),Ee.set(De.$X7b,new z.$yh(Ue.$Z7b)),Ee.set(ut.$37b,new z.$yh(Ct.$a8b)),Ee.set($t.$h8b,new z.$yh($t.$i8b)),new _.$6p(Ee)}j(Ee){const Fe=this.B(new L.$jc),Ke=new b.$0o(Ee.get(a.$2n),()=>null);this.a.registerChannel("extensions",Ke);const He=P.ProxyChannel.fromService(Ee.get(Q.$Iq),Fe);this.a.registerChannel("languagePacks",He);const nt=P.ProxyChannel.fromService(Ee.get(C.$gm),Fe);this.a.registerChannel("diagnostics",nt);const Ge=new b.$_o(Ee.get(a.$6n));this.a.registerChannel("extensionTipsService",Ge);const Qe=P.ProxyChannel.fromService(Ee.get(h.$K7b),Fe);this.a.registerChannel("checksum",Qe);const st=P.ProxyChannel.fromService(Ee.get(Re.$CF),Fe);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$Q7b(Ee.get(de.$qgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(Ee.get(X.$0k),Fe);this.a.registerChannel("customEndpointTelemetry",Je);const Ye=new he.$R7b(Ee.get(le.$Czb));this.a.registerChannel("userDataSyncAccount",Ye);const lt=new he.$S7b(Ee.get(se.$Cgb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$U7b(Ee.get(se.$Ogb),Ee.get(je.$Ek),Ee.get(x.$5i));this.a.registerChannel("userDataSync",rt);const Xe=this.B(Ee.get(B.$Ah).createInstance(Dt.$d8b)),ht=new he.$N7b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Ee.get(se.$Pgb),Fe));const Ze=P.ProxyChannel.fromService(Ee.get(De.$X7b),Fe);this.a.registerChannel(De.$Y7b,Ze);const _e=P.ProxyChannel.fromService(Ee.get(ut.$37b),Fe);this.a.registerChannel("remoteTunnel",_e)}m(Ee){process.on("uncaughtException",Fe=>(0,A.$Y)(Fe)),process.on("unhandledRejection",Fe=>(0,A.$Y)(Fe)),(0,A.setUnexpectedErrorHandler)(Fe=>{const Ke=(0,N.$mi)(Fe,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}handledClientConnection(Ee){if(Ee.data!==tt.$s6b.response)return!1;const Fe=(0,S.$Mb)(Ee.ports);return Fe?(this.c.fire(Fe),!0):!1}}async function mt(it){const Ee=new Mt(it);process.parentPort.postMessage(tt.$q6b.ipcReady),await Ee.init(),process.parentPort.postMessage(tt.$q6b.initDone)}e.main=mt,process.parentPort.once("message",it=>{mt(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10765021158cf51eaf6785361598e1668f53e06e/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
