/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],v=0,F=be.length;v<F;v++)e[v]=Ae[be[v]];return e};define(Ae[65],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function v(A){return(l,S,g)=>{let P=null,D=null;if(typeof g.value=="function"?(P="value",D=g.value):typeof g.get=="function"&&(P="get",D=g.get),!D)throw new Error("not supported");g[P]=A(D,S)}}function F(A,l,S){let g=null,P=null;if(typeof S.value=="function"?(g="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(g="get",P=S.get),!P)throw new Error("not supported");const D=`$memoize$${l}`;S[g]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[D]}}e.$6g=F;function C(A,l,S){return v((g,P)=>{const D=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...b){this[u]||(this[u]=S?S():void 0),clearTimeout(this[D]),l&&(this[u]=l(this[u],...b),b=[this[u]]),this[D]=setTimeout(()=>{g.apply(this,b),this[u]=S?S():void 0},A)}})}e.$7g=C;function T(A,l,S){return v((g,P)=>{const D=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...d){if(this[u]||(this[u]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),l&&(this[u]=l(this[u],...d)),this[$])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[u]]),this[u]=S?S():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[b]=Date.now(),g.apply(this,[this[u]]),this[u]=S?S():void 0},t-Date.now()))}})}e.$8g=T}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0;class v{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$7L=v,e.$8L=new v("id#")}),define(Ae[116],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var F;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(r,a=!1){let n=0;const c=r.length;let E="",p=0,I=16,k=0;function s(B){let O=0,N=0;for(;O<B;){const ee=r.charCodeAt(n);if(ee>=48&&ee<=57)N=N*16+ee-48;else if(ee>=65&&ee<=70)N=N*16+ee-65+10;else if(ee>=97&&ee<=102)N=N*16+ee-97+10;else break;n++,O++}return O<B&&(N=-1),N}function f(B){n=B,E="",p=0,I=16,k=0}function w(){const B=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&g(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&g(r.charCodeAt(n)))for(n++;n<r.length&&g(r.charCodeAt(n));)n++;else return k=3,r.substring(B,n);let O=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&g(r.charCodeAt(n))){for(n++;n<r.length&&g(r.charCodeAt(n));)n++;O=n}else k=3;return r.substring(B,O)}function R(){let B="",O=n;for(;;){if(n>=c){B+=r.substring(O,n),k=2;break}const N=r.charCodeAt(n);if(N===34){B+=r.substring(O,n),n++;break}if(N===92){if(B+=r.substring(O,n),n++,n>=c){k=2;break}switch(r.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const Y=s(4);Y>=0?B+=String.fromCharCode(Y):k=4;break}default:k=5}O=n;continue}if(N>=0&&N<=31)if(S(N)){B+=r.substring(O,n),k=2;break}else k=6;n++}return B}function W(){if(E="",k=0,p=n,n>=c)return p=c,I=17;let B=r.charCodeAt(n);if(l(B)){do n++,E+=String.fromCharCode(B),B=r.charCodeAt(n);while(l(B));return I=15}if(S(B))return n++,E+=String.fromCharCode(B),B===13&&r.charCodeAt(n)===10&&(n++,E+=`
`),I=14;switch(B){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,E=R(),I=10;case 47:{const O=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<c&&!S(r.charCodeAt(n));)n++;return E=r.substring(O,n),I=12}if(r.charCodeAt(n+1)===42){n+=2;const N=c-1;let ee=!1;for(;n<N;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,ee=!0;break}n++}return ee||(n++,k=1),E=r.substring(O,n),I=13}return E+=String.fromCharCode(B),n++,I=16}case 45:if(E+=String.fromCharCode(B),n++,n===c||!g(r.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=w(),I=11;default:for(;n<c&&V(B);)n++,B=r.charCodeAt(n);if(p!==n){switch(E=r.substring(p,n),E){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return E+=String.fromCharCode(B),n++,I=16}}function V(B){if(l(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=W();while(B>=12&&B<=15);return B}return{setPosition:f,getPosition:()=>n,scan:a?U:W,getToken:()=>I,getTokenValue:()=>E,getTokenOffset:()=>p,getTokenLength:()=>n-p,getTokenError:()=>k}}e.$Jm=A;function l(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function D(r,a){const n=[],c=new Object;let E;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(s,f,w,R){p.value=s,p.offset=f,p.length=w,p.type=R,p.colonOffset=void 0,E=p}try{h(r,{onObjectBegin:(s,f)=>{if(a<=s)throw c;E=void 0,I=a>s,n.push("")},onObjectProperty:(s,f,w)=>{if(a<f||(k(s,f,w,"property"),n[n.length-1]=s,a<=f+w))throw c},onObjectEnd:(s,f)=>{if(a<=s)throw c;E=void 0,n.pop()},onArrayBegin:(s,f)=>{if(a<=s)throw c;E=void 0,n.push(0)},onArrayEnd:(s,f)=>{if(a<=s)throw c;E=void 0,n.pop()},onLiteralValue:(s,f,w)=>{if(a<f||(k(s,f,w,m(s)),a<=f+w))throw c},onSeparator:(s,f,w)=>{if(a<=f)throw c;if(s===":"&&E&&E.type==="property")E.colonOffset=f,I=!1,E=void 0;else if(s===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(I=!0,n[n.length-1]=""),E=void 0}}})}catch(s){if(s!==c)throw s}return{path:n,previousNode:E,isAtPropertyKey:I,matches:s=>{let f=0;for(let w=0;f<s.length&&w<n.length;w++)if(s[f]===n[w]||s[f]==="*")f++;else if(s[f]!=="**")return!1;return f===s.length}}}e.$Km=D;function u(r,a=[],n=T.DEFAULT){let c=null,E=[];const p=[];function I(s){Array.isArray(E)?E.push(s):c!==null&&(E[c]=s)}return h(r,{onObjectBegin:()=>{const s={};I(s),p.push(E),E=s,c=null},onObjectProperty:s=>{c=s},onObjectEnd:()=>{E=p.pop()},onArrayBegin:()=>{const s=[];I(s),p.push(E),E=s,c=null},onArrayEnd:()=>{E=p.pop()},onLiteralValue:I,onError:(s,f,w)=>{a.push({error:s,offset:f,length:w})}},n),E[0]}e.$Lm=u;function b(r,a=[],n=T.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(s){c.type==="property"&&(c.length=s-c.offset,c=c.parent)}function p(s){return c.children.push(s),s}h(r,{onObjectBegin:s=>{c=p({type:"object",offset:s,length:-1,parent:c,children:[]})},onObjectProperty:(s,f,w)=>{c=p({type:"property",offset:f,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:s,offset:f,length:w,parent:c})},onObjectEnd:(s,f)=>{c.length=s+f-c.offset,c=c.parent,E(s+f)},onArrayBegin:(s,f)=>{c=p({type:"array",offset:s,length:-1,parent:c,children:[]})},onArrayEnd:(s,f)=>{c.length=s+f-c.offset,c=c.parent,E(s+f)},onLiteralValue:(s,f,w)=>{p({type:m(s),offset:f,length:w,parent:c,value:s}),E(f+w)},onSeparator:(s,f,w)=>{c.type==="property"&&(s===":"?c.colonOffset=f:s===","&&E(f))},onError:(s,f,w)=>{a.push({error:s,offset:f,length:w})}},n);const k=c.children[0];return k&&delete k.parent,k}e.$Mm=b;function $(r,a){if(!r)return;let n=r;for(const c of a)if(typeof c=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let E=!1;for(const p of n.children)if(Array.isArray(p.children)&&p.children[0].value===c){n=p.children[1],E=!0;break}if(!E)return}else{const E=c;if(n.type!=="array"||E<0||!Array.isArray(n.children)||E>=n.children.length)return;n=n.children[E]}return n}e.$Nm=$;function d(r){if(!r.parent||!r.parent.children)return[];const a=d(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;a.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&a.push(n)}return a}e.$Om=d;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const a=Object.create(null);for(const n of r.children){const c=n.children[1];c&&(a[n.children[0].value]=t(c))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Pm=t;function i(r,a,n=!1){return a>=r.offset&&a<r.offset+r.length||n&&a===r.offset+r.length}e.$Qm=i;function o(r,a,n=!1){if(i(r,a,n)){const c=r.children;if(Array.isArray(c))for(let E=0;E<c.length&&c[E].offset<=a;E++){const p=o(c[E],a,n);if(p)return p}return r}}e.$Rm=o;function h(r,a,n=T.DEFAULT){const c=A(r,!1);function E(ye){return ye?()=>ye(c.getTokenOffset(),c.getTokenLength()):()=>!0}function p(ye){return ye?ce=>ye(ce,c.getTokenOffset(),c.getTokenLength()):()=>!0}const I=E(a.onObjectBegin),k=p(a.onObjectProperty),s=E(a.onObjectEnd),f=E(a.onArrayBegin),w=E(a.onArrayEnd),R=p(a.onLiteralValue),W=p(a.onSeparator),V=E(a.onComment),U=p(a.onError),B=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const ye=c.scan();switch(c.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:B||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(ye){case 12:case 13:B?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return ye}}}function ee(ye,ce=[],$e=[]){if(U(ye),ce.length+$e.length>0){let ie=c.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function Y(ye){const ce=c.getTokenValue();return ye?R(ce):k(ce),N(),!0}function Ee(){switch(c.getToken()){case 11:{let ye=0;try{ye=JSON.parse(c.getTokenValue()),typeof ye!="number"&&(ee(2),ye=0)}catch{ee(2)}R(ye);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return N(),!0}function ke(){return c.getToken()!==10?(ee(3,[],[2,5]),!1):(Y(!1),c.getToken()===6?(W(":"),N(),ue()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){I(),N();let ye=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ye||ee(4,[],[]),W(","),N(),c.getToken()===2&&O)break}else ye&&ee(6,[],[]);ke()||ee(4,[],[2,5]),ye=!0}return s(),c.getToken()!==2?ee(7,[2],[]):N(),!0}function X(){f(),N();let ye=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ye||ee(4,[],[]),W(","),N(),c.getToken()===4&&O)break}else ye&&ee(6,[],[]);ue()||ee(4,[],[4,5]),ye=!0}return w(),c.getToken()!==4?ee(8,[4],[]):N(),!0}function ue(){switch(c.getToken()){case 3:return X();case 1:return Pe();case 10:return Y(!0);default:return Ee()}}return N(),c.getToken()===17?n.allowEmptyContent?!0:(ee(4,[],[]),!1):ue()?(c.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Sm=h;function y(r,a){const n=A(r),c=[];let E,p=0,I;do switch(I=n.getPosition(),E=n.scan(),E){case 12:case 13:case 17:p!==I&&c.push(r.substring(p,I)),a!==void 0&&c.push(n.getTokenValue().replace(/[^\r\n]/g,a)),p=n.getPosition();break}while(E!==17);return c.join("")}e.$Tm=y;function m(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=m}),define(Ae[28],Re([1,0]),function(be,e){"use strict";var v,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function T(i,o,h){let y=i.get(o);return y===void 0&&(y=h,i.set(o,y)),y}e.$wi=T;function A(i){const o=[];return i.forEach((h,y)=>{o.push(`${y} => ${h}`)}),`Map(${i.size}) {${o.join(", ")}}`}e.$xi=A;function l(i){const o=[];return i.forEach(h=>{o.push(h)}),`Set(${i.size}) {${o.join(", ")}}`}e.$yi=l;class S{constructor(o,h){this.uri=o,this.value=h}}function g(i){return Array.isArray(i)}class P{static{this.a=o=>o.toString()}constructor(o,h){if(this[v]="ResourceMap",o instanceof P)this.b=new Map(o.b),this.c=h??P.a;else if(g(o)){this.b=new Map,this.c=h??P.a;for(const[y,m]of o)this.set(y,m)}else this.b=new Map,this.c=o??P.a}set(o,h){return this.b.set(this.c(o),new S(o,h)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,h){typeof h<"u"&&(o=o.bind(h));for(const[y,m]of this.b)o(m.value,m.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$zi=P;class D{constructor(o,h){this[F]="ResourceSet",!o||typeof o=="function"?this.a=new P(o):(this.a=new P(h),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,h){this.a.forEach((y,m)=>o.call(h,m,m,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=D;var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class b{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,h=0){const y=this.a.get(o);if(y)return h!==0&&this.j(y,h),y.value}set(o,h,y=0){let m=this.a.get(o);if(m)m.value=h,y!==0&&this.j(m,y);else{switch(m={key:o,value:h,next:void 0,previous:void 0},y){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(o,m),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const h=this.a.get(o);if(h)return this.a.delete(o),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,h){const y=this.e;let m=this.b;for(;m;){if(h?o.bind(h)(m.value,m.key,this):o(m.value,m.key,this),this.e!==y)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const o=this,h=this.e;let y=this.b;const m={[Symbol.iterator](){return m},next(){if(o.e!==h)throw new Error("LinkedMap got modified during iteration.");if(y){const r={value:y.key,done:!1};return y=y.next,r}else return{value:void 0,done:!0}}};return m}values(){const o=this,h=this.e;let y=this.b;const m={[Symbol.iterator](){return m},next(){if(o.e!==h)throw new Error("LinkedMap got modified during iteration.");if(y){const r={value:y.value,done:!1};return y=y.next,r}else return{value:void 0,done:!0}}};return m}entries(){const o=this,h=this.e;let y=this.b;const m={[Symbol.iterator](){return m},next(){if(o.e!==h)throw new Error("LinkedMap got modified during iteration.");if(y){const r={value:[y.key,y.value],done:!1};return y=y.next,r}else return{value:void 0,done:!0}}};return m}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let h=this.b,y=this.size;for(;h&&y>o;)this.a.delete(h.key),h=h.next,y--;this.b=h,this.d=y,h&&(h.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const h=o.next,y=o.previous;if(!h||!y)throw new Error("Invalid list");h.previous=y,y.next=h}o.next=void 0,o.previous=void 0,this.e++}j(o,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(o===this.b)return;const y=o.next,m=o.previous;o===this.c?(m.next=void 0,this.c=m):(y.previous=m,m.next=y),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(h===2){if(o===this.c)return;const y=o.next,m=o.previous;o===this.b?(y.previous=void 0,this.b=y):(y.previous=m,m.next=y),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((h,y)=>{o.push([y,h])}),o}fromJSON(o){this.clear();for(const[h,y]of o)this.set(h,y)}}e.$Bi=b;class $ extends b{constructor(o,h=1){super(),this.k=o,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,h=2){return super.get(o,h)}peek(o){return super.get(o,0)}set(o,h){return super.set(o,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=$;class d{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let h=this.a.get(o)||0;return h===0?!1:(h--,h===0?this.a.delete(o):this.a.set(o,h),!0)}has(o){return this.a.has(o)}}e.$Di=d;class t{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[h,y]of o)this.set(h,y)}clear(){this.a.clear(),this.b.clear()}set(o,h){this.a.set(o,h),this.b.set(h,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const h=this.a.get(o);return h===void 0?!1:(this.a.delete(o),this.b.delete(h),!0)}forEach(o,h){this.a.forEach((y,m)=>{o.call(h,y,m,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=t}),function(be,e){typeof define=="function"&&define.amd?define(Ae[117],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,ge){for(var De=0;De<ge.length;De++){var ne=ge[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ve,ne.key,ne)}}function v(ve,ge,De){return ge&&e(ve.prototype,ge),De&&e(ve,De),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function F(ve,ge){if(ve){if(typeof ve=="string")return C(ve,ge);var De=Object.prototype.toString.call(ve).slice(8,-1);if(De==="Object"&&ve.constructor&&(De=ve.constructor.name),De==="Map"||De==="Set")return Array.from(ve);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ve,ge)}}function C(ve,ge){(ge==null||ge>ve.length)&&(ge=ve.length);for(var De=0,ne=new Array(ge);De<ge;De++)ne[De]=ve[De];return ne}function T(ve,ge){var De=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(De)return(De=De.call(ve)).next.bind(De);if(Array.isArray(ve)||(De=F(ve))||ge&&ve&&typeof ve.length=="number"){De&&(ve=De);var ne=0;return function(){return ne>=ve.length?{done:!0}:{done:!1,value:ve[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function l(ve){be.defaults=ve}var S=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ge){return u[ge]};function $(ve,ge){if(ge){if(S.test(ve))return ve.replace(g,b)}else if(P.test(ve))return ve.replace(D,b);return ve}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(d,function(ge,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function o(ve,ge){ve=typeof ve=="string"?ve:ve.source,ge=ge||"";var De={replace:function(he,se){return se=se.source||se,se=se.replace(i,"$1"),ve=ve.replace(he,se),De},getRegex:function(){return new RegExp(ve,ge)}};return De}var h=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(ve,ge,De){if(ve){var ne;try{ne=decodeURIComponent(t(De)).replace(h,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}ge&&!y.test(De)&&(De=E(ge,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var r={},a=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(ve,ge){r[" "+ve]||(a.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=s(ve,"/",!0)),ve=r[" "+ve];var De=ve.indexOf(":")===-1;return ge.substring(0,2)==="//"?De?ge:ve.replace(n,"$1")+ge:ge.charAt(0)==="/"?De?ge:ve.replace(c,"$1")+ge:ve+ge}var p={exec:function(){}};function I(ve){for(var ge=1,De,ne;ge<arguments.length;ge++){De=arguments[ge];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&(ve[ne]=De[ne])}return ve}function k(ve,ge){var De=ve.replace(/\|/g,function(se,oe,fe){for(var Ie=!1,M=oe;--M>=0&&fe[M]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=De.split(/ \|/),he=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>ge)ne.splice(ge);else for(;ne.length<ge;)ne.push("");for(;he<ne.length;he++)ne[he]=ne[he].trim().replace(/\\\|/g,"|");return ne}function s(ve,ge,De){var ne=ve.length;if(ne===0)return"";for(var he=0;he<ne;){var se=ve.charAt(ne-he-1);if(se===ge&&!De)he++;else if(se!==ge&&De)he++;else break}return ve.slice(0,ne-he)}function f(ve,ge){if(ve.indexOf(ge[1])===-1)return-1;for(var De=ve.length,ne=0,he=0;he<De;he++)if(ve[he]==="\\")he++;else if(ve[he]===ge[0])ne++;else if(ve[he]===ge[1]&&(ne--,ne<0))return he;return-1}function w(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,ge){if(ge<1)return"";for(var De="";ge>1;)ge&1&&(De+=ve),ge>>=1,ve+=ve;return De+ve}function W(ve,ge,De,ne){var he=ge.href,se=ge.title?$(ge.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){ne.state.inLink=!0;var fe={type:"link",raw:De,href:he,title:se,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,fe}return{type:"image",raw:De,href:he,title:se,text:$(oe)}}function V(ve,ge){var De=ve.match(/^(\s+)(?:```)/);if(De===null)return ge;var ne=De[1];return ge.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=ne.length?he.slice(ne.length):he}).join(`
`)}var U=function(){function ve(De){this.options=De||be.defaults}var ge=ve.prototype;return ge.space=function(ne){var he=this.rules.block.newline.exec(ne);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ge.code=function(ne){var he=this.rules.block.code.exec(ne);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:s(se,`
`)}}},ge.fences=function(ne){var he=this.rules.block.fences.exec(ne);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},ge.heading=function(ne){var he=this.rules.block.heading.exec(ne);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=s(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},ge.hr=function(ne){var he=this.rules.block.hr.exec(ne);if(he)return{type:"hr",raw:he[0]}},ge.blockquote=function(ne){var he=this.rules.block.blockquote.exec(ne);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},ge.list=function(ne){var he=this.rules.block.list.exec(ne);if(he){var se,oe,fe,Ie,M,K,G,Q,J,x,ae,Oe,je=he[1].trim(),Qe=je.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var et=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Oe=!1,!(!(he=et.exec(ne))||this.rules.block.hr.test(ne)));){if(se=he[0],ne=ne.substring(se.length),Q=he[2].split(`
`,1)[0],J=ne.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(J)&&(se+=J+`
`,ne=ne.substring(J.length+1),Oe=!0),!Oe)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ne&&(x=ne.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||_e.test(ne)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!K)ae+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),se+=x+`
`,ne=ne.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!oe,checked:fe,loose:!1,text:ae}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var ze=He.items.length;for(M=0;M<ze;M++){this.lexer.state.top=!1,He.items[M].tokens=this.lexer.blockTokens(He.items[M].text,[]);var rt=He.items[M].tokens.filter(function(Z){return Z.type==="space"}),_=rt.every(function(Z){for(var pe=Z.raw.split(""),Ue=0,Ne=T(pe),Ze;!(Ze=Ne()).done;){var nt=Ze.value;if(nt===`
`&&(Ue+=1),Ue>1)return!0}return!1});!He.loose&&rt.length&&_&&(He.loose=!0,He.items[M].loose=!0)}return He}},ge.html=function(ne){var he=this.rules.block.html.exec(ne);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},ge.def=function(ne){var he=this.rules.block.def.exec(ne);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},ge.table=function(ne){var he=this.rules.block.table.exec(ne);if(he){var se={type:"table",header:k(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,fe,Ie,M,K;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(se.align[fe])?se.align[fe]="right":/^ *:-+: *$/.test(se.align[fe])?se.align[fe]="center":/^ *:-+ *$/.test(se.align[fe])?se.align[fe]="left":se.align[fe]=null;for(oe=se.rows.length,fe=0;fe<oe;fe++)se.rows[fe]=k(se.rows[fe],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],M=0;M<K.length;M++)K[M].tokens=this.lexer.inline(K[M].text);return se}}},ge.lheading=function(ne){var he=this.rules.block.lheading.exec(ne);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ge.paragraph=function(ne){var he=this.rules.block.paragraph.exec(ne);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},ge.text=function(ne){var he=this.rules.block.text.exec(ne);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ge.escape=function(ne){var he=this.rules.inline.escape.exec(ne);if(he)return{type:"escape",raw:he[0],text:$(he[1])}},ge.tag=function(ne){var he=this.rules.inline.tag.exec(ne);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]):he[0]}},ge.link=function(ne){var he=this.rules.inline.link.exec(ne);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=s(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var fe=f(he[2],"()");if(fe>-1){var Ie=he[0].indexOf("!")===0?5:4,M=Ie+he[1].length+fe;he[2]=he[2].substring(0,fe),he[0]=he[0].substring(0,M).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),W(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ge.reflink=function(ne,he){var se;if((se=this.rules.inline.reflink.exec(ne))||(se=this.rules.inline.nolink.exec(ne))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var fe=se[0].charAt(0);return{type:"text",raw:fe,text:fe}}return W(se,oe,se[0],this.lexer)}},ge.emStrong=function(ne,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,M,K,G=Ie,Q=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*ne.length+Ie);(oe=J.exec(he))!=null;)if(M=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!M){if(K=M.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var x=ne.slice(1,Ie+oe.index+K);return{type:"em",raw:ne.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=ne.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:ne.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},ge.codespan=function(ne){var he=this.rules.inline.code.exec(ne);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),fe=/^ /.test(se)&&/ $/.test(se);return oe&&fe&&(se=se.substring(1,se.length-1)),se=$(se,!0),{type:"codespan",raw:he[0],text:se}}},ge.br=function(ne){var he=this.rules.inline.br.exec(ne);if(he)return{type:"br",raw:he[0]}},ge.del=function(ne){var he=this.rules.inline.del.exec(ne);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ge.autolink=function(ne,he){var se=this.rules.inline.autolink.exec(ne);if(se){var oe,fe;return se[2]==="@"?(oe=$(this.options.mangle?he(se[1]):se[1]),fe="mailto:"+oe):(oe=$(se[1]),fe=oe),{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.url=function(ne,he){var se;if(se=this.rules.inline.url.exec(ne)){var oe,fe;if(se[2]==="@")oe=$(this.options.mangle?he(se[0]):se[0]),fe="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=$(se[0]),se[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.inlineText=function(ne,he){var se=this.rules.inline.text.exec(ne);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):$(se[0]):se[0]:oe=$(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=o(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=o(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=o(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=o(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=o(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=o(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=I({},B),B.gfm=I({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=o(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=o(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=I({},B.normal,{html:o(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:o(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=o(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=o(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=o(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=o(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=o(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=o(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=o(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=o(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=o(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=o(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=o(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:o(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:o(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:o(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=o(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:o(O.br).replace("{2,}","*").getRegex(),text:o(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var ge="",De,ne,he=ve.length;for(De=0;De<he;De++)ne=ve.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),ge+="&#"+ne+";";return ge}var Y=function(){function ve(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:B.normal,inline:O.normal};this.options.pedantic?(ne.block=B.pedantic,ne.inline=O.pedantic):this.options.gfm&&(ne.block=B.gfm,this.options.breaks?ne.inline=O.breaks:ne.inline=O.gfm),this.tokenizer.rules=ne}ve.lex=function(ne,he){var se=new ve(he);return se.lex(ne)},ve.lexInline=function(ne,he){var se=new ve(he);return se.inlineTokens(ne)};var ge=ve.prototype;return ge.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ge.blockTokens=function(ne,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(G,Q,J){return Q+"    ".repeat(J.length)});for(var oe,fe,Ie,M;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},ne,he))?(ne=ne.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=ne.slice(1),J=void 0;se.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Q),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=ne.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=he[he.length-1],M&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe),M=Ie.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(ne){var K="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},ge.inline=function(ne,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:ne,tokens:he}),he},ge.inlineTokens=function(ne,he){var se=this;he===void 0&&(he=[]);var oe,fe,Ie,M=ne,K,G,Q;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(M))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(M))!=null;)M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(M))!=null;)M=M.slice(0,K.index)+"++"+M.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},ne,he))?(ne=ne.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,M,Q)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(ne,ee)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,ee))){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Oe=ne.slice(1),je=void 0;se.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Oe),typeof je=="number"&&je>=0&&(ae=Math.min(ae,je))}),ae<1/0&&ae>=0&&(Ie=ne.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(ne){var x="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},v(ve,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),ve}(),Ee=function(){function ve(De){this.options=De||be.defaults}var ge=ve.prototype;return ge.code=function(ne,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(ne,oe);fe!=null&&fe!==ne&&(se=!0,ne=fe)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(se?ne:$(ne,!0))+`</code></pre>
`:"<pre><code>"+(se?ne:$(ne,!0))+`</code></pre>
`},ge.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},ge.html=function(ne){return ne},ge.heading=function(ne,he,se,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+fe+'">'+ne+"</h"+he+`>
`}return"<h"+he+">"+ne+"</h"+he+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(ne,he,se){var oe=he?"ol":"ul",fe=he&&se!==1?' start="'+se+'"':"";return"<"+oe+fe+`>
`+ne+"</"+oe+`>
`},ge.listitem=function(ne){return"<li>"+ne+`</li>
`},ge.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(ne){return"<p>"+ne+`</p>
`},ge.table=function(ne,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+he+`</table>
`},ge.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},ge.tablecell=function(ne,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+ne+("</"+se+`>
`)},ge.strong=function(ne){return"<strong>"+ne+"</strong>"},ge.em=function(ne){return"<em>"+ne+"</em>"},ge.codespan=function(ne){return"<code>"+ne+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(ne){return"<del>"+ne+"</del>"},ge.link=function(ne,he,se){if(ne=m(this.options.sanitize,this.options.baseUrl,ne),ne===null)return se;var oe='<a href="'+$(ne)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},ge.image=function(ne,he,se){if(ne=m(this.options.sanitize,this.options.baseUrl,ne),ne===null)return se;var oe='<img src="'+ne+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},ge.text=function(ne){return ne},ve}(),ke=function(){function ve(){}var ge=ve.prototype;return ge.strong=function(ne){return ne},ge.em=function(ne){return ne},ge.codespan=function(ne){return ne},ge.del=function(ne){return ne},ge.html=function(ne){return ne},ge.text=function(ne){return ne},ge.link=function(ne,he,se){return""+se},ge.image=function(ne,he,se){return""+se},ge.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var ge=ve.prototype;return ge.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(ne,he){var se=ne,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[ne];do oe++,se=ne+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[ne]=oe,this.seen[se]=0),se},ge.slug=function(ne,he){he===void 0&&(he={});var se=this.serialize(ne);return this.getNextSafeSlug(se,he.dryrun)},ve}(),X=function(){function ve(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Pe}ve.parse=function(ne,he){var se=new ve(he);return se.parse(ne)},ve.parseInline=function(ne,he){var se=new ve(he);return se.parseInline(ne)};var ge=ve.prototype;return ge.parse=function(ne,he){he===void 0&&(he=!0);var se="",oe,fe,Ie,M,K,G,Q,J,x,ae,Oe,je,Qe,He,et,Xe,_e,it,tt,ze=ne.length;for(oe=0;oe<ze;oe++){if(ae=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",Q="",M=ae.header.length,fe=0;fe<M;fe++)Q+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(J+=this.renderer.tablerow(Q),x="",M=ae.rows.length,fe=0;fe<M;fe++){for(G=ae.rows[fe],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Q)}se+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Oe=ae.ordered,je=ae.start,Qe=ae.loose,M=ae.items.length,x="",fe=0;fe<M;fe++)et=ae.items[fe],Xe=et.checked,_e=et.task,He="",et.task&&(it=this.renderer.checkbox(Xe),Qe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Qe),x+=this.renderer.listitem(He,_e,Xe);se+=this.renderer.list(x,Oe,je);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&ne[oe+1].type==="text";)ae=ne[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var rt='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}}return se},ge.parseInline=function(ne,he){he=he||this.renderer;var se="",oe,fe,Ie,M=ne.length;for(oe=0;oe<M;oe++){if(fe=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){se+=Ie||"";continue}switch(fe.type){case"escape":{se+=he.text(fe.text);break}case"html":{se+=he.html(fe.text);break}case"link":{se+=he.link(fe.href,fe.title,this.parseInline(fe.tokens,he));break}case"image":{se+=he.image(fe.href,fe.title,fe.text);break}case"strong":{se+=he.strong(this.parseInline(fe.tokens,he));break}case"em":{se+=he.em(this.parseInline(fe.tokens,he));break}case"codespan":{se+=he.codespan(fe.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(fe.tokens,he));break}case"text":{se+=he.text(fe.text);break}default:{var K='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function ue(ve,ge,De){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof ge=="function"&&(De=ge,ge=null),ge=I({},ue.defaults,ge||{}),w(ge),De){var ne=ge.highlight,he;try{he=Y.lex(ve,ge)}catch(M){return De(M)}var se=function(K){var G;if(!K)try{ge.walkTokens&&ue.walkTokens(he,ge.walkTokens),G=X.parse(he,ge)}catch(Q){K=Q}return ge.highlight=ne,K?De(K):De(null,G)};if(!ne||ne.length<3||(delete ge.highlight,!he.length))return se();var oe=0;ue.walkTokens(he,function(M){M.type==="code"&&(oe++,setTimeout(function(){ne(M.text,M.lang,function(K,G){if(K)return se(K);G!=null&&G!==M.text&&(M.text=G,M.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function fe(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+$(M.message+"",!0)+"</pre>";throw M}try{var Ie=Y.lex(ve,ge);if(ge.walkTokens){if(ge.async)return Promise.all(ue.walkTokens(Ie,ge.walkTokens)).then(function(){return X.parse(Ie,ge)}).catch(fe);ue.walkTokens(Ie,ge.walkTokens)}return X.parse(Ie,ge)}catch(M){fe(M)}}ue.options=ue.setOptions=function(ve){return I(ue.defaults,ve),l(ue.defaults),ue},ue.getDefaults=A,ue.defaults=be.defaults,ue.use=function(){for(var ve=arguments.length,ge=new Array(ve),De=0;De<ve;De++)ge[De]=arguments[De];var ne=I.apply(void 0,[{}].concat(ge)),he=ue.defaults.extensions||{renderers:{},childTokens:{}},se;ge.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var M=he.renderers?he.renderers[Ie.name]:null;M?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var J=Ie.renderer.apply(this,G);return J===!1&&(J=M.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ue.defaults.renderer||new Ee,M=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Oe=0;Oe<x;Oe++)ae[Oe]=arguments[Oe];var je=oe.renderer[Q].apply(Ie,ae);return je===!1&&(je=J.apply(Ie,ae)),je}};for(var K in oe.renderer)M(K);ne.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ue.defaults.tokenizer||new U,M=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Oe=0;Oe<x;Oe++)ae[Oe]=arguments[Oe];var je=oe.tokenizer[Q].apply(Ie,ae);return je===!1&&(je=J.apply(Ie,ae)),je}};for(var K in oe.tokenizer)M(K);ne.tokenizer=Ie}(),oe.walkTokens){var fe=ue.defaults.walkTokens;ne.walkTokens=function(Ie){var M=[];return M.push(oe.walkTokens.call(this,Ie)),fe&&(M=M.concat(fe.call(this,Ie))),M}}se&&(ne.extensions=he),ue.setOptions(ne)})},ue.walkTokens=function(ve,ge){for(var De=[],ne=function(){var fe=se.value;switch(De=De.concat(ge.call(ue,fe)),fe.type){case"table":{for(var Ie=T(fe.header),M;!(M=Ie()).done;){var K=M.value;De=De.concat(ue.walkTokens(K.tokens,ge))}for(var G=T(fe.rows),Q;!(Q=G()).done;)for(var J=Q.value,x=T(J),ae;!(ae=x()).done;){var Oe=ae.value;De=De.concat(ue.walkTokens(Oe.tokens,ge))}break}case"list":{De=De.concat(ue.walkTokens(fe.items,ge));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[fe.type]?ue.defaults.extensions.childTokens[fe.type].forEach(function(je){De=De.concat(ue.walkTokens(fe[je],ge))}):fe.tokens&&(De=De.concat(ue.walkTokens(fe.tokens,ge)))}},he=T(ve),se;!(se=he()).done;)ne();return De},ue.parseInline=function(ve,ge){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");ge=I({},ue.defaults,ge||{}),w(ge);try{var De=Y.lexInline(ve,ge);return ge.walkTokens&&ue.walkTokens(De,ge.walkTokens),X.parseInline(De,ge)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+$(ne.message+"",!0)+"</pre>";throw ne}},ue.Parser=X,ue.parser=X.parse,ue.Renderer=Ee,ue.TextRenderer=ke,ue.Lexer=Y,ue.lexer=Y.lex,ue.Tokenizer=U,ue.Slugger=Pe,ue.parse=ue;var ye=ue.options,ce=ue.setOptions,$e=ue.use,ie=ue.walkTokens,z=ue.parseInline,q=ue,le=X.parse,we=Y.lex;be.Lexer=Y,be.Parser=X,be.Renderer=Ee,be.Slugger=Pe,be.TextRenderer=ke,be.Tokenizer=U,be.getDefaults=A,be.lexer=we,be.marked=ue,be.options=ye,be.parse=q,be.parseInline=z,be.parser=le,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[118],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function v(l,S,g){return Math.min(Math.max(l,S),g)}e.$Hl=v;function F(l,S){return(S+l%S)%S}e.rot=F;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=C;class T{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=T;class A{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const g=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=A}),function(){function be(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function A(S){T.push(S,Date.now())}function l(){const S=[];for(let g=0;g<T.length;g+=2)S.push({name:T[g],startTime:T[g+1]});return S}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(C+A.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=v(F))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var F in v)(typeof exports=="object"?exports:be)[F]=v[F]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function v(F){if(e[F])return e[F].exports;var C=e[F]={i:F,l:!1,exports:{}};return be[F].call(C.exports,C,C.exports,v),C.l=!0,C.exports}return v.m=be,v.c=e,v.d=function(F,C,T){v.o(F,C)||Object.defineProperty(F,C,{enumerable:!0,get:T})},v.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},v.t=function(F,C){if(1&C&&(F=v(F)),8&C||4&C&&typeof F=="object"&&F&&F.__esModule)return F;var T=Object.create(null);if(v.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:F}),2&C&&typeof F!="string")for(var A in F)v.d(T,A,function(l){return F[l]}.bind(null,A));return T},v.n=function(F){var C=F&&F.__esModule?function(){return F.default}:function(){return F};return v.d(C,"a",C),C},v.o=function(F,C){return Object.prototype.hasOwnProperty.call(F,C)},v.p="",v(v.s=0)}([function(be,e,v){(function(F){var C;e=be.exports=$e,C=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],S=e.src=[],g=0,P=g++;S[P]="0|[1-9]\\d*";var D=g++;S[D]="[0-9]+";var u=g++;S[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;S[b]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=g++;S[$]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var d=g++;S[d]="(?:"+S[P]+"|"+S[u]+")";var t=g++;S[t]="(?:"+S[D]+"|"+S[u]+")";var i=g++;S[i]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var o=g++;S[o]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var h=g++;S[h]="[0-9A-Za-z-]+";var y=g++;S[y]="(?:\\+("+S[h]+"(?:\\."+S[h]+")*))";var m=g++,r="v?"+S[b]+S[i]+"?"+S[y]+"?";S[m]="^"+r+"$";var a="[v=\\s]*"+S[$]+S[o]+"?"+S[y]+"?",n=g++;S[n]="^"+a+"$";var c=g++;S[c]="((?:<|>)?=?)";var E=g++;S[E]=S[D]+"|x|X|\\*";var p=g++;S[p]=S[P]+"|x|X|\\*";var I=g++;S[I]="[v=\\s]*("+S[p]+")(?:\\.("+S[p]+")(?:\\.("+S[p]+")(?:"+S[i]+")?"+S[y]+"?)?)?";var k=g++;S[k]="[v=\\s]*("+S[E]+")(?:\\.("+S[E]+")(?:\\.("+S[E]+")(?:"+S[o]+")?"+S[y]+"?)?)?";var s=g++;S[s]="^"+S[c]+"\\s*"+S[I]+"$";var f=g++;S[f]="^"+S[c]+"\\s*"+S[k]+"$";var w=g++;S[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;S[R]="(?:~>?)";var W=g++;S[W]="(\\s*)"+S[R]+"\\s+",l[W]=new RegExp(S[W],"g");var V=g++;S[V]="^"+S[R]+S[I]+"$";var U=g++;S[U]="^"+S[R]+S[k]+"$";var B=g++;S[B]="(?:\\^)";var O=g++;S[O]="(\\s*)"+S[B]+"\\s+",l[O]=new RegExp(S[O],"g");var N=g++;S[N]="^"+S[B]+S[I]+"$";var ee=g++;S[ee]="^"+S[B]+S[k]+"$";var Y=g++;S[Y]="^"+S[c]+"\\s*("+a+")$|^$";var Ee=g++;S[Ee]="^"+S[c]+"\\s*("+r+")$|^$";var ke=g++;S[ke]="(\\s*)"+S[c]+"\\s*("+a+"|"+S[I]+")",l[ke]=new RegExp(S[ke],"g");var Pe=g++;S[Pe]="^\\s*("+S[I]+")\\s+-\\s+("+S[I]+")\\s*$";var X=g++;S[X]="^\\s*("+S[k]+")\\s+-\\s+("+S[k]+")\\s*$";var ue=g++;S[ue]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)C(ye,S[ye]),l[ye]||(l[ye]=new RegExp(S[ye]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>T||!(x?l[n]:l[m]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?l[n]:l[m]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var je=+Oe;if(je>=0&&je<A)return je}return Oe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),z(this.major,J.major)||z(this.minor,J.minor)||z(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Oe=J.prerelease[x];if(C("prerelease compare",x,ae,Oe),ae===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ae===void 0)return-1;if(ae!==Oe)return z(ae,Oe)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Oe){typeof ae=="string"&&(Oe=ae,ae=void 0);try{return new $e(J,ae).inc(x,Oe).version}catch{return null}},e.diff=function(J,x){if(ve(J,x))return null;var ae=ce(J),Oe=ce(x);if(ae.prerelease.length||Oe.prerelease.length){for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Oe[je])return"pre"+je;return"prerelease"}for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Oe[je])return je},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(J,x){var ae=ie.test(J),Oe=ie.test(x);return ae&&Oe&&(J=+J,x=+x),ae&&!Oe?-1:Oe&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function le(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function ve(J,x,ae){return q(J,x,ae)===0}function ge(J,x,ae){return q(J,x,ae)!==0}function De(J,x,ae){return q(J,x,ae)>=0}function ne(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Oe){var je;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),je=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),je=J!==ae;break;case"":case"=":case"==":je=ve(J,ae,Oe);break;case"!=":je=ge(J,ae,Oe);break;case">":je=le(J,ae,Oe);break;case">=":je=De(J,ae,Oe);break;case"<":je=we(J,ae,Oe);break;case"<=":je=ne(J,ae,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return je}function se(J,x){if(J instanceof se){if(J.loose===x)return J;J=J.value}if(!(this instanceof se))return new se(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return z(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Oe){return e.compare(ae,Oe,x)})},e.rsort=function(J,x){return J.sort(function(ae,Oe){return e.rcompare(ae,Oe,x)})},e.gt=le,e.lt=we,e.eq=ve,e.neq=ge,e.gte=De,e.lte=ne,e.cmp=he,e.Comparator=se;var oe={};function fe(J,x){if(J instanceof fe)return J.loose===x?J:new fe(J.raw,x);if(J instanceof se)return new fe(J.value,x);if(!(this instanceof fe))return new fe(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function M(J,x,ae,Oe,je,Qe,He,et,Xe,_e,it,tt,ze){return((x=Ie(ae)?"":Ie(Oe)?">="+ae+".0.0":Ie(je)?">="+ae+"."+Oe+".0":">="+x)+" "+(et=Ie(Xe)?"":Ie(_e)?"<"+(+Xe+1)+".0.0":Ie(it)?"<"+Xe+"."+(+_e+1)+".0":tt?"<="+Xe+"."+_e+"."+it+"-"+tt:"<="+et)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Oe=J[ae].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new fe(x,ae)}catch{return!1}return x.test(J)}function Q(J,x,ae,Oe){var je,Qe,He,et,Xe;switch(J=new $e(J,Oe),x=new fe(x,Oe),ae){case">":je=le,Qe=ne,He=we,et=">",Xe=">=";break;case"<":je=we,Qe=De,He=le,et="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Oe))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,ze=null;if(it.forEach(function(rt){rt.semver===oe&&(rt=new se(">=0.0.0")),tt=tt||rt,ze=ze||rt,je(rt.semver,tt.semver,Oe)?tt=rt:He(rt.semver,ze.semver,Oe)&&(ze=rt)}),tt.operator===et||tt.operator===Xe||(!ze.operator||ze.operator===et)&&Qe(J,ze.semver)||ze.operator===Xe&&He(J,ze.semver))return!1}return!0}se.prototype.parse=function(J){var x=this.loose?l[Y]:l[Ee],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},se.prototype.intersects=function(J,x){if(!(J instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new fe(this.value,x),G(J.semver,ae,x);var Oe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Qe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),et=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Xe=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Oe||je||Qe&&He||et||Xe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?l[X]:l[Pe];J=J.replace(ae,M),C("hyphen replace",J),J=J.replace(l[ke],"$1$2$3"),C("comparator trim",J,l[ke]),J=(J=(J=J.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Oe=x?l[Y]:l[Ee],je=J.split(" ").map(function(Qe){return function(He,et){return C("comp",He),He=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var rt=ze?l[ee]:l[N];return tt.replace(rt,function(_,Z,pe,Ue,Ne){var Ze;return C("caret",tt,_,Z,pe,Ue,Ne),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Ue)?Ze=Z==="0"?">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+".0 <"+(+Z+1)+".0.0":Ne?(C("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+Ue+Ne+" <"+Z+"."+pe+"."+(+Ue+1):">="+Z+"."+pe+"."+Ue+Ne+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+Ue+Ne+" <"+(+Z+1)+".0.0"):(C("no pr"),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+Ue+" <"+Z+"."+pe+"."+(+Ue+1):">="+Z+"."+pe+"."+Ue+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+Ue+" <"+(+Z+1)+".0.0"),C("caret return",Ze),Ze})}(it,_e)}).join(" ")}(He,et),C("caret",He),He=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){var rt=ze?l[U]:l[V];return tt.replace(rt,function(_,Z,pe,Ue,Ne){var Ze;return C("tilde",tt,_,Z,pe,Ue,Ne),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Ue)?Ze=">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":Ne?(C("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=">="+Z+"."+pe+"."+Ue+Ne+" <"+Z+"."+(+pe+1)+".0"):Ze=">="+Z+"."+pe+"."+Ue+" <"+Z+"."+(+pe+1)+".0",C("tilde return",Ze),Ze})}(it,_e)}).join(" ")}(He,et),C("tildes",He),He=function(Xe,_e){return C("replaceXRanges",Xe,_e),Xe.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var rt=ze?l[f]:l[s];return tt.replace(rt,function(_,Z,pe,Ue,Ne,Ze){C("xRange",tt,_,Z,pe,Ue,Ne,Ze);var nt=Ie(pe),dt=nt||Ie(Ue),vt=dt||Ie(Ne);return Z==="="&&vt&&(Z=""),nt?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&vt?(dt&&(Ue=0),vt&&(Ne=0),Z===">"?(Z=">=",dt?(pe=+pe+1,Ue=0,Ne=0):vt&&(Ue=+Ue+1,Ne=0)):Z==="<="&&(Z="<",dt?pe=+pe+1:Ue=+Ue+1),_=Z+pe+"."+Ue+"."+Ne):dt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":vt&&(_=">="+pe+"."+Ue+".0 <"+pe+"."+(+Ue+1)+".0"),C("xRange return",_),_})}(it,_e)}).join(" ")}(He,et),C("xrange",He),He=function(Xe,_e){return C("replaceStars",Xe,_e),Xe.trim().replace(l[ue],"")}(He,et),C("stars",He),He}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Oe)})),je=je.map(function(Qe){return new se(Qe,x)})},fe.prototype.intersects=function(J,x){if(!(J instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Oe){return J.set.some(function(je){return je.every(function(Qe){return Oe.intersects(Qe,x)})})})})},e.toComparators=function(J,x){return new fe(J,x).set.map(function(ae){return ae.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Oe=null,je=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Oe&&je.compare(He)!==-1||(je=new $e(Oe=He,ae)))}),Oe},e.minSatisfying=function(J,x,ae){var Oe=null,je=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Oe&&je.compare(He)!==1||(je=new $e(Oe=He,ae)))}),Oe},e.validRange=function(J,x){try{return new fe(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return Q(J,x,"<",ae)},e.gtr=function(J,x,ae){return Q(J,x,">",ae)},e.outside=Q,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new fe(J,ae),x=new fe(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(l[w]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,v(1))},function(be,e){var v,F,C=be.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(v===setTimeout)return setTimeout(t,0);if((v===T||!v)&&setTimeout)return v=setTimeout,setTimeout(t,0);try{return v(t,0)}catch{try{return v.call(null,t,0)}catch{return v.call(this,t,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:T}catch{v=T}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var S,g=[],P=!1,D=-1;function u(){P&&S&&(P=!1,S.length?g=S.concat(g):D=-1,g.length&&b())}function b(){if(!P){var t=l(u);P=!0;for(var i=g.length;i;){for(S=g,g=[];++D<i;)S&&S[D].run();D=-1,i=g.length}S=null,P=!1,function(o){if(F===clearTimeout)return clearTimeout(o);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(o);try{F(o)}catch{try{return F.call(null,o)}catch{return F.call(this,o)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function d(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var o=1;o<arguments.length;o++)i[o-1]=arguments[o];g.push(new $(t,i)),g.length!==1||P||l(b)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,9,6]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function C(y){const m=y;return m?typeof m.read=="function":!1}e.$qd=C;function T(y){const m=y;return m?[m.on,m.pause,m.resume,m.destroy].every(r=>typeof r=="function"):!1}e.$rd=T;function A(y){const m=y;return m?T(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.$sd=A;function l(y,m){return new S(y,m)}e.$td=l;class S{constructor(m,r){this.e=m,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(r=>r(m))}h(m){this.c.error.length===0?(0,v.$Y)(m):this.c.error.slice(0).forEach(r=>r(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,r){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(m,r){if(this.a.destroyed)return;let a;switch(m){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(r);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(y,m){const r=[];let a;for(;(a=y.read())!==null;)r.push(a);return m(r)}e.$ud=g;function P(y,m,r){const a=[];let n;for(;(n=y.read())!==null&&a.length<r;)a.push(n);return n===null&&a.length>0?m(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const c=n;return n=void 0,c}return y.read()}}}e.$vd=P;function D(y,m){return new Promise((r,a)=>{const n=[];u(y,{onData:c=>{m&&n.push(c)},onError:c=>{m?a(c):r(void 0)},onEnd:()=>{r(m?m(n):void 0)}})})}e.$wd=D;function u(y,m,r){y.on("error",a=>{r?.isCancellationRequested||m.onError(a)}),y.on("end",()=>{r?.isCancellationRequested||m.onEnd()}),y.on("data",a=>{r?.isCancellationRequested||m.onData(a)})}e.$xd=u;function b(y,m){return new Promise((r,a)=>{const n=new F.$jc,c=[],E=k=>{if(c.push(k),c.length>m)return n.dispose(),y.pause(),r({stream:y,buffer:c,ended:!1})},p=k=>(n.dispose(),a(k)),I=()=>(n.dispose(),r({stream:y,buffer:c,ended:!0}));n.add((0,F.$ic)(()=>y.removeListener("error",p))),y.on("error",p),n.add((0,F.$ic)(()=>y.removeListener("end",I))),y.on("end",I),n.add((0,F.$ic)(()=>y.removeListener("data",E))),y.on("data",E)})}e.$yd=b;function $(y,m){const r=l(m);return r.end(y),r}e.$zd=$;function d(){const y=l(()=>{throw new Error("not supported")});return y.end(),y}e.$Ad=d;function t(y){let m=!1;return{read:()=>m?null:(m=!0,y)}}e.$Bd=t;function i(y,m,r){const a=l(r);return u(y,{onData:n=>a.write(m.data(n)),onError:n=>a.error(m.error?m.error(n):n),onEnd:()=>a.end()}),a}e.$Cd=i;function o(y,m,r){let a=!1;return{read:()=>{const n=m.read();return a?n:(a=!0,n!==null?r([y,n]):y)}}}e.$Dd=o;function h(y,m,r){let a=!1;const n=l(r);return u(m,{onData:c=>a?n.write(c):(a=!0,n.write(r([y,c]))),onError:c=>n.error(c),onEnd:()=>{a||(a=!0,n.write(y)),n.end()}}),n}e.$Ed=h}),define(Ae[25],Re([1,0,66,119]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const C=typeof Buffer<"u",T=new v.$T(()=>new Uint8Array(256));let A,l;class S{static alloc(w){return C?new S(Buffer.allocUnsafe(w)):new S(new Uint8Array(w))}static wrap(w){return C&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new S(w)}static fromString(w,R){return!(R?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(w)):(A||(A=new TextEncoder),new S(A.encode(w)))}static fromByteArray(w){const R=S.alloc(w.length);for(let W=0,V=w.length;W<V;W++)R.buffer[W]=w[W];return R}static concat(w,R){if(typeof R>"u"){R=0;for(let U=0,B=w.length;U<B;U++)R+=w[U].byteLength}const W=S.alloc(R);let V=0;for(let U=0,B=w.length;U<B;U++){const O=w[U];W.set(O,V),V+=O.byteLength}return W}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=S.alloc(this.byteLength);return w.set(this),w}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(w,R){return new S(this.buffer.subarray(w,R))}set(w,R){if(w instanceof S)this.buffer.set(w.buffer,R);else if(w instanceof Uint8Array)this.buffer.set(w,R);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),R);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return u(this.buffer,w)}writeUInt32BE(w,R){b(this.buffer,w,R)}readUInt32LE(w){return $(this.buffer,w)}writeUInt32LE(w,R){d(this.buffer,w,R)}readUInt8(w){return t(this.buffer,w)}writeUInt8(w,R){i(this.buffer,w,R)}indexOf(w,R=0){return g(this.buffer,w instanceof S?w.buffer:w,R)}}e.$Fd=S;function g(f,w,R=0){const W=w.byteLength,V=f.byteLength;if(W===0)return 0;if(W===1)return f.indexOf(w[0]);if(W>V-R)return-1;const U=T.value;U.fill(w.length);for(let ee=0;ee<w.length;ee++)U[w[ee]]=w.length-ee-1;let B=R+w.length-1,O=B,N=-1;for(;B<V;)if(f[B]===w[O]){if(O===0){N=B;break}B--,O--}else B+=Math.max(w.length-O,U[f[B]]),O=w.length-1;return N}e.$Gd=g;function P(f,w){return f[w+0]<<0>>>0|f[w+1]<<8>>>0}e.$Hd=P;function D(f,w,R){f[R+0]=w&255,w=w>>>8,f[R+1]=w&255}e.$Id=D;function u(f,w){return f[w]*2**24+f[w+1]*2**16+f[w+2]*2**8+f[w+3]}e.$Jd=u;function b(f,w,R){f[R+3]=w,w=w>>>8,f[R+2]=w,w=w>>>8,f[R+1]=w,w=w>>>8,f[R]=w}e.$Kd=b;function $(f,w){return f[w+0]<<0>>>0|f[w+1]<<8>>>0|f[w+2]<<16>>>0|f[w+3]<<24>>>0}e.$Ld=$;function d(f,w,R){f[R+0]=w&255,w=w>>>8,f[R+1]=w&255,w=w>>>8,f[R+2]=w&255,w=w>>>8,f[R+3]=w&255}e.$Md=d;function t(f,w){return f[w]}e.$Nd=t;function i(f,w,R){f[R]=w}e.$Od=i;function o(f){return F.$ud(f,w=>S.concat(w))}e.$Pd=o;function h(f){return F.$Bd(f)}e.$Qd=h;function y(f){return F.$wd(f,w=>S.concat(w))}e.$Rd=y;async function m(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await y(f.stream)])}e.$Sd=m;function r(f){return F.$zd(f,w=>S.concat(w))}e.$Td=r;function a(f){return F.$Cd(f,{data:w=>typeof w=="string"?S.fromString(w):S.wrap(w)},w=>S.concat(w))}e.$Ud=a;function n(f){return F.$td(w=>S.concat(w),f)}e.$Vd=n;function c(f,w){return F.$Dd(f,w,R=>S.concat(R))}e.$Wd=c;function E(f,w){return F.$Ed(f,w,R=>S.concat(R))}e.$Xd=E;function p(f){let w=0,R=0,W=0;const V=new Uint8Array(Math.floor(f.length/4*3)),U=O=>{switch(R){case 3:V[W++]=w|O,R=0;break;case 2:V[W++]=w|O>>>2,w=O<<6,R=3;break;case 1:V[W++]=w|O>>>4,w=O<<4,R=2;break;default:w=O<<2,R=1}};for(let O=0;O<f.length;O++){const N=f.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${f[O]}`)}}const B=W;for(;R>0;)U(0);return S.wrap(V).slice(0,B)}e.$Yd=p;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:f},w=!0,R=!1){const W=R?k:I;let V="";const U=f.byteLength%3;let B=0;for(;B<f.byteLength-U;B+=3){const O=f[B+0],N=f[B+1],ee=f[B+2];V+=W[O>>>2],V+=W[(O<<4|N>>>4)&63],V+=W[(N<<2|ee>>>6)&63],V+=W[ee&63]}if(U===1){const O=f[B+0];V+=W[O>>>2],V+=W[O<<4&63],w&&(V+="==")}else if(U===2){const O=f[B+0],N=f[B+1];V+=W[O>>>2],V+=W[(O<<4|N>>>4)&63],V+=W[N<<2&63],w&&(V+="=")}return V}e.$Zd=s}),define(Ae[120],Re([1,0,28,15]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.FuzzyScore=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.or=void 0;function C(...se){return function(oe,fe){for(let Ie=0,M=se.length;Ie<M;Ie++){const K=se[Ie](oe,fe);if(K)return K}return null}}e.or=C,e.$xj=T.bind(void 0,!1),e.$yj=T.bind(void 0,!0);function T(se,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return se?Ie=F.$Ne(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const fe=oe.toLowerCase().indexOf(se.toLowerCase());return fe===-1?null:[{start:fe,end:fe+se.length}]}e.$zj=A;function l(se,oe){return S(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Aj=l;function S(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]===oe[Ie]){let M=null;return(M=S(se,oe,fe+1,Ie+1))?i({start:Ie,end:Ie+1},M):null}return S(se,oe,fe,Ie+1)}function g(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Bj=P;function D(se){return 48<=se&&se<=57}function u(se){return se===32||se===9||se===10||se===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>b.add(se.charCodeAt(0)));function $(se){return u(se)||b.has(se)}function d(se,oe){return se===oe||$(se)&&$(oe)}function t(se){return g(se)||P(se)||D(se)}function i(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function o(se,oe){for(let fe=oe;fe<se.length;fe++){const Ie=se.charCodeAt(fe);if(P(Ie)||D(Ie)||fe>0&&!t(se.charCodeAt(fe-1)))return fe}return se.length}function h(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]!==oe[Ie].toLowerCase())return null;{let M=null,K=Ie+1;for(M=h(se,oe,fe+1,Ie+1);!M&&(K=o(oe,K))<oe.length;)M=h(se,oe,fe+1,K),K++;return M===null?null:i({start:Ie,end:Ie+1},M)}}function y(se){let oe=0,fe=0,Ie=0,M=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,g(K)&&fe++,t(K)&&Ie++,D(K)&&M++;const G=oe/se.length,Q=fe/se.length,J=Ie/se.length,x=M/se.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:J,numericPercent:x}}function m(se){const{upperPercent:oe,lowerPercent:fe}=se;return fe===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:M}=se;return fe>.2&&oe<.8&&Ie>.6&&M<.2}function a(se){let oe=0,fe=0,Ie=0,M=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,g(Ie)&&fe++,u(Ie)&&M++;return(oe===0||fe===0)&&M===0?se.length<=30:oe<=5}function n(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!a(se)||oe.length>60)return null;const fe=y(oe);if(!r(fe)){if(!m(fe))return null;oe=oe.toLowerCase()}let Ie=null,M=0;for(se=se.toLowerCase();M<oe.length&&(Ie=h(se,oe,0,M))===null;)M=o(oe,M+1);return Ie}e.$Cj=n;function c(se,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,M=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();M<oe.length&&(Ie=E(se,oe,0,M,fe))===null;)M=p(oe,M+1);return Ie}e.$Dj=c;function E(se,oe,fe,Ie,M){if(fe===se.length)return[];if(Ie===oe.length)return null;if(d(se.charCodeAt(fe),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=E(se,oe,fe+1,Ie+1,M),!M)for(;!K&&(G=p(oe,G))<oe.length;)K=E(se,oe,fe+1,G,M),G++;return K?se.charCodeAt(fe)!==oe.charCodeAt(Ie)?K:i({start:Ie,end:Ie+1},K):null}else return null}function p(se,oe){for(let fe=oe;fe<se.length;fe++)if($(se.charCodeAt(fe))||fe>0&&$(se.charCodeAt(fe-1)))return fe;return se.length}const I=C(e.$yj,n,A),k=C(e.$yj,n,l),s=new v.$Ci(1e4);function f(se,oe,fe=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=s.get(se);Ie||(Ie=new RegExp(F.$we(se),"i"),s.set(se,Ie));const M=Ie.exec(oe);return M?[{start:M.index,end:M.index+M[0].length}]:fe?k(se,oe):I(se,oe)}e.$Ej=f;function w(se,oe){const fe=le(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?W(fe):null}e.$Fj=w;function R(se,oe,fe,Ie,M,K){const G=Math.min(13,se.length);for(;fe<G;fe++){const Q=le(se,oe,fe,Ie,M,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Gj=R;function W(se){if(typeof se>"u")return[];const oe=[],fe=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const M=se[Ie]+fe,K=oe[oe.length-1];K&&K.end===M?K.end=M+1:oe.push({start:M,end:M+1})}return oe}e.$Hj=W;const V=128;function U(){const se=[],oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;for(let fe=0;fe<=V;fe++)se.push(oe.slice(0));return se}function B(se){const oe=[];for(let fe=0;fe<=se;fe++)oe[fe]=0;return oe}const O=B(2*V),N=B(2*V),ee=U(),Y=U(),Ee=U(),ke=!1;function Pe(se,oe,fe,Ie,M){function K(Q,J,x=" "){for(;Q.length<J;)Q=x+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=fe;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=se[Q].slice(0,M+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function X(se,oe,fe,Ie){se=se.substr(oe),fe=fe.substr(Ie),console.log(Pe(Y,se,se.length,fe,fe.length)),console.log(Pe(Ee,se,se.length,fe,fe.length)),console.log(Pe(ee,se,se.length,fe,fe.length))}function ue(se,oe){if(oe<0||oe>=se.length)return!1;const fe=se.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$6e(fe)}}function ye(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,fe){return oe[se]!==fe[se]}function $e(se,oe,fe,Ie,M,K,G=!1){for(;oe<fe&&M<K;)se[oe]===Ie[M]&&(G&&(O[oe]=M),oe+=1),M+=1;return oe===fe}e.$Ij=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Jj=q;function le(se,oe,fe,Ie,M,K,G=q.default){const Q=se.length>V?V:se.length,J=Ie.length>V?V:Ie.length;if(fe>=Q||K>=J||Q-fe>J-K||!$e(oe,fe,Q,M,K,J,!0))return;we(Q,J,fe,K,oe,M);let x=1,ae=1,Oe=fe,je=K;const Qe=[!1];for(x=1,Oe=fe;Oe<Q;x++,Oe++){const it=O[Oe],tt=N[Oe],ze=Oe+1<Q?N[Oe+1]:J;for(ae=it-K+1,je=it;je<ze;ae++,je++){let rt=Number.MIN_SAFE_INTEGER,_=!1;je<=tt&&(rt=ve(se,oe,Oe,fe,Ie,M,je,J,K,ee[x-1][ae-1]===0,Qe));let Z=0;rt!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=rt+Y[x-1][ae-1]);const pe=je>it,Ue=pe?Y[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,Ne=je>it+1&&ee[x][ae-1]>0,Ze=Ne?Y[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(Ne&&(!pe||Ze>=Ue)&&(!_||Ze>=Z))Y[x][ae]=Ze,Ee[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||Ue>=Z))Y[x][ae]=Ue,Ee[x][ae]=2,ee[x][ae]=0;else if(_)Y[x][ae]=Z,Ee[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(ke&&X(se,fe,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[Y[x][ae],K];let et=0,Xe=0;for(;x>=1;){let it=ae;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&oe[fe+x-1]===M[K+ae-1]&&!ce(it+K-1,Ie,M)&&et+1>ee[x][it]&&(it=ae),it===ae?et++:et=1,Xe||(Xe=it),x--,ae=it-1,He.push(ae)}J===Q&&G.boostFullMatch&&(He[0]+=2);const _e=Xe-Q;return He[0]-=_e,He}e.$Kj=le;function we(se,oe,fe,Ie,M,K){let G=se-1,Q=oe-1;for(;G>=fe&&Q>=Ie;)M[G]===K[Q]&&(N[G]=Q,G--),Q--}function ve(se,oe,fe,Ie,M,K,G,Q,J,x,ae){if(oe[fe]!==K[G])return Number.MIN_SAFE_INTEGER;let Oe=1,je=!1;return G===fe-Ie?Oe=se[fe]===M[G]?7:5:ce(G,M,K)&&(G===0||!ce(G-1,M,K))?(Oe=se[fe]===M[G]?7:5,je=!0):ue(K,G)&&(G===0||!ue(K,G-1))?Oe=5:(ue(K,G-1)||ye(K,G-1))&&(Oe=5,je=!0),Oe>1&&fe===Ie&&(ae[0]=!0),je||(je=ce(G,M,K)||ue(K,G-1)||ye(K,G-1)),fe===Ie?G>J&&(Oe-=je?3:5):x?Oe+=je?2:0:Oe+=je?0:1,G+1===Q&&(Oe-=je?3:5),Oe}function ge(se,oe,fe,Ie,M,K,G){return ne(se,oe,fe,Ie,M,K,!0,G)}e.$Lj=ge;function De(se,oe,fe,Ie,M,K,G){return ne(se,oe,fe,Ie,M,K,!1,G)}e.$Mj=De;function ne(se,oe,fe,Ie,M,K,G,Q){let J=le(se,oe,fe,Ie,M,K,Q);if(J&&!G)return J;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ae=fe+1;ae<x;ae++){const Oe=he(se,ae);if(Oe){const je=le(Oe,Oe.toLowerCase(),fe,Ie,M,K,Q);je&&(je[0]-=3,(!J||je[0]>J[0])&&(J=je))}}}return J}function he(se,oe){if(oe+1>=se.length)return;const fe=se[oe],Ie=se[oe+1];if(fe!==Ie)return se.slice(0,oe)+Ie+fe+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const T="error",A="warning",l="warn",S="info",g="ignore";function P(u){return u?v.$Me(T,u)?C.Error:v.$Me(A,u)||v.$Me(l,u)?C.Warning:v.$Me(S,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function D(u){switch(u){case C.Error:return T;case C.Warning:return A;case C.Info:return S;default:return g}}C.toString=D}(F||(F={})),e.default=F}),define(Ae[121],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const $=b.charCodeAt(0),d=this.b.charCodeAt(this.c);return $-d}value(){return this.b[this.c]}}e.$Dh=C;class T{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,F.$Ge)(b,this.b,0,b.length,this.c,this.d):(0,F.$Ie)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=T;class A{constructor(b=!0,$=!0){this.f=b,this.g=$}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let $=b.length-1;$>=0;$--,this.c--){const d=this.b.charCodeAt($);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,F.$Ge)(b,this.b,0,b.length,this.d,this.e):(0,F.$Ie)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=A;var l;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(l||(l={}));class S{constructor(b,$){this.f=b,this.g=$,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,F.$He)(b,this.c.scheme);if(this.d[this.e]===2)return(0,F.$He)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,F.$Fe)(b,this.c.query);if(this.d[this.e]===5)return(0,F.$Fe)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class D{static forUris(b=()=>!1,$=()=>!1){return new D(new S(b,$))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new T)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,$){if($){const d=$.slice(0);(0,v.$Vb)(d);for(const t of d)this.set(t,b)}else{const d=b.slice(0);(0,v.$Vb)(d);for(const t of d)this.set(t[0],t[1])}}set(b,$){const d=this.b.reset(b);let t;this.c||(this.c=new g,this.c.segment=d.value());const i=[];for(t=this.c;;){const h=d.cmp(t.segment);if(h>0)t.left||(t.left=new g,t.left.segment=d.value()),i.push([-1,t]),t=t.left;else if(h<0)t.right||(t.right=new g,t.right.segment=d.value()),i.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new g,t.mid.segment=d.value()),i.push([0,t]),t=t.mid;else break}const o=t.value;t.value=$,t.key=b;for(let h=i.length-1;h>=0;h--){const y=i[h][1];y.updateHeight();const m=y.balanceFactor();if(m<-1||m>1){const r=i[h][0],a=i[h+1][0];if(r===1&&a===1)i[h][1]=y.rotateLeft();else if(r===-1&&a===-1)i[h][1]=y.rotateRight();else if(r===1&&a===-1)y.right=i[h+1][1]=i[h+1][1].rotateRight(),i[h][1]=y.rotateLeft();else if(r===-1&&a===1)y.left=i[h+1][1]=i[h+1][1].rotateLeft(),i[h][1]=y.rotateRight();else throw new Error;if(h>0)switch(i[h-1][0]){case-1:i[h-1][1].left=i[h][1];break;case 1:i[h-1][1].right=i[h][1];break;case 0:i[h-1][1].mid=i[h][1];break}else this.c=i[0][1]}}return o}get(b){return this.d(b)?.value}d(b){const $=this.b.reset(b);let d=this.c;for(;d;){const t=$.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if($.hasNext())$.next(),d=d.mid;else break}return d}has(b){const $=this.d(b);return!($?.value===void 0&&$?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,$){const d=this.b.reset(b),t=[];let i=this.c;for(;i;){const o=d.cmp(i.segment);if(o>0)t.push([-1,i]),i=i.left;else if(o<0)t.push([1,i]),i=i.right;else if(d.hasNext())d.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const o=this.f(i.right);if(o.key){const{key:h,value:y,segment:m}=o;this.e(o.key,!1),i.key=h,i.value=y,i.segment=m}}else{const o=i.left??i.right;if(t.length>0){const[h,y]=t[t.length-1];switch(h){case-1:y.left=o;break;case 0:y.mid=o;break;case 1:y.right=o;break}}else this.c=o}for(let o=t.length-1;o>=0;o--){const h=t[o][1];h.updateHeight();const y=h.balanceFactor();if(y>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),t[o][1]=h.rotateLeft()):y<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),t[o][1]=h.rotateRight()),o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const $=this.b.reset(b);let d=this.c,t;for(;d;){const i=$.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if($.hasNext())$.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(b){return this.g(b,!1)}g(b,$){const d=this.b.reset(b);let t=this.c;for(;t;){const i=d.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[$,d]of this)b(d,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const $=[];return this.j(b,$),$[Symbol.iterator]()}j(b,$){b&&(b.left&&this.j(b.left,$),b.value&&$.push([b.key,b.value]),b.mid&&this.j(b.mid,$),b.right&&this.j(b.right,$))}_isBalanced(){const b=$=>{if(!$)return!0;const d=$.balanceFactor();return d<-1||d>1?!1:b($.left)&&b($.right)};return b(this.c)}}e.$Hh=D}),define(Ae[40],Re([1,0,89]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var F;(function(A){function l(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=l})(F||(e.ThemeColor=F={}));function C(A){return{id:A}}e.$Qj=C;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(o){const h=l.exec(o.id);if(!h)return S(v.$Pj.error);const[,y,m]=h,r=["codicon","codicon-"+y];return m&&r.push("codicon-modifier-"+m.substring(1)),r}A.asClassNameArray=S;function g(o){return S(o).join(" ")}A.asClassName=g;function P(o){return"."+S(o).join(".")}A.asCSSSelector=P;function D(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||F.isThemeColor(o.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(o){const h=u.exec(o);if(!h)return;const[,y]=h;return{id:y}}A.fromString=b;function $(o){return{id:o}}A.fromId=$;function d(o,h){let y=o.id;const m=y.lastIndexOf("~");return m!==-1&&(y=y.substring(0,m)),h&&(y=`${y}~${h}`),{id:y}}A.modify=d;function t(o){const h=o.id.lastIndexOf("~");if(h!==-1)return o.id.substring(h+1)}A.getModifier=t;function i(o,h){return o.id===h.id&&o.color?.id===h.color?.id}A.isEqual=i})(T||(e.ThemeIcon=T={}))}),define(Ae[122],Re([1,0,120,15,40]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=void 0;const T="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function S(i){return i.replace(l,(o,h)=>h?o:`\\${o}`)}e.$Rj=S;const g=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(g,o=>`\\${o}`)}e.$Sj=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(T)===-1?i:i.replace(D,(o,h,y,m)=>y?o:h||m||"")}e.$Tj=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(o,h)=>` ${h} `).trim():""}e.$Uj=b;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(i){$.lastIndex=0;let o="";const h=[];let y=0;for(;;){const m=$.lastIndex,r=$.exec(i),a=i.substring(m,r?.index);if(a.length>0){o+=a;for(let n=0;n<a.length;n++)h.push(y)}if(!r)break;y+=r[0].length}return{text:o,iconOffsets:h}}e.$Vj=d;function t(i,o,h=!1){const{text:y,iconOffsets:m}=o;if(!m||m.length===0)return(0,v.$Ej)(i,y,h);const r=(0,F.$ue)(y," "),a=y.length-r.length,n=(0,v.$Ej)(i,r,h);if(n)for(const c of n){const E=m[c.start+a]+a;c.start+=E,c.end+=E}return n}e.$Wj=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(C){return v.test(C)}e.$3f=F,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let S=0;S<l.length;S++)l[S]=Math.floor(Math.random()*256);return l};const T=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let S=0,g="";return g+=A[T[S++]],g+=A[T[S++]],g+=A[T[S++]],g+=A[T[S++]],g+="-",g+=A[T[S++]],g+=A[T[S++]],g+="-",g+=A[T[S++]],g+=A[T[S++]],g+="-",g+=A[T[S++]],g+=A[T[S++]],g+="-",g+=A[T[S++]],g+=A[T[S++]],g+=A[T[S++]],g+=A[T[S++]],g+=A[T[S++]],g+=A[T[S++]],g}}()}),define(Ae[123],Re([1,0,18,67,36]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=e.$Qs=e.$Ps=void 0;function T(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Ps=T;function A(D,u,b){const $={id:(0,C.$4f)(),name:D,uri:u,data:b};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Qs=A;class l{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return F.Iterable.some(this,([$,d])=>d.asFile())&&b.push("files"),P(S(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const $=this.a.get(u);$?$.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const $ of b)yield[u,$]}b(u){return S(u)}}e.$Rs=l;function S(D){return D.toLowerCase()}function g(D,u){return P(S(D),u.map(S))}e.$Ss=g;function P(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[$,d,t]=b;return t==="*"?u.some(i=>i.startsWith(d+"/")):!1}e.$Ts=Object.freeze({create:D=>(0,v.$Kb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ts.split(D).filter(u=>!u.startsWith("#"))})}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0,e.$Ur={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.IndentAction=void 0;var v;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(v||(e.IndentAction=v={}));class F{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let S=0,g=l.notIn.length;S<g;S++)switch(l.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,S){if(l.getTokenCount()===0)return!0;const g=l.findTokenIndexAtOffset(S-2),P=l.getStandardTokenType(g);return this.isOK(P)}g(l,S){for(let g=l;g<=S;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$gt=F;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of l)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$ht=C;function T(A,l,S){A.has(l)?A.get(l).push(S):A.set(l,[S])}}),define(Ae[126],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7=e.$j7=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$j7=v;class F{constructor(T){this.identifier=T}}e.$k7=F}),define(Ae[127],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[128],Re([1,0,5,6,127]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class T extends F.$kc{constructor(u,b="",$="",d=!0,t){super(),this.h=this.B(new v.$fd),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=$,this.w=d,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$gi=T;class A extends F.$kc{constructor(){super(...arguments),this.f=this.B(new v.$fd),this.onWillRun=this.f.event,this.m=this.B(new v.$fd),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let $;try{await this.u(u,b)}catch(d){$=d}this.m.fire({action:u,error:$})}async u(u,b){await u.run(b)}}e.$hi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const $ of u)$.length&&(b.length?b=[...b,new l,...$]:b=$);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$ii=l;class S{get actions(){return this.a}constructor(u,b,$,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=d,this.a=$}async run(){}}e.$ji=S;class g extends T{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$ki=g;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(),tooltip:D.label}}e.$li=P}),define(Ae[129],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[130],Re([1,0,129]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const F=60,C=F*60,T=C*24,A=T*7,l=T*30,S=T*365;function g(D,u,b,$){typeof D!="number"&&(D=D.getTime());const d=Math.round((new Date().getTime()-D)/1e3);if(d<-30)return(0,v.localize)(0,null,g(new Date().getTime()+d*1e3,!1));if(!$&&d<30)return(0,v.localize)(1,null);let t;return d<F?(t=d,u?t===1?b?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):b?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t):t===1?b?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):b?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):d<C?(t=Math.floor(d/F),u?t===1?b?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):b?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t):t===1?b?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):b?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):d<T?(t=Math.floor(d/C),u?t===1?b?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):b?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t):t===1?b?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):b?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):d<A?(t=Math.floor(d/T),u?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t)):d<l?(t=Math.floor(d/A),u?t===1?b?(0,v.localize)(30,null,t):(0,v.localize)(31,null,t):b?(0,v.localize)(32,null,t):(0,v.localize)(33,null,t):t===1?b?(0,v.localize)(34,null,t):(0,v.localize)(35,null,t):b?(0,v.localize)(36,null,t):(0,v.localize)(37,null,t)):d<S?(t=Math.floor(d/l),u?t===1?b?(0,v.localize)(38,null,t):(0,v.localize)(39,null,t):b?(0,v.localize)(40,null,t):(0,v.localize)(41,null,t):t===1?b?(0,v.localize)(42,null,t):(0,v.localize)(43,null,t):b?(0,v.localize)(44,null,t):(0,v.localize)(45,null,t)):(t=Math.floor(d/S),u?t===1?b?(0,v.localize)(46,null,t):(0,v.localize)(47,null,t):b?(0,v.localize)(48,null,t):(0,v.localize)(49,null,t):t===1?b?(0,v.localize)(50,null,t):(0,v.localize)(51,null,t):b?(0,v.localize)(52,null,t):(0,v.localize)(53,null,t))}e.$6l=g;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=P}),define(Ae[131],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,131]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function T(D,u){return u&&(D.stack||D.stacktrace)?C.localize(0,null,l(D),A(D.stack)||A(D.stacktrace)):l(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function l(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function S(D=null,u=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const b=v.$Fb(D),$=S(b[0],u);return b.length>1?C.localize(4,null,$,b.length):$}if(F.$jf(D))return D;if(D.detail){const b=D.detail;if(b.error)return T(b.error,u);if(b.exception)return T(b.exception,u)}return D.stack?T(D,u):D.message?D.message:C.localize(5,null)}e.$mi=S;function g(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$ni=g;function P(D,u){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=u,b}e.$oi=P}),define(Ae[132],Re([1,0,66,19]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=void 0;const C=new v.$T(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),T=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(k,s,f=!1){const w=k||"",R=s||"",W=C.value.collator.compare(w,R);return C.value.collatorIsNumeric&&W===0&&w!==R?w<R?-1:1:W}e.$0p=l;function S(k,s){const f=T.value.collator;return k=k||"",s=s||"",y(f,k,s)}e.$$p=S;function g(k,s){const f=T.value.collator;return k=k||"",s=s||"",n(k,s)||y(f,k,s)}e.$_p=g;function P(k,s){const f=T.value.collator;return k=k||"",s=s||"",a(k,s)||y(f,k,s)}e.$aq=P;function D(k,s){return k=k||"",s=s||"",k===s?0:k<s?-1:1}e.$bq=D;function u(k,s){const[f,w]=o(k),[R,W]=o(s);let V=C.value.collator.compare(w,W);if(V===0){if(C.value.collatorIsNumeric&&w!==W)return w<W?-1:1;if(V=C.value.collator.compare(f,R),C.value.collatorIsNumeric&&V===0&&f!==R)return f<R?-1:1}return V}e.$cq=u;function b(k,s){k=k||"",s=s||"";const f=h(k),w=h(s),R=T.value.collator,W=A.value.collator;return y(W,f,w)||y(R,k,s)}e.$dq=b;function $(k,s){k=k||"",s=s||"";const f=h(k),w=h(s),R=T.value.collator,W=A.value.collator;return y(W,f,w)||n(k,s)||y(R,k,s)}e.$eq=$;function d(k,s){k=k||"",s=s||"";const f=h(k),w=h(s),R=T.value.collator,W=A.value.collator;return y(W,f,w)||a(k,s)||y(R,k,s)}e.$fq=d;function t(k,s){k=k||"",s=s||"";const f=h(k).toLowerCase(),w=h(s).toLowerCase();return f!==w?f<w?-1:1:k!==s?k<s?-1:1:0}e.$gq=t;const i=/^(.*?)(\.([^.]*))?$/;function o(k,s=!1){const f=k?i.exec(k):[];let w=[f&&f[1]||"",f&&f[3]||""];return s&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function h(k){const s=k?i.exec(k):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function y(k,s,f){const w=k.compare(s,f);return w!==0?w:s.length!==f.length?s.length<f.length?-1:1:0}function m(k){const s=k.charAt(0);return s.toLocaleUpperCase()!==s}function r(k){const s=k.charAt(0);return s.toLocaleLowerCase()!==s}function a(k,s){return m(k)&&r(s)?-1:r(k)&&m(s)?1:0}function n(k,s){return r(k)&&m(s)?-1:m(k)&&r(s)?1:0}function c(k,s,f=!1){return f||(k=k&&k.toLowerCase(),s=s&&s.toLowerCase()),k===s?0:k<s?-1:1}function E(k,s,f=!1){const w=k.split(F.sep),R=s.split(F.sep),W=w.length-1,V=R.length-1;let U,B;for(let O=0;;O++){if(U=W===O,B=V===O,U&&B)return l(w[O],R[O],f);if(U)return-1;if(B)return 1;const N=c(w[O],R[O],f);if(N!==0)return N}}e.$hq=E;function p(k,s,f){const w=k.toLowerCase(),R=s.toLowerCase(),W=I(k,s,f);if(W)return W;const V=w.endsWith(f),U=R.endsWith(f);if(V!==U)return V?-1:1;const B=l(w,R);return B!==0?B:w.localeCompare(R)}e.$iq=p;function I(k,s,f){const w=k.toLowerCase(),R=s.toLowerCase(),W=w.startsWith(f),V=R.startsWith(f);if(W!==V)return W?-1:1;if(W&&V){if(w.length<R.length)return-1;if(w.length>R.length)return 1}return 0}e.$jq=I}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function A(p){return p===47||p===92}e.$Bf=A;function l(p){return p.replace(/[\\/]/g,v.$6d.sep)}e.$Cf=l;function S(p){return p.indexOf("/")===-1&&(p=l(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}e.$Df=S;function g(p,I=v.$6d.sep){if(!p)return"";const k=p.length,s=p.charCodeAt(0);if(A(s)){if(A(p.charCodeAt(1))&&!A(p.charCodeAt(2))){let w=3;const R=w;for(;w<k&&!A(p.charCodeAt(w));w++);if(R!==w&&!A(p.charCodeAt(w+1))){for(w+=1;w<k;w++)if(A(p.charCodeAt(w)))return p.slice(0,w+1).replace(/[\\/]/g,I)}}return I}else if(i(s)&&p.charCodeAt(1)===58)return A(p.charCodeAt(2))?p.slice(0,2)+I:p.slice(0,2);let f=p.indexOf("://");if(f!==-1){for(f+=3;f<k;f++)if(A(p.charCodeAt(f)))return p.slice(0,f+1)}return""}e.$Ef=g;function P(p){if(!F.$i||!p||p.length<5)return!1;let I=p.charCodeAt(0);if(I!==92||(I=p.charCodeAt(1),I!==92))return!1;let k=2;const s=k;for(;k<p.length&&(I=p.charCodeAt(k),I!==92);k++);return!(s===k||(I=p.charCodeAt(k+1),isNaN(I)||I===92))}e.$Ff=P;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(p,I=F.$i){const k=I?D:u;return!(!p||p.length===0||/^\s+$/.test(p)||(k.lastIndex=0,k.test(p))||I&&b.test(p)||p==="."||p===".."||I&&p[p.length-1]==="."||I&&p.length!==p.trim().length||p.length>255)}e.$Gf=$;function d(p,I,k){const s=p===I;return!k||s?s:!p||!I?!1:(0,C.$Me)(p,I)}e.$Hf=d;function t(p,I,k,s=v.sep){if(p===I)return!0;if(!p||!I||I.length>p.length)return!1;if(k){if(!(0,C.$Ne)(p,I))return!1;if(I.length===p.length)return!0;let w=I.length;return I.charAt(I.length-1)===s&&w--,p.charAt(w)===s}return I.charAt(I.length-1)!==s&&(I+=s),p.indexOf(I)===0}e.$If=t;function i(p){return p>=65&&p<=90||p>=97&&p<=122}e.$Jf=i;function o(p,I){return F.$i&&p.endsWith(":")&&(p+=v.sep),(0,v.$8d)(p)||(p=(0,v.$9d)(I,p)),p=(0,v.$7d)(p),F.$i?(p=(0,C.$ve)(p,v.sep),p.endsWith(":")&&(p+=v.sep)):(p=(0,C.$ve)(p,v.sep),p||(p=v.sep)),p}e.$Kf=o;function h(p){const I=(0,v.$7d)(p);return F.$i?p.length>3?!1:y(I)&&(p.length===2||I.charCodeAt(2)===92):I===v.$6d.sep}e.$Lf=h;function y(p,I=F.$i){return I?i(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}e.$Mf=y;function m(p,I=F.$i){return y(p,I)?p[0]:void 0}e.$Nf=m;function r(p,I,k){return I.length>p.length?-1:p===I?0:(k&&(p=p.toLowerCase(),I=I.toLowerCase()),p.indexOf(I))}e.$Of=r;function a(p){const I=p.split(":");let k,s,f;for(const w of I){const R=Number(w);(0,T.$nf)(R)?s===void 0?s=R:f===void 0&&(f=R):k=k?[k,w].join(":"):w}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:s!==void 0?s:void 0,column:f!==void 0?f:s!==void 0?1:void 0}}e.$Pf=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(p,I,k=8){let s="";for(let w=0;w<k;w++){let R;w===0&&F.$i&&!I&&(k===3||k===4)?R=c:R=n,s+=R.charAt(Math.floor(Math.random()*R.length))}let f;return I?f=`${I}-${s}`:f=s,p?(0,v.$9d)(p,f):f}e.$Qf=E}),define(Ae[68],Re([1,0,19]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const D=(0,v.$be)(P),u=F[D.toLowerCase()];return u!==void 0?u:A(P)}e.$Ir=T;function A(P){const D=(0,v.$be)(P);return C[D.toLowerCase()]}e.$Jr=A;function l(P){for(const D in C)if(C[D]===P)return D}e.$Kr=l;const S=/^(.+)\/(.+?)(;.+)?$/;function g(P,D){const u=S.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:P}e.$Lr=g}),define(Ae[69],Re([1,0,25,2]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function C(S){return JSON.stringify(S,A)}e.$9g=C;function T(S){let g=JSON.parse(S);return g=l(g),g}e.$0g=T;function A(S,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function l(S,g=0){if(!S||g>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return F.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof v.$Fd||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=l(S[P],g+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=l(S[P],g+1))}return S}e.$$g=l}),define(Ae[13],Re([1,0,9,22,2]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var T;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${T.vscodeRemoteResource}`}set(P,D,u){this.a[P]=D,this.b[P]=u}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return v.$Y(t),P}const D=P.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[D],$=this.c[D];let d=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(d+=`&${e.$Vf}=${encodeURIComponent($)}`),C.URI.from({scheme:F.$o?this.d:T.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:d})}}e.$Wf=new A,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(P){const D=this.b(P,be);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===T.vscodeRemote?e.$Wf.rewrite(P):P.scheme===T.file&&(F.$m||F.$p&&F.$g.origin===`${T.vscodeFileResource}://${l.a}`)?P.with({scheme:T.vscodeFileResource,authority:P.authority||l.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,be);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===T.vscodeFileResource?P.with({scheme:T.file,authority:P.authority!==l.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return C.URI.isUri(P)?P:C.URI.parse(D.toUrl(P))}}e.$2f=new l;var S;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function u($){let d;typeof $=="string"?d=new URL($).searchParams:$ instanceof URL?d=$.searchParams:C.URI.isUri($)&&(d=new URL($.toString(!0)).searchParams);const t=d?.get(D);if(t)return P.get(t)}g.getHeadersFromQuery=u;function b($,d,t){if(!globalThis.crossOriginIsolated)return;const i=d&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(D,i):$[D]=i}g.addSearchParam=b})(S||(e.COI=S={}))}),define(Ae[23],Re([1,0,42,13,19,22,15,2]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function S(b){return(0,l.$Tf)(b,!0)}e.$9f=S;class g{constructor($){this.a=$}compare($,d,t=!1){return $===d?0:(0,A.$Fe)(this.getComparisonKey($,t),this.getComparisonKey(d,t))}isEqual($,d,t=!1){return $===d?!0:!$||!d?!1:this.getComparisonKey($,t)===this.getComparisonKey(d,t)}getComparisonKey($,d=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,d,t=!1){if($.scheme===d.scheme){if($.scheme===F.Schemas.file)return v.$If(S($),S(d),this.a($))&&$.query===d.query&&(t||$.fragment===d.fragment);if((0,e.$ng)($.authority,d.authority))return v.$If($.path,d.path,this.a($),"/")&&$.query===d.query&&(t||$.fragment===d.fragment)}return!1}joinPath($,...d){return l.URI.joinPath($,...d)}basenameOrAuthority($){return(0,e.$fg)($)||$.authority}basename($){return C.$6d.basename($.path)}extname($){return C.$6d.extname($.path)}dirname($){if($.path.length===0)return $;let d;return $.scheme===F.Schemas.file?d=l.URI.file(C.$_d(S($))).path:(d=C.$6d.dirname($.path),$.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),d="/")),$.with({path:d})}normalizePath($){if(!$.path.length)return $;let d;return $.scheme===F.Schemas.file?d=l.URI.file(C.$7d(S($))).path:d=C.$6d.normalize($.path),$.with({path:d})}relativePath($,d){if($.scheme!==d.scheme||!(0,e.$ng)($.authority,d.authority))return;if($.scheme===F.Schemas.file){const o=C.$$d(S($),S(d));return T.$i?v.$Cf(o):o}let t=$.path||"/";const i=d.path||"/";if(this.a($)){let o=0;for(const h=Math.min(t.length,i.length);o<h&&!(t.charCodeAt(o)!==i.charCodeAt(o)&&t.charAt(o).toLowerCase()!==i.charAt(o).toLowerCase());o++);t=i.substr(0,o)+t.substr(o)}return C.$6d.relative(t,i)}resolvePath($,d){if($.scheme===F.Schemas.file){const t=l.URI.file(C.$0d(S($),d));return $.with({authority:t.authority,path:t.path})}return d=v.$Df(d),$.with({path:C.$6d.resolve($.path,d)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,d){return $===d||$!==void 0&&d!==void 0&&(0,A.$Me)($,d)}hasTrailingPathSeparator($,d=C.sep){if($.scheme===F.Schemas.file){const t=S($);return t.length>v.$Ef(t).length&&t[t.length-1]===d}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,d=C.sep){return(0,e.$og)($,d)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,d=C.sep){let t=!1;if($.scheme===F.Schemas.file){const i=S($);t=i!==void 0&&i.length===v.$Ef(i).length&&i[i.length-1]===d}else{d="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$og)($,d)?$.with({path:$.path+"/"}):$}}e.$0f=g,e.$$f=new g(()=>!1),e.$_f=new g(b=>b.scheme===F.Schemas.file?!T.$k:!0),e.$ag=new g(b=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function P(b,$){const d=[];for(let t=0;t<b.length;t++){const i=$(b[t]);b.some((o,h)=>h===t?!1:(0,e.$cg)(i,$(o)))||d.push(b[t])}return d}e.$rg=P;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function $(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(h=>{const[y,m]=h.split(":");y&&m&&t.set(y,m)});const o=d.path.substring(0,d.path.indexOf(";"));return o&&t.set(b.META_DATA_MIME,o),t}b.parseMetaData=$})(D||(e.DataUri=D={}));function u(b,$,d){if($){let t=b.path;return t&&t[0]!==C.$6d.sep&&(t=C.$6d.sep+t),b.with({scheme:d,authority:$,path:t})}return b.with({scheme:d})}e.$sg=u}),define(Ae[12],Re([1,0,21,9,5,6,23,22,121]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function g(z){return!!z&&typeof z.then=="function"}e.$tg=g;function P(z){const q=new v.$pd,le=z(q.token),we=new Promise((ve,ge)=>{const De=q.token.onCancellationRequested(()=>{De.dispose(),q.dispose(),ge(new F.$3)});Promise.resolve(le).then(ne=>{De.dispose(),q.dispose(),ve(ne)},ne=>{De.dispose(),q.dispose(),ge(ne)})});return new class{cancel(){q.cancel()}then(ve,ge){return we.then(ve,ge)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$ug=P;function D(z,q,le){return new Promise((we,ve)=>{const ge=q.onCancellationRequested(()=>{ge.dispose(),we(le)});z.then(we,ve).finally(()=>ge.dispose())})}e.$vg=D;function u(z,q){return new Promise((le,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new F.$3)});z.then(le,we).finally(()=>ve.dispose())})}e.$wg=u;async function b(z){let q=-1;const le=z.map((we,ve)=>we.then(ge=>(q=ve,ge)));try{return await Promise.race(le)}finally{z.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$xg=b;function $(z,q,le){let we;const ve=setTimeout(()=>{we?.(void 0),le?.()},q);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(ge=>we=ge)])}e.$yg=$;function d(z){return new Promise((q,le)=>{const we=z();g(we)?we.then(q,le):q(we)})}e.$zg=d;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const le=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(le,le).then(we)})}return new Promise((le,we)=>{this.b.then(le,we)})}return this.a=q(),new Promise((le,we)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$Ag=t;class i{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Bg=i;class o{constructor(){this.a=new Map}queue(q,le){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Cg=o;const h=(z,q)=>{let le=!0;const we=setTimeout(()=>{le=!1,q()},z);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},y=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class m{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,le=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,ge)=>{this.d=ve,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=le===S.$cd?y(we):h(le,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=m;class r{constructor(q){this.a=new m(q),this.b=new t}trigger(q,le){return this.a.trigger(()=>this.b.queue(q),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=r;class a{constructor(){this.a=!1,this.b=new Promise((q,le)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=a;class n extends a{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Gg=n;function c(z,q){return q?new Promise((le,we)=>{const ve=setTimeout(()=>{ge.dispose(),le()},z),ge=q.onCancellationRequested(()=>{clearTimeout(ve),ge.dispose(),we(new F.$3)})}):P(le=>c(z,le))}e.$Hg=c;function E(z,q=0){const le=setTimeout(z,q);return(0,T.$ic)(()=>clearTimeout(le))}e.$Ig=E;function p(z){const q=[];let le=0;const we=z.length;function ve(){return le<we?z[le++]():null}function ge(De){De!=null&&q.push(De);const ne=ve();return ne?ne.then(ge):Promise.resolve(q)}return Promise.resolve(null).then(ge)}e.$Jg=p;function I(z,q=we=>!!we,le=null){let we=0;const ve=z.length,ge=()=>{if(we>=ve)return Promise.resolve(le);const De=z[we++];return Promise.resolve(De()).then(he=>q(he)?Promise.resolve(he):ge())};return ge()}e.$Kg=I;function k(z,q=we=>!!we,le=null){if(z.length===0)return Promise.resolve(le);let we=z.length;const ve=()=>{we=-1;for(const ge of z)ge.cancel?.()};return new Promise((ge,De)=>{for(const ne of z)ne.then(he=>{--we>=0&&q(he)?(ve(),ge(he)):we===0&&ge(le)}).catch(he=>{--we>=0&&(ve(),De(he))})})}e.$Lg=k;class s{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((le,we)=>{this.f.push({factory:q,c:le,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const le=q.factory();le.then(q.c,q.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=s;class f extends s{constructor(){super(1)}}e.$Ng=f;class w{constructor(){this.a=new Ee,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Og=w;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new X;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,le=A.$$f){const we=le.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new f;const ge=this.f++,De=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$sc),this.d.set(ge,De),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=R;class W{constructor(q,le){this.a=-1,typeof q=="function"&&typeof le=="number"&&this.setIfNotSet(q,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},le)}setIfNotSet(q,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},le))}}e.$Qg=W;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setInterval(()=>{q()},le)}}e.$Rg=V;class U{constructor(q,le){this.b=-1,this.a=q,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=U;class B{constructor(q,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=q,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=B;class O extends U{constructor(q,le){super(q,le),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Ug=O;class N extends T.$kc{constructor(q,le){super(),this.g=q,this.h=le,this.a=[],this.b=this.B(new T.$lc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of q)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=z=>{(0,l.$A)(()=>{if(q)return;const le=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Wg=(z,q)=>{const le=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=ee;async function Y(z,q,le){let we;for(let ve=0;ve<le;ve++)try{return await z()}catch(ge){we=ge,await c(q)}throw we}e.$Yg=Y;class Ee{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,le,we){return this.a={taskId:q,cancel:()=>we?.(),promise:le},le.then(()=>this.d(q),()=>this.d(q)),le}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let le,we;const ve=new Promise((ge,De)=>{le=ge,we=De});this.b={run:q,promise:ve,promiseResolve:le,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=Ee;class ke{constructor(q,le=()=>Date.now()){this.d=q,this.f=le,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$1g=ke;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,le)=>{this.a=q,this.b=le})}complete(q){return new Promise(le=>{this.a(q),this.d={outcome:0,value:q},le()})}error(q){return new Promise(le=>{this.b(q),this.d={outcome:1,value:q},le()})}cancel(){return this.error(new F.$3)}}e.$2g=X;var ue;(function(z){async function q(we){let ve;const ge=await Promise.all(we.map(De=>De.then(ne=>ne,ne=>{ve||(ve=ne)})));if(typeof ve<"u")throw ve;return ge}z.settled=q;function le(we){return new Promise(async(ve,ge)=>{try{await we(ve,ge)}catch(De){ge(De)}})}z.withAsyncBody=le})(ue||(e.Promises=ue={}));var ye;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(ye||(ye={}));class ce{static fromArray(q){return new ce(le=>{le.emitMany(q)})}static fromPromise(q){return new ce(async le=>{le.emitMany(await q)})}static fromPromises(q){return new ce(async le=>{await Promise.all(q.map(async we=>le.emitOne(await we)))})}static merge(q){return new ce(async le=>{await Promise.all(q.map(async we=>{for await(const ve of we)le.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$fd,queueMicrotask(async()=>{const le={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(le)),this.j()}catch(we){this.k(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,le){return new ce(async we=>{for await(const ve of q)we.emitOne(le(ve))})}map(q){return ce.map(this,q)}static filter(q,le){return new ce(async we=>{for await(const ve of q)le(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,le=>!!le)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const le=[];for await(const we of q)le.push(we);return le}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$3g=ce;class $e extends ce{constructor(q,le){super(le),this.l=q}cancel(){this.l.cancel()}}e.$4g=$e;function ie(z){const q=new v.$pd,le=z(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new F.$3)});try{for await(const ge of le){if(q.token.isCancellationRequested)return;we.emitOne(ge)}ve.dispose(),q.dispose()}catch(ge){ve.dispose(),q.dispose(),we.reject(ge)}})}e.$5g=ie}),define(Ae[37],Re([1,0,18,12,42,28,19,22,15]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function g(){return Object.create(null)}e.$mj=g,e.$nj="**",e.$oj="/";const P="[/\\\\]",D="[^/\\\\]",u=/\//g;function b(Ee,ke){switch(Ee){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${ke?`|${P}${D}+`:""})*?`}}function $(Ee,ke){if(!Ee)return[];const Pe=[];let X=!1,ue=!1,ye="";for(const ce of Ee){switch(ce){case ke:if(!X&&!ue){Pe.push(ye),ye="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ye+=ce}return ye&&Pe.push(ye),Pe}e.$pj=$;function d(Ee){if(!Ee)return"";let ke="";const Pe=$(Ee,e.$oj);if(Pe.every(X=>X===e.$nj))ke=".*";else{let X=!1;Pe.forEach((ue,ye)=>{if(ue===e.$nj){if(X)return;ke+=b(2,ye===Pe.length-1)}else{let ce=!1,$e="",ie=!1,z="";for(const q of ue){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!z)){let le;q==="-"?le=q:(q==="^"||q==="!")&&!z?le="^":q===e.$oj?le="":le=(0,S.$qe)(q),z+=le;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${$($e,",").map(ve=>d(ve)).join("|")})`;ke+=we,ce=!1,$e="";break}case"]":{ke+="["+z+"]",ie=!1,z="";break}case"?":ke+=D;continue;case"*":ke+=b(1);continue;default:ke+=(0,S.$qe)(q)}}ye<Pe.length-1&&(Pe[ye+1]!==e.$nj||ye+2<Pe.length)&&(ke+=P)}X=ue===e.$nj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new T.$Ci(1e4),a=function(){return!1},n=function(){return null};function c(Ee,ke){if(!Ee)return n;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const X=`${Pe}_${!!ke.trimForExclusions}`;let ue=r.get(X);if(ue)return E(ue,Ee);let ye;return t.test(Pe)?ue=I(Pe.substr(4),Pe):(ye=i.exec(p(Pe,ke)))?ue=k(ye[1],Pe):(ke.trimForExclusions?h:o).test(Pe)?ue=s(Pe,ke):(ye=y.exec(p(Pe,ke)))?ue=f(ye[1].substr(1),Pe,!0):(ye=m.exec(p(Pe,ke)))?ue=f(ye[1],Pe,!1):ue=w(Pe),r.set(X,ue),E(ue,Ee)}function E(Ee,ke){if(typeof ke=="string")return Ee;const Pe=function(X,ue){return(0,C.$If)(X,ke.base,!l.$k)?Ee((0,S.$ue)(X.substr(ke.base.length),A.sep),ue):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function p(Ee,ke){return ke.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,ke){return function(Pe,X){return typeof Pe=="string"&&Pe.endsWith(Ee)?ke:null}}function k(Ee,ke){const Pe=`/${Ee}`,X=`\\${Ee}`,ue=function(ce,$e){return typeof ce!="string"?null:$e?$e===Ee?ke:null:ce===Ee||ce.endsWith(Pe)||ce.endsWith(X)?ke:null},ye=[Ee];return ue.basenames=ye,ue.patterns=[ke],ue.allBasenames=ye,ue}function s(Ee,ke){const Pe=ee(Ee.slice(1,-1).split(",").map($e=>c($e,ke)).filter($e=>$e!==n),Ee),X=Pe.length;if(!X)return n;if(X===1)return Pe[0];const ue=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return Ee;return null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function f(Ee,ke,Pe){const X=A.sep===A.$6d.sep,ue=X?Ee:Ee.replace(u,A.sep),ye=A.sep+ue,ce=A.$6d.sep+Ee;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===ue||ie.endsWith(ye)||!X&&(ie===Ee||ie.endsWith(ce)))?ke:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===ue||!X&&ie===Ee)?ke:null},$e.allPaths=[(Pe?"*/":"./")+Ee],$e}function w(Ee){try{const ke=new RegExp(`^${d(Ee)}$`);return function(Pe){return ke.lastIndex=0,typeof Pe=="string"&&ke.test(Pe)?Ee:null}}catch{return n}}function R(Ee,ke,Pe){return!Ee||typeof ke!="string"?!1:W(Ee)(ke,void 0,Pe)}e.$qj=R;function W(Ee,ke={}){if(!Ee)return a;if(typeof Ee=="string"||V(Ee)){const Pe=c(Ee,ke);if(Pe===n)return a;const X=function(ue,ye){return!!Pe(ue,ye)};return Pe.allBasenames&&(X.allBasenames=Pe.allBasenames),Pe.allPaths&&(X.allPaths=Pe.allPaths),X}return O(Ee,ke)}e.$rj=W;function V(Ee){const ke=Ee;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$sj=V;function U(Ee){return Ee.allBasenames||[]}e.$tj=U;function B(Ee){return Ee.allPaths||[]}e.$uj=B;function O(Ee,ke){const Pe=ee(Object.getOwnPropertyNames(Ee).map($e=>N($e,Ee[$e],ke)).filter($e=>$e!==n)),X=Pe.length;if(!X)return n;if(!Pe.some($e=>!!$e.requiresSiblings)){if(X===1)return Pe[0];const $e=function(q,le){let we;for(let ve=0,ge=Pe.length;ve<ge;ve++){const De=Pe[ve](q,le);if(typeof De=="string")return De;(0,F.$tg)(De)&&(we||(we=[]),we.push(De))}return we?(async()=>{for(const ve of we){const ge=await ve;if(typeof ge=="string")return ge}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,le)=>le.allPaths?q.concat(le.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const ue=function($e,ie,z){let q,le;for(let we=0,ve=Pe.length;we<ve;we++){const ge=Pe[we];ge.requiresSiblings&&z&&(ie||(ie=(0,A.$ae)($e)),q||(q=ie.substr(0,ie.length-(0,A.$be)($e).length)));const De=ge($e,ie,q,z);if(typeof De=="string")return De;(0,F.$tg)(De)&&(le||(le=[]),le.push(De))}return le?(async()=>{for(const we of le){const ve=await we;if(typeof ve=="string")return ve}return null})():null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function N(Ee,ke,Pe){if(ke===!1)return n;const X=c(Ee,Pe);if(X===n)return n;if(typeof ke=="boolean")return X;if(ke){const ue=ke.when;if(typeof ue=="string"){const ye=(ce,$e,ie,z)=>{if(!z||!X(ce,$e))return null;const q=ue.replace("$(basename)",()=>ie),le=z(q);return(0,F.$tg)(le)?le.then(we=>we?Ee:null):le?Ee:null};return ye.requiresSiblings=!0,ye}}return X}function ee(Ee,ke){const Pe=Ee.filter($e=>!!$e.basenames);if(Pe.length<2)return Ee;const X=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let ue;if(ke){ue=[];for(let $e=0,ie=X.length;$e<ie;$e++)ue.push(ke)}else ue=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const ye=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const le=$e.charCodeAt(q-1);if(le===47||le===92)break}ie=$e.substr(q)}const z=X.indexOf(ie);return z!==-1?ue[z]:null};ye.basenames=X,ye.patterns=ue,ye.allBasenames=X;const ce=Ee.filter($e=>!$e.basenames);return ce.push(ye),ce}function Y(Ee,ke){return(0,v.$sb)(Ee,ke,(Pe,X)=>typeof Pe=="string"&&typeof X=="string"?Pe===X:typeof Pe!="string"&&typeof X!="string"?Pe.base===X.base&&Pe.pattern===X.pattern:!1)}e.$vj=Y}),define(Ae[49],Re([1,0,9,122,23,15,2]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class S{constructor(i="",o=!1){if(this.value=i,typeof this.value!="string")throw(0,v.$5)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(i,o=0){return this.value+=u(this.supportThemeIcons?(0,F.$Rj)(i):i).replace(/([ \t]+)/g,(h,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,o){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}appendLink(i,o,h){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(i),")"),h&&(this.value+=` "${this.c(this.c(h,'"'),")")}"`),this.value+=")",this}c(i,o){const h=new RegExp((0,T.$qe)(o),"g");return i.replace(h,(y,m)=>i.charAt(m-1)!=="\\"?`\\${y}`:y)}}e.$Xj=S;function g(t){return P(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$Yj=g;function P(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Zj=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$bg)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$1j=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$2j=u;function b(t){return t.replace(/"/g,"&quot;")}e.$3j=b;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$4j=$;function d(t){const i=[],o=t.split("|").map(y=>y.trim());t=o[0];const h=o[1];if(h){const y=/height=(\d+)/.exec(h),m=/width=(\d+)/.exec(h),r=y?y[1]:"",a=m?m[1]:"",n=isFinite(parseInt(a)),c=isFinite(parseInt(r));n&&i.push(`width="${a}"`),c&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$5j=d}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nA=e.$mA=e.$lA=e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=void 0;function S(c,E){const{os:p,tildify:I,relative:k}=E;if(k){const w=g(c,k,p);if(typeof w=="string")return w}let s=c.fsPath;if(p===1&&!T.$i?s=s.replace(/\//g,"\\"):p!==1&&T.$i&&(s=s.replace(/\\/g,"/")),p!==1&&I?.userHome){const w=I.userHome.fsPath;let R;c.scheme!==I.userHome.scheme&&c.path.startsWith(C.$6d.sep)?R=I.userHome.with({path:c.path}).fsPath:R=c.fsPath,s=u(R,w,p)}return(p===1?C.$5d:C.$6d).normalize(P(s,p===1))}e.$eA=S;function g(c,E,p){const I=p===1?C.$5d:C.$6d,k=p===3?A.$$f:A.$ag,s=E.getWorkspace(),f=(0,v.$Mb)(s.folders);if(!f)return;c.scheme!==f.uri.scheme&&c.path.startsWith(C.$6d.sep)&&(c=f.uri.with({path:c.path}));const w=E.getWorkspaceFolder(c);if(!w)return;let R;if(k.isEqual(w.uri,c)?R="":R=k.relativePath(w.uri,c)??"",R&&(R=I.normalize(R)),s.folders.length>1&&!E.noPrefix){const W=w.name?w.name:k.basenameOrAuthority(w.uri);R=R?`${W} \u2022 ${R}`:W}return R}function P(c,E=T.$i){return(0,F.$Mf)(c,E)?c.charAt(0).toUpperCase()+c.slice(1):c}e.$fA=P;let D=Object.create(null);function u(c,E,p=T.OS){if(p===1||!c||!E)return c;let I=D.original===E?D.normalized:void 0;I||(I=E,T.$i&&(I=(0,F.$Cf)(I)),I=`${(0,l.$ve)(I,C.$6d.sep)}${C.$6d.sep}`,D={original:E,normalized:I});let k=c;return T.$i&&(k=(0,F.$Cf)(k)),(p===3?k.startsWith(I):(0,l.$Ne)(k,I))?`~/${k.substr(I.length)}`:c}e.$gA=u;function b(c,E){return c.replace(/^~($|\/|\\)/,`${E}$1`)}e.$hA=b;const $="\u2026",d="\\\\",t="~";function i(c,E=C.sep){const p=new Array(c.length);let I=!1;for(let k=0;k<c.length;k++){const s=c[k];if(s===""){p[k]=`.${E}`;continue}if(!s){p[k]=s;continue}I=!0;let f="",w=s;w.indexOf(d)===0?(f=w.substr(0,w.indexOf(d)+d.length),w=w.substr(w.indexOf(d)+d.length)):w.indexOf(E)===0?(f=w.substr(0,w.indexOf(E)+E.length),w=w.substr(w.indexOf(E)+E.length)):w.indexOf(t)===0&&(f=w.substr(0,w.indexOf(t)+t.length),w=w.substr(w.indexOf(t)+t.length));const R=w.split(E);for(let W=1;I&&W<=R.length;W++)for(let V=R.length-W;I&&V>=0;V--){I=!1;let U=R.slice(V,V+W).join(E);for(let B=0;!I&&B<c.length;B++)if(B!==k&&c[B]&&c[B].indexOf(U)>-1){const O=V+W===R.length,N=V>0&&c[B].indexOf(E)>-1?E+U:U,ee=c[B].endsWith(N);I=!O||ee}if(!I){let B="";(R[0].endsWith(":")||f!=="")&&(V===1&&(V=0,W++,U=R[0]+E+U),V>0&&(B=R[0]+E),B=f+B),V>0&&(B=B+$+E),B=B+U,V+W<R.length&&(B=B+E+$),p[k]=B}}I&&(p[k]=s)}return p}e.$iA=i;var o;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function h(c,E=Object.create(null)){const p=[];let I=!1,k="";for(const s of c)if(s==="$"||I&&s==="{")k&&p.push({value:k,type:o.TEXT}),k="",I=!0;else if(s==="}"&&I){const f=E[k];if(typeof f=="string")f.length&&p.push({value:f,type:o.VARIABLE});else if(f){const w=p[p.length-1];(!w||w.type!==o.SEPARATOR)&&p.push({value:f.label,type:o.SEPARATOR})}k="",I=!1}else k+=s;return k&&!I&&p.push({value:k,type:o.TEXT}),p.filter((s,f)=>{if(s.type===o.SEPARATOR){const w=p[f-1],R=p[f+1];return[w,R].every(W=>W&&(W.type===o.VARIABLE||W.type===o.TEXT)&&W.value.length>0)}return!0}).map(s=>s.value).join("")}e.$jA=h;function y(c,E){return T.$j||E?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):c.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.$kA=y;function m(c,E){return T.$j||E?c.replace(/\(&&\w\)|&&/g,""):T.$i?c.replace(/&&|&/g,p=>p==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.$lA=m;function r(c){return c.replace(/&/g,"&&")}e.$mA=r;function a(c){if(c.endsWith("]")){const E=c.lastIndexOf(" [",c.length-2);if(E!==-1){const p=n(c.substring(0,E));return{name:p.name,parentPath:p.parentPath+c.substring(E)}}}return n(c)}e.$nA=a;function n(c){const E=c.indexOf("/")!==-1?C.$6d:C.$5d,p=E.basename(c),I=E.dirname(c);return p.length?{name:p,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[133],Re([1,0,25,2]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function C(D){return D.toJSON()}class T{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:C(F.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:C(F.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:F.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Bm=T,e.$Cm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return u.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const d=A(D[$],u,b+1);d!==null&&(D[$]=d)}}return null}function l(D,u){const b=A(D,u,0);return b===null?D:b}e.$Dm=l;function S(D,u,b,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?F.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof v.$Fd)return null;for(const d in D)if(Object.hasOwnProperty.call(D,d)){const t=S(D[d],u,b,$+1);t!==null&&(D[d]=t)}}return null}function g(D,u){const b=S(D,u,!1,0);return b===null?D:b}e.$Em=g;function P(D,u){const b=S(D,u,!0,0);return b===null?D:b}e.$Fm=P}),define(Ae[134],Re([1,0,37,19]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cF=void 0;function C(T,A,l,S,g,P){if(Array.isArray(T)){let D=0;for(const u of T){const b=C(u,A,l,S,g,P);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof T=="string")return S?T==="*"?5:T===l?10:0:0;if(T){const{language:D,pattern:u,scheme:b,hasAccessToAllModels:$,notebookType:d}=T;if(!S&&!$)return 0;d&&g&&(A=g);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===l)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(d)if(d===P)t=10;else if(d==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,F.$7d)(u.base)},i===A.fsPath||(0,v.$qj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$cF=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0=e.$t0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function T(D){for(let u=0,b=D.length;u<b;u+=4){const $=D[u+0],d=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=d,D[u+3]=$}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.$C()||T(u),v.$Fd.wrap(u)}function l(D){const u=D.buffer;if(F.$C()||T(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(D){const u=new Uint32Array(g(D));let b=0;if(u[b++]=D.id,D.type==="full")u[b++]=1,u[b++]=D.data.length,u.set(D.data,b),b+=D.data.length;else{u[b++]=2,u[b++]=D.deltas.length;for(const $ of D.deltas)u[b++]=$.start,u[b++]=$.deleteCount,$.data?(u[b++]=$.data.length,u.set($.data,b),b+=$.data.length):u[b++]=0}return A(u)}e.$t0=S;function g(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(u+=b.data.length)}return u}function P(D){const u=l(D);let b=0;const $=u[b++];if(u[b++]===1){const o=u[b++],h=u.subarray(b,b+o);return b+=o,{id:$,type:"full",data:h}}const t=u[b++],i=[];for(let o=0;o<t;o++){const h=u[b++],y=u[b++],m=u[b++];let r;m>0&&(r=u.subarray(b,b+m),b+=m),i[o]={start:h,deleteCount:y,data:r}}return{id:$,type:"delta",deltas:i}}e.$u0=P}),define(Ae[135],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[136],Re([1,0,18,24,22,124,137,135]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(Z,pe,Ue,Ne){this.id=Z,this.name=pe,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Z,pe){return b(Z,pe)}compute(Z,pe,Ue){return Ue}}class u{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=u;function b(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new u(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const Ue=Array.isArray(_)&&Array.isArray(Z)&&v.$sb(_,Z);return new u(Z,!Ue)}let pe=!1;for(const Ue in Z)if(Z.hasOwnProperty(Ue)){const Ne=b(_[Ue],Z[Ue]);Ne.didChange&&(_[Ue]=Ne.newValue,pe=!0)}return new u(_,pe)}class ${constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return b(Z,pe)}validate(Z){return this.defaultValue}}class d{constructor(Z,pe,Ue,Ne){this.id=Z,this.name=pe,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Z,pe){return b(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,Ue){return Ue}}function t(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=t;class i extends d{constructor(Z,pe,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Ue),super(Z,pe,Ue,Ne)}validate(Z){return t(Z,this.defaultValue)}}function o(_,Z,pe,Ue){if(typeof _>"u")return Z;let Ne=parseInt(_,10);return isNaN(Ne)?Z:(Ne=Math.max(pe,Ne),Ne=Math.min(Ue,Ne),Ne|0)}e.clampedInt=o;class h extends d{static clampedInt(Z,pe,Ue,Ne){return o(Z,pe,Ue,Ne)}constructor(Z,pe,Ue,Ne,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ue,nt.minimum=Ne,nt.maximum=Ze),super(Z,pe,Ue,nt),this.minimum=Ne,this.maximum=Ze}validate(Z){return h.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function y(_,Z,pe,Ue){if(typeof _>"u")return Z;const Ne=m.float(_,Z);return m.clamp(Ne,pe,Ue)}e.clampedFloat=y;class m extends d{static clamp(Z,pe,Ue){return Z<pe?pe:Z>Ue?Ue:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const Ue=parseFloat(Z);return isNaN(Ue)?pe:Ue}constructor(Z,pe,Ue,Ne,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(Z,pe,Ue,Ze),this.validationFn=Ne}validate(Z){return this.validationFn(m.float(Z,this.defaultValue))}}class r extends d{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Ue),super(Z,pe,Ue,Ne)}validate(Z){return r.string(Z,this.defaultValue)}}function a(_,Z,pe,Ue){return typeof _!="string"?Z:Ue&&_ in Ue?Ue[_]:pe.indexOf(_)===-1?Z:_}e.stringSet=a;class n extends d{constructor(Z,pe,Ue,Ne,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ne,Ze.default=Ue),super(Z,pe,Ue,Ze),this.c=Ne}validate(Z){return a(Z,this.defaultValue,this.c)}}class c extends D{constructor(Z,pe,Ue,Ne,Ze,nt,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Ze,dt.default=Ne),super(Z,pe,Ue,dt),this.c=Ze,this.d=nt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function E(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,Ue){return Ue===0?Z.accessibilitySupport:Ue}}class I extends D{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function s(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function w(_){switch(_){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function R(_){switch(_){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class W extends ${constructor(){super(140)}compute(Z,pe,Ue){const Ne=["monaco-editor"];return pe.get(39)&&Ne.push(pe.get(39)),Z.extraEditorClassName&&Ne.push(Z.extraEditorClassName),pe.get(73)==="default"?Ne.push("mouse-default"):pe.get(73)==="copy"&&Ne.push("mouse-copy"),pe.get(110)&&Ne.push("showUnused"),pe.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Z,pe,Ue){return Ue&&Z.emptySelectionClipboard}}class U extends D{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:l.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:l.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":a(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":a(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class B extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?B.OFF:Z==="true"?B.ON:Z:Z?B.ON:B.OFF}}e.EditorFontLigatures=B;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?O.OFF:Z==="true"?O.TRANSLATE:Z:Z?O.TRANSLATE:O.OFF}compute(Z,pe,Ue){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends ${constructor(){super(50)}compute(Z,pe,Ue){return Z.fontInfo}}class ee extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Z){const pe=m.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(pe,6,100)}compute(Z,pe,Ue){return Z.fontInfo.fontSize}}class Y extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(h.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class Ee extends D{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ue,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ue,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ue,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ue,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ue,description:l.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:a(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??a(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??a(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??a(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??a(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??a(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends D{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:l.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:h.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:h.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class X extends ${constructor(){super(143)}compute(Z,pe,Ue){return X.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,Ue=Math.floor(Z.paddingTop/Z.lineHeight);let Ne=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ne=Math.max(Ne,pe-1));const Ze=(Ue+Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),nt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Ne,desiredRatio:Ze,minimapLineCount:nt}}static c(Z,pe){const Ue=Z.outerWidth,Ne=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=pe.stableMinimapLayoutInput,dt=nt&&Z.outerHeight===nt.outerHeight&&Z.lineHeight===nt.lineHeight&&Z.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===nt.pixelRatio&&Z.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Z.paddingTop===nt.paddingTop&&Z.paddingBottom===nt.paddingBottom&&Z.minimap.enabled===nt.minimap.enabled&&Z.minimap.side===nt.minimap.side&&Z.minimap.size===nt.minimap.size&&Z.minimap.showSlider===nt.minimap.showSlider&&Z.minimap.renderCharacters===nt.minimap.renderCharacters&&Z.minimap.maxColumn===nt.minimap.maxColumn&&Z.minimap.scale===nt.minimap.scale&&Z.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Z.isViewportWrapping===nt.isViewportWrapping,vt=Z.lineHeight,Ot=Z.typicalHalfwidthCharacterWidth,Zt=Z.scrollBeyondLastLine,qt=Z.minimap.renderCharacters;let wt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Nt=Z.minimap.maxColumn,zt=Z.minimap.size,Ht=Z.minimap.side,Pt=Z.verticalScrollbarWidth,At=Z.viewLineCount,jt=Z.remainingWidth,Bt=Z.isViewportWrapping,Kt=qt?2:3;let Wt=Math.floor(Ze*Ne);const Vt=Wt/Ze;let ot=!1,ft=!1,Rt=Kt*wt,Ft=wt/Ze,It=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:me,extraLinesBeyondLastLine:H,desiredRatio:Me,minimapLineCount:Be}=X.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Zt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ne,lineHeight:vt,pixelRatio:Ze});if(At/Be>1)ot=!0,ft=!0,wt=1,Rt=1,Ft=wt/Ze;else{let We=!1,xe=wt+1;if(zt==="fit"){const $t=Math.ceil((me+At+H)*Rt);Bt&&dt&&jt<=pe.stableFitRemainingWidth?(We=!0,xe=pe.stableFitMaxMinimapScale):We=$t>Wt}if(zt==="fill"||We){ot=!0;const $t=wt;Rt=Math.min(vt*Ze,Math.max(1,Math.floor(1/Me))),Bt&&dt&&jt<=pe.stableFitRemainingWidth&&(xe=pe.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(Rt/Kt))),wt>$t&&(It=Math.min(2,wt/$t)),Ft=wt/Ze/It,Wt=Math.ceil(Math.max(Fe,me+At+H)*Rt),Bt?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=jt,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ht=Math.floor(Nt*Ft),kt=Math.min(ht,Math.max(0,Math.floor((jt-Pt-2)*Ft/(Ot+Ft)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Ze*kt);const Mt=Dt/Ze;Dt=Math.floor(Dt*It);const Ve=qt?1:2,Ce=Ht==="left"?0:Ue-kt-Pt;return{renderMinimap:Ve,minimapLeft:Ce,minimapWidth:kt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:wt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:Vt}}static computeLayout(Z,pe){const Ue=pe.outerWidth|0,Ne=pe.outerHeight|0,Ze=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,dt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,Ot=pe.pixelRatio,Zt=pe.viewLineCount,qt=Z.get(135),wt=qt==="inherit"?Z.get(134):qt,Nt=wt==="inherit"?Z.get(130):wt,zt=Z.get(133),Ht=pe.isDominatedByLongLines,Pt=Z.get(57),At=Z.get(67).renderType!==0,jt=Z.get(68),Bt=Z.get(104),Kt=Z.get(83),Wt=Z.get(72),Vt=Z.get(102),ot=Vt.verticalScrollbarSize,ft=Vt.verticalHasArrows,Rt=Vt.arrowSize,Ft=Vt.horizontalScrollbarSize,It=Z.get(43),ht=Z.get(109)!=="never";let kt=Z.get(65);It&&ht&&(kt+=16);let Dt=0;if(At){const bt=Math.max(nt,jt);Dt=Math.round(bt*vt)}let Mt=0;Pt&&(Mt=Ze*pe.glyphMarginDecorationLaneCount);let Ve=0,Ce=Ve+Mt,Fe=Ce+Dt,me=Fe+kt;const H=Ue-Mt-Dt-kt;let Me=!1,Be=!1,Ge=-1;wt==="inherit"&&Ht?(Me=!0,Be=!0):Nt==="on"||Nt==="bounded"?Be=!0:Nt==="wordWrapColumn"&&(Ge=zt);const We=X.c({outerWidth:Ue,outerHeight:Ne,lineHeight:Ze,typicalHalfwidthCharacterWidth:dt,pixelRatio:Ot,scrollBeyondLastLine:Bt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Wt,verticalScrollbarWidth:ot,viewLineCount:Zt,remainingWidth:H,isViewportWrapping:Be},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Ve+=We.minimapWidth,Ce+=We.minimapWidth,Fe+=We.minimapWidth,me+=We.minimapWidth);const xe=H-We.minimapWidth,$t=Math.max(1,Math.floor((xe-ot-2)/dt)),Ct=ft?Rt:0;return Be&&(Ge=Math.max(1,$t),Nt==="bounded"&&(Ge=Math.min(Ge,zt))),{width:Ue,height:Ne,glyphMarginLeft:Ve,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:Dt,decorationsLeft:Fe,decorationsWidth:kt,contentLeft:me,contentWidth:xe,minimap:We,viewportColumn:$t,isWordWrapMinified:Me,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Ft,overviewRuler:{top:Ct,width:ot,height:Ne-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=X;class ue extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Z){return a(Z,"simple",["simple","advanced"])}compute(Z,pe,Ue){return pe.get(2)===2?"advanced":Ue}}class ye extends D{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:l.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class ce extends D{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:l.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:h.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends D{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:l.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:a(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:h.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):h.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,Ue){return Ue<0?h.clampedInt(-Ue*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class z extends m{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>m.clamp(Z,0,150),{markdownDescription:l.localize(63,null)})}compute(Z,pe,Ue){return Z.fontInfo.lineHeight}}class q extends D{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Z.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:l.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:a(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(pe.side,this.defaultValue.side,["right","left"]),showSlider:a(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(pe.scale,1,1,3),maxColumn:h.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:h.clampedInt(pe.top,0,0,1e3),bottom:h.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends D{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:l.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class ge extends ${constructor(){super(141)}compute(Z,pe,Ue){return Z.pixelRatio}}class De extends D{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:l.localize(82,null)},comments:{anyOf:pe,default:Z.comments,description:l.localize(83,null)},other:{anyOf:pe,default:Z.other,description:l.localize(84,null)}},default:Z,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ot=Z?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:Ue,strings:Ne}=Z,Ze=["on","inline","off"];let nt,dt,vt;return typeof pe=="boolean"?nt=pe?"on":"off":nt=a(pe,this.defaultValue.other,Ze),typeof Ue=="boolean"?dt=Ue?"on":"off":dt=a(Ue,this.defaultValue.comments,Ze),typeof Ne=="boolean"?vt=Ne?"on":"off":vt=a(Ne,this.defaultValue.strings,Ze),{other:nt,comments:dt,strings:vt}}}var ne;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class he extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Z){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,Ue=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function se(_){const Z=_.get(97);return Z==="editable"?_.get(90):Z!=="on"}e.filterValidationDecorations=se;class oe extends D{constructor(){const Z=[],pe={type:"number",description:l.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Z,description:l.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const Ue of Z)if(typeof Ue=="number")pe.push({column:h.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ne=Ue;pe.push({column:h.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort((Ue,Ne)=>Ue.column-Ne.column),pe}return this.defaultValue}}class fe extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends D{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:l.localize(104,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,Ue=h.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=h.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:h.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:h.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends D{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Z,pe){let Ue=!1;pe.allowedCharacters&&Z&&(F.$Zm(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},Ue=!0)),pe.allowedLocales&&Z&&(F.$Zm(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},Ue=!0));const Ne=super.applyUpdate(Z,pe);return Ue?new u(Ne.newValue,!0):Ne}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const Ue={};for(const[Ne,Ze]of Object.entries(Z))Ze===!0&&(Ue[Ne]=!0);return Ue}}class G extends D{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:l.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:a(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends D{constructor(){const Z={enabled:T.$Ur.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$Ur.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends D{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Z.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Z.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Z.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Z,pe){const Ue=pe.indexOf(_);return Ue===-1?Z:pe[Ue]}class ae extends D{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Z.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Z.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:a(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:a(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,Ue){return pe.get(2)===2?0:Ue}}class He extends ${constructor(){super(144)}compute(Z,pe,Ue){const Ne=pe.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class et extends D{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:a(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends D{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:a(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:_e,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var rt;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(rt||(e.EditorOption=rt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new p),accessibilityPageSize:ze(new h(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new J),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new h(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new h(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new c(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new h(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new h(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new et),stickyScroll:ze(new ce),experimentalWhitespaceRendering:ze(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new m(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:l.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new h(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new ee),fontWeight:ze(new Y),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new ke),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new m(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>m.clamp(_,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ye),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new h(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new n(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new m(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new c(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new h(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new h(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Xe),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new h(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new n(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new h(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new M),scrollBeyondLastColumn:ze(new h(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$k})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new h(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new h(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new h(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new h(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$Vr,{description:l.localize(337,null)})),wordWrap:ze(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new h(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new ge),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new X),wrappingInfo:ze(new He),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new ue)}}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,9,140]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function T(...g){switch(g.length){case 1:return(0,F.localize)(0,null,g[0]);case 2:return(0,F.localize)(1,null,g[0],g[1]);case 3:return(0,F.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,F.localize)(3,null),l=(0,F.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,v.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),u=S.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(l);return}const $=this.c.charCodeAt(P);if(D)D=!1;else if($===47&&!u){P++;break}else $===91?u=!0:$===92?D=!0:$===93&&(u=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=S}),define(Ae[170],Re([1,0,23,29,142,277]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function S(i){return i=i.trim(),i==="*"||A.test(i)}e.$Bo=S;function g(i){if(!S(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=i.match(A);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}e.$Co=g;function P(i){if(!i)return null;const o=i.majorBase,h=i.majorMustEqual,y=i.minorBase;let m=i.minorMustEqual;const r=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(o===0||(m=!1),a=!1);let n=0;if(i.preRelease){const c=l.exec(i.preRelease);if(c){const[,E,p,I]=c;n=Date.UTC(Number(E),Number(p)-1,Number(I))}}return{majorBase:o,majorMustEqual:h,minorBase:y,minorMustEqual:m,patchBase:r,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$Do=P;function D(i,o,h){let y;typeof i=="string"?y=P(g(i)):y=i;let m;o instanceof Date?m=o.getTime():typeof o=="string"&&(m=new Date(o).getTime());let r;if(typeof h=="string"?r=P(g(h)):r=h,!y||!r)return!1;const a=y.majorBase,n=y.minorBase,c=y.patchBase;let E=r.majorBase,p=r.minorBase,I=r.patchBase;const k=r.notBefore;let s=r.majorMustEqual,f=r.minorMustEqual,w=r.patchMustEqual;return r.isMinimum?a>E?!0:a<E?!1:n>p?!0:n<p||m&&m<k?!1:c>=I:(a===1&&E===0&&(!s||!f||!w)&&(E=1,p=0,I=0,s=!0,f=!1,w=!1),a<E?!1:a>E?!s:n<p?!1:n>p?!f:c<I?!1:c>I?!w:!(m&&m<k))}e.$Eo=D;function u(i,o,h,y,m){const r=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return r.push([F.default.Error,C.localize(0,null)]),r;if(typeof y.name!="string")return r.push([F.default.Error,C.localize(1,null,"name")]),r;if(typeof y.version!="string")return r.push([F.default.Error,C.localize(2,null,"version")]),r;if(!y.engines)return r.push([F.default.Error,C.localize(3,null,"engines")]),r;if(typeof y.engines.vscode!="string")return r.push([F.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof y.extensionDependencies<"u"&&!t(y.extensionDependencies))return r.push([F.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof y.activationEvents<"u"){if(!t(y.activationEvents))return r.push([F.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof y.main>"u"&&typeof y.browser>"u")return r.push([F.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&r.push([F.default.Warning,C.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return r.push([F.default.Error,C.localize(9,null,"main")]),r;{const c=(0,v.$ig)(h,y.main);(0,v.$cg)(c,h)||r.push([F.default.Warning,C.localize(10,null,c.path,h.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return r.push([F.default.Error,C.localize(11,null,"browser")]),r;{const c=(0,v.$ig)(h,y.browser);(0,v.$cg)(c,h)||r.push([F.default.Warning,C.localize(12,null,c.path,h.path)])}}if(!T.valid(y.version))return r.push([F.default.Error,C.localize(13,null)]),r;const a=[];if(!b(i,o,y,m,a))for(const c of a)r.push([F.default.Error,c]);return r}e.$Fo=u;function b(i,o,h,y,m){return y||typeof h.main>"u"&&typeof h.browser>"u"?!0:d(i,o,h.engines.vscode,m)}e.$Go=b;function $(i,o,h){return i==="*"||d(o,h,i)}e.$Ho=$;function d(i,o,h,y=[]){const m=P(g(h));if(!m)return y.push(C.localize(14,null,h)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return y.push(C.localize(15,null,h)),!1}else if(!m.majorMustEqual)return y.push(C.localize(16,null,h)),!1;return D(i,o,m)?!0:(y.push(C.localize(17,null,i,h)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let o=0,h=i.length;o<h;o++)if(typeof i[o]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class v{constructor(C,T=[],A=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$yh=v}),define(Ae[71],Re([1,0,70]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const F=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(l,S,g){S instanceof v.$yh||(S=new v.$yh(S,[],!!g)),F.push([l,S])}e.$mr=T;function A(){return F}e.$nr=A}),define(Ae[171],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class v{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$4p=v;class F{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const l=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(A);l.outgoing.set(S.key,S),S.incoming.set(l.key,l)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let l=this.a.get(A);return l||(l=new v(A,T),this.a.set(A,l)),l}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,l]of this.a)T.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const l=new Set([T]),S=this.c(A,l);if(S)return S}}c(T,A){for(const[l,S]of T.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const g=this.c(S,A);if(g)return g;A.delete(l)}}}e.$5p=F}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(v||(e._util=v={})),e.$Ah=C("instantiationService");function F(A,l,S){l[v.DI_TARGET]===l?l[v.DI_DEPENDENCIES].push({id:A,index:S}):(l[v.DI_DEPENDENCIES]=[{id:A,index:S}],l[v.DI_TARGET]=l)}function C(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const l=function(S,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(l,S,P)};return l.toString=()=>A,v.serviceIds.set(A,l),l}e.$Bh=C;function T(A){return A}e.$Ch=T}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,C.$Bh)("configurationService");function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof F.URI)}e.$9h=T;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof F.URI)}e.$0h=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function S(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=S;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$_h=g;function P(i,o){const h=Object.create(null);for(const y in i)D(h,y,i[y],o);return h}e.$ai=P;function D(i,o,h,y){const m=o.split("."),r=m.pop();let a=i;for(let n=0;n<m.length;n++){const c=m[n];let E=a[c];switch(typeof E){case"undefined":E=a[c]=Object.create(null);break;case"object":break;default:y(`Ignoring ${o} as ${m.slice(0,n+1).join(".")} is ${JSON.stringify(E)}`);return}a=E}if(typeof a=="object"&&a!==null)try{a[r]=h}catch{y(`Ignoring ${o} as ${m.join(".")} is ${JSON.stringify(a)}`)}else y(`Ignoring ${o} as ${m.join(".")} is ${JSON.stringify(a)}`)}e.$bi=D;function u(i,o){const h=o.split(".");b(i,h)}e.$ci=u;function b(i,o){const h=o.shift();if(o.length===0){delete i[h];return}if(Object.keys(i).indexOf(h)!==-1){const y=i[h];typeof y=="object"&&!Array.isArray(y)&&(b(y,o),Object.keys(y).length===0&&delete i[h])}}function $(i,o,h){function y(a,n){let c=a;for(const E of n){if(typeof c!="object"||c===null)return;c=c[E]}return c}const m=o.split("."),r=y(i,m);return typeof r>"u"?h:r}e.$di=$;function d(i,o,h){Object.keys(o).forEach(y=>{y!=="__proto__"&&(y in i?v.$lf(i[y])&&v.$lf(o[y])?d(i[y],o[y],h):h&&(i[y]=o[y]):i[y]=o[y])})}e.$ei=d;function t(i){return i.replace(/[\[\]]/g,"")}e.$fi=t}),define(Ae[32],Re([1,0,22,15,169,4,139,9]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",v.$j),S.set("isLinux",v.$k),S.set("isWindows",v.$i),S.set("isWeb",v.$o),S.set("isMacNative",v.$j&&!v.$o),S.set("isEdge",v.$G),S.set("isFirefox",v.$E),S.set("isChrome",v.$D),S.set("isSafari",v.$F);function g(ie,z){if(S.get(ie)!==void 0)throw(0,l.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(ie,z)}e.$Gi=g;const P=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),$=(0,A.localize)(1,null),d=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),o=(0,A.localize)(5,null),h=(0,A.localize)(6,null),y=(0,A.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=u){this.k=z,this.d=new C.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const le=this.D(),we=le.type===17?o:void 0;throw this.h.push({message:i,offset:le.offset,lexeme:C.$Fi.getLexeme(le),additionalInfo:we}),m.c}return q}catch(q){if(q!==m.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,ge=ve.lastIndexOf("/"),De=ge===ve.length-1?void 0:this.w(ve.substring(ge+1));let ne;try{ne=new RegExp(ve.substring(1,ge),De)}catch{throw this.B("REGEX",we)}return N.create(q,ne)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let ge=this.D(),De=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--;for(;!this.E()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let fe=0;fe<ge.lexeme.length;fe++)ge.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--}if(De<0)break;ve.push(C.$Fi.getLexeme(ge)),this.z(),ge=this.D()}const ne=ve.join(""),he=ne.lastIndexOf("/"),se=he===ne.length-1?void 0:this.w(ne.substring(he+1));let oe;try{oe=new RegExp(ne.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let ge=null;if(!(0,F.$me)(ve)){const De=ve.indexOf("/"),ne=ve.lastIndexOf("/");if(De!==ne&&De>=0){const he=ve.slice(De+1,ne),se=ve[ne+1]==="i"?"i":"";try{ge=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(ge===null)throw this.B("REGEX",we);return N.create(q,ge)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const we=this.u();return r.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(q,we);switch(we){case"true":return r.has(q);case"false":return r.not(q);default:return r.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(q,we);switch(we){case"true":return r.not(q);case"false":return r.has(q);default:return r.notEquals(q,we)}}case 5:return this.z(),B.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),U.create(q,this.u());case 13:return this.z(),r.in(q,this.u());default:return r.has(q)}}case 20:throw this.h.push({message:h,offset:z.offset,lexeme:"",additionalInfo:y}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,le){const we=(0,A.localize)(8,null,z,C.$Fi.getLexeme(q)),ve=q.offset,ge=C.$Fi.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:ge,additionalInfo:le}),m.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=m;class r{static false(){return E.INSTANCE}static true(){return p.INSTANCE}static has(z){return I.create(z)}static equals(z,q){return k.create(z,q)}static notEquals(z,q){return w.create(z,q)}static regex(z,q){return N.create(z,q)}static in(z,q){return s.create(z,q)}static notIn(z,q){return f.create(z,q)}static not(z){return R.create(z)}static and(...z){return Ee.create(z,null,!0)}static or(...z){return ke.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return U.create(z,q)}static smaller(z,q){return B.create(z,q)}static smallerEquals(z,q){return O.create(z,q)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Ii=r;function a(ie){const z=new m({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,A.localize)(9,null,le.additionalInfo):(0,A.localize)(10,null),offset:le.offset,length:le.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$Ji=a;function n(ie,z){const q=ie?ie.substituteConstants():void 0,le=z?z.substituteConstants():void 0;return!q&&!le?!0:!q||!le?!1:q.equals(le)}e.$Ki=n;function c(ie,z){return ie.cmp(z)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return p.INSTANCE}}e.$Li=E;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return E.INSTANCE}}e.$Mi=p;class I{static create(z,q=null){const le=S.get(z);return typeof le=="boolean"?le?p.INSTANCE:E.INSTANCE:new I(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:X(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=S.get(this.key);return typeof z=="boolean"?z?p.INSTANCE:E.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Ni=I;class k{static create(z,q,le=null){if(typeof q=="boolean")return q?I.create(z,le):R.create(z,le);const we=S.get(z);return typeof we=="boolean"?q===(we?"true":"false")?p.INSTANCE:E.INSTANCE:new k(z,q,le)}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=S.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?p.INSTANCE:E.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Oi=k;class s{static create(z,q){return new s(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),le=z.getValue(this.d);return Array.isArray(q)?q.includes(le):typeof le=="string"&&typeof q=="object"&&q!==null?P.call(q,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Pi=s;class f{static create(z,q){return new f(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=s.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=f;class w{static create(z,q,le=null){if(typeof q=="boolean")return q?R.create(z,le):I.create(z,le);const we=S.get(z);return typeof we=="boolean"?q===(we?"true":"false")?E.INSTANCE:p.INSTANCE:new w(z,q,le)}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=S.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?E.INSTANCE:p.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ri=w;class R{static create(z,q=null){const le=S.get(z);return typeof le=="boolean"?le?E.INSTANCE:p.INSTANCE:new R(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:X(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=S.get(this.c);return typeof z=="boolean"?z?E.INSTANCE:p.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Si=R;function W(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):E.INSTANCE}class V{static create(z,q,le=null){return W(q,we=>new V(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ti=V;class U{static create(z,q,le=null){return W(q,we=>new U(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ui=U;class B{static create(z,q,le=null){return W(q,we=>new B(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Vi=B;class O{static create(z,q,le=null){return W(q,we=>new O(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Wi=O;class N{static create(z,q){return new N(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",le=z.f?z.f.source:"";return q<le?-1:q>le?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",le=z.f?z.f.source:"";return this.d===z.d&&q===le}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Xi=N;class ee{static create(z){return new ee(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new ee(this.c.map(z))}negate(){return this.c}}e.$Yi=ee;function Y(ie){let z=null;for(let q=0,le=ie.length;q<le;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let ve=0;ve<q;ve++)z[ve]=ie[ve]}z!==null&&(z[q]=we)}return z===null?ie:z}class Ee{static create(z,q,le){return Ee.d(z,q,le)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=c(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Ee.create(z,this.c,!1)}evaluate(z){for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,le){const we=[];let ve=!1;for(const ge of z)if(ge){if(ge.type===1){ve=!0;continue}if(ge.type===0)return E.INSTANCE;if(ge.type===6){we.push(...ge.expr);continue}we.push(ge)}if(we.length===0&&ve)return p.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(c);for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];for(;we.length>1;){const ge=we[we.length-1];if(ge.type!==9)break;we.pop();const De=we.pop(),ne=we.length===0,he=ke.create(ge.expr.map(se=>Ee.create([se,De],null,le)),null,ne);he&&(we.push(he),we.sort(c))}if(we.length===1)return we[0];if(le){for(let ge=0;ge<we.length;ge++)for(let De=ge+1;De<we.length;De++)if(we[ge].negate().equals(we[De]))return E.INSTANCE;if(we.length===1)return we[0]}return new Ee(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new Ee(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=ke.create(z,this,!0)}return this.c}}e.$Zi=Ee;class ke{static create(z,q,le){return ke.d(z,q,le)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=c(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:ke.create(z,this.c,!1)}evaluate(z){for(let q=0,le=this.expr.length;q<le;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,le){let we=[],ve=!1;if(z){for(let ge=0,De=z.length;ge<De;ge++){const ne=z[ge];if(ne){if(ne.type===0){ve=!0;continue}if(ne.type===1)return p.INSTANCE;if(ne.type===9){we=we.concat(ne.expr);continue}we.push(ne)}}if(we.length===0&&ve)return E.INSTANCE;we.sort(c)}if(we.length!==0){if(we.length===1)return we[0];for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];if(le){for(let ge=0;ge<we.length;ge++)for(let De=ge+1;De<we.length;De++)if(we[ge].negate().equals(we[De]))return p.INSTANCE;if(we.length===1)return we[0]}return new ke(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ke(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),le=z.shift(),we=[];for(const ve of $e(q))for(const ge of $e(le))we.push(Ee.create([ve,ge],null,!1));z.unshift(ke.create(we,null,!1))}this.c=ke.create(z,this,!0)}return this.c}}e.$1i=ke;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,le){super(z,null),this.f=q,typeof le=="object"?Pe.d.push({...le,key:z}):le!==!0&&Pe.d.push({key:z,description:le,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return k.create(this.key,z)}notEqualsTo(z){return w.create(this.key,z)}}e.$2i=Pe,e.$3i=(0,T.$Bh)("contextKeyService");function X(ie,z){return ie<z?-1:ie>z?1:0}function ue(ie,z,q,le){return ie<q?-1:ie>q?1:z<le?-1:z>le?1:0}function ye(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(ye(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const q of ie.expr)if(ye(q,z))return!0;return!1}return ie.equals(z)}e.$4i=ye;function ce(ie,z){let q=0,le=0;for(;q<ie.length&&le<z.length;){const we=ie[q].cmp(z[le]);if(we<0)return!1;we===0&&q++,le++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[172],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,v.$Bh)("environmentService"),e.$Jh=(0,v.$Ch)(e.$Ih)}),define(Ae[92],Re([1,0,141,4]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function C(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=C;function T(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=T;function A(o,h){switch(o){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=A;function l(o,h){return h==="web"&&!o.includes("web")}e.$Vn=l;function S(o,h,y){return l(h,y)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===y?!0:g(y).includes(o)}e.$Wn=S;function g(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=g;function P(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Yn=P;var D;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var u;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var b;(function(o){o.Install="install",o.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var $;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Zn=(0,F.$Bh)("extensionGalleryService");var d;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(h,y){super(h),this.code=y,this.name=y}}e.$1n=i,e.$2n=(0,F.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,F.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,F.$Bh)("IExtensionTipsService"),e.$7n=(0,v.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,v.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,143,4,22,13]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,S.$Bh)("fileService");function D(X){return X.create===!0}e.$7j=D;var u;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var b;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var $;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function d(X){return!!(X.capabilities&2)}e.$8j=d;function t(X){return!!(X.capabilities&8)}e.$9j=t;function i(X){return!!(X.capabilities&131072)}e.$0j=i;function o(X){return!!(X.capabilities&4)}e.$$j=o;function h(X){return!!(X.capabilities&16)}e.$_j=h;function y(X){return d(X)?!!(X.capabilities&16384):!1}e.$ak=y;function m(X){return d(X)?!!(X.capabilities&32768):!1}e.$bk=m;function r(X){return!!(X.capabilities&65536)}e.$ck=r;function a(X){return!!(X.capabilities&2048)}e.$dk=a;var n;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(ue,ye){const ce=new c(ue.toString(),ye);return I(ce,ye),ce}constructor(ue,ye){super(ue),this.code=ye}}e.$ek=c;function E(X,ue){return c.create(X,ue)}e.$fk=E;function p(X){return X||E((0,l.localize)(0,null),n.Unknown)}e.$gk=p;function I(X,ue){return X.name=ue?`${ue} (FileSystemError)`:"FileSystemError",X}e.$hk=I;function k(X){if(!X)return n.Unknown;if(X instanceof c)return X.code;const ue=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ue)return n.Unknown;switch(ue[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ik=k;function s(X){if(X instanceof U)return X.fileOperationResult;switch(k(X)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$jk=s;var f;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class w{constructor(ue,ye,ce){this.resource=ue,this.operation=ye,this.target=ce}isOperation(ue){return this.operation===ue}}e.$kk=w;var R;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class W{constructor(ue,ye){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of ue){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=v.$Hh.forUris(()=>ye),this.a.fill(ie);break;case 0:this.b=v.$Hh.forUris(()=>ye),this.b.fill(ie);break;case 2:this.c=v.$Hh.forUris(()=>ye),this.c.fill(ie);break}}contains(ue,...ye){return this.d(ue,{includeChildren:!1},...ye)}affects(ue,...ye){return this.d(ue,{includeChildren:!0},...ye)}d(ue,ye,...ce){if(!ue)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(ue)||ye.includeChildren&&this.a?.findSuperstr(ue))||(!$e||ce.includes(0))&&(this.b?.get(ue)||ye.includeChildren&&this.b?.findSuperstr(ue))||(!$e||ce.includes(2))&&(this.c?.findSubstr(ue)||ye.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=W;function V(X,ue,ye){return!X||!ue||X===ue||ue.length>X.length?!1:(ue.charAt(ue.length-1)!==F.sep&&(ue+=F.sep),ye?(0,C.$Ne)(X,ue):X.indexOf(ue)===0)}e.$mk=V;class U extends Error{constructor(ue,ye,ce){super(ue),this.fileOperationResult=ye,this.options=ce}}e.$nk=U;class B extends U{constructor(ue,ye,ce,$e){super(ue,ye,$e),this.fileOperationResult=ye,this.size=ce}}e.$ok=B;class O extends U{constructor(ue,ye,ce){super(ue,2,ce),this.stat=ye}}e.$pk=O;var N;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var ee;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$xk="";function Y(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$yk=Y;async function Ee(X,ue){if(!ue.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(ye=>{const ce=ue.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===X.scheme&&$e.added&&(ce.dispose(),ye())})})}e.$zk=Ee;class ke{static{this.KB=1024}static{this.MB=ke.KB*ke.KB}static{this.GB=ke.MB*ke.KB}static{this.TB=ke.GB*ke.KB}static formatSize(ue){return(0,T.$nf)(ue)||(ue=0),ue<ke.KB?(0,l.localize)(1,null,ue.toFixed(0)):ue<ke.MB?(0,l.localize)(2,null,(ue/ke.KB).toFixed(2)):ue<ke.GB?(0,l.localize)(3,null,(ue/ke.MB).toFixed(2)):ue<ke.TB?(0,l.localize)(4,null,(ue/ke.GB).toFixed(2)):(0,l.localize)(5,null,(ue/ke.TB).toFixed(2))}}e.$Ak=ke;function Pe(X){const ue=typeof X=="string"||X?.scheme===P.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===P.Schemas.file?1024*ke.MB:ue?10*ke.MB:g.$o?50*ke.MB:1024*ke.MB}e.$Bk=Pe}),define(Ae[72],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class v{constructor(...C){this.a=new Map;for(const[T,A]of C)this.set(T,A)}set(C,T){const A=this.a.get(C);return this.a.set(C,T),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$zh=v}),define(Ae[173],Re([1,0,12,9,6,70,171,4,72,174]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new S.$zh,i=!1,o,h=P){this.f=t,this.g=i,this.h=o,this.i=h,this.o=new Set,this.f.set(l.$Ah,this),this._globalGraph=h?o?._globalGraph??new A.$5p(y=>y):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const o=$.traceInvocation(this.i,t);let h=!1;try{return t({get:m=>{if(h)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const r=this.m(m,o);if(!r)throw new Error(`[invokeFunction] unknown service '${m}'`);return r}},...i)}finally{h=!0,o.stop()}}createInstance(t,...i){let o,h;return t instanceof T.$yh?(o=$.traceCreation(this.i,t.ctor),h=this.j(t.ctor,t.staticArguments.concat(i),o)):(o=$.traceCreation(this.i,t),h=this.j(t,i,o)),o.stop(),h}j(t,i=[],o){const h=l._util.getServiceDependencies(t).sort((r,a)=>r.index-a.index),y=[];for(const r of h){const a=this.m(r.id,o);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),y.push(a)}const m=h.length>0?h[0].index:i.length;if(i.length!==m){console.trace(`[createInstance] First service dependency of ${t.name} at position ${m+1} conflicts with ${i.length} static arguments`);const r=m-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,m)}return Reflect.construct(t,i.concat(y))}k(t,i){if(this.f.get(t)instanceof T.$yh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const o=this.l(t);return o instanceof T.$yh?this.q(t,o,i.branch(t,!0)):(i.branch(t,!1),o)}q(t,i,o){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,o)}finally{this.o.delete(t)}}r(t,i,o){const h=new A.$5p(r=>r.id.toString());let y=0;const m=[{id:t,desc:i,_trace:o}];for(;m.length;){const r=m.pop();if(h.lookupOrInsertNode(r),y++>1e3)throw new D(h);for(const a of l._util.getServiceDependencies(r.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(a.id)),n instanceof T.$yh){const c={id:a.id,desc:n,_trace:r._trace.branch(a.id,!0)};h.insertEdge(r,c),m.push(c)}}}for(;;){const r=h.roots();if(r.length===0){if(!h.isEmpty())throw new D(h);break}for(const{data:a}of r){if(this.l(a.id)instanceof T.$yh){const c=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,c)}h.removeNode(a)}}return this.l(t)}s(t,i,o=[],h,y){if(this.f.get(t)instanceof T.$yh)return this.t(t,i,o,h,y);if(this.h)return this.h.s(t,i,o,h,y);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,o=[],h,y){if(h){const m=new u(void 0,this.g,this,this.i);m.c=String(t);const r=new Map,a=new v.$Xg(()=>{const n=m.j(i,o,y);for(const[c,E]of r){const p=n[c];if(typeof p=="function")for(const I of E)p.apply(n,I)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,c){if(!a.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let I=r.get(c);return I||(I=new g.$tc,r.set(c,I)),(s,f,w)=>{const R=I.push([s,f,w]);return(0,C.$ic)(R)}}if(c in n)return n[c];const E=a.value;let p=E[c];return typeof p!="function"||(p=p.bind(E),n[c]=p),p},set(n,c,E){return a.value[c]=E,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,o,y)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$6p=u;var b;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(b||(b={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const o=new $(3,t.toString());return this.h.push([t,i,o]),o}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function o(y,m){const r=[],a=new Array(y+1).join("	");for(const[n,c,E]of m.h)if(c&&E){i=!0,r.push(`${a}CREATES -> ${n}`);const p=o(y+1,E);p&&r.push(p)}else r.push(`${a}uses -> ${n}`);return r.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${o(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(h.join(`
`))}}e.$7p=$}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,u.$Bh)("logService"),e.$6i=(0,u.$Bh)("loggerService");function b(){return new Date().toISOString()}function $(s){return(0,g.$nf)(s)}e.$7i=$;var d;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$8i=d.Info;function t(s,f,w){switch(f){case d.Trace:s.trace(w);break;case d.Debug:s.debug(w);break;case d.Info:s.info(w);break;case d.Warning:s.warn(w);break;case d.Error:s.error(w);break;case d.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=t;function i(s,f=!1){let w="";for(let R=0;R<s.length;R++){let W=s[R];if(W instanceof Error&&(W=(0,v.$mi)(W,f)),typeof W=="object")try{W=JSON.stringify(W)}catch{}w+=(R>0?" ":"")+W}return w}class o extends T.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new F.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==d.Off&&this.b<=f}}e.$0i=o;class h extends o{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...w){this.f(d.Trace)&&this.g(d.Trace,i([f,...w],!0))}debug(f,...w){this.f(d.Debug)&&this.g(d.Debug,i([f,...w]))}info(f,...w){this.f(d.Info)&&this.g(d.Info,i([f,...w]))}warn(f,...w){this.f(d.Warning)&&this.g(d.Warning,i([f,...w]))}error(f,...w){if(this.f(d.Error))if(f instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=f.stack,this.g(d.Error,i(R))}else this.g(d.Error,i([f,...w]))}flush(){}}e.$$i=h;class y extends o{constructor(f=e.$8i){super(),this.setLevel(f),this.g=!l.$i}trace(f,...w){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,f,...w):console.log(`[main ${b()}]`,f,...w))}debug(f,...w){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,f,...w):console.log(`[main ${b()}]`,f,...w))}info(f,...w){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,f,...w):console.log(`[main ${b()}]`,f,...w))}warn(f,...w){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,f,...w):console.warn(`[main ${b()}]`,f,...w))}error(f,...w){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,f,...w):console.error(`[main ${b()}]`,f,...w))}dispose(){}flush(){}}e.$_i=y;class m extends o{constructor(f=e.$8i,w=!0){super(),this.g=w,this.setLevel(f)}trace(f,...w){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...w):console.log(f,...w))}debug(f,...w){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...w):console.log(f,...w))}info(f,...w){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...w):console.log(f,...w))}warn(f,...w){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...w):console.log(f,...w))}error(f,...w){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...w):console.error(f,...w))}dispose(){}flush(){}}e.$aj=m;class r extends o{constructor(f,w=e.$8i){super(),this.g=f,this.setLevel(w)}trace(f,...w){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(f),...w])}debug(f,...w){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(f),...w])}info(f,...w){this.f(d.Info)&&this.g.log(d.Info,[this.h(f),...w])}warn(f,...w){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(f),...w])}error(f,...w){this.f(d.Error)&&this.g.log(d.Error,[this.h(f),...w])}h(f){return typeof f=="string"?f:(0,v.$mi)(f,this.f(d.Trace))}dispose(){}flush(){}}e.$bj=r;class a extends o{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const w of this.g)w.setLevel(f);super.setLevel(f)}trace(f,...w){for(const R of this.g)R.trace(f,...w)}debug(f,...w){for(const R of this.g)R.debug(f,...w)}info(f,...w){for(const R of this.g)R.info(f,...w)}warn(f,...w){for(const R of this.g)R.warn(f,...w)}error(f,...w){for(const R of this.g)R.error(f,...w)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$cj=a;class n extends T.$kc{constructor(f,w,R){if(super(),this.h=f,this.j=w,this.b=new A.$zi,this.c=this.B(new F.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$fd),this.onDidChangeVisibility=this.g.event,R)for(const W of R)this.b.set(W.resource,{logger:void 0,info:W})}m(f){return(0,g.$jf)(f)?[...this.b.values()].find(w=>w.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,w){const R=this.n(f),W=(0,g.$jf)(f)?f:w?.id??(0,C.$pi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const U=w?.logLevel==="always"?d.Trace:w?.logLevel;V||(V=this.s(R,U??this.getLogLevel(R)??this.h,{...w,id:W}));const B={logger:V,info:{resource:R,id:W,logLevel:U,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(B.info),this.b.set(R,B),V}n(f){return(0,g.$jf)(f)?(0,S.$ig)(this.j,`${f}.log`):f}setLogLevel(f,w){if(P.URI.isUri(f)){const R=f,W=w,V=this.b.get(R);V&&W!==V.info.logLevel&&(V.info.logLevel=W===this.h?void 0:W,V.logger?.setLevel(W),this.b.set(V.info.resource,V),this.f.fire([R,W]))}else{this.h=f;for(const[R,W]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,w){const R=this.m(f);R&&w!==!R.info.hidden&&(R.info.hidden=!w,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,w]))}getLogLevel(f){let w;return f&&(w=this.b.get(f)?.info.logLevel),w??this.h}registerLogger(f){const w=this.b.get(f.resource);w?w.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const w=this.b.get(f);w&&(w.logger&&w.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=n;class c{constructor(){this.onDidChangeLogLevel=new F.$fd().event}setLevel(f){}getLevel(){return d.Info}trace(f,...w){}debug(f,...w){}info(f,...w){}warn(f,...w){}error(f,...w){}critical(f,...w){}dispose(){}flush(){}}e.$ej=c;class E extends c{}e.$fj=E;function p(s){if(s.verbose)return d.Trace;if(typeof s.logLevel=="string"){const f=k(s.logLevel.toLowerCase());if(f!==void 0)return f}return e.$8i}e.$gj=p;function I(s){switch(s){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$hj=I;function k(s){switch(s){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$ij=k,e.$jj=new D.$2i("logLevel",I(d.Info))}),define(Ae[175],Re([1,0,6,14]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class C extends v.$kc{constructor(A,l=[]){super(),this.a=new F.$cj([A,...l]),this.B(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$mN=C}),define(Ae[94],Re([1,0,29,144,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function g($,d){return d-$}S.compare=g;const P=Object.create(null);P[S.Error]=(0,F.localize)(0,null),P[S.Warning]=(0,F.localize)(1,null),P[S.Info]=(0,F.localize)(2,null);function D($){return P[$]||""}S.toString=D;function u($){switch($){case v.default.Error:return S.Error;case v.default.Warning:return S.Warning;case v.default.Info:return S.Info;case v.default.Ignore:return S.Hint}}S.fromSeverity=u;function b($){switch($){case S.Error:return v.default.Error;case S.Warning:return v.default.Warning;case S.Info:return v.default.Info;case S.Hint:return v.default.Ignore}}S.toSeverity=b}(A||(e.MarkerSeverity=A={}));var l;(function(S){const g="";function P(u){return D(u,!0)}S.makeKey=P;function D(u,b){const $=[g];return u.source?$.push(u.source.replace("\xA6","\\\xA6")):$.push(g),u.code?typeof u.code=="string"?$.push(u.code.replace("\xA6","\\\xA6")):$.push(u.code.value.replace("\xA6","\\\xA6")):$.push(g),u.severity!==void 0&&u.severity!==null?$.push(A.toString(u.severity)):$.push(g),u.message&&b?$.push(u.message.replace("\xA6","\\\xA6")):$.push(g),u.startLineNumber!==void 0&&u.startLineNumber!==null?$.push(u.startLineNumber.toString()):$.push(g),u.startColumn!==void 0&&u.startColumn!==null?$.push(u.startColumn.toString()):$.push(g),u.endLineNumber!==void 0&&u.endLineNumber!==null?$.push(u.endLineNumber.toString()):$.push(g),u.endColumn!==void 0&&u.endColumn!==null?$.push(u.endColumn.toString()):$.push(g),$.push(g),$.join("\xA6")}S.makeKeyOptionalMessage=D})(l||(e.IMarkerData=l={})),e.$3s=(0,C.$Bh)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Yu=e.Severity=void 0,e.Severity=F.default,e.$Yu=(0,C.$Bh)("notificationService");var T;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class S{constructor(){this.progress=new g,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Zu=S;class g{infinite(){}done(){}total(D){}worked(D){}}e.$1u=g}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PT=e.$OT=e.$NT=e.$MT=e.$LT=void 0,e.$LT=(0,C.$Bh)("openerService");function T(g,P){return F.URI.isUri(g)?(0,v.$Me)(g.scheme,P):(0,v.$Ne)(g,P+":")}e.$MT=T;function A(g,...P){return P.some(D=>T(g,D))}e.$NT=A;function l(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$OT=l;function S(g){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$PT=S}),define(Ae[177],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,v.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,v,F){var C=arguments.length,T=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,v):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(be,e,v,F);else for(var l=be.length-1;l>=0;l--)(A=be[l])&&(T=(C<3?A(T):C>3?A(e,v,T):A(e,v))||T);return C>3&&T&&Object.defineProperty(e,v,T),T},qe=this&&this.__param||function(be,e){return function(v,F){e(v,F,be)}};define(Ae[50],Re([1,0,12,21,6,4]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProgressLocation=e.$2u=void 0,e.$2u=(0,T.$Bh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$3u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,u){this.c=D,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(D){this.a=D,this.c(this.a)}e(D){Promise.resolve(this.b).finally(()=>{this.a=D;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$4u=l;let S=class extends C.$kc{constructor(D,u){super(),this.a=new v.$2g,u.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$ic)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$5u=S,e.$5u=S=Ke([qe(1,e.$2u)],S);class g extends C.$kc{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$jc)}start(D){this.stop();const u=++this.a,b=new F.$pd;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$ic)(()=>clearTimeout(this.f))),this.b.add((0,C.$ic)(()=>b.cancel())),this.b.add((0,C.$ic)(()=>this.c?this.c.done():void 0)),{id:u,token:b.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$6u=g,e.$7u=(0,T.$Bh)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class C{constructor(){this.a=new Map}add(A,l){v.ok(F.$jf(A)),v.ok(F.$lf(l)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$8m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class T{constructor(){this.b=new v.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,g){this.a[C(S)]=g,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;F.$8m.add(e.$9m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,138,43,73,30]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var g;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$an={Configuration:"base.contributions.configuration"};var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const D=S.$8m.as(l.$9m.JSONContribution);class u{constructor(){this.h=new Set,this.i=new F.$fd,this.onDidSchemaChange=this.i.event,this.j=new F.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(r,a=!0){this.registerConfigurations([r],a)}registerConfigurations(r,a=!0){const n=new Set;this.n(r,a,n),D.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(r){const a=new Set;this.o(r,a),D.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:r,remove:a}){const n=new Set;this.o(a,n),this.n(r,!1,n),D.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(r){const a=new Set;this.k(r,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(r,a){const n=[];for(const{overrides:c,source:E}of r)for(const p in c)if(a.add(p),e.$kn.test(p)){const I=this.a.get(p),k=I?.valuesSources??new Map;if(E)for(const R of Object.keys(c[p]))k.set(R,E);const s={...I?.value||{},...c[p]};this.a.set(p,{source:E,value:s,valuesSources:k});const f=(0,A.$fi)(p),w={type:"object",default:s,description:T.localize(1,null,f),$ref:e.$hn,defaultDefaultValue:s,source:C.$jf(E)?void 0:E,defaultValueSource:E};n.push(...d(p)),this.d[p]=w,this.b.properties[p]=w}else{this.a.set(p,{value:c[p],source:E});const I=this.d[p];I&&(this.w(p,I),this.r(p,I))}this.m(n)}deregisterDefaultConfigurations(r){const a=new Set;this.l(r,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(r,a){for(const{overrides:n,source:c}of r)for(const E in n){const p=this.a.get(E),I=C.$jf(c)?c:c?.id,k=C.$jf(p?.source)?p?.source:p?.source?.id;if(I===k)if(a.add(E),this.a.delete(E),e.$kn.test(E))delete this.d[E],delete this.b.properties[E];else{const s=this.d[E];s&&(this.w(E,s),this.r(E,s))}}this.u()}deltaConfiguration(r){let a=!1;const n=new Set;r.removedDefaults&&(this.l(r.removedDefaults,n),a=!0),r.addedDefaults&&(this.k(r.addedDefaults,n),a=!0),r.removedConfigurations&&this.o(r.removedConfigurations,n),r.addedConfigurations&&this.n(r.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const a of r)this.h.add(a);this.u()}n(r,a,n){r.forEach(c=>{this.p(c,a,c.extensionInfo,c.restrictedProperties,void 0,n),this.c.push(c),this.q(c)})}o(r,a){const n=c=>{if(c.properties)for(const E in c.properties){a.add(E);const p=this.d[E];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[E],this.s(E,c.properties[E])}c.allOf?.forEach(E=>n(E))};for(const c of r){n(c);const E=this.c.indexOf(c);E!==-1&&this.c.splice(E,1)}}p(r,a=!0,n,c,E=3,p){E=C.$sf(r.scope)?E:r.scope;const I=r.properties;if(I)for(const s in I){const f=I[s];if(a&&h(s,f)){delete I[s];continue}if(f.source=n,f.defaultDefaultValue=I[s].default,this.w(s,f),e.$kn.test(s)?f.scope=void 0:(f.scope=C.$sf(f.scope)?E:f.scope,f.restricted=C.$sf(f.restricted)?!!c?.includes(s):f.restricted),I[s].hasOwnProperty("included")&&!I[s].included){this.f[s]=I[s],delete I[s];continue}else this.d[s]=I[s],I[s].policy?.name&&this.e.set(I[s].policy.name,s);!I[s].deprecationMessage&&I[s].markdownDeprecationMessage&&(I[s].deprecationMessage=I[s].markdownDeprecationMessage),p.add(s)}const k=r.allOf;if(k)for(const s of k)this.p(s,a,n,c,E,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const a=n=>{const c=n.properties;if(c)for(const p in c)this.r(p,c[p]);n.allOf?.forEach(a)};a(r)}r(r,a){switch(e.$bn.properties[r]=a,a.scope){case 1:e.$cn.properties[r]=a;break;case 2:e.$dn.properties[r]=a;break;case 6:e.$en.properties[r]=a;break;case 3:e.$fn.properties[r]=a;break;case 4:e.$gn.properties[r]=a;break;case 5:e.$gn.properties[r]=a,this.g.properties[r]=a;break}}s(r,a){switch(delete e.$bn.properties[r],a.scope){case 1:delete e.$cn.properties[r];break;case 2:delete e.$dn.properties[r];break;case 6:delete e.$en.properties[r];break;case 3:delete e.$fn.properties[r];break;case 4:case 5:delete e.$gn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const a=`[${r}]`,n={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$hn};this.w(a,n),e.$bn.properties[a]=n,e.$cn.properties[a]=n,e.$dn.properties[a]=n,e.$en.properties[a]=n,e.$fn.properties[a]=n,e.$gn.properties[a]=n}}v(){const r={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=r,e.$cn.patternProperties[e.$jn]=r,e.$dn.patternProperties[e.$jn]=r,e.$en.patternProperties[e.$jn]=r,e.$fn.patternProperties[e.$jn]=r,e.$gn.patternProperties[e.$jn]=r,this.i.fire()}w(r,a){const n=this.a.get(r);let c=n?.value,E=n?.source;C.$qf(c)&&(c=a.defaultDefaultValue,E=void 0),C.$qf(c)&&(c=i(a.type)),a.default=c,a.defaultValueSource=E}}const b="\\[([^\\]]+)\\]",$=new RegExp(b,"g");e.$jn=`^(${b})+$`,e.$kn=new RegExp(e.$jn);function d(m){const r=[];if(e.$kn.test(m)){let a=$.exec(m);for(;a?.length;){const n=a[1].trim();n&&r.push(n),a=$.exec(m)}}return(0,v.$Kb)(r)}e.$ln=d;function t(m){return m.reduce((r,a)=>`${r}[${a}]`,"")}e.$mn=t;function i(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=i;const o=new u;S.$8m.add(e.$an.Configuration,o);function h(m,r){return m.trim()?e.$kn.test(m)?T.localize(7,null,m):o.getConfigurationProperties()[m]!==void 0?T.localize(8,null,m):r.policy?.name&&o.getPolicyConfigurations().get(r.policy?.name)!==void 0?T.localize(9,null,m,r.policy?.name,o.getPolicyConfigurations().get(r.policy?.name)):null:T.localize(6,null)}e.$on=h;function y(){const m=[],r=o.getConfigurationProperties();for(const a of Object.keys(r))m.push([a,r[a].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.$pn=y}),define(Ae[178],Re([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function b(a){return Object.isFrozen(a)?a:l.$Wm(a)}class ${constructor(n={},c=[],E=[],p){this.b=n,this.c=c,this.d=E,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(c=>{if(c instanceof $)return c;const E=new d("");return E.parseRaw(c),E.configurationModel});this.f=n.reduce((c,E)=>E===c?E:c.merge(E),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$di)(this.contents,n):this.contents}inspect(n,c){const E=this.rawConfiguration.getValue(n),p=c?this.rawConfiguration.getOverrideValue(n,c):void 0,I=c?this.rawConfiguration.override(c).getValue(n):E;return{value:E,override:p,merged:I}}getOverrideValue(n,c){const E=this.i(c);return E?n?(0,P.$di)(E,n):E:void 0}getKeysForOverrideIdentifier(n){const c=[];for(const E of this.overrides)E.identifiers.includes(n)&&c.push(...E.keys);return v.$Kb(c)}getAllOverrideIdentifiers(){const n=[];for(const c of this.overrides)n.push(...c.identifiers);return v.$Kb(n)}override(n){let c=this.a.get(n);return c||(c=this.g(n),this.a.set(n,c)),c}merge(...n){const c=l.$Vm(this.contents),E=l.$Vm(this.overrides),p=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of n)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(c,k.contents);for(const s of k.overrides){const[f]=E.filter(w=>v.$sb(w.identifiers,s.identifiers));f?(this.h(f.contents,s.contents),f.keys.push(...s.keys),f.keys=v.$Kb(f.keys)):E.push(l.$Vm(s))}for(const s of k.keys)p.indexOf(s)===-1&&p.push(s)}return new $(c,p,E,I.every(k=>k instanceof $)?void 0:I)}g(n){const c=this.i(n);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const E={};for(const p of v.$Kb([...Object.keys(this.contents),...Object.keys(c)])){let I=this.contents[p];const k=c[p];k&&(typeof I=="object"&&typeof k=="object"?(I=l.$Vm(I),this.h(I,k)):I=k),E[p]=I}return new $(E,this.keys,this.overrides)}h(n,c){for(const E of Object.keys(c)){if(E in n&&S.$lf(n[E])&&S.$lf(c[E])){this.h(n[E],c[E]);continue}n[E]=l.$Vm(c[E])}}i(n){let c=null,E=null;const p=I=>{I&&(E?this.h(E,I):E=l.$Vm(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===n?c=I.contents:I.identifiers.includes(n)&&p(I.contents);return p(c),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,c){this.j(n,c,!0)}setValue(n,c){this.j(n,c,!1)}removeValue(n){const c=this.keys.indexOf(n);c!==-1&&(this.keys.splice(c,1),(0,P.$ci)(this.contents,n),D.$kn.test(n)&&this.overrides.splice(this.overrides.findIndex(E=>v.$sb(E.identifiers,(0,D.$ln)(n))),1))}j(n,c,E){(0,P.$bi)(this.contents,n,c,p=>console.error(p)),E=E||this.keys.indexOf(n)===-1,E&&this.keys.push(n),D.$kn.test(n)&&this.overrides.push({identifiers:(0,D.$ln)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$ai)(this.contents[n],p=>console.error(p))})}}e.$qn=$;class d{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,c){if(!S.$sf(n)){const E=this.g(n);this.parseRaw(E,c)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,c){this.a=n;const{contents:E,keys:p,overrides:I,restricted:k,hasExcludedProperties:s}=this.h(n,c);this.b=new $(E,p,I,s?[n]:void 0),this.c=k||[]}g(n){let c={},E=null,p=[];const I=[],k=[];function s(w){Array.isArray(p)?p.push(w):E!==null&&(p[E]=w)}const f={onObjectBegin:()=>{const w={};s(w),I.push(p),p=w,E=null},onObjectProperty:w=>{E=w},onObjectEnd:()=>{p=I.pop()},onArrayBegin:()=>{const w=[];s(w),I.push(p),p=w,E=null},onArrayEnd:()=>{p=I.pop()},onLiteralValue:s,onError:(w,R,W)=>{k.push({error:w,offset:R,length:W})}};if(n)try{C.$Sm(n,f),c=p[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return c}h(n,c){const E=u.$8m.as(D.$an.Configuration).getConfigurationProperties(),p=this.i(n,E,!0,c);n=p.raw;const I=(0,P.$ai)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),k=Object.keys(n),s=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:I,keys:k,overrides:s,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(n,c,E,p){let I=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:I};const k={},s=[];for(const f in n)if(D.$kn.test(f)&&E){const w=this.i(n[f],c,!1,p);k[f]=w.raw,I=I||w.hasExcludedProperties,s.push(...w.restricted)}else{const w=c[f],R=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&s.push(f),!p.exclude?.includes(f)&&(p.include?.includes(f)||(R===void 0||p.scopes===void 0||p.scopes.includes(R))&&!(p.skipRestricted&&w?.restricted))?k[f]=n[f]:I=!0}return{raw:k,restricted:s,hasExcludedProperties:I}}j(n,c){const E=[];for(const p of Object.keys(n))if(D.$kn.test(p)){const I={};for(const k in n[p])I[k]=n[p][k];E.push({identifiers:(0,D.$ln)(p),keys:Object.keys(I),contents:(0,P.$ai)(I,c)})}return E}}e.$rn=d;class t extends T.$kc{constructor(n,c,E,p){super(),this.c=n,this.f=c,this.g=p,this.b=this.B(new F.$fd),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&E.isEqual(I.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=t;class i{constructor(n,c,E,p,I,k,s,f,w,R,W,V,U){this.a=n,this.b=c,this.c=E,this.overrideIdentifiers=p,this.d=I,this.f=k,this.g=s,this.h=f,this.i=w,this.j=R,this.k=W,this.l=V,this.m=U}get value(){return b(this.c)}n(n,c,E){const p=n.inspect(c,E);return{get value(){return b(p.value)},get override(){return b(p.override)},get merged(){return b(p.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class o{constructor(n,c,E,p,I=new $,k=new $,s=new A.$zi,f=new $,w=new A.$zi){this.c=n,this.d=c,this.f=E,this.g=p,this.h=I,this.i=k,this.j=s,this.l=f,this.m=w,this.a=null,this.b=new A.$zi,this.n=null}getValue(n,c,E){return this.q(n,c,E).getValue(n)}updateValue(n,c,E={}){let p;E.resource?(p=this.m.get(E.resource),p||(p=new $,this.m.set(E.resource,p))):p=this.l,c===void 0?p.removeValue(n):p.setValue(n,c),E.resource||(this.a=null)}inspect(n,c,E){const p=this.q(n,c,E),I=this.u(c.resource,E),k=c.resource?this.m.get(c.resource)||this.l:this.l,s=new Set;for(const f of p.overrides)for(const w of f.identifiers)p.getOverrideValue(n,w)!==void 0&&s.add(w);return new i(n,c,p.getValue(n),s.size?[...s]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,I||void 0,k)}keys(n){const c=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,c){this.j.set(n,c),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,c){const E=[];if(!c){const{added:p,updated:I,removed:k}=m(this.c,n);c=[...p,...I,...k]}for(const p of c)for(const I of(0,D.$ln)(p)){const k=this.c.getKeysForOverrideIdentifier(I),s=n.getKeysForOverrideIdentifier(I),f=[...s.filter(w=>k.indexOf(w)===-1),...k.filter(w=>s.indexOf(w)===-1),...k.filter(w=>!l.$Zm(this.c.override(I).getValue(w),n.override(I).getValue(w)))];E.push([I,f])}return this.updateDefaultConfiguration(n),{keys:c,overrides:E}}compareAndUpdatePolicyConfiguration(n){const{added:c,updated:E,removed:p}=m(this.d,n),I=[...c,...E,...p];return I.length&&this.updatePolicyConfiguration(n),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:c,updated:E,removed:p,overrides:I}=m(this.applicationConfiguration,n),k=[...c,...E,...p];return k.length&&this.updateApplicationConfiguration(n),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(n){const{added:c,updated:E,removed:p,overrides:I}=m(this.localUserConfiguration,n),k=[...c,...E,...p];return k.length&&this.updateLocalUserConfiguration(n),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(n){const{added:c,updated:E,removed:p,overrides:I}=m(this.remoteUserConfiguration,n),k=[...c,...E,...p];return k.length&&this.updateRemoteUserConfiguration(n),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(n){const{added:c,updated:E,removed:p,overrides:I}=m(this.workspaceConfiguration,n),k=[...c,...E,...p];return k.length&&this.updateWorkspaceConfiguration(n),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(n,c){const E=this.p.get(n),{added:p,updated:I,removed:k,overrides:s}=m(E,c),f=[...p,...I,...k];return(f.length||!E)&&this.updateFolderConfiguration(n,c),{keys:f,overrides:s}}compareAndDeleteFolderConfiguration(n){const c=this.p.get(n);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:E,updated:p,removed:I,overrides:k}=m(c,void 0);return{keys:[...E,...p,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,c,E){let p=this.r(c,E);return c.overrideIdentifier&&(p=p.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(p=p.merge(this.d)),p}r({resource:n},c){let E=this.s();if(c&&n){const p=c.getFolder(n);p&&(E=this.t(p.uri)||E);const I=this.m.get(n);I&&(E=E.merge(I))}return E}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let c=this.b.get(n);if(!c){const E=this.s(),p=this.j.get(n);p?(c=E.merge(p),this.b.set(n,c)):c=E}return c}u(n,c){if(c&&n){const E=c.getFolder(n);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,c)=>{const{contents:E,overrides:p,keys:I}=this.j.get(c);return n.push([c,{contents:E,overrides:p,keys:I}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(c=>n.add(c)),this.userConfiguration.keys.forEach(c=>n.add(c)),this.i.keys.forEach(c=>n.add(c)),this.j.forEach(c=>c.keys.forEach(E=>n.add(E))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(E=>n.add(E))),[...n.values()]}w(n){const c=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(E=>c.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(E=>c.add(E)),this.i.getKeysForOverrideIdentifier(n).forEach(E=>c.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(n).forEach(p=>c.add(p))),[...c.values()]}static parse(n){const c=this.x(n.defaults),E=this.x(n.policy),p=this.x(n.application),I=this.x(n.user),k=this.x(n.workspace),s=n.folders.reduce((f,w)=>(f.set(g.URI.revive(w[0]),this.x(w[1])),f),new A.$zi);return new o(c,E,p,I,new $,k,s,new $,new A.$zi)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$tn=o;function h(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,c=new Map;for(const p of a)p.keys.forEach(I=>n.add(I)),p.overrides.forEach(([I,k])=>{const s=(0,A.$wi)(c,I,new Set);k.forEach(f=>s.add(f))});const E=[];return c.forEach((p,I)=>E.push([I,[...p.values()]])),{keys:[...n.values()],overrides:E}}e.$un=h;class y{constructor(n,c,E,p){this.change=n,this.f=c,this.g=E,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of n.keys)this.affectedKeys.add(I);for(const[,I]of n.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=o.parse(this.f.data)),this.i}affectsConfiguration(n,c){const E=this.a+n,p=this.d.indexOf(E);if(p<0)return!1;const I=p+E.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(c){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,c,this.f?.workspace):void 0,f=this.g.getValue(n,c,this.h);return!l.$Zm(s,f)}return!0}}e.$vn=y;function m(a,n){const{added:c,removed:E,updated:p}=r(n?.rawConfiguration,a?.rawConfiguration),I=[],k=a?.getAllOverrideIdentifiers()||[],s=n?.getAllOverrideIdentifiers()||[];if(n){const f=s.filter(w=>!k.includes(w));for(const w of f)I.push([w,n.getKeysForOverrideIdentifier(w)])}if(a){const f=k.filter(w=>!s.includes(w));for(const w of f)I.push([w,a.getKeysForOverrideIdentifier(w)])}if(n&&a){for(const f of k)if(s.includes(f)){const w=r({contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});I.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:c,removed:E,updated:p,overrides:I}}function r(a,n){const c=a?n?a.keys.filter(I=>n.keys.indexOf(I)===-1):[...a.keys]:[],E=n?a?n.keys.filter(I=>a.keys.indexOf(I)===-1):[...n.keys]:[],p=[];if(a&&n){for(const I of n.keys)if(a.keys.indexOf(I)!==-1){const k=(0,P.$di)(n.contents,I),s=(0,P.$di)(a.contents,I);l.$Zm(k,s)||p.push(I)}}return{added:c,removed:E,updated:p}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,F.$Bh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=T;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=A;var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class S extends v.$_{static isNotAvailable(D){return D instanceof S&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof S&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof S&&D._code===l.NoResolverFound}static isInvalidAuthority(D){return D instanceof S&&D._code===l.InvalidAuthority}static isHandled(D){return D instanceof S&&D.isHandled}constructor(D,u=l.Unknown,b){super(D),this._message=D,this._code=u,this._detail=b,this.isHandled=u===l.NotAvailable&&b===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Mk=S;function g(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Nk=g}),define(Ae[52],Re([1,0,13]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function F(g){return g.scheme===v.Schemas.vscodeRemote?g.authority:void 0}e.$Ok=F;function C(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Pk=C;function T(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Qk=T;function A(g){const{host:P,port:D}=S(g);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$Rk=A;function l(g,P){let{host:D,port:u}=S(g);return typeof u>"u"&&(u=P),{host:D,port:u}}e.$Sk=l;function S(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=g.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=g.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:g,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$Tl=T,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class S{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const o=typeof t=="string"?t:t.value,h=typeof i=="string"?i:i.value;return v.$Me(o,h)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Vl=S;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(S.toKey(t))}delete(t){return this.c.delete(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}}e.$Wl=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(S.toKey(t))}get(t){return this.c.get(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}set(t,i){this.c.set(S.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=P;function D(d){return u(d)}e.$Yl=D;function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$Zl=u;function b(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$1l=b;function $(d,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Pk)(t)}`;return!!d.activationEvents?.includes(i)}return!1}e.$2l=$,e.$3l=(0,F.$Bh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const S of A){const g=this.readActivationEvents(S);g.length>0&&(l[F.$Vl.toKey(S.identifier)]=g)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const S in A.contributes){const g=this.a.get(S);if(!g)continue;const P=A.contributes[S],D=Array.isArray(P)?P:[P];try{g(D,l)}catch(u){(0,v.$Y)(u)}}return l}}e.$AF=C,e.$BF=new C}),define(Ae[179],Re([1,0,22,74,36]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function T(S){if(v.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,g,P,D,u,b,$,d){const t=Object.create(null);t["common.machineId"]=b,t.sessionID=(0,C.$4f)()+Date.now(),t.commitHash=D,t.version=u,t["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,v.$h)(v.$t),t["common.nodePlatform"]=F.$3d,t["common.nodeArch"]=P,t["common.product"]=d||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const o=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$l&&(t["common.snap"]="true");const h=T(g);return h&&(t["common.platformDetail"]=h),t}e.$0n=A;function l(S){const g=F.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return S.some(D=>P===D)}e.$$n=l}),define(Ae[180],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,v.$Bh)("telemetryService"),e.$0k=(0,v.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var F;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,179,180]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class g{constructor(E){this.value=E,this.isTrustedTelemetryValue=!0}}e.$_n=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=P,e.$bo=new P;class D{async publicLog(E,p,I){}async publicLogError(E,p,I){}}e.$co=D,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,E){return C.Event.debounce(E.onDidChangeConfiguration,(I,k)=>{const s=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:s}},1e3,!0)(I=>{I.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,T.$$h)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$go=u;function b(c,E){return!E.isBuilt&&!E.disableTelemetry?!0:!(E.disableTelemetry||!c.enableTelemetry||E.extensionTestsLocationURI)}e.$ho=b;function $(c,E){return!(E.isBuilt||E.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.$io=$;function d(c){const E=c.getValue(S.$dl),p=c.getValue(S.$el);if(c.getValue(S.$fl)===!1||p===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=d;function t(c){const E={},p={},I={};h(c,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const s=I[k];typeof s=="number"?p[k]=s:typeof s=="boolean"?p[k]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${s.length}`),E[k]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(E[k]=s)}return{properties:E,measurements:p}}e.$ko=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(c){if(!c)return"none";const E=(0,A.$Pk)(c);return i.has(E)?E:"other"}e.$lo=o;function h(c,E,p=0,I){if(c)for(const k of Object.getOwnPropertyNames(c)){const s=c[k],f=I?I+k:k;Array.isArray(s)?E[f]=(0,v.$1m)(s):s instanceof Date?E[f]=s.toISOString():(0,F.$lf)(s)?p<2?h(s,E,p+1,f+"."):E[f]=(0,v.$1m)(s):E[f]=s}}function y(c,E){const p=c.msftInternalDomains||[],I=E.getValue("telemetry.internalTesting");return(0,l.$$n)(p)||I}e.$mo=y;function m(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.$no=m;function r(c,E){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let p=c;const I=[];for(const w of E)for(;;){const R=w.exec(c);if(!R)break;I.push([R.index,w.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(p="";;){const w=s.exec(c);if(!w)break;const R=I.some(([W,V])=>w.index<V&&W<s.lastIndex);!k.test(w[0])&&!R&&(p+=c.substring(f,w.index)+"<REDACTED: user-file-path>",f=s.lastIndex)}return f<c.length&&(p+=c.substr(f)),p}function a(c){if(!c)return c;const E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of E)if(p.regex.test(c))return`<REDACTED: ${p.label}>`;return c}function n(c,E){return(0,v.$Xm)(c,p=>{if(p instanceof g||Object.hasOwnProperty.call(p,"isTrustedTelemetryValue"))return p.value;if(typeof p=="string"){let I=p.replaceAll("%20"," ");I=r(I,E);for(const k of E)I=I.replace(k,"");return I=a(I),I}})}e.$oo=n}),define(Ae[181],Re([1,0,15,92,20,22,2,9,74,53]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function P(n,c){return n.uuid&&c.uuid?n.uuid===c.uuid:n.id===c.id?!0:(0,v.$He)(n.id,c.id)===0}e.$po=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(c){const E=c.manifest?c.manifest.version:c.version,p=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new u(c.identifier,E,p)}static parse(c){const E=D.exec(c);return E&&E[1]&&E[2]?new u({id:E[1]},E[2],E[4]||void 0):null}constructor(c,E,p="undefined"){this.version=E,this.targetPlatform=p,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof u?P(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$qo=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const c=b.exec(n);return c&&c[1]?[t(c[1]),c[2]]:[t(n),void 0]}e.$ro=$;function d(n,c){return`${n}.${c}`}e.$so=d;function t(n){return n.toLowerCase()}e.$to=t;function i(n,c){return t(d(n??C.$Rl,c))}e.$uo=i;function o(n,c){const E=[],p=I=>{for(const k of E)if(k.some(s=>P(c(s),c(I))))return k;return null};for(const I of n){const k=p(I);k?k.push(I):E.push([I])}return E}e.$vo=o;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$wo=h;function y(n){return{id:new g.$_n(n.identifier.id),name:new g.$_n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$xo=y,e.$yo=new C.$Vl("pprice.better-merge");function m(n,c){const E=[],p=c.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const I=p.shift();if(I&&E.every(k=>!P(k.identifier,{id:I}))){const k=n.filter(s=>P(s.identifier,{id:I}));k.length===1&&(E.push(k[0]),p.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$zo=m;async function r(n,c){if(!T.$k)return!1;let E;try{E=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){c.debug("Error while getting the os-release file.",(0,l.$8)(I))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,c){const E=await r(n,c),p=(0,F.$Un)(E?"alpine":T.$t,S.$4d);return c.debug("ComputeTargetPlatform:",p),p}e.$Ao=a}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function v(S){return[...S.entries()]}e.$ar=v;function F(S){return S?[...S.entries()]:[]}e.$br=F;function C(S){return new Map(S)}e.$cr=C;function T(S){return new Map(S??[])}e.$dr=T;function A(S){return Array.from(S.entries()).map(g=>[g[0],v(g[1].map),F(g[1].descriptionMap)])}e.$er=A;function l(S){return new Map(S.map(g=>[g[0],{map:C(g[1]),descriptionMap:T(g[2])}]))}e.$fr=l}),define(Ae[183],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkb=void 0;class v{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,A=5){const l=T(S=>{const g=typeof S=="string"?S:S.data;let P=this.a.get(C);if(P){P.data.push(g);return}const D=setTimeout(()=>this.flushBuffer(C),A);P={data:[g],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),l.dispose()}},this.a.set(C,P)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$Qkb=v}),define(Ae[184],Re([1,0,12,89,40,5,16,2,145,73,30]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.IconFontDefinition=e.IconContribution=e.$8u=void 0,e.$8u={IconContribution:"base.contributions.icons"};var D;(function(y){function m(r,a){let n=r.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const c=$.getIcon(n.id);if(!c)return;n=c.defaults}return n}y.getDefinition=m})(D||(e.IconContribution=D={}));var u;(function(y){function m(a){return{weight:a.weight,style:a.style,src:a.src.map(n=>({format:n.format,location:n.location.toString()}))}}y.toJSONObject=m;function r(a){const n=c=>(0,A.$jf)(c)?c:void 0;if(a&&Array.isArray(a.src)&&a.src.every(c=>(0,A.$jf)(c.format)&&(0,A.$jf)(c.location)))return{weight:n(a.weight),style:n(a.style),src:a.src.map(c=>({format:c.format,location:l.URI.parse(c.location)}))}}y.fromJSONObject=r})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new T.$fd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(m,r,a,n){const c=this.b[m];if(c){if(a&&!c.description){c.description=a,this.d.properties[m].markdownDescription=`${a} $(${m})`;const I=this.e.enum.indexOf(m);I!==-1&&(this.e.enumDescriptions[I]=a),this.a.fire()}return c}const E={id:m,description:a,defaults:r,deprecationMessage:n};this.b[m]=E;const p={$ref:"#/definitions/icons"};return n&&(p.deprecationMessage=n),a&&(p.markdownDescription=`${a}: $(${m})`),this.d.properties[m]=p,this.e.enum.push(m),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:m}}deregisterIcon(m){delete this.b[m],delete this.d.properties[m];const r=this.e.enum.indexOf(m);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(m=>this.b[m])}getIcon(m){return this.b[m]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(m,r){const a=this.f[m];return a||(this.f[m]=r,this.a.fire(),r)}deregisterIconFont(m){delete this.f[m]}getIconFont(m){return this.f[m]}toString(){const m=(c,E)=>c.id.localeCompare(E.id),r=c=>{for(;C.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(c=>this.b[c]);for(const c of n.filter(E=>!!E.description).sort(m))a.push(`|<i class="${r(c)}"></i>|${c.id}|${C.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const c of n.filter(E=>!C.ThemeIcon.isThemeIcon(E.defaults)).sort(m))a.push(`|<i class="${r(c)}"></i>|${c.id}|`);return a.join(`
`)}}const $=new b;P.$8m.add(e.$8u.IconContribution,$);function d(y,m,r,a){return $.registerIcon(y,m,r,a)}e.$9u=d;function t(){return $}e.$0u=t;function i(){const y=(0,F.$Nj)();for(const m in y){const r="\\"+y[m].toString(16);$.registerIcon(m,{fontCharacter:r})}}i(),e.$$u="vscode://schemas/icons";const o=P.$8m.as(g.$9m.JSONContribution);o.registerSchema(e.$$u,$.getIconSchema());const h=new v.$Sg(()=>o.notifySchemaChanged(e.$$u),200);$.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.$_u=d("widget-close",F.$Pj.close,(0,S.localize)(2,null)),e.$av=d("goto-previous-location",F.$Pj.arrowUp,(0,S.localize)(3,null)),e.$bv=d("goto-next-location",F.$Pj.arrowDown,(0,S.localize)(4,null)),e.$cv=C.ThemeIcon.modify(F.$Pj.sync,"spin"),e.$dv=C.ThemeIcon.modify(F.$Pj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,4,14]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.ProvidedOnAutoForward=e.$Yz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xz=e.$Wz=void 0,e.$Wz=(0,C.$Bh)("tunnelService"),e.$Xz=(0,C.$Bh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function S(t){return!!t.forwardPort}e.$Yz=S;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Zz=P,e.$1z=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$1z.indexOf(t)>=0}e.$2z=D,e.$3z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$3z.indexOf(t)>=0}e.$4z=u;function b(t,i,o,h){if(o===1)return!1;if(o===2&&u(i)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(y?.length===4&&parseInt(y[1])>=18)return!1}return t<1024}e.$5z=b;class ${constructor(i,o,h){this.remoteAddress=i,this.localAddress=o,this.b=h,this.a=new v.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$6z=$;let d=class{constructor(i,o){this.j=i,this.k=o,this.a=new v.$fd,this.onTunnelOpened=this.a.event,this.b=new v.$fd,this.onTunnelClosed=this.b.event,this.c=new v.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],o=Array.from(this.e.values());for(const h of o){const y=Array.from(h.values());for(const m of y){const r=await m.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:o}of i.values())await o.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,o,h,y,m){this.p(i,o,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:o,localAddress:h,privacy:y,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,o){(u(i)||D(i))&&(i=e.$1z[0]);const h=this.r(i,o);if(h)return++h.refcount,h.value}openTunnel(i,o,h,y,m,r=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${h} on local port ${m}.`);const c=this.f??i;if(!c)return;if(o||(o="localhost"),y||(y=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const E=this.s(c,o,h,y,m,r,a,n);return E?E.then(p=>{if(p){if(typeof p=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(o,h),p}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(o,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(p);return(p.tunnelRemoteHost!==o||p.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&p.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),E)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const o=this.e.get(i.tunnelRemoteHost);if(o){const h=o.get(i.tunnelRemotePort);h&&(h.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async o(i,o,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${o}.`);const y=h.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(o),y}}async closeTunnel(i,o){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${o} `);const h=this.e.get(i);if(h&&h.has(o)){const y=h.get(o);y.refcount=0,await this.o(i,o,y)}}p(i,o,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(o,{refcount:1,value:h})}async q(i,o){const h=this.e.get(i);if(h){const y=h.get(o),m=y?await y.value:void 0;(!m||typeof m=="string")&&h.delete(o),h.size===0&&this.e.delete(i)}}r(i,o){const h=[i];D(i)?(h.push(...e.$1z),h.push(...e.$3z)):u(i)&&h.push(...e.$3z);const y=h.map(m=>this.e.get(m));for(const m of y){const r=m?.get(o);if(r)return r}}canTunnel(i){return!!P(i)}t(i,o,h,y,m,r,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${h} on local port ${y}.`);const n=h;this.i.add(n);const c=y===void 0?h:y,E={elevationRequired:m?this.isPortPrivileged(c):!1},p={remoteAddress:{host:o,port:h},localAddressPort:y,privacy:r,public:r?r!==l.Private:void 0,protocol:a},I=i.forwardPort(p,E);return I?(this.p(o,h,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),I}};e.$7z=d,e.$7z=d=Ke([qe(0,T.$5i),qe(1,F.$8h)],d)}),define(Ae[186],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$8z=void 0,e.$8z=(0,v.$Bh)("editSessionIdentityService");var F;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ae[187],Re([1,0,13]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=void 0;function F(S){return S.scheme!==v.Schemas.file&&S.scheme!==v.Schemas.vscodeRemote}e.$sJ=F;function C(S){if(S.folders.length)return S.folders.every(g=>F(g.uri))?S.folders[0].uri:void 0;if(S.configuration&&F(S.configuration))return S.configuration}e.$tJ=C;function T(S){return C(S)?.scheme}e.$uJ=T;function A(S){return C(S)?.authority}e.$vJ=A;function l(S){return C(S)!==void 0}e.$wJ=l}),define(Ae[54],Re([1,0,146,19,48,23,2,4,13]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,l.$Bh)("contextService");function g(c){const E=c;return typeof E?.id=="string"&&A.URI.isUri(E.uri)}e.$Lh=g;function P(c){return typeof c?.id=="string"&&!g(c)&&!u(c)}e.$Mh=P,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function D(c,E){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,F.$ae)(c)}:E?e.$Nh:e.$Oh;const p=c;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}e.$Ph=D;function u(c){const E=c;return typeof E?.id=="string"&&A.URI.isUri(E.configPath)}e.$Qh=u;function b(c){const E=c;if(E?.uri)return{id:E.id,uri:A.URI.revive(E.uri)};const p=c;if(p?.configPath)return{id:p.id,configPath:A.URI.revive(p.configPath)};if(c?.id)return{id:c.id}}e.$Rh=b;var $;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function d(c){const E=c;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$Sh=d;function t(c){const E=c;return!!(E&&typeof E=="object"&&A.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$Th=t;class i{constructor(E,p,I,k,s){this.h=E,this.j=I,this.k=k,this.l=s,this.c=C.$Hh.forUris(this.l,()=>!0),this.folders=p}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=C.$Hh.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=i;class o{constructor(E,p){this.raw=p,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,T.$ig)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=o;function h(c){return new o({uri:c,index:0,name:(0,T.$eg)(c)},{uri:c.toString()})}e.$Wh=h,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,v.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function y(c,E){return T.$_f.isEqualOrParent(c,E.untitledWorkspacesHome)}e.$2h=y;function m(c){let E;return A.URI.isUri(c)?E=c:E=c.configuration,E?.scheme===S.Schemas.tmp}e.$3h=m,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(c){return c.id===e.$4h}e.$5h=r;function a(c,E){return!y(c,E)&&!m(c)}e.$6h=a;function n(c){return(typeof c=="string"?(0,F.$be)(c):(0,T.$gg)(c))===e.$Yh}e.$7h=n}),define(Ae[55],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;class v{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Zac=v}),define(Ae[39],Re([1,0,13,23,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0;class T{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new F.$0f(l=>{const S=this.b.get(l.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(l,S){S===null?this.b.delete(l.scheme):this.b.set(l.scheme,S)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$2ac=T,e.$3ac=(0,C.$Bh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$fM=(0,v.$Bh)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;let A=class extends C.$mN{constructor(S,g,P){const D=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",u=P.remote.isRemote?(0,v.localize)(0,null):S?(0,v.localize)(1,null):(0,v.localize)(2,null);super(g.createLogger(D,{name:u}))}};e.$0cc=A,e.$0cc=A=Ke([qe(1,F.$6i),qe(2,T.$fM)],A)}),define(Ae[189],Re([1,0,12]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class F{constructor(A,l,S){this.h=new Map,this.a=A,this.b=l,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new v.$Sg(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const D of g.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let S=this.f[A];return typeof S>"u"&&(S=l),S}update(A,l){this.f[A]=l;const S=this.h.get(A);if(S!==void 0)return S.p;const g=new v.$2g;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$sbc=F;class C extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$tbc=C}),define(Ae[190],Re([1,0,5,2]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class C{constructor(A){this.c=A,this.a=new v.$fd,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$fd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,S,g){const D=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(l.value,S,g);this.b.fire(D)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Rcc=C}),define(Ae[17],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0,e.$2L=(0,v.$Bh)("IExtHostRpcService");class F{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$3L=F}),define(Ae[191],Re([1,0,20,5]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class C{#e;constructor(A,l){this.b=new F.$fd,this.onDidChange=this.b.event,this.a=v.$Vl.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$Ebc=C}),define(Ae[56],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=e.$abc=void 0,e.$abc=(0,v.$Bh)("IURITransformerService");class F{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$bbc=F}),define(Ae[192],Re([1,0,25]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bb=e.$9bb=void 0;class F{constructor(){this.buffers=[]}add(S){let g=this.buffers.indexOf(S);return g<0&&(g=this.buffers.length,this.buffers.push(S)),g}}function C(l,S){if(S.serializeBuffersForPostMessage){const g=new F,D=JSON.stringify(l,(b,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add($)};if(ArrayBuffer.isView($)){const d=T($);if(d)return{$$vscode_array_buffer_reference$$:!0,index:g.add($.buffer),view:{type:d,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),u=g.buffers.map(b=>{const $=new Uint8Array(b);return v.$Fd.wrap($)});return{message:D,buffers:u}}else return{message:JSON.stringify(l),buffers:[]}}e.$9bb=C;function T(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,S){const g=S.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),P=S.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const $=b,{index:d}=$,t=g[d];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(l,P),arrayBuffers:g}}e.$0bb=A}),define(Ae[99],Re([1,0,160,16,2,6,4,30,38,13,41,128,29]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7E=e.$6E=e.$5E=e.EditorsOrder=e.$4E=e.CloseDirection=e.$3E=e.$2E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.EditorInputCapabilities=e.$SE=e.SaveReason=e.Verbosity=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=void 0,e.$GE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$HE={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.$IE="workbench.editor.sidebysideEditor",e.$JE="workbench.editors.textDiffEditor",e.$KE="workbench.editors.binaryResourceDiffEditor";var b;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var $;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function d(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$LE=d;function t(ce,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ce.matches(z.input))return z.getViewState()}e.$ME=t;function i(ce){if(p(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$NE=i;function o(ce){if(p(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$OE=o;function h(ce){if(p(ce)||o(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$PE=h;function y(ce){if(p(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===g.Schemas.untitled||$e.forceUntitled===!0:!1}e.$QE=y;function m(ce){if(p(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$RE=m;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var a;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class n{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$SE=new n;var c;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(c||(e.EditorInputCapabilities=c={}));class E extends T.$kc{}e.$TE=E;function p(ce){return ce instanceof E}e.$UE=p;function I(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function k(ce){const $e=ce;return p($e?.primary)&&p($e?.secondary)}e.$VE=k;function s(ce){const $e=ce;return p($e?.modified)&&p($e?.original)}e.$WE=s;function f(ce,$e,ie,z,q){return ye(z,[(0,D.$li)({id:"workbench.action.openLargeFile",label:(0,v.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,le)}}),(0,D.$li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$XE=f;function w(ce){return p(ce?.editor)}e.$YE=w;function R(ce){const $e=ce;return w(ce)&&$e?.group!==void 0}e.$ZE=R;function W(ce){const $e=ce;return typeof $e?.groupId=="number"&&p($e.editor)}e.$1E=W;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var B;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri($e,ie){if(!$e)return;if(m($e))return e.$3E.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?q:le}}if(o($e)||h($e)||m($e))return;const z=I($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return k($e)||h($e)?{primary:$e.primary,secondary:$e.secondary}:s($e)||o($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(m($e))return e.$3E.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?q:le}}if(o($e)||h($e)||m($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ee(ce,$e,ie,z){if(!ce.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$2E=ee,e.$3E=new O;var Y;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$Ah);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,F.$uf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,T.$ic)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$8m.add(e.$GE.EditorFactory,new Ee);async function ke(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?S.FileType.Directory:S.FileType.Unknown,we=!0}catch(De){ie.error(De),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===S.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const ge={...z.options,pinned:!0};return we?{resource:q,options:ge}:{resource:q,options:ge,forceUntitled:!0}}))}e.$4E=ke;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function X(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return X(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$5E=X;function ue(ce){return(0,P.$ni)(ce)}e.$6E=ue;function ye(ce,$e,ie){const z=(0,P.$oi)(ce,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$7E=ye}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$_E=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=void 0,e.$8E=(0,u.$9u)("default-view-icon",D.$Pj.window,(0,F.localize)(0,null));var b;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var $;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$9E=[0,1,2];function d(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=d;class t extends T.$kc{constructor(){super(...arguments),this.c=this.B(new v.$fd),this.onDidRegister=this.c.event,this.f=this.B(new v.$fd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Pb)([...this.g.values()])}registerViewContainer(c,E,p){const I=this.get(c.id);if(I)return I;const k=c;return k.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$wi)(this.g,E,[]).push(k),p?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:E}),k}deregisterViewContainer(c){for(const E of this.g.keys()){const p=this.g.get(E),I=p?.indexOf(c);if(I!==-1){p?.splice(I,1),p.length===0&&this.g.delete(E),this.f.fire({viewContainer:c,viewContainerLocation:E});return}}}get(c){return this.all.filter(E=>E.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(E=>this.getViewContainers(E).filter(p=>p?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(E=>this.getViewContainerLocation(E)===c)}}l.$8m.add(b.ViewContainersRegistry,new t);var i;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(i||(e.ViewContentGroups=i={}));function o(n,c){const E=n.group??i.More,p=c.group??i.More;return E!==p?E.localeCompare(p):(n.order??5)-(c.order??5)}class h extends T.$kc{constructor(){super(...arguments),this.c=this.B(new v.$fd),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$fd),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$fd),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$fd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new g.$L}registerViews(c,E){this.registerViews2([{views:c,viewContainer:E}])}registerViews2(c){c.forEach(({views:E,viewContainer:p})=>this.r(E,p)),this.c.fire(c)}deregisterViews(c,E){const p=this.s(c,E);p.length&&this.f.fire({views:p,viewContainer:E})}moveViews(c,E){for(const p of this.m.keys())if(p!==E){const I=this.s(c,p);I.length&&(this.r(I,E),this.g.fire({views:I,from:p,to:E}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const E of this.j){const p=(this.m.get(E)||[]).filter(I=>I.id===c)[0];if(p)return p}return null}getViewContainer(c){for(const E of this.j)if((this.m.get(E)||[]).filter(I=>I.id===c)[0])return E;return null}registerViewWelcomeContent(c,E){return this.n.add(c,E),this.h.fire(c),(0,T.$ic)(()=>{this.n.delete(c,E),this.h.fire(c)})}registerViewWelcomeContent2(c,E){const p=new Map;for(const[I,k]of E)this.n.add(c,k),p.set(I,(0,T.$ic)(()=>{this.n.delete(c,k),this.h.fire(c)}));return this.h.fire(c),p}getViewWelcomeContent(c){const E=[];return this.n.forEach(c,p=>E.push(p)),E.sort(o)}r(c,E){let p=this.m.get(E);p||(p=[],this.m.set(E,p),this.j.push(E));for(const I of c){if(this.getView(I.id)!==null)throw new Error((0,F.localize)(1,null,I.id));p.push(I)}}s(c,E){const p=this.m.get(E);if(!p)return[];const I=[],k=[];for(const s of p)c.includes(s)?I.push(s):k.push(s);return I.length&&(k.length?this.m.set(E,k):(this.m.delete(E),this.j.splice(this.j.indexOf(E),1))),I}}l.$8m.add(b.ViewsRegistry,new h),e.$$E=(0,C.$Bh)("viewsService"),e.$_E=(0,C.$Bh)("viewDescriptorService");var y;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(y||(e.ViewVisibilityState=y={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class r{constructor(c,E){this.c=!1,this.d=!1,(0,P.$Ym)(this,c),this.d=!!E,this.resolve=async p=>{if(E&&!this.c){const I=await E(p);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$aF=r;class a extends Error{constructor(c){super((0,F.localize)(2,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$bF=a}),define(Ae[194],Re([1,0,5,12,162]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new v.$fd,this.n=new v.$fd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,S,g,P){const D={command:l};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:l,message:(0,C.localize)(0,null,P,l)};b($)}},P)}return g&&this.f.set(D.seq,g),D.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,S){return l.type!=="event"||S.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,F.$Hg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const S=l,g=this.f.get(S.request_seq);g&&(this.f.delete(S.request_seq),g(S));break}}}}s(l,S){S.type=l,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((S,g)=>l.set(g,S)),await(0,F.$Hg)(500),l.forEach((S,g)=>{S({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ccb=T}),define(Ae[195],Re([1,0,163,32,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$nH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$mH=e.MemoryRangeType=e.$lH=e.State=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=void 0,e.$jG="workbench.view.debug",e.$kG="workbench.debug.variablesView",e.$lG="workbench.debug.watchExpressionsView",e.$mG="workbench.debug.callStackView",e.$nG="workbench.debug.loadedScriptsView",e.$oG="workbench.debug.breakPointsView",e.$pG="workbench.debug.disassemblyView",e.$qG="workbench.panel.repl",e.$rG="workbench.panel.repl.view",e.$sG=new F.$2i("debugType",void 0,{type:"string",description:v.localize(0,null)}),e.$tG=new F.$2i("debugConfigurationType",void 0,{type:"string",description:v.localize(1,null)}),e.$uG=new F.$2i("debugState","inactive",{type:"string",description:v.localize(2,null)}),e.$vG="debugUx",e.$wG=new F.$2i(e.$vG,"default",{type:"string",description:v.localize(3,null)}),e.$xG=new F.$2i("hasDebugged",!1,{type:"boolean",description:v.localize(4,null)}),e.$yG=new F.$2i("inDebugMode",!1,{type:"boolean",description:v.localize(5,null)}),e.$zG=new F.$2i("inDebugRepl",!1,{type:"boolean",description:v.localize(6,null)}),e.$AG=new F.$2i("breakpointWidgetVisible",!1,{type:"boolean",description:v.localize(7,null)}),e.$BG=new F.$2i("inBreakpointWidget",!1,{type:"boolean",description:v.localize(8,null)}),e.$CG=new F.$2i("breakpointsFocused",!0,{type:"boolean",description:v.localize(9,null)}),e.$DG=new F.$2i("watchExpressionsFocused",!0,{type:"boolean",description:v.localize(10,null)}),e.$EG=new F.$2i("watchExpressionsExist",!1,{type:"boolean",description:v.localize(11,null)}),e.$FG=new F.$2i("variablesFocused",!0,{type:"boolean",description:v.localize(12,null)}),e.$GG=new F.$2i("expressionSelected",!1,{type:"boolean",description:v.localize(13,null)}),e.$HG=new F.$2i("breakpointInputFocused",!1,{type:"boolean",description:v.localize(14,null)}),e.$IG=new F.$2i("callStackItemType",void 0,{type:"string",description:v.localize(15,null)}),e.$JG=new F.$2i("callStackSessionIsAttach",!1,{type:"boolean",description:v.localize(16,null)}),e.$KG=new F.$2i("callStackItemStopped",!1,{type:"boolean",description:v.localize(17,null)}),e.$LG=new F.$2i("callStackSessionHasOneThread",!1,{type:"boolean",description:v.localize(18,null)}),e.$MG=new F.$2i("watchItemType",void 0,{type:"string",description:v.localize(19,null)}),e.$NG=new F.$2i("canViewMemory",void 0,{type:"boolean",description:v.localize(20,null)}),e.$OG=new F.$2i("breakpointItemType",void 0,{type:"string",description:v.localize(21,null)}),e.$PG=new F.$2i("breakpointSupportsCondition",!1,{type:"boolean",description:v.localize(22,null)}),e.$QG=new F.$2i("loadedScriptsSupported",!1,{type:"boolean",description:v.localize(23,null)}),e.$RG=new F.$2i("loadedScriptsItemType",void 0,{type:"string",description:v.localize(24,null)}),e.$SG=new F.$2i("focusedSessionIsAttach",!1,{type:"boolean",description:v.localize(25,null)}),e.$TG=new F.$2i("stepBackSupported",!1,{type:"boolean",description:v.localize(26,null)}),e.$UG=new F.$2i("restartFrameSupported",!1,{type:"boolean",description:v.localize(27,null)}),e.$VG=new F.$2i("stackFrameSupportsRestart",!1,{type:"boolean",description:v.localize(28,null)}),e.$WG=new F.$2i("jumpToCursorSupported",!1,{type:"boolean",description:v.localize(29,null)}),e.$XG=new F.$2i("stepIntoTargetsSupported",!1,{type:"boolean",description:v.localize(30,null)}),e.$YG=new F.$2i("breakpointsExist",!1,{type:"boolean",description:v.localize(31,null)}),e.$ZG=new F.$2i("debuggersAvailable",!1,{type:"boolean",description:v.localize(32,null)}),e.$1G=new F.$2i("debugExtensionAvailable",!0,{type:"boolean",description:v.localize(33,null)}),e.$2G=new F.$2i("debugProtocolVariableMenuContext",void 0,{type:"string",description:v.localize(34,null)}),e.$3G=new F.$2i("debugSetVariableSupported",!1,{type:"boolean",description:v.localize(35,null)}),e.$4G=new F.$2i("debugSetExpressionSupported",!1,{type:"boolean",description:v.localize(36,null)}),e.$5G=new F.$2i("breakWhenValueChangesSupported",!1,{type:"boolean",description:v.localize(37,null)}),e.$6G=new F.$2i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:v.localize(38,null)}),e.$7G=new F.$2i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:v.localize(39,null)}),e.$8G=new F.$2i("terminateDebuggeeSupported",!1,{type:"boolean",description:v.localize(40,null)}),e.$9G=new F.$2i("suspendDebuggeeSupported",!1,{type:"boolean",description:v.localize(41,null)}),e.$0G=new F.$2i("variableEvaluateNamePresent",!1,{type:"boolean",description:v.localize(42,null)}),e.$$G=new F.$2i("variableIsReadonly",!1,{type:"boolean",description:v.localize(43,null)}),e.$_G=new F.$2i("exceptionWidgetVisible",!1,{type:"boolean",description:v.localize(44,null)}),e.$aH=new F.$2i("multiSessionRepl",!1,{type:"boolean",description:v.localize(45,null)}),e.$bH=new F.$2i("multiSessionDebug",!1,{type:"boolean",description:v.localize(46,null)}),e.$cH=new F.$2i("disassembleRequestSupported",!1,{type:"boolean",description:v.localize(47,null)}),e.$dH=new F.$2i("disassemblyViewFocus",!1,{type:"boolean",description:v.localize(48,null)}),e.$eH=new F.$2i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:v.localize(49,null)}),e.$fH=new F.$2i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:v.localize(50,null)});const T=u=>v.localize(51,null,u);e.$gH=T,e.$hH="editor.contrib.debug",e.$iH="editor.contrib.breakpoint",e.$jH="debug",e.$kH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:v.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function l(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$lH=l;var S;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$mH="vscode-debug-memory";var g;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$nH=(0,C.$Bh)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ae[196],Re([1,0,15,2,19,24,13,44,21,18]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const P=/{([^}]+)}/g;function D(k,s,f){return k.replace(P,function(w,R){return s&&R.length>0&&R[0]!=="_"?w:f&&f.hasOwnProperty(R)?f[R]:w})}e.$iF=D;function u(k){const s={};for(const f of Object.keys(k))f.startsWith("!")||(s[f]=k[f]);return s}e.$jF=u;function b(k){return k.configuration.request==="attach"&&!$(k)&&(!k.parentSession||b(k.parentSession))}e.$kF=b;function $(k){let s=k.configuration.type;if(s)return s==="vslsShare"&&(s=k.configuration.adapterProxy.configuration.type),(0,v.$Me)(s,"extensionhost")||(0,v.$Me)(s,"pwa-extensionhost")?k:k.parentSession?$(k.parentSession):void 0}e.$lF=$;function d(k){return k.type&&(k.label||k.program||k.runtime)}e.$mF=d;function t(k,s,f){let w,R=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=W.exec(k);){const U=V.index+1,B=U+V[0].length;if(U<=s&&B>=f){w=V[0],R=U;break}}if(w){const U=/\w+/g;let B=null;for(;(B=U.exec(w))&&!(B.index+1+R+B[0].length>=f););B&&(w=w.substring(0,U.lastIndex))}return w?{start:R,end:R+w.length-1}:{start:0,end:0}}e.$nF=t;async function i(k,s,f,w){if(k.evaluatableExpressionProvider.has(s)){const R=k.evaluatableExpressionProvider.ordered(s),W=(0,g.$Fb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(s,f,w??S.CancellationToken.None)}catch{return}})));if(W.length>0){let V=W[0].expression;const U=W[0].range;return V||(V=s.getLineContent(f.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const R=s.getLineContent(f.lineNumber),{start:W,end:V}=t(R,f.column,f.column),U=R.substring(W-1,V);return{matchingExpression:U,range:new l.$ks(f.lineNumber,W,f.lineNumber,W+U.length)}}return null}e.$oF=i;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(k){return!!(k&&k.match(o))}e.$pF=h;function y(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(h(k.path))return F.URI.parse(k.path);if((0,C.$8d)(k.path))return F.URI.file(k.path)}return k.path}function m(k){if(typeof k.path=="object"){const s=F.URI.revive(k.path);if(s)return s.scheme===A.Schemas.file?s.fsPath:s.toString()}return k.path}function r(k,s){const f=s?y:m,w=(0,T.$Vm)(k);return n(w,(R,W)=>{R&&W&&(W.path=f(W))}),w}e.$qF=r;function a(k,s){const f=s?y:m,w=(0,T.$Vm)(k);return n(w,(R,W)=>{!R&&W&&(W.path=f(W))}),w}e.$rF=a;function n(k,s){switch(k.type){case"event":{const f=k;switch(f.event){case"output":s(!1,f.body.source);break;case"loadedSource":s(!1,f.body.source);break;case"breakpoint":s(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=k;switch(f.command){case"setBreakpoints":s(!0,f.arguments.source);break;case"breakpointLocations":s(!0,f.arguments.source);break;case"source":s(!0,f.arguments.source);break;case"gotoTargets":s(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(w=>s(!1,w));break;default:break}break}case"response":{const f=k;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(w=>s(!1,w.source));break;case"loadedSources":f.body.sources.forEach(w=>s(!1,w));break;case"scopes":f.body.scopes.forEach(w=>s(!1,w.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(w=>s(!1,w.source));break;case"setBreakpoints":f.body.breakpoints.forEach(w=>s(!1,w.source));break;case"disassemble":f.body?.instructions.forEach(R=>s(!1,R.location));break;default:break}break}}}function c(k){return k.filter(s=>!s.presentation?.hidden).sort((s,f)=>s.presentation?f.presentation?s.presentation.group?f.presentation.group?s.presentation.group!==f.presentation.group?s.presentation.group.localeCompare(f.presentation.group):E(s.presentation.order,f.presentation.order):-1:f.presentation.group?1:E(s.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$sF=c;function E(k,s){return typeof k!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:k-s}async function p(k,s){const f=k.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(f!=="none"&&(await s.saveAll(),f==="allEditorsInActiveGroup")){const w=s.activeEditorPane;w&&w.input.resource?.scheme===A.Schemas.untitled&&await s.save({editor:w.input,groupId:w.group.id})}await k.reloadConfiguration()}e.$tF=p;const I=(k,s)=>!k||!s?k===s:k.name===s.name&&k.path===s.path&&k.sourceReference===s.sourceReference;e.$uF=I}),define(Ae[75],Re([1,0,25,37,67,68,13,19,22,32]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$H=e.$0H=e.$9H=e.$8H=e.CellStatusbarAlignment=e.$7H=e.$6H=e.$5H=e.NotebookEditorPriority=e.$4H=e.$3H=e.$2H=e.$1H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$ZH=e.$YH=e.$XH=e.$WH=e.CellKind=e.$VH=e.$UH=e.$TH=void 0,e.$TH="workbench.editor.notebook",e.$UH="workbench.editor.notebookTextDiffEditor",e.$VH="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.$WH=["application/json","application/javascript","text/html","image/svg+xml",T.$Hr.latex,T.$Hr.markdown,"image/png","image/jpeg",T.$Hr.text],e.$XH=[T.$Hr.latex,T.$Hr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Hr.text],e.$YH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$ZH="_notAvailable";var D;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var $;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var d;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var o;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var h;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${ee.join("")}]+`),Ee=7;function ke($e,ie){const z=ie.toString(Ee),le=`${z.length<ee.length?ee[z.length-1]:"z"}${z}s${(0,v.$Zd)(v.$Fd.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:le})}N.generate=ke;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Y,""),Ee),q=(0,v.$Yd)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}N.parse=Pe;function X($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=X;function ue($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=ue;function ye($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=ye;function ce($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(h||(e.CellUri=h={}));const y=N=>S.$i?N.replace(/\//g,"\\"):N;class m{constructor(ee=[],Y=e.$WH){this.e=Y,this.d=[...new Set(ee)].map(Ee=>({pattern:Ee,matches:F.$rj(y(Ee))}))}sort(ee){const Y=new Map(C.Iterable.map(ee,ke=>[ke,y(ke)]));let Ee=[];for(const{matches:ke}of this.d)for(const[Pe,X]of Y)if(ke(X)){Ee.push(Pe),Y.delete(Pe);break}return Y.size&&(Ee=Ee.concat([...Y.keys()].sort((ke,Pe)=>this.e.indexOf(ke)-this.e.indexOf(Pe)))),Ee}prioritize(ee,Y){const Ee=this.f(ee);if(Ee===-1){this.d.unshift({pattern:ee,matches:F.$rj(y(ee))});return}const ke=new Set(Y.map(X=>this.f(X,Ee)));ke.delete(-1);const Pe=Array.from(ke).sort();this.d.splice(Ee+1,0,...Pe.map(X=>this.d[X]));for(let X=Pe.length-1;X>=0;X--)this.d.splice(Pe[X],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,Y=this.d.length){const Ee=y(ee);for(let ke=0;ke<Y;ke++)if(this.d[ke].matches(Ee))return ke;return-1}}e.$1H=m;function r(N,ee,Y,Ee=(ke,Pe)=>ke===Pe){const ke=[];function Pe(ye,ce,$e){if(ce===0&&$e.length===0)return;const ie=ke[ke.length-1];ie&&ie.start+ie.deleteCount===ye?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):ke.push({start:ye,deleteCount:ce,toInsert:$e})}let X=0,ue=0;for(;;){if(X===N.length){Pe(X,0,ee.slice(ue));break}if(ue===ee.length){Pe(X,N.length-X,[]);break}const ye=N[X],ce=ee[ue];if(Ee(ye,ce)){X+=1,ue+=1;continue}Y(ce)?(Pe(X,1,[]),X+=1):(Pe(X,0,[ce]),ue+=1)}return ke}e.$2H=r,e.$3H=new g.$2i("notebookEditorCursorAtBoundary","none"),e.$4H=new g.$2i("notebookEditorCursorAtLineBoundary","none");var a;(function(N){N.default="default",N.option="option"})(a||(e.NotebookEditorPriority=a={}));function n(N){const ee=N;return!!((typeof ee.include=="string"||F.$sj(ee.include))&&(typeof ee.exclude=="string"||F.$sj(ee.exclude)))}e.$5H=n;function c(N,ee,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ee)>=0||N.viewType===ee)return!0;if(N.filenamePattern){const Ee=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,ke=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(F.$qj(Ee,(0,l.$ae)(Y.fsPath).toLowerCase()))return!(ke&&F.$qj(ke,(0,l.$ae)(Y.fsPath).toLowerCase()))}return!1}e.$6H=c,e.$7H={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",cellExecutionScroll:"notebook.revealNextOnExecuteBehavior"};var E;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(E||(e.CellStatusbarAlignment=E={}));class p{static{this.d="notebook/"}static create(ee){return`${p.d}${ee}`}static parse(ee){if(ee.startsWith(p.d))return ee.substring(p.d.length)}}e.$8H=p;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$9H=I;const k=new TextDecoder;function s(N){const ee=[];let Y=!1;for(const X of N)(ee.length===0||Y)&&(ee.push(X),Y=!0);let Ee=R(ee);const ke=v.$Fd.concat(ee.map(X=>v.$Fd.wrap(X))),Pe=O(ke);return Ee=Ee||Pe.byteLength!==ke.byteLength,{data:Pe,didCompression:Ee}}e.$0H=s,e.$$H=`${String.fromCharCode(27)}[A`;const f=e.$$H.split("").map(N=>N.charCodeAt(0)),w=10;function R(N){let ee=!1;return N.forEach((Y,Ee)=>{if(Ee===0||Y.length<e.$$H.length)return;const ke=N[Ee-1],Pe=Y.subarray(0,e.$$H.length);if(Pe[0]===f[0]&&Pe[1]===f[1]&&Pe[2]===f[2]){const X=ke.lastIndexOf(w);if(X===-1)return;ee=!0,N[Ee-1]=ke.subarray(0,X),N[Ee]=Y.subarray(e.$$H.length)}}),ee}function W(N){let ee=N;do N=ee,ee=N.replace(/[^\n]\x08/gm,"");while(ee.length<N.length);return N}function V(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ee=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+ee.slice(Y.length,ee.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const U="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(B)?N:v.$Fd.fromString(V(W(k.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,49,28,68,15,16,2,36,20,38,97,75]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$){"use strict";var d,t,i,o,h,y,m,r,a,n,c,E,p,I,k,s,f,w;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$QL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.TestRunProfileKind=e.TestResultState=e.$xL=e.$wL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$vL=e.$uL=e.$tL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$sL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.ColorThemeKind=e.$mL=e.$lL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$kL=e.DebugConsoleMode=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$eL=e.$dL=e.FileChangeType=e.$cL=e.$bL=e.$aL=e.$_K=e.InlineCompletionTriggerKind=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.ConfigurationTarget=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$OK=e.ViewBadge=e.ProgressLocation=e.$NK=e.$MK=e.TaskScope=e.ShellQuoting=e.$LK=e.$KK=e.$JK=e.TaskPanelKind=e.TaskRevealKind=e.$IK=e.TerminalLocation=e.$HK=e.$GK=e.$FK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$EK=e.$DK=e.$CK=e.$BK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$AK=e.StatusBarAlignment=e.ViewColumn=e.$zK=e.$yK=e.$xK=e.$wK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$vK=e.$uK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.LanguageStatusSeverity=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.CodeActionTriggerKind=e.$hK=e.$gK=e.SymbolTag=e.SymbolKind=e.$fK=e.DocumentHighlightKind=e.$eK=e.$dK=e.$cK=e.$bK=e.DiagnosticSeverity=e.DiagnosticTag=e.$aK=e.$_J=e.FileEditType=e.$$J=e.$0J=e.$9J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(j,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const[Se,...Je]=re;return Reflect.construct(j,Je,Se.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var V;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let U=d=class{static from(...L){let re=L;return new d(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$2J=U,e.$2J=U=d=Ke([R],U);let B=t=class{static Min(...L){if(L.length===0)throw new TypeError;let re=L[0];for(let Se=1;Se<L.length;Se++){const Je=L[Se];Je.isBefore(re)&&(re=Je)}return re}static Max(...L){if(L.length===0)throw new TypeError;let re=L[0];for(let Se=1;Se<L.length;Se++){const Je=L[Se];Je.isAfter(re)&&(re=Je)}return re}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:re,character:Se}=L;return typeof re=="number"&&typeof Se=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,re){if(L<0)throw(0,F.$5)("line must be non-negative");if(re<0)throw(0,F.$5)("character must be non-negative");this.c=L,this.e=re}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,re=0){if(L===null||re===null)throw(0,F.$5)();let Se;return typeof L>"u"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,re=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&re===0?this:new t(this.line+Se,this.character+re)}with(L,re=this.character){if(L===null||re===null)throw(0,F.$5)();let Se;return typeof L>"u"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,re=typeof L.character=="number"?L.character:this.character),Se===this.line&&re===this.character?this:new t(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$3J=B,e.$3J=B=t=Ke([R],B);let O=i=class{static isRange(L){return L instanceof i?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,re,Se,Je){let Ye,at;if(typeof L=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new B(L,re),at=new B(Se,Je)):B.isPosition(L)&&B.isPosition(re)&&(Ye=B.of(L),at=B.of(re)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):B.isPosition(L)?!(B.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const re=B.Max(L.start,this.c),Se=B.Min(L.end,this.e);if(!re.isAfter(Se))return new i(re,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const re=B.Min(L.start,this.c),Se=B.Max(L.end,this.end);return new i(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,re=this.end){if(L===null||re===null)throw(0,F.$5)();let Se;return L?B.isPosition(L)?Se=L:(Se=L.start||this.start,re=L.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new i(Se,re)}toJSON(){return[this.start,this.end]}};e.$4J=O,e.$4J=O=i=Ke([R],O);let N=o=class extends O{static isSelection(L){return L instanceof o?!0:L?O.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,re,Se,Je){let Ye,at;if(typeof L=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new B(L,re),at=new B(Se,Je)):B.isPosition(L)&&B.isPosition(re)&&(Ye=B.of(L),at=B.of(re)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$5J=N,e.$5J=N=o=Ke([R],N);const ee=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,F.$5)("connectionToken")};class Y{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,re,Se){if(typeof L!="string"||L.length===0)throw(0,F.$5)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,F.$5)("port");typeof Se<"u"&&ee(Se),this.host=L,this.port=Math.round(re),this.connectionToken=Se}}e.$6J=Y;class Ee{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,re){this.makeConnection=L,this.connectionToken=re,typeof re<"u"&&ee(re)}}e.$7J=Ee;class ke extends Error{static NotAvailable(L,re){return new ke(L,b.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(L){return new ke(L,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,re=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L),this._message=L,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$8J=ke;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var X;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let ue=h=class{static isTextEdit(L){return L instanceof h?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,re){return new h(L,re)}static insert(L,re){return h.replace(new O(L,L),re)}static delete(L){return h.replace(L,"")}static setEndOfLine(L){const re=new h(new O(new B(0,0),new B(0,0)),"");return re.newEol=L,re}get range(){return this.c}set range(L){if(L&&!O.isRange(L))throw(0,F.$5)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,F.$5)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,F.$5)("newEol");this.f=L}constructor(L,re){this.c=L,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$9J=ue,e.$9J=ue=h=Ke([R],ue);let ye=y=class{static isNotebookCellEdit(L){return L instanceof y?!0:L?xt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,re){return new y(L,re)}static insertCells(L,re){return new y(new xt(L,L),re)}static deleteCells(L){return new y(L,[])}static updateCellMetadata(L,re){const Se=new y(new xt(L,L),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(L){const re=new y(new xt(0,0),[]);return re.newNotebookMetadata=L,re}constructor(L,re){this.range=L,this.newCells=re}};e.$0J=ye,e.$0J=ye=y=Ke([R],ye);class ce{static isSnippetTextEdit(L){return L instanceof ce?!0:L?O.isRange(L.range)&&z.isSnippetString(L.snippet):!1}static replace(L,re){return new ce(L,re)}static insert(L,re){return ce.replace(new O(L,L),re)}constructor(L,re){this.range=L,this.snippet=re}}e.$$J=ce;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,re,Se,Je){this.c.push({_type:1,from:L,to:re,options:Se,metadata:Je})}createFile(L,re,Se){this.c.push({_type:1,from:void 0,to:L,options:re,metadata:Se})}deleteFile(L,re,Se){this.c.push({_type:1,from:L,to:void 0,options:re,metadata:Se})}e(L,re,Se){this.c.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:re},notebookMetadata:re})}f(L,re,Se,Je){const Ye=re.start,at=re.end;(Ye!==at||Se.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:at-Ye,cells:Se,metadata:Je})}g(L,re,Se,Je){this.c.push({_type:3,metadata:Je,uri:L,edit:{editType:3,index:re,metadata:Se}})}replace(L,re,Se,Je){this.c.push({_type:2,uri:L,edit:new ue(re,Se),metadata:Je})}insert(L,re,Se,Je){this.replace(L,new O(re,re),Se,Je)}delete(L,re,Se){this.replace(L,re,"",Se)}has(L){return this.c.some(re=>re._type===2&&re.uri.toString()===L.toString())}set(L,re){if(re)for(const Se of re){if(!Se)continue;let Je,Ye;Array.isArray(Se)?(Je=Se[0],Ye=Se[1]):Je=Se,ye.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(L,Je.range.start,Je.newCellMetadata,Ye):Je.newNotebookMetadata?this.e(L,Je.newNotebookMetadata,Ye):this.f(L,Je.range,Je.newCells,Ye):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:L,range:Je.range,edit:Je.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Je,metadata:Ye})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===L.toString()&&(this.c[Se]=void 0);break}}(0,v.$Gb)(this.c)}}get(L){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===L.toString()&&re.push(Se.edit);return re}entries(){const L=new T.$zi;for(const re of this.c)if(re._type===2){let Se=L.get(re.uri);Se||(Se=[re.uri,[]],L.set(re.uri,Se)),Se[1].push(re.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$_J=ie,e.$_J=ie=Ke([R],ie);let z=m=class{static isSnippetString(L){return L instanceof m?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=m.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,re=this.e++){if(typeof L=="function"){const Se=new m;Se.e=this.e,L(Se),this.e=Se.e,L=Se.value}else L=m.c(L);return this.value+="${",this.value+=re,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,re=this.e++){const Se=L.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,re){if(typeof re=="function"){const Se=new m;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$aK=z,e.$aK=z=m=Ke([R],z);var q;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var le;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=r=class{static isLocation(L){return L instanceof r?!0:L?O.isRange(L.range)&&g.URI.isUri(L.uri):!1}constructor(L,re){if(this.uri=L,re)if(O.isRange(re))this.range=O.of(re);else if(B.isPosition(re))this.range=new O(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$bK=we,e.$bK=we=r=Ke([R],we);let ve=class{static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&g.URI.isUri(L.location.uri):!1}constructor(L,re){this.location=L,this.message=re}static isEqual(L,re){return L===re?!0:!L||!re?!1:L.message===re.message&&L.location.range.isEqual(re.location.range)&&L.location.uri.toString()===re.location.uri.toString()}};e.$cK=ve,e.$cK=ve=Ke([R],ve);let ge=class{constructor(L,re,Se=le.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=L,this.message=re,this.severity=Se}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,re){return L===re?!0:!L||!re?!1:L.message===re.message&&L.severity===re.severity&&L.code===re.code&&L.severity===re.severity&&L.source===re.source&&L.range.isEqual(re.range)&&(0,v.$sb)(L.tags,re.tags)&&(0,v.$sb)(L.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$dK=ge,e.$dK=ge=Ke([R],ge);let De=class{constructor(L,re){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=re}};e.$eK=De,e.$eK=De=Ke([R],De);var ne;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let he=class{constructor(L,re=ne.Text){this.range=L,this.kind=re}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$fK=he,e.$fK=he=Ke([R],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,re,Se,Je,Ye){this.name=L,this.kind=re,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof O&&(this.location=new we(Je,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$gK=fe,e.$gK=fe=a=Ke([R],fe);let Ie=n=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(n.validate)}constructor(L,re,Se,Je,Ye){this.name=L,this.detail=re,this.kind=Se,this.range=Je,this.selectionRange=Ye,this.children=[],n.validate(this)}};e.$hK=Ie,e.$hK=Ie=n=Ke([R],Ie);var M;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(M||(e.CodeActionTriggerKind=M={}));let K=class{constructor(L,re){this.title=L,this.kind=re}};e.$iK=K,e.$iK=K=Ke([R],K);let G=class{static{c=this}static{this.c="."}constructor(L){this.value=L}append(L){return new c(this.value?this.value+c.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+c.c)}};e.$jK=G,e.$jK=G=c=Ke([R],G);class Q extends G{constructor(L){super(L),this.value=L}}e.$kK=Q,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(L,re){if(this.range=L,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$lK=J,e.$lK=J=Ke([R],J);class x{constructor(L,re,Se,Je,Ye,at){this.kind=L,this.name=re,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=at}}e.$mK=x;class ae{constructor(L,re){this.fromRanges=re,this.from=L}}e.$nK=ae;class Oe{constructor(L,re){this.fromRanges=re,this.to=L}}e.$oK=Oe;var je;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let Qe=class{constructor(L,re){this.range=L,this.command=re}get isResolved(){return!!this.command}};e.$pK=Qe,e.$pK=Qe=Ke([R],Qe);let He=E=class{#e;static isMarkdownString(L){return L instanceof E?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,re=!1){this.#e=new C.$Xj(L,{supportThemeIcons:re})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,re){return this.#e.appendCodeblock(re??"",L),this}};e.$qK=He,e.$qK=He=E=Ke([R],He);let et=class{constructor(L,re){this.label=L,this.documentation=re}};e.$rK=et,e.$rK=et=Ke([R],et);let Xe=class{constructor(L,re){this.label=L,this.documentation=re,this.parameters=[]}};e.$sK=Xe,e.$sK=Xe=Ke([R],Xe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$tK=_e,e.$tK=_e=Ke([R],_e);var it;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let ze=class{constructor(L){this.value=L}};e.$uK=ze,e.$uK=ze=Ke([R],ze);let rt=class{constructor(L,re,Se){this.position=L,this.label=re,this.kind=Se}};e.$vK=rt,e.$vK=rt=Ke([R],rt);var _;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var Z;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var pe;(function(j){j[j.Deprecated=1]="Deprecated"})(pe||(e.CompletionItemTag=pe={}));let Ue=class{constructor(L,re){this.label=L,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$wK=Ue,e.$wK=Ue=Ke([R],Ue);let Ne=class{constructor(L=[],re=!1){this.items=L,this.isIncomplete=re}};e.$xK=Ne,e.$xK=Ne=Ke([R],Ne);let Ze=class{constructor(L,re,Se){this.insertText=L,this.range=re,this.command=Se}};e.$yK=Ze,e.$yK=Ze=Ke([R],Ze);let nt=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$zK=nt,e.$zK=nt=Ke([R],nt);var dt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Ot(j,L){return`${D.$Vl.toKey(j)}.${L}`}e.$AK=Ot;var Zt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Zt||(e.TextEditorLineNumbersStyle=Zt={}));var qt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var wt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Nt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var zt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Ht;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(j){function L(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(Nt||(e.TextEditorSelectionChangeKind=Nt={}));let Pt=class{constructor(L,re){if(re&&!g.URI.isUri(re))throw(0,F.$5)("target");if(!O.isRange(L)||L.isEmpty)throw(0,F.$5)("range");this.range=L,this.target=re}};e.$BK=Pt,e.$BK=Pt=Ke([R],Pt);let At=class{constructor(L,re,Se,Je){this.red=L,this.green=re,this.blue=Se,this.alpha=Je}};e.$CK=At,e.$CK=At=Ke([R],At);let jt=class{constructor(L,re){if(re&&!(re instanceof At))throw(0,F.$5)("color");if(!O.isRange(L)||L.isEmpty)throw(0,F.$5)("range");this.range=L,this.color=re}};e.$DK=jt,e.$DK=jt=Ke([R],jt);let Bt=class{constructor(L){if(!L||typeof L!="string")throw(0,F.$5)("label");this.label=L}};e.$EK=Bt,e.$EK=Bt=Ke([R],Bt);var Kt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class ot{constructor(L,re,Se){if(this.startIndex=L,this.length=re,this.tooltip=Se,typeof L!="number"||L<0)throw(0,F.$5)("startIndex");if(typeof re!="number"||re<1)throw(0,F.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,F.$5)("tooltip")}}e.$FK=ot;class ft{constructor(L){this.uri=L}}e.$GK=ft;class Rt{constructor(L){this.terminalCommand=L}}e.$HK=Rt;var Ft;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ft||(e.TerminalLocation=Ft={}));class It{constructor(L){if(this.options=L,typeof L!="object")throw(0,F.$5)("options")}}e.$IK=It;var ht;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ht||(e.TaskRevealKind=ht={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Dt=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(L,re){if(this.label=re,typeof L!="string"||typeof re!="string")throw(0,F.$5)("name");this.c=L}get id(){return this.c}};e.$JK=Dt,e.$JK=Dt=p=Ke([R],Dt);function Mt(j){let L="";for(let re=0;re<j.length;re++)L+=j[re].replace(/,/g,",,")+",";return L}let Ve=class{constructor(L,re,Se){if(typeof L!="string")throw(0,F.$5)("process");this.e=[],this.c=L,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,F.$5)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const re of this.e)L.push(re);return Mt(L)}};e.$KK=Ve,e.$KK=Ve=Ke([R],Ve);let Ce=class{constructor(L,re,Se){if(this.f=[],Array.isArray(re)){if(!L)throw(0,F.$5)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,F.$5)("command");this.e=L,this.f=re,this.g=Se}else{if(typeof L!="string")throw(0,F.$5)("commandLine");this.c=L,this.g=re}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,F.$5)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,F.$5)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)L.push(typeof re=="string"?re:re.value);return Mt(L)}};e.$LK=Ce,e.$LK=Ce=Ke([R],Ce);var Fe;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var me;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(me||(e.TaskScope=me={}));class H{constructor(L){this.c=L}computeId(){return"customExecution"+(0,P.$4f)()}set callback(L){this.c=L}get callback(){return this.c}}e.$MK=H;let Me=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,re,Se,Je,Ye,at){this.j=!1,this.k=this.definition=L;let lt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Se,this.execution=Je,lt=Ye,this.j=!0):re===me.Global||re===me.Workspace?(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=at):(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ve?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$4f)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=L}get scope(){return this.l}set target(L){this.y(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,F.$5)("name");this.y(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.y(),this.n=L;const re=this.k.type;(I.g===re||I.e===re||I.f===re||I.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.y(),this.o=L,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.y(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.y(),this.u=L}get detail(){return this.x}set detail(L){L===null&&(L=void 0),this.x=L}get presentationOptions(){return this.v}set presentationOptions(L){L==null&&(L=Object.create(null)),this.y(),this.v=L}get runOptions(){return this.w}set runOptions(L){L==null&&(L=Object.create(null)),this.y(),this.w=L}};e.$NK=Me,e.$NK=Me=I=Ke([R],Me);var Be;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(j){function L(re){const Se=re;return(0,S.$nf)(Se.value)?Se.tooltip&&!(0,S.$jf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=L})(Ge||(e.ViewBadge=Ge={}));let We=k=class{static isTreeItem(L,re){const Se=L;if(Se.checkboxState!==void 0){const Je=(0,S.$nf)(Se.checkboxState)?Se.checkboxState:(0,S.$lf)(Se.checkboxState)&&(0,S.$nf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ye=!(0,S.$nf)(Se.checkboxState)&&(0,S.$lf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==$t.Checked&&Je!==$t.Unchecked||Ye!==void 0&&!(0,S.$jf)(Ye))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(L instanceof k)return!0;if(Se.label!==void 0&&!(0,S.$jf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,S.$jf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,S.$jf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,S.$jf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,S.$jf)(Je.light)&&!g.URI.isUri(Je.light)&&!(0,S.$jf)(Je.dark)&&!g.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,S.$jf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,S.$jf)(Se.tooltip)&&!(Se.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,S.$jf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(L,re=xe.None){this.collapsibleState=re,g.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$OK=We,e.$OK=We=k=Ke([R],We);var xe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var $t;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let Ct=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$PK=Ct,e.$PK=Ct=Ke([R],Ct);class bt extends Ct{}e.$QK=bt;class ut extends bt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$RK=ut;class mt{constructor(L,re,Se,Je){this.name=L,this.uri=re,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$SK=mt;let yt=class{#e=new Map;constructor(L){for(const[re,Se]of L??[]){const Je=this.#e.get(this.#t(re));Je?Je.push(Se):this.#e.set(this.#t(re),[Se])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,re){this.#e.set(this.#t(L),[re])}forEach(L,re){for(const[Se,Je]of this.#e)for(const Ye of Je)L.call(re,Ye,Se,this)}*[Symbol.iterator](){for(const[L,re]of this.#e)for(const Se of re)yield[L,Se]}#t(L){return L.toLowerCase()}};e.$TK=yt,e.$TK=yt=Ke([R],yt);let gi=class{constructor(L){this.insertText=L}};e.$UK=gi,e.$UK=gi=Ke([R],gi);let Jt=class{constructor(L,re){this.label=re,this.insertText=L}};e.$VK=Jt,e.$VK=Jt=Ke([R],Jt);let Yt=class{constructor(L,re){this.id=L,this.color=re}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$WK=Yt,e.$WK=Yt=Ke([R],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let si=class{constructor(L){this.id=L}};e.$XK=si,e.$XK=si=Ke([R],si);var ki;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let St=class{get base(){return this.c}set base(L){this.c=L,this.e=g.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,re){if(typeof L!="string"&&(!L||!g.URI.isUri(L)&&!g.URI.isUri(L.uri)))throw(0,F.$5)("base");if(typeof re!="string")throw(0,F.$5)("pattern");typeof L=="string"?this.baseUri=g.URI.file(L):g.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$YK=St,e.$YK=St=Ke([R],St);const Yi=new WeakMap;function un(j,L){Yi.set(j,L)}e.$ZK=un;let pt=class{constructor(L,re,Se,Je){this.enabled=typeof L=="boolean"?L:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Yi.get(this)??(0,P.$4f)()),this.c}};e.$1K=pt,e.$1K=pt=Ke([R],pt);let mi=class extends pt{constructor(L,re,Se,Je,Ye){if(super(re,Se,Je,Ye),L===null)throw(0,F.$5)("location");this.location=L}};e.$2K=mi,e.$2K=mi=Ke([R],mi);let $i=class extends pt{constructor(L,re,Se,Je,Ye){super(re,Se,Je,Ye),this.functionName=L}};e.$3K=$i,e.$3K=$i=Ke([R],$i);let oi=class extends pt{constructor(L,re,Se,Je,Ye,at,lt){if(super(Je,Ye,at,lt),!re)throw(0,F.$5)("dataId");this.label=L,this.dataId=re,this.canPersist=Se}};e.$4K=oi,e.$4K=oi=Ke([R],oi);let Di=class{constructor(L,re,Se){this.command=L,this.args=re||[],this.options=Se}};e.$5K=Di,e.$5K=Di=Ke([R],Di);let Si=class{constructor(L,re){this.port=L,this.host=re}};e.$6K=Si,e.$6K=Si=Ke([R],Si);let Tt=class{constructor(L){this.path=L}};e.$7K=Tt,e.$7K=Tt=Ke([R],Tt);let pi=class{constructor(L){this.implementation=L}};e.$8K=pi,e.$8K=pi=Ke([R],pi);let Ii=class{constructor(L,re,Se){this.session=L,this.threadId=re,this.frameId=Se}};e.$9K=Ii,e.$9K=Ii=Ke([R],Ii);let ai=class{constructor(L,re){this.session=L,this.threadId=re}};e.$0K=ai,e.$0K=ai=Ke([R],ai);let ci=class{constructor(L,re){this.range=L,this.expression=re}};e.$$K=ci,e.$$K=ci=Ke([R],ci);var ct;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ct||(e.InlineCompletionTriggerKind=ct={}));let Ci=class{constructor(L,re){this.range=L,this.text=re}};e.$_K=Ci,e.$_K=Ci=Ke([R],Ci);let Xt=class{constructor(L,re,Se=!0){this.range=L,this.variableName=re,this.caseSensitiveLookup=Se}};e.$aL=Xt,e.$aL=Xt=Ke([R],Xt);let ii=class{constructor(L,re){this.range=L,this.expression=re}};e.$bL=ii,e.$bL=ii=Ke([R],ii);let bi=class{constructor(L,re){this.frameId=L,this.stoppedLocation=re}};e.$cL=bi,e.$cL=bi=Ke([R],bi);var Xi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Pi=s=class extends Error{static FileExists(L){return new s(L,u.FileSystemProviderErrorCode.FileExists,s.FileExists)}static FileNotFound(L){return new s(L,u.FileSystemProviderErrorCode.FileNotFound,s.FileNotFound)}static FileNotADirectory(L){return new s(L,u.FileSystemProviderErrorCode.FileNotADirectory,s.FileNotADirectory)}static FileIsADirectory(L){return new s(L,u.FileSystemProviderErrorCode.FileIsADirectory,s.FileIsADirectory)}static NoPermissions(L){return new s(L,u.FileSystemProviderErrorCode.NoPermissions,s.NoPermissions)}static Unavailable(L){return new s(L,u.FileSystemProviderErrorCode.Unavailable,s.Unavailable)}constructor(L,re=u.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(L)?L.toString(!0):L),this.code=Se?.name??"Unknown",(0,u.$hk)(this,re),Object.setPrototypeOf(this,s.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$dL=Pi,e.$dL=Pi=s=Ke([R],Pi);let Ai=class{constructor(L,re,Se){this.start=L,this.end=re,this.kind=Se}};e.$eL=Ai,e.$eL=Ai=Ke([R],Ai);var Ri;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ri||(e.FoldingRangeKind=Ri={}));var _i;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(_i||(e.CommentThreadCollapsibleState=_i={}));var Fi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Fi||(e.CommentMode=Fi={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var xi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(xi||(e.CommentThreadState=xi={}));class Mi{constructor(L,re=[]){this.tokenTypes=L,this.tokenModifiers=re}}e.$fL=Mi;function Ti(j){return typeof j>"u"||(0,S.$kf)(j)}class Li{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let re=0,Se=L.tokenTypes.length;re<Se;re++)this.j.set(L.tokenTypes[re],re);for(let re=0,Se=L.tokenModifiers.length;re<Se;re++)this.k.set(L.tokenModifiers[re],re)}}push(L,re,Se,Je,Ye){if(typeof L=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(L,re,Se,Je,Ye);if(O.isRange(L)&&typeof re=="string"&&Ti(Se))return this.m(L,re,Se);throw(0,F.$5)()}m(L,re,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=L.start.line,Ye=L.start.character,at=L.end.character-L.start.character,lt=this.j.get(re);let Ut=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Qt);Ut|=1<<_t>>>0}this.n(Je,Ye,at,lt,Ut)}n(L,re,Se,Je,Ye){if(this.f&&(L<this.c||L===this.c&&re<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,_t=0;for(let ti=0;ti<Ut;ti++){let ri=this.g[5*ti],Qi=this.g[5*ti+1];ri===0?(ri=Qt,Qi+=_t):ri+=Qt,this.g[5*ti]=ri,this.g[5*ti+1]=Qi,Qt=ri,_t=Qi}}let at=L,lt=re;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Ye,this.c=L,this.e=re}static o(L){const re=[],Se=L.length/5|0;for(let lt=0;lt<Se;lt++)re[lt]=lt;re.sort((lt,Ut)=>{const Qt=L[5*lt],_t=L[5*Ut];if(Qt===_t){const ti=L[5*lt+1],ri=L[5*Ut+1];return ti-ri}return Qt-_t});const Je=new Uint32Array(L.length);let Ye=0,at=0;for(let lt=0;lt<Se;lt++){const Ut=5*re[lt],Qt=L[Ut+0],_t=L[Ut+1],ti=L[Ut+2],ri=L[Ut+3],Qi=L[Ut+4],En=Qt-Ye,Fn=En===0?_t-at:_t,Zi=5*lt;Je[Zi+0]=En,Je[Zi+1]=Fn,Je[Zi+2]=ti,Je[Zi+3]=ri,Je[Zi+4]=Qi,Ye=Qt,at=_t}return Je}build(L){return this.f?new Oi(new Uint32Array(this.g),L):new Oi(Li.o(this.g),L)}}e.$gL=Li;class Oi{constructor(L,re){this.resultId=re,this.data=L}}e.$hL=Oi;class hi{constructor(L,re,Se){this.start=L,this.deleteCount=re,this.data=Se}}e.$iL=hi;class ln{constructor(L,re){this.resultId=re,this.edits=L}}e.$jL=ln;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$kL=Ni,e.$kL=Ni=Ke([R],Ni);var di;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(di||(e.QuickPickItemKind=di={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class hn{static validate(L){if(typeof L.badge=="string"){let re=(0,l.$We)(L.badge,0);if(re<L.badge.length&&(re+=(0,l.$We)(L.badge,re)),L.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Yt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,re,Se){this.badge=L,this.tooltip=re,this.color=Se}}e.$lL=hn;let ni=class{constructor(L){this.kind=L}};e.$mL=ni,e.$mL=ni=Ke([R],ni);var zi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(zi||(e.ColorThemeKind=zi={}));class xt{static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,re){if(L<0)throw(0,F.$5)("start must be positive");if(re<0)throw(0,F.$5)("end must be positive");L<=re?(this.c=L,this.e=re):(this.c=re,this.e=L)}with(L){let re=this.c,Se=this.e;return L.start!==void 0&&(re=L.start),L.end!==void 0&&(Se=L.end),re===this.c&&Se===this.e?this:new xt(re,Se)}}e.$nL=xt;class vi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(re=>vi.isNotebookCellData(re))}static isNotebookCellData(L){return!0}constructor(L,re,Se,Je,Ye,at,lt){this.kind=L,this.value=re,this.languageId=Se,this.mime=Je,this.outputs=Ye??[],this.metadata=at,this.executionSummary=lt,vi.validate(this)}}e.$oL=vi;class rn{constructor(L){this.cells=L}}e.$pL=rn;class Gt{static isNotebookCellOutputItem(L){return L instanceof Gt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const re={name:L.name,message:L.message,stack:L.stack};return Gt.json(re,"application/vnd.code.notebook.error")}static stdout(L){return Gt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Gt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,re="application/octet-stream"){return new Gt(L,re)}static#e=new TextEncoder;static text(L,re=A.$Hr.text){const Se=Gt.#e.encode(String(L));return new Gt(Se,re)}static json(L,re="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return Gt.text(Se,re)}constructor(L,re){this.data=L,this.mime=re;const Se=(0,A.$Lr)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$qL=Gt;class wi{static isNotebookCellOutput(L){return L instanceof wi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,re=!1){const Se=new Set,Je=new Set;for(let Ye=0;Ye<L.length;Ye++){const at=L[Ye],lt=(0,A.$Lr)(at.mime);if(!Se.has(lt)||(0,$.$9H)(lt)){Se.add(lt);continue}Je.add(Ye),re&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Je.size===0?L:L.filter((Ye,at)=>!Je.has(at))}constructor(L,re,Se){this.items=wi.ensureUniqueMimeTypes(L,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,P.$4f)(),this.metadata=re??Se)}}e.$rL=wi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var yi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(yi||(e.NotebookCellExecutionState=yi={}));var ji;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var Le;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Le||(e.NotebookEditorRevealType=Le={}));class ei{constructor(L,re){this.text=L,this.alignment=re}}e.$sL=ei;var Ui;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var gt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(gt||(e.NotebookControllerAffinity2=gt={}));class dn{constructor(L,re=[]){this.uri=L,this.provides=(0,v.$1b)(re)}}e.$tL=dn;class fn{constructor(L){this.label=L}}e.$uL=fn;let Ei=class{constructor(L,re){this.label=L,this.timestamp=re}};e.$vL=Ei,e.$vL=Ei=Ke([R],Ei);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class gn{constructor(L,re){this.ranges=L,this.wordPattern=re}}e.$wL=gn;class mn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$xL=mn;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(L=void 0,re=void 0,Se=void 0,Je=!1){this.include=L,this.exclude=re,this.profile=Se,this.continuous=Je}};e.$yL=Wi,e.$yL=Wi=Ke([R],Wi);let Vi=f=class{static diff(L,re,Se){const Je=new f(L);return Je.expectedOutput=re,Je.actualOutput=Se,Je}constructor(L){this.message=L}};e.$zL=Vi,e.$zL=Vi=f=Ke([R],Vi);let qi=class{constructor(L){this.id=L}};e.$AL=qi,e.$AL=qi=Ke([R],qi);let li=class{constructor(L,re){this.covered=L,this.total=re}};e.$BL=li,e.$BL=li=Ke([R],li);let Ki=w=class{static fromDetails(L,re){const Se=new li(0,0),Je=new li(0,0),Ye=new li(0,0);for(const lt of re)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const at=new w(L,Se,Je.total>0?Je:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=re,at}constructor(L,re,Se,Je){this.uri=L,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Je}};e.$CL=Ki,e.$CL=Ki=w=Ke([R],Ki);let Ji=class{constructor(L,re,Se=[]){this.executionCount=L,this.location=re,this.branches=Se}};e.$DL=Ji,e.$DL=Ji=Ke([R],Ji);let Hi=class{constructor(L,re){this.executionCount=L,this.location=re}};e.$EL=Hi,e.$EL=Hi=Ke([R],Hi);let Gi=class{constructor(L,re){this.executionCount=L,this.location=re}};e.$FL=Gi,e.$FL=Gi=Ke([R],Gi);var te;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}));var de;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(de||(e.WorkspaceTrustState=de={}));var Te;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Te||(e.PortAutoForwardAction=Te={}));class st{constructor(L,re,Se,Je,Ye,at){this.kind=L,this.name=re,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=at}}e.$GL=st;class Et{constructor(L){this.uri=L}}e.$HL=Et;class Lt{constructor(L,re){this.original=L,this.modified=re}}e.$IL=Lt;class kn{constructor(L,re,Se,Je){this.base=L,this.input1=re,this.input2=Se,this.result=Je}}e.$JL=kn;class Dn{constructor(L,re){this.uri=L,this.viewType=re}}e.$KL=Dn;class Sn{constructor(L){this.viewType=L}}e.$LL=Sn;class In{constructor(L,re){this.uri=L,this.notebookType=re}}e.$ML=In;class Cn{constructor(L,re,Se){this.original=L,this.modified=re,this.notebookType=Se}}e.$NL=Cn;class Pn{constructor(){}}e.$OL=Pn;class An{constructor(L,re){this.uri=L,this.inputBoxUri=re}}e.$PL=An;var $n;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var bn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var vn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var wn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Rn{constructor(L,re){this.role=L,this.content=re}}e.$QL=Rn;var yn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(yn||(e.RelatedInformationType=yn={}))}),define(Ae[101],Re([1,0,51,13,15,278,137,7,18]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=void 0;const g=new Map;function P($,d){d?g.set($,d):g.delete($)}e.$4L=P;function D($){return g.get($)}class u extends T.$Mu{constructor(d,t,i,o,h,y,m,r){super(t,i,o,h),this.c=d,this.m=y,this.q=m,this.notebook=r,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.$sb)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===F.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,i){return d.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,v.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,v.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,o=t.start.line,h=t.end.line,y=[];y.push(this.f[o].substring(t.start.character));for(let m=o+1;m<h;m++)y.push(this.f[m]);return y.push(this.f[h].substring(0,t.end.character)),y.join(i)}t(d){let t;if(d instanceof l.$3J?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const t=this.j.getIndexOf(d),i=this.f[t.index].length;return new l.$3J(t.index,Math.min(t.remainder,i))}w(d){if(!(d instanceof l.$4J))throw new Error("Invalid argument");const t=this.x(d.start),i=this.x(d.end);return t===d.start&&i===d.end?d:new l.$4J(t.line,t.character,i.line,i.character)}x(d){if(!(d instanceof l.$3J))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:t,character:i}=d,o=!1;if(t<0)t=0,i=0,o=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,o=!0;else{const h=this.f[t].length;i<0?(i=0,o=!0):i>h&&(i=h,o=!0)}return o?new l.$3J(t,i):d}y(d,t){const i=this.x(d);if(!t)t=D(this.m);else if((0,C.$ze)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const o=(0,A.$Zr)(i.character+1,(0,A.$Xr)(t),this.f[i.line],0);if(o)return new l.$4J(i.line,o.startColumn-1,i.line,o.endColumn-1)}}e.$5L=u;class b{constructor(d,t,i){this.a=d,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$4J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$4J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$6L=b}),define(Ae[197],Re([1,0,7,17,5]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;let T=class{constructor(l){this.a=new v.$mL(v.ColorThemeKind.Dark),this.b=new C.$fd}get activeColorTheme(){return this.a}$onColorThemeChange(l){let S;switch(l){case"light":S=v.ColorThemeKind.Light;break;case"hcDark":S=v.ColorThemeKind.HighContrast;break;case"hcLight":S=v.ColorThemeKind.HighContrastLight;break;default:S=v.ColorThemeKind.Dark}this.a=new v.$mL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Acc=T,e.$Acc=T=Ke([qe(0,F.$2L)],T)}),define(Ae[198],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aI=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$aI=(0,v.$Bh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(T){T.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var F;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class C{static fromExtHostTestItem(A,l,S=A.parent){if(A._isRoot)return new C([l]);const g=[A.id];for(let P=S;P&&P.id!==l;P=P.parent)g.push(P.id);return g.push(l),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$OI=C}),define(Ae[57],Re([1,0,2,44,45]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$UI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$TI=e.$SI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$RI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$QI=e.$PI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$PI=[2,4,8,16,32,64];const S=k=>"runId"in k;e.$QI=S;var g;(function(k){k.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),k.deserialize=s=>({range:F.$ks.lift(s.range),uri:v.URI.revive(s.uri)})})(g||(e.IRichLocation=g={}));var P;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(k){k.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,contextValue:s.contextValue,location:s.location&&g.serialize(s.location)}),k.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,contextValue:s.contextValue,location:s.location&&g.deserialize(s.location)})})(D||(e.ITestErrorMessage=D={}));const u=(k,s)=>`${s?"s":"e"}${k}`;e.$RI=u;var b;(function(k){k.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&g.serialize(s.location)}),k.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&g.deserialize(s.location)})})(b||(e.ITestOutputMessage=b={}));var $;(function(k){k.serialize=s=>s.type===0?D.serialize(s):b.serialize(s),k.deserialize=s=>s.type===0?D.deserialize(s):b.deserialize(s)})($||(e.ITestMessage=$={}));var d;(function(k){k.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),k.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map($.serialize)}),k.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map($.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",i=(k,s)=>k+t+s;e.$SI=i;const o=k=>{const s=k.indexOf(t);return{ctrlId:k.slice(0,s),tagId:k.slice(s+1)}};e.$TI=o;var h;(function(k){k.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),k.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?v.URI.revive(s.uri):void 0,range:s.range?F.$ks.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(h||(e.ITestItem=h={}));var y;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(y||(e.TestItemExpandState=y={}));var m;(function(k){k.serialize=s=>({expand:s.expand,item:h.serialize(s.item)}),k.deserialize=s=>({controllerId:C.$OI.root(s.item.extId),expand:s.expand,item:h.deserialize(s.item)})})(m||(e.InternalTestItem=m={}));var r;(function(k){k.serialize=s=>{let f;return s.item&&(f={},s.item.label!==void 0&&(f.label=s.item.label),s.item.tags!==void 0&&(f.tags=s.item.tags),s.item.busy!==void 0&&(f.busy=s.item.busy),s.item.uri!==void 0&&(f.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(f.range=s.item.range?.toJSON()),s.item.description!==void 0&&(f.description=s.item.description),s.item.error!==void 0&&(f.error=s.item.error),s.item.sortText!==void 0&&(f.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:f}},k.deserialize=s=>{let f;return s.item&&(f={},s.item.label!==void 0&&(f.label=s.item.label),s.item.tags!==void 0&&(f.tags=s.item.tags),s.item.busy!==void 0&&(f.busy=s.item.busy),s.item.range!==void 0&&(f.range=s.item.range?F.$ks.lift(s.item.range):null),s.item.description!==void 0&&(f.description=s.item.description),s.item.error!==void 0&&(f.error=s.item.error),s.item.sortText!==void 0&&(f.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:f}}})(r||(e.ITestItemUpdate=r={}));const a=(k,s)=>{s.expand!==void 0&&(k.expand=s.expand),s.item!==void 0&&(k.item=k.item?Object.assign(k.item,s.item):s.item)};e.$UI=a;var n;(function(k){k.serializeWithoutMessages=s=>({...m.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(d.serializeWithoutMessages)}),k.serialize=s=>({...m.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(d.serialize)}),k.deserialize=s=>({...m.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(d.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var c;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(c||(e.DetailType=c={}));var E;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(E||(e.TestDiffOpType=E={}));var p;(function(k){k.deserialize=s=>s.op===0?{op:s.op,item:m.deserialize(s.item)}:s.op===1?{op:s.op,item:r.deserialize(s.item)}:s.op===2?{op:s.op,uri:v.URI.revive(s.uri),docv:s.docv}:s,k.serialize=s=>s.op===0?{op:s.op,item:m.serialize(s.item)}:s.op===1?{op:s.op,item:r.serialize(s.item)}:s})(p||(e.TestsDiffOp=p={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(s){const f=this.p();for(const w of s)switch(w.op){case 0:this.k(m.deserialize(w.item),f);break;case 1:this.l(r.deserialize(w.item),f);break;case 3:this.m(w.itemId,f);break;case 5:this.o(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.d.set(w.tag.id,w.tag);break;case 7:this.d.delete(w.id);break}f.complete?.()}k(s,f){const w=C.$OI.parentId(s.item.extId)?.toString();let R;if(!w)R=this.q(s),this.g.add(R),this.f.set(s.item.extId,R);else if(this.f.has(w)){const W=this.f.get(w);W.children.add(s.item.extId),R=this.q(s,W),this.f.set(s.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return f.add?.(R),s.expand===2&&this.h++,R}l(s,f){const w=this.f.get(s.extId);if(w)return s.expand!==void 0&&(w.expand===2&&this.h--,s.expand===2&&this.h++),(0,e.$UI)(w,s),f.update?.(w),w}m(s,f){const w=this.f.get(s);if(!w)return;const R=C.$OI.parentId(w.item.extId)?.toString();R?this.f.get(R).children.delete(w.item.extId):this.g.delete(w);const W=[[s]];for(;W.length;)for(const V of W.pop()){const U=this.f.get(V);U&&(W.push(U.children),this.f.delete(V),f.remove?.(U,U!==w),U.expand===2&&this.h--)}}o(s){}updatePendingRoots(s){this.j+=s}p(){return{}}}e.$VI=I}),define(Ae[76],Re([1,0,12,5,6,51,57,45]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.TestItemEventOp=void 0;var S;(function(o){o[o.Upsert=0]="Upsert",o[o.SetTags=1]="SetTags",o[o.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",o[o.RemoveChild=3]="RemoveChild",o[o.SetProp=4]="SetProp",o[o.Bulk=5]="Bulk",o[o.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const g=(o,h)=>o===h,D=Object.entries({range:(o,h)=>o===h?!0:!o||!h?!1:o.equalsRange(h),busy:g,label:g,description:g,error:g,sortText:g,tags:(o,h)=>!(o.length!==h.length||o.some(y=>!h.includes(y)))}),u=(o,h)=>{let y;for(const[m,r]of D)r(o[m],h[m])||(y?y[m]=h[m]:y={[m]:h[m]});return y};class b extends C.$kc{get root(){return this.s.root}constructor(h){super(),this.s=h,this.f=this.B(new v.$Sg(()=>this.flushDiff(),200)),this.g=this.B(new F.$fd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(h){this.h=h;for(const y of this.tree.values())this.I(y)}get resolveHandler(){return this.h}collectDiff(){const h=this.m;return this.m=[],h}pushDiff(h){switch(h.op){case 2:{for(const y of this.m)if(y.op===2&&y.uri===h.uri){y.docv=h.docv;return}break}case 1:{const y=this.m[this.m.length-1];if(y){if(y.op===1&&y.item.extId===h.item.extId){(0,A.$UI)(y.item,h.item);return}if(y.op===0&&y.item.item.extId===h.item.extId){(0,A.$UI)(y.item,h.item);return}}break}}this.m.push(h),this.f.isScheduled()||this.f.schedule()}expand(h,y){const m=this.tree.get(h);if(m){if((m.expandLevels===void 0||y>m.expandLevels)&&(m.expandLevels=y),m.expand===1){const r=this.L(m);return r.isOpen()?this.J(m,y-1):r.wait().then(()=>this.J(m,y-1))}else if(m.expand===3)return m.resolveBarrier?.isOpen()===!1?m.resolveBarrier.wait().then(()=>this.J(m,y-1)):this.J(m,y-1)}}dispose(){for(const h of this.tree.values())this.s.getApiFor(h.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(h,y){switch(y.op){case 3:this.N(l.$OI.joinToString(h.fullId,y.id));break;case 0:this.y(y.item,h);break;case 5:for(const m of y.ops)this.u(h,m);break;case 1:this.z(y.new,y.old,h.fullId.toString());break;case 2:this.I(h);break;case 4:this.pushDiff({op:1,item:{extId:h.fullId.toString(),item:y.update}});break;case 6:this.w(h.actual.uri);break;default:(0,T.$vc)(y)}}w(h){h&&this.pushDiff({op:2,uri:h,docv:this.s.getDocumentVersion(h)})}y(h,y){const m=l.$OI.fromExtHostTestItem(h,this.root.id,y?.actual),r=this.s.getApiFor(h);r.parent&&r.parent!==y?.actual&&this.s.getChildren(r.parent).delete(h.id);let a=this.tree.get(m.toString());if(!a){a={fullId:m,actual:h,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},h.tags.forEach(this.C,this),this.tree.set(a.fullId.toString(),a),this.F(h,y),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(h)}}),this.H(h,a,y);return}if(a.actual===h){this.G(h,a,y);return}if(a.actual.uri?.toString()!==h.uri?.toString())return this.N(m.toString()),this.y(h,y);const n=this.s.getChildren(a.actual),c=a.actual,E=u(this.s.toITestItem(c),this.s.toITestItem(h));this.s.getApiFor(c).listener=void 0,a.actual=h,a.expand=0,E&&(E.hasOwnProperty("tags")&&(this.z(h.tags,c.tags,m.toString()),delete E.tags),this.u(a,{op:4,update:E})),this.H(h,a,y);for(const[p,I]of n)this.s.getChildren(h).get(I.id)||this.N(l.$OI.joinToString(m,I.id));this.w(a.actual.uri)}z(h,y,m){const r=new Set(y.map(a=>a.id));for(const a of h)r.delete(a.id)||this.C(a);this.pushDiff({op:1,item:{extId:m,item:{tags:h.map(a=>(0,A.$SI)(this.s.controllerId,a.id))}}}),r.forEach(this.D,this)}C(h){const y=this.j.get(h.id);y?y.refCount++:(this.j.set(h.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$SI)(this.s.controllerId,h.id)}}))}D(h){const y=this.j.get(h);y&&!--y.refCount&&(this.j.delete(h),this.pushDiff({op:7,id:(0,A.$SI)(this.s.controllerId,h)}))}F(h,y){this.s.getApiFor(h).parent=y&&y.actual!==this.root?y.actual:void 0}G(h,y,m){this.F(h,m);const r=this.s.getApiFor(h);r.parent=m?.actual,r.listener=a=>this.u(y,a),this.I(y)}H(h,y,m){this.G(h,y,m);for(const[r,a]of this.s.getChildren(h))this.y(a,y)}I(h){let y;this.h?h.resolveBarrier?y=h.resolveBarrier.isOpen()?3:2:y=h.actual.canResolveChildren?1:0:y=0,y!==h.expand&&(h.expand=y,this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:y}}),y===1&&h.expandLevels!==void 0&&this.L(h))}J(h,y){if(y<0)return;const m=[];for(const[r,a]of this.s.getChildren(h.actual)){const n=this.expand(l.$OI.joinToString(h.fullId,a.id),y);(0,v.$tg)(n)&&m.push(n)}if(m.length)return Promise.all(m).then(()=>{})}L(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this.h){const a=new v.$Fg;return a.open(),a}h.expand=2,this.M(h);const y=h.resolveBarrier=new v.$Fg,m=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let r;try{r=this.h(h.actual===this.root?void 0:h.actual)}catch(a){m(a)}return(0,v.$tg)(r)?r.catch(m).then(()=>{y.open(),this.I(h)}):(y.open(),this.I(h)),h.resolveBarrier}M(h){this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:h.expand}})}N(h){const y=this.tree.get(h);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:h});const m=[y];for(;m.length;){const r=m.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const a of r.actual.tags)this.D(a.id);this.tree.delete(r.fullId.toString());for(const[a,n]of this.s.getChildren(r.actual))m.push(this.tree.get(l.$OI.joinToString(r.fullId,n.id)))}}}flushDiff(){const h=this.collectDiff();h.length&&this.g.fire(h)}}e.$RL=b;class $ extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.$SL=$;class d extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$TL=d;class t extends Error{constructor(h,y,m){super(`TestItem with ID "${h}" is from controller "${y}" and cannot be added as a child of an item from controller "${m}".`)}}e.$UL=t;const i=(o,h,y)=>{let m=new Map;return{get size(){return m.size},forEach(r,a){for(const n of m.values())r.call(a,n,this)},[Symbol.iterator](){return m.entries()},replace(r){const a=new Map,n=new Set(m.keys()),c={op:5,ops:[]};for(const E of r){if(!(E instanceof y))throw new d(E.id);const p=h(E).controllerId;if(p!==o.controllerId)throw new t(E.id,p,o.controllerId);if(a.has(E.id))throw new $(E.id);a.set(E.id,E),n.delete(E.id),c.ops.push({op:0,item:E})}for(const E of n.keys())c.ops.push({op:3,id:E});o.listener?.(c),m=a},add(r){if(!(r instanceof y))throw new d(r.id);m.set(r.id,r),o.listener?.({op:0,item:r})},delete(r){m.delete(r)&&o.listener?.({op:3,id:r})},get(r){return m.get(r)},toJSON(){return Array.from(m.values())}}};e.$VL=i}),define(Ae[102],Re([1,0,76]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0;const F=new WeakMap,C=(A,l)=>{const S={controllerId:l};return F.set(A,S),S};e.$WL=C;const T=A=>{const l=F.get(A);if(!l)throw new v.$TL(A?.id||"<unknown>");return l};e.$XL=T}),define(Ae[77],Re([1,0,13,2]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zob=e.$Yob=e.$Xob=e.$Wob=e.$Vob=void 0,e.$Vob="vscode-cdn.net",e.$Wob=`vscode-resource.${e.$Vob}`,e.$Xob=`'self' https://*.${e.$Vob}`;function C(l,S){return l.scheme===v.Schemas.http||l.scheme===v.Schemas.https?l:(S&&S.authority&&S.isRemote&&l.scheme===v.Schemas.file&&(l=F.URI.from({scheme:v.Schemas.vscodeRemote,authority:S.authority,path:l.path})),F.URI.from({scheme:v.Schemas.https,authority:`${l.scheme}+${T(l.authority)}.${e.$Wob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$Yob=C;function T(l){return l.replace(/./g,S=>{const g=S.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?S:"-"+g.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(S,g)=>String.fromCharCode(parseInt(g,16)))}e.$Zob=A}),define(Ae[199],Re([1,0,5,6,77]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;class T{constructor(l,S,g){this.d=l,this.e=S,this.f=g,this.a=0,this.b=new F.$jc,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,S,g,P,D){let u;for(const h of this.e.getVisibleTextEditors(!0))if(h.value===l){u=h;break}if(!u)throw new Error("not a visible editor");const b=this,$=this.a++,d=new v.$fd,t=new v.$fd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(h){return(0,C.$Yob)(h,b.f)}get cspSource(){return C.$Xob}set options(h){this.b=h,b.d.$setOptions($,h)}get options(){return this.b}set html(h){this.a=h,b.d.$setHtml($,h)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(h){return b.d.$postMessage($,h)}},o=new class{constructor(){this.editor=l,this.line=S,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has($)&&(b.c.delete($),b.d.$disposeEditorInset($),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset($,u.id,u.value.document.uri,S+1,g,P||{},D.identifier,D.extensionLocation),this.c.set($,{editor:l,inset:o,onDidReceiveMessage:d}),o}$onDidDispose(l){const S=this.c.get(l);S&&S.inset.dispose()}$onDidReceiveMessage(l,S){this.c.get(l)?.onDidReceiveMessage.fire(S)}}e.$$bc=T}),define(Ae[200],Re([1,0,4]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.VariableKind=e.$NM=void 0,e.$NM=(0,v.$Bh)("configurationResolverService");var F;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$OM=C}),define(Ae[201],Re([1,0,19,74,16,24,22,90,166,200,15]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,$,d,t){this.h=new Map,this.a=b,this.b=$,this.g=d,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$i){const $=Object.create(null);return Object.keys(b).forEach(d=>{$[d.toLowerCase()]=b[d]}),$}return b}resolveWithEnvironment(b,$,d){return this.l({env:this.i(b),userHome:void 0},$?$.uri:void 0,d)}async resolveAsync(b,$){const d={env:await this.c,userHome:await this.g};return this.l(d,b?b.uri:void 0,$)}async j(b,$,d,t){const i=T.$Vm($);A.$i&&i.windows?Object.keys(i.windows).forEach(h=>i[h]=i.windows[h]):A.$j&&i.osx?Object.keys(i.osx).forEach(h=>i[h]=i.osx[h]):A.$k&&i.linux&&Object.keys(i.linux).forEach(h=>i[h]=i.linux[h]),delete i.windows,delete i.osx,delete i.linux;const o={env:await this.c,userHome:await this.g};return this.l(o,b?b.uri:void 0,i,d,t)}async resolveAnyAsync(b,$,d){return this.j(b,$,d)}async resolveAnyMap(b,$,d){const t=new Map;return{newConfig:await this.j(b,$,d,t),resolvedVariables:t}}resolveWithInteractionReplace(b,$,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,$,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,$){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,$)}async l(b,$,d,t,i){if(C.$jf(d))return this.m(b,$,d,t,i);if(Array.isArray(d))return Promise.all(d.map(o=>this.l(b,$,o,t,i)));if(C.$lf(d)){const o=Object.create(null),h=await Promise.all(Object.keys(d).map(async y=>[await this.m(b,$,y,t,i),await this.l(b,$,d[y],t,i)]));for(const[y,m]of h)o[y]=m;return o}return d}m(b,$,d,t,i){return(0,P.$Ee)(d,D.VARIABLE_REGEXP,async(o,h)=>{if(h.includes(D.VARIABLE_LHS))return o;let y=await this.o(b,o,h,$,t);return i?.set(h,y),y!==o&&C.$jf(y)&&y.match(D.VARIABLE_REGEXP)&&(y=await this.m(b,$,y,t,i)),y})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,$,d,t,i){let o;const h=d.split(":");h.length>1&&(d=h[0],o=h[1]);const y=a=>{const n=this.a.getFilePath();if(n)return(0,l.$fA)(n);throw new g.$OM(a,(0,S.localize)(0,null,$))},m=a=>{const n=y(a);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,l.$fA)(c)}throw new g.$OM(a,(0,S.localize)(1,null,$,v.$ae(n)))},r=a=>{if(o){const n=this.a.getFolderUri(o);if(n)return n;throw new g.$OM(a,(0,S.localize)(2,null,$,o))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$OM(a,(0,S.localize)(3,null,$)):new g.$OM(a,(0,S.localize)(4,null,$))};switch(d){case"env":if(o){if(b.env){const a=b.env[A.$i?o.toLowerCase():o];if(C.$jf(a))return a}return""}throw new g.$OM(g.VariableKind.Env,(0,S.localize)(5,null,$));case"config":if(o){const a=this.a.getConfigurationValue(t,o);if(C.$sf(a))throw new g.$OM(g.VariableKind.Config,(0,S.localize)(6,null,$,o));if(C.$lf(a))throw new g.$OM(g.VariableKind.Config,(0,S.localize)(7,null,$,o));return a}throw new g.$OM(g.VariableKind.Config,(0,S.localize)(8,null,$));case"command":return this.p(g.VariableKind.Command,$,o,i,"command");case"input":return this.p(g.VariableKind.Input,$,o,i,"input");case"extensionInstallFolder":if(o){const a=await this.a.getExtension(o);if(!a)throw new g.$OM(g.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,$,o));return this.n(a.extensionLocation)}throw new g.$OM(g.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,$));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,l.$fA)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||o?(0,l.$fA)(this.n(r(g.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$fA)(v.$ae(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new g.$OM(g.VariableKind.UserHome,(0,S.localize)(11,null,$))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new g.$OM(g.VariableKind.LineNumber,(0,S.localize)(12,null,$))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new g.$OM(g.VariableKind.SelectedText,(0,S.localize)(13,null,$))}case"file":return y(g.VariableKind.File);case"fileWorkspaceFolder":return m(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||o?v.$$d(this.n(r(g.VariableKind.RelativeFile)),y(g.VariableKind.RelativeFile)):y(g.VariableKind.RelativeFile);case"relativeFileDirname":{const a=v.$_d(y(g.VariableKind.RelativeFileDirname));if(t||o){const n=v.$$d(this.n(r(g.VariableKind.RelativeFileDirname)),a);return n.length===0?".":n}return a}case"fileDirname":return v.$_d(y(g.VariableKind.FileDirname));case"fileExtname":return v.$be(y(g.VariableKind.FileExtname));case"fileBasename":return v.$ae(y(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=v.$ae(y(g.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-v.$be(a).length)}case"fileDirnameBasename":return v.$ae(v.$_d(y(g.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||$}case"execInstallFolder":{const a=this.a.getAppRoot();return a||$}case"pathSeparator":return v.sep;default:try{const a=o?`${d}:${o}`:d;return this.p(g.VariableKind.Unknown,$,a,i,void 0)}catch{return $}}}}p(b,$,d,t,i){if(d&&t){const o=i===void 0?t[d]:t[i+":"+d];if(typeof o=="string")return o;throw new g.$OM(b,(0,S.localize)(14,null,$))}return $}}e.$3M=D}),define(Ae[103],Re([1,0,4,99]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=e.$7C=e.OpenEditorContext=e.GroupsOrder=e.$6C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$5C=void 0,e.$5C=(0,v.$Bh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var S;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function g($){const d=$;return(0,F.$UE)(d?.editor)&&(0,F.$UE)(d?.replacement)}e.$6C=g;var P;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u($){const d=$;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$7C=u;function b($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$8C=b}),define(Ae[202],Re([1,0,4,103]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.$0C=e.$9C=void 0,e.$9C=(0,v.$Bh)("editorService"),e.$0C=-1,e.$$C=-2;function C(T){const A=T;return typeof T=="number"||(0,F.$7C)(A)}e.$_C=C}),define(Ae[8],Re([1,0,18,25,123,203,49,28,117,69,68,24,16,2,44,78,94,102,99,75,45,57,202,7]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$1L=e.$ZL=e.MarkdownString=e.$YL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ce){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=H,xe=new a.$3J(Me-1,Be-1),$t=new a.$3J(Ge-1,We-1);return new a.$5J(xe,$t)}Ce.to=Fe;function me(H){const{anchor:Me,active:Be}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=me})(n||(e.Selection=n={}));var c;(function(Ce){function Fe(H){if(!H)return;const{start:Me,end:Be}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Fe;function me(H){if(!H)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Ge,endColumn:We}=H;return new a.$4J(Me-1,Be-1,Ge-1,We-1)}Ce.to=me})(c||(e.Range=c={}));var E;(function(Ce){function Fe(me){switch(me){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ce.to=Fe})(E||(e.TokenType=E={}));var p;(function(Ce){function Fe(H){return new a.$3J(H.lineNumber-1,H.column-1)}Ce.to=Fe;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=me})(p||(e.Position=p={}));var I;(function(Ce){function Fe(Me,Be,Ge){return(0,v.$Fb)((0,v.$1b)(Me).map(We=>me(We,Be,Ge)))}Ce.from=Fe;function me(Me,Be,Ge){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ge?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,Be),pattern:rt.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var k;(function(Ce){function Fe(H){switch(H){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ce.from=Fe;function me(H){switch(H){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(k||(e.DiagnosticTag=k={}));var s;(function(Ce){function Fe(H){let Me;return H.code&&((0,u.$jf)(H.code)||(0,u.$nf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...c.from(H.range),message:H.message,source:H.source,code:Me,severity:w.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(f.from),tags:Array.isArray(H.tags)?(0,v.$Fb)(H.tags.map(k.from)):void 0}}Ce.from=Fe;function me(H){const Me=new a.$dK(c.to(H),H.message,w.to(H.severity));return Me.source=H.source,Me.code=(0,u.$jf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(f.to),Me.tags=H.tags&&(0,v.$Fb)(H.tags.map(k.to)),Me}Ce.to=me})(s||(e.Diagnostic=s={}));var f;(function(Ce){function Fe(H){return{...c.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Fe;function me(H){return new a.$cK(new a.$bK(H.resource,c.to(H)),H.message)}Ce.to=me})(f||(e.DiagnosticRelatedInformation=f={}));var w;(function(Ce){function Fe(H){switch(H){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Fe;function me(H){switch(H){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ce.to=me})(w||(e.DiagnosticSeverity=w={}));var R;(function(Ce){function Fe(H){return typeof H=="number"&&H>=a.ViewColumn.One?H-1:H===a.ViewColumn.Beside?r.$$C:r.$0C}Ce.from=Fe;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(R||(e.ViewColumn=R={}));function W(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$YL=V;var U;(function(Ce){function Fe(We){return We.map(Ce.from)}Ce.fromMany=Fe;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let xe;if(me(We)){const{language:ut,value:mt}=We;xe={value:"```"+ut+`
`+mt+"\n```\n"}}else a.$qK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const $t=Object.create(null);xe.uris=$t;const Ct=ut=>{try{let mt=b.URI.parse(ut,!0);mt=mt.with({query:Me(mt.query,$t)}),$t[ut]=mt}catch{}return""},bt=new S.marked.Renderer;return bt.link=Ct,bt.image=ut=>typeof ut=="string"?Ct(A.$5j(ut).href):"",(0,S.marked)(xe.value,{renderer:bt}),xe}Ce.from=H;function Me(We,xe){if(!We)return We;let $t;try{$t=(0,g.$0g)(We)}catch{}if(!$t)return We;let Ct=!1;return $t=(0,D.$Xm)($t,bt=>{if(b.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ut]=bt,Ct=!0,ut}else return}),Ct?JSON.stringify($t):We}function Be(We){const xe=new a.$qK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?b.URI.from(We.baseUri):void 0,xe}Ce.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(U||(e.MarkdownString=U={}));function B(Ce){return V(Ce)?Ce.map(Fe=>({range:c.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?U.fromMany(Fe.hoverMessage):Fe.hoverMessage?U.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ce.map(Fe=>({range:c.from(Fe)}))}e.$ZL=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$1L=O;var N;(function(Ce){function Fe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Fe})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ee;(function(Ce){function Fe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Fe})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Y;(function(Ce){function Fe(me){if(typeof me>"u")return me;switch(me){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Fe})(Y||(e.DecorationRangeBehavior=Y={}));var Ee;(function(Ce){function Fe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Y.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ee.from(me.light):void 0,dark:me.dark?ee.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Fe})(Ee||(e.DecorationRenderOptions=Ee={}));var ke;(function(Ce){function Fe(H){return{text:H.newText,eol:H.newEol&&Xe.from(H.newEol),range:c.from(H.range)}}Ce.from=Fe;function me(H){const Me=new a.$9J(c.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Xe.to(H.eol),Me}Ce.to=me})(ke||(e.TextEdit=ke={}));var Pe;(function(Ce){function Fe(H,Me){const Be={edits:[]};if(H instanceof a.$_J){const Ge=new l.$Ai;for(const We of H._allEntries())We._type===1&&b.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,F.$Zd)(F.$Fd.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:c.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(dt.from)}})}return Be}Ce.from=Fe;function me(H){const Me=new a.$_J,Be=new l.$zi;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,xe=b.URI.revive(We.resource),$t=c.to(We.textEdit.range),Ct=We.textEdit.text,bt=We.textEdit.insertAsSnippet;let ut;bt?ut=a.$$J.replace($t,new a.$aK(Ct)):ut=a.$9J.replace($t,Ct);const mt=Be.get(xe);mt?mt.push(ut):Be.set(xe,[ut])}else Me.renameFile(b.URI.revive(Ge.oldResource),b.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Me.set(Ge,We);return Me}Ce.to=me})(Pe||(e.WorkspaceEdit=Pe={}));var X;(function(Ce){const Fe=Object.create(null);Fe[a.SymbolKind.File]=0,Fe[a.SymbolKind.Module]=1,Fe[a.SymbolKind.Namespace]=2,Fe[a.SymbolKind.Package]=3,Fe[a.SymbolKind.Class]=4,Fe[a.SymbolKind.Method]=5,Fe[a.SymbolKind.Property]=6,Fe[a.SymbolKind.Field]=7,Fe[a.SymbolKind.Constructor]=8,Fe[a.SymbolKind.Enum]=9,Fe[a.SymbolKind.Interface]=10,Fe[a.SymbolKind.Function]=11,Fe[a.SymbolKind.Variable]=12,Fe[a.SymbolKind.Constant]=13,Fe[a.SymbolKind.String]=14,Fe[a.SymbolKind.Number]=15,Fe[a.SymbolKind.Boolean]=16,Fe[a.SymbolKind.Array]=17,Fe[a.SymbolKind.Object]=18,Fe[a.SymbolKind.Key]=19,Fe[a.SymbolKind.Null]=20,Fe[a.SymbolKind.EnumMember]=21,Fe[a.SymbolKind.Struct]=22,Fe[a.SymbolKind.Event]=23,Fe[a.SymbolKind.Operator]=24,Fe[a.SymbolKind.TypeParameter]=25;function me(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ce.from=me;function H(Me){for(const Be in Fe)if(Fe[Be]===Me)return Number(Be);return a.SymbolKind.Property}Ce.to=H})(X||(e.SymbolKind=X={}));var ue;(function(Ce){function Fe(H){switch(H){case a.SymbolTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return a.SymbolTag.Deprecated}}Ce.to=me})(ue||(e.SymbolTag=ue={}));var ye;(function(Ce){function Fe(H){return{name:H.name,kind:X.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Fe;function me(H){const Me=new a.$gK(H.name,X.to(H.kind),H.containerName,q.to(H.location));return Me.tags=H.tags&&H.tags.map(ue.to),Me}Ce.to=me})(ye||(e.WorkspaceSymbol=ye={}));var ce;(function(Ce){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:c.from(H.range),selectionRange:c.from(H.selectionRange),kind:X.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ce.from=Fe;function me(H){const Me=new a.$hK(H.name,H.detail,X.to(H.kind),c.to(H.range),c.to(H.selectionRange));return(0,v.$Jb)(H.tags)&&(Me.tags=H.tags.map(ue.to)),H.children&&(Me.children=H.children.map(me)),Me}Ce.to=me})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Fe(H){const Me=new a.$mK(X.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),c.to(H.range),c.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,Be){if(Me=Me??H._sessionId,Be=Be??H._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:H.name,detail:H.detail,kind:X.from(H.kind),uri:H.uri,range:c.from(H.range),selectionRange:c.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=me})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Fe(me){return new a.$nK($e.to(me.from),me.fromRanges.map(H=>c.to(H)))}Ce.to=Fe})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Fe(me){return new a.$oK($e.to(me.to),me.fromRanges.map(H=>c.to(H)))}Ce.to=Fe})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Fe(H){return{range:H.range&&c.from(H.range),uri:H.uri}}Ce.from=Fe;function me(H){return new a.$bK(b.URI.revive(H.uri),c.to(H.range))}Ce.to=me})(q||(e.location=q={}));var le;(function(Ce){function Fe(H){const Me=H,Be=H;return{originSelectionRange:Me.originSelectionRange?c.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:c.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?c.from(Me.targetSelectionRange):void 0}}Ce.from=Fe;function me(H){return{targetUri:b.URI.revive(H.uri),targetRange:c.to(H.range),targetSelectionRange:H.targetSelectionRange?c.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?c.to(H.originSelectionRange):void 0}}Ce.to=me})(le||(e.DefinitionLink=le={}));var we;(function(Ce){function Fe(H){return{range:c.from(H.range),contents:U.fromMany(H.contents)}}Ce.from=Fe;function me(H){return new a.$eK(H.contents.map(U.to),c.to(H.range))}Ce.to=me})(we||(e.Hover=we={}));var ve;(function(Ce){function Fe(H){return{range:c.from(H.range),expression:H.expression}}Ce.from=Fe;function me(H){return new a.$$K(c.to(H.range),H.expression)}Ce.to=me})(ve||(e.EvaluatableExpression=ve={}));var ge;(function(Ce){function Fe(H){if(H instanceof a.$_K)return{type:"text",range:c.from(H.range),text:H.text};if(H instanceof a.$aL)return{type:"variable",range:c.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof a.$bL)return{type:"expression",range:c.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Fe;function me(H){switch(H.type){case"text":return{range:c.to(H.range),text:H.text};case"variable":return{range:c.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:c.to(H.range),expression:H.expression}}}Ce.to=me})(ge||(e.InlineValue=ge={}));var De;(function(Ce){function Fe(H){return{frameId:H.frameId,stoppedLocation:c.from(H.stoppedLocation)}}Ce.from=Fe;function me(H){return new a.$cL(H.frameId,c.to(H.stoppedLocation))}Ce.to=me})(De||(e.InlineValueContext=De={}));var ne;(function(Ce){function Fe(H){return{range:c.from(H.range),kind:H.kind}}Ce.from=Fe;function me(H){return new a.$fK(c.to(H.range),H.kind)}Ce.to=me})(ne||(e.DocumentHighlight=ne={}));var he;(function(Ce){function Fe(me){switch(me){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ce.to=Fe})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Fe(me){return{triggerKind:he.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Fe})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Fe(H){switch(H){case a.CompletionItemTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return a.CompletionItemTag.Deprecated}}Ce.to=me})(oe||(e.CompletionItemTag=oe={}));var fe;(function(Ce){const Fe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function me(Be){return Fe.get(Be)??9}Ce.from=me;const H=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(Be){return H.get(Be)??a.CompletionItemKind.Property}Ce.to=Me})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Fe(me,H){const Me=new a.$wK(me.label);return Me.insertText=me.insertText,Me.kind=fe.to(me.kind),Me.tags=me.tags?.map(oe.to),Me.detail=me.detail,Me.documentation=A.$Zj(me.documentation)?U.to(me.documentation):me.documentation,Me.sortText=me.sortText,Me.filterText=me.filterText,Me.preselect=me.preselect,Me.commitCharacters=me.commitCharacters,$.$ks.isIRange(me.range)?Me.range=c.to(me.range):typeof me.range=="object"&&(Me.range={inserting:c.to(me.range.insert),replacing:c.to(me.range.replace)}),Me.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Me.insertText=new a.$aK(me.insertText):(Me.insertText=me.insertText,Me.textEdit=Me.range instanceof a.$4J?new a.$9J(Me.range,Me.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Me.additionalTextEdits=me.additionalTextEdits.map(Be=>ke.to(Be))),Me.command=H&&me.command?H.fromInternal(me.command):void 0,Me}Ce.to=Fe})(Ie||(e.CompletionItem=Ie={}));var M;(function(Ce){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:U.fromStrict(H.documentation)}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$Zj(H.documentation)?U.to(H.documentation):H.documentation}}Ce.to=me})(M||(e.ParameterInformation=M={}));var K;(function(Ce){function Fe(H){return{label:H.label,documentation:U.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(M.from):[],activeParameter:H.activeParameter}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$Zj(H.documentation)?U.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(M.to):[],activeParameter:H.activeParameter}}Ce.to=me})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Fe;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=me})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Fe(me,H){const Me=new a.$vK(p.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,me)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(ke.to),Me.tooltip=A.$Zj(H.tooltip)?U.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Fe})(Q||(e.InlayHint=Q={}));var J;(function(Ce){function Fe(me,H){const Me=new a.$uK(H.label);return Me.tooltip=A.$Zj(H.tooltip)?U.to(H.tooltip):H.tooltip,d.Command.is(H.command)&&(Me.command=me.fromInternal(H.command)),H.location&&(Me.location=q.to(H.location)),Me}Ce.to=Fe})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Fe(H){return H}Ce.from=Fe;function me(H){return H}Ce.to=me})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Fe(H){return{range:c.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Fe;function me(H){let Me;if(H.url)try{Me=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new a.$BK(c.to(H.range),Me)}Ce.to=me})(ae||(e.DocumentLink=ae={}));var Oe;(function(Ce){function Fe(H){const Me=new a.$EK(H.label);return H.textEdit&&(Me.textEdit=ke.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(Be=>ke.to(Be))),Me}Ce.to=Fe;function me(H){return{label:H.label,textEdit:H.textEdit?ke.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>ke.from(Me)):void 0}}Ce.from=me})(Oe||(e.ColorPresentation=Oe={}));var je;(function(Ce){function Fe(H){return new a.$CK(H[0],H[1],H[2],H[3])}Ce.to=Fe;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=me})(je||(e.Color=je={}));var Qe;(function(Ce){function Fe(H){return{range:c.from(H.range)}}Ce.from=Fe;function me(H){return new a.$lK(c.to(H.range))}Ce.to=me})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ce){function Fe(me){switch(me){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ce.to=Fe})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ce){function Fe(H){switch(H){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Fe;function me(H){switch(H){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ce.to=me})(et||(e.TextEditorLineNumbersStyle=et={}));var Xe;(function(Ce){function Fe(H){if(H===a.EndOfLine.CRLF)return 1;if(H===a.EndOfLine.LF)return 0}Ce.from=Fe;function me(H){if(H===1)return a.EndOfLine.CRLF;if(H===0)return a.EndOfLine.LF}Ce.to=me})(Xe||(e.EndOfLine=Xe={}));var _e;(function(Ce){function Fe(me){if(typeof me=="object")return me.viewId;switch(me){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Fe;function me(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Fe(H){if(H)switch(H){case a.FoldingRangeKind.Comment:return d.$_s.Comment;case a.FoldingRangeKind.Imports:return d.$_s.Imports;case a.FoldingRangeKind.Region:return d.$_s.Region}}Ce.from=Fe;function me(H){if(H)switch(H.value){case d.$_s.Comment.value:return a.FoldingRangeKind.Comment;case d.$_s.Imports.value:return a.FoldingRangeKind.Imports;case d.$_s.Region.value:return a.FoldingRangeKind.Region}}Ce.to=me})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Fe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?c.from(me.selection):void 0,override:typeof me.override=="boolean"?o.$HE.id:void 0}}Ce.from=Fe})(ze||(e.TextEditorOpenOptions=ze={}));var rt;(function(Ce){function Fe(Be){return Be instanceof a.$YK?Be.toJSON():typeof Be=="string"?Be:me(Be)||H(Be)?new a.$YK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Fe;function me(Be){const Ge=Be;return Ge?b.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new a.$YK(b.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Me})(rt||(e.GlobPattern=rt={}));var _;(function(Ce){function Fe(me){if(me){if(Array.isArray(me))return me.map(Fe);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:rt.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Fe})(_||(e.LanguageSelector=_={}));var Z;(function(Ce){function Fe(H){return!!H&&typeof H=="object"&&"selections"in H&&Array.isArray(H.selections)&&H.selections.every(Me=>Me instanceof a.$5J)&&"related"in H&&Array.isArray(H.related)&&H.related.every(Me=>Me&&typeof Me=="object"&&b.URI.isUri(Me.uri)&&Me.range instanceof a.$4J)}Ce.is=Fe;function me(H){return{selections:H.selections.map(Me=>n.from(Me)),related:H.related.map(Me=>({uri:b.URI.from(Me.uri),range:c.from(Me.range)}))}}Ce.from=me})(Z||(e.MappedEditsContext=Z={}));var pe;(function(Ce){function Fe(H){return{start:H.start,end:H.end}}Ce.from=Fe;function me(H){return new a.$nL(H.start,H.end)}Ce.to=me})(pe||(e.NotebookRange=pe={}));var Ue;(function(Ce){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Fe;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=me})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ne;(function(Ce){function Fe(me){if(me===h.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(me===h.NotebookCellExecutionState.Pending)return;if(me===h.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Fe})(Ne||(e.NotebookCellExecutionState=Ne={}));var Ze;(function(Ce){function Fe(H){switch(H){case a.NotebookCellKind.Markup:return h.CellKind.Markup;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}Ce.from=Fe;function me(H){switch(H){case h.CellKind.Markup:return a.NotebookCellKind.Markup;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}Ce.to=me})(Ze||(e.NotebookCellKind=Ze={}));var nt;(function(Ce){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)a.$oL.validate(Be),Me.cells.push(dt.from(Be));return Me}Ce.from=Fe;function me(H){const Me=new a.$pL(H.cells.map(dt.to));return(0,u.$wf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=me})(nt||(e.NotebookData=nt={}));var dt;(function(Ce){function Fe(H){return{cellKind:Ze.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Ue.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ot.from):[]}}Ce.from=Fe;function me(H){return new a.$oL(Ze.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ot.to):void 0,H.metadata,H.internalMetadata?Ue.to(H.internalMetadata):void 0)}Ce.to=me})(dt||(e.NotebookCellData=dt={}));var vt;(function(Ce){function Fe(H){return{mime:H.mime,valueBytes:F.$Fd.wrap(H.data)}}Ce.from=Fe;function me(H){return new a.$qL(H.valueBytes.buffer,H.mime)}Ce.to=me})(vt||(e.NotebookCellOutputItem=vt={}));var Ot;(function(Ce){function Fe(H){return{outputId:H.id,items:H.items.map(vt.from),metadata:H.metadata}}Ce.from=Fe;function me(H){const Me=H.items.map(vt.to);return new a.$rL(Me,H.outputId,H.metadata)}Ce.to=me})(Ot||(e.NotebookCellOutput=Ot={}));var Zt;(function(Ce){function Fe(Me){return H(Me)?{include:rt.from(Me.include)??void 0,exclude:rt.from(Me.exclude)??void 0}:rt.from(Me)??void 0}Ce.from=Fe;function me(Me){return H(Me)?{include:rt.to(Me.include),exclude:rt.to(Me.exclude)}:rt.to(Me)}Ce.to=me;function H(Me){const Be=Me;return Be?!(0,u.$sf)(Be.include)&&!(0,u.$sf)(Be.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var qt;(function(Ce){function Fe(me,H,Me){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Be,Me),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Fe})(qt||(e.NotebookStatusBarItem=qt={}));var wt;(function(Ce){function Fe(me,H,Me){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(Be,Me),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Fe})(wt||(e.NotebookKernelSourceAction=wt={}));var Nt;(function(Ce){function Fe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var zt;(function(Ce){function Fe(H){return{uri:H.uri,provides:H.provides}}Ce.from=Fe;function me(H){return new a.$tL(b.URI.revive(H.uri),H.provides)}Ce.to=me})(zt||(e.NotebookRendererScript=zt={}));var Ht;(function(Ce){function Fe(H){return{message:U.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:c.from(H.location.range),uri:H.location.uri}}}Ce.from=Fe;function me(H){const Me=new a.$zL(typeof H.message=="string"?H.message:U.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?q.to(H.location):void 0,Me}Ce.to=me})(Ht||(e.TestMessage=Ht={}));var Pt;(function(Ce){Ce.namespace=m.$SI,Ce.denamespace=m.$TI})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Fe(H){const Me=(0,i.$XL)(H).controllerId;return{extId:y.$OI.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>Pt.namespace(Me,Be.id)),range:$.$ks.lift(c.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&U.fromStrict(H.error)||null}}Ce.from=Fe;function me(H){return{parent:void 0,error:void 0,id:y.$OI.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:Be}=Pt.denamespace(Me);return new a.$AL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=me})(At||(e.TestItem=At={})),function(Ce){function Fe(H){return{id:H.id}}Ce.from=Fe;function me(H){return new a.$AL(H.id)}Ce.to=me}(Pt||(e.TestTag=Pt={}));var jt;(function(Ce){const Fe=(H,Me)=>{const Be=[];for(const[We,xe]of Me)y.$OI.compare(xe.item.extId,We)===2&&(Me.delete(We),Be.push(xe));const Ge={...At.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Ht.to)})),children:Be.map(We=>Fe(We,Me))};for(const We of Ge.children)We.parent=Ge;return Ge};function me(H){const Me=[],Be=new Map;for(const Ge of H.items){Be.set(Ge.item.extId,Ge);const We=y.$OI.root(Ge.item.extId);H.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Me.push(Ge)}return{completedAt:H.completedAt,results:Me.map(Ge=>Fe(Ge,Be))}}Ce.to=me})(jt||(e.TestResults=jt={}));var Bt;(function(Ce){function Fe(Be){return{covered:Be.covered,total:Be.covered}}function me(Be){return"line"in Be?p.from(Be):c.from(Be)}function H(Be){return"branches"in Be?{count:Be.executionCount,location:me(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&me(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:me(Be.location)}}Ce.fromDetailed=H;function Me(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Bt||(e.TestCoverage=Bt={}));var Kt;(function(Ce){function Fe(me){switch(me){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ce.to=Fe})(Kt||(e.CodeActionTriggerKind=Kt={}));var Wt;(function(Ce){function Fe(H){const Me=new a.$GL(X.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),c.to(H.range),c.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,Be){if(Me=Me??H._sessionId,Be=Be??H._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:X.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:c.from(H.range),selectionRange:c.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=me})(Wt||(e.TypeHierarchyItem=Wt={}));var Vt;(function(Ce){function Fe(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Fe})(Vt||(e.ViewBadge=Vt={}));var ot;(function(Ce){function Fe(Be,Ge,We){const xe=Ge.fileData;return xe?new a.$RK(new a.$SK(xe.name,b.URI.revive(xe.uri),xe.id,(0,T.$bb)(()=>We(xe.id)))):Be===P.$Hr.uriList&&Ge.uriListData?new a.$QK(Me(Ge.uriListData)):new a.$QK(Ge.asString)}Ce.to=Fe;async function me(Be,Ge){const We=await Ge.asString();if(Be===P.$Hr.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ce.from=me;function H(Be){return C.$Ts.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return b.URI.parse(Ge)}catch{}return Ge})}function Me(Be){return C.$Ts.create(Be.map(Ge=>typeof Ge=="string"?Ge:b.URI.revive(Ge)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Ce){function Fe(H,Me){const Be=H.items.map(([Ge,We])=>[Ge,ot.to(Ge,We,Me)]);return new a.$TK(Be)}Ce.toDataTransfer=Fe;async function me(H){const Me={items:[]},Be=[];for(const[Ge,We]of H)Be.push((async()=>{Me.items.push([Ge,await ot.from(Ge,We)])})());return await Promise.all(Be),Me}Ce.from=me})(ft||(e.DataTransfer=ft={}));var Rt;(function(Ce){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Fe;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=me})(Rt||(e.ChatReplyFollowup=Rt={}));var Ft;(function(Ce){function Fe(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:Rt.from(me)}Ce.from=Fe})(Ft||(e.ChatFollowup=Ft={}));var It;(function(Ce){function Fe(H){const Me=new a.$QL(ht.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Fe;function me(H){return{role:ht.from(H.role),content:H.content,name:H.name}}Ce.from=me})(It||(e.ChatMessage=It={}));var ht;(function(Ce){function Fe(H){switch(H){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ce.to=Fe;function me(H){switch(H){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ce.from=me})(ht||(e.ChatMessageRole=ht={}));var kt;(function(Ce){function Fe(H){return{level:Dt.to(H.level),value:H.value,description:H.description}}Ce.to=Fe;function me(H){return{level:Dt.from(H.level),value:H.value,description:H.description}}Ce.from=me})(kt||(e.ChatVariable=kt={}));var Dt;(function(Ce){function Fe(H){switch(H){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ce.to=Fe;function me(H){switch(H){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ce.from=me})(Dt||(e.ChatVariableLevel=Dt={}));var Mt;(function(Ce){function Fe(me){switch(me){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Fe})(Mt||(e.InteractiveEditorResponseFeedbackKind=Mt={}));var Ve;(function(Ce){function Fe(me,H,Me){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Me)}Ce.from=Fe})(Ve||(e.TerminalQuickFix=Ve={}))}),define(Ae[204],Re([1,0,2,9,7,8,174]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class l{constructor(g,P,D,u={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=D,this.g=u,this.a=new A.$tc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,D,u)=>{const $={dispose:this.a.push([P,D,g])};return Array.isArray(u)&&u.push($),$}}async $participateInSave(g,P){const D=v.URI.revive(g);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),$=[];try{for(const d of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(d,{document:t,reason:T.TextDocumentSaveReason.to(P)});$.push(i)}}finally{clearTimeout(b)}return $}h([g,P,D],u){const b=this.b.get(g);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,g,P,u).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const d=this.b.get(g);this.b.set(g,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,D,u){const b=[],$=Date.now(),{document:d,reason:t}=u,{version:i}=d,o=Object.freeze({document:d,reason:t,waitUntil(h){if(Object.isFrozen(b))throw(0,F.$6)("waitUntil can not be called async");b.push(Promise.resolve(h))}});try{P.apply(D,[o])}catch(h){return Promise.reject(h)}return Object.freeze(b),new Promise((h,y)=>{const m=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(b).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(m),h(r)}).catch(r=>{clearTimeout(m),y(r)})}).then(h=>{const y={edits:[]};for(const m of h)if(Array.isArray(m)&&m.every(r=>r instanceof C.$9J))for(const{newText:r,newEol:a,range:n}of m)y.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:n&&T.Range.from(n),text:r,eol:a&&T.EndOfLine.from(a)}});if(y.edits.length!==0)return i===d.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.$jbc=l}),define(Ae[205],Re([1,0,13,2,8,7,75]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;class l{constructor(D,u,b,$){this.start=D,this.deletedCount=u,this.deletedItems=b,this.items=$}asApiEvent(){return{range:new T.$nL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,b){this.notebook=D,this.h=u,this.j=b,this.handle=b.handle,this.uri=F.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,b){const $=b.map(C.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===D);if(d&&(u||(d.items.length=0),d.items.push(...$),d.items.length>1&&d.items.every(t=>A.$9H(t.mime)))){const t=new Map,i=[];d.items.forEach(o=>{let h;t.has(o.mime)?h=t.get(o.mime):(h=[],t.set(o.mime,h),i.push(o.mime)),h.push(o.data)}),d.items.length=0,i.forEach(o=>{const h=A.$0H(t.get(o));d.items.push({mime:o,data:h.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$wcc=S;class g{static{this.a=0}constructor(D,u,b,$,d){this.k=D,this.l=u,this.m=b,this.uri=$,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===v.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(d=>d.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,b){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const $={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},d=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),d.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),d.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<d.length;i++){const o=d[i],h=t.get(o.cell);if(h===void 0){const y=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...o});t.set(o.cell,y-1)}else $.cellChanges[h]={...$.cellChanges[h],...o}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,b=D.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),D.with({start:u,end:b})}p(D){D=this.o(D);const u=[];for(let b=D.start;b<D.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,b){if(this.j)return;const $=[],d=[],t=[];if(D.reverse().forEach(i=>{const h=i[2].map(r=>{const a=new S(this,this.l,r);return u||d.push(S.asModelAddData(this.apiNotebook,r)),a}),y=new l(i[0],i[1],[],h),m=this.b.splice(i[0],i[1],...h);for(const r of m)t.push(r.uri),y.deletedItems.push(r.apiCell);$.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),b)for(const i of $)b.push(i.asApiEvent())}s(D,u,b,$){const d=this.b.splice(D,u);this.b.splice(b,0,...d);const t=[new l(D,u,d.map(i=>i.apiCell),[]),new l(b,0,[],d)];for(const i of t)$.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,b,$){this.b[D].setOutputItems(u,b,$)}v(D,u){const b=this.b[D];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(D,u){const b=this.b[D];b.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$xcc=g}),define(Ae[206],Re([1,0,5,2,8,7]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class A{constructor(S,g,P,D={timeout:1500,errors:3}){this.b=S,this.c=g,this.d=P,this.f=D,this.a=new v.$hd}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(g,P,D)=>{const u=function($){g.call(P,$)};return u.extension=S,this.a.event(u,void 0,D)}}async $participateInSave(S,g,P){const D=F.URI.revive(S),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},P,async(d,t)=>{const i=Date.now(),o=await await Promise.resolve(d);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&o&&(o instanceof T.$_J?b.push(o):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const $={edits:[]};for(const d of b){const{edits:t}=C.WorkspaceEdit.from(d);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Xcc=A}),define(Ae[104],Re([1,0,9,8,7]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,S,g,P,D,u){this.id=l,this.f=S,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=u}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(S){this.selections=[S]},get selections(){return l.a},set selections(S){if(!Array.isArray(S)||!S.every(C.$nL.isNotebookRange))throw(0,v.$5)("selections");l.a=S,l.g(S)},get visibleRanges(){return l.b},revealRange(S,g){l.f.$tryRevealRange(l.id,F.NotebookRange.from(S),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(F.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$ycc=T}),define(Ae[207],Re([1,0,9,5,14,8]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let A=class{constructor(S,g){this.c=S,this.d=g,this.a=new F.$fd({onListenerError:v.$Z}),this.b=new F.$fd({onListenerError:v.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,g);const P=this.d.getEditorById(S);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(T.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(T.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const g in S)this.d.getEditorById(g)._acceptViewColumn(T.ViewColumn.to(S[g]))}};e.$Qcc=A,e.$Qcc=A=Ke([qe(0,C.$5i)],A)}),define(Ae[208],Re([1,0,8,50,153,21,65,9]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class S{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,$){const d=this.b++,{title:t,location:i,cancellable:o}=b,h={label:(0,C.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(i),title:t,source:h,cancellable:o},u.isUnderDevelopment?void 0:u.identifier.value).catch(l.$Z),this.d(d,$,!!o)}d(u,b,$){let d;$&&(d=new T.$pd,this.c.set(u,d));const t=o=>{this.a.$progressEnd(o),this.c.delete(o),d?.dispose()};let i;try{i=b(new P(this.a,u),$&&d?d.token:T.CancellationToken.None)}catch(o){throw t(u),o}return i.then(o=>t(u),o=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$Ubc=S;function g(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class P extends F.$4u{constructor(u,b){super($=>this.throttledReport($)),this.f=u,this.g=b}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$8g)(100,(D,u)=>g(D,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,102,45,76,57,8,2]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=e.$bM=void 0;const g=(h,y,m,r)=>{let a=y;return{enumerable:!0,configurable:!1,get(){return a},set(n){if(!m(a,n)){const c=a;a=n,h.listener?.(r(n,c))}}}},P=(h,y)=>h===y,D={range:(h,y)=>h===y?!0:!h||!y?!1:h.isEqual(y),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(h,y)=>!(h.length!==y.length||h.some(m=>!y.find(r=>m.id===r.id)))},u=h=>y=>({op:4,update:h(y)}),b=(h,y)=>({range:(()=>{let m;const r=u(a=>({range:v.$ks.lift(l.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return m},set(a){h.listener?.({op:6}),D.range(m,a)||(m=a,h.listener?.(r(a)))}}})(),label:g(h,y,D.label,u(m=>({label:m}))),description:g(h,void 0,D.description,u(m=>({description:m}))),sortText:g(h,void 0,D.sortText,u(m=>({sortText:m}))),canResolveChildren:g(h,!1,D.canResolveChildren,m=>({op:2,state:m})),busy:g(h,!1,D.busy,u(m=>({busy:m}))),error:g(h,void 0,D.error,u(m=>({error:l.MarkdownString.fromStrict(m)||null}))),tags:g(h,[],D.tags,(m,r)=>({op:1,new:m.map(l.TestTag.from),old:r.map(l.TestTag.from)}))}),$=h=>{const y=C.$OI.fromString(h.extId),m=new t(y.controllerId,y.localId,h.label,S.URI.revive(h.uri)||void 0);return m.range=l.Range.to(h.range||void 0),m.description=h.description||void 0,m.sortText=h.sortText||void 0,m.tags=h.tags.map(r=>l.TestTag.to({id:(0,A.$TI)(r).tagId})),m},d=h=>{let y;for(const m of h.tests){const r=$(m.item);(0,F.$XL)(r).parent=y,y=r}return y};e.$bM=d;class t{constructor(y,m,r,a){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const n=(0,F.$WL)(this,y);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,T.$VL)(n,F.$XL,t),enumerable:!0,writable:!1},...b(n,r)})}}e.$cM=t;class i extends t{constructor(y,m){super(y,y,m,void 0),this._isRoot=!0}}e.$dM=i;class o extends T.$RL{constructor(y,m,r){super({controllerId:y,getDocumentVersion:a=>a&&r.getDocument(a)?.version,getApiFor:F.$XL,getChildren:a=>a.children,root:new i(y,m),toITestItem:l.TestItem.from})}}e.$eM=o}),define(Ae[106],Re([1,0,51,9,88,8,7]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.$9L=void 0;class l{static{this.c=new C.$7L("TextEditorDecorationType")}constructor(u,b,$){const d=l.c.nextId();u.$registerTextEditorDecorationType(b.identifier,d,T.DecorationRenderOptions.from($)),this.value=Object.freeze({key:d,dispose(){u.$removeTextEditorDecorationType(d)}})}}e.$9L=l;class S{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let $=null;if(u instanceof A.$3J)$=new A.$4J(u,u);else if(u instanceof A.$4J)$=u;else throw new Error("Unrecognized location");this.l($,b,!1)}insert(u,b){this.k(),this.l(new A.$4J(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$4J)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,$){const d=this.c.validateRange(u);this.g.push({range:d,text:b,forceMoveMarkers:$})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=u}}class g{constructor(u,b,$,d){this.c=u,this.d=b,this._accept($),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let $=!1;if(typeof u.tabSize<"u"){const d=this.l(u.tabSize);d==="auto"?($=!0,b.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,$=!0,b.tabSize=d)}if(typeof u.indentSize<"u"){const d=this.n(u.indentSize);d==="tabSize"?($=!0,b.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,$=!0,b.indentSize=d)}if(typeof u.insertSpaces<"u"){const d=this.p(u.insertSpaces);d==="auto"?($=!0,b.insertSpaces=d):this.h!==d&&(this.h=d,$=!0,b.insertSpaces=d)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,$=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,$=!0,b.lineNumbers=T.TextEditorLineNumbersStyle.from(u.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn($)})}}e.$0L=g;class P{constructor(u,b,$,d,t,i,o,h){this.id=u,this.j=b,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,$),this.e=o,this.f=h;const y=this;this.value=Object.freeze({get document(){return d.value},set document(m){throw new F.$7("document")},get selection(){return y.c&&y.c[0]},set selection(m){if(!(m instanceof A.$5J))throw(0,F.$5)("selection");y.c=[m],y.l()},get selections(){return y.c},set selections(m){if(!Array.isArray(m)||m.some(r=>!(r instanceof A.$5J)))throw(0,F.$5)("selections");y.c=m,y.l()},get visibleRanges(){return y.e},set visibleRanges(m){throw new F.$7("visibleRanges")},get options(){return y.d.value},set options(m){y.g||y.d.assign(m)},get viewColumn(){return y.f},set viewColumn(m){throw new F.$7("viewColumn")},edit(m,r={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(d.value,r);return m(a),y.m(a)},insertSnippet(m,r,a={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=y.c.map(c=>T.Range.from(c));else if(r instanceof A.$3J){const{lineNumber:c,column:E}=T.Position.from(r);n=[{startLineNumber:c,startColumn:E,endLineNumber:c,endColumn:E}]}else if(r instanceof A.$4J)n=[T.Range.from(r)];else{n=[];for(const c of r)if(c instanceof A.$4J)n.push(T.Range.from(c));else{const{lineNumber:E,column:p}=T.Position.from(c);n.push({startLineNumber:E,startColumn:p,endLineNumber:E,endColumn:p})}}return b.$tryInsertSnippet(u,d.value.version,m.value,n,a)},setDecorations(m,r){const a=r.length===0;a&&!y.h.has(m.key)||(a?y.h.delete(m.key):y.h.add(m.key),y.n(()=>{if(T.$YL(r))return b.$trySetDecorations(u,m.key,T.$ZL(r));{const n=new Array(4*r.length);for(let c=0,E=r.length;c<E;c++){const p=r[c];n[4*c]=p.start.line+1,n[4*c+1]=p.start.character+1,n[4*c+2]=p.end.line+1,n[4*c+3]=p.end.character+1}return b.$trySetDecorationsFast(u,m.key,n)}}))},revealRange(m,r){y.n(()=>b.$tryRevealRange(u,T.Range.from(m),r||A.TextEditorRevealType.Default))},show(m){b.$tryShowEditor(u,T.ViewColumn.from(m))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const $=b.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const o=$[t].end;if($[t+1].start.isBefore(o))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=b.edits.map(t=>({range:T.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,d,{setEndOfLine:typeof b.setEndOfLine=="number"?T.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$$L=P}),define(Ae[209],Re([1,0,4,172]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=void 0,e.$gJ=(0,v.$Ch)(F.$Ih)}),define(Ae[107],Re([1,0,20,5,19,6]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=e.$w3b=e.$v3b=e.$u3b=e.$t3b=e.$s3b=void 0;class A{constructor(i,o){this.versionId=i,this.removedDueToLooping=o}}e.$s3b=A;class l{static isHostExtension(i,o,h){if(o.getExtensionDescription(i))return!1;const y=h.getExtensionDescription(i);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(i,o){this.j=i,this.c=new F.$fd,this.onDidChange=this.c.event,this.d=0,this.e=o,this.k()}k(){this.e.sort($),this.f=new v.$Xl,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const o=this.j.readActivationEvents(i);if(Array.isArray(o))for(let h of o)h==="onUri"&&(h=`onUri:${v.$Vl.toKey(i.identifier)}`),this.h.has(h)||this.h.set(h,[]),this.h.get(h).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,o){this.e=d(this.e,o),this.e=this.e.concat(i);const h=l.l(this.e);return this.e=d(this.e,h.map(y=>y.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,h)}static l(i){const o=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,n){this.addNode(a),this.addNode(n),this.c.has(a)?this.c.get(a).push(n):this.c.set(a,[n])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,n){const c=o.getArcs(a);for(let E=0;E<c.length;E++)if(!n.has(c[E]))return!1;return!0}getNodes(){return this.e}},h=new v.$Xl;for(const a of i)if(h.set(a.identifier,a),a.extensionDependencies)for(const n of a.extensionDependencies)o.addArc(v.$Vl.toKey(a.identifier),v.$Vl.toKey(n));const y=new Set;o.getNodes().filter(a=>o.getArcs(a).length===0).forEach(a=>y.add(a));const m=o.getNodes().filter(a=>!y.has(a));let r;do{r=!1;for(let a=0;a<m.length;a++){const n=m[a];o.hasOnlyGoodArcs(n,y)&&(m.splice(a,1),a--,y.add(n),r=!0)}}while(r);return m.map(a=>h.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const o=this.h.get(i);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const o=this.f.get(i);return o||void 0}getExtensionDescriptionByUUID(i){for(const o of this.g)if(o.uuid===i)return o}getExtensionDescriptionByIdOrUUID(i,o){return this.getExtensionDescription(i)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.$t3b=l;class S{constructor(i,o){this.versionId=i,this.extensions=o}}e.$u3b=S,e.$v3b={readActivationEvents:t=>t.activationEvents};class g{constructor(i){this.d=new u,this.c=new l(i,[])}async acquireLock(i){const o=await this.d.acquire(i);return new P(this,o)}deltaExtensions(i,o,h){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(o,h)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,o){return this.c.getExtensionDescriptionByIdOrUUID(i,o)}}e.$w3b=g;class P extends T.$kc{constructor(i,o){super(),this.f=i,this.c=!1,this.B(o)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$x3b=P;class D{constructor(i){this.name=i,this.promise=new Promise((o,h)=>{this.c=o})}resolve(i){this.c(i)}}class u{constructor(){this.c=[],this.d=!1}async acquire(i){const o=new D(i);return this.c.push(o),this.e(),o.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let o=!0;const h=setTimeout(()=>{o&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{o&&(clearTimeout(h),o=!1,this.d=!1,this.e())};i.resolve((0,T.$ic)(y))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function $(t,i){const o=t.isBuiltin?0:t.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(o!==h)return o-h;const y=C.$6d.basename(t.extensionLocation.path),m=C.$6d.basename(i.extensionLocation.path);return y<m?-1:y>m?1:0}function d(t,i){const o=new v.$Wl(i);return t.filter(h=>!o.has(h.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$5l=e.$4l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(F||(e.UIKind=F={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(g){const P=v.$Fd.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$4l=A;function l(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$5l=l;var S;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,52,53,24,2,6,155]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=e.$gM=void 0;let b=class extends D.$kc{constructor(i,o){super(),this.s=i,this.t=o,this.a=this.B(new F.$fd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$fd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=o.createLogger(this.m,{id:S.$eo,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(o.onDidChangeLogLevel(h=>{(0,C.$7i)(h)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,o,h){const y=this.getTelemetryDetails(),m=new $(o,h,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,m]),m.apiTelemetryLogger}$initializeTelemetryLevel(i,o,h){this.f=i,this.g=o,this.c=h??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const o=Object.create(null);switch(o["common.extname"]=`${i.publisher}.${i.name}`,o["common.extversion"]=i.version,o["common.vscodemachineid"]=this.s.telemetryInfo.machineId,o["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,o["common.vscodeversion"]=this.s.version,o["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),o["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:o["common.uikind"]="web";break;case A.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,l.$Pk)((0,S.$lo)(this.s.remote.authority)),o}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const o=this.getTelemetryDetails();this.r.forEach((h,y)=>{const m=h.filter(r=>!r.isDisposed);m.length===0?this.r.delete(y):this.r.set(y,m)}),this.r.forEach(h=>{for(const y of h)y.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,o){const y=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!y)return this.r.delete(i.value),!1;let m=!1;for(const r of y)r.ignoreUnhandledExtHostErrors||(r.logError(o),m=!0);return m}};e.$gM=b,e.$gM=b=Ke([qe(0,T.$fM),qe(1,C.$6i)],b);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,o,h,y,m,r,a){this.g=h,this.h=y,this.i=m,this.j=r,this.a=new F.$fd,this.ignoreUnhandledExtHostErrors=o?.ignoreUnhandledErrors??!1,this.b=o?.ignoreBuiltInCommonProperties??!1,this.c=o?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,o){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:o},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let o="properties"in i?i.properties??{}:i;return o=(0,S.$oo)(o,[]),this.c&&(o=(0,g.$Ym)(o,this.c)),this.b||(o=(0,g.$Ym)(o,this.j)),"properties"in i?i.properties=o:i=o,i}k(i,o){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,o=this.mixInCommonPropsAndCleanData(o||{}),this.i||this.f?.sendEventData(i,o),this.h.trace(i,o))}logUsage(i,o){this.d.isUsageEnabled&&this.k(i,o)}logError(i,o){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,o);else{const h={name:i.name,message:i.message,stack:i.stack,cause:i.cause},y=(0,S.$oo)(h,[]),m=new Error(y.message,{cause:y.cause});m.stack=y.stack,m.name=y.name,o=this.mixInCommonPropsAndCleanData(o||{}),this.i||this.f.sendErrorData(m,o),this.h.trace("exception",o)}}get apiTelemetryLogger(){if(!this.e){const i=this,o={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(o)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$hM=$;function d(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$iM=d,e.$jM=(0,v.$Bh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,20,4]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.$TF=e.ActivationKind=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.ExtensionHostStartup=e.$NF=e.$MF=e.$LF=e.$KF=void 0,e.$KF=Object.freeze({identifier:new A.$Vl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$LF="extensions.webWorker",e.$MF=(0,l.$Bh)("extensionService");class S{constructor(m){this.dependency=m}}e.$NF=S;var g;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(m,r,a){this.c=m,this.d=r.slice(0),this.e=a.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$BF.createActivationEventsMap(this.d)}}set(m,r,a){if(this.c>m)throw new Error(`ExtensionHostExtensions: invalid versionId ${m} (current: ${this.c})`);const n=[],c=[],E=[],p=[],I=D(this.d),k=D(r),s=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=k.get(V.identifier);if(!U){n.push(V.identifier),I.delete(V.identifier);continue}if(!s(V,U)){n.push(V.identifier),I.delete(V.identifier);continue}}for(const V of r){const U=I.get(V.identifier);if(!U){c.push(V);continue}if(!s(U,V)){n.push(U.identifier),I.delete(U.identifier);continue}}const f=new A.$Wl(this.e),w=new A.$Wl(a);for(const V of this.e)w.has(V)||E.push(V);for(const V of a)f.has(V)||p.push(V);const R=T.$BF.createActivationEventsMap(c),W={versionId:m,toRemove:n,toAdd:c,addActivationEvents:R,myToRemove:E,myToAdd:p};return this.delta(W),W}delta(m){if(this.c>=m.versionId)return null;const{toRemove:r,toAdd:a,myToRemove:n,myToAdd:c}=m,E=new A.$Wl(r),p=new A.$Wl(n);for(let I=0;I<this.d.length;I++)E.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)p.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of a)this.d.push(I);for(const I of c)this.e.push(I);return m}containsExtension(m){for(const r of this.e)if(A.$Vl.equals(r,m))return!0;return!1}}e.$OF=P;function D(y){const m=new A.$Xl;for(const r of y)m.set(r.identifier,r);return m}function u(y,m){return y.enabledApiProposals?y.enabledApiProposals.includes(m):!1}e.$PF=u;function b(y,m){if(!u(y,m))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.$QF=b;class ${constructor(m,r,a,n){this.codeLoadingTime=m,this.activateCallTime=r,this.activateResolvedTime=a,this.activationReason=n}}e.$RF=$;class d{constructor(m,r){this.description=m,this.value=r}}e.$SF=d;var t;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,C.$uo)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.$TF=i;function o(y,m){return{identifier:new A.$Vl((0,C.$so)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!m,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform}}e.$UF=o;class h{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(m,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$VF=h}),define(Ae[210],Re([1,0,9,107,20,26,14,12]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=e.$nbc=e.$mbc=e.$lbc=e.$kbc=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(i,o,h,y){this.startup=i,this.codeLoadingTime=o,this.activateCallTime=h,this.activateResolvedTime=y}}e.$kbc=S;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,o){return i===-1||o===-1?-1:o-i}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$lbc=g;class P{constructor(i,o,h,y,m,r){this.activationFailed=i,this.activationFailedError=o,this.activationTimes=h,this.module=y,this.exports=m,this.subscriptions=r}}e.$mbc=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$nbc=D;class u extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$obc=u;class b extends P{constructor(i){super(!0,i,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,o,h,y){this.g=y,this.a=i,this.b=o,this.c=h,this.d=new C.$Xl,this.f=Object.create(null)}dispose(){for(const[i,o]of this.d)o.dispose()}async waitForActivatingExtensions(){const i=[];for(const[o,h]of this.d)i.push(h.wait());await Promise.all(i)}isActivated(i){const o=this.d.get(i);return!!(o&&o.value)}getActivatedExtension(i){const o=this.d.get(i);if(!o||!o.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return o.value}async activateByEvent(i,o){if(this.f[i])return;const h=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(h.map(y=>({id:y.identifier,reason:{startup:o,extensionId:y.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,o){const h=this.a.getExtensionDescription(i);if(!h)throw new Error(`Extension '${i}' is not known`);return this.h([{id:h.identifier,reason:o}])}async h(i){const o=i.filter(h=>!this.isActivated(h.id)).map(h=>this.j(h));await Promise.all(o.map(h=>h.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const o=this.a.getExtensionDescription(i.id);if(!o){const m=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new b(m));return this.c.onExtensionActivationError(i.id,m,new T.$NF(i.id.value)),r}const h=[],y=typeof o.extensionDependencies>"u"?[]:o.extensionDependencies;for(const m of y){if(this.m(m))continue;const r=this.d.get(m);if(r){h.push(r);continue}if(this.l(m)){h.push(this.j({id:this.b.getExtensionDescription(m).identifier,reason:i.reason}));continue}const a=this.a.getExtensionDescription(m);if(a){if(!a.main&&!a.browser)continue;h.push(this.j({id:a.identifier,reason:i.reason}));continue}const n=o.displayName||o.identifier.value,c=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${m}'`),E=this.k(i,o.displayName,[],new b(c));return this.c.onExtensionActivationError(o.identifier,c,new T.$NF(m)),E}return this.k(i,o.displayName,h,null)}k(i,o,h,y){const m=new d(i.id,o,i.reason,h,y,this.c,this.g);return this.d.set(i.id,m),m}l(i){return F.$t3b.isHostExtension(i,this.a,this.b)}m(i){const o=this.b.getExtensionDescription(i);return o?!o.main&&!o.browser:!1}};e.$pbc=$,e.$pbc=$=Ke([qe(3,A.$5i)],$);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,o,h,y,m,r,a){this.c=i,this.d=o,this.f=h,this.g=y,this.h=m,this.j=r,this.k=a,this.a=new l.$Fg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const o=this.g[i];if(o.value&&!o.value.activationFailed){this.g.splice(i,1),i--;continue}if(o.value&&o.value.activationFailed){const h=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${o.friendlyName}' failed to activate`);h.detail=o.value.activationFailedError,this.h=new b(h),this.j.onExtensionActivationError(this.c,h,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const o=new Error;if(i&&i.name&&(o.name=i.name),i&&i.message?o.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:o.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(o.stack=i.stack),this.h=new b(o),this.b&&v.$2(i))return;this.j.onExtensionActivationError(this.c,o,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};d=Ke([qe(6,A.$5i)],d)}),define(Ae[211],Re([1,0,157,23,2,5,6,193,12,7,16,18,8,49,21,126,26]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;function i(y,m){if((0,P.$jf)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let r;return Array.isArray(y.highlights)&&(r=y.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),r=r.length?r:void 0),{label:y.label,highlights:r}}}class o extends A.$kc{constructor(m,r,a){super(),this.f=m,this.g=r,this.h=a,this.a=new Map,this.b=new d.$j7;function n(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:c=>n(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(E=>n(E)?this.r(E):E):c})}registerTreeDataProvider(m,r,a){const n=this.createTreeView(m,{treeDataProvider:r},a);return{dispose:()=>n.dispose()}}createTreeView(m,r,a){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=r.dragAndDropController?.dropMimeTypes??[],c=r.dragAndDropController?.dragMimeTypes??[],E=!!r.dragAndDropController?.handleDrag,p=!!r.dragAndDropController?.handleDrop,I=this.m(m,r,a),k={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:n,dragMimeTypes:c,hasHandleDrag:E,hasHandleDrop:p,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},s=this.f.$registerTreeViewDataProvider(m,k),f={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$QF)(a,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$QF)(a,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(w){(0,b.$Zj)(w)&&(0,t.$QF)(a,"treeViewMarkdownMessage"),I.message=w},get title(){return I.title},set title(w){I.title=w},get description(){return I.description},set description(w){I.description=w},get badge(){return I.badge},set badge(w){w!==void 0&&g.ViewBadge.isViewBadge(w)?I.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(I.badge=void 0)},reveal:(w,R)=>I.reveal(w,R),dispose:async()=>{await s,this.a.delete(m),I.dispose()}};return this.B(f),f}$getChildren(m,r){const a=this.a.get(m);return a?a.getChildren(r):Promise.reject(new l.$bF(m))}async $handleDrop(m,r,a,n,c,E,p,I){const k=this.a.get(m);if(!k)return Promise.reject(new l.$bF(m));const s=u.DataTransfer.toDataTransfer(a,async f=>(await this.f.$resolveDropFileData(m,r,f)).buffer);return p===m&&I&&await this.j(s,k,I,c,E),k.onDrop(s,n,c)}async j(m,r,a,n,c){const E=this.b.removeDragOperationTransfer(c);if(E)(await E)?.forEach((p,I)=>{p&&m.set(I,p)});else if(c&&r.handleDrag){const p=r.handleDrag(a,m,n);this.b.addDragOperationTransfer(c,p),await p}return m}async $handleDrag(m,r,a,n){const c=this.a.get(m);if(!c)return Promise.reject(new l.$bF(m));const E=await this.j(new g.$TK,c,r,n,a);if(!(!E||n.isCancellationRequested))return u.DataTransfer.from(E)}async $hasResolve(m){const r=this.a.get(m);if(!r)throw new l.$bF(m);return r.hasResolve}$resolve(m,r,a){const n=this.a.get(m);if(!n)throw new l.$bF(m);return n.resolveTreeItem(r,a)}$setExpanded(m,r,a){const n=this.a.get(m);if(!n)throw new l.$bF(m);n.setExpanded(r,a)}$setSelectionAndFocus(m,r,a){const n=this.a.get(m);if(!n)throw new l.$bF(m);n.setSelectionAndFocus(r,a)}$setVisible(m,r){const a=this.a.get(m);if(!a){if(!r)return;throw new l.$bF(m)}a.setVisible(r)}$changeCheckboxState(m,r){const a=this.a.get(m);if(!a)throw new l.$bF(m);a.setCheckboxState(r)}m(m,r,a){const n=this.B(new h(m,r,this.f,this.g.converter,this.h,a));return this.a.set(m,n),n}r(m){const r=this.a.get(m.$treeViewId);return r&&"$treeItemHandle"in m?r.getExtensionElement(m.$treeItemHandle):r&&"$focusedTreeItem"in m&&m.$focusedTreeItem?r.focusedElement:null}}e.$2bc=o;class h extends A.$kc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(m=>this.getExtensionElement(m)).filter(m=>!(0,P.$sf)(m))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(m,r,a,n,c,E){if(super(),this.I=m,this.J=a,this.L=n,this.M=c,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$fd),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$fd),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$fd),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$fd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$fd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$fd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$fd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$pd,E.contributes&&E.contributes.views)for(const s in E.contributes.views)for(const f of E.contributes.views[s])f.id===m&&(this.P=f.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(s=>this.F.fire({message:!1,element:s})));let p,I;const k=T.Event.debounce(this.F.event,(s,f)=>(s||(s={message:!1,elements:[]}),f.element!==!1&&(p||(p=new Promise(w=>I=w),this.G=this.G.then(()=>p)),Array.isArray(f.element)?s.elements.push(...f.element):s.elements.push(f.element)),f.message&&(s.message=!0),s),200,!0);this.B(k(({message:s,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const w=I;return p=null,this.$(f).then(()=>w())})),s&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(m){const r=m?this.getExtensionElement(m):void 0;if(m&&!r)return this.M.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let a=this.X(m);return a||(a=await this.Y(r)),a?a.map(n=>n.item):void 0}getExtensionElement(m){return this.j.get(m)}reveal(m,r){r=r||{select:!0,focus:!1};const a=(0,P.$sf)(r.select)?!0:r.select,n=(0,P.$sf)(r.focus)?!1:r.focus,c=(0,P.$sf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.G.then(()=>this.S(m)).then(E=>this.W(m,E[E.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:E.map(I=>I.item)},{select:a,focus:n,expand:c})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:a,focus:n,expand:c})}get message(){return this.O}set message(m){this.O=m,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(m){this.P=m,this.J.$setTitle(this.I,m,this.Q)}get description(){return this.Q}set description(m){this.Q=m,this.J.$setTitle(this.I,this.P,m)}get badge(){return this.R}set badge(m){this.R?.value===m?.value&&this.R?.tooltip===m?.tooltip||(this.R=u.ViewBadge.from(m),this.J.$setBadge(this.I,m))}setExpanded(m,r){const a=this.getExtensionElement(m);a&&(r?this.u.fire(Object.freeze({element:a})):this.w.fire(Object.freeze({element:a})))}setSelectionAndFocus(m,r){const a=!(0,D.$sb)(this.s,m);this.s=m;const n=this.t!==r;this.t=r,a&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(m){m!==this.r&&(this.r=m,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(m){const r=(await Promise.all(m.map(async a=>{const n=this.getExtensionElement(a.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:a.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);r.forEach(a=>{a.treeItem.checkboxState=a.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(a=>[a.extensionItem,a.newState])})}async handleDrag(m,r,a){const n=[];for(const c of m){const E=this.getExtensionElement(c);E&&n.push(E)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,r,a),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(m,r,a){const n=r?this.getExtensionElement(r):void 0;if(!(!n&&r||!this.g?.handleDrop))return(0,S.$zg)(()=>this.g?.handleDrop?this.g.handleDrop(n,m,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(m,r){if(!this.f.resolveTreeItem)return;const a=this.j.get(m);if(a){const n=this.m.get(a);if(n){const c=await this.f.resolveTreeItem(n.extensionItem,a,r)??n.extensionItem;return this.hb(c),n.item.tooltip=this.eb(c.tooltip),n.item.command=this.fb(n.disposableStore,c.command),n.item}}}S(m){return this.U(m).then(r=>r?this.S(r).then(a=>this.W(r,a[a.length-1]).then(n=>(a.push(n),a))):Promise.resolve([]))}U(m){const r=this.m.get(m);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,S.$zg)(()=>this.f.getParent(m))}W(m,r){const a=this.m.get(m);return a?Promise.resolve(a):(0,S.$zg)(()=>this.f.getTreeItem(m)).then(n=>this.kb(m,n,r,!0)).then(n=>this.getChildren(r?r.item.handle:void 0).then(()=>{const c=this.getExtensionElement(n);if(c){const E=this.m.get(c);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(m){if(m){let r;if(typeof m=="string"){const a=this.getExtensionElement(m);r=a?this.m.get(a):void 0}else r=m;return r&&r.children||void 0}return this.h}async Y(m){this.rb(m);const r=new $.$pd(this.Z.token);try{const a=m?this.m.get(m):void 0,n=await this.f.getChildren(m);if(r.token.isCancellationRequested)return;const c=await Promise.all((0,D.$Fb)(n||[]).map(async E=>{const p=await this.f.getTreeItem(E);return p&&!r.token.isCancellationRequested?this.db(E,p,a):null}));return r.token.isCancellationRequested?void 0:(0,D.$Fb)(c)}finally{r.dispose()}}$(m){if(m.some(a=>!a))return this.Z.dispose(!0),this.Z=new $.$pd,this.tb(),this.J.$refresh(this.I);{const a=this.ab(m);if(a.length)return this.bb(a)}return Promise.resolve(void 0)}ab(m){const r=new Set,a=m.map(c=>this.m.get(c));for(const c of a)if(c&&!r.has(c.item.handle)){let E=c;for(;E&&E.parent&&a.findIndex(p=>E&&E.parent&&p&&p.item.handle===E.parent.item.handle)===-1;){const p=this.j.get(E.parent.item.handle);E=p?this.m.get(p):void 0}E&&!E.parent&&r.add(c.item.handle)}const n=[];return r.forEach(c=>{const E=this.j.get(c);if(E){const p=this.m.get(E);p&&(!p.parent||!r.has(p.parent.item.handle))&&n.push(c)}}),n}bb(m){const r={};return Promise.all(m.map(a=>this.cb(a).then(n=>{n&&(r[a]=n.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(m){const r=this.getExtensionElement(m);if(r){const a=this.m.get(r);if(a)return this.rb(r),(0,S.$zg)(()=>this.f.getTreeItem(r)).then(n=>{if(n){const c=this.ib(r,n,a.parent);return this.pb(r,c,a,a.parent),a.dispose(),c}return null})}return Promise.resolve(null)}db(m,r,a){const n=this.ib(m,r,a);if(r.id&&this.j.has(n.item.handle))throw new Error((0,v.localize)(0,null,r.id));return this.ob(m,n),this.qb(n,a),n}eb(m){return g.$qK.isMarkdownString(m)?u.MarkdownString.from(m):m}fb(m,r){return r?{...this.L.toInternal(r,m),originalId:r.command}:void 0}gb(m){if(m.checkboxState===void 0)return;let r,a,n;return typeof m.checkboxState=="number"?r=m.checkboxState:(r=m.checkboxState.state,a=m.checkboxState.tooltip,n=m.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:n}}hb(m){if(!g.$OK.isTreeItem(m,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(m,r,a){this.hb(r);const n=this.B(new A.$jc),c=this.kb(m,r,a),E=this.lb(r);return{item:{handle:c,parentHandle:a?a.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(n,r.command),contextValue:r.contextValue,icon:E,iconDark:this.mb(r)||E,themeIcon:this.jb(r),collapsibleState:(0,P.$sf)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:a,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(m){return m.iconPath instanceof g.$WK?m.iconPath:void 0}kb(m,{id:r,label:a,resourceUri:n},c,E){if(r)return`${h.b}/${r}`;const p=i(a,this.N),I=c?c.item.handle:h.a;let k=p?p.label:n?(0,F.$fg)(n):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const s=this.m.has(m)?this.m.get(m).item.handle:void 0,f=this.X(c)||[];let w,R=0;do{if(w=`${I}/${R}:${k}`,E||!this.j.has(w)||s===w)break;R++}while(R<=f.length);return w}lb(m){if(m.iconPath&&!(m.iconPath instanceof g.$WK))return typeof m.iconPath=="string"||C.URI.isUri(m.iconPath)?this.nb(m.iconPath):this.nb(m.iconPath.light)}mb(m){if(m.iconPath&&!(m.iconPath instanceof g.$WK)&&m.iconPath.dark)return this.nb(m.iconPath.dark)}nb(m){return C.URI.isUri(m)?m:C.URI.file(m)}ob(m,r){this.j.set(r.item.handle,m),this.m.set(m,r)}pb(m,r,a,n){this.j.delete(r.item.handle),this.m.delete(m),r.item.handle!==a.item.handle&&this.j.delete(a.item.handle),this.ob(m,r);const c=this.X(n)||[],E=c.filter(p=>p.item.handle===a.item.handle)[0];E&&c.splice(c.indexOf(E),1,r)}qb(m,r){r?(r.children||(r.children=[]),r.children.push(m)):(this.h||(this.h=[]),this.h.push(m))}rb(m){if(m){const r=this.m.get(m);if(r){if(r.children)for(const a of r.children){const n=this.j.get(a.item.handle);n&&this.sb(n)}r.children=void 0}}else this.tb()}sb(m){const r=this.m.get(m);if(r){if(r.children)for(const a of r.children){const n=this.j.get(a.item.handle);n&&this.sb(n)}this.m.delete(m),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(m=>m.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,167,9,29,92,73,30,20,212,177,98]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const u=l.$8m.as(A.$9m.JSONContribution);class b{constructor(m,r,a){this.a=m,this.b=r,this.c=a}d(m,r){this.a({type:m,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(m){this.d(C.default.Error,m)}warn(m){this.d(C.default.Warning,m)}info(m){this.d(C.default.Info,m)}}e.$WF=b;class ${static a(m){const r=new S.$Wl;for(let a=0,n=m.length;a<n;a++)r.add(m[a].description.identifier);return r}static compute(m,r){if(!m||!m.length)return new $(r,[]);if(!r||!r.length)return new $([],m);const a=this.a(m),n=this.a(r),c=r.filter(p=>!a.has(p.description.identifier)),E=m.filter(p=>!n.has(p.description.identifier));return new $(c,E)}constructor(m,r){this.added=m,this.removed=r}}e.$XF=$;class d{constructor(m,r){this.name=m,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(m){if(this.a!==null)throw new Error("Handler already set!");this.a=m,this.d()}acceptUsers(m){this.c=$.compute(this.b,m),this.b=m,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(m){(0,F.$Y)(m)}}}e.$YF=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(0,null),v.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$ZF={properties:{engines:{type:"object",description:v.localize(2,null),properties:{vscode:{type:"string",description:v.localize(3,null),default:"^1.22.0"}}},publisher:{description:v.localize(4,null),type:"string"},displayName:{description:v.localize(5,null),type:"string"},categories:{description:v.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Ul},{type:"string",const:"Languages",deprecationMessage:v.localize(7,null)}]}},galleryBanner:{type:"object",description:v.localize(8,null),properties:{color:{description:v.localize(9,null),type:"string"},theme:{description:v.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(13,null)},enabledApiProposals:{markdownDescription:v.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:v.localize(15,null),type:"string",enum:["none"],enumDescriptions:[v.localize(16,null)]},activationEvents:{description:v.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(32,null)},{label:"onUri",body:"onUri",description:v.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(37,null)},{label:"onRenderer",description:v.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(41,null)},{label:"*",description:v.localize(42,null),body:"*"}]}},badges:{type:"array",description:v.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(44,null)},href:{type:"string",description:v.localize(45,null)},description:{type:"string",description:v.localize(46,null)}}}},markdown:{type:"string",description:v.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Mn}},extensionPack:{description:v.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Mn}},extensionKind:{description:v.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(52,null)},{body:["workspace"],description:v.localize(53,null)},{body:["ui","workspace"],description:v.localize(54,null)},{body:["workspace","ui"],description:v.localize(55,null)},{body:[],description:v.localize(56,null)}]},capabilities:{description:v.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(60,null),v.localize(61,null),v.localize(62,null)]},description:{type:"string",markdownDescription:v.localize(63,null)}}},untrustedWorkspaces:{description:v.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(66,null),v.localize(67,null),v.localize(68,null)]},restrictedConfigurations:{description:v.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(70,null)}}}}},sponsor:{description:v.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(73,null),type:"string"},"vscode:uninstall":{description:v.localize(74,null),type:"string"}}},icon:{type:"string",description:v.localize(75,null)},l10n:{type:"string",description:v.localize(76,null)},pricing:{type:"string",markdownDescription:v.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class o{constructor(){this.a=new Map}registerExtensionPoint(m){if(this.a.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const r=new d(m.extensionPoint,m.defaultExtensionKind);return this.a.set(m.extensionPoint,r),m.activationEventsGenerator&&D.$BF.register(m.extensionPoint,m.activationEventsGenerator),e.$ZF.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,u.registerSchema(i,e.$ZF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$1F=o;const h={ExtensionsRegistry:"ExtensionsRegistry"};l.$8m.add(h.ExtensionsRegistry,new o),e.$2F=l.$8m.as(h.ExtensionsRegistry),u.registerSchema(i,e.$ZF),u.registerSchema(P.$lj,{properties:{extensionEnabledApiProposals:{description:v.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,164,16,24,213,32,5]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(2,null),default:""}}};var g;(function(u){function b($,d,t){if(!$)return;const i=F.$jf($.type)?$.type:void 0;if(!i||i.length===0){t.error(v.localize(3,null));return}const o=[];if(Array.isArray($.required))for(const h of $.required)F.$jf(h)&&o.push(h);return{extensionId:d.value,taskType:i,required:o,properties:$.properties?C.$Vm($.properties):{},when:$.when?A.$Ii.deserialize($.when):void 0}}u.from=b})(g||(g={}));const P=T.$2F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const $ of u)$.type&&b.push(`onTaskType:${$.type}`)},jsonSchema:{description:v.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new l.$fd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,$)=>{P.setHandler((d,t)=>{this.c=void 0;try{for(const i of t.removed){const o=i.value;for(const h of o)this.a&&h.type&&this.a[h.type]&&delete this.a[h.type]}for(const i of t.added){const o=i.value;for(const h of o){const y=g.from(h,i.description.identifier,i.collector);y&&(this.a[y.taskType]=y)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const $ of this.all()){const d={type:"object",additionalProperties:!1};$.required.length>0&&(d.required=$.required.slice(0)),$.properties!==void 0?d.properties=C.$Vm($.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[$.taskType]},b.push(d)}this.c={oneOf:b}}return this.c}}e.$$F=new D}),define(Ae[215],Re([1,0,165,16,23,24,32,214]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$iG=e.JsonSchemaVersion=e.ExecutionEngine=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$cG=e.ShellQuoting=e.$bG=e.$aG=e.$_F=void 0,e.$_F="settings",e.$aG=new A.$2i("taskRunning",!1,v.localize(0,null)),e.$bG={value:v.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$cG="$customized",function(O){function N(ee){if(!ee)return O.Strong;switch(ee.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(S||(e.ShellQuoting=S={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(P||(e.RevealKind=P={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(D||(e.RevealProblemKind=D={}));var u;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(u||(e.PanelKind=u={})),function(O){function N(ee){switch(ee.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(u||(e.PanelKind=u={}));var b;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var $;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(O){function N(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ee(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ee}($||(e.RuntimeType=$={}));var d;(function(O){function N(ee){return F.$jf(ee)?ee:ee.value}O.value=N})(d||(e.CommandString=d={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=N;function ee(Y){if(Y!==void 0)return F.$jf(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=ee})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var o;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ee){switch(ee){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(o||(e.TaskSourceKind=o={}));var h;(function(O){O.parallel="parallel",O.sequence="sequence"})(h||(e.DependsOrder=h={}));var y;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(y||(e.RunOnOptions=y={}));var m;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(m||(e.RunOptions=m={}));class r{constructor(N,ee,Y,Ee,ke,Pe){this._label="",this._id=N,ee&&(this._label=ee),Y&&(this.type=Y),this.runOptions=Ee,this.configurationProperties=ke,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ee=!1){if(N===void 0)return!1;if(F.$jf(N))return N===this._label||N===this.configurationProperties.identifier||ee&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$dG=r;class a extends r{constructor(N,ee,Y,Ee,ke,Pe,X,ue){super(N,Y,void 0,X,ue,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,ke&&(this.command=ke)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case $.Shell:ee="shell";break;case $.Process:ee="process";break;case $.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(N){return N instanceof a}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===o.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==o.Workspace&&(ee+=this._source.kind);const Y={type:e.$cG,folder:N,id:ee};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new a(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$eG=a;class n extends r{constructor(N,ee,Y,Ee,ke,Pe,X){super(N,Y,Ee,Pe,X,ee),this._source=ee,this.configures=ke}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===o.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==o.Workspace&&(ee+=this._source.kind);const Y={type:e.$cG,folder:N,id:ee};return JSON.stringify(Y)}}e.$fG=n;class c extends r{constructor(N,ee,Y,Ee,ke,Pe,X,ue,ye){super(N,Y,Ee,ue,ye,ee),this.defines=ke,this.hasDefinedMatchers=X,this.command=Pe,this.icon=ye.icon,this.hide=ye.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof c}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new c(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$gG=c;class E extends r{constructor(N,ee,Y,Ee,ke,Pe){super(N,Y,Ee,ke,Pe,ee),this._source=ee}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new E(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$hG=E;var p;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(O){O._default=O.Terminal}(p||(e.ExecutionEngine=p={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(N){this.c=new Map;for(let ee=0;ee<N.length;ee++)this.c.set(N[ee].uri.toString(),ee)}compare(N,ee){const Y=N.getWorkspaceFolder(),Ee=ee.getWorkspaceFolder();if(Y&&Ee){let ke=this.c.get(Y.uri.toString());ke=ke===void 0?0:ke+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,ke===Pe?N._label.localeCompare(ee._label):ke-Pe}else return!Y&&Ee?-1:Y&&!Ee?1:0}}e.$iG=k;var s;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(s||(e.TaskEventKind=s={}));var f;(function(O){O.SingleRun="singleRun",O.Background="background"})(f||(e.TaskRunType=f={}));var w;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var R;(function(O){function N(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function ee(ue,ye,ce){return{...N(ue),kind:"start",terminalId:ye,resolvedVariables:ce}}O.start=ee;function Y(ue,ye,ce){return{...N(ue),kind:"processStarted",terminalId:ye,processId:ce}}O.processStarted=Y;function Ee(ue,ye,ce){return{...N(ue),kind:"processEnded",terminalId:ye,exitCode:ce}}O.processEnded=Ee;function ke(ue,ye,ce){return{...N(ue),kind:"terminated",exitReason:ce,terminalId:ye}}O.terminated=ke;function Pe(ue,ye,ce){return{...N(ye),kind:ue,terminalId:ce}}O.general=Pe;function X(){return{kind:"changed"}}O.changed=X})(R||(e.TaskEvent=R={}));var W;(function(O){function N(Y){const Ee=Object.keys(Y).sort();let ke="";for(const Pe of Ee){let X=Y[Pe];X instanceof Object?X=N(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),ke+=Pe+","+X+","}return ke}function ee(Y){const ke={_key:N(Y),type:Y.taskType};return Object.assign(ke,Y),ke}O.create=ee})(W||(e.KeyedTaskIdentifier=W={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var B;(function(O){function N(ee,Y){const Ee=l.$$F.get(ee.type);if(Ee===void 0){const ue=T.$Vm(ee);return delete ue._key,W.create(ue)}const ke=Object.create(null);ke.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(ue=>Pe.add(ue));const X=Ee.properties;for(const ue of Object.keys(X)){const ye=ee[ue];if(ye!=null)ke[ue]=ye;else if(Pe.has(ue)){const ce=X[ue];if(ce.default!==void 0)ke[ue]=T.$Vm(ce.default);else switch(ce.type){case"boolean":ke[ue]=!1;break;case"number":case"integer":ke[ue]=0;break;case"string":ke[ue]="";break;default:Y.error(v.localize(2,null,JSON.stringify(ee,void 0,0),ue));return}}}return W.create(ke)}O.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Ae[216],Re([1,0,9]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z3b=e.$y3b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Y)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$y3b=F;class C extends F{constructor(){super(),this.h=!0,this.i=new v.$3}}e.$z3b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dA=e.$cA=e.$bA=e.$aA=void 0;class v{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++v.count}}e.$aA=v;const F=[];function C(l){const S=new v(l);return F[S.nid]=S,S}e.$bA=C;function T(l){return F[l].sid}e.$cA=T;class A{constructor(S){this.value=S}}e.$dA=A}),define(Ae[3],Re([1,0,46]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$YJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var g;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$YJ=D;var u;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var $;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$ZJ={MainThreadAuthentication:(0,v.$bA)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$bA)("MainThreadBulkEdits"),MainThreadChatProvider:(0,v.$bA)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,v.$bA)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,v.$bA)("MainThreadChatAgents"),MainThreadChatVariables:(0,v.$bA)("MainThreadChatVariables"),MainThreadClipboard:(0,v.$bA)("MainThreadClipboard"),MainThreadCommands:(0,v.$bA)("MainThreadCommands"),MainThreadComments:(0,v.$bA)("MainThreadComments"),MainThreadConfiguration:(0,v.$bA)("MainThreadConfiguration"),MainThreadConsole:(0,v.$bA)("MainThreadConsole"),MainThreadDebugService:(0,v.$bA)("MainThreadDebugService"),MainThreadDecorations:(0,v.$bA)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$bA)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$bA)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$bA)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$bA)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$bA)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$bA)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$bA)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$bA)("MainThreadErrors"),MainThreadTreeViews:(0,v.$bA)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$bA)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$bA)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$bA)("MainThreadLanguages"),MainThreadLogger:(0,v.$bA)("MainThreadLogger"),MainThreadMessageService:(0,v.$bA)("MainThreadMessageService"),MainThreadOutputService:(0,v.$bA)("MainThreadOutputService"),MainThreadProgress:(0,v.$bA)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$bA)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$bA)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$bA)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$bA)("MainThreadSecretState"),MainThreadStorage:(0,v.$bA)("MainThreadStorage"),MainThreadTelemetry:(0,v.$bA)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$bA)("MainThreadTerminalService"),MainThreadWebviews:(0,v.$bA)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$bA)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$bA)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$bA)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$bA)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$bA)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$bA)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$bA)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$bA)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.$bA)("MainThreadExtensionService"),MainThreadSCM:(0,v.$bA)("MainThreadSCM"),MainThreadSearch:(0,v.$bA)("MainThreadSearch"),MainThreadShare:(0,v.$bA)("MainThreadShare"),MainThreadTask:(0,v.$bA)("MainThreadTask"),MainThreadWindow:(0,v.$bA)("MainThreadWindow"),MainThreadLabelService:(0,v.$bA)("MainThreadLabelService"),MainThreadNotebook:(0,v.$bA)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$bA)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$bA)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$bA)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$bA)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$bA)("MainThreadInteractive"),MainThreadChat:(0,v.$bA)("MainThreadChat"),MainThreadInlineChat:(0,v.$bA)("MainThreadInlineChatShape"),MainThreadTheming:(0,v.$bA)("MainThreadTheming"),MainThreadTunnelService:(0,v.$bA)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$bA)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$bA)("MainThreadTimeline"),MainThreadTesting:(0,v.$bA)("MainThreadTesting"),MainThreadLocalization:(0,v.$bA)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$bA)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$bA)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,v.$bA)("MainThreadIssueReporter")},e.$1J={ExtHostCommands:(0,v.$bA)("ExtHostCommands"),ExtHostConfiguration:(0,v.$bA)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$bA)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$bA)("ExtHostDebugService"),ExtHostDecorations:(0,v.$bA)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$bA)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$bA)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$bA)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$bA)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$bA)("ExtHostEditors"),ExtHostTreeViews:(0,v.$bA)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$bA)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$bA)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$bA)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$bA)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$bA)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$bA)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$bA)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$bA)("ExtHostStatusBar"),ExtHostShare:(0,v.$bA)("ExtHostShare"),ExtHostExtensionService:(0,v.$bA)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$bA)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$bA)("ExtHostTerminalService"),ExtHostSCM:(0,v.$bA)("ExtHostSCM"),ExtHostSearch:(0,v.$bA)("ExtHostSearch"),ExtHostTask:(0,v.$bA)("ExtHostTask"),ExtHostWorkspace:(0,v.$bA)("ExtHostWorkspace"),ExtHostWindow:(0,v.$bA)("ExtHostWindow"),ExtHostWebviews:(0,v.$bA)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$bA)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$bA)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$bA)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$bA)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$bA)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$bA)("ExtHostProgress"),ExtHostComments:(0,v.$bA)("ExtHostComments"),ExtHostSecretState:(0,v.$bA)("ExtHostSecretState"),ExtHostStorage:(0,v.$bA)("ExtHostStorage"),ExtHostUrls:(0,v.$bA)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$bA)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$bA)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$bA)("ExtHostOutputService"),ExtHosLabelService:(0,v.$bA)("ExtHostLabelService"),ExtHostNotebook:(0,v.$bA)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$bA)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$bA)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$bA)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$bA)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$bA)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$bA)("ExtHostInteractive"),ExtHostInlineChat:(0,v.$bA)("ExtHostInlineChatShape"),ExtHostChat:(0,v.$bA)("ExtHostChat"),ExtHostChatSlashCommands:(0,v.$bA)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,v.$bA)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$bA)("ExtHostChatVariables"),ExtHostChatProvider:(0,v.$bA)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,v.$bA)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$bA)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$bA)("ExtHostTheming"),ExtHostTunnelService:(0,v.$bA)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$bA)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$bA)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$bA)("ExtHostTimeline"),ExtHostTesting:(0,v.$bA)("ExtHostTesting"),ExtHostTelemetry:(0,v.$bA)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$bA)("ExtHostLocalization"),ExtHostIssueReporter:(0,v.$bA)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$ZJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,S){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(l,S)??[]}getRelatedInformation(A,l,S){return this.c.$getAiRelatedInformation(l,S)}registerRelatedInformationProvider(A,l,S){const g=this.b;return this.b++,this.a.set(g,S),this.c.$registerAiRelatedInformationProvider(g,l),new F.$2J(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$4cc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=e.$6ac=void 0,e.$6ac=(0,v.$Bh)("IExtHostApiDeprecationService");let A=class{constructor(S,g){this.c=g,this.a=new Set,this.b=S.getProxy(C.$ZJ.MainThreadTelemetry)}report(S,g,P){const D=this.d(S,g);this.a.has(D)||(this.a.add(D),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:S}))}d(S,g){return`${S}-${g.identifier.value}`}};e.$7ac=A,e.$7ac=A=Ke([qe(0,T.$2L),qe(1,F.$5i)],A),e.$8ac=Object.freeze(new class{report(l,S,g){}})}),define(Ae[218],Re([1,0,5,3,7,20]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new v.$fd,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=g.getProxy(F.$ZJ.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,D,u={}){const b=T.$Vl.toKey(g.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const d=g.displayName||g.name;return this.a.$getSession(P,D,b,d,u)})}async getSessions(g,P,D){const u=T.$Vl.toKey(g.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(P);const $=g.displayName||g.name;return this.a.$getSessions(P,D,u,$)})}async removeSession(g,P){const D=this.b.get(g);return D?D.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,D,u){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===g)||this.c.push({id:g,label:P});const b=D.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(g,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,u?.supportsMultipleAccounts??!1),new C.$2J(()=>{b.dispose(),this.b.delete(g);const $=this.c.findIndex(d=>d.id===g);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,D){const u=this.b.get(g);if(u)return Promise.resolve(u.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const D=this.b.get(g);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const D=this.b.get(g);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$Bcc=A;class l{constructor(){this.a=new Map}getOrCreate(g,P){const D=this.a.get(g);if(D)return D;const u=P().finally(()=>this.a.delete(g));return this.a.set(g,u),u}}}),define(Ae[219],Re([1,0,3,17,8]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;let T=class{constructor(l,S){this.a=l.getProxy(v.$ZJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>S.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,S,g){const P=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$Hcc=T,e.$Hcc=T=Ke([qe(0,F.$2L)],T)}),define(Ae[220],Re([1,0,12,5,67,6,59,147,3,8]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class P{static{this.a=0}constructor(b,$){this.extension=b,this.provider=$,this.handle=P.a++}}class D{static{this.a=0}constructor(b,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new F.$fd,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(S.$ZJ.MainThreadChat)}registerChatProvider(b,$,d){const t=new P(b,d);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,T.$ic)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,$){const d=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===b)??0;typeof d=="number"&&this.g.$transferChatSession(d,$)}addChatRequest(b){this.g.$addRequest(b)}sendInteractiveRequestToProvider(b,$){this.g.$sendRequestToProvider(b,$)}async $prepareChat(b,$,d){const t=this.b.get(b);if(!t)return;const i=await t.provider.prepareSession($,d);if(!i)return;const o=D.a++;return this.d.set(o,i),{id:o,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(b,$,d,t){const i=this.b.get(b);if(!i)return;const o=this.d.get($);if(!o||!i.provider.resolveRequest)return;const h=await i.provider.resolveRequest(o,d,t);if(h)return{message:typeof h.message=="string"?h.message:g.ChatReplyFollowup.from(h.message)}}async $provideWelcomeMessage(b,$){const d=this.b.get(b);if(!d||!d.provider.provideWelcomeMessage)return;const t=await d.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(o=>g.ChatReplyFollowup.from(o)))}async $provideFollowups(b,$,d){const t=this.b.get(b);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,d))?.map(h=>g.ChatFollowup.from(h))}$removeRequest(b,$,d){const t=this.b.get(b);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,d)}async $provideReply(b,$,d,t){const i=this.b.get(b);if(!i)return;const o=this.d.get($);if(!o)return;const h={session:o,message:typeof d.message=="string"?d.message:g.ChatReplyFollowup.to(d.message),variables:{}};if(d.variables)for(const c of Object.keys(d.variables))h.variables[c]=d.variables[c].map(g.ChatVariable.to);const y=A.$bd.create(!1);let m;const r={report:c=>{if(!t.isCancellationRequested)if(typeof m>"u"&&(m=y.elapsed()),"responseId"in c)this.g.$acceptResponseProgress(b,$,{requestId:c.responseId});else if("placeholder"in c&&"resolvedContent"in c){const E=Promise.all([this.g.$acceptResponseProgress(b,$,{placeholder:c.placeholder}),c.resolvedContent]);(0,v.$vg)(E,t).then(p=>{if(!p)return;const[I,k]=p;this.g.$acceptResponseProgress(b,$,k,I??void 0)})}else"content"in c?this.g.$acceptResponseProgress(b,$,{content:typeof c.content=="string"?c.content:g.MarkdownString.from(c.content)}):this.g.$acceptResponseProgress(b,$,c)}};let a;try{a=await i.provider.provideResponseWithProgress(h,r,t),a||(a={errorDetails:{message:(0,l.localize)(0,null)}})}catch(c){a={errorDetails:{message:(0,l.localize)(1,null,c.message),responseIsIncomplete:!0}},this.h.error(c)}try{if(o.saveState&&this.d.has($)){const c=o.saveState();this.g.$acceptChatState($,c)}}catch(c){this.h.warn(c)}const n={firstProgress:m??0,totalElapsed:y.elapsed()};return{errorDetails:a.errorDetails,timings:n}}async $provideSlashCommands(b,$,d){const t=this.b.get(b);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,d))?.map(h=>({...h,kind:g.CompletionItemKind.from(h.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$Vcc=D}),define(Ae[221],Re([1,0,12,6,50,3,8,7]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class S{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(T.$ZJ.MainThreadChatAgents)}registerAgent(D,u,b,$){const d=S.a++;return this.b.set(d,{extension:D,agent:b}),this.c.$registerAgent(d,u,$),(0,F.$ic)(()=>{this.c.$unregisterAgent(d),this.b.delete(d)})}async $invokeAgent(D,u,b,$,d){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function o(){if(i)throw new Error("Only valid while executing the command")}const h=new v.$2g;d.onCancellationRequested(()=>h.complete()),setTimeout(()=>h.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,h.p);const y=t.agent({role:l.ChatMessageRole.User,content:b},{history:$.history.map(A.ChatMessage.to)},new C.$4u(m=>{o(),this.c.$handleProgressChunk(u,{content:g(m.message)?m.message:m.message.value})}),d);try{return await(0,v.$vg)(Promise.resolve(y).then(m=>{if(m&&"followUp"in m)return{followUp:m?.followUp?.map(a=>A.ChatFollowup.from(a))}}),d)}finally{i=!0,h.complete()}}}e.$6cc=S;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[222],Re([1,0,6,3,8,50,20]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class l{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Xl,this.b=g.getProxy(F.$ZJ.MainThreadChatProvider)}registerProvider(g,P,D,u){const b=l.a++;return this.c.set(b,{extension:g,provider:D}),this.b.$registerProvider(b,P,{extension:g,displayName:u.name??g.value}),(0,v.$ic)(()=>{this.b.$unregisterProvider(b),this.c.delete(b)})}async $provideChatResponse(g,P,D,u,b){const $=this.c.get(g);if(!$)return;const d=new T.$4u(async t=>{if(b.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(D.map(C.ChatMessage.to),u,d,b)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(g)},async makeRequest(u,b,$,d){if(!D.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,$);try{await D.b.$fetchResponse(g,P,t,u.map(C.ChatMessage.from),b,d)}finally{D.e.delete(t)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$1cc=l}),define(Ae[223],Re([1,0,6,3,7,8,50,12]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class S{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(F.$ZJ.MainThreadChatSlashCommands)}registerCommand(D,u,b,$){const d=S.a++;return this.b.set(d,{extension:D,command:b}),this.c.$registerCommand(d,u,$.description),(0,v.$ic)(()=>{this.c.$unregisterCommand(d),this.b.delete(d)})}async $executeCommand(D,u,b,$,d){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT execute command because the command is not registered`);return}let i=!1;function o(){if(i)throw new Error("Only valid while executing the command")}const h=new l.$2g;d.onCancellationRequested(()=>h.complete()),setTimeout(()=>h.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,h.p);const y=t.command({role:C.ChatMessageRole.User,content:b},{history:$.history.map(T.ChatMessage.to)},new A.$4u(m=>{o(),this.c.$handleProgressChunk(u,{content:g(m.message)?m.message:m.message.value})}),d);try{return await(0,l.$vg)(Promise.resolve(y).then(m=>{if(m&&"followUp"in m)return{followUp:m?.followUp?.map(a=>T.ChatFollowup.from(a))}}),d)}finally{i=!0,h.complete()}}}e.$2cc=S;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[224],Re([1,0,6,3,9,8]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class A{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(F.$ZJ.MainThreadChatVariables)}async $resolveVariable(S,g,P){const D=this.b.get(S);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:g},P);if(u)return u.map(T.ChatVariable.from)}catch(u){(0,C.$Z)(u)}}registerVariableResolver(S,g,P,D){const u=A.a++;return this.b.set(u,{extension:S.identifier,data:{name:g,description:P},resolver:D}),this.c.$registerVariable(u,{name:g,description:P}),(0,v.$ic)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$3cc=A}),define(Ae[225],Re([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class F{constructor(T){const A=T.getProxy(v.$ZJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$$ac=F}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,69,44,279,2,6,4,17,105,25,46,41,59,53,58]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=void 0;let a=class{#e;#t;#i;constructor(k,s,f){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$ZJ.MainThreadCommands),this.d=s,this.#i=f,this.#t=k.getProxy(A.$ZJ.MainThreadTelemetry),this.converter=new n(this,w=>{const R=this.c.get(w);return R?.result===E.Void?R:void 0},s),this.f=[{processArgument(w){return(0,g.$$g)(w)}},{processArgument(w){return(0,T.$Xm)(w,function(R){if(P.$ks.isIRange(R))return C.Range.to(R);if(D.$js.isIPosition(R))return C.Position.to(R);if(P.$ks.isIRange(R.range)&&u.URI.isUri(R.uri))return C.location.to(R);if(R instanceof i.$Fd)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const s=this.registerCommand(!1,k.id,async(...f)=>{const w=k.args.map((W,V)=>{if(!W.validate(f[V]))throw new Error(`Invalid argument '${W.name}' when running '${k.id}', received: ${f[V]}`);return W.convert(f[V])}),R=await this.executeCommand(k.internalId,...w);return k.result.convert(R,f,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new F.$2J(()=>{s.dispose(),this.c.delete(k.id)})}registerCommand(k,s,f,w,R,W){if(this.d.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this.b.has(s))throw new Error(`command '${s}' already exists`);return this.b.set(s,{callback:f,thisArg:w,description:R,extension:W}),k&&this.#e.$registerCommand(s),new F.$2J(()=>{this.b.delete(s)&&k&&this.#e.$unregisterCommand(s)})}executeCommand(k,...s){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,s,!0)}async g(k,s,f){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,s,!1);{let w=!1;const R=(0,T.$Xm)(s,function(W){if(W instanceof F.$3J)return C.Position.from(W);if(W instanceof F.$4J)return C.Range.from(W);if(W instanceof F.$bK)return C.location.from(W);if(F.$nL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return w=!0,i.$Fd.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return w=!0,i.$Fd.wrap(W);if(W instanceof i.$Fd)return w=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(k,w?new o.$dA(R):R,f);return(0,g.$$g)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(k,s,!1);throw W}}}async h(k,s,f){const w=this.b.get(k);if(!w)throw new Error("Unknown command");const{callback:R,thisArg:W,description:V}=w;if(V)for(let B=0;B<V.args.length;B++)try{(0,v.$Af)(s[B],V.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${V.args[B].name}' - ${V.args[B].description}`)}const U=y.$bd.create();try{return await R.apply(W,s)}catch(B){if(k===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...s);O&&(k=O.command)}if(this.d.error(B,k,w.extension?.identifier),!f)throw B;if(w.extension?.identifier){const O=this.#i.onExtensionError(w.extension.identifier,B);this.d.trace("forwarded error to extension?",O,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,h.$mi)(B)),this.id=k,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,k,U.elapsed())}}j(k,s,f){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new m.$_n(s),duration:f})}$executeContributedCommand(k,...s){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const f=this.b.get(k);return f?(s=s.map(w=>this.f.reduce((R,W)=>W.processArgument(R,f.extension?.identifier),w)),this.h(k,s,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(s=>(k&&(s=s.filter(f=>f[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const k=Object.create(null);for(const[s,f]of this.b){const{description:w}=f;w&&(k[s]=w)}return Promise.resolve(k)}};e.$kM=a,e.$kM=a=Ke([qe(0,d.$2L),qe(1,S.$5i),qe(2,r.$jM)],a),e.$lM=(0,$.$Bh)("IExtHostCommands");class n{constructor(k,s,f){this.d=k,this.f=s,this.g=f,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,s){if(!k)return;const f={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return f;const w=this.f(k.command);if(w)f.id=w.internalId,f.arguments=w.args.map((R,W)=>R.convert(k.arguments&&k.arguments[W]));else if((0,l.$Jb)(k.arguments)){const R=`${k.command}/${++this.c}`;this.b.set(R,k),s.add((0,b.$ic)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),f.$ident=R,f.id=this.delegatingCommandId,f.arguments=[R],this.g.trace("CommandsConverter#CREATE",k.command,R)}return f}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const s=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],s?s.command:"MISSING"),s?this.d.executeCommand(s.command,...s.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$mM=n;class c{static{this.Uri=new c("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new c("position","A position in a text document",k=>F.$3J.isPosition(k),C.Position.from)}static{this.Range=new c("range","A range in a text document",k=>F.$4J.isRange(k),C.Range.from)}static{this.Selection=new c("selection","A selection in a text document",k=>F.$5J.isSelection(k),C.Selection.from)}static{this.Number=new c("number","",k=>typeof k=="number",k=>k)}static{this.String=new c("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=c.Arr(c.String)}static Arr(k){return new c(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,s=>Array.isArray(s)&&s.every(f=>k.validate(f)),s=>s.map(f=>k.convert(f)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",k=>k instanceof F.$mK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",k=>k instanceof F.$GL,C.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",k=>k instanceof t.$cM,C.TestItem.from)}constructor(k,s,f,w){this.name=k,this.description=s,this.validate=f,this.convert=w}optional(){return new c(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,s){return new c(k??this.name,s??this.description,this.validate,this.convert)}}e.$nM=c;class E{static{this.Void=new E("no result",k=>k)}constructor(k,s){this.description=k,this.convert=s}}e.$oM=E;class p{constructor(k,s,f,w,R){this.id=k,this.internalId=s,this.description=f,this.args=w,this.result=R}}e.$pM=p}),define(Ae[226],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=void 0;const u=[new g.$pM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of DocumentHighlight-instances.",$(P.DocumentHighlight.to))),new g.$pM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$nM.Uri],new g.$oM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,v.$Ib)(t))return;class o extends D.$gK{static to(y){const m=new o(y.name,P.SymbolKind.to(y.kind),y.containerName||"",new D.$bK(i[0],P.Range.to(y.range)));return m.detail=y.detail,m.range=m.location.range,m.selectionRange=P.Range.to(y.selectionRange),m.children=y.children?y.children.map(o.to):[],m}}return t.map(o.to)})),new g.$pM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$nM.Uri,new g.$nM("options","Formatting options",t=>!0,t=>t)],new g.$oM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$pM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$nM.Uri,g.$nM.Range,new g.$nM("options","Formatting options",t=>!0,t=>t)],new g.$oM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$pM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$nM.Uri,g.$nM.Position,new g.$nM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$nM("options","Formatting options",t=>!0,t=>t)],new g.$oM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$pM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$pM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$pM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$pM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$pM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of Location-instances.",$(P.location.to))),new g.$pM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of Hover-instances.",$(P.Hover.to))),new g.$pM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$nM.Uri,new g.$nM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$3J.isPosition(i)),t=>t.map(P.Position.from))],new g.$oM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let o;for(const h of i.reverse())o=new D.$lK(P.Range.to(h),o);return o}))),new g.$pM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$nM.String.with("query","Search string")],new g.$oM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new g.$pM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new g.$pM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$nM.CallHierarchyItem],new g.$oM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new g.$pM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$nM.CallHierarchyItem],new g.$oM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new g.$pM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new g.$pM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$nM.Uri,g.$nM.Position,g.$nM.String.with("newName","The new symbol name")],new g.$oM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new g.$pM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$nM.Uri,g.$nM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$oM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new g.$pM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$nM.Uri],new g.$oM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$fL(t.tokenTypes,t.tokenModifiers)})),new g.$pM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$nM.Uri],new g.$oM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$u0)(t);if(i.type==="full")return new D.$hL(i.data,void 0)})),new g.$pM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$nM.Uri,g.$nM.Range.optional()],new g.$oM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$fL(t.tokenTypes,t.tokenModifiers)})),new g.$pM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$nM.Uri,g.$nM.Range],new g.$oM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$u0)(t);if(i.type==="full")return new D.$hL(i.data,void 0)})),new g.$pM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$nM.Uri,g.$nM.Position,g.$nM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$nM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$oM("A promise that resolves to a CompletionList-instance.",(t,i,o)=>{if(!t)return new D.$xK([]);const h=t.suggestions.map(y=>P.CompletionItem.to(y,o));return new D.$xK(h,t.incomplete)})),new g.$pM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$nM.Uri,g.$nM.Position,g.$nM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$oM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new g.$pM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$nM.Uri,g.$nM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$oM("A promise that resolves to an array of CodeLens-instances.",(t,i,o)=>$(h=>new D.$pK(P.Range.to(h.range),h.command&&o.fromInternal(h.command)))(t))),new g.$pM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$nM.Uri,new g.$nM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$4J.isRange(t),t=>D.$5J.isSelection(t)?P.Selection.from(t):P.Range.from(t)),g.$nM.String.with("kind","Code action kind to return code actions for").optional(),g.$nM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$oM("A promise that resolves to an array of Command-instances.",(t,i,o)=>$(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(h.command)}else{const y=new D.$iK(h.title,h.kind?new D.$jK(h.kind):void 0);return h.edit&&(y.edit=P.WorkspaceEdit.to(h.edit)),h.command&&(y.command=o.fromInternal(h.command)),y.isPreferred=h.isPreferred,y}})(t))),new g.$pM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$nM.Uri],new g.$oM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$DK(P.Range.to(i.range),P.Color.to(i.color))):[])),new g.$pM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$nM("color","The color to show and insert",t=>t instanceof D.$CK,P.Color.from),new g.$nM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new g.$oM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new g.$pM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$nM.Uri,g.$nM.Range],new g.$oM("A promise that resolves to an array of Inlay objects",(t,i,o)=>t.map(P.InlayHint.to.bind(void 0,o)))),new g.$pM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$nM.Uri],new g.$oM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new g.$pM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$oM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new g.$pM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$nM.Uri,g.$nM.Range,new g.$nM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$4J,t=>P.InlineValueContext.from(t))],new g.$oM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new g.$pM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$nM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,S.$NT)(t,F.Schemas.http,F.Schemas.https),t=>t),new g.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),g.$nM.String.with("label","").optional()],g.$oM.Void),new g.$pM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$nM.Uri.with("resource","Resource to open"),g.$nM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],g.$oM.Void),new g.$pM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$nM.Uri.with("left","Left-hand side resource of the diff editor"),g.$nM.Uri.with("right","Right-hand side resource of the diff editor"),g.$nM.String.with("title","Human readable title for the diff editor").optional(),new g.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],g.$oM.Void),new g.$pM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$nM.Uri,g.$nM.Position],new g.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$pM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$nM.TypeHierarchyItem],new g.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$pM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$nM.TypeHierarchyItem],new g.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$pM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$nM.TestItem],g.$oM.Void),new g.$pM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$nM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$oM.Void),new g.$pM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$nM.String.with("name","The context key name"),new g.$nM("value","The context key value",()=>!0,t=>t)],g.$oM.Void),new g.$pM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$nM.Uri,g.$nM.StringArray,new g.$nM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new g.$oM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Ji)}}e.$0ac=b;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function d(t){if(!Array.isArray(t))return;const i=[];for(const o of t)T.$8s(o)?i.push(P.DefinitionLink.to(o)):i.push(P.location.to(o));return i}}),define(Ae[227],Re([1,0,12,65,5,6,2,78,20,8,7,3,26]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;function b($,d,t){const i=$.getProxy(D.$ZJ.MainThreadComments);class o{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Xl,d.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===6){const I=this.b.get(p.handle);return I?I.value:p}else if(p&&p.$mid===7){const I=this.b.get(p.commentControlHandle);if(!I)return p;const k=I.getCommentThread(p.commentThreadHandle);return k?k.value:p}else if(p&&(p.$mid===9||p.$mid===8)){const I=this.b.get(p.thread.commentControlHandle);if(!I)return p;const k=I.getCommentThread(p.thread.commentThreadHandle);return k?p.$mid===8?k.value:{thread:k.value,text:p.text}:p}else if(p&&p.$mid===10){const I=this.b.get(p.thread.commentControlHandle);if(!I)return p;const k=I.getCommentThread(p.thread.commentThreadHandle);if(!k)return p;const s=p.commentUniqueId,f=k.getCommentByUniqueId(s);return f||p}else if(p&&p.$mid===11){const I=this.b.get(p.thread.commentControlHandle);if(!I)return p;const k=I.getCommentThread(p.thread.commentThreadHandle);if(!k)return p;const s=p.text,f=p.commentUniqueId,w=k.getCommentByUniqueId(f);return w?(typeof w.body=="string"?w.body=s:w.body=new P.$qK(s),w):p}return p}})}createCommentController(p,I,k){const s=o.a++,f=new y(p,s,I,k);this.b.set(f.handle,f);const w=this.c.get(p.identifier)||[];return w.push(f),this.c.set(p.identifier,w),f.value}$createCommentThreadTemplate(p,I,k){const s=this.b.get(p);s&&s.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(p,I,k){const s=this.b.get(p);s&&s.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(p,I){this.b.get(p)?.$deleteCommentThread(I)}$provideCommentingRanges(p,I,k){const s=this.b.get(p);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const f=t.getDocument(A.URI.revive(I));return(0,v.$zg)(async()=>{const w=await s.commentingRangeProvider.provideCommentingRanges(f,k);let R;return Array.isArray(w)?R={ranges:w,fileComments:!1}:w?R={ranges:w.ranges||[],fileComments:w.fileComments||!1}:R=w??void 0,R}).then(w=>{let R;return w&&(R={ranges:w.ranges.map(W=>g.Range.from(W)),fileComments:w.fileComments}),R})}$toggleReaction(p,I,k,s,f){const w=this.b.get(p);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,v.$zg)(()=>{const R=w.getCommentThread(I);if(R){const W=R.getCommentByUniqueId(s.uniqueIdInThread);if(w!==void 0&&W&&w.reactionHandler)return w.reactionHandler(W,a(f))}return Promise.resolve(void 0)})}}class h{static{this.a=0}set threadId(p){this.n=p}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(p){(p===void 0!=(this.p===void 0)||!p||!this.p||!p.isEqual(this.p))&&(this.p=p,this.b.range=p,this.c.fire())}get range(){return this.p}set canReply(p){this.d!==p&&(this.d=p,this.b.canReply=p,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(p){this.e=p,this.b.label=p,this.c.fire()}get contextValue(){return this.f}set contextValue(p){this.f=p,this.b.contextValue=p,this.c.fire()}get comments(){return this.q}set comments(p){this.q=p,this.b.comments=p,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(p){this.g=p,this.b.collapsibleState=p,this.c.fire()}get state(){return this.h}set state(p){this.h=p,this.b.state=p,this.c.fire()}get isDisposed(){return this.j}constructor(p,I,k,s,f,w,R,W){this.m=I,this.n=k,this.o=s,this.p=f,this.q=w,this.extensionDescription=R,this.r=W,this.handle=h.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$fd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$lc,this.l.value=new T.$jc,this.n===void 0&&(this.n=`${p}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$jc);const p=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};p("range")&&(I.range=g.Range.from(this.p)),p("label")&&(I.label=this.label),p("contextValue")&&(I.contextValue=this.contextValue??null),p("comments")&&(I.comments=this.q.map(k=>m(this,k,this.k,this.extensionDescription))),p("collapsibleState")&&(I.collapseState=n(this.g)),p("canReply")&&(I.canReply=this.canReply),p("state")&&(I.state=c(this.h)),p("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(p){for(const I of this.k){const k=I[0],s=I[1];if(p===s)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(p=>p.dispose())}}Ke([(0,F.$7g)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class y{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(p){this.b=p,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(p){this.c=p,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!p})}get options(){return this.d}set options(p){this.d=p,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(p,I,k,s){this.f=p,this.g=I,this.h=k,this.i=s,this.a=new Map,i.$registerCommentController(this.handle,k,s,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(w){f.options=w},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(w){f.commentingRangeProvider=w},get reactionHandler(){return f.reactionHandler},set reactionHandler(w){f.reactionHandler=w},createCommentThread(w,R,W){return f.createCommentThread(w,R,W).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(p,I,k){I===void 0&&(0,u.$QF)(this.f,"fileComments");const s=new h(this.id,this.handle,void 0,p,I,k,this.f,!1);return this.a.set(s.handle,s),s}$createCommentThreadTemplate(p,I){const k=new h(this.id,this.handle,void 0,A.URI.revive(p),g.Range.to(I),[],this.f,!0);return k.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(p,I){const k=this.a.get(p);k&&(k.range=g.Range.to(I))}$deleteCommentThread(p){this.a.get(p)?.dispose(),this.a.delete(p)}getCommentThread(p){return this.a.get(p)}dispose(){this.a.forEach(p=>{p.dispose()}),this.e.forEach(p=>p.dispose())}}function m(E,p,I,k){let s=I.get(p);return s||(s=++E.commentHandle,I.set(p,s)),p.state!==void 0&&(0,u.$QF)(k,"commentsDraftState"),{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:s,body:typeof p.body=="string"?p.body:g.MarkdownString.from(p.body),userName:p.author.name,userIconPath:p.author.iconPath,label:p.label,commentReactions:p.reactions?p.reactions.map(f=>r(f)):void 0,state:p.state,timestamp:p.timestamp?.toJSON()}}function r(E){return{label:E.label,iconPath:E.iconPath?g.$1L(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted}}function a(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?A.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1}}function n(E){if(E!==void 0)switch(E){case P.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function c(E){if(E!==void 0)switch(E){case P.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new o}e.$_ac=b}),define(Ae[228],Re([1,0,24,3,27,17]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;let A=class{constructor(P,D){this.a=P.getProxy(F.$ZJ.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const u=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,D,b,arguments)}})}e(P,D,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(b,this.b)}),this.c&&this.f(P,u,b)}};e.$9cc=A,e.$9cc=A=Ke([qe(0,T.$2L),qe(1,C.$fM)],A);const l=1e5;function S(g,P){const D=[];if(g.length)for(let u=0;u<g.length;u++){let b=g[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const $=b;$.stack?b=$.stack:b=$.toString()}D.push(b)}if(P){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$1m)(D);return u.length>l?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[108],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(d,t){this.h=t,this.f=new Map,this.g=d.getProxy(F.$ZJ.MainThreadDecorations)}registerFileDecorationProvider(d,t){const i=u.c++;this.f.set(i,{provider:d,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const o=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(h=>{if(!h){this.g.$onDidChange(i,null);return}const y=(0,S.$1b)(h);if(y.length<=u.d){this.g.$onDidChange(i,y);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,y.length);const m=y.map(n=>({uri:n,rank:(0,g.$re)(n.path,"/")})),r=(0,S.$xb)(m,(n,c)=>n.rank-c.rank||(0,g.$Fe)(n.uri.path,c.uri.path)),a=[];e:for(const n of r){let c;for(const E of n){const p=(0,P.$_d)(E.uri.path);if(c!==p&&(c=p,a.push(E.uri)>=u.d))break e}}this.g.$onDidChange(i,a)});return new C.$2J(()=>{o?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(d,t,i){if(!this.f.has(d))return Object.create(null);const o=Object.create(null),{provider:h,extensionDescription:y}=this.f.get(d);return await Promise.all(t.map(async m=>{try{const{uri:r,id:a}=m,n=await Promise.resolve(h.provideFileDecoration(v.URI.revive(r),i));if(!n)return;try{C.$lL.validate(n),n.badge&&typeof n.badge!="string"&&(0,D.$QF)(y,"codiconDecoration"),o[a]=[n.propagate,n.tooltip,n.badge,n.color]}catch(c){this.h.warn(`INVALID decoration from extension '${y.identifier.value}': ${c}`)}}catch(r){this.h.error(r)}})),o}};e.$acc=b,e.$acc=b=u=Ke([qe(0,A.$2L),qe(1,l.$5i)],b),e.$bcc=(0,T.$Bh)("IExtHostDecorations")}),define(Ae[229],Re([1,0,148,94,2,3,7,8,5,14,28,39]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0;class b{#e;#t;#i;constructor(t,i,o,h,y,m,r,a){this.d=t,this.e=i,this.f=o,this.g=h,this.h=y,this.c=!1,this.f=Math.max(h,o),this.#i=new P.$zi(n=>m.getComparisonKey(n)),this.#e=r,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let o=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),o=[t]}else if(Array.isArray(t)){o=[];let m;t=[...t].sort(b.k);for(const r of t){const[a,n]=r;if((!m||a.toString()!==m.toString())&&(m&&this.#i.get(m).length===0&&this.#i.delete(m),m=a,o.push(a),this.#i.set(a,[])),n)this.#i.get(a)?.push(...n);else{const c=this.#i.get(a);c&&(c.length=0)}}}if(this.#t.fire(o),!this.#e)return;const h=[];let y=0;for(const m of o){let r=[];const a=this.#i.get(m);if(a)if(a.length>this.g){r=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const E of a)if(E.severity===n[c]&&r.push({...l.Diagnostic.from(E),modelVersionId:this.h(m)})===this.g)break e;r.push({severity:F.MarkerSeverity.Info,message:(0,v.localize)(0,null,a.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=a.map(n=>({...l.Diagnostic.from(n),modelVersionId:this.h(m)}));if(h.push([m,r]),y+=r.length,y>this.f)break}this.#e.$changeMany(this.e,h)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[o,h]of this)t.call(i,o,h,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$4ac=b;let $=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$zi;for(const o of t)i.set(o,o);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,o,h){this.j=i,this.k=o,this.l=h,this.g=new Map,this.h=new S.$jd({merge:y=>y.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,u._mapper),this.f=t.getProxy(T.$ZJ.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:o,f:h,h:y,j:m,k:r,l:a}=this,n=new class{$changeMany(p,I){h.$changeMany(p,I),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,p,I.length===0?"CLEARING":I)}$clear(p){h.$clear(p),m.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,p)}dispose(){h.dispose()}};let c;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,c=i;else if(!o.has(i))c=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do c=i+u.c++;while(o.has(c))}return new class extends b{constructor(){super(i,c,u.e,u.d,p=>a.getDocument(p)?.version,r.extUri,n,y),o.set(c,this)}dispose(){super.dispose(),o.delete(c)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,o=[];for(const h of this.g.values())h.forEach((y,m)=>{let r=i.get(y.toString());typeof r>"u"&&(r=o.length,i.set(y.toString(),r),o.push([y,[]])),o[r][1]=o[r][1].concat(...m)});return o}}m(t){let i=[];for(const o of this.g.values())o.has(t)&&(i=i.concat(o.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",o=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,h=>{},this.k.extUri,void 0,this.h);this.g.set(i,o),this.n=o}for(const[i,o]of t)this.n.set(C.URI.revive(i),o.map(l.Diagnostic.to))}};e.$5ac=$,e.$5ac=$=u=Ke([qe(1,g.$5i),qe(2,D.$3ac)],$)}),define(Ae[230],Re([1,0,2,3,26]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;class T{constructor(l){this.a=l.getProxy(F.$ZJ.MainThreadDialogs)}showOpenDialog(l,S){return S?.allowUIResources&&(0,C.$QF)(l,"showLocal"),this.a.$showOpenDialog(S).then(g=>g?g.map(P=>v.URI.revive(P)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(S=>S?v.URI.revive(S):void 0)}}e.$hbc=T}),define(Ae[231],Re([1,0,9,2,7,3,13,21,15]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;class g{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(T.$ZJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=g.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,D);let $;return typeof u.onDidChange=="function"&&($=u.onDidChange(d=>{if(d.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(b,d).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(d);if(!i)return;const o=(0,S.$Ae)(t);if(!i.equalLines(o))return this.c.$onVirtualDocumentChange(d,t)},v.$Y)})),new C.$2J(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,u){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(F.URI.revive(u),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$ibc=g}),define(Ae[232],Re([1,0,5,6,2,3,101,8,16,24,7,9]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;class u{constructor($,d){this.a=new v.$fd({onListenerError:D.$Z}),this.b=new v.$fd({onListenerError:D.$Z}),this.c=new v.$fd({onListenerError:D.$Z}),this.d=new v.$fd({onListenerError:D.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$jc,this.h=new Map,this.f=$.getProxy(T.$ZJ.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const d=this.g.getDocument($);if(d)return d}getDocument($){const d=this.getDocumentData($);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return d.document}ensureDocumentData($){const d=this.g.getDocument($);if(d)return Promise.resolve(d);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const o=C.URI.revive(i);return(0,S.$uf)(this.g.getDocument(o))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(d=>C.URI.revive(d))}$acceptModelLanguageChanged($,d){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(d),this.a.fire(i.document)}$acceptModelSaved($){const d=C.URI.revive($),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,d){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,d,t){const i=C.URI.revive($),o=this.g.getDocument(i);if(!o)throw new Error("unknown document");o._acceptIsDirty(t),o.onEvents(d);let h;d.isUndoing?h=P.TextDocumentChangeReason.Undo:d.isRedoing&&(h=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Wm)({document:o.document,contentChanges:d.changes.map(y=>({range:l.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:h}))}setWordDefinitionFor($,d){(0,A.$4L)($,d)}}e.$1ac=u}),define(Ae[60],Re([1,0,51,5,6,2,4,3,101,17,106,8,14,28,13,67,66]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=void 0;class i{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let o=class{constructor(y,m){this.h=y,this.i=m,this.a=null,this.b=new Map,this.c=new b.$zi,this.d=new F.$fd,this.e=new F.$fd,this.f=new F.$fd,this.g=new F.$fd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const m=[],r=[],a=[];if(y.removedDocuments)for(const n of y.removedDocuments){const c=T.URI.revive(n),E=this.c.get(c);E?.unref()&&(this.c.delete(c),m.push(E.value))}if(y.addedDocuments)for(const n of y.addedDocuments){const c=T.URI.revive(n.uri);let E=this.c.get(c);if(E&&c.scheme!==$.Schemas.vscodeNotebookCell&&c.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);E||(E=new i(new S.$5L(this.h.getProxy(l.$ZJ.MainThreadDocuments),c,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(c,E),r.push(E.value)),E.ref()}if(y.removedEditors)for(const n of y.removedEditors){const c=this.b.get(n);this.b.delete(n),c&&a.push(c)}if(y.addedEditors)for(const n of y.addedEditors){const c=T.URI.revive(n.documentUri);v.ok(this.c.has(c),`document '${c}' does not exist`),v.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const E=this.c.get(c).value,p=new P.$$L(n.id,this.h.getProxy(l.$ZJ.MainThreadTextEditors),this.i,new t.$T(()=>E.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(I=>D.Range.to(I)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,p)}y.newActiveEditor!==void 0&&(v.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,C.$fc)(m),(0,C.$fc)(a),y.removedDocuments&&this.e.fire(m),y.addedDocuments&&this.d.fire(r),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return d.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const m=this.b.get(this.a);return y?m:m?.value}allEditors(){return[...this.b.values()]}};e.$_L=o,e.$_L=o=Ke([qe(0,g.$2L),qe(1,u.$5i)],o),e.$aM=(0,A.$Bh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,100]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0,e.$fcc=(0,A.$Bh)("IExtHostEditorTabs");class D{constructor(t,i,o){this.e=o,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$HL(C.URI.revive(this.b.input.uri));case 2:return new l.$IL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$JL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$KL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$LL(this.b.input.viewType);case 4:return new l.$ML(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$NL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$OL;case 9:return new l.$PL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const o of t.tabs)o.isActive&&(this.d=o.id),this.c.push(new D(o,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return v.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(o=>o.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(o=>o.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const o=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,o),t.tabDto.isActive&&(this.d=o.tabId),o}else if(t.kind===1){const o=this.c.splice(t.index,1)[0];if(!o)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return o.tabId===this.d&&(this.d=""),o}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const o=this.c.splice(t.oldIndex,1)[0];if(!o)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,o),o}const i=this.c.find(o=>o.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new T.$fd,this.c=new T.$fd,this.e=[],this.a=t.getProxy(F.$ZJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(o=>o.apiObject))},get activeTabGroup(){const o=t.d;return(0,g.$uf)(t.e.find(y=>y.groupId===o)?.apiObject)},close:async(o,h)=>{const y=Array.isArray(o)?o:[o];return y.length?$(y[0])?this.j(y,h):this.i(y,h):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),o=new Set(t.map(n=>n.groupId)),h=(0,P.$J)(i,o),y=this.e.filter(n=>h.removed.includes(n.groupId)).map(n=>n.apiObject),m=[],r=[];this.e=t.map(n=>{const c=new u(n,()=>this.d);return h.added.includes(c.groupId)?m.push(c.apiObject):r.push(c.apiObject),c});const a=(0,g.$uf)(t.find(n=>n.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:m,closed:y,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(o=>o.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(h=>h.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const o=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[o.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[o.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[o.apiObject]}));return}}g(t){for(const i of this.e)for(const o of i.tabs)if(o.apiObject===t)return o}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const o=[];for(const h of t){const y=this.g(h);if(!y)throw new Error("Tab close: Invalid tab not found!");o.push(y.tabId)}return this.a.$closeTab(o,i)}async j(t,i){const o=[];for(const h of t){const y=this.h(h);if(!y)throw new Error("Group close: Invalid group not found!");o.push(y.groupId)}return this.a.$closeGroup(o,i)}};e.$gcc=b,e.$gcc=b=Ke([qe(0,S.$2L)],b);function $(d){return d.tabs!==void 0}}),define(Ae[233],Re([1,0,3,7]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$ZJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(l,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,l,S){const g=this.b;return this.b++,this.a.set(g,S),this.c.$registerAiEmbeddingVectorProvider(l,g),new F.$2J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$5cc=C}),define(Ae[234],Re([1,0,2,3,6,7,8,280,15,25,26,49]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class u{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const t=this.a.indexOf(d);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),t=[];let i,o,h=14,y=14;for(const m of d){let r=i?(0,S.$Oe)(i,m):0;for(r===0?o=1:o=y;r<m.length;r++)r+1===m.length?(h=y,y=9):y+=1,t.push([o,m.toUpperCase().charCodeAt(r),y]),t.push([o,m.toLowerCase().charCodeAt(r),y]),o=y;i=m,y=h}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$wY(t)}}provideDocumentLinks(d){this.c();const t=[],i=l.$xY.computeLinks({getLineContent(o){return d.lineAt(o-1).text},getLineCount(){return d.lineCount}},this.b);for(const o of i){const h=A.DocumentLink.to(o);h.target&&t.push(h)}return t}}class b{constructor(d,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(F.$ZJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,t,i,o={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const h=this.h++;this.b.add(t),this.d.add(t),this.c.set(h,i);let y=2;o.isCaseSensitive&&(y+=1024),o.isReadonly&&(y+=2048),typeof i.copy=="function"&&(y+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$QF)(d,"fsChunks"),y+=4);let m;o.isReadonly&&(0,D.$Zj)(o.isReadonly)&&((0,P.$QF)(d,"readonlyMessage"),m={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(h,t,y,m).catch(a=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${t}`),console.error(a)});const r=i.onDidChangeFile(a=>{const n=[];for(const c of a){const{uri:E,type:p}=c;if(E.scheme!==t)continue;let I;switch(p){case T.FileChangeType.Changed:I=0;break;case T.FileChangeType.Created:I=1;break;case T.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:E,type:I})}this.a.$onFileSystemChange(h,n)});return(0,C.$ic)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(h),this.a.$unregisterProvider(h)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:t,ctime:i,mtime:o,size:h,permissions:y}=d;return{type:t,ctime:i,mtime:o,size:h,permissions:y}}$stat(d,t){return Promise.resolve(this.l(d).stat(v.URI.revive(t))).then(i=>b.k(i))}$readdir(d,t){return Promise.resolve(this.l(d).readDirectory(v.URI.revive(t)))}$readFile(d,t){return Promise.resolve(this.l(d).readFile(v.URI.revive(t))).then(i=>g.$Fd.wrap(i))}$writeFile(d,t,i,o){return Promise.resolve(this.l(d).writeFile(v.URI.revive(t),i.buffer,o))}$delete(d,t,i){return Promise.resolve(this.l(d).delete(v.URI.revive(t),i))}$rename(d,t,i,o){return Promise.resolve(this.l(d).rename(v.URI.revive(t),v.URI.revive(i),o))}$copy(d,t,i,o){const h=this.l(d);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(v.URI.revive(t),v.URI.revive(i),o))}$mkdir(d,t){return Promise.resolve(this.l(d).createDirectory(v.URI.revive(t)))}$watch(d,t,i,o){const h=this.l(d).watch(v.URI.revive(i),o);this.f.set(t,h)}$unwatch(d,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(d,t,i){const o=this.l(d);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(v.URI.revive(t),i))}$close(d,t){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(d,t,i,o){const h=this.l(d);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const y=g.$Fd.alloc(o);return Promise.resolve(h.read(t,i,y.buffer,0,o)).then(m=>y.slice(0,m))}$write(d,t,i,o){const h=this.l(d);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(t,i,o.buffer,0,o.byteLength))}l(d){const t=this.c.get(d);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Obc=b}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=void 0;let $=b=class{constructor(t,i){this.b=new Map,this.c=new P.$Pg,this.a=t.getProxy(v.$ZJ.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(h){try{let y;const m=o.b.get(h.scheme);return m?(await o.a.$ensureActivation(h.scheme),y=await m.impl.stat(h)):y=await o.a.$stat(h),{type:y.type,ctime:y.ctime,mtime:y.mtime,size:y.size,permissions:y.permissions===F.FilePermission.Readonly?1:void 0}}catch(y){b.e(y)}},async readDirectory(h){try{const y=o.b.get(h.scheme);return y?(await o.a.$ensureActivation(h.scheme),(await y.impl.readDirectory(h)).slice()):await o.a.$readdir(h)}catch(y){return b.e(y)}},async createDirectory(h){try{const y=o.b.get(h.scheme);return y&&!y.isReadonly?(await o.a.$ensureActivation(h.scheme),await o.d(y.impl,y.extUri,h)):await o.a.$mkdir(h)}catch(y){return b.e(y)}},async readFile(h){try{const y=o.b.get(h.scheme);return y?(await o.a.$ensureActivation(h.scheme),(await y.impl.readFile(h)).slice()):(await o.a.$readFile(h)).buffer}catch(y){return b.e(y)}},async writeFile(h,y){try{const m=o.b.get(h.scheme);return m&&!m.isReadonly?(await o.a.$ensureActivation(h.scheme),await o.d(m.impl,m.extUri,m.extUri.dirname(h)),await o.c.queueFor(h).queue(()=>Promise.resolve(m.impl.writeFile(h,y,{create:!0,overwrite:!0})))):await o.a.$writeFile(h,T.$Fd.wrap(y))}catch(m){return b.e(m)}},async delete(h,y){try{const m=o.b.get(h.scheme);return m&&!m.isReadonly?(await o.a.$ensureActivation(h.scheme),await m.impl.delete(h,{recursive:!1,...y})):await o.a.$delete(h,{recursive:!1,useTrash:!1,atomic:!1,...y})}catch(m){return b.e(m)}},async rename(h,y,m){try{return await o.a.$rename(h,y,{overwrite:!1,...m})}catch(r){return b.e(r)}},async copy(h,y,m){try{return await o.a.$copy(h,y,{overwrite:!1,...m})}catch(r){return b.e(r)}},isWritableFileSystem(h){const y=i.getCapabilities(h);if(typeof y=="number")return!(y&2048)}})}async d(t,i,o){const h=[];for(;!i.isEqual(o,i.dirname(o));)try{if(!((await t.stat(o)).type&F.FileType.Directory))throw C.$dL.FileExists(`Unable to create folder '${o.scheme===u.Schemas.file?o.fsPath:o.toString(!0)}' that already exists but is not a directory`);break}catch(y){if(F.$ik(y)!==F.FileSystemProviderErrorCode.FileNotFound)throw y;h.push(i.basename(o)),o=i.dirname(o)}for(let y=h.length-1;y>=0;y--){o=i.joinPath(o,h[y]);try{await t.createDirectory(o)}catch(m){if(F.$ik(m)!==F.FileSystemProviderErrorCode.FileExists)throw m}}}static e(t){if(t instanceof C.$dL)throw t;if(t instanceof F.$ek)switch(t.code){case F.FileSystemProviderErrorCode.FileExists:throw C.$dL.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.$dL.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.$dL.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.$dL.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.$dL.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.$dL.Unavailable(t.message);default:throw new C.$dL(t.message,t.name)}if(!(t instanceof Error))throw new C.$dL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$dL.Unavailable(t.message);switch(t.name){case F.FileSystemProviderErrorCode.FileExists:throw C.$dL.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.$dL.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.$dL.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.$dL.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.$dL.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.$dL.Unavailable(t.message);default:throw new C.$dL(t.message,t.name)}}addFileSystemProvider(t,i,o){return this.b.set(t,{impl:i,extUri:o?.isCaseSensitive?D.$$f:D.$ag,isReadonly:!!o?.isReadonly}),(0,g.$ic)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$$f}};e.$ubc=$,e.$ubc=$=b=Ke([qe(0,l.$2L),qe(1,S.$3ac)],$),e.$vbc=(0,A.$Bh)("IExtHostConsumerFileSystem")}),define(Ae[235],Re([1,0,5,37,2,3,8,7]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,u,b,$,d,t,i,o){this.a=new v.$fd,this.b=new v.$fd,this.c=new v.$fd;const h=this.h(D,b,d);this.g=0,t&&(this.g+=1),i&&(this.g+=2),o&&(this.g+=4);const y=(0,F.$rj)(d),m=typeof d=="string",r=$(a=>{if(!t)for(const n of a.created){const c=C.URI.revive(n);y(c.fsPath)&&(!m||u.getWorkspaceFolder(c))&&this.a.fire(c)}if(!i)for(const n of a.changed){const c=C.URI.revive(n);y(c.fsPath)&&(!m||u.getWorkspaceFolder(c))&&this.b.fire(c)}if(!o)for(const n of a.deleted){const c=C.URI.revive(n);y(c.fsPath)&&(!m||u.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=l.$2J.from(h,this.a,this.b,this.c,r)}h(D,u,b){const $=l.$2J.from();if(typeof b=="string")return $;const d=D.getProxy(T.$ZJ.MainThreadFileSystem);let t=!1;(b.pattern.includes(F.$nj)||b.pattern.includes(F.$oj))&&(t=!0);const i=Math.random();return d.$watch(u.identifier.value,i,b.baseUri,{recursive:t,excludes:[]}),l.$2J.from({dispose:()=>d.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(D,u,b){this.j=D,this.k=u,this.l=b,this.a=new v.$fd,this.b=new v.$fd,this.c=new v.$fd,this.d=new v.$fd,this.g=new v.$hd,this.h=new v.$hd,this.i=new v.$hd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,u,b,$,d,t){return new S(this.j,D,u,this.a.event,A.GlobPattern.from(b),$,d,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,u){switch(D){case 2:this.b.fire(Object.freeze({files:u.map(b=>({oldUri:C.URI.revive(b.source),newUri:C.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(b=>C.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(b=>C.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,u){return(b,$,d)=>{const t=function(o){b.call($,o)};return t.extension=D,u.event(t,void 0,d)}}async $onWillRunFileOperation(D,u,b,$){switch(D){case 2:return await this.n(this.g,{files:u.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},b,$);case 1:return await this.n(this.i,{files:u.map(d=>C.URI.revive(d.target))},b,$);case 0:case 3:return await this.n(this.h,{files:u.map(d=>C.URI.revive(d.target))},b,$)}}async n(D,u,b,$){const d=new Set,t=[];if(await D.fireAsync(u,$,async(o,h)=>{const y=Date.now(),m=await Promise.resolve(o);m instanceof l.$_J&&(t.push([h.extension,m]),d.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-y>b&&this.k.warn("SLOW file-participant",h.extension.identifier)}),$.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,o]of t){const{edits:h}=A.WorkspaceEdit.from(o,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(d)}}}e.$Pbc=g}),define(Ae[236],Re([1,0,6,2,3,8,7,31]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;class S{static{this.a=0}constructor(u,b){this.extension=u,this.provider=b,this.handle=S.a++}}class g{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,b,$,d){this.f=$,this.g=d,this.b=new Map,this.d=new Map,this.e=u.getProxy(C.$ZJ.MainThreadInlineChat),b.registerApiCommand(new l.$pM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$nM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?T.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?T.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?T.Position.from(t.position):void 0}})],l.$oM.Void))}registerProvider(u,b,$){const d=new S(u,b);return this.b.set(d.handle,d),this.e.$registerInteractiveEditorProvider(d.handle,$.label,u.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function"),(0,v.$ic)(()=>{this.e.$unregisterInteractiveEditorProvider(d.handle),this.b.delete(d.handle)})}async $prepareSession(u,b,$,d){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(b)),o=T.Selection.to($),h=await t.provider.prepareInteractiveEditorSession({document:i,selection:o},d);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const y=P.a++;return this.d.set(y,new g(h)),{id:y,placeholder:h.placeholder,slashCommands:h.slashCommands?.map(m=>({command:m.command,detail:m.detail,refer:m.refer,executeImmediately:m.executeImmediately})),wholeRange:T.Range.from(h.wholeRange),message:h.message}}async $provideResponse(u,b,$,d){const t=this.b.get(u);if(!t)return;const i=this.d.get(b.id);if(!i)return;const o={prompt:$.prompt,selection:T.Selection.to($.selection),wholeRange:T.Range.to($.wholeRange),attempt:$.attempt,live:$.live};let h=!1;const y={report:a=>{if(!$.live)throw new Error("Progress reporting is only supported for live sessions");h||d.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk($.requestId,{message:a.message,edits:a.edits?.map(T.TextEdit.from)})}},m=t.provider.provideInteractiveEditorResponse(i.session,o,y,d);Promise.resolve(m).finally(()=>h=!0);const r=await m;if(r){const a=i.responses.push(r)-1,n={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r))return{...n,id:a,type:"message",message:T.MarkdownString.from(r.contents)};const{edits:c}=r;if(c instanceof A.$_J)return{...n,id:a,type:"bulkEdit",edits:T.WorkspaceEdit.from(c)};if(Array.isArray(c))return{...n,id:a,type:"editorEdit",edits:c.map(T.TextEdit.from)}}}$handleFeedback(u,b,$,d){const t=this.b.get(u),i=this.d.get(b),o=i?.responses[$];if(t&&o){const h=T.InteractiveEditorResponseFeedbackKind.to(d);t.provider.handleInteractiveEditorResponseFeedback?.(i.session,o,h)}}$releaseSession(u,b){}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$Wcc=P}),define(Ae[237],Re([1,0,2,31]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class C{constructor(A,l,S,g,P){this.a=l,this.b=S,this.c=g;const D=new F.$pM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$nM("showOptions","Show Options",u=>!0,u=>u),new F.$nM("resource","Interactive resource Uri",u=>!0,u=>u),new F.$nM("controllerId","Notebook controller Id",u=>!0,u=>u),new F.$nM("title","Interactive editor title",u=>!0,u=>u)],new F.$oM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,l,S,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(v.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Scc=C}),define(Ae[238],Re([1,0,3,7]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(v.$ZJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(A);if(!S)throw new Error("Issue request handler not found");const g=await S.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,l){const S=A.identifier.value;return this.a.set(S,l),this.b.$registerIssueUriRequestHandler(S),new F.$2J(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$Ycc=C}),define(Ae[239],Re([1,0,6,3]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(F.$ZJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,v.$ic)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$_bc=C}),define(Ae[240],Re([1,0,2,24,8,7,78,3,15,44,18,16,281,21,20,6,91,88,55,59,9,12,26,150]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;class n{constructor(M,K){this.d=M,this.e=K}async provideDocumentSymbols(M,K){const G=this.d.getDocument(M),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Ib)(Q))return Q[0]instanceof T.$hK?Q.map(C.DocumentSymbol.from):n.f(Q)}static f(M){M=M.slice(0).sort((Q,J)=>{let x=Q.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Q.location.range.end)),x});const K=[],G=[];for(const Q of M){const J={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(g.$ks.containsRange(x.range,J.range)&&!g.$ks.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class c{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(M,K,G){this.g=M,this.h=K,this.j=G,this.e=new o.$Zac("CodeLens"),this.f=new Map}async provideCodeLenses(M,K){const G=this.g.getDocument(M),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const J=this.e.add(Q),x=new d.$jc;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Oe=0;Oe<Q.length;Oe++)ae.lenses.push({cacheId:[J,Oe],range:C.Range.from(Q[Oe].range),command:this.h.toInternal(Q[Oe].command,x)});return ae}async resolveCodeLens(M,K){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const J=M.cacheId&&this.f.get(M.cacheId[0]);if(J)return M.command=this.h.toInternal(Q.command??c.d,J),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}function E(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class p{constructor(M,K){this.d=M,this.e=K}async provideDefinition(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDefinition(Q,J,G);return E(x)}}class I{constructor(M,K){this.d=M,this.e=K}async provideDeclaration(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDeclaration(Q,J,G);return E(x)}}class k{constructor(M,K){this.d=M,this.e=K}async provideImplementation(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideImplementation(Q,J,G);return E(x)}}class s{constructor(M,K){this.d=M,this.e=K}async provideTypeDefinition(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideTypeDefinition(Q,J,G);return E(x)}}class f{constructor(M,K){this.d=M,this.e=K}async provideHover(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideHover(Q,J,G);if(!(!x||(0,P.$Ib)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(J)),x.range||(x.range=new T.$4J(J,J)),C.Hover.from(x)}}class w{constructor(M,K){this.d=M,this.e=K}async provideEvaluatableExpression(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(Q,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(M,K){this.d=M,this.e=K}async provideInlineValues(M,K,G,Q){const J=this.d.getDocument(M),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class W{constructor(M,K){this.d=M,this.e=K}async provideDocumentHighlights(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(Q,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(M,K){this.d=M,this.e=K}async provideLinkedEditingRanges(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(Q,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Fb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(M,K){this.d=M,this.e=K}async provideReferences(M,K,G,Q){const J=this.d.getDocument(M),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class B{static{this.d=1e3}constructor(M,K,G,Q,J,x,ae){this.h=M,this.j=K,this.k=G,this.l=Q,this.m=J,this.n=x,this.o=ae,this.e=new o.$Zac("CodeAction"),this.f=new Map,this.g=new T.$jK("notebook")}async provideCodeActions(M,K,G,Q){const J=this.h.getDocument(M),x=u.$ms.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Xe of this.k.getDiagnostics(M))if(x.intersection(Xe.range)&&ae.push(Xe)>B.d)break;const Oe={diagnostics:ae,only:G.only?new T.$jK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},je=await this.l.provideCodeActions(J,x,Oe,Q);if(!(0,P.$Jb)(je)||Q.isCancellationRequested)return;const Qe=this.e.add(je),He=new d.$jc;this.f.set(Qe,He);const et=[];for(let Xe=0;Xe<je.length;Xe++){const _e=je[Xe];if(_e)if(B.p(_e))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this.j.toInternal(_e,He)});else{if(Oe.triggerKind!==T.CodeActionTriggerKind.Invoke&&_e.kind&&this.g.contains(_e.kind))continue;Oe.only&&(_e.kind?Oe.only.contains(_e.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Qe,Xe],title:_e.title,command:_e.command&&this.j.toInternal(_e.command,He),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})}}return{cacheId:Qe,actions:et}}async resolveCodeAction(M,K){const[G,Q]=M,J=this.e.get(G,Q);if(!J||B.p(J))return{};if(!this.l.resolveCodeAction)return{};const x=await this.l.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const je=this.f.get(G);je&&(Oe=this.j.toInternal(x.command,je))}return{edit:ae,command:Oe}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static p(M){return typeof M.command=="string"&&typeof M.title=="string"}}class O{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,Q,J){this.d=M,this.e=K,this.f=G,this.g=Q,this.h=J}async prepareDocumentPaste(M,K,G,Q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(M),x=K.map(je=>C.Range.to(je)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new y.$9});if(await this.f.prepareDocumentPaste(J,x,ae,Q),Q.isCancellationRequested)return;const Oe=Array.from(ae).filter(([,je])=>!(je instanceof T.$QK));return C.DataTransfer.from(Oe)}async providePasteEdits(M,K,G,Q,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Qe=>C.Range.to(Qe)),Oe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,M,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ae,Oe,J);if(je)return{label:je.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class N{constructor(M,K){this.d=M,this.e=K}async provideDocumentFormattingEdits(M,K,G){const Q=this.d.getDocument(M),J=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeFormattingEdits(M,K,G,Q){const J=this.d.getDocument(M),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,K,G,Q){(0,D.$tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(M),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Y{constructor(M,K){this.d=M,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,K,G,Q,J){const x=this.d.getDocument(M),ae=C.Position.to(K),Oe=await this.e.provideOnTypeFormattingEdits(x,ae,G,Q,J);if(Array.isArray(Oe))return Oe.map(C.TextEdit.from)}}class Ee{constructor(M,K){this.e=M,this.f=K,this.d=new o.$Zac("WorkspaceSymbols")}async provideWorkspaceSymbols(M,K){const G=await this.e.provideWorkspaceSymbols(M,K);if(!(0,P.$Jb)(G))return{symbols:[]};const Q=this.d.add(G),J={cacheId:Q,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,x]})}return J}async resolveWorkspaceSymbol(M,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,F.$Ym)(M,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class ke{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideRenameEdits(M,K,G,Q){const J=this.d.getDocument(M),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Oe=ke.g(ae);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(M,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(M),J=C.Position.to(K);try{const x=await this.e.prepareRename(Q,J,G);let ae,Oe;if(T.$4J.isRange(x)?(ae=x,Oe=Q.getText(x)):(0,D.$lf)(x)&&(ae=x.range,Oe=x.placeholder),!ae||!Oe)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Oe}}catch(x){const ae=ke.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Pe{constructor(M,K){this.resultId=M,this.tokens=K}}class X{constructor(M,K){this.f=M,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,K,G){const Q=this.f.getDocument(M),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,J.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return J&&this.d.delete(K),x?(x=X.h(x),this.o(X.n(J,x),x)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return X.j(M)?X.k(M)?M:new T.$hL(new Uint32Array(M.data),M.resultId):X.l(M)?X.m(M)?M:new T.$jL(M.edits.map(K=>new T.$iL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const K of M.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(M,K){if(!X.j(K)||!M||!M.tokens)return K;const G=M.tokens,Q=G.length,J=K.data,x=J.length;let ae=0;const Oe=Math.min(Q,x);for(;ae<Oe&&G[ae]===J[ae];)ae++;if(ae===Q&&ae===x)return new T.$jL([],K.resultId);let je=0;const Qe=Oe-ae;for(;je<Qe&&G[Q-je-1]===J[x-je-1];)je++;return new T.$jL([{start:ae,deleteCount:Q-ae-je,data:J.subarray(ae,x-je)}],K.resultId)}o(M,K){if(X.j(M)){const G=this.e++;return this.d.set(G,new Pe(M.resultId,M.data)),(0,t.$t0)({id:G,type:"full",data:M.data})}if(X.l(M)){const G=this.e++;return X.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(M.resultId)),(0,t.$t0)({id:G,type:"delta",deltas:(M.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class ue{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeSemanticTokens(M,K,G){const Q=this.d.getDocument(M),J=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return J?this.f(J):null}f(M){return(0,t.$t0)({id:0,type:"full",data:M.data})}}class ye{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,K,G,Q,J){this.f=M,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new o.$Zac("CompletionItem"),this.e=new Map}async provideCompletionItems(M,K,G,Q){const J=this.f.getDocument(M),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new T.$4J(x,x),Oe=ae.with({end:x}),je=new h.$bd,Qe=await this.h.provideCompletionItems(J,x,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new T.$xK(Qe):Qe,et=ye.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Xe=new d.$jc;this.e.set(et,Xe);const _e=[],it={x:et,b:_e,a:{replace:C.Range.from(ae),insert:C.Range.from(Oe)},c:He.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<He.items.length;tt++){const ze=He.items[tt],rt=this.l(ze,[et,tt],Oe,ae);_e.push(rt)}return it}async resolveCompletionItem(M,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const Q=this.l(G,M),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,M);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,F.$Zm)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K,G,Q){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(M.command,J),ae={x:K,a:M.label,b:M.kind!==void 0?C.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(C.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:C.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=M.textEdit.newText):typeof M.insertText=="string"?ae.h=M.insertText:M.insertText instanceof T.$aK&&(ae.h=M.insertText.value,ae.i|=4);let Oe;return M.textEdit?Oe=M.textEdit.range:M.range&&(Oe=M.range),T.$4J.isRange(Oe)?ae.j=C.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!Q?.isEqual(Oe.replacing))&&(ae.j={insert:C.Range.from(Oe.inserting),replace:C.Range.from(Oe.replacing)}),ae}}class ce{async provideInlineCompletions(M,K,G,Q){}disposeCompletions(M){}handleDidShowCompletionItem(M,K,G){}handlePartialAccept(M,K,G){}}class $e extends ce{constructor(M,K,G,Q){super(),this.f=M,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,r.$PF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$PF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,K,G,Q){const J=this.g.getDocument(M),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Oe=Array.isArray(ae)?ae:ae.items,je=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Oe}),items:Oe.map((Xe,_e)=>{let it;Xe.command&&(He||(He=new d.$jc),it=this.j.toInternal(Xe.command,He));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?C.Range.from(Xe.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:je.map(Xe=>(He||(He=new d.$jc),this.j.toInternal(Xe,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,K,G){const Q=this.d.get(M)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(M,K,G){const Q=this.d.get(M)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const K=this.e++;return this.d.set(K,M),K}disposeReferenceId(M){const K=this.d.get(M);return this.d.delete(M),K}get(M){return this.d.get(M)}}class z{constructor(M,K){this.e=M,this.f=K,this.d=new o.$Zac("SignatureHelp")}async provideSignatureHelp(M,K,G,Q){const J=this.e.getDocument(M),x=C.Position.to(K),ae=this.g(G),Oe=await this.f.provideSignatureHelp(J,x,Q,ae);if(Oe){const je=this.d.add([Oe]);return{...C.SignatureHelp.from(Oe),id:je}}}g(M){let K;if(M.activeSignatureHelp){const G=C.SignatureHelp.to(M.activeSignatureHelp),Q=this.d.get(M.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...M,activeSignatureHelp:K}}releaseSignatureHelp(M){this.d.delete(M)}}class q{constructor(M,K,G,Q,J){this.f=M,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new o.$Zac("InlayHints"),this.e=new Map}async provideInlayHints(M,K,G){const Q=this.f.getDocument(M),J=C.Range.to(K),x=await this.h.provideInlayHints(Q,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new d.$jc);const Oe={hints:[],cacheId:ae};for(let je=0;je<x.length;je++)this.l(x[je],J)&&Oe.hints.push(this.m(x[je],[ae,je]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Oe}async resolveInlayHint(M,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(K&&!K.contains(M.position))}m(M,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(M.tooltip),position:C.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(C.TextEdit.from),kind:M.kind&&C.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?Q.label=M.label:Q.label=M.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),T.$bK.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),Q}}class le{constructor(M,K){this.e=M,this.f=K,this.d=new o.$Zac("DocumentLink")}async provideLinks(M,K){const G=this.e.getDocument(M),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(le.g).map(C.DocumentLink.from)};{const J=this.d.add(Q),x={links:[],cacheId:J};for(let ae=0;ae<Q.length;ae++){if(!le.g(Q[ae]))continue;const Oe=C.DocumentLink.from(Q[ae]);Oe.cacheId=[J,ae],x.links.push(Oe)}return x}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!le.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(M){this.d.delete(M)}}class we{constructor(M,K){this.d=M,this.e=K}async provideColors(M,K){const G=this.d.getDocument(M),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(M,K,G){const Q=this.d.getDocument(M),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:Q,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(M,K){this.d=M,this.e=K}async provideFoldingRanges(M,K,G){const Q=this.d.getDocument(M),J=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class ge{constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideSelectionRanges(M,K,G){const Q=this.d.getDocument(M),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,J,G);if(!(0,P.$Jb)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Oe=0;Oe<J.length;Oe++){const je=[];ae.push(je);let Qe=J[Oe],He=x[Oe];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ae}}class De{constructor(M,K){this.f=M,this.g=K,this.d=new i.$7L(""),this.e=new Map}async prepareSession(M,K,G){const Q=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Oe=>this.h(ae,Oe)):[this.h(ae,x)]}async provideCallsTo(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(J)return J.map(x=>({from:this.h(M,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(J)return J.map(x=>({to:this.h(M,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),Q=C.CallHierarchyItem.from(K,M,G.size.toString(36));return G.set(Q._itemId,K),Q}j(M,K){return this.e.get(M)?.get(K)}}class ne{constructor(M,K){this.f=M,this.g=K,this.d=new i.$7L(""),this.e=new Map}async prepareSession(M,K,G){const Q=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Oe=>this.h(ae,Oe)):[this.h(ae,x)]}async provideSupertypes(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Q,G);if(J)return J.map(x=>this.h(M,x))}async provideSubtypes(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Q,G);if(J)return J.map(x=>this.h(M,x))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),Q=C.TypeHierarchyItem.from(K,M,G.size.toString(36));return G.set(Q._itemId,K),Q}j(M,K){return this.e.get(M)?.get(K)}}class he{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,Q,J){this.d=M,this.e=K,this.f=G,this.g=Q,this.h=J}async provideDocumentOnDropEdits(M,K,G,Q,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Oe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,ae,Oe,J);if(je)return{label:je.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class se{constructor(M,K){this.d=M,this.e=K}async provideMappedEdits(M,K,G,Q){const J=v.URI.revive(M),x=this.d.getDocument(J),ae={selections:G.selections.map(je=>C.Selection.to(je)),related:G.related.map(je=>({uri:v.URI.revive(je.uri),range:C.Range.to(je.range)}))},Oe=await this.e.provideMappedEdits(x,K,ae,Q);return Oe?C.WorkspaceEdit.from(Oe):null}}class oe{constructor(M,K){this.adapter=M,this.extension=K}}class fe{static{this.d=0}constructor(M,K,G,Q,J,x,ae,Oe){this.g=K,this.h=G,this.j=Q,this.k=J,this.l=x,this.m=ae,this.n=Oe,this.f=new Map,this.e=M.getProxy(l.$ZJ.MainThreadLanguageFeatures)}o(M,K){return C.DocumentSelector.from(M,this.g,K)}p(M){return new T.$2J(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return fe.d++}async t(M,K,G,Q,J,x=!1){const ae=this.f.get(M);if(!ae||!(ae.adapter instanceof K))return Q;const Oe=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(ae.adapter,ae.extension);return Promise.resolve(je).catch(Qe=>{(0,y.$2)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),b.CancellationToken.isCancellationToken(J)?(0,m.$wg)(je,J):je}u(M,K){const G=this.q();return this.f.set(G,new oe(M,K)),G}static w(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,K,G,Q){const J=this.u(new n(this.h,G),M),x=Q&&Q.label||fe.w(M);return this.e.$registerDocumentSymbolProvider(J,this.o(K,M),x),this.p(J)}$provideDocumentSymbols(M,K,G){return this.t(M,n,Q=>Q.provideDocumentSymbols(v.URI.revive(K),G),void 0,G)}registerCodeLensProvider(M,K,G){const Q=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new c(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(Q,this.o(K,M),J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(J));x=T.$2J.from(x,ae)}return x}$provideCodeLenses(M,K,G){return this.t(M,c,Q=>Q.provideCodeLenses(v.URI.revive(K),G),void 0,G)}$resolveCodeLens(M,K,G){return this.t(M,c,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(M,K){this.t(M,c,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(M,K,G){const Q=this.u(new p(this.h,G),M);return this.e.$registerDefinitionSupport(Q,this.o(K,M)),this.p(Q)}$provideDefinition(M,K,G,Q){return this.t(M,p,J=>J.provideDefinition(v.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(M,K,G){const Q=this.u(new I(this.h,G),M);return this.e.$registerDeclarationSupport(Q,this.o(K,M)),this.p(Q)}$provideDeclaration(M,K,G,Q){return this.t(M,I,J=>J.provideDeclaration(v.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(M,K,G){const Q=this.u(new k(this.h,G),M);return this.e.$registerImplementationSupport(Q,this.o(K,M)),this.p(Q)}$provideImplementation(M,K,G,Q){return this.t(M,k,J=>J.provideImplementation(v.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(M,K,G){const Q=this.u(new s(this.h,G),M);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,M)),this.p(Q)}$provideTypeDefinition(M,K,G,Q){return this.t(M,s,J=>J.provideTypeDefinition(v.URI.revive(K),G,Q),[],Q)}registerHoverProvider(M,K,G,Q){const J=this.u(new f(this.h,G),M);return this.e.$registerHoverProvider(J,this.o(K,M)),this.p(J)}$provideHover(M,K,G,Q){return this.t(M,f,J=>J.provideHover(v.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(M,K,G,Q){const J=this.u(new w(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,M)),this.p(J)}$provideEvaluatableExpression(M,K,G,Q){return this.t(M,w,J=>J.provideEvaluatableExpression(v.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(M,K,G,Q){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.u(new R(this.h,G),M);this.e.$registerInlineValuesProvider(x,this.o(K,M),J);let ae=this.p(x);if(J!==void 0){const Oe=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(J));ae=T.$2J.from(ae,Oe)}return ae}$provideInlineValues(M,K,G,Q,J){return this.t(M,R,x=>x.provideInlineValues(v.URI.revive(K),G,Q,J),void 0,J)}registerDocumentHighlightProvider(M,K,G){const Q=this.u(new W(this.h,G),M);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,M)),this.p(Q)}$provideDocumentHighlights(M,K,G,Q){return this.t(M,W,J=>J.provideDocumentHighlights(v.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(M,K,G){const Q=this.u(new V(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,M)),this.p(Q)}$provideLinkedEditingRanges(M,K,G,Q){return this.t(M,V,async J=>{const x=await J.provideLinkedEditingRanges(v.URI.revive(K),G,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.y(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(M,K,G){const Q=this.u(new U(this.h,G),M);return this.e.$registerReferenceSupport(Q,this.o(K,M)),this.p(Q)}$provideReferences(M,K,G,Q,J){return this.t(M,U,x=>x.provideReferences(v.URI.revive(K),G,Q,J),void 0,J)}registerCodeActionProvider(M,K,G,Q){const J=new d.$jc,x=this.u(new B(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(x,this.o(K,M),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},fe.w(M),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(M,K,G,Q,J){return this.t(M,B,x=>x.provideCodeActions(v.URI.revive(K),G,Q,J),void 0,J)}$resolveCodeAction(M,K,G){return this.t(M,B,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(M,K){this.t(M,B,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(M,K,G){const Q=this.u(new N(this.h,G),M);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,M),M.identifier,M.displayName||M.name),this.p(Q)}$provideDocumentFormattingEdits(M,K,G,Q){return this.t(M,N,J=>J.provideDocumentFormattingEdits(v.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(M,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.u(new ee(this.h,G),M);return this.e.$registerRangeFormattingSupport(J,this.o(K,M),M.identifier,M.displayName||M.name,Q),this.p(J)}$provideDocumentRangeFormattingEdits(M,K,G,Q,J){return this.t(M,ee,x=>x.provideDocumentRangeFormattingEdits(v.URI.revive(K),G,Q,J),void 0,J)}$provideDocumentRangesFormattingEdits(M,K,G,Q,J){return this.t(M,ee,x=>x.provideDocumentRangesFormattingEdits(v.URI.revive(K),G,Q,J),void 0,J)}registerOnTypeFormattingEditProvider(M,K,G,Q){const J=this.u(new Y(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,M),Q,M.identifier),this.p(J)}$provideOnTypeFormattingEdits(M,K,G,Q,J,x){return this.t(M,Y,ae=>ae.provideOnTypeFormattingEdits(v.URI.revive(K),G,Q,J,x),void 0,x)}registerWorkspaceSymbolProvider(M,K){const G=this.u(new Ee(K,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,K,G){return this.t(M,Ee,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,K,G){return this.t(M,Ee,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(M,K){this.t(M,Ee,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(M,K,G){const Q=this.u(new ke(this.h,G,this.l),M);return this.e.$registerRenameSupport(Q,this.o(K,M),ke.supportsResolving(G)),this.p(Q)}$provideRenameEdits(M,K,G,Q,J){return this.t(M,ke,x=>x.provideRenameEdits(v.URI.revive(K),G,Q,J),void 0,J)}$resolveRenameLocation(M,K,G,Q){return this.t(M,ke,J=>J.resolveRenameLocation(v.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(M,K,G,Q){const J=this.u(new X(this.h,G),M),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,M),Q,x);let ae=this.p(J);if(x){const Oe=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ae=T.$2J.from(ae,Oe)}return ae}$provideDocumentSemanticTokens(M,K,G,Q){return this.t(M,X,J=>J.provideDocumentSemanticTokens(v.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(M,K){this.t(M,X,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,K,G,Q){const J=this.u(new ue(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,M),Q),this.p(J)}$provideDocumentRangeSemanticTokens(M,K,G,Q){return this.t(M,ue,J=>J.provideDocumentRangeSemanticTokens(v.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(M,K,G,Q){const J=this.u(new ye(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(J,this.o(K,M),Q,ye.supportsResolving(G),M.identifier),this.p(J)}$provideCompletionItems(M,K,G,Q,J){return this.t(M,ye,x=>x.provideCompletionItems(v.URI.revive(K),G,Q,J),void 0,J)}$resolveCompletionItem(M,K,G){return this.t(M,ye,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(M,K){this.t(M,ye,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(M,K,G,Q){const J=new $e(M,this.h,G,this.j.converter),x=this.u(J,M);return this.e.$registerInlineCompletionsSupport(x,this.o(K,M),J.supportsHandleEvents,$.$Vl.toKey(M.identifier.value),Q?.yieldTo?.map(ae=>$.$Vl.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(M,K,G,Q,J){return this.t(M,ce,x=>x.provideInlineCompletions(v.URI.revive(K),G,Q,J),void 0,J)}$handleInlineCompletionDidShow(M,K,G,Q){this.t(M,ce,async J=>{J.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,K,G,Q){this.t(M,ce,async J=>{J.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(M,K){this.t(M,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(M,K,G,Q){const J=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.u(new z(this.h,G),M);return this.e.$registerSignatureHelpProvider(x,this.o(K,M),J),this.p(x)}$provideSignatureHelp(M,K,G,Q,J){return this.t(M,z,x=>x.provideSignatureHelp(v.URI.revive(K),G,Q,J),void 0,J)}$releaseSignatureHelp(M,K){this.t(M,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(M,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.u(new q(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(J,this.o(K,M),typeof G.resolveInlayHint=="function",Q,fe.w(M));let x=this.p(J);if(Q!==void 0){const ae=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(Q));x=T.$2J.from(x,ae)}return x}$provideInlayHints(M,K,G,Q){return this.t(M,q,J=>J.provideInlayHints(v.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(M,K,G){return this.t(M,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(M,K){this.t(M,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(M,K,G){const Q=this.u(new le(this.h,G),M);return this.e.$registerDocumentLinkProvider(Q,this.o(K,M),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(M,K,G){return this.t(M,le,Q=>Q.provideLinks(v.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(M,K,G){return this.t(M,le,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(M,K){this.t(M,le,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(M,K,G){const Q=this.u(new we(this.h,G),M);return this.e.$registerDocumentColorProvider(Q,this.o(K,M)),this.p(Q)}$provideDocumentColors(M,K,G){return this.t(M,we,Q=>Q.provideColors(v.URI.revive(K),G),[],G)}$provideColorPresentations(M,K,G,Q){return this.t(M,we,J=>J.provideColorPresentations(v.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(M,K,G){const Q=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,G),M)),this.e.$registerFoldingRangeProvider(Q,this.o(K,M),M.identifier,J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=T.$2J.from(x,ae)}return x}$provideFoldingRanges(M,K,G,Q){return this.t(M,ve,J=>J.provideFoldingRanges(v.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(M,K,G){const Q=this.u(new ge(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(Q,this.o(K,M)),this.p(Q)}$provideSelectionRanges(M,K,G,Q){return this.t(M,ge,J=>J.provideSelectionRanges(v.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(M,K,G){const Q=this.u(new De(this.h,G),M);return this.e.$registerCallHierarchyProvider(Q,this.o(K,M)),this.p(Q)}$prepareCallHierarchy(M,K,G,Q){return this.t(M,De,J=>Promise.resolve(J.prepareSession(v.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(M,K,G,Q){return this.t(M,De,J=>J.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(M,K,G,Q){return this.t(M,De,J=>J.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(M,K){this.t(M,De,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(M,K,G){const Q=this.u(new ne(this.h,G),M);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,M)),this.p(Q)}$prepareTypeHierarchy(M,K,G,Q){return this.t(M,ne,J=>Promise.resolve(J.prepareSession(v.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(M,K,G,Q){return this.t(M,ne,J=>J.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(M,K,G,Q){return this.t(M,ne,J=>J.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(M,K){this.t(M,ne,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(M,K,G,Q){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,M),M));const x=(0,r.$PF)(M,"dropMetadata")&&Q?he.toInternalProviderId(M.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,M),x,(0,r.$PF)(M,"dropMetadata")?Q:void 0),this.p(J)}$provideDocumentOnDropEdits(M,K,G,Q,J,x){return this.t(M,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,v.URI.revive(G),Q,J,x)),void 0,void 0)}registerMappedEditsProvider(M,K,G){const Q=this.u(new se(this.h,G),M);return this.e.$registerMappedEditsProvider(Q,this.o(K,M)),this.p(Q)}$provideMappedEdits(M,K,G,Q,J){return this.t(M,se,x=>Promise.resolve(x.provideMappedEdits(K,G,Q,J)),null,J)}registerDocumentPasteEditProvider(M,K,G,Q){const J=this.q();this.f.set(J,new oe(new O(this.e,this.h,G,J,M),M));const x=O.toInternalProviderId(M.identifier.value,Q.id);return this.e.$registerPasteEditProvider(J,this.o(K,M),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(M,K,G,Q,J){return this.t(M,O,x=>x.prepareDocumentPaste(v.URI.revive(K),G,Q,J),void 0,J)}$providePasteEdits(M,K,G,Q,J,x){return this.t(M,O,ae=>ae.providePasteEdits(K,v.URI.revive(G),Q,J,x),void 0,x)}static y(M){return{pattern:M.source,flags:M.flags}}static z(M){return{decreaseIndentPattern:fe.y(M.decreaseIndentPattern),increaseIndentPattern:fe.y(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?fe.y(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?fe.y(M.unIndentedLinePattern):void 0}}static B(M){return{beforeText:fe.y(M.beforeText),afterText:M.afterText?fe.y(M.afterText):void 0,previousLineText:M.previousLineText?fe.y(M.previousLineText):void 0,action:M.action}}static C(M){return M.map(fe.B)}setLanguageConfiguration(M,K,G){const{wordPattern:Q}=G;if(Q&&(0,S.$ze)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use."),G.autoClosingPairs&&(0,r.$QF)(M,"languageConfigurationAutoClosingPairs");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(M){for(const K of M)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$9ac=fe}),define(Ae[241],Re([1,0,3,8,7,29,12,6]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;class S{constructor(P,D,u,b){this.c=D,this.d=u,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(v.$ZJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,D){await this.a.$changeLanguage(P,D);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,D){const u=P.version,b=F.Position.from(D),$=await this.a.$tokensAtPosition(P.uri,b),d={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new C.$4J(D.line,D.character,D.line,D.character)};if(!$)return d;const t={range:F.Range.to($.range),type:F.TokenType.to($.type)};return!t.range.contains(D)||u!==P.version?d:t}createLanguageStatusItem(P,D,u){const b=this.f++,$=this.a,d=this.g,t=`${P.identifier.value}/${D}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(t);const i={selector:u,id:D,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const h=new l.$jc,y=()=>{if(o?.dispose(),!d.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.$Ig)(()=>{h.clear(),this.a.$setLanguageStatus(b,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?T.default.Error:i.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:i.command&&this.d.toInternal(i.command,h),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},m={dispose(){h.dispose(),o?.dispose(),$.$removeLanguageStatus(b),d.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,y()},get selector(){return i.selector},set selector(r){i.selector=r,y()},get text(){return i.text},set text(r){i.text=r,y()},get detail(){return i.detail},set detail(r){i.detail=r,y()},get severity(){return i.severity},set severity(r){i.severity=r,y()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,y()},get command(){return i.command},set command(r){i.command=r,y()},get busy(){return i.busy},set busy(r){i.busy=r,y()}};return y(),m}}e.$Qbc=S}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=void 0;let P=class{constructor(u,b,$){this.f=$,this.d=new Map,this.a=b.getProxy(l.$ZJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$f}getMessage(u,b){const{message:$,args:d,comment:t}=b;if(this.c)return(0,F.$oe)($,d??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const o=this.d.get(u)?.contents[i];return o||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,F.$oe)(o??$,d??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const $=await this.g(u);if(!$){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents($),t=JSON.parse(d);b=u.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${u.identifier.value} from ${$}: ${d.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:$})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(b)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Fbc=P,e.$Fbc=P=Ke([qe(0,S.$fM),qe(1,g.$2L),qe(2,A.$5i)],P),e.$Gbc=(0,T.$Bh)("IExtHostLocalizationService")}),define(Ae[242],Re([1,0,14,3,27,17,2,69]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;let S=class extends v.$dj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,l.$$g)(b))),this.r=D.getProxy(F.$ZJ.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,b){return new g(this.r,D,u,b)}};e.$8cc=S,e.$8cc=S=Ke([qe(0,T.$2L),qe(1,C.$fM)],S);class g extends v.$$i{constructor(D,u,b,$){super($?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,$).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const b=[[D,u]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0,e.$Hbc=(0,F.$Bh)("IExtHostManagedSockets");let l=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(v.$ZJ.MainThreadManagedSockets)}setFactory(D,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,b=await this.c.makeConnection(),$=new C.$jc;return this.d.set(u,new g(u,b,$)),$.add((0,C.$ic)(()=>this.d.delete(u))),$.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),$.dispose()})),$.add(b.onDidClose(d=>{this.a.$onDidManagedSocketClose(u,d?.stack??d?.message),$.dispose()})),$.add(b.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(u,A.$Fd.wrap(d)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Ibc=l,e.$Ibc=l=Ke([qe(0,T.$2L)],l);class S{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class g extends C.$kc{constructor(D,u,b){super(),this.socketId=D,this.actual=u,this.B(b)}}}),define(Ae[243],Re([1,0,3,14,26]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;function T(l){return l&&l.title}let A=class{constructor(S,g){this.b=g,this.a=S.getProxy(v.$ZJ.MainThreadMessageService)}showMessage(S,g,P,D,u){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let $;typeof D=="string"||T(D)?$=[D,...u]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,$=u),b.useCustom&&(0,C.$QF)(S,"resolvers");const d=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")d.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:o,isCloseAffordance:h}=i;d.push({title:o,isCloseAffordance:!!h,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,P,b,d).then(t=>{if(typeof t=="number")return $[t]})}};e.$Rbc=A,e.$Rbc=A=Ke([qe(1,F.$5i)],A)}),define(Ae[244],Re([1,0,152,25,5,6,28,15,16,2,38,55,3,31,8,7,46,205,104,9,24,13]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,c,E,p,I){this.q=E,this.r=p,this.s=I,this.f=new Map,this.g=new A.$zi,this.h=new Map,this.j=new C.$fd({onListenerError:h.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$fd({onListenerError:h.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$fd({onListenerError:h.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$fd({onListenerError:h.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Zac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(u.$ZJ.MainThreadNotebook),this.c=n.getProxy(u.$ZJ.MainThreadNotebookDocuments),this.d=n.getProxy(u.$ZJ.MainThreadNotebookEditors),this.i=c.converter,c.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const s=k.notebookEditor?.notebookUri,f=k.cell.handle,R=this.g.get(s)?.getCell(f);if(R)return R.apiCell}if(k&&k.$mid===14){const s=k.uri,f=this.g.get(s);if(f)return f.apiNotebook}return k}}),r.A(c)}getEditorById(n){const c=this.h.get(n);if(!c)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return c}getIdByEditor(n){for(const[c,E]of this.h)if(E.apiEditor===n)return c}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,c){const E=this.g.get(n);if(!E&&!c)throw new Error(`NO notebook document for '${n}'`);return E}static t(n,c){if(!c)return;const E=c.filenamePattern.map(p=>$.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(c.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:c.displayName,filenamePattern:E,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,c,E){const p=r.a++,I=typeof E.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(p,E),this.b.$registerNotebookCellStatusBarItemProvider(p,I,c);let k;return I!==void 0&&(k=E.onDidChangeCellStatusBarItems(s=>this.b.$emitCellStatusBarEvent(I))),new d.$2J(()=>{this.f.delete(p),this.b.$unregisterNotebookCellStatusBarItemProvider(p,I),k?.dispose()})}async createNotebookDocument(n){const c=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&$.NotebookData.from(n.content)});return g.URI.revive(c)}async openNotebookDocument(n){const c=this.g.get(n);if(c)return c.apiNotebook;const E=await this.c.$tryOpenNotebook(n),p=this.g.get(g.URI.revive(E));return(0,S.$uf)(p?.apiNotebook)}async showNotebookDocument(n,c){g.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let E;typeof c=="object"?E={position:$.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map($.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:E={preserveFocus:!1};const p=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,E),I=p&&this.h.get(p)?.apiEditor;if(I)return I;throw p?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,c,E,p){const I=this.f.get(n),k=g.URI.revive(c),s=this.g.get(k);if(!s||!I)return;const f=s.getCellFromIndex(E);if(!f)return;const w=await I.provideCellStatusBarItems(f.apiCell,p);if(!w)return;const R=new T.$jc,W=this.p.add([R]),U=(Array.isArray(w)?w:[w]).map(B=>$.NotebookStatusBarItem.from(B,this.i,R));return{cacheId:W,items:U}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,c,E,p,I){if((0,l.$me)(c))throw new Error("viewType cannot be empty or just whitespace");const k=this.u++;return this.w.set(k,{viewType:c,serializer:E,options:p}),this.b.$registerNotebookSerializer(k,{id:n.identifier,location:n.extensionLocation},c,$.NotebookDocumentContentOptions.from(p),r.t(n,I)),(0,T.$ic)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(n,c,E){const p=this.w.get(n);if(!p)throw new Error("NO serializer found");const I=await p.serializer.deserializeNotebook(c.buffer,E);return new t.$dA($.NotebookData.from(I))}async $notebookToData(n,c,E){const p=this.w.get(n);if(!p)throw new Error("NO serializer found");const I=await p.serializer.serializeNotebook($.NotebookData.to(c.value),E);return F.$Fd.wrap(I)}async $saveNotebook(n,c,E,p,I){const k=g.URI.revive(c),s=this.w.get(n);if(!s)throw new Error("NO serializer found");const f=this.g.get(k);if(!f)throw new Error("Document NOT found");if(f.versionId!==E)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new P.$nk((0,v.localize)(0,null,this.y(k)),6);await this.x(k,p);const w={metadata:(0,y.$4m)(f.apiNotebook.metadata,B=>!(s.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of f.apiNotebook.getCells()){const O=new d.$oL(B.kind,B.document.getText(),B.document.languageId,B.mime,s.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,y.$4m)(B.metadata,N=>!(s.options?.transientCellMetadata??{})[N]),w.cells.push(O)}const R=await s.serializer.serializeNotebook(w,I);await this.s.value.writeFile(k,R);const W=this.s.getFileSystemProviderExtUri(k.scheme),V=await this.s.value.stat(k);return{name:W.basename(k),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$yk({mtime:V.mtime,size:V.size}),children:void 0}}async x(n,c){const E=await this.s.value.stat(n);if(typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==P.$xk&&typeof E.mtime=="number"&&typeof E.size=="number"&&c.mtime<E.mtime&&c.etag!==P.$yk({mtime:c.mtime,size:E.size}))throw new P.$nk((0,v.localize)(1,null),3,c)}y(n){return n.scheme===m.Schemas.file?n.fsPath:n.toString()}z(n,c,E){if(this.h.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const p=new o.$ycc(c,this.d,n,E.visibleRanges.map($.NotebookRange.to),E.selections.map($.NotebookRange.to),typeof E.viewColumn=="number"?$.ViewColumn.to(E.viewColumn):void 0);this.h.set(c,p)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const E of n.value.removedDocuments){const p=g.URI.revive(E),I=this.g.get(p);I&&(I.dispose(),this.g.delete(p),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(I.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===p.toString()&&this.h.delete(k.id)}if(n.value.addedDocuments){const E=[];for(const p of n.value.addedDocuments){const I=g.URI.revive(p.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const k=new i.$xcc(this.c,this.q,this.r,I,p);E.push(...p.cells.map(s=>i.$wcc.asModelAddData(k.apiNotebook,s))),this.g.get(I)?.dispose(),this.g.set(I,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this.m.fire(k.apiNotebook)}}if(n.value.addedEditors)for(const E of n.value.addedEditors){if(this.h.has(E.id))return;const p=g.URI.revive(E.documentUri),I=this.g.get(p);I&&this.z(I,E.id,E)}const c=[];if(n.value.removedEditors)for(const E of n.value.removedEditors){const p=this.h.get(E);p&&(this.h.delete(E),this.k?.id===p.id&&(this.k=void 0),c.push(p))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(p=>this.h.get(p)).filter(p=>!!p);const E=new Set;this.l.forEach(p=>E.add(p.id));for(const p of this.h.values()){const I=E.has(p.id);p._acceptVisibility(I)}this.l=[...this.h.values()].map(p=>p).filter(p=>p.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const c=b.$nM.String.with("notebookType","A notebook type"),E=new b.$pM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new b.$nM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>F.$Fd.wrap(I))],new b.$oM("Notebook Data",I=>$.NotebookData.to(I.value))),p=new b.$pM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new b.$nM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$dA($.NotebookData.from(I)))],new b.$oM("Bytes",I=>I.buffer));n.registerApiCommand(E),n.registerApiCommand(p)}}e.$zcc=r}),define(Ae[245],Re([1,0,18,12,21,5,6,28,2,20,14,55,3,31,8,7,77,198,26,46]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;let y=class{constructor(I,k,s,f,w){this.m=k,this.n=s,this.o=f,this.q=w,this.b=new l.$zi,this.c=new l.$zi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$Zac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new T.$fd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=I.getProxy(u.$ZJ.MainThreadNotebookKernels);const R=new b.$pM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$nM("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],b.$oM.Void);this.o.registerApiCommand(R)}createNotebookController(I,k,s,f,w,R){for(const ye of this.j.values())if(ye.controller.id===k&&g.$Vl.equals(I.identifier,ye.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const W=this.k++,V=this;this.q.trace(`NotebookController[${W}], CREATED by ${I.identifier.value}, ${k}`);const U=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${I.identifier}'`);let B=!1;const O=new T.$fd,N=new T.$fd,ee={id:E(I.identifier,k),notebookType:s,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:f||I.identifier.value,preloads:R?R.map($.NotebookRendererScript.from):[]};let Y=w??U,Ee;this.a.$addKernel(W,ee).catch(ye=>{console.log(ye),B=!0});let ke=0;const Pe=()=>{if(B)return;const ye=++ke;Promise.resolve().then(()=>{ye===ke&&this.a.$updateKernel(W,ee)})},X=new l.$zi,ue={get id(){return k},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(ye){ee.label=ye??I.displayName??I.name,Pe()},get detail(){return ee.detail??""},set detail(ye){ee.detail=ye,Pe()},get description(){return ee.description??""},set description(ye){ee.description=ye,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(ye){ee.supportedLanguages=ye,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(ye){ee.supportsExecutionOrder=ye,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(ye){Y=ye??U},get interruptHandler(){return Ee},set interruptHandler(ye){Ee=ye,ee.supportsInterrupt=!!ye,Pe()},createNotebookCellExecution(ye){if(B)throw new Error("notebook controller is DISPOSED");if(!X.has(ye.notebook.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.notebook.uri.toString()}`);return V._createNotebookCellExecution(ye,E(I.identifier,this.id))},createNotebookExecution(ye){if((0,o.$QF)(I,"notebookExecution"),B)throw new Error("notebook controller is DISPOSED");if(!X.has(ye.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.uri.toString()}`);return V._createNotebookExecution(ye,E(I.identifier,this.id))},dispose:()=>{B||(this.q.trace(`NotebookController[${W}], DISPOSED`),B=!0,this.j.delete(W),O.dispose(),N.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(ye,ce){ce===d.NotebookControllerAffinity2.Hidden&&(0,o.$QF)(I,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(W,ye.uri,ce)},onDidReceiveMessage:N.event,postMessage(ye,ce){return(0,o.$QF)(I,"notebookMessaging"),V.a.$postMessage(W,ce&&V.n.getIdByEditor(ce),ye)},asWebviewUri(ye){return(0,o.$QF)(I,"notebookMessaging"),(0,t.$Yob)(ye,V.m.remote)}};return this.j.set(W,{extensionId:I.identifier,controller:ue,onDidReceiveMessage:N,onDidChangeSelection:O,associatedNotebooks:X}),ue}getIdByController(I){for(const[k,s]of this.j)if(s.controller===I)return E(s.extensionId,I.id);return null}createNotebookControllerDetectionTask(I,k){const s=this.f++,f=this;this.q.trace(`NotebookControllerDetectionTask[${s}], CREATED by ${I.identifier.value}`),this.a.$addKernelDetectionTask(s,k);const w={dispose:()=>{this.e.delete(s),f.a.$removeKernelDetectionTask(s)}};return this.e.set(s,w),w}registerKernelSourceActionProvider(I,k,s){const f=this.h++,w=typeof s.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,R=this;this.g.set(f,s),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${I.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,k);let W;return w!==void 0&&(W=s.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(f),R.a.$removeKernelSourceActionProvider(f,f),W?.dispose()}}}async $provideKernelSourceActions(I,k){const s=this.g.get(I);if(s){const f=new A.$jc;return this.i.add([f]),(await s.provideNotebookKernelSourceActions(k)??[]).map(R=>$.NotebookKernelSourceAction.from(R,this.o.converter,f))}return[]}$acceptNotebookAssociation(I,k,s){const f=this.j.get(I);if(f){const w=this.n.getNotebookDocument(S.URI.revive(k));s?f.associatedNotebooks.set(w.uri,!0):f.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${I}] ASSOCIATE notebook`,w.uri.toString(),s),f.onDidChangeSelection.fire({selected:s,notebook:w.apiNotebook})}}async $executeCells(I,k,s){const f=this.j.get(I);if(!f)return;const w=this.n.getNotebookDocument(S.URI.revive(k)),R=[];for(const W of s){const V=w.getCell(W);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${I}] EXECUTE cells`,w.uri.toString(),R.length),await f.controller.executeHandler.call(f.controller,R,w.apiNotebook,f.controller)}catch(W){this.q.error(`NotebookController[${I}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(I,k,s){const f=this.j.get(I);if(!f)return;const w=this.n.getNotebookDocument(S.URI.revive(k));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,w.apiNotebook);else for(const R of s){const W=w.getCell(R);W&&this.b.get(W.uri)?.cancel()}if(f.controller.interruptHandler){const R=this.c.get(w.uri);s.length&&Array.isArray(R)&&R.length&&R.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(I,k,s){const f=this.j.get(I);if(!f)return;const w=this.n.getEditorById(k);f.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:s}))}$cellExecutionChanged(I,k,s){const w=this.n.getNotebookDocument(S.URI.revive(I)).getCell(k);if(w){const R=s?$.NotebookCellExecutionState.to(s):d.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:w.apiCell,state:R})}}_createNotebookCellExecution(I,k){if(I.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(I.notebook.uri).getCellFromApiCell(I);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const w=new r(k,f,this.a);this.b.set(f.uri,w);const R=w.onDidChangeState(()=>{w.state===m.Resolved&&(w.dispose(),R.dispose(),this.b.delete(f.uri))});return w.asApiObject()}_createNotebookExecution(I,k){const s=this.n.getNotebookDocument(I.uri),f=I.getCells().find(W=>{const V=s.getCellFromApiCell(W);return V&&this.b.has(V.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(s.uri))throw new Error(`duplicate notebook execution for ${s.uri}`);const w=new n(k,s,this.a),R=w.onDidChangeState(()=>{w.state===a.Resolved&&(w.dispose(),R.dispose(),this.c.delete(s.uri))});return this.c.set(s.uri,[w,R]),w.asApiObject()}};e.$Ncc=y,e.$Ncc=y=Ke([qe(4,P.$5i)],y);var m;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(m||(m={}));class r extends A.$kc{static{this.a=0}get state(){return this.f}constructor(I,k,s){super(),this.m=k,this.n=s,this.b=r.a++,this.c=new T.$fd,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new C.$pd),this.h=new c(10,f=>this.s(f)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,I,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(I){await this.h.addItem(I)}async s(I){const k=Array.isArray(I)?I:[I];return this.n.$updateExecution(this.b,new h.$dA(k))}t(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(I){let k=this.m;if(I&&(k=this.m.notebook.getCellFromApiCell(I)),!k)throw new Error("INVALID cell");return k.handle}y(I){return I.map(k=>{const s=d.$rL.ensureUniqueMimeTypes(k.items,!0);return s===k.items?$.NotebookCellOutput.from(k):$.NotebookCellOutput.from({items:s,id:k.id,metadata:k.metadata})})}async z(I,k,s){const f=this.w(k),w=this.y((0,v.$1b)(I));return this.r({editType:i.CellExecutionUpdateType.Output,cellHandle:f,append:s,outputs:w})}async C(I,k,s){return I=d.$rL.ensureUniqueMimeTypes((0,v.$1b)(I),!0),this.r({editType:i.CellExecutionUpdateType.OutputItems,items:I.map($.NotebookCellOutputItem.from),outputId:k.id,append:s})}asApiObject(){const I=this;return Object.freeze({get token(){return I.g.token},get cell(){return I.m.apiCell},get executionOrder(){return I.j},set executionOrder(s){I.j=s,I.s([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:I.j}])},start(s){if(I.f===m.Resolved||I.f===m.Started)throw new Error("Cannot call start again");I.f=m.Started,I.c.fire(),I.s({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:s})},end(s,f){if(I.f===m.Resolved)throw new Error("Cannot call resolve twice");I.f=m.Resolved,I.c.fire(),I.h.flush(),I.n.$completeExecution(I.b,new h.$dA({runEndTime:f,lastRunSuccess:s}))},clearOutput(s){return I.t(),I.z([],s,!1)},appendOutput(s,f){return I.t(),I.z(s,f,!0)},replaceOutput(s,f){return I.t(),I.z(s,f,!1)},appendOutputItems(s,f){return I.t(),I.C(s,f,!0)},replaceOutputItems(s,f){return I.t(),I.C(s,f,!1)}})}}var a;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(a||(a={}));class n extends A.$kc{static{this.a=0}get state(){return this.f}constructor(I,k,s){super(),this.h=k,this.j=s,this.b=n.a++,this.c=new T.$fd,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new C.$pd),this.j.$createNotebookExecution(this.b,I,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(I,k){this.e=I,this.f=k,this.a=[],this.b=Date.now()}addItem(I){return this.a.push(I),this.c||(this.c=new F.$2g,this.b=Date.now(),(0,F.$Hg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const I=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>I.complete())}}function E(p,I){return`${p.value}/${I}`}e.$Occ=E}),define(Ae[246],Re([1,0,5,3,104]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class T{constructor(l,S){this.c=S,this.a=new Map,this.b=l.getProxy(F.$ZJ.MainThreadNotebookRenderers)}$postRendererMessage(l,S,g){const P=this.c.getEditorById(l);this.a.get(S)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(l,S){if(!l.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,D,u)=>this.d(S).event(P,D,u),postMessage:(P,D)=>{C.$ycc.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const u=D&&C.$ycc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,S,P)}}}d(l){let S=this.a.get(l);return S||(S=new v.$fd({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(l)}}),this.a.set(l,S),S)}}e.$Pcc=T}),define(Ae[247],Re([1,0,6,16,2,26,3]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;class l{constructor(g){this.b=new Map,this.a=g.getProxy(A.$ZJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,D){if((0,T.$QF)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,g.identifier.value),(0,v.$ic)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,D,u){const b=this.b.get(g);if(!b)throw new Error(`Unknown handler with id: ${g}`);return b.saveProfile(P,D,u)}async $readProfile(g,P,D){const u=this.b.get(g);if(!u)throw new Error(`Unknown handler with id: ${g}`);return u.readProfile((0,F.$jf)(P)?P:C.URI.revive(P),D)}}e.$Tcc=l}),define(Ae[248],Re([1,0,2,3,12,8]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class A{static{this.a=0}constructor(S,g){this.d=g,this.c=new Map,this.b=S.getProxy(F.$ZJ.MainThreadQuickDiff)}$provideOriginalResource(S,g,P){const D=v.URI.revive(g),u=this.c.get(S);return u?(0,C.$zg)(()=>u.provideOriginalResource(D,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(S,g,P,D){const u=A.a++;return this.c.set(u,g),this.b.$registerQuickDiffProvider(u,T.DocumentSelector.from(S,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ucc=A}),define(Ae[249],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;function $(d,t,i){const o=d.getProxy(T.$ZJ.MainThreadQuickOpen);class h{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,s,f=v.CancellationToken.None){this.c=void 0;const w=Promise.resolve(k),R=++this.f,W=o.$show(R,{title:s?.title,placeHolder:s?.placeHolder,matchOnDescription:s?.matchOnDescription,matchOnDetail:s?.matchOnDetail,ignoreFocusLost:s?.ignoreFocusOut,canPickMany:s?.canPickMany},f),V={},U=W.then(()=>V);return Promise.race([U,w]).then(B=>{if(B===V)return;const O=(0,u.$PF)(I,"quickPickItemTooltip");return w.then(N=>{const ee=[];for(let Y=0;Y<N.length;Y++){const Ee=N[Y];if(typeof Ee=="string")ee.push({label:Ee,handle:Y});else if(Ee.kind===l.QuickPickItemKind.Separator)ee.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=Ee.iconPath?n(Ee.iconPath):void 0;ee.push({label:Ee.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?b.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:Y})}}return s&&typeof s.onDidSelectItem=="function"&&(this.c=Y=>{s.onDidSelectItem(N[Y])}),o.$setItems(R,ee),W.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(Ee=>N[Ee])})})}).then(void 0,B=>{if(!(0,S.$2)(B))return o.$setError(R,B),Promise.reject(B)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=v.CancellationToken.None){return this.d=I?.validateInput,o.$input(I,typeof this.d=="function",k).then(void 0,s=>{if(!(0,S.$2)(s))return Promise.reject(s)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let s;switch(k.severity){case l.InputBoxValidationSeverity.Info:s=P.default.Info;break;case l.InputBoxValidationSeverity.Warning:s=P.default.Warning;break;case l.InputBoxValidationSeverity.Error:s=P.default.Error;break;default:s=k.message?P.default.Error:P.default.Ignore;break}return{content:k.message,severity:s}}async showWorkspaceFolderPick(I,k=v.CancellationToken.None){const s=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!s)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(w=>w.uri.toString()===s.uri.toString())}createQuickPick(I){const k=new c(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new E(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const s=this.e.get(I);s instanceof c&&s._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const s=this.e.get(I);s instanceof c&&s._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,s){const f=this.e.get(I);f instanceof c&&f._fireDidTriggerItemButton(k,s)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class y{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$fd,this.q=new F.$fd,this.r=new F.$fd,this.s=new F.$fd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,s)=>{const f=k===l.$kL.Back?-1:s;this.o.set(f,k)}),this.z({buttons:I.map((k,s)=>({...n(k.iconPath),tooltip:k.tooltip,handle:k===l.$kL.Back?-1:s}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$fc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const s=I[k];this.u[k]=s===void 0?null:s}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}function m(p){if(p instanceof l.$WK)return{id:p.id};const I=a(p),k=r(p);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof k=="string"?A.URI.file(k):k}}function r(p){return typeof p=="object"&&"light"in p?p.light:p}function a(p){return typeof p=="object"&&"dark"in p?p.dark:p}function n(p){const I=m(p);let k,s;return"id"in I?s=D.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:s}}class c extends y{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$fd,this.L=[],this.M=new F.$fd,this.N=new F.$fd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((f,w)=>{this.C.set(w,f),this.D.set(f,w)});const k=(0,u.$PF)(this.O,"quickPickItemTooltip"),s=[];for(let f=0;f<I.length;f++){const w=I[f];if(w.kind===l.QuickPickItemKind.Separator)s.push({type:"separator",label:w.label});else{w.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=w.iconPath?n(w.iconPath):void 0;s.push({handle:f,label:w.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:k?b.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((W,V)=>({...n(W.iconPath),tooltip:W.tooltip,handle:V}))})}}this.z({items:s})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Fb)(I.map(s=>this.C.get(s)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Fb)(I.map(s=>this.C.get(s)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const s=this.C.get(I);if(!s||!s.buttons||!s.buttons.length)return;const f=s.buttons[k];f&&this.N.fire({button:f,item:s})}}class E extends y{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new h(t,i)}e.$Vbc=$}),define(Ae[250],Re([1,0,2,5,65,6,12,3,18,132,14,20,40,8,26,13]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0;function i(k){if(k)return typeof k.iconPath=="string"?v.URI.file(k.iconPath):v.URI.isUri(k.iconPath)||u.ThemeIcon.isThemeIcon(k.iconPath)?k.iconPath:void 0}function o(k,s){if(!k.iconPath&&!s.iconPath)return 0;if(k.iconPath){if(!s.iconPath)return 1}else return-1;const f=typeof k.iconPath=="string"?k.iconPath:v.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id,w=typeof s.iconPath=="string"?s.iconPath:v.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,g.$hq)(f,w)}function h(k,s){let f=0;if(k.strikeThrough!==s.strikeThrough)return k.strikeThrough?1:-1;if(k.faded!==s.faded)return k.faded?1:-1;if(k.tooltip!==s.tooltip)return(k.tooltip||"").localeCompare(s.tooltip||"");if(f=o(k,s),f!==0)return f;if(k.light&&s.light)f=o(k.light,s.light);else{if(k.light)return 1;if(s.light)return-1}if(f!==0)return f;if(k.dark&&s.dark)f=o(k.dark,s.dark);else{if(k.dark)return 1;if(s.dark)return-1}return f}function y(k,s){if(k.command!==s.command)return k.command<s.command?-1:1;if(k.title!==s.title)return k.title<s.title?-1:1;if(k.tooltip!==s.tooltip){if(k.tooltip!==void 0&&s.tooltip!==void 0)return k.tooltip<s.tooltip?-1:1;if(k.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(k.arguments===s.arguments)return 0;if(k.arguments)if(s.arguments){if(k.arguments.length!==s.arguments.length)return k.arguments.length-s.arguments.length}else return 1;else return-1;for(let f=0;f<k.arguments.length;f++){const w=k.arguments[f],R=s.arguments[f];if(w!==R)return w<R?-1:1}return 0}function m(k,s){let f=(0,g.$hq)(k.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(f!==0)return f;if(k.command&&s.command)f=y(k.command,s.command);else{if(k.command)return 1;if(s.command)return-1}if(f!==0)return f;if(k.decorations&&s.decorations)f=h(k.decorations,s.decorations);else{if(k.decorations)return 1;if(s.decorations)return-1}return f}function r(k,s){for(let f=0;f<k.length;f++)if(k[f]!==s[f])return!1;return!0}function a(k,s){return k.command===s.command&&k.title===s.title&&k.tooltip===s.tooltip&&(k.arguments&&s.arguments?r(k.arguments,s.arguments):k.arguments===s.arguments)}function n(k,s){return(0,S.$sb)(k,s,a)}class c{#e;#t;get value(){return this.d}set value(s){s=s??"",this.#e.$setInputBoxValue(this.l,s),this.n(s)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(s){this.#e.$setInputBoxPlaceholder(this.l,s),this.f=s}get validateInput(){return(0,$.$QF)(this.k,"scmValidation"),this.g}set validateInput(s){if((0,$.$QF)(this.k,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=s,this.#e.$setValidationProviderIsEnabled(this.l,!!s)}get enabled(){return this.h}set enabled(s){s=!!s,this.h!==s&&(this.h=s,this.#e.$setInputBoxEnablement(this.l,s))}get visible(){return this.j}set visible(s){s=!!s,this.j!==s&&(this.j=s,this.#e.$setInputBoxVisibility(this.l,s))}get document(){return(0,$.$QF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(s,f,w,R,W){this.k=s,this.l=R,this.m=W,this.d="",this.e=new F.$fd,this.f="",this.h=!0,this.j=!0,this.#t=f,this.#e=w}showValidationMessage(s,f){(0,$.$QF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,s,f)}$onInputBoxValueChange(s){this.n(s)}n(s){this.d=s,this.e.fire(s)}}e.$Wbc=c;class E{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(s){this.v=s,this.q.$updateGroupLabel(this.t,this.handle,s)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(s){this.p=s,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(s){this.f=[...s],this.k.fire()}constructor(s,f,w,R,W){this.q=s,this.s=f,this.t=w,this.u=R,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$fd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$fd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=E.d++}getResourceState(s){return this.g.get(s)}$executeResourceCommand(s,f){const w=this.h.get(s);return w?(0,A.$zg)(()=>this.s.executeCommand(w.command,...w.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this.f].sort(m),w=(0,S.$Bb)(this.o,s,m).map(V=>{const U=V.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const N=B.resourceUri;let ee;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ie=new T.$jc;ee=this.s.converter.toInternal(B.command,ie),this.j.set(O,ie)}else this.h.set(O,B.command);const Y=i(B.decorations),Ee=B.decorations&&i(B.decorations.light)||Y,ke=B.decorations&&i(B.decorations.dark)||Y,Pe=[Ee,ke],X=B.decorations&&B.decorations.tooltip||"",ue=B.decorations&&!!B.decorations.strikeThrough,ye=B.decorations&&!!B.decorations.faded,ce=B.contextValue||"";return{rawResource:[O,N,Pe,X,ue,ye,ce,ee],handle:O}});return{start:V.start,deleteCount:V.deleteCount,toInsert:U}}),R=w.map(({start:V,deleteCount:U,toInsert:B})=>[V,U,B.map(O=>O.rawResource)]),W=w.reverse();for(const{start:V,deleteCount:U,toInsert:B}of W){const O=B.map(ee=>ee.handle),N=this.n.splice(V,U,...O);for(const ee of N)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=s,R}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(s){this.g!==s&&(this.g=s,this.#e.$updateSourceControl(this.t,{count:s}))}get quickDiffProvider(){return this.h}set quickDiffProvider(s){this.h=s;let f;(0,$.$PF)(this.u,"quickDiffProvider")&&(f=s?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!s,quickDiffLabel:f})}get commitTemplate(){return this.j}set commitTemplate(s){s!==this.j&&(this.j=s,this.#e.$updateSourceControl(this.t,{commitTemplate:s}))}get acceptInputCommand(){return this.l}set acceptInputCommand(s){this.k.value=new T.$jc,this.l=s;const f=this.v.converter.toInternal(s,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:f})}get actionButton(){return(0,$.$QF)(this.u,"scmActionButton"),this.n}set actionButton(s){(0,$.$QF)(this.u,"scmActionButton"),this.m.value=new T.$jc,this.n=s;const f=s!==void 0?{command:this.v.converter.toInternal(s.command,this.m.value),secondaryCommands:s.secondaryCommands?.map(w=>w.map(R=>this.v.converter.toInternal(R,this.m.value))),description:s.description,enabled:s.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:f??null})}get statusBarCommands(){return this.p}set statusBarCommands(s){if(this.p&&s&&n(this.p,s))return;this.o.value=new T.$jc,this.p=s;const f=(s||[]).map(w=>this.v.converter.toInternal(w,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:f})}get selected(){return this.q}constructor(s,f,w,R,W,V,U){this.u=s,this.v=R,this.w=W,this.x=V,this.y=U,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new T.$lc,this.l=void 0,this.m=new T.$lc,this.o=new T.$lc,this.p=void 0,this.q=!1,this.s=new F.$fd,this.onDidChangeSelection=this.s.event,this.t=p.d++,this.z=new Map,this.A=new Set,this.#e=w;const B=v.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${W}/scm${this.t}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new c(s,f,this.#e,this.t,B),this.#e.$registerSourceControl(this.t,W,V,U,B)}createResourceGroup(s,f){const w=new E(this.#e,this.v,this.t,s,f),R=F.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,R),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const s=[],f=[];for(const[w,R]of this.z){R.dispose();const W=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});F.Event.once(w.onDidDispose)(()=>{this.A.delete(w),W.dispose(),this.e.delete(w.handle),this.#e.$unregisterGroup(this.t,w.handle)}),s.push([w.handle,w.id,w.label,w.features]);const V=w._takeResourceStateSnapshot();V.length>0&&f.push([w.handle,V]),this.e.set(w.handle,w)}this.#e.$registerGroups(this.t,s,f),this.z.clear()}eventuallyUpdateResourceStates(){const s=[];this.A.forEach(f=>{const w=f._takeResourceStateSnapshot();w.length!==0&&s.push([f.handle,w])}),s.length>0&&this.#e.$spliceResourceStates(this.t,s),this.A.clear()}getResourceGroup(s){return this.e.get(s)}setSelectionState(s){this.q=s,this.s.fire(s)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(s=>s.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,C.$7g)(100)],p.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$7g)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let I=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(s,f,w,R){this.l=f,this.m=w,this.n=R,this.g=new Map,this.h=new D.$Xl,this.j=new F.$fd,this.e=s.getProxy(l.$ZJ.MainThreadSCM),this.f=s.getProxy(l.$ZJ.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const V=this.g.get(W.sourceControlHandle);if(!V)return W;const U=V.getResourceGroup(W.groupHandle);return U?U.getResourceState(W.handle):W}else if(W&&W.$mid===4){const V=this.g.get(W.sourceControlHandle);return V?V.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const V=this.g.get(W.handle);return V||W}return W}})}createSourceControl(s,f,w,R){this.n.trace("ExtHostSCM#createSourceControl",s.identifier.value,f,w,R),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const W=t.d++,V=new p(s,this.m,this.e,this.l,f,w,R);this.g.set(W,V);const U=this.h.get(s.identifier)||[];return U.push(V),this.h.set(s.identifier,U),V}getLastInputBox(s){this.n.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const f=this.h.get(s.identifier),w=f&&f[f.length-1];return w&&w.inputBox}$provideOriginalResource(s,f,w){const R=v.URI.revive(f);this.n.trace("ExtHostSCM#$provideOriginalResource",s,R.toString());const W=this.g.get(s);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$zg)(()=>W.quickDiffProvider.provideOriginalResource(R,w)).then(V=>V||null)}$onInputBoxValueChange(s,f){this.n.trace("ExtHostSCM#$onInputBoxValueChange",s);const w=this.g.get(s);return w&&w.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(s,f,w,R){this.n.trace("ExtHostSCM#$executeResourceCommand",s,f,w);const W=this.g.get(s);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(f);return V?V.$executeResourceCommand(w,R):Promise.resolve(void 0)}$validateInput(s,f,w){this.n.trace("ExtHostSCM#$validateInput",s);const R=this.g.get(s);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,A.$zg)(()=>R.inputBox.validateInput(f,w)).then(W=>{if(!W)return Promise.resolve(void 0);const V=b.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this.g.get(s)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=s,Promise.resolve(void 0)}};e.$Xbc=I,e.$Xbc=I=t=Ke([qe(3,P.$5i)],I)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;class T{constructor(l){this.b=new F.$fd,this.onDidChangePassword=this.b.event,this.a=l.getProxy(v.$ZJ.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,S){return this.a.$getPassword(l,S)}store(l,S,g){return this.a.$setPassword(l,S,g)}delete(l,S){return this.a.$deletePassword(l,S)}}e.$Cbc=T,e.$Dbc=(0,C.$Bh)("IExtHostSecretState")}),define(Ae[251],Re([1,0,3,8,2]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class T{static{this.a=0}constructor(l,S){this.d=S,this.c=new Map,this.b=l.getProxy(v.$ZJ.MainThreadShare)}async $provideShare(l,S,g){return await this.c.get(l)?.provideShare({selection:F.Range.to(S.selection),resourceUri:C.URI.revive(S.resourceUri)},g)??void 0}registerShareProvider(l,S){const g=T.a++;return this.c.set(g,S),this.b.$registerShareProvider(g,F.DocumentSelector.from(l,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Zcc=T}),define(Ae[252],Re([1,0,7,3,154,6,8,16]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$XK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$XK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,$,d,t,i=v.StatusBarAlignment.Left,o){if(this.i=!1,this.k="",this.q=new T.$jc,this.#e=u,this.#t=b,t&&d){this.c=(0,v.$AK)(d.identifier,t);const h=$.get(this.c);h&&(i=h.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,o=h.priority,this.j=!0,this.name=h.name,this.text=h.text,this.tooltip=h.tooltip,this.command=h.command,this.accessibilityInformation=h.accessibilityInformation)}else this.c=String(S.a++);this.e=d,this.f=t,this.g=i,this.h=this.u(o)}u(u){if((0,l.$nf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!S.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new T.$jc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=S.b.get(this.o.id));const d=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,d,this.r?.internal,$,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ybc=S;class g{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new v.$2J(()=>{const $=this.b.indexOf(b);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,b){this.e=new Map,this.a=u.getProxy(F.$ZJ.MainThreadStatusBar),this.b=b,this.c=new g(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,$,d){return new S(this.a,this.b,this.e,u,b,$,d)}setStatusBarMessage(u,b){const $=this.c.setMessage(u);let d;return typeof b=="number"?d=setTimeout(()=>$.dispose(),b):typeof b<"u"&&b.then(()=>$.dispose(),()=>$.dispose()),new v.$2J(()=>{$.dispose(),clearTimeout(d)})}}e.$Zbc=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0;class T{constructor(l,S){this.c=S,this.b=new F.$fd,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(v.$ZJ.MainThreadStorage)}registerExtensionStorageKeysToSync(l,S){this.a.$registerExtensionStorageKeysToSync(l,S)}async initializeExtensionStorage(l,S,g){const P=await this.a.$initializeExtensionStorage(l,S);let D;return P&&(D=this.d(l,S,P)),D||g}setValue(l,S,g){return this.a.$setValue(l,S,g)}$acceptValue(l,S,g){const P=this.d(l,S,g);P&&this.b.fire({shared:l,key:S,value:P})}d(l,S,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${l}): ${P}`)}}}e.$qbc=T,e.$rbc=(0,C.$Bh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0,e.$wbc=(0,v.$Bh)("IExtensionStoragePaths");let l=class{constructor(g,P,D){this.d=P,this.f=D,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xbc=l,e.$xbc=l=Ke([qe(0,F.$fM),qe(1,C.$5i),qe(2,T.$vbc)],l)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,12,8,31]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=e.$zbc=e.$ybc=void 0,e.$ybc=(0,C.$Bh)("IExtHostTerminalService");class h{constructor(s,f,w,R){this.l=s,this._id=f,this.m=w,this.n=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(V,U=!0){W.q(),W.l.$sendText(W._id,V,U)},show(V){W.q(),W.l.$show(W._id,V)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(s,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:s.name,shellPath:s.shellPath??void 0,shellArgs:s.shellArgs??void 0,cwd:s.cwd??void 0,env:s.env??void 0,icon:E(s.iconPath)??void 0,color:d.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:s.message??void 0,strictEnv:s.strictEnv??void 0,hideFromUser:s.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(s.location,f?.resolvedExtHostIdentifier),isTransient:s.isTransient??void 0})}async createExtensionTerminal(s,f,w,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:w,color:d.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.o(s,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(s,f){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in s?{viewColumn:i.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(s){this.n=s}setExitStatus(s,f){this.h=Object.freeze({code:s,reason:f})}setDimensions(s,f){return s===this.d&&f===this.g||s===0||f===0?!1:(this.d=s,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(s){this.k=s}_setProcessId(s){this.f?(this.f(s),this.f=void 0):this.b.then(f=>{f!==s&&(this.b=Promise.resolve(s))})}}e.$zbc=h;class y{get onProcessReady(){return this.b.event}constructor(s){this.g=s,this.id=0,this.shouldPersist=!1,this.a=new v.$fd,this.onProcessData=this.a.event,this.b=new v.$fd,this.d=new v.$fd,this.onDidChangeProperty=this.d.event,this.f=new v.$fd,this.onProcessExit=this.f.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(s){this.g.handleInput?.(s)}resize(s,f){this.g.setDimensions?.({columns:s,rows:f})}clearBuffer(){}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(s){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(s||void 0),s&&this.g.setDimensions?.(s),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,r=class extends l.$kc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(s=>s.value)}constructor(s,f,w){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$lc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$fd,this.onDidCloseTerminal=this.H.event,this.I=new v.$fd,this.onDidOpenTerminal=this.I.event,this.J=new v.$fd,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$fd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$fd,this.onDidChangeTerminalState=this.M.event,this.N=new v.$fd,this.onDidChangeShell=this.N.event,this.O=new v.$fd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$fd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(F.$ZJ.MainThreadTerminalService),this.y=new $.$Qkb(this.a.$sendProcessData),this.a.$registerProcessSupport(s),this.Q.registerArgumentProcessor({processArgument:R=>{const W=V=>{const U=V;return this.W(U.instanceId)?.value};switch(R?.$mid){case 15:return W(R);default:{if(Array.isArray(R))for(let V=0;V<R.length&&R[V].$mid===15;V++)R[V]=W(R[V]);return R}}}}),this.B({dispose:()=>{for(const[R,W]of this.g)W.shutdown(!0)}})}getDefaultShell(s){return(s?this.u:this.s)?.path||""}getDefaultShellArgs(s){return(s?this.u:this.s)?.args||[]}createExtensionTerminal(s,f){const w=new h(this.a,(0,b.$4f)(),s,s.name),R=new y(s.pty);return w.createExtensionTerminal(s.location,this.R(s,f).resolvedExtHostIdentifier,E(s.iconPath),p(s.color)).then(W=>{const V=this.S(W,R);this.h[W]=V}),this.f.push(w),w.value}R(s,f){if(f=f||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const w=s.location.parentTerminal;if(w){const R=this.f.find(W=>W.value===w);R&&(f.resolvedExtHostIdentifier=R._id)}}else s.location&&typeof s.location!="object"?f.location=s.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(s,f){if(!this.W(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const R=new y(f),W=this.S(s,R);this.h[s]=W}async $acceptActiveTerminalChanged(s){const f=this.b;if(s===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const w=this.W(s);w&&(this.b=w,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(s,f){const w=this.W(s);w&&this.O.fire({terminal:w.value,data:f})}async $acceptTerminalDimensions(s,f,w){const R=this.W(s);R&&R.setDimensions(f,w)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(s,f){const w=this.W(s);w&&this.P.fire({terminal:w.value,...f})}async $acceptTerminalMaximumDimensions(s,f,w){this.g.get(s)?.resize(f,w)}async $acceptTerminalTitleChange(s,f){const w=this.W(s);w&&(w.name=f)}async $acceptTerminalClosed(s,f,w){const R=this.Y(this.f,s);if(R!==null){const W=this.f.splice(R,1)[0];W.setExitStatus(f,w),this.H.fire(W.value)}}$acceptTerminalOpened(s,f,w,R){if(f){const U=this.Y(this.f,f);if(U!==null){this.f[U]._id=s,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:T.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new h(this.a,s,W,w);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(s,f){this.W(s)?._setProcessId(f)}async $startExtensionTerminal(s,f){const w=this.W(s);if(!w)return{message:(0,g.localize)(0,null,s)};w.isOpen||await new Promise(W=>{const V=this.onDidOpenTerminal(async U=>{U===w.value&&(V.dispose(),W())})});const R=this.g.get(s);R?R.startSendingEvents(f):this.j[s]={initialDimensions:f}}S(s,f){const w=new l.$jc;w.add(f.onProcessReady(W=>this.a.$sendProcessReady(s,W.pid,W.cwd,W.windowsPty))),w.add(f.onDidChangeProperty(W=>this.a.$sendProcessProperty(s,W))),this.y.startBuffering(s,f.onProcessData),w.add(f.onProcessExit(W=>this.U(s,W))),this.g.set(s,f);const R=this.j[s];return R&&f instanceof y&&(f.startSendingEvents(R.initialDimensions),delete this.j[s]),w}$acceptProcessAckDataEvent(s,f){this.g.get(s)?.acknowledgeDataEvent(f)}$acceptProcessInput(s,f){this.g.get(s)?.input(f)}$acceptTerminalInteraction(s){const f=this.W(s);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(s,f){this.W(s)?.setSelection(f)}$acceptProcessResize(s,f,w){try{this.g.get(s)?.resize(f,w)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(s,f){this.g.get(s)?.shutdown(f)}$acceptProcessRequestInitialCwd(s){this.g.get(s)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(s,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(s){this.g.get(s)?.getCwd().then(f=>this.a.$sendProcessProperty(s,{type:"cwd",value:f}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this.z.add(s),this.z.size===1&&this.a.$startLinkProvider(),new S.$2J(()=>{this.z.delete(s),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(s,f,w){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,w),this.a.$registerProfileProvider(f,s.identifier.value),new S.$2J(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(s,f,w){if(this.D.has(s))throw new Error(`Terminal quick fix provider "${s}" is already registered`);return this.D.set(s,w),this.a.$registerQuickFixProvider(s,f),new S.$2J(()=>{this.D.delete(s),this.a.$unregisterQuickFixProvider(s)})}async $provideTerminalQuickFixes(s,f){const w=new u.$pd().token;if(w.isCancellationRequested)return;const R=this.D.get(s);if(!R)return;const W=await R.provideTerminalQuickFixes(f,w);if(W===null||Array.isArray(W)&&W.length===0)return;const V=new l.$jc;if(this.w.value=V,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,V):void 0;const U=[];for(const B of W){const O=i.TerminalQuickFix.from(B,this.Q.converter,V);O&&U.push(O)}return U}async $createContributedProfileTerminal(s,f){const w=new u.$pd().token;let R=await this.C.get(s)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,f);return}this.createTerminalFromOptions(R.options,f)}}async $provideLinks(s,f){const w=this.W(s);if(!w)return[];this.F.delete(s),this.G.get(s)?.dispose(!0);const W=new u.$pd;this.G.set(s,W);const V=[],U={terminal:w.value,line:f},B=[];for(const ee of this.z)B.push(t.Promises.withAsyncBody(async Y=>{W.token.onCancellationRequested(()=>Y({provider:ee,links:[]}));const Ee=await ee.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||Y({provider:ee,links:Ee})}));const O=await Promise.all(B);if(W.token.isCancellationRequested)return[];const N=new Map;for(const ee of O)ee&&ee.links.length>0&&V.push(...ee.links.map(Y=>{const Ee={id:m++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return N.set(Ee.id,{provider:ee.provider,link:Y}),Ee}));return this.F.set(s,N),V}$activateLink(s,f){const w=this.F.get(s)?.get(f);w&&w.provider.handleTerminalLink(w.link)}U(s,f){this.y.stopBuffering(s),this.g.delete(s),delete this.j[s];const w=this.h[s];w&&(w.dispose(),delete this.h[s]),this.a.$sendProcessExit(s,f)}W(s){return this.X(this.f,s)}X(s,f){const w=this.Y(s,f);return w!==null?s[w]:null}Y(s,f){const w=s.findIndex(R=>R._id===f);return w===-1?null:w}getEnvironmentVariableCollection(s){let f=this.n.get(s.identifier.value);return f||(f=new a,this.$(s.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(s,f){const w=(0,D.$ar)(f.map),R=(0,D.$br)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(s,f.persistent,w.length===0?void 0:w,R)}$initEnvironmentVariableCollections(s){s.forEach(f=>{const w=f[0],R=new a(f[1]);this.$(w,R)})}$acceptDefaultProfile(s,f){const w=this.s;this.s=s,this.u=f,w?.path!==s.path&&this.N.fire(s.path)}$(s,f){this.n.set(s,f),f.onDidChangeCollection(()=>{this.Z(s,f)})}};e.$Abc=r,e.$Abc=r=Ke([qe(1,o.$lM),qe(2,A.$2L)],r);class a{get persistent(){return this.b}set persistent(s){this.b=s,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(s){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new v.$fd,this.map=new Map(s)}getScopedEnvironmentVariableCollection(s){const f=this.h(s);let w=this.a.get(f);return w||(w=new n(this,s),this.a.set(f,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(s,f,w,R){this.f(s,{value:f,type:S.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:R})}append(s,f,w,R){this.f(s,{value:f,type:S.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:R})}prepend(s,f,w,R){this.f(s,{value:f,type:S.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:R})}f(s,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(s,f.scope),R=this.map.get(w),W=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==f.value||R.type!==f.type||R.options?.applyAtProcessCreation!==W.applyAtProcessCreation||R.options?.applyAtShellIntegration!==W.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const V=this.g(s,f.scope),U={variable:s,...f,options:W};this.map.set(V,U),this.d.fire()}}get(s,f){const w=this.g(s,f),R=this.map.get(w);return R?I(R):void 0}g(s,f){const w=this.h(f);return w.length?`${s}:::${w}`:s}h(s){return this.j(s?.workspaceFolder)??""}j(s){return s?s.uri.toString():void 0}getVariableMap(s){const f=new Map;for(const[w,R]of this.map)this.h(R.scope)===this.h(s)&&f.set(R.variable,I(R));return f}delete(s,f){const w=this.g(s,f);this.map.delete(w),this.d.fire()}clear(s){if(s?.workspaceFolder){for(const[f,w]of this.map)w.scope?.workspaceFolder?.index===s.workspaceFolder.index&&this.map.delete(f);this.k(s)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(s,f){const w=this.h(f),R=this.descriptionMap.get(w);if(!R||R.description!==s){let W;typeof s=="string"?W=s:W=s?.value.split(`

`)[0];const V={description:W,scope:f};this.descriptionMap.set(w,V),this.d.fire()}}getDescription(s){const f=this.h(s);return this.descriptionMap.get(f)?.description}k(s){const f=this.h(s);this.descriptionMap.delete(f)}}class n{get persistent(){return this.b.persistent}set persistent(s){this.b.persistent=s}get onDidChangeCollection(){return this.a&&this.a.event}constructor(s,f){this.b=s,this.d=f,this.a=new v.$fd}getScoped(s){return this.b.getScopedEnvironmentVariableCollection(s)}replace(s,f,w){this.b.replace(s,f,w,this.d)}append(s,f,w){this.b.append(s,f,w,this.d)}prepend(s,f,w){this.b.prepend(s,f,w,this.d)}get(s){return this.b.get(s,this.d)}forEach(s,f){this.b.getVariableMap(this.d).forEach((w,R)=>s.call(f,R,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(s){this.b.delete(s,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(s){this.b.setDescription(s,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends r{constructor(s,f){super(!1,s,f)}createTerminal(s,f,w){throw new P.$0}createTerminalFromOptions(s,f){throw new P.$0}};e.$Bbc=c,e.$Bbc=c=Ke([qe(0,o.$lM),qe(1,A.$2L)],c);function E(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function p(k){return d.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const s={...k};return delete s.scope,s.options=s.options??void 0,delete s.variable,s}}),define(Ae[253],Re([1,0,282,12,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,57,26]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=e.$Jcc=e.$Icc=void 0;let r=class{constructor(U,B,O){this.k=O,this.d=new A.$fd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(b.$ZJ.MainThreadTesting),this.j=new w(this.g),this.h=new E(this.g),B.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ee=N,Y=ee.tests[ee.tests.length-1].item.extId;return this.f.get(o.$OI.root(Y))?.collection.tree.get(Y)?.actual??(0,d.$bM)(N)}case 18:{const{extId:ee,message:Y}=N;return{test:this.f.get(o.$OI.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(Y)}}default:return N}}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),ee=Y=>{const Ee=this.f.get(o.$OI.root(Y));if(Ee)return o.$OI.isRoot(Y)?Ee.controller:Ee.collection.tree.get(Y)?.actual};return{include:N?.include.map(ee).filter(D.$rf)||[],exclude:N?.exclude.map(ee).filter(D.$rf)||[]}})}createTestController(U,B,O,N){if(this.f.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const ee=new g.$jc,Y=ee.add(new d.$eM(B,O,this.k));Y.root.label=O;const Ee=new Map,ke=this.g,Pe={items:Y.root.children,get label(){return O},set label(ue){O=ue,Y.root.label=ue,ke.$updateController(B,{label:O})},get refreshHandler(){return N},set refreshHandler(ue){N=ue,ke.$updateController(B,{canRefresh:!!ue})},get id(){return B},createRunProfile:(ue,ye,ce,$e,ie,z)=>{let q=(0,S.$pi)(ue);for(;Ee.has(q);)q++;return new R(this.g,Ee,B,q,ue,ye,ce,$e,ie,z)},createTestItem(ue,ye,ce){return new d.$cM(B,ue,ye,ce)},createTestRun:(ue,ye,ce=!0)=>this.h.createTestRun(U,B,Y,ue,ye,ce),invalidateTestResults:ue=>{if(ue===void 0)this.g.$markTestRetired(void 0);else{const ye=ue instanceof Array?ue:[ue];this.g.$markTestRetired(ye.map(ce=>o.$OI.fromExtHostTestItem(ce,B).toString()))}},set resolveHandler(ue){Y.resolveHandler=ue},get resolveHandler(){return Y.resolveHandler},dispose:()=>{ee.dispose()}};ke.$registerTestController(B,O,!!N),ee.add((0,g.$ic)(()=>ke.$unregisterTestController(B)));const X={controller:Pe,collection:Y,profiles:Ee,extension:U};return this.f.set(B,X),ee.add((0,g.$ic)(()=>this.f.delete(B))),ee.add(Y.onDidGenerateDiff(ue=>ke.$publishDiff(B,ue.map(y.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,B=T.CancellationToken.None){const O=p(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>o.$OI.fromExtHostTestItem(ee,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},B)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,O){return(0,v.$pb)(this.h.trackers,ee=>ee.id===U?ee.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,B,O,N){return(0,v.$pb)(this.h.trackers,Y=>Y.id===U?Y.getCoverage(B):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,B){this.f.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.f.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,P.$Wm)(t.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,B){const O=this.f.get(o.$OI.fromString(U).controllerId)?.collection;O&&(await O.expand(U,B<0?1/0:B),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(y.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map(O=>this.l(O,!1,B)))}async $startContinuousRun(U,B){const O=new T.$pd(B),N=await Promise.all(U.map(ee=>this.l(ee,!0,O.token)));return!B.isCancellationRequested&&!N.some(ee=>ee.error)&&await new Promise(ee=>B.onCancellationRequested(ee)),O.dispose(!0),N}async l(U,B,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:ee,profiles:Y,extension:Ee}=N,ke=Y.get(U.profileId);if(!ke)return{};const Pe=U.testIds.map(ce=>ee.tree.get(ce)).filter(D.$rf),X=U.excludeExtIds.map(ce=>N.collection.tree.get(ce)).filter(D.$rf).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const ue=new i.$yL(Pe.some(ce=>ce.actual instanceof d.$dM)?void 0:Pe.map(ce=>ce.actual),X.map(ce=>ce.actual),ke,B),ye=(0,y.$QI)(U)&&this.h.prepareForMainThreadTestRun(ue,I.fromInternal(U,N.collection),Ee,O);try{return await ke.runHandler(ue,O),{}}catch(ce){return{error:String(ce)}}finally{ye&&(ye.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$Icc=r,e.$Icc=r=Ke([qe(0,$.$2L)],r);const a=1e4;var n;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(n||(n={}));class c extends g.$kc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,B,O,N){super(),this.s=U,this.u=B,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$fd),this.onEnd=this.m.event,this.j=this.B(new T.$pd(N));const ee=this.B(new F.$Sg(()=>this.y(),a));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const B=this.s.id,O=this.s.controllerId,N=(0,u.$4f)(),ee=new k(this.u,B,N),Y=X=>(ue,...ye)=>{if(ke){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ue)&&(this.C(ue),X(ue,...ye))},Ee=(X,ue)=>{const ye=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(ye.some(ce=>ce.contextValue!==void 0)&&(0,m.$QF)(this.w,"testMessageContextValue"),X.uri&&X.range){const ce={range:t.Range.from(X.range),uri:X.uri};for(const $e of ye)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(B,N,o.$OI.fromExtHostTestItem(X,O).toString(),ye)};let ke=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(X){ee.coverageProvider=X},enqueued:Y(X=>{this.u.$updateTestStateInRun(B,N,o.$OI.fromExtHostTestItem(X,O).toString(),1)}),skipped:Y(X=>{this.u.$updateTestStateInRun(B,N,o.$OI.fromExtHostTestItem(X,O).toString(),5)}),started:Y(X=>{this.u.$updateTestStateInRun(B,N,o.$OI.fromExtHostTestItem(X,O).toString(),2)}),errored:Y((X,ue,ye)=>{Ee(X,ue),this.u.$updateTestStateInRun(B,N,o.$OI.fromExtHostTestItem(X,O).toString(),6,ye)}),failed:Y((X,ue,ye)=>{Ee(X,ue),this.u.$updateTestStateInRun(B,N,o.$OI.fromExtHostTestItem(X,O).toString(),4,ye)}),passed:Y((X,ue)=>{this.u.$updateTestStateInRun(B,N,o.$OI.fromExtHostTestItem(X,this.s.controllerId).toString(),3,ue)}),appendOutput:(X,ue,ye)=>{ke||(ye&&(this.s.isIncluded(ye)?this.C(ye):ye=void 0),this.u.$appendOutputToRun(B,N,C.$Fd.fromString(X),ue&&t.location.from(ue),ye&&o.$OI.fromExtHostTestItem(ye,O).toString()))},end:()=>{ke||(ke=!0,this.u.$finishedTestRunTask(B,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(B,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof d.$cM))throw new h.$TL(U.id);if(this.h.has(o.$OI.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const B=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(U);if(B.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.z(),super.dispose()}}class E{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,B,O,N){return this.g(U,B,O,N)}cancelRunById(U){for(const B of this.d.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,B,O,N,ee,Y){const Ee=this.d.get(N);if(Ee)return Ee.createRun(ee);const ke=I.fromPublic(B,O,N,Y),Pe=p(N);this.f.$startedExtensionTestRun({controllerId:B,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(ue=>o.$OI.fromExtHostTestItem(ue,O.root.id).toString())??[],id:ke.id,include:N.include?.map(ue=>o.$OI.fromExtHostTestItem(ue,O.root.id).toString())??[O.root.id],persist:Y});const X=this.g(N,ke,U);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(ke.id),X.dispose()}),X.createRun(ee)}g(U,B,O,N){const ee=new c(B,this.f,O,N);return this.d.set(U,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(U)),ee}}e.$Jcc=E;const p=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class I{static fromPublic(U,B,O,N){return new I(U,(0,u.$4f)(),O.include?.map(ee=>o.$OI.fromExtHostTestItem(ee,U).toString())??[U],O.exclude?.map(ee=>o.$OI.fromExtHostTestItem(ee,U).toString())??[],N,B)}static fromInternal(U,B){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,O,N,ee,Y){this.controllerId=U,this.id=B,this.isPersisted=ee,this.colllection=Y,this.d=O.map(Ee=>Ee+"\0"),this.f=N.map(Ee=>Ee+"\0")}isIncluded(U){const B=o.$OI.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(B===O||B.startsWith(O))return!1;for(const O of this.d)if(B===O||B.startsWith(O))return!0;return!1}}e.$Kcc=I;class k{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,B,O){this.g=U,this.h=B,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.f=void 0,B}}async resolveFileCoverage(U,B){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class s{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const B=o.$OI.parentId(U.item.extId);if(B&&this.h.has(B.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:B,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends y.$VI{constructor(){super(...arguments),this.s=new A.$fd,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,B){return{...U,revived:t.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}p(){return new s(this.s)}}class w{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,l.$bb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new f;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class R{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,O,N,ee,Y,Ee,ke=!1,Pe=void 0,X=!1){this.controllerId=O,this.profileId=N,this.f=ee,this.kind=Y,this.runHandler=Ee,this.g=ke,this._tag=Pe,this.h=X,this.#e=U,this.#t=B,B.set(N,this);const ue=W[Y];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:ue,isDefault:ke,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Lcc=R;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[254],Re([1,0,18,9,5,3,106,8,7]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class g{constructor(D,u){this.i=u,this.a=new C.$fd({onListenerError:F.$Z}),this.b=new C.$fd({onListenerError:F.$Z}),this.c=new C.$fd({onListenerError:F.$Z}),this.d=new C.$fd({onListenerError:F.$Z}),this.f=new C.$fd({onListenerError:F.$Z}),this.g=new C.$fd({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(T.$ZJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(b=>b.value)}async showTextDocument(D,u,b){let $;typeof u=="number"?$={position:l.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?$={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?l.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:$={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(D.uri,$),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$9L(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const $=u.selections.selections.map(l.Selection.to);b._acceptSelections($)}if(u.visibleRanges){const $=v.$Fb(u.visibleRanges.map(l.Range.to));b._acceptVisibleRanges($)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:l.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const $=S.TextEditorSelectionChangeKind.fromValue(u.selections.source),d=u.selections.selections.map(l.Selection.to);this.a.fire({textEditor:b.value,selections:d,kind:$})}if(u.visibleRanges){const $=v.$Fb(u.visibleRanges.map(l.Range.to));this.c.fire({textEditor:b.value,visibleRanges:$})}}$acceptEditorPositionData(D){for(const u in D){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const $=l.ViewColumn.to(D[u]);b.value.viewColumn!==$&&(b._acceptViewColumn($),this.d.fire({textEditor:b.value,viewColumn:$}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$1bc=g}),define(Ae[255],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0,e.$Ccc=(0,F.$Bh)("IExtHostTimeline");class P{constructor(b,$){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$ZJ.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&S.$Vl.equals(t,this.b.get(d.source)?.extension)){const i=d.uri===void 0?void 0:v.URI.revive(d.uri);return this.c.get(d.source)?.get(D(i))?.get(d.handle)}else return;return d}})}async $getTimeline(b,$,d,t){return this.b.get(b)?.provider.provideTimeline(v.URI.revive($),d,t)}registerTimelineProvider(b,$,d,t){const i=new T.$jc,o=this.d($.id,t,i).bind(this);let h;$.onDidChange&&(h=$.onDidChange(m=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...m,id:$.id}),this));const y=this.c;return this.f({...$,scheme:b,onDidChange:void 0,async provideTimeline(m,r,a){r?.resetCache&&(i.clear(),y.get($.id)?.clear());const n=await $.provideTimeline(m,r,a);if(n==null)return;const c=o(m,r);return{...n,source:$.id,items:n.items.map(c)}},dispose(){for(const m of y.values())m.get($.id)?.clear();h?.dispose(),i.dispose()}},d)}d(b,$,d){return(t,i)=>{let o;if(i?.cacheResults){let h=this.c.get(b);h===void 0&&(h=new Map,this.c.set(b,h));const y=D(t);o=h.get(y),o===void 0&&(o=new Map,h.set(y,o))}return h=>{const{iconPath:y,...m}=h,r=`${b}|${h.id??h.timestamp}`;o?.set(r,h);let a,n,c;h.iconPath&&(y instanceof A.$WK?c={id:y.id,color:y.color}:v.URI.isUri(y)?(a=y,n=y):{light:a,dark:n}=y);let E;return A.$qK.isMarkdownString(m.tooltip)?E=l.MarkdownString.from(m.tooltip):(0,g.$jf)(m.tooltip)?E=m.tooltip:A.$qK.isMarkdownString(m.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=l.MarkdownString.from(m.detail)):(0,g.$jf)(m.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=m.detail),{...m,id:m.id??void 0,handle:r,source:b,command:h.command?$.toInternal(h.command,d):void 0,icon:a,iconDark:n,themeIcon:c,tooltip:E,accessibilityInformation:h.accessibilityInformation}}}}f(b,$){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:$}),(0,T.$ic)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Dcc=P;function D(u){return u?.toString()}}),define(Ae[86],Re([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssb=e.$rsb=e.TunnelDtoConverter=void 0;class b extends S.$6z{}var $;(function(t){function i(h){return{remoteAddress:h.remoteAddress,localAddress:h.localAddress,public:!!h.public,privacy:h.privacy??(h.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:h.protocol}}t.fromApiTunnel=i;function o(h){return{remoteAddress:{host:h.tunnelRemoteHost,port:h.tunnelRemotePort},localAddress:h.localAddress,public:h.privacy!==S.TunnelPrivacyId.ConstantPrivate&&h.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:h.privacy,protocol:h.protocol}}t.fromServiceTunnel=o})($||(e.TunnelDtoConverter=$={})),e.$rsb=(0,A.$Bh)("IExtHostTunnelService");let d=class extends C.$kc{constructor(i,o,h){super(),this.s=h,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$fd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$ZJ.MainThreadTunnelService)}async openTunnel(i,o){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${o.remoteAddress.host}:${o.remoteAddress.port}.`);const h=await this.a.$openTunnel(o,i.displayName);if(h){const y=new b(h.remoteAddress,h.localAddress,()=>this.a.$closeTunnel(h.remoteAddress));return this.B(y),y}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,o){const h=this.u();return this.r.set(h,{selector:i,provider:o}),this.a.$registerPortsAttributesProvider(i,h),new u.$2J(()=>{this.r.delete(h),this.a.$unregisterPortsAttributesProvider(h)})}async $providePortAttributes(i,o,h,y,m){const r=[];for(const n of i){const c=this.r.get(n);if(!c)return[];r.push(...await Promise.all(o.map(async E=>{let p;try{p=await c.provider.providePortAttributes({port:E,pid:h,commandLine:y},m)}catch{p=await c.provider.providePortAttributes(E,h,y,m)}return{providedAttributes:p,port:E}})))}const a=r.filter(n=>!!n.providedAttributes);return a.length>0?a.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,o){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(y,m)=>await i.provideTunnel(y,m,new v.$pd().token)??void 0;const h=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,privacyOptions:o.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(h),Promise.resolve((0,C.$ic)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,o){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const h=i.tunnelFactory??(o?this.w(o):void 0);if(h){this.b=h;let y=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&y.length===0&&(y=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const m=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:y}:void 0;this.a.$setTunnelProvider(m)}}else this.b=void 0;return(0,C.$ic)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,o){if(this.g.has(i.host)){const h=this.g.get(i.host);h.has(i.port)&&(o&&h.get(i.port).disposeListener.dispose(),await h.get(i.port).tunnel.dispose(),h.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,o){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const h=this.b(i,o);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),h!==void 0){const y=await h;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),y===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const m=this.B(y.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(y.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:y,disposeListener:m}),$.fromApiTunnel(y)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(h){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),h instanceof Error)return h.message}}async $applyCandidateFilter(i){const o=await Promise.all(i.map(y=>this.f(y.host,y.port,y.detail??""))),h=i.filter((y,m)=>o[m]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(y=>y.port).join(", ")} to ${h.map(y=>y.port).join(", ")}`),h}};e.$ssb=d,e.$ssb=d=Ke([qe(0,D.$2L),qe(1,P.$fM),qe(2,l.$5i)],d)}),define(Ae[256],Re([1,0,6,13,2,3]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(T.$ZJ.MainThreadUriOpeners)}registerExternalUriOpener(S,g,P,D){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const u=D.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,D.schemes,S,D.label),(0,v.$ic)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(S,g,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const u=C.URI.revive(g);return D.canOpenExternalUri(u,P)}async $openUri(S,g,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},P)}}e.$Mcc=A}),define(Ae[257],Re([1,0,3,2,6,9,20]),function(be,e,v,F,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class l{static{this.a=0}constructor(g){this.c=new A.$Wl,this.d=new Map,this.b=g.getProxy(v.$ZJ.MainThreadUrls)}registerUriHandler(g,P){const D=g.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=l.a++;return this.c.add(D),this.d.set(u,P),this.b.$registerUriHandler(u,D,g.displayName||g.name),(0,C.$ic)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(g,P){const D=this.d.get(g);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(P))}catch(u){(0,T.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(g){return F.URI.revive(await this.b.$createAppUri(g))}}e.$3bc=l}),define(Ae[64],Re([1,0,5,6,13,24,2,170,192,77,3]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=e.$6bc=e.$5bc=e.$4bc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(y,m,r,a,n,c,E){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new v.$fd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$fd,this._onDidDispose=this.#h.event,this.#e=y,this.#t=m,this.#r=r,this.#l=a,this.#u=n,this.#n=c,this.#c=u(c),this.#d=b(c),this.#i=E}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(y){return this.#a=!0,(0,g.$Yob)(y,this.#l)}get cspSource(){const y=this.#n.extensionLocation;if(y.scheme===C.Schemas.https||y.scheme===C.Schemas.http){let m=y.toString();return m.endsWith("/")||(m+="/"),m+" "+g.$Xob}return g.$Xob}get html(){return this.a(),this.#s}set html(y){this.a(),this.#s!==y&&(this.#s=y,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(y)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(y)))}get options(){return this.a(),this.#r}set options(y){this.a(),T.$Zm(this.#r,y)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,y)),this.#r=y}async postMessage(y){if(this.#o)return!1;const m=(0,S.$9bb)(y,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,m.message,...m.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(y){if(!this.#d)return y;const m=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return y.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,n,c,E,p,I)=>{const k=A.URI.from({scheme:E||"file",path:decodeURIComponent(p)}),s=(0,g.$Yob)(k,{isRemote:m,authority:r}).toString();return`${n}${s}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,n,c,E,p,I)=>{const k=A.URI.from({scheme:E||"file",path:decodeURIComponent(p)}),s=(0,g.$Yob)(k,{isRemote:m,authority:r}).toString();return`${n}${s}${I}`})}}e.$4bc=D;function u(h){try{const y=(0,l.$Do)((0,l.$Co)(h.engines.vscode));return!!y&&y.majorBase>=1&&y.minorBase>=57}catch{return!1}}e.$5bc=u;function b(h){try{const y=(0,l.$Do)((0,l.$Co)(h.engines.vscode));return y?y.majorBase<1||y.majorBase===1&&y.minorBase<60:!1}catch{return!1}}class $ extends F.$kc{constructor(y,m,r,a,n){super(),this.c=m,this.f=r,this.g=a,this.h=n,this.b=new Map,this.a=y.getProxy(P.$ZJ.MainThreadWebviews)}dispose(){super.dispose();for(const y of this.b.values())y.dispose();this.b.clear()}$onMessage(y,m,r){const a=this.j(y);if(a){const{message:n}=(0,S.$0bb)(m,r.value);a._onMessageEmitter.fire(n)}}$onMissingCsp(y,m){this.g.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(y,m,r){const a=new D(y,this.a,i(m),this.c,this.f,r,this.h);this.b.set(y,a);const n=a._onDidDispose(()=>{n.dispose(),this.deleteWebview(y)});return a}deleteWebview(y){this.b.delete(y)}j(y){return this.b.get(y)}}e.$6bc=$;function d(h){return{id:h.identifier,location:h.extensionLocation}}e.$7bc=d;function t(h,y,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||o(h,y)}}e.$8bc=t;function i(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(y=>A.URI.from(y))}}function o(h,y){return[...(y?.getWorkspaceFolders()||[]).map(m=>m.uri),h.extensionLocation]}}),define(Ae[258],Re([1,0,21,93,6,13,23,2,8,64,55,3,7]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class b{constructor(a,n){this.document=a,this.b=n,this.a=1,this.c=new P.$Zac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,n){await this.f(a).undo(),n||this.disposeBackup()}async redo(a,n){await this.f(a).redo(),n||this.disposeBackup()}disposeEdits(a){for(const n of a)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=m(this.document.uri)+this.a++;return(0,A.$ig)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const n=this.c.get(a,0);if(!n)throw new Error("No edit found");return n}}class ${constructor(){this.a=new Map}get(a,n){return this.a.get(this.b(a,n))}add(a,n,c){const E=this.b(a,n.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${a} resource:${n.uri}`);const p=new b(n,c);return this.a.set(E,p),p}delete(a,n){const c=this.b(a,n.uri);this.a.delete(c)}b(a,n){return`${a}@@@${n}`}}var d;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(a,n,c){return this.b(0,a,n,c)}addCustomProvider(a,n,c){return this.b(1,a,n,c)}get(a){return this.a.get(a)}b(a,n,c,E){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:a,extension:c,provider:E}),new u.$2J(()=>this.a.delete(n))}}class i{constructor(a,n,c,E,p){this.d=n,this.f=c,this.g=E,this.h=p,this.b=new t,this.c=new $,this.a=a.getProxy(D.$ZJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,n,c,E){const p=new C.$jc;return h(c)?(p.add(this.b.addTextProvider(n,a,c)),this.a.$registerTextEditorProvider((0,g.$7bc)(a),n,E.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,g.$5bc)(a))):(p.add(this.b.addCustomProvider(n,a,c)),o(c)&&p.add(c.onDidChangeCustomDocument(I=>{const k=this.i(n,I.document.uri);if(y(I)){const s=k.addEdit(I);this.a.$onDidEdit(I.document.uri,n,s,I.label)}else this.a.$onContentChange(I.document.uri,n)})),this.a.$registerCustomEditorProvider((0,g.$7bc)(a),n,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,g.$5bc)(a))),u.$2J.from(p,new u.$2J(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(a,n,c,E,p){const I=this.b.get(n);if(!I)throw new Error(`No provider found for '${n}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${n}'`);const k=l.URI.revive(a),s=await I.provider.openCustomDocument(k,{backupId:c,untitledDocumentData:E?.buffer},p);let f;return o(I.provider)&&this.f&&(f=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(n,s,f),{editable:o(I.provider)}}async $disposeCustomDocument(a,n){const c=this.b.get(n);if(!c)throw new Error(`No provider found for '${n}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${n}'`);const E=l.URI.revive(a),{document:p}=this.i(n,E);this.c.delete(n,p),p.dispose()}async $resolveCustomEditor(a,n,c,E,p,I){const k=this.b.get(c);if(!k)throw new Error(`No provider found for '${c}'`);const s=S.ViewColumn.to(p),f=this.g.createNewWebview(n,E.contentOptions,k.extension),w=this.h.createNewWebviewPanel(n,c,E.title,s,E.options,f,E.active),R=l.URI.revive(a);switch(k.type){case 1:{const{document:W}=this.i(c,R);return k.provider.resolveCustomEditor(W,w,I)}case 0:{const W=this.d.getDocument(R);return k.provider.resolveCustomTextEditor(W,w,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,n,c){this.i(n,a).disposeEdits(c)}async $onMoveCustomEditor(a,n,c){const E=this.b.get(c);if(!E)throw new Error(`No provider found for '${c}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const p=this.h.getWebviewPanel(a);if(!p)throw new Error("No webview found");const I=l.URI.revive(n),k=this.d.getDocument(I);await E.provider.moveCustomTextEditor(k,p,v.CancellationToken.None)}async $undo(a,n,c,E){return this.i(n,a).undo(c,E)}async $redo(a,n,c,E){return this.i(n,a).redo(c,E)}async $revert(a,n,c){const E=this.i(n,a);await this.j(n).revertCustomDocument(E.document,c),E.disposeBackup()}async $onSave(a,n,c){const E=this.i(n,a);await this.j(n).saveCustomDocument(E.document,c),E.disposeBackup()}async $onSaveAs(a,n,c,E){const p=this.i(n,a);return this.j(n).saveCustomDocumentAs(p.document,l.URI.revive(c),E)}async $backup(a,n,c){const E=this.i(n,a),I=await this.j(n).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},c);return E.updateBackup(I),I.id}i(a,n){const c=this.c.get(a,l.URI.revive(n));if(!c)throw new Error("No custom document found");return c}j(a){const c=this.b.get(a)?.provider;if(!c||!o(c))throw new Error("Custom document is not editable");return c}}e.$Gcc=i;function o(r){return!!r.onDidChangeCustomDocument}function h(r){return typeof r.resolveCustomTextEditor=="function"}function y(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function m(r){const a=r.scheme===T.Schemas.file||r.scheme===T.Schemas.untitled?r.fsPath:r.toString();return(0,F.$pi)(a)+""}}),define(Ae[259],Re([1,0,5,6,2,36,8,64,3,7]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class P extends F.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,d,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new v.$fd),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$fd),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=d,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!d})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends F.$kc{static c(){return(0,T.$4f)()}constructor($,d,t){super(),this.j=d,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(S.$ZJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,d,t,i,o={}){const h=typeof i=="object"?i.viewColumn:i,y={viewColumn:A.ViewColumn.from(h),preserveFocus:typeof i=="object"&&!!i.preserveFocus},m=(0,l.$5bc)($),r=D.c();this.f.$createWebviewPanel((0,l.$7bc)($),r,d,{title:t,panelOptions:u(o),webviewOptions:(0,l.$8bc)($,this.m,o),serializeBuffersForPostMessage:m},y);const a=this.j.createNewWebview(r,o,$);return this.createNewWebviewPanel(r,d,t,h,o,a,!0)}$onDidChangeWebviewPanelViewStates($){const d=Object.keys($);d.sort((t,i)=>{const o=$[t],h=$[i];return o.active?1:h.active?-1:+o.visible-+h.visible});for(const t of d){const i=this.getWebviewPanel(t);if(!i)continue;const o=$[t];i._updateViewState({active:o.active,visible:o.visible,viewColumn:A.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,d,t){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:t,extension:$}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,l.$5bc)($)}),new g.$2J(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel($,d,t,i){const o=this.h.get(d);if(!o)throw new Error(`No serializer found for '${d}'`);const{serializer:h,extension:y}=o,m=this.j.createNewWebview($,t.webviewOptions,y),r=this.createNewWebviewPanel($,d,t.title,i,t.panelOptions,m,t.active);await h.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel($,d,t,i,o,h,y){const m=new P($,this.f,h,{viewType:d,title:t,viewColumn:i,panelOptions:o,active:y});return this.g.set($,m),m}getWebviewPanel($){return this.g.get($)}}e.$Fcc=D;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[260],Re([1,0,5,6,64,8,3,7]),function(be,e,v,F,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class S extends F.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,u,b,$,d,t){super(),this.#u=!1,this.#a=this.B(new v.$fd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new v.$fd),this.onDidDispose=this.#c.event,this.#i=b,this.#s=$,this.#e=D,this.#t=u,this.#l=d,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=T.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$ZJ.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,b,$){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,C.$7bc)(D),u,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$5bc)(D)}),new l.$2J(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,b,$,d){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:o}=t,h=this.d.createNewWebview(D,{},o),y=new S(D,this.a,u,b,h,!0);this.c.set(D,y),await i.resolveWebviewView(y,{state:$},d)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$Ecc=g}),define(Ae[109],Re([1,0,5,3,2,13,15,4,17,26]),function(be,e,v,F,C,T,A,l,S,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const $=this.d;return{get focused(){return $.focused},get active(){return(0,g.$QF)(b,"windowActivity"),$.active}}}constructor(b){this.c=new v.$fd,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(F.$ZJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:d})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,$){$!==this.d[b]&&(this.d={...this.d,[b]:$},this.c.fire(this.d))}openUri(b,$){let d;if(typeof b=="string"){d=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$me)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,d,$)}async asExternalUri(b,$){if((0,A.$me)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(b,$);return C.URI.from(d)}};e.$9bc=D,e.$9bc=D=P=Ke([qe(0,S.$2L)],D),e.$0bc=(0,l.$Bh)("IExtHostWindow")}),define(Ae[261],Re([1,0,228,27,17]),function(be,e,v,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let T=class extends v.$9cc{constructor(l,S){super(l,S)}f(l,S,g){S.apply(console,g)}};e.$dfc=T,e.$dfc=T=Ke([qe(0,C.$2L),qe(1,F.$fM)],T)}),define(Ae[262],Re([1,0,12,25,21,9,5,6,133,216,46]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=e.ResponsiveState=e.RequestInitiator=e.$B3b=e.$A3b=void 0;function u(w,R){try{return JSON.stringify(w,R)}catch{return"null"}}const b="$$ref$$",$={[b]:-1};class d{constructor(R,W){this.jsonString=R,this.referencedBuffers=W}}function t(w,R=null,W=!1){const V=[];return{jsonString:(W?u:JSON.stringify)(w,(B,O)=>{if(typeof O>"u")return $;if(typeof O=="object"){if(O instanceof F.$Fd){const N=V.push(O)-1;return{[b]:N}}if(R)return R(B,O)}return O}),referencedBuffers:V}}e.$A3b=t;function i(w,R,W){return JSON.parse(w,(V,U)=>{if(U){const B=U[b];if(typeof B=="number")return R[B];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$B3b=i;function o(w,R){return JSON.stringify(w,R)}function h(w){return w?(R,W)=>W&&W.$mid===1?w.transformOutgoing(W):W:null}var y;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));var m;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const r=()=>{},a=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class c extends l.$kc{static{D=a}static{this.a=3*1e3}constructor(R,W=null,V=null){super(),this[D]=!0,this.b=this.B(new A.$fd),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=W,this.g=V,this.h=h(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,B=P.$aA.count;U<B;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new v.$Sg(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const W=this.w[R];delete this.w[R],W.resolveErr(T.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,S.$Em)(R,this.g):R}getProxy(R){const{nid:W,sid:V}=R;return this.s[W]||(this.s[W]=this.J(W,V)),this.s[W]}J(R,W){const V={get:(U,B)=>(typeof B=="string"&&!U[B]&&B.charCodeAt(0)===36&&(U[B]=(...O)=>this.U(R,B,O)),B===n?W:U[B])};return new Proxy(Object.create(null),V)}set(R,W){return this.m[R.nid]=W,W}assertRegistered(R){for(let W=0,V=R.length;W<V;W++){const U=R[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(R){if(this.j)return;const W=R.byteLength,V=p.read(R,0),U=V.readUInt8(),B=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:ee}=k.deserializeRequestJSONArgs(V);this.g&&(ee=(0,S.$Em)(ee,this.g)),this.M(W,B,O,N,ee,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ee}=k.deserializeRequestMixedArgs(V);this.g&&(ee=(0,S.$Em)(ee,this.g)),this.M(W,B,O,N,ee,U===4);break}case 5:{this.f?.logIncoming(W,B,0,"ack"),this.G(B);break}case 6:{this.N(W,B);break}case 7:{this.O(W,B,void 0);break}case 9:{let O=k.deserializeReplyOKJSON(V);this.g&&(O=(0,S.$Em)(O,this.g)),this.O(W,B,O);break}case 10:{const O=k.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(W,B,O);break}case 8:{const O=k.deserializeReplyOKVSBuffer(V);this.O(W,B,O);break}case 11:{let O=k.deserializeReplyErrError(V);this.g&&(O=(0,S.$Em)(O,this.g)),this.P(W,B,O);break}case 12:{this.P(W,B,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,W,V,U,B,O){this.f?.logIncoming(R,W,1,`receiveRequest ${(0,P.$cA)(V)}.${U}(`,B);const N=String(W);let ee,Y;if(O){const ke=new C.$pd;B.push(ke.token),ee=this.Q(V,U,B),Y=()=>ke.cancel()}else ee=this.Q(V,U,B),Y=r;this.u[N]=Y;const Ee=k.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),ee.then(ke=>{delete this.u[N];const Pe=k.serializeReplyOK(W,ke,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",ke),this.c.send(Pe)},ke=>{delete this.u[N];const Pe=k.serializeReplyErr(W,ke);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",ke),this.c.send(Pe)})}N(R,W){this.f?.logIncoming(R,W,1,"receiveCancel");const V=String(W);this.u[V]?.()}O(R,W,V){this.f?.logIncoming(R,W,0,"receiveReply:",V);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U],B.resolveOk(V)}P(R,W,V){this.f?.logIncoming(R,W,0,"receiveReplyErr:",V);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),B.resolveErr(O)}Q(R,W,V){try{return Promise.resolve(this.S(R,W,V))}catch(U){return Promise.reject(U)}}S(R,W,V){const U=this.m[R];if(!U)throw new Error("Unknown actor "+(0,P.$cA)(R));const B=U[W];if(typeof B!="function")throw new Error("Unknown method "+W+" on actor "+(0,P.$cA)(R));return B.apply(U,V)}U(R,W,V){if(this.j)return new g.$z3b;let U=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(T.$4());const B=k.serializeRequestArguments(V,this.h),O=++this.t,N=String(O),ee=new g.$y3b,Y=new l.$jc;U&&Y.add(U.onCancellationRequested(()=>{const ke=k.serializeCancel(O);this.f?.logOutgoing(ke.byteLength,O,0,"cancel"),this.c.send(k.serializeCancel(O))})),this.w[N]=new E(ee,Y),this.F(O);const Ee=k.serializeRequest(O,R,W,B,!!U);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,P.$cA)(R)}.${W}(`,V),this.c.send(Ee),ee}}e.$C3b=c;class E{constructor(R,W){this.a=R,this.b=W}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class p{static alloc(R,W,V){const U=new p(F.$Fd.alloc(V+1+4),0);return U.writeUInt8(R),U.writeUInt32(W),U}static read(R,W){return new p(R,W)}get buffer(){return this.a}constructor(R,W){this.a=R,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+R);return this.b+=R,W}static sizeMixedArray(R){let W=0;W+=1;for(let V=0,U=R.length;V<U;V++){const B=R[V];switch(W+=1,B.type){case 1:W+=this.sizeLongString(B.value);break;case 2:W+=this.sizeVSBuffer(B.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(B.value);for(let O=0;O<B.buffers.length;++O)W+=this.sizeVSBuffer(B.buffers[O]);break;case 4:break}}return W}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let W=0,V=R.length;W<V;W++){const U=R[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let B=0;B<U.buffers.length;++B)this.writeBuffer(U.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const W=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:W[V]=this.readLongString();break;case 2:W[V]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),O=this.readLongString(),N=[];for(let ee=0;ee<B;++ee)N.push(this.readVSBuffer());W[V]=new P.$dA(i(O,N,null));break}case 4:W[V]=void 0;break}return W}}var I;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(I||(I={}));class k{static a(R){for(let W=0,V=R.length;W<V;W++)if(R[W]instanceof F.$Fd||R[W]instanceof P.$dA||typeof R[W]>"u")return!0;return!1}static serializeRequestArguments(R,W){if(this.a(R)){const V=[];for(let U=0,B=R.length;U<B;U++){const O=R[U];if(O instanceof F.$Fd)V[U]={type:2,value:O};else if(typeof O>"u")V[U]={type:4};else if(O instanceof P.$dA){const{jsonString:N,referencedBuffers:ee}=t(O.value,W);V[U]={type:3,value:F.$Fd.fromString(N),buffers:ee}}else V[U]={type:1,value:F.$Fd.fromString(o(O,W))}}return{type:1,args:V}}return{type:0,args:o(R,W)}}static serializeRequest(R,W,V,U,B){switch(U.type){case 0:return this.b(R,W,V,U.args,B);case 1:return this.c(R,W,V,U.args,B)}}static b(R,W,V,U,B){const O=F.$Fd.fromString(V),N=F.$Fd.fromString(U);let ee=0;ee+=p.sizeUInt8(),ee+=p.sizeShortString(O),ee+=p.sizeLongString(N);const Y=p.alloc(B?2:1,R,ee);return Y.writeUInt8(W),Y.writeShortString(O),Y.writeLongString(N),Y.buffer}static deserializeRequestJSONArgs(R){const W=R.readUInt8(),V=R.readShortString(),U=R.readLongString();return{rpcId:W,method:V,args:JSON.parse(U)}}static c(R,W,V,U,B){const O=F.$Fd.fromString(V);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(O),N+=p.sizeMixedArray(U);const ee=p.alloc(B?4:3,R,N);return ee.writeUInt8(W),ee.writeShortString(O),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(R){const W=R.readUInt8(),V=R.readShortString(),U=R.readMixedArray(),B=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const ee=U[O];typeof ee=="string"?B[O]=JSON.parse(ee):B[O]=ee}return{rpcId:W,method:V,args:B}}static serializeAcknowledged(R){return p.alloc(5,R,0).buffer}static serializeCancel(R){return p.alloc(6,R,0).buffer}static serializeReplyOK(R,W,V){if(typeof W>"u")return this.d(R);if(W instanceof F.$Fd)return this.e(R,W);if(W instanceof P.$dA){const{jsonString:U,referencedBuffers:B}=t(W.value,V,!0);return this.g(R,U,B)}else return this.f(R,u(W,V))}static d(R){return p.alloc(7,R,0).buffer}static e(R,W){let V=0;V+=p.sizeVSBuffer(W);const U=p.alloc(8,R,V);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,W){const V=F.$Fd.fromString(W);let U=0;U+=p.sizeLongString(V);const B=p.alloc(9,R,U);return B.writeLongString(V),B.buffer}static g(R,W,V){const U=F.$Fd.fromString(W);let B=0;B+=p.sizeUInt32,B+=p.sizeLongString(U);for(const N of V)B+=p.sizeVSBuffer(N);const O=p.alloc(10,R,B);O.writeUInt32(V.length),O.writeLongString(U);for(const N of V)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(R){const W=R.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(R,W){const V=R.readUInt32(),U=R.readLongString(),B=[];for(let O=0;O<V;++O)B.push(R.readVSBuffer());return new P.$dA(i(U,B,W))}static serializeReplyErr(R,W){const V=W?u(T.$1(W),null):void 0;if(typeof V!="string")return this.h(R);const U=F.$Fd.fromString(V);let B=0;B+=p.sizeLongString(U);const O=p.alloc(11,R,B);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(R){const W=R.readLongString();return JSON.parse(W)}static h(R){return p.alloc(12,R,0).buffer}}var s;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var f;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(f||(f={}))}),define(Ae[263],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;const v=function(T){const A=l=>{globalThis.removeEventListener("message",A);const S=l.data;Object.defineProperties(globalThis,{postMessage:{value(g,P){S.postMessage(g,P)}},onmessage:{get(){return S.onmessage},set(g){S.onmessage=g}}}),S.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class F extends EventTarget{constructor(T,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${v})('${A}'))`,g=new Blob([S],{type:"application/javascript"}),P=URL.createObjectURL(g),D=new MessageChannel,u=P,b={type:"_newWorker",id:u,port:D.port2,url:P,options:l};T(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{T({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const d=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(d)}),D.port1.addEventListener("message",$=>{const d=new MessageEvent("message",{data:$.data});this.dispatchEvent(d)}),D.port1.start()}}e.$ffc=F}),define(Ae[264],Re([1,0,5,30,32,4]),function(be,e,v,F,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.OutputChannelUpdateMode=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I="text/x-code-output",e.$7I="output",e.$8I="Log",e.$9I="text/x-code-log-output",e.$0I="log",e.$$I="log",e.$_I="workbench.panel.output",e.$aJ=new C.$2i("inOutput",!1),e.$bJ=new C.$2i("activeLogOutput",!1),e.$cJ=new C.$2i("outputView.scrollLock",!1),e.$dJ=(0,T.$Bh)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$eJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new v.$fd,this.onDidRegisterChannel=this.b.event,this.c=new v.$fd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}F.$8m.add(e.$eJ.OutputChannels,new l),e.$fJ=new C.$2i("activeOutputChannel","")}),define(Ae[110],Re([1,0,3,4,17,20,14,264,62,27,39,130,25,16,38,5,6]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=void 0;class i extends A.$$i{get disposed(){return this.n}constructor(m,r,a,n,c){super(),this.id=m,this.name=r,this.r=a,this.s=n,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(m){this.append(m+`
`)}append(m){this.info(m)}clear(){const m=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,m)}replace(m){const r=this.m;this.info(m),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(m,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof m=="boolean"?m:r))}hide(){this.s.$close(this.id)}g(m,r){this.m+=u.$Fd.fromString(r).byteLength,(0,A.log)(this.r,m,r),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class o extends i{appendLine(m){this.append(m)}}let h=class{constructor(m,r,a,n,c,E){this.i=r,this.j=a,this.k=n,this.l=c,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=m.getProxy(v.$ZJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.h=m;for(const[r,a]of this.g)a.visible=r===this.h}createOutputChannel(m,r,a){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,c=(0,b.$jf)(r)?r:void 0;if((0,b.$jf)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const p=this.i.environment.extensionLogLevel?.find(([k])=>T.$Vl.equals(a.identifier,k))?.[1];p&&(E=(0,A.$ij)(p));const I=n?this.o(m,E,a):this.n(m,c,a);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),n?this.r(m,E??this.m.getLevel(),I):this.q(m,I)}async n(m,r,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,c=this.k.extUri.joinPath(n,`${this.f++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(m,c,r,a.identifier.value);return new i(p,m,E,this.a,a)}async o(m,r,a){const n=await this.p(a),c=m.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(n,`${c}.log`),p=`${a.identifier.value}.${c}`,I=this.l.createLogger(E,{id:p,name:m,logLevel:r,extensionId:a.identifier.value});return new o(p,m,I,this.a,a)}p(m){let r=this.d.get(m.identifier.value);if(!r){const a=this.k.extUri.joinPath(this.i.logsLocation,m.identifier.value);this.d.set(m.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(a)}catch(n){if((0,$.$ik)(n)!==$.FileSystemProviderErrorCode.FileExists)throw n}return a})())}return r}q(m,r){let a=!1;const n=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return m},append(c){n(),r.then(E=>E.append(c))},appendLine(c){n(),r.then(E=>E.appendLine(c))},clear(){n(),r.then(c=>c.clear())},replace(c){n(),r.then(E=>E.replace(c))},show(c,E){n(),r.then(p=>p.show(c,E))},hide(){n(),r.then(c=>c.hide())},dispose(){a=!0,r.then(c=>c.dispose())}}}r(m,r,a){const n=new t.$jc,c=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},E=n.add(new d.$fd);function p(I){r=I,E.fire(I)}return a.then(I=>{n.add(I),I.logLevel!==r&&p(I.logLevel),n.add(I.onDidChangeLogLevel(k=>p(k)))}),{...this.q(m,a),get logLevel(){return r},onDidChangeLogLevel:E.event,trace(I,...k){c(),a.then(s=>s.trace(I,...k))},debug(I,...k){c(),a.then(s=>s.debug(I,...k))},info(I,...k){c(),a.then(s=>s.info(I,...k))},warn(I,...k){c(),a.then(s=>s.warn(I,...k))},error(I,...k){c(),a.then(s=>s.error(I,...k))},dispose(){n.dispose()}}}};e.$Sbc=h,e.$Sbc=h=Ke([qe(0,C.$2L),qe(1,g.$fM),qe(2,S.$vbc),qe(3,P.$3ac),qe(4,A.$6i),qe(5,A.$5i)],h),e.$Tbc=(0,F.$Bh)("IExtHostOutputService")}),define(Ae[265],Re([1,0,4,12]),function(be,e,v,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0,e.$jm=(0,v.$Bh)("remoteAgentService"),e.$km=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let l=0;l<this.maxSampleCount;l++){const S=await C.getRoundTripTime();if(S===void 0)return;T=Math.min(T,S/2),await(0,F.$Hg)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((l,S)=>l+S,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((l,S)=>l+S,0)/this.average.length,high:(()=>typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[266],Re([1,0,42,13,19,22,23,2,4,187,54,209,265]),function(be,e,v,F,C,T,A,l,S,g,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=void 0,e.$xJ=(0,S.$Bh)("pathService");let $=b=class{constructor(t,i,o,h){this.d=t,this.e=i,this.f=o,this.g=h,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const y=await this.e.getEnvironment();return this.c=y?.userHome??t})()}hasValidBasename(t,i,o){return typeof i=="string"||typeof i>"u"?this.a.then(h=>this.h(t,h,i)):this.h(t,i,o)}h(t,i,o){return t.scheme===F.Schemas.file||t.scheme===F.Schemas.vscodeRemote?(0,v.$Gf)(o??(0,A.$fg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return F.Schemas.vscodeRemote;const o=(0,g.$uJ)(i.getWorkspace());if(o)return o;const h=i.getWorkspace().folders[0];if(h)return h.uri.scheme;const y=i.getWorkspace().configuration;return y?y.scheme:F.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$5d:C.$6d)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const h=t.indexOf("/",2);h===-1?(i=t.substring(2),t="/"):(i=t.substring(2,h),t=t.substring(h)||"/")}return l.URI.from({scheme:F.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$yJ=$,e.$yJ=$=b=Ke([qe(1,u.$jm),qe(2,D.$gJ),qe(3,P.$Kh)],$)}),define(Ae[111],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$hI=e.$gI=void 0;class v{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new v(0,0)}with(A){return new v(0,0)}}e.$gI=v;class F{constructor(A,l,S,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,l),this.end=new v(S,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$hI=F;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,111,12]),function(be,e,v,F,C,T,A,l,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.SearchErrorCode=e.$wI=e.$vI=e.SearchSortOrder=e.ViewMode=e.$uI=e.$tI=e.$sI=e.$rI=e.SearchCompletionExitCode=e.$qI=e.$pI=e.$oI=e.QueryType=e.SearchProviderType=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$iI="workbench.view.search",e.$jI="workbench.panel.search",e.$kI="workbench.view.search",e.$lI="search-result",e.$mI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",$=(u.length+b.length+5)*2;e.$nI=(0,l.$Bh)("searchService");var d;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(t||(e.QueryType=t={}));function i(X){return!!X.preview}e.$oI=i;function o(X){return!!X.resource}e.$pI=o;function h(X){return!!X.message}e.$qI=h;var y;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(y||(e.SearchCompletionExitCode=y={}));class m{constructor(ue){this.resource=ue,this.results=[]}}e.$rI=m;class r{constructor(ue,ye,ce,$e){this.ranges=ye,this.webviewIndex=$e;const ie=Array.isArray(ye)?ye:[ye];if(ce&&ce.matchLines===1&&a(ie)){ue=(0,A.$cf)(ue,ce.matchLines);let z="",q=0,le=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const ge of ie){const De=Math.max(ge.startColumn-we,0),ne=ge.startColumn+ce.charsPerLine;if(De>le+we+$){const he=u+(De-le)+b;z+=he+ue.slice(De,ne),q+=De-(le+he.length)}else z+=ue.slice(le,ne);ve.push(new c(0,ge.startColumn-q,ge.endColumn-q)),le=ne}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(ye)?ye[0].startLineNumber:ye.startLineNumber;this.preview={text:ue,matches:(0,v.$Zb)(ye,q=>new n(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$sI=r;function a(X){const ue=X[0].startLineNumber;for(const ye of X)if(ye.startLineNumber!==ue||ye.endLineNumber!==ue)return!1;return!0}class n{constructor(ue,ye,ce,$e){this.startLineNumber=ue,this.startColumn=ye,this.endLineNumber=ce,this.endColumn=$e}}e.$tI=n;class c extends n{constructor(ue,ye,ce){super(ue,ye,ue,ce)}}e.$uI=c;var E;(function(X){X.List="list",X.Tree="tree"})(E||(e.ViewMode=E={}));var p;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function I(X,ue=!0){const ye=X&&X.files&&X.files.exclude,ce=ue&&X&&X.search&&X.search.exclude;if(!ye&&!ce)return;if(!ye||!ce)return ye||ce;let $e=Object.create(null);return $e=C.$Ym($e,C.$Vm(ye)),$e=C.$Ym($e,C.$Vm(ce),!0),$e}e.$vI=I;function k(X,ue){return X.excludePattern&&F.$qj(X.excludePattern,ue)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&F.$qj(X.includePattern,ue)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(ye=>{const ce=ye.folder.fsPath;if(T.$If(ue,ce)){const $e=S.$$d(ce,ue);return!ye.includePattern||!!F.$qj(ye.includePattern,$e)}else return!1}):!1:!0}e.$wI=k;var s;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(s||(e.SearchErrorCode=s={}));class f extends Error{constructor(ue,ye){super(ue),this.code=ye}}e.$xI=f;function w(X){const ue=X.message;if((0,g.$2)(X))return new f(ue,s.canceled);try{const ye=JSON.parse(ue);return new f(ye.message,ye.code)}catch{return new f(ue,s.other)}}e.$yI=w;function R(X){const ue={message:X.message,code:X.code};return new Error(JSON.stringify(ue))}e.$zI=R;function W(X){return X.type==="error"?!0:X.type==="success"}e.$AI=W;function V(X){return X.type==="success"}e.$BI=V;function U(X){return!!X.path}e.$CI=U;function B(X,ue){const ye=X.searchPath?X.searchPath:X.relativePath;return(0,A.$_e)(ye,ue)}e.$DI=B;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$EI=O;function N(X,ue){const ye={...X||{},...ue||{}};return Object.keys(ye).filter(ce=>{const $e=ye[ce];return typeof $e=="boolean"&&$e})}e.$FI=N;class ee{constructor(ue,ye){this.c=null,this.a={...ue.excludePattern||{},...ye.excludePattern||{}},this.b=F.$rj(this.a);let ce=ue.includePattern;ye.includePattern&&(ce?ce={...ce,...ye.includePattern}:ce=ye.includePattern),ce&&(this.c=F.$rj(ce))}matchesExcludesSync(ue,ye,ce){return!!(this.b&&this.b(ue,ye,ce))}includedInQuerySync(ue,ye,ce){return!(this.b&&this.b(ue,ye,ce)||this.c&&!this.c(ue,ye,ce))}includedInQuery(ue,ye,ce){const $e=this.b(ue,ye,ce),ie=()=>this.c?!!this.c(ue,ye,ce):!0;return(0,D.$tg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$GI=ee;function Y(X){for(const ue in X)if(typeof X[ue]!="boolean")return!0;return!1}function Ee(X){if(!X)return;let ue;return ye=>(ue||(ue=(X()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),ue.then(ce=>!!ce[ye]))}e.$HI=Ee;function ke(X){if(!X)return;let ue;return ye=>{if(!ue){const ce=X();ue=ce?Pe(ce):{}}return!!ue[ye]}}e.$II=ke;function Pe(X){const ue={};for(const ye of X)ue[ye]=!0;return ue}}),define(Ae[33],Re([1,0,18,12,21,5,6,48,13,118,23,15,2,159,4,14,176,54,39,27,17,8,7,56,47,3]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r,a,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0;function E(W,V,U){return new P.$0f(B=>s(B,U)).isEqual(W,V)}function p(W,V,U){return E(W.uri,V.uri,U)?0:(0,D.$Fe)(W.uri.toString(),V.uri.toString())}function I(W,V,U){return W.index!==V.index?W.index<V.index?-1:1:E(W.uri,V.uri,U)?(0,D.$Fe)(W.name,V.name):(0,D.$Fe)(W.uri.toString(),V.uri.toString())}function k(W,V,U,B){const O=W.slice(0).sort((ee,Y)=>U(ee,Y,B)),N=V.slice(0).sort((ee,Y)=>U(ee,Y,B));return(0,v.$Cb)(O,N,(ee,Y)=>U(ee,Y,B))}function s(W,V){const U=V.getCapabilities(W.scheme);return!(U&&U&1024)}class f extends i.$Uh{static toExtHostWorkspace(V,U,B,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:N,name:ee,folders:Y,configuration:Ee,transient:ke,isUntitled:Pe}=V,X=[],ue=U;U?Y.forEach((ie,z)=>{const q=u.URI.revive(ie.uri),le=f.o(B||U,q,O);le?(le.name=ie.name,le.index=ie.index,X.push(le)):X.push({uri:q,name:ie.name,index:z})}):X.push(...Y.map(({uri:ie,name:z,index:q})=>({uri:u.URI.revive(ie),name:z,index:q}))),X.sort((ie,z)=>ie.index<z.index?-1:1);const ye=new f(N,ee,X,!!ke,Ee?u.URI.revive(Ee):null,!!Pe,ie=>s(ie,O)),{added:ce,removed:$e}=k(ue?ue.workspaceFolders:[],ye.workspaceFolders,p,O);return{workspace:ye,added:ce,removed:$e}}static o(V,U,B){for(let O=0;O<V.folders.length;O++){const N=V.workspaceFolders[O];if(E(N.uri,U,B))return N}}constructor(V,U,B,O,N,ee,Y){super(V,B.map(Ee=>new i.$Vh(Ee)),O,N,Y),this.t=U,this.u=ee,this.q=[],this.s=l.$Hh.forUris(Y),B.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,P.$hg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let w=class{constructor(V,U,B,O,N){this.c=new T.$fd,this.onDidChangeWorkspace=this.c.event,this.g=new T.$fd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$hd,this.B=new Map,this.h=O,this.s=B,this.t=N,this.j=new g.$Jl,this.k=new F.$Fg,this.o=V.getProxy(c.$ZJ.MainThreadWorkspace),this.q=V.getProxy(c.$ZJ.MainThreadMessageService);const ee=U.workspace;this.l=ee?new f(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,Y=>s(Y,B)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:S.Schemas.untitled,path:(0,P.$fg)((0,P.$hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,B,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{u.URI.isUri(Pe.uri)&&!N.some(X=>E(X.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.$eg)(Pe.uri)})}),this.n||[U,B].some(Pe=>typeof Pe!="number"||Pe<0)||B===0&&N.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+B>ee.length)return!1;const Y=ee.slice(0);Y.splice(U,B,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$eg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Y.length;Pe++){const X=Y[Pe];if(Y.some((ue,ye)=>ye!==Pe&&E(X.uri,ue.uri,this.s)))return!1}Y.forEach((Pe,X)=>Pe.index=X);const{added:Ee,removed:ke}=k(ee,Y,I,this.s);if(Ee.length===0&&ke.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,U,B,N).then(void 0,X=>{this.n=void 0;const ue={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Pe,X.toString()),ue,[])})}return this.y(Y),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let B,O="";if(typeof V=="string"?(B=u.URI.file(V),O=V):typeof V<"u"&&(B=V,O=V.fsPath),!B)return O;const N=this.getWorkspaceFolder(B,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,P.$kg)(N.uri,B);return U&&N.name&&(ee=`${N.name}/${ee}`),ee}y(V){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:B,removed:O}=f.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:O}))}findFiles(V,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ee;if(U===null?ee=!1:U&&(typeof U=="string"?ee=U:ee=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:Ee}=R(m.GlobPattern.from(V));return this.o.$startFileSearch(Y??null,Ee??null,ee??null,B??null,N).then(ke=>Array.isArray(ke)?ke.map(Pe=>u.URI.revive(Pe)):[])}async findTextInFiles(V,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),Y=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Ee,folder:ke}=R(m.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,X={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Y,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Ee,excludePattern:Pe},ue=!1;if(this.u[ee]=ye=>{if(ue)return;const ce=u.URI.revive(ye.resource);ye.results.forEach($e=>{(0,n.$oI)($e)?B({uri:ce,preview:{text:$e.preview.text,matches:(0,v.$Zb)($e.preview.matches,ie=>new r.$4J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,v.$Zb)($e.ranges,ie=>new r.$4J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):B({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(V,ke??null,X,ee,N);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return u.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return u.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const B=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,B),(0,A.$ic)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const B=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const O=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(B,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(V,U,B,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ee=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ee),!ee)return;const Y=await ee.provideEditSessionIdentityMatch?.(U,B,O);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(V){return(U,B,O)=>{const N=function(Y){U.call(B,Y)};return N.extension=V,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(V,U,B){const O=await this.resolveWorkspaceFolder(u.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,ee)=>{const Y=Date.now();await Promise.resolve(N),Date.now()-Y>B&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const B=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,B),(0,A.$ic)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,U,B){const O=this.B.get(V.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(u.URI.revive(V),U,B);if(N)return N}async $provideCanonicalUri(V,U,B){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:U},B)}};e.$cbc=w,e.$cbc=w=Ke([qe(0,y.$2L),qe(1,h.$fM),qe(2,o.$3ac),qe(3,d.$5i),qe(4,a.$abc)],w),e.$dbc=(0,$.$Bh)("IExtHostWorkspace");function R(W){let V,U;return W&&(typeof W=="string"?V=W:(V=W.pattern,U=u.URI.revive(W.baseUri))),{includePattern:V,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,3,7,178,96,16,12,4,17,14,2]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=e.$ebc=void 0;function d(a,n){if(n){const c=n.split(".");let E=a;for(let p=0;E&&p<c.length;p++)E=E[c[p]];return E}}function t(a){return a instanceof $.URI}function i(a){return a&&a.uri instanceof $.URI&&a.languageId&&typeof a.languageId=="string"}function o(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function h(a){return a&&a.uri instanceof $.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function y(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(o(a))return{overrideIdentifier:a.languageId};if(h(a))return{resource:a.uri};if(a===null)return{resource:null}}let m=class{constructor(n,c,E){this.a=n.getProxy(T.$ZJ.MainThreadConfiguration),this.c=c,this.b=E,this.d=new P.$Fg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new r(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,c){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(n,c))}};e.$ebc=m,e.$ebc=m=Ke([qe(0,u.$2L),qe(1,C.$dbc),qe(2,b.$5i)],m);class r{constructor(n,c,E,p){this.a=new F.$fd,this.b=n,this.f=p,this.c=c,this.e=l.$tn.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,c){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$tn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(c,E))}getConfiguration(n,c,E){const p=y(c)||{},I=this.g(n?d(this.e.getValue(void 0,p,this.c.workspace),n):this.e.getValue(void 0,p,this.c.workspace));n&&this.h(n,p,E?.identifier);function k(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const s={has(f){return typeof d(I,f)<"u"},get:(f,w)=>{this.h(n?`${n}.${f}`:f,p,E?.identifier);let R=d(I,f);if(typeof R>"u")R=w;else{let W;const V=(U,B)=>{if((0,g.$lf)(U)){let O;const N=()=>{W=W||(0,v.$Vm)(I),O=O||d(W,B)};return new Proxy(U,{get:(ee,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||d(W,B),O[Y];const Ee=ee[Y];return typeof Y=="string"?V(Ee,`${B}.${Y}`):Ee},set:(ee,Y,Ee)=>(N(),O&&(O[Y]=Ee),!0),deleteProperty:(ee,Y)=>(N(),O&&delete O[Y],!0),defineProperty:(ee,Y,Ee)=>(N(),O&&Object.defineProperty(O,Y,Ee),!0)})}return Array.isArray(U)?(0,v.$Vm)(U):U};R=V(R,f)}return R},update:(f,w,R,W)=>{f=n?`${n}.${f}`:f;const V=k(R);return w!==void 0?this.b.$updateConfigurationOption(V,f,w,p,W):this.b.$removeConfigurationOption(V,f,p,W)},inspect:f=>{f=n?`${n}.${f}`:f;const w=this.e.inspect(f,p,this.c.workspace);if(w)return{key:f,defaultValue:(0,v.$Vm)(w.policy?.value??w.default?.value),globalValue:(0,v.$Vm)(w.user?.value??w.application?.value),workspaceValue:(0,v.$Vm)(w.workspace?.value),workspaceFolderValue:(0,v.$Vm)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$Vm)(w.default?.override),globalLanguageValue:(0,v.$Vm)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$Vm)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$Vm)(w.workspaceFolder?.override),languageIds:(0,v.$Vm)(w.overrideIdentifiers)}}};return typeof I=="object"&&(0,v.$Ym)(s,I,!1),Object.freeze(s)}g(n){const c=E=>(0,g.$lf)(E)?new Proxy(E,{get:(p,I)=>c(p[I]),set:(p,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(p,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(p,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return c(n)}h(n,c,E){const p=S.$kn.test(n)?4:this.d.get(n),I=E?`[${E.value}] `:"";if(p===4){typeof c?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){c?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,c){const E=new l.$vn(n,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,I)=>E.affectsConfiguration(p,y(I))})}k(n){return n.reduce((c,E)=>(c.set(E[0],E[1]),c),new Map)}}e.$fbc=r,e.$gbc=(0,D.$Bh)("IExtHostConfiguration")}),define(Ae[112],Re([1,0,2,12,5,3,7,33,60,34,21,63,17,27,4,13,22,14,80,215,9]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var m;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(m||(m={}));var r;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(r||(r={}));var a;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(a||(a={}));var n;(function(V){function U(N){if(N){const ee=N;return ee&&!!ee.process}else return!1}V.is=U;function B(N){if(N==null)return;const ee={process:N.process,args:N.args};return N.options&&(ee.options=a.from(N.options)),ee}V.from=B;function O(N){if(N!=null)return new A.$KK(N.process,N.args,N.options)}V.to=O})(n||(n={}));var c;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(c||(c={}));var E;(function(V){function U(N){if(N){const ee=N;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=U;function B(N){if(N==null)return;const ee={};return N.commandLine!==void 0?ee.commandLine=N.commandLine:(ee.command=N.command,ee.args=N.args),N.options&&(ee.options=c.from(N.options)),ee}V.from=B;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$LK(N.commandLine,N.options):new A.$LK(N.command,N.args?N.args:[],N.options)}V.to=O})(E||(E={}));var p;(function(V){function U(N){if(N){const ee=N;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=U;function B(N){return{customExecution:"customExecution"}}V.from=B;function O(N,ee){return ee.get(N)}V.to=O})(p||(e.CustomExecutionDTO=p={}));var I;(function(V){function U(B,O){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=h.$_F),{id:B._id,workspaceFolder:N}}V.from=U})(I||(e.TaskHandleDTO=I={}));var k;(function(V){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}V.from=U})(k||(k={}));var s;(function(V){function U(N,ee){if(N==null)return[];const Y=[];for(const Ee of N){const ke=B(Ee,ee);ke&&Y.push(ke)}return Y}V.fromMany=U;function B(N,ee){if(N==null)return;let Y;N.execution instanceof A.$KK?Y=n.from(N.execution):N.execution instanceof A.$LK?Y=E.from(N.execution):N.execution&&N.execution instanceof A.$MK&&(Y=p.from(N.execution));const Ee=m.from(N.definition);let ke;return N.scope?typeof N.scope=="number"?ke=N.scope:ke=N.scope.uri:ke=A.TaskScope.Workspace,!Ee||!ke?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:ee.identifier.value,label:N.source,scope:ke},execution:Y,isBackground:N.isBackground,group:k.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=B;async function O(N,ee,Y){if(N==null)return;let Ee;n.is(N.execution)?Ee=n.to(N.execution):E.is(N.execution)?Ee=E.to(N.execution):p.is(N.execution)&&(Ee=p.to(N._id,Y));const ke=m.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ee.resolveWorkspaceFolder(v.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!ke||!Pe)return;const X=new A.$NK(ke,Pe,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&(X.isBackground=N.isBackground),N.group!==void 0&&(X.group=A.$JK.from(N.group._id),X.group&&N.group.isDefault&&(X.group=new A.$JK(X.group.id,X.group.label),N.group.isDefault===!0&&(X.group.isDefault=N.group.isDefault))),N.presentationOptions&&(X.presentationOptions=r.to(N.presentationOptions)),N._id&&(X._id=N._id),N.detail&&(X.detail=N.detail),X}V.to=O})(s||(e.TaskDTO=s={}));var f;(function(V){function U(O){return O}V.from=U;function B(O){if(O)return Object.assign(Object.create(null),O)}V.to=B})(f||(f={}));class w{#e;constructor(U,B,O){this._id=B,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let R=class{constructor(U,B,O,N,ee,Y,Ee,ke){this.q=new C.$fd,this.r=new C.$fd,this.s=new C.$fd,this.t=new C.$fd,this.a=U.getProxy(T.$ZJ.MainThreadTask),this.b=O,this.c=N,this.d=ee,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,O){if(!O)return new A.$2J(()=>{});const N=this.w();return this.j.set(N,{type:B,provider:O,extension:U}),this.a.$registerTaskProvider(N,B),new A.$2J(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,B){this.a.$registerTaskSystem(U,B)}fetchTasks(U){return this.a.$fetchTasks(f.from(U)).then(async B=>{const O=[];for(const N of B){const ee=await s.to(N,this.b,this.m);ee&&O.push(ee)}return O})}get taskExecutions(){const U=[];return this.k.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,B,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(B,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const B=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const B=await this.y(U.id);this.s.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const B=await this.y(U.id);this.t.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ee=(0,F.$zg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(Y=>this.u(B,N,O,Y));return new Promise(Y=>{ee.then(Ee=>{Promise.all(N).then(()=>{Y(Ee)})})})}async $resolveTask(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(B.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await s.to(B,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ee=await O.provider.resolveTask(N,P.CancellationToken.None);if(!ee)return;this.z(ee,O);const Y=s.from(ee,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(Y.execution)&&await this.x(Y,ee,!0),await this.v(Y)}w(){return this.h++}async x(U,B,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,B.execution)),this.m.set(N,B.execution)}async y(U,B){if(typeof U=="string"){const ee=this.l.get(U);if(!ee)throw new y.$_("Unexpected: The specified task is missing an execution");return ee}const O=this.l.get(U.id);if(O)return O;const N=new Promise((ee,Y)=>{function Ee(ke,Pe,X){X?ee(new w(ke,Pe.id,X)):Y("Unexpected: Task does not exist.")}B?Ee(this,U,B):s.to(U.task,this.b,this.m).then(ke=>Ee(this,U,ke))});return this.l.set(U.id,N),N.then(ee=>(this.k.set(U.id,ee),ee),ee=>Promise.reject(ee))}z(U,B){U._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$ccc=R,e.$ccc=R=Ke([qe(0,u.$2L),qe(1,b.$fM),qe(2,l.$dbc),qe(3,S.$aM),qe(4,g.$gbc),qe(5,D.$ybc),qe(6,i.$5i),qe(7,o.$6ac)],R);let W=class extends R{constructor(U,B,O,N,ee,Y,Ee,ke){super(U,B,O,N,ee,Y,Ee,ke),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const O=s.from(B,U);if(O===void 0)throw new Error("Task is not valid");if(p.is(O.execution))await this.x(O,B,!1);else throw new y.$0;const N=await this.y(await this.a.$getTaskExecution(O),B);return this.a.$executeTask(O).catch(ee=>{throw new Error(ee)}),N}u(U,B,O,N){const ee=[];if(N)for(const Y of N){this.z(Y,O),(!Y.definition||!U[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=s.from(Y,O.extension);Ee&&p.is(Ee.execution)?(ee.push(Ee),B.push(this.x(Ee,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:O.extension}}async v(U){if(p.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,O){}};e.$dcc=W,e.$dcc=W=Ke([qe(0,u.$2L),qe(1,b.$fM),qe(2,l.$dbc),qe(3,S.$aM),qe(4,g.$gbc),qe(5,D.$ybc),qe(6,i.$5i),qe(7,o.$6ac)],W),e.$ecc=(0,$.$Bh)("IExtHostTask")}),define(Ae[267],Re([1,0,19,21,41,37,23,59,47]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class g{constructor(u,b,$){this.k=u,this.l=b,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&T.$rj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&T.$rj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise(($,d)=>{const t=i=>{this.f++,u(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const o=i.toString(),h=v.$ae(o);this.j&&this.j(o,h)||this.v(t,{base:i,basename:h})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{d(new Error((0,C.$mi)(i)))})})}async p(u,b){const $=new F.$pd,d=this.q(u),t=this.r(),i=new S.$GI(this.k,u),o=!i.hasSiblingExcludeClauses();let h;try{this.h.add($),h=l.$bd.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,$.token),m=h.elapsed(),r=l.$bd.create();return this.g&&!this.e||(y&&y.forEach(a=>{const n=v.$6d.relative(u.folder.path,a.path);if(o){const c=v.$ae(a.path);this.v(b,{base:u.folder,relativePath:n,basename:c});return}this.s(t,u.folder,n,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:m,postProcessTime:r.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(u){const b=(0,S.$FI)(this.k.includePattern,u.includePattern),$=(0,S.$FI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:$,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,$,d){if($===this.a){const i=v.$ae(this.a);this.v(d,{base:b,relativePath:this.a,basename:i})}function t(i){const o=v.$ae(i),h=v.$_d(i);let y=u[h];y||(y=u[h]=[],t(h)),y.push({base:b,relativePath:i,basename:o})}t($)}u({rootEntries:u,pathToEntries:b},$,d){const t=this,i=this.a;function o(h){const y=(0,S.$II)(()=>h.map(m=>m.basename));for(let m=0,r=h.length;m<r;m++){const a=h[m],{relativePath:n,basename:c}=a;if($.matchesExcludesSync(n,c,i!==c?y:void 0))continue;const E=b[n];if(E)o(E);else{if(n===i)continue;t.v(d,a)}if(t.e)break}}o(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,$,d){const t=this.c(u.cacheKey),i=new g(u,b,t&&t.token);let o=0;const h=y=>{o+=y.length,$(y.map(m=>this.d(m)))};return this.e(i,P.a,h,d).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:o,detailStats:y.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new F.$pd),this.b.get(u)}d(u){return u.relativePath?{resource:A.$ig(u.base,u.relativePath)}:{resource:u.base}}e(u,b,$,d){const t=d.onCancellationRequested(()=>{u.cancel()}),i=h=>{h&&(o.push(h),b>0&&o.length>=b&&($(o),o=[]))};let o=[];return u.search(i).then(h=>(o.length&&$(o),t.dispose(),h),h=>(o.length&&$(o),t.dispose(),Promise.reject(h)))}}e.$occ=P}),define(Ae[268],Re([1,0,18,100,37,90,28,13,19,23,15,16,2,283,168,43,14,54,103,266,47]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJ=e.$zJ=void 0;let m=class{constructor(f,w,R,W,V){this.a=f,this.b=w,this.c=R,this.d=W,this.e=V}text(f,w,R={}){f=this.f(f,R);const W=this.a.getValue(),V=w&&w.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(w?.map(i.$Wh),R),type:2,contentPattern:f,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:W.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(f,w){const R=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const W={...f,wordSeparators:R.editor.wordSeparators};return this.j(f,w)&&(W.isCaseSensitive=!0),this.k(f)&&(W.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),W}file(f,w={}){return{...this.h(f,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(f,w){return f?(f=Array.isArray(f)?f.map(E):E(f),w?this.parseSearchPaths(f):{pattern:a(...Array.isArray(f)?f:[f])}):{}}h(f=[],w={}){const R=this.g(w.includePattern,w.expandPatterns),W=this.g(w.excludePattern,w.expandPatterns),V=f.length>1,U=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.q(N,w,W)):f.map(N=>this.r(N,w,W,V))).filter(N=>!!N),B={_reason:w._reason,folderQueries:U,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:W.pattern,includePattern:R.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const N=v.$Fb(v.$Pb(this.c.groups.map(Ee=>Ee.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ee=N.filter(Ee=>(0,y.$wI)(B,Ee.fsPath)),Y=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...B,...Y}}const O=w.extraFileResources&&w.extraFileResources.filter(N=>(0,y.$wI)(B,N.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(f){const w=[],R=new A.$zi,W={};let V=!1;return f.forEach(U=>{if(U.scheme===l.Schemas.walkThrough)return;if((0,g.$mg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:S.$_d(U.fsPath)});let N=R.get(O);N||(V=!0,N={folder:O,includePattern:{}},w.push(N),R.set(O,N));const ee=S.$$d(O.fsPath,U.fsPath);(0,D.$uf)(N.includePattern)[ee.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,W[U.fsPath]=!0)}),{folderQueries:w,includePattern:W,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(f,w){if(w.isSmartCase){if(f.isRegExp){if(P.$af(f.pattern,!0))return!0}else if(P.$af(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,b.$iC)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const w=Y=>S.$8d(Y)||/^\.\.?([\/\\]|$)/.test(Y),W=(Array.isArray(f)?f:n(f)).map(Y=>{const Ee=this.e.resolvedUserHome;return Ee?(0,T.$hA)(Y,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):Y}),V=F.$I(W,Y=>w(Y)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(Y=>P.$ve(Y,"/")).map(Y=>P.$ve(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),c(Y))),B={},O=this.m(V.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const N=v.$Pb(U),ee=a(...N);return ee&&(B.pattern=ee),B}l(f,w){return w.disregardExcludeSettings?void 0:(0,y.$vI)(f,!w.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const w=f.flatMap(W=>{let{pathPortion:V,globPortion:U}=r(W);return U&&(U=p(U)),this.n(V).flatMap(O=>this.o(O,U))}),R=new Map;return w.forEach(W=>{const V=W.searchPath.toString(),U=R.get(V);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):R.set(V,{searchPath:W.searchPath,pattern:W.pattern?a(W.pattern):void 0})}),Array.from(R.values())}n(f){if(S.$8d(f)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==l.Schemas.file?[{searchPath:w[0].uri.with({path:f})}]:[{searchPath:u.URI.file(S.$7d(f))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(f=E(f),f.startsWith("../")||f===".."){const W=S.$6d.resolve(w.path,f);return[{searchPath:w.with({path:W})}]}const R=p(f);return[{searchPath:w,pattern:R}]}else{if(f==="./"||f===".\\")return[];{const w=f.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(V=>{const U=w.match(new RegExp(`^${P.$qe(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(D.$rf);if(W.length)return W.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&p(U)}});{const V=f.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:f,B=$.localize(0,null,U);throw new Error(B)}}}}o(f,w){const R=f.pattern&&w?`${f.pattern}/${w}`:f.pattern||w,W=[{searchPath:f.searchPath,pattern:R}];return R&&!R.endsWith("**")&&W.push({searchPath:f.searchPath,pattern:R+"/**"}),W}q(f,w,R){const W=this.r((0,i.$Wh)(f.searchPath),w,R,!1);return W?{...W,includePattern:f.pattern}:null}r(f,w,R,W){let V;const U=u.URI.isUri(f)?f:f.uri;if(R.searchPaths){const Y=R.searchPaths.filter(Ee=>(0,g.$bg)(Ee.searchPath,U))[0];if(Y&&!Y.pattern)return null;Y&&(V=Y.pattern)}const B=this.a.getValue({resource:U}),N={...this.l(B,w)||{},...V||{}},ee=u.URI.isUri(f)?(0,g.$fg)(f):f.name;return{folder:U,folderName:W?ee:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!B.search.followSymlinks}}};e.$zJ=m,e.$zJ=m=Ke([qe(0,d.$8h),qe(1,i.$Kh),qe(2,o.$5C),qe(3,t.$5i),qe(4,h.$xJ)],m);function r(s){const f=s.match(/[\*\{\}\(\)\[\]\?]/);if(f){const w=f.index,R=s.substr(0,w).match(/[/|\\][^/\\]*$/);if(R){let W=s.substr(0,R.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:s.substr((R.index||0)+1)}}}return{pathPortion:s}}function a(...s){return s.length?s.reduce((f,w)=>(f[w]=!0,f),Object.create(null)):void 0}function n(s){return C.$pj(s,",").map(f=>f.trim()).filter(f=>!!f.length)}function c(s){return[`**/${s}/**`,`**/${s}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function E(s){return s.replace(/\\/g,"/")}function p(s){return E(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(s){return s.replace(/([?*[\]])/g,"[$1]")}function k(s,f){s=v.$Kb(s,W=>W.toString());const w=[],R=f.getWorkspace();return s&&s.forEach(W=>{let V;if(f.getWorkbenchState()===2)V=(0,g.$kg)(R.folders[0].uri,W),V&&V!=="."&&(V="./"+V);else{const U=f.getWorkspaceFolder(W);if(U){const B=U.name;if(R.folders.filter(N=>N.name===B).length===1){const N=(0,g.$kg)(U.uri,W);N===""?V=`./${U.name}`:V=`./${U.name}/${N}`}else V=W.fsPath}}V&&w.push(I(V))}),w}e.$AJ=k}),define(Ae[269],Re([1,0,23,2,21,9,4,268,47,54]),function(be,e,v,F,C,T,A,l,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylb=e.$xlb=void 0;const P=7e3;function D(d,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const o=[],h=[];for(const c of i)if(/^workspaceContains:/.test(c)){const E=c.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||d.forceUsingSearch?h.push(E):o.push(E)}if(o.length===0&&h.length===0)return Promise.resolve(void 0);let y;const m=new Promise((c,E)=>{y=c}),r=c=>y({activationEvent:c}),a=Promise.all(o.map(c=>u(d,c,r))).then(()=>{}),n=b(d,t.identifier,h,r);return Promise.all([a,n]).then(()=>{y(void 0)}),m}e.$xlb=D;async function u(d,t,i){for(const o of d.folders)if(await d.exists(v.$ig(F.URI.revive(o),t))){i(`workspaceContains:${t}`);return}}async function b(d,t,i,o){if(i.length===0)return Promise.resolve(void 0);const h=new C.$pd,y=d.checkExists(d.folders,i,h.token),m=setTimeout(async()=>{h.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let r=!1;try{r=await y}catch(a){T.$2(a)||T.$Y(a)}h.dispose(),clearTimeout(m),r&&o(`workspaceContains:${i.join(",")}`)}function $(d,t,i,o){const h=d.get(A.$Ah),y=d.get(S.$nI),r=h.createInstance(l.$zJ).file(t.map(a=>(0,g.$Wh)(F.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return y.fileSearch(r,o).then(a=>!!a.limitHit,a=>T.$2(a)?!1:Promise.reject(a))}e.$ylb=$}),define(Ae[35],Re([1,0,149,19,87,23,12,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,72,86,63,5,269,83,191,13,81,59,22,82]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r,a,n,c,E,p,I,k,s,f,w,R,W,V,U,B,O,N){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=e.$Lbc=e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,n.$Bh)("IHostUtils");let Y=ee=class extends l.$kc{constructor(ie,z,q,le,we,ve,ge,De,ne,he,se,oe){super(),this.X=oe,this.a=this.B(new f.$fd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=ge,this.j=le,this.m=we,this.s=ve,this.t=ne,this.u=he,this.w=se,this.y=this.g.getProxy(D.$ZJ.MainThreadWorkspace),this.z=this.g.getProxy(D.$ZJ.MainThreadTelemetry),this.C=this.g.getProxy(D.$ZJ.MainThreadExtensionService),this.D=new A.$Fg,this.F=new A.$Fg,this.G=new A.$Fg,this.H=new A.$Fg,this.I=new ce(this.f.extensions.activationEvents),this.L=new i.$t3b(this.I,this.f.extensions.allExtensions);const fe=new h.$Wl(this.f.extensions.myExtensions);this.J=new i.$t3b(this.I,ue(this.L,fe)),O.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new $.$qbc(this.g,this.s),this.N=new R.$Cbc(this.g),this.O=De,this.h=ie.createChild(new I.$zh([$.$rbc,this.M],[R.$Dbc,this.N])),this.P=this.B(new b.$pbc(this.J,this.L,{onExtensionActivationError:(Ie,M,K)=>{this.C.$onExtensionActivationError(Ie,o.$1(M),K)},actualActivateExtension:async(Ie,M)=>{if(i.$t3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,M),new b.$obc;const K=this.J.getExtensionDescription(Ie);return this.db(K,M)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){o.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),o.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Hg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new h.$Vl(z.identifier.value),extensionLocation:g.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return g.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new ye(ie))),this.Q}async bb(ie){const z=S.$Hh.forUris(q=>T.$_f.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const le=await this.ab(q.extensionLocation);z.set(le,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(le)}try{(0,l.$fc)(q.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(le)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const le=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,z),this.eb(ie,z,"success",le),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,le){const we=ke(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:q})}fb(ie,z){const q=ke(ie,z);this.z.$publicLog2("activatePlugin",q);const le=this.ub(ie);if(!le)return Promise.resolve(new b.$nbc(b.$kbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new b.$lbc(z.startup);return Promise.all([this.vb(ie,(0,T.$ig)(ie.extensionLocation,le),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new m.$tbc(ie,this.M),q=new m.$sbc(ie.identifier.value,!1,this.M),le=new W.$Ebc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ve=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const ge=this;let De,ne;const he=(0,t.$PF)(ie,"ipc")?this.f.messagePorts?.get(h.$Vl.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return F.$9d(ie.extensionLocation.fsPath,se)},get storagePath(){return ge.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return ge.O.globalValue(ie).fsPath},get logPath(){return F.$9d(ge.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return g.URI.joinPath(ge.f.logsLocation,ie.identifier.value)},get storageUri(){return ge.O.workspaceValue(ie)},get globalStorageUri(){return ge.O.globalValue(ie)},get extensionMode(){return we},get extension(){return De===void 0&&(De=new X(ge,ie.identifier,ie,ve,!1)),De},get extensionRuntime(){return(0,t.$QF)(ie,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!ne){if(!he)return;const se=f.Event.buffer(f.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),ne={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return ne}})})}static hb(ie,z,q,le,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,le,we).then(ve=>new b.$mbc(!1,null,we.build(),q,ve,le.subscriptions))}static ib(ie,z,q,le,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,ge=q.activate.apply(ve,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(ge).then(De=>(we.activateResolveStop(),De))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const le=Date.now();(0,O.$A)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const ge of ve.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-le>50){this.kb(ie,we);break}else this.jb(ve,ge)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const le of q)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this.jb(le,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),le=this.pb(),we=Promise.all([le,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Hg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,ge,De)=>this.y.$checkExists(ve,ge,De)},we=await(0,w.$xlb)(le,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(v.localize(0,null));const q=await this.vb(null,z,new b.$lbc(!1));if(!q||typeof q.run!="function")throw new Error(v.localize(1,null,z.toString()));return new Promise((le,we)=>{const ve=(ne,he)=>{ne?(O.$s&&this.s.error("Test runner called back with error",ne),we(ne)):(O.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},ge=(0,T.$9f)(z),De=q.run(ge,ve);De&&De.then&&De.then(()=>{O.$s&&this.s.info("Test runner finished successfully."),le(0)}).catch(ne=>{O.$s&&this.s.error("Test runner finished with error",ne),we(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Hg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,l.$ic)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$8J("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=B.$bd.create(!1),le=()=>`[resolveAuthority(${(0,a.$Nk)(ie)},${z})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${le()}${Q}`),ve=Q=>this.s.warn(`${le()}${Q}`),ge=(Q,J=void 0)=>this.s.error(`${le()}${Q}`,J),De=Q=>{if(Q instanceof r.$8J)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},ne=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:J,authorityPrefix:x}=await this.sb(Q);if(!J)throw ge(`no resolver for ${x}`),new r.$8J(`No remote extension installed to resolve ${x}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(ne)).catch(async Q=>{if(!(Q instanceof r.$8J)||Q._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await ne(ie)]})}catch(Q){return De(Q)}const oe=new A.$Rg;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[Q,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),fe=await x.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$7J.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$8J(`Exec server was not available for ${ae}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Oe){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),ge("returned an error",Oe),oe.dispose(),De(Oe)}oe.dispose();const M={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},K={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$7J.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(r.$7J.isManagedResolvedAuthority(fe)){const Q=z;this.X.setFactory(Q,fe.makeConnection),G={authority:ie,connectTo:new a.$Kk(Q),connectionToken:fe.connectionToken}}else G={authority:ie,connectTo:new a.$Lk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:M}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,a.$Nk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const le=g.URI.revive(z);if(typeof q.getCanonicalURI>"u")return le;const we=await(0,A.$zg)(()=>q.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=g.URI.revive(le.extensionLocation));const{globalRegistry:z,myExtensions:q}=Ee(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=g.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:q}=Ee(this.I,this.L,this.J,ie),le=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=y.$Fd.alloc(ie),q=Math.random()%256;for(let le=0;le<ie;le++)z.writeUInt8(q,le);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$Kbc=Y,e.$Kbc=Y=ee=Ke([qe(0,n.$Ah),qe(1,e.$Jbc),qe(2,p.$2L),qe(3,d.$dbc),qe(4,u.$gbc),qe(5,P.$5i),qe(6,c.$fM),qe(7,E.$wbc),qe(8,k.$rsb),qe(9,s.$ybc),qe(10,U.$Gbc),qe(11,N.$Hbc)],Y);function Ee($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const le=new i.$t3b($e,ie.getAllExtensionDescriptions());le.deltaExtensions(q.toAdd,q.toRemove);const we=new h.$Wl(z.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of q.myToRemove)we.delete(ge);for(const ge of q.myToAdd)we.add(ge);const ve=ue(le,we);return{globalRegistry:le,myExtensions:ve}}function ke($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$Lbc=(0,n.$Bh)("IExtHostExtensionService");class X{#e;#t;#i;constructor(ie,z,q,le,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=F.$7d((0,T.$9f)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Mbc=X;function ue($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class ye{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$Nbc=ye;class ce{constructor(ie){this.a=new h.$Xl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Ae[270],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;let d=class{constructor(y,m,r,a,n,c,E){this.c=y,this.d=m,this.e=r,this.f=a,this.g=n,this.h=c,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const y=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const m=await this.g.getExtensionPathIndex();this.register(new i(this.c,m,this.d,y,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(o,m,this.h.environment.appUriScheme))}register(y){if("nodeModuleName"in y)if(Array.isArray(y.nodeModuleName))for(const m of y.nodeModuleName)this.a.set(m,y);else this.a.set(y.nodeModuleName,y);typeof y.alternativeModuleName=="function"&&this.b.push(m=>y.alternativeModuleName(m))}};e.$$cc=d,e.$$cc=d=Ke([qe(2,P.$Ah),qe(3,T.$gbc),qe(4,D.$Lbc),qe(5,g.$fM),qe(6,u.$5i)],d);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(y){if(y.environment.appRoot&&$.a.size){const m=(0,b.$qe)(this.c(y.environment.appRoot.fsPath)),r="[a-z0-9_.-]",a=`@${r}+\\/${r}+|${r}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${m}/${n}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(y){if(!this.b)return;const m=this.b.exec(this.c(y));if(!m)return;const[,r,a,n]=m,c=$.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),r+c+n}c(y){return y.replace(/\\/g,"/")}};t=$=Ke([qe(0,g.$fM)],t);class i{constructor(y,m,r,a,n){this.c=y,this.d=m,this.e=r,this.f=a,this.g=n,this.nodeModuleName="vscode",this.a=new l.$Xl}load(y,m){const r=this.d.findSubstr(m);if(r){let a=this.a.get(r.identifier);return a||(a=this.c(r,this.e,this.f),this.a.set(r.identifier,a)),a}if(!this.b){let a="";this.d.forEach((n,c)=>a+=`	${c} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${m}. These are the extension path mappings: 
${a}`),this.b=this.c(A.$KF,this.e,this.f)}return this.b}}let o=class{constructor(y,m,r){this.e=y,this.f=m,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$ZJ.MainThreadTelemetry);const a=r.getProxy(C.$ZJ.MainThreadWindow);this.c=(n,c)=>{const E=F.URI.parse(n);return c?this.g(n,c):E.scheme==="http"||E.scheme==="https"?a.$openUri(E,n,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?a.$openUri(E,n,{}):this.g(n,c)}}load(y,m,r){const a=this.e.findSubstr(m);return a&&(this.a=a.identifier.value,this.h()),this.b=r(y),this.c}g(y,m){return this.i(),this.b(y,m)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};o=Ke([qe(2,S.$2L)],o)}),define(Ae[113],Re([1,0,66,6,19,74,4,60,61,35,7,33,201,34]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0,e.$hcc=(0,A.$Bh)("IExtHostVariableResolverProvider");class $ extends u.$3M{constructor(i,o,h,y,m,r,a){function n(){if(h){const c=h.activeEditor();if(c)return c.document.uri;const E=y.tabGroups.all.find(p=>p.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof P.$IL||E.input instanceof P.$NL)return E.input.modified;if(E.input instanceof P.$HL||E.input instanceof P.$ML||E.input instanceof P.$KL)return E.input.uri}}}super({getFolderUri:c=>{const E=r.folders.filter(p=>p.name===c);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(c,E)=>m.getConfiguration(void 0,c).get(E),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=n();if(c)return C.$7d(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(o){const c=n();if(c){const E=o.getWorkspaceFolder(c);if(E)return C.$7d(E.uri.fsPath)}}},getSelectedText:()=>{if(h){const c=h.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(h){const c=h.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>i.getExtension(c)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(T.env))}}let d=class extends F.$kc{constructor(i,o,h,y,m){super(),this.b=i,this.c=o,this.g=h,this.h=y,this.j=m,this.a=new v.$T(async()=>{const r=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,r,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$icc=d,e.$icc=d=Ke([qe(0,g.$Lbc),qe(1,D.$dbc),qe(2,l.$aM),qe(3,b.$gbc),qe(4,S.$fcc)],d)}),define(Ae[114],Re([1,0,12,5,2,4,3,61,35,17,7,33,194,196,34,113]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=e.$lcc=e.$kcc=e.$jcc=void 0,e.$jcc=(0,T.$Bh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,n,c,E,p,I){this.E=n,this.F=c,this.G=E,this.H=p,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$fd,this.n=new F.$fd,this.o=new F.$fd,this.u=new F.$fd,this.k=a.getProxy(A.$ZJ.MainThreadDebugService),this.y=new F.$fd,this.A=new F.$fd,this.v=new o(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(s=>{this.J(k)}),this.J(k)})}asDebugSourceUri(a,n){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let E=`debug:${encodeURIComponent(c.path||"")}`,p="?";return n&&(E+=`${p}session=${encodeURIComponent(n.id)}`,p="&"),E+=`${p}ref=${c.sourceReference}`,C.URI.parse(E)}else{if(c.path)return C.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const n=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const E=c.contributes.debuggers;if(E&&E.length>0)for(const p of E)(0,b.$mF)(p)&&n.push(p.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(n=>a.push(n)),a}addBreakpoints(a){const n=a.filter(p=>{const I=p.id;return this.w.has(I)?!1:(this.w.set(I,p),!0)});this.U(n,[],[]);const c=[],E=new Map;for(const p of n)if(p instanceof P.$2K){let I=E.get(p.location.uri.toString());I||(I={type:"sourceMulti",uri:p.location.uri,lines:[]},E.set(p.location.uri.toString(),I),c.push(I)),I.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof P.$3K&&c.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){const n=a.filter(I=>this.w.delete(I.id));this.U([],n,[]);const c=n.filter(I=>I instanceof P.$2K).map(I=>I.id),E=n.filter(I=>I instanceof P.$3K).map(I=>I.id),p=n.filter(I=>I instanceof P.$4K).map(I=>I.id);return this.k.$unregisterBreakpoints(c,E,p)}startDebugging(a,n,c){return this.k.$startDebugging(a?a.uri:void 0,n,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,n,c){if(!n)return new P.$2J(()=>{});const E=this.d++;return this.f.push({type:a,handle:E,provider:n}),this.k.$registerDebugConfigurationProvider(a,c,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,E),new P.$2J(()=>{this.f=this.f.filter(p=>p.provider!==n),this.k.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(a,n,c){if(!c)return new P.$2J(()=>{});if(!this.Q(a,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:n,handle:E,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(n,E),new P.$2J(()=>{this.h=this.h.filter(p=>p.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(a,n){if(!n)return new P.$2J(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:n}),new P.$2J(()=>{this.j=this.j.filter(E=>E.factory!==n)})}async $runInTerminal(a,n){return Promise.resolve(void 0)}async $substituteVariables(a,n){let c;const E=await this.W(a);return E&&(c={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(c,n)}K(a,n){if(a.type==="implementation")return new y(a.implementation)}L(){}async $startDASession(a,n){const c=this,E=await this.V(n);return this.S(this.N(E.type),E).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const I=this.M(p),k=this.K(I,E);if(!k)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const s=k;return this.B.set(a,s),this.R(E).then(f=>(f&&this.C.set(a,f),s.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const R=w,W={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);W.body={signature:V},s.sendResponse(W)}else throw new Error("no signer")}catch(V){W.success=!1,W.message=V.message,s.sendResponse(W)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(w),w=(0,b.$rF)(w,!0),c.k.$acceptDAMessage(a,w)}),s.onError(w=>{f&&f.onError&&f.onError(w),this.k.$acceptDAError(a,w.name,w.message,w.stack)}),s.onExit(w=>{f&&f.onExit&&f.onExit(w??void 0,void 0),this.k.$acceptDAExit(a,w??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),s.startSession()))})}$sendDAMessage(a,n){n=(0,b.$qF)(n,!1);const c=this.C.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(n),this.B.get(a)?.sendMessage(n)}$stopDASession(a){const n=this.C.get(a);this.C.delete(a),n&&n.onWillStopSession&&n.onWillStopSession();const c=this.B.get(a);return this.B.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const n=[],c=[],E=[];if(a.added)for(const p of a.added){const I=p.id;if(I&&!this.w.has(I)){let k;if(p.type==="function")k=new P.$3K(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")k=new P.$4K(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const s=C.URI.revive(p.uri);k=new P.$2K(new P.$bK(s,new P.$3J(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}(0,P.$ZK)(k,I),this.w.set(I,k),n.push(k)}}if(a.removed)for(const p of a.removed){const I=this.w.get(p);I&&(this.w.delete(p),c.push(I))}if(a.changed){for(const p of a.changed)if(p.id){const I=this.w.get(p.id);if(I){if(I instanceof P.$3K&&p.type==="function"){const k=I;k.enabled=p.enabled,k.condition=p.condition,k.hitCondition=p.hitCondition,k.logMessage=p.logMessage,k.functionName=p.functionName}else if(I instanceof P.$2K&&p.type==="source"){const k=I;k.enabled=p.enabled,k.condition=p.condition,k.hitCondition=p.hitCondition,k.logMessage=p.logMessage,k.location=new P.$bK(C.URI.revive(p.uri),new P.$3J(p.line,p.character))}E.push(I)}}}this.U(n,c,E)}async $acceptStackFrameFocus(a){let n;const c=a.sessionId?await this.V(a.sessionId):void 0;if(!c)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?n=new P.$0K(c,a.threadId):n=new P.$9K(c,a.threadId,a.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(a,n,c){return(0,v.$zg)(async()=>{const E=this.P(a);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.W(n);return E.provideDebugConfigurations(p,c)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(a,n,c,E){return(0,v.$zg)(async()=>{const p=this.P(a);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(n);return p.resolveDebugConfiguration(I,c,E)})}$resolveDebugConfigurationWithSubstitutedVariables(a,n,c,E){return(0,v.$zg)(async()=>{const p=this.P(a);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(n);return p.resolveDebugConfigurationWithSubstitutedVariables(I,c,E)})}async $provideDebugAdapter(a,n){const c=this.O(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.V(n);return this.S(c,E).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.M(p)})}async $acceptDebugSessionStarted(a){const n=await this.V(a);this.m.fire(n)}async $acceptDebugSessionTerminated(a){const n=await this.V(a);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,n){(await this.V(a))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(a,n){const E={session:await this.V(a),event:n.event,body:n.body};this.u.fire(E)}M(a){if(a instanceof P.$5K)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$6K)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$7K)return{type:"pipeServer",path:a.path};if(a instanceof P.$8K)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const n=this.h.filter(c=>c.type===a);if(n.length>0)return n[0].factory}O(a){const n=this.h.filter(c=>c.handle===a);if(n.length>0)return n[0].factory}P(a){const n=this.f.filter(c=>c.handle===a);if(n.length>0)return n[0].provider}Q(a,n){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const E of c)if(E.label&&E.type&&E.type===n)return!0}}return!1}R(a){const c=a.configuration.type,E=this.j.filter(p=>p.type===c||p.type==="*").map(p=>(0,v.$zg)(()=>p.factory.createDebugAdapterTracker(a)).then(I=>I,I=>null));return Promise.race([Promise.all(E).then(p=>{const I=p.filter(k=>!!k);if(I.length>0)return new h(I)}),new Promise(p=>setTimeout(()=>p(void 0),1e3))]).catch(p=>{})}async S(a,n){const c=n.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new P.$6K(c));if(a){const p=await this.F.getExtensionRegistry();return(0,v.$zg)(()=>a.createDebugAdapterDescriptor(n,this.T(n,p))).then(I=>{if(I)return I})}const E=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,E))}T(a,n){}U(a,n,c){(a.length>0||n.length>0||c.length>0)&&this.y.fire(Object.freeze({added:a,removed:n,changed:c}))}async V(a){if(a)if(typeof a=="string"){const n=this.l.get(a);if(n)return n}else{let n=this.l.get(a.id);if(!n){const c=await this.W(a.folderUri),E=a.parent?this.l.get(a.parent):void 0;n=new i(this.k,a.id,a.type,a.name,c,a.configuration,E),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(a){if(a){const n=C.URI.revive(a);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$kcc=t,e.$kcc=t=Ke([qe(0,g.$2L),qe(1,D.$dbc),qe(2,S.$Lbc),qe(3,$.$gbc),qe(4,l.$fcc),qe(5,d.$hcc)],t);class i{constructor(a,n,c,E,p,I,k){this.d=a,this.f=n,this.g=c,this.h=E,this.i=p,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,n){return this.d.$customDebugAdapterRequest(this.f,a,n)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$lcc=i;class o{constructor(a){this.value=Object.freeze({append(n){a.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$mcc=o;class h{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(n=>n.onError?n.onError(a):void 0)}onExit(a,n){this.d.forEach(c=>c.onExit?c.onExit(a,n):void 0)}}class y extends u.$Ccb{constructor(a){super(),this.h=a,a.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let m=class extends t{constructor(a,n,c,E,p,I){super(a,n,c,E,p,I)}};e.$ncc=m,e.$ncc=m=Ke([qe(0,g.$2L),qe(1,D.$dbc),qe(2,S.$Lbc),qe(3,$.$gbc),qe(4,l.$fcc),qe(5,d.$hcc)],m)}),define(Ae[271],Re([1,0,9,87,2,3,262,14,71,72,27,173,17,56,35,58]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;class t{static async installEarlyHandler(h){Error.stackTraceLimit=100;const y=h.get(l.$5i),r=h.get(u.$2L).getProxy(T.$ZJ.MainThreadErrors);v.setUnexpectedErrorHandler(a=>{y.error(a);const n=v.$1(a);r.$onUnexpectedError(n)})}static async installFullHandler(h){const y=h.get(l.$5i),m=h.get(u.$2L),r=h.get($.$Lbc),a=h.get(d.$jM),n=m.getProxy(T.$ZJ.MainThreadExtensionService),c=m.getProxy(T.$ZJ.MainThreadErrors),E=await r.getExtensionPathIndex(),p=new WeakMap;function I(f,w){if(p.has(f))return p.get(f).stack;let R="",W,V;for(const B of w)R+=`
	at ${B.toString()}`,V=B.getFileName(),!W&&V&&(W=E.findSubstr(C.URI.file(V)));const U=`${f.name||"Error"}: ${f.message||""}${R}`;return p.set(f,{extensionIdentifier:W?.identifier,stack:U}),U}const k=Symbol("prepareStackTrace wrapped");let s=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return s},set(f){if(f===I||!f||f[k]){s=f||I;return}s=function(w,R){return I(w,R),f.call(Error,w,R)},Object.assign(s,{[k]:!0})}}),v.setUnexpectedErrorHandler(f=>{y.error(f);const w=v.$1(f),R=p.get(f);if(!R?.extensionIdentifier){c.$onUnexpectedError(w);return}n.$onExtensionRuntimeError(R.extensionIdentifier,w);const W=a.onExtensionError(R.extensionIdentifier,f);y.trace("forwarded error to extension?",W,R)})}}e.$_cc=t;class i{constructor(h,y,m,r,a){this.a=m,this.b=new A.$C3b(h,null,r),y=i.e(y,this.b);const n=new g.$zh(...(0,S.$nr)());n.set(P.$fM,{_serviceBrand:void 0,...y,messagePorts:a}),n.set(u.$2L,new u.$3L(this.b)),n.set(b.$abc,new b.$bbc(r)),n.set($.$Jbc,m);const c=new D.$6p(n,!0);c.invokeFunction(t.installEarlyHandler),this.d=c.invokeFunction(E=>E.get(l.$5i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=c.invokeFunction(E=>E.get($.$Lbc)),this.c.initialize(),c.invokeFunction(t.installFullHandler)}async asBrowserUri(h){const y=this.b.getProxy(T.$ZJ.MainThreadExtensionService);return C.URI.revive(await y.$asBrowserUri(h))}terminate(h){this.c.terminate(h)}static e(h,y){h.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(y.transformIncomingURIs(r.extensionLocation))}),h.environment.appRoot=C.URI.revive(y.transformIncomingURIs(h.environment.appRoot));const m=h.environment.extensionDevelopmentLocationURI;return m&&(h.environment.extensionDevelopmentLocationURI=m.map(r=>C.URI.revive(y.transformIncomingURIs(r)))),h.environment.extensionTestsLocationURI=C.URI.revive(y.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=C.URI.revive(y.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=C.URI.revive(y.transformIncomingURIs(h.environment.workspaceStorageHome)),h.environment.extensionTelemetryLogResource=C.URI.revive(y.transformIncomingURIs(h.environment.extensionTelemetryLogResource)),h.nlsBaseUrl=C.URI.revive(y.transformIncomingURIs(h.nlsBaseUrl)),h.logsLocation=C.URI.revive(y.transformIncomingURIs(h.logsLocation)),h.workspace=y.transformIncomingURIs(h.workspace),h}}e.$adc=i}),define(Ae[272],Re([1,0,18,12,21,41,13,19,23,2,47]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=e.$qcc=e.$pcc=void 0;class D{constructor(o,h,y,m){this.d=o,this.e=h,this.f=y,this.g=m,this.a=null,this.b=!1,this.c=0}search(o,h){const y=this.d.folderQueries||[],m=new C.$pd(h);return new Promise((r,a)=>{this.a=new b(o);let n=!1;const c=(E,p)=>{if(!n&&!this.b){const I=this.h(E);d(E)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,n=!0,m.cancel(),E=this.j(E,this.d.maxResults-this.c));const k=this.h(E);this.c+=k,(k>0||!d(E))&&this.a.add(E,p)}};Promise.all(y.map((E,p)=>this.k(E,I=>c(I,p),m.token))).then(E=>{m.dispose(),this.a.flush();const p=E.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||p,messages:(0,v.$Pb)(E.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},E=>{m.dispose();const p=(0,T.$mi)(E);a(new Error(p))})})}h(o){return d(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}j(o,h){const y=Array.isArray(o.ranges)?o.ranges:[o.ranges],m=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:y.slice(0,h),preview:{matches:m.slice(0,h),text:o.preview.text},uri:o.uri}}async k(o,h,y){const m=new P.$GI(this.d,o),r=[],a={report:E=>{if(!this.l(E))return;const p=o.folder.scheme===A.Schemas.file?(0,P.$HI)(()=>this.f.readdir(S.$hg(E.uri))):void 0,I=S.$kg(o.folder,E.uri);if(I){const k=m.includedInQuery(I,l.$ae(I),p);(0,F.$tg)(k)?r.push(k.then(s=>{s&&h(E)})):k&&h(E)}}},n=this.n(o),c=await this.e.provideTextSearchResults(u(this.d.contentPattern),n,a,y);return r.length&&await Promise.all(r),c}l(o){if(d(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(o){const h=(0,P.$FI)(this.d.includePattern,o.includePattern),y=(0,P.$FI)(this.d.excludePattern,o.excludePattern),m={folder:g.URI.from(o.folder),excludes:y,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.f.toCanonicalName(o.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return m.usePCRE2=this.d.usePCRE2,m}}e.$pcc=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(o){this.e=o,this.b=-1,this.d=null,this.a=new t(512,h=>this.g(h))}add(o,h){this.d&&(this.b!==h||!S.$bg(this.c,o.uri))&&(this.f(),this.d=null),this.d||(this.b=h,this.d={resource:o.uri,results:[]}),this.d.results.push($(o))}f(){const o=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,o)}flush(){this.f(),this.a.flush()}g(o){this.e(o)}}e.$qcc=b;function $(i){return d(i)?{preview:{matches:(0,v.$Zb)(i.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:i.preview.text},ranges:(0,v.$Zb)(i.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function d(i){return!!i.preview}e.$rcc=d;class t{static{this.a=4e3}static{this.b=50}constructor(o,h){this.g=o,this.h=h,this.c=0,this.d=[],this.e=0}addItem(o,h){o&&this.j(o,h)}addItems(o,h){o&&this.k(o,h)}j(o,h){this.d.push(o),this.e+=h,this.l()}k(o,h){this.d=this.d.concat(o),this.e+=h,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$scc=t}),define(Ae[115],Re([1,0,6,3,4,267,17,56,14,2,272]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=e.$tcc=void 0,e.$tcc=(0,C.$Bh)("IExtHostSearch");let D=class{constructor(d,t,i){this.k=d,this.l=t,this.n=i,this.c=this.k.getProxy(F.$ZJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$occ}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(d)),(0,v.$ic)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(d)),(0,v.$ic)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,t,i,o){const h=u(i),y=this.h.get(d);if(y)return this.j.fileSearch(h,y,m=>{this.c.$handleFileMatch(d,t,m.map(r=>r.resource))},o);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,i,o){const h=this.e.get(d);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const y=u(i);return this.q(y,h).search(r=>this.c.$handleTextMatch(d,t,r),o)}$enableExtensionHostSearch(){}q(d,t){return new P.$pcc(d,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$ucc=D,e.$ucc=D=Ke([qe(0,A.$2L),qe(1,l.$abc),qe(2,S.$5i)],D);function u($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(b),extraFileResources:$.extraFileResources&&$.extraFileResources.map(d=>g.URI.revive(d))}}e.$vcc=u;function b($){return{...$,folder:g.URI.revive($.folder)}}}),define(Ae[273],Re([1,0,21,9,5,29,2,136,284,125,134,38,3,79,226,225,31,227,34,229,230,231,204,232,60,35,234,235,240,241,243,110,208,249,250,252,84,63,254,211,8,7,53,257,64,109,33,20,199,239,52,108,112,114,115,14,56,17,27,244,197,86,80,218,255,85,62,260,258,259,219,39,253,256,83,61,58,245,111,246,13,95,207,190,237,6,26,195,81,186,247,248,220,236,206,238,82,251,222,223,224,217,233,221]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r,a,n,c,E,p,I,k,s,f,w,R,W,V,U,B,O,N,ee,Y,Ee,ke,Pe,X,ue,ye,ce,$e,ie,z,q,le,we,ve,ge,De,ne,he,se,oe,fe,Ie,M,K,G,Q,J,x,ae,Oe,je,Qe,He,et,Xe,_e,it,tt,ze,rt,_,Z,pe,Ue,Ne,Ze,nt,dt,vt,Ot,Zt,qt,wt,Nt,zt,Ht,Pt,At,jt,Bt,Kt,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;function Vt(ot){const ft=ot.get(ne.$fM),Rt=ot.get(Oe.$3ac),Ft=ot.get(G.$vbc),It=ot.get(c.$Lbc),ht=ot.get(ue.$dbc),kt=ot.get(Xe.$jM),Dt=ot.get(o.$gbc),Mt=ot.get(ge.$abc),Ve=ot.get(De.$2L),Ce=ot.get(U.$rbc),Fe=ot.get(K.$wbc),me=ot.get(ve.$6i),H=ot.get(ve.$5i),Me=ot.get(oe.$rsb),Be=ot.get(fe.$6ac),Ge=ot.get(X.$0bc),We=ot.get(He.$Dbc),xe=ot.get(et.$fcc),$t=ot.get(zt.$Hbc);Ve.set(u.$1J.ExtHostFileSystemInfo,Rt),Ve.set(u.$1J.ExtHostLogLevelServiceShape,me),Ve.set(u.$1J.ExtHostWorkspace,ht),Ve.set(u.$1J.ExtHostConfiguration,Dt),Ve.set(u.$1J.ExtHostExtensionService,It),Ve.set(u.$1J.ExtHostStorage,Ce),Ve.set(u.$1J.ExtHostTunnelService,Me),Ve.set(u.$1J.ExtHostWindow,Ge),Ve.set(u.$1J.ExtHostSecretState,We),Ve.set(u.$1J.ExtHostTelemetry,kt),Ve.set(u.$1J.ExtHostEditorTabs,xe),Ve.set(u.$1J.ExtHostManagedSockets,$t);const Ct=Ve.set(u.$1J.ExtHostDecorations,ot.get(z.$bcc)),bt=Ve.set(u.$1J.ExtHostDocumentsAndEditors,ot.get(n.$aM)),ut=Ve.set(u.$1J.ExtHostCommands,ot.get(t.$lM)),mt=Ve.set(u.$1J.ExtHostTerminalService,ot.get(B.$ybc)),yt=Ve.set(u.$1J.ExtHostDebugService,ot.get(le.$jcc)),gi=Ve.set(u.$1J.ExtHostSearch,ot.get(we.$tcc)),Jt=Ve.set(u.$1J.ExtHostTask,ot.get(q.$ecc)),Yt=Ve.set(u.$1J.ExtHostOutputService,ot.get(f.$Tbc)),si=Ve.set(u.$1J.ExtHostLocalization,ot.get(nt.$Gbc)),ki=Ve.set(u.$1J.ExtHostUrls,new ke.$3bc(Ve)),St=Ve.set(u.$1J.ExtHostDocuments,new a.$1ac(Ve,bt)),Yi=Ve.set(u.$1J.ExtHostDocumentContentProviders,new m.$ibc(Ve,bt,H)),un=Ve.set(u.$1J.ExtHostDocumentSaveParticipant,new r.$jbc(H,St,Ve.getProxy(u.$ZJ.MainThreadBulkEdits))),pt=Ve.set(u.$1J.ExtHostNotebook,new he.$zcc(Ve,ut,bt,St,Ft)),mi=Ve.set(u.$1J.ExtHostNotebookDocuments,new Z.$Rcc(pt)),$i=Ve.set(u.$1J.ExtHostNotebookEditors,new _.$Qcc(H,pt)),oi=Ve.set(u.$1J.ExtHostNotebookKernels,new _e.$Ncc(Ve,ft,pt,ut,H)),Di=Ve.set(u.$1J.ExtHostNotebookRenderers,new tt.$Pcc(Ve,pt)),Si=Ve.set(u.$1J.ExtHostNotebookDocumentSaveParticipant,new wt.$Xcc(H,pt,Ve.getProxy(u.$ZJ.MainThreadBulkEdits))),Tt=Ve.set(u.$1J.ExtHostEditors,new O.$1bc(Ve,bt)),pi=Ve.set(u.$1J.ExtHostTreeViews,new N.$2bc(Ve.getProxy(u.$ZJ.MainThreadTreeViews),ut,H)),Ii=Ve.set(u.$1J.ExtHostEditorInsets,new ce.$$bc(Ve.getProxy(u.$ZJ.MainThreadEditorInsets),Tt,ft.remote)),ai=Ve.set(u.$1J.ExtHostDiagnostics,new h.$5ac(Ve,H,Rt,bt)),ci=Ve.set(u.$1J.ExtHostLanguages,new k.$Qbc(Ve,St,ut.converter,Mt)),ct=Ve.set(u.$1J.ExtHostLanguageFeatures,new I.$9ac(Ve,Mt,St,ut,ai,H,Be,kt)),Ci=Ve.set(u.$1J.ExtHostFileSystem,new E.$Obc(Ve,ct)),Xt=Ve.set(u.$1J.ExtHostFileSystemEventService,new p.$Pbc(Ve,H,bt)),ii=Ve.set(u.$1J.ExtHostQuickOpen,(0,R.$Vbc)(Ve,ht,ut)),bi=Ve.set(u.$1J.ExtHostSCM,new W.$Xbc(Ve,ut,St,H)),Xi=Ve.set(u.$1J.ExtHostQuickDiff,new Ot.$Ucc(Ve,Mt)),Pi=Ve.set(u.$1J.ExtHostShare,new Ht.$Zcc(Ve,Mt)),Ai=Ve.set(u.$1J.ExtHostComments,(0,i.$_ac)(Ve,ut,St)),Ri=Ve.set(u.$1J.ExtHostProgress,new w.$Ubc(Ve.getProxy(u.$ZJ.MainThreadProgress))),_i=Ve.set(u.$1J.ExtHosLabelService,new $e.$_bc(Ve)),Fi=Ve.set(u.$1J.ExtHostTheming,new se.$Acc(Ve)),ui=Ve.set(u.$1J.ExtHostAuthentication,new Ie.$Bcc(Ve)),xi=Ve.set(u.$1J.ExtHostTimeline,new M.$Dcc(Ve,ut)),Mi=Ve.set(u.$1J.ExtHostWebviews,new Pe.$6bc(Ve,ft.remote,ht,H,Be)),Ti=Ve.set(u.$1J.ExtHostWebviewPanels,new x.$Fcc(Ve,Mi,ht)),Li=Ve.set(u.$1J.ExtHostCustomEditors,new J.$Gcc(Ve,St,Fe,Mi,Ti)),Oi=Ve.set(u.$1J.ExtHostWebviewViews,new Q.$Ecc(Ve,Mi)),hi=Ve.set(u.$1J.ExtHostTesting,new je.$Icc(Ve,ut,bt)),ln=Ve.set(u.$1J.ExtHostUriOpeners,new Qe.$Mcc(Ve)),en=Ve.set(u.$1J.ExtHostProfileContentHandlers,new vt.$Tcc(Ve));Ve.set(u.$1J.ExtHostInteractive,new pe.$Scc(Ve,pt,bt,ut,H));const Ni=Ve.set(u.$1J.ExtHostInlineChat,new qt.$Wcc(Ve,ut,St,H)),di=Ve.set(u.$1J.ExtHostChatProvider,new Pt.$1cc(Ve,H)),tn=Ve.set(u.$1J.ExtHostChatSlashCommands,new At.$2cc(Ve,di,H)),nn=Ve.set(u.$1J.ExtHostChatAgents,new Wt.$6cc(Ve,di,H)),hn=Ve.set(u.$1J.ExtHostChatVariables,new jt.$3cc(Ve)),ni=Ve.set(u.$1J.ExtHostChat,new Zt.$Vcc(Ve,H)),zi=Ve.set(u.$1J.ExtHostAiRelatedInformation,new Bt.$4cc(Ve)),xt=Ve.set(u.$1J.ExtHostAiEmbeddingVector,new Kt.$5cc(Ve)),vi=Ve.set(u.$1J.ExtHostIssueReporter,new Nt.$Ycc(Ve)),rn=Ve.set(u.$1J.ExtHostStatusBar,new V.$Zbc(Ve,ut.converter)),Gt=Object.values(u.$1J);Ve.assertRegistered(Gt);const wi=new ae.$Hcc(Ve,bt),sn=new d.$$ac(Ve),yi=new s.$Rbc(Ve,H),ji=new y.$hbc(Ve);return $.$0ac.register(ut),function(Le,ei,Ui){const gt=function(){let te=!Le.isUnderDevelopment;function de(){te||(H.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")de();else{const Et=st;typeof Et.scheme>"u"&&de(),typeof Et.exclusive=="boolean"&&(0,Ne.$QF)(Le,"documentFiltersExclusive")}return st}}(),dn={getSession(te,de,Te){return ui.getSession(Le,te,de,Te)},getSessions(te,de){return(0,Ne.$QF)(Le,"authGetSessions"),ui.getSessions(Le,te,de)},async hasSession(te,de){return(0,Ne.$QF)(Le,"authSession"),!!await ui.getSession(Le,te,de,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,st){return ui.registerAuthenticationProvider(te,de,Te,st)}},fn={registerCommand(te,de,Te){return ut.registerCommand(!0,te,de,Te,void 0,Le)},registerTextEditorCommand(te,de,Te){return ut.registerCommand(!0,te,(...st)=>{const Et=Tt.getActiveTextEditor();if(!Et){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return Et.edit(Lt=>{de.apply(Te,[Et,Lt,...st])}).then(Lt=>{Lt||H.warn("Edits from command "+te+" were not applied.")},Lt=>{H.warn("An error occurred while running command "+te,Lt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,de,Te)=>((0,Ne.$QF)(Le,"diffCommand"),ut.registerCommand(!0,te,async(...st)=>{const Et=bt.activeEditor(!0);if(!Et){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Lt=await Tt.getDiffInformation(Et.id);de.apply(Te,[Lt,...st])},void 0,void 0,Le)),executeCommand(te,...de){return ut.executeCommand(te,...de)},getCommands(te=!1){return ut.getCommands(te)}},Ei={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$QF)(Le,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$QF)(Le,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$iM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Xe.$hM.validateSender(te),kt.instantiateLogger(Le,te,de)},openExternal(te,de){return Ge.openUri(te,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ft.environment.appUriScheme)return ki.createAppUri(te);try{return await Ge.asExternalUri(te,{allowTunneling:!!ft.remote.authority})}catch(de){if((0,rt.$MT)(te,ze.Schemas.http)||(0,rt.$MT)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,ie.$Pk)(ft.remote.authority)},get remoteAuthority(){return(0,Ne.$QF)(Le,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$QF)(Le,"handleIssueUri"),vi.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Ne.$QF)(Le,"resolvers"),ft.quality},get appCommit(){return(0,Ne.$QF)(Le,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Ei);const on={createTestController(te,de,Te){return hi.createTestController(Le,te,de,Te)},createTestObserver(){return(0,Ne.$QF)(Le,"testObserver"),hi.createTestObserver()},runTests(te){return(0,Ne.$QF)(Le,"testObserver"),hi.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$QF)(Le,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ne.$QF)(Le,"testObserver"),hi.results}},fi=ft.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,an={getExtension(te,de){(0,Ne.$PF)(Le,"extensionsAny")||(de=!1);const Te=ei.mine.getExtensionDescription(te);if(Te)return new c.$Mbc(It,Le.identifier,Te,fi,!1);if(de){const st=ei.all.getExtensionDescription(te);if(st)return new c.$Mbc(It,Le.identifier,st,fi,!0)}},get all(){const te=[];for(const de of ei.mine.getAllExtensionDescriptions())te.push(new c.$Mbc(It,Le.identifier,de,fi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$QF)(Le,"extensionsAny");const te=new ye.$Wl(ei.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of ei.all.getAllExtensionDescriptions()){const st=!te.has(Te.identifier);de.push(new c.$Mbc(It,Le.identifier,Te,fi,st))}return de},get onDidChange(){return(0,Ne.$PF)(Le,"extensionsAny")?C.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},gn={createDiagnosticCollection(te){return ai.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:te=>ai.getDiagnostics(te),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(te,de){return ci.changeLanguage(te.uri,de)},match(te,de){const Te=St.getDocumentData(de.uri)?.notebook;return(0,P.$cF)(ee.LanguageSelector.from(te),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Le,gt(te),de,Te)},registerDocumentPasteEditProvider(te,de,Te){return(0,Ne.$QF)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,gt(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Le,gt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Le,gt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Le,gt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Le,gt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Le,gt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Le,gt(te),de,Le.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Le,gt(te),de,Le.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Le,gt(te),de,Le.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Le,gt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Le,gt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Le,gt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Le,gt(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Le,gt(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Le,gt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Le,gt(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...st){return ct.registerOnTypeFormattingEditProvider(Le,gt(te),de,[Te].concat(st))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Le,gt(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Le,gt(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...st){return typeof Te=="object"?ct.registerSignatureHelpProvider(Le,gt(te),de,Te):ct.registerSignatureHelpProvider(Le,gt(te),de,typeof Te>"u"?[]:[Te,...st])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Le,gt(te),de,Te)},registerInlineCompletionItemProvider(te,de,Te){return de.handleDidShowCompletionItem&&(0,Ne.$QF)(Le,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$QF)(Le,"inlineCompletionsAdditions"),Te&&(0,Ne.$QF)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,gt(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Le,gt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Le,gt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Le,gt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Le,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Le,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Le,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Le,te,de),getTokenInformationAtPosition(te,de){return(0,Ne.$QF)(Le,"tokenInformation"),ci.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Le,te,de)},createLanguageStatusItem(te,de){return ci.createLanguageStatusItem(Le,te,de)},registerDocumentDropEditProvider(te,de,Te){return ct.registerDocumentOnDropEditProvider(Le,te,de,(0,Ne.$PF)(Le,"dropMetadata")?Te:void 0)}},mn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(te,de,Te){const st=await(A.URI.isUri(te)?Promise.resolve(Bi.openTextDocument(te)):Promise.resolve(te));return Tt.showTextDocument(st,de,Te)},createTextEditorDecorationType(te){return Tt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,de,Te){return Tt.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Tt.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Tt.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Tt.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Tt.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Tt.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return mt.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return mt.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return mt.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Ne.$QF)(Le,"terminalDimensions"),mt.onDidChangeTerminalDimensions(te,de,Te)},onDidChangeTerminalState(te,de,Te){return mt.onDidChangeTerminalState(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Ne.$QF)(Le,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(te,de,Te)},onDidExecuteTerminalCommand(te,de,Te){return(0,Ne.$QF)(Le,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(te,de,Te)},get state(){return Ge.getState(Le)},onDidChangeWindowState(te,de,Te){return Ge.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return yi.showMessage(Le,T.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return yi.showMessage(Le,T.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return yi.showMessage(Le,T.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return ii.showQuickPick(Le,te,de,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return ji.showOpenDialog(Le,te)},showSaveDialog(te){return ji.showSaveDialog(te)},createStatusBarItem(te,de,Te){let st,Et,Lt;return typeof te=="string"?(st=te,Et=de,Lt=Te):(Et=te,Lt=de),rn.createStatusBarEntry(Le,st,Et,Lt)},setStatusBarMessage(te,de){return rn.setStatusBarMessage(te,de)},withScmProgress(te){return Be.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ri.withProgress(Le,{location:Y.ProgressLocation.SourceControl},(de,Te)=>te({report(st){}}))},withProgress(te,de){return Ri.withProgress(Le,te,de)},createOutputChannel(te,de){return Yt.createOutputChannel(te,de,Le)},createWebviewPanel(te,de,Te,st){return Ti.createWebviewPanel(Le,te,de,Te,st)},createWebviewTextEditorInset(te,de,Te,st){return(0,Ne.$QF)(Le,"editorInsets"),Ii.createWebviewEditorInset(te,de,Te,st,Le)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?mt.createExtensionTerminal(te):mt.createTerminalFromOptions(te):mt.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return mt.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return mt.registerProfileProvider(Le,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Ne.$QF)(Le,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(te,Le.identifier.value,de)},registerTreeDataProvider(te,de){return pi.registerTreeDataProvider(te,de,Le)},createTreeView(te,de){return pi.createTreeView(te,de,Le)},registerWebviewPanelSerializer:(te,de)=>Ti.registerWebviewPanelSerializer(Le,te,de),registerCustomEditorProvider:(te,de,Te={})=>Li.registerCustomEditorProvider(Le,te,de,Te),registerFileDecorationProvider(te){return Ct.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return ki.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Fi.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return Oi.registerWebviewViewProvider(Le,te,de,Te?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return pt.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return $i.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return pt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Ne.$QF)(Le,"externalUriOpener"),ln.registerExternalUriOpener(Le.identifier,te,de,Te)},registerProfileContentHandler(te,de){return(0,Ne.$QF)(Le,"profileContentHandlers"),en.registrProfileContentHandler(Le,te,de)},registerQuickDiffProvider(te,de,Te,st){return(0,Ne.$QF)(Le,"quickDiffProvider"),Xi.registerQuickDiffProvider(gt(te),de,Te,st)},get tabGroups(){return xe.tabGroups},registerShareProvider(te,de){return(0,Ne.$QF)(Le,"shareProvider"),Pi.registerShareProvider(gt(te),de)}},Bi={get rootPath(){return Be.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new F.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new F.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new F.$7("workspaceFile")},updateWorkspaceFolders:(te,de,...Te)=>ht.updateWorkspaceFolders(Le,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return ht.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>ht.getRelativePath(te,de),findFiles:(te,de,Te,st)=>ht.findFiles(te,de,Te,Le.identifier,st),findTextInFiles:(te,de,Te,st)=>{(0,Ne.$QF)(Le,"findTextInFiles");let Et,Lt;return typeof de=="object"?(Et=de,Lt=Te):(Et={},Lt=de,st=Te),ht.findTextInFiles(te,Et||{},Lt,Le.identifier,st)},save:te=>((0,Ne.$QF)(Le,"saveEditor"),ht.save(te)),saveAs:te=>((0,Ne.$QF)(Le,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,de){return wi.applyWorkspaceEdit(te,Le,de)},createFileSystemWatcher:(te,de,Te,st)=>Xt.createFileSystemWatcher(ht,Le,te,de,Te,st),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new F.$7("textDocuments")},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>St.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(te,de,Te)=>St.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>St.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>St.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>St.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>un.getOnWillSaveTextDocumentEvent(Le)(te,de,Te),get notebookDocuments(){return pt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Te;if(A.URI.isUri(te))Te=te,await pt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await pt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,de,Te){return mi.onDidSaveNotebookDocument(te,de,Te)},onDidChangeNotebookDocument(te,de,Te){return mi.onDidChangeNotebookDocument(te,de,Te)},onWillSaveNotebookDocument(te,de,Te){return Si.getOnWillSaveNotebookDocumentEvent(Le)(te,de,Te)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Te,st){return pt.registerNotebookSerializer(Le,te,de,Te,(0,Ne.$PF)(Le,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(te,de,Te)=>Ui.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,Ui.getConfiguration(te,de,Le)},registerTextDocumentContentProvider(te,de){return Yi.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Be.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Le,te,de)),registerFileSystemProvider(te,de,Te){return(0,Ue.$hc)(Ci.registerFileSystemProvider(Le,te,de,Te),Ft.addFileSystemProvider(te,de,Te))},get fs(){return Ft.value},registerFileSearchProvider:(te,de)=>((0,Ne.$QF)(Le,"fileSearchProvider"),gi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Ne.$QF)(Le,"textSearchProvider"),gi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Ne.$QF)(Le,"resolvers"),It.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Ne.$QF)(Le,"resolvers"),_i.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$QF)(Le,"resolvers"),It.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Te)=>Xt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Xt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Xt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Xt.getOnWillCreateFileEvent(Le)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Xt.getOnWillDeleteFileEvent(Le)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Xt.getOnWillRenameFileEvent(Le)(te,de,Te),openTunnel:te=>((0,Ne.$QF)(Le,"tunnels"),Me.openTunnel(Le,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ne.$QF)(Le,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Ne.$QF)(Le,"tunnels"),Me.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Ne.$QF)(Le,"portsAttributes"),Me.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Ne.$QF)(Le,"tunnelFactory"),Me.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Ne.$QF)(Le,"timeline"),xi.registerTimelineProvider(te,de,Le.identifier,ut.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Ne.$QF)(Le,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>ht.onDidGrantWorkspaceTrust(te,de,Te),registerEditSessionIdentityProvider:(te,de)=>((0,Ne.$QF)(Le,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Te)=>((0,Ne.$QF)(Le,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Le)(te,de,Te)),registerCanonicalUriProvider:(te,de)=>((0,Ne.$QF)(Le,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Te)=>((0,Ne.$QF)(Le,"canonicalUriProvider"),ht.provideCanonicalUri(te,de,Te))},cn={get inputBox(){return Be.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Le)},createSourceControl(te,de,Te){return bi.createSourceControl(Le,te,de,Te)}},Wi={createCommentController(te,de){return Ai.createCommentController(Le,te,de)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(te,de,Te){return yt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return yt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return yt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return yt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return yt.onDidChangeBreakpoints(te,de,Te)},onDidChangeStackFrameFocus(te,de,Te){return(0,Ne.$QF)(Le,"debugFocus"),yt.onDidChangeStackFrameFocus(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return yt.registerDebugConfigurationProvider(te,de,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return yt.registerDebugAdapterDescriptorFactory(Le,te,de)},registerDebugAdapterTrackerFactory(te,de){return yt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?yt.startDebugging(te,de,{parentSession:Te}):yt.startDebugging(te,de,Te||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,de){return yt.asDebugSourceUri(te,de)}},qi={registerTaskProvider:(te,de)=>Jt.registerTaskProvider(Le,te,de),fetchTasks:te=>Jt.fetchTasks(te),executeTask:te=>Jt.executeTask(Le,te),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(te,de,Te)=>Jt.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>Jt.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>Jt.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>Jt.onDidEndTaskProcess(te,de,Te)},li={createNotebookController(te,de,Te,st,Et){return oi.createNotebookController(Le,te,de,Te,st,(0,Ne.$PF)(Le,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>pt.registerNotebookCellStatusBarItemProvider(Le,te,de),createRendererMessaging(te){return Di.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$QF)(Le,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,de){return(0,Ne.$QF)(Le,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Le,te,de)},onDidChangeNotebookCellExecutionState(te,de,Te){return(0,Ne.$QF)(Le,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(te,de,Te)}},Ki={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return si.getMessage(Le.identifier.value,{message:de,args:Te})}return si.getMessage(Le.identifier.value,te[0])},get bundle(){return si.getBundle(Le.identifier.value)},get uri(){return si.getBundleUri(Le.identifier.value)}},Ji={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Ne.$QF)(Le,"interactive"),Ni.registerProvider(Le,te,de={label:de?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,de){return(0,Ne.$QF)(Le,"interactive"),ni.registerChatProvider(Le,te,de)},addInteractiveRequest(te){return(0,Ne.$QF)(Le,"interactive"),ni.addChatRequest(te)},sendInteractiveRequestToProvider(te,de){return(0,Ne.$QF)(Le,"interactive"),ni.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Ne.$QF)(Le,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(te,de){return(0,Ne.$QF)(Le,"interactive"),ni.transferChatSession(te,de)}},Hi={getRelatedInformation(te,de){return(0,Ne.$QF)(Le,"aiRelatedInformation"),zi.getRelatedInformation(Le,te,de)},registerRelatedInformationProvider(te,de){return(0,Ne.$QF)(Le,"aiRelatedInformation"),zi.registerRelatedInformationProvider(Le,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Ne.$QF)(Le,"aiRelatedInformation"),xt.registerEmbeddingVectorProvider(Le,te,de)}},Gi={registerChatResponseProvider(te,de,Te){return(0,Ne.$QF)(Le,"chatProvider"),di.registerProvider(Le.identifier,te,de,Te)},registerSlashCommand(te,de,Te){return(0,Ne.$QF)(Le,"chatSlashCommands"),tn.registerCommand(Le.identifier,te,de,Te??{description:""})},requestChatAccess(te){return(0,Ne.$QF)(Le,"chatRequestAccess"),di.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,de,Te){return(0,Ne.$QF)(Le,"chatVariables"),hn.registerVariableResolver(Le,te,de,Te)},registerMappedEditsProvider(te,de){return(0,Ne.$QF)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,de)},registerAgent(te,de,Te){return(0,Ne.$QF)(Le,"chatAgents"),nn.registerAgent(Le.identifier,te,de,Te)}};return{version:ft.version,ai:Hi,authentication:dn,commands:fn,comments:Wi,chat:Gi,debug:Vi,env:Ei,extensions:an,interactive:Ji,l10n:Ki,languages:gn,notebooks:li,scm:cn,tasks:qi,tests:on,window:mn,workspace:Bi,Breakpoint:Y.$1K,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$QL,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$nK,CallHierarchyItem:Y.$mK,CallHierarchyOutgoingCall:Y.$oK,CancellationError:F.$3,CancellationTokenSource:v.$pd,CandidatePortSource:u.CandidatePortSource,CodeAction:Y.$iK,CodeActionKind:Y.$jK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$pK,Color:Y.$CK,ColorInformation:Y.$DK,ColorPresentation:Y.$EK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$wK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$xK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$MK,DebugAdapterExecutable:Y.$5K,DebugAdapterInlineImplementation:Y.$8K,DebugAdapterNamedPipeServer:Y.$7K,DebugAdapterServer:Y.$6K,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$dK,DiagnosticRelatedInformation:Y.$cK,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$2J,DocumentHighlight:Y.$fK,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$BK,DocumentSymbol:Y.$hK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$$K,InlineValueText:Y.$_K,InlineValueVariableLookup:Y.$aL,InlineValueEvaluatableExpression:Y.$bL,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$fd,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$lL,FileDecoration2:Y.$lL,FileSystemError:Y.$dL,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Y.$eL,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$3K,InlineCompletionItem:Y.$yK,InlineCompletionList:Y.$zK,Hover:Y.$eK,IndentAction:g.IndentAction,Location:Y.$bK,MarkdownString:Y.$qK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Y.$rK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$3J,ProcessExecution:Y.$KK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$kL,Range:Y.$4J,RelativePattern:Y.$YK,Selection:Y.$5J,SelectionRange:Y.$lK,SemanticTokens:Y.$hL,SemanticTokensBuilder:Y.$gL,SemanticTokensEdit:Y.$iL,SemanticTokensEdits:Y.$jL,SemanticTokensLegend:Y.$fL,ShellExecution:Y.$LK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$tK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$sK,SnippetString:Y.$aK,SourceBreakpoint:Y.$2K,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$gK,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$NK,TaskGroup:Y.$JK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$FK,TerminalQuickFixExecuteTerminalCommand:Y.$HK,TerminalQuickFixOpener:Y.$GK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$IK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$9J,SnippetTextEdit:Y.$$J,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$XK,ThemeIcon:Y.$WK,TreeItem:Y.$OK,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$GL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$_J,DocumentDropEdit:Y.$UK,DocumentPasteEdit:Y.$VK,InlayHint:Y.$vK,InlayHintLabelPart:Y.$uK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$8J,ResolvedAuthority:Y.$6J,ManagedResolvedAuthority:Y.$7J,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$vL,NotebookRange:Y.$nL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$oL,NotebookData:Y.$pL,NotebookRendererScript:Y.$tL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$rL,NotebookCellOutputItem:Y.$qL,NotebookCellStatusBarItem:Y.$sL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$0J,NotebookKernelSourceAction:Y.$uL,PortAttributes:Y.$xL,LinkedEditingRanges:Y.$wL,TestResultState:Y.TestResultState,TestRunRequest:Y.$yL,TestMessage:Y.$zL,TestMessage2:Y.$zL,TestTag:Y.$AL,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$TK,DataTransferItem:Y.$PK,CoveredCount:Y.$BL,FileCoverage:Y.$CL,StatementCoverage:Y.$DL,BranchCoverage:Y.$EL,FunctionCoverage:Y.$FL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$HL,TabInputTextDiff:Y.$IL,TabInputTextMerge:Y.$JL,TabInputCustom:Y.$KL,TabInputNotebook:Y.$ML,TabInputNotebookDiff:Y.$NL,TabInputWebview:Y.$LL,TabInputTerminal:Y.$OL,TabInputInteractiveWindow:Y.$PL,TelemetryTrustedValue:Ee.$_n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:dt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$9K,ThreadFocus:Y.$0K,NotebookCodeActionKind:Y.$kK,RelatedInformationType:Y.RelatedInformationType}}}e.$7cc=Vt}),define(Ae[274],Re([1,0,71,110,33,108,34,31,60,63,112,114,115,84,86,80,109,62,39,83,58,61,242,14,113,81,82]),function(be,e,v,F,C,T,A,l,S,g,P,D,u,b,$,d,t,i,o,h,y,m,r,a,n,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$mr)(c.$Gbc,c.$Fbc,1),(0,v.$mr)(a.$6i,r.$8cc,1),(0,v.$mr)(d.$6ac,d.$7ac,1),(0,v.$mr)(l.$lM,l.$kM,0),(0,v.$mr)(A.$gbc,A.$ebc,0),(0,v.$mr)(i.$vbc,i.$ubc,0),(0,v.$mr)(D.$jcc,D.$ncc,0),(0,v.$mr)(T.$bcc,T.$acc,0),(0,v.$mr)(S.$aM,S.$_L,0),(0,v.$mr)(E.$Hbc,E.$Ibc,0),(0,v.$mr)(o.$3ac,o.$2ac,0),(0,v.$mr)(F.$Tbc,F.$Sbc,1),(0,v.$mr)(u.$tcc,u.$ucc,0),(0,v.$mr)(b.$rbc,b.$qbc,0),(0,v.$mr)(P.$ecc,P.$dcc,0),(0,v.$mr)(g.$ybc,g.$Bbc,0),(0,v.$mr)($.$rsb,$.$ssb,0),(0,v.$mr)(t.$0bc,t.$9bc,0),(0,v.$mr)(C.$dbc,C.$cbc,0),(0,v.$mr)(h.$Dbc,h.$Cbc,0),(0,v.$mr)(y.$jM,y.$gM,0),(0,v.$mr)(m.$fcc,m.$gcc,0),(0,v.$mr)(n.$hcc,n.$icc,0)}),define(Ae[275],Re([1,0,273,35,2,270,7,12,261]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class g extends T.$$cc{j(){}getModule(b,$){for(const d of this.b){const t=d(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends F.$Kbc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(S.$dfc);const b=this.h.invokeFunction(v.$7cc);this.r=this.h.createInstance(g,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,$,d){$=$.with({path:D($.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri($)),o=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),o.status!==200)throw new Error(o.statusText);const h=await o.text(),y=`${$.toString(!0)}#vscode-extension`,m=`${h}
//# sourceURL=${y}`;let r;try{r=new Function("module","exports","require",m)}catch(E){throw console.error(t?`Loading code for extension ${t} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${$.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}b&&await this.w.initializeLocalizedMessages(b);const a={},n={exports:a},c=E=>{const p=this.r.getModule(E,$);if(p===void 0)throw new Error(`Cannot load module '${E}'`);return p};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,a,c),n.exports!==a?n.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+b;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Hg)(10)}}e.$efc=P;function D(u,b){return u.endsWith(b)?u:u+b}}),define(Ae[276],Re([1,0,70,71,14,35,188,85,275]),function(be,e,v,F,C,T,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$mr)(C.$5i,new v.$yh(A.$0cc,[!0],!0)),(0,F.$mr)(T.$Lbc,S.$efc,0),(0,F.$mr)(l.$wbc,l.$xbc,0)}),define(Ae[285],Re([1,0,25,5,79,271,263,19,87,13,2,274,276]),function(be,e,v,F,C,T,A,l,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(r){return/^(file|vscode-remote):/i.test(r)}const $=fetch.bind(self);function d(r){self.fetch=async function(a,n){return a instanceof Request||b(String(a))&&(a=(await r(P.URI.parse(String(a)))).toString(!0)),$(a,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,n,c,E,p){(async()=>(b(n.toString())&&(n=(await r(P.URI.parse(n.toString()))).toString(!0)),super.open(a,n,c??!0,E,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(a,n){if(/^file:/i.test(a.toString()))a=g.$2f.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(s){function f(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const w=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?w(W,V):w(f(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,U,B,O){return super.open(W,f(V),U??!0,B,O)}};const R=importScripts.bind(self);self.importScripts=(...W)=>{R(...W.map(f))},R(s)}.toString()}('${a}'))`;n=n||{},n.name=n.name||l.$ae(a.toString());const p=new Blob([E],{type:"application/javascript"}),I=URL.createObjectURL(p);return new r(I,n)}}else self.Worker=class extends A.$ffc{constructor(r,a){super(u,r,{name:l.$ae(r.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(r){D()}};class i{constructor(){const a=new MessageChannel,n=new F.$fd;let c=!1;u(a.port2,[a.port2]),a.port1.onmessage=E=>{const{data:p}=E;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const I=v.$Fd.wrap(new Uint8Array(p,0,p.byteLength));if((0,C.$5l)(I,2)){c=!0,h("received terminate message from renderer");return}n.fire(I)},this.protocol={onMessage:n.event,send:E=>{if(!c){const p=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);a.port1.postMessage(p,[p])}}}}}function o(r){return new Promise(a=>{const n=r.onMessage(c=>{n.dispose();const E=JSON.parse(c.toString());r.send((0,C.$4l)(0)),a({protocol:r,initData:E})});r.send((0,C.$4l)(1))})}let h=r=>D();function y(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function m(){S.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(a){y(a)&&o(r.protocol).then(n=>{S.mark("code/extHost/didWaitForInitData");const c=new T.$adc(n.protocol,n.initData,t,null,a.data);d(E=>c.asBrowserUri(E)),h=E=>c.terminate(E)})}}}e.create=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10765021158cf51eaf6785361598e1668f53e06e/core/vs/workbench/api/worker/extensionHostWorker.js.map
